<?php
/**
 * @version		$Id: tags.php 785 2011-04-28 12:39:17Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.gr
 * @copyright	Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

$tag_sizes = array();

foreach($tags as $tag) {
	array_push($tag_sizes, $tag->size);
}

$tag_sizes = array_unique($tag_sizes);
asort($tag_sizes);
$tag_sizes = array_values($tag_sizes);

$tag_sizes_is_big_enough = false;
$tag_sizes_has_center_element = false;

if(count($tag_sizes) >= 3) {
	$tag_sizes_is_big_enough = true;	
	
	if(count($tag_sizes) % 2 == 1) {
		$tag_sizes_has_center_element = true;	
	}
}

$small_size = 0;
$medium_size = 0;
$big_size = 0;

if($tag_sizes_is_big_enough) {
	if($tag_sizes_has_center_element) {
		$small_size = $tag_sizes[((count($tag_sizes) - 1) / 2) - 1];
		$medium_size = $tag_sizes[((count($tag_sizes) + 1) / 2) - 1];
		$big_size = $tag_sizes[((count($tag_sizes) + 3) / 2) - 1];
	} else {
		$medium_size = ($tag_sizes[(count($tag_sizes) / 2) - 1] + $tag_sizes[(count($tag_sizes) / 2)]) / 2.0;
	}
}

?>

<div id="k2ModuleBox<?php echo $module->id; ?>" class="k2TagCloudBlock<?php if($params->get('moduleclass_sfx')) echo ' '.$params->get('moduleclass_sfx'); ?>">
	<?php foreach ($tags as $tag): ?>
	<?php if(!empty($tag->tag)): ?>
	<a href="<?php echo $tag->link; ?>" style="font-size:<?php echo $tag->size; ?>%" title="<?php echo $tag->count.' '.JText::_('K2_ITEMS_TAGGED_WITH').' '.$tag->tag; ?>" 
	<?php
		if($tag_sizes_is_big_enough) {
			if($tag_sizes_has_center_element) {
				if($tag->size >= $big_size) {
					echo ' class="big-tag"';
				} else if($tag->size > $small_size) {
					echo ' class="medium-tag"';
				} else {
					echo ' class="small-tag"';
				}
			} else {
				if($tag->size > $medium_size) {
					echo ' class="big-tag"';
				} else {
					echo ' class="medium-tag"';
				}
			}
		}		
	 ?>
	 >
		<?php echo $tag->tag; ?>
	</a>
	<?php endif; ?>
	<?php endforeach; ?>
	<div class="clr"></div>
</div>
