<?php
/**
 * @version		$Id: item.php 859 2011-06-24 10:18:35Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.gr
 * @copyright	Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class K2ControllerItem extends JController
{

	function display() {

		$model=&$this->getModel('itemlist');
		$document =& JFactory::getDocument();
		$viewType = $document->getType();
		$view = &$this->getView('item', $viewType);
		$view->setModel($model);
		JRequest::setVar('view', 'item');
		$user = &JFactory::getUser();
		if ($user->guest){
		    $cache = true;
		}
		else {
		    $cache = true;
		    JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
		    $row = & JTable::getInstance('K2Item', 'Table');
            $row->load(JRequest::getInt('id'));
		    if (K2HelperPermissions::canEditItem($row->created_by,$row->catid)){
		        $cache = false;
		    }
		    $params = &K2HelperUtilities::getParams('com_k2');
		    if($row->created_by==$user->id && $params->get('inlineCommentsModeration')){
		        $cache = false;
		    }
		    if($row->access > 0){
		        $cache = false;
		    }
		    $category = & JTable::getInstance('K2Category', 'Table');
		    $category->load($row->catid);
		    if ($category->access > 0) {
		        $cache = false;
		    }
		}
		
		parent::display($cache);
	}

	function edit() {
		$language = &JFactory::getLanguage();
		$language->load('com_k2', JPATH_ADMINISTRATOR);
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::root(true).'/administrator/components/com_k2/css/k2.css');
		$document->addScript(JURI::root(true).'/components/com_k2/js/jquery.min.js');
		$document->addScript(JURI::root(true).'/administrator/components/com_k2/js/jquery.ui.custom.min.js');
		$document->addScript(JURI::root(true).'/administrator/components/com_k2/js/k2.js');
		$this->addViewPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'views');
		$this->addModelPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'models');
		$view = & $this->getView('item', 'html');
		$view->addTemplatePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'item'.DS.'tmpl');
		$view->display();
	}

	function add() {
		$this->edit();
	}

	function save() {
		$mainframe = &JFactory::getApplication();
		JRequest::checkToken() or jexit('Invalid Token');
		JRequest::setVar('tmpl', 'component');
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'item.php');
		$model= new K2ModelItem;
		$model->save(true);
		$mainframe->close();

	}

	function deleteAttachment() {

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'item.php');
		$model= new K2ModelItem;
		$model->deleteAttachment();
	}

	function tag() {

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'tag.php');
		$model= new K2ModelTag;
		$model->addTag();
	}

	function tags() {

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'tag.php');
		$model= new K2ModelTag;
		$model->tags();
	}

	function download(){

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'item.php');
		$model= new K2ModelItem;
		$model->download(true);
	}

	function extraFields(){

		$mainframe = &JFactory::getApplication();
		$language = &JFactory::getLanguage();
		$language->load('com_k2', JPATH_ADMINISTRATOR);
		$itemID=JRequest::getInt('id',NULL);

		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
		$catid = JRequest::getInt('cid');
		$category = & JTable::getInstance('K2Category', 'Table');
		$category->load($catid);

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'extrafield.php');
		$extraFieldModel= new K2ModelExtraField;

		$extraFields = $extraFieldModel->getExtraFieldsByGroup($category->extraFieldsGroup);

		$output='<table class="admintable" id="extraFields">';
		$counter=0;
		if (count($extraFields)){
			foreach ($extraFields as $extraField){
				$output.='<tr><td align="right" class="key">'.$extraField->name.'</td>';
				$output.='<td>'.$extraFieldModel->renderExtraField($extraField,$itemID).'</td></tr>';
				$counter++;
			}
		}
		$output.='</table>';

		if ($counter==0) $output=JText::_('K2_THIS_CATEGORY_DOESNT_HAVE_ASSIGNED_EXTRA_FIELDS');

		echo $output;
		$mainframe->close();
	}

	function checkin(){

		$model = & $this->getModel('item');
		$model->checkin();
	}

	function vote()	{

		$model = & $this->getModel('item');
		$model->vote();
	}

	function getVotesNum()	{

		$model = & $this->getModel('item');
		$model->getVotesNum();
	}

	function getVotesPercentage()	{

		$model = & $this->getModel('item');
		$model->getVotesPercentage();
	}

	function comment(){

		$model = & $this->getModel('item');
		$model->comment();
	}

	function resetHits(){
		JRequest::checkToken() or jexit('Invalid Token');
		JRequest::setVar('tmpl', 'component');
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'item.php');
		$model= new K2ModelItem;
		$model->resetHits();

	}

	function resetRating(){
		JRequest::checkToken() or jexit('Invalid Token');
		JRequest::setVar('tmpl', 'component');
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'item.php');
		$model= new K2ModelItem;
		$model->resetRating();

	}

	function filebrowser(){
		$language = &JFactory::getLanguage();
		$language->load('com_k2', JPATH_ADMINISTRATOR);
		$user = &JFactory::getUser();
		if($user->guest){
            JError::raiseError(403, JText::_('K2_ALERTNOTAUTH'));
		}
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::root().'administrator/components/com_k2/css/k2.css');
		$document->addScript(JURI::root().'administrator/components/com_k2/js/k2.mootools.js');
		$this->addViewPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'views');
		$view = &$this->getView('item', 'html');
		$view->_addPath('template', JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'item'.DS.'tmpl');
		$view->setLayout('filebrowser');
		$view->filebrowser();

	}

}
