<?php

/**
* Gavick GK JS Stats- helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// Main class
class GKJSSHelper
{
	var $config;
	var $content;

	/**
	 * 
	 *	INITIALIZATION
	 * 
	 **/
	
	function init()
	{		
		// configuration array
		$this->config = array(
			'module_unique_id' => 'gk_js_stats1',	
			'jomsocial_itemid' => 0,			            
            'show_breadcrumbs' => true,
			'show_total' => true,
            'show_recent' => true,
			'show_male' => true,
			'show_female' => true,
			'fieldname' => '',
			'male' => '',
			'female' => '',
			'useCSS' => true
		);	
		// content array
		$this->content = array(
			'breadcrumbs' => '',
			'recent' => '',
			'total' => '',
			'male' => '',
			'female' => ''
		);
	}
	
	/**
	 * 
	 *	VARIABLES VALIDATION
	 * 
	 **/
	
	function validateVariables(&$params)
	{
		$this->config['module_unique_id'] = $params->get('module_unique_id','gk_js_stats1'); // unique ID
		$this->config['jomsocial_itemid'] = $params->get('jomsocial_itemid',0); // unique ID
		$this->config['show_breadcrumbs'] = (bool) $params->get('show_breadcrumbs',1);
       	$this->config['show_total'] = (bool) $params->get('show_total',1);
       	$this->config['show_recent'] = (bool) $params->get('show_recent',1);
       	$this->config['show_female'] = (bool) $params->get('show_female',1);
       	$this->config['show_male'] = (bool) $params->get('show_male',1);
       	$this->config['fieldname'] = $params->get('fieldname','FIELD_GENDER');
       	$this->config['female'] = $params->get('female','Female');
  		$this->config['male'] = $params->get('male','Male');
		$this->config['useCSS'] = (bool) $params->get('useCSS',1);
	}
	
	/**
	 * 
	 *	GETTING DATA
	 * 
	 **/
		
	function getData()
	{
		// Creating DB object instance
		$db =& JFactory::getDBO();
		// total
		$query = $db->setQuery("SELECT COUNT(id) AS total FROM #__users WHERE block = 0");
		$row = $db->loadObject();
  		$total = $row->total;
  		// recent
  		$query = $db->setQuery("SELECT created FROM #__community_activities ORDER BY created DESC LIMIT 1");
		$row = $db->loadObject();
  		if(!empty($row)) $recent = $row->created;
  		else $recent = false;
  		// Male-Female
		$query = $db->setQuery("SELECT id FROM #__community_fields WHERE fieldcode = '".$this->config['fieldname']."';");
		$row = $db->loadObject();
		// gender table
	    $sex = array('female' => 0, 'male' => 0);
		if(!empty($row))
		{	    		    
			$query = $db->setQuery("SELECT value, COUNT(a.id) AS total FROM #__community_fields_values AS a, #__users AS b WHERE b.id = a.user_id AND block = 0 AND field_id = '".$row->id."' GROUP BY value;");
			$row = $db->loadObjectList();
									    
		    foreach($row as $item)
			{
				switch($item->value)
				{
					case $this->config['female']: $sex['female'] = $item->total; break;
					case $this->config['male']: $sex['male'] = $item->total; break;
				}
			}    
		}
		// group name
		$present_group = false;
		$group_id = 0;
		$query = $db->setQuery("SELECT name,id FROM #__community_groups ORDER BY id DESC LIMIT 1;");
		$row = $db->loadObject();
		if(!empty($row)){
			$present_group = $row->name;
			$group_id = $row->id;
		} 
		// Generating content
		$this->content['breadcrumbs'] = (($present_group) ? '<a href="index.php?option=com_community&amp;view=groups&amp;task=viewgroup&amp;groupid='.$group_id.'&amp;Itemid='.$this->config['jomsocial_itemid'].'" class="gk_js_groupname">'.$present_group.'</a>' : '').'<a href="index.php?option=com_community&amp;view=groups" class="gk_js_viewgroups">'.JText::_('VIEW_ALL_GROUPS').'</a>';
		$this->content['recent'] = JText::_('RECENT_ACTIVITIES').' '.(($recent) ? $this->time_diff($recent) : JText::_('NEVER'));
		$this->content['total'] = '<strong>'.$total.'</strong> '.JText::_('TOTAL_MEMBERS');
		$this->content['male'] = '<span>Male members:</span> '.$sex['male'];
		$this->content['female'] = '<span>Female members:</span> '.$sex['female'];
	}
	
	/**
	 * 
	 *	RENDERING LAYOUT
	 * 
	 **/
	
	function renderLayout()
	{	
		/**
			GENERATING FINAL XHTML CODE START
		**/

		// create instances of basic Joomla! classes
		$document =& JFactory::getDocument();
		$uri =& JURI::getInstance();
		// add stylesheets to document header
		if($this->config["useCSS"]){
			$document->addStyleSheet( $uri->root().'modules/mod_gk_js_stats/style/style.css', 'text/css' );
		}
		//
		require(JModuleHelper::getLayoutPath('mod_gk_js_stats', 'default'));
	}
	
	
	function time_diff( $timestamp )
	{
    	$start = strtotime( $timestamp );
    	$end = time();
    	
		if($start <= $end)
		{   
        	$d = $end - $start;
        	if( $days = intval((floor($d/86400))) ) $d = $d % 86400;
        	if( $hours = intval((floor($d/3600))) ) $d = $d % 3600;
        	if( $minutes = intval((floor($d/60))) ) $d = $d % 60;
        	//$d = intval( $d ); 
			if($days == 0 && $hours == 0 && $minutes == 0)
			{
				return JText::_('MOMENT_AGO');
			} 
			else
			{
				$str = '';
				$str .= ($days > 0) ? (($days == 1) ? $days.' '.JText::_('DAY').' ' : $days.' '.JText::_('DAYS').' ') : '';
				$str .= ($hours > 0) ? (($hours == 1) ? $hours.' '.JText::_('HOUR').' ' : $hours.' '.JText::_('HOURS')).' ' : '';
				$str .= ($minutes > 0) ? (($minutes == 1) ? $minutes.' '.JText::_('MINUTE').' ' : $minutes.' '.JText::_('MINUTES')).' ' : '';     
				$str .= JText::_('AGO');     
        	}
        	
        	return $str;
        }
        else
        {
        	return JText::_('MOMENT_AGO');
        }
	}
}

?>