<?php
/*
 * --------------------------------------------------------------------------------
   Weblogicx India  - K2 Store v 2.0
 * --------------------------------------------------------------------------------
 * @package		Joomla! 1.5x
 * @subpackage	K2 Store
 * @author    	Weblogicx India http://www.weblogicxindia.com
 * @copyright	Copyright (c) 2010 - 2015 Weblogicx India Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 * @link		http://weblogicxindia.com
 * --------------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die ('Restricted access');
JLoader::register('K2Plugin', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_k2store'.DS.'helpers'.DS.'utilities.php');
require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2store'.DS.'library'.DS.'prices.php');
	
class plgK2K2Store extends K2Plugin {

	// Some params
	var $pluginName = 'k2store';
	var $pluginNameHumanReadable = 'K2 Store';

	function plgK2K2Store( & $subject, $params) {
	
		parent::__construct($subject, $params);		

	}
	
	function onK2PrepareContent( & $item, & $params, $limitstart) {
		 
	}
	
	function onK2AfterDisplay( & $item, & $params, $limitstart) {
	
		global $mainframe;
		$lang = JFactory::getLanguage();
		$lang->load('com_k2store');
		$k2params = &JComponentHelper::getParams('com_k2store');

		$item_price = K2StorePrices::getItemPrice($item->id);
		
		if ($item_price > 0) {
			
			 $doc = &JFactory::getDocument();
			 $doc->addStyleSheet(JURI::base().'components'.DS.'com_k2store'.DS.'css'.DS.'style.css');
		
			
			// show/hide add to cart button
			$content = '';
			if (!$k2params->get('show_addtocart')) {		
				$content = $this->addtoCart($item, $item_price);
			}
			
		} else {
			$content = '';
			
		}
		return $content;
	}
	
	function onK2AfterDisplayContent( & $item, & $params, $limitstart) {
	
		global $mainframe;
		//get component params
		$params = &JComponentHelper::getParams('com_k2store');
		
		//item_price
		$item_price = K2StorePrices::getItemPrice($item->id);
		
		if ( empty($item_price)) return;
		
		if ($item_price > 0) { 
			if($params->get('show_itemprice')) {
				$output ='<div class="k2store_item_price"><span class="item_price_label">'.JText::_('Item Price').' : </span><span class="k2store_item_price_value">&nbsp;'.$params->get('currency').$item_price.'</span></div>';		
			}
		}	
	
		return $output;
	}	
	
 function addtoCart(&$item, &$item_price) {
	 
		$user 	=& JFactory::getUser();
		
		//get component params
		$params = &JComponentHelper::getParams('com_k2store');
		
		//get plugin params		
		
		$plugins = new K2Parameter($item->plugins, '', $this->pluginName);
		
		$Itemid = $params->get('itemid');
		
		$link = JRoute::_('index.php?option=com_k2store&view=mycart&Itemid='.$Itemid);
		$currency = $params->get('currency');
		$add_to_cart_text = JText::_('ADD TO CART');
		$checkout_text = JText::_('SHOWCART');
	
		//build the cart buttons
		
			if ($item) {
				
					$action = JRoute::_('index.php?option=com_k2store&view=mycart&format=ajax&order_code='.$item->id);		
					
					$cart = "<div class=\"mycart\">";
					$cart .="<form id=\"cart_form\" class=\"cart_form\" action=\"$action\" method=\"post\">";
					$cart .="<input type=\"hidden\" name=\"option\" value=\"com_k2store\" />";
					$cart .="<input type=\"hidden\" name=\"task\" value=\"cartaction\" />";
					$cart .="<input type=\"hidden\" name=\"Itemid\" value=\"$Itemid\" />";
					$cart .="<input type=\"hidden\" id=\"order_code\" name=\"order_code\" value=\"$item->id\" />";
					$cart .="<label><b> $item->title : </b> <input class=\"center\" type=\"text\" id=\"quantity\" name=\"quantity\" value=\"1\" size=\"3\" /></label>";
					$cart .="<label><b> $currency </b> $item_price </label>";
					$cart .="<input type=\"submit\" name=\"submit\" value=\"$add_to_cart_text\" />";
					$cart .="&nbsp;&nbsp;&nbsp;";
					$cart .= "<input type=\"button\" value=\"$checkout_text \" onclick=\"window.location = '$link'\"/>";
					$cart .="</form>";
					$cart .="</div>";					
			}	
							
	return $cart;
	
}
	

	
} // END CLASS

