-- MySQL dump 10.13  Distrib 5.1.56, for unknown-linux-gnu (x86_64)
--
-- Host: localhost    Database: project_clean_financial_business_j17
-- ------------------------------------------------------
-- Server version	5.1.56-log







--
-- Table structure for table `#__assets`
--



CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM AUTO_INCREMENT=84 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__assets`
--


INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES (1,0,1,516,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":[],\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(2,1,1,2,1,'com_admin','com_admin','{}'),(3,1,3,6,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(4,1,7,8,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(5,1,9,10,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(6,1,11,12,1,'com_config','com_config','{}'),(7,1,13,20,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(8,1,21,112,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(9,1,113,114,1,'com_cpanel','com_cpanel','{}'),(10,1,115,116,1,'com_installer','com_installer','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1},\"core.delete\":[],\"core.edit.state\":[]}'),(11,1,117,118,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(12,1,119,120,1,'com_login','com_login','{}'),(13,1,121,122,1,'com_mailto','com_mailto','{}'),(14,1,123,124,1,'com_massmail','com_massmail','{}'),(15,1,125,126,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),(16,1,127,128,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(17,1,129,130,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(18,1,131,132,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(19,1,133,140,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(20,1,141,142,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(21,1,143,144,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),(22,1,145,146,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),(23,1,147,148,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(24,1,149,150,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.own\":{\"6\":1},\"core.edit.state\":[]}'),(25,1,151,158,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(26,1,159,160,1,'com_wrapper','com_wrapper','{}'),(27,8,22,29,2,'com_content.category.2','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(28,3,4,5,2,'com_banners.category.3','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(29,7,14,15,2,'com_contact.category.4','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(30,19,134,135,2,'com_newsfeeds.category.5','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(31,25,152,153,2,'com_weblinks.category.6','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(32,33,31,32,3,'com_content.article.1','Typography','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(33,8,30,45,2,'com_content.category.7','Template articles','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(34,33,33,34,3,'com_content.article.2','Module positions','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(35,33,35,36,3,'com_content.article.3','Messages','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(36,33,37,38,3,'com_content.article.4','Chrome frame','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(37,8,46,55,2,'com_content.category.8','Menu types','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(38,37,47,48,3,'com_content.article.5','Menu types','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(39,8,56,75,2,'com_content.category.9','Layouts','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(40,39,57,58,3,'com_content.article.6','Right column','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(41,39,59,60,3,'com_content.article.7','Right two columns','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(42,39,61,62,3,'com_content.article.8','Left column','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(43,39,63,64,3,'com_content.article.9','Left two columns','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(44,39,65,66,3,'com_content.article.10','Content inset left','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(45,39,67,68,3,'com_content.article.11','Content inset right','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(46,39,69,70,3,'com_content.article.12','Content inset both','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(47,39,71,72,3,'com_content.article.13','Content inset + column','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(48,39,73,74,3,'com_content.article.14','Content inset + column (2x)','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(49,37,49,50,3,'com_content.article.15','Split menu','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(50,37,51,52,3,'com_content.article.16','Dropline menu','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(51,37,53,54,3,'com_content.article.17','GK Menu','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(52,33,39,40,3,'com_content.article.18','Module variation','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(53,7,16,17,2,'com_contact.category.10','Sample category I','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(54,7,18,19,2,'com_contact.category.11','Sample category II','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(55,25,154,155,2,'com_weblinks.category.12','Joomla Weblink Category','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(56,25,156,157,2,'com_weblinks.category.13','GavickPro','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(57,19,136,137,2,'com_newsfeeds.category.14','GavickPro','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(58,19,138,139,2,'com_newsfeeds.category.15','Joomla!','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(59,27,23,24,3,'com_content.article.19','Archive article I','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(60,27,25,26,3,'com_content.article.20','Archive article II','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(61,27,27,28,3,'com_content.article.21','Archive article III','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(63,33,41,42,3,'com_content.article.23','IE 6 style','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(64,33,43,44,3,'com_content.article.24','Lorem ipsum','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(65,1,514,515,1,'com_k2','k2','{}'),(66,8,76,79,2,'com_content.category.16','Latest','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(67,66,77,78,3,'com_content.article.25','Welcome to Joomla!','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(68,8,80,111,2,'com_content.category.17','Financial Business','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(69,68,81,90,3,'com_content.category.18','Financial Adviser','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(70,68,91,100,3,'com_content.category.19',' Investment Guide','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(71,68,101,110,3,'com_content.category.20','Market Center','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(72,69,82,83,4,'com_content.article.26','Online Business Conference','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(73,69,84,85,4,'com_content.article.27','Need Additional Capital?','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(74,69,86,87,4,'com_content.article.28','We celebrate your success! ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(75,69,88,89,4,'com_content.article.29','Idea about starting your own business','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(76,70,92,93,4,'com_content.article.30','Support your financial success ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(77,70,94,95,4,'com_content.article.31','WorkShop from dedicated stractegy','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(78,70,96,97,4,'com_content.article.32','Office and Support Staff ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(79,70,98,99,4,'com_content.article.33','Creating a great team environment','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(80,71,102,103,4,'com_content.article.34','Our business is built on friendship.','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(81,71,104,105,4,'com_content.article.35','Trusted in financial market','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(82,71,108,109,4,'com_content.article.36','Fully equipped modern workshop','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(83,71,106,107,4,'com_content.article.37','Top professional advisers','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');


--
-- Table structure for table `#__associations`
--



CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__associations`
--




--
-- Table structure for table `#__banner_clients`
--



CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_clients`
--




--
-- Table structure for table `#__banner_tracks`
--



CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_tracks`
--




--
-- Table structure for table `#__banners`
--



CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banners`
--


INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`) VALUES (1,0,1,'Joomla!','joomla',0,427,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomla! The most popular and widely used Open Source CMS Project in the world.',0,1,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-02-13 00:00:00','2011-01-13 13:00:45','*'),(2,0,1,'JoomlaCode','joomlacode',0,427,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomlaCode, development and distribution made easy.',0,2,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-02-13 00:00:00','2011-01-13 13:01:50','*'),(3,0,1,'GavickPro','gavickpro',0,192,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nProfessional Joomla! templates and extensions.',0,3,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-09-18 00:00:00','2011-08-18 09:35:33','*');


--
-- Table structure for table `#__categories`
--



CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` varchar(5120) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__categories`
--


INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES (1,0,0,0,39,0,'','system','ROOT','root','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'2009-10-18 16:07:09',0,'0000-00-00 00:00:00',0,'*'),(2,27,1,1,2,1,'uncategorised','com_content','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:26:37',0,'0000-00-00 00:00:00',0,'*'),(3,28,1,3,4,1,'uncategorised','com_banners','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:35',0,'0000-00-00 00:00:00',0,'*'),(4,29,1,5,6,1,'uncategorised','com_contact','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:57',0,'0000-00-00 00:00:00',0,'*'),(5,30,1,7,8,1,'uncategorised','com_newsfeeds','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:15',0,'0000-00-00 00:00:00',0,'*'),(6,31,1,9,10,1,'uncategorised','com_weblinks','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:33',0,'0000-00-00 00:00:00',0,'*'),(7,33,1,11,12,1,'template','com_content','Template articles','template','','',1,42,'2011-07-20 08:46:26',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-11 22:34:53',42,'2011-01-12 17:11:44',0,'*'),(8,37,1,13,14,1,'menu-types','com_content','Menu types','menu-types','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-12 17:56:17',0,'0000-00-00 00:00:00',0,'*'),(9,39,1,15,16,1,'layouts','com_content','Layouts','layouts','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-12 19:18:18',0,'0000-00-00 00:00:00',0,'*'),(10,53,1,17,18,1,'sample-category-i','com_contact','Sample category I','sample-category-i','','<p>Category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 14:51:48',0,'0000-00-00 00:00:00',0,'*'),(11,54,1,19,20,1,'sample-category-ii','com_contact','Sample category II','sample-category-ii','','<p>Sample category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 14:52:10',0,'0000-00-00 00:00:00',0,'*'),(12,55,1,21,22,1,'joomla-weblink-category','com_weblinks','Joomla Weblink Category','joomla-weblink-category','','<p>Simple category with Joomla links!</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:01:01',0,'0000-00-00 00:00:00',0,'*'),(13,56,1,23,24,1,'gavick','com_weblinks','GavickPro','gavick','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:05:39',42,'2011-01-13 15:11:56',0,'*'),(14,57,1,25,26,1,'gavickpro','com_newsfeeds','GavickPro','gavickpro','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:34:33',0,'0000-00-00 00:00:00',0,'*'),(15,58,1,27,28,1,'joomla','com_newsfeeds','Joomla!','joomla','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:48:47',0,'0000-00-00 00:00:00',0,'*'),(16,66,1,29,30,1,'latest','com_content','Latest','latest','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 08:47:35',0,'0000-00-00 00:00:00',0,'*'),(17,68,1,31,38,1,'financial-business','com_content','Financial Business','financial-business','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:10:00',42,'2011-07-20 12:10:09',0,'*'),(18,69,17,32,33,2,'financial-business/financial-adviser','com_content','Financial Adviser','financial-adviser','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:10:40',0,'0000-00-00 00:00:00',0,'*'),(19,70,17,34,35,2,'financial-business/investment-guide','com_content',' Investment Guide','investment-guide','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:11:03',0,'0000-00-00 00:00:00',0,'*'),(20,71,17,36,37,2,'financial-business/market-center','com_content','Market Center','market-center','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:11:28',0,'0000-00-00 00:00:00',0,'*');


--
-- Table structure for table `#__contact_details`
--



CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__contact_details`
--


INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES (1,'Eli Manning','eli-manning','','B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146.','Victoria','Australia','Australia','3146','+49 5241 80-0 00','+49 5241 80-0 00','','images/admin.jpg',NULL,'test@test.com',0,1,42,'2011-08-17 18:23:36',1,'{\"show_contact_category\":\"hide\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"0\",\"show_email\":\"0\",\"show_street_address\":\"\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"0\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"0\",\"show_image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,10,1,'+49 5241 80-0 00','','','','','*','2011-01-13 14:54:01',42,'','2011-08-17 18:23:36',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(2,'Joomla User ','eli-manning','','B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146. \r\nAustralia','','Australia','','','','','','images/powered_by.png',NULL,'test@test.com',0,1,0,'0000-00-00 00:00:00',2,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,11,1,'','','','','','*','2011-01-13 14:54:01',42,'','2011-01-13 14:57:11',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');


--
-- Table structure for table `#__content`
--



CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `title_alias` varchar(255) NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=38 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content`
--


INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES (1,32,'Typography','typography','','<ul id=\"demo-typography\">\r\n<li><a href=\"#warnings\">Warnings</a></li>\r\n<li><a href=\"#headers\">Headers</a></li>\r\n<li><a href=\"#icons1\">Icon set 1</a></li>\r\n<li><a href=\"#icons2\">Icon set 2</a></li>\r\n<li><a href=\"#icons3\">Icon set 3</a></li>\r\n<li><a href=\"#tooltips\">Tooltips</a></li>\r\n<li><a href=\"#highlights\">Highlights</a></li>\r\n<li><a href=\"#code\">Code</a></li>\r\n<li><a href=\"#ulists\">Unordered lists</a></li>\r\n<li><a href=\"#olists\">Ordered lists</a></li>\r\n<li><a href=\"#abbrs\">Abbrs and acronyms</a></li>\r\n<li><a href=\"#definition\">Definition lists</a></li>\r\n<li><a href=\"#legends\">Legends</a></li>\r\n<li><a href=\"#dropcaps\">Dropcaps</a></li>\r\n<li><a href=\"#blocks\">Floated blocks</a></li>\r\n<li><a href=\"#other\">Other span blocks</a></li>\r\n<li><a href=\"#blockquote\">Blockquotes</a></li>\r\n<li><a href=\"#tables\">Tables</a></li>\r\n</ul>\r\n<h4 class=\"demo-typo\"><a name=\"warnings\">Warnings</a></h4>\r\n<p class=\"gkInfo1\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo1\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips1\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips1\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning1\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning1\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo2\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo2\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips2\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips2\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning2\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning2\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo3\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo3\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips3\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips3\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning3\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning3\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo4\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo4\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips4\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips4\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning4\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning4\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo5\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo5\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips5\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips5\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning5\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning5\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"headers\">Headers</a></h4>\r\n<h1>This is heading 1</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer    semper egestas nunc in volutpat. Fusce adipiscing velit ac eros tempor    iaculis. Phasellus venenatis mollis augue, non posuere odio placerat  in.   Etiam volutpat ultrices lectus. Fusce eu felis erat. Donec congue    interdum elit, sed ornare magna convallis lacinia. In hac habitasse    platea dictumst. Mauris volutpat consectetur accumsan.</p>\r\n<h2>This is heading 2</h2>\r\n<p>Cras diam justo, sodales quis lobortis sed, lobortis vel mauris. Sed a    mollis nunc. Quisque semper condimentum lectus, eget laoreet ipsum    auctor et. Quisque sagittis luctus augue, id fringilla enim euismod    quis. Nullam blandit, elit at euismod rutrum, tortor nibh posuere    mauris, in volutpat diam ante ac dui. Sed velit massa, imperdiet    placerat tristique et, consectetur a lorem. Praesent aliquet turpis in    quam tempor eu pulvinar nibh luctus.</p>\r\n<h3>This is heading 3</h3>\r\n<p>Vivamus rhoncus arcu sit amet est tristique convallis nec vel eros.    Vestibulum euismod luctus velit quis porta. Aliquam varius placerat    mauris sed vehicula. Integer porta facilisis sapien, in tempus lorem    mattis molestie. Suspendisse potenti. Praesent quis diam non dolor    convallis mattis eu id nulla.</p>\r\n<h4>This is heading 4</h4>\r\n<p>Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<p class=\"gkHeadline\">This is a headline.</p>\r\n<p class=\"gkSubHeadline\">This is a subheadline.</p>\r\n<p>Use <strong>&lt;p    class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p    class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<p class=\"gkSmallHeadline\">This is a small headline</p>\r\n<p class=\"gkLargeHeadline\">This is a large headline</p>\r\n<p>Use <strong>&lt;p    class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p    class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons1\">Icon set 1</a></h4>\r\n<p class=\"gkAudio\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudio\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWebcam\">This is a sample webcam message. Use <strong>&lt;p    class=\"gkWebcam\"&gt;Your webcam goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkEmail\">This is a sample email message. Use <strong>&lt;p    class=\"gkEmail\"&gt;Your email message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCreditcard\">This is a sample creditcard message. Use <strong>&lt;p    class=\"gkCreditcard\"&gt;Your creditcart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFeed\">This is a sample feed message. Use <strong>&lt;p    class=\"gkFeed\"&gt;Your feed goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHelp\">This is a sample help message. Use <strong>&lt;p    class=\"gkHelp\"&gt;Your help message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImages\">This is a sample images message. Use <strong>&lt;p    class=\"gkImages\"&gt;Your images message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLock\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLock\"&gt;Your webcam goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPrinter\">This is a sample printer message. Use <strong>&lt;p    class=\"gkPrinter\"&gt;Your printer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkReport\">This is a sample report message. Use <strong>&lt;p    class=\"gkReport\"&gt;Your report message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkScript\">This is a sample script message. Use <strong>&lt;p    class=\"gkScript\"&gt;Your script goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTime\">This is a sample time message. Use <strong>&lt;p    class=\"gkTime\"&gt;Your time message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUser\">This is a sample user message. Use <strong>&lt;p    class=\"gkUser\"&gt;Your user message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWorld\">This is a sample world message. Use <strong>&lt;p    class=\"gkWorld\"&gt;Your world goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCart\">This is a sample cart message. Use <strong>&lt;p    class=\"gkCart\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCd\">This is a sample cd message. Use <strong>&lt;p    class=\"gkCd\"&gt;Your cd message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartBar\">This is a sample chart_bar message. Use <strong>&lt;p    class=\"gkChartBar\"&gt;Your chart_bar goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartLine\">This is a sample chart_line message. Use <strong>&lt;p    class=\"gkChartLine\"&gt;Your chart_line message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartPie\">This is a sample chart_pie message. Use <strong>&lt;p    class=\"gkChartPie\"&gt;Your chart_pie message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkClock\">This is a sample clock message. Use <strong>&lt;p    class=\"gkClock\"&gt;Your clock goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCog\">This is a sample cog message. Use <strong>&lt;p    class=\"gkCog\"&gt;Your cog message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCoins\">This is a sample coins message. Use <strong>&lt;p    class=\"gkCoins\"&gt;Your coins message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCompress\">This is a sample compress message. Use <strong>&lt;p    class=\"gkCompress\"&gt;Your compress goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputer\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputer\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCross\">This is a sample cross message. Use <strong>&lt;p    class=\"gkCross\"&gt;Your cross message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkDisk\">This is a sample disk message. Use <strong>&lt;p    class=\"gkDisk\"&gt;Your disk goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkError\">This is a sample error message. Use <strong>&lt;p    class=\"gkError\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkExclamation\">This is a sample exclamation message. Use <strong>&lt;p    class=\"gkExclamation\"&gt;Your exclamation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFilm\">This is a sample film message. Use <strong>&lt;p    class=\"gkFilm\"&gt;Your film goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFolder\">This is a sample folder message. Use <strong>&lt;p    class=\"gkFolder\"&gt;Your folder message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkGroup\">This is a sample group message. Use <strong>&lt;p    class=\"gkGroup\"&gt;Your group message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHeart\">This is a sample heart message. Use <strong>&lt;p    class=\"gkHeart\"&gt;Your heart goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouse\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouse\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImage\">This is a sample image message. Use <strong>&lt;p    class=\"gkImage\"&gt;Your image message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformation\">This is a sample information message. Use <strong>&lt;p    class=\"gkInformation\"&gt;Your information message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifier\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifier\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMoney\">This is a sample money message. Use <strong>&lt;p    class=\"gkMoney\"&gt;Your money goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkNew\">This is a sample new message. Use <strong>&lt;p    class=\"gkNew\"&gt;Your new message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkNote\">This is a sample note message. Use <strong>&lt;p    class=\"gkNote\"&gt;Your note message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPage\">This is a sample page message. Use <strong>&lt;p    class=\"gkPage\"&gt;Your page goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPage_white\">This is a sample page_white message. Use <strong>&lt;p    class=\"gkPage_white\"&gt;Your page_white message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPlugin\">This is a sample plugin message. Use <strong>&lt;p    class=\"gkPlugin\"&gt;Your plugin message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkAccept\">This is a sample accept message. Use <strong>&lt;p    class=\"gkAccept\"&gt;Your accept goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkAdd\">This is a sample add message. Use <strong>&lt;p    class=\"gkAdd\"&gt;Your add message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCamera\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCamera\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkBrick\">This is a sample brick message. Use <strong>&lt;p    class=\"gkBrick\"&gt;Your brick goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkBox\">This is a sample box message. Use <strong>&lt;p    class=\"gkBox\"&gt;Your box message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCalendar\">This is a sample calendar message. Use <strong>&lt;p    class=\"gkCalendar\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons2\">Icon set 2</a></h4>\r\n<p class=\"gkAudioIs2\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudioIs2\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkEmailIs2\">This is a sample email message. Use <strong>&lt;p    class=\"gkEmailIs2\"&gt;Your email message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFeedIs2\">This is a sample feed message. Use <strong>&lt;p    class=\"gkFeedIs2\"&gt;Your feed message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImagesIs2\">This is a sample images message. Use <strong>&lt;p    class=\"gkImagesIs2\"&gt;Your images message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs2\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs2\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPrinterIs2\">This is a sample printer message. Use <strong>&lt;p    class=\"gkPrinterIs2\"&gt;Your printer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTimeIs2\">This is a sample time message. Use <strong>&lt;p    class=\"gkTimeIs2\"&gt;Your time message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUserIs2\">This is a sample user message. Use <strong>&lt;p    class=\"gkUserIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWorldIs2\">This is a sample world message. Use <strong>&lt;p    class=\"gkWorldIs2\"&gt;Your world message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCartIs2\">YThis is a sample cart message. Use <strong>&lt;p    class=\"gkCartIs2\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCdIs2\">This is a sample cd message. Use <strong>&lt;p    class=\"gkCdIs2\"&gt;Your cd message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartLineIs2\">This is a sample chart line message. Use <strong>&lt;p    class=\"gkChartLineIs2\"&gt;Your chart line message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartPieIs2\">This is a sample chart pie message. Use <strong>&lt;p    class=\"gkChartPieIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkClockIs2\">This is a sample clock message. Use <strong>&lt;p    class=\"gkClockIs2\"&gt;Your clock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCogIs2\">This is a sample config message. Use <strong>&lt;p    class=\"gkCogIs2\"&gt;Your config message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputerIs2\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputerIs2\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkErrorIs2\">This is a sample error message. Use <strong>&lt;p    class=\"gkErrorIs2\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkExclamationIs2\">This is a sample exclamation message. Use <strong>&lt;p    class=\"gkExclamationIs2\"&gt;Your exclamation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFilmIs2\">This is a sample movie message. Use <strong>&lt;p    class=\"gkFilmIs2\"&gt;Your movie message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFolderIs2\">This is a sample folder message. Use <strong>&lt;p    class=\"gkFolderIs2\"&gt;Your folder message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkGroupIs2\">This is a group calendar message. Use <strong>&lt;p    class=\"gkGroupIs2\"&gt;Your group message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouseIs2\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouseIs2\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImageIs2\">This is a sample image message. Use <strong>&lt;p    class=\"gkImageIs2\"&gt;Your image message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformationIs2\">This is a sample information message. Use <strong>&lt;p    class=\"gkInfromationIs2\"&gt;Your information message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifierIs2\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifierIs2\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMoneyIs2\">This is a sample money message. Use <strong>&lt;p    class=\"gkMoneyIs2\"&gt;Your money message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPageIs2\">This is a sample page message. Use <strong>&lt;p    class=\"gkPageIs2\"&gt;Your page message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs2\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs2\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCalendarIs2\">This is a calendar feed message. Use <strong>&lt;p    class=\"gkCalendarIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkContactIs2\">This is a sample contact message. Use <strong>&lt;p    class=\"gkContactIs2\"&gt;Your contact message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFacebookIs2\">This is a sample facebook message. Use <strong>&lt;p    class=\"gkFacebookIs2\"&gt;Your facebook message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLikeItIs2\">This is a sample like it message. Use <strong>&lt;p    class=\"gkLikeItIs2\"&gt;Your like it message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTwitterIs2\">This is a sample twitter message. Use <strong>&lt;p    class=\"gkTwitterIs2\"&gt;Your twitter message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkVimeoIs2\">This is a sample video message. Use <strong>&lt;p    class=\"gkVideoIs2\"&gt;Your video message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkYoutubeIs2\">This is a sample youtube message. Use <strong>&lt;p    class=\"gkYoutubeIs2\"&gt;Your youtube message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons3\">Icon set 3</a></h4>\r\n<p class=\"gkAudioIs3\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudioIs3\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs3\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs3\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs3\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs3\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUserIs3\">This is a sample user message. Use <strong>&lt;p    class=\"gkUserIs3\"&gt;Your user message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCartIs3\">This is a sample cart message. Use <strong>&lt;p    class=\"gkCartIs3\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartBarIs3\">This is a sample chart bar message. Use <strong>&lt;p    class=\"gkChartBarIs3\"&gt;Your chart bar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkConfigIs3\">This is a sample config message. Use <strong>&lt;p    class=\"gkConfigIs3\"&gt;Your config message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkConfig2Is3\">This is a sample configuration message. Use <strong>&lt;p    class=\"gkConfig2Is3\"&gt;Your configuration message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputerIs3\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputerIs3\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCoffeIs3\">This is a sample coffe message. Use <strong>&lt;p    class=\"gkCoffeIs3\"&gt;Your coffe message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCrossIs3\">This is a sample cross message. Use <strong>&lt;p    class=\"gkCrossIs3\"&gt;Your cross message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkErrorIs3\">This is a sample error message. Use <strong>&lt;p    class=\"gkErrorIs3\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouseIs3\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouseIs3\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformationIs3\">This is a sample information message. Use <strong>&lt;p    class=\"gkInformationIs3\"&gt;Your inforation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifierIs3\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifierIs3\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPageIs3\">This is a sample page message. Use <strong>&lt;p    class=\"gkPageIs3\"&gt;Your page message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs3\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs3\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs3\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs3\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkStarIs3\">This is a sample star message. Use <strong>&lt;p    class=\"gkStarIs3\"&gt;Your star message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTelephoneIs3\">This is a sample telephone message. Use <strong>&lt;p    class=\"gkTelephoneIs3\"&gt;Your telephone message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"tooltips\">Tooltips</a></h4>\r\n<p>Here are some examples of a <a class=\"gkTooltip\" href=\"#\">Classic<span class=\"classicTooltip\">This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Critical<span class=\"customTooltip criticalTooltip\"><em>Critical</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Help<span class=\"customTooltip helpTooltip\"><em>Help</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Information<span class=\"customTooltip infoTooltip\"><em>Information</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> and <a class=\"gkTooltip\" href=\"#\">Warning<span class=\"customTooltip warningTooltip\"><em>Warning</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> CSS powered tooltip. This is just an example of what you can do so feel free to get creative and produce your own!</p>\r\n<h4 class=\"demo-typo\"><a name=\"highlights\">Highlights</a></h4>\r\n<p>This is a <span class=\"gkHighlight1\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight1\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight2\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight2\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight3\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight3\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight4\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight4\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"code\">Code</a></h4>\r\n<p>Below is a sample of <strong>&lt;pre&gt;</strong> or <strong>&lt;div    class=\"gkCode1\"&gt;</strong></p>\r\n<p><strong> </strong></p>\r\n<pre>#wrapper {<br />	position: relative;<br />	float: left;<br />	display: block;<br />}<br /></pre>\r\n<p> </p>\r\n<p>Below is a sample of <strong>&lt;div class=\"gkCode2\"&gt;</strong></p>\r\n<div class=\"gkCode2\">#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br />}</div>\r\n<p> </p>\r\n<p>Below is a sample of <strong>&lt;div class=\"gkCode3\"&gt;&lt;h4&gt;Name    of your file&lt;/h4&gt;Here goes your code&lt;/div&gt;</strong></p>\r\n<p> </p>\r\n<div class=\"gkCode3\">\r\n<h4 class=\"demo-typo\">File</h4>\r\n#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br />}</div>\r\n<h4 class=\"demo-typo\"><a name=\"ulists\">Unordered lists</a></h4>\r\n<p>Types of unordered lists</p>\r\n<table border=\"0\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet1\"&gt;</strong></p>\r\n<ul class=\"gkBullet1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet2\"&gt;</strong></p>\r\n<ul class=\"gkBullet2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet3\"&gt;</strong></p>\r\n<ul class=\"gkBullet3\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet4\"&gt;</strong></p>\r\n<ul class=\"gkBullet4\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkCircle1\"&gt;</strong></p>\r\n<ul class=\"gkCircle1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkCircle2\"&gt;</strong></p>\r\n<ul class=\"gkCircle2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare1\"&gt;</strong></p>\r\n<ul class=\"gkSquare1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare2\"&gt;</strong></p>\r\n<ul class=\"gkSquare2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare3\"&gt;</strong></p>\r\n<ul class=\"gkSquare3\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<h4 class=\"demo-typo\"><a name=\"olists\">Ordered lists</a></h4>\r\n<p>Types of ordered list:</p>\r\n<table border=\"0\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkRoman\"&gt;</strong></p>\r\n<ol class=\"gkRoman\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkDec\"&gt;</strong></p>\r\n<ol class=\"gkDec\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkAlpha\"&gt;</strong></p>\r\n<ol class=\"gkAlpha\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkDecimalLeadingZero\"&gt;</strong></p>\r\n<ol class=\"gkDecimalLeadingZero\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p><strong>&lt;div class=\"gkNumber1\"&gt;&lt;p&gt;&lt;span&gt;here goes a    number&lt;/span&gt;and here text of element&lt;/p&gt;</strong></p>\r\n<div class=\"gkNumber1\">\r\n<p><span>01</span> Element</p>\r\n<p><span>02</span> Element</p>\r\n</div>\r\n<p><strong>&lt;div class=\"gkNumber2\"&gt;&lt;p&gt;&lt;span&gt;here goes a    number&lt;/span&gt;and here text of element&lt;/p&gt;</strong></p>\r\n<div class=\"gkNumber2\">\r\n<p><span>01</span> Element</p>\r\n<p><span>02</span> Element</p>\r\n<p> </p>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"abbrs\">Abbrs and acronyms</a></h4>\r\n<p>This is a sample of an abbreviation <abbr title=\"Doctor\">Dr</abbr>.    Use <strong>&lt;abbr title=\"Here goes full word or phrase\"&gt;here goes    an abbreviation&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<p>This is a sample of an acronym <acronym title=\"North Atlantic Treaty    Organization\">NATO</acronym>. Use <strong>&lt;acronym title=\"Here goes    full phrase\"&gt;here goes an acronym&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<h4 class=\"demo-typo\"><a name=\"definition\">Definition lists</a></h4>\r\n<p>Below are samples of definition lists</p>\r\n<p><strong>&lt;dl class=\"gkDef1\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef1\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<p><strong>&lt;dl class=\"gkDef2\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef2\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<p><strong>&lt;dl class=\"gkDef3\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef3\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<h4 class=\"demo-typo\"><a name=\"legends\">Legends</a></h4>\r\n<div class=\"gkLegend1\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend1\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend2\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend2\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend3\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend3\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend4\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend4\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend5\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend5\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend6\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend6\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend7\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend7\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"dropcaps\">Dropcaps</a></h4>\r\n<p><span class=\"gkDropcap1\">T</span>his is a sample text with Dropcap. Use    <strong>&lt;p&gt; &lt;span class=\"gkDropcap1\"&gt;t&lt;/span&gt;</strong> to make the first letter larger. Lorem ipsum dolor sit amet,   consectetur  adipiscing elit. Vestibulum condimentum pulvinar justo, sed   faucibus  ligula feugiat ac. Morbi quis enim nulla, vel congue augue.   Duis quis  quam sed purus porta eleifend. Vivamus ullamcorper est id   libero aliquam  ullamcorper. Donec eget dignissim augue. Donec ante   felis, aliquam ut  consequat eget, lobortis dapibus risus. Aliquam   laoreet enim et lectus  ornare hendrerit. Aliquam rhoncus enim libero.   Morbi aliquam, nibh  mattis feugiat dapibus, nisi massa adipiscing   justo, sit amet  condimentum urna ipsum et lacus. Nam fermentum, eros   quis ullamcorper  convallis, libero mauris lacinia eros, sed tempus leo   lorem vitae purus.  Nunc a malesuada felis. Cras ultrices sapien eu  nisi  elementum non  blandit urna sodales. Duis accumsan cursus massa,  eu  facilisis diam  porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkDropcap2\"><span class=\"gkDropcap2\">T</span>his is a sample text    with Dropcap. Use <strong>&lt;p&gt; &lt;span    class=\"gkDropcap2\"&gt;t&lt;/span&gt;</strong> to make the first letter    larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit.    Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac.    Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta    eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper.  Donec   eget dignissim augue. Donec ante felis, aliquam ut consequat  eget,   lobortis dapibus risus. Aliquam laoreet enim et lectus ornare  hendrerit.   Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis  feugiat   dapibus, nisi massa adipiscing justo, sit amet condimentum  urna ipsum et   lacus. Nam fermentum, eros quis ullamcorper convallis,  libero mauris   lacinia eros, sed tempus leo lorem vitae purus. Nunc a  malesuada felis.   Cras ultrices sapien eu nisi elementum non blandit  urna sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkDropcap3\"><span class=\"gkDropcap3\">T</span>his is a sample text    with Dropcap. Use <strong>&lt;p class=\"gkDropcap3\"&gt; &lt;span    class=\"gkDropcap3\"&gt;t&lt;/span&gt;</strong> to make the first letter    larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit.    Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac.    Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta    eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper.  Donec   eget dignissim augue. Donec ante felis, aliquam ut consequat  eget,   lobortis dapibus risus. Aliquam laoreet enim et lectus ornare  hendrerit.   Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis  feugiat   dapibus, nisi massa adipiscing justo, sit amet condimentum  urna ipsum et   lacus. Nam fermentum, eros quis ullamcorper convallis,  libero mauris   lacinia eros, sed tempus leo lorem vitae purus. Nunc a  malesuada felis.   Cras ultrices sapien eu nisi elementum non blandit  urna sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"blocks\">Floated blocks</a></h4>\r\n<p>Below are samples of text in which part of it is displayed in a    separate block</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextLeft\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextLeft\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextRight\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextRight\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextCenter\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextCenter\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<h4 class=\"demo-typo\"><a name=\"other\">Other span blocks</a></h4>\r\n<p><span class=\"gkClear\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkClear-1\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear-1\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkClear-2\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear-2\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-1\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-1\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-2\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-2\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-3\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-3\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-4\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-4\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-5\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-5\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-6\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-6\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-7\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-7\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<h4 class=\"demo-typo\"><a name=\"blockquote\">Blockquotes</a></h4>\r\n<blockquote>This is a sample quote text. Use <strong>&lt; blockquote    &gt; Your quoted text goes here!&lt; /blockquote &gt;</strong></blockquote>\r\n<blockquote>\r\n<div class=\"gkBlockquote1\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote1\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote2\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote2\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote3\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote4\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote4\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"tables\">Tables</a></h4>\r\n<table class=\"gkTable\" width=\"654\" height=\"94\">\r\n<thead> \r\n<tr>\r\n<td colspan=\"2\">Table Header (thead)</td>\r\n</tr>\r\n</thead><tfoot> \r\n<tr>\r\n<td colspan=\"2\">Table Footer (tfoot)</td>\r\n</tr>\r\n</tfoot> \r\n<tbody>\r\n<tr class=\"gkTableColor\">\r\n<td><strong>Column 1</strong></td>\r\n<td><strong>Column 2</strong></td>\r\n</tr>\r\n<tr>\r\n<td>Cell 3 - part of tbody</td>\r\n<td>Cell 4 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 5 - part of tbody</td>\r\n<td>Cell 6 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 7 - part of tbody</td>\r\n<td>Cell 8 - part of tbody</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p> </p>\r\n<table class=\"gkTable2\" width=\"656\" height=\"94\">\r\n<thead> \r\n<tr>\r\n<td colspan=\"2\">Table Header (thead)</td>\r\n</tr>\r\n</thead><tfoot> \r\n<tr>\r\n<td colspan=\"2\">Table Footer (tfoot)</td>\r\n</tr>\r\n</tfoot> \r\n<tbody>\r\n<tr class=\"gkTableColor\">\r\n<td><strong>Column 1</strong></td>\r\n<td><strong>Column 2</strong></td>\r\n</tr>\r\n<tr class=\"odd\">\r\n<td>Cell 1 - part of tbody</td>\r\n<td>Cell 2 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 3 - part of tbody</td>\r\n<td>Cell 4 - part of tbody</td>\r\n</tr>\r\n<tr class=\"odd\">\r\n<td>Cell 5 - part of tbody</td>\r\n<td>Cell 6 - part of tbody</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</blockquote>','',1,0,0,7,'2011-01-11 22:34:23',42,'','2011-08-17 10:39:43',42,0,'0000-00-00 00:00:00','2011-01-11 22:34:23','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_vote\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',62,0,6,'','',1,601,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(2,34,'Module positions','module-positions','','<p><img src=\"images/demo/module_positions.png\" border=\"0\" style=\"display: block; margin-left: auto; margin-right: auto; border: 0px none currentColor;\" /></p>','',1,0,0,7,'2011-01-12 16:57:05',42,'','2011-01-17 15:05:55',42,0,'0000-00-00 00:00:00','2011-01-12 16:57:05','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,5,'','',1,46,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(3,35,'Messages','messages','','<p>Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows:</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"message message fade\"> \r\n<ul>\r\n<li>This is a sample message</li>\r\n</ul>\r\n</dd></dl> \r\n</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"notice message fade\"> \r\n<ul>\r\n<li>This is a sample warning message</li>\r\n</ul>\r\n</dd></dl> \r\n</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"error message fade\"> \r\n<ul>\r\n<li>This is a sample error message</li>\r\n</ul>\r\n</dd></dl>\r\n</p>','',1,0,0,7,'2011-01-12 17:08:51',42,'','2011-01-20 10:10:47',42,0,'0000-00-00 00:00:00','2011-01-12 17:08:51','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,4,'','',1,97,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(4,36,'Chrome frame','chrome-frame','','<p>Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page.</p>\r\n<p>In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine.</p>\r\n<p>To get know more about Google Chrome Frame, please visit:</p>\r\n<p><a href=\"http://code.google.com/intl/en-GB/chrome/chromeframe/\">http://code.google.com/intl/en-GB/chrome/chromeframe/</a> - the official Projects web side containing the link to the plug-in.</p>\r\n<p><a href=\"http://www.chromium.org/developers/how-tos/chrome-frame-getting-started\">http://www.chromium.org/developers/how-tos/chrome-frame-getting-started</a> - more info about Google Chrome Frame for developers.</p>','',1,0,0,7,'2011-01-12 17:12:21',42,'','2011-01-17 14:37:56',42,0,'0000-00-00 00:00:00','2011-01-12 17:12:21','0000-00-00 00:00:00','','','{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,3,'','',1,103,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(5,38,'Menu types','menu-types','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-12 17:58:21',42,'','2011-01-12 18:16:21',42,0,'0000-00-00 00:00:00','2011-01-12 17:58:21','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,86,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(6,40,'Right column','right-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:18:41',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 19:18:41','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,8,'','',1,35,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(7,41,'Right two columns','right-two-columns','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:28:47',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 19:28:47','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,7,'','',1,41,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(8,42,'Left column','left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:33:11',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 19:33:11','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,6,'','',1,20,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(9,43,'Left two columns','left-two-columns','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:33:11',42,'','2011-01-12 20:49:37',42,0,'0000-00-00 00:00:00','2011-01-12 19:33:11','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,5,'','',1,36,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(10,44,'Content inset left','content-inset-left','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 21:11:22',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 21:11:22','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,4,'','',1,50,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(11,45,'Content inset right','content-inset-right','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 21:12:26',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 21:12:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,3,'','',1,21,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(12,46,'Content inset both','content-inset-both','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 21:12:26',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 21:12:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,2,'','',1,31,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(13,47,'Content inset + column','content-inset--column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 22:01:45',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 22:01:45','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,36,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(14,48,'Content inset + column (2x)','content-inset--column-2x','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 22:03:08',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 22:03:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,0,'','',1,28,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(15,49,'Split menu','split-menu','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-13 00:12:59',42,'','2011-01-13 00:14:18',42,0,'0000-00-00 00:00:00','2011-01-13 00:12:59','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,3,'','',1,64,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(16,50,'Dropline menu','dropline-menu','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-12 17:58:21',42,'','2011-01-12 18:16:21',0,0,'0000-00-00 00:00:00','2011-01-12 17:58:21','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,199,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(17,51,'GK Menu','gk-menu','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-13 00:12:59',42,'','2011-01-13 00:14:18',0,0,'0000-00-00 00:00:00','2011-01-13 00:12:59','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,0,'','',1,45,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(18,52,'Module variation','module-variation','','<p>On this page you can see basic suffixes used in this template. Please remember about using space at beginning of suffix name in module options.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Curabitur blandit tempus porttitor. Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. <br /><br />Donec id elit non mi porta gravida at eget metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas sed diam eget risus varius blandit sit amet non magna. <br /><br />Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Donec id elit non mi porta gravida at eget metus. Donec ullamcorper nulla non metus auctor fringilla. Aenean lacinia bibendum nulla sed consectetur. <br /><br />Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. <br /><br />Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.</p>','',1,0,0,7,'2011-01-13 12:30:01',42,'','2011-08-17 12:01:33',42,0,'0000-00-00 00:00:00','2011-01-13 12:30:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,213,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(19,59,'Archive article I','archive-article-i','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,0,0,2,'2011-01-13 16:01:40',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,3,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(20,60,'Archive article II','archive-article-ii','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,0,0,2,'2011-01-13 16:01:40',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(21,61,'Archive article III','archive-article-iii','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,0,0,2,'2011-01-13 16:01:40',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(23,63,'IE 6 style','ie-6-style','','<p>Internet Explorer 6 is on the way out, but there is still a significant number of users that are stuck to this browser. According to this, we decided that our templates are going to support IE 6 slightly. By dint of the \"IE6 Bar\" plug-in, available in templates menu options, users can apply the upper bar in their IE browser to keep them informed that Internet Explorer can not display the Web site properly. Additionally, instead of the whole range of template styles, we created one style- Universal Internet Explorer 6 CSS - project\'s website. Thanks to this, users will have the full access to the webs content, but on the other hand, a web sites appearance and functioning might be more rough to some extend.</p>','',1,0,0,7,'2011-01-17 14:47:32',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-17 14:47:32','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,27,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(24,64,'Lorem ipsum','lorem-ipsum','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo.</p>\r\n<p>Donec ullamcorper nulla non metus auctor fringilla. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas faucibus mollis interdum.</p>\r\n<p>Sed posuere consectetur est at lobortis. Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Nulla vitae elit libero, a pharetra augue. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Donec sed odio dui. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla. Maecenas sed diam eget risus varius blandit sit amet non magna. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum id ligula porta felis euismod semper.</p>\r\n<p>Curabitur blandit tempus porttitor. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>','',1,0,0,7,'2011-01-17 17:16:48',42,'','2011-01-17 17:50:27',42,0,'0000-00-00 00:00:00','2011-01-17 17:16:48','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,0,'','',1,243,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(25,67,'Welcome to Joomla!','welcome-to-joomla','','<div><strong>Joomla! is a free open source framework and content publishing  system designed for quickly creating highly interactive multi-language  Web sites, online communities, media portals, blogs and eCommerce  applications. <br /></strong></div>\r\n<p><strong><br /></strong><img class=\"caption\" src=\"http://localhost/financial/images/stories/powered_by.png\" border=\"0\" alt=\"Joomla! Logo\" title=\"Example Caption\" hspace=\"6\" vspace=\"0\" width=\"165\" height=\"68\" align=\"left\" />Joomla!  provides an easy-to-use graphical user interface that simplifies the  management and publishing of large volumes of content including HTML,  documents, and rich media.  Joomla! is used by organisations of all  sizes for intranets and extranets and is supported by a community of  tens of thousands of users.</p>\r\n','\r\n<p>With a fully documented library of developer resources, Joomla!  allows the customisation of every aspect of a Web site including  presentation, layout, administration, and the rapid integration with  third-party applications.</p>\r\n<p>Joomla! now provides more developer power while making the user  experience all the more friendly. For those who always wanted increased  extensibility, Joomla! 1.5 can make this happen.</p>\r\n<p>A new framework, ground-up refactoring, and a highly-active  development team brings the excitement of \'the next generation CMS\' to  your fingertips.  Whether you are a systems architect or a complete  \'noob\' Joomla! can take you to the next level of content delivery. \'More  than a CMS\' is something we have been playing with as a catchcry  because the new Joomla! API has such incredible power and flexibility,  you are free to take whatever direction your creative mind takes you and  Joomla! can help you get there so much more easily than ever before.</p>\r\n<p>Thinking Web publishing? Think Joomla!</p>',1,0,0,16,'2011-07-20 08:49:51',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-07-20 08:49:51','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(26,72,'Online Business Conference','online-business-conference','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Online Business Conference\" title=\"Online Business Conference\" align=\"left\" />With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.</p>\r\n','\r\n<p>More importantly, several e business meetings sites have been launched over the World Wide Web recently helping to their valued customers worldwide in a most artful and dedicated manner.<br /><br />Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,18,'2011-07-20 12:15:26',42,'','2011-08-19 14:09:09',42,0,'0000-00-00 00:00:00','2011-07-20 12:15:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(27,73,'Need Additional Capital?','need-additional-capital','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Need Additional Capital?\" title=\"Need Additional Capital?\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,18,'2011-07-20 12:17:45',42,'','2011-08-19 14:08:30',42,0,'0000-00-00 00:00:00','2011-07-20 12:17:45','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(28,74,'We celebrate your success! ','we-celebrate-your-success','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Online Business Conference\" title=\"Online Business Conference\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,18,'2011-07-20 12:25:43',42,'','2011-08-19 14:10:23',42,0,'0000-00-00 00:00:00','2011-07-20 12:25:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(29,75,'Idea about starting your own business','idea-about-starting-your-own-business','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Idea about starting your own business\" title=\"Idea about starting your own business\" align=\"left\" />In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to gauge their support and to get their advice.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi.</p>',1,0,0,18,'2011-07-20 12:27:42',42,'','2011-08-19 14:06:37',42,0,'0000-00-00 00:00:00','2011-07-20 12:27:42','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(30,76,'Support your financial success ','support-your-financial-success','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Support your financial success\" title=\"Support your financial success\" align=\"left\" />A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:29:48',42,'','2011-08-19 14:25:12',42,0,'0000-00-00 00:00:00','2011-07-20 12:29:48','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(31,77,'WorkShop from dedicated stractegy','workshop-from-dedicated-stractegy','','<p style=\"margin-top: 10px;\"><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"WorkShop from dedicated stractegy\" title=\"WorkShop from dedicated stractegy\" align=\"left\" />Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding</p>\r\n','\r\n<p>you can qualify for and who you can rely on is an important part of the decision making process.</p>\r\n<p>Business Financial Services (BFS) is the trusted provider of merchant cash advances to businesses nationwide. Since 2002, business owners have come to us to get the small business capital they need for inventory, vendor financing, renovation, equipment, taxes or just extra cash flow.</p>\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:31:43',42,'','2011-08-19 14:25:57',42,0,'0000-00-00 00:00:00','2011-07-20 12:31:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(32,78,'Office and Support Staff ','office-and-support-staff','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Office and Support Staff \" title=\"Office and Support Staff \" align=\"left\" />Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:33:51',42,'','2011-08-19 14:23:44',42,0,'0000-00-00 00:00:00','2011-07-20 12:33:51','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(33,79,'Creating a great team environment','creating-a-great-team-environment','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Creating a great team environment\" title=\"Creating a great team environment\" align=\"left\" />When your business encounters bumps in the road, it seems like everyone knows  especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:35:47',42,'','2011-08-19 14:23:01',42,0,'0000-00-00 00:00:00','2011-07-20 12:35:47','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(34,80,'Our business is built on friendship.','our-business-is-built-on-friendship','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Our business is built on friendship.\" title=\"Our business is built on friendship.\" align=\"left\" />Describe your company\'s <em>business</em> plan with this <em>presentation</em> for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia.</p>\r\n','\r\n<p>It all have to do with what you are ready, willing and able to accept within yourself and in accepting to be able to give others. It is your personal power to make the difference by being true to the best within you and letting truth shine through your words and actions. Be yourself in front of the eyes of the crowd.<br /><br /></p>\r\n<div style=\"text-align: justify;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</div>\r\n<p></p>',1,0,0,20,'2011-07-20 12:37:26',42,'','2011-08-19 14:27:59',42,0,'0000-00-00 00:00:00','2011-07-20 12:37:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(35,81,'Trusted in financial market','trusted-in-financial-market','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Trusted in financial market\" title=\"Trusted in financial market\" align=\"left\" />Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding you</p>\r\n','\r\n<p>can qualify for and who you can rely on is an important part of the decision making process. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',1,0,0,20,'2011-07-20 12:39:26',42,'','2011-08-19 14:29:30',42,0,'0000-00-00 00:00:00','2011-07-20 12:39:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(36,82,'Fully equipped modern workshop','fully-equipped-modern-workshop','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Fully equipped modern workshop\" title=\"Fully equipped modern workshop\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />~Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',1,0,0,20,'2011-07-20 12:41:06',42,'','2011-08-19 14:27:09',42,0,'0000-00-00 00:00:00','2011-07-20 12:41:06','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(37,83,'Top professional advisers','top-professional-advisers','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Top professional advisers\" title=\"Top professional advisers\" align=\"left\" />Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?</p>\r\n','\r\n<p>If yes, then please feel free to contact at www.ebusinessmeetings.net as this is yours own company who helps you regarding your e business meetings, conferences and seminars in a clearly artful and dedicated manner. It provides you the smart business meeting tips through which you would be instantly able to promote your own business meetings as well as conferences effortlessly. So please do not get hesitated to contact with E Business Meetings so as to get a perfect advice regarding your own business meetings.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.</p>',1,0,0,20,'2011-07-20 12:43:31',42,'','2011-08-19 14:28:43',42,0,'0000-00-00 00:00:00','2011-07-20 12:43:31','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,0,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');


--
-- Table structure for table `#__content_frontpage`
--



CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_frontpage`
--


INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES (23,5),(2,6),(4,8),(17,7),(3,4),(16,3),(31,2),(28,1);


--
-- Table structure for table `#__content_rating`
--



CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_rating`
--




--
-- Table structure for table `#__core_log_searches`
--



CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__core_log_searches`
--




--
-- Table structure for table `#__extensions`
--



CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10026 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__extensions`
--


INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(3,'com_admin','component','com_admin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(4,'com_banners','component','com_banners','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(5,'com_cache','component','com_cache','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(6,'com_categories','component','com_categories','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(8,'com_contact','component','com_contact','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"contact_layout\":\"_:default\",\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"plain\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"1\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10,'com_installer','component','com_installer','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(11,'com_languages','component','com_languages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),(12,'com_login','component','com_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(13,'com_media','component','com_media','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(14,'com_menus','component','com_menus','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(15,'com_messages','component','com_messages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(16,'com_modules','component','com_modules','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(19,'com_search','component','com_search','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(20,'com_templates','component','com_templates','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(22,'com_content','component','com_content','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"filters\":{\"1\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),(10023,'mod_gk_register','module','mod_gk_register','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_gk_register\",\"type\":\"module\",\"creationDate\":\"14\\/02\\/2011\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2011 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 1.0\",\"description\":\"GavickPro register form\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(23,'com_config','component','com_config','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(25,'com_users','component','com_users','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"useractivation\":\"1\",\"frontend_userparams\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"legacy\":false,\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"PHPMailer\",\"copyright\":\"Copyright (C) PHPMailer.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/phpmailer.codeworxtech.com\\/\",\"version\":\"1.7.0\",\"description\":\"Classes for sending email\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"legacy\":false,\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (C) 2008 SimplePie\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.0.1\",\"description\":\"A PHP-Based RSS and Atom Feed Framework.\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(102,'phputf8','library','phputf8','',0,1,1,1,'{\"legacy\":false,\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"1.7.0\",\"description\":\"Classes for UTF8\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(103,'Joomla! Web Application Framework','library','joomla','',0,1,1,0,'{\"legacy\":false,\"name\":\"Joomla! Web Application Framework\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"The Joomla! Web Application Framework is the Core of the Joomla! Content Management System\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(203,'mod_banners','module','mod_banners','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(206,'mod_feed','module','mod_feed','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(207,'mod_footer','module','mod_footer','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(208,'mod_login','module','mod_login','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(213,'mod_search','module','mod_search','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(216,'mod_users_latest','module','mod_users_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(220,'mod_articles_category','module','mod_articles_category','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\\n\\t\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(304,'mod_login','module','mod_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(306,'mod_online','module','mod_online','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(309,'mod_status','module','mod_status','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(311,'mod_title','module','mod_title','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(313,'mod_unread','module','mod_unread','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"none\"}','','',0,'0000-00-00 00:00:00',0,0),(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}','','',0,'0000-00-00 00:00:00',4,0),(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),(409,'plg_content_vote','plugin','vote','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.7.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2011\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.4.3.2\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"compressed\":\"0\",\"cleanup_startup\":\"0\",\"cleanup_save\":\"2\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"safari\":\"0\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(423,'plg_system_p3p','plugin','p3p','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0),(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',3,0),(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0),(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0),(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',9,0),(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),(433,'plg_user_profile','plugin','profile','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(500,'atomic','template','atomic','',0,1,1,0,'{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"1.7.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(502,'bluestork','template','bluestork','',1,1,1,0,'{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"1.7.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(503,'beez_20','template','beez_20','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"1.7.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),(504,'hathor','template','hathor','',1,1,1,0,'{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"1.7.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(505,'beez5','template','beez5','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"1.7.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(700,'files_joomla','file','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"July 2011\",\"author\":\"Joomla!\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10000,'Authentication - Facebook','plugin','facebook','authentication',0,1,1,0,'{\"legacy\":false,\"name\":\"Authentication - Facebook\",\"type\":\"plugin\",\"creationDate\":\"18 December 2010\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2010 - 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"GK4 1.0\",\"description\":\"GavickPro Facebook authentication plugin\",\"group\":\"\"}','{\"facebook_api_id\":\"171342606239806\",\"facebook_api_secret\":\"f08d507c3c74fc1688868f38cbe43331\",\"auto_register\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(10011,'System - GKreCaptcha','plugin','gk_recaptcha','system',0,1,1,0,'{\"legacy\":false,\"name\":\"System - GKreCaptcha\",\"type\":\"plugin\",\"creationDate\":\"23 January 2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"1.0\",\"description\":\"GavickPro reCaptcha plugin\",\"group\":\"\"}','{\"public_key\":\"6LfHc8YSAAAAAGcJ0NLN1VcMpwldK1HyF-a6dwDI \",\"private_key\":\"6LfHc8YSAAAAADZonH7o61FtzYXTFGPR-t1rxKag\",\"theme\":\"clean\",\"lang\":\"en\"}','','',0,'0000-00-00 00:00:00',0,0),(10009,'mod_tabs_gk4','module','mod_tabs_gk4','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_tabs_gk4\",\"type\":\"module\",\"creationDate\":\"20\\/01\\/2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK4 1.0\",\"description\":\"MOD_TABS_GK4_XML_DESC\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"module_height\":\"200\",\"buttons\":\"1\",\"tabs_position\":\"top\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"1\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"opacity\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"1\",\"useScript\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(10002,'Button - GK Typography','plugin','gk_typography','editors-xtd',0,1,1,0,'{\"legacy\":true,\"name\":\"Button - GK Typography\",\"type\":\"plugin\",\"creationDate\":\"08\\/01\\/2011\",\"author\":\"Robert Gavick - GavickPro\",\"copyright\":\"Copyrighted Commercial Software\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0.1\",\"description\":\"Plugin to easier typography using in Joomla WYSIWYG editors.\",\"group\":\"\"}','{\"typo_override\":\"gk_penguinmail:full.xml\"}','','',0,'0000-00-00 00:00:00',0,0),(10010,'GK Menu Extended Parameters','plugin','plg_gkextmenu','system',0,1,1,0,'{\"legacy\":true,\"name\":\"GK Menu Extended Parameters\",\"type\":\"plugin\",\"creationDate\":\"29 December 2010\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional menu options for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10004,'mod_news_pro_gk4','module','mod_news_pro_gk4','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_news_pro_gk4\",\"type\":\"module\",\"creationDate\":\"26\\/07\\/2011\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2011 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 1.7\",\"description\":\"\\n\\n\\t\\t<style type=\'text\\/css\'>span.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; } span.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; } span.readonly p { margin: 0 26px 10px } span.readonly p a { color: #ab3f0a } span.readonly p.homepage { margin-top: 30px } span.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }<\\/style><span class=\'readonly\'><h1>News Show Pro GK4 <small>ver. 1.6<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6.<\\/p><p>Basing on experiences gathered, we created probably the best tool to present articles for Joomla! Huge amount of options and possibilities of formatting causes News Show Pro GK4 is a complex tool in making www pages content attractive. News Show Pro is appropriate while preparing simple structures with an individual article, the same as, complex arrangements including few articles and a list of links.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/newshowpro.html\' target=\'_blank\'>Learn more at the NSP GK4 project website.<\\/a><\\/p><p class=\'license\'>News Show Pro GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\n\\t\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_width\":\"100\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":\"\",\"com_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"art_padding\":\"0 20px 20px 0\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"0\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"3\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"160\",\"img_height\":\"120\",\"img_margin\":\"6px 14px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"top_interface_style\":\"arrows_with_pagination\",\"bottom_interface_style\":\"arrows_with_counter\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\"}','','',0,'0000-00-00 00:00:00',0,0),(10008,'gk_finance_business','template','gk_finance_business','',0,1,1,0,'{\"legacy\":false,\"name\":\"gk_finance_business\",\"type\":\"template\",\"creationDate\":\"20 January 2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2010 - 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"1.0\",\"description\":\"TPL_GK_LANG_XML_DESCRIPTION\",\"group\":\"\"}','{\"template_color\":\"1\",\"mainbody_frontpage\":\"only_component\",\"mainbody_subpage\":\"mainbody_or_component\",\"messages_position\":\"message-position-1\",\"default_layout\":\"default\",\"facebook_layout\":\"facebook\",\"iphone_layout\":\"iphone\",\"android_layout\":\"android\",\"handheld_layout\":\"handheld\",\"template_width\":\"980px\",\"header1_width\":\"50\",\"left_column_width\":\"20\",\"left2_column_width\":\"50\",\"right_column_width\":\"20\",\"right2_column_width\":\"50\",\"inset_column_width\":\"20\",\"inset2_column_width\":\"20\",\"user1_6_widest_value\":\"0\",\"user1_6_widest\":\"user1\",\"user7_12_widest_value\":\"0\",\"user7_12_widest\":\"user7\",\"top1_6_widest_value\":\"0\",\"top1_6_widest\":\"top1\",\"top7_12_widest_value\":\"0\",\"top7_12_widest\":\"top7\",\"bottom1_6_widest_value\":\"0\",\"bottom1_6_widest\":\"bottom1\",\"bottom7_12_widest_value\":\"0\",\"bottom7_12_widest\":\"bottom7\",\"logo_type\":\"image\",\"logo_image\":\"\",\"logo_text\":\"\",\"logo_slogan\":\"\",\"print_logo\":\"\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"tools\":\"1\",\"typography\":\"0\",\"typo_iconset1\":\"0\",\"typo_iconset2\":\"0\",\"typo_iconset3\":\"0\",\"menu_type\":\"gk_menu\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_height\":\"0\",\"menu_width\":\"0\",\"menu_duration\":\"500\",\"mobile_login\":\"0\",\"mobile_register\":\"0\",\"mobile_desktop\":\"0\",\"mobile_search\":\"0\",\"mobile_collapsible\":\"0\",\"fb_api_id\":\"\",\"fb_lang\":\"en_US\",\"fb_login\":\"0\",\"fb_like\":\"0\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"500\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"fb_facepile\":\"0\",\"fb_facepile_max_rows\":\"1\",\"fb_facepile_width\":\"500\",\"tweet_btn\":\"0\",\"tweet_btn_data_count\":\"vertical\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"digg_btn\":\"0\",\"digg_btn_style\":\"0\",\"buzz_btn\":\"0\",\"buzz_btn_style\":\"0\",\"delicious_btn\":\"0\",\"instapaper_btn\":\"0\",\"excluded_cats\":\"\",\"selectivizr\":\"0\",\"reset_css\":\"\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"chrome_frame_support\":\"0\",\"ie6bar\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10012,'K2 Comments','module','mod_k2_comments','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Comments\",\"type\":\"module\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_COMMENTS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"\",\"\":\"K2_TOP_COMMENTERS\",\"catfilter\":\"0\",\"category_id\":\"\",\"comments_limit\":\"5\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"1\",\"itemCategory\":\"1\",\"feed\":\"1\",\"commenters_limit\":\"5\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10013,'K2 Content','module','mod_k2_content','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Content\",\"type\":\"module\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_MOD_K2_CONTENT_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"\":\"K2_OTHER_OPTIONS\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemCount\":\"5\",\"itemsOrdering\":\"\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"\",\"items\":\"\",\"itemTitle\":\"1\",\"itemAuthor\":\"1\",\"itemAuthorAvatar\":\"1\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"50\",\"userDescription\":\"1\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"\",\"itemImage\":\"1\",\"itemImgSize\":\"Small\",\"itemVideo\":\"1\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemAttachments\":\"1\",\"itemTags\":\"1\",\"itemCategory\":\"1\",\"itemDateCreated\":\"1\",\"itemHits\":\"1\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"1\",\"feed\":\"1\",\"itemPreText\":\"\",\"itemCustomLink\":\"0\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkTitle\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10014,'K2 Login','module','mod_k2_login','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Login\",\"type\":\"module\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_LOGIN_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10015,'K2 Tools','module','mod_k2_tools','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Tools\",\"type\":\"module\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_TOOLS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"\":\"K2_TAG_CLOUD_SETTINGS\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"\",\"authors_module_category\":\"\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":\"0\",\"cloud_category_recursive\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10016,'K2 Users','module','mod_k2_users','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Users\",\"type\":\"module\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_MOD_K2_USERS_DESCRTIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"0\",\"\":\"K2_DISPLAY_OPTIONS\",\"filter\":\"1\",\"K2UserGroup\":\"\",\"ordering\":\"1\",\"limit\":\"4\",\"userIDs\":\"\",\"userName\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"userDescription\":\"1\",\"userDescriptionWordLimit\":\"\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"userItemCount\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10017,'K2 QuickIcons (admin)','module','mod_k2_quickicons','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 QuickIcons (admin)\",\"type\":\"module\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE\",\"group\":\"\"}','{\"modCSSStyling\":\"1\",\"modLogo\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10018,'K2 Stats (admin)','module','mod_k2_stats','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 Stats (admin)\",\"type\":\"module\",\"creationDate\":\"March 14th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE\",\"group\":\"\"}','{\"latestItems\":\"1\",\"popularItems\":\"1\",\"mostCommentedItems\":\"1\",\"latestComments\":\"1\",\"statistics\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10019,'Search - K2','plugin','k2','search',0,1,1,0,'{\"legacy\":true,\"name\":\"Search - K2\",\"type\":\"plugin\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_tags\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10020,'System - K2','plugin','k2','system',0,1,1,0,'{\"legacy\":true,\"name\":\"System - K2\",\"type\":\"plugin\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10021,'User - K2','plugin','k2','user',0,1,1,0,'{\"legacy\":true,\"name\":\"User - K2\",\"type\":\"plugin\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10022,'k2','component','com_k2','',1,1,0,0,'{\"legacy\":true,\"name\":\"K2\",\"type\":\"component\",\"creationDate\":\"March 29th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5\",\"description\":\"K2_THANK_YOU_FOR_INSTALLING_K2_BY_JOOMLAWORKS_THE_POWERFUL_CONTENT_COMPONENT_FOR_JOOMLA_15\",\"group\":\"\"}','{\"enable_css\":\"1\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"1\",\"userFeed\":\"1\",\"userItemCount\":\"4\",\"userItemTitle\":\"1\",\"userItemTitleLinked\":\"1\",\"userItemDateCreated\":\"1\",\"userItemImage\":\"1\",\"userItemIntroText\":\"1\",\"userItemCategory\":\"0\",\"userItemTags\":\"1\",\"userItemCommentsAnchor\":\"1\",\"userItemReadMore\":\"1\",\"userItemK2Plugins\":\"1\",\"genericItemCount\":\"10\",\"genericItemTitle\":\"1\",\"genericItemTitleLinked\":\"1\",\"genericItemDateCreated\":\"1\",\"genericItemImage\":\"1\",\"genericItemIntroText\":\"1\",\"genericItemCategory\":\"1\",\"genericItemReadMore\":\"1\",\"genericItemExtraFields\":\"0\",\"tagOrdering\":\"\",\"feedLimit\":\"10\",\"feedItemImage\":\"1\",\"feedImgSize\":\"S\",\"feedItemIntroText\":\"1\",\"feedTextWordLimit\":\"\",\"feedItemFullText\":\"1\",\"feedItemTags\":\"0\",\"feedItemVideo\":\"0\",\"feedItemGallery\":\"0\",\"feedItemAttachments\":\"0\",\"introTextCleanup\":\"0\",\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":\"0\",\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":\"0\",\"linkPopupWidth\":\"900\",\"linkPopupHeight\":\"600\",\"imagesQuality\":\"100\",\"itemImageXS\":\"145\",\"itemImageS\":\"175\",\"itemImageM\":\"265\",\"itemImageL\":\"645\",\"itemImageXL\":\"900\",\"itemImageGeneric\":\"300\",\"catImageWidth\":\"185\",\"catImageDefault\":\"1\",\"userImageWidth\":\"120\",\"userImageDefault\":\"1\",\"commenterImgWidth\":\"48\",\"imageTimestamp\":\"0\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"urlShortener\":\"1\",\"comments\":\"1\",\"commentsOrdering\":\"DESC\",\"commentsLimit\":\"10\",\"commentsFormPosition\":\"below\",\"commentsPublishing\":\"1\",\"commentsReporting\":\"2\",\"commentsReportRecipient\":\"\",\"inlineCommentsModeration\":\"0\",\"gravatar\":\"1\",\"recaptcha\":\"1\",\"recaptcha_public_key\":\"6LfHc8YSAAAAAGcJ0NLN1VcMpwldK1HyF-a6dwDI\",\"recaptcha_private_key\":\"6LfHc8YSAAAAADZonH7o61FtzYXTFGPR-t1rxKag\",\"recaptcha_theme\":\"clean\",\"commentsFormNotes\":\"1\",\"commentsFormNotesText\":\"Make sure you enter the (*) required information where indicated.Basic HTML code is allowed.\",\"frontendEditing\":\"1\",\"showImageTab\":\"1\",\"showImageGalleryTab\":\"1\",\"showVideoTab\":\"1\",\"showExtraFieldsTab\":\"1\",\"showAttachmentsTab\":\"1\",\"showK2Plugins\":\"1\",\"sideBarDisplayFrontend\":\"0\",\"mergeEditors\":\"1\",\"sideBarDisplay\":\"1\",\"attachmentsFolder\":\"\",\"hideImportButton\":\"0\",\"taggingSystem\":\"1\",\"lockTags\":\"0\",\"showTagFilter\":\"0\",\"googleSearch\":\"0\",\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":\"0\",\"K2UserGroup\":\"1\",\"redirect\":\"\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"showItemsCounterAdmin\":\"1\",\"showChildCatItems\":\"1\",\"disableCompactOrdering\":\"0\",\"SEFReplacements\":\"\\u00c5\\u00a0|S, \\u00c5\\u2019|O, \\u00c5\\u00bd|Z, \\u00c5\\u00a1|s, \\u00c5\\u201c|oe, \\u00c5\\u00be|z, \\u00c5\\u00b8|Y, \\u00c2\\u00a5|Y, \\u00c2\\u00b5|u, \\u00c3\\u20ac|A, \\u00c3\\ufffd|A, \\u00c3\\u201a|A, \\u00c3\\u0192|A, \\u00c3\\u201e|A, \\u00c3\\u2026|A, \\u00c3\\u2020|A, \\u00c3\\u2021|C, \\u00c3\\u02c6|E, \\u00c3\\u2030|E, \\u00c3\\u0160|E, \\u00c3\\u2039|E, \\u00c3\\u0152|I, \\u00c3\\ufffd|I, \\u00c3\\u017d|I, \\u00c3\\ufffd|I, \\u00c3\\ufffd|D, \\u00c3\\u2018|N, \\u00c3\\u2019|O, \\u00c3\\u201c|O, \\u00c3\\u201d|O, \\u00c3\\u2022|O, \\u00c3\\u2013|O, \\u00c3\\u02dc|O, \\u00c3\\u2122|U, \\u00c3\\u0161|U, \\u00c3\\u203a|U, \\u00c3\\u0153|U, \\u00c3\\ufffd|Y, \\u00c3\\u0178|s, \\u00c3\\u00a0|a, \\u00c3\\u00a1|a, \\u00c3\\u00a2|a, \\u00c3\\u00a3|a, \\u00c3\\u00a4|a, \\u00c3\\u00a5|a, \\u00c3\\u00a6|a, \\u00c3\\u00a7|c, \\u00c3\\u00a8|e, \\u00c3\\u00a9|e, \\u00c3\\u00aa|e, \\u00c3\\u00ab|e, \\u00c3\\u00ac|i, \\u00c3\\u00ad|i, \\u00c3\\u00ae|i, \\u00c3\\u00af|i, \\u00c3\\u00b0|o, \\u00c3\\u00b1|n, \\u00c3\\u00b2|o, \\u00c3\\u00b3|o, \\u00c3\\u00b4|o, \\u00c3\\u00b5|o, \\u00c3\\u00b6|o, \\u00c3\\u00b8|o, \\u00c3\\u00b9|u, \\u00c3\\u00ba|u, \\u00c3\\u00bb|u, \\u00c3\\u00bc|u, \\u00c3\\u00bd|y, \\u00c3\\u00bf|y, \\u00c3\\u0178|ss\",\"metaDescLimit\":\"150\",\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":\"2\",\"sh404SefTitleAlias\":\"alias\"}','','',0,'0000-00-00 00:00:00',0,0),(10024,'Joomla! Content Management System','package','pkg_joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"Joomla! Content Management System\",\"type\":\"package\",\"creationDate\":\"2006\",\"author\":\"Joomla!\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"The Joomla! Content Management System is one of the most popular content management system\'s available today.\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10025,'Image Show GK4','module','mod_image_show_gk4','',0,1,0,0,'{\"legacy\":false,\"name\":\"Image Show GK4\",\"type\":\"module\",\"creationDate\":\"11\\/08\\/2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK4 1.12\",\"description\":\"\\n\\t\\t<style type=\\\"text\\/css\\\">\\n\\t\\t\\tspan.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; }\\n\\t\\t\\tspan.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; }\\n\\t\\t\\tspan.readonly p { margin: 0 26px 10px }\\n\\t\\t\\tspan.readonly p a { color: #8e0b8c }\\n\\t\\t\\tspan.readonly p.homepage { margin-top: 30px }\\n\\t\\t\\tspan.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }\\n\\t\\t<\\/style>\\n\\n\\t\\t<span class=\\\"readonly\\\"><h1>Image Show GK4<small>ver. 1.12<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6+.<\\/p><p>With Image Show GK4 module, you can create slideshow on a site which include various images and article fragments or texts defined by a user. Thanks to slide management system integrated in the module, its support is very easy, intuitive and fast. With the new method of creating module styles you can easily move your slideshow style from one template to other template.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/image-show.html\' target=\'_blank\'>Learn more at the Image Show GK4 project website.<\\/a><\\/p><p class=\'license\'>Image Show GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-is-1\",\"moduleclass_sfx\":\"\",\"module_style\":\"gk_coffe\"}','','',0,'0000-00-00 00:00:00',0,0);


--
-- Table structure for table `#__k2_attachments`
--



CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_attachments`
--




--
-- Table structure for table `#__k2_categories`
--



CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_categories`
--


INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`) VALUES (1,'Financial Business','financial-business','<p class=\"ItemCatDesc\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus.</p>',0,0,1,1,1,'','{\"inheritFrom\":\"0\",\"num_leading_items\":\"0\",\"num_leading_columns\":\"0\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"0\",\"num_primary_columns\":\"0\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"0\",\"secondaryImgSize\":\"Small\",\"num_links\":\"0\",\"num_links_columns\":\"0\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"1\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"0\",\"catDescription\":\"1\",\"catImage\":\"0\",\"catFeedLink\":\"0\",\"feedLink\":\"0\",\"subCategories\":\"1\",\"subCatColumns\":\"3\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,''),(2,'Financial Adviser','financial-adviser','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus. Quisque aliquet posuere libero at molestie.</p>',1,0,1,1,1,'2.png','{\"inheritFrom\":\"3\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"2\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"feedLink\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,''),(3,'Investment Guide','investment-guide','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus. Quisque aliquet posuere libero at molestie</p>',1,0,1,1,2,'3.png','{\"inheritFrom\":\"0\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"2\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"2\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"0\",\"secondaryImgSize\":\"Large\",\"num_links\":\"0\",\"num_links_columns\":\"0\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"0\",\"catFeedLink\":\"1\",\"feedLink\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"0\",\"catItemDateCreated\":\"0\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"20\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"0\",\"catItemTags\":\"0\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,''),(4,'Market Center','market-center','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus. Quisque aliquet posuere libero at molestie.</p>',1,1,1,1,3,'4.png','{\"inheritFrom\":\"3\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"2\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"2\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"feedLink\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,'');


--
-- Table structure for table `#__k2_comments`
--



CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_comments`
--


INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`) VALUES (1,7,0,'Robert','2011-08-17 17:03:31','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi faucibus risus id metus porttitor sit amet vulputate nibh blandit.','eeee@aaa.pl','',1),(2,8,0,'Robert','2011-08-17 17:04:26','Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue.','eeee@aaa.pl','',1),(3,8,0,'Paulo','2011-08-17 17:05:04','Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum','eeeee@aa.pl','',1),(4,6,0,'Paulo','2011-08-17 17:06:45','Aliquam auctor feugiat ante, ac lobortis metus facilisis sit amet. Proin mollis mollis ultrices. Sed elementum faucibus lacinia. Vivamus posuere.','eeeee@aa.pl','',1);


--
-- Table structure for table `#__k2_extra_fields`
--



CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields`
--


INSERT INTO `#__k2_extra_fields` (`id`, `name`, `value`, `type`, `group`, `published`, `ordering`) VALUES (1,'Theme','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,1),(2,'Version','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,2),(3,'Demo','[{\"name\":\"\",\"value\":\"http:\\/\\/\",\"target\":\"new\"}]','link',1,1,3),(4,'Developer','[{\"name\":\"\",\"value\":\"http:\\/\\/\",\"target\":\"new\"}]','link',1,1,4);


--
-- Table structure for table `#__k2_extra_fields_groups`
--



CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields_groups`
--


INSERT INTO `#__k2_extra_fields_groups` (`id`, `name`) VALUES (1,'PortFolio');


--
-- Table structure for table `#__k2_items`
--



CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `created` (`created`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_items`
--


INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`) VALUES (1,'Online Business Conference','online-business-conference',2,1,'<p>With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.</p>\r\n','\r\n<p>More importantly, several e business meetings sites have been launched over the World Wide Web recently helping to their valued customers worldwide in a most artful and dedicated manner.<br /><br />Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam</p>',NULL,NULL,'[]','','2011-07-12 09:17:45',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:49:06',42,'2011-07-12 09:17:45','0000-00-00 00:00:00',0,1,1,0,0,'Online Business Conference','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(2,'Need Additional Capital?','need-additional-capital?',2,1,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:21:17',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:49:42',42,'2011-07-12 09:21:17','0000-00-00 00:00:00',0,1,2,1,1,'Need Additional Capital?','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(3,'We celebrate your success! ','we-celebrate-your-success',2,1,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:24:22',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:50:57',42,'2011-07-12 09:24:22','0000-00-00 00:00:00',0,1,3,0,0,'We celebrate your success! ','','','',4,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(4,'Idea about starting your own business','idea-about-starting-your-own-business',2,1,'<p>In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to gauge their support and to get their advice.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi.</p>',NULL,NULL,'[]','','2011-07-12 09:25:58',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:51:27',42,'2011-07-12 09:25:58','0000-00-00 00:00:00',0,1,4,1,2,'Idea about starting your own business','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(5,'Support your financial success ','support-your-financial-success',3,1,'<p>A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:33:33',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:47:39',42,'2011-07-12 09:33:33','0000-00-00 00:00:00',0,1,1,0,0,'Support your financial success ','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(6,'WorkShop from dedicated stractegy','workshop-from-dedicated-stractegy',3,1,'<p>Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding</p>\r\n','\r\n<p>you can qualify for and who you can rely on is an important part of the decision making process.</p>\r\n<p>Business Financial Services (BFS) is the trusted provider of merchant cash advances to businesses nationwide. Since 2002, business owners have come to us to get the small business capital they need for inventory, vendor financing, renovation, equipment, taxes or just extra cash flow.</p>\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:38:15',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:46:55',42,'2011-07-12 09:38:15','0000-00-00 00:00:00',0,1,2,0,0,'WorkShop from dedicated stractegy','','','',5,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(7,'Office and Support Staff ','office-and-support-staff',3,1,'<p>Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:55:04',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:46:12',42,'2011-07-12 09:55:04','0000-00-00 00:00:00',0,1,3,0,0,'Office and Support Staff ','','','',2,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(8,'Creating a great team environment','creating-a-great-team-environment',3,1,'<p>When your business encounters bumps in the road, it seems like everyone knows  especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 10:09:11',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:45:05',42,'2011-07-12 10:09:11','0000-00-00 00:00:00',0,1,4,1,3,'Creating a great team environment','','','',6,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(9,'Our business is built on friendship.','our-business-is-built-on-friendship',4,1,'<p>Describe your company\'s <em>business</em> plan with this <em>presentation</em> for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia.</p>\r\n','\r\n<p>It all have to do with what you are ready, willing and able to accept within yourself and in accepting to be able to give others. It is your personal power to make the difference by being true to the best within you and letting truth shine through your words and actions. Be yourself in front of the eyes of the crowd.<br /><br /></p>\r\n<div style=\"text-align: justify;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</div>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"PostNote\"},{\"id\":\"2\",\"value\":\"Jun 2010\"},{\"id\":\"3\",\"value\":[\"Click here\",\"http:\\/\\/demo.gavick.com\\/joomla15\\/jun2010\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"GavickPro Creative Joomla! Development Studio\",\"http:\\/\\/www.gavick.com\",\"new\"]}]','PostNote Jun 2010 Click here http://demo.gavick.com/joomla15/jun2010/  GavickPro Creative Joomla! Development Studio http://www.gavick.com  ','2011-07-12 10:17:07',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:44:23',42,'2011-07-12 10:17:07','0000-00-00 00:00:00',0,1,1,0,0,'Our business is built on friendship.','','','',49,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(10,'Trusted in financial market','trusted-in-financial-market',4,1,'<p>Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding you</p>\r\n','\r\n<p>can qualify for and who you can rely on is an important part of the decision making process. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]}]','   http://   http://  ','2011-07-12 10:19:19',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:43:43',42,'2011-07-12 10:19:19','0000-00-00 00:00:00',0,1,2,1,4,'Trusted in financial market','','','',6,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(11,'Fully equipped modern workshop','fully-equipped-modern-workshop',4,1,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />~Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"Click here\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"GavickPro Creative Joomla! Development Studio\",\"http:\\/\\/\",\"new\"]}]','  Click here http://  GavickPro Creative Joomla! Development Studio http://  ','2011-07-12 10:23:54',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:43:06',42,'2011-07-12 10:23:54','0000-00-00 00:00:00',0,1,3,0,0,'Fully equipped modern workshop','','','',8,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(12,'Top professional advisers','top-professional-advisers',4,1,'<p>Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?</p>\r\n','\r\n<p>If yes, then please feel free to contact at www.ebusinessmeetings.net as this is yours own company who helps you regarding your e business meetings, conferences and seminars in a clearly artful and dedicated manner. It provides you the smart business meeting tips through which you would be instantly able to promote your own business meetings as well as conferences effortlessly. So please do not get hesitated to contact with E Business Meetings so as to get a perfect advice regarding your own business meetings.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]}]','   http://   http://  ','2011-07-12 10:29:13',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:42:21',42,'2011-07-12 10:29:13','0000-00-00 00:00:00',0,1,4,0,0,'Top professional advisers','','','',14,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','',''),(13,'Copy of Top professional advisers','top-professional-advisers',4,0,'<p>Latest e business ideas as well as concepts are being introduced by the   most professional and dedicated e business companies worldwide. So do   you have a perfect e business plan?  Do you instantly want to promote  your e business conference?</p>','<p>If yes,  then please feel free to contact at www.ebusinessmeetings.net  as this is  yours own company who helps you regarding your e business  meetings,  conferences and seminars in a clearly artful and dedicated  manner. It  provides you the smart business meeting tips through which  you would be  instantly able to promote your own business meetings as  well as  conferences effortlessly. So please do not get hesitated to  contact  with E Business Meetings so as to get a perfect advice  regarding your  own business meetings.<br /><br />Nulla at est quis leo  placerat iaculis. Integer massa augue,  pellentesque eu facilisis nec,  auctor et turpis. Vivamus congue blandit  nisl nec auctor. Proin rutrum  magna iaculis arcu malesuada a suscipit  nisl tincidunt. Etiam id quam  semper diam dapibus pretium ac vel arcu.  Cras ornare, eros consectetur  gravida pharetra, nisi enim luctus eros,  blandit accumsan tortor ligula  non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing  elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id  eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac.  Nullam nibh neque, varius et congue sit amet, placerat eget nibh.  Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque.  Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque  commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada  ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan  eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit  amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis  leo placerat iaculis. Integer massa augue, pellentesque eu facilisis  nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin  rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id  quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros  consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan  tortor ligula non tortor.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]}]','   http://   http://  ','2011-07-20 12:05:48',42,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2011-07-12 10:29:13','0000-00-00 00:00:00',1,1,4,0,0,'Top professional advisers','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','');


--
-- Table structure for table `#__k2_rating`
--



CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_rating`
--




--
-- Table structure for table `#__k2_tags`
--



CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=23 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags`
--


INSERT INTO `#__k2_tags` (`id`, `name`, `published`) VALUES (1,'support',1),(2,'Business',1),(3,'Conference',1),(4,'capital',1),(5,'credit',1),(6,'financial',1),(7,'idea',1),(8,'sucess',1),(9,'workshop',1),(10,'strategy',1),(11,'staff',1),(12,'office',1),(13,'team',1),(14,'environment',1),(15,'friendship',1),(16,'market',1),(17,'trust',1),(18,'professionalism',1),(19,'advisers',1),(20,'client',1),(21,'Vitory',1),(22,'Team Work',1);


--
-- Table structure for table `#__k2_tags_xref`
--



CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM AUTO_INCREMENT=199 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags_xref`
--


INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`) VALUES (180,3,1),(179,2,1),(178,1,1),(190,6,2),(189,5,2),(188,4,2),(187,2,2),(186,1,2),(198,7,4),(197,6,4),(196,2,4),(195,1,4),(166,8,5),(165,2,5),(164,1,5),(160,10,6),(159,9,6),(158,8,6),(157,2,6),(152,12,7),(151,11,7),(150,2,7),(149,1,7),(144,14,8),(143,13,8),(142,6,8),(141,2,8),(136,15,9),(135,6,9),(134,2,9),(130,17,10),(129,16,10),(128,6,10),(127,2,10),(122,18,11),(121,9,11),(120,2,11),(116,20,12),(115,19,12),(114,6,12),(113,2,12),(42,19,13),(43,20,13),(44,2,13),(45,6,13),(191,2,3),(192,8,3),(193,21,3),(194,22,3);


--
-- Table structure for table `#__k2_user_groups`
--



CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_user_groups`
--


INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`) VALUES (1,'Registered','{\"comment\":\"1\",\"frontEdit\":\"0\",\"add\":\"0\",\"editOwn\":\"0\",\"editAll\":\"0\",\"publish\":\"0\",\"inheritance\":\"0\",\"categories\":\"all\"}'),(2,'Site Owner','{\"comment\":\"1\",\"frontEdit\":\"1\",\"add\":\"1\",\"editOwn\":\"1\",\"editAll\":\"1\",\"publish\":\"1\",\"inheritance\":\"1\",\"categories\":\"all\"}');


--
-- Table structure for table `#__k2_users`
--



CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_users`
--


INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`) VALUES (1,42,'Super User','m','<p>Hi my name is Bob Urichuck and I have been the SEO Director on Business Financial Inc. More than 5000 employees support BF Inc outsourcing <em>business</em>, delivering a seamless customer service experience to <em>our</em> client.</p>','1.jpg','http://www.gavick.com',2,'');


--
-- Table structure for table `#__languages`
--



CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__languages`
--


INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `published`, `ordering`) VALUES (1,'en-GB','English (UK)','English (UK)','en','en','','','',1,0);


--
-- Table structure for table `#__menu`
--



CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias` (`client_id`,`parent_id`,`alias`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=216 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu`
--


INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES (1,'','Menu_Item_Root','root','','','','',1,0,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,241,0,'*',0),(2,'menu','com_banners','Banners','','Banners','index.php?option=com_banners','component',0,1,1,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',1,10,0,'*',1),(3,'menu','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',2,3,0,'*',1),(4,'menu','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',4,5,0,'*',1),(5,'menu','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',6,7,0,'*',1),(6,'menu','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',8,9,0,'*',1),(7,'menu','com_contact','Contacts','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',11,16,0,'*',1),(8,'menu','com_contact','Contacts','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',12,13,0,'*',1),(9,'menu','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',14,15,0,'*',1),(10,'menu','com_messages','Messaging','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',17,22,0,'*',1),(11,'menu','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',18,19,0,'*',1),(12,'menu','com_messages_read','Read Private Message','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',20,21,0,'*',1),(13,'menu','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',23,28,0,'*',1),(14,'menu','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',24,25,0,'*',1),(15,'menu','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',26,27,0,'*',1),(16,'menu','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',37,38,0,'*',1),(17,'menu','com_search','Search','','Search','index.php?option=com_search','component',0,1,1,19,0,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',29,30,0,'*',1),(18,'menu','com_weblinks','Weblinks','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',31,36,0,'*',1),(19,'menu','com_weblinks_links','Links','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',32,33,0,'*',1),(20,'menu','com_weblinks_categories','Categories','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',34,35,0,'*',1),(101,'mainmenu','Home','home','','home','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',39,40,1,'*',0),(102,'mainmenu','Template','template','','template','#','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"2\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',41,128,0,'*',0),(103,'mainmenu','Template articles','template-articles','','template/lorem-ipsum/template-articles','#','url',1,123,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',43,56,0,'*',0),(104,'mainmenu','Typography','typography','','template/lorem-ipsum/template-articles/typography','index.php?option=com_content&view=article&id=1','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" demo_typography\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" demo_typography\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',44,45,0,'*',0),(105,'mainmenu','Error page','error-page','','template/lorem-ipsum/template-articles/error-page','?option=non-existing-component','url',1,103,4,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',46,47,0,'*',0),(106,'mainmenu','Offline page','offline-page','','template/lorem-ipsum/template-articles/offline-page','?tmpl=offline','url',1,103,4,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',48,49,0,'*',0),(107,'mainmenu','Module positions','module-positions','','template/lorem-ipsum/module-positions','index.php?option=com_content&view=article&id=2','component',1,123,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',57,58,0,'*',0),(108,'mainmenu','Messages','messages','','template/lorem-ipsum/template-articles/messages','index.php?option=com_content&view=article&id=3','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',50,51,0,'*',0),(109,'mainmenu','Chrome frame','chrome-frame','','template/lorem-ipsum/template-articles/chrome-frame','index.php?option=com_content&view=article&id=4','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',52,53,0,'*',0),(110,'mainmenu','Menu types','menu-types','','menu-types','index.php?option=com_content&view=article&id=5','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',129,136,0,'*',0),(111,'mainmenu','Dropline menu','dropline-menu','','menu-types/dropline-menu','index.php?option=com_content&view=article&id=16','component',1,110,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',132,133,0,'*',0),(112,'mainmenu','Split menu','split-menu','','menu-types/split-menu','index.php?option=com_content&view=article&id=15','component',1,110,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',134,135,0,'*',0),(113,'mainmenu','Layouts','layouts','','template/lorem-ipsum-ii/layouts','#','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',63,82,0,'*',0),(114,'mainmenu','Right column','right-column','','template/lorem-ipsum-ii/layouts/right-column','index.php?option=com_content&view=article&id=6','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',64,65,0,'*',0),(115,'mainmenu','Right two columns','right-two-columns','','template/lorem-ipsum-ii/layouts/right-two-columns','index.php?option=com_content&view=article&id=7','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',66,67,0,'*',0),(116,'mainmenu','Left column','left-column','','template/lorem-ipsum-ii/layouts/left-column','index.php?option=com_content&view=article&id=8','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',68,69,0,'*',0),(117,'mainmenu','Left two columns','left-two-columns','','template/lorem-ipsum-ii/layouts/left-two-columns','index.php?option=com_content&view=article&id=9','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',70,71,0,'*',0),(118,'mainmenu','Content inset left','content-inset-left','','template/lorem-ipsum-ii/layouts/content-inset-left','index.php?option=com_content&view=article&id=10','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',72,73,0,'*',0),(119,'mainmenu','Content inset both','content-inset-both','','template/lorem-ipsum-ii/layouts/content-inset-both','index.php?option=com_content&view=article&id=12','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',74,75,0,'*',0),(120,'mainmenu','Content inset right','content-inset-right','','template/lorem-ipsum-ii/layouts/content-inset-right','index.php?option=com_content&view=article&id=11','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',76,77,0,'*',0),(121,'mainmenu','Content inset + column','content-inset-column','','template/lorem-ipsum-ii/layouts/content-inset-column','index.php?option=com_content&view=article&id=13','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',78,79,0,'*',0),(122,'mainmenu','Content inset + column (2x)','content-inset-column-2x','','template/lorem-ipsum-ii/layouts/content-inset-column-2x','index.php?option=com_content&view=article&id=14','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',80,81,0,'*',0),(123,'mainmenu','Lorem ipsum','lorem-ipsum','','template/lorem-ipsum','#','url',1,102,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"Group1\",\"gk_cols\":\"1\",\"gk_group\":\"1\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',42,61,0,'*',0),(124,'mainmenu','Lorem ipsum II','lorem-ipsum-ii','','template/lorem-ipsum-ii','#','url',1,102,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"Group2\",\"gk_cols\":\"1\",\"gk_group\":\"1\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',62,127,0,'*',0),(125,'mainmenu','Who\'s online','2011-01-12-23-23-21','','modules-menu/2011-01-12-23-23-21','index.php?option=com_content&view=archive','url',1,137,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"pos\",\"gk_subcontent_pos_positions\":\"menu1\"}',138,139,0,'*',0),(126,'mainmenu','GK Menu','gk-menu','','menu-types/gk-menu','index.php?option=com_content&view=article&id=17','component',1,110,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',130,131,0,'*',0),(127,'mainmenu','Module variations','module-variations','','template/lorem-ipsum/module-variations','index.php?option=com_content&view=article&id=18','component',1,123,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',59,60,0,'*',0),(128,'mainmenu','Joomla pages I','joomla-pages-i','','template/lorem-ipsum-ii/joomla-pages-i','#','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',83,96,0,'*',0),(129,'mainmenu','Contact categories','contact-categories','','template/lorem-ipsum-ii/joomla-pages-i/contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',84,85,0,'*',0),(130,'mainmenu','Contacts in Category','contacts-in-category','','template/lorem-ipsum-ii/joomla-pages-i/contacts-in-category','index.php?option=com_contact&view=category&id=10','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"0\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"1\",\"show_fax_headings\":\"1\",\"show_suburb_headings\":\"0\",\"show_state_headings\":\"0\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',86,87,0,'*',0),(131,'mainmenu','Single Contact','single-contact','','template/lorem-ipsum-ii/joomla-pages-i/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"0\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',88,89,0,'*',0),(132,'mainmenu','Weblink single category','weblink-single-category','','template/lorem-ipsum-ii/joomla-pages-i/weblink-single-category','index.php?option=com_weblinks&view=category&id=13','component',1,128,4,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',90,91,0,'*',0),(134,'mainmenu','Web Link Categories Link','web-link-categories-link','','template/lorem-ipsum-ii/joomla-pages-i/web-link-categories-link','index.php?option=com_weblinks&view=categories&id=0','component',1,128,4,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',92,93,0,'*',0),(135,'mainmenu','Joomla Pages II','joomla-pages-ii','','template/lorem-ipsum-ii/joomla-pages-ii','#','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',97,112,0,'*',0),(136,'mainmenu','News feeds categories list','news-feeds-categories-list','','template/lorem-ipsum-ii/joomla-pages-ii/news-feeds-categories-list','index.php?option=com_newsfeeds&view=categories&id=0','component',1,135,4,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',98,99,0,'*',0),(137,'mainmenu','Modules menu','modules-menu','','modules-menu','#','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',137,140,0,'*',0),(138,'mainmenu','News feeds in a category','news-feeds-in-a-category','','template/lorem-ipsum-ii/joomla-pages-ii/news-feeds-in-a-category','index.php?option=com_weblinks&view=category&id=13','component',1,135,4,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',100,101,0,'*',0),(139,'mainmenu','User login','user-login','','template/lorem-ipsum-ii/joomla-pages-ii/user-login','index.php?option=com_users&view=login','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',102,103,0,'*',0),(140,'mainmenu','User registration','user-registration','','template/lorem-ipsum-ii/joomla-pages-ii/user-registration','index.php?option=com_users&view=registration','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',104,105,0,'*',0),(141,'mainmenu','User profile','user-profile','','template/lorem-ipsum-ii/joomla-pages-ii/user-profile','index.php?option=com_users&view=profile','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',106,107,0,'*',0),(142,'mainmenu','User remind','user-remind','','template/lorem-ipsum-ii/joomla-pages-ii/user-remind','index.php?option=com_users&view=remind','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',108,109,0,'*',0),(143,'mainmenu','Password reset','password-reset','','template/lorem-ipsum-ii/joomla-pages-ii/password-reset','index.php?option=com_users&view=reset','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',110,111,0,'*',0),(144,'mainmenu','Featured contacts','featured-contacts','','template/lorem-ipsum-ii/joomla-pages-i/featured-contacts','index.php?option=com_contact&view=featured','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',94,95,0,'*',0),(145,'mainmenu','Joomla pages III','joomla-pages-iii','','template/lorem-ipsum-ii/joomla-pages-iii','','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',113,126,0,'*',0),(146,'mainmenu','Archieved Articles','archieved-articles','','template/lorem-ipsum-ii/joomla-pages-iii/archieved-articles','index.php?option=com_content&view=archive','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',114,115,0,'*',0),(147,'mainmenu','Single Article','single-article','','template/lorem-ipsum-ii/joomla-pages-iii/single-article','index.php?option=com_content&view=article&id=24','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',116,117,0,'*',0),(148,'mainmenu','Categories List','categories-list','','template/lorem-ipsum-ii/joomla-pages-iii/categories-list','index.php?option=com_content&view=categories&id=0','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',118,119,0,'*',0),(149,'mainmenu','Blog Layout','blog-layout','','template/lorem-ipsum-ii/joomla-pages-iii/blog-layout','index.php?option=com_content&view=category&layout=blog&id=7','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',120,121,0,'*',0),(150,'mainmenu','Category List','category-list','','template/lorem-ipsum-ii/joomla-pages-iii/category-list','index.php?option=com_content&view=category&id=7','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',122,123,0,'*',0),(151,'mainmenu','Featured Articles','featured-articles','','template/lorem-ipsum-ii/joomla-pages-iii/featured-articles','index.php?option=com_content&view=featured','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',124,125,0,'*',0),(152,'footmenu','About Joomla!','about-joomla','','about-joomla','index.php?option=com_content&view=article&id=4','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',141,142,0,'*',0),(153,'footmenu','Features','features','','features','index.php?option=com_content&view=article&id=18','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',143,144,0,'*',0),(154,'footmenu','News','news','','news','index.php?option=com_content&view=article&id=1','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',145,146,0,'*',0),(155,'footmenu','The Community','the-community','','the-community','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',147,148,0,'*',0),(156,'mobile-menu','Home','home-2','','home-2','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',149,150,0,'*',0),(157,'mobile-menu','Template articles','template-articles','','template-articles','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',151,162,0,'*',0),(158,'mobile-menu','Typography','typography','','template-articles/typography','index.php?option=com_content&view=article&id=1','component',1,157,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" demo_typography\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" demo_typography\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',152,153,0,'*',0),(159,'mobile-menu','Error page','error-page','','template-articles/error-page','?option=non-existing-component','url',1,157,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',154,155,0,'*',0),(160,'mobile-menu','Offline page','offline-page','','template-articles/offline-page','?tmpl=offline','url',1,157,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',156,157,0,'*',0),(161,'mobile-menu','Messages','messages','','template-articles/messages','index.php?option=com_content&view=article&id=3','component',1,157,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',158,159,0,'*',0),(162,'mobile-menu','Chrome frame','chrome-frame','','template-articles/chrome-frame','index.php?option=com_content&view=article&id=4','component',1,157,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',160,161,0,'*',0),(175,'mobile-menu','Joomla pages I','joomla-pages-i','','joomla-pages-i','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',163,176,0,'*',0),(176,'mobile-menu','Contact categories','contact-categories','','joomla-pages-i/contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',164,165,0,'*',0),(177,'mobile-menu','Contacts in Category','contacts-in-category','','joomla-pages-i/contacts-in-category','index.php?option=com_contact&view=category&id=10','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"0\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"1\",\"show_fax_headings\":\"1\",\"show_suburb_headings\":\"0\",\"show_state_headings\":\"0\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',166,167,0,'*',0),(178,'mobile-menu','Single Contact','single-contact','','joomla-pages-i/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"0\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',168,169,0,'*',0),(179,'mobile-menu','Weblink single category','weblink-single-category','','joomla-pages-i/weblink-single-category','index.php?option=com_weblinks&view=category&id=13','component',1,175,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',170,171,0,'*',0),(180,'mobile-menu','Web Link Categories Link','web-link-categories-link','','joomla-pages-i/web-link-categories-link','index.php?option=com_weblinks&view=categories&id=0','component',1,175,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',172,173,0,'*',0),(181,'mobile-menu','Featured contacts','featured-contacts','','joomla-pages-i/featured-contacts','index.php?option=com_contact&view=featured','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',174,175,0,'*',0),(182,'mobile-menu','Joomla Pages II','joomla-pages-ii','','joomla-pages-ii','index.php?Itemid=','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',177,192,0,'*',0),(183,'mobile-menu','News feeds categories list','news-feeds-categories-list','','joomla-pages-ii/news-feeds-categories-list','index.php?option=com_newsfeeds&view=categories&id=0','component',1,182,2,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',178,179,0,'*',0),(184,'mobile-menu','News feeds in a category','news-feeds-in-a-category','','joomla-pages-ii/news-feeds-in-a-category','index.php?option=com_weblinks&view=category&id=13','component',1,182,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',180,181,0,'*',0),(185,'mobile-menu','User login','user-login','','joomla-pages-ii/user-login','index.php?option=com_users&view=login','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',182,183,0,'*',0),(186,'mobile-menu','User registration','user-registration','','joomla-pages-ii/user-registration','index.php?option=com_users&view=registration','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',184,185,0,'*',0),(187,'mobile-menu','User profile','user-profile','','joomla-pages-ii/user-profile','index.php?option=com_users&view=profile','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',186,187,0,'*',0),(188,'mobile-menu','User remind','user-remind','','joomla-pages-ii/user-remind','index.php?option=com_users&view=remind','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',188,189,0,'*',0),(189,'mobile-menu','Password reset','password-reset','','joomla-pages-ii/password-reset','index.php?option=com_users&view=reset','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',190,191,0,'*',0),(190,'mobile-menu','Joomla pages III','joomla-pages-iii','','joomla-pages-iii','index.php?Itemid=','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',193,206,0,'*',0),(191,'mobile-menu','Archieved Articles','archieved-articles','','joomla-pages-iii/archieved-articles','index.php?option=com_content&view=archive','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',194,195,0,'*',0),(192,'mobile-menu','Single Article','single-article','','joomla-pages-iii/single-article','index.php?option=com_content&view=article&id=4','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',196,197,0,'*',0),(193,'mobile-menu','Categories List','categories-list','','joomla-pages-iii/categories-list','index.php?option=com_content&view=categories&id=0','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',198,199,0,'*',0),(194,'mobile-menu','Blog Layout','blog-layout','','joomla-pages-iii/blog-layout','index.php?option=com_content&view=category&layout=blog&id=7','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',200,201,0,'*',0),(195,'mobile-menu','Category List','category-list','','joomla-pages-iii/category-list','index.php?option=com_content&view=category&id=7','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',202,203,0,'*',0),(196,'mobile-menu','Featured Articles','featured-articles','','joomla-pages-iii/featured-articles','index.php?option=com_content&view=featured','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',204,205,0,'*',0),(198,'mainmenu','IE6 Style','ie-6-style','','template/lorem-ipsum/template-articles/ie-6-style','index.php?option=com_content&view=article&id=23','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',54,55,0,'*',0),(199,'mainemu','Your Profile','your-profile','','your-profile','index.php?option=com_users&view=profile','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',207,208,0,'*',0),(200,'mainemu','Edit Profile','edit-profile','','edit-profile','index.php?option=com_users&view=profile&layout=edit','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',209,210,0,'*',0),(201,'mainemu','Create Article','create-article','','create-article','index.php?option=com_content&view=form&layout=edit','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',211,212,0,'*',0),(202,'mainemu','Submit a Web Link','submit-a-web-link','','submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,1,1,21,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',213,214,0,'*',0),(203,'main','K2','k2','','k2','index.php?option=com_k2','component',0,1,1,10022,0,0,'0000-00-00 00:00:00',0,1,'components/com_k2/images/system/k2-icon.png',0,'',215,216,0,'',1),(204,'mainmenu','K2','2011-07-28-18-14-23','','2011-07-28-18-14-23','http://getk2.org/','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',217,232,0,'*',0),(205,'mainmenu','item','item','','2011-07-28-18-14-23/item','index.php?option=com_k2&view=item&layout=item&id=9','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',218,219,0,'*',0),(206,'mainmenu','Categories','categories','','2011-07-28-18-14-23/categories','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=1','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"1\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',220,227,0,'*',0),(207,'mainmenu','Financial Adviser','financial-adviser','','2011-07-28-18-14-23/categories/financial-adviser','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=2','component',1,206,3,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"2\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',221,222,0,'*',0),(208,'mainmenu','Investment Guide','investment-guide','','2011-07-28-18-14-23/categories/investment-guide','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=3','component',1,206,3,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"3\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',223,224,0,'*',0),(209,'mainmenu','Market Center','market-center','','2011-07-28-18-14-23/categories/market-center','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=4','component',1,206,3,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"4\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',225,226,0,'*',0),(210,'mainmenu','User','user','','2011-07-28-18-14-23/user','index.php?option=com_k2&view=itemlist&layout=user&id=42&task=user','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"feedLink\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',228,229,0,'*',0),(211,'mainmenu','Tag','tag','','2011-07-28-18-14-23/tag','index.php?option=com_k2&view=itemlist&layout=tag&tag=Business&task=tag','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"categoriesFilter\":[\"2\",\"3\",\"4\"],\"tagOrdering\":\"\",\"feedLink\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',230,231,0,'*',0),(212,'mainmenu','News','2011-08-19-13-59-20','','2011-08-19-13-59-20','#','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',233,240,0,'*',0),(213,'mainmenu','Financial adviser','financial-adviser','','2011-08-19-13-59-20/financial-adviser','index.php?option=com_content&view=category&layout=blog&id=18','component',1,212,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"2\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',234,235,0,'*',0),(214,'mainmenu','Investment Guide','investment-guide','','2011-08-19-13-59-20/investment-guide','index.php?option=com_content&view=category&layout=blog&id=19','component',1,212,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',236,237,0,'*',0),(215,'mainmenu','Market Center','market-center','','2011-08-19-13-59-20/market-center','index.php?option=com_content&view=category&layout=blog&id=20','component',1,212,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',238,239,0,'*',0);


--
-- Table structure for table `#__menu_types`
--



CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu_types`
--


INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES (1,'mainmenu','Main Menu','The main menu for the site'),(2,'footmenu','Footer menu',''),(3,'mobile-menu','Mobile menu','Menu for mobile devices'),(4,'mainemu','User Menu','');


--
-- Table structure for table `#__messages`
--



CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages`
--




--
-- Table structure for table `#__messages_cfg`
--



CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages_cfg`
--




--
-- Table structure for table `#__modules`
--



CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) DEFAULT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=119 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules`
--


INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES (1,'Main Menu','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(6,'Unread Messages','','',1,'header',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_unread',3,1,'',1,'*'),(7,'Online Users','','',2,'header',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_online',3,1,'',1,'*'),(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),(14,'User Status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),(16,'Sign In','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,0,'{\"pretext\":\"Log in to your account or \",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*'),(17,'Breadcrumbs','','',1,'position-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,1,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(18,'Banners','','',1,'position-5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"27\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(19,'Right column (right-top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(23,'Left column (left-bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(20,'Right column (right-left)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(22,'Right column (right-bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(21,'Right column (right-right)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_right',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(24,'Left column (left-top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(25,'Left column (left-right)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_right',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(26,'Left column (left-left)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(27,'Inset left (inset1)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'inset1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(28,'Mainbody top (mainbody_top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(29,'Inset right (inset2)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'inset2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(30,'Mainbody bottom (mainbody_bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(31,'Top module (top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(32,'Bottom module (bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(33,'Pinguin video','','<p>\r\n\r\n<param name=\"movie\" value=\"http://www.youtube.com/v/eKG08z85DtY?fs=1&amp;hl=pl_PL&amp;rel=0\" />\r\n<param name=\"allowFullScreen\" value=\"true\" />\r\n<param name=\"allowscriptaccess\" value=\"always\" />\r\n\r\n</p>',1,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(34,'Statistics','','',0,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_stats',1,1,'{\"serverinfo\":\"0\",\"siteinfo\":\"0\",\"counter\":\"0\",\"increase\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(35,'Who\'s online','','',0,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_whosonline',1,1,'{\"showmode\":\"0\",\"linknames\":\"0\",\"linktowhat\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*'),(36,'\"badge-new\"','','',0,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-new\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(37,'\"badge-hot\"','','',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-hot\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(38,'\"badge-top\"','','',1,'top3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-top\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(39,'\"badge-soon\"','','',1,'top4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-soon\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(40,'Default module','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',0,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(41,'Suffix \" light1\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(42,'Suffix \" light2\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(43,'Suffix \" light3\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(44,'Suffix \" border1\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(45,'Suffix \" border2\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(46,'Suffix \" border3\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(47,'Suffix \" border4\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border4\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(48,'Suffix  \" smalltitle\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" smalltitle\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(49,'Suffix      \" bigtitle\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" bigtitle\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(50,'Suffix \"_menu color1\"','','<ul class=\"menu\">\r\n<li class=\"item1\"><a href=\"../oct2010/\"><span>Home</span></a></li>\r\n<li class=\"parent\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=19&amp;Itemid=27\"><span>Template</span></a> </li>\r\n<li class=\"parent item56\"><a href=\"#\"><span>Template articles</span></a></li>\r\n<li id=\"current\" class=\"active item59\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=47&amp;Itemid=59\"><span>Module variations</span></a></li>\r\n<li class=\"item117\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=65&amp;Itemid=117\"><span>GK Tab variations</span></a></li>\r\n<li class=\"item60\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=48&amp;Itemid=60\"><span>Module positions</span></a></li>\r\n</ul>',0,'left_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu color1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(51,'Suffix \"_menu\"','','<ul class=\"menu\">\r\n<li class=\"item1\"><a href=\"../oct2010/\"><span>Home</span></a></li>\r\n<li class=\"parent\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=19&amp;Itemid=27\"><span>Template</span></a> </li>\r\n<li class=\"parent item56\"><a href=\"#\"><span>Template articles</span></a></li>\r\n<li id=\"current\" class=\"active item59\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=47&amp;Itemid=59\"><span>Module variations</span></a></li>\r\n<li class=\"item117\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=65&amp;Itemid=117\"><span>GK Tab variations</span></a></li>\r\n<li class=\"item60\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=48&amp;Itemid=60\"><span>Module positions</span></a></li>\r\n</ul>',1,'left_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(52,'Suffix \"_text\"','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"5\",\"cid\":\"0\",\"catid\":[\"3\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured Links:\",\"footer_text\":\"<a href=\\\"http:\\/\\/www.joomla.org\\\">Ads by Joomla!<\\/a>\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_text\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(53,'Suffix \" clear\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet.</p>',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(54,'Our offers','','<ul>\r\n<li><a href=\"#\">New products</a></li>\r\n<li><a href=\"#\">Top sellers</a></li>\r\n<li><a href=\"#\">Specials</a></li>\r\n<li><a href=\"#\">Manufacturers</a></li>\r\n<li><a href=\"#\">Suppliers</a></li>\r\n</ul>',0,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(55,'Shipping Info','','<ul>\r\n<li><a href=\"#\">Returns</a></li>\r\n<li><a href=\"#\">Delivery</a></li>\r\n<li><a href=\"#\">Customer Service</a></li>\r\n<li><a href=\"#\">Gift Cards</a></li>\r\n<li><a href=\"#\">Extended Service Plan</a></li>\r\n</ul>',0,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(56,'Account','','<ul>\r\n<li><a href=\"#\">Your Account</a></li>\r\n<li><a href=\"#\">Personal information</a></li>\r\n<li><a href=\"#\">Addresses</a></li>\r\n<li><a href=\"#\">Discount</a></li>\r\n<li><a href=\"#\">Orders history</a></li>\r\n</ul>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(57,'Support','','<ul>\r\n<li><a href=\"#\">Site Map</a></li>\r\n<li><a href=\"#\">Search Terms</a></li>\r\n<li><a href=\"#\">Advanced Search</a></li>\r\n<li><a href=\"#\">Mobile</a></li>\r\n<li><a href=\"#\">Contact Us</a></li>\r\n</ul>',0,'bottom5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(58,'Sell','','<ul>\r\n<li><a href=\"#\">Top-rated sellers</a></li>\r\n<li><a href=\"#\">Affiliates</a></li>\r\n<li><a href=\"#\">Learn to sell</a></li>\r\n<li><a href=\"#\">Bestsellers</a></li>\r\n<li><a href=\"#\">Sell is an art</a></li>\r\n</ul>',1,'bottom6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(59,'Frontpage - demo content','','<p><img src=\"images/demo/img4.jpg\" alt=\"Mailing list\" style=\"display: block;\" /></p>\r\n<p><small>The Admin Console allows you to control every aspect of Email Temlate - in multiple languages. </small></p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(60,'Frontpage - demo content','','<div>\r\n<h3>Quick &amp; Easy deployment</h3>\r\n<img src=\"images/demo/img1.png\" alt=\"Quick &amp; Easy deployment\" />Add your own text and images as you please, and arrange them until you\'re completely satisfied with your creation.</div>\r\n<div>\r\n<h3>Track and analyze your email</h3>\r\n<img src=\"images/demo/img2.png\" alt=\"Track and analyze your email\" />Add your own text and images as you please, and arrange them until you\'re completely satisfied with your creation.</div>\r\n<div>\r\n<h3>Manage lists and subscribers</h3>\r\n<img src=\"images/demo/img3.png\" alt=\"Manage lists and subscribers\" />Add your own text and images as you please, and arrange them until you\'re completely satisfied with your creation.</div>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light3 demoFront1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(61,'Frontpage - demo content','','<div>\r\n<h1>Email marketing that is Powerful, Easy and Fun!</h1>\r\nStore up to 1,000 subscribers - Send up to 6,000 emails a month.</div>\r\n<p><a class=\"buttonGreen\" href=\"#\">Sign Up Free!</a></p>',1,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" demoFront2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(62,'User Menu','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',2,1,'{\"menutype\":\"mainemu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(63,'Frontpage - demo content','','Get in touch\r\n<h1>+48 800 801 5577</h1>',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(72,'Categories','','',1,'left_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(64,'Frontpage - demo content','','<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>Our clients are blown away when we demo PenguinMail.\r\n<p><strong><em><small>Robert Gavick, Designer</small></em></strong></p>\r\n</div>\r\n</div>\r\n</blockquote>',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(65,'Search','','',0,'search',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,0,'{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(66,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"0\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(67,'Footer','','',0,'footer_nav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_footer',1,0,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(68,'Footer menu','','',1,'footer_nav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"footmenu\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(69,'Test ','','<param name=\"movie\" value=\"http://www.youtube.com/v/EnlCz1P95WM?fs=1&amp;hl=pl_PL&amp;rel=0\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowscriptaccess\" value=\"always\"></param>',1,'menu2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(70,'mod_news_pro_gk4','','',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_width\":\"100\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"7\"],\"com_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"art_padding\":\"0 20px 20px 0\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"3\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"160\",\"img_height\":\"120\",\"img_margin\":\"6px 14px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"top_interface_style\":\"arrows_with_pagination\",\"bottom_interface_style\":\"arrows_with_counter\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(71,'mod_tabs_gk4','','',1,'header',42,'2011-08-18 14:15:48','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_tabs_gk4',1,0,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\" clear tabHeader\",\"module_height\":\"377\",\"tabs_data\":\"[{\\\"name\\\":\\\"Tab 1\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]div class=\\\\\\\"tabHeaderStyle\\\\\\\"[rightbracket]\\\\n[leftbracket]h1 class=\\\\\\\"tabH1\\\\\\\"[rightbracket]Create and send [leftbracket]strong[rightbracket]newsletters[leftbracket]\\/strong[rightbracket] [leftbracket]span[rightbracket]in a second.[leftbracket]\\/span[rightbracket][leftbracket]\\/h1[rightbracket]\\\\n[leftbracket]a class=\\\\\\\"bigButton\\\\\\\" href=\\\\\\\"#\\\\\\\"[rightbracket]Try It Now[leftbracket]span[rightbracket]30-day trial, then $30[leftbracket]\\/span[rightbracket][leftbracket]\\/a[rightbracket][leftbracket]\\/div[rightbracket]\\\\n[leftbracket]img src=\\\\\\\"images\\/demo\\/header.png\\\\\\\" alt=\\\\\\\"Mail\\\\\\\" style=\\\\\\\"border: 0; float: right; margin: 0px;\\\\\\\" \\/[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Tab 2\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]img src=\\\\\\\"images\\/demo\\/img8.png\\\\\\\" alt=\\\\\\\"Newsletter\\\\\\\" \\/[rightbracket][leftbracket]br \\/[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Tab 3\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]img src=\\\\\\\"images\\/demo\\/img7.png\\\\\\\" alt=\\\\\\\"demo-image\\\\\\\" \\/[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"}]\",\"buttons\":\"0\",\"tabs_position\":\"bottom\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"0\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"slider\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(73,'K2 Comments','','',1,'right_bottom',42,'2011-08-17 17:09:17','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_comments',1,1,'{\"moduleclass_sfx\":\" light3\",\"module_usage\":\"0\",\"catfilter\":\"0\",\"comments_limit\":\"3\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"0\",\"itemCategory\":\"0\",\"feed\":\"0\",\"commenters_limit\":\"3\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(74,'K2 Content','','',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_content',1,1,'{\"moduleclass_sfx\":\" border\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"catfilter\":\"1\",\"category_id\":[\"2\",\"3\",\"4\"],\"getChildren\":\"0\",\"itemCount\":\"2\",\"itemsOrdering\":\"rand\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"0\",\"itemTitle\":\"1\",\"itemAuthor\":\"0\",\"itemAuthorAvatar\":\"0\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"30\",\"userDescription\":\"0\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"16\",\"itemImage\":\"1\",\"itemImgSize\":\"Medium\",\"itemVideo\":\"0\",\"itemVideoCaption\":\"0\",\"itemVideoCredits\":\"0\",\"itemAttachments\":\"0\",\"itemTags\":\"0\",\"itemCategory\":\"0\",\"itemDateCreated\":\"0\",\"itemHits\":\"0\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"0\",\"feed\":\"1\",\"itemPreText\":\"Find some of our top services and take advantage of the most professional and determine team.\",\"itemCustomLink\":\"0\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkTitle\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(75,'K2 Login','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_login',1,1,'',0,'*'),(76,'K2 Categories','','',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"_menu\",\"module_usage\":\"4\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(77,'K2 Users','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_users',1,1,'',0,'*'),(78,'K2 QuickIcons (admin)','','',99,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_quickicons',1,1,'',1,'*'),(79,'K2 Stats (admin)','','',100,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_stats',1,1,'',1,'*'),(80,'Default module','','',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(81,'Suffix \" smaller\"','','',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" smaller\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(82,'Suffix \" color\"','','',1,'top3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(83,'Suffix \" font1\"','','',1,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" font1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(84,'Suffix \" clear\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu   odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique   quis sagittis lectus imperdiet.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Curabitur blandit  tempus porttitor. Etiam porta sem malesuada magna mollis euismod.</p>',1,'top8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(85,'Suffix \" icon-info\"','','<p>You can also use a lot of suffixes with icons. There is available 13   suffixes with prefix   \"icon-\":icon-rss,icon-mail,.icon-alert,.icon-cog,.icon-clock,.icon-calendar,.icon-chat,.icon-marker,.icon-document,.icon-mac,.icon-ipad,.icon-info,.icon-access.</p>',1,'top10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-info\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(86,'Suffix \"_menu\"','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"2\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(87,'Suffix \" font2\"','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" font2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(88,'Suffix \" icon-cog\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-cog\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(89,'Suffix \" icon-clock\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-clock\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(90,'Suffix \" icon-mail\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-mail\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(91,'Suffix \" icon-marker\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-marker\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(92,'Suffix \" icon-chat\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-chat\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(93,'Suffix \" icon-calendar\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-calendar\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(94,'Suffix \" icon-ipad\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-ipad\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(95,'Suffix \" icon-document\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-document\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(96,'Suffix \" icon-rss\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-rss\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(97,'Suffix \" icon-alert\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-alert\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(98,'Suffix \" icon-access\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-access\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(99,'Suffix \" icon-mac\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-mac\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(100,'Suffix \" color4\"','','',1,'user7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color4\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(101,'Suffix \" color3\"','','',1,'user8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(102,'Suffix \" color2\"','','',1,'user9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(103,'Suffix \" color1\"','','',1,'user10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(104,'Tabs color','','',1,'bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_tabs_gk4',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\" color\",\"module_height\":\"144\",\"tabs_data\":\"[{\\\"name\\\":\\\"First\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Second\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. \\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Third\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla sed consectetur. \\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"}]\",\"buttons\":\"0\",\"tabs_position\":\"top\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"0\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"slider\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"1\"}',0,'*'),(107,'News','','',1,'header2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_1\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"309\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"34,37,27,26,31\",\"k2_articles\":\"9,12,2,1,6,8\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"16\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"1\",\"news_limit_type\":\"chars\",\"news_limit\":\"23\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 20px 0 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"74\",\"img_height\":\"74\",\"img_margin\":\"0 10px 18px 0\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"5\",\"simple_crop_bottom\":\"5\",\"simple_crop_left\":\"30\",\"simple_crop_right\":\"30\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"1\"}',0,'*'),(105,'Tabs default','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_tabs_gk4',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\"\",\"module_height\":\"170\",\"tabs_data\":\"[{\\\"name\\\":\\\"First\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\\u000a\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Second\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\\u000a \\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Third\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\\u000a\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"}]\",\"buttons\":\"0\",\"tabs_position\":\"top\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"0\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"slider\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"1\"}',0,'*'),(106,'Image Show','','<p><img src=\"images/image_show.png\" border=\"0\" /></p>',1,'header1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(108,'Popular','','',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color1\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"none\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"0\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(109,'News','','',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color2\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro2\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"title\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"0\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(110,'Top Rated ','','',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color3\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro3\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"title\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\"}',0,'*'),(111,'Latest','','',1,'user4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color4\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro4\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"ordering\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"0\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(112,'mod_gk_register','','',1,'register',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_gk_register',1,1,'',0,'*'),(113,'NSP - Portal mode 2','','',2,'mainbody',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,0,'{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_2\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"2\",\"3\",\"4\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHOR %COMMENTS %DATE %HITS\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"123\",\"img_height\":\"82\",\"img_margin\":\"3px 5px 3px 5px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\"}',0,'*'),(114,'NSP - Portal mode 3','','',1,'mainbody',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,0,'{\"moduleclass_sfx\":\" clean\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_3\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"3\",\"4\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"2\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"5\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"left\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"0\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"60\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHOR %COMMENTS %DATE %HITS %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"7px 20px 10px 0\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"1\"}',0,'*'),(115,'K2 Tag Cloud','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\" border1\",\"module_usage\":\"7\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"130\",\"cloud_limit\":\"20\",\"cloud_category\":[\"2\",\"3\",\"4\"],\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(116,'Advertise','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"5\",\"cid\":\"0\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured links:\",\"footer_text\":\"<a href=\\\"http:\\/\\/www.joomla.org\\\">Ads by Joomla!<\\/a>\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_text\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(117,'NSP GK4 suffix \" nsp\"','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"2\",\"3\",\"4\"],\"k2_articles\":\"\",\"news_sort_value\":\"hits\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"2\",\"news_full_pages\":\"2\",\"news_column\":\"2\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_counter\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"17\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"none\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"100\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"%COMMENTS %HITS\",\"category_link\":\"0\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 12px 0 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"left\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows_with_pagination\",\"links_margin\":\"20px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"90\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_keep_aspect_ratio\":\"1\",\"img_width\":\"170\",\"img_height\":\"90\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"10\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"10\",\"simple_crop_right\":\"10\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(118,'Image Show GK4','','',1,'header1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_image_show_gk4',1,0,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-is-1\",\"moduleclass_sfx\":\"\",\"module_style\":\"gk_financial_business\",\"last_modification\":\"1313761171\",\"image_show_data\":\"[{\\\"name\\\":\\\"Strong technical team with innovative solutions\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide1.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#1\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Dedicated strategy workshop\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide2.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#2\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Creating a great team environment\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide3.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#3\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Top professional advisers support our customers\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide4.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#4\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Do you have a perfect business plan?\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide5.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#5\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"}]\",\"config\":\"{\\\"gk_appsite1\\\":{\\\"gk_appsite1_image_width\\\":\\\"166\\\",\\\"gk_appsite1_image_height\\\":\\\"166\\\",\\\"gk_appsite1_image_bg\\\":\\\"#000000\\\",\\\"gk_appsite1_quality\\\":\\\"95\\\",\\\"gk_appsite1_show_text_block\\\":\\\"1\\\",\\\"gk_appsite1_text_block_x\\\":\\\"0\\\",\\\"gk_appsite1_text_block_y\\\":\\\"215\\\",\\\"gk_appsite1_text_block_width\\\":\\\"1000\\\",\\\"gk_appsite1_image_y\\\":\\\"65\\\",\\\"gk_appsite1_module_height\\\":\\\"450\\\",\\\"gk_appsite1_pagination\\\":\\\"1\\\",\\\"gk_appsite1_slide_links\\\":\\\"1\\\",\\\"gk_appsite1_animation_speed\\\":\\\"500\\\",\\\"gk_appsite1_animation_interval\\\":\\\"5000\\\",\\\"gk_appsite1_autoanimation\\\":\\\"1\\\"},\\\"gk_black_and_white\\\":{\\\"gk_black_and_white_image_width\\\":\\\"978\\\",\\\"gk_black_and_white_image_height\\\":\\\"362\\\",\\\"gk_black_and_white_image_bg\\\":\\\"#000000\\\",\\\"gk_black_and_white_quality\\\":\\\"95\\\",\\\"gk_black_and_white_text_block_position_x\\\":\\\"20\\\",\\\"gk_black_and_white_text_block_position_y\\\":\\\"20\\\",\\\"gk_black_and_white_text_block_width\\\":\\\"300\\\",\\\"gk_black_and_white_show_text_block\\\":\\\"1\\\",\\\"gk_black_and_white_clean_xhtml\\\":\\\"1\\\",\\\"gk_black_and_white_wordcount\\\":\\\"10\\\",\\\"gk_black_and_white_title_char_amount\\\":\\\"30\\\",\\\"gk_black_and_white_pagination\\\":\\\"1\\\",\\\"gk_black_and_white_pagination_position_x\\\":\\\"20\\\",\\\"gk_black_and_white_pagination_position_y\\\":\\\"320\\\",\\\"gk_black_and_white_show_readmore\\\":\\\"1\\\",\\\"gk_black_and_white_stripe_width\\\":\\\"60\\\",\\\"gk_black_and_white_slide_links\\\":\\\"1\\\",\\\"gk_black_and_white_animation_speed\\\":\\\"1800\\\",\\\"gk_black_and_white_animation_interval\\\":\\\"5000\\\",\\\"gk_black_and_white_autoanimation\\\":\\\"1\\\",\\\"gk_black_and_white_animation_type\\\":\\\"opacity\\\",\\\"gk_black_and_white_show_title_block\\\":\\\"1\\\",\\\"gk_black_and_white_title_link\\\":\\\"1\\\",\\\"gk_black_and_white_interface\\\":\\\"1\\\"},\\\"gk_cherrydesign\\\":{\\\"gk_cherrydesign_image_width\\\":\\\"480\\\",\\\"gk_cherrydesign_image_height\\\":\\\"320\\\",\\\"gk_cherrydesign_image_bg\\\":\\\"#000000\\\",\\\"gk_cherrydesign_quality\\\":\\\"95\\\",\\\"gk_cherrydesign_show_text_block\\\":\\\"1\\\",\\\"gk_cherrydesign_slide_links\\\":\\\"1\\\",\\\"gk_cherrydesign_pagination\\\":\\\"1\\\",\\\"gk_cherrydesign_pagination_position\\\":\\\"left\\\",\\\"gk_cherrydesign_readmore_text\\\":\\\"Read more...\\\",\\\"gk_cherrydesign_clean_xhtml\\\":\\\"1\\\",\\\"gk_cherrydesign_wordcount\\\":\\\"30\\\",\\\"gk_cherrydesign_animation_speed\\\":\\\"500\\\",\\\"gk_cherrydesign_animation_interval\\\":\\\"5000\\\",\\\"gk_cherrydesign_autoanimation\\\":\\\"1\\\",\\\"gk_cherrydesign_animation_type\\\":\\\"opacity\\\"},\\\"gk_coffe\\\":{\\\"gk_coffe_image_width\\\":\\\"480\\\",\\\"gk_coffe_image_height\\\":\\\"320\\\",\\\"gk_coffe_image_bg\\\":\\\"#000000\\\",\\\"gk_coffe_quality\\\":\\\"95\\\",\\\"gk_coffe_show_title_block\\\":\\\"1\\\",\\\"gk_coffe_title_link\\\":\\\"1\\\",\\\"gk_coffe_interface\\\":\\\"1\\\",\\\"gk_coffe_slide_links\\\":\\\"1\\\",\\\"gk_coffe_animation_speed\\\":\\\"500\\\",\\\"gk_coffe_animation_interval\\\":\\\"5000\\\",\\\"gk_coffe_autoanimation\\\":\\\"1\\\",\\\"gk_coffe_animation_type\\\":\\\"opacity\\\"},\\\"gk_corporate2\\\":{\\\"gk_corporate2_image_width\\\":\\\"480\\\",\\\"gk_corporate2_image_height\\\":\\\"320\\\",\\\"gk_corporate2_image_bg\\\":\\\"#000000\\\",\\\"gk_corporate2_quality\\\":\\\"95\\\",\\\"gk_corporate2_show_list\\\":\\\"1\\\",\\\"gk_corporate2_list_title_small\\\":\\\"Why to choose\\\",\\\"gk_corporate2_list_title_big\\\":\\\"our company\\\",\\\"gk_corporate2_list_char_count\\\":\\\"25\\\",\\\"gk_corporate2_list_text_overflow\\\":\\\"...\\\",\\\"gk_corporate2_image_position\\\":\\\"gkRightFloat\\\",\\\"gk_corporate2_list_position\\\":\\\"gkRightFloat\\\",\\\"gk_corporate2_art_width\\\":\\\"70\\\",\\\"gk_corporate2_title\\\":\\\"1\\\",\\\"gk_corporate2_title_link\\\":\\\"1\\\",\\\"gk_corporate2_clean_xhtml\\\":\\\"1\\\",\\\"gk_corporate2_wordcount\\\":\\\"30\\\",\\\"gk_corporate2_readmore_button\\\":\\\"1\\\",\\\"gk_corporate2_readmore_text\\\":\\\"Find more\\\",\\\"gk_corporate2_interface\\\":\\\"1\\\",\\\"gk_corporate2_interface_animation\\\":\\\"0\\\",\\\"gk_corporate2_animation_speed\\\":\\\"500\\\",\\\"gk_corporate2_animation_interval\\\":\\\"5000\\\",\\\"gk_corporate2_autoanimation\\\":\\\"1\\\",\\\"gk_corporate2_animation_type\\\":\\\"opacity\\\"},\\\"gk_financial_business\\\":{\\\"gk_financial_business_image_width\\\":\\\"750\\\",\\\"gk_financial_business_image_height\\\":\\\"310\\\",\\\"gk_financial_business_image_bg\\\":\\\"#000000\\\",\\\"gk_financial_business_quality\\\":\\\"95\\\",\\\"gk_financial_business_date_format\\\":\\\"d-m-Y\\\",\\\"gk_financial_business_interface\\\":\\\"1\\\",\\\"gk_financial_business_slide_links\\\":\\\"1\\\",\\\"gk_financial_business_animation_speed\\\":\\\"500\\\",\\\"gk_financial_business_animation_interval\\\":\\\"5000\\\",\\\"gk_financial_business_autoanimation\\\":\\\"1\\\",\\\"gk_financial_business_animation_type\\\":\\\"opacity\\\"},\\\"gk_gamebox\\\":{\\\"gk_gamebox_image_width\\\":\\\"640\\\",\\\"gk_gamebox_image_height\\\":\\\"360\\\",\\\"gk_gamebox_image_bg\\\":\\\"#000000\\\",\\\"gk_gamebox_quality\\\":\\\"95\\\",\\\"gk_gamebox_show_text_block\\\":\\\"1\\\",\\\"gk_gamebox_show_info\\\":\\\"1\\\",\\\"gk_gamebox_date_format\\\":\\\"A e, B Y\\\",\\\"gk_gamebox_author_name\\\":\\\"username\\\",\\\"gk_gamebox_info_format\\\":\\\"Written: %date by %author\\\",\\\"gk_gamebox_readmore_text\\\":\\\"Read more\\\",\\\"gk_gamebox_text_position\\\":\\\"280\\\",\\\"gk_gamebox_text_height\\\":\\\"80\\\",\\\"gk_gamebox_interface\\\":\\\"1\\\",\\\"gk_gamebox_slide_links\\\":\\\"1\\\",\\\"gk_gamebox_animation_speed\\\":\\\"500\\\",\\\"gk_gamebox_animation_interval\\\":\\\"5000\\\",\\\"gk_gamebox_autoanimation\\\":\\\"1\\\",\\\"gk_gamebox_animation_type\\\":\\\"opacity\\\"},\\\"gk_memovie\\\":{\\\"gk_memovie_image_width\\\":\\\"670\\\",\\\"gk_memovie_image_height\\\":\\\"313\\\",\\\"gk_memovie_image_bg\\\":\\\"#000000\\\",\\\"gk_memovie_quality\\\":\\\"95\\\",\\\"gk_memovie_interface\\\":\\\"1\\\",\\\"gk_memovie_interface_animation\\\":\\\"0\\\",\\\"gk_memovie_interface_x\\\":\\\"30\\\",\\\"gk_memovie_interface_y\\\":\\\"30\\\",\\\"gk_memovie_slide_links\\\":\\\"1\\\",\\\"gk_memovie_animation_speed\\\":\\\"500\\\",\\\"gk_memovie_animation_interval\\\":\\\"5000\\\",\\\"gk_memovie_autoanimation\\\":\\\"1\\\",\\\"gk_memovie_animation_type\\\":\\\"opacity\\\"},\\\"gk_musicity\\\":{\\\"gk_musicity_image_width\\\":\\\"627\\\",\\\"gk_musicity_image_height\\\":\\\"345\\\",\\\"gk_musicity_image_bg\\\":\\\"#000000\\\",\\\"gk_musicity_quality\\\":\\\"95\\\",\\\"gk_musicity_show_title_block\\\":\\\"1\\\",\\\"gk_musicity_show_date_block\\\":\\\"1\\\",\\\"gk_musicity_date_format\\\":\\\"F d, Y\\\",\\\"gk_musicity_interface\\\":\\\"1\\\",\\\"gk_musicity_title_block_y\\\":\\\"23\\\",\\\"gk_musicity_date_block_y\\\":\\\"14\\\",\\\"gk_musicity_slide_links\\\":\\\"1\\\",\\\"gk_musicity_animation_speed\\\":\\\"500\\\",\\\"gk_musicity_animation_interval\\\":\\\"5000\\\",\\\"gk_musicity_autoanimation\\\":\\\"1\\\",\\\"gk_musicity_animation_type\\\":\\\"opacity\\\"},\\\"gk_partyfreak\\\":{\\\"gk_partyfreak_image_width\\\":\\\"600\\\",\\\"gk_partyfreak_image_height\\\":\\\"600\\\",\\\"gk_partyfreak_thumb_width\\\":\\\"70\\\",\\\"gk_partyfreak_thumb_height\\\":\\\"70\\\",\\\"gk_partyfreak_image_bg\\\":\\\"#ffffff\\\",\\\"gk_partyfreak_quality\\\":\\\"95\\\",\\\"gk_partyfreak_total_width\\\":\\\"980\\\",\\\"gk_partyfreak_thumbs_margin\\\":\\\"0 0 0 0\\\",\\\"gk_partyfreak_thumbs_padding\\\":\\\"0 0 0 0\\\",\\\"gk_partyfreak_thumbs_amount\\\":\\\"3\\\",\\\"gk_partyfreak_thumbs_space\\\":\\\"8\\\",\\\"gk_partyfreak_thumbs_text_word_amount\\\":\\\"14\\\",\\\"gk_partyfreak_show_title\\\":\\\"1\\\",\\\"gk_partyfreak_text_block_height\\\":\\\"80\\\",\\\"gk_partyfreak_show_text\\\":\\\"1\\\",\\\"gk_partyfreak_text_word_amount\\\":\\\"40\\\",\\\"gk_partyfreak_slide_links\\\":\\\"1\\\",\\\"gk_partyfreak_animation_speed\\\":\\\"500\\\",\\\"gk_partyfreak_animation_interval\\\":\\\"5000\\\",\\\"gk_partyfreak_autoanimation\\\":\\\"1\\\",\\\"gk_partyfreak_animation_type\\\":\\\"opacity\\\"},\\\"gk_sporter1\\\":{\\\"gk_sporter1_image_width\\\":\\\"637\\\",\\\"gk_sporter1_image_height\\\":\\\"346\\\",\\\"gk_sporter1_image_bg\\\":\\\"#000000\\\",\\\"gk_sporter1_quality\\\":\\\"95\\\",\\\"gk_sporter1_text_position\\\":\\\"246\\\",\\\"gk_sporter1_text_height\\\":\\\"90\\\",\\\"gk_sporter1_show_text_block\\\":\\\"1\\\",\\\"gk_sporter1_pagination\\\":\\\"1\\\",\\\"gk_sporter1_pagination_cols\\\":\\\"4\\\",\\\"gk_sporter1_pagination_date\\\":\\\"1\\\",\\\"gk_sporter1_pagination_date_format\\\":\\\"d m, Y\\\",\\\"gk_sporter1_pagination_limit\\\":\\\"39\\\",\\\"gk_sporter1_readmore_text\\\":\\\"Read more\\\",\\\"gk_sporter1_pagination_position\\\":\\\"left\\\",\\\"gk_sporter1_clean_xhtml\\\":\\\"1\\\",\\\"gk_sporter1_wordcount\\\":\\\"24\\\",\\\"gk_sporter1_title_char_amount\\\":\\\"27\\\",\\\"gk_sporter1_show_info\\\":\\\"1\\\",\\\"gk_sporter1_date_format\\\":\\\"F d, Y\\\",\\\"gk_sporter1_author_name\\\":\\\"name\\\",\\\"gk_sporter1_info_format\\\":\\\"Written: %date by %author\\\",\\\"gk_sporter1_slide_links\\\":\\\"1\\\",\\\"gk_sporter1_animation_speed\\\":\\\"500\\\",\\\"gk_sporter1_animation_interval\\\":\\\"5000\\\",\\\"gk_sporter1_autoanimation\\\":\\\"1\\\",\\\"gk_sporter1_animation_type\\\":\\\"opacity\\\"},\\\"gk_sporter2\\\":{\\\"gk_sporter2_image_width\\\":\\\"600\\\",\\\"gk_sporter2_image_height\\\":\\\"600\\\",\\\"gk_sporter2_thumb_width\\\":\\\"70\\\",\\\"gk_sporter2_thumb_height\\\":\\\"70\\\",\\\"gk_sporter2_image_bg\\\":\\\"#ffffff\\\",\\\"gk_sporter2_quality\\\":\\\"95\\\",\\\"gk_sporter2_image_rows\\\":\\\"3\\\",\\\"gk_sporter2_image_cols\\\":\\\"3\\\",\\\"gk_sporter2_image_margin\\\":\\\"0\\\",\\\"gk_sporter2_image_padding\\\":\\\"0\\\",\\\"gk_sporter2_image_border\\\":\\\"0\\\",\\\"gk_sporter2_slide_popups\\\":\\\"1\\\",\\\"gk_sporter2_overlay\\\":\\\"1\\\",\\\"gk_sporter2_show_text_block\\\":\\\"1\\\",\\\"gk_sporter2_text_block_height\\\":\\\"100\\\",\\\"gk_sporter2_clean_xhtml\\\":\\\"1\\\",\\\"gk_sporter2_readmore_text\\\":\\\"Read more\\\",\\\"gk_sporter2_title_char_amount\\\":\\\"30\\\",\\\"gk_sporter2_text_wordcount\\\":\\\"30\\\"}}\"}',0,'*');


--
-- Table structure for table `#__modules_menu`
--



CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules_menu`
--


INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES (1,0),(2,0),(3,0),(4,0),(6,0),(7,0),(8,0),(9,0),(10,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(18,0),(19,114),(19,115),(19,120),(19,121),(19,122),(20,115),(20,121),(20,122),(21,114),(21,115),(21,120),(21,121),(21,122),(22,114),(22,115),(22,120),(22,121),(22,122),(23,116),(23,117),(23,122),(24,116),(24,117),(24,122),(25,117),(25,122),(26,116),(26,117),(26,122),(27,118),(27,119),(27,121),(27,122),(28,118),(28,119),(28,120),(28,122),(29,119),(29,120),(29,121),(29,122),(30,118),(30,119),(30,120),(30,122),(31,118),(31,119),(31,120),(31,121),(31,122),(32,118),(32,119),(32,120),(32,121),(32,122),(33,0),(34,0),(35,0),(36,127),(37,127),(38,127),(39,127),(40,127),(41,127),(42,127),(43,127),(44,127),(45,127),(46,127),(47,127),(48,127),(49,127),(50,127),(51,127),(52,127),(53,127),(54,0),(55,0),(56,0),(57,0),(58,0),(59,101),(60,101),(61,101),(62,0),(63,101),(64,101),(65,0),(66,0),(67,0),(68,0),(69,0),(70,0),(71,101),(72,101),(73,205),(73,206),(73,207),(73,208),(73,209),(73,210),(73,211),(74,205),(74,210),(76,101),(76,205),(76,206),(76,207),(76,208),(76,209),(76,210),(76,211),(80,127),(81,127),(82,127),(83,127),(84,127),(85,127),(86,127),(87,127),(88,127),(89,127),(90,127),(91,127),(92,127),(93,127),(94,127),(95,127),(96,127),(97,127),(98,127),(99,127),(100,127),(101,127),(102,127),(103,127),(104,127),(105,127),(106,101),(107,101),(108,101),(109,101),(110,101),(111,101),(112,0),(113,101),(114,101),(115,205),(115,206),(115,210),(115,211),(116,101),(117,127),(118,101);


--
-- Table structure for table `#__newsfeeds`
--



CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(100) NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__newsfeeds`
--


INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`) VALUES (14,1,'GavickPro News','gavickpro-news','http://www.gavickmagazine.com/index.php?format=feed&type=rss',NULL,1,5,3600,0,'0000-00-00 00:00:00',1,0,1,'*','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\"}','2011-01-13 15:35:16',42,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00');


--
-- Table structure for table `#__redirect_links`
--



CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(150) NOT NULL,
  `new_url` varchar(150) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__redirect_links`
--


INSERT INTO `#__redirect_links` (`id`, `old_url`, `new_url`, `referer`, `comment`, `published`, `created_date`, `modified_date`) VALUES (1,'http://project.gavick.com/dziudek/joomla16/penguinmail/?option=non-existing-component','','http://project.gavick.com/dziudek/joomla16/penguinmail/','',0,'2011-01-11 22:42:03','0000-00-00 00:00:00'),(2,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/module-variations','','http://project.gavick.com/dziudek/joomla16/penguinmail/','',0,'2011-01-13 13:12:27','0000-00-00 00:00:00'),(3,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/single-contact','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/menu-types/dropline-menu','',0,'2011-01-13 15:16:23','0000-00-00 00:00:00'),(4,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_user&view=login','','http://project.gavick.com/dziudek/joomla16/penguinmail/','',0,'2011-01-13 16:06:50','0000-00-00 00:00:00'),(5,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_user&task=login','','','',0,'2011-01-13 16:23:44','0000-00-00 00:00:00'),(6,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_user','','','',0,'2011-01-13 16:23:47','0000-00-00 00:00:00'),(7,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=user','','','',0,'2011-01-13 16:23:53','0000-00-00 00:00:00'),(8,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/blog-layout','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-iii/categories-list','',0,'2011-01-13 19:12:35','0000-00-00 00:00:00'),(9,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-ii/index.php','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-ii/user-login','',0,'2011-01-17 22:56:37','0000-00-00 00:00:00'),(10,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-i/index.php','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-i/single-contact','',0,'2011-01-19 11:06:04','0000-00-00 00:00:00'),(11,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=non-existing-component','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_content&view=article&id=1&Itemid=104','',0,'2011-01-20 19:09:13','0000-00-00 00:00:00'),(12,'http://project.gavick.com/konrad/J16_finance_business/?option=non-existing-component','','http://project.gavick.com/konrad/J16_finance_business/','',0,'2011-07-21 11:00:31','0000-00-00 00:00:00'),(13,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-i/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-i/single-contact','',0,'2011-07-22 10:36:02','0000-00-00 00:00:00'),(14,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/template-articles/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/template-articles/typography','',0,'2011-07-26 10:54:30','0000-00-00 00:00:00'),(15,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/layouts/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/layouts/content-inset-column-2x','',0,'2011-07-27 11:46:45','0000-00-00 00:00:00'),(16,'http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/item','',0,'2011-07-28 18:31:16','0000-00-00 00:00:00'),(17,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/module-variations','',0,'2011-07-28 20:39:03','0000-00-00 00:00:00'),(18,'http://project.gavick.com/konrad/J16_finance_business/index.php/component/search/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/component/search/?searchword=&ordering=newest&searchphrase=all&limit=20','',0,'2011-08-15 12:53:28','0000-00-00 00:00:00'),(19,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-iii/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-iii/single-article','',0,'2011-08-17 11:02:35','0000-00-00 00:00:00'),(20,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-ii/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-ii/user-registration','',0,'2011-08-17 13:26:39','0000-00-00 00:00:00'),(21,'http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide/item/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide/item/6-workshop-from-dedicated-stracte','',0,'2011-08-17 17:23:27','0000-00-00 00:00:00'),(22,'http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide','',0,'2011-08-18 09:07:39','0000-00-00 00:00:00'),(23,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-08-19-13-59-20/index.php','','http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-08-19-13-59-20/financial-adviser','',0,'2011-08-19 14:35:23','0000-00-00 00:00:00');


--
-- Table structure for table `#__schemas`
--



CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__schemas`
--





--
-- Table structure for table `#__session`
--



CREATE TABLE `#__session` (
  `session_id` varchar(32) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` varchar(20480) DEFAULT NULL,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  `usertype` varchar(50) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__session`
--


INSERT INTO `#__session` (`session_id`, `client_id`, `guest`, `time`, `data`, `userid`, `username`, `usertype`) VALUES ('4a55d9e1e9ce56821743a2ef26853c44',0,1,'1314133357','__default|a:9:{s:15:\"session.counter\";i:1;s:19:\"session.timer.start\";i:1314133356;s:18:\"session.timer.last\";i:1314133356;s:17:\"session.timer.now\";i:1314133356;s:22:\"session.client.browser\";s:63:\"Opera/9.80 (Windows NT 6.1; U; pl) Presto/2.9.168 Version/11.50\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:4:\"user\";O:5:\"JUser\":23:{s:9:\"\0*\0isRoot\";b:0;s:2:\"id\";i:0;s:4:\"name\";N;s:8:\"username\";N;s:5:\"email\";N;s:8:\"password\";N;s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";N;s:5:\"block\";N;s:9:\"sendEmail\";i:0;s:12:\"registerDate\";N;s:13:\"lastvisitDate\";N;s:10:\"activation\";N;s:6:\"params\";N;s:6:\"groups\";a:0:{}s:5:\"guest\";i:1;s:10:\"\0*\0_params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:14:\"\0*\0_authGroups\";a:1:{i:0;i:1;}s:14:\"\0*\0_authLevels\";a:2:{i:0;i:1;i:1;i:1;}s:15:\"\0*\0_authActions\";N;s:12:\"\0*\0_errorMsg\";N;s:10:\"\0*\0_errors\";a:0:{}s:3:\"aid\";i:0;}s:16:\"com_mailto.links\";a:3:{s:40:\"d8254122e4576aa36a6601bda7d37e0edaa6c1bd\";O:8:\"stdClass\":2:{s:4:\"link\";s:97:\"http://project.gavick.com/_updates/joomla17/finance_business/index.php/template-articles/messages\";s:6:\"expiry\";i:1314133357;}s:40:\"576ed890556ce25bacc186edce83735a5a523bb3\";O:8:\"stdClass\":2:{s:4:\"link\";s:120:\"http://project.gavick.com/_updates/joomla17/finance_business/index.php/template/lorem-ipsum/template-articles/ie-6-style\";s:6:\"expiry\";i:1314133357;}s:40:\"cc9a1c35040280ded1d548a7f13f8a659f1c2c0d\";O:8:\"stdClass\":2:{s:4:\"link\";s:108:\"http://project.gavick.com/_updates/joomla17/finance_business/index.php/template/lorem-ipsum/module-positions\";s:6:\"expiry\";i:1314133357;}}s:13:\"session.token\";s:32:\"bf98b450747fb10c0625aa873a961370\";}',0,'',''),('2d6ef4c2e353e9982a6140d1fbf1d661',1,0,'1314133383','__default|a:8:{s:15:\"session.counter\";i:8;s:19:\"session.timer.start\";i:1314133369;s:18:\"session.timer.last\";i:1314133383;s:17:\"session.timer.now\";i:1314133383;s:22:\"session.client.browser\";s:63:\"Opera/9.80 (Windows NT 6.1; U; pl) Presto/2.9.168 Version/11.50\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:11:\"application\";O:8:\"stdClass\":1:{s:4:\"lang\";s:0:\"\";}s:13:\"com_templates\";O:8:\"stdClass\":2:{s:6:\"styles\";O:8:\"stdClass\":1:{s:10:\"limitstart\";i:0;}s:4:\"edit\";O:8:\"stdClass\":1:{s:5:\"style\";O:8:\"stdClass\":2:{s:2:\"id\";a:0:{}s:4:\"data\";N;}}}}}s:4:\"user\";O:5:\"JUser\":23:{s:9:\"\0*\0isRoot\";b:1;s:2:\"id\";s:2:\"42\";s:4:\"name\";s:13:\"Administrator\";s:8:\"username\";s:5:\"admin\";s:5:\"email\";s:18:\"dziudek@gavick.com\";s:8:\"password\";s:65:\"5917e9b35073a2e8513a96b390813e43:KmIyeTk7JDEByZE4ATBv62c87E06rZZP\";s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";s:10:\"deprecated\";s:5:\"block\";s:1:\"0\";s:9:\"sendEmail\";s:1:\"1\";s:12:\"registerDate\";s:19:\"2011-07-08 09:20:19\";s:13:\"lastvisitDate\";s:19:\"2011-08-23 14:59:05\";s:10:\"activation\";s:0:\"\";s:6:\"params\";s:92:\"{\"admin_style\":\"\",\"admin_language\":\"\",\"language\":\"\",\"editor\":\"\",\"helpsite\":\"\",\"timezone\":\"\"}\";s:6:\"groups\";a:1:{s:11:\"Super Users\";s:1:\"8\";}s:5:\"guest\";i:0;s:10:\"\0*\0_params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":6:{s:11:\"admin_style\";s:0:\"\";s:14:\"admin_language\";s:0:\"\";s:8:\"language\";s:0:\"\";s:6:\"editor\";s:0:\"\";s:8:\"helpsite\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}}s:14:\"\0*\0_authGroups\";a:2:{i:0;i:1;i:1;i:8;}s:14:\"\0*\0_authLevels\";a:4:{i:0;i:1;i:1;i:1;i:2;i:2;i:3;i:3;}s:15:\"\0*\0_authActions\";N;s:12:\"\0*\0_errorMsg\";N;s:10:\"\0*\0_errors\";a:0:{}s:3:\"aid\";i:0;}s:13:\"session.token\";s:32:\"d2fdabfd8390dae19a2ad79a8f7a85cd\";}',42,'admin','');


--
-- Table structure for table `#__template_styles`
--



CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__template_styles`
--


INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES (2,'bluestork',1,'1','Bluestork - Default','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}'),(3,'atomic',0,'0','Atomic - Default','{}'),(4,'beez_20',0,'0','Beez2 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),(6,'beez5',0,'0','Beez5 - Default-Fruit Shop','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Matuna Market \",\"sitedescription\":\"Fruit Shop Sample Site\",\"navposition\":\"left\",\"html5\":\"0\"}'),(11,'gk_finance_business',0,'1','gk_finance_business - Default','{\"template_color\":\"1\",\"mainbody_frontpage\":\"only_mainbody\",\"mainbody_subpage\":\"only_component\",\"messages_position\":\"message-position-3\",\"default_layout\":\"default\",\"facebook_layout\":\"facebook\",\"iphone_layout\":\"iphone\",\"android_layout\":\"android\",\"handheld_layout\":\"handheld\",\"layout_override\":\"\",\"template_width\":\"1002px\",\"header_column_width\":\"25\",\"left_column_width\":\"50\",\"left2_column_width\":\"50\",\"right_column_width\":\"27\",\"right2_column_width\":\"54\",\"inset_column_width\":\"47\",\"inset2_column_width\":\"6\",\"user1_6_widest_value\":\"0\",\"user1_6_widest\":\"user1\",\"user7_12_widest_value\":\"0\",\"user7_12_widest\":\"user7\",\"top1_6_widest_value\":\"0\",\"top1_6_widest\":\"top1\",\"top7_12_widest_value\":\"0\",\"top7_12_widest\":\"top7\",\"bottom1_6_widest_value\":\"0\",\"bottom1_6_widest\":\"bottom1\",\"bottom7_12_widest_value\":\"0\",\"bottom7_12_widest\":\"bottom7\",\"font_name_group1\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group1\":\"body,\\r\\ndiv.gk-menu .level0 > li li,\\r\\n#gkWrap2 .box_text .banneritem,\\r\\n#gkWrap2 .box_text .bannerfooter,\\r\\n#gkWrap2 .box.color1 > h3, \\r\\n#gkWrap2 .box_menu.color1 > h3, \\r\\n#gkWrap2 .box_text.color1 > h3, \\r\\n#gkWrap2 .box.color2 > h3, \\r\\n#gkWrap2 .box_menu.color2 > h3, \\r\\n#gkWrap2 .box_text.color2 > h3, \\r\\n#gkWrap2 .box.color3 > h3, \\r\\n#gkWrap2 .box_menu.color3 > h3, \\r\\n#gkWrap2 .box_text.color3 > h3, \\r\\n#gkWrap2 .box.color4 > h3, \\r\\n#gkWrap2 .box_menu.color4 > h3, \\r\\n#gkWrap2 .box_text.color4 > h3,\\r\\n.nspMainPortalMode2 .nspBotInterface .nspArtHeadline .nspHeadline h4, \\r\\n.nspMainPortalMode1 .nspHeader\",\"font_name_group2\":\"squirrel;BebasNeue\",\"font_rules_group2\":\"h1,\\r\\nh2,\\r\\nh3,\\r\\nh4,\\r\\nh5,\\r\\ndiv.gk-menu > ul.level0 > li,\\r\\ndiv#gkDropMain > ul > li,\\r\\n#gkWrap2 .box_text .bannergroup_text,\\r\\n.search-results dt.result-title a,\\r\\n.nspMainPortalMode3 .nspTitleTab .nspTitle,\\r\\n.registration legend,\\r\\n.gkIsTextTitle a\",\"font_name_group3\":\"standard;Tahoma, Geneva, sans-serif\",\"font_rules_group3\":\"#gkButtons a,\\r\\n.button, button, \\r\\nbutton.button, \\r\\na.readon, \\r\\n .moduleItemReadMore, \\r\\n .latestItemReadMore a.k2ReadMore, \\r\\n .userItemReadMore a.k2ReadMore, \\r\\n .catItemReadMore a.k2ReadMore, \\r\\n .k2ReadMore,\\r\\n .subCategoryMore, \\r\\n .readmore-link, \\r\\n .comments-link,\\r\\n#gkWrap2 .box.font2 > h3, \\r\\n#gkWrap2 .box_menu.font2 > h3, \\r\\n#gkWrap2 .box_text.font2 > h3 \",\"logo_type\":\"image\",\"logo_image\":\"\",\"logo_text\":\"Finance Business\",\"logo_slogan\":\"slogan\",\"print_logo\":\"\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"copyrights\":\"Copyright by GavickPro 2011. All rights reserved.\",\"google_analytics\":\"\",\"tools\":\"1\",\"tools_for_pages\":\"\",\"mootools_for_pages\":\"\",\"suffix_override\":\"\",\"module_override\":\"\",\"socialIcons\":\"1\",\"socialIcons1\":\"1\",\"socialIcons1url\":\"http:\\/\\/twitter.com\\/gavickpro\",\"socialIcons1text\":\"Twitter\",\"socialIcons2\":\"1\",\"socialIcons2url\":\"http:\\/\\/www.demo.gavick.com\",\"socialIcons2text\":\"Vimeo\",\"socialIcons3\":\"1\",\"socialIcons3url\":\"http:\\/\\/www.facebook.com\\/gavickpro\",\"socialIcons3text\":\"Facebook\",\"typography\":\"1\",\"typo_iconset1\":\"1\",\"typo_iconset2\":\"1\",\"typo_iconset3\":\"1\",\"menu_name\":\"mainmenu\",\"menu_type\":\"gk_menu\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_height\":\"1\",\"menu_width\":\"1\",\"menu_duration\":\"250\",\"menu_override\":\"111=gk_dropline\\r\\n112=gk_split\\r\\n\",\"mobile_menu_name\":\"mobile-menu\",\"mobile_login\":\"1\",\"mobile_register\":\"1\",\"mobile_desktop\":\"1\",\"mobile_search\":\"1\",\"mobile_collapsible\":\"1\",\"fb_api_id\":\"2432432432\",\"fb_lang\":\"en_US\",\"fb_login\":\"1\",\"fb_like\":\"1\",\"fb_like_send\":\"0\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"false\",\"fb_like_width\":\"320\",\"fb_like_action\":\"like\",\"fb_like_font\":\"verdana\",\"fb_like_colorscheme\":\"light\",\"tweet_btn\":\"1\",\"tweet_btn_data_count\":\"horizontal\",\"tweet_btn_data_via\":\"http:\\/\\/twitter.com\\/gavickpro\",\"tweet_btn_data_lang\":\"en\",\"digg_btn\":\"1\",\"digg_btn_style\":\"DiggCompact\",\"buzz_btn\":\"1\",\"buzz_btn_style\":\"small-count\",\"delicious_btn\":\"1\",\"instapaper_btn\":\"1\",\"excluded_arts\":\"\",\"excluded_cats\":[\"2\"],\"selectivizr\":\"0\",\"reset_css\":\"meyer\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"chrome_frame_support\":\"0\",\"ie6bar\":\"1\"}');


--
-- Table structure for table `#__update_categories`
--



CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Update Categories';


--
-- Dumping data for table `#__update_categories`
--




--
-- Table structure for table `#__update_sites`
--



CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Update Sites';


--
-- Dumping data for table `#__update_sites`
--


INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`) VALUES (1,'Joomla Core','collection','http://update.joomla.org/core/list.xml',1),(2,'Joomla Extension Directory','collection','http://update.joomla.org/jed/list.xml',1);


--
-- Table structure for table `#__update_sites_extensions`
--



CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';


--
-- Dumping data for table `#__update_sites_extensions`
--


INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES (1,700),(2,700);


--
-- Table structure for table `#__updates`
--



CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Available Updates';


--
-- Dumping data for table `#__updates`
--




--
-- Table structure for table `#__user_profiles`
--



CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';


--
-- Dumping data for table `#__user_profiles`
--




--
-- Table structure for table `#__user_usergroup_map`
--



CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_usergroup_map`
--


INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES (42,8),(45,2);


--
-- Table structure for table `#__usergroups`
--



CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__usergroups`
--


INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES (1,0,1,20,'Public'),(2,1,6,17,'Registered'),(3,2,7,14,'Author'),(4,3,8,11,'Editor'),(5,4,9,10,'Publisher'),(6,1,2,5,'Manager'),(7,6,3,4,'Administrator'),(8,1,18,19,'Super Users');


--
-- Table structure for table `#__users`
--



CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `usertype` varchar(25) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM AUTO_INCREMENT=50 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__users`
--


INSERT INTO `#__users` (`id`, `name`, `username`, `email`, `password`, `usertype`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`) VALUES (42,'Administrator','admin','dziudek@gavick.com','5917e9b35073a2e8513a96b390813e43:KmIyeTk7JDEByZE4ATBv62c87E06rZZP','deprecated',0,1,'2011-07-08 09:20:19','2011-08-23 21:02:52','','{\"admin_style\":\"\",\"admin_language\":\"\",\"language\":\"\",\"editor\":\"\",\"helpsite\":\"\",\"timezone\":\"\"}');


--
-- Table structure for table `#__viewlevels`
--



CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__viewlevels`
--


INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES (1,'Public',0,'[1]'),(2,'Registered',1,'[6,2,8]'),(3,'Special',2,'[6,3,8]');


--
-- Table structure for table `#__weblinks`
--



CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__weblinks`
--


INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES (1,12,0,'Joomla! 1.6','joomla-16','http://www.joomla.org','<p>Joomla! CMS offical site.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:02:04',42,'','2011-01-13 15:02:15',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(2,12,0,'Joomla Extensions','joomla-extensions','http://extensions.joomla.org','<p>Joomla extensions.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:02:54',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(3,12,0,'Joomla documentation','joomla-documentation','http://docs.joomla.org','<p>Full Joomla! documentation.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:03:23',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(4,13,0,'GavickPro Demo','demo-gavick','http://demo.gavick.com','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',4,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:06:17',42,'','2011-01-13 15:12:26',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(5,13,0,'GavickPro Magazine','gavick-magazine','http://www.gavickmagazine.com','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',5,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:09:14',42,'','2011-01-13 15:13:34',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(6,13,0,'GavickPro Homepage','gavickpro-homepage','http://www.gavick.com','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',6,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:13:15',42,'','2011-01-13 15:13:24',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(7,13,0,'GavickPro Tools','gavickpro-tools','http://tools.gavick.com/','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',7,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:14:11',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(8,13,0,'GavickPro Twitter','gavickpro-twitter','http://twitter.com/gavickpro','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',8,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:15:04',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(9,13,0,'GavickPro Facebook','gavickpro-facebook','http://www.facebook.com/gavickpro','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',9,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:15:30',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(10,13,0,'GavickPro Updates','gavickpro-updates','http://www.gavick.com/support/updates.html','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',10,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:16:04',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(11,13,0,'Join us!','join-us','http://www.gavick.com/home/join-us.html','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',11,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:17:14',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(12,13,0,'GavickPro RSS & News','gavickpro-rss-a-news','http://www.gavickmagazine.com/index.php?format=feed&type=rss','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',12,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:19:20',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');








-- Dump completed on 2011-08-24 11:19:17
