-- MySQL dump 10.13  Distrib 5.1.56, for unknown-linux-gnu (x86_64)
--
-- Host: localhost    Database: project_j17_financial_business_beta
-- ------------------------------------------------------
-- Server version	5.1.56-log












--
-- Table structure for table `#__assets`
--



CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM AUTO_INCREMENT=86 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__assets`
--


INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES (1,0,1,520,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":[],\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(2,1,1,2,1,'com_admin','com_admin','{}'),(3,1,3,6,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(4,1,7,8,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(5,1,9,10,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(6,1,11,12,1,'com_config','com_config','{}'),(7,1,13,20,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(8,1,21,116,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(9,1,117,118,1,'com_cpanel','com_cpanel','{}'),(10,1,119,120,1,'com_installer','com_installer','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1},\"core.delete\":[],\"core.edit.state\":[]}'),(11,1,121,122,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(12,1,123,124,1,'com_login','com_login','{}'),(13,1,125,126,1,'com_mailto','com_mailto','{}'),(14,1,127,128,1,'com_massmail','com_massmail','{}'),(15,1,129,130,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),(16,1,131,132,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(17,1,133,134,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(18,1,135,136,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(19,1,137,144,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(20,1,145,146,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(21,1,147,148,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),(22,1,149,150,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),(23,1,151,152,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(24,1,153,154,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(25,1,155,162,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(26,1,163,164,1,'com_wrapper','com_wrapper','{}'),(27,8,22,29,2,'com_content.category.2','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(28,3,4,5,2,'com_banners.category.3','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(29,7,14,15,2,'com_contact.category.4','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(30,19,138,139,2,'com_newsfeeds.category.5','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(31,25,156,157,2,'com_weblinks.category.6','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(32,33,31,32,3,'com_content.article.1','Typography','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(33,8,30,49,2,'com_content.category.7','Template articles','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(34,33,33,34,3,'com_content.article.2','Module positions','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(35,33,35,36,3,'com_content.article.3','Messages','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(36,33,37,38,3,'com_content.article.4','Chrome frame','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(37,8,50,59,2,'com_content.category.8','Menu types','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(38,37,51,52,3,'com_content.article.5','Menu types','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(39,8,60,79,2,'com_content.category.9','Layouts','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(40,39,61,62,3,'com_content.article.6','Right column','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(41,39,63,64,3,'com_content.article.7','Right two columns','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(42,39,65,66,3,'com_content.article.8','Left column','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(43,39,67,68,3,'com_content.article.9','Left two columns','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(44,39,69,70,3,'com_content.article.10','Content inset left','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(45,39,71,72,3,'com_content.article.11','Content inset right','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(46,39,73,74,3,'com_content.article.12','Content inset both','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(47,39,75,76,3,'com_content.article.13','Content inset + column','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(48,39,77,78,3,'com_content.article.14','Content inset + column (2x)','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(49,37,53,54,3,'com_content.article.15','Split menu','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(50,37,55,56,3,'com_content.article.16','Dropline menu','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(51,37,57,58,3,'com_content.article.17','GK Menu','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(52,33,39,40,3,'com_content.article.18','Module variation','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(53,7,16,17,2,'com_contact.category.10','Sample category I','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(54,7,18,19,2,'com_contact.category.11','Sample category II','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(55,25,158,159,2,'com_weblinks.category.12','Joomla Weblink Category','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(56,25,160,161,2,'com_weblinks.category.13','GavickPro','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(57,19,140,141,2,'com_newsfeeds.category.14','GavickPro','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(58,19,142,143,2,'com_newsfeeds.category.15','Joomla!','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(59,27,23,24,3,'com_content.article.19','Archive article I','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(60,27,25,26,3,'com_content.article.20','Archive article II','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(61,27,27,28,3,'com_content.article.21','Archive article III','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(63,33,41,42,3,'com_content.article.23','IE 6 style','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(64,33,43,44,3,'com_content.article.24','Lorem ipsum','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(65,1,518,519,1,'com_k2','k2','{}'),(66,8,80,83,2,'com_content.category.16','Latest','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(67,66,81,82,3,'com_content.article.25','Welcome to Joomla!','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(68,8,84,115,2,'com_content.category.17','Financial Business','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(69,68,85,94,3,'com_content.category.18','Financial Adviser','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(70,68,95,104,3,'com_content.category.19',' Investment Guide','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(71,68,105,114,3,'com_content.category.20','Market Center','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(72,69,86,87,4,'com_content.article.26','Online Business Conference','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(73,69,88,89,4,'com_content.article.27','Need Additional Capital?','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(74,69,90,91,4,'com_content.article.28','We celebrate your success! ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(75,69,92,93,4,'com_content.article.29','Idea about starting your own business','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(76,70,96,97,4,'com_content.article.30','Support your financial success ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(77,70,98,99,4,'com_content.article.31','WorkShop from dedicated stractegy','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(78,70,100,101,4,'com_content.article.32','Office and Support Staff ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(79,70,102,103,4,'com_content.article.33','Creating a great team environment','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(80,71,106,107,4,'com_content.article.34','Our business is built on friendship.','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(81,71,108,109,4,'com_content.article.35','Trusted in financial market','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(82,71,112,113,4,'com_content.article.36','Fully equipped modern workshop','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(83,71,110,111,4,'com_content.article.37','Top professional advisers','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(84,33,45,46,3,'com_content.article.38','Page Break','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(85,33,47,48,3,'com_content.article.39','Chrome frame (2)','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');


--
-- Table structure for table `#__associations`
--



CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__associations`
--




--
-- Table structure for table `#__banner_clients`
--



CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_clients`
--




--
-- Table structure for table `#__banner_tracks`
--



CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_tracks`
--




--
-- Table structure for table `#__banners`
--



CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banners`
--


INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`) VALUES (1,0,1,'Joomla!','joomla',0,775,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomla! The most popular and widely used Open Source CMS Project in the world.',0,1,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-02-13 00:00:00','2011-01-13 13:00:45','*'),(2,0,1,'JoomlaCode','joomlacode',0,775,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomlaCode, development and distribution made easy.',0,2,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-02-13 00:00:00','2011-01-13 13:01:50','*'),(3,0,1,'GavickPro','gavickpro',0,540,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nProfessional Joomla! templates and extensions.',0,3,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-09-18 00:00:00','2011-08-18 09:35:33','*');


--
-- Table structure for table `#__categories`
--



CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned DEFAULT NULL,
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__categories`
--


INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES (1,0,0,0,39,0,'','system','ROOT','root','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'2009-10-18 16:07:09',0,'0000-00-00 00:00:00',0,'*'),(2,27,1,1,2,1,'uncategorised','com_content','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:26:37',0,'0000-00-00 00:00:00',0,'*'),(3,28,1,3,4,1,'uncategorised','com_banners','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:35',0,'0000-00-00 00:00:00',0,'*'),(4,29,1,5,6,1,'uncategorised','com_contact','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:57',0,'0000-00-00 00:00:00',0,'*'),(5,30,1,7,8,1,'uncategorised','com_newsfeeds','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:15',0,'0000-00-00 00:00:00',0,'*'),(6,31,1,9,10,1,'uncategorised','com_weblinks','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:33',0,'0000-00-00 00:00:00',0,'*'),(7,33,1,11,12,1,'template','com_content','Template articles','template','','',1,42,'2011-07-20 08:46:26',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-11 22:34:53',42,'2011-01-12 17:11:44',0,'*'),(8,37,1,13,14,1,'menu-types','com_content','Menu types','menu-types','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-12 17:56:17',0,'0000-00-00 00:00:00',0,'*'),(9,39,1,15,16,1,'layouts','com_content','Layouts','layouts','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-12 19:18:18',0,'0000-00-00 00:00:00',0,'*'),(10,53,1,17,18,1,'sample-category-i','com_contact','Sample category I','sample-category-i','','<p>Category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 14:51:48',0,'0000-00-00 00:00:00',0,'*'),(11,54,1,19,20,1,'sample-category-ii','com_contact','Sample category II','sample-category-ii','','<p>Sample category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 14:52:10',0,'0000-00-00 00:00:00',0,'*'),(12,55,1,21,22,1,'joomla-weblink-category','com_weblinks','Joomla Weblink Category','joomla-weblink-category','','<p>Simple category with Joomla links!</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:01:01',0,'0000-00-00 00:00:00',0,'*'),(13,56,1,23,24,1,'gavick','com_weblinks','GavickPro','gavick','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:05:39',42,'2011-01-13 15:11:56',0,'*'),(14,57,1,25,26,1,'gavickpro','com_newsfeeds','GavickPro','gavickpro','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:34:33',0,'0000-00-00 00:00:00',0,'*'),(15,58,1,27,28,1,'joomla','com_newsfeeds','Joomla!','joomla','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-01-13 15:48:47',0,'0000-00-00 00:00:00',0,'*'),(16,66,1,29,30,1,'latest','com_content','Latest','latest','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 08:47:35',0,'0000-00-00 00:00:00',0,'*'),(17,68,1,31,38,1,'financial-business','com_content','Financial Business','financial-business','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:10:00',42,'2011-07-20 12:10:09',0,'*'),(18,69,17,32,33,2,'financial-business/financial-adviser','com_content','Financial Adviser','financial-adviser','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:10:40',0,'0000-00-00 00:00:00',0,'*'),(19,70,17,34,35,2,'financial-business/investment-guide','com_content',' Investment Guide','investment-guide','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:11:03',0,'0000-00-00 00:00:00',0,'*'),(20,71,17,36,37,2,'financial-business/market-center','com_content','Market Center','market-center','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',42,'2011-07-20 12:11:28',0,'0000-00-00 00:00:00',0,'*');


--
-- Table structure for table `#__contact_details`
--



CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__contact_details`
--


INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES (1,'Eli Manning','eli-manning','','B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146.','Victoria','Australia','Australia','3146','+49 5241 80-0 00','+49 5241 80-0 00','','images/admin.jpg',NULL,'test@test.com',0,1,42,'2011-08-17 18:23:36',1,'{\"show_contact_category\":\"hide\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"0\",\"show_email\":\"0\",\"show_street_address\":\"\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"0\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"0\",\"show_image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,10,1,'+49 5241 80-0 00','','','','','*','2011-01-13 14:54:01',42,'','2011-08-17 18:23:36',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(2,'Joomla User ','eli-manning','','B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146. \r\nAustralia','','Australia','','','','','','images/powered_by.png',NULL,'test@test.com',0,1,0,'0000-00-00 00:00:00',2,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,11,1,'','','','','','*','2011-01-13 14:54:01',42,'','2011-01-13 14:57:11',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');


--
-- Table structure for table `#__content`
--



CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=40 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content`
--


INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES (1,32,'Typography','typography','','<ul id=\"demo-typography\">\r\n<li><a href=\"#warnings\">Warnings</a></li>\r\n<li><a href=\"#headers\">Headers</a></li>\r\n<li><a href=\"#icons1\">Icon set 1</a></li>\r\n<li><a href=\"#icons2\">Icon set 2</a></li>\r\n<li><a href=\"#icons3\">Icon set 3</a></li>\r\n<li><a href=\"#tooltips\">Tooltips</a></li>\r\n<li><a href=\"#highlights\">Highlights</a></li>\r\n<li><a href=\"#code\">Code</a></li>\r\n<li><a href=\"#ulists\">Unordered lists</a></li>\r\n<li><a href=\"#olists\">Ordered lists</a></li>\r\n<li><a href=\"#abbrs\">Abbrs and acronyms</a></li>\r\n<li><a href=\"#definition\">Definition lists</a></li>\r\n<li><a href=\"#legends\">Legends</a></li>\r\n<li><a href=\"#dropcaps\">Dropcaps</a></li>\r\n<li><a href=\"#blocks\">Floated blocks</a></li>\r\n<li><a href=\"#other\">Other span blocks</a></li>\r\n<li><a href=\"#blockquote\">Blockquotes</a></li>\r\n<li><a href=\"#tables\">Tables</a></li>\r\n</ul>\r\n<h4 class=\"demo-typo\"><a name=\"warnings\">Warnings</a></h4>\r\n<p class=\"gkInfo1\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo1\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips1\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips1\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning1\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning1\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo2\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo2\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips2\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips2\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning2\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning2\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo3\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo3\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips3\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips3\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning3\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning3\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo4\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo4\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips4\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips4\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning4\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning4\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo5\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo5\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips5\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips5\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning5\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning5\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"headers\">Headers</a></h4>\r\n<h1>This is heading 1</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer    semper egestas nunc in volutpat. Fusce adipiscing velit ac eros tempor    iaculis. Phasellus venenatis mollis augue, non posuere odio placerat  in.   Etiam volutpat ultrices lectus. Fusce eu felis erat. Donec congue    interdum elit, sed ornare magna convallis lacinia. In hac habitasse    platea dictumst. Mauris volutpat consectetur accumsan.</p>\r\n<h2>This is heading 2</h2>\r\n<p>Cras diam justo, sodales quis lobortis sed, lobortis vel mauris. Sed a    mollis nunc. Quisque semper condimentum lectus, eget laoreet ipsum    auctor et. Quisque sagittis luctus augue, id fringilla enim euismod    quis. Nullam blandit, elit at euismod rutrum, tortor nibh posuere    mauris, in volutpat diam ante ac dui. Sed velit massa, imperdiet    placerat tristique et, consectetur a lorem. Praesent aliquet turpis in    quam tempor eu pulvinar nibh luctus.</p>\r\n<h3>This is heading 3</h3>\r\n<p>Vivamus rhoncus arcu sit amet est tristique convallis nec vel eros.    Vestibulum euismod luctus velit quis porta. Aliquam varius placerat    mauris sed vehicula. Integer porta facilisis sapien, in tempus lorem    mattis molestie. Suspendisse potenti. Praesent quis diam non dolor    convallis mattis eu id nulla.</p>\r\n<h4>This is heading 4</h4>\r\n<p>Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<p class=\"gkHeadline\">This is a headline.</p>\r\n<p class=\"gkSubHeadline\">This is a subheadline.</p>\r\n<p>Use <strong>&lt;p    class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p    class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<p class=\"gkSmallHeadline\">This is a small headline</p>\r\n<p class=\"gkLargeHeadline\">This is a large headline</p>\r\n<p>Use <strong>&lt;p    class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p    class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons1\">Icon set 1</a></h4>\r\n<p class=\"gkAudio\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudio\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWebcam\">This is a sample webcam message. Use <strong>&lt;p    class=\"gkWebcam\"&gt;Your webcam goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkEmail\">This is a sample email message. Use <strong>&lt;p    class=\"gkEmail\"&gt;Your email message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCreditcard\">This is a sample creditcard message. Use <strong>&lt;p    class=\"gkCreditcard\"&gt;Your creditcart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFeed\">This is a sample feed message. Use <strong>&lt;p    class=\"gkFeed\"&gt;Your feed goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHelp\">This is a sample help message. Use <strong>&lt;p    class=\"gkHelp\"&gt;Your help message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImages\">This is a sample images message. Use <strong>&lt;p    class=\"gkImages\"&gt;Your images message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLock\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLock\"&gt;Your webcam goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPrinter\">This is a sample printer message. Use <strong>&lt;p    class=\"gkPrinter\"&gt;Your printer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkReport\">This is a sample report message. Use <strong>&lt;p    class=\"gkReport\"&gt;Your report message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkScript\">This is a sample script message. Use <strong>&lt;p    class=\"gkScript\"&gt;Your script goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTime\">This is a sample time message. Use <strong>&lt;p    class=\"gkTime\"&gt;Your time message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUser\">This is a sample user message. Use <strong>&lt;p    class=\"gkUser\"&gt;Your user message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWorld\">This is a sample world message. Use <strong>&lt;p    class=\"gkWorld\"&gt;Your world goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCart\">This is a sample cart message. Use <strong>&lt;p    class=\"gkCart\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCd\">This is a sample cd message. Use <strong>&lt;p    class=\"gkCd\"&gt;Your cd message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartBar\">This is a sample chart_bar message. Use <strong>&lt;p    class=\"gkChartBar\"&gt;Your chart_bar goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartLine\">This is a sample chart_line message. Use <strong>&lt;p    class=\"gkChartLine\"&gt;Your chart_line message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartPie\">This is a sample chart_pie message. Use <strong>&lt;p    class=\"gkChartPie\"&gt;Your chart_pie message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkClock\">This is a sample clock message. Use <strong>&lt;p    class=\"gkClock\"&gt;Your clock goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCog\">This is a sample cog message. Use <strong>&lt;p    class=\"gkCog\"&gt;Your cog message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCoins\">This is a sample coins message. Use <strong>&lt;p    class=\"gkCoins\"&gt;Your coins message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCompress\">This is a sample compress message. Use <strong>&lt;p    class=\"gkCompress\"&gt;Your compress goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputer\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputer\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCross\">This is a sample cross message. Use <strong>&lt;p    class=\"gkCross\"&gt;Your cross message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkDisk\">This is a sample disk message. Use <strong>&lt;p    class=\"gkDisk\"&gt;Your disk goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkError\">This is a sample error message. Use <strong>&lt;p    class=\"gkError\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkExclamation\">This is a sample exclamation message. Use <strong>&lt;p    class=\"gkExclamation\"&gt;Your exclamation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFilm\">This is a sample film message. Use <strong>&lt;p    class=\"gkFilm\"&gt;Your film goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFolder\">This is a sample folder message. Use <strong>&lt;p    class=\"gkFolder\"&gt;Your folder message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkGroup\">This is a sample group message. Use <strong>&lt;p    class=\"gkGroup\"&gt;Your group message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHeart\">This is a sample heart message. Use <strong>&lt;p    class=\"gkHeart\"&gt;Your heart goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouse\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouse\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImage\">This is a sample image message. Use <strong>&lt;p    class=\"gkImage\"&gt;Your image message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformation\">This is a sample information message. Use <strong>&lt;p    class=\"gkInformation\"&gt;Your information message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifier\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifier\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMoney\">This is a sample money message. Use <strong>&lt;p    class=\"gkMoney\"&gt;Your money goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkNew\">This is a sample new message. Use <strong>&lt;p    class=\"gkNew\"&gt;Your new message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkNote\">This is a sample note message. Use <strong>&lt;p    class=\"gkNote\"&gt;Your note message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPage\">This is a sample page message. Use <strong>&lt;p    class=\"gkPage\"&gt;Your page goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPage_white\">This is a sample page_white message. Use <strong>&lt;p    class=\"gkPage_white\"&gt;Your page_white message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPlugin\">This is a sample plugin message. Use <strong>&lt;p    class=\"gkPlugin\"&gt;Your plugin message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkAccept\">This is a sample accept message. Use <strong>&lt;p    class=\"gkAccept\"&gt;Your accept goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkAdd\">This is a sample add message. Use <strong>&lt;p    class=\"gkAdd\"&gt;Your add message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCamera\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCamera\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkBrick\">This is a sample brick message. Use <strong>&lt;p    class=\"gkBrick\"&gt;Your brick goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkBox\">This is a sample box message. Use <strong>&lt;p    class=\"gkBox\"&gt;Your box message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCalendar\">This is a sample calendar message. Use <strong>&lt;p    class=\"gkCalendar\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons2\">Icon set 2</a></h4>\r\n<p class=\"gkAudioIs2\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudioIs2\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkEmailIs2\">This is a sample email message. Use <strong>&lt;p    class=\"gkEmailIs2\"&gt;Your email message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFeedIs2\">This is a sample feed message. Use <strong>&lt;p    class=\"gkFeedIs2\"&gt;Your feed message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImagesIs2\">This is a sample images message. Use <strong>&lt;p    class=\"gkImagesIs2\"&gt;Your images message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs2\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs2\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPrinterIs2\">This is a sample printer message. Use <strong>&lt;p    class=\"gkPrinterIs2\"&gt;Your printer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTimeIs2\">This is a sample time message. Use <strong>&lt;p    class=\"gkTimeIs2\"&gt;Your time message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUserIs2\">This is a sample user message. Use <strong>&lt;p    class=\"gkUserIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWorldIs2\">This is a sample world message. Use <strong>&lt;p    class=\"gkWorldIs2\"&gt;Your world message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCartIs2\">YThis is a sample cart message. Use <strong>&lt;p    class=\"gkCartIs2\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCdIs2\">This is a sample cd message. Use <strong>&lt;p    class=\"gkCdIs2\"&gt;Your cd message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartLineIs2\">This is a sample chart line message. Use <strong>&lt;p    class=\"gkChartLineIs2\"&gt;Your chart line message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartPieIs2\">This is a sample chart pie message. Use <strong>&lt;p    class=\"gkChartPieIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkClockIs2\">This is a sample clock message. Use <strong>&lt;p    class=\"gkClockIs2\"&gt;Your clock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCogIs2\">This is a sample config message. Use <strong>&lt;p    class=\"gkCogIs2\"&gt;Your config message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputerIs2\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputerIs2\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkErrorIs2\">This is a sample error message. Use <strong>&lt;p    class=\"gkErrorIs2\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkExclamationIs2\">This is a sample exclamation message. Use <strong>&lt;p    class=\"gkExclamationIs2\"&gt;Your exclamation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFilmIs2\">This is a sample movie message. Use <strong>&lt;p    class=\"gkFilmIs2\"&gt;Your movie message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFolderIs2\">This is a sample folder message. Use <strong>&lt;p    class=\"gkFolderIs2\"&gt;Your folder message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkGroupIs2\">This is a group calendar message. Use <strong>&lt;p    class=\"gkGroupIs2\"&gt;Your group message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouseIs2\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouseIs2\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImageIs2\">This is a sample image message. Use <strong>&lt;p    class=\"gkImageIs2\"&gt;Your image message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformationIs2\">This is a sample information message. Use <strong>&lt;p    class=\"gkInfromationIs2\"&gt;Your information message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifierIs2\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifierIs2\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMoneyIs2\">This is a sample money message. Use <strong>&lt;p    class=\"gkMoneyIs2\"&gt;Your money message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPageIs2\">This is a sample page message. Use <strong>&lt;p    class=\"gkPageIs2\"&gt;Your page message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs2\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs2\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCalendarIs2\">This is a calendar feed message. Use <strong>&lt;p    class=\"gkCalendarIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkContactIs2\">This is a sample contact message. Use <strong>&lt;p    class=\"gkContactIs2\"&gt;Your contact message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFacebookIs2\">This is a sample facebook message. Use <strong>&lt;p    class=\"gkFacebookIs2\"&gt;Your facebook message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLikeItIs2\">This is a sample like it message. Use <strong>&lt;p    class=\"gkLikeItIs2\"&gt;Your like it message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTwitterIs2\">This is a sample twitter message. Use <strong>&lt;p    class=\"gkTwitterIs2\"&gt;Your twitter message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkVimeoIs2\">This is a sample video message. Use <strong>&lt;p    class=\"gkVideoIs2\"&gt;Your video message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkYoutubeIs2\">This is a sample youtube message. Use <strong>&lt;p    class=\"gkYoutubeIs2\"&gt;Your youtube message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons3\">Icon set 3</a></h4>\r\n<p class=\"gkAudioIs3\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudioIs3\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs3\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs3\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs3\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs3\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUserIs3\">This is a sample user message. Use <strong>&lt;p    class=\"gkUserIs3\"&gt;Your user message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCartIs3\">This is a sample cart message. Use <strong>&lt;p    class=\"gkCartIs3\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartBarIs3\">This is a sample chart bar message. Use <strong>&lt;p    class=\"gkChartBarIs3\"&gt;Your chart bar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkConfigIs3\">This is a sample config message. Use <strong>&lt;p    class=\"gkConfigIs3\"&gt;Your config message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkConfig2Is3\">This is a sample configuration message. Use <strong>&lt;p    class=\"gkConfig2Is3\"&gt;Your configuration message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputerIs3\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputerIs3\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCoffeIs3\">This is a sample coffe message. Use <strong>&lt;p    class=\"gkCoffeIs3\"&gt;Your coffe message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCrossIs3\">This is a sample cross message. Use <strong>&lt;p    class=\"gkCrossIs3\"&gt;Your cross message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkErrorIs3\">This is a sample error message. Use <strong>&lt;p    class=\"gkErrorIs3\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouseIs3\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouseIs3\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformationIs3\">This is a sample information message. Use <strong>&lt;p    class=\"gkInformationIs3\"&gt;Your inforation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifierIs3\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifierIs3\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPageIs3\">This is a sample page message. Use <strong>&lt;p    class=\"gkPageIs3\"&gt;Your page message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs3\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs3\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs3\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs3\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkStarIs3\">This is a sample star message. Use <strong>&lt;p    class=\"gkStarIs3\"&gt;Your star message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTelephoneIs3\">This is a sample telephone message. Use <strong>&lt;p    class=\"gkTelephoneIs3\"&gt;Your telephone message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"tooltips\">Tooltips</a></h4>\r\n<p>Here are some examples of a <a class=\"gkTooltip\" href=\"#\">Classic<span class=\"classicTooltip\">This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Critical<span class=\"customTooltip criticalTooltip\"><em>Critical</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Help<span class=\"customTooltip helpTooltip\"><em>Help</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Information<span class=\"customTooltip infoTooltip\"><em>Information</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> and <a class=\"gkTooltip\" href=\"#\">Warning<span class=\"customTooltip warningTooltip\"><em>Warning</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> CSS powered tooltip. This is just an example of what you can do so feel free to get creative and produce your own!</p>\r\n<h4 class=\"demo-typo\"><a name=\"highlights\">Highlights</a></h4>\r\n<p>This is a <span class=\"gkHighlight1\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight1\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight2\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight2\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight3\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight3\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight4\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight4\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"code\">Code</a></h4>\r\n<p>Below is a sample of <strong>&lt;pre&gt;</strong> or <strong>&lt;div    class=\"gkCode1\"&gt;</strong></p>\r\n<p><strong> </strong></p>\r\n<pre>#wrapper {<br />	position: relative;<br />	float: left;<br />	display: block;<br />}<br /></pre>\r\n<p> </p>\r\n<p>Below is a sample of <strong>&lt;div class=\"gkCode2\"&gt;</strong></p>\r\n<div class=\"gkCode2\">#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br />}</div>\r\n<p> </p>\r\n<p>Below is a sample of <strong>&lt;div class=\"gkCode3\"&gt;&lt;h4&gt;Name    of your file&lt;/h4&gt;Here goes your code&lt;/div&gt;</strong></p>\r\n<p> </p>\r\n<div class=\"gkCode3\">\r\n<h4 class=\"demo-typo\">File</h4>\r\n#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br />}</div>\r\n<h4 class=\"demo-typo\"><a name=\"ulists\">Unordered lists</a></h4>\r\n<p>Types of unordered lists</p>\r\n<table border=\"0\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet1\"&gt;</strong></p>\r\n<ul class=\"gkBullet1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet2\"&gt;</strong></p>\r\n<ul class=\"gkBullet2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet3\"&gt;</strong></p>\r\n<ul class=\"gkBullet3\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet4\"&gt;</strong></p>\r\n<ul class=\"gkBullet4\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkCircle1\"&gt;</strong></p>\r\n<ul class=\"gkCircle1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkCircle2\"&gt;</strong></p>\r\n<ul class=\"gkCircle2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare1\"&gt;</strong></p>\r\n<ul class=\"gkSquare1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare2\"&gt;</strong></p>\r\n<ul class=\"gkSquare2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare3\"&gt;</strong></p>\r\n<ul class=\"gkSquare3\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<h4 class=\"demo-typo\"><a name=\"olists\">Ordered lists</a></h4>\r\n<p>Types of ordered list:</p>\r\n<table border=\"0\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkRoman\"&gt;</strong></p>\r\n<ol class=\"gkRoman\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkDec\"&gt;</strong></p>\r\n<ol class=\"gkDec\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkAlpha\"&gt;</strong></p>\r\n<ol class=\"gkAlpha\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkDecimalLeadingZero\"&gt;</strong></p>\r\n<ol class=\"gkDecimalLeadingZero\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p><strong>&lt;div class=\"gkNumber1\"&gt;&lt;p&gt;&lt;span&gt;here goes a    number&lt;/span&gt;and here text of element&lt;/p&gt;</strong></p>\r\n<div class=\"gkNumber1\">\r\n<p><span>01</span> Element</p>\r\n<p><span>02</span> Element</p>\r\n</div>\r\n<p><strong>&lt;div class=\"gkNumber2\"&gt;&lt;p&gt;&lt;span&gt;here goes a    number&lt;/span&gt;and here text of element&lt;/p&gt;</strong></p>\r\n<div class=\"gkNumber2\">\r\n<p><span>01</span> Element</p>\r\n<p><span>02</span> Element</p>\r\n<p> </p>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"abbrs\">Abbrs and acronyms</a></h4>\r\n<p>This is a sample of an abbreviation <abbr title=\"Doctor\">Dr</abbr>.    Use <strong>&lt;abbr title=\"Here goes full word or phrase\"&gt;here goes    an abbreviation&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<p>This is a sample of an acronym <acronym title=\"North Atlantic Treaty    Organization\">NATO</acronym>. Use <strong>&lt;acronym title=\"Here goes    full phrase\"&gt;here goes an acronym&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<h4 class=\"demo-typo\"><a name=\"definition\">Definition lists</a></h4>\r\n<p>Below are samples of definition lists</p>\r\n<p><strong>&lt;dl class=\"gkDef1\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef1\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<p><strong>&lt;dl class=\"gkDef2\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef2\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<p><strong>&lt;dl class=\"gkDef3\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef3\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<h4 class=\"demo-typo\"><a name=\"legends\">Legends</a></h4>\r\n<div class=\"gkLegend1\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend1\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend2\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend2\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend3\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend3\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend4\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend4\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend5\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend5\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend6\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend6\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend7\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend7\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"dropcaps\">Dropcaps</a></h4>\r\n<p><span class=\"gkDropcap1\">T</span>his is a sample text with Dropcap. Use    <strong>&lt;p&gt; &lt;span class=\"gkDropcap1\"&gt;t&lt;/span&gt;</strong> to make the first letter larger. Lorem ipsum dolor sit amet,   consectetur  adipiscing elit. Vestibulum condimentum pulvinar justo, sed   faucibus  ligula feugiat ac. Morbi quis enim nulla, vel congue augue.   Duis quis  quam sed purus porta eleifend. Vivamus ullamcorper est id   libero aliquam  ullamcorper. Donec eget dignissim augue. Donec ante   felis, aliquam ut  consequat eget, lobortis dapibus risus. Aliquam   laoreet enim et lectus  ornare hendrerit. Aliquam rhoncus enim libero.   Morbi aliquam, nibh  mattis feugiat dapibus, nisi massa adipiscing   justo, sit amet  condimentum urna ipsum et lacus. Nam fermentum, eros   quis ullamcorper  convallis, libero mauris lacinia eros, sed tempus leo   lorem vitae purus.  Nunc a malesuada felis. Cras ultrices sapien eu  nisi  elementum non  blandit urna sodales. Duis accumsan cursus massa,  eu  facilisis diam  porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkDropcap2\"><span class=\"gkDropcap2\">T</span>his is a sample text    with Dropcap. Use <strong>&lt;p&gt; &lt;span    class=\"gkDropcap2\"&gt;t&lt;/span&gt;</strong> to make the first letter    larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit.    Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac.    Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta    eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper.  Donec   eget dignissim augue. Donec ante felis, aliquam ut consequat  eget,   lobortis dapibus risus. Aliquam laoreet enim et lectus ornare  hendrerit.   Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis  feugiat   dapibus, nisi massa adipiscing justo, sit amet condimentum  urna ipsum et   lacus. Nam fermentum, eros quis ullamcorper convallis,  libero mauris   lacinia eros, sed tempus leo lorem vitae purus. Nunc a  malesuada felis.   Cras ultrices sapien eu nisi elementum non blandit  urna sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkDropcap3\"><span class=\"gkDropcap3\">T</span>his is a sample text    with Dropcap. Use <strong>&lt;p class=\"gkDropcap3\"&gt; &lt;span    class=\"gkDropcap3\"&gt;t&lt;/span&gt;</strong> to make the first letter    larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit.    Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac.    Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta    eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper.  Donec   eget dignissim augue. Donec ante felis, aliquam ut consequat  eget,   lobortis dapibus risus. Aliquam laoreet enim et lectus ornare  hendrerit.   Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis  feugiat   dapibus, nisi massa adipiscing justo, sit amet condimentum  urna ipsum et   lacus. Nam fermentum, eros quis ullamcorper convallis,  libero mauris   lacinia eros, sed tempus leo lorem vitae purus. Nunc a  malesuada felis.   Cras ultrices sapien eu nisi elementum non blandit  urna sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"blocks\">Floated blocks</a></h4>\r\n<p>Below are samples of text in which part of it is displayed in a    separate block</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextLeft\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextLeft\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextRight\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextRight\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextCenter\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextCenter\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<h4 class=\"demo-typo\"><a name=\"other\">Other span blocks</a></h4>\r\n<p><span class=\"gkClear\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkClear-1\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear-1\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkClear-2\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear-2\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-1\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-1\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-2\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-2\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-3\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-3\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-4\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-4\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-5\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-5\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-6\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-6\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-7\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-7\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<h4 class=\"demo-typo\"><a name=\"blockquote\">Blockquotes</a></h4>\r\n<blockquote>This is a sample quote text. Use <strong>&lt; blockquote    &gt; Your quoted text goes here!&lt; /blockquote &gt;</strong></blockquote>\r\n<blockquote>\r\n<div class=\"gkBlockquote1\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote1\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote2\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote2\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote3\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote4\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote4\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"tables\">Tables</a></h4>\r\n<table class=\"gkTable\" width=\"654\" height=\"94\">\r\n<thead> \r\n<tr>\r\n<td colspan=\"2\">Table Header (thead)</td>\r\n</tr>\r\n</thead><tfoot> \r\n<tr>\r\n<td colspan=\"2\">Table Footer (tfoot)</td>\r\n</tr>\r\n</tfoot> \r\n<tbody>\r\n<tr class=\"gkTableColor\">\r\n<td><strong>Column 1</strong></td>\r\n<td><strong>Column 2</strong></td>\r\n</tr>\r\n<tr>\r\n<td>Cell 3 - part of tbody</td>\r\n<td>Cell 4 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 5 - part of tbody</td>\r\n<td>Cell 6 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 7 - part of tbody</td>\r\n<td>Cell 8 - part of tbody</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p> </p>\r\n<table class=\"gkTable2\" width=\"656\" height=\"94\">\r\n<thead> \r\n<tr>\r\n<td colspan=\"2\">Table Header (thead)</td>\r\n</tr>\r\n</thead><tfoot> \r\n<tr>\r\n<td colspan=\"2\">Table Footer (tfoot)</td>\r\n</tr>\r\n</tfoot> \r\n<tbody>\r\n<tr class=\"gkTableColor\">\r\n<td><strong>Column 1</strong></td>\r\n<td><strong>Column 2</strong></td>\r\n</tr>\r\n<tr class=\"odd\">\r\n<td>Cell 1 - part of tbody</td>\r\n<td>Cell 2 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 3 - part of tbody</td>\r\n<td>Cell 4 - part of tbody</td>\r\n</tr>\r\n<tr class=\"odd\">\r\n<td>Cell 5 - part of tbody</td>\r\n<td>Cell 6 - part of tbody</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</blockquote>','',1,0,0,7,'2011-01-11 22:34:23',42,'','2011-08-17 10:39:43',42,0,'0000-00-00 00:00:00','2011-01-11 22:34:23','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_vote\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',62,0,8,'','',1,602,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(2,34,'Module positions','module-positions','','<p><img src=\"images/demo/module_positions.png\" border=\"0\" style=\"display: block; margin-left: auto; margin-right: auto; border: 0px none currentColor;\" /></p>','',1,0,0,7,'2011-01-12 16:57:05',42,'','2011-01-17 15:05:55',42,0,'0000-00-00 00:00:00','2011-01-12 16:57:05','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,7,'','',1,46,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(3,35,'Messages','messages','','<p>Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows:</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"message message fade\"> \r\n<ul>\r\n<li>This is a sample message</li>\r\n</ul>\r\n</dd></dl> \r\n</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"notice message fade\"> \r\n<ul>\r\n<li>This is a sample warning message</li>\r\n</ul>\r\n</dd></dl> \r\n</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"error message fade\"> \r\n<ul>\r\n<li>This is a sample error message</li>\r\n</ul>\r\n</dd></dl>\r\n</p>','',1,0,0,7,'2011-01-12 17:08:51',42,'','2011-01-20 10:10:47',42,0,'0000-00-00 00:00:00','2011-01-12 17:08:51','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,6,'','',1,105,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(4,36,'Chrome frame','chrome-frame','','<p>Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page.</p>\r\n<p>In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine.</p>\r\n<p>To get know more about Google Chrome Frame, please visit:</p>\r\n<p><a href=\"http://code.google.com/intl/en-GB/chrome/chromeframe/\">http://code.google.com/intl/en-GB/chrome/chromeframe/</a> - the official Project’s web side containing the link to the plug-in.</p>\r\n<p><a href=\"http://www.chromium.org/developers/how-tos/chrome-frame-getting-started\">http://www.chromium.org/developers/how-tos/chrome-frame-getting-started</a> - more info about Google Chrome Frame for developers.</p>','',1,0,0,7,'2011-01-12 17:12:21',42,'','2012-01-15 22:40:43',42,0,'0000-00-00 00:00:00','2011-01-12 17:12:21','0000-00-00 00:00:00','{\"image_intro\":\"images\\/google-chrome-logo1.png\",\"float_intro\":\"right\",\"image_intro_alt\":\"Google Chrome Frame\",\"image_intro_caption\":\"Google Chrome Frame\",\"image_fulltext\":\"images\\/google-chrome-logo1.png\",\"float_fulltext\":\"right\",\"image_fulltext_alt\":\"Google Chrome Frame\",\"image_fulltext_caption\":\"Google Chrome Frame\"}','{\"urla\":\"http:\\/\\/www.google.com\",\"urlatext\":\"Google\",\"targeta\":\"\",\"urlb\":\"http:\\/\\/code.google.com\\/intl\\/en-GB\\/chrome\\/chromeframe\\/\",\"urlbtext\":\"Official Project Site\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,5,'','',1,105,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(5,38,'Menu types','menu-types','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-12 17:58:21',42,'','2011-01-12 18:16:21',42,0,'0000-00-00 00:00:00','2011-01-12 17:58:21','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,86,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(6,40,'Right column','right-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:18:41',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 19:18:41','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,8,'','',1,35,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(7,41,'Right two columns','right-two-columns','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:28:47',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 19:28:47','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,7,'','',1,43,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(8,42,'Left column','left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:33:11',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 19:33:11','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,6,'','',1,20,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(9,43,'Left two columns','left-two-columns','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 19:33:11',42,'','2011-01-12 20:49:37',42,0,'0000-00-00 00:00:00','2011-01-12 19:33:11','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,5,'','',1,37,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(10,44,'Content inset left','content-inset-left','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 21:11:22',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 21:11:22','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,4,'','',1,50,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(11,45,'Content inset right','content-inset-right','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 21:12:26',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 21:12:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,3,'','',1,21,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(12,46,'Content inset both','content-inset-both','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 21:12:26',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 21:12:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,2,'','',1,31,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(13,47,'Content inset + column','content-inset--column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 22:01:45',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 22:01:45','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,37,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(14,48,'Content inset + column (2x)','content-inset--column-2x','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>','',1,0,0,9,'2011-01-12 22:03:08',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-12 22:03:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,0,'','',1,31,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(15,49,'Split menu','split-menu','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-13 00:12:59',42,'','2011-01-13 00:14:18',42,0,'0000-00-00 00:00:00','2011-01-13 00:12:59','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,3,'','',1,64,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(16,50,'Dropline menu','dropline-menu','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-12 17:58:21',42,'','2011-01-12 18:16:21',0,0,'0000-00-00 00:00:00','2011-01-12 17:58:21','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,199,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(17,51,'GK Menu','gk-menu','','<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>','',1,0,0,8,'2011-01-13 00:12:59',42,'','2011-01-13 00:14:18',0,0,'0000-00-00 00:00:00','2011-01-13 00:12:59','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,0,'','',1,45,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(18,52,'Module variation','module-variation','','<p>On this page you can see basic suffixes used in this template. Please remember about using space at beginning of suffix name in module options.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Curabitur blandit tempus porttitor. Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. <br /><br />Donec id elit non mi porta gravida at eget metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas sed diam eget risus varius blandit sit amet non magna. <br /><br />Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Donec id elit non mi porta gravida at eget metus. Donec ullamcorper nulla non metus auctor fringilla. Aenean lacinia bibendum nulla sed consectetur. <br /><br />Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. <br /><br />Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.</p>','',1,0,0,7,'2011-01-13 12:30:01',42,'','2011-08-17 12:01:33',42,0,'0000-00-00 00:00:00','2011-01-13 12:30:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,4,'','',1,214,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(19,59,'Archive article I','archive-article-i','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,0,0,2,'2011-01-13 16:01:40',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,3,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(20,60,'Archive article II','archive-article-ii','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,0,0,2,'2011-01-13 16:01:40',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(21,61,'Archive article III','archive-article-iii','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,0,0,2,'2011-01-13 16:01:40',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(23,63,'IE 6 style','ie-6-style','','<p>Internet Explorer 6 is on the way out, but there is still a significant number of users that are stuck to this browser. According to this, we decided that our templates are going to support IE 6 slightly. By dint of the \"IE6 Bar\" plug-in, available in templates menu options, users can apply the upper bar in their IE browser to keep them informed that Internet Explorer can not display the Web site properly. Additionally, instead of the whole range of template styles, we created one style- Universal Internet Explorer 6 CSS - project\'s website. Thanks to this, users will have the full access to the web’s content, but on the other hand, a web site’s appearance and functioning might be more rough to some extend.</p>','',1,0,0,7,'2011-01-17 14:47:32',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-01-17 14:47:32','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,3,'','',1,28,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(24,64,'Lorem ipsum','lorem-ipsum','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo.</p>\r\n<p>Donec ullamcorper nulla non metus auctor fringilla. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas faucibus mollis interdum.</p>\r\n<p>Sed posuere consectetur est at lobortis. Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Nulla vitae elit libero, a pharetra augue. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Donec sed odio dui. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla. Maecenas sed diam eget risus varius blandit sit amet non magna. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum id ligula porta felis euismod semper.</p>\r\n<p>Curabitur blandit tempus porttitor. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>','',1,0,0,7,'2011-01-17 17:16:48',42,'','2011-09-23 19:44:30',42,0,'0000-00-00 00:00:00','2011-01-17 17:16:48','0000-00-00 00:00:00','','','{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',5,0,2,'','',1,262,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(25,67,'Welcome to Joomla!','welcome-to-joomla','','<div><strong>Joomla! is a free open source framework and content publishing  system designed for quickly creating highly interactive multi-language  Web sites, online communities, media portals, blogs and eCommerce  applications. <br /></strong></div>\r\n<p><strong><br /></strong><img class=\"caption\" src=\"http://localhost/financial/images/stories/powered_by.png\" border=\"0\" alt=\"Joomla! Logo\" title=\"Example Caption\" hspace=\"6\" vspace=\"0\" width=\"165\" height=\"68\" align=\"left\" />Joomla!  provides an easy-to-use graphical user interface that simplifies the  management and publishing of large volumes of content including HTML,  documents, and rich media.  Joomla! is used by organisations of all  sizes for intranets and extranets and is supported by a community of  tens of thousands of users.</p>\r\n','\r\n<p>With a fully documented library of developer resources, Joomla!  allows the customisation of every aspect of a Web site including  presentation, layout, administration, and the rapid integration with  third-party applications.</p>\r\n<p>Joomla! now provides more developer power while making the user  experience all the more friendly. For those who always wanted increased  extensibility, Joomla! 1.5 can make this happen.</p>\r\n<p>A new framework, ground-up refactoring, and a highly-active  development team brings the excitement of \'the next generation CMS\' to  your fingertips.  Whether you are a systems architect or a complete  \'noob\' Joomla! can take you to the next level of content delivery. \'More  than a CMS\' is something we have been playing with as a catchcry  because the new Joomla! API has such incredible power and flexibility,  you are free to take whatever direction your creative mind takes you and  Joomla! can help you get there so much more easily than ever before.</p>\r\n<p>Thinking Web publishing? Think Joomla!</p>',1,0,0,16,'2011-07-20 08:49:51',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-07-20 08:49:51','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(26,72,'Online Business Conference','online-business-conference','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Online Business Conference\" title=\"Online Business Conference\" align=\"left\" />With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.</p>\r\n','\r\n<p>More importantly, several e business meetings sites have been launched over the World Wide Web recently helping to their valued customers worldwide in a most artful and dedicated manner.<br /><br />Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,18,'2011-07-20 12:15:26',42,'','2011-08-19 14:09:09',42,0,'0000-00-00 00:00:00','2011-07-20 12:15:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(27,73,'Need Additional Capital?','need-additional-capital','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Need Additional Capital?\" title=\"Need Additional Capital?\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,18,'2011-07-20 12:17:45',42,'','2011-08-19 14:08:30',42,0,'0000-00-00 00:00:00','2011-07-20 12:17:45','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(28,74,'We celebrate your success! ','we-celebrate-your-success','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Online Business Conference\" title=\"Online Business Conference\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,18,'2011-07-20 12:25:43',42,'','2011-08-19 14:10:23',42,0,'0000-00-00 00:00:00','2011-07-20 12:25:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(29,75,'Idea about starting your own business','idea-about-starting-your-own-business','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Idea about starting your own business\" title=\"Idea about starting your own business\" align=\"left\" />In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to gauge their support and to get their advice.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi.</p>',1,0,0,18,'2011-07-20 12:27:42',42,'','2011-08-19 14:06:37',42,0,'0000-00-00 00:00:00','2011-07-20 12:27:42','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(30,76,'Support your financial success ','support-your-financial-success','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Support your financial success\" title=\"Support your financial success\" align=\"left\" />A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:29:48',42,'','2011-08-19 14:25:12',42,0,'0000-00-00 00:00:00','2011-07-20 12:29:48','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(31,77,'WorkShop from dedicated stractegy','workshop-from-dedicated-stractegy','','<p style=\"margin-top: 10px;\"><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"WorkShop from dedicated stractegy\" title=\"WorkShop from dedicated stractegy\" align=\"left\" />Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding</p>\r\n','\r\n<p>you can qualify for and who you can rely on is an important part of the decision making process.</p>\r\n<p>Business Financial Services (BFS) is the trusted provider of merchant cash advances to businesses nationwide. Since 2002, business owners have come to us to get the small business capital they need for inventory, vendor financing, renovation, equipment, taxes or just extra cash flow.</p>\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:31:43',42,'','2011-08-19 14:25:57',42,0,'0000-00-00 00:00:00','2011-07-20 12:31:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(32,78,'Office and Support Staff ','office-and-support-staff','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Office and Support Staff \" title=\"Office and Support Staff \" align=\"left\" />Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:33:51',42,'','2011-08-19 14:23:44',42,0,'0000-00-00 00:00:00','2011-07-20 12:33:51','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(33,79,'Creating a great team environment','creating-a-great-team-environment','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Creating a great team environment\" title=\"Creating a great team environment\" align=\"left\" />When your business encounters bumps in the road, it seems like everyone knows — especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',1,0,0,19,'2011-07-20 12:35:47',42,'','2011-08-19 14:23:01',42,0,'0000-00-00 00:00:00','2011-07-20 12:35:47','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(34,80,'Our business is built on friendship.','our-business-is-built-on-friendship','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Our business is built on friendship.\" title=\"Our business is built on friendship.\" align=\"left\" />Describe your company\'s <em>business</em> plan with this <em>presentation</em> for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia.</p>\r\n','\r\n<p>It all have to do with what you are ready, willing and able to accept within yourself and in accepting to be able to give others. It is your personal power to make the difference by being true to the best within you and letting truth shine through your words and actions. Be yourself in front of the eyes of the crowd.<br /><br /></p>\r\n<div style=\"text-align: justify;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</div>\r\n<p> </p>',1,0,0,20,'2011-07-20 12:37:26',42,'','2011-08-19 14:27:59',42,0,'0000-00-00 00:00:00','2011-07-20 12:37:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(35,81,'Trusted in financial market','trusted-in-financial-market','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Trusted in financial market\" title=\"Trusted in financial market\" align=\"left\" />Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding you</p>\r\n','\r\n<p>can qualify for and who you can rely on is an important part of the decision making process. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',1,0,0,20,'2011-07-20 12:39:26',42,'','2011-08-19 14:29:30',42,0,'0000-00-00 00:00:00','2011-07-20 12:39:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(36,82,'Fully equipped modern workshop','fully-equipped-modern-workshop','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Fully equipped modern workshop\" title=\"Fully equipped modern workshop\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />~Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',1,0,0,20,'2011-07-20 12:41:06',42,'','2011-08-19 14:27:09',42,0,'0000-00-00 00:00:00','2011-07-20 12:41:06','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(37,83,'Top professional advisers','top-professional-advisers','','<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Top professional advisers\" title=\"Top professional advisers\" align=\"left\" />Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?</p>\r\n','\r\n<p>If yes, then please feel free to contact at www.ebusinessmeetings.net as this is yours own company who helps you regarding your e business meetings, conferences and seminars in a clearly artful and dedicated manner. It provides you the smart business meeting tips through which you would be instantly able to promote your own business meetings as well as conferences effortlessly.  So please do not get hesitated to contact with E Business Meetings so as to get a perfect advice regarding your own business meetings.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.</p>',1,0,0,20,'2011-07-20 12:43:31',42,'','2011-08-19 14:28:43',42,0,'0000-00-00 00:00:00','2011-07-20 12:43:31','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,0,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(38,84,'Page Break','page-break','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<hr title=\"Page 1\" alt=\"page1\" class=\"system-pagebreak\" />\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<hr title=\"Page 2\" alt=\"page2\" class=\"system-pagebreak\" />\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>','',1,0,0,7,'2011-09-13 20:09:41',42,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-09-13 20:09:41','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',1,0,1,'','',1,6,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(39,85,'Chrome frame (2)','chrome-frame-2','','<p>Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page.</p>\r\n<p>In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine.</p>\r\n<p>To get know more about Google Chrome Frame, please visit:</p>\r\n<p><a href=\"http://code.google.com/intl/en-GB/chrome/chromeframe/\">http://code.google.com/intl/en-GB/chrome/chromeframe/</a> - the official Project’s web side containing the link to the plug-in.</p>\r\n<p><a href=\"http://www.chromium.org/developers/how-tos/chrome-frame-getting-started\">http://www.chromium.org/developers/how-tos/chrome-frame-getting-started</a> - more info about Google Chrome Frame for developers.</p>','',1,0,0,7,'2011-01-12 17:12:21',42,'','2011-01-17 14:37:56',0,42,'2012-01-15 22:38:52','2011-01-12 17:12:21','0000-00-00 00:00:00','','','{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*','');


--
-- Table structure for table `#__content_frontpage`
--



CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_frontpage`
--


INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES (23,6),(2,7),(4,9),(17,8),(3,5),(16,4),(31,3),(28,2),(39,1);


--
-- Table structure for table `#__content_rating`
--



CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_rating`
--




--
-- Table structure for table `#__core_log_searches`
--



CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__core_log_searches`
--




--
-- Table structure for table `#__extensions`
--



CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned DEFAULT NULL,
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10029 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__extensions`
--


INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(3,'com_admin','component','com_admin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(4,'com_banners','component','com_banners','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(5,'com_cache','component','com_cache','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(6,'com_categories','component','com_categories','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(8,'com_contact','component','com_contact','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"contact_layout\":\"_:default\",\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"plain\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"1\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10,'com_installer','component','com_installer','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(11,'com_languages','component','com_languages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),(12,'com_login','component','com_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(13,'com_media','component','com_media','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(14,'com_menus','component','com_menus','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(15,'com_messages','component','com_messages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(16,'com_modules','component','com_modules','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(19,'com_search','component','com_search','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(20,'com_templates','component','com_templates','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(22,'com_content','component','com_content','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"1\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"right\",\"float_fulltext\":\"right\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10023,'mod_gk_register','module','mod_gk_register','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_gk_register\",\"type\":\"module\",\"creationDate\":\"14\\/02\\/2011\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2011 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 1.0\",\"description\":\"GavickPro register form\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(23,'com_config','component','com_config','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','{\"filters\":{\"1\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(25,'com_users','component','com_users','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"1\",\"useractivation\":\"1\",\"mail_to_admin\":\"0\",\"captcha\":\"recaptcha\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"legacy\":false,\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"PHPMailer\",\"copyright\":\"Copyright (C) PHPMailer.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/phpmailer.codeworxtech.com\\/\",\"version\":\"2.5.0\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"legacy\":false,\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (C) 2008 SimplePie\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.0.1\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(102,'phputf8','library','phputf8','',0,1,1,1,'{\"legacy\":false,\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"2.5.0\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(103,'Joomla! Web Application Framework','library','joomla','',0,1,1,0,'{\"legacy\":false,\"name\":\"Joomla! Web Application Framework\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(203,'mod_banners','module','mod_banners','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(206,'mod_feed','module','mod_feed','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(207,'mod_footer','module','mod_footer','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(208,'mod_login','module','mod_login','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(213,'mod_search','module','mod_search','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(216,'mod_users_latest','module','mod_users_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(220,'mod_articles_category','module','mod_articles_category','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(304,'mod_login','module','mod_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(306,'mod_online','module','mod_online','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(309,'mod_status','module','mod_status','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(311,'mod_title','module','mod_title','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(313,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.1\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"none\"}','','',0,'0000-00-00 00:00:00',0,0),(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"article_index\":\"1\",\"article_index_text\":\"\",\"multipage_toc\":\"1\",\"showall\":\"1\",\"style\":\"pages\"}','','',0,'0000-00-00 00:00:00',4,0),(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),(409,'plg_content_vote','plugin','vote','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"2.5.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2011\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.4.7\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"compressed\":\"0\",\"cleanup_startup\":\"0\",\"cleanup_save\":\"2\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"safari\":\"0\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),(423,'plg_system_p3p','plugin','p3p','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',6,0),(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',10,0),(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',7,0),(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0),(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',9,0),(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',11,0),(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',12,0),(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',13,0),(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),(433,'plg_user_profile','plugin','profile','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(500,'atomic','template','atomic','',0,1,1,0,'{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"2.5.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(502,'bluestork','template','bluestork','',1,1,1,0,'{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(503,'beez_20','template','beez_20','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),(504,'hathor','template','hathor','',1,1,1,0,'{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"2.5.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(505,'beez5','template','beez5','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(700,'files_joomla','file','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10000,'Authentication - Facebook','plugin','facebook','authentication',0,1,1,0,'{\"legacy\":false,\"name\":\"Authentication - Facebook\",\"type\":\"plugin\",\"creationDate\":\"18 December 2010\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2010 - 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"GK4 1.0\",\"description\":\"GavickPro Facebook authentication plugin\",\"group\":\"\"}','{\"facebook_api_id\":\"171342606239806\",\"facebook_api_secret\":\"f08d507c3c74fc1688868f38cbe43331\",\"auto_register\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(10011,'System - GKreCaptcha','plugin','gk_recaptcha','system',0,0,1,0,'{\"legacy\":false,\"name\":\"System - GKreCaptcha\",\"type\":\"plugin\",\"creationDate\":\"23 January 2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"1.0\",\"description\":\"GavickPro reCaptcha plugin\",\"group\":\"\"}','{\"public_key\":\"6LfHc8YSAAAAAGcJ0NLN1VcMpwldK1HyF-a6dwDI \",\"private_key\":\"6LfHc8YSAAAAADZonH7o61FtzYXTFGPR-t1rxKag\",\"theme\":\"clean\",\"lang\":\"en\"}','','',0,'0000-00-00 00:00:00',3,0),(10009,'Tabs GK4','module','mod_tabs_gk4','',0,1,0,0,'{\"legacy\":false,\"name\":\"Tabs GK4\",\"type\":\"module\",\"creationDate\":\"25\\/09\\/2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK4 1.3\",\"description\":\"\\n\\t\\t<style type=\\\"text\\/css\\\">\\n\\t\\t\\tspan.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; }\\n\\t\\t\\tspan.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; }\\n\\t\\t\\tspan.readonly p { margin: 0 26px 10px }\\n\\t\\t\\tspan.readonly p a { color: #2F4C6D }\\n\\t\\t\\tspan.readonly p.homepage { margin-top: 30px }\\n\\t\\t\\tspan.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }\\n\\t\\t<\\/style>\\n\\t\\t\\n\\t\\t<span class=\\\"readonly\\\"><h1>Tabs GK4<small>ver. 1.3<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6.<\\/p><p>With Tabs GK4 module, you can create tabs on a site which include various content, like: some modules or XHTML code defined by a user. Thanks to tab management system integrated in the module, its support is very easy, intuitive and fast. By embedding <a href=\'http:\\/\\/tools.gavick.com\\/newshowpro.html\' target=\'_blank\'>News Show GK4<\\/a> module in it, it is possible to get a tool for presenting articles in the form of tabs easily.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/tabs.html\' target=\'_blank\'>Learn more at the Tabs GK4 project website.<\\/a><\\/p><p class=\'license\'>Tabs GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"module_height\":\"200\",\"buttons\":\"1\",\"tabs_position\":\"top\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"1\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"opacity\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"1\",\"useScript\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(10002,'Button - GK Typography','plugin','gk_typography','editors-xtd',0,1,1,0,'{\"legacy\":true,\"name\":\"Button - GK Typography\",\"type\":\"plugin\",\"creationDate\":\"08\\/01\\/2011\",\"author\":\"Robert Gavick - GavickPro\",\"copyright\":\"Copyrighted Commercial Software\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0.1\",\"description\":\"Plugin to easier typography using in Joomla WYSIWYG editors.\",\"group\":\"\"}','{\"typo_override\":\"gk_penguinmail:full.xml\"}','','',0,'0000-00-00 00:00:00',0,0),(10010,'GK Menu Extended Parameters','plugin','plg_gkextmenu','system',0,1,1,0,'{\"legacy\":true,\"name\":\"GK Menu Extended Parameters\",\"type\":\"plugin\",\"creationDate\":\"29 December 2010\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional menu options for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(10004,'mod_news_pro_gk4','module','mod_news_pro_gk4','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_news_pro_gk4\",\"type\":\"module\",\"creationDate\":\"26\\/07\\/2011\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2011 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 1.7\",\"description\":\"\\n\\n\\t\\t<style type=\'text\\/css\'>span.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; } span.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; } span.readonly p { margin: 0 26px 10px } span.readonly p a { color: #ab3f0a } span.readonly p.homepage { margin-top: 30px } span.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }<\\/style><span class=\'readonly\'><h1>News Show Pro GK4 <small>ver. 1.6<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6.<\\/p><p>Basing on experiences gathered, we created probably the best tool to present articles for Joomla! Huge amount of options and possibilities of formatting causes News Show Pro GK4 is a complex tool in making www pages content attractive. News Show Pro is appropriate while preparing simple structures with an individual article, the same as, complex arrangements including few articles and a list of links.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/newshowpro.html\' target=\'_blank\'>Learn more at the NSP GK4 project website.<\\/a><\\/p><p class=\'license\'>News Show Pro GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\n\\t\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_width\":\"100\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":\"\",\"com_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"art_padding\":\"0 20px 20px 0\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"0\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"3\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"160\",\"img_height\":\"120\",\"img_margin\":\"6px 14px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"top_interface_style\":\"arrows_with_pagination\",\"bottom_interface_style\":\"arrows_with_counter\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\"}','','',0,'0000-00-00 00:00:00',0,0),(10008,'gk_finance_business','template','gk_finance_business','',0,1,1,0,'{\"legacy\":false,\"name\":\"gk_finance_business\",\"type\":\"template\",\"creationDate\":\"20 January 2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2010 - 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"1.0\",\"description\":\"TPL_GK_LANG_XML_DESCRIPTION\",\"group\":\"\"}','{\"template_color\":\"1\",\"mainbody_frontpage\":\"only_component\",\"mainbody_subpage\":\"mainbody_or_component\",\"messages_position\":\"message-position-1\",\"default_layout\":\"default\",\"facebook_layout\":\"facebook\",\"iphone_layout\":\"iphone\",\"android_layout\":\"android\",\"handheld_layout\":\"handheld\",\"template_width\":\"980px\",\"header1_width\":\"50\",\"left_column_width\":\"20\",\"left2_column_width\":\"50\",\"right_column_width\":\"20\",\"right2_column_width\":\"50\",\"inset_column_width\":\"20\",\"inset2_column_width\":\"20\",\"user1_6_widest_value\":\"0\",\"user1_6_widest\":\"user1\",\"user7_12_widest_value\":\"0\",\"user7_12_widest\":\"user7\",\"top1_6_widest_value\":\"0\",\"top1_6_widest\":\"top1\",\"top7_12_widest_value\":\"0\",\"top7_12_widest\":\"top7\",\"bottom1_6_widest_value\":\"0\",\"bottom1_6_widest\":\"bottom1\",\"bottom7_12_widest_value\":\"0\",\"bottom7_12_widest\":\"bottom7\",\"logo_type\":\"image\",\"logo_image\":\"\",\"logo_text\":\"\",\"logo_slogan\":\"\",\"print_logo\":\"\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"tools\":\"1\",\"typography\":\"0\",\"typo_iconset1\":\"0\",\"typo_iconset2\":\"0\",\"typo_iconset3\":\"0\",\"menu_type\":\"gk_menu\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_height\":\"0\",\"menu_width\":\"0\",\"menu_duration\":\"500\",\"mobile_login\":\"0\",\"mobile_register\":\"0\",\"mobile_desktop\":\"0\",\"mobile_search\":\"0\",\"mobile_collapsible\":\"0\",\"fb_api_id\":\"\",\"fb_lang\":\"en_US\",\"fb_login\":\"0\",\"fb_like\":\"0\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"500\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"fb_facepile\":\"0\",\"fb_facepile_max_rows\":\"1\",\"fb_facepile_width\":\"500\",\"tweet_btn\":\"0\",\"tweet_btn_data_count\":\"vertical\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"digg_btn\":\"0\",\"digg_btn_style\":\"0\",\"buzz_btn\":\"0\",\"buzz_btn_style\":\"0\",\"delicious_btn\":\"0\",\"instapaper_btn\":\"0\",\"excluded_cats\":\"\",\"selectivizr\":\"0\",\"reset_css\":\"\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"chrome_frame_support\":\"0\",\"ie6bar\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10012,'K2 Comments','module','mod_k2_comments','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Comments\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_COMMENTS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"\",\"\":\"K2_TOP_COMMENTERS\",\"catfilter\":\"0\",\"category_id\":\"\",\"comments_limit\":\"5\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"1\",\"itemCategory\":\"1\",\"feed\":\"1\",\"commenters_limit\":\"5\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10013,'K2 Content','module','mod_k2_content','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Content\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_MOD_K2_CONTENT_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"\":\"K2_OTHER_OPTIONS\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemCount\":\"5\",\"itemsOrdering\":\"\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"\",\"items\":\"\",\"itemTitle\":\"1\",\"itemAuthor\":\"1\",\"itemAuthorAvatar\":\"1\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"50\",\"userDescription\":\"1\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"\",\"itemImage\":\"1\",\"itemImgSize\":\"Small\",\"itemVideo\":\"1\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemAttachments\":\"1\",\"itemTags\":\"1\",\"itemCategory\":\"1\",\"itemDateCreated\":\"1\",\"itemHits\":\"1\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"1\",\"feed\":\"1\",\"itemPreText\":\"\",\"itemCustomLink\":\"0\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkTitle\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10014,'K2 Login','module','mod_k2_login','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Login\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_LOGIN_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10015,'K2 Tools','module','mod_k2_tools','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Tools\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_TOOLS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"\":\"K2_TAG_CLOUD_SETTINGS\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"\",\"authors_module_category\":\"\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":\"0\",\"cloud_category_recursive\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10016,'K2 Users','module','mod_k2_users','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Users\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_MOD_K2_USERS_DESCRTIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"0\",\"\":\"K2_DISPLAY_OPTIONS\",\"filter\":\"1\",\"K2UserGroup\":\"\",\"ordering\":\"1\",\"limit\":\"4\",\"userIDs\":\"\",\"userName\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"userDescription\":\"1\",\"userDescriptionWordLimit\":\"\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"userItemCount\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10017,'K2 Quick Icons (admin)','module','mod_k2_quickicons','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 Quick Icons (admin)\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE\",\"group\":\"\"}','{\"modCSSStyling\":\"1\",\"modLogo\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10018,'K2 Stats (admin)','module','mod_k2_stats','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 Stats (admin)\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE\",\"group\":\"\"}','{\"latestItems\":\"1\",\"popularItems\":\"1\",\"mostCommentedItems\":\"1\",\"latestComments\":\"1\",\"statistics\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10019,'Search - K2','plugin','k2','search',0,1,1,0,'{\"legacy\":true,\"name\":\"Search - K2\",\"type\":\"plugin\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_tags\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10020,'System - K2','plugin','k2','system',0,1,1,0,'{\"legacy\":true,\"name\":\"System - K2\",\"type\":\"plugin\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(10021,'User - K2','plugin','k2','user',0,1,1,0,'{\"legacy\":true,\"name\":\"User - K2\",\"type\":\"plugin\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10022,'k2','component','com_k2','',1,1,0,0,'{\"legacy\":true,\"name\":\"K2\",\"type\":\"component\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!\",\"group\":\"\"}','{\"enable_css\":\"1\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"1\",\"userFeed\":\"1\",\"userItemCount\":\"4\",\"userItemTitle\":\"1\",\"userItemTitleLinked\":\"1\",\"userItemDateCreated\":\"1\",\"userItemImage\":\"1\",\"userItemIntroText\":\"1\",\"userItemCategory\":\"0\",\"userItemTags\":\"1\",\"userItemCommentsAnchor\":\"1\",\"userItemReadMore\":\"1\",\"userItemK2Plugins\":\"1\",\"genericItemCount\":\"10\",\"genericItemTitle\":\"1\",\"genericItemTitleLinked\":\"1\",\"genericItemDateCreated\":\"1\",\"genericItemImage\":\"1\",\"genericItemIntroText\":\"1\",\"genericItemCategory\":\"1\",\"genericItemReadMore\":\"1\",\"genericItemExtraFields\":\"0\",\"tagOrdering\":\"\",\"feedLimit\":\"10\",\"feedItemImage\":\"1\",\"feedImgSize\":\"S\",\"feedItemIntroText\":\"1\",\"feedTextWordLimit\":\"\",\"feedItemFullText\":\"1\",\"feedItemTags\":\"0\",\"feedItemVideo\":\"0\",\"feedItemGallery\":\"0\",\"feedItemAttachments\":\"0\",\"introTextCleanup\":\"0\",\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":\"0\",\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":\"0\",\"linkPopupWidth\":\"900\",\"linkPopupHeight\":\"600\",\"imagesQuality\":\"100\",\"itemImageXS\":\"145\",\"itemImageS\":\"175\",\"itemImageM\":\"265\",\"itemImageL\":\"645\",\"itemImageXL\":\"900\",\"itemImageGeneric\":\"300\",\"catImageWidth\":\"185\",\"catImageDefault\":\"1\",\"userImageWidth\":\"120\",\"userImageDefault\":\"1\",\"commenterImgWidth\":\"48\",\"imageTimestamp\":\"0\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"urlShortener\":\"1\",\"comments\":\"1\",\"commentsOrdering\":\"DESC\",\"commentsLimit\":\"10\",\"commentsFormPosition\":\"below\",\"commentsPublishing\":\"1\",\"commentsReporting\":\"2\",\"commentsReportRecipient\":\"\",\"inlineCommentsModeration\":\"0\",\"gravatar\":\"1\",\"recaptcha\":\"1\",\"recaptcha_public_key\":\"6LfHc8YSAAAAAGcJ0NLN1VcMpwldK1HyF-a6dwDI\",\"recaptcha_private_key\":\"6LfHc8YSAAAAADZonH7o61FtzYXTFGPR-t1rxKag\",\"recaptcha_theme\":\"clean\",\"commentsFormNotes\":\"1\",\"commentsFormNotesText\":\"Make sure you enter the (*) required information where indicated.Basic HTML code is allowed.\",\"frontendEditing\":\"1\",\"showImageTab\":\"1\",\"showImageGalleryTab\":\"1\",\"showVideoTab\":\"1\",\"showExtraFieldsTab\":\"1\",\"showAttachmentsTab\":\"1\",\"showK2Plugins\":\"1\",\"sideBarDisplayFrontend\":\"0\",\"mergeEditors\":\"1\",\"sideBarDisplay\":\"1\",\"attachmentsFolder\":\"\",\"hideImportButton\":\"0\",\"taggingSystem\":\"1\",\"lockTags\":\"0\",\"showTagFilter\":\"0\",\"googleSearch\":\"0\",\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":\"0\",\"K2UserGroup\":\"1\",\"redirect\":\"\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"showItemsCounterAdmin\":\"1\",\"showChildCatItems\":\"1\",\"disableCompactOrdering\":\"0\",\"SEFReplacements\":\"\\u00c5\\u00a0|S, \\u00c5\\u2019|O, \\u00c5\\u00bd|Z, \\u00c5\\u00a1|s, \\u00c5\\u201c|oe, \\u00c5\\u00be|z, \\u00c5\\u00b8|Y, \\u00c2\\u00a5|Y, \\u00c2\\u00b5|u, \\u00c3\\u20ac|A, \\u00c3\\ufffd|A, \\u00c3\\u201a|A, \\u00c3\\u0192|A, \\u00c3\\u201e|A, \\u00c3\\u2026|A, \\u00c3\\u2020|A, \\u00c3\\u2021|C, \\u00c3\\u02c6|E, \\u00c3\\u2030|E, \\u00c3\\u0160|E, \\u00c3\\u2039|E, \\u00c3\\u0152|I, \\u00c3\\ufffd|I, \\u00c3\\u017d|I, \\u00c3\\ufffd|I, \\u00c3\\ufffd|D, \\u00c3\\u2018|N, \\u00c3\\u2019|O, \\u00c3\\u201c|O, \\u00c3\\u201d|O, \\u00c3\\u2022|O, \\u00c3\\u2013|O, \\u00c3\\u02dc|O, \\u00c3\\u2122|U, \\u00c3\\u0161|U, \\u00c3\\u203a|U, \\u00c3\\u0153|U, \\u00c3\\ufffd|Y, \\u00c3\\u0178|s, \\u00c3\\u00a0|a, \\u00c3\\u00a1|a, \\u00c3\\u00a2|a, \\u00c3\\u00a3|a, \\u00c3\\u00a4|a, \\u00c3\\u00a5|a, \\u00c3\\u00a6|a, \\u00c3\\u00a7|c, \\u00c3\\u00a8|e, \\u00c3\\u00a9|e, \\u00c3\\u00aa|e, \\u00c3\\u00ab|e, \\u00c3\\u00ac|i, \\u00c3\\u00ad|i, \\u00c3\\u00ae|i, \\u00c3\\u00af|i, \\u00c3\\u00b0|o, \\u00c3\\u00b1|n, \\u00c3\\u00b2|o, \\u00c3\\u00b3|o, \\u00c3\\u00b4|o, \\u00c3\\u00b5|o, \\u00c3\\u00b6|o, \\u00c3\\u00b8|o, \\u00c3\\u00b9|u, \\u00c3\\u00ba|u, \\u00c3\\u00bb|u, \\u00c3\\u00bc|u, \\u00c3\\u00bd|y, \\u00c3\\u00bf|y, \\u00c3\\u0178|ss\",\"metaDescLimit\":\"150\",\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":\"2\",\"sh404SefTitleAlias\":\"alias\"}','','',0,'0000-00-00 00:00:00',0,0),(10024,'PKG_JOOMLA','package','pkg_joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"PKG_JOOMLA\",\"type\":\"package\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PKG_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10027,'K2 User','module','mod_k2_user','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 User\",\"type\":\"module\",\"creationDate\":\"December 9th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.4\",\"description\":\"K2_MOD_K2_USER_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10025,'Image Show GK4','module','mod_image_show_gk4','',0,1,0,0,'{\"legacy\":false,\"name\":\"Image Show GK4\",\"type\":\"module\",\"creationDate\":\"11\\/08\\/2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK4 1.12\",\"description\":\"\\n\\t\\t<style type=\\\"text\\/css\\\">\\n\\t\\t\\tspan.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; }\\n\\t\\t\\tspan.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; }\\n\\t\\t\\tspan.readonly p { margin: 0 26px 10px }\\n\\t\\t\\tspan.readonly p a { color: #8e0b8c }\\n\\t\\t\\tspan.readonly p.homepage { margin-top: 30px }\\n\\t\\t\\tspan.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }\\n\\t\\t<\\/style>\\n\\n\\t\\t<span class=\\\"readonly\\\"><h1>Image Show GK4<small>ver. 1.12<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6+.<\\/p><p>With Image Show GK4 module, you can create slideshow on a site which include various images and article fragments or texts defined by a user. Thanks to slide management system integrated in the module, its support is very easy, intuitive and fast. With the new method of creating module styles you can easily move your slideshow style from one template to other template.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/image-show.html\' target=\'_blank\'>Learn more at the Image Show GK4 project website.<\\/a><\\/p><p class=\'license\'>Image Show GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-is-1\",\"moduleclass_sfx\":\"\",\"module_style\":\"gk_coffe\"}','','',0,'0000-00-00 00:00:00',0,0),(10026,'GK Cache','plugin','plg_gkcache','system',0,0,1,0,'{\"legacy\":true,\"name\":\"GK Cache\",\"type\":\"plugin\",\"creationDate\":\"25 August 2011\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin necessary if you\'re using Joomla! cache for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(10028,'plg_system_gavickExtCache','plugin','gavickExtCache','system',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_system_gavickExtCache\",\"type\":\"plugin\",\"creationDate\":\"25 August 2011\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Alternative for system cache plugin for GavickPro templates\",\"group\":\"\"}','[]','','',0,'0000-00-00 00:00:00',14,0),(436,'plg_system_languagecode','plugin','languagecode','system',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',10,0),(437,'plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.1\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(438,'plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.1\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(27,'com_finder','component','com_finder','',1,1,0,0,'','{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"porter_en\"}','','',0,'0000-00-00 00:00:00',0,0),(439,'plg_captcha_recaptcha','plugin','recaptcha','captcha',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}','{\"public_key\":\"6Lc-7csSAAAAAA2jJjc3Dhi37_9NhxTvIOSRy-LI\",\"private_key\":\"6Lc-7csSAAAAAIadObFzqVSwzUetIECPVEiFCmDJ\",\"theme\":\"clean\"}','','',0,'0000-00-00 00:00:00',0,0),(440,'plg_system_highlight','plugin','highlight','system',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',7,0),(441,'plg_content_finder','plugin','finder','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(442,'plg_finder_categories','plugin','categories','finder',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',1,0),(443,'plg_finder_contacts','plugin','contacts','finder',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',2,0),(444,'plg_finder_content','plugin','content','finder',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',3,0),(445,'plg_finder_newsfeeds','plugin','newsfeeds','finder',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',4,0),(446,'plg_finder_weblinks','plugin','weblinks','finder',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',5,0),(223,'mod_finder','module','mod_finder','',0,1,0,0,'','','','',0,'0000-00-00 00:00:00',0,0);


--
-- Table structure for table `#__finder_filters`
--



CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_filters`
--




--
-- Table structure for table `#__finder_links`
--



CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM AUTO_INCREMENT=73 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links`
--


INSERT INTO `#__finder_links` (`link_id`, `url`, `route`, `title`, `description`, `indexdate`, `md5sum`, `published`, `state`, `access`, `language`, `publish_start_date`, `publish_end_date`, `start_date`, `end_date`, `list_price`, `sale_price`, `type_id`, `object`) VALUES (1,'index.php?option=com_content&view=category&id=2','index.php?option=com_content&view=category&id=2','Uncategorised','','2012-01-15 22:32:57','01679bc6e14619baec22e976f4541c6c',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2010-06-28 13:26:37','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"2\";s:5:\"alias\";s:13:\"uncategorised\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":3:{s:10:\"page_title\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:1:\"1\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"target\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:15:\"2:uncategorised\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:52:\"index.php/component/content/category/2-uncategorised\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=category&id=2\";s:5:\"route\";s:47:\"index.php?option=com_content&view=category&id=2\";s:5:\"title\";s:13:\"Uncategorised\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2010-06-28 13:26:37\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(2,'index.php?option=com_banners&view=category&id=3','index.php?option=com_content&view=category&id=3','Uncategorised','','2012-01-15 22:32:58','7c9bff02b659601131fb921c9990d6a9',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2010-06-28 13:27:35','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"3\";s:5:\"alias\";s:13:\"uncategorised\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_banners\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":3:{s:10:\"page_title\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:1:\"3\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":3:{s:6:\"target\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"foobar\";s:0:\"\";}}s:4:\"slug\";s:15:\"3:uncategorised\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:41:\"index.php/component/content/category?id=3\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_banners&view=category&id=3\";s:5:\"route\";s:47:\"index.php?option=com_content&view=category&id=3\";s:5:\"title\";s:13:\"Uncategorised\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2010-06-28 13:27:35\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(3,'index.php?option=com_contact&view=category&id=4','index.php?option=com_contact&view=category&id=4','Uncategorised','','2012-01-15 22:32:58','a14b0cf433e211d87fab86c05b11a87c',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2010-06-28 13:27:57','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"4\";s:5:\"alias\";s:13:\"uncategorised\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_contact\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":3:{s:10:\"page_title\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:1:\"5\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"target\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:15:\"4:uncategorised\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:52:\"index.php/component/contact/category/4-uncategorised\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_contact&view=category&id=4\";s:5:\"route\";s:47:\"index.php?option=com_contact&view=category&id=4\";s:5:\"title\";s:13:\"Uncategorised\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2010-06-28 13:27:57\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(4,'index.php?option=com_newsfeeds&view=category&id=5','index.php?option=com_newsfeeds&view=category&id=5','Uncategorised','','2012-01-15 22:32:58','74140b899dfe2e97886864aa2423bd11',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2010-06-28 13:28:15','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"5\";s:5:\"alias\";s:13:\"uncategorised\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:13:\"com_newsfeeds\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":3:{s:10:\"page_title\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:1:\"7\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"target\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:15:\"5:uncategorised\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:54:\"index.php/component/newsfeeds/category/5-uncategorised\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:49:\"index.php?option=com_newsfeeds&view=category&id=5\";s:5:\"route\";s:49:\"index.php?option=com_newsfeeds&view=category&id=5\";s:5:\"title\";s:13:\"Uncategorised\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2010-06-28 13:28:15\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(5,'index.php?option=com_weblinks&view=category&id=6','index.php?option=com_weblinks&view=category&id=6','Uncategorised','','2012-01-15 22:32:58','f6ea76c5bf2a6aabf81096a47e0a3fa4',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2010-06-28 13:28:33','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"6\";s:5:\"alias\";s:13:\"uncategorised\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:12:\"com_weblinks\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":3:{s:10:\"page_title\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:1:\"9\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"target\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:15:\"6:uncategorised\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:53:\"index.php/component/weblinks/category/6-uncategorised\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_weblinks&view=category&id=6\";s:5:\"route\";s:48:\"index.php?option=com_weblinks&view=category&id=6\";s:5:\"title\";s:13:\"Uncategorised\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2010-06-28 13:28:33\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(6,'index.php?option=com_content&view=category&id=7','index.php?Itemid=195','Template articles','','2012-01-15 22:32:58','eea2b6f25e18b489cc9c8507502d9df2',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-11 22:34:53','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"7\";s:5:\"alias\";s:8:\"template\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"2011-01-12 17:11:44\";s:11:\"modified_by\";s:2:\"42\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"11\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:10:\"7:template\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:40:\"index.php/joomla-pages-iii/category-list\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=category&id=7\";s:5:\"route\";s:20:\"index.php?Itemid=195\";s:5:\"title\";s:17:\"Template articles\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-11 22:34:53\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(7,'index.php?option=com_content&view=category&id=8','index.php?option=com_content&view=category&id=8','Menu types','','2012-01-15 22:32:58','960d3c373a699573d982b1f8bc50c938',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-12 17:56:17','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"8\";s:5:\"alias\";s:10:\"menu-types\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"13\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:12:\"8:menu-types\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:49:\"index.php/component/content/category/8-menu-types\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=category&id=8\";s:5:\"route\";s:47:\"index.php?option=com_content&view=category&id=8\";s:5:\"title\";s:10:\"Menu types\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 17:56:17\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(8,'index.php?option=com_content&view=category&id=9','index.php?option=com_content&view=category&id=9','Layouts','','2012-01-15 22:32:58','6562ea9a1d2f6925791e6f91f804de31',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-12 19:18:18','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:1:\"9\";s:5:\"alias\";s:7:\"layouts\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"15\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:9:\"9:layouts\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:46:\"index.php/component/content/category/9-layouts\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=category&id=9\";s:5:\"route\";s:47:\"index.php?option=com_content&view=category&id=9\";s:5:\"title\";s:7:\"Layouts\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 19:18:18\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(9,'index.php?option=com_contact&view=category&id=10','index.php?Itemid=177','Sample category I','Category description','2012-01-15 22:32:58','33f93f676f7541622b3c7a2d3c46914e',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 14:51:48','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"10\";s:5:\"alias\";s:17:\"sample-category-i\";s:7:\"summary\";s:27:\"<p>Category description</p>\";s:9:\"extension\";s:11:\"com_contact\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"17\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:20:\"10:sample-category-i\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:45:\"index.php/joomla-pages-i/contacts-in-category\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_contact&view=category&id=10\";s:5:\"route\";s:20:\"index.php?Itemid=177\";s:5:\"title\";s:17:\"Sample category I\";s:11:\"description\";s:20:\"Category description\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 14:51:48\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(10,'index.php?option=com_contact&view=category&id=11','index.php?option=com_contact&view=category&id=11','Sample category II','Sample category description','2012-01-15 22:32:58','b27500ed55f618718d5738fe531db79f',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 14:52:10','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"11\";s:5:\"alias\";s:18:\"sample-category-ii\";s:7:\"summary\";s:34:\"<p>Sample category description</p>\";s:9:\"extension\";s:11:\"com_contact\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"19\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:21:\"11:sample-category-ii\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:58:\"index.php/component/contact/category/11-sample-category-ii\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_contact&view=category&id=11\";s:5:\"route\";s:48:\"index.php?option=com_contact&view=category&id=11\";s:5:\"title\";s:18:\"Sample category II\";s:11:\"description\";s:27:\"Sample category description\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 14:52:10\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(11,'index.php?option=com_weblinks&view=category&id=12','index.php?option=com_weblinks&view=category&id=12','Joomla Weblink Category','Simple category with Joomla links!','2012-01-15 22:32:58','621ec0f3dd35af62aceaf60d96ee90f8',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:01:01','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"12\";s:5:\"alias\";s:23:\"joomla-weblink-category\";s:7:\"summary\";s:41:\"<p>Simple category with Joomla links!</p>\";s:9:\"extension\";s:12:\"com_weblinks\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"21\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:26:\"12:joomla-weblink-category\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:64:\"index.php/component/weblinks/category/12-joomla-weblink-category\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:49:\"index.php?option=com_weblinks&view=category&id=12\";s:5:\"route\";s:49:\"index.php?option=com_weblinks&view=category&id=12\";s:5:\"title\";s:23:\"Joomla Weblink Category\";s:11:\"description\";s:34:\"Simple category with Joomla links!\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:01:01\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(12,'index.php?option=com_weblinks&view=category&id=13','index.php?Itemid=184','GavickPro','','2012-01-15 22:32:58','902a87aaa22ff13c21234630a17fbdcf',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:05:39','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"13\";s:5:\"alias\";s:6:\"gavick\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:12:\"com_weblinks\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"2011-01-13 15:11:56\";s:11:\"modified_by\";s:2:\"42\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"23\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:50:\"index.php/joomla-pages-ii/news-feeds-in-a-category\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:49:\"index.php?option=com_weblinks&view=category&id=13\";s:5:\"route\";s:20:\"index.php?Itemid=184\";s:5:\"title\";s:9:\"GavickPro\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:05:39\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(13,'index.php?option=com_newsfeeds&view=category&id=14','index.php?option=com_newsfeeds&view=category&id=14','GavickPro','','2012-01-15 22:32:58','803504fab9444fbd3059a117190a5e52',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:34:33','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"14\";s:5:\"alias\";s:9:\"gavickpro\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:13:\"com_newsfeeds\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"25\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:12:\"14:gavickpro\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:51:\"index.php/component/newsfeeds/category/14-gavickpro\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:50:\"index.php?option=com_newsfeeds&view=category&id=14\";s:5:\"route\";s:50:\"index.php?option=com_newsfeeds&view=category&id=14\";s:5:\"title\";s:9:\"GavickPro\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:34:33\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(14,'index.php?option=com_newsfeeds&view=category&id=15','index.php?option=com_newsfeeds&view=category&id=15','Joomla!','','2012-01-15 22:32:58','8cf56376240d4e49897c1b2b997679fe',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:48:47','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"15\";s:5:\"alias\";s:6:\"joomla\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:13:\"com_newsfeeds\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"27\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:9:\"15:joomla\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:48:\"index.php/component/newsfeeds/category/15-joomla\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:50:\"index.php?option=com_newsfeeds&view=category&id=15\";s:5:\"route\";s:50:\"index.php?option=com_newsfeeds&view=category&id=15\";s:5:\"title\";s:7:\"Joomla!\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:48:47\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(15,'index.php?option=com_content&view=category&id=16','index.php?option=com_content&view=category&id=16','Latest','','2012-01-15 22:32:58','9770763656233027044cb243f576b39f',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-07-20 08:47:35','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"16\";s:5:\"alias\";s:6:\"latest\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"29\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:9:\"16:latest\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:46:\"index.php/component/content/category/16-latest\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_content&view=category&id=16\";s:5:\"route\";s:48:\"index.php?option=com_content&view=category&id=16\";s:5:\"title\";s:6:\"Latest\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 08:47:35\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(16,'index.php?option=com_content&view=category&id=17','index.php?option=com_content&view=category&id=17','Financial Business','','2012-01-15 22:32:58','89b5d7542fe0e09a24f91ea8a00fb47f',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-07-20 12:10:00','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"17\";s:5:\"alias\";s:18:\"financial-business\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"2011-07-20 12:10:09\";s:11:\"modified_by\";s:2:\"42\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"31\";s:9:\"parent_id\";s:1:\"1\";s:5:\"level\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:21:\"17:financial-business\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:58:\"index.php/component/content/category/17-financial-business\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_content&view=category&id=17\";s:5:\"route\";s:48:\"index.php?option=com_content&view=category&id=17\";s:5:\"title\";s:18:\"Financial Business\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:10:00\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(17,'index.php?option=com_content&view=category&id=18','index.php?Itemid=213','Financial Adviser','','2012-01-15 22:32:58','c103a007d9db61c8c2be874adb5b5291',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-07-20 12:10:40','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"18\";s:5:\"alias\";s:17:\"financial-adviser\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"32\";s:9:\"parent_id\";s:2:\"17\";s:5:\"level\";s:1:\"2\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:20:\"18:financial-adviser\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:47:\"index.php/2011-08-19-13-59-20/financial-adviser\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_content&view=category&id=18\";s:5:\"route\";s:20:\"index.php?Itemid=213\";s:5:\"title\";s:17:\"Financial Adviser\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:10:40\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(18,'index.php?option=com_content&view=category&id=19','index.php?Itemid=214',' Investment Guide','','2012-01-15 22:32:58','7163a02116d84ead6e33a72a1a7bc98d',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-07-20 12:11:03','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"19\";s:5:\"alias\";s:16:\"investment-guide\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"34\";s:9:\"parent_id\";s:2:\"17\";s:5:\"level\";s:1:\"2\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:19:\"19:investment-guide\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:46:\"index.php/2011-08-19-13-59-20/investment-guide\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_content&view=category&id=19\";s:5:\"route\";s:20:\"index.php?Itemid=214\";s:5:\"title\";s:17:\" Investment Guide\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:11:03\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(19,'index.php?option=com_content&view=category&id=20','index.php?Itemid=215','Market Center','','2012-01-15 22:32:58','bb98e65a4aa5f72ec417f56d2128847d',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-07-20 12:11:28','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:19:{s:2:\"id\";s:2:\"20\";s:5:\"alias\";s:13:\"market-center\";s:7:\"summary\";s:0:\"\";s:9:\"extension\";s:11:\"com_content\";s:10:\"created_by\";s:2:\"42\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"author\";s:0:\"\";s:6:\"robots\";s:0:\"\";}}s:3:\"lft\";s:2:\"36\";s:9:\"parent_id\";s:2:\"17\";s:5:\"level\";s:1:\"2\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:15:\"category_layout\";s:0:\"\";s:5:\"image\";s:0:\"\";}}s:4:\"slug\";s:16:\"20:market-center\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"category\";s:10:\"metaauthor\";N;s:4:\"path\";s:43:\"index.php/2011-08-19-13-59-20/market-center\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:2:{s:4:\"Type\";a:1:{s:8:\"Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_content&view=category&id=20\";s:5:\"route\";s:20:\"index.php?Itemid=215\";s:5:\"title\";s:13:\"Market Center\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:11:28\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(20,'index.php?option=com_contact&view=contact&id=1','index.php?option=com_contact&view=contact&id=1:eli-manning&catid=10:sample-category-i&Itemid=178','Eli Manning','','2012-01-15 22:32:58','ab643df790168396cfb57b3aa2a2b350',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 14:54:01','0000-00-00 00:00:00',0,0,2,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:35:{s:2:\"id\";s:1:\"1\";s:5:\"alias\";s:11:\"eli-manning\";s:8:\"position\";s:0:\"\";s:7:\"address\";s:53:\"B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146.\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-17 18:23:36\";s:11:\"modified_by\";s:2:\"42\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";s:25:\"{\"robots\":\"\",\"rights\":\"\"}\";s:9:\"sortname1\";s:0:\"\";s:9:\"sortname2\";s:0:\"\";s:9:\"sortname3\";s:0:\"\";s:4:\"city\";s:8:\"Victoria\";s:6:\"region\";s:9:\"Australia\";s:7:\"country\";s:9:\"Australia\";s:3:\"zip\";s:4:\"3146\";s:9:\"telephone\";s:16:\"+49 5241 80-0 00\";s:3:\"fax\";s:16:\"+49 5241 80-0 00\";s:7:\"summary\";s:0:\"\";s:5:\"email\";s:13:\"test@test.com\";s:6:\"mobile\";s:16:\"+49 5241 80-0 00\";s:7:\"webpage\";s:0:\"\";s:8:\"ordering\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":40:{s:21:\"show_contact_category\";s:4:\"hide\";s:17:\"show_contact_list\";s:0:\"\";s:18:\"presentation_style\";s:0:\"\";s:9:\"show_name\";s:0:\"\";s:13:\"show_position\";s:1:\"0\";s:10:\"show_email\";s:1:\"0\";s:19:\"show_street_address\";s:0:\"\";s:11:\"show_suburb\";s:1:\"0\";s:10:\"show_state\";s:1:\"0\";s:13:\"show_postcode\";s:1:\"0\";s:12:\"show_country\";s:0:\"\";s:14:\"show_telephone\";s:0:\"\";s:11:\"show_mobile\";s:0:\"\";s:8:\"show_fax\";s:0:\"\";s:12:\"show_webpage\";s:0:\"\";s:9:\"show_misc\";s:1:\"0\";s:10:\"show_image\";s:0:\"\";s:11:\"allow_vcard\";s:1:\"0\";s:13:\"show_articles\";s:0:\"\";s:12:\"show_profile\";s:0:\"\";s:10:\"show_links\";s:0:\"\";s:10:\"linka_name\";s:0:\"\";s:5:\"linka\";s:0:\"\";s:10:\"linkb_name\";s:0:\"\";s:5:\"linkb\";s:0:\"\";s:10:\"linkc_name\";s:0:\"\";s:5:\"linkc\";s:0:\"\";s:10:\"linkd_name\";s:0:\"\";s:5:\"linkd\";s:0:\"\";s:10:\"linke_name\";s:0:\"\";s:5:\"linke\";s:0:\"\";s:14:\"contact_layout\";s:0:\"\";s:15:\"show_email_form\";s:0:\"\";s:15:\"show_email_copy\";s:0:\"\";s:12:\"banned_email\";s:0:\"\";s:14:\"banned_subject\";s:0:\"\";s:11:\"banned_text\";s:0:\"\";s:16:\"validate_session\";s:0:\"\";s:12:\"custom_reply\";s:0:\"\";s:8:\"redirect\";s:0:\"\";}}s:5:\"catid\";s:2:\"10\";s:8:\"category\";s:17:\"Sample category I\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"1:eli-manning\";s:7:\"catslug\";s:20:\"10:sample-category-i\";s:4:\"user\";N;s:4:\"mime\";N;s:6:\"layout\";s:7:\"contact\";s:4:\"path\";s:74:\"index.php/joomla-pages-i/single-contact/10-sample-category-i/1-eli-manning\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:10:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"address\";i:4;s:7:\"country\";i:5;s:9:\"telephone\";i:6;s:3:\"fax\";i:7;s:6:\"mobile\";i:8;s:7:\"webpage\";i:9;s:4:\"user\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:5:{s:4:\"Type\";a:1:{s:7:\"Contact\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Contact\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Sample category I\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Sample category I\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Region\";a:1:{s:9:\"Australia\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"Australia\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:7:\"Country\";a:1:{s:9:\"Australia\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"Australia\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_contact&view=contact&id=1\";s:5:\"route\";s:96:\"index.php?option=com_contact&view=contact&id=1:eli-manning&catid=10:sample-category-i&Itemid=178\";s:5:\"title\";s:11:\"Eli Manning\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 14:54:01\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:2;}'),(21,'index.php?option=com_contact&view=contact&id=2','index.php?option=com_contact&view=contact&id=2:eli-manning&catid=11:sample-category-ii','Joomla User ','','2012-01-15 22:32:59','33f44d788a199002c38f18c765c051b9',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 14:54:01','0000-00-00 00:00:00',0,0,2,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:35:{s:2:\"id\";s:1:\"2\";s:5:\"alias\";s:11:\"eli-manning\";s:8:\"position\";s:0:\"\";s:7:\"address\";s:65:\"B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146. \r\nAustralia\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 14:57:11\";s:11:\"modified_by\";s:2:\"42\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";s:25:\"{\"robots\":\"\",\"rights\":\"\"}\";s:9:\"sortname1\";s:0:\"\";s:9:\"sortname2\";s:0:\"\";s:9:\"sortname3\";s:0:\"\";s:4:\"city\";s:0:\"\";s:6:\"region\";s:9:\"Australia\";s:7:\"country\";s:0:\"\";s:3:\"zip\";s:0:\"\";s:9:\"telephone\";s:0:\"\";s:3:\"fax\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:5:\"email\";s:13:\"test@test.com\";s:6:\"mobile\";s:0:\"\";s:7:\"webpage\";s:0:\"\";s:8:\"ordering\";s:1:\"2\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":40:{s:21:\"show_contact_category\";s:0:\"\";s:17:\"show_contact_list\";s:0:\"\";s:18:\"presentation_style\";s:0:\"\";s:9:\"show_name\";s:0:\"\";s:13:\"show_position\";s:0:\"\";s:10:\"show_email\";s:0:\"\";s:19:\"show_street_address\";s:0:\"\";s:11:\"show_suburb\";s:0:\"\";s:10:\"show_state\";s:0:\"\";s:13:\"show_postcode\";s:0:\"\";s:12:\"show_country\";s:0:\"\";s:14:\"show_telephone\";s:0:\"\";s:11:\"show_mobile\";s:0:\"\";s:8:\"show_fax\";s:0:\"\";s:12:\"show_webpage\";s:0:\"\";s:9:\"show_misc\";s:0:\"\";s:10:\"show_image\";s:0:\"\";s:11:\"allow_vcard\";s:0:\"\";s:13:\"show_articles\";s:0:\"\";s:12:\"show_profile\";s:0:\"\";s:10:\"show_links\";s:0:\"\";s:10:\"linka_name\";s:0:\"\";s:5:\"linka\";s:0:\"\";s:10:\"linkb_name\";s:0:\"\";s:5:\"linkb\";s:0:\"\";s:10:\"linkc_name\";s:0:\"\";s:5:\"linkc\";s:0:\"\";s:10:\"linkd_name\";s:0:\"\";s:5:\"linkd\";s:0:\"\";s:10:\"linke_name\";s:0:\"\";s:5:\"linke\";s:0:\"\";s:14:\"contact_layout\";s:0:\"\";s:15:\"show_email_form\";s:0:\"\";s:15:\"show_email_copy\";s:0:\"\";s:12:\"banned_email\";s:0:\"\";s:14:\"banned_subject\";s:0:\"\";s:11:\"banned_text\";s:0:\"\";s:16:\"validate_session\";s:0:\"\";s:12:\"custom_reply\";s:0:\"\";s:8:\"redirect\";s:0:\"\";}}s:5:\"catid\";s:2:\"11\";s:8:\"category\";s:18:\"Sample category II\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"2:eli-manning\";s:7:\"catslug\";s:21:\"11:sample-category-ii\";s:4:\"user\";N;s:4:\"mime\";N;s:6:\"layout\";s:7:\"contact\";s:4:\"path\";s:71:\"index.php/component/contact/contact/11-sample-category-ii/2-eli-manning\";}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:15:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:8:\"position\";i:4;s:7:\"address\";i:5;s:4:\"city\";i:6;s:6:\"region\";i:7;s:7:\"country\";i:8;s:3:\"zip\";i:9;s:9:\"telephone\";i:10;s:3:\"fax\";i:11;s:5:\"email\";i:12;s:6:\"mobile\";i:13;s:7:\"webpage\";i:14;s:4:\"user\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Contact\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Contact\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:18:\"Sample category II\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:18:\"Sample category II\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Region\";a:1:{s:9:\"Australia\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"Australia\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_contact&view=contact&id=2\";s:5:\"route\";s:86:\"index.php?option=com_contact&view=contact&id=2:eli-manning&catid=11:sample-category-ii\";s:5:\"title\";s:12:\"Joomla User \";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 14:54:01\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:2;}'),(22,'index.php?option=com_content&view=article&id=1','index.php?option=com_content&view=article&id=1:typography&catid=7:template&Itemid=158','Typography','Warnings Headers Icon set 1 Icon set 2 Icon set 3 Tooltips Highlights Code Unordered lists Ordered lists Abbrs and acronyms Definition lists Legends Dropcaps Floated blocks Other span blocks Blockquotes Tables Warnings This is a sample info message. Use <','2012-01-15 22:32:59','fda55ac658968f90dc7f9f2c9b7dbe80',1,1,1,'*','2011-01-11 22:34:23','0000-00-00 00:00:00','2011-01-11 22:34:23','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"1\";s:5:\"alias\";s:10:\"typography\";s:7:\"summary\";s:47236:\"<ul id=\"demo-typography\">\r\n<li><a href=\"#warnings\">Warnings</a></li>\r\n<li><a href=\"#headers\">Headers</a></li>\r\n<li><a href=\"#icons1\">Icon set 1</a></li>\r\n<li><a href=\"#icons2\">Icon set 2</a></li>\r\n<li><a href=\"#icons3\">Icon set 3</a></li>\r\n<li><a href=\"#tooltips\">Tooltips</a></li>\r\n<li><a href=\"#highlights\">Highlights</a></li>\r\n<li><a href=\"#code\">Code</a></li>\r\n<li><a href=\"#ulists\">Unordered lists</a></li>\r\n<li><a href=\"#olists\">Ordered lists</a></li>\r\n<li><a href=\"#abbrs\">Abbrs and acronyms</a></li>\r\n<li><a href=\"#definition\">Definition lists</a></li>\r\n<li><a href=\"#legends\">Legends</a></li>\r\n<li><a href=\"#dropcaps\">Dropcaps</a></li>\r\n<li><a href=\"#blocks\">Floated blocks</a></li>\r\n<li><a href=\"#other\">Other span blocks</a></li>\r\n<li><a href=\"#blockquote\">Blockquotes</a></li>\r\n<li><a href=\"#tables\">Tables</a></li>\r\n</ul>\r\n<h4 class=\"demo-typo\"><a name=\"warnings\">Warnings</a></h4>\r\n<p class=\"gkInfo1\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo1\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips1\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips1\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning1\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning1\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo2\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo2\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips2\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips2\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning2\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning2\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo3\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo3\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips3\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips3\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning3\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning3\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo4\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo4\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips4\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips4\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning4\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning4\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkInfo5\">This is a sample info message. Use <strong>&lt;p    class=\"gkInfo5\"&gt;Your info message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTips5\">This is a sample tips message. Use <strong>&lt;p    class=\"gkTips5\"&gt;Your tips goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWarning5\">This is a sample warning message. Use <strong>&lt;p    class=\"gkWarning5\"&gt;Your warning message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"headers\">Headers</a></h4>\r\n<h1>This is heading 1</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer    semper egestas nunc in volutpat. Fusce adipiscing velit ac eros tempor    iaculis. Phasellus venenatis mollis augue, non posuere odio placerat  in.   Etiam volutpat ultrices lectus. Fusce eu felis erat. Donec congue    interdum elit, sed ornare magna convallis lacinia. In hac habitasse    platea dictumst. Mauris volutpat consectetur accumsan.</p>\r\n<h2>This is heading 2</h2>\r\n<p>Cras diam justo, sodales quis lobortis sed, lobortis vel mauris. Sed a    mollis nunc. Quisque semper condimentum lectus, eget laoreet ipsum    auctor et. Quisque sagittis luctus augue, id fringilla enim euismod    quis. Nullam blandit, elit at euismod rutrum, tortor nibh posuere    mauris, in volutpat diam ante ac dui. Sed velit massa, imperdiet    placerat tristique et, consectetur a lorem. Praesent aliquet turpis in    quam tempor eu pulvinar nibh luctus.</p>\r\n<h3>This is heading 3</h3>\r\n<p>Vivamus rhoncus arcu sit amet est tristique convallis nec vel eros.    Vestibulum euismod luctus velit quis porta. Aliquam varius placerat    mauris sed vehicula. Integer porta facilisis sapien, in tempus lorem    mattis molestie. Suspendisse potenti. Praesent quis diam non dolor    convallis mattis eu id nulla.</p>\r\n<h4>This is heading 4</h4>\r\n<p>Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<p class=\"gkHeadline\">This is a headline.</p>\r\n<p class=\"gkSubHeadline\">This is a subheadline.</p>\r\n<p>Use <strong>&lt;p    class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p    class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<p class=\"gkSmallHeadline\">This is a small headline</p>\r\n<p class=\"gkLargeHeadline\">This is a large headline</p>\r\n<p>Use <strong>&lt;p    class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p    class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec    est risus, facilisis dignissim placerat nec, euismod lacinia nisi.  Nam   ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim  urna,   ultricies ac mollis pretium, imperdiet hendrerit massa. Sed  eleifend   felis sed tellus cursus lacinia. Aenean venenatis aliquet  euismod. Nam   quis turpis tellus, vitae malesuada neque.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons1\">Icon set 1</a></h4>\r\n<p class=\"gkAudio\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudio\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWebcam\">This is a sample webcam message. Use <strong>&lt;p    class=\"gkWebcam\"&gt;Your webcam goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkEmail\">This is a sample email message. Use <strong>&lt;p    class=\"gkEmail\"&gt;Your email message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCreditcard\">This is a sample creditcard message. Use <strong>&lt;p    class=\"gkCreditcard\"&gt;Your creditcart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFeed\">This is a sample feed message. Use <strong>&lt;p    class=\"gkFeed\"&gt;Your feed goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHelp\">This is a sample help message. Use <strong>&lt;p    class=\"gkHelp\"&gt;Your help message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImages\">This is a sample images message. Use <strong>&lt;p    class=\"gkImages\"&gt;Your images message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLock\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLock\"&gt;Your webcam goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPrinter\">This is a sample printer message. Use <strong>&lt;p    class=\"gkPrinter\"&gt;Your printer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkReport\">This is a sample report message. Use <strong>&lt;p    class=\"gkReport\"&gt;Your report message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkScript\">This is a sample script message. Use <strong>&lt;p    class=\"gkScript\"&gt;Your script goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTime\">This is a sample time message. Use <strong>&lt;p    class=\"gkTime\"&gt;Your time message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUser\">This is a sample user message. Use <strong>&lt;p    class=\"gkUser\"&gt;Your user message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWorld\">This is a sample world message. Use <strong>&lt;p    class=\"gkWorld\"&gt;Your world goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCart\">This is a sample cart message. Use <strong>&lt;p    class=\"gkCart\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCd\">This is a sample cd message. Use <strong>&lt;p    class=\"gkCd\"&gt;Your cd message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartBar\">This is a sample chart_bar message. Use <strong>&lt;p    class=\"gkChartBar\"&gt;Your chart_bar goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartLine\">This is a sample chart_line message. Use <strong>&lt;p    class=\"gkChartLine\"&gt;Your chart_line message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartPie\">This is a sample chart_pie message. Use <strong>&lt;p    class=\"gkChartPie\"&gt;Your chart_pie message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkClock\">This is a sample clock message. Use <strong>&lt;p    class=\"gkClock\"&gt;Your clock goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCog\">This is a sample cog message. Use <strong>&lt;p    class=\"gkCog\"&gt;Your cog message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCoins\">This is a sample coins message. Use <strong>&lt;p    class=\"gkCoins\"&gt;Your coins message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCompress\">This is a sample compress message. Use <strong>&lt;p    class=\"gkCompress\"&gt;Your compress goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputer\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputer\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCross\">This is a sample cross message. Use <strong>&lt;p    class=\"gkCross\"&gt;Your cross message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkDisk\">This is a sample disk message. Use <strong>&lt;p    class=\"gkDisk\"&gt;Your disk goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkError\">This is a sample error message. Use <strong>&lt;p    class=\"gkError\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkExclamation\">This is a sample exclamation message. Use <strong>&lt;p    class=\"gkExclamation\"&gt;Your exclamation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFilm\">This is a sample film message. Use <strong>&lt;p    class=\"gkFilm\"&gt;Your film goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFolder\">This is a sample folder message. Use <strong>&lt;p    class=\"gkFolder\"&gt;Your folder message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkGroup\">This is a sample group message. Use <strong>&lt;p    class=\"gkGroup\"&gt;Your group message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHeart\">This is a sample heart message. Use <strong>&lt;p    class=\"gkHeart\"&gt;Your heart goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouse\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouse\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImage\">This is a sample image message. Use <strong>&lt;p    class=\"gkImage\"&gt;Your image message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformation\">This is a sample information message. Use <strong>&lt;p    class=\"gkInformation\"&gt;Your information message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifier\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifier\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMoney\">This is a sample money message. Use <strong>&lt;p    class=\"gkMoney\"&gt;Your money goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkNew\">This is a sample new message. Use <strong>&lt;p    class=\"gkNew\"&gt;Your new message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkNote\">This is a sample note message. Use <strong>&lt;p    class=\"gkNote\"&gt;Your note message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPage\">This is a sample page message. Use <strong>&lt;p    class=\"gkPage\"&gt;Your page goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPage_white\">This is a sample page_white message. Use <strong>&lt;p    class=\"gkPage_white\"&gt;Your page_white message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPlugin\">This is a sample plugin message. Use <strong>&lt;p    class=\"gkPlugin\"&gt;Your plugin message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkAccept\">This is a sample accept message. Use <strong>&lt;p    class=\"gkAccept\"&gt;Your accept goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkAdd\">This is a sample add message. Use <strong>&lt;p    class=\"gkAdd\"&gt;Your add message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCamera\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCamera\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkBrick\">This is a sample brick message. Use <strong>&lt;p    class=\"gkBrick\"&gt;Your brick goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkBox\">This is a sample box message. Use <strong>&lt;p    class=\"gkBox\"&gt;Your box message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCalendar\">This is a sample calendar message. Use <strong>&lt;p    class=\"gkCalendar\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons2\">Icon set 2</a></h4>\r\n<p class=\"gkAudioIs2\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudioIs2\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkEmailIs2\">This is a sample email message. Use <strong>&lt;p    class=\"gkEmailIs2\"&gt;Your email message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFeedIs2\">This is a sample feed message. Use <strong>&lt;p    class=\"gkFeedIs2\"&gt;Your feed message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImagesIs2\">This is a sample images message. Use <strong>&lt;p    class=\"gkImagesIs2\"&gt;Your images message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs2\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs2\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPrinterIs2\">This is a sample printer message. Use <strong>&lt;p    class=\"gkPrinterIs2\"&gt;Your printer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTimeIs2\">This is a sample time message. Use <strong>&lt;p    class=\"gkTimeIs2\"&gt;Your time message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUserIs2\">This is a sample user message. Use <strong>&lt;p    class=\"gkUserIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkWorldIs2\">This is a sample world message. Use <strong>&lt;p    class=\"gkWorldIs2\"&gt;Your world message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCartIs2\">YThis is a sample cart message. Use <strong>&lt;p    class=\"gkCartIs2\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCdIs2\">This is a sample cd message. Use <strong>&lt;p    class=\"gkCdIs2\"&gt;Your cd message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartLineIs2\">This is a sample chart line message. Use <strong>&lt;p    class=\"gkChartLineIs2\"&gt;Your chart line message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartPieIs2\">This is a sample chart pie message. Use <strong>&lt;p    class=\"gkChartPieIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkClockIs2\">This is a sample clock message. Use <strong>&lt;p    class=\"gkClockIs2\"&gt;Your clock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCogIs2\">This is a sample config message. Use <strong>&lt;p    class=\"gkCogIs2\"&gt;Your config message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputerIs2\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputerIs2\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkErrorIs2\">This is a sample error message. Use <strong>&lt;p    class=\"gkErrorIs2\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkExclamationIs2\">This is a sample exclamation message. Use <strong>&lt;p    class=\"gkExclamationIs2\"&gt;Your exclamation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFilmIs2\">This is a sample movie message. Use <strong>&lt;p    class=\"gkFilmIs2\"&gt;Your movie message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFolderIs2\">This is a sample folder message. Use <strong>&lt;p    class=\"gkFolderIs2\"&gt;Your folder message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkGroupIs2\">This is a group calendar message. Use <strong>&lt;p    class=\"gkGroupIs2\"&gt;Your group message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouseIs2\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouseIs2\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkImageIs2\">This is a sample image message. Use <strong>&lt;p    class=\"gkImageIs2\"&gt;Your image message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformationIs2\">This is a sample information message. Use <strong>&lt;p    class=\"gkInfromationIs2\"&gt;Your information message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifierIs2\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifierIs2\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMoneyIs2\">This is a sample money message. Use <strong>&lt;p    class=\"gkMoneyIs2\"&gt;Your money message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPageIs2\">This is a sample page message. Use <strong>&lt;p    class=\"gkPageIs2\"&gt;Your page message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs2\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs2\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCalendarIs2\">This is a calendar feed message. Use <strong>&lt;p    class=\"gkCalendarIs2\"&gt;Your calendar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkContactIs2\">This is a sample contact message. Use <strong>&lt;p    class=\"gkContactIs2\"&gt;Your contact message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkFacebookIs2\">This is a sample facebook message. Use <strong>&lt;p    class=\"gkFacebookIs2\"&gt;Your facebook message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLikeItIs2\">This is a sample like it message. Use <strong>&lt;p    class=\"gkLikeItIs2\"&gt;Your like it message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTwitterIs2\">This is a sample twitter message. Use <strong>&lt;p    class=\"gkTwitterIs2\"&gt;Your twitter message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkVimeoIs2\">This is a sample video message. Use <strong>&lt;p    class=\"gkVideoIs2\"&gt;Your video message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkYoutubeIs2\">This is a sample youtube message. Use <strong>&lt;p    class=\"gkYoutubeIs2\"&gt;Your youtube message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"icons3\">Icon set 3</a></h4>\r\n<p class=\"gkAudioIs3\">This is a sample audio message. Use <strong>&lt;p    class=\"gkAudioIs3\"&gt;Your audio message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs3\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs3\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs3\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs3\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkUserIs3\">This is a sample user message. Use <strong>&lt;p    class=\"gkUserIs3\"&gt;Your user message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCartIs3\">This is a sample cart message. Use <strong>&lt;p    class=\"gkCartIs3\"&gt;Your cart message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkChartBarIs3\">This is a sample chart bar message. Use <strong>&lt;p    class=\"gkChartBarIs3\"&gt;Your chart bar message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkConfigIs3\">This is a sample config message. Use <strong>&lt;p    class=\"gkConfigIs3\"&gt;Your config message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkConfig2Is3\">This is a sample configuration message. Use <strong>&lt;p    class=\"gkConfig2Is3\"&gt;Your configuration message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkComputerIs3\">This is a sample computer message. Use <strong>&lt;p    class=\"gkComputerIs3\"&gt;Your computer message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCoffeIs3\">This is a sample coffe message. Use <strong>&lt;p    class=\"gkCoffeIs3\"&gt;Your coffe message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCrossIs3\">This is a sample cross message. Use <strong>&lt;p    class=\"gkCrossIs3\"&gt;Your cross message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkErrorIs3\">This is a sample error message. Use <strong>&lt;p    class=\"gkErrorIs3\"&gt;Your error message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkHouseIs3\">This is a sample house message. Use <strong>&lt;p    class=\"gkHouseIs3\"&gt;Your house message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkInformationIs3\">This is a sample information message. Use <strong>&lt;p    class=\"gkInformationIs3\"&gt;Your inforation message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkMagnifierIs3\">This is a sample magnifier message. Use <strong>&lt;p    class=\"gkMagnifierIs3\"&gt;Your magnifier message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkPageIs3\">This is a sample page message. Use <strong>&lt;p    class=\"gkPageIs3\"&gt;Your page message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkLockIs3\">This is a sample lock message. Use <strong>&lt;p    class=\"gkLockIs3\"&gt;Your lock message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkCameraIs3\">This is a sample camera message. Use <strong>&lt;p    class=\"gkCameraIs3\"&gt;Your camera message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkStarIs3\">This is a sample star message. Use <strong>&lt;p    class=\"gkStarIs3\"&gt;Your star message goes here!&lt;/p&gt;</strong>.</p>\r\n<p class=\"gkTelephoneIs3\">This is a sample telephone message. Use <strong>&lt;p    class=\"gkTelephoneIs3\"&gt;Your telephone message goes here!&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"tooltips\">Tooltips</a></h4>\r\n<p>Here are some examples of a <a class=\"gkTooltip\" href=\"#\">Classic<span class=\"classicTooltip\">This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Critical<span class=\"customTooltip criticalTooltip\"><em>Critical</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Help<span class=\"customTooltip helpTooltip\"><em>Help</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a>, <a class=\"gkTooltip\" href=\"#\">Information<span class=\"customTooltip infoTooltip\"><em>Information</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> and <a class=\"gkTooltip\" href=\"#\">Warning<span class=\"customTooltip warningTooltip\"><em>Warning</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> CSS powered tooltip. This is just an example of what you can do so feel free to get creative and produce your own!</p>\r\n<h4 class=\"demo-typo\"><a name=\"highlights\">Highlights</a></h4>\r\n<p>This is a <span class=\"gkHighlight1\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight1\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight2\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight2\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight3\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight3\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<p>This is a <span class=\"gkHighlight4\">highlight phrase</span>. Use <strong>&lt;span    class=\"gkHighlight4\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"code\">Code</a></h4>\r\n<p>Below is a sample of <strong>&lt;pre&gt;</strong> or <strong>&lt;div    class=\"gkCode1\"&gt;</strong></p>\r\n<p><strong> </strong></p>\r\n<pre>#wrapper {<br />	position: relative;<br />	float: left;<br />	display: block;<br />}<br /></pre>\r\n<p> </p>\r\n<p>Below is a sample of <strong>&lt;div class=\"gkCode2\"&gt;</strong></p>\r\n<div class=\"gkCode2\">#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br />}</div>\r\n<p> </p>\r\n<p>Below is a sample of <strong>&lt;div class=\"gkCode3\"&gt;&lt;h4&gt;Name    of your file&lt;/h4&gt;Here goes your code&lt;/div&gt;</strong></p>\r\n<p> </p>\r\n<div class=\"gkCode3\">\r\n<h4 class=\"demo-typo\">File</h4>\r\n#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br />}</div>\r\n<h4 class=\"demo-typo\"><a name=\"ulists\">Unordered lists</a></h4>\r\n<p>Types of unordered lists</p>\r\n<table border=\"0\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet1\"&gt;</strong></p>\r\n<ul class=\"gkBullet1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet2\"&gt;</strong></p>\r\n<ul class=\"gkBullet2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet3\"&gt;</strong></p>\r\n<ul class=\"gkBullet3\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkBullet4\"&gt;</strong></p>\r\n<ul class=\"gkBullet4\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkCircle1\"&gt;</strong></p>\r\n<ul class=\"gkCircle1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkCircle2\"&gt;</strong></p>\r\n<ul class=\"gkCircle2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare1\"&gt;</strong></p>\r\n<ul class=\"gkSquare1\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare2\"&gt;</strong></p>\r\n<ul class=\"gkSquare2\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n<td>\r\n<p><strong>&lt;ul class=\"gkSquare3\"&gt;</strong></p>\r\n<ul class=\"gkSquare3\">\r\n<li>Element 1</li>\r\n<li>Element 2</li>\r\n<li>Element 3</li>\r\n</ul>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<h4 class=\"demo-typo\"><a name=\"olists\">Ordered lists</a></h4>\r\n<p>Types of ordered list:</p>\r\n<table border=\"0\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkRoman\"&gt;</strong></p>\r\n<ol class=\"gkRoman\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkDec\"&gt;</strong></p>\r\n<ol class=\"gkDec\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkAlpha\"&gt;</strong></p>\r\n<ol class=\"gkAlpha\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n<td>\r\n<p><strong>&lt;ol class=\"gkDecimalLeadingZero\"&gt;</strong></p>\r\n<ol class=\"gkDecimalLeadingZero\">\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n<li>Element</li>\r\n</ol></td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p><strong>&lt;div class=\"gkNumber1\"&gt;&lt;p&gt;&lt;span&gt;here goes a    number&lt;/span&gt;and here text of element&lt;/p&gt;</strong></p>\r\n<div class=\"gkNumber1\">\r\n<p><span>01</span> Element</p>\r\n<p><span>02</span> Element</p>\r\n</div>\r\n<p><strong>&lt;div class=\"gkNumber2\"&gt;&lt;p&gt;&lt;span&gt;here goes a    number&lt;/span&gt;and here text of element&lt;/p&gt;</strong></p>\r\n<div class=\"gkNumber2\">\r\n<p><span>01</span> Element</p>\r\n<p><span>02</span> Element</p>\r\n<p> </p>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"abbrs\">Abbrs and acronyms</a></h4>\r\n<p>This is a sample of an abbreviation <abbr title=\"Doctor\">Dr</abbr>.    Use <strong>&lt;abbr title=\"Here goes full word or phrase\"&gt;here goes    an abbreviation&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<p>This is a sample of an acronym <acronym title=\"North Atlantic Treaty    Organization\">NATO</acronym>. Use <strong>&lt;acronym title=\"Here goes    full phrase\"&gt;here goes an acronym&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<h4 class=\"demo-typo\"><a name=\"definition\">Definition lists</a></h4>\r\n<p>Below are samples of definition lists</p>\r\n<p><strong>&lt;dl class=\"gkDef1\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef1\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<p><strong>&lt;dl class=\"gkDef2\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef2\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<p><strong>&lt;dl class=\"gkDef3\"&gt;&lt;dt&gt;Here goes the word you\'re    about to define&lt;/dt&gt;&lt;dd&gt;Here goes    definition&lt;/dd&gt;&lt;/dl&gt;</strong></p>\r\n<dl class=\"gkDef3\"><dt>Butter</dt><dd>it is a dairy product made by    churning fresh or fermented cream or milk. It is generally used as a    spread and a condiment, as well as in cooking applications such as    baking, sauce making, and frying. Butter consists of butterfat, water    and milk proteins.</dd><dt>Dairy milk</dt><dd> is an opaque white liquid    produced by the mammary glands of mammals (including monotremes). It    provides the primary source of nutrition for newborn mammals before  they   are able to digest other types of food.</dd></dl>\r\n<h4 class=\"demo-typo\"><a name=\"legends\">Legends</a></h4>\r\n<div class=\"gkLegend1\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend1\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend2\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend2\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend3\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend3\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend4\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend4\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend5\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend5\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend6\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend6\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<div class=\"gkLegend7\">\r\n<h4>Legend</h4>\r\n<p>This is a sample legend note. Use <strong>&lt;div class=\"gkLegend7\"&gt;    &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;Lorem ipsum dolor sit amet,    consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a    neque. Cum sociis natoque penatibus et magnis dis parturient montes,    nascetur ridiculus mus.&lt;/p&gt; &lt;/div&gt;</strong>.</p>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"dropcaps\">Dropcaps</a></h4>\r\n<p><span class=\"gkDropcap1\">T</span>his is a sample text with Dropcap. Use    <strong>&lt;p&gt; &lt;span class=\"gkDropcap1\"&gt;t&lt;/span&gt;</strong> to make the first letter larger. Lorem ipsum dolor sit amet,   consectetur  adipiscing elit. Vestibulum condimentum pulvinar justo, sed   faucibus  ligula feugiat ac. Morbi quis enim nulla, vel congue augue.   Duis quis  quam sed purus porta eleifend. Vivamus ullamcorper est id   libero aliquam  ullamcorper. Donec eget dignissim augue. Donec ante   felis, aliquam ut  consequat eget, lobortis dapibus risus. Aliquam   laoreet enim et lectus  ornare hendrerit. Aliquam rhoncus enim libero.   Morbi aliquam, nibh  mattis feugiat dapibus, nisi massa adipiscing   justo, sit amet  condimentum urna ipsum et lacus. Nam fermentum, eros   quis ullamcorper  convallis, libero mauris lacinia eros, sed tempus leo   lorem vitae purus.  Nunc a malesuada felis. Cras ultrices sapien eu  nisi  elementum non  blandit urna sodales. Duis accumsan cursus massa,  eu  facilisis diam  porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkDropcap2\"><span class=\"gkDropcap2\">T</span>his is a sample text    with Dropcap. Use <strong>&lt;p&gt; &lt;span    class=\"gkDropcap2\"&gt;t&lt;/span&gt;</strong> to make the first letter    larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit.    Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac.    Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta    eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper.  Donec   eget dignissim augue. Donec ante felis, aliquam ut consequat  eget,   lobortis dapibus risus. Aliquam laoreet enim et lectus ornare  hendrerit.   Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis  feugiat   dapibus, nisi massa adipiscing justo, sit amet condimentum  urna ipsum et   lacus. Nam fermentum, eros quis ullamcorper convallis,  libero mauris   lacinia eros, sed tempus leo lorem vitae purus. Nunc a  malesuada felis.   Cras ultrices sapien eu nisi elementum non blandit  urna sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<p> </p>\r\n<p class=\"gkDropcap3\"><span class=\"gkDropcap3\">T</span>his is a sample text    with Dropcap. Use <strong>&lt;p class=\"gkDropcap3\"&gt; &lt;span    class=\"gkDropcap3\"&gt;t&lt;/span&gt;</strong> to make the first letter    larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit.    Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac.    Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta    eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper.  Donec   eget dignissim augue. Donec ante felis, aliquam ut consequat  eget,   lobortis dapibus risus. Aliquam laoreet enim et lectus ornare  hendrerit.   Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis  feugiat   dapibus, nisi massa adipiscing justo, sit amet condimentum  urna ipsum et   lacus. Nam fermentum, eros quis ullamcorper convallis,  libero mauris   lacinia eros, sed tempus leo lorem vitae purus. Nunc a  malesuada felis.   Cras ultrices sapien eu nisi elementum non blandit  urna sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut..<strong>&lt;/p&gt;</strong>.</p>\r\n<h4 class=\"demo-typo\"><a name=\"blocks\">Floated blocks</a></h4>\r\n<p>Below are samples of text in which part of it is displayed in a    separate block</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextLeft\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextLeft\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextRight\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextRight\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<p> </p>\r\n<p><strong>&lt;p&gt; Here goes main part of the text &lt;span    class=\"gkBlockTextCenter\"&gt;Block of text&lt;/span&gt;rest of the    text&lt;/p&gt; </strong></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum    condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis    enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextCenter\">Lorem ipsum dolor sit amet, consectetur    adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus    ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec    eget dignissim augue. Donec ante felis, aliquam ut consequat eget,    lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit.    Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat    dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et    lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris    lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada  felis.   Cras ultrices sapien eu nisi elementum non blandit urna  sodales. Duis   accumsan cursus massa, eu facilisis diam porta ut. Morbi  cursus est vel   velit hendrerit dictum.</p>\r\n<h4 class=\"demo-typo\"><a name=\"other\">Other span blocks</a></h4>\r\n<p><span class=\"gkClear\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkClear-1\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear-1\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkClear-2\">This is a sample pin note. Use <strong>&lt;span    class=\"gkClear-2\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-1\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-1\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-2\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-2\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-3\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-3\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-4\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-4\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-5\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-5\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-6\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-6\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<p><span class=\"gkColor-7\">This is a sample pin note. Use <strong>&lt;span    class=\"gkColor-7\"&gt;</strong>Lorem ipsum dolor sit amet, consectetuer    adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum    sociis natoque penatibus et magnis dis parturient montes, nascetur    ridiculus mus. <strong>&lt;/span&gt;</strong></span></p>\r\n<h4 class=\"demo-typo\"><a name=\"blockquote\">Blockquotes</a></h4>\r\n<blockquote>This is a sample quote text. Use <strong>&lt; blockquote    &gt; Your quoted text goes here!&lt; /blockquote &gt;</strong></blockquote>\r\n<blockquote>\r\n<div class=\"gkBlockquote1\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote1\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote2\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote2\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote3\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n</blockquote>\r\n<p></p>\r\n<blockquote>\r\n<div class=\"gkBlockquote4\">\r\n<div>This is a sample quote text. Use<strong>&lt; blockquote&gt;&lt;div    class=\"gkBlockquote4\"&gt;&lt;div&gt; Your quoted text goes here!&lt;    /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</strong></div>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"tables\">Tables</a></h4>\r\n<table class=\"gkTable\" width=\"654\" height=\"94\">\r\n<thead> \r\n<tr>\r\n<td colspan=\"2\">Table Header (thead)</td>\r\n</tr>\r\n</thead><tfoot> \r\n<tr>\r\n<td colspan=\"2\">Table Footer (tfoot)</td>\r\n</tr>\r\n</tfoot> \r\n<tbody>\r\n<tr class=\"gkTableColor\">\r\n<td><strong>Column 1</strong></td>\r\n<td><strong>Column 2</strong></td>\r\n</tr>\r\n<tr>\r\n<td>Cell 3 - part of tbody</td>\r\n<td>Cell 4 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 5 - part of tbody</td>\r\n<td>Cell 6 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 7 - part of tbody</td>\r\n<td>Cell 8 - part of tbody</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p> </p>\r\n<table class=\"gkTable2\" width=\"656\" height=\"94\">\r\n<thead> \r\n<tr>\r\n<td colspan=\"2\">Table Header (thead)</td>\r\n</tr>\r\n</thead><tfoot> \r\n<tr>\r\n<td colspan=\"2\">Table Footer (tfoot)</td>\r\n</tr>\r\n</tfoot> \r\n<tbody>\r\n<tr class=\"gkTableColor\">\r\n<td><strong>Column 1</strong></td>\r\n<td><strong>Column 2</strong></td>\r\n</tr>\r\n<tr class=\"odd\">\r\n<td>Cell 1 - part of tbody</td>\r\n<td>Cell 2 - part of tbody</td>\r\n</tr>\r\n<tr>\r\n<td>Cell 3 - part of tbody</td>\r\n<td>Cell 4 - part of tbody</td>\r\n</tr>\r\n<tr class=\"odd\">\r\n<td>Cell 5 - part of tbody</td>\r\n<td>Cell 6 - part of tbody</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</blockquote>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-17 10:39:43\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:2:\"62\";s:8:\"ordering\";s:1:\"7\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:12:\"1:typography\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:62:\"index.php/template-articles/typography/7-template/1-typography\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=1\";s:5:\"route\";s:85:\"index.php?option=com_content&view=article&id=1:typography&catid=7:template&Itemid=158\";s:5:\"title\";s:10:\"Typography\";s:11:\"description\";s:30759:\"Warnings Headers Icon set 1 Icon set 2 Icon set 3 Tooltips Highlights Code Unordered lists Ordered lists Abbrs and acronyms Definition lists Legends Dropcaps Floated blocks Other span blocks Blockquotes Tables Warnings This is a sample info message. Use <p class=\"gkInfo1\">Your info message goes here!</p> . This is a sample tips message. Use <p class=\"gkTips1\">Your tips goes here!</p> . This is a sample warning message. Use <p class=\"gkWarning1\">Your warning message goes here!</p> . This is a sample info message. Use <p class=\"gkInfo2\">Your info message goes here!</p> . This is a sample tips message. Use <p class=\"gkTips2\">Your tips goes here!</p> . This is a sample warning message. Use <p class=\"gkWarning2\">Your warning message goes here!</p> . This is a sample info message. Use <p class=\"gkInfo3\">Your info message goes here!</p> . This is a sample tips message. Use <p class=\"gkTips3\">Your tips goeshere!</p> . This is a sample warning message. Use <p class=\"gkWarning3\">Your warning message goes here!</p> . This is a sample info message. Use <p class=\"gkInfo4\">Your info message goes here!</p> . This is a sample tips message. Use <p class=\"gkTips4\">Your tips goes here!</p> . This is a sample warning message. Use <p class=\"gkWarning4\">Your warning message goes here!</p> . This is a sample info message. Use <p class=\"gkInfo5\">Your info message goes here!</p> . This is a sample tips message. Use <p class=\"gkTips5\">Your tips goes here!</p> . This is a sample warning message. Use <p class=\"gkWarning5\">Your warning message goes here!</p> . Headers This is heading 1 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer semper egestas nunc in volutpat. Fusce adipiscing velit ac eros tempor iaculis. Phasellus venenatis mollis augue, non posuere odio placerat in. Etiam volutpat ultrices lectus. Fusce eu felis erat. Donec congue interdum elit, sed ornare magna convallis lacinia. In hac habitasse platea dictumst. Mauris volutpat consectetur accumsan. This is heading 2 Cras diam justo, sodales quis lobortis sed, lobortis vel mauris. Sed a mollis nunc. Quisque semper condimentum lectus, eget laoreet ipsum auctor et. Quisque sagittis luctus augue, id fringilla enim euismod quis. Nullam blandit, elit at euismod rutrum, tortor nibh posuere mauris, in volutpat diam ante ac dui. Sed velit massa, imperdiet placerat tristique et, consectetur a lorem. Praesent aliquet turpis in quamtempor eu pulvinar nibh luctus. This is heading 3 Vivamus rhoncus arcu sit amet est tristique convallis nec vel eros. Vestibulum euismod luctus velit quis porta. Aliquam varius placerat mauris sed vehicula. Integer porta facilisis sapien, in tempus lorem mattis molestie. Suspendisse potenti. Praesent quis diam non dolor convallis mattis eu id nulla. This is heading 4 Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec est risus, facilisis dignissim placerat nec, euismod lacinia nisi. Nam ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim urna, ultricies ac mollis pretium, imperdiet hendrerit massa. Sed eleifend felis sed tellus cursus lacinia. Aenean venenatis aliquet euismod. Nam quis turpis tellus, vitae malesuada neque. This is a headline. This is a subheadline. Use <p class=\"gkHeadling\">for headline</p> .Use <p class=\"gkSubHeadline\">for subheadline</p> .Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec est risus, facilisis dignissim placerat nec, euismod lacinia nisi. Nam ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim urna, ultricies ac mollis pretium, imperdiet hendrerit massa. Sed eleifend felis sed tellus cursus lacinia. Aenean venenatis aliquet euismod. Nam quis turpis tellus, vitae malesuada neque. This is a small headline This is a large headline Use <p class=\"gkHeadling\">for headline</p> .Use <p class=\"gkSubHeadline\">for subheadline</p> .Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec est risus, facilisis dignissim placerat nec, euismod lacinia nisi. Nam ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim urna, ultricies ac mollis pretium, imperdiet hendreritmassa. Sed eleifend felis sed tellus cursus lacinia. Aenean venenatis aliquet euismod. Nam quis turpis tellus, vitae malesuada neque. Icon set 1 This is a sample audio message. Use <p class=\"gkAudio\">Your audio message goes here!</p> . This is a sample webcam message. Use <p class=\"gkWebcam\">Your webcam goes here!</p> . This is a sample email message. Use <p class=\"gkEmail\">Your email message goes here!</p> . This is a sample creditcard message. Use <p class=\"gkCreditcard\">Your creditcart message goes here!</p> . This is a sample feed message. Use <p class=\"gkFeed\">Your feed goes here!</p> . This is a sample help message. Use <p class=\"gkHelp\">Your help message goes here!</p> . This is a sample images message. Use <p class=\"gkImages\">Your images message goes here!</p> . This is a sample lock message. Use <p class=\"gkLock\">Your webcam goes here!</p> . This is a sample printer message. Use <p class=\"gkPrinter\">Your printer message goes here!</p> . This is a sample report message. Use <p class=\"gkReport\">Your report message goes here!</p> . This is a sample script message. Use <p class=\"gkScript\">Your script goes here!</p> . This is a sample time message. Use <p class=\"gkTime\">Your time message goes here!</p> . This is a sample user message. Use <p class=\"gkUser\">Youruser message goes here!</p> . This is a sample world message. Use <p class=\"gkWorld\">Your world goes here!</p> . This is a sample cart message. Use <p class=\"gkCart\">Your cart message goes here!</p> . This is a sample cd message. Use <p class=\"gkCd\">Your cd message goes here!</p> . This is a sample chart_bar message. Use <p class=\"gkChartBar\">Your chart_bar goes here!</p> . This is a sample chart_line message. Use <p class=\"gkChartLine\">Your chart_line message goes here!</p> . This is a sample chart_pie message. Use <p class=\"gkChartPie\">Your chart_pie message goes here!</p> . This is a sample clock message. Use <p class=\"gkClock\">Your clock goes here!</p> . This is a sample cog message. Use <p class=\"gkCog\">Your cog message goes here!</p> . This is a sample coins message. Use <p class=\"gkCoins\">Your coins message goes here!</p> . This is a sample compress message. Use <p class=\"gkCompress\">Your compress goes here!</p> . This is a sample computer message. Use <p class=\"gkComputer\">Your computer message goes here!</p> . This is a sample cross message. Use <p class=\"gkCross\">Your cross message goes here!</p> . This is a sample disk message. Use <p class=\"gkDisk\">Your disk goes here!</p> . This is a sample error message. Use <p class=\"gkError\">Yourerror message goes here!</p> . This is a sample exclamation message. Use <p class=\"gkExclamation\">Your exclamation message goes here!</p> . This is a sample film message. Use <p class=\"gkFilm\">Your film goes here!</p> . This is a sample folder message. Use <p class=\"gkFolder\">Your folder message goes here!</p> . This is a sample group message. Use <p class=\"gkGroup\">Your group message goes here!</p> . This is a sample heart message. Use <p class=\"gkHeart\">Your heart goes here!</p> . This is a sample house message. Use <p class=\"gkHouse\">Your house message goes here!</p> . This is a sample image message. Use <p class=\"gkImage\">Your image message goes here!</p> . This is a sample information message. Use <p class=\"gkInformation\">Your information message goes here!</p> . This is a sample magnifier message. Use <p class=\"gkMagnifier\">Your magnifier message goes here!</p> . This is a sample money message. Use <p class=\"gkMoney\">Your money goes here!</p> . This is a sample new message. Use <p class=\"gkNew\">Your new message goes here!</p> . This is a sample note message. Use <p class=\"gkNote\">Your note message goes here!</p> . This is a sample page message. Use <p class=\"gkPage\">Your page goes here!</p> . This is a sample page_white message. Use <pclass=\"gkPage_white\">Your page_white message goes here!</p> . This is a sample plugin message. Use <p class=\"gkPlugin\">Your plugin message goes here!</p> . This is a sample accept message. Use <p class=\"gkAccept\">Your accept goes here!</p> . This is a sample add message. Use <p class=\"gkAdd\">Your add message goes here!</p> . This is a sample camera message. Use <p class=\"gkCamera\">Your camera message goes here!</p> . This is a sample brick message. Use <p class=\"gkBrick\">Your brick goes here!</p> . This is a sample box message. Use <p class=\"gkBox\">Your box message goes here!</p> . This is a sample calendar message. Use <p class=\"gkCalendar\">Your calendar message goes here!</p> . Icon set 2 This is a sample audio message. Use <p class=\"gkAudioIs2\">Your audio message goes here!</p> . This is a sample email message. Use <p class=\"gkEmailIs2\">Your email message goes here!</p> . This is a sample feed message. Use <p class=\"gkFeedIs2\">Your feed message goes here!</p> . This is a sample images message. Use <p class=\"gkImagesIs2\">Your images message goes here!</p> . This is a sample lock message. Use <p class=\"gkLockIs2\">Your lock message goes here!</p> . This is a sample printer message. Use <p class=\"gkPrinterIs2\">Your printer message goeshere!</p> . This is a sample time message. Use <p class=\"gkTimeIs2\">Your time message goes here!</p> . This is a sample user message. Use <p class=\"gkUserIs2\">Your calendar message goes here!</p> . This is a sample world message. Use <p class=\"gkWorldIs2\">Your world message goes here!</p> . YThis is a sample cart message. Use <p class=\"gkCartIs2\">Your cart message goes here!</p> . This is a sample cd message. Use <p class=\"gkCdIs2\">Your cd message goes here!</p> . This is a sample chart line message. Use <p class=\"gkChartLineIs2\">Your chart line message goes here!</p> . This is a sample chart pie message. Use <p class=\"gkChartPieIs2\">Your calendar message goes here!</p> . This is a sample clock message. Use <p class=\"gkClockIs2\">Your clock message goes here!</p> . This is a sample config message. Use <p class=\"gkCogIs2\">Your config message goes here!</p> . This is a sample computer message. Use <p class=\"gkComputerIs2\">Your computer message goes here!</p> . This is a sample error message. Use <p class=\"gkErrorIs2\">Your error message goes here!</p> . This is a sample exclamation message. Use <p class=\"gkExclamationIs2\">Your exclamation message goes here!</p> . This is a sample movie message. Use <p class=\"gkFilmIs2\">Your movie message goeshere!</p> . This is a sample folder message. Use <p class=\"gkFolderIs2\">Your folder message goes here!</p> . This is a group calendar message. Use <p class=\"gkGroupIs2\">Your group message goes here!</p> . This is a sample house message. Use <p class=\"gkHouseIs2\">Your house message goes here!</p> . This is a sample image message. Use <p class=\"gkImageIs2\">Your image message goes here!</p> . This is a sample information message. Use <p class=\"gkInfromationIs2\">Your information message goes here!</p> . This is a sample magnifier message. Use <p class=\"gkMagnifierIs2\">Your magnifier message goes here!</p> . This is a sample money message. Use <p class=\"gkMoneyIs2\">Your money message goes here!</p> . This is a sample page message. Use <p class=\"gkPageIs2\">Your page message goes here!</p> . This is a sample camera message. Use <p class=\"gkCameraIs2\">Your camera message goes here!</p> . This is a calendar feed message. Use <p class=\"gkCalendarIs2\">Your calendar message goes here!</p> . This is a sample contact message. Use <p class=\"gkContactIs2\">Your contact message goes here!</p> . This is a sample facebook message. Use <p class=\"gkFacebookIs2\">Your facebook message goes here!</p> . This is a sample like it message. Use <p class=\"gkLikeItIs2\">Your like itmessage goes here!</p> . This is a sample twitter message. Use <p class=\"gkTwitterIs2\">Your twitter message goes here!</p> . This is a sample video message. Use <p class=\"gkVideoIs2\">Your video message goes here!</p> . This is a sample youtube message. Use <p class=\"gkYoutubeIs2\">Your youtube message goes here!</p> . Icon set 3 This is a sample audio message. Use <p class=\"gkAudioIs3\">Your audio message goes here!</p> . This is a sample camera message. Use <p class=\"gkCameraIs3\">Your camera message goes here!</p> . This is a sample lock message. Use <p class=\"gkLockIs3\">Your lock message goes here!</p> . This is a sample user message. Use <p class=\"gkUserIs3\">Your user message goes here!</p> . This is a sample cart message. Use <p class=\"gkCartIs3\">Your cart message goes here!</p> . This is a sample chart bar message. Use <p class=\"gkChartBarIs3\">Your chart bar message goes here!</p> . This is a sample config message. Use <p class=\"gkConfigIs3\">Your config message goes here!</p> . This is a sample configuration message. Use <p class=\"gkConfig2Is3\">Your configuration message goes here!</p> . This is a sample computer message. Use <p class=\"gkComputerIs3\">Your computer message goes here!</p> . This is a sample coffe message. Use<p class=\"gkCoffeIs3\">Your coffe message goes here!</p> . This is a sample cross message. Use <p class=\"gkCrossIs3\">Your cross message goes here!</p> . This is a sample error message. Use <p class=\"gkErrorIs3\">Your error message goes here!</p> . This is a sample house message. Use <p class=\"gkHouseIs3\">Your house message goes here!</p> . This is a sample information message. Use <p class=\"gkInformationIs3\">Your inforation message goes here!</p> . This is a sample magnifier message. Use <p class=\"gkMagnifierIs3\">Your magnifier message goes here!</p> . This is a sample page message. Use <p class=\"gkPageIs3\">Your page message goes here!</p> . This is a sample lock message. Use <p class=\"gkLockIs3\">Your lock message goes here!</p> . This is a sample camera message. Use <p class=\"gkCameraIs3\">Your camera message goes here!</p> . This is a sample star message. Use <p class=\"gkStarIs3\">Your star message goes here!</p> . This is a sample telephone message. Use <p class=\"gkTelephoneIs3\">Your telephone message goes here!</p> . Tooltips Here are some examples of a Classic This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own! , Critical Critical Thisis just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own! , Help Help This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own! , Information Information This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own! and Warning Warning This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own! CSS powered tooltip. This is just an example of what you can do so feel free to get creative and produce your own! Highlights This is a highlight phrase . Use <span class=\"gkHighlight1\">Your highlight phrase goes here!</span> . This is a highlight phrase . Use <span class=\"gkHighlight2\">Your highlight phrase goes here!</span> . This is a highlight phrase . Use <span class=\"gkHighlight3\">Your highlight phrase goes here!</span> . This is a highlight phrase . Use <span class=\"gkHighlight4\">Your highlight phrase goes here!</span> . Code Below is a sample of <pre> or <div class=\"gkCode1\"> #wrapper { position: relative; float: left; display: block; } Below is a sample of <div class=\"gkCode2\">class=\"gkCode2\"> #wrapper { position: relative; float: left; display: block; } Below is a sample of <div class=\"gkCode3\"><h4>Name of your file</h4>Here goes your code</div> File #wrapper { position: relative; float: left; display: block; } Unordered lists Types of unordered lists <ul class=\"gkBullet1\"> Element 1 Element 2 Element 3 <ul class=\"gkBullet2\"> Element 1 Element 2 Element 3 <ul class=\"gkBullet3\"> Element 1 Element 2 Element 3 <ul class=\"gkBullet4\"> Element 1 Element 2 Element 3 <ul class=\"gkCircle1\"> Element 1 Element 2 Element 3 <ul class=\"gkCircle2\"> Element 1 Element 2 Element 3 <ul class=\"gkSquare1\"> Element 1 Element 2 Element 3 <ul class=\"gkSquare2\"> Element 1 Element 2 Element 3 <ul class=\"gkSquare3\"> Element 1 Element 2 Element 3class=\"demo-typo\"> Ordered lists Types of ordered list: <ol class=\"gkRoman\"> Element Element Element Element <ol class=\"gkDec\"> Element Element Element Element <ol class=\"gkAlpha\"> Element Element Element Element <ol class=\"gkDecimalLeadingZero\"> Element Element Element Element <div class=\"gkNumber1\"><p><span>here goes a number</span>and here text of element</p> 01 Element 02 Element <div class=\"gkNumber2\"><p><span>here goes a number</span>and here text of element</p> 01 Element 02 Element Abbrs and acronyms This is a sample of an abbreviation Dr . Use <abbr title=\"Here goes full word or phrase\">here goes an abbreviation</abbr> This is a sample of an acronym NATO . Use <acronym title=\"Here goes full phrase\">here goes an acronym</abbr> Definition lists Below are samples of definition lists <dl class=\"gkDef1\"><dt>Here goes the word you\'re about todefine</dt><dd>Here goes definition</dd></dl> Butter it is a dairy product made by churning fresh or fermented cream or milk. It is generally used as a spread and a condiment, as well as in cooking applications such as baking, sauce making, and frying. Butter consists of butterfat, water and milk proteins. Dairy milk is an opaque white liquid produced by the mammary glands of mammals (including monotremes). It provides the primary source of nutrition for newborn mammals before they are able to digest other types of food. <dl class=\"gkDef2\"><dt>Here goes the word you\'re about to define</dt><dd>Here goes definition</dd></dl> Butter it is a dairy product made by churning fresh or fermented cream or milk. It is generally used as a spread and a condiment, as well as in cooking applications such as baking, sauce making, and frying. Butter consists of butterfat, water and milk proteins. Dairy milk is an opaque white liquid produced by the mammary glands of mammals (including monotremes). It provides the primary source of nutrition for newborn mammals before they are able to digest other types of food. <dl class=\"gkDef3\"><dt>Here goes the word you\'re about to define</dt><dd>Here goes definition</dd></dl> Butter it is a dairy product made by churning fresh or fermented cream or milk. It is generally used as a spread and a condiment, as well as in cooking applications such as baking, sauce making, and frying. Butter consists of butterfat, water and milk proteins. Dairy milk is an opaque white liquid produced by the mammary glands of mammals (including monotremes). It provides the primary source of nutrition for newborn mammalsbefore they are able to digest other types of food. Legends Legend This is a sample legend note. Use <div class=\"gkLegend1\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p> </div> . Legend This is a sample legend note. Use <div class=\"gkLegend2\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p> </div> . Legend This is a sample legend note. Use <div class=\"gkLegend3\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p> </div> . Legend This is a sample legend note. Use <div class=\"gkLegend4\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p> </div> . Legend This is a sample legend note. Use <div class=\"gkLegend5\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnisdis parturient montes, nascetur ridiculus mus.</p> </div> . Legend This is a sample legend note. Use <div class=\"gkLegend6\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p> </div> . Legend This is a sample legend note. Use <div class=\"gkLegend7\"> <h4> Title </h4> <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p> </div> . Dropcaps T his is a sample text with Dropcap. Use <p> <span class=\"gkDropcap1\">t</span> to make the first letter larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper. Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales. Duis accumsan cursus massa, eu facilisis diam porta ut.. </p> .class=\"gkDropcap2\"> T his is a sample text with Dropcap. Use <p> <span class=\"gkDropcap2\">t</span> to make the first letter larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper. Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales. Duis accumsan cursus massa, eu facilisis diam porta ut.. </p> . T his is a sample text with Dropcap. Use <p class=\"gkDropcap3\"> <span class=\"gkDropcap3\">t</span> to make the first letter larger. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend. Vivamus ullamcorper est id libero aliquam ullamcorper. Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Crasultrices sapien eu nisi elementum non blandit urna sodales. Duis accumsan cursus massa, eu facilisis diam porta ut.. </p> . Floated blocks Below are samples of text in which part of it is displayed in a separate block <p> Here goes main part of the text <span class=\"gkBlockTextLeft\">Block of text</span>rest of the text</p> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales. Duis accumsan cursus massa, eu facilisis diam porta ut. Morbi cursus est vel velit hendrerit dictum. <p> Here goes main part of the text <span class=\"gkBlockTextRight\">Block of text</span>rest of the text</p> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentumpulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales. Duis accumsan cursus massa, eu facilisis diam porta ut. Morbi cursus est vel velit hendrerit dictum. <p> Here goes main part of the text <span class=\"gkBlockTextCenter\">Block of text</span>rest of the text</p> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales. Duis accumsan cursus massa, eu facilisis diam porta ut. Morbi cursus est vel velit hendrerit dictum. Other span blocks This isa sample pin note. Use <span class=\"gkClear\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkClear-1\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkClear-2\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor-1\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor-2\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</span> This is a sample pin note. Use <span class=\"gkColor-3\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor-4\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor-5\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor-6\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> This is a sample pin note. Use <span class=\"gkColor-7\"> Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Integer urna. Aenean tristique. Fusce a neque. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. </span> Blockquotes This is a sample quote text. Use < blockquote > Your quoted text goes here!< /blockquote >class=\"gkBlockquote1\"> This is a sample quote text. Use < blockquote><div class=\"gkBlockquote1\"><div> Your quoted text goes here!< /div>< /div>< /blockquote > This is a sample quote text. Use < blockquote><div class=\"gkBlockquote2\"><div> Your quoted text goes here!< /div>< /div>< /blockquote > This is a sample quote text. Use < blockquote><div class=\"gkBlockquote3\"><div> Your quoted text goes here!< /div>< /div>< /blockquote > This is a sample quote text. Use < blockquote><div class=\"gkBlockquote4\"><div> Your quoted text goes here!< /div>< /div>< /blockquote > Tables Table Header (thead) Table Footer (tfoot) Column 1 Column 2 Cell 3 - part of tbody Cell 4 - part of tbody Cell 5 - part of tbody Cell 6 - part of tbody Cell 7 - part of tbody Cell 8 - part of tbody Table Header (thead) Table Footer (tfoot) Column 1 Column 2class=\"odd\"> Cell 1 - part of tbody Cell 2 - part of tbody Cell 3 - part of tbody Cell 4 - part of tbody Cell 5 - part of tbody Cell 6 - part of tbody\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-11 22:34:23\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-11 22:34:23\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(23,'index.php?option=com_content&view=article&id=2','index.php?option=com_content&view=article&id=2:module-positions&catid=7:template&Itemid=107','Module positions','','2012-01-15 22:33:02','a880177d2890dda783f8f152aff29048',1,1,1,'*','2011-01-12 16:57:05','0000-00-00 00:00:00','2011-01-12 16:57:05','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"2\";s:5:\"alias\";s:16:\"module-positions\";s:7:\"summary\";s:158:\"<p><img src=\"images/demo/module_positions.png\" border=\"0\" style=\"display: block; margin-left: auto; margin-right: auto; border: 0px none currentColor;\" /></p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-17 15:05:55\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"3\";s:8:\"ordering\";s:1:\"6\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:18:\"2:module-positions\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:77:\"index.php/template/lorem-ipsum/module-positions/7-template/2-module-positions\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=2\";s:5:\"route\";s:91:\"index.php?option=com_content&view=article&id=2:module-positions&catid=7:template&Itemid=107\";s:5:\"title\";s:16:\"Module positions\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 16:57:05\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 16:57:05\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(24,'index.php?option=com_content&view=article&id=3','index.php?option=com_content&view=article&id=3:messages&catid=7:template&Itemid=161','Messages','Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows: Error This is a sample message Error This is a sample warning message Error This is a sample error m','2012-01-15 22:33:02','08bdc3c9174cfae52e9705fe08a3f0b3',1,1,1,'*','2011-01-12 17:08:51','0000-00-00 00:00:00','2011-01-12 17:08:51','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"3\";s:5:\"alias\";s:8:\"messages\";s:7:\"summary\";s:651:\"<p>Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows:</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"message message fade\"> \r\n<ul>\r\n<li>This is a sample message</li>\r\n</ul>\r\n</dd></dl> \r\n</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"notice message fade\"> \r\n<ul>\r\n<li>This is a sample warning message</li>\r\n</ul>\r\n</dd></dl> \r\n</p>\r\n<p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"error message fade\"> \r\n<ul>\r\n<li>This is a sample error message</li>\r\n</ul>\r\n</dd></dl>\r\n</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-20 10:10:47\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"3\";s:8:\"ordering\";s:1:\"5\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:10:\"3:messages\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:58:\"index.php/template-articles/messages/7-template/3-messages\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=3\";s:5:\"route\";s:83:\"index.php?option=com_content&view=article&id=3:messages&catid=7:template&Itemid=161\";s:5:\"title\";s:8:\"Messages\";s:11:\"description\";s:261:\"Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows: Error This is a sample message Error This is a sample warning message Error This is a sample error message\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 17:08:51\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 17:08:51\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(25,'index.php?option=com_content&view=article&id=4','index.php?option=com_content&view=article&id=4:chrome-frame&catid=7:template&Itemid=192','Chrome frame','Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit','2012-01-15 23:40:43','8571ae6aedc8a65d48df1f675c9abdbc',1,1,1,'*','2011-01-12 17:12:21','0000-00-00 00:00:00','2011-01-12 17:12:21','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:24:{s:2:\"id\";s:1:\"4\";s:5:\"alias\";s:12:\"chrome-frame\";s:7:\"summary\";s:1314:\"<p>Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page.</p>\r\n<p>In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine.</p>\r\n<p>To get know more about Google Chrome Frame, please visit:</p>\r\n<p><a href=\"http://code.google.com/intl/en-GB/chrome/chromeframe/\">http://code.google.com/intl/en-GB/chrome/chromeframe/</a> - the official Project’s web side containing the link to the plug-in.</p>\r\n<p><a href=\"http://www.chromium.org/developers/how-tos/chrome-frame-getting-started\">http://www.chromium.org/developers/how-tos/chrome-frame-getting-started</a> - more info about Google Chrome Frame for developers.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2012-01-15 22:40:43\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":66:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:23:\"show_publishing_options\";s:1:\"1\";s:20:\"show_article_options\";s:1:\"1\";s:25:\"show_urls_images_frontend\";s:1:\"1\";s:24:\"show_urls_images_backend\";s:1:\"1\";s:7:\"targeta\";i:0;s:7:\"targetb\";i:0;s:7:\"targetc\";i:0;s:11:\"float_intro\";s:5:\"right\";s:14:\"float_fulltext\";s:5:\"right\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"4\";s:8:\"ordering\";s:1:\"5\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:14:\"4:chrome-frame\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:67:\"index.php/joomla-pages-iii/single-article/7-template/4-chrome-frame\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=4\";s:5:\"route\";s:87:\"index.php?option=com_content&view=article&id=4:chrome-frame&catid=7:template&Itemid=192\";s:5:\"title\";s:12:\"Chrome frame\";s:11:\"description\";s:1121:\"Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page. In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine. To get know more about Google Chrome Frame, please visit: http://code.google.com/intl/en-GB/chrome/chromeframe/ - the official Project’s web side containing the link to the plug-in. http://www.chromium.org/developers/how-tos/chrome-frame-getting-started - more info about Google Chrome Frame for developers.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 17:12:21\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 17:12:21\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(26,'index.php?option=com_content&view=article&id=5','index.php?option=com_content&view=article&id=5:menu-types&catid=8:menu-types&Itemid=110','Menu types','Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in whic','2012-01-15 22:33:02','8266ee67f34348db65b827489cab80cb',1,1,1,'*','2011-01-12 17:58:21','0000-00-00 00:00:00','2011-01-12 17:58:21','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"5\";s:5:\"alias\";s:10:\"menu-types\";s:7:\"summary\";s:379:\"<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"8\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-12 18:16:21\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"2\";s:8:\"category\";s:10:\"Menu types\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:12:\"5:menu-types\";s:7:\"catslug\";s:12:\"8:menu-types\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:46:\"index.php/menu-types/8-menu-types/5-menu-types\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:10:\"Menu types\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Menu types\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=5\";s:5:\"route\";s:87:\"index.php?option=com_content&view=article&id=5:menu-types&catid=8:menu-types&Itemid=110\";s:5:\"title\";s:10:\"Menu types\";s:11:\"description\";s:321:\"Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 17:58:21\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 17:58:21\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(27,'index.php?option=com_content&view=article&id=6','index.php?option=com_content&view=article&id=6:right-column&catid=9:layouts&Itemid=114','Right column','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:02','46001e03ca24271d706b2e0ce7b9d360',1,1,1,'*','2011-01-12 19:18:41','0000-00-00 00:00:00','2011-01-12 19:18:41','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"6\";s:5:\"alias\";s:12:\"right-column\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"8\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:14:\"6:right-column\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:79:\"index.php/template/lorem-ipsum-ii/layouts/right-column/9-layouts/6-right-column\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=6\";s:5:\"route\";s:86:\"index.php?option=com_content&view=article&id=6:right-column&catid=9:layouts&Itemid=114\";s:5:\"title\";s:12:\"Right column\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 19:18:41\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 19:18:41\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(28,'index.php?option=com_content&view=article&id=7','index.php?option=com_content&view=article&id=7:right-two-columns&catid=9:layouts&Itemid=115','Right two columns','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:02','6ebcef4de4a5c174024104a3c5c145c1',1,1,1,'*','2011-01-12 19:28:47','0000-00-00 00:00:00','2011-01-12 19:28:47','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"7\";s:5:\"alias\";s:17:\"right-two-columns\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"7\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:19:\"7:right-two-columns\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:89:\"index.php/template/lorem-ipsum-ii/layouts/right-two-columns/9-layouts/7-right-two-columns\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=7\";s:5:\"route\";s:91:\"index.php?option=com_content&view=article&id=7:right-two-columns&catid=9:layouts&Itemid=115\";s:5:\"title\";s:17:\"Right two columns\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 19:28:47\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 19:28:47\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(29,'index.php?option=com_content&view=article&id=8','index.php?option=com_content&view=article&id=8:left-column&catid=9:layouts&Itemid=116','Left column','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:02','860cc74c22836d246a1a3f8aa7e0145c',1,1,1,'*','2011-01-12 19:33:11','0000-00-00 00:00:00','2011-01-12 19:33:11','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"8\";s:5:\"alias\";s:11:\"left-column\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"6\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"8:left-column\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:77:\"index.php/template/lorem-ipsum-ii/layouts/left-column/9-layouts/8-left-column\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=8\";s:5:\"route\";s:85:\"index.php?option=com_content&view=article&id=8:left-column&catid=9:layouts&Itemid=116\";s:5:\"title\";s:11:\"Left column\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 19:33:11\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 19:33:11\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(30,'index.php?option=com_content&view=article&id=9','index.php?option=com_content&view=article&id=9:left-two-columns&catid=9:layouts&Itemid=117','Left two columns','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:03','14f13ebe063a8fb20bce1434587e05ba',1,1,1,'*','2011-01-12 19:33:11','0000-00-00 00:00:00','2011-01-12 19:33:11','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"9\";s:5:\"alias\";s:16:\"left-two-columns\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-12 20:49:37\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"5\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:18:\"9:left-two-columns\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:87:\"index.php/template/lorem-ipsum-ii/layouts/left-two-columns/9-layouts/9-left-two-columns\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:46:\"index.php?option=com_content&view=article&id=9\";s:5:\"route\";s:90:\"index.php?option=com_content&view=article&id=9:left-two-columns&catid=9:layouts&Itemid=117\";s:5:\"title\";s:16:\"Left two columns\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 19:33:11\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 19:33:11\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(31,'index.php?option=com_content&view=article&id=10','index.php?option=com_content&view=article&id=10:content-inset-left&catid=9:layouts&Itemid=118','Content inset left','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:03','9f2fe0821726d2f8fab493b94792f411',1,1,1,'*','2011-01-12 21:11:22','0000-00-00 00:00:00','2011-01-12 21:11:22','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"10\";s:5:\"alias\";s:18:\"content-inset-left\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"4\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:21:\"10:content-inset-left\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:92:\"index.php/template/lorem-ipsum-ii/layouts/content-inset-left/9-layouts/10-content-inset-left\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=10\";s:5:\"route\";s:93:\"index.php?option=com_content&view=article&id=10:content-inset-left&catid=9:layouts&Itemid=118\";s:5:\"title\";s:18:\"Content inset left\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 21:11:22\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 21:11:22\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(32,'index.php?option=com_content&view=article&id=11','index.php?option=com_content&view=article&id=11:content-inset-right&catid=9:layouts&Itemid=120','Content inset right','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:03','73e18a5b20fd0fdeaba540a39d39635d',1,1,1,'*','2011-01-12 21:12:26','0000-00-00 00:00:00','2011-01-12 21:12:26','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"11\";s:5:\"alias\";s:19:\"content-inset-right\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"3\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:22:\"11:content-inset-right\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:94:\"index.php/template/lorem-ipsum-ii/layouts/content-inset-right/9-layouts/11-content-inset-right\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=11\";s:5:\"route\";s:94:\"index.php?option=com_content&view=article&id=11:content-inset-right&catid=9:layouts&Itemid=120\";s:5:\"title\";s:19:\"Content inset right\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 21:12:26\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 21:12:26\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(33,'index.php?option=com_content&view=article&id=12','index.php?option=com_content&view=article&id=12:content-inset-both&catid=9:layouts&Itemid=119','Content inset both','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:03','b505ae33febbb0f3328eafca2ad7e69d',1,1,1,'*','2011-01-12 21:12:26','0000-00-00 00:00:00','2011-01-12 21:12:26','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"12\";s:5:\"alias\";s:18:\"content-inset-both\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"2\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:21:\"12:content-inset-both\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:92:\"index.php/template/lorem-ipsum-ii/layouts/content-inset-both/9-layouts/12-content-inset-both\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=12\";s:5:\"route\";s:93:\"index.php?option=com_content&view=article&id=12:content-inset-both&catid=9:layouts&Itemid=119\";s:5:\"title\";s:18:\"Content inset both\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 21:12:26\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 21:12:26\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(34,'index.php?option=com_content&view=article&id=13','index.php?option=com_content&view=article&id=13:content-inset--column&catid=9:layouts&Itemid=121','Content inset + column','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:03','8e2b6f45d000ef9ba5af000552b45dcb',1,1,1,'*','2011-01-12 22:01:45','0000-00-00 00:00:00','2011-01-12 22:01:45','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"13\";s:5:\"alias\";s:21:\"content-inset--column\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:24:\"13:content-inset--column\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:97:\"index.php/template/lorem-ipsum-ii/layouts/content-inset-column/9-layouts/13-content-inset--column\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=13\";s:5:\"route\";s:96:\"index.php?option=com_content&view=article&id=13:content-inset--column&catid=9:layouts&Itemid=121\";s:5:\"title\";s:22:\"Content inset + column\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 22:01:45\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 22:01:45\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(35,'index.php?option=com_content&view=article&id=14','index.php?option=com_content&view=article&id=14:content-inset--column-2x&catid=9:layouts&Itemid=122','Content inset + column (2x)','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada','2012-01-15 22:33:03','20e335e1578fa34cdd44fde0a5432973',1,1,1,'*','2011-01-12 22:03:08','0000-00-00 00:00:00','2011-01-12 22:03:08','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"14\";s:5:\"alias\";s:24:\"content-inset--column-2x\";s:7:\"summary\";s:1183:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"9\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:7:\"Layouts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:27:\"14:content-inset--column-2x\";s:7:\"catslug\";s:9:\"9:layouts\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:103:\"index.php/template/lorem-ipsum-ii/layouts/content-inset-column-2x/9-layouts/14-content-inset--column-2x\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:7:\"Layouts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Layouts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=14\";s:5:\"route\";s:99:\"index.php?option=com_content&view=article&id=14:content-inset--column-2x&catid=9:layouts&Itemid=122\";s:5:\"title\";s:27:\"Content inset + column (2x)\";s:11:\"description\";s:1176:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis sit amet lacus sit amet odio vulputate lobortis. Etiam lorem libero, fermentum a facilisis id, blandit vel urna. Quisque tempor cursus libero aliquam blandit. In at sapien neque, quis malesuada ligula. Phasellus fringilla aliquam nunc ut volutpat. In in nibh lacus. Sed tempus dui nec velit hendrerit tempus. Nunc scelerisque ante nec magna blandit interdum. Maecenas lectus nunc, gravida volutpat adipiscing placerat, commodo quis purus. Morbi ligula quam, aliquet ac euismod ut, iaculis in orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec malesuada ligula eget urna luctus eu tempor odio consequat. Etiam eget enim sit amet nunc commodo tempus. Donec eget massa ut ligula mattis pharetra a nec felis. Suspendisse tortor libero, venenatis in elementum a, tincidunt in turpis. Curabitur ut nisl sed mauris vestibulum vestibulum ultricies et purus. Nam porttitor libero et justo placerat vitae sodales ligula egestas. Vestibulum leo ligula, volutpat et ultricies nec, tempus a enim. Cras quis tellus et nibh molestie pretium vel sit amet lacus. Sed sed diam neque.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 22:03:08\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 22:03:08\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(36,'index.php?option=com_content&view=article&id=15','index.php?option=com_content&view=article&id=15:split-menu&catid=8:menu-types&Itemid=112','Split menu','Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in whic','2012-01-15 22:33:03','d3fd778e4f4a739cf25ced17790c26db',1,1,1,'*','2011-01-13 00:12:59','0000-00-00 00:00:00','2011-01-13 00:12:59','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"15\";s:5:\"alias\";s:10:\"split-menu\";s:7:\"summary\";s:379:\"<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"8\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 00:14:18\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"3\";s:8:\"ordering\";s:1:\"3\";s:8:\"category\";s:10:\"Menu types\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"15:split-menu\";s:7:\"catslug\";s:12:\"8:menu-types\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:58:\"index.php/menu-types/split-menu/8-menu-types/15-split-menu\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:10:\"Menu types\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Menu types\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=15\";s:5:\"route\";s:88:\"index.php?option=com_content&view=article&id=15:split-menu&catid=8:menu-types&Itemid=112\";s:5:\"title\";s:10:\"Split menu\";s:11:\"description\";s:321:\"Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-13 00:12:59\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 00:12:59\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(37,'index.php?option=com_content&view=article&id=16','index.php?option=com_content&view=article&id=16:dropline-menu&catid=8:menu-types&Itemid=111','Dropline menu','Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in whic','2012-01-15 22:33:04','2bcbe87d5709553afbbef597dfffa40a',1,1,1,'*','2011-01-12 17:58:21','0000-00-00 00:00:00','2011-01-12 17:58:21','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"16\";s:5:\"alias\";s:13:\"dropline-menu\";s:7:\"summary\";s:379:\"<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"8\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-12 18:16:21\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:10:\"Menu types\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:16:\"16:dropline-menu\";s:7:\"catslug\";s:12:\"8:menu-types\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:64:\"index.php/menu-types/dropline-menu/8-menu-types/16-dropline-menu\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:10:\"Menu types\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Menu types\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=16\";s:5:\"route\";s:91:\"index.php?option=com_content&view=article&id=16:dropline-menu&catid=8:menu-types&Itemid=111\";s:5:\"title\";s:13:\"Dropline menu\";s:11:\"description\";s:321:\"Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 17:58:21\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 17:58:21\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(38,'index.php?option=com_content&view=article&id=17','index.php?option=com_content&view=article&id=17:gk-menu&catid=8:menu-types&Itemid=126','GK Menu','Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in whic','2012-01-15 22:33:04','3f5283ac26289630007d54c272fb5fad',1,1,1,'*','2011-01-13 00:12:59','0000-00-00 00:00:00','2011-01-13 00:12:59','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"17\";s:5:\"alias\";s:7:\"gk-menu\";s:7:\"summary\";s:379:\"<p>Our template supports three menu types:</p>\r\n<ul>\r\n<li>GK menu</li>\r\n<li>Dropline menu</li>\r\n<li>Split menu</li>\r\n</ul>\r\n<p>Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"8\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 00:14:18\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:10:\"Menu types\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:10:\"17:gk-menu\";s:7:\"catslug\";s:12:\"8:menu-types\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:52:\"index.php/menu-types/gk-menu/8-menu-types/17-gk-menu\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:10:\"Menu types\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Menu types\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=17\";s:5:\"route\";s:85:\"index.php?option=com_content&view=article&id=17:gk-menu&catid=8:menu-types&Itemid=126\";s:5:\"title\";s:7:\"GK Menu\";s:11:\"description\";s:321:\"Our template supports three menu types: GK menu Dropline menu Split menu Each of these menus has different characteristic. It is important to know that in order to gain an additional functionality offered by \"GK menu\", a user has to install a plug-in which can be found in the rest-files package of a particular template.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-13 00:12:59\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 00:12:59\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(39,'index.php?option=com_content&view=article&id=18','index.php?option=com_content&view=article&id=18:module-variation&catid=7:template&Itemid=153','Module variation','On this page you can see basic suffixes used in this template. Please remember about using space at beginning of suffix name in module options. Vestibulum id ligula porta felis euismod semper. Curabitur blandit tempus porttitor. Etiam porta sem malesuada ','2012-01-15 22:33:04','2c173bb4f9b6bfc61d5d315106bf4d73',1,1,1,'*','2011-01-13 12:30:01','0000-00-00 00:00:00','2011-01-13 12:30:01','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"18\";s:5:\"alias\";s:16:\"module-variation\";s:7:\"summary\";s:1185:\"<p>On this page you can see basic suffixes used in this template. Please remember about using space at beginning of suffix name in module options.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Curabitur blandit tempus porttitor. Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. <br /><br />Donec id elit non mi porta gravida at eget metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas sed diam eget risus varius blandit sit amet non magna. <br /><br />Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Donec id elit non mi porta gravida at eget metus. Donec ullamcorper nulla non metus auctor fringilla. Aenean lacinia bibendum nulla sed consectetur. <br /><br />Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. <br /><br />Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-17 12:01:33\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"3\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:19:\"18:module-variation\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:49:\"index.php/features/7-template/18-module-variation\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=18\";s:5:\"route\";s:92:\"index.php?option=com_content&view=article&id=18:module-variation&catid=7:template&Itemid=153\";s:5:\"title\";s:16:\"Module variation\";s:11:\"description\";s:1122:\"On this page you can see basic suffixes used in this template. Please remember about using space at beginning of suffix name in module options. Vestibulum id ligula porta felis euismod semper. Curabitur blandit tempus porttitor. Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas sed diam eget risus varius blandit sit amet non magna. Morbi leo risus, porta ac consectetur ac, vestibulum at eros. Donec id elit non mi porta gravida at eget metus. Donec ullamcorper nulla non metus auctor fringilla. Aenean lacinia bibendum nulla sed consectetur. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-13 12:30:01\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 12:30:01\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(40,'index.php?option=com_content&view=article&id=19','index.php?option=com_content&view=article&id=19:archive-article-i&catid=2:uncategorised','Archive article I','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tort','2012-01-15 22:33:04','1efa80078f0be4de70294ffcb72a151d',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 16:01:40','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"19\";s:5:\"alias\";s:17:\"archive-article-i\";s:7:\"summary\";s:1924:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"3\";s:8:\"category\";s:13:\"Uncategorised\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:20:\"19:archive-article-i\";s:7:\"catslug\";s:15:\"2:uncategorised\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:72:\"index.php/component/content/article/2-uncategorised/19-archive-article-i\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Uncategorised\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Uncategorised\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=19\";s:5:\"route\";s:87:\"index.php?option=com_content&view=article&id=19:archive-article-i&catid=2:uncategorised\";s:5:\"title\";s:17:\"Archive article I\";s:11:\"description\";s:1905:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 16:01:40\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(41,'index.php?option=com_content&view=article&id=20','index.php?option=com_content&view=article&id=20:archive-article-ii&catid=2:uncategorised','Archive article II','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tort','2012-01-15 22:33:04','8038435abe55cfa830127d4a719f3ca3',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 16:01:40','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"20\";s:5:\"alias\";s:18:\"archive-article-ii\";s:7:\"summary\";s:1924:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"2\";s:8:\"category\";s:13:\"Uncategorised\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:21:\"20:archive-article-ii\";s:7:\"catslug\";s:15:\"2:uncategorised\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:73:\"index.php/component/content/article/2-uncategorised/20-archive-article-ii\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Uncategorised\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Uncategorised\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=20\";s:5:\"route\";s:88:\"index.php?option=com_content&view=article&id=20:archive-article-ii&catid=2:uncategorised\";s:5:\"title\";s:18:\"Archive article II\";s:11:\"description\";s:1905:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 16:01:40\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(42,'index.php?option=com_content&view=article&id=21','index.php?option=com_content&view=article&id=21:archive-article-iii&catid=2:uncategorised','Archive article III','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tort','2012-01-15 22:33:04','d716618cc1e1af5c55177126d73f265d',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 16:01:40','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"21\";s:5:\"alias\";s:19:\"archive-article-iii\";s:7:\"summary\";s:1924:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:13:\"Uncategorised\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:22:\"21:archive-article-iii\";s:7:\"catslug\";s:15:\"2:uncategorised\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:74:\"index.php/component/content/article/2-uncategorised/21-archive-article-iii\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Uncategorised\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Uncategorised\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=21\";s:5:\"route\";s:89:\"index.php?option=com_content&view=article&id=21:archive-article-iii&catid=2:uncategorised\";s:5:\"title\";s:19:\"Archive article III\";s:11:\"description\";s:1905:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 16:01:40\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(43,'index.php?option=com_content&view=article&id=23','index.php?option=com_content&view=article&id=23:ie-6-style&catid=7:template&Itemid=198','IE 6 style','Internet Explorer 6 is on the way out, but there is still a significant number of users that are stuck to this browser. According to this, we decided that our templates are going to support IE 6 slightly. By dint of the \"IE6 Bar\" plug-in, available in tem','2012-01-15 22:33:05','b6f93c22c0b6df481d6a5600305bc655',1,1,1,'*','2011-01-17 14:47:32','0000-00-00 00:00:00','2011-01-17 14:47:32','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"23\";s:5:\"alias\";s:10:\"ie-6-style\";s:7:\"summary\";s:727:\"<p>Internet Explorer 6 is on the way out, but there is still a significant number of users that are stuck to this browser. According to this, we decided that our templates are going to support IE 6 slightly. By dint of the \"IE6 Bar\" plug-in, available in templates menu options, users can apply the upper bar in their IE browser to keep them informed that Internet Explorer can not display the Web site properly. Additionally, instead of the whole range of template styles, we created one style- Universal Internet Explorer 6 CSS - project\'s website. Thanks to this, users will have the full access to the web’s content, but on the other hand, a web site’s appearance and functioning might be more rough to some extend.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"2\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"23:ie-6-style\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:84:\"index.php/template/lorem-ipsum/template-articles/ie-6-style/7-template/23-ie-6-style\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=23\";s:5:\"route\";s:86:\"index.php?option=com_content&view=article&id=23:ie-6-style&catid=7:template&Itemid=198\";s:5:\"title\";s:10:\"IE 6 style\";s:11:\"description\";s:720:\"Internet Explorer 6 is on the way out, but there is still a significant number of users that are stuck to this browser. According to this, we decided that our templates are going to support IE 6 slightly. By dint of the \"IE6 Bar\" plug-in, available in templates menu options, users can apply the upper bar in their IE browser to keep them informed that Internet Explorer can not display the Web site properly. Additionally, instead of the whole range of template styles, we created one style- Universal Internet Explorer 6 CSS - project\'s website. Thanks to this, users will have the full access to the web’s content, but on the other hand, a web site’s appearance and functioning might be more rough to some extend.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-17 14:47:32\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-17 14:47:32\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(44,'index.php?option=com_content&view=article&id=24','index.php?option=com_content&view=article&id=24:lorem-ipsum&catid=7:template&Itemid=147','Lorem ipsum','Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Don','2012-01-15 22:33:05','fc9a9686f68f2c73175c42253870a2f5',1,1,1,'*','2011-01-17 17:16:48','0000-00-00 00:00:00','2011-01-17 17:16:48','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"24\";s:5:\"alias\";s:11:\"lorem-ipsum\";s:7:\"summary\";s:1654:\"<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo.</p>\r\n<p>Donec ullamcorper nulla non metus auctor fringilla. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas faucibus mollis interdum.</p>\r\n<p>Sed posuere consectetur est at lobortis. Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Nulla vitae elit libero, a pharetra augue. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Donec sed odio dui. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<p>Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla. Maecenas sed diam eget risus varius blandit sit amet non magna. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum id ligula porta felis euismod semper.</p>\r\n<p>Curabitur blandit tempus porttitor. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-09-23 19:44:30\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"5\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:14:\"24:lorem-ipsum\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:91:\"index.php/template/lorem-ipsum-ii/joomla-pages-iii/single-article/7-template/24-lorem-ipsum\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=24\";s:5:\"route\";s:87:\"index.php?option=com_content&view=article&id=24:lorem-ipsum&catid=7:template&Itemid=147\";s:5:\"title\";s:11:\"Lorem ipsum\";s:11:\"description\";s:1607:\"Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas faucibus mollis interdum. Sed posuere consectetur est at lobortis. Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Nulla vitae elit libero, a pharetra augue. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Donec sed odio dui. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Donec ullamcorper nulla non metus auctor fringilla. Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla. Maecenas sed diam eget risus varius blandit sit amet non magna. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum id ligula porta felis euismod semper. Curabitur blandit tempus porttitor. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-17 17:16:48\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-17 17:16:48\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(45,'index.php?option=com_content&view=article&id=25','index.php?option=com_content&view=article&id=25:welcome-to-joomla&catid=16:latest','Welcome to Joomla!','Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. Joomla! provides an easy-to-use graphical','2012-01-15 22:33:06','12510f2c5f878d5b5ac0f66f40fee2e3',1,1,1,'*','2011-07-20 08:49:51','0000-00-00 00:00:00','2011-07-20 08:49:51','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"25\";s:5:\"alias\";s:17:\"welcome-to-joomla\";s:7:\"summary\";s:800:\"<div><strong>Joomla! is a free open source framework and content publishing  system designed for quickly creating highly interactive multi-language  Web sites, online communities, media portals, blogs and eCommerce  applications. <br /></strong></div>\r\n<p><strong><br /></strong><img class=\"caption\" src=\"http://localhost/financial/images/stories/powered_by.png\" border=\"0\" alt=\"Joomla! Logo\" title=\"Example Caption\" hspace=\"6\" vspace=\"0\" width=\"165\" height=\"68\" align=\"left\" />Joomla!  provides an easy-to-use graphical user interface that simplifies the  management and publishing of large volumes of content including HTML,  documents, and rich media.  Joomla! is used by organisations of all  sizes for intranets and extranets and is supported by a community of  tens of thousands of users.</p>\r\n\";s:4:\"body\";s:1042:\"\r\n<p>With a fully documented library of developer resources, Joomla!  allows the customisation of every aspect of a Web site including  presentation, layout, administration, and the rapid integration with  third-party applications.</p>\r\n<p>Joomla! now provides more developer power while making the user  experience all the more friendly. For those who always wanted increased  extensibility, Joomla! 1.5 can make this happen.</p>\r\n<p>A new framework, ground-up refactoring, and a highly-active  development team brings the excitement of \'the next generation CMS\' to  your fingertips.  Whether you are a systems architect or a complete  \'noob\' Joomla! can take you to the next level of content delivery. \'More  than a CMS\' is something we have been playing with as a catchcry  because the new Joomla! API has such incredible power and flexibility,  you are free to take whatever direction your creative mind takes you and  Joomla! can help you get there so much more easily than ever before.</p>\r\n<p>Thinking Web publishing? Think Joomla!</p>\";s:5:\"catid\";s:2:\"16\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:6:\"Latest\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:20:\"25:welcome-to-joomla\";s:7:\"catslug\";s:9:\"16:latest\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:66:\"index.php/component/content/article/16-latest/25-welcome-to-joomla\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:6:\"Latest\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:6:\"Latest\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=25\";s:5:\"route\";s:81:\"index.php?option=com_content&view=article&id=25:welcome-to-joomla&catid=16:latest\";s:5:\"title\";s:18:\"Welcome to Joomla!\";s:11:\"description\";s:524:\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. Joomla! provides an easy-to-use graphical user interface that simplifies the management and publishing of large volumes of content including HTML, documents, and rich media. Joomla! is used by organisations of all sizes for intranets and extranets and is supported by a community of tens of thousands of users.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 08:49:51\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 08:49:51\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(46,'index.php?option=com_content&view=article&id=26','index.php?option=com_content&view=article&id=26:online-business-conference&catid=18:financial-adviser&Itemid=213','Online Business Conference','With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.','2012-01-15 22:33:06','247e327c6fafee123f8a09ae3a95fb62',1,1,1,'*','2011-07-20 12:15:26','0000-00-00 00:00:00','2011-07-20 12:15:26','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"26\";s:5:\"alias\";s:26:\"online-business-conference\";s:7:\"summary\";s:393:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Online Business Conference\" title=\"Online Business Conference\" align=\"left\" />With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.</p>\r\n\";s:4:\"body\";s:2249:\"\r\n<p>More importantly, several e business meetings sites have been launched over the World Wide Web recently helping to their valued customers worldwide in a most artful and dedicated manner.<br /><br />Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"18\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:09:09\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:17:\"Financial Adviser\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:29:\"26:online-business-conference\";s:7:\"catslug\";s:20:\"18:financial-adviser\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:117:\"index.php/2011-08-19-13-59-20/financial-adviser/18-financial-business/financial-adviser/26-online-business-conference\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Financial Adviser\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Financial Adviser\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=26\";s:5:\"route\";s:112:\"index.php?option=com_content&view=article&id=26:online-business-conference&catid=18:financial-adviser&Itemid=213\";s:5:\"title\";s:26:\"Online Business Conference\";s:11:\"description\";s:232:\"With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:15:26\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:15:26\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(47,'index.php?option=com_content&view=article&id=27','index.php?option=com_content&view=article&id=27:need-additional-capital&catid=18:financial-adviser&Itemid=213','Need Additional Capital?','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget ni','2012-01-15 22:33:07','7f00dcd9c260327de162229205c2ba50',1,1,1,'*','2011-07-20 12:17:45','0000-00-00 00:00:00','2011-07-20 12:17:45','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"27\";s:5:\"alias\";s:23:\"need-additional-capital\";s:7:\"summary\";s:415:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Need Additional Capital?\" title=\"Need Additional Capital?\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n\";s:4:\"body\";s:2051:\"\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"18\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:08:30\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:17:\"Financial Adviser\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:26:\"27:need-additional-capital\";s:7:\"catslug\";s:20:\"18:financial-adviser\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:114:\"index.php/2011-08-19-13-59-20/financial-adviser/18-financial-business/financial-adviser/27-need-additional-capital\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Financial Adviser\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Financial Adviser\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=27\";s:5:\"route\";s:109:\"index.php?option=com_content&view=article&id=27:need-additional-capital&catid=18:financial-adviser&Itemid=213\";s:5:\"title\";s:24:\"Need Additional Capital?\";s:11:\"description\";s:258:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:17:45\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:17:45\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(48,'index.php?option=com_content&view=article&id=28','index.php?option=com_content&view=article&id=28:we-celebrate-your-success&catid=18:financial-adviser&Itemid=213','We celebrate your success! ','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget ni','2012-01-15 22:33:07','fa5454964253c9fb87f0b797b97c13c5',1,1,1,'*','2011-07-20 12:25:43','0000-00-00 00:00:00','2011-07-20 12:25:43','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"28\";s:5:\"alias\";s:25:\"we-celebrate-your-success\";s:7:\"summary\";s:419:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Online Business Conference\" title=\"Online Business Conference\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n\";s:4:\"body\";s:2051:\"\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"18\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:10:23\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"3\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:17:\"Financial Adviser\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:28:\"28:we-celebrate-your-success\";s:7:\"catslug\";s:20:\"18:financial-adviser\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:116:\"index.php/2011-08-19-13-59-20/financial-adviser/18-financial-business/financial-adviser/28-we-celebrate-your-success\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Financial Adviser\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Financial Adviser\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=28\";s:5:\"route\";s:111:\"index.php?option=com_content&view=article&id=28:we-celebrate-your-success&catid=18:financial-adviser&Itemid=213\";s:5:\"title\";s:27:\"We celebrate your success! \";s:11:\"description\";s:258:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:25:43\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:25:43\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(49,'index.php?option=com_content&view=article&id=29','index.php?option=com_content&view=article&id=29:idea-about-starting-your-own-business&catid=18:financial-adviser&Itemid=213','Idea about starting your own business','In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to g','2012-01-15 22:33:07','28b2ba55b373bf39fef9cf502899a92a',1,1,1,'*','2011-07-20 12:27:42','0000-00-00 00:00:00','2011-07-20 12:27:42','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"29\";s:5:\"alias\";s:37:\"idea-about-starting-your-own-business\";s:7:\"summary\";s:481:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Idea about starting your own business\" title=\"Idea about starting your own business\" align=\"left\" />In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to gauge their support and to get their advice.</p>\r\n\";s:4:\"body\";s:2051:\"\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi.</p>\";s:5:\"catid\";s:2:\"18\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:06:37\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"3\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:17:\"Financial Adviser\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:40:\"29:idea-about-starting-your-own-business\";s:7:\"catslug\";s:20:\"18:financial-adviser\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:128:\"index.php/2011-08-19-13-59-20/financial-adviser/18-financial-business/financial-adviser/29-idea-about-starting-your-own-business\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Financial Adviser\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Financial Adviser\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=29\";s:5:\"route\";s:123:\"index.php?option=com_content&view=article&id=29:idea-about-starting-your-own-business&catid=18:financial-adviser&Itemid=213\";s:5:\"title\";s:37:\"Idea about starting your own business\";s:11:\"description\";s:298:\"In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to gauge their support and to get their advice.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:27:42\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:27:42\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(50,'index.php?option=com_content&view=article&id=30','index.php?option=com_content&view=article&id=30:support-your-financial-success&catid=19:investment-guide&Itemid=214','Support your financial success ','A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.','2012-01-15 22:33:08','2a2452c0297511928a5ee516c8531999',1,1,1,'*','2011-07-20 12:29:48','0000-00-00 00:00:00','2011-07-20 12:29:48','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"30\";s:5:\"alias\";s:30:\"support-your-financial-success\";s:7:\"summary\";s:404:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Support your financial success\" title=\"Support your financial success\" align=\"left\" />A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.</p>\r\n\";s:4:\"body\";s:2550:\"\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"19\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:25:12\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"0\";s:10:\"show_intro\";s:1:\"0\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"0\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"0\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"0\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"0\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"0\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"3\";s:8:\"category\";s:17:\" Investment Guide\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:33:\"30:support-your-financial-success\";s:7:\"catslug\";s:19:\"19:investment-guide\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:119:\"index.php/2011-08-19-13-59-20/investment-guide/19-financial-business/investment-guide/30-support-your-financial-success\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\" Investment Guide\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\" Investment Guide\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=30\";s:5:\"route\";s:115:\"index.php?option=com_content&view=article&id=30:support-your-financial-success&catid=19:investment-guide&Itemid=214\";s:5:\"title\";s:31:\"Support your financial success \";s:11:\"description\";s:235:\"A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:29:48\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:29:48\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(51,'index.php?option=com_content&view=article&id=31','index.php?option=com_content&view=article&id=31:workshop-from-dedicated-stractegy&catid=19:investment-guide&Itemid=214','WorkShop from dedicated stractegy','Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business ','2012-01-15 22:33:08','c017c4dd4832432db303e9064c253984',1,1,1,'*','2011-07-20 12:31:43','0000-00-00 00:00:00','2011-07-20 12:31:43','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"31\";s:5:\"alias\";s:33:\"workshop-from-dedicated-stractegy\";s:7:\"summary\";s:463:\"<p style=\"margin-top: 10px;\"><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"WorkShop from dedicated stractegy\" title=\"WorkShop from dedicated stractegy\" align=\"left\" />Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding</p>\r\n\";s:4:\"body\";s:2449:\"\r\n<p>you can qualify for and who you can rely on is an important part of the decision making process.</p>\r\n<p>Business Financial Services (BFS) is the trusted provider of merchant cash advances to businesses nationwide. Since 2002, business owners have come to us to get the small business capital they need for inventory, vendor financing, renovation, equipment, taxes or just extra cash flow.</p>\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"19\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:25:57\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"2\";s:8:\"category\";s:17:\" Investment Guide\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:36:\"31:workshop-from-dedicated-stractegy\";s:7:\"catslug\";s:19:\"19:investment-guide\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:122:\"index.php/2011-08-19-13-59-20/investment-guide/19-financial-business/investment-guide/31-workshop-from-dedicated-stractegy\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\" Investment Guide\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\" Investment Guide\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=31\";s:5:\"route\";s:118:\"index.php?option=com_content&view=article&id=31:workshop-from-dedicated-stractegy&catid=19:investment-guide&Itemid=214\";s:5:\"title\";s:33:\"WorkShop from dedicated stractegy\";s:11:\"description\";s:262:\"Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:31:43\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:31:43\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(52,'index.php?option=com_content&view=article&id=32','index.php?option=com_content&view=article&id=32:office-and-support-staff&catid=19:investment-guide&Itemid=214','Office and Support Staff ','Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et','2012-01-15 22:33:11','0fd3ef97533d04062f8135e81a3b86d7',1,1,1,'*','2011-07-20 12:33:51','0000-00-00 00:00:00','2011-07-20 12:33:51','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"32\";s:5:\"alias\";s:24:\"office-and-support-staff\";s:7:\"summary\";s:422:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Office and Support Staff \" title=\"Office and Support Staff \" align=\"left\" />Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis.</p>\r\n\";s:4:\"body\";s:2391:\"\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"19\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:23:44\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:17:\" Investment Guide\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:27:\"32:office-and-support-staff\";s:7:\"catslug\";s:19:\"19:investment-guide\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:113:\"index.php/2011-08-19-13-59-20/investment-guide/19-financial-business/investment-guide/32-office-and-support-staff\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\" Investment Guide\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\" Investment Guide\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=32\";s:5:\"route\";s:109:\"index.php?option=com_content&view=article&id=32:office-and-support-staff&catid=19:investment-guide&Itemid=214\";s:5:\"title\";s:25:\"Office and Support Staff \";s:11:\"description\";s:263:\"Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:33:51\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:33:51\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(53,'index.php?option=com_content&view=article&id=33','index.php?option=com_content&view=article&id=33:creating-a-great-team-environment&catid=19:investment-guide&Itemid=214','Creating a great team environment','When your business encounters bumps in the road, it seems like everyone knows — especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.','2012-01-15 22:33:11','62b8825f82c789ab77d603b1e860712f',1,1,1,'*','2011-07-20 12:35:47','0000-00-00 00:00:00','2011-07-20 12:35:47','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"33\";s:5:\"alias\";s:33:\"creating-a-great-team-environment\";s:7:\"summary\";s:402:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Creating a great team environment\" title=\"Creating a great team environment\" align=\"left\" />When your business encounters bumps in the road, it seems like everyone knows — especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.</p>\r\n\";s:4:\"body\";s:2709:\"\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>\";s:5:\"catid\";s:2:\"19\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:23:01\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:17:\" Investment Guide\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:36:\"33:creating-a-great-team-environment\";s:7:\"catslug\";s:19:\"19:investment-guide\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:122:\"index.php/2011-08-19-13-59-20/investment-guide/19-financial-business/investment-guide/33-creating-a-great-team-environment\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\" Investment Guide\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\" Investment Guide\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=33\";s:5:\"route\";s:118:\"index.php?option=com_content&view=article&id=33:creating-a-great-team-environment&catid=19:investment-guide&Itemid=214\";s:5:\"title\";s:33:\"Creating a great team environment\";s:11:\"description\";s:227:\"When your business encounters bumps in the road, it seems like everyone knows — especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:35:47\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:35:47\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(54,'index.php?option=com_content&view=article&id=34','index.php?option=com_content&view=article&id=34:our-business-is-built-on-friendship&catid=20:market-center&Itemid=215','Our business is built on friendship.','Describe your company\'s business plan with this presentation for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec','2012-01-15 22:33:12','bb1416fe3a0e5060d1caf4f0214b181f',1,1,1,'*','2011-07-20 12:37:26','0000-00-00 00:00:00','2011-07-20 12:37:26','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"34\";s:5:\"alias\";s:35:\"our-business-is-built-on-friendship\";s:7:\"summary\";s:528:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Our business is built on friendship.\" title=\"Our business is built on friendship.\" align=\"left\" />Describe your company\'s <em>business</em> plan with this <em>presentation</em> for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia.</p>\r\n\";s:4:\"body\";s:1708:\"\r\n<p>It all have to do with what you are ready, willing and able to accept within yourself and in accepting to be able to give others. It is your personal power to make the difference by being true to the best within you and letting truth shine through your words and actions. Be yourself in front of the eyes of the crowd.<br /><br /></p>\r\n<div style=\"text-align: justify;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</div>\r\n<p> </p>\";s:5:\"catid\";s:2:\"20\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:27:59\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"2\";s:8:\"category\";s:13:\"Market Center\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:38:\"34:our-business-is-built-on-friendship\";s:7:\"catslug\";s:16:\"20:market-center\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:118:\"index.php/2011-08-19-13-59-20/market-center/20-financial-business/market-center/34-our-business-is-built-on-friendship\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Market Center\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Market Center\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=34\";s:5:\"route\";s:117:\"index.php?option=com_content&view=article&id=34:our-business-is-built-on-friendship&catid=20:market-center&Itemid=215\";s:5:\"title\";s:36:\"Our business is built on friendship.\";s:11:\"description\";s:329:\"Describe your company\'s business plan with this presentation for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:37:26\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:37:26\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(55,'index.php?option=com_content&view=article&id=35','index.php?option=com_content&view=article&id=35:trusted-in-financial-market&catid=20:market-center&Itemid=215','Trusted in financial market','Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business ','2012-01-15 22:33:12','b0c5521c846d42bd7f0a00125de60539',1,1,1,'*','2011-07-20 12:39:26','0000-00-00 00:00:00','2011-07-20 12:39:26','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"35\";s:5:\"alias\";s:27:\"trusted-in-financial-market\";s:7:\"summary\";s:429:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Trusted in financial market\" title=\"Trusted in financial market\" align=\"left\" />Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding you</p>\r\n\";s:4:\"body\";s:2082:\"\r\n<p>can qualify for and who you can rely on is an important part of the decision making process. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>\";s:5:\"catid\";s:2:\"20\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:29:30\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"1\";s:8:\"category\";s:13:\"Market Center\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:30:\"35:trusted-in-financial-market\";s:7:\"catslug\";s:16:\"20:market-center\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:110:\"index.php/2011-08-19-13-59-20/market-center/20-financial-business/market-center/35-trusted-in-financial-market\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Market Center\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Market Center\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=35\";s:5:\"route\";s:109:\"index.php?option=com_content&view=article&id=35:trusted-in-financial-market&catid=20:market-center&Itemid=215\";s:5:\"title\";s:27:\"Trusted in financial market\";s:11:\"description\";s:266:\"Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding you\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:39:26\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:39:26\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(56,'index.php?option=com_content&view=article&id=36','index.php?option=com_content&view=article&id=36:fully-equipped-modern-workshop&catid=20:market-center&Itemid=215','Fully equipped modern workshop','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget ni','2012-01-15 22:33:14','29ec91f0812c7e7f6747f42c0764f547',1,1,1,'*','2011-07-20 12:41:06','0000-00-00 00:00:00','2011-07-20 12:41:06','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"36\";s:5:\"alias\";s:30:\"fully-equipped-modern-workshop\";s:7:\"summary\";s:427:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Fully equipped modern workshop\" title=\"Fully equipped modern workshop\" align=\"left\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n\";s:4:\"body\";s:1992:\"\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />~Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>\";s:5:\"catid\";s:2:\"20\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:27:09\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"3\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:13:\"Market Center\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:33:\"36:fully-equipped-modern-workshop\";s:7:\"catslug\";s:16:\"20:market-center\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:113:\"index.php/2011-08-19-13-59-20/market-center/20-financial-business/market-center/36-fully-equipped-modern-workshop\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Market Center\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Market Center\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=36\";s:5:\"route\";s:112:\"index.php?option=com_content&view=article&id=36:fully-equipped-modern-workshop&catid=20:market-center&Itemid=215\";s:5:\"title\";s:30:\"Fully equipped modern workshop\";s:11:\"description\";s:258:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:41:06\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:41:06\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(57,'index.php?option=com_content&view=article&id=37','index.php?option=com_content&view=article&id=37:top-professional-advisers&catid=20:market-center&Itemid=215','Top professional advisers','Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?','2012-01-15 22:33:14','ed2ae5db8abe213185ceb6c9aec874a1',1,1,1,'*','2011-07-20 12:43:31','0000-00-00 00:00:00','2011-07-20 12:43:31','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"37\";s:5:\"alias\";s:25:\"top-professional-advisers\";s:7:\"summary\";s:397:\"<p><img class=\"caption\" src=\"images/demo/joomla_article.png\" border=\"0\" alt=\"Top professional advisers\" title=\"Top professional advisers\" align=\"left\" />Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?</p>\r\n\";s:4:\"body\";s:1988:\"\r\n<p>If yes, then please feel free to contact at www.ebusinessmeetings.net as this is yours own company who helps you regarding your e business meetings, conferences and seminars in a clearly artful and dedicated manner. It provides you the smart business meeting tips through which you would be instantly able to promote your own business meetings as well as conferences effortlessly.  So please do not get hesitated to contact with E Business Meetings so as to get a perfect advice regarding your own business meetings.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.</p>\";s:5:\"catid\";s:2:\"20\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-08-19 14:28:43\";s:11:\"modified_by\";s:2:\"42\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"2\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:13:\"Market Center\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:28:\"37:top-professional-advisers\";s:7:\"catslug\";s:16:\"20:market-center\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:108:\"index.php/2011-08-19-13-59-20/market-center/20-financial-business/market-center/37-top-professional-advisers\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:13:\"Market Center\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Market Center\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=37\";s:5:\"route\";s:107:\"index.php?option=com_content&view=article&id=37:top-professional-advisers&catid=20:market-center&Itemid=215\";s:5:\"title\";s:25:\"Top professional advisers\";s:11:\"description\";s:238:\"Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-07-20 12:43:31\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-07-20 12:43:31\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(58,'index.php?option=com_content&view=article&id=38','index.php?option=com_content&view=article&id=38:page-break&catid=7:template&Itemid=216','Page Break','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi.','2012-01-15 22:33:14','f6a1333005ba5c4b6f28c5d59eb31d43',1,1,1,'*','2011-09-13 20:09:41','0000-00-00 00:00:00','2011-09-13 20:09:41','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"38\";s:5:\"alias\";s:10:\"page-break\";s:7:\"summary\";s:3584:\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<hr title=\"Page 1\" alt=\"page1\" class=\"system-pagebreak\" />\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<hr title=\"Page 2\" alt=\"page2\" class=\"system-pagebreak\" />\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"1\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"38:page-break\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:84:\"index.php/template/lorem-ipsum-ii/joomla-pages-i/page-break/7-template/38-page-break\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=38\";s:5:\"route\";s:86:\"index.php?option=com_content&view=article&id=38:page-break&catid=7:template&Itemid=216\";s:5:\"title\";s:10:\"Page Break\";s:11:\"description\";s:3416:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est. Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique. Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit ametmi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est. Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique. Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-09-13 20:09:41\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-09-13 20:09:41\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}'),(59,'index.php?option=com_newsfeeds&view=newsfeed&id=1','index.php?option=com_newsfeeds&view=newsfeed&id=1:gavickpro-news&catid=14:gavickpro','GavickPro News','','2012-01-15 22:33:17','b3547e64d527a108d7492458efca6bdb',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:35:16','0000-00-00 00:00:00',0,0,4,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:22:{s:2:\"id\";s:1:\"1\";s:5:\"catid\";s:2:\"14\";s:5:\"alias\";s:14:\"gavickpro-news\";s:4:\"link\";s:60:\"http://www.gavickmagazine.com/index.php?format=feed&type=rss\";s:8:\"ordering\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":5:{s:15:\"show_feed_image\";s:0:\"\";s:21:\"show_feed_description\";s:0:\"\";s:21:\"show_item_description\";s:0:\"\";s:20:\"feed_character_count\";s:1:\"0\";s:15:\"newsfeed_layout\";s:0:\"\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"rights\";s:0:\"\";}}s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:16:\"1:gavickpro-news\";s:7:\"catslug\";s:12:\"14:gavickpro\";s:4:\"mime\";N;s:6:\"layout\";s:8:\"newsfeed\";s:4:\"path\";s:68:\"index.php/component/newsfeeds/newsfeed/14-gavickpro/1-gavickpro-news\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:9:\"News Feed\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"News Feed\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:49:\"index.php?option=com_newsfeeds&view=newsfeed&id=1\";s:5:\"route\";s:83:\"index.php?option=com_newsfeeds&view=newsfeed&id=1:gavickpro-news&catid=14:gavickpro\";s:5:\"title\";s:14:\"GavickPro News\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:35:16\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:4;}'),(60,'index.php?option=com_weblinks&view=weblink&id=1','index.php?option=com_weblinks&view=weblink&id=1:joomla-16&catid=12:joomla-weblink-category','Joomla! 1.6','Joomla! CMS offical site.','2012-01-15 22:33:17','81c80c30c5ed4644661a27a3fa86b4cb',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:02:04','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"1\";s:5:\"catid\";s:2:\"12\";s:5:\"alias\";s:9:\"joomla-16\";s:4:\"link\";s:21:\"http://www.joomla.org\";s:7:\"summary\";s:32:\"<p>Joomla! CMS offical site.</p>\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"1\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 15:02:15\";s:11:\"modified_by\";s:2:\"42\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:23:\"Joomla Weblink Category\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:11:\"1:joomla-16\";s:7:\"catslug\";s:26:\"12:joomla-weblink-category\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:75:\"index.php/component/weblinks/weblink/12-joomla-weblink-category/1-joomla-16\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:23:\"Joomla Weblink Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:23:\"Joomla Weblink Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=1\";s:5:\"route\";s:90:\"index.php?option=com_weblinks&view=weblink&id=1:joomla-16&catid=12:joomla-weblink-category\";s:5:\"title\";s:11:\"Joomla! 1.6\";s:11:\"description\";s:25:\"Joomla! CMS offical site.\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:02:04\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(61,'index.php?option=com_weblinks&view=weblink&id=2','index.php?option=com_weblinks&view=weblink&id=2:joomla-extensions&catid=12:joomla-weblink-category','Joomla Extensions','Joomla extensions.','2012-01-15 22:33:17','5ffbb08d3c67c874b92b8c91ab2e1711',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:02:54','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"2\";s:5:\"catid\";s:2:\"12\";s:5:\"alias\";s:17:\"joomla-extensions\";s:4:\"link\";s:28:\"http://extensions.joomla.org\";s:7:\"summary\";s:25:\"<p>Joomla extensions.</p>\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"2\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:23:\"Joomla Weblink Category\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:19:\"2:joomla-extensions\";s:7:\"catslug\";s:26:\"12:joomla-weblink-category\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:83:\"index.php/component/weblinks/weblink/12-joomla-weblink-category/2-joomla-extensions\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:23:\"Joomla Weblink Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:23:\"Joomla Weblink Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=2\";s:5:\"route\";s:98:\"index.php?option=com_weblinks&view=weblink&id=2:joomla-extensions&catid=12:joomla-weblink-category\";s:5:\"title\";s:17:\"Joomla Extensions\";s:11:\"description\";s:18:\"Joomla extensions.\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:02:54\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(62,'index.php?option=com_weblinks&view=weblink&id=3','index.php?option=com_weblinks&view=weblink&id=3:joomla-documentation&catid=12:joomla-weblink-category','Joomla documentation','Full Joomla! documentation.','2012-01-15 22:33:17','9f5d9564b38c94743f38a4a54f96124e',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:03:23','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"3\";s:5:\"catid\";s:2:\"12\";s:5:\"alias\";s:20:\"joomla-documentation\";s:4:\"link\";s:22:\"http://docs.joomla.org\";s:7:\"summary\";s:34:\"<p>Full Joomla! documentation.</p>\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"3\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:23:\"Joomla Weblink Category\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:22:\"3:joomla-documentation\";s:7:\"catslug\";s:26:\"12:joomla-weblink-category\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:86:\"index.php/component/weblinks/weblink/12-joomla-weblink-category/3-joomla-documentation\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:23:\"Joomla Weblink Category\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:23:\"Joomla Weblink Category\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=3\";s:5:\"route\";s:101:\"index.php?option=com_weblinks&view=weblink&id=3:joomla-documentation&catid=12:joomla-weblink-category\";s:5:\"title\";s:20:\"Joomla documentation\";s:11:\"description\";s:27:\"Full Joomla! documentation.\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:03:23\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(63,'index.php?option=com_weblinks&view=weblink&id=4','index.php?option=com_weblinks&view=weblink&id=4:demo-gavick&catid=13:gavick&Itemid=184','GavickPro Demo','','2012-01-15 22:33:17','e44fc9b5f3fec52bad1c250c86bffdc3',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:06:17','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"4\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:11:\"demo-gavick\";s:4:\"link\";s:22:\"http://demo.gavick.com\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"4\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 15:12:26\";s:11:\"modified_by\";s:2:\"42\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:13:\"4:demo-gavick\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:74:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/4-demo-gavick\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=4\";s:5:\"route\";s:86:\"index.php?option=com_weblinks&view=weblink&id=4:demo-gavick&catid=13:gavick&Itemid=184\";s:5:\"title\";s:14:\"GavickPro Demo\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:06:17\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(64,'index.php?option=com_weblinks&view=weblink&id=5','index.php?option=com_weblinks&view=weblink&id=5:gavick-magazine&catid=13:gavick&Itemid=184','GavickPro Magazine','','2012-01-15 22:33:17','3c7121dfe8156a418bb57855383ba960',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:09:14','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"5\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:15:\"gavick-magazine\";s:4:\"link\";s:29:\"http://www.gavickmagazine.com\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"5\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 15:13:34\";s:11:\"modified_by\";s:2:\"42\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:17:\"5:gavick-magazine\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:78:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/5-gavick-magazine\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=5\";s:5:\"route\";s:90:\"index.php?option=com_weblinks&view=weblink&id=5:gavick-magazine&catid=13:gavick&Itemid=184\";s:5:\"title\";s:18:\"GavickPro Magazine\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:09:14\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(65,'index.php?option=com_weblinks&view=weblink&id=6','index.php?option=com_weblinks&view=weblink&id=6:gavickpro-homepage&catid=13:gavick&Itemid=184','GavickPro Homepage','','2012-01-15 22:33:17','9b43940af5c94fdcf4e1132f6282bded',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:13:15','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"6\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:18:\"gavickpro-homepage\";s:4:\"link\";s:21:\"http://www.gavick.com\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"6\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-13 15:13:24\";s:11:\"modified_by\";s:2:\"42\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:20:\"6:gavickpro-homepage\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:81:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/6-gavickpro-homepage\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=6\";s:5:\"route\";s:93:\"index.php?option=com_weblinks&view=weblink&id=6:gavickpro-homepage&catid=13:gavick&Itemid=184\";s:5:\"title\";s:18:\"GavickPro Homepage\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:13:15\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(66,'index.php?option=com_weblinks&view=weblink&id=7','index.php?option=com_weblinks&view=weblink&id=7:gavickpro-tools&catid=13:gavick&Itemid=184','GavickPro Tools','','2012-01-15 22:33:17','14b1107bef08ffb817a3004711a3f5f4',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:14:11','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"7\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:15:\"gavickpro-tools\";s:4:\"link\";s:24:\"http://tools.gavick.com/\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"7\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:17:\"7:gavickpro-tools\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:78:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/7-gavickpro-tools\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=7\";s:5:\"route\";s:90:\"index.php?option=com_weblinks&view=weblink&id=7:gavickpro-tools&catid=13:gavick&Itemid=184\";s:5:\"title\";s:15:\"GavickPro Tools\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:14:11\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(67,'index.php?option=com_weblinks&view=weblink&id=8','index.php?option=com_weblinks&view=weblink&id=8:gavickpro-twitter&catid=13:gavick&Itemid=184','GavickPro Twitter','','2012-01-15 22:33:17','f081dcdc7fecdeb25b6887667523c058',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:15:04','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"8\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:17:\"gavickpro-twitter\";s:4:\"link\";s:28:\"http://twitter.com/gavickpro\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"8\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:19:\"8:gavickpro-twitter\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:80:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/8-gavickpro-twitter\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=8\";s:5:\"route\";s:92:\"index.php?option=com_weblinks&view=weblink&id=8:gavickpro-twitter&catid=13:gavick&Itemid=184\";s:5:\"title\";s:17:\"GavickPro Twitter\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:15:04\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(68,'index.php?option=com_weblinks&view=weblink&id=9','index.php?option=com_weblinks&view=weblink&id=9:gavickpro-facebook&catid=13:gavick&Itemid=184','GavickPro Facebook','','2012-01-15 22:33:17','085f9ae8a75148f8c9d3ca051994c1e7',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:15:30','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:1:\"9\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:18:\"gavickpro-facebook\";s:4:\"link\";s:33:\"http://www.facebook.com/gavickpro\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:1:\"9\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:20:\"9:gavickpro-facebook\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:81:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/9-gavickpro-facebook\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_weblinks&view=weblink&id=9\";s:5:\"route\";s:93:\"index.php?option=com_weblinks&view=weblink&id=9:gavickpro-facebook&catid=13:gavick&Itemid=184\";s:5:\"title\";s:18:\"GavickPro Facebook\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:15:30\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(69,'index.php?option=com_weblinks&view=weblink&id=10','index.php?option=com_weblinks&view=weblink&id=10:gavickpro-updates&catid=13:gavick&Itemid=184','GavickPro Updates','','2012-01-15 22:33:17','e92af0f881a64129760d6929d13279a5',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:16:04','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:2:\"10\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:17:\"gavickpro-updates\";s:4:\"link\";s:42:\"http://www.gavick.com/support/updates.html\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:2:\"10\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:20:\"10:gavickpro-updates\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:81:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/10-gavickpro-updates\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_weblinks&view=weblink&id=10\";s:5:\"route\";s:93:\"index.php?option=com_weblinks&view=weblink&id=10:gavickpro-updates&catid=13:gavick&Itemid=184\";s:5:\"title\";s:17:\"GavickPro Updates\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:16:04\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(70,'index.php?option=com_weblinks&view=weblink&id=11','index.php?option=com_weblinks&view=weblink&id=11:join-us&catid=13:gavick&Itemid=184','Join us!','','2012-01-15 22:33:17','d91ff5b133f62ff3a1cc856367b60194',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:17:14','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:2:\"11\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:7:\"join-us\";s:4:\"link\";s:39:\"http://www.gavick.com/home/join-us.html\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:2:\"11\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:10:\"11:join-us\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:71:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/11-join-us\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_weblinks&view=weblink&id=11\";s:5:\"route\";s:83:\"index.php?option=com_weblinks&view=weblink&id=11:join-us&catid=13:gavick&Itemid=184\";s:5:\"title\";s:8:\"Join us!\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:17:14\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(71,'index.php?option=com_weblinks&view=weblink&id=12','index.php?option=com_weblinks&view=weblink&id=12:gavickpro-rss-a-news&catid=13:gavick&Itemid=184','GavickPro RSS & News','','2012-01-15 22:33:17','75e315457182fbb56d7a919b92848f12',1,1,1,'*','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-13 15:19:20','0000-00-00 00:00:00',0,0,5,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:23:{s:2:\"id\";s:2:\"12\";s:5:\"catid\";s:2:\"13\";s:5:\"alias\";s:20:\"gavickpro-rss-a-news\";s:4:\"link\";s:60:\"http://www.gavickmagazine.com/index.php?format=feed&type=rss\";s:7:\"summary\";s:0:\"\";s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:8:\"ordering\";s:2:\"12\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:8:\"approved\";s:1:\"1\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"target\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";s:12:\"count_clicks\";s:0:\"\";}}s:8:\"category\";s:9:\"GavickPro\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:23:\"12:gavickpro-rss-a-news\";s:7:\"catslug\";s:9:\"13:gavick\";s:4:\"mime\";N;s:6:\"layout\";s:7:\"weblink\";s:4:\"path\";s:84:\"index.php/joomla-pages-ii/news-feeds-in-a-category/13-gavick/12-gavickpro-rss-a-news\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:9:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:4:\"link\";i:4;s:7:\"metakey\";i:5;s:8:\"metadesc\";i:6;s:10:\"metaauthor\";i:7;s:6:\"author\";i:8;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:3:{s:4:\"Type\";a:1:{s:8:\"Web Link\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:8:\"Web Link\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:9:\"GavickPro\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:9:\"GavickPro\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:48:\"index.php?option=com_weblinks&view=weblink&id=12\";s:5:\"route\";s:96:\"index.php?option=com_weblinks&view=weblink&id=12:gavickpro-rss-a-news&catid=13:gavick&Itemid=184\";s:5:\"title\";s:20:\"GavickPro RSS & News\";s:11:\"description\";s:0:\"\";s:9:\"published\";N;s:5:\"state\";s:1:\"1\";s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"0000-00-00 00:00:00\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-13 15:19:20\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:5;}'),(72,'index.php?option=com_content&view=article&id=39','index.php?option=com_content&view=article&id=39:chrome-frame-2&catid=7:template&Itemid=195','Chrome frame (2)','Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit','2012-01-15 23:38:52','83eb2b72e29866086974acee66396354',1,1,1,'*','2011-01-12 17:12:21','0000-00-00 00:00:00','2011-01-12 17:12:21','0000-00-00 00:00:00',0,0,3,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:24:{s:2:\"id\";s:2:\"39\";s:5:\"alias\";s:14:\"chrome-frame-2\";s:7:\"summary\";s:1314:\"<p>Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page.</p>\r\n<p>In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine.</p>\r\n<p>To get know more about Google Chrome Frame, please visit:</p>\r\n<p><a href=\"http://code.google.com/intl/en-GB/chrome/chromeframe/\">http://code.google.com/intl/en-GB/chrome/chromeframe/</a> - the official Project’s web side containing the link to the plug-in.</p>\r\n<p><a href=\"http://www.chromium.org/developers/how-tos/chrome-frame-getting-started\">http://www.chromium.org/developers/how-tos/chrome-frame-getting-started</a> - more info about Google Chrome Frame for developers.</p>\";s:4:\"body\";s:0:\"\";s:5:\"catid\";s:1:\"7\";s:10:\"created_by\";s:2:\"42\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2011-01-17 14:37:56\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":58:{s:14:\"article_layout\";s:9:\"_:default\";s:10:\"show_title\";s:1:\"0\";s:11:\"link_titles\";s:1:\"1\";s:10:\"show_intro\";s:1:\"1\";s:13:\"show_category\";s:1:\"0\";s:13:\"link_category\";s:1:\"1\";s:20:\"show_parent_category\";s:1:\"0\";s:20:\"link_parent_category\";s:1:\"0\";s:11:\"show_author\";s:1:\"1\";s:11:\"link_author\";s:1:\"0\";s:16:\"show_create_date\";s:1:\"1\";s:16:\"show_modify_date\";s:1:\"0\";s:17:\"show_publish_date\";s:1:\"0\";s:20:\"show_item_navigation\";s:1:\"1\";s:9:\"show_vote\";s:1:\"0\";s:13:\"show_readmore\";s:1:\"1\";s:19:\"show_readmore_title\";s:1:\"1\";s:14:\"readmore_limit\";s:3:\"100\";s:10:\"show_icons\";s:1:\"1\";s:15:\"show_print_icon\";s:1:\"1\";s:15:\"show_email_icon\";s:1:\"1\";s:9:\"show_hits\";s:1:\"0\";s:11:\"show_noauth\";s:1:\"0\";s:15:\"category_layout\";s:6:\"_:blog\";s:19:\"show_category_title\";s:1:\"0\";s:16:\"show_description\";s:1:\"0\";s:22:\"show_description_image\";s:1:\"0\";s:8:\"maxLevel\";s:1:\"1\";s:21:\"show_empty_categories\";s:1:\"0\";s:16:\"show_no_articles\";s:1:\"1\";s:16:\"show_subcat_desc\";s:1:\"1\";s:21:\"show_cat_num_articles\";s:1:\"0\";s:21:\"show_base_description\";s:1:\"1\";s:11:\"maxLevelcat\";s:2:\"-1\";s:25:\"show_empty_categories_cat\";s:1:\"0\";s:20:\"show_subcat_desc_cat\";s:1:\"1\";s:25:\"show_cat_num_articles_cat\";s:1:\"1\";s:20:\"num_leading_articles\";s:1:\"1\";s:18:\"num_intro_articles\";s:1:\"4\";s:11:\"num_columns\";s:1:\"2\";s:9:\"num_links\";s:1:\"4\";s:18:\"multi_column_order\";s:1:\"0\";s:24:\"show_subcategory_content\";s:1:\"0\";s:21:\"show_pagination_limit\";s:1:\"1\";s:12:\"filter_field\";s:4:\"hide\";s:13:\"show_headings\";s:1:\"1\";s:14:\"list_show_date\";s:1:\"0\";s:11:\"date_format\";s:0:\"\";s:14:\"list_show_hits\";s:1:\"1\";s:16:\"list_show_author\";s:1:\"1\";s:11:\"orderby_pri\";s:5:\"order\";s:11:\"orderby_sec\";s:5:\"rdate\";s:10:\"order_date\";s:9:\"published\";s:15:\"show_pagination\";s:1:\"2\";s:23:\"show_pagination_results\";s:1:\"1\";s:14:\"show_feed_link\";s:1:\"1\";s:12:\"feed_summary\";s:1:\"0\";s:7:\"filters\";O:8:\"stdClass\":8:{s:1:\"1\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"6\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"7\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"2\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"3\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"4\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"5\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}s:1:\"8\";O:8:\"stdClass\":3:{s:11:\"filter_type\";s:4:\"NONE\";s:11:\"filter_tags\";s:0:\"\";s:17:\"filter_attributes\";s:0:\"\";}}}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":4:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";s:6:\"rights\";s:0:\"\";s:10:\"xreference\";s:0:\"\";}}s:7:\"version\";s:1:\"1\";s:8:\"ordering\";s:1:\"0\";s:8:\"category\";s:17:\"Template articles\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:17:\"39:chrome-frame-2\";s:7:\"catslug\";s:10:\"7:template\";s:6:\"author\";s:13:\"Administrator\";s:6:\"layout\";s:7:\"article\";s:4:\"path\";s:69:\"index.php/joomla-pages-iii/category-list/7-template/39-chrome-frame-2\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"Article\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"Article\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:13:\"Administrator\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:13:\"Administrator\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Category\";a:1:{s:17:\"Template articles\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:17:\"Template articles\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:47:\"index.php?option=com_content&view=article&id=39\";s:5:\"route\";s:90:\"index.php?option=com_content&view=article&id=39:chrome-frame-2&catid=7:template&Itemid=195\";s:5:\"title\";s:16:\"Chrome frame (2)\";s:11:\"description\";s:1121:\"Google Chrome Frame is a retort of Google company to Internet Explorer browser which is still widely popular, despite the fact that its rendering engine remains fallen behind other internet browsers. By applying this plug-in, users can benefit from Webkit engine capabilities and, at the same time, do not loose the opportunity of using Internet Explorer interface. To make this interesting solution work, an appropriate \"meta name\" has to be implemented into the head section of the visited page. In accordance with that, our template contains an appropriate option in its settings that helps the user to switch the meta name in the head section, so that all IE users that have Google Chrome Frame plug-in installed will be able to see the web site along with all facilities offered by Webkit rendering engine. To get know more about Google Chrome Frame, please visit: http://code.google.com/intl/en-GB/chrome/chromeframe/ - the official Project’s web side containing the link to the plug-in. http://www.chromium.org/developers/how-tos/chrome-frame-getting-started - more info about Google Chrome Frame for developers.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2011-01-12 17:12:21\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2011-01-12 17:12:21\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:3;}');


--
-- Table structure for table `#__finder_links_terms0`
--



CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms0`
--


INSERT INTO `#__finder_links_terms0` (`link_id`, `term_id`, `weight`) VALUES (6,11,0.90661),(9,25,1.48),(9,26,5.55),(9,27,5.79679),(10,25,1.76),(10,26,6.6),(10,31,1.33),(10,32,5.92),(11,41,0.28),(11,42,1.05),(11,43,1.16669),(17,61,1.72679),(20,25,0.48),(20,26,1.8),(20,27,1.88004),(20,85,2.16),(20,102,0.08004),(20,103,1.47996),(20,104,1.59996),(20,105,0.39996),(20,106,1.52004),(20,107,1.88004),(20,108,0.15996),(20,109,1.47996),(20,110,1.68),(21,25,0.48),(21,26,1.8),(21,32,1.92),(21,85,2.16),(21,102,0.08004),(21,103,1.47996),(21,104,1.59996),(21,105,0.39996),(21,106,1.52004),(21,107,1.88004),(21,108,0.15996),(21,109,1.47996),(21,110,1.68),(22,11,0.63996),(22,25,41.16),(22,175,9.38469),(22,176,0.93331),(22,177,1.05),(22,178,0.91),(22,179,1.02669),(22,180,2.87007),(22,181,3.08007),(22,182,4.08345),(22,183,5.01655),(22,184,2.58993),(22,185,3.15),(22,186,0.86331),(22,187,1.07331),(22,188,0.93331),(22,189,1.05),(22,190,3.82676),(22,191,4.48),(22,192,0.86331),(22,193,1.07331),(22,194,0.86331),(22,195,1.07331),(22,196,5.74014),(22,197,6.58014),(22,198,0.88669),(22,199,1.00331),(22,200,15.5396),(22,201,17.2204),(22,202,1.77338),(22,203,2.00662),(22,204,130.343),(22,205,1.05),(22,206,0.98),(22,207,3.08007),(22,208,0.98),(22,209,1.02669),(22,210,1.09669),(22,211,4.2),(22,212,3.00993),(22,213,1.91338),(22,214,6.16014),(22,215,2.05338),(22,216,1.02669),(22,217,0.98),(22,218,1.02669),(22,219,1.09669),(22,220,3.29007),(22,221,2.1),(22,222,1.21331),(22,223,1.07331),(22,224,1.14331),(22,225,2.05338),(22,226,1.00331),(22,227,2.05338),(22,228,3.08007),(22,229,2.33338),(22,230,1.09669),(22,231,2.00662),(22,232,1.00331),(22,233,2.1),(22,234,1.02669),(22,235,1.02669),(22,236,1.00331),(22,237,3.08007),(22,238,2.05338),(22,239,2.1),(22,240,5.01655),(22,241,3.50007),(22,242,7.35),(22,243,1.00331),(22,244,4.01324),(22,245,3.36),(22,246,2.05338),(22,247,1.02669),(22,248,0.98),(22,249,1.00331),(22,250,4.78345),(22,251,4.01324),(22,252,10.78),(22,253,1.05),(22,254,2.14662),(22,255,5.13345),(22,256,1.05),(22,257,1.05),(22,258,1.00331),(22,259,1.12),(22,260,3.00993),(22,261,2.00662),(22,262,5.01655),(22,263,1.07331),(22,264,3.00993),(22,265,1.02669),(22,266,5.36655),(22,267,1.05),(22,268,2.05338),(22,269,1.07331),(22,270,0.93331),(22,271,1.07331),(22,272,0.86331),(22,273,1.07331),(22,274,2.66007),(22,275,2.94),(22,276,1.00331),(22,277,1.09669),(22,278,0.56007),(22,279,1.05),(22,280,1.19),(22,281,0.91),(22,282,0.98),(22,283,0.93331),(22,284,1.05),(22,285,1.12),(22,286,1.09669),(22,287,1.21331),(22,288,1.05),(22,289,1.14331),(22,290,0.46662),(22,291,1.82),(22,292,2.24),(22,293,0.56007),(22,294,2.58993),(22,295,3.08007),(22,296,0.69993),(22,297,2.66007),(22,298,2.1),(22,299,1.58627),(22,300,0.84),(22,301,0.93331),(22,302,0.86331),(22,303,1.02669),(22,304,2.73),(22,305,3.29007),(22,306,7.98021),(22,307,9.02979),(22,308,2.52),(22,309,2.79993),(22,310,0.56),(22,311,0.95669),(22,312,1.07331),(22,313,1.02669),(22,314,1.12),(22,315,3.7331),(22,316,2.87007),(22,317,3.29007),(22,318,6.3),(22,319,7.14),(22,320,1.00331),(22,321,1.07331),(22,322,0.98007),(22,323,0.98),(22,324,1.23669),(22,325,0.98),(22,326,1.07331),(22,327,1.00331),(22,328,1.12),(22,329,0.74662),(22,330,1.14331),(22,331,1.28331),(22,332,1.00331),(22,333,1.07331),(22,334,0.28),(22,335,1.91338),(22,336,1.07331),(22,337,1.05),(22,338,16.3342),(22,339,29.4),(22,340,23.4971),(22,341,11.7602),(22,342,6.43986),(22,343,7.00014),(22,344,1.07331),(22,345,1.14331),(22,346,2.08008),(22,347,5.88),(22,348,19.3196),(22,349,21.8396),(22,350,3.21993),(22,351,3.78),(22,352,9.14732),(22,353,6.3),(22,354,7.00014),(22,355,5.88),(22,356,6.85986),(22,357,6.3),(22,358,7.00014),(22,359,3.42993),(22,360,3.84993),(22,361,5.59986),(22,362,7.00014),(22,363,1.02669),(22,364,1.23669),(22,365,1.30676),(22,366,3.15),(22,367,3.42993),(22,368,1.02669),(22,369,1.09669),(22,370,6.53415),(22,371,6.43986),(22,372,7.14),(22,373,19.7404),(22,374,24.3596),(22,375,10.7331),(22,376,13.3),(22,377,0.88669),(22,378,1.12),(22,379,1.21303),(22,380,2.1),(22,381,1.16669),(22,382,1.12),(22,383,1.86662),(22,384,1.05),(22,385,1.05),(22,386,5.59986),(22,387,6.01986),(22,388,2.73),(22,389,3.15),(22,390,2.8),(22,391,2.45007),(22,392,3.15),(22,393,1.96),(22,394,1.23669),(22,395,1.09669),(22,396,2.79993),(22,397,3.29007),(22,398,1.77338),(22,399,2.00662),(22,400,2.66007),(22,401,3.29007),(22,402,5.74014),(22,403,6.43986),(22,404,0.95669),(22,405,1.14331),(22,406,1.30683),(22,407,0.86331),(22,408,0.95669),(22,409,5.59986),(22,410,6.72),(22,411,1.68),(22,412,3.29007),(22,413,3.50007),(22,414,0.18669),(22,415,0.88669),(22,416,1.00331),(22,417,0.84),(22,418,2.66007),(22,419,2.87007),(22,420,1.91338),(22,421,2.05338),(22,422,0.88669),(22,423,1.09669),(22,424,0.56004),(22,425,1.11972),(22,426,2.37993),(22,427,2.87007),(22,428,2.73),(22,429,3.15),(22,430,2.45007),(22,431,3.00993),(22,432,2.58993),(22,433,2.79993),(22,434,0.65317),(22,435,2.87007),(22,436,3.08007),(22,437,0.93331),(22,438,1.09669),(22,439,2.66007),(22,440,3.08007),(22,441,0.28),(22,442,0.91),(22,443,1.09669),(22,444,1.39986),(22,445,6.01986),(22,446,3.36),(22,447,3.29007),(22,448,3.96627),(22,449,8.61021),(22,450,6.43986),(22,451,3.21993),(22,452,5.59986),(22,453,6.3),(22,454,0.88669),(22,455,1.12),(22,456,0.91),(22,457,1.09669),(22,2996,0.37331),(22,2997,1.05),(22,2998,1.19),(22,2999,1.00331),(22,3000,1.19),(22,3001,0.93331),(22,3002,1.12),(22,3003,2.94),(22,3004,3.50007),(22,3005,0.93331),(22,3006,1.12),(22,3007,0.98),(22,3008,1.16669),(22,3009,1.05),(22,3010,1.23669),(22,3011,4.01324),(22,3012,4.76),(22,3013,2.87007),(22,3014,3.42993),(22,3015,1.82),(22,3016,2.19338),(22,3017,5.88),(22,3018,2.14662),(22,3019,2.19338),(22,3020,2.14662),(22,3021,1.96),(22,3022,2.33338),(22,3023,0.98),(22,3024,1.16669),(22,3025,0.93331),(22,3026,1.12),(22,3027,0.98),(22,3028,1.16669),(22,3029,1.05),(22,3030,1.23669),(22,3031,3.15),(22,3032,3.71007),(22,3033,2.00662),(22,3034,2.38),(22,3035,1.16669),(22,3036,1.35331),(22,3037,1.02669),(22,3038,1.21331),(22,3039,1.09669),(22,3040,1.28331),(22,3041,1.96),(22,3042,2.33338),(22,3043,0.95669),(22,3044,1.14331),(22,3045,1.96),(22,3046,2.33338),(22,3047,2.94),(22,3048,3.50007),(22,3049,2.24),(22,3050,2.61338),(22,3051,1.05),(22,3052,1.23669),(22,3053,1.91338),(22,3054,2.28662),(22,3055,0.95669),(22,3056,1.14331),(22,3057,2.00662),(22,3058,2.38),(22,3059,0.98),(22,3060,1.16669),(22,3061,0.98),(22,3062,1.16669),(22,3063,0.95669),(22,3064,1.14331),(22,3065,2.94),(22,3066,3.50007),(22,3067,1.96),(22,3068,2.33338),(22,3069,2.00662),(22,3070,2.38),(22,3071,4.78345),(22,3072,5.71655),(22,3073,3.36),(22,3074,3.92007),(22,3075,7.02317),(22,3076,7.84),(22,3077,0.95669),(22,3078,1.02669),(22,3079,3.82676),(22,3080,4.57324),(22,3081,3.21993),(22,3082,3.78),(22,3083,1.96),(22,3084,2.33338),(22,3085,0.98),(22,3086,1.16669),(22,3087,0.93331),(22,3088,1.12),(22,3089,0.95669),(22,3090,1.14331),(22,3091,4.55),(22,3092,1.96),(22,3093,2.00662),(22,3094,1.00331),(22,3095,3.82676),(22,3096,3.42993),(22,3097,1.09669),(22,3098,10.2664),(22,3099,11.55),(22,3100,1.00331),(22,3101,1.19),(22,3102,2.05338),(22,3103,2.42662),(22,3104,4.9),(22,3105,5.48345),(22,3106,1.00331),(22,3107,1.19),(22,3108,1.00331),(22,3109,1.19),(22,3110,0.95669),(22,3111,1.14331),(22,3112,1.07331),(22,3113,1.26),(22,3114,2.87007),(22,3115,3.21993),(22,3116,1.91338),(22,3117,2.28662),(22,3118,4.78345),(22,3119,5.71655),(22,3120,1.02669),(22,3121,1.21331),(22,3122,2.87007),(22,3123,3.42993),(22,3124,0.98),(22,3125,1.16669),(22,3126,5.13345),(22,3127,6.06655),(22,3128,1.00331),(22,3129,1.19),(22,3130,1.96),(22,3131,2.33338),(22,3132,1.02669),(22,3133,1.21331),(22,3134,0.65338),(22,3135,1.86662),(22,3136,1.19),(22,3137,1.05),(22,3138,1.96),(22,3139,5.46),(22,3140,6.16014),(22,3141,0.91),(22,3142,1.07331),(22,3143,0.69993),(22,3144,2.94),(22,3145,3.21993),(22,3146,0.56),(22,3147,0.95669),(22,3148,1.07331),(22,3149,1.02669),(22,3150,1.12),(22,3151,4.9),(22,3152,0.81669),(22,3153,0.98),(22,3154,2.94),(22,3155,3.36),(22,3156,8.82),(22,3157,10.2898),(22,3158,0.98),(22,3159,1.07331),(22,3160,0.93331),(22,3161,1.07331),(22,3162,5.46),(22,3163,6.3),(22,3164,2.66007),(22,3165,3.57),(22,3166,2.79993),(22,3167,3.29007),(22,3168,5.59986),(22,3169,6.16014),(22,3170,0.98),(22,3171,1.16669),(22,3172,0.91),(22,3173,1.05),(22,3174,0.42),(22,3175,2.58993),(22,3176,2.94),(22,3177,0.56),(22,3178,1.12),(22,3179,1.28331),(22,3180,1.02669),(22,3181,1.14331),(22,3182,0.37331),(22,3183,1.02669),(22,3184,1.07331),(22,3185,0.84),(22,3186,1.63338),(22,3187,0.93331),(22,3188,0.93331),(22,3189,1.63338),(22,3190,0.93331),(22,3191,0.93331),(22,3192,1.63338),(22,3193,0.93331),(22,3194,1.02669),(22,3195,4.9),(22,3196,31.0342),(22,3197,7.00014),(22,3198,21.42),(22,3199,11.6669),(22,3200,0.98),(22,3201,0.23331),(22,3202,1.02669),(22,3203,1.14331),(22,3204,0.09331),(22,3205,0.86331),(22,3206,0.98),(22,3207,5.04),(22,3208,18.4804),(22,3209,22.68),(22,3210,2.28683),(22,3211,5.88),(22,3212,7.14),(22,3213,0.98),(22,3214,1.19),(22,3215,1.68),(22,3216,3.78),(22,3217,3.99),(22,3218,0.18669),(22,3219,1.00331),(22,3220,1.07331),(22,3221,0.84),(22,3222,2.73),(22,3223,3.42993),(22,3224,8.96112),(22,3225,1.77338),(22,3226,2.00662),(22,3227,1.07331),(22,3228,1.19),(22,3229,1.91338),(22,3230,1.23669),(22,3231,1.07331),(22,3232,19.5995),(22,3233,1.35331),(22,3234,1.30669),(22,3235,1.33),(22,3236,1.12),(22,3237,1.16669),(22,3238,1.16669),(22,3239,1.12),(22,3240,1.16669),(22,3241,1.16669),(22,3242,1.16669),(22,3243,1.16669),(22,3244,1.16669),(22,3245,1.16669),(22,3246,1.16669),(22,3247,1.19),(22,3248,1.19),(22,3249,1.19),(22,3250,1.23669),(22,3251,1.23669),(22,3252,1.23669),(22,3253,1.23669),(22,3254,0.91),(22,3255,1.05),(22,3256,1.82),(22,3257,2.05338),(22,3258,2.73),(22,3259,2.94),(22,3260,11.83),(22,3261,12.74),(22,3262,2.58993),(22,3263,2.94),(22,3264,0.84),(22,3265,2.79993),(22,3266,2.94),(22,3267,0.37338),(22,3268,1.96),(22,3269,1.09669),(22,3270,1.07331),(22,3271,1.53993),(22,3272,2.00662),(22,3273,2.24),(22,3274,1.05),(22,3275,1.09669),(22,3276,0.56007),(22,3277,2.58993),(22,3278,3.08007),(22,3279,0.51331),(22,3280,1.14331),(22,3281,1.35331),(23,11,0.63996),(23,346,2.08008),(23,424,0.56004),(24,11,0.63996),(24,25,0.84),(24,175,0.18676),(24,204,2.66007),(24,228,1.02669),(24,266,1.07331),(24,296,0.23331),(24,346,2.08008),(24,424,0.56004),(24,425,0.09331),(24,3047,0.98),(24,3048,1.16669),(24,3126,1.02669),(24,3127,1.21331),(24,3775,0.91),(24,3776,1.02669),(24,3777,1.07331),(24,3778,0.98),(24,3779,1.14331),(24,3780,0.93331),(24,3781,1.07331),(24,3822,1.02669),(24,3823,1.16669),(24,3824,0.37331),(24,3825,1.16669),(24,3826,1.30669),(24,3827,0.28),(24,3828,0.91),(24,3829,1.14331),(25,11,0.63996),(25,175,0.04669),(25,293,0.18669),(25,294,0.86331),(25,296,0.46662),(25,346,2.08008),(25,379,0.18662),(25,390,0.14),(25,424,0.56004),(25,434,0.09331),(25,3204,0.09331),(25,3838,0.88669),(25,3839,0.95669),(25,3840,0.95669),(25,3841,1.96),(25,3842,2.28662),(25,3843,0.46669),(25,3844,1.05),(25,3845,1.16669),(25,3846,0.28),(25,3847,1.02669),(25,3848,1.21331),(25,3849,0.84),(25,3850,0.98),(25,3851,0.23331),(25,3852,0.93331),(25,3853,1.02669),(25,3854,2.05338),(25,3855,1.14331),(25,3856,1.19),(25,3857,0.84),(25,3858,0.93331),(25,3859,0.37331),(25,3860,1.00331),(25,3861,1.19),(25,3862,1.02662),(25,3863,1.07331),(25,3864,1.19),(25,3865,1.12),(25,3866,1.19),(25,3867,0.84),(25,3868,0.95669),(25,4123,0.18669),(25,4124,0.91),(25,4125,0.98),(25,4126,0.65338),(25,4127,0.93331),(25,4128,1.02669),(25,4129,0.93331),(25,4130,1.05),(25,4131,0.14),(25,4132,0.86331),(25,4133,0.95669),(25,4134,0.37331),(25,4135,1.00331),(25,4136,1.14331),(25,4137,0.18669),(25,4138,1.05),(25,4139,1.14331),(25,4140,0.18669),(25,4141,0.93331),(25,4142,1.05),(25,4143,0.86331),(25,4144,0.95669),(25,4145,0.37331),(25,4146,1.00331),(25,4147,1.07331),(25,4148,0.23331),(25,4149,0.98),(25,4150,1.16669),(25,4151,0.28),(25,4152,0.93331),(25,4153,1.05),(26,175,0.14007),(26,346,2.08008),(26,379,0.09331),(26,424,0.56004),(26,4250,0.98),(26,4251,1.19),(26,4252,0.91),(26,4253,1.05),(26,4254,0.84),(26,4255,0.93331),(26,4256,0.46669),(26,4257,1.26),(26,4258,1.4),(26,4259,1.00331),(26,4260,1.33),(26,4338,0.23331),(26,4339,0.93331),(26,4340,1.05),(26,4341,0.37331),(26,4342,1.02669),(26,4343,1.14331),(27,175,0.18676),(27,299,0.09331),(27,338,0.93338),(27,339,1.05),(27,346,2.08008),(27,352,0.65338),(27,365,0.32669),(27,370,0.93345),(27,375,1.07331),(27,376,1.33),(27,406,0.37338),(27,424,0.56004),(27,434,0.09331),(27,3138,0.28),(27,3151,0.56),(27,3168,0.93331),(27,3195,0.7),(27,3196,4.43345),(27,3199,1.16669),(27,3210,0.32669),(27,3279,0.51331),(27,4367,0.84),(27,4368,0.95669),(27,4369,0.95669),(27,4370,1.02669),(27,4371,0.81669),(27,4372,0.95669),(27,4373,0.95669),(27,4374,1.02669),(27,4375,0.93331),(27,4376,1.00331),(27,4377,1.16669),(27,4378,1.14331),(27,4379,1.33),(27,4380,1.05),(27,4381,1.12),(27,4382,0.98),(27,4383,1.05),(27,4384,0.93331),(27,4385,1.12),(27,4386,1.86662),(27,4387,1.02669),(27,4388,1.02669),(27,4389,0.91),(27,4390,1.09669),(27,4391,0.91),(27,4392,1.14331),(27,4393,0.93331),(27,4394,1.09669),(27,4395,0.88669),(27,4396,1.02669),(27,4397,0.91),(27,4398,1.05),(27,4631,0.98),(27,4632,1.09669),(27,4633,0.51331),(27,4634,1.07331),(27,4635,1.16669),(27,4636,0.88669),(27,4637,1.02669),(27,4638,0.93331),(27,4639,1.19),(27,4640,0.86331),(27,4641,0.98),(27,4642,1.02669),(27,4643,2.05338),(27,4644,1.00331),(27,4645,1.00331),(27,4646,1.02669),(27,4647,1.21331),(27,4648,1.12),(27,4649,1.28331),(28,175,0.18676),(28,299,0.09331),(28,338,0.93338),(28,339,1.05),(28,346,2.08008),(28,352,0.65338),(28,365,0.32669),(28,370,0.93345),(28,375,1.07331),(28,376,1.33),(28,406,0.37338),(28,424,0.56004),(28,434,0.09331),(28,3138,0.28),(28,3151,0.56),(28,3168,0.93331),(28,3195,0.7),(28,3196,4.43345),(28,3199,1.16669),(28,3210,0.32669),(28,3279,0.51331),(28,4367,0.84),(28,4368,0.95669),(28,4369,0.95669),(28,4370,1.02669),(28,4371,0.81669),(28,4372,0.95669),(28,4373,0.95669),(28,4374,1.02669),(28,4375,0.93331),(28,4376,1.00331),(28,4377,1.16669),(28,4378,1.14331),(28,4379,1.33),(28,4380,1.05),(28,4381,1.12),(28,4382,0.98),(28,4383,1.05),(28,4384,0.93331),(28,4385,1.12),(28,4386,1.86662),(28,4387,1.02669),(28,4388,1.02669),(28,4389,0.91),(28,4390,1.09669),(28,4391,0.91),(28,4392,1.14331),(28,4393,0.93331),(28,4394,1.09669),(28,4395,0.88669),(28,4396,1.02669),(28,4397,0.91),(28,4398,1.05),(28,4631,0.98),(28,4632,1.09669),(28,4633,0.51331),(28,4634,1.07331),(28,4635,1.16669),(28,4636,0.88669),(28,4637,1.02669),(28,4638,0.93331),(28,4639,1.19),(28,4640,0.86331),(28,4641,0.98),(28,4642,1.02669),(28,4643,2.05338),(28,4644,1.00331),(28,4645,1.00331),(28,4646,1.02669),(28,4647,1.21331),(28,4648,1.12),(28,4649,1.28331),(29,175,0.18676),(29,299,0.09331),(29,338,0.93338),(29,339,1.05),(29,346,2.08008),(29,352,0.65338),(29,365,0.32669),(29,370,0.93345),(29,375,1.07331),(29,376,1.33),(29,406,0.37338),(29,424,0.56004),(29,434,0.09331),(29,3138,0.28),(29,3151,0.56),(29,3168,0.93331),(29,3195,0.7),(29,3196,4.43345),(29,3199,1.16669),(29,3210,0.32669),(29,3279,0.51331),(29,4367,0.84),(29,4368,0.95669),(29,4369,0.95669),(29,4370,1.02669),(29,4371,0.81669),(29,4372,0.95669),(29,4373,0.95669),(29,4374,1.02669),(29,4375,0.93331),(29,4376,1.00331),(29,4377,1.16669),(29,4378,1.14331),(29,4379,1.33),(29,4380,1.05),(29,4381,1.12),(29,4382,0.98),(29,4383,1.05),(29,4384,0.93331),(29,4385,1.12),(29,4386,1.86662),(29,4387,1.02669),(29,4388,1.02669),(29,4389,0.91),(29,4390,1.09669),(29,4391,0.91),(29,4392,1.14331),(29,4393,0.93331),(29,4394,1.09669),(29,4395,0.88669),(29,4396,1.02669),(29,4397,0.91),(29,4398,1.05),(29,4631,0.98),(29,4632,1.09669),(29,4633,0.51331),(29,4634,1.07331),(29,4635,1.16669),(29,4636,0.88669),(29,4637,1.02669),(29,4638,0.93331),(29,4639,1.19),(29,4640,0.86331),(29,4641,0.98),(29,4642,1.02669),(29,4643,2.05338),(29,4644,1.00331),(29,4645,1.00331),(29,4646,1.02669),(29,4647,1.21331),(29,4648,1.12),(29,4649,1.28331),(30,175,0.18676),(30,299,0.09331),(30,338,0.93338),(30,339,1.05),(30,346,2.08008),(30,352,0.65338),(30,365,0.32669),(30,370,0.93345),(30,375,1.07331),(30,376,1.33),(30,406,0.37338),(30,424,0.56004),(30,434,0.09331),(30,3138,0.28),(30,3151,0.56),(30,3168,0.93331),(30,3195,0.7),(30,3196,4.43345),(30,3199,1.16669),(30,3210,0.32669),(30,3279,0.51331),(30,4367,0.84),(30,4368,0.95669),(30,4369,0.95669),(30,4370,1.02669),(30,4371,0.81669),(30,4372,0.95669),(30,4373,0.95669),(30,4374,1.02669),(30,4375,0.93331),(30,4376,1.00331),(30,4377,1.16669),(30,4378,1.14331),(30,4379,1.33),(30,4380,1.05),(30,4381,1.12),(30,4382,0.98),(30,4383,1.05),(30,4384,0.93331),(30,4385,1.12),(30,4386,1.86662),(30,4387,1.02669),(30,4388,1.02669),(30,4389,0.91),(30,4390,1.09669),(30,4391,0.91),(30,4392,1.14331),(30,4393,0.93331),(30,4394,1.09669),(30,4395,0.88669),(30,4396,1.02669),(30,4397,0.91),(30,4398,1.05),(30,4631,0.98),(30,4632,1.09669),(30,4633,0.51331),(30,4634,1.07331),(30,4635,1.16669),(30,4636,0.88669),(30,4637,1.02669),(30,4638,0.93331),(30,4639,1.19),(30,4640,0.86331),(30,4641,0.98),(30,4642,1.02669),(30,4643,2.05338),(30,4644,1.00331),(30,4645,1.00331),(30,4646,1.02669),(30,4647,1.21331),(30,4648,1.12),(30,4649,1.28331),(31,175,0.18676),(31,299,0.09331),(31,338,0.93338),(31,339,1.05),(31,346,2.08008),(31,352,0.65338),(31,365,0.32669),(31,370,0.93345),(31,375,1.07331),(31,376,1.33),(31,406,0.37338),(31,424,0.56004),(31,434,0.09331),(31,3138,0.28),(31,3151,0.56),(31,3168,0.93331),(31,3195,0.7),(31,3196,4.43345),(31,3199,1.16669),(31,3210,0.32669),(31,3279,0.51331),(31,4367,0.84),(31,4368,0.95669),(31,4369,0.95669),(31,4370,1.02669),(31,4371,0.81669),(31,4372,0.95669),(31,4373,0.95669),(31,4374,1.02669),(31,4375,0.93331),(31,4376,1.00331),(31,4377,1.16669),(31,4378,1.14331),(31,4379,1.33),(31,4380,1.05),(31,4381,1.12),(31,4382,0.98),(31,4383,1.05),(31,4384,0.93331),(31,4385,1.12),(31,4386,1.86662),(31,4387,1.02669),(31,4388,1.02669),(31,4389,0.91),(31,4390,1.09669),(31,4391,0.91),(31,4392,1.14331),(31,4393,0.93331),(31,4394,1.09669),(31,4395,0.88669),(31,4396,1.02669),(31,4397,0.91),(31,4398,1.05),(31,4631,0.98),(31,4632,1.09669),(31,4633,0.51331),(31,4634,1.07331),(31,4635,1.16669),(31,4636,0.88669),(31,4637,1.02669),(31,4638,0.93331),(31,4639,1.19),(31,4640,0.86331),(31,4641,0.98),(31,4642,1.02669),(31,4643,2.05338),(31,4644,1.00331),(31,4645,1.00331),(31,4646,1.02669),(31,4647,1.21331),(31,4648,1.12),(31,4649,1.28331),(32,175,0.18676),(32,299,0.09331),(32,338,0.93338),(32,339,1.05),(32,346,2.08008),(32,352,0.65338),(32,365,0.32669),(32,370,0.93345),(32,375,1.07331),(32,376,1.33),(32,406,0.37338),(32,424,0.56004),(32,434,0.09331),(32,3138,0.28),(32,3151,0.56),(32,3168,0.93331),(32,3195,0.7),(32,3196,4.43345),(32,3199,1.16669),(32,3210,0.32669),(32,3279,0.51331),(32,4367,0.84),(32,4368,0.95669),(32,4369,0.95669),(32,4370,1.02669),(32,4371,0.81669),(32,4372,0.95669),(32,4373,0.95669),(32,4374,1.02669),(32,4375,0.93331),(32,4376,1.00331),(32,4377,1.16669),(32,4378,1.14331),(32,4379,1.33),(32,4380,1.05),(32,4381,1.12),(32,4382,0.98),(32,4383,1.05),(32,4384,0.93331),(32,4385,1.12),(32,4386,1.86662),(32,4387,1.02669),(32,4388,1.02669),(32,4389,0.91),(32,4390,1.09669),(32,4391,0.91),(32,4392,1.14331),(32,4393,0.93331),(32,4394,1.09669),(32,4395,0.88669),(32,4396,1.02669),(32,4397,0.91),(32,4398,1.05),(32,4631,0.98),(32,4632,1.09669),(32,4633,0.51331),(32,4634,1.07331),(32,4635,1.16669),(32,4636,0.88669),(32,4637,1.02669),(32,4638,0.93331),(32,4639,1.19),(32,4640,0.86331),(32,4641,0.98),(32,4642,1.02669),(32,4643,2.05338),(32,4644,1.00331),(32,4645,1.00331),(32,4646,1.02669),(32,4647,1.21331),(32,4648,1.12),(32,4649,1.28331),(33,175,0.18676),(33,299,0.09331),(33,338,0.93338),(33,339,1.05),(33,346,2.08008),(33,352,0.65338),(33,365,0.32669),(33,370,0.93345),(33,375,1.07331),(33,376,1.33),(33,406,0.37338),(33,424,0.56004),(33,434,0.09331),(33,3138,0.28),(33,3151,0.56),(33,3168,0.93331),(33,3195,0.7),(33,3196,4.43345),(33,3199,1.16669),(33,3210,0.32669),(33,3279,0.51331),(33,4367,0.84),(33,4368,0.95669),(33,4369,0.95669),(33,4370,1.02669),(33,4371,0.81669),(33,4372,0.95669),(33,4373,0.95669),(33,4374,1.02669),(33,4375,0.93331),(33,4376,1.00331),(33,4377,1.16669),(33,4378,1.14331),(33,4379,1.33),(33,4380,1.05),(33,4381,1.12),(33,4382,0.98),(33,4383,1.05),(33,4384,0.93331),(33,4385,1.12),(33,4386,1.86662),(33,4387,1.02669),(33,4388,1.02669),(33,4389,0.91),(33,4390,1.09669),(33,4391,0.91),(33,4392,1.14331),(33,4393,0.93331),(33,4394,1.09669),(33,4395,0.88669),(33,4396,1.02669),(33,4397,0.91),(33,4398,1.05),(33,4631,0.98),(33,4632,1.09669),(33,4633,0.51331),(33,4634,1.07331),(33,4635,1.16669),(33,4636,0.88669),(33,4637,1.02669),(33,4638,0.93331),(33,4639,1.19),(33,4640,0.86331),(33,4641,0.98),(33,4642,1.02669),(33,4643,2.05338),(33,4644,1.00331),(33,4645,1.00331),(33,4646,1.02669),(33,4647,1.21331),(33,4648,1.12),(33,4649,1.28331),(34,175,0.18676),(34,299,0.09331),(34,338,0.93338),(34,339,1.05),(34,346,2.08008),(34,352,0.65338),(34,365,0.32669),(34,370,0.93345),(34,375,1.07331),(34,376,1.33),(34,406,0.37338),(34,424,0.56004),(34,434,0.09331),(34,3138,0.28),(34,3151,0.56),(34,3168,0.93331),(34,3195,0.7),(34,3196,4.43345),(34,3199,1.16669),(34,3210,0.32669),(34,3279,0.51331),(34,4367,0.84),(34,4368,0.95669),(34,4369,0.95669),(34,4370,1.02669),(34,4371,0.81669),(34,4372,0.95669),(34,4373,0.95669),(34,4374,1.02669),(34,4375,0.93331),(34,4376,1.00331),(34,4377,1.16669),(34,4378,1.14331),(34,4379,1.33),(34,4380,1.05),(34,4381,1.12),(34,4382,0.98),(34,4383,1.05),(34,4384,0.93331),(34,4385,1.12),(34,4386,1.86662),(34,4387,1.02669),(34,4388,1.02669),(34,4389,0.91),(34,4390,1.09669),(34,4391,0.91),(34,4392,1.14331),(34,4393,0.93331),(34,4394,1.09669),(34,4395,0.88669),(34,4396,1.02669),(34,4397,0.91),(34,4398,1.05),(34,4631,0.98),(34,4632,1.09669),(34,4633,0.51331),(34,4634,1.07331),(34,4635,1.16669),(34,4636,0.88669),(34,4637,1.02669),(34,4638,0.93331),(34,4639,1.19),(34,4640,0.86331),(34,4641,0.98),(34,4642,1.02669),(34,4643,2.05338),(34,4644,1.00331),(34,4645,1.00331),(34,4646,1.02669),(34,4647,1.21331),(34,4648,1.12),(34,4649,1.28331),(35,175,0.18676),(35,299,0.09331),(35,338,0.93338),(35,339,1.05),(35,346,2.08008),(35,352,0.65338),(35,365,0.32669),(35,370,0.93345),(35,375,1.07331),(35,376,1.33),(35,406,0.37338),(35,424,0.56004),(35,434,0.09331),(35,3138,0.28),(35,3151,0.56),(35,3168,0.93331),(35,3195,0.7),(35,3196,4.43345),(35,3199,1.16669),(35,3210,0.32669),(35,3279,0.51331),(35,4367,0.84),(35,4368,0.95669),(35,4369,0.95669),(35,4370,1.02669),(35,4371,0.81669),(35,4372,0.95669),(35,4373,0.95669),(35,4374,1.02669),(35,4375,0.93331),(35,4376,1.00331),(35,4377,1.16669),(35,4378,1.14331),(35,4379,1.33),(35,4380,1.05),(35,4381,1.12),(35,4382,0.98),(35,4383,1.05),(35,4384,0.93331),(35,4385,1.12),(35,4386,1.86662),(35,4387,1.02669),(35,4388,1.02669),(35,4389,0.91),(35,4390,1.09669),(35,4391,0.91),(35,4392,1.14331),(35,4393,0.93331),(35,4394,1.09669),(35,4395,0.88669),(35,4396,1.02669),(35,4397,0.91),(35,4398,1.05),(35,4631,0.98),(35,4632,1.09669),(35,4633,0.51331),(35,4634,1.07331),(35,4635,1.16669),(35,4636,0.88669),(35,4637,1.02669),(35,4638,0.93331),(35,4639,1.19),(35,4640,0.86331),(35,4641,0.98),(35,4642,1.02669),(35,4643,2.05338),(35,4644,1.00331),(35,4645,1.00331),(35,4646,1.02669),(35,4647,1.21331),(35,4648,1.12),(35,4649,1.28331),(36,175,0.14007),(36,346,2.08008),(36,379,0.09331),(36,424,0.56004),(36,4250,0.98),(36,4251,1.19),(36,4252,0.91),(36,4253,1.05),(36,4254,0.84),(36,4255,0.93331),(36,4256,0.46669),(36,4257,1.26),(36,4258,1.4),(36,4259,1.00331),(36,4260,1.33),(36,4338,1.46652),(36,4339,5.86652),(36,4340,1.05),(36,4341,0.37331),(36,4342,1.02669),(36,4343,1.14331),(37,175,0.14007),(37,346,2.08008),(37,379,0.09331),(37,424,0.56004),(37,4250,0.98),(37,4251,1.19),(37,4252,0.91),(37,4253,1.05),(37,4254,0.84),(37,4255,0.93331),(37,4256,0.46669),(37,4257,1.26),(37,4258,1.4),(37,4259,1.00331),(37,4260,1.33),(37,4338,0.23331),(37,4339,0.93331),(37,4340,1.05),(37,4341,0.37331),(37,4342,1.02669),(37,4343,1.14331),(38,175,0.14007),(38,346,2.08008),(38,379,0.09331),(38,424,0.56004),(38,4250,0.98),(38,4251,1.19),(38,4252,0.91),(38,4253,1.05),(38,4254,0.84),(38,4255,0.93331),(38,4256,0.46669),(38,4257,1.26),(38,4258,1.4),(38,4259,1.00331),(38,4260,1.33),(38,4338,0.23331),(38,4339,0.93331),(38,4340,1.05),(38,4341,0.37331),(38,4342,1.02669),(38,4343,1.14331),(39,11,0.63996),(39,296,0.23331),(39,299,0.18662),(39,346,2.08008),(39,347,0.56),(39,370,0.37338),(39,424,0.56004),(39,434,0.46655),(39,441,0.28),(39,3151,0.42),(39,3174,0.28),(39,3177,0.56),(39,3195,0.28),(39,3196,1.77338),(39,3207,0.28),(39,3208,1.02669),(39,3209,1.26),(39,4131,0.14),(39,4636,0.88669),(39,4738,0.95669),(39,4739,1.09669),(39,4740,1.02669),(39,4741,1.09669),(39,4742,1.00331),(39,4743,1.07331),(39,4744,0.91),(39,4745,1.00331),(39,4746,1.02669),(39,4747,1.23669),(39,4748,1.02669),(39,4749,1.19),(39,4750,0.88669),(39,4751,1.02669),(39,4752,0.98),(39,4753,1.05),(39,4754,1.72662),(39,4755,2.00662),(39,4756,0.86331),(39,4757,1.00331),(39,4758,0.95669),(39,4759,1.19),(39,4760,1.07331),(39,4761,1.23669),(39,4943,1.05),(39,4944,1.21331),(39,4945,1.00331),(39,4946,0.95669),(39,4947,1.23669),(39,4948,0.91),(39,4949,1.12),(39,4950,0.95669),(39,4951,1.07331),(39,4952,1.00331),(39,4953,1.14331),(39,4954,1.07331),(39,4955,1.26),(39,4956,0.93331),(39,4957,1.12),(39,4958,1.12),(39,4959,0.98),(39,4960,0.23331),(39,4961,0.88669),(39,4962,1.12),(39,4963,0.28),(39,4964,0.95669),(39,4965,1.02669),(39,4966,0.37331),(39,4967,1.00331),(39,4968,1.07331),(40,175,0.28014),(40,194,0.86331),(40,338,2.80014),(40,339,3.15),(40,346,2.08008),(40,352,0.65338),(40,365,0.32669),(40,370,1.68021),(40,375,3.21993),(40,376,3.99),(40,414,0.56007),(40,415,0.88669),(40,416,1.00331),(40,424,2.28683),(40,434,0.55986),(40,441,0.56),(40,448,0.69993),(40,454,0.88669),(40,3138,0.84),(40,3151,1.4),(40,3166,0.93331),(40,3168,0.93331),(40,3174,0.28),(40,3177,0.28),(40,3195,1.26),(40,3196,7.98021),(40,3199,3.50007),(40,3207,0.28),(40,3208,1.02669),(40,3209,1.26),(40,3215,1.68),(40,4389,0.91),(40,4640,0.86331),(40,4644,1.00331),(40,5000,0.84),(40,5001,1.02669),(40,5002,1.00331),(40,5003,0.86331),(40,5004,0.98),(40,5005,0.93331),(40,5006,1.02669),(40,5007,0.84),(40,5008,0.95669),(40,5009,0.88669),(40,5010,1.19),(40,5011,1.19),(40,5012,1.14331),(40,5013,1.14331),(40,5014,1.16669),(40,5015,1.26),(40,5016,1.09669),(40,5017,1.14331),(40,5018,1.02669),(40,5019,1.14331),(40,5020,1.09669),(40,5021,1.4),(40,5022,1.02669),(40,5023,1.09669),(40,5024,0.95669),(40,5025,1.05),(40,5026,1.00331),(40,5027,1.09669),(40,5028,0.91),(40,5029,1.09669),(40,5030,0.98),(40,5031,1.05),(40,5032,0.95669),(40,5033,1.09669),(40,5034,1.07331),(40,5035,1.00331),(40,5036,1.16669),(40,5037,1.72679),(40,5038,5.55),(40,5039,5.79679),(40,5040,0.95669),(40,5041,1.19),(40,5042,0.93331),(40,5043,1.02669),(40,5044,4.81),(40,5045,0.98),(40,5046,1.12),(40,5047,0.91),(40,5048,1.00331),(40,5049,0.81669),(40,5050,0.95669),(40,5051,0.91),(40,5052,1.02669),(40,5053,1.05),(40,5054,1.21331),(40,5055,0.93331),(40,5056,1.02669),(40,5057,1.07331),(40,5058,1.28331),(40,5059,1.05),(40,5060,1.19),(40,5061,1.07331),(40,5062,1.05),(40,5063,1.26),(40,5064,0.91),(40,5065,1.02669),(40,5373,1.00331),(40,5374,1.07331),(40,5375,1.05),(40,5376,1.14331),(40,5377,0.93331),(40,5378,1.09669),(40,5379,0.88669),(40,5380,1.02669),(40,5381,0.95669),(40,5382,1.09669),(40,5383,0.93331),(40,5384,1.05),(40,5385,0.91),(40,5386,1.02669),(40,5387,0.91),(40,5388,1.05),(40,5389,1.02669),(40,5390,1.02669),(40,5391,1.09669),(40,5392,0.93331),(40,5393,1.07331),(40,5394,1.00331),(40,5395,1.07331),(40,5396,0.95669),(40,5397,1.19),(40,5398,0.95669),(40,5399,1.19),(40,5400,1.02669),(40,5401,1.14331),(40,5402,1.09669),(40,5403,1.00331),(40,5404,1.07331),(40,5405,1.05),(40,5406,1.09669),(40,5407,1.12),(40,5408,1.28331),(40,5409,1.14331),(40,5410,1.28331),(40,5411,1.07331),(40,5412,1.30669),(41,175,0.28014),(41,194,0.86331),(41,338,2.80014),(41,339,3.15),(41,346,2.08008),(41,352,0.65338),(41,365,0.32669),(41,370,1.68021),(41,375,3.21993),(41,376,3.99),(41,414,0.56007),(41,415,0.88669),(41,416,1.00331),(41,424,2.28683),(41,434,0.55986),(41,441,0.56),(41,448,0.69993),(41,454,0.88669),(41,3138,0.84),(41,3151,1.4),(41,3166,0.93331),(41,3168,0.93331),(41,3174,0.28),(41,3177,0.28),(41,3195,1.26),(41,3196,7.98021),(41,3199,3.50007),(41,3207,0.28),(41,3208,1.02669),(41,3209,1.26),(41,3215,1.68),(41,4389,0.91),(41,4640,0.86331),(41,4644,1.00331),(41,5000,0.84),(41,5001,1.02669),(41,5002,1.00331),(41,5003,0.86331),(41,5004,0.98),(41,5005,0.93331),(41,5006,1.02669),(41,5007,0.84),(41,5008,0.95669),(41,5009,0.88669),(41,5010,1.19),(41,5011,1.19),(41,5012,1.14331),(41,5013,1.14331),(41,5014,1.16669),(41,5015,1.26),(41,5016,1.09669),(41,5017,1.14331),(41,5018,1.02669),(41,5019,1.14331),(41,5020,1.09669),(41,5021,1.4),(41,5022,1.02669),(41,5023,1.09669),(41,5024,0.95669),(41,5025,1.05),(41,5026,1.00331),(41,5027,1.09669),(41,5028,0.91),(41,5029,1.09669),(41,5030,0.98),(41,5031,1.05),(41,5032,0.95669),(41,5033,1.09669),(41,5034,1.07331),(41,5035,1.00331),(41,5036,1.16669),(41,5037,1.72679),(41,5038,5.55),(41,5040,0.95669),(41,5041,1.19),(41,5042,0.93331),(41,5043,1.02669),(41,5045,0.98),(41,5046,1.12),(41,5047,0.91),(41,5048,1.00331),(41,5049,0.81669),(41,5050,0.95669),(41,5051,0.91),(41,5052,1.02669),(41,5053,1.05),(41,5054,1.21331),(41,5055,0.93331),(41,5056,1.02669),(41,5057,1.07331),(41,5058,1.28331),(41,5059,1.05),(41,5060,1.19),(41,5061,1.07331),(41,5062,1.05),(41,5063,1.26),(41,5064,0.91),(41,5065,1.02669),(41,5373,1.00331),(41,5374,1.07331),(41,5375,1.05),(41,5376,1.14331),(41,5377,0.93331),(41,5378,1.09669),(41,5379,0.88669),(41,5380,1.02669),(41,5381,0.95669),(41,5382,1.09669),(41,5383,0.93331),(41,5384,1.05),(41,5385,0.91),(41,5386,1.02669),(41,5387,0.91),(41,5388,1.05),(41,5389,1.02669),(41,5390,1.02669),(41,5391,1.09669),(41,5392,0.93331),(41,5393,1.07331),(41,5394,1.00331),(41,5395,1.07331),(41,5396,0.95669),(41,5397,1.19),(41,5398,0.95669),(41,5399,1.19),(41,5400,1.02669),(41,5401,1.14331),(41,5402,1.09669),(41,5403,1.00331),(41,5404,1.07331),(41,5405,1.05),(41,5406,1.09669),(41,5407,1.12),(41,5408,1.28331),(41,5409,1.14331),(41,5410,1.28331),(41,5411,1.07331),(41,5412,1.30669),(41,5491,5.92),(41,5492,4.93321),(42,175,0.28014),(42,194,0.86331),(42,338,2.80014),(42,339,3.15),(42,346,2.08008),(42,352,0.65338),(42,365,0.32669),(42,370,1.68021),(42,375,3.21993),(42,376,3.99),(42,414,0.56007),(42,415,0.88669),(42,416,1.00331),(42,424,2.28683),(42,434,0.55986),(42,441,0.56),(42,448,0.69993),(42,454,0.88669),(42,3138,0.84),(42,3151,1.4),(42,3166,0.93331),(42,3168,0.93331),(42,3174,0.28),(42,3177,0.28),(42,3195,1.26),(42,3196,7.98021),(42,3199,3.50007),(42,3207,0.28),(42,3208,1.02669),(42,3209,1.26),(42,3215,1.68),(42,4389,0.91),(42,4640,0.86331),(42,4644,1.00331),(42,5000,0.84),(42,5001,1.02669),(42,5002,1.00331),(42,5003,0.86331),(42,5004,0.98),(42,5005,0.93331),(42,5006,1.02669),(42,5007,0.84),(42,5008,0.95669),(42,5009,0.88669),(42,5010,1.19),(42,5011,1.19),(42,5012,1.14331),(42,5013,1.14331),(42,5014,1.16669),(42,5015,1.26),(42,5016,1.09669),(42,5017,1.14331),(42,5018,1.02669),(42,5019,1.14331),(42,5020,1.09669),(42,5021,1.4),(42,5022,1.02669),(42,5023,1.09669),(42,5024,0.95669),(42,5025,1.05),(42,5026,1.00331),(42,5027,1.09669),(42,5028,0.91),(42,5029,1.09669),(42,5030,0.98),(42,5031,1.05),(42,5032,0.95669),(42,5033,1.09669),(42,5034,1.07331),(42,5035,1.00331),(42,5036,1.16669),(42,5037,1.72679),(42,5038,5.55),(42,5040,0.95669),(42,5041,1.19),(42,5042,0.93331),(42,5043,1.02669),(42,5045,0.98),(42,5046,1.12),(42,5047,0.91),(42,5048,1.00331),(42,5049,0.81669),(42,5050,0.95669),(42,5051,0.91),(42,5052,1.02669),(42,5053,1.05),(42,5054,1.21331),(42,5055,0.93331),(42,5056,1.02669),(42,5057,1.07331),(42,5058,1.28331),(42,5059,1.05),(42,5060,1.19),(42,5061,1.07331),(42,5062,1.05),(42,5063,1.26),(42,5064,0.91),(42,5065,1.02669),(42,5373,1.00331),(42,5374,1.07331),(42,5375,1.05),(42,5376,1.14331),(42,5377,0.93331),(42,5378,1.09669),(42,5379,0.88669),(42,5380,1.02669),(42,5381,0.95669),(42,5382,1.09669),(42,5383,0.93331),(42,5384,1.05),(42,5385,0.91),(42,5386,1.02669),(42,5387,0.91),(42,5388,1.05),(42,5389,1.02669),(42,5390,1.02669),(42,5391,1.09669),(42,5392,0.93331),(42,5393,1.07331),(42,5394,1.00331),(42,5395,1.07331),(42,5396,0.95669),(42,5397,1.19),(42,5398,0.95669),(42,5399,1.19),(42,5400,1.02669),(42,5401,1.14331),(42,5402,1.09669),(42,5403,1.00331),(42,5404,1.07331),(42,5405,1.05),(42,5406,1.09669),(42,5407,1.12),(42,5408,1.28331),(42,5409,1.14331),(42,5410,1.28331),(42,5411,1.07331),(42,5412,1.30669),(42,5494,6.04321),(42,5495,5.05679),(43,11,0.63996),(43,175,0.09338),(43,346,2.08008),(43,390,0.14),(43,417,0.28),(43,424,0.56004),(43,3218,0.18669),(43,4140,0.18669),(43,4148,0.23331),(43,5505,1.00331),(43,5506,1.16669),(43,5507,0.81669),(43,5508,0.98),(43,5509,0.28),(43,5510,0.91),(43,5511,1.00331),(43,5512,0.42),(43,5513,0.98),(43,5514,1.09669),(43,5515,0.56),(43,5516,1.16669),(43,5517,1.23669),(43,5518,1.05),(43,5519,1.19),(43,5520,0.46669),(43,5521,1.02669),(43,5522,1.30669),(43,5523,0.23331),(43,5524,0.91),(43,5525,1.05),(43,5526,0.91),(43,5527,0.98),(43,5528,0.91),(43,5529,0.98),(43,5530,0.42),(43,5531,0.98),(43,5532,1.21331),(43,5659,0.51331),(43,5660,1.12),(43,5661,1.19),(43,5662,1.00331),(43,5663,1.30669),(43,5664,0.28),(43,5665,1.09669),(43,5666,1.19),(43,5667,0.37331),(43,5668,0.95669),(43,5669,1.07331),(43,5670,0.95669),(43,5671,0.86331),(43,5672,1.14331),(43,5673,0.23331),(43,5674,0.88669),(43,5675,1.00331),(43,5676,1.46652),(43,5677,1.05),(43,5678,1.26),(43,5679,0.28),(43,5680,0.91),(43,5681,1.09669),(43,5682,0.32669),(43,5683,0.93331),(43,5684,0.98),(44,11,0.63996),(44,175,0.09338),(44,299,0.18662),(44,346,2.08008),(44,347,0.28),(44,365,0.32669),(44,370,0.56007),(44,406,0.18669),(44,424,0.56004),(44,434,0.09331),(44,441,1.4),(44,448,0.46662),(44,2996,0.37331),(44,3151,0.7),(44,3174,0.56),(44,3177,0.56),(44,3195,0.42),(44,3196,2.66007),(44,3207,0.56),(44,3208,2.05338),(44,3209,2.52),(44,4633,0.51331),(44,4636,1.77338),(44,4744,0.91),(44,4745,1.00331),(44,4750,1.77338),(44,4751,2.05338),(44,4758,0.95669),(44,4760,4.29324),(44,4945,2.00662),(44,4946,0.95669),(44,4947,1.23669),(44,4950,0.95669),(44,4951,1.07331),(44,4954,1.07331),(44,4955,1.26),(44,4959,1.96),(44,5005,0.93331),(44,5773,0.84),(44,5774,1.07331),(44,5775,1.07331),(44,5776,0.91),(44,5777,1.09669),(44,5778,0.98),(44,5779,1.05),(44,5780,1.00331),(44,5781,1.09669),(44,5782,0.93331),(44,5783,1.02669),(44,5784,1.21331),(44,5785,1.16669),(44,5786,1.19),(44,5787,1.21331),(44,5788,1.28331),(44,5789,1.23669),(44,5790,0.98),(44,5791,1.16669),(44,5792,1.00331),(44,5793,1.19),(44,5794,1.00331),(44,5795,1.16669),(44,5947,1.02669),(44,5948,1.12),(44,5949,1.07331),(44,5950,1.35331),(44,5951,1.77338),(44,5952,1.96),(44,5953,2.58993),(44,5954,2.94),(44,5955,0.98),(44,5956,1.26),(44,5957,1.02669),(45,175,0.4669),(45,346,2.08008),(45,379,0.09331),(45,390,1.4),(45,391,0.81669),(45,411,1.12),(45,417,0.28),(45,424,0.56004),(45,425,0.09331),(45,426,0.79331),(45,3204,0.09331),(45,3221,0.28),(45,3276,0.18669),(45,3827,0.28),(45,3846,0.28),(45,4140,0.18669),(45,5507,0.81669),(45,5992,0.93331),(45,5993,1.12),(45,5994,0.84),(45,5995,0.91),(45,5996,0.95669),(45,5997,1.02669),(45,5998,0.93331),(45,5999,1.09669),(45,6000,0.84),(45,6001,0.95669),(45,6002,0.86331),(45,6003,1.12),(45,6004,1.05),(45,6005,1.33),(45,6006,0.81669),(45,6007,1.05),(45,6008,0.91),(45,6009,1.14331),(45,6010,0.93331),(45,6011,0.65331),(45,6012,1.12),(45,6013,1.21331),(45,6014,0.91),(45,6015,1.00331),(45,6016,0.86331),(45,6017,0.98),(45,6018,0.28),(45,6019,0.93331),(45,6020,1.26),(45,6021,0.28),(45,6022,1.00331),(45,6023,1.23669),(45,6024,1.02669),(45,6025,1.26),(45,6026,1.14331),(45,6027,0.95669),(45,6028,1.21331),(45,6029,1.00331),(45,6030,1.30669),(45,6031,1.00331),(45,6032,1.09669),(45,6033,1.05),(45,6034,1.14331),(45,6035,0.84),(45,6036,1.07331),(45,6037,0.93331),(45,6038,1.02669),(45,6039,1.02669),(45,6040,1.09669),(45,6041,0.88669),(45,6042,1.02669),(45,6043,0.86331),(45,6044,1.00331),(45,6045,0.14),(45,6046,0.86331),(45,6047,0.98),(45,6048,2.28662),(45,6049,1.23669),(45,6050,1.35331),(45,6051,0.42),(45,6052,0.98),(45,6053,1.02669),(45,6054,0.81669),(45,6055,1.00331),(45,6056,0.88669),(45,6057,0.95669),(45,6058,1.00331),(45,6059,0.28),(45,6060,0.91),(45,6061,0.95669),(45,6384,0.46669),(45,6385,1.02669),(45,6386,1.28331),(45,6387,1.02669),(45,6388,1.33),(45,6389,0.23331),(45,6390,0.98),(45,6391,1.26),(45,6392,0.23331),(45,6393,0.91),(45,6394,1.14331),(45,6395,0.86331),(45,6396,0.98),(45,6397,0.42),(45,6398,0.98),(45,6399,1.09669),(45,6400,1.07331),(45,6401,1.16669),(45,6402,1.05),(45,6403,1.19),(45,6404,0.42),(45,6405,0.98),(45,6406,1.02669),(45,6407,1.05),(45,6408,1.14331),(45,6409,0.32669),(45,6410,1.09669),(45,6411,1.16669),(46,61,0.56004),(46,175,0.23345),(46,299,0.74648),(46,315,0.74662),(46,346,2.08008),(46,352,0.65338),(46,365,0.32669),(46,370,0.37338),(46,390,0.28),(46,406,0.56007),(46,414,0.93345),(46,424,0.56004),(46,434,0.46655),(46,441,0.56),(46,442,0.91),(46,448,0.93324),(46,3138,0.56),(46,3151,0.56),(46,3174,0.14),(46,3177,0.56),(46,3195,0.28),(46,3196,1.77338),(46,3215,0.56),(46,3279,1.02662),(46,4369,0.95669),(46,4633,0.51331),(46,4636,0.88669),(46,6389,0.46662),(46,6526,1.07331),(46,6527,0.84),(46,6528,1.00331),(46,6529,0.95669),(46,6530,1.23669),(46,6531,0.93331),(46,6532,1.05),(46,6533,0.95669),(46,6534,1.12),(46,6535,0.86331),(46,6536,1.05),(46,6537,0.88669),(46,6538,1.05),(46,6539,0.91),(46,6540,1.09669),(46,6541,0.88669),(46,6542,1.09669),(46,6543,0.91),(46,6544,0.98),(46,6545,0.91),(46,6546,1.00331),(46,6547,1.05),(46,6548,1.12),(46,6549,0.84),(46,6550,0.95669),(46,6551,0.95669),(46,6552,1.16669),(46,6553,1.05),(46,6554,1.21331),(46,6555,0.51331),(46,6556,1.02669),(46,6557,1.28331),(46,6558,0.46669),(46,6559,1.07331),(46,6560,0.93331),(46,6561,1.12),(46,6562,0.93331),(46,6563,1.07331),(46,6564,1.00331),(46,6565,1.05),(46,6566,0.86331),(46,6567,0.98),(46,6568,1.02669),(46,6569,1.09669),(46,6570,1.00331),(46,6571,1.16669),(46,6572,0.98),(46,6573,1.21331),(46,6574,0.86331),(46,6575,0.95669),(46,6576,0.86331),(46,6577,1.02669),(46,6578,0.95669),(46,6579,1.19),(46,6580,0.91),(46,6581,1.07331),(46,6582,0.86331),(46,6583,1.00331),(46,6584,1.02669),(46,6585,1.07331),(46,6586,1.00331),(46,6587,1.23669),(46,6588,0.98),(46,6589,1.21331),(46,6590,0.28),(46,6591,0.93331),(46,6592,1.16669),(46,6593,0.84),(46,6594,1.07331),(46,6595,0.84),(46,6596,0.95669),(46,6597,0.91),(46,6598,1.07331),(46,6599,0.88669),(46,6600,1.09669),(46,6601,0.86331),(46,6602,0.98),(46,6603,1.07331),(46,6604,0.98),(46,6605,1.14331),(46,6606,0.98),(46,6607,1.12),(46,6608,2.24),(46,6609,1.19),(46,6610,1.37669),(46,6611,0.98),(46,6612,1.09669),(46,7079,1.07331),(46,7080,1.16669),(46,7081,1.07331),(46,7082,1.23669),(46,7083,1.07331),(46,7084,1.19),(46,7085,1.19),(46,7086,1.00331),(46,7087,1.07331),(46,7088,0.91),(46,7089,1.02669),(46,7090,0.98),(46,7091,1.09669),(46,7092,0.98),(46,7093,1.12),(46,7094,0.95669),(46,7095,1.14331),(46,7096,0.93331),(46,7097,1.05),(46,7098,0.37331),(46,7099,0.95669),(46,7100,1.09669),(46,7101,0.32669),(46,7102,0.91),(46,7103,1.12),(46,7104,0.95669),(46,7105,1.12),(46,7106,1.86662),(46,7107,2.1),(46,7108,1.05),(46,7109,1.21331),(46,7110,0.37331),(46,7111,1.00331),(46,7112,1.23669),(46,7113,1.02669),(46,7114,1.19),(46,7115,1.23669),(46,7116,1.35331),(47,61,0.56004),(47,175,0.18676),(47,299,0.83979),(47,315,0.74662),(47,338,0.46669),(47,339,1.05),(47,341,1.30669),(47,346,2.08008),(47,352,0.65338),(47,365,0.65338),(47,370,0.93345),(47,375,1.07331),(47,376,1.33),(47,406,0.56007),(47,414,0.93345),(47,424,0.56004),(47,434,0.55986),(47,441,0.56),(47,442,0.91),(47,448,0.93324),(47,3138,0.56),(47,3151,0.56),(47,3174,0.14),(47,3177,0.56),(47,3195,0.7),(47,3196,4.43345),(47,3199,1.16669),(47,3215,0.56),(47,3279,1.02662),(47,4256,2.46679),(47,4369,0.95669),(47,4633,0.51331),(47,4636,0.88669),(47,6526,1.07331),(47,6529,0.95669),(47,6530,1.23669),(47,6531,0.93331),(47,6532,1.05),(47,6533,0.95669),(47,6534,1.12),(47,6535,0.86331),(47,6536,1.05),(47,6537,0.88669),(47,6538,1.05),(47,6539,0.91),(47,6540,1.09669),(47,6541,0.88669),(47,6542,1.09669),(47,6543,0.91),(47,6544,0.98),(47,6545,0.91),(47,6546,1.00331),(47,6547,1.05),(47,6548,1.12),(47,6549,0.84),(47,6550,0.95669),(47,6551,0.95669),(47,6552,1.16669),(47,6553,1.05),(47,6554,1.21331),(47,6560,0.93331),(47,6561,1.12),(47,6562,0.93331),(47,6563,1.07331),(47,6564,1.00331),(47,6565,1.05),(47,6566,0.86331),(47,6567,0.98),(47,6568,1.02669),(47,6569,1.09669),(47,6574,0.86331),(47,6575,0.95669),(47,6576,0.86331),(47,6577,1.02669),(47,6578,0.95669),(47,6579,1.19),(47,6580,0.91),(47,6581,1.07331),(47,6582,0.86331),(47,6583,1.00331),(47,6584,1.02669),(47,6585,1.07331),(47,6586,1.00331),(47,6587,1.23669),(47,6588,0.98),(47,6589,1.21331),(47,6593,0.84),(47,6594,1.07331),(47,6595,0.84),(47,6596,0.95669),(47,6597,0.91),(47,6598,1.07331),(47,6599,0.88669),(47,6600,1.09669),(47,6601,0.86331),(47,6602,0.98),(47,6603,1.07331),(47,6604,0.98),(47,6605,1.14331),(47,6606,0.98),(47,6607,1.12),(47,6608,2.24),(47,6609,1.19),(47,6610,1.37669),(47,6611,0.98),(47,6612,1.09669),(47,7079,1.07331),(47,7080,1.16669),(47,7081,1.07331),(47,7082,1.23669),(47,7083,1.07331),(47,7084,1.19),(47,7085,1.19),(47,7086,1.00331),(47,7087,1.07331),(47,7088,0.91),(47,7089,1.02669),(47,7090,0.98),(47,7091,1.09669),(47,7092,0.98),(47,7093,1.12),(47,7094,0.95669),(47,7095,1.14331),(47,7096,0.93331),(47,7097,1.05),(47,7104,0.95669),(47,7105,1.12),(47,7108,1.05),(47,7109,1.21331),(47,7110,0.37331),(47,7111,1.00331),(47,7112,1.23669),(47,7113,1.02669),(47,7114,1.19),(47,7115,1.23669),(47,7116,1.35331),(47,7240,0.91),(47,7241,1.02669),(47,7242,5.92),(47,7243,1.07331),(47,7244,1.23669),(47,7245,1.02669),(47,7246,1.19),(47,7247,1.00331),(47,7248,1.12),(47,7249,1.00331),(47,7250,1.07331),(47,7295,1.12),(47,7296,1.09669),(48,61,0.56004),(48,175,0.18676),(48,299,0.83979),(48,315,0.74662),(48,338,0.46669),(48,339,1.05),(48,341,1.30669),(48,346,2.08008),(48,352,0.65338),(48,365,0.65338),(48,370,0.93345),(48,375,1.07331),(48,376,1.33),(48,406,0.56007),(48,414,0.93345),(48,424,0.56004),(48,434,0.55986),(48,441,0.56),(48,442,0.91),(48,448,0.93324),(48,3138,0.56),(48,3151,0.56),(48,3174,0.14),(48,3177,0.56),(48,3195,0.7),(48,3196,4.43345),(48,3199,1.16669),(48,3215,0.56),(48,3279,1.02662),(48,4369,0.95669),(48,4633,0.51331),(48,4636,0.88669),(48,6526,1.07331),(48,6529,0.95669),(48,6530,1.23669),(48,6531,0.93331),(48,6532,1.05),(48,6533,0.95669),(48,6534,1.12),(48,6535,0.86331),(48,6536,1.05),(48,6537,0.88669),(48,6538,1.05),(48,6539,0.91),(48,6540,1.09669),(48,6541,0.88669),(48,6542,1.09669),(48,6543,0.91),(48,6544,0.98),(48,6545,0.91),(48,6546,1.00331),(48,6547,1.05),(48,6548,1.12),(48,6549,0.84),(48,6550,0.95669),(48,6551,0.95669),(48,6552,1.16669),(48,6553,1.05),(48,6554,1.21331),(48,6560,0.93331),(48,6561,1.12),(48,6562,0.93331),(48,6563,1.07331),(48,6564,1.00331),(48,6565,1.05),(48,6566,0.86331),(48,6567,0.98),(48,6568,1.02669),(48,6569,1.09669),(48,6574,0.86331),(48,6575,0.95669),(48,6576,0.86331),(48,6577,1.02669),(48,6578,0.95669),(48,6579,1.19),(48,6580,0.91),(48,6581,1.07331),(48,6582,0.86331),(48,6583,1.00331),(48,6584,1.02669),(48,6585,1.07331),(48,6586,1.00331),(48,6587,1.23669),(48,6588,0.98),(48,6589,1.21331),(48,6593,0.84),(48,6594,1.07331),(48,6595,0.84),(48,6596,0.95669),(48,6597,0.91),(48,6598,1.07331),(48,6599,0.88669),(48,6600,1.09669),(48,6601,0.86331),(48,6602,0.98),(48,6603,1.07331),(48,6604,0.98),(48,6605,1.14331),(48,6606,0.98),(48,6607,1.12),(48,6608,2.24),(48,6609,1.19),(48,6610,1.37669),(48,6611,0.98),(48,6612,1.09669),(48,7079,1.07331),(48,7080,1.16669),(48,7081,1.07331),(48,7082,1.23669),(48,7083,1.07331),(48,7084,1.19),(48,7085,1.19),(48,7086,1.00331),(48,7087,1.07331),(48,7088,0.91),(48,7089,1.02669),(48,7090,0.98),(48,7091,1.09669),(48,7092,0.98),(48,7093,1.12),(48,7094,0.95669),(48,7095,1.14331),(48,7096,0.93331),(48,7097,1.05),(48,7104,0.95669),(48,7105,1.12),(48,7108,1.05),(48,7109,1.21331),(48,7110,0.37331),(48,7111,1.00331),(48,7112,1.23669),(48,7113,1.02669),(48,7114,1.19),(48,7115,1.23669),(48,7116,1.35331),(48,7240,0.91),(48,7241,1.02669),(48,7243,1.07331),(48,7244,1.23669),(48,7245,1.02669),(48,7246,1.19),(48,7247,1.00331),(48,7248,1.12),(48,7249,1.00331),(48,7250,1.07331),(48,7295,1.12),(48,7296,1.09669),(48,7307,1.72679),(49,61,0.56004),(49,175,0.28014),(49,296,1.46652),(49,299,0.74648),(49,315,0.74662),(49,346,2.08008),(49,352,0.32669),(49,365,0.32669),(49,379,0.09331),(49,390,0.42),(49,406,0.37338),(49,414,0.93345),(49,424,0.56004),(49,434,0.18662),(49,441,1.12),(49,442,1.82),(49,448,1.63317),(49,3138,0.28),(49,3151,0.42),(49,3174,0.28),(49,3177,0.56),(49,3215,1.12),(49,3279,0.51331),(49,4369,1.91338),(49,4633,0.51331),(49,4636,1.77338),(49,5682,0.32669),(49,6526,2.14662),(49,6529,0.95669),(49,6530,1.23669),(49,6531,1.86662),(49,6532,2.1),(49,6533,0.95669),(49,6534,1.12),(49,6537,1.77338),(49,6538,2.1),(49,6539,1.82),(49,6540,2.19338),(49,6547,2.1),(49,6548,2.24),(49,6549,1.68),(49,6550,1.91338),(49,6553,2.1),(49,6554,2.42662),(49,6560,0.93331),(49,6561,1.12),(49,6564,1.00331),(49,6565,1.05),(49,6576,0.86331),(49,6577,1.02669),(49,6578,0.95669),(49,6579,1.19),(49,6580,1.82),(49,6581,2.14662),(49,6582,0.86331),(49,6583,1.00331),(49,6584,2.05338),(49,6585,2.14662),(49,6595,1.68),(49,6596,1.91338),(49,6603,2.14662),(49,6604,1.96),(49,6605,2.28662),(49,6606,1.96),(49,6607,2.24),(49,6608,3.36),(49,6609,2.38),(49,6610,1.37669),(49,6611,1.96),(49,6612,2.19338),(49,7081,1.07331),(49,7082,1.23669),(49,7083,1.07331),(49,7084,1.19),(49,7085,2.38),(49,7090,0.98),(49,7091,1.09669),(49,7092,1.96),(49,7093,2.24),(49,7094,1.91338),(49,7095,2.28662),(49,7108,2.1),(49,7109,2.42662),(49,7110,0.74662),(49,7111,2.00662),(49,7112,2.47338),(49,7115,1.23669),(49,7116,1.35331),(49,7312,6.45348),(49,7313,7.18652),(49,7314,0.37331),(49,7315,1.02669),(49,7316,1.09669),(49,7317,0.28),(49,7318,0.86331),(49,7319,1.00331),(49,7320,0.93331),(49,7321,1.02669),(49,7322,0.93331),(49,7323,1.00331),(49,7324,0.84),(49,7325,0.93331),(49,7392,0.42),(49,7393,1.09669),(49,7394,1.19),(49,7395,2.34652),(49,7396,6.30652),(49,7397,6.89348),(49,7398,0.95669),(49,7399,1.02669),(50,175,0.56028),(50,192,0.86331),(50,299,0.74648),(50,315,0.37331),(50,346,2.08008),(50,352,0.65338),(50,365,0.65338),(50,370,0.37338),(50,390,0.14),(50,406,0.74676),(50,414,1.12014),(50,424,0.56004),(50,425,0.09331),(50,426,0.79331),(50,434,0.09331),(50,441,0.56),(50,442,0.91),(50,448,1.16655),(50,3138,0.56),(50,3151,0.7),(50,3174,0.14),(50,3177,0.28),(50,3195,0.28),(50,3196,1.77338),(50,3215,0.56),(50,3279,2.05324),(50,4369,0.95669),(50,4633,1.02662),(50,4636,0.88669),(50,5682,1.72679),(50,6526,1.07331),(50,6529,1.91338),(50,6530,2.47338),(50,6531,0.93331),(50,6532,1.05),(50,6533,1.91338),(50,6534,2.24),(50,6535,1.72662),(50,6536,2.1),(50,6537,0.88669),(50,6538,1.05),(50,6539,0.91),(50,6540,1.09669),(50,6543,1.82),(50,6544,1.96),(50,6547,1.05),(50,6548,1.12),(50,6549,0.84),(50,6550,0.95669),(50,6553,1.05),(50,6554,1.21331),(50,6560,1.86662),(50,6561,2.24),(50,6564,2.00662),(50,6565,2.1),(50,6566,1.72662),(50,6567,1.96),(50,6576,1.72662),(50,6577,2.05338),(50,6578,1.91338),(50,6579,2.38),(50,6580,0.91),(50,6581,1.07331),(50,6582,1.72662),(50,6583,2.00662),(50,6584,1.02669),(50,6585,1.07331),(50,6588,1.96),(50,6589,2.42662),(50,6595,0.84),(50,6596,0.95669),(50,6603,1.07331),(50,6604,0.98),(50,6605,1.14331),(50,6606,0.98),(50,6607,1.12),(50,6608,3.36),(50,6609,1.19),(50,6610,2.75338),(50,6611,0.98),(50,6612,1.09669),(50,7081,2.14662),(50,7082,2.47338),(50,7083,2.14662),(50,7084,2.38),(50,7085,1.19),(50,7086,2.00662),(50,7087,2.14662),(50,7090,1.96),(50,7091,2.19338),(50,7092,0.98),(50,7093,1.12),(50,7094,0.95669),(50,7095,1.14331),(50,7104,1.91338),(50,7108,1.05),(50,7109,1.21331),(50,7110,0.37331),(50,7111,1.00331),(50,7112,1.23669),(50,7113,2.05338),(50,7114,2.38),(50,7115,1.23669),(50,7116,1.35331),(50,7307,1.72679),(50,7324,0.84),(50,7435,1.86662),(50,7436,2.14662),(50,7437,0.86331),(50,7438,0.95669),(50,7439,1.05),(50,7440,0.91),(50,7441,1.19),(50,7442,0.93331),(50,7443,1.00331),(50,7444,0.88669),(50,7445,1.00331),(50,7501,0.37331),(50,7502,0.95669),(50,7503,1.07331),(50,7504,5.18),(50,7505,6.41321),(50,7506,0.23331),(50,7507,0.88669),(50,7508,0.98),(51,175,0.23345),(51,299,0.74648),(51,315,0.74662),(51,346,2.08008),(51,352,0.65338),(51,365,0.32669),(51,370,0.37338),(51,379,0.09331),(51,390,0.14),(51,406,0.56007),(51,414,0.93345),(51,417,0.14),(51,424,0.56004),(51,425,0.09331),(51,426,0.79331),(51,434,0.46655),(51,441,0.56),(51,442,0.91),(51,448,0.93324),(51,3138,0.56),(51,3151,0.56),(51,3174,0.14),(51,3177,0.56),(51,3195,0.28),(51,3196,1.77338),(51,3201,0.69993),(51,3215,0.56),(51,3279,1.02662),(51,4369,0.95669),(51,4633,0.51331),(51,4636,0.88669),(51,6526,1.07331),(51,6529,0.95669),(51,6530,1.23669),(51,6531,0.93331),(51,6532,1.05),(51,6533,0.95669),(51,6534,1.12),(51,6535,0.86331),(51,6536,1.05),(51,6537,0.88669),(51,6538,1.05),(51,6539,0.91),(51,6540,1.09669),(51,6541,0.88669),(51,6542,1.09669),(51,6543,0.91),(51,6544,0.98),(51,6545,0.91),(51,6546,1.00331),(51,6547,1.05),(51,6548,1.12),(51,6549,0.84),(51,6550,0.95669),(51,6551,0.95669),(51,6552,1.16669),(51,6553,1.05),(51,6554,1.21331),(51,6560,0.93331),(51,6561,1.12),(51,6562,0.93331),(51,6563,1.07331),(51,6564,1.00331),(51,6565,1.05),(51,6566,0.86331),(51,6567,0.98),(51,6568,1.02669),(51,6569,1.09669),(51,6574,0.86331),(51,6575,0.95669),(51,6576,0.86331),(51,6577,1.02669),(51,6578,0.95669),(51,6579,1.19),(51,6580,0.91),(51,6581,1.07331),(51,6582,0.86331),(51,6583,1.00331),(51,6584,1.02669),(51,6585,1.07331),(51,6586,1.00331),(51,6587,1.23669),(51,6588,0.98),(51,6589,1.21331),(51,6593,0.84),(51,6594,1.07331),(51,6595,0.84),(51,6596,0.95669),(51,6597,0.91),(51,6598,1.07331),(51,6599,0.88669),(51,6600,1.09669),(51,6601,0.86331),(51,6602,0.98),(51,6603,1.07331),(51,6604,0.98),(51,6605,1.14331),(51,6606,0.98),(51,6607,1.12),(51,6608,2.24),(51,6609,1.19),(51,6610,1.37669),(51,6611,0.98),(51,6612,1.09669),(51,7079,1.07331),(51,7080,1.16669),(51,7081,1.07331),(51,7082,1.23669),(51,7083,1.07331),(51,7084,1.19),(51,7085,1.19),(51,7086,1.00331),(51,7087,1.07331),(51,7088,0.91),(51,7089,1.02669),(51,7090,0.98),(51,7091,1.09669),(51,7092,0.98),(51,7093,1.12),(51,7094,0.95669),(51,7095,1.14331),(51,7096,0.93331),(51,7097,1.05),(51,7098,0.37331),(51,7104,0.95669),(51,7105,1.12),(51,7108,1.05),(51,7109,1.21331),(51,7110,0.37331),(51,7111,1.00331),(51,7112,1.23669),(51,7113,1.02669),(51,7114,1.19),(51,7115,1.23669),(51,7116,1.35331),(51,7435,0.93331),(51,7530,1.07331),(51,7531,0.37331),(51,7532,0.95669),(51,7533,1.21331),(51,7534,0.98),(51,7535,1.09669),(51,7536,0.86331),(51,7537,0.95669),(51,7538,0.88669),(51,7539,1.07331),(51,7540,1.00331),(51,7694,0.98),(51,7695,1.05),(51,7696,0.23331),(51,7697,0.93331),(51,7698,1.14331),(51,7699,3.08007),(51,7700,2.42662),(51,7701,1.21331),(51,7702,2.22),(52,175,0.32683),(52,299,0.9331),(52,315,0.74662),(52,346,2.08008),(52,352,0.32669),(52,365,0.32669),(52,370,0.18669),(52,390,0.88),(52,406,0.37338),(52,414,1.12014),(52,424,0.56004),(52,434,0.27993),(52,441,1.4),(52,442,2.73),(52,448,1.86648),(52,3138,0.28),(52,3151,0.56),(52,3174,0.28),(52,3177,0.56),(52,3195,0.14),(52,3196,0.88669),(52,3215,1.12),(52,3279,1.02662),(52,4369,1.91338),(52,4633,0.51331),(52,4636,1.77338),(52,5682,2.05348),(52,6526,2.14662),(52,6529,0.95669),(52,6530,1.23669),(52,6531,1.86662),(52,6532,2.1),(52,6533,0.95669),(52,6534,1.12),(52,6535,0.86331),(52,6536,1.05),(52,6537,1.77338),(52,6538,2.1),(52,6539,1.82),(52,6540,2.19338),(52,6543,0.91),(52,6544,0.98),(52,6547,2.1),(52,6548,2.24),(52,6549,1.68),(52,6550,1.91338),(52,6553,2.1),(52,6554,2.42662),(52,6560,0.93331),(52,6561,1.12),(52,6564,1.00331),(52,6565,1.05),(52,6566,0.86331),(52,6567,0.98),(52,6576,0.86331),(52,6577,1.02669),(52,6578,0.95669),(52,6579,1.19),(52,6580,1.82),(52,6581,2.14662),(52,6582,0.86331),(52,6583,1.00331),(52,6584,2.05338),(52,6585,2.14662),(52,6588,0.98),(52,6589,1.21331),(52,6595,2.52),(52,6596,2.87007),(52,6603,3.21993),(52,6604,1.96),(52,6605,2.28662),(52,6606,1.96),(52,6607,2.24),(52,6608,4.48),(52,6609,3.57),(52,6610,1.37669),(52,6611,1.96),(52,6612,2.19338),(52,7081,1.07331),(52,7082,1.23669),(52,7083,1.07331),(52,7084,1.19),(52,7085,2.38),(52,7086,1.00331),(52,7087,1.07331),(52,7090,0.98),(52,7091,1.09669),(52,7092,1.96),(52,7093,2.24),(52,7094,1.91338),(52,7095,2.28662),(52,7104,0.95669),(52,7108,2.1),(52,7109,2.42662),(52,7110,0.74662),(52,7111,2.00662),(52,7112,2.47338),(52,7113,1.02669),(52,7114,1.19),(52,7115,1.23669),(52,7116,1.35331),(52,7764,0.84),(52,7765,0.95669),(52,7766,5.05679),(52,7767,5.79679),(52,7768,0.91),(52,7769,1.02669),(52,7770,0.42),(52,7771,1.09669),(52,7772,1.19),(52,7773,0.18669),(52,7774,1.02669),(52,7775,1.21331),(52,7806,1.46652),(52,7807,0.98),(52,7808,1.07331),(52,7809,6.30652),(52,7810,1.16669),(53,175,0.52693),(53,299,0.74648),(53,346,2.08008),(53,352,0.98007),(53,365,0.98007),(53,370,0.74676),(53,406,1.12014),(53,414,1.30683),(53,424,0.56004),(53,448,0.69993),(53,3138,0.84),(53,3151,0.84),(53,3195,0.56),(53,3196,3.54676),(53,3279,3.59317),(53,4633,1.53993),(53,6529,2.87007),(53,6530,3.71007),(53,6533,2.87007),(53,6534,3.36),(53,6535,3.45324),(53,6536,4.2),(53,6543,3.64),(53,6544,3.92),(53,6560,2.79993),(53,6561,3.36),(53,6564,3.00993),(53,6565,3.15),(53,6566,3.45324),(53,6567,3.92),(53,6576,2.58993),(53,6577,3.08007),(53,6578,2.87007),(53,6579,3.57),(53,6582,2.58993),(53,6583,3.00993),(53,6588,3.92),(53,6589,4.85324),(53,6608,3.36),(53,6610,4.13007),(53,7081,3.21993),(53,7082,3.71007),(53,7083,3.21993),(53,7084,3.57),(53,7086,3.00993),(53,7087,3.21993),(53,7090,2.94),(53,7091,3.29007),(53,7104,3.82676),(53,7113,4.10676),(53,7114,4.76),(53,7115,3.71007),(53,7116,4.05993),(53,7806,0.23331),(53,7833,4.56321),(53,7834,5.18),(53,7871,0.23331),(53,7872,0.93331),(53,7873,1.14331),(53,7874,0.98),(53,7875,1.12),(54,293,0.37338),(54,294,1.72662),(54,299,0.55986),(54,310,0.28),(54,315,0.74662),(54,338,0.93338),(54,339,2.1),(54,341,2.61338),(54,346,2.08008),(54,352,0.65338),(54,365,0.65338),(54,370,1.68021),(54,375,2.14662),(54,376,2.66),(54,390,0.56),(54,406,0.37338),(54,414,0.37338),(54,417,0.14),(54,424,0.56004),(54,434,1.11972),(54,3138,0.84),(54,3151,0.28),(54,3177,0.56),(54,3195,1.26),(54,3196,7.98021),(54,3199,2.33338),(54,3846,0.14),(54,6541,1.77338),(54,6542,2.19338),(54,6545,1.82),(54,6546,2.00662),(54,6551,1.91338),(54,6552,2.33338),(54,6562,1.86662),(54,6563,2.14662),(54,6568,2.05338),(54,6569,2.19338),(54,6574,1.72662),(54,6575,1.91338),(54,6586,2.00662),(54,6587,2.47338),(54,6593,1.68),(54,6594,2.14662),(54,6597,2.73),(54,6598,3.21993),(54,6599,2.66007),(54,6600,3.29007),(54,6601,1.72662),(54,6602,1.96),(54,7079,3.21993),(54,7080,3.50007),(54,7088,1.82),(54,7089,2.05338),(54,7096,1.86662),(54,7097,2.1),(54,7105,2.24),(54,7240,1.82),(54,7241,2.05338),(54,7243,2.14662),(54,7244,2.47338),(54,7245,2.05338),(54,7246,2.38),(54,7247,3.00993),(54,7248,3.36),(54,7249,2.00662),(54,7250,2.14662),(54,7295,2.24),(54,7296,3.29007),(54,7894,1.02669),(54,7895,0.98),(54,7896,1.00331),(54,7897,1.21331),(54,7898,0.42),(54,7899,0.98),(54,7900,1.05),(54,7901,0.32669),(54,7902,0.93331),(54,7903,1.14331),(54,7904,0.88669),(54,7905,0.95669),(54,7906,0.88669),(54,7907,0.95669),(54,7908,0.95669),(54,7909,1.02669),(54,7910,0.84),(54,7911,1.07331),(54,7912,0.95669),(54,7913,1.09669),(54,7914,0.91),(54,7915,1.09669),(54,8021,0.23331),(54,8022,1.00331),(54,8023,1.12),(54,8024,0.28),(54,8025,0.95669),(54,8026,1.12),(54,8027,0.42),(54,8028,0.98),(54,8029,1.07331),(55,175,0.04669),(55,299,0.83979),(55,315,1.11993),(55,338,1.40007),(55,339,3.15),(55,341,3.92007),(55,346,2.08008),(55,352,0.98007),(55,365,0.98007),(55,370,2.24028),(55,375,3.21993),(55,376,3.99),(55,379,0.09331),(55,390,0.14),(55,406,0.56007),(55,414,0.56007),(55,417,0.14),(55,424,0.56004),(55,425,0.09331),(55,426,0.79331),(55,434,1.39965),(55,3138,0.84),(55,3151,0.42),(55,3177,0.84),(55,3195,1.68),(55,3196,10.6403),(55,3199,3.50007),(55,3201,0.46662),(55,6541,2.66007),(55,6542,3.29007),(55,6545,2.73),(55,6546,3.00993),(55,6551,2.87007),(55,6552,3.50007),(55,6562,2.79993),(55,6563,3.21993),(55,6568,3.08007),(55,6569,2.19338),(55,6574,2.58993),(55,6575,2.87007),(55,6586,3.00993),(55,6587,3.71007),(55,6593,2.52),(55,6594,3.21993),(55,6597,2.73),(55,6598,3.21993),(55,6599,2.66007),(55,6600,3.29007),(55,6601,2.58993),(55,6602,2.94),(55,7079,3.21993),(55,7080,3.50007),(55,7088,2.73),(55,7089,3.08007),(55,7096,2.79993),(55,7097,3.15),(55,7105,3.36),(55,7240,2.73),(55,7241,3.08007),(55,7243,3.21993),(55,7244,3.71007),(55,7245,3.08007),(55,7246,3.57),(55,7247,3.00993),(55,7248,3.36),(55,7249,3.00993),(55,7250,3.21993),(55,7295,3.36),(55,7296,3.29007),(55,7435,0.93331),(55,7530,1.07331),(55,7534,0.98),(55,7535,1.09669),(55,7536,0.86331),(55,7537,0.95669),(55,7538,0.88669),(55,7539,1.07331),(55,7540,1.00331),(55,7699,2.05338),(55,7700,1.21331),(55,7701,1.21331),(56,299,0.9331),(56,315,1.11993),(56,338,1.86676),(56,339,4.2),(56,341,5.22676),(56,346,2.08008),(56,352,0.98007),(56,365,1.30676),(56,370,2.80035),(56,375,4.29324),(56,376,5.32),(56,406,0.56007),(56,414,0.56007),(56,424,0.56004),(56,434,1.49296),(56,3138,0.84),(56,3151,0.42),(56,3177,0.84),(56,3195,2.1),(56,3196,13.3004),(56,3199,4.66676),(56,6541,2.66007),(56,6542,3.29007),(56,6545,2.73),(56,6546,3.00993),(56,6551,2.87007),(56,6552,3.50007),(56,6562,2.79993),(56,6563,3.21993),(56,6568,3.08007),(56,6569,3.29007),(56,6574,2.58993),(56,6575,2.87007),(56,6586,3.00993),(56,6587,3.71007),(56,6593,2.52),(56,6594,3.21993),(56,6597,2.73),(56,6598,3.21993),(56,6599,2.66007),(56,6600,3.29007),(56,6601,2.58993),(56,6602,2.94),(56,7079,3.21993),(56,7080,3.50007),(56,7088,2.73),(56,7089,3.08007),(56,7096,2.79993),(56,7097,3.15),(56,7105,3.36),(56,7240,3.64),(56,7241,4.10676),(56,7243,4.29324),(56,7244,4.94676),(56,7245,4.10676),(56,7246,4.76),(56,7247,4.01324),(56,7248,4.48),(56,7249,4.01324),(56,7250,4.29324),(56,7295,4.48),(56,7296,4.38676),(57,175,0.23345),(57,293,0.18669),(57,294,0.86331),(57,299,0.46655),(57,315,1.11993),(57,338,0.46669),(57,339,1.05),(57,341,1.30669),(57,346,2.08008),(57,352,0.32669),(57,365,0.32669),(57,370,0.74676),(57,375,1.07331),(57,376,1.33),(57,390,0.42),(57,406,0.18669),(57,414,0.93345),(57,417,0.14),(57,424,0.56004),(57,425,0.55986),(57,432,1.72662),(57,433,1.86662),(57,434,0.74648),(57,441,1.12),(57,442,1.82),(57,448,0.46662),(57,3138,0.28),(57,3151,0.14),(57,3177,0.84),(57,3195,0.56),(57,3196,3.54676),(57,3199,1.16669),(57,3204,0.27993),(57,6531,1.86662),(57,6532,2.1),(57,6541,0.88669),(57,6542,1.09669),(57,6545,0.91),(57,6546,1.00331),(57,6549,1.68),(57,6550,1.91338),(57,6551,0.95669),(57,6552,1.16669),(57,6553,2.1),(57,6554,2.42662),(57,6562,0.93331),(57,6563,1.07331),(57,6568,1.02669),(57,6569,1.09669),(57,6570,2.00662),(57,6571,1.16669),(57,6574,0.86331),(57,6575,0.95669),(57,6580,1.82),(57,6581,2.14662),(57,6584,2.05338),(57,6585,2.14662),(57,6586,1.00331),(57,6587,1.23669),(57,6590,0.28),(57,6591,0.93331),(57,6592,1.16669),(57,6593,0.84),(57,6594,1.07331),(57,6595,1.68),(57,6596,1.91338),(57,6597,0.91),(57,6598,1.07331),(57,6599,0.88669),(57,6600,1.09669),(57,6601,0.86331),(57,6602,0.98),(57,6603,2.14662),(57,6604,1.96),(57,6605,2.28662),(57,6608,2.24),(57,6609,2.38),(57,7079,1.07331),(57,7080,1.16669),(57,7088,0.91),(57,7089,1.02669),(57,7094,1.91338),(57,7095,2.28662),(57,7096,0.93331),(57,7097,1.05),(57,7105,1.12),(57,7110,0.74662),(57,7111,2.00662),(57,7112,2.47338),(57,7240,0.91),(57,7241,1.02669),(57,7243,1.07331),(57,7244,1.23669),(57,7245,1.02669),(57,7246,1.19),(57,7247,1.00331),(57,7248,1.12),(57,7249,1.00331),(57,7250,1.07331),(57,7295,1.12),(57,7296,1.09669),(57,7317,0.28),(57,8114,0.91),(57,8115,1.07331),(57,8116,1.82),(57,8117,1.07331),(57,8118,0.95669),(57,8119,1.05),(57,8120,1.07331),(57,8121,1.19),(57,8122,1.97321),(57,8123,1.05),(57,8124,0.98),(57,8125,1.05),(57,8126,0.91),(57,8127,1.16669),(57,8128,0.95669),(57,8129,1.05),(57,8130,1.02669),(57,8131,1.33),(57,8132,0.86331),(57,8133,0.93331),(57,8134,0.81669),(57,8135,0.91),(57,8136,0.84),(57,8137,1.26),(57,8271,0.37331),(57,8272,0.95669),(57,8273,1.00331),(57,8274,0.23331),(57,8275,1.02669),(57,8276,1.21331),(57,8277,0.81669),(57,8278,0.88669),(57,8279,0.81669),(57,8280,0.91),(57,8281,0.91),(57,8282,0.98),(58,11,0.63996),(58,175,0.4669),(58,194,1.72662),(58,299,0.74648),(58,338,2.80014),(58,339,4.2),(58,346,2.08008),(58,347,0.56),(58,352,1.96014),(58,370,2.24028),(58,375,4.29324),(58,376,5.32),(58,406,0.37338),(58,414,0.74676),(58,424,0.56004),(58,441,0.56),(58,448,1.86648),(58,2996,1.49324),(58,3138,1.12),(58,3151,1.4),(58,3166,1.86662),(58,3177,0.56),(58,3195,1.68),(58,3196,10.6403),(58,3199,4.66676),(58,3210,0.65338),(58,3215,2.24),(58,5947,2.05338),(58,6529,1.91338),(58,6582,1.72662),(58,6608,2.24),(58,7110,0.74662),(58,7245,2.05338),(58,7295,2.24),(58,8342,1.77338),(58,8343,2.24),(58,8344,1.77338),(58,8345,2.05338),(58,8346,2.05338),(58,8347,1.72662),(58,8348,1.96),(58,8349,2.05338),(58,8350,2.05338),(58,8351,2.24),(58,8352,1.91338),(58,8353,2.1),(58,8354,1.86662),(58,8355,2.14662),(58,8356,1.82),(58,8357,2.19338),(58,8358,2.19338),(58,8359,2.38),(58,8360,2.47338),(58,8361,2.38),(58,8362,1.82),(58,8363,2.05338),(58,8364,1.86662),(58,8365,2.42662),(58,8366,1.96),(58,8367,2.38),(58,8368,1.86662),(58,8369,2.05338),(58,8370,2.19338),(58,8371,0.86331),(58,8372,1.05),(58,8373,1.82),(58,8374,2.1),(58,8375,1.77338),(58,8376,2.00662),(58,8377,1.72662),(58,8378,2.05338),(58,8379,2.1),(58,8380,1.91338),(58,8381,2.33338),(58,8382,1.86662),(58,8383,2.19338),(58,8384,1.86662),(58,8385,2.14662),(58,8386,1.91338),(58,8387,2.19338),(58,8388,1.91338),(58,8389,2.05338),(58,8390,2.66),(58,8699,2.28662),(58,8700,2.38),(58,8701,2.61338),(58,8702,2.24),(58,8703,2.47338),(58,8704,2.1),(58,8705,2.33338),(58,8706,1.72662),(58,8707,2.00662),(58,8708,1.77338),(58,8709,2.24),(58,8710,1.82),(58,8711,2.14662),(58,8712,2.19338),(58,8713,1.86662),(58,8714,2.33338),(58,8715,1.96),(58,8716,2.24),(58,8717,0.74662),(58,8718,1.91338),(58,8719,2.19338),(58,8720,0.95669),(58,8721,2.00662),(58,8722,1.96),(58,8723,2.00662),(58,8724,2.28662),(58,8725,2.24),(58,8726,2.66),(58,8727,2.14662),(58,8728,2.38),(58,8729,2.05338),(58,8730,2.24),(60,4140,0.18669),(69,5682,0.56004),(69,8891,1.8),(69,8892,2.00004),(71,175,0.1334),(71,8905,2.4),(72,11,0.63996),(72,175,0.04669),(72,293,0.18669),(72,294,0.86331),(72,296,0.46662),(72,346,2.08008),(72,379,0.18662),(72,390,0.14),(72,424,0.56004),(72,434,0.09331),(72,3204,0.09331),(72,3838,0.88669),(72,3839,0.95669),(72,3840,0.95669),(72,3841,1.96),(72,3842,2.28662),(72,3843,0.46669),(72,3844,1.05),(72,3845,1.16669),(72,3846,0.28),(72,3847,1.02669),(72,3848,1.21331),(72,3849,0.84),(72,3850,0.98),(72,3851,0.23331),(72,3852,0.93331),(72,3853,1.02669),(72,3854,2.05338),(72,3855,1.14331),(72,3856,1.19),(72,3857,0.84),(72,3858,0.93331),(72,3859,0.37331),(72,3860,1.00331),(72,3861,1.19),(72,3862,1.02662),(72,3863,1.07331),(72,3864,1.19),(72,3865,1.12),(72,3866,1.19),(72,3867,0.84),(72,3868,0.95669),(72,4123,0.18669),(72,4124,0.91),(72,4125,0.98),(72,4126,0.65338),(72,4127,0.93331),(72,4128,1.02669),(72,4129,0.93331),(72,4130,1.05),(72,4131,0.14),(72,4132,0.86331),(72,4133,0.95669),(72,4134,0.37331),(72,4135,1.00331),(72,4136,1.14331),(72,4137,0.18669),(72,4138,1.05),(72,4139,1.14331),(72,4140,0.18669),(72,4141,0.93331),(72,4142,1.05),(72,4143,0.86331),(72,4144,0.95669),(72,4145,0.37331),(72,4146,1.00331),(72,4147,1.07331),(72,4148,0.23331),(72,4149,0.98),(72,4150,1.16669),(72,4151,0.28),(72,4152,0.93331),(72,4153,1.05);


--
-- Table structure for table `#__finder_links_terms1`
--



CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms1`
--


INSERT INTO `#__finder_links_terms1` (`link_id`, `term_id`, `weight`) VALUES (5,9,0.17),(22,9,0.14),(22,169,1.68),(22,170,1.82),(27,9,0.17),(43,9,0.58),(43,5498,0.81669),(43,5499,1.05),(43,5500,0.79331),(43,5501,0.86331),(43,5502,0.93331),(43,5503,1.00331),(43,5504,4.56321),(65,9,0.17);


--
-- Table structure for table `#__finder_links_terms2`
--



CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms2`
--


INSERT INTO `#__finder_links_terms2` (`link_id`, `term_id`, `weight`) VALUES (8,19,1.72679),(11,40,0.23331),(15,55,1.48),(20,71,1.08),(20,72,4.56012),(20,73,5.15988),(22,2025,1.49296),(22,2026,0.86331),(22,2027,0.98),(22,2028,0.86331),(22,2029,0.93331),(22,2030,5.55317),(22,2031,6.53317),(22,2032,6.20683),(22,2033,6.69683),(22,2034,0.42),(22,2035,1.07331),(22,2036,1.28331),(22,2037,0.14),(22,2038,1.00331),(22,2039,1.16669),(22,2040,0.56),(22,2041,1.96),(22,2042,2.24),(22,2043,0.65338),(22,2044,0.98),(22,2045,1.07331),(22,2046,0.98),(22,2047,1.05),(22,2048,1.30676),(22,2049,0.91),(22,2050,1.05),(22,2051,0.91),(22,2052,1.02669),(22,2053,0.91),(22,2054,1.09669),(22,2055,0.91),(22,2056,1.05),(22,2057,1.86655),(22,2058,1.86662),(22,2059,1.96),(22,2060,2.00662),(22,2061,2.14662),(22,2062,0.98),(22,2063,1.02669),(22,2064,0.46662),(22,2065,0.93331),(22,2066,1.05),(22,2067,1.00331),(22,2068,1.09669),(22,2069,0.74676),(22,2070,0.91),(22,2071,1.02669),(22,2072,1.96),(22,2073,1.09669),(22,2074,1.07331),(22,2075,0.91),(22,2076,0.98),(22,2077,5.04),(22,2078,6.58014),(22,2079,7.69986),(22,2080,3.21993),(22,2081,1.21331),(22,2082,2.24),(22,2083,2.1),(22,2084,2.28662),(22,2085,27.2567),(22,2086,0.88669),(22,2087,1.00331),(22,2088,1.05),(22,2089,3.54676),(22,2090,3.92),(22,2091,14.56),(22,2092,1.91338),(22,2093,1.96),(22,2094,3.50007),(22,2095,2.05338),(22,2096,3.08007),(22,2097,3.00993),(22,2098,1.02669),(22,2099,99.12),(22,2100,1.02669),(22,2101,1.91338),(22,2102,108.106),(22,2103,1.05),(22,2104,0.98),(22,2105,3.64),(22,2106,1.02669),(22,2107,3.08007),(22,2108,1.82),(22,2109,1.96),(22,2110,3.36),(22,2111,8.58648),(22,2112,4.76),(22,2113,4.66676),(22,2114,0.93338),(22,2115,1.05),(22,2116,1.28331),(22,2117,1.05),(22,2118,1.12),(22,2119,0.42),(22,2120,2.52),(22,2121,2.66007),(22,2122,1.39986),(22,2123,6.01986),(22,2124,3.36),(22,2125,3.29007),(22,2249,4.24697),(22,2250,3.08007),(22,2251,3.78),(22,2252,5.88),(22,2253,6.43986),(22,2254,0.93331),(22,2255,1.02669),(22,2256,2.94),(22,2257,3.21993),(22,2258,1.39986),(22,2259,5.46),(22,2260,6.85986),(22,2261,2.28683),(22,2262,5.88),(22,2263,6.3),(22,2264,1.00331),(22,2265,1.16669),(22,2266,0.23331),(22,2267,1.02669),(22,2268,1.12),(22,2269,0.84),(22,2270,2.94),(22,2271,3.36),(22,2272,2.24),(22,2273,0.95669),(22,2274,1.14331),(22,2275,0.98),(22,2276,1.05),(22,2277,6.01986),(22,2278,7.42014),(22,2279,0.56007),(22,2280,2.94),(22,2281,3.36),(22,2282,3.92),(22,2283,6.69683),(22,2284,7.35),(22,2285,6.69683),(22,2286,7.18683),(22,2287,0.65338),(22,2288,1.07331),(22,2289,1.26),(22,2290,1.02669),(22,2291,1.14331),(22,2292,0.84),(22,2293,5.46),(22,2294,6.3),(22,2295,0.84),(22,2296,3.00993),(22,2297,3.42993),(22,2298,4.2),(22,2299,3.08007),(22,2300,3.92007),(22,2301,6.01986),(22,2302,7.14),(22,2303,5.88),(22,2304,7.00014),(22,2305,2.52),(22,2306,9.24021),(22,2307,9.87021),(22,2308,0.37338),(22,2309,1.72662),(22,2310,1.05),(22,2311,0.74676),(22,2312,3.92),(22,2313,2.19338),(22,2314,2.14662),(22,2315,0.84),(22,2316,3.15),(22,2317,3.36),(22,2318,0.18669),(22,2319,0.86331),(22,2320,1.00331),(22,2321,1.86648),(22,2322,0.95669),(22,2323,1.05),(22,2324,0.95669),(22,2325,1.05),(22,2326,0.88669),(22,2327,1.02669),(22,2328,1.00331),(22,2329,1.21331),(22,2330,1.00331),(22,2331,1.14331),(22,2332,1.91338),(22,2333,2.05338),(22,2334,0.88669),(22,2335,1.02669),(22,2336,2.98648),(22,2337,6.43986),(22,2338,7.27986),(22,2339,0.98),(22,2340,1.19),(22,2341,0.98),(22,2342,1.14331),(22,2343,1.30683),(22,2344,6.86),(22,2345,3.29007),(22,2346,4.29324),(22,2347,8.39916),(22,2348,26.7873),(22,2349,30.7073),(22,2350,0.98),(22,2351,1.19),(22,2352,1.02669),(22,2353,1.21331),(22,2354,5.74014),(22,2355,6.58014),(22,2356,0.84),(22,2357,0.98),(22,2358,1.05),(22,2359,0.95669),(22,2360,1.02669),(22,2361,0.98),(22,2362,1.09669),(25,3979,0.14),(25,3980,0.84),(25,3981,0.91),(25,3982,0.18669),(25,3983,0.95669),(25,3984,1.12),(25,3985,0.37338),(25,3986,1.96),(25,3987,1.05),(25,3988,1.05),(25,3989,0.23331),(25,3990,0.91),(25,3991,1.02669),(25,3992,0.32669),(25,3993,1.4),(25,3994,1.4),(25,3995,0.37338),(25,3996,0.91),(25,3997,1.07331),(25,3998,0.88669),(25,3999,1.09669),(25,4046,0.18669),(25,4047,0.86331),(25,4048,0.95669),(25,4049,0.23331),(25,4050,0.91),(25,4051,1.19),(26,3979,0.28),(26,3980,0.84),(26,4291,1.00331),(26,4292,1.35331),(26,4293,1.02669),(27,19,0.56004),(27,2077,0.42),(27,2258,0.69993),(27,2272,0.28),(27,2292,0.14),(27,2298,1.12),(27,2299,1.02669),(27,2305,1.68),(27,2336,0.37331),(27,2347,0.46662),(27,2348,0.95669),(27,2349,1.09669),(27,2356,0.56),(27,4480,1.07331),(27,4481,1.19),(27,4506,1.82),(27,4507,1.00331),(27,4508,1.07331),(27,4509,0.91),(27,4510,1.02669),(27,4511,0.95669),(27,4512,1.14331),(27,4513,0.93331),(27,4514,1.14331),(27,4515,1.21331),(27,4516,0.91),(27,4517,1.05),(27,4518,1.07331),(27,4519,1.12),(27,4520,1.07331),(27,4521,1.14331),(27,4522,1.02669),(27,4523,1.28331),(27,4524,0.95669),(27,4525,1.07331),(27,4526,1.00331),(27,4527,1.21331),(27,4528,1.07331),(27,4529,1.30669),(27,4530,0.95669),(27,4531,1.14331),(27,4532,1.05),(27,4533,1.12),(27,4534,1.02669),(27,4535,1.16669),(27,4536,0.98),(27,4537,1.21331),(27,4538,0.91),(27,4539,1.12),(27,4540,0.91),(27,4541,1.07331),(28,19,0.56004),(28,2077,0.42),(28,2258,0.69993),(28,2272,0.28),(28,2292,0.14),(28,2298,1.12),(28,2299,1.02669),(28,2305,1.68),(28,2336,0.37331),(28,2347,0.46662),(28,2348,0.95669),(28,2349,1.09669),(28,2356,0.56),(28,4480,1.07331),(28,4481,1.19),(28,4506,1.82),(28,4507,1.00331),(28,4508,1.07331),(28,4509,0.91),(28,4510,1.02669),(28,4511,0.95669),(28,4512,1.14331),(28,4513,0.93331),(28,4514,1.14331),(28,4515,1.21331),(28,4516,0.91),(28,4517,1.05),(28,4518,1.07331),(28,4519,1.12),(28,4520,1.07331),(28,4521,1.14331),(28,4522,1.02669),(28,4523,1.28331),(28,4524,0.95669),(28,4525,1.07331),(28,4526,1.00331),(28,4527,1.21331),(28,4528,1.07331),(28,4529,1.30669),(28,4530,0.95669),(28,4531,1.14331),(28,4532,1.05),(28,4533,1.12),(28,4534,1.02669),(28,4535,1.16669),(28,4536,0.98),(28,4537,1.21331),(28,4538,0.91),(28,4539,1.12),(28,4540,0.91),(28,4541,1.07331),(29,19,0.56004),(29,2077,0.42),(29,2258,0.69993),(29,2272,0.28),(29,2279,0.98679),(29,2292,0.14),(29,2298,1.12),(29,2299,1.02669),(29,2305,1.68),(29,2336,0.37331),(29,2347,0.46662),(29,2348,0.95669),(29,2349,1.09669),(29,2356,0.56),(29,4480,1.07331),(29,4481,1.19),(29,4506,1.82),(29,4507,1.00331),(29,4508,1.07331),(29,4509,0.91),(29,4510,1.02669),(29,4511,0.95669),(29,4512,1.14331),(29,4513,0.93331),(29,4514,1.14331),(29,4515,1.21331),(29,4516,0.91),(29,4517,1.05),(29,4518,1.07331),(29,4519,1.12),(29,4520,1.07331),(29,4521,1.14331),(29,4522,1.02669),(29,4523,1.28331),(29,4524,0.95669),(29,4525,1.07331),(29,4526,1.00331),(29,4527,1.21331),(29,4528,1.07331),(29,4529,1.30669),(29,4530,0.95669),(29,4531,1.14331),(29,4532,1.05),(29,4533,1.12),(29,4534,1.02669),(29,4535,1.16669),(29,4536,0.98),(29,4537,1.21331),(29,4538,0.91),(29,4539,1.12),(29,4540,0.91),(29,4541,1.07331),(29,4720,5.05679),(30,19,0.56004),(30,2077,0.42),(30,2258,0.69993),(30,2272,0.28),(30,2279,0.98679),(30,2292,0.14),(30,2298,1.12),(30,2299,1.02669),(30,2305,1.68),(30,2336,0.37331),(30,2347,0.46662),(30,2348,0.95669),(30,2349,1.09669),(30,2356,0.56),(30,4480,1.07331),(30,4481,1.19),(30,4506,1.82),(30,4507,1.00331),(30,4508,1.07331),(30,4509,0.91),(30,4510,1.02669),(30,4511,0.95669),(30,4512,1.14331),(30,4513,0.93331),(30,4514,1.14331),(30,4515,1.21331),(30,4516,0.91),(30,4517,1.05),(30,4518,1.07331),(30,4519,1.12),(30,4520,1.07331),(30,4521,1.14331),(30,4522,1.02669),(30,4523,1.28331),(30,4524,0.95669),(30,4525,1.07331),(30,4526,1.00331),(30,4527,1.21331),(30,4528,1.07331),(30,4529,1.30669),(30,4530,0.95669),(30,4531,1.14331),(30,4532,1.05),(30,4533,1.12),(30,4534,1.02669),(30,4535,1.16669),(30,4536,0.98),(30,4537,1.21331),(30,4538,0.91),(30,4539,1.12),(30,4540,0.91),(30,4541,1.07331),(30,4721,4.68679),(30,4722,5.67321),(31,19,0.56004),(31,2077,0.42),(31,2258,0.69993),(31,2272,0.28),(31,2279,0.98679),(31,2292,0.14),(31,2298,1.12),(31,2299,1.02669),(31,2305,1.68),(31,2336,0.37331),(31,2347,0.46662),(31,2348,0.95669),(31,2349,1.09669),(31,2356,0.56),(31,4480,1.07331),(31,4481,1.19),(31,4506,1.82),(31,4507,1.00331),(31,4508,1.07331),(31,4509,0.91),(31,4510,1.02669),(31,4511,0.95669),(31,4512,1.14331),(31,4513,0.93331),(31,4514,1.14331),(31,4515,1.21331),(31,4516,0.91),(31,4517,1.05),(31,4518,1.07331),(31,4519,1.12),(31,4520,1.07331),(31,4521,1.14331),(31,4522,1.02669),(31,4523,1.28331),(31,4524,0.95669),(31,4525,1.07331),(31,4526,1.00331),(31,4527,1.21331),(31,4528,1.07331),(31,4529,1.30669),(31,4530,0.95669),(31,4531,1.14331),(31,4532,1.05),(31,4533,1.12),(31,4534,1.02669),(31,4535,1.16669),(31,4536,0.98),(31,4537,1.21331),(31,4538,0.91),(31,4539,1.12),(31,4540,0.91),(31,4541,1.07331),(32,19,0.56004),(32,2077,0.42),(32,2258,0.69993),(32,2272,0.28),(32,2292,0.14),(32,2298,1.12),(32,2299,1.02669),(32,2305,1.68),(32,2336,0.37331),(32,2347,0.46662),(32,2348,0.95669),(32,2349,1.09669),(32,2356,0.56),(32,4480,1.07331),(32,4481,1.19),(32,4506,1.82),(32,4507,1.00331),(32,4508,1.07331),(32,4509,0.91),(32,4510,1.02669),(32,4511,0.95669),(32,4512,1.14331),(32,4513,0.93331),(32,4514,1.14331),(32,4515,1.21331),(32,4516,0.91),(32,4517,1.05),(32,4518,1.07331),(32,4519,1.12),(32,4520,1.07331),(32,4521,1.14331),(32,4522,1.02669),(32,4523,1.28331),(32,4524,0.95669),(32,4525,1.07331),(32,4526,1.00331),(32,4527,1.21331),(32,4528,1.07331),(32,4529,1.30669),(32,4530,0.95669),(32,4531,1.14331),(32,4532,1.05),(32,4533,1.12),(32,4534,1.02669),(32,4535,1.16669),(32,4536,0.98),(32,4537,1.21331),(32,4538,0.91),(32,4539,1.12),(32,4540,0.91),(32,4541,1.07331),(33,19,0.56004),(33,2077,0.42),(33,2258,0.69993),(33,2272,0.28),(33,2292,0.14),(33,2298,1.12),(33,2299,1.02669),(33,2305,1.68),(33,2336,0.37331),(33,2347,0.46662),(33,2348,0.95669),(33,2349,1.09669),(33,2356,0.56),(33,4480,1.07331),(33,4481,1.19),(33,4506,1.82),(33,4507,1.00331),(33,4508,1.07331),(33,4509,0.91),(33,4510,1.02669),(33,4511,0.95669),(33,4512,1.14331),(33,4513,0.93331),(33,4514,1.14331),(33,4515,1.21331),(33,4516,0.91),(33,4517,1.05),(33,4518,1.07331),(33,4519,1.12),(33,4520,1.07331),(33,4521,1.14331),(33,4522,1.02669),(33,4523,1.28331),(33,4524,0.95669),(33,4525,1.07331),(33,4526,1.00331),(33,4527,1.21331),(33,4528,1.07331),(33,4529,1.30669),(33,4530,0.95669),(33,4531,1.14331),(33,4532,1.05),(33,4533,1.12),(33,4534,1.02669),(33,4535,1.16669),(33,4536,0.98),(33,4537,1.21331),(33,4538,0.91),(33,4539,1.12),(33,4540,0.91),(33,4541,1.07331),(34,19,0.56004),(34,2077,0.42),(34,2258,0.69993),(34,2272,0.28),(34,2292,0.14),(34,2298,1.12),(34,2299,1.02669),(34,2305,1.68),(34,2336,0.37331),(34,2347,0.46662),(34,2348,0.95669),(34,2349,1.09669),(34,2356,0.56),(34,4480,1.07331),(34,4481,1.19),(34,4506,1.82),(34,4507,1.00331),(34,4508,1.07331),(34,4509,0.91),(34,4510,1.02669),(34,4511,0.95669),(34,4512,1.14331),(34,4513,0.93331),(34,4514,1.14331),(34,4515,1.21331),(34,4516,0.91),(34,4517,1.05),(34,4518,1.07331),(34,4519,1.12),(34,4520,1.07331),(34,4521,1.14331),(34,4522,1.02669),(34,4523,1.28331),(34,4524,0.95669),(34,4525,1.07331),(34,4526,1.00331),(34,4527,1.21331),(34,4528,1.07331),(34,4529,1.30669),(34,4530,0.95669),(34,4531,1.14331),(34,4532,1.05),(34,4533,1.12),(34,4534,1.02669),(34,4535,1.16669),(34,4536,0.98),(34,4537,1.21331),(34,4538,0.91),(34,4539,1.12),(34,4540,0.91),(34,4541,1.07331),(35,19,0.56004),(35,2077,0.42),(35,2258,0.69993),(35,2272,0.28),(35,2292,0.14),(35,2298,1.12),(35,2299,1.02669),(35,2305,1.68),(35,2336,0.37331),(35,2347,0.46662),(35,2348,0.95669),(35,2349,1.09669),(35,2356,0.56),(35,4480,1.07331),(35,4481,1.19),(35,4506,1.82),(35,4507,1.00331),(35,4508,1.07331),(35,4509,0.91),(35,4510,1.02669),(35,4511,0.95669),(35,4512,1.14331),(35,4513,0.93331),(35,4514,1.14331),(35,4515,1.21331),(35,4516,0.91),(35,4517,1.05),(35,4518,1.07331),(35,4519,1.12),(35,4520,1.07331),(35,4521,1.14331),(35,4522,1.02669),(35,4523,1.28331),(35,4524,0.95669),(35,4525,1.07331),(35,4526,1.00331),(35,4527,1.21331),(35,4528,1.07331),(35,4529,1.30669),(35,4530,0.95669),(35,4531,1.14331),(35,4532,1.05),(35,4533,1.12),(35,4534,1.02669),(35,4535,1.16669),(35,4536,0.98),(35,4537,1.21331),(35,4538,0.91),(35,4539,1.12),(35,4540,0.91),(35,4541,1.07331),(36,3979,0.28),(36,3980,0.84),(36,4291,1.00331),(36,4292,1.35331),(36,4293,1.02669),(37,3979,0.28),(37,3980,0.84),(37,4291,1.00331),(37,4292,1.35331),(37,4293,1.02669),(38,3979,0.28),(38,3980,0.84),(38,4291,1.00331),(38,4292,1.35331),(38,4293,1.02669),(39,2249,0.65338),(39,2292,0.56),(39,2305,0.56),(39,2336,0.37331),(39,4833,1.07331),(39,4834,1.21331),(39,4835,0.98),(39,4836,1.21331),(39,4837,0.91),(39,4838,0.98),(39,4839,0.88669),(39,4840,1.19),(39,4841,0.91),(39,4842,1.05),(39,4843,1.96),(39,4844,2.24),(39,4845,1.12),(39,4846,1.30669),(40,2077,0.84),(40,2249,0.32669),(40,2258,0.23331),(40,2261,0.65338),(40,2272,0.56),(40,2292,0.42),(40,2298,0.56),(40,2347,1.16655),(40,2348,2.87007),(40,2349,3.29007),(40,2356,0.28),(40,4839,0.88669),(40,5181,1.05),(40,5182,1.12),(40,5183,1.05),(40,5207,0.93331),(40,5208,1.09669),(40,5209,1.00331),(40,5210,1.16669),(40,5211,1.00331),(40,5212,1.21331),(40,5213,0.93331),(40,5214,1.19),(40,5215,0.88669),(40,5216,1.09669),(40,5217,0.98),(40,5218,1.14331),(40,5219,0.88669),(40,5220,1.00331),(40,5221,0.98),(40,5222,1.14331),(40,5223,1.19),(40,5224,0.91),(40,5225,1.14331),(40,5226,1.05),(40,5227,1.12),(40,5228,0.98),(40,5229,1.19),(40,5230,1.00331),(40,5231,1.16669),(40,5232,0.98),(40,5233,1.07331),(41,2077,0.84),(41,2249,0.32669),(41,2258,0.23331),(41,2261,0.65338),(41,2272,0.56),(41,2292,0.42),(41,2298,0.56),(41,2347,1.16655),(41,2348,2.87007),(41,2349,3.29007),(41,2356,0.28),(41,4839,0.88669),(41,5181,1.05),(41,5182,1.12),(41,5183,1.05),(41,5207,0.93331),(41,5208,1.09669),(41,5209,1.00331),(41,5210,1.16669),(41,5211,1.00331),(41,5212,1.21331),(41,5213,0.93331),(41,5214,1.19),(41,5215,0.88669),(41,5216,1.09669),(41,5217,0.98),(41,5218,1.14331),(41,5219,0.88669),(41,5220,1.00331),(41,5221,0.98),(41,5222,1.14331),(41,5223,1.19),(41,5224,0.91),(41,5225,1.14331),(41,5226,1.05),(41,5227,1.12),(41,5228,0.98),(41,5229,1.19),(41,5230,1.00331),(41,5231,1.16669),(41,5232,0.98),(41,5233,1.07331),(42,2077,0.84),(42,2249,0.32669),(42,2258,0.23331),(42,2261,0.65338),(42,2272,0.56),(42,2292,0.42),(42,2298,0.56),(42,2347,1.16655),(42,2348,2.87007),(42,2349,3.29007),(42,2356,0.28),(42,4839,0.88669),(42,5181,1.05),(42,5182,1.12),(42,5183,1.05),(42,5207,0.93331),(42,5208,1.09669),(42,5209,1.00331),(42,5210,1.16669),(42,5211,1.00331),(42,5212,1.21331),(42,5213,0.93331),(42,5214,1.19),(42,5215,0.88669),(42,5216,1.09669),(42,5217,0.98),(42,5218,1.14331),(42,5219,0.88669),(42,5220,1.00331),(42,5221,0.98),(42,5222,1.14331),(42,5223,1.19),(42,5224,0.91),(42,5225,1.14331),(42,5226,1.05),(42,5227,1.12),(42,5228,0.98),(42,5229,1.19),(42,5230,1.00331),(42,5231,1.16669),(42,5232,0.98),(42,5233,1.07331),(43,3982,0.18669),(43,5583,0.18669),(43,5584,0.84),(43,5585,0.93331),(43,5586,0.88669),(43,5587,1.00331),(44,2249,1.30676),(44,2258,0.23331),(44,2261,0.32669),(44,2292,0.28),(44,2298,0.28),(44,2305,1.4),(44,2336,0.37331),(44,2347,1.23321),(44,2348,5.05679),(44,2356,0.84),(44,4524,2.87007),(44,4835,0.98),(44,4836,1.21331),(44,4837,0.91),(44,4839,0.88669),(44,4840,1.19),(44,4843,1.96),(44,4844,2.24),(44,5875,2.94),(44,5876,3.21993),(44,5877,0.91),(44,5878,1.05),(44,5879,1.02669),(44,5880,1.23669),(44,5881,1.19),(44,5882,0.88669),(44,5883,1.09669),(44,5884,3.42993),(44,5885,1.09669),(44,5886,1.19),(44,5887,2.87007),(44,5888,3.21993),(45,55,0.48),(45,2069,0.18669),(45,2266,0.23331),(45,3979,0.14),(45,3982,0.18669),(45,6204,0.28),(45,6205,0.88669),(45,6206,0.98),(45,6207,0.88669),(45,6208,1.14331),(45,6209,0.91),(45,6210,1.09669),(45,6211,0.88669),(45,6212,0.98),(45,6213,0.28),(45,6214,1.12),(45,6215,1.4),(45,6216,0.60669),(45,6217,1.28331),(45,6218,1.4),(45,6219,0.18669),(45,6220,1.02669),(45,6221,1.12),(45,6266,1.00331),(45,6267,1.07331),(45,6268,0.28),(45,6269,1.19),(45,6270,1.28331),(45,6271,0.23331),(45,6272,0.88669),(45,6273,1.07331),(45,6274,0.32669),(45,6275,0.93331),(45,6276,1.16669),(46,2077,0.42),(46,2249,0.32669),(46,2258,0.69993),(46,2261,0.32669),(46,2272,2.24),(46,2292,0.28),(46,2298,0.56),(46,2305,0.84),(46,2336,1.11993),(46,2339,0.98),(46,2347,0.69993),(46,2356,0.56),(46,3982,0.37338),(46,5882,0.88669),(46,6209,1.82),(46,6768,1.09669),(46,6769,1.12),(46,6770,0.32669),(46,6771,0.93331),(46,6772,1.07331),(46,6773,0.95669),(46,6774,1.19),(46,6823,1.05),(46,6824,1.12),(46,6825,0.88669),(46,6826,1.02669),(46,6827,1.02669),(46,6828,1.12),(46,6829,1.02669),(46,6830,1.16669),(46,6831,1.07331),(46,6832,1.19),(46,6833,0.37331),(46,6834,1.00331),(46,6835,1.09669),(46,6836,1.02669),(46,6837,1.14331),(46,6838,0.93331),(46,6839,1.09669),(46,6840,1.00331),(46,6841,1.19),(46,6842,0.95669),(46,6843,1.09669),(46,6844,1.00331),(46,6845,1.19),(46,6846,0.95669),(46,6847,1.09669),(46,6848,0.91),(46,6849,1.02669),(46,6850,0.98),(46,6851,1.14331),(46,6852,0.93331),(46,6853,1.05),(46,6854,0.98),(46,6855,1.16669),(46,6856,1.12),(46,6857,0.91),(46,6858,1.05),(46,6859,0.93331),(46,6860,1.16669),(46,6861,0.93331),(46,6862,1.09669),(46,6863,0.95669),(46,6864,1.05),(46,6865,0.95669),(46,6866,1.12),(46,6867,1.02669),(46,6868,1.23669),(46,6869,1.12),(46,6870,1.02669),(46,6871,1.09669),(46,6872,0.98),(46,6873,1.12),(46,6874,0.91),(46,6875,1.09669),(46,6876,0.95669),(46,6877,1.14331),(46,6878,1.02669),(46,6879,1.21331),(47,2077,0.42),(47,2249,0.32669),(47,2258,0.69993),(47,2261,0.32669),(47,2272,2.24),(47,2292,0.42),(47,2298,0.56),(47,2305,1.12),(47,2336,1.11993),(47,2339,0.98),(47,2347,0.93324),(47,2348,0.95669),(47,2349,1.09669),(47,2356,0.56),(47,5882,0.88669),(47,6773,0.95669),(47,6774,1.19),(47,6823,1.05),(47,6824,1.12),(47,6825,0.88669),(47,6826,1.02669),(47,6827,1.02669),(47,6828,1.12),(47,6829,1.02669),(47,6830,1.16669),(47,6831,1.07331),(47,6832,1.19),(47,6836,1.02669),(47,6837,1.14331),(47,6838,0.93331),(47,6839,1.09669),(47,6840,1.00331),(47,6841,1.19),(47,6842,0.95669),(47,6843,1.09669),(47,6844,1.00331),(47,6845,1.19),(47,6846,0.95669),(47,6847,1.09669),(47,6848,0.91),(47,6849,1.02669),(47,6850,0.98),(47,6852,0.93331),(47,6853,1.05),(47,6854,0.98),(47,6855,1.16669),(47,6856,1.12),(47,6857,0.91),(47,6858,1.05),(47,6859,0.93331),(47,6860,1.16669),(47,6861,0.93331),(47,6862,1.09669),(47,6863,0.95669),(47,6864,1.05),(47,6865,0.95669),(47,6866,1.12),(47,6867,1.02669),(47,6868,1.23669),(47,6869,1.12),(47,6870,1.02669),(47,6871,1.09669),(47,6872,0.98),(47,6873,1.12),(47,6874,0.91),(47,6875,1.09669),(47,6876,0.95669),(47,6877,1.14331),(47,6878,1.02669),(47,6879,1.21331),(47,7273,0.88669),(47,7274,1.16669),(47,7275,0.93331),(47,7276,1.05),(48,2077,0.42),(48,2249,0.32669),(48,2258,0.69993),(48,2261,0.32669),(48,2272,2.24),(48,2292,0.42),(48,2298,0.56),(48,2305,1.12),(48,2336,1.11993),(48,2339,0.98),(48,2347,0.93324),(48,2348,0.95669),(48,2349,1.09669),(48,2356,0.56),(48,5882,0.88669),(48,6773,0.95669),(48,6774,1.19),(48,6823,1.05),(48,6824,1.12),(48,6825,0.88669),(48,6826,1.02669),(48,6827,1.02669),(48,6828,1.12),(48,6829,1.02669),(48,6830,1.16669),(48,6831,1.07331),(48,6832,1.19),(48,6836,1.02669),(48,6837,1.14331),(48,6838,0.93331),(48,6839,1.09669),(48,6840,1.00331),(48,6841,1.19),(48,6842,0.95669),(48,6843,1.09669),(48,6844,1.00331),(48,6845,1.19),(48,6846,0.95669),(48,6847,1.09669),(48,6848,0.91),(48,6849,1.02669),(48,6850,0.98),(48,6852,0.93331),(48,6853,1.05),(48,6854,0.98),(48,6855,1.16669),(48,6856,1.12),(48,6857,0.91),(48,6858,1.05),(48,6859,0.93331),(48,6860,1.16669),(48,6861,0.93331),(48,6862,1.09669),(48,6863,0.95669),(48,6864,1.05),(48,6865,0.95669),(48,6866,1.12),(48,6867,1.02669),(48,6868,1.23669),(48,6869,1.12),(48,6870,1.02669),(48,6871,1.09669),(48,6872,0.98),(48,6873,1.12),(48,6874,0.91),(48,6875,1.09669),(48,6876,0.95669),(48,6877,1.14331),(48,6878,1.02669),(48,6879,1.21331),(48,7273,0.88669),(48,7274,1.16669),(48,7275,0.93331),(48,7276,1.05),(49,2077,0.84),(49,2258,0.23331),(49,2261,0.65338),(49,2272,0.84),(49,2292,0.28),(49,2298,0.28),(49,2305,1.12),(49,2347,0.23331),(49,2356,0.56),(49,5882,0.88669),(49,6773,1.91338),(49,6774,2.38),(49,6829,1.02669),(49,6830,1.16669),(49,6831,2.14662),(49,6832,2.38),(49,6836,2.05338),(49,6837,2.28662),(49,6844,1.00331),(49,6845,1.19),(49,6854,1.96),(49,6855,2.33338),(49,6856,1.12),(49,6859,0.93331),(49,6860,1.16669),(49,6861,1.86662),(49,6862,2.19338),(49,6863,0.95669),(49,6864,1.05),(49,6874,0.91),(49,6875,1.09669),(49,6876,1.91338),(49,6877,2.28662),(49,7360,0.14),(49,7361,0.88669),(49,7362,1.00331),(50,2077,0.42),(50,2258,0.46662),(50,2261,0.32669),(50,2266,0.23331),(50,2272,2.52),(50,2292,0.42),(50,2298,0.56),(50,2305,1.4),(50,2308,0.18669),(50,2347,0.93324),(50,2356,0.28),(50,5882,1.77338),(50,6773,0.95669),(50,6774,1.19),(50,6829,2.05338),(50,6830,2.33338),(50,6831,1.07331),(50,6832,1.19),(50,6836,1.02669),(50,6837,1.14331),(50,6838,1.86662),(50,6839,2.19338),(50,6844,2.00662),(50,6845,2.38),(50,6846,1.91338),(50,6847,2.19338),(50,6850,1.96),(50,6851,2.28662),(50,6852,1.86662),(50,6853,2.1),(50,6854,0.98),(50,6855,1.16669),(50,6856,2.24),(50,6859,1.86662),(50,6860,2.33338),(50,6861,0.93331),(50,6862,1.09669),(50,6863,1.91338),(50,6864,2.1),(50,6872,1.96),(50,6873,2.24),(50,6874,1.82),(50,6875,2.19338),(50,6876,0.95669),(50,6877,1.14331),(50,7471,1.00331),(50,7472,1.33),(50,7473,0.88669),(50,7474,1.02669),(51,2069,0.18669),(51,2077,0.42),(51,2249,0.32669),(51,2258,0.69993),(51,2261,0.32669),(51,2272,2.24),(51,2292,0.28),(51,2298,0.56),(51,2305,0.84),(51,2336,1.11993),(51,2339,0.98),(51,2347,0.69993),(51,2356,0.56),(51,3982,0.18669),(51,5882,0.88669),(51,6773,0.95669),(51,6774,1.19),(51,6823,1.05),(51,6824,1.12),(51,6825,0.88669),(51,6826,1.02669),(51,6827,1.02669),(51,6828,1.12),(51,6829,1.02669),(51,6830,1.16669),(51,6831,1.07331),(51,6832,1.19),(51,6836,1.02669),(51,6837,1.14331),(51,6838,0.93331),(51,6839,1.09669),(51,6840,1.00331),(51,6841,1.19),(51,6842,0.95669),(51,6843,1.09669),(51,6844,1.00331),(51,6845,1.19),(51,6846,0.95669),(51,6847,1.09669),(51,6848,0.91),(51,6849,1.02669),(51,6850,0.98),(51,6851,1.14331),(51,6852,0.93331),(51,6853,1.05),(51,6854,0.98),(51,6855,1.16669),(51,6856,1.12),(51,6857,0.91),(51,6858,1.05),(51,6859,0.93331),(51,6860,1.16669),(51,6861,0.93331),(51,6862,1.09669),(51,6863,0.95669),(51,6865,0.95669),(51,6866,1.12),(51,6867,1.02669),(51,6868,1.23669),(51,6869,1.12),(51,6870,1.02669),(51,6871,1.09669),(51,6872,0.98),(51,6873,1.12),(51,6874,0.91),(51,6875,1.09669),(51,6876,0.95669),(51,6877,1.14331),(51,6878,1.02669),(51,6879,1.21331),(51,7623,0.91),(51,7624,0.98),(51,7625,0.91),(51,7626,1.16669),(52,2077,0.84),(52,2258,0.23331),(52,2261,0.65338),(52,2272,1.68),(52,2292,0.56),(52,2298,0.28),(52,2305,1.12),(52,2318,0.18669),(52,2347,0.46662),(52,2356,0.56),(52,3982,0.18669),(52,5882,0.88669),(52,6209,0.91),(52,6773,1.91338),(52,6774,2.38),(52,6829,1.02669),(52,6830,1.16669),(52,6831,2.14662),(52,6832,2.38),(52,6836,2.05338),(52,6837,2.28662),(52,6838,0.93331),(52,6839,1.09669),(52,6844,1.00331),(52,6845,1.19),(52,6846,0.95669),(52,6847,1.09669),(52,6850,0.98),(52,6851,1.14331),(52,6852,0.93331),(52,6853,1.05),(52,6854,2.94),(52,6855,3.50007),(52,6856,1.12),(52,6859,0.93331),(52,6860,1.16669),(52,6861,1.86662),(52,6862,2.19338),(52,6863,0.95669),(52,6864,1.05),(52,6872,0.98),(52,6873,1.12),(52,6874,0.91),(52,6875,1.09669),(52,6876,1.91338),(52,6877,2.28662),(52,7781,1.09669),(52,7782,0.86331),(52,7783,0.98),(52,7784,0.18669),(52,7785,0.91),(52,7786,0.98),(52,7787,0.32669),(52,7788,0.95669),(52,7789,1.02669),(53,2258,0.69993),(53,2272,3.36),(53,2292,0.42),(53,2298,0.84),(53,2305,1.68),(53,2308,0.18669),(53,2347,1.39986),(53,5882,2.66007),(53,6829,3.08007),(53,6830,3.50007),(53,6838,2.79993),(53,6839,3.29007),(53,6844,3.00993),(53,6845,3.57),(53,6846,2.87007),(53,6847,3.29007),(53,6850,2.94),(53,6851,3.42993),(53,6852,2.79993),(53,6853,3.15),(53,6856,3.36),(53,6859,2.79993),(53,6860,3.50007),(53,6863,2.87007),(53,6864,3.15),(53,6872,2.94),(53,6873,3.36),(53,6874,2.73),(53,6875,3.29007),(53,7866,1.00331),(53,7867,1.14331),(54,2249,0.98007),(54,2258,0.93324),(54,2272,1.96),(54,2292,0.28),(54,2298,0.56),(54,2305,0.56),(54,2336,2.23986),(54,2339,1.96),(54,2347,0.93324),(54,2348,1.91338),(54,2349,2.19338),(54,2356,0.84),(54,3982,0.18669),(54,6823,2.1),(54,6824,2.24),(54,6825,1.77338),(54,6826,2.05338),(54,6827,2.05338),(54,6828,2.24),(54,6840,3.00993),(54,6841,3.57),(54,6842,1.91338),(54,6848,1.82),(54,6849,2.05338),(54,6857,1.82),(54,6858,2.1),(54,6865,1.91338),(54,6866,2.24),(54,6867,2.05338),(54,6868,2.47338),(54,6869,2.24),(54,6870,2.05338),(54,6871,2.19338),(54,6878,3.08007),(54,6879,2.42662),(54,7273,1.77338),(54,7274,2.33338),(54,7275,1.86662),(54,7276,2.1),(54,7965,0.86331),(54,7966,0.93331),(54,7983,1.09669),(54,7984,0.32669),(54,7985,1.00331),(54,7986,1.14331),(55,2069,0.18669),(55,2249,0.98007),(55,2258,1.39986),(55,2272,2.52),(55,2292,0.42),(55,2298,0.84),(55,2305,0.84),(55,2336,3.35979),(55,2339,2.94),(55,2347,1.39986),(55,2348,2.87007),(55,2349,3.29007),(55,2356,0.84),(55,6823,3.15),(55,6824,3.36),(55,6825,2.66007),(55,6826,3.08007),(55,6827,3.08007),(55,6828,3.36),(55,6840,3.00993),(55,6841,3.57),(55,6842,2.87007),(55,6848,2.73),(55,6849,3.08007),(55,6857,2.73),(55,6858,3.15),(55,6865,2.87007),(55,6866,3.36),(55,6867,3.08007),(55,6868,3.71007),(55,6869,3.36),(55,6870,3.08007),(55,6871,3.29007),(55,6878,3.08007),(55,6879,3.63993),(55,7273,2.66007),(55,7274,3.50007),(55,7275,2.79993),(55,7276,3.15),(55,7625,0.91),(55,7626,1.16669),(55,7983,2.19338),(56,2249,0.98007),(56,2258,1.39986),(56,2272,2.52),(56,2292,0.56),(56,2298,0.84),(56,2305,1.12),(56,2336,3.35979),(56,2339,2.94),(56,2347,1.63317),(56,2348,3.82676),(56,2349,4.38676),(56,2356,0.84),(56,6823,3.15),(56,6824,3.36),(56,6825,2.66007),(56,6826,3.08007),(56,6827,3.08007),(56,6828,3.36),(56,6840,3.00993),(56,6841,3.57),(56,6842,2.87007),(56,6848,2.73),(56,6849,3.08007),(56,6857,2.73),(56,6858,3.15),(56,6865,2.87007),(56,6866,3.36),(56,6867,3.08007),(56,6868,3.71007),(56,6869,3.36),(56,6870,3.08007),(56,6871,3.29007),(56,6878,3.08007),(56,6879,3.63993),(56,7273,3.54676),(56,7274,4.66676),(56,7275,3.73324),(56,7276,4.2),(56,7983,2.19338),(57,55,0.28),(57,2249,0.32669),(57,2258,0.46662),(57,2272,0.84),(57,2292,0.42),(57,2298,0.28),(57,2305,0.84),(57,2336,1.11993),(57,2339,0.98),(57,2347,0.46662),(57,2348,0.95669),(57,2349,1.09669),(57,2356,0.84),(57,3982,0.18669),(57,3989,0.23331),(57,6823,1.05),(57,6824,1.12),(57,6825,0.88669),(57,6826,1.02669),(57,6827,1.02669),(57,6828,1.12),(57,6840,1.00331),(57,6841,1.19),(57,6842,0.95669),(57,6843,1.09669),(57,6848,0.91),(57,6849,1.02669),(57,6854,1.96),(57,6855,2.33338),(57,6857,0.91),(57,6858,1.05),(57,6861,1.86662),(57,6862,2.19338),(57,6865,0.95669),(57,6866,1.12),(57,6867,1.02669),(57,6868,1.23669),(57,6869,1.12),(57,6870,1.02669),(57,6871,1.09669),(57,6876,1.91338),(57,6877,2.28662),(57,6878,1.02669),(57,6879,1.21331),(57,7273,0.88669),(57,7274,1.16669),(57,7275,0.93331),(57,7276,1.05),(57,8196,0.84),(57,8197,1.02669),(57,8198,0.91),(57,8199,1.14331),(57,8200,0.42),(57,8201,0.98),(57,8202,1.16669),(57,8221,0.88669),(57,8222,1.09669),(58,2077,0.84),(58,2249,0.65338),(58,2258,0.46662),(58,2261,1.96014),(58,2272,1.12),(58,2292,0.84),(58,2298,1.68),(58,2305,1.68),(58,2336,1.49324),(58,2341,1.96),(58,2347,1.86648),(58,2348,3.82676),(58,2349,4.38676),(58,4518,2.14662),(58,6848,1.82),(58,8515,0.74662),(58,8516,2.05338),(58,8517,2.52),(58,8518,2.1),(58,8519,2.42662),(58,8540,2.19338),(58,8541,2.47338),(58,8542,1.86662),(58,8543,2.00662),(58,8544,2.05338),(58,8545,2.28662),(58,8546,1.86662),(58,8547,2.28662),(58,8548,1.91338),(58,8549,2.1),(58,8550,2.19338),(58,8551,2.52),(58,8552,2.05338),(58,8553,1.91338),(58,8554,2.1),(58,8555,1.77338),(58,8556,2.19338),(58,8557,1.86662),(58,8558,2.24),(58,8559,2.56662),(58,8560,1.91338),(58,8561,2.24),(58,8562,1.86662),(58,8563,2.33338),(58,8564,3.64),(58,8565,2.24),(58,8566,2.28662),(58,8567,1.96),(58,8568,2.38),(58,8569,2.1),(58,8570,2.24),(58,8571,2.42662),(58,8572,1.77338),(58,8573,2.1),(58,8574,1.96),(58,8575,2.1),(59,3995,0.32004),(59,3998,1.52004),(59,8812,2.12004),(60,3995,0.32004),(60,3998,1.52004),(60,4046,0.32004),(60,8828,1.8),(61,3995,0.32004),(61,4046,0.32004),(61,8842,1.8),(61,8843,2.07996),(62,3995,0.32004),(62,4046,0.32004),(62,8851,1.56),(62,8852,1.83996),(63,3995,0.32004),(63,4046,0.32004),(63,8859,1.56),(63,8860,1.83996),(64,3995,0.32004),(64,3998,1.52004),(64,4046,0.32004),(64,8812,2.12004),(65,3995,0.32004),(65,3998,1.52004),(65,4046,0.32004),(65,8865,1.97321),(65,8866,1.8),(66,3995,0.32004),(66,4046,0.32004),(66,8870,1.59996),(66,8871,1.88004),(67,3995,0.32004),(67,4046,0.32004),(67,8877,1.68),(67,8878,1.83996),(68,3995,0.32004),(68,3998,1.52004),(68,4046,0.32004),(68,8884,1.88004),(69,3995,0.32004),(69,3998,1.52004),(69,4046,0.32004),(69,6219,0.32004),(69,8866,1.8),(70,3995,0.32004),(70,3998,1.52004),(70,4046,0.32004),(70,6219,0.32004),(70,8866,1.8),(70,8898,0.32004),(70,8899,1.68),(70,8900,1.88004),(71,3995,0.32004),(71,3998,1.52004),(71,4046,0.32004),(71,8812,2.12004),(72,3979,0.14),(72,3980,0.84),(72,3981,0.91),(72,3982,0.18669),(72,3983,0.95669),(72,3984,1.12),(72,3985,0.37338),(72,3986,1.96),(72,3987,1.05),(72,3988,1.05),(72,3989,0.23331),(72,3990,0.91),(72,3991,1.02669),(72,3992,0.32669),(72,3993,1.4),(72,3994,1.4),(72,3995,0.37338),(72,3996,0.91),(72,3997,1.07331),(72,3998,0.88669),(72,3999,1.09669),(72,4046,0.18669),(72,4047,0.86331),(72,4048,0.95669),(72,4049,0.23331),(72,4050,0.91),(72,4051,1.19);


--
-- Table structure for table `#__finder_links_terms3`
--



CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms3`
--


INSERT INTO `#__finder_links_terms3` (`link_id`, `term_id`, `weight`) VALUES (11,36,1.76),(11,37,0.98),(11,38,5.42679),(11,39,6.53679),(14,36,1.48),(21,36,0.68),(21,115,2.32339),(22,2239,1.12014),(22,2240,5.17986),(22,2241,6.3),(22,2242,3.73296),(22,2243,8.19),(22,2244,10.08),(22,2245,5.46),(22,2246,6.16014),(22,2247,1.00331),(22,2248,1.12),(24,36,0.56),(24,3800,1.00331),(24,3801,1.14331),(24,3802,1.00331),(24,3803,1.07331),(27,2242,0.23331),(27,4504,1.02669),(27,4505,1.16669),(28,2242,0.23331),(28,4504,1.02669),(28,4505,1.16669),(29,2242,0.23331),(29,4504,1.02669),(29,4505,1.16669),(30,2242,0.23331),(30,4504,1.02669),(30,4505,1.16669),(31,2242,0.23331),(31,4504,1.02669),(31,4505,1.16669),(32,2242,0.23331),(32,4504,1.02669),(32,4505,1.16669),(33,2242,0.23331),(33,4504,1.02669),(33,4505,1.16669),(34,2242,0.23331),(34,4504,1.02669),(34,4505,1.16669),(35,2242,0.23331),(35,4504,1.02669),(35,4505,1.16669),(44,2242,0.46662),(44,2245,0.91),(44,2246,1.02669),(44,5873,0.93331),(44,5874,1.12),(45,36,4.28),(45,5980,0.23331),(45,5981,0.93331),(45,5982,0.98),(45,5983,0.28),(45,5984,1.00331),(45,5985,1.09669),(45,5986,0.18669),(45,5987,0.91),(45,5988,1.16669),(45,6250,0.93331),(45,6251,1.02669),(45,6252,1.00331),(45,6253,1.09669),(45,6254,0.93331),(45,6255,1.02669),(45,6256,1.86662),(45,6257,1.05),(45,6258,1.05),(45,6259,1.82),(45,6260,0.95669),(45,6261,1.02669),(45,6262,0.93331),(45,6263,1.14331),(45,6264,1.05),(45,6265,1.12),(51,2239,0.18669),(51,7641,0.93331),(51,7642,1.05),(60,36,2.72),(60,38,1.76004),(60,39,2.12004),(60,8829,2.26661),(60,8830,2.6),(60,8831,0.93331),(60,8832,1.12),(60,8833,1.59996),(61,36,2.72),(61,38,1.76004),(61,39,2.12004),(61,8833,1.59996),(61,8844,6.89348),(62,36,2.72),(62,38,1.76004),(62,39,2.12004),(62,8833,1.59996),(62,8853,7.33348),(70,8901,0.98679),(70,8902,4.56321),(70,8903,0.56004),(70,8904,1.68);


--
-- Table structure for table `#__finder_links_terms4`
--



CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms4`
--


INSERT INTO `#__finder_links_terms4` (`link_id`, `term_id`, `weight`) VALUES (1,3,0.63996),(2,3,0.63996),(3,3,0.63996),(4,3,0.63996),(5,3,0.63996),(6,3,0.63996),(7,3,0.63996),(8,3,0.63996),(8,18,0.17),(9,3,2.98648),(9,21,1.16669),(9,22,4.93321),(10,3,2.98648),(10,21,1.16669),(10,29,5.05679),(11,3,2.98648),(11,34,1.00331),(11,35,1.16669),(12,3,0.63996),(13,3,0.63996),(14,3,0.63996),(15,3,0.63996),(16,3,0.63996),(17,3,0.63996),(18,3,0.63996),(19,3,0.63996),(19,68,1.48),(20,3,0.63996),(20,22,1.59996),(20,89,0.56004),(20,90,0.63996),(20,91,1.64004),(20,92,1.83996),(21,3,0.63996),(21,29,1.64004),(21,89,0.56004),(21,90,0.63996),(21,91,1.64004),(21,92,1.83996),(21,114,0.24),(22,89,0.65338),(22,534,2.61317),(22,535,1.00331),(22,536,1.19),(22,537,6.43986),(22,538,4.76),(22,539,2.33338),(22,540,2.24),(22,541,8.21352),(22,542,4.57324),(22,543,4.48),(22,544,0.84),(22,545,5.04),(22,546,0.91),(22,547,4.9),(22,548,1.12014),(22,549,5.88),(22,550,3.29007),(22,551,3.21993),(22,552,0.37324),(22,553,3.73324),(22,554,2.1),(22,555,2.05338),(22,556,2.24028),(22,557,0.84),(22,558,0.95669),(22,559,0.84),(22,560,0.95669),(22,561,1.68),(22,562,1.91338),(22,563,1.68),(22,564,1.91338),(22,565,1.68),(22,566,1.91338),(22,567,1.68),(22,568,1.91338),(22,569,0.84),(22,570,0.95669),(22,571,0.84),(22,572,0.95669),(22,573,2.56641),(22,574,3.64),(22,575,1.02669),(22,576,3.29007),(22,577,3.73324),(22,578,4.48),(22,579,2.73),(22,580,3.29007),(22,581,1.11993),(22,582,3.08007),(22,583,3.29007),(22,584,42.2291),(22,585,1.05),(22,586,1.23669),(22,587,1.02669),(22,588,1.14331),(22,589,0.95669),(22,590,1.07331),(22,591,1.00331),(22,592,1.19),(22,593,1.00331),(22,594,1.12),(22,595,1.07331),(22,596,1.19),(22,597,1.07331),(22,598,1.19),(22,599,2.28662),(22,600,1.23669),(22,601,1.26),(22,602,1.14331),(22,603,1.23669),(22,604,1.14331),(22,605,1.23669),(22,606,1.14331),(22,607,1.23669),(22,608,1.23669),(22,609,1.37669),(22,610,1.19),(22,611,1.33),(22,612,1.21331),(22,613,1.35331),(22,614,0.95669),(22,615,1.07331),(22,616,1.00331),(22,617,1.12),(22,618,1.05),(22,619,1.23669),(22,620,1.05),(22,621,1.23669),(22,622,1.05),(22,623,1.23669),(22,624,1.05),(22,625,1.23669),(22,626,1.07331),(22,627,1.19),(22,628,1.14331),(22,629,1.26),(22,630,1.02669),(22,631,1.14331),(22,632,1.09669),(22,633,1.21331),(22,634,2.19338),(22,635,2.42662),(22,636,0.98),(22,637,1.09669),(22,638,1.05),(22,639,1.16669),(22,640,1.05),(22,641,1.16669),(22,642,0.93331),(22,643,1.05),(22,644,1.00331),(22,645,1.12),(22,646,1.07331),(22,647,1.19),(22,648,1.14331),(22,649,1.26),(22,650,1.09669),(22,651,1.21331),(22,652,1.16669),(22,653,1.28331),(22,654,1.07331),(22,655,1.19),(22,656,1.14331),(22,657,1.26),(22,658,1.05),(22,659,1.23669),(22,660,1.05),(22,661,1.23669),(22,662,1.00331),(22,663,1.14331),(22,664,1.05),(22,665,1.19),(22,666,1.05),(22,667,1.19),(22,668,1.00331),(22,669,1.12),(22,670,1.07331),(22,671,1.19),(22,672,1.00331),(22,673,1.19),(22,674,2.00662),(22,675,1.19),(22,676,1.00331),(22,677,1.07331),(22,678,1.07331),(22,679,1.19),(22,680,0.95669),(22,681,1.07331),(22,682,1.02669),(22,683,1.14331),(22,684,1.00331),(22,685,1.12),(22,686,1.00331),(22,687,1.14331),(22,688,1.05),(22,689,1.19),(22,690,1.05),(22,691,1.19),(22,692,1.05),(22,693,1.19),(22,694,1.05),(22,695,1.19),(22,696,1.05),(22,697,1.19),(22,698,1.05),(22,699,1.19),(22,700,1.05),(22,701,1.19),(22,702,1.07331),(22,703,1.19),(22,704,1.07331),(22,705,1.19),(22,706,1.14331),(22,707,1.26),(22,708,1.14331),(22,709,1.26),(22,710,1.12),(22,711,1.23669),(22,712,1.09669),(22,713,1.21331),(22,714,1.12),(22,715,1.23669),(22,716,1.12),(22,717,1.23669),(22,718,1.00331),(22,719,1.12),(22,720,1.07331),(22,721,1.19),(22,722,0.95669),(22,723,1.14331),(22,724,1.30669),(22,725,1.4),(22,726,0.98),(22,727,1.05),(22,728,0.98),(22,729,1.05),(22,730,0.98),(22,731,1.05),(22,732,0.98),(22,733,1.09669),(22,734,1.07331),(22,735,1.12),(22,736,2.14662),(22,737,2.24),(22,738,2.14662),(22,739,1.19),(22,740,1.12),(22,741,1.00331),(22,742,1.12),(22,743,1.07331),(22,744,1.19),(22,745,1.00331),(22,746,1.12),(22,747,1.07331),(22,748,1.19),(22,749,1.07331),(22,750,1.19),(22,751,1.14331),(22,752,1.26),(22,753,1.21331),(22,754,1.33),(22,755,1.14331),(22,756,1.26),(22,757,0.98),(22,758,1.09669),(22,759,1.05),(22,760,1.16669),(22,761,0.98),(22,762,1.09669),(22,763,1.05),(22,764,1.16669),(22,765,1.02669),(22,766,1.14331),(22,767,1.09669),(22,768,1.21331),(22,769,1.00331),(22,770,1.12),(22,771,1.07331),(22,772,1.19),(22,773,2.14662),(22,774,2.33338),(22,775,1.00331),(22,776,1.12),(22,777,0.98),(22,778,1.09669),(22,779,1.12),(22,780,1.23669),(22,781,1.12),(22,782,1.23669),(22,783,1.12),(22,784,1.23669),(22,785,1.12),(22,786,1.23669),(22,787,1.00331),(22,788,1.12),(22,789,1.07331),(22,790,1.19),(22,791,1.07331),(22,792,1.19),(22,793,1.00331),(22,794,1.12),(22,795,1.07331),(22,796,1.19),(22,797,1.02669),(22,798,1.14331),(22,799,1.09669),(22,800,1.21331),(22,801,1.00331),(22,802,1.12),(22,803,1.00331),(22,804,1.12),(22,805,1.00331),(22,806,1.12),(22,807,1.00331),(22,808,1.12),(22,809,1.00331),(22,810,1.12),(22,811,1.14331),(22,812,1.26),(22,813,1.21331),(22,814,1.33),(22,815,1.21331),(22,816,1.33),(22,817,1.05),(22,818,1.12),(22,819,1.05),(22,820,1.12),(22,821,1.05),(22,822,1.12),(22,823,1.05),(22,824,1.12),(22,825,1.05),(22,826,1.12),(22,827,1.05),(22,828,1.12),(22,829,1.05),(22,830,1.12),(22,831,1.09669),(22,832,1.21331),(22,833,0.98),(22,834,1.09669),(22,835,1.05),(22,836,1.16669),(22,837,2.1),(22,838,2.33338),(22,839,1.09669),(22,840,1.21331),(22,841,1.16669),(22,842,1.28331),(22,843,1.16669),(22,844,1.28331),(22,845,1.00331),(22,846,1.12),(22,847,1.07331),(22,848,1.19),(22,849,0.95669),(22,850,1.07331),(22,851,0.98),(22,852,1.09669),(22,853,1.05),(22,854,1.09669),(22,855,1.05),(22,856,1.09669),(22,857,1.96),(22,858,1.12),(22,859,1.09669),(22,860,1.05),(22,861,1.16669),(22,862,1.05),(22,863,1.16669),(22,864,1.02669),(22,865,1.14331),(22,866,1.05),(22,867,1.16669),(22,868,1.12),(22,869,1.23669),(22,870,1.02669),(22,871,1.14331),(22,872,1.00331),(22,873,1.19),(22,874,1.02669),(22,875,1.14331),(22,876,1.05),(22,877,1.23669),(22,878,1.05),(22,879,1.23669),(22,880,1.05),(22,881,1.23669),(22,882,1.05),(22,883,1.16669),(22,884,2.28662),(22,885,2.47338),(22,886,1.16669),(22,887,1.28331),(22,888,0.98),(22,889,1.09669),(22,890,1.05),(22,891,1.16669),(22,892,1.00331),(22,893,1.12),(22,894,1.00331),(22,895,1.12),(22,896,1.00331),(22,897,1.12),(22,898,1.00331),(22,899,1.12),(22,900,1.00331),(22,901,1.12),(22,902,1.12),(22,903,1.23669),(22,904,0.98),(22,905,1.09669),(22,906,1.05),(22,907,1.16669),(22,908,1.05),(22,909,1.16669),(22,910,1.07331),(22,911,1.19),(22,912,1.07331),(22,913,1.19),(22,914,1.07331),(22,915,1.19),(22,916,1.07331),(22,917,1.19),(22,918,1.07331),(22,919,1.19),(22,920,1.07331),(22,921,1.19),(22,922,1.02669),(22,923,1.14331),(22,924,1.00331),(22,925,1.12),(22,926,1.07331),(22,927,1.19),(22,928,1.12),(22,929,1.23669),(22,930,0.91),(22,931,1.02669),(22,932,0.32669),(22,933,0.98),(22,934,1.05),(22,935,0.93324),(22,936,0.93331),(22,937,1.05),(22,938,3.00993),(22,939,1.12),(22,940,2.19338),(22,941,0.56007),(22,942,0.93331),(22,943,1.00331),(22,944,0.88669),(22,945,1.00331),(22,946,1.02669),(22,947,1.16669),(22,948,0.46662),(22,949,2.00662),(22,950,1.12),(22,951,1.09669),(22,952,0.28),(22,953,1.91338),(22,954,1.07331),(22,955,1.05),(22,956,0.46662),(22,957,2.00662),(22,958,1.12),(22,959,1.09669),(22,960,1.12),(22,961,1.77338),(22,962,2.1),(22,963,1.77338),(22,964,1.00331),(22,965,0.74662),(22,966,1.00331),(22,967,1.12),(22,968,1.07331),(22,969,1.16669),(22,970,2.23986),(22,971,6.43986),(22,972,3.57),(22,973,3.50007),(22,974,1.26),(22,975,2.94),(22,976,3.29007),(22,977,9.75289),(22,978,3.08007),(22,979,3.29007),(22,980,1.12),(22,981,1.23669),(22,982,9.33352),(22,983,10.4535),(22,984,6.43986),(22,985,7.27986),(22,986,1.12),(22,987,4.10676),(22,988,2.28662),(22,989,2.24),(22,990,1.21338),(22,991,2.38),(22,992,1.30669),(22,993,1.28331),(22,994,2.8),(22,995,8.82),(22,996,3.36),(22,997,6.58014),(22,998,1.05),(22,999,1.16669),(22,1000,10.08),(22,1001,22.2604),(22,1002,24.3596),(22,1003,7.69965),(22,1004,1.00331),(22,1005,1.14331),(22,1006,1.16669),(22,1007,1.28331),(22,1008,12.1331),(22,1009,13.3),(22,1010,3.08007),(22,1011,3.71007),(22,1012,2.52),(22,1013,6.16014),(22,1014,7.42014),(22,1015,1.11993),(22,1016,2.87007),(22,1017,3.57),(22,1018,2.1),(22,1019,1.16669),(22,1020,1.14331),(22,1021,3.78),(22,1022,1.09669),(22,1023,1.16669),(22,1024,6.43986),(22,1025,7.42014),(22,1026,1.07331),(22,1027,1.14331),(22,1028,1.00331),(22,1029,1.09669),(22,1030,0.98007),(22,1031,3.50007),(22,1032,3.84993),(22,1033,1.30683),(22,1034,0.91),(22,1035,1.05),(22,1036,5.01655),(22,1037,5.83345),(22,1038,0.69993),(22,1039,2.66007),(22,1040,3.00993),(22,1041,2.23986),(22,1042,5.88),(22,1043,7.00014),(22,1044,0.46669),(22,1045,1.12),(22,1046,1.21331),(22,1047,0.46669),(22,1048,1.12),(22,1049,1.23669),(22,1050,0.74662),(22,1051,1.09669),(22,1052,1.21331),(22,1053,1.00331),(22,1054,0.93324),(22,1055,4.01324),(22,1056,2.24),(22,1057,2.19338),(22,1058,0.84),(22,1059,0.95669),(22,1060,1.14331),(22,1061,4.78345),(22,1062,5.36655),(22,1063,2.52),(22,1064,16.7996),(22,1065,20.16),(22,1066,3.36),(22,1067,2.79993),(22,1068,3.08007),(22,1069,3.08007),(22,1070,3.57),(22,1071,5.88),(22,1072,6.3),(22,2969,1.11993),(22,2970,3.08007),(22,2971,3.42993),(22,2972,0.56),(22,2973,2.05338),(22,2974,1.14331),(22,2975,1.12),(22,2976,0.56007),(22,2977,2.58993),(22,2978,2.87007),(22,2979,2.28683),(22,2980,0.98),(22,2981,1.07331),(22,2982,5.88),(22,2983,6.85986),(22,2984,7.56),(22,2985,18.0596),(22,2986,7.35),(22,2987,11.2),(22,2988,2.09979),(22,2989,6.01986),(22,2990,7.14),(22,2991,3.15),(22,2992,3.84993),(22,2993,0.28),(22,2994,1.00331),(22,2995,1.12),(22,3613,0.84),(22,3614,5.17986),(22,3615,5.59986),(22,3616,0.84),(22,3617,2.94),(22,3618,3.15),(22,3619,25.2031),(22,3620,0.95669),(22,3621,1.07331),(22,3622,0.88669),(22,3623,1.07331),(22,3624,2.79993),(22,3625,3.36),(22,3626,0.88669),(22,3627,1.07331),(22,3628,0.93331),(22,3629,1.05),(22,3630,4.01324),(22,3631,4.76),(22,3632,3.82676),(22,3633,4.57324),(22,3634,2.73),(22,3635,3.29007),(22,3636,1.72662),(22,3637,2.1),(22,3638,4.66655),(22,3639,2.05338),(22,3640,2.1),(22,3641,1.02669),(22,3642,1.86662),(22,3643,1.05),(22,3644,1.12),(22,3645,0.91),(22,3646,1.00331),(22,3647,0.93331),(22,3648,1.12),(22,3649,0.88669),(22,3650,1.07331),(22,3651,0.93331),(22,3652,1.12),(22,3653,1.00331),(22,3654,1.12),(22,3655,3.00993),(22,3656,3.57),(22,3657,1.91338),(22,3658,2.28662),(22,3659,1.12),(22,3660,1.30669),(22,3661,0.98),(22,3662,1.16669),(22,3663,1.05),(22,3664,1.23669),(22,3665,1.86662),(22,3666,2.24),(22,3667,0.91),(22,3668,1.02669),(22,3669,1.86662),(22,3670,2.24),(22,3671,1.86662),(22,3672,2.24),(22,3673,2.14662),(22,3674,2.52),(22,3675,1.00331),(22,3676,1.19),(22,3677,1.82),(22,3678,1.02669),(22,3679,1.09669),(22,3680,0.91),(22,3681,0.98),(22,3682,0.91),(22,3683,1.02669),(22,3684,1.91338),(22,3685,2.28662),(22,3686,1.86662),(22,3687,2.24),(22,3688,0.93331),(22,3689,1.05),(22,3690,0.91),(22,3691,1.09669),(22,3692,4.10676),(22,3693,4.76),(22,3694,2.79993),(22,3695,3.36),(22,3696,1.86662),(22,3697,2.24),(22,3698,1.91338),(22,3699,2.28662),(22,3700,4.55),(22,3701,5.48345),(22,3702,1.05),(22,3703,1.23669),(22,3704,2.14662),(22,3705,2.52),(22,3706,0.91),(22,3707,0.98),(22,3708,2.73),(22,3709,3.29007),(22,3710,3.08007),(22,3711,3.63993),(22,3712,1.86662),(22,3713,1.05),(22,3714,1.12),(22,3715,0.93331),(22,3716,1.12),(22,3717,0.88669),(22,3718,1.07331),(22,3719,0.91),(22,3720,1.09669),(22,3721,5.32014),(22,3722,0.98),(22,3723,1.09669),(22,3724,0.98),(22,3725,1.00331),(22,3726,1.14331),(22,3727,1.16669),(22,3728,3.64),(22,3729,1.02669),(22,3730,2.19338),(22,3731,1.05),(22,3732,0.95669),(22,3733,1.14331),(22,3734,1.96),(22,3735,2.33338),(22,3736,4.78345),(22,3737,5.36655),(22,3738,0.95669),(22,3739,1.14331),(22,3740,0.95669),(22,3741,1.07331),(22,3742,0.91),(22,3743,1.09669),(22,3744,1.02669),(22,3745,1.21331),(22,3746,1.82),(22,3747,2.19338),(22,3748,4.55),(22,3749,5.13345),(22,3750,0.98),(22,3751,1.16669),(22,3752,0.91),(22,3753,1.09669),(22,3754,0.93331),(22,3755,1.12),(22,3756,4.9),(22,3757,5.83345),(22,3758,1.91338),(22,3759,2.14662),(22,3760,1.86662),(22,3761,1.05),(22,3762,1.12),(22,3763,0.98),(22,3764,1.16669),(22,3765,0.65338),(22,3766,2.1),(22,3767,1.16669),(22,3768,1.14331),(22,3769,0.23331),(22,3770,0.88669),(22,3771,0.93331),(24,3782,0.42),(24,3783,1.12),(24,3784,1.4),(25,114,0.14),(25,544,0.14),(25,941,0.18669),(25,3890,0.95669),(25,3891,1.07331),(25,3892,0.56),(25,3893,1.07331),(25,3894,1.14331),(25,3895,2.88),(25,3896,1.12),(25,3897,1.21331),(25,3898,9.1),(25,3899,1.07331),(25,3900,1.05),(25,3901,1.14331),(25,3902,1.16669),(25,3903,0.7),(25,3904,1.4),(25,3905,1.4),(25,3906,0.51331),(25,3907,1.05),(25,3908,1.26),(25,3909,0.37331),(25,3910,0.98),(25,3911,1.23669),(25,3912,0.95669),(25,3913,1.05),(25,3914,0.88669),(25,3915,1.02669),(25,3916,0.32669),(25,3917,0.93331),(25,3918,1.14331),(25,3919,0.46669),(25,3920,1.02669),(25,3921,1.14331),(25,3922,0.37331),(25,3923,0.95669),(25,3924,1.23669),(25,4113,0.32669),(25,4114,1.02669),(25,4115,1.19),(25,4116,0.84),(25,4117,2.14662),(25,4118,1.26),(25,4119,1.14331),(25,4120,0.28),(25,4121,0.91),(25,4122,1.07331),(26,544,0.14),(26,4265,0.84),(26,4266,0.98),(26,4267,0.65331),(26,4268,1.09669),(26,4269,1.16669),(26,4335,0.46669),(26,4336,1.12),(26,4337,1.19),(27,960,1.48),(27,1003,0.51331),(27,1008,1.21331),(27,1009,1.33),(27,1012,0.42),(27,1033,0.18669),(27,1066,0.28),(27,4405,0.65338),(27,4406,0.98),(27,4407,1.12),(27,4408,1.02669),(27,4409,1.16669),(27,4410,1.05),(27,4411,1.16669),(27,4412,0.91),(27,4413,1.07331),(27,4414,0.32669),(27,4415,1.00331),(27,4416,1.14331),(27,4417,0.42),(27,4418,0.98),(27,4419,1.09669),(27,4420,0.23331),(27,4421,0.95669),(27,4422,1.19),(27,4423,1.00331),(27,4424,1.19),(27,4629,1.23321),(27,4630,5.18),(28,1003,0.51331),(28,1008,1.21331),(28,1009,1.33),(28,1012,0.42),(28,1033,0.18669),(28,1066,0.28),(28,4405,0.65338),(28,4406,0.98),(28,4407,1.12),(28,4408,1.02669),(28,4409,1.16669),(28,4410,1.05),(28,4411,1.16669),(28,4412,0.91),(28,4413,1.07331),(28,4414,0.32669),(28,4415,1.00331),(28,4416,1.14331),(28,4417,0.42),(28,4418,0.98),(28,4419,1.09669),(28,4420,0.23331),(28,4421,0.95669),(28,4422,1.19),(28,4423,1.00331),(28,4424,1.19),(28,4629,1.23321),(28,4715,1.72679),(28,4716,4.81),(28,4717,5.79679),(29,960,1.48),(29,1003,0.51331),(29,1008,1.21331),(29,1009,1.33),(29,1012,0.42),(29,1033,0.18669),(29,1066,0.28),(29,4405,0.65338),(29,4406,0.98),(29,4407,1.12),(29,4408,1.02669),(29,4409,1.16669),(29,4410,1.05),(29,4411,1.16669),(29,4412,0.91),(29,4413,1.07331),(29,4414,0.32669),(29,4415,1.00331),(29,4416,1.14331),(29,4417,0.42),(29,4418,0.98),(29,4419,1.09669),(29,4420,0.23331),(29,4421,0.95669),(29,4422,1.19),(29,4423,1.00331),(29,4424,1.19),(30,18,0.17),(30,1003,0.51331),(30,1008,1.21331),(30,1009,1.33),(30,1012,0.42),(30,1033,0.18669),(30,1066,0.28),(30,4405,0.65338),(30,4406,0.98),(30,4407,1.12),(30,4408,1.02669),(30,4409,1.16669),(30,4410,1.05),(30,4411,1.16669),(30,4412,0.91),(30,4413,1.07331),(30,4414,0.32669),(30,4415,1.00331),(30,4416,1.14331),(30,4417,0.42),(30,4418,0.98),(30,4419,1.09669),(30,4420,0.23331),(30,4421,0.95669),(30,4422,1.19),(30,4423,1.00331),(30,4424,1.19),(30,4715,1.72679),(31,1003,0.51331),(31,1008,1.21331),(31,1009,1.33),(31,1012,0.42),(31,1033,0.18669),(31,1066,0.28),(31,4405,0.65338),(31,4406,0.98),(31,4407,1.12),(31,4408,1.02669),(31,4409,1.16669),(31,4410,1.05),(31,4411,1.16669),(31,4412,0.91),(31,4413,1.07331),(31,4414,0.32669),(31,4415,1.00331),(31,4416,1.14331),(31,4417,0.42),(31,4418,0.98),(31,4419,1.09669),(31,4420,0.23331),(31,4421,0.95669),(31,4422,1.19),(31,4423,1.00331),(31,4424,1.19),(31,4723,1.72679),(31,4724,5.30321),(31,4725,5.92),(32,1003,0.51331),(32,1008,1.21331),(32,1009,1.33),(32,1012,0.42),(32,1033,0.18669),(32,1066,0.28),(32,4405,0.65338),(32,4406,0.98),(32,4407,1.12),(32,4408,1.02669),(32,4409,1.16669),(32,4410,1.05),(32,4411,1.16669),(32,4412,0.91),(32,4413,1.07331),(32,4414,0.32669),(32,4415,1.00331),(32,4416,1.14331),(32,4417,0.42),(32,4418,0.98),(32,4419,1.09669),(32,4420,0.23331),(32,4421,0.95669),(32,4422,1.19),(32,4423,1.00331),(32,4424,1.19),(32,4629,1.23321),(32,4723,1.72679),(32,4724,5.30321),(32,4728,6.04321),(33,1003,0.51331),(33,1008,1.21331),(33,1009,1.33),(33,1012,0.42),(33,1033,0.18669),(33,1066,0.28),(33,4405,0.65338),(33,4406,0.98),(33,4407,1.12),(33,4408,1.02669),(33,4409,1.16669),(33,4410,1.05),(33,4411,1.16669),(33,4412,0.91),(33,4413,1.07331),(33,4414,0.32669),(33,4415,1.00331),(33,4416,1.14331),(33,4417,0.42),(33,4418,0.98),(33,4419,1.09669),(33,4420,0.23331),(33,4421,0.95669),(33,4422,1.19),(33,4423,1.00331),(33,4424,1.19),(33,4723,1.72679),(33,4724,5.30321),(33,4731,5.92),(34,960,1.48),(34,1003,0.51331),(34,1008,1.21331),(34,1009,1.33),(34,1012,0.42),(34,1033,0.18669),(34,1066,0.28),(34,4405,0.65338),(34,4406,0.98),(34,4407,1.12),(34,4408,1.02669),(34,4409,1.16669),(34,4410,1.05),(34,4411,1.16669),(34,4412,0.91),(34,4413,1.07331),(34,4414,0.32669),(34,4415,1.00331),(34,4416,1.14331),(34,4417,0.42),(34,4418,0.98),(34,4419,1.09669),(34,4420,0.23331),(34,4421,0.95669),(34,4422,1.19),(34,4423,1.00331),(34,4424,1.19),(34,4723,1.72679),(34,4724,5.30321),(34,4733,6.16679),(35,960,1.48),(35,1003,0.51331),(35,1008,1.21331),(35,1009,1.33),(35,1012,0.42),(35,1033,0.18669),(35,1066,0.28),(35,4405,0.65338),(35,4406,0.98),(35,4407,1.12),(35,4408,1.02669),(35,4409,1.16669),(35,4410,1.05),(35,4411,1.16669),(35,4412,0.91),(35,4413,1.07331),(35,4414,0.32669),(35,4415,1.00331),(35,4416,1.14331),(35,4417,0.42),(35,4418,0.98),(35,4419,1.09669),(35,4420,0.23331),(35,4421,0.95669),(35,4422,1.19),(35,4423,1.00331),(35,4424,1.19),(35,4723,1.72679),(35,4724,5.30321),(35,4733,6.16679),(35,4736,4.81),(36,544,0.14),(36,4265,0.84),(36,4266,0.98),(36,4267,0.65331),(36,4268,1.09669),(36,4269,1.16669),(36,4335,0.46669),(36,4336,1.12),(36,4337,1.19),(37,544,0.14),(37,4265,0.84),(37,4266,0.98),(37,4267,0.65331),(37,4268,1.09669),(37,4269,1.16669),(37,4335,0.46669),(37,4336,1.12),(37,4337,1.19),(38,544,0.14),(38,4265,0.84),(38,4266,0.98),(38,4267,0.65331),(38,4268,1.09669),(38,4269,1.16669),(38,4335,0.46669),(38,4336,1.12),(38,4337,1.19),(39,544,0.14),(39,1003,2.05324),(39,1033,0.18669),(39,1063,0.14),(39,1064,0.93331),(39,1065,1.12),(39,2984,0.42),(39,2985,1.00331),(39,2988,0.93324),(39,3613,0.14),(39,3614,0.86331),(39,4417,1.68),(39,4775,0.86331),(39,4776,1.00331),(39,4777,1.02669),(39,4778,1.28331),(39,4779,1.12),(39,4780,1.19),(39,4781,1.05),(39,4782,1.12),(39,4783,1.09669),(39,4784,1.19),(39,4785,0.95669),(39,4786,1.23669),(39,4787,4.38676),(39,4788,5.04),(39,4933,0.37331),(39,4934,1.02669),(39,4935,1.16669),(39,4936,1.21331),(39,4937,1.86662),(39,4938,2.1),(39,4939,0.95669),(39,4940,1.02669),(39,4941,0.98),(39,4942,1.16669),(39,4999,0.95669),(40,994,0.56),(40,1003,1.53993),(40,1008,3.63993),(40,1009,3.99),(40,1012,0.42),(40,1021,0.42),(40,1063,0.14),(40,1064,0.93331),(40,1065,1.12),(40,1066,0.84),(40,2979,0.65338),(40,2984,0.42),(40,2985,1.00331),(40,2988,0.46662),(40,4417,0.42),(40,4937,0.93331),(40,5069,0.91),(40,5070,1.09669),(40,5071,0.93331),(40,5072,1.05),(40,5073,1.05),(40,5074,1.23669),(40,5075,1.02669),(40,5076,1.12),(40,5077,1.00331),(40,5078,1.16669),(40,5079,0.98),(40,5080,1.07331),(40,5081,0.93331),(40,5082,1.09669),(40,5083,1.05),(40,5084,1.12),(40,5365,0.93331),(40,5366,1.16669),(40,5367,0.98),(40,5368,1.07331),(40,5369,1.30669),(40,5370,1.07331),(40,5371,0.95669),(40,5372,1.12),(41,994,0.56),(41,1003,1.53993),(41,1008,3.63993),(41,1009,3.99),(41,1012,0.42),(41,1021,0.42),(41,1063,0.14),(41,1064,0.93331),(41,1065,1.12),(41,1066,0.84),(41,2979,0.65338),(41,2984,0.42),(41,2985,1.00331),(41,2988,0.46662),(41,4417,0.42),(41,4937,0.93331),(41,5069,0.91),(41,5070,1.09669),(41,5071,0.93331),(41,5072,1.05),(41,5073,1.05),(41,5074,1.23669),(41,5075,1.02669),(41,5076,1.12),(41,5077,1.00331),(41,5078,1.16669),(41,5079,0.98),(41,5080,1.07331),(41,5081,0.93331),(41,5082,1.09669),(41,5083,1.05),(41,5084,1.12),(41,5365,0.93331),(41,5366,1.16669),(41,5367,0.98),(41,5368,1.07331),(41,5369,1.30669),(41,5370,1.07331),(41,5371,0.95669),(41,5372,1.12),(42,994,0.56),(42,1003,1.53993),(42,1008,3.63993),(42,1009,3.99),(42,1012,0.42),(42,1021,0.42),(42,1063,0.14),(42,1064,0.93331),(42,1065,1.12),(42,1066,0.84),(42,2979,0.65338),(42,2984,0.42),(42,2985,1.00331),(42,2988,0.46662),(42,4417,0.42),(42,4937,0.93331),(42,5069,0.91),(42,5070,1.09669),(42,5071,0.93331),(42,5072,1.05),(42,5073,1.05),(42,5074,1.23669),(42,5075,1.02669),(42,5076,1.12),(42,5077,1.00331),(42,5078,1.16669),(42,5079,0.98),(42,5080,1.07331),(42,5081,0.93331),(42,5082,1.09669),(42,5083,1.05),(42,5084,1.12),(42,5365,0.93331),(42,5366,1.16669),(42,5367,0.98),(42,5368,1.07331),(42,5369,1.30669),(42,5370,1.07331),(42,5371,0.95669),(42,5372,1.12),(43,544,0.28),(43,1058,0.14),(43,4723,0.32669),(43,5550,0.91),(43,5551,1.00331),(43,5552,0.86331),(43,5553,1.05),(43,5554,0.95669),(43,5555,1.02669),(43,5556,0.32669),(43,5557,0.95669),(43,5558,1.09669),(43,5559,1.00331),(43,5560,1.19),(43,5653,0.23331),(43,5654,0.88669),(43,5655,1.09669),(43,5656,0.23331),(43,5657,0.88669),(43,5658,1.00331),(44,977,0.51331),(44,1003,1.02662),(44,1033,0.18669),(44,1063,0.28),(44,1064,1.86662),(44,1065,2.24),(44,1066,0.56),(44,2984,0.84),(44,2985,2.00662),(44,2988,0.93324),(44,2993,0.28),(44,4405,1.63345),(44,4417,0.42),(44,4781,1.05),(44,4782,1.12),(44,4787,1.09669),(44,4788,1.26),(44,4936,1.21331),(44,4937,0.93331),(44,4938,1.05),(44,4941,1.96),(44,4942,2.33338),(44,5079,0.98),(44,5796,1.02669),(44,5797,1.16669),(44,5798,3.08007),(44,5799,3.42993),(44,5800,1.02669),(44,5801,1.19),(44,5802,1.07331),(44,5803,1.14331),(44,5804,1.02669),(44,5805,1.16669),(44,5806,0.93331),(44,5807,1.05),(44,5808,1.02669),(44,5809,1.19),(44,5810,1.07331),(44,5944,1.26),(44,5945,1.05),(44,5946,1.19),(45,544,0.42),(45,1041,0.37331),(45,3613,0.7),(45,3619,0.37338),(45,4723,0.98007),(45,6080,0.88669),(45,6081,0.98),(45,6082,0.88669),(45,6083,1.00331),(45,6084,0.88669),(45,6085,0.98),(45,6086,0.37331),(45,6087,1.07331),(45,6088,1.16669),(45,6089,0.37338),(45,6090,0.86331),(45,6091,1.09669),(45,6092,0.86331),(45,6093,0.98),(45,6094,0.51331),(45,6095,1.09669),(45,6096,1.28331),(45,6097,0.42),(45,6098,0.98),(45,6099,1.09669),(45,6100,0.37331),(45,6101,1.05),(45,6102,1.21331),(45,6103,1.07331),(45,6104,1.21331),(45,6105,1.09669),(45,6106,1.21331),(45,6107,1.12),(45,6108,1.28331),(45,6109,0.37331),(45,6110,1.05),(45,6111,1.33),(45,6112,1.00331),(45,6113,1.14331),(45,6114,0.60669),(45,6115,1.07331),(45,6116,1.21331),(45,6372,0.23331),(45,6373,1.09669),(45,6374,1.21331),(45,6375,0.51331),(45,6376,1.05),(45,6377,1.09669),(45,6378,0.42),(45,6379,1.07331),(45,6380,1.23669),(45,6381,0.18669),(45,6382,0.93331),(45,6383,1.09669),(45,6512,0.86331),(45,6513,1.02669),(45,6514,1.72662),(45,6515,0.91),(45,6516,0.98),(45,6517,0.86331),(45,6518,1.00331),(45,6519,0.84),(45,6520,0.93331),(45,6521,1.00331),(45,6522,1.12),(45,6523,1.05),(45,6524,1.23669),(46,977,0.51331),(46,984,1.07331),(46,994,0.28),(46,1003,1.02662),(46,1021,0.84),(46,1033,0.37338),(46,1066,0.28),(46,2979,0.32669),(46,2988,0.23331),(46,2993,0.56),(46,4405,0.32669),(46,4417,0.42),(46,5077,1.00331),(46,6372,0.23331),(46,6630,1.09669),(46,6631,1.16669),(46,6632,1.14331),(46,6633,2.46679),(46,6634,1.02669),(46,6635,1.14331),(46,6636,1.14331),(46,6637,1.35331),(46,6638,1.26),(46,6639,1.35331),(46,6640,1.02669),(46,6641,1.19),(46,6642,0.98),(46,6643,1.05),(46,6644,0.23331),(46,6645,0.95669),(46,6646,1.07331),(46,6647,1.00331),(46,6648,1.14331),(46,6649,1.12),(46,6650,0.95669),(46,6651,1.19),(46,6652,0.84),(46,6653,2.28662),(46,6654,1.21331),(46,6655,1.30669),(46,7066,1.09669),(46,7067,1.16669),(46,7068,0.37331),(46,7069,1.07331),(46,7070,1.14331),(46,7071,0.95669),(46,7072,1.05),(46,7073,1.02669),(46,7074,1.19),(46,7075,0.98),(46,7076,1.16669),(46,7077,0.95669),(46,7078,1.05),(47,977,1.02662),(47,984,1.07331),(47,994,0.84),(47,1003,1.53993),(47,1008,1.21331),(47,1009,1.33),(47,1021,0.84),(47,1033,0.56007),(47,1066,0.28),(47,2979,0.32669),(47,2988,0.23331),(47,2993,0.56),(47,4405,0.32669),(47,4417,0.42),(47,5077,1.00331),(47,6630,1.09669),(47,6631,1.16669),(47,6632,1.14331),(47,6634,1.02669),(47,6635,1.14331),(47,6636,1.14331),(47,6637,1.35331),(47,6638,1.26),(47,6639,1.35331),(47,6640,1.02669),(47,6641,1.19),(47,6642,0.98),(47,6643,1.05),(47,6645,0.95669),(47,6646,1.07331),(47,6647,1.00331),(47,6648,1.14331),(47,6649,1.12),(47,6650,0.95669),(47,6651,1.19),(47,7071,0.95669),(47,7072,1.05),(47,7073,1.02669),(47,7074,1.19),(47,7075,0.98),(47,7076,1.16669),(47,7077,0.95669),(47,7078,1.05),(47,7251,1.72679),(47,7252,1.02669),(47,7253,1.28331),(47,7254,0.91),(47,7255,1.07331),(47,7256,0.93331),(47,7257,1.05),(47,7258,0.98),(47,7259,1.19),(48,977,1.02662),(48,984,1.07331),(48,994,0.84),(48,1003,1.53993),(48,1008,1.21331),(48,1009,1.33),(48,1021,0.84),(48,1033,0.56007),(48,1066,0.28),(48,2979,0.32669),(48,2988,0.23331),(48,2993,0.56),(48,3619,0.98679),(48,4405,0.32669),(48,4417,0.42),(48,5077,1.00331),(48,6630,1.09669),(48,6631,1.16669),(48,6632,1.14331),(48,6634,1.02669),(48,6635,1.14331),(48,6636,1.14331),(48,6637,1.35331),(48,6638,1.26),(48,6639,1.35331),(48,6640,1.02669),(48,6641,1.19),(48,6642,0.98),(48,6643,1.05),(48,6645,0.95669),(48,6646,1.07331),(48,6647,1.00331),(48,6648,1.14331),(48,6649,1.12),(48,6650,0.95669),(48,6651,1.19),(48,7071,0.95669),(48,7072,1.05),(48,7073,1.02669),(48,7074,1.19),(48,7075,0.98),(48,7076,1.16669),(48,7077,0.95669),(48,7078,1.05),(48,7252,1.02669),(48,7253,1.28331),(48,7254,0.91),(48,7255,1.07331),(48,7256,0.93331),(48,7257,1.05),(48,7258,0.98),(48,7259,1.19),(48,7304,2.22),(48,7305,5.42679),(48,7306,6.41321),(48,7310,5.18),(49,977,0.51331),(49,984,1.07331),(49,994,0.56),(49,1003,1.02662),(49,1021,0.42),(49,1033,0.74676),(49,2979,0.32669),(49,2988,0.23331),(49,2993,1.12),(49,3613,0.28),(49,3619,1.36017),(49,3721,5.57348),(49,6632,1.14331),(49,6634,2.05338),(49,6635,2.28662),(49,6636,2.28662),(49,6637,2.70662),(49,6640,1.02669),(49,6641,1.19),(49,6645,1.91338),(49,6646,2.14662),(49,6647,2.00662),(49,6648,2.28662),(49,7071,0.95669),(49,7072,1.05),(49,7073,1.02669),(49,7074,1.19),(49,7075,1.96),(49,7076,2.33338),(49,7077,1.91338),(49,7078,2.1),(49,7337,0.37331),(49,7338,0.98),(49,7339,1.19),(49,7424,0.91),(49,7425,0.98),(49,7426,0.98),(49,7427,1.07331),(49,7428,0.28),(49,7429,0.93331),(49,7430,1.05),(49,7431,0.91),(49,7432,1.07331),(49,7433,6.89348),(50,935,0.23331),(50,977,1.02662),(50,984,2.14662),(50,994,0.28),(50,1003,1.53993),(50,1021,0.84),(50,1033,0.37338),(50,1066,0.56),(50,2979,0.65338),(50,2988,0.46662),(50,2993,0.56),(50,3619,0.98679),(50,4417,0.84),(50,5077,2.00662),(50,6632,2.28662),(50,6634,1.02669),(50,6635,1.14331),(50,6636,1.14331),(50,6637,1.35331),(50,6638,2.52),(50,6639,2.70662),(50,6640,2.05338),(50,6641,2.38),(50,6645,0.95669),(50,6646,1.07331),(50,6647,1.00331),(50,6648,1.14331),(50,6649,2.24),(50,6650,1.91338),(50,6651,2.38),(50,7071,1.91338),(50,7072,2.1),(50,7073,2.05338),(50,7074,2.38),(50,7075,0.98),(50,7076,1.16669),(50,7077,0.95669),(50,7078,1.05),(50,7448,0.91),(50,7449,1.07331),(50,7450,0.46662),(50,7451,1.77338),(50,7452,1.14331),(50,7453,0.98),(50,7492,0.28),(50,7493,0.93331),(50,7494,1.00331),(50,7495,0.32669),(50,7496,1.14331),(50,7497,1.21331),(50,7498,0.42),(50,7499,1.16669),(50,7500,1.28331),(50,7524,5.42679),(50,7525,6.41321),(51,544,0.28),(51,977,0.51331),(51,984,1.07331),(51,994,0.28),(51,1003,1.02662),(51,1021,0.84),(51,1033,0.37338),(51,1066,0.28),(51,2979,0.32669),(51,2988,0.23331),(51,2993,0.56),(51,3613,0.42),(51,3614,1.72662),(51,4405,0.32669),(51,4417,0.42),(51,5077,1.00331),(51,6630,1.09669),(51,6631,1.16669),(51,6632,1.14331),(51,6634,1.02669),(51,6635,1.14331),(51,6636,1.14331),(51,6637,1.35331),(51,6638,1.26),(51,6639,1.35331),(51,6640,1.02669),(51,6641,1.19),(51,6642,0.98),(51,6643,1.05),(51,6645,0.95669),(51,6646,1.07331),(51,6647,1.00331),(51,6648,1.14331),(51,6649,1.12),(51,6650,0.95669),(51,6651,1.19),(51,7071,0.95669),(51,7072,1.05),(51,7073,1.02669),(51,7074,1.19),(51,7075,0.98),(51,7076,1.16669),(51,7077,0.95669),(51,7078,1.05),(51,7251,0.98007),(51,7557,0.95669),(51,7558,1.05),(51,7559,0.88669),(51,7560,0.95669),(51,7561,1.00331),(51,7562,1.09669),(51,7563,0.98),(51,7564,1.09669),(51,7565,0.95669),(51,7566,1.07331),(51,7567,0.37338),(51,7568,1.00331),(51,7569,1.07331),(51,7570,0.91),(51,7571,1.14331),(51,7572,0.51331),(51,7573,1.02669),(51,7574,1.21331),(51,7575,0.32669),(51,7576,0.93331),(51,7577,0.98),(51,7578,0.18669),(51,7579,0.86331),(51,7580,0.93331),(51,7581,0.23331),(51,7582,0.88669),(51,7583,1.12),(51,7685,0.42),(51,7686,1.02669),(51,7687,1.09669),(51,7688,0.18669),(51,7689,0.86331),(51,7690,0.93331),(51,7691,0.46669),(51,7692,1.16669),(51,7693,1.30669),(51,7759,1.05),(51,7760,0.98),(51,7761,0.88669),(51,7762,0.95669),(52,977,0.51331),(52,984,1.07331),(52,994,0.56),(52,1003,1.53993),(52,1021,0.42),(52,1033,0.74676),(52,1066,0.28),(52,2979,0.32669),(52,2988,0.23331),(52,2993,1.12),(52,3613,0.14),(52,4417,0.42),(52,5077,1.00331),(52,6632,1.14331),(52,6634,2.05338),(52,6635,2.28662),(52,6636,2.28662),(52,6637,2.70662),(52,6638,1.26),(52,6639,1.35331),(52,6640,1.02669),(52,6641,1.19),(52,6645,1.91338),(52,6646,2.14662),(52,6647,2.00662),(52,6648,2.28662),(52,6649,1.12),(52,6650,0.95669),(52,6651,1.19),(52,7071,0.95669),(52,7072,1.05),(52,7073,1.02669),(52,7074,1.19),(52,7075,1.96),(52,7076,2.33338),(52,7077,1.91338),(52,7078,2.1),(52,7830,0.88669),(52,7831,1.00331),(53,977,1.53993),(53,984,3.21993),(53,1003,1.53993),(53,1021,1.26),(53,1066,0.84),(53,2979,0.98007),(53,2988,0.69993),(53,3619,0.37338),(53,4417,1.26),(53,5077,3.00993),(53,6109,1.97321),(53,6632,3.42993),(53,6638,3.78),(53,6639,4.05993),(53,6640,3.08007),(53,6641,3.57),(53,6649,3.36),(53,6650,2.87007),(53,6651,3.57),(53,7071,2.87007),(53,7072,3.15),(53,7073,3.08007),(53,7074,2.38),(53,7572,0.51331),(53,7840,1.09669),(53,7841,1.28331),(53,7842,4.93321),(53,7843,5.67321),(53,7868,0.18669),(53,7869,0.86331),(53,7870,1.00331),(53,7889,1.00331),(53,7890,1.26),(53,7891,0.93331),(53,7892,1.09669),(54,68,0.48),(54,977,1.02662),(54,994,1.4),(54,1003,1.02662),(54,1008,2.42662),(54,1009,2.66),(54,1021,0.84),(54,1033,0.37338),(54,3613,0.28),(54,3619,0.56007),(54,4405,0.65338),(54,6512,0.86331),(54,6514,0.86331),(54,6630,2.19338),(54,6631,2.33338),(54,6642,1.96),(54,6643,2.1),(54,7252,2.05338),(54,7253,2.56662),(54,7254,1.82),(54,7255,2.14662),(54,7256,2.79993),(54,7257,3.15),(54,7258,1.96),(54,7259,2.38),(54,7933,0.42),(54,7934,1.12),(54,7935,1.23669),(54,7936,0.23331),(54,7937,0.95669),(54,7938,1.09669),(54,8015,0.32669),(54,8016,0.98),(54,8017,1.16669),(54,8018,0.23331),(54,8019,1.00331),(54,8020,1.09669),(54,8081,1.05),(54,8082,1.00331),(54,8083,1.02669),(54,8084,1.23669),(54,8085,1.00331),(54,8086,1.14331),(54,8087,0.93331),(54,8088,1.02669),(54,8089,0.74662),(54,8090,0.98),(54,8091,1.05),(54,8092,0.95669),(54,8093,1.09669),(55,68,0.48),(55,544,0.28),(55,977,1.53993),(55,994,1.68),(55,1003,1.53993),(55,1008,3.63993),(55,1009,3.99),(55,1021,1.26),(55,1033,0.56007),(55,3613,0.42),(55,3614,0.86331),(55,4405,0.98007),(55,6630,3.29007),(55,6631,3.50007),(55,6642,2.94),(55,6643,3.15),(55,7251,0.65338),(55,7252,3.08007),(55,7253,3.84993),(55,7254,2.73),(55,7255,3.21993),(55,7256,2.79993),(55,7257,3.15),(55,7258,2.94),(55,7259,3.57),(55,7557,0.95669),(55,7558,1.05),(55,7559,0.88669),(55,7560,0.95669),(55,7561,1.00331),(55,7562,1.09669),(55,7565,0.95669),(55,7566,1.07331),(55,7572,0.51331),(55,7573,1.02669),(55,7574,1.21331),(55,7575,0.32669),(55,7576,0.93331),(55,7577,0.98),(55,7581,0.23331),(55,7582,0.88669),(55,7583,1.12),(55,7685,0.42),(55,7686,1.02669),(55,7687,1.09669),(55,7688,0.18669),(55,7689,0.86331),(55,7690,0.93331),(55,7760,0.98),(55,7761,0.88669),(55,7762,0.95669),(56,68,0.48),(56,977,2.05324),(56,994,2.24),(56,1003,2.05324),(56,1008,4.85324),(56,1009,5.32),(56,1021,1.26),(56,1033,0.74676),(56,4405,0.98007),(56,6630,3.29007),(56,6631,3.50007),(56,6642,2.94),(56,6643,3.15),(56,7252,4.10676),(56,7253,5.13324),(56,7254,3.64),(56,7255,4.29324),(56,7256,3.73324),(56,7257,4.2),(56,7258,3.92),(56,7259,4.76),(57,68,0.48),(57,89,0.65338),(57,977,0.51331),(57,994,1.12),(57,1003,1.53993),(57,1008,1.21331),(57,1009,1.33),(57,1021,0.42),(57,1033,0.56007),(57,2993,0.56),(57,3613,0.7),(57,3619,0.74676),(57,3721,1.77338),(57,3916,0.32669),(57,4405,0.32669),(57,6630,1.09669),(57,6631,1.16669),(57,6633,0.46669),(57,6634,2.05338),(57,6635,2.28662),(57,6636,2.28662),(57,6637,2.70662),(57,6642,0.98),(57,6643,1.05),(57,6645,1.91338),(57,6646,2.14662),(57,7075,1.96),(57,7076,2.33338),(57,7252,1.02669),(57,7253,1.28331),(57,7254,0.91),(57,7255,1.07331),(57,7256,0.93331),(57,7257,1.05),(57,7258,0.98),(57,7259,1.19),(57,7433,2.19338),(57,7830,0.88669),(57,8154,0.32669),(57,8155,1.02669),(57,8156,1.12),(57,8157,0.42),(57,8158,1.14331),(57,8159,1.21331),(57,8160,0.95669),(57,8161,1.09669),(57,8162,0.37331),(57,8163,0.98),(57,8164,1.12),(57,8165,1.02662),(57,8166,1.05),(57,8167,1.26),(57,8168,1.26),(57,8169,1.33),(57,8170,0.93331),(57,8171,1.02669),(57,8172,0.98),(57,8173,1.02669),(57,8267,0.84),(57,8268,2.05338),(57,8269,1.07331),(57,8270,1.12),(57,8324,0.14),(57,8325,0.88669),(57,8326,1.05),(57,8327,0.93331),(57,8328,1.00331),(57,8329,1.12),(57,8330,1.00331),(57,8331,1.12),(57,8332,0.86331),(57,8333,1.00331),(57,8334,0.91),(57,8335,0.98),(57,8336,1.68),(57,8337,2.1),(57,8338,0.23331),(57,8339,0.91),(57,8340,1.09669),(58,977,3.07986),(58,1003,2.05324),(58,1008,4.85324),(58,1009,5.32),(58,1021,0.84),(58,1028,2.00662),(58,1066,1.12),(58,2988,0.46662),(58,4417,0.84),(58,8392,2.00662),(58,8393,2.47338),(58,8394,2.14662),(58,8395,2.61338),(58,8396,2.1),(58,8397,2.47338),(58,8398,2.42662),(58,8399,2.19338),(58,8400,2.47338),(58,8401,2.14662),(58,8402,2.47338),(58,8403,1.96),(58,8404,2.56662),(58,8697,1.82),(58,8698,2.1),(59,114,0.24),(59,8801,1.56),(59,8802,1.71996),(59,8820,0.24),(60,3,0.63996),(60,8825,0.14),(60,8826,0.95669),(60,8827,1.07331),(61,3,0.63996),(62,3,0.63996),(63,114,0.24),(64,114,0.24),(65,114,0.24),(66,114,0.24),(67,114,0.24),(67,8875,1.71996),(68,18,0.17),(68,114,0.24),(68,8875,1.71996),(69,114,0.24),(69,8887,1.64004),(69,8888,1.95996),(70,114,0.24),(70,8895,1.52004),(70,8896,1.83996),(71,114,0.24),(71,8801,1.56),(71,8802,1.71996),(71,8820,0.98),(71,8909,2.3334),(71,8910,2.6666),(71,8911,2.15339),(72,114,0.14),(72,544,0.14),(72,941,0.18669),(72,3890,0.95669),(72,3891,1.07331),(72,3892,0.56),(72,3893,1.07331),(72,3894,1.14331),(72,3895,2.88),(72,3896,1.12),(72,3897,1.21331),(72,3898,9.1),(72,3899,1.07331),(72,3900,1.05),(72,3901,1.14331),(72,3902,1.16669),(72,3903,0.7),(72,3904,1.4),(72,3905,1.4),(72,3906,0.51331),(72,3907,1.05),(72,3908,1.26),(72,3909,0.37331),(72,3910,0.98),(72,3911,1.23669),(72,3912,0.95669),(72,3913,1.05),(72,3914,0.88669),(72,3915,1.02669),(72,3916,0.32669),(72,3917,0.93331),(72,3918,1.14331),(72,3919,0.46669),(72,3920,1.02669),(72,3921,1.14331),(72,3922,0.37331),(72,3923,0.95669),(72,3924,1.23669),(72,4113,0.32669),(72,4114,1.02669),(72,4115,1.19),(72,4116,0.84),(72,4117,2.14662),(72,4118,1.26),(72,4119,1.14331),(72,4120,0.28),(72,4121,0.91),(72,4122,1.07331),(72,8913,5.42679);


--
-- Table structure for table `#__finder_links_terms5`
--



CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms5`
--




--
-- Table structure for table `#__finder_links_terms6`
--



CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms6`
--


INSERT INTO `#__finder_links_terms6` (`link_id`, `term_id`, `weight`) VALUES (7,15,0.98679),(7,16,4.93321),(19,69,1.48),(19,70,5.30321),(20,101,1.72679),(21,101,0.9334),(22,2363,0.56007),(22,2364,2.58993),(22,2365,3.21993),(22,2366,0.23331),(22,2367,1.05),(22,2368,1.23669),(22,2369,2.52),(22,2370,6.58014),(22,2371,3.63993),(22,2372,3.57),(22,2373,5.04),(22,2374,15.8663),(22,2375,20.23),(22,2376,0.56007),(22,2377,2.73),(22,2378,2.94),(22,2379,0.56007),(22,2380,2.66007),(22,2381,3.08007),(22,2382,0.84),(22,2383,2.79993),(22,2384,3.29007),(22,2385,3.78),(22,2386,6.3),(22,2387,7.00014),(22,2388,3.15),(22,2389,1.16669),(22,2390,2.33338),(22,2391,1.96014),(22,2392,2.05338),(22,2393,2.28662),(22,2394,3.29007),(22,2395,4.05993),(22,2396,0.98007),(22,2397,3.08007),(22,2398,3.29007),(22,2399,3.73296),(22,2400,6.43986),(22,2401,7.27986),(22,2402,5.32014),(22,2403,6.72),(22,2404,1.05),(22,2405,1.26),(22,2406,2.73),(22,2407,3.36),(22,2408,2.24),(22,2409,0.91),(22,2410,0.98),(22,2411,6.16014),(22,2412,7.27986),(22,2413,1.05),(22,2414,1.33),(22,2415,2.8),(22,2416,0.91),(22,2417,1.12),(22,2418,6.16014),(22,2419,6.85986),(22,2420,1.86662),(22,2421,0.98),(22,2422,1.14331),(22,2423,1.05),(22,2424,1.33),(22,2425,70.565),(22,2426,96.04),(22,2427,105.282),(22,2428,112.889),(22,2429,117.387),(22,2430,1.68021),(22,2431,2.58993),(22,2432,2.79993),(22,2433,2.58993),(22,2434,2.79993),(22,2435,3.00993),(22,2436,3.42993),(22,2437,0.37331),(22,2438,1.16669),(22,2439,1.35331),(22,2440,1.4),(22,2441,0.98),(22,2442,1.07331),(22,2443,0.95669),(22,2444,1.14331),(22,2445,3.08007),(22,2446,3.78),(22,2447,0.93324),(22,2448,0.93331),(22,2449,1.05),(22,2450,3.00993),(22,2451,1.12),(22,2452,2.19338),(22,2453,1.40007),(22,2454,3.00993),(22,2455,3.63993),(22,2456,5.04),(22,2457,18.9),(22,2458,23.0996),(22,2459,4.19958),(22,2460,6.01986),(22,2461,6.72),(22,2462,2.94),(22,2463,3.21993),(22,2464,8.39979),(22,2465,9.45),(22,2466,0.46662),(22,2467,2.00662),(22,2468,1.12),(22,2469,1.09669),(22,2470,2.52),(22,2471,5.71683),(22,2472,6.37),(22,2473,8.8669),(22,2474,1.16669),(22,2475,9.02979),(23,3772,1.48),(23,3773,5.67321),(24,2425,1.30676),(24,3804,2.00662),(24,3805,2.24),(24,3806,0.98),(24,3807,1.05),(24,3808,2.34652),(24,3809,1.12),(24,3810,1.33),(25,2379,0.18669),(25,4052,0.91),(25,4053,1.19),(25,4054,0.37338),(25,4055,1.82),(25,4056,1.00331),(25,4057,0.98),(25,4058,0.37338),(25,4059,0.93331),(25,4060,1.09669),(25,4061,0.91),(25,4062,1.05),(26,15,2.24028),(26,16,7.46648),(26,4308,0.84),(26,4309,0.95669),(26,4310,1.00331),(26,4311,1.12),(26,4312,0.91),(26,4313,0.98),(26,4314,0.93331),(26,4315,1.05),(26,4316,1.00331),(26,4317,0.23331),(26,4318,0.91),(26,4319,1.14331),(27,2366,0.23331),(27,2385,0.84),(27,2399,0.23331),(27,2408,0.28),(27,2415,0.28),(27,2437,0.37331),(27,2459,0.23331),(27,4542,0.37331),(27,4543,1.05),(27,4544,1.16669),(27,4545,1.00331),(27,4546,1.21331),(27,4547,2.14662),(27,4548,1.19),(27,4549,1.30669),(27,4550,0.88669),(27,4551,1.05),(27,4552,1.05),(27,4553,1.09669),(27,4554,1.09669),(27,4555,1.35331),(27,4556,1.07331),(27,4557,1.16669),(27,4558,0.98),(27,4559,1.09669),(28,2366,0.23331),(28,2385,0.84),(28,2399,0.23331),(28,2408,0.28),(28,2415,0.28),(28,2437,0.37331),(28,2459,0.23331),(28,4542,0.37331),(28,4543,1.05),(28,4544,1.16669),(28,4545,1.00331),(28,4546,1.21331),(28,4547,2.14662),(28,4548,1.19),(28,4549,1.30669),(28,4550,0.88669),(28,4551,1.05),(28,4552,1.05),(28,4553,1.09669),(28,4554,1.09669),(28,4555,1.35331),(28,4556,1.07331),(28,4557,1.16669),(28,4558,0.98),(28,4559,1.09669),(29,2366,0.23331),(29,2385,0.84),(29,2399,0.23331),(29,2408,0.28),(29,2415,0.28),(29,2437,0.37331),(29,2459,0.23331),(29,4542,0.37331),(29,4543,1.05),(29,4544,1.16669),(29,4545,1.00331),(29,4546,1.21331),(29,4547,2.14662),(29,4548,1.19),(29,4549,1.30669),(29,4550,0.88669),(29,4551,1.05),(29,4552,1.05),(29,4553,1.09669),(29,4554,1.09669),(29,4555,1.35331),(29,4556,1.07331),(29,4557,1.16669),(29,4558,0.98),(29,4559,1.09669),(30,2366,0.23331),(30,2385,0.84),(30,2399,0.23331),(30,2408,0.28),(30,2415,0.28),(30,2437,0.37331),(30,2459,0.23331),(30,4542,0.37331),(30,4543,1.05),(30,4544,1.16669),(30,4545,1.00331),(30,4546,1.21331),(30,4547,2.14662),(30,4548,1.19),(30,4549,1.30669),(30,4550,0.88669),(30,4551,1.05),(30,4552,1.05),(30,4553,1.09669),(30,4554,1.09669),(30,4555,1.35331),(30,4556,1.07331),(30,4557,1.16669),(30,4558,0.98),(30,4559,1.09669),(31,2366,0.23331),(31,2385,0.84),(31,2399,0.23331),(31,2408,0.28),(31,2415,0.28),(31,2437,0.37331),(31,2459,0.23331),(31,4542,0.37331),(31,4543,1.05),(31,4544,1.16669),(31,4545,1.00331),(31,4546,1.21331),(31,4547,2.14662),(31,4548,1.19),(31,4549,1.30669),(31,4550,0.88669),(31,4551,1.05),(31,4552,1.05),(31,4553,1.09669),(31,4554,1.09669),(31,4555,1.35331),(31,4556,1.07331),(31,4557,1.16669),(31,4558,0.98),(31,4559,1.09669),(32,2366,0.23331),(32,2385,0.84),(32,2399,0.23331),(32,2408,0.28),(32,2415,0.28),(32,2437,0.37331),(32,2459,0.23331),(32,4542,0.37331),(32,4543,1.05),(32,4544,1.16669),(32,4545,1.00331),(32,4546,1.21331),(32,4547,2.14662),(32,4548,1.19),(32,4549,1.30669),(32,4550,0.88669),(32,4551,1.05),(32,4552,1.05),(32,4553,1.09669),(32,4554,1.09669),(32,4555,1.35331),(32,4556,1.07331),(32,4557,1.16669),(32,4558,0.98),(32,4559,1.09669),(33,2366,0.23331),(33,2385,0.84),(33,2399,0.23331),(33,2408,0.28),(33,2415,0.28),(33,2437,0.37331),(33,2459,0.23331),(33,4542,0.37331),(33,4543,1.05),(33,4544,1.16669),(33,4545,1.00331),(33,4546,1.21331),(33,4547,2.14662),(33,4548,1.19),(33,4549,1.30669),(33,4550,0.88669),(33,4551,1.05),(33,4552,1.05),(33,4553,1.09669),(33,4554,1.09669),(33,4555,1.35331),(33,4556,1.07331),(33,4557,1.16669),(33,4558,0.98),(33,4559,1.09669),(34,2366,0.23331),(34,2385,0.84),(34,2399,0.23331),(34,2408,0.28),(34,2415,0.28),(34,2437,0.37331),(34,2459,0.23331),(34,4542,0.37331),(34,4543,1.05),(34,4544,1.16669),(34,4545,1.00331),(34,4546,1.21331),(34,4547,2.14662),(34,4548,1.19),(34,4549,1.30669),(34,4550,0.88669),(34,4551,1.05),(34,4552,1.05),(34,4553,1.09669),(34,4554,1.09669),(34,4555,1.35331),(34,4556,1.07331),(34,4557,1.16669),(34,4558,0.98),(34,4559,1.09669),(35,2366,0.23331),(35,2385,0.84),(35,2399,0.23331),(35,2408,0.28),(35,2415,0.28),(35,2437,0.37331),(35,2459,0.23331),(35,4542,0.37331),(35,4543,1.05),(35,4544,1.16669),(35,4545,1.00331),(35,4546,1.21331),(35,4547,2.14662),(35,4548,1.19),(35,4549,1.30669),(35,4550,0.88669),(35,4551,1.05),(35,4552,1.05),(35,4553,1.09669),(35,4554,1.09669),(35,4555,1.35331),(35,4556,1.07331),(35,4557,1.16669),(35,4558,0.98),(35,4559,1.09669),(36,15,2.24028),(36,16,2.53327),(36,4308,0.84),(36,4309,0.95669),(36,4310,1.00331),(36,4311,1.12),(36,4312,0.91),(36,4313,0.98),(36,4314,0.93331),(36,4315,1.05),(36,4316,1.00331),(36,4317,0.23331),(36,4318,0.91),(36,4319,1.14331),(37,15,2.24028),(37,16,2.53327),(37,4308,0.84),(37,4309,0.95669),(37,4310,1.00331),(37,4311,1.12),(37,4312,0.91),(37,4313,0.98),(37,4314,0.93331),(37,4315,1.05),(37,4316,1.00331),(37,4317,0.23331),(37,4318,0.91),(37,4319,1.14331),(38,15,2.24028),(38,16,2.53327),(38,4308,0.84),(38,4309,0.95669),(38,4310,1.00331),(38,4311,1.12),(38,4312,0.91),(38,4313,0.98),(38,4314,0.93331),(38,4315,1.05),(38,4316,1.00331),(38,4317,0.23331),(38,4318,0.91),(38,4319,1.14331),(39,2366,0.46662),(39,2373,0.28),(39,2374,0.93331),(39,2375,1.19),(39,2385,0.42),(39,2408,0.28),(39,2440,0.84),(39,2456,0.28),(39,2457,1.05),(39,2458,1.28331),(39,2459,0.23331),(39,2470,0.14),(39,3772,1.76),(39,4542,0.37331),(39,4847,0.98),(39,4848,1.09669),(39,4849,0.98),(39,4850,1.16669),(39,4851,0.95669),(39,4852,1.05),(39,4853,1.05),(39,4854,1.21331),(39,4855,1.12),(39,4856,1.26),(39,4857,0.69993),(39,4858,0.98),(39,4859,1.21331),(39,4860,0.91),(39,4861,1.07331),(39,4862,0.95669),(39,4863,1.23669),(39,4864,0.18662),(39,4865,1.77338),(39,4866,2.14662),(39,4867,1.02669),(39,4868,1.28331),(39,4869,5.67321),(39,4870,1.02669),(39,4871,1.14331),(39,4872,2.00662),(39,4873,2.19338),(39,4874,0.91),(39,4875,1.05),(39,4876,0.98),(39,4877,1.07331),(40,2366,0.93324),(40,2373,0.28),(40,2374,0.93331),(40,2375,1.19),(40,2385,0.84),(40,2399,0.69993),(40,2408,0.84),(40,2415,0.56),(40,2437,0.37331),(40,2440,0.28),(40,2456,0.28),(40,2457,1.05),(40,2458,1.28331),(40,2459,0.46662),(40,2470,0.14),(40,4542,0.37331),(40,4849,0.98),(40,4857,0.69993),(40,5234,1.09669),(40,5235,1.33),(40,5236,0.86331),(40,5237,0.98),(40,5238,0.91),(40,5239,1.16669),(40,5240,0.88669),(40,5241,0.93331),(40,5242,1.07331),(40,5243,1.07331),(40,5244,1.21331),(40,5245,1.00331),(40,5246,1.09669),(40,5247,1.00331),(40,5248,1.23669),(40,5249,0.88669),(40,5250,0.98),(40,5251,0.98),(40,5252,1.07331),(40,5253,0.95669),(40,5254,1.02669),(40,5255,0.95669),(40,5256,1.07331),(40,5257,1.00331),(40,5258,1.07331),(40,5259,1.02669),(40,5260,1.14331),(40,5261,0.93331),(40,5262,1.05),(40,5263,0.95669),(40,5264,1.02669),(40,5265,0.93331),(40,5266,1.00331),(40,5267,1.00331),(40,5268,1.07331),(40,5269,1.02669),(40,5270,1.23669),(40,5271,0.93331),(40,5272,1.16669),(40,5273,0.91),(40,5274,1.05),(40,5275,0.91),(40,5276,1.02669),(40,5277,1.07331),(40,5278,1.23669),(41,2366,0.93324),(41,2373,0.28),(41,2374,0.93331),(41,2375,1.19),(41,2385,0.84),(41,2399,0.69993),(41,2408,0.84),(41,2415,0.56),(41,2437,0.37331),(41,2440,0.28),(41,2456,0.28),(41,2457,1.05),(41,2458,1.28331),(41,2459,0.46662),(41,2470,0.14),(41,4542,0.37331),(41,4849,0.98),(41,4857,0.69993),(41,5234,1.09669),(41,5235,1.33),(41,5236,0.86331),(41,5237,0.98),(41,5238,0.91),(41,5239,1.16669),(41,5240,0.88669),(41,5241,0.93331),(41,5242,1.07331),(41,5243,1.07331),(41,5244,1.21331),(41,5245,1.00331),(41,5246,1.09669),(41,5247,1.00331),(41,5248,1.23669),(41,5249,0.88669),(41,5250,0.98),(41,5251,0.98),(41,5252,1.07331),(41,5253,0.95669),(41,5254,1.02669),(41,5255,0.95669),(41,5256,1.07331),(41,5257,1.00331),(41,5258,1.07331),(41,5259,1.02669),(41,5260,1.14331),(41,5261,0.93331),(41,5262,1.05),(41,5263,0.95669),(41,5264,1.02669),(41,5265,0.93331),(41,5266,1.00331),(41,5267,1.00331),(41,5268,1.07331),(41,5269,1.02669),(41,5270,1.23669),(41,5271,0.93331),(41,5272,1.16669),(41,5273,0.91),(41,5274,1.05),(41,5275,0.91),(41,5276,1.02669),(41,5277,1.07331),(41,5278,1.23669),(42,2366,0.93324),(42,2373,0.28),(42,2374,0.93331),(42,2375,1.19),(42,2385,0.84),(42,2399,0.69993),(42,2408,0.84),(42,2415,0.56),(42,2437,0.37331),(42,2440,0.28),(42,2456,0.28),(42,2457,1.05),(42,2458,1.28331),(42,2459,0.46662),(42,2470,0.14),(42,4542,0.37331),(42,4849,0.98),(42,4857,0.69993),(42,5234,1.09669),(42,5235,1.33),(42,5236,0.86331),(42,5237,0.98),(42,5238,0.91),(42,5239,1.16669),(42,5240,0.88669),(42,5241,0.93331),(42,5242,1.07331),(42,5243,1.07331),(42,5244,1.21331),(42,5245,1.00331),(42,5246,1.09669),(42,5247,1.00331),(42,5248,1.23669),(42,5249,0.88669),(42,5250,0.98),(42,5251,0.98),(42,5252,1.07331),(42,5253,0.95669),(42,5254,1.02669),(42,5255,0.95669),(42,5256,1.07331),(42,5257,1.00331),(42,5258,1.07331),(42,5259,1.02669),(42,5260,1.14331),(42,5261,0.93331),(42,5262,1.05),(42,5263,0.95669),(42,5264,1.02669),(42,5265,0.93331),(42,5266,1.00331),(42,5267,1.00331),(42,5268,1.07331),(42,5269,1.02669),(42,5270,1.23669),(42,5271,0.93331),(42,5272,1.16669),(42,5273,0.91),(42,5274,1.05),(42,5275,0.91),(42,5276,1.02669),(42,5277,1.07331),(42,5278,1.23669),(43,15,0.18669),(43,4058,0.18669),(43,5614,0.98),(43,5615,1.12),(43,5616,0.23331),(43,5617,0.88669),(43,5618,1.00331),(43,5619,0.93331),(43,5620,1.00331),(44,2366,0.69993),(44,2373,0.56),(44,2374,1.86662),(44,2375,2.38),(44,2399,0.23331),(44,2415,0.28),(44,2440,1.4),(44,2456,0.56),(44,2457,2.1),(44,2458,2.56662),(44,2470,0.28),(44,4542,1.11993),(44,4847,1.96),(44,4848,2.19338),(44,4857,0.93324),(44,4858,3.92),(44,4859,4.85324),(44,4872,1.00331),(44,4873,1.09669),(44,4876,0.98),(44,5889,1.09669),(44,5890,1.26),(44,5891,0.91),(44,5892,1.07331),(44,5893,1.02669),(44,5894,1.21331),(44,5895,0.91),(44,5896,1.19),(44,5897,0.95669),(44,5898,1.05),(44,5899,1.12),(44,5900,1.23669),(44,5901,2.79993),(44,5902,3.08007),(44,5903,1.05),(44,5904,1.14331),(44,5905,1.19),(44,5906,1.02669),(44,5907,1.09669),(45,2379,0.18669),(45,2382,0.28),(45,4052,0.91),(45,4058,0.56007),(45,6277,1.07331),(45,6278,0.93331),(45,6279,1.05),(45,6280,0.46669),(45,6281,1.02669),(45,6282,1.28331),(45,6283,0.46662),(45,6284,0.98),(45,6285,1.05),(45,6286,1.00331),(45,6287,1.14331),(45,6288,0.18669),(45,6289,0.93331),(45,6290,1.02669),(45,6291,1.02669),(45,6292,1.16669),(45,6293,0.95669),(45,6294,1.07331),(45,6295,1.00331),(45,6296,1.09669),(45,6297,0.18669),(45,6298,0.91),(45,6299,1.07331),(45,6300,0.65331),(45,6301,1.12),(45,6302,1.26),(46,2366,0.46662),(46,2385,1.26),(46,2399,0.23331),(46,2408,0.28),(46,2415,1.12),(46,2440,0.28),(46,4058,0.18669),(46,4542,0.74662),(46,4543,1.05),(46,4857,0.23331),(46,6880,1.21331),(46,6881,0.98),(46,6882,1.07331),(46,6883,0.93331),(46,6884,1.14331),(46,6885,1.00331),(46,6886,1.12),(46,6887,0.95669),(46,6888,1.16669),(46,6889,1.02669),(46,6890,1.09669),(46,6891,1.00331),(46,6892,1.23669),(46,6893,0.28),(46,6894,1.07331),(46,6895,1.19),(46,6896,0.95669),(46,6897,1.26),(46,6898,0.95669),(46,6899,1.12),(46,6900,0.91),(46,6901,1.02669),(46,6902,0.91),(46,6903,1.12),(46,6904,0.98),(46,6905,1.19),(46,6906,0.95669),(46,6907,1.07331),(46,6908,0.37331),(46,6909,1.02669),(46,6910,1.14331),(46,6911,0.88669),(46,6912,1.05),(46,6913,0.95669),(46,6914,1.12),(46,6915,1.07331),(46,6916,1.26),(46,6917,0.37338),(46,6918,1.05),(46,6919,1.19),(46,6920,0.95669),(46,6921,1.05),(47,2366,0.46662),(47,2385,1.26),(47,2399,0.23331),(47,2408,0.28),(47,2415,1.12),(47,2437,0.37331),(47,2440,0.28),(47,4542,0.74662),(47,4543,1.05),(47,4857,0.23331),(47,6880,1.21331),(47,6881,0.98),(47,6882,1.07331),(47,6883,0.93331),(47,6884,1.14331),(47,6885,1.00331),(47,6886,1.12),(47,6887,0.95669),(47,6888,1.16669),(47,6889,1.02669),(47,6890,1.09669),(47,6891,1.00331),(47,6892,1.23669),(47,6896,0.95669),(47,6897,1.26),(47,6898,0.95669),(47,6899,1.12),(47,6900,0.91),(47,6901,1.02669),(47,6902,0.91),(47,6903,1.12),(47,6904,0.98),(47,6905,1.19),(47,6906,0.95669),(47,6907,1.07331),(47,6911,0.88669),(47,6912,1.05),(47,6913,0.95669),(47,6914,1.12),(47,7277,1.05),(47,7278,1.14331),(48,2366,0.46662),(48,2385,1.26),(48,2399,0.23331),(48,2408,0.28),(48,2415,1.12),(48,2437,0.37331),(48,2440,0.28),(48,4542,0.74662),(48,4543,1.05),(48,4857,0.23331),(48,6880,1.21331),(48,6881,0.98),(48,6882,1.07331),(48,6883,0.93331),(48,6884,1.14331),(48,6885,1.00331),(48,6886,1.12),(48,6887,0.95669),(48,6888,1.16669),(48,6889,1.02669),(48,6890,1.09669),(48,6891,1.00331),(48,6892,1.23669),(48,6896,0.95669),(48,6897,1.26),(48,6898,0.95669),(48,6899,1.12),(48,6900,0.91),(48,6901,1.02669),(48,6902,0.91),(48,6903,1.12),(48,6904,0.98),(48,6905,1.19),(48,6906,0.95669),(48,6907,1.07331),(48,6911,0.88669),(48,6912,1.05),(48,6913,0.95669),(48,6914,1.12),(48,7277,1.05),(48,7278,1.14331),(49,2366,0.46662),(49,2385,0.84),(49,2399,0.46662),(49,2408,0.28),(49,2415,0.56),(49,2440,0.28),(49,4542,0.37331),(49,4543,1.05),(49,4857,0.23331),(49,6288,0.18669),(49,6880,1.21331),(49,6885,2.00662),(49,6886,2.24),(49,6887,1.91338),(49,6888,2.33338),(49,6896,1.91338),(49,6897,2.52),(49,6898,0.95669),(49,6899,1.12),(49,6902,0.91),(49,6903,1.12),(49,6904,0.98),(49,6905,1.19),(49,6911,0.88669),(49,6912,1.05),(49,6913,0.95669),(49,6914,1.12),(49,7374,0.95669),(49,7375,1.05),(50,2366,0.23331),(50,2385,0.42),(50,2399,0.23331),(50,2408,0.56),(50,2415,2.24),(50,2440,0.56),(50,4542,0.74662),(50,4543,2.1),(50,4857,0.46662),(50,6880,2.42662),(50,6885,1.00331),(50,6886,1.12),(50,6887,0.95669),(50,6888,1.16669),(50,6896,0.95669),(50,6897,1.26),(50,6898,1.91338),(50,6899,2.24),(50,6900,1.82),(50,6901,2.05338),(50,6902,1.82),(50,6903,2.24),(50,6904,1.96),(50,6905,2.38),(50,6906,1.91338),(50,6907,2.14662),(50,6911,1.77338),(50,6912,2.1),(50,6913,1.91338),(50,6914,2.24),(51,2366,0.46662),(51,2382,0.28),(51,2385,1.26),(51,2399,0.23331),(51,2408,0.28),(51,2415,1.12),(51,2440,0.28),(51,4542,0.74662),(51,4543,1.05),(51,4857,0.23331),(51,6880,1.21331),(51,6881,0.98),(51,6882,1.07331),(51,6883,0.93331),(51,6884,1.14331),(51,6885,1.00331),(51,6886,1.12),(51,6887,0.95669),(51,6888,1.16669),(51,6889,1.02669),(51,6890,1.09669),(51,6891,1.00331),(51,6892,1.23669),(51,6896,0.95669),(51,6897,1.26),(51,6898,0.95669),(51,6899,1.12),(51,6900,0.91),(51,6901,1.02669),(51,6902,0.91),(51,6903,1.12),(51,6904,0.98),(51,6905,1.19),(51,6906,0.95669),(51,6907,1.07331),(51,6911,0.88669),(51,6912,1.05),(51,6913,0.95669),(51,6914,1.12),(51,7643,1.02669),(51,7644,1.23669),(51,7645,0.18669),(51,7646,0.98),(51,7647,1.05),(51,7648,0.37331),(51,7649,1.00331),(51,7650,1.21331),(52,2366,0.46662),(52,2385,0.84),(52,2399,0.69993),(52,2408,0.28),(52,2415,1.12),(52,2440,0.28),(52,4542,0.37331),(52,4543,1.05),(52,4857,0.23331),(52,6880,1.21331),(52,6885,2.00662),(52,6886,2.24),(52,6887,1.91338),(52,6888,2.33338),(52,6896,2.87007),(52,6897,3.78),(52,6898,0.95669),(52,6899,1.12),(52,6900,0.91),(52,6901,1.02669),(52,6902,0.91),(52,6903,1.12),(52,6904,0.98),(52,6905,1.19),(52,6906,0.95669),(52,6907,1.07331),(52,6911,0.88669),(52,6912,1.05),(52,6913,0.95669),(52,6914,1.12),(52,7790,0.18669),(52,7791,0.93331),(52,7792,1.00331),(53,2408,0.84),(53,2415,3.64),(53,2440,0.84),(53,4542,1.11993),(53,4543,2.1),(53,4857,0.69993),(53,6880,2.42662),(53,6898,2.87007),(53,6899,3.36),(53,6900,3.64),(53,6901,4.10676),(53,6902,2.73),(53,6903,3.36),(53,6904,2.94),(53,6905,3.57),(53,6906,2.87007),(53,6907,3.21993),(53,6911,2.66007),(53,6912,3.15),(53,6913,2.87007),(53,6914,3.36),(54,69,0.48),(54,70,1.71996),(54,2366,0.46662),(54,2379,0.18669),(54,2380,0.88669),(54,2385,2.1),(54,2437,0.74662),(54,4542,1.11993),(54,6881,2.94),(54,6882,3.21993),(54,6883,1.86662),(54,6884,2.28662),(54,6889,2.05338),(54,6890,2.19338),(54,6891,3.00993),(54,6892,3.71007),(54,7277,2.1),(54,7278,2.28662),(54,7987,1.14331),(54,7988,0.32669),(54,7989,1.09669),(54,7990,1.16669),(55,69,1.96),(55,70,1.71996),(55,2366,0.69993),(55,2382,0.28),(55,2385,2.52),(55,2437,1.11993),(55,4542,1.11993),(55,6881,2.94),(55,6882,3.21993),(55,6883,2.79993),(55,6884,3.42993),(55,6889,3.08007),(55,6890,3.29007),(55,6891,3.00993),(55,6892,3.71007),(55,7277,3.15),(55,7278,3.42993),(55,7643,1.02669),(55,7645,0.18669),(55,7646,0.98),(55,7647,1.05),(55,8100,1.16669),(56,69,0.48),(56,70,1.71996),(56,2366,0.69993),(56,2385,2.52),(56,2437,1.49324),(56,4542,1.11993),(56,6881,2.94),(56,6882,3.21993),(56,6883,2.79993),(56,6884,3.42993),(56,6889,3.08007),(56,6890,3.29007),(56,6891,3.00993),(56,6892,3.71007),(56,7277,4.2),(56,7278,4.57324),(56,8111,1.48),(56,8112,5.55),(57,69,0.48),(57,70,1.71996),(57,2366,0.69993),(57,2385,1.68),(57,2399,0.46662),(57,2437,0.37331),(57,4542,0.37331),(57,6881,0.98),(57,6882,1.07331),(57,6883,0.93331),(57,6884,1.14331),(57,6885,2.00662),(57,6886,2.24),(57,6887,1.91338),(57,6888,2.33338),(57,6889,1.02669),(57,6890,1.09669),(57,6891,1.00331),(57,6892,1.23669),(57,6893,0.28),(57,6896,1.91338),(57,6897,2.52),(57,6908,1.49324),(57,6917,0.18669),(57,7277,1.05),(57,7278,1.14331),(57,8223,0.91),(57,8224,1.12),(57,8225,0.32669),(57,8226,0.98),(57,8227,1.16669),(57,8228,0.95669),(57,8229,1.07331),(57,8230,1.16669),(57,8231,1.26),(57,8232,1.02669),(57,8233,1.09669),(57,8234,0.95669),(57,8235,1.02669),(57,8236,1.09669),(57,8237,1.19),(58,2366,1.39986),(58,2385,2.52),(58,2399,0.93324),(58,2408,0.56),(58,2415,0.56),(58,2437,0.74662),(58,2459,1.86648),(58,4542,0.74662),(58,4864,0.37324),(58,8576,1.91338),(58,8577,2.24),(58,8578,1.77338),(58,8579,2.05338),(58,8580,1.96),(58,8581,2.52),(58,8582,2.1),(58,8583,2.38),(58,8584,2.00662),(58,8585,2.38),(58,8586,2.1),(58,8587,2.24),(58,8588,2.19338),(58,8589,2.28662),(58,8590,1.91338),(58,8591,2.28662),(58,8592,1.82),(58,8593,2.28662),(58,8594,2.1),(58,8595,2.24),(58,8596,2.00662),(58,8597,2.14662),(58,8598,1.68),(58,8599,1.82),(58,8600,1.86662),(58,8601,2.28662),(58,8602,1.96),(58,8603,2.19338),(58,8604,2.05338),(58,8605,2.28662),(58,8606,1.91338),(58,8607,2.1),(58,8608,2.1),(58,8609,2.52),(58,8610,1.82),(58,8611,2.14662),(64,8863,1.97321),(72,2379,0.18669),(72,4052,0.91),(72,4053,1.19),(72,4054,0.37338),(72,4055,1.82),(72,4056,1.00331),(72,4057,0.98),(72,4058,0.37338),(72,4059,0.93331),(72,4060,1.09669),(72,4061,0.91),(72,4062,1.05);


--
-- Table structure for table `#__finder_links_terms7`
--



CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms7`
--


INSERT INTO `#__finder_links_terms7` (`link_id`, `term_id`, `weight`) VALUES (1,5,3.20679),(2,5,3.20679),(3,5,3.20679),(4,5,3.20679),(5,5,3.20679),(21,120,0.45339),(22,120,0.93345),(22,2476,1.68),(22,2477,2.52),(22,2478,2.79993),(22,2479,6.01986),(22,2480,6.72),(22,2481,2.66007),(22,2482,3.15),(22,2483,0.18669),(22,2484,0.86331),(22,2485,0.98),(22,2486,6.71958),(22,2487,20.16),(22,2488,21.8396),(22,2489,0.18669),(22,2490,0.88669),(22,2491,1.07331),(22,2492,5.88042),(22,2493,19.7404),(22,2494,21.0004),(22,2495,0.56),(22,2496,2.87007),(22,2497,3.42993),(22,2498,0.86331),(22,2499,0.98),(22,2500,5.59944),(22,2501,16.38),(22,2502,19.3196),(22,2503,0.93331),(22,2504,1.02669),(22,2505,2.79993),(22,2506,3.15),(22,2507,1.86662),(22,2508,2.00662),(22,2509,0.28),(22,2510,1.91338),(22,2511,1.07331),(22,2512,1.05),(22,2513,0.98007),(22,2514,3.15),(22,2515,2.42662),(22,2516,1.49352),(22,2517,0.95669),(22,2518,1.07331),(22,2519,5.74014),(22,2520,6.85986),(22,2521,0.98),(22,2522,1.14331),(22,2523,2.80035),(22,2524,6.16014),(22,2525,6.72),(22,2526,5.59986),(22,2527,7.14),(22,2528,2.66007),(22,2529,2.87007),(22,2530,1.12),(22,2531,5.74014),(22,2532,6.43986),(22,2533,0.91),(22,2534,1.14331),(22,2535,0.95669),(22,2536,1.07331),(22,2537,3.7338),(22,2538,1.96),(22,2539,1.09669),(22,2540,1.07331),(22,2541,15.9604),(22,2542,6.86),(22,2543,11.0364),(22,2544,2.3331),(22,2545,0.93331),(22,2546,1.00331),(22,2547,8.19),(22,2548,9.65979),(22,2549,0.28),(22,2550,1.02669),(22,2551,1.14331),(22,2552,0.56),(22,2553,1.91338),(22,2554,2.1),(22,2555,2.05359),(22,2556,5.04),(22,2557,6.43986),(22,2558,2.73),(22,2559,3.08007),(22,2560,0.86331),(22,2561,1.07331),(22,2562,0.98),(22,2563,1.14331),(22,2564,1.26),(22,2565,3.00993),(22,2566,3.57),(22,2936,1.8669),(22,2937,5.32014),(22,2938,6.16014),(22,2939,3.29007),(22,2940,4.13007),(22,2941,5.22732),(22,2942,0.91),(22,2943,1.00331),(22,2944,8.19),(22,2945,9.45),(22,2946,1.00331),(22,2947,1.09669),(22,2948,0.95669),(22,2949,1.14331),(22,2950,0.93331),(22,2951,1.12),(22,2952,5.46),(22,2953,6.01986),(22,2954,2.87007),(22,2955,3.36),(22,2956,6.43986),(22,2957,7.84014),(22,2958,0.65338),(22,2959,1.07331),(22,2960,1.23669),(22,2961,1.02669),(22,2962,1.30669),(22,2963,1.16655),(22,2964,4.66655),(22,2965,5.13345),(22,2966,1.4),(22,2967,4.78345),(22,2968,5.36655),(22,3426,0.83979),(22,3427,7.98021),(22,3428,1.12),(22,3429,1.12),(22,3430,1.12),(22,3431,1.12),(22,3432,1.12),(22,3433,1.12),(22,3434,1.12),(22,3435,1.12),(22,3436,1.12),(22,3437,6.15972),(22,3438,7.14),(22,3439,8.11986),(22,3440,3.29007),(22,3441,3.63993),(22,3442,3.15),(22,3443,3.36),(22,3444,2.61317),(22,3445,1.05),(22,3446,1.19),(22,3447,6.3),(22,3448,6.72),(22,3449,1.26),(22,3450,2.94),(22,3451,3.42993),(22,3452,1.26),(22,3453,3.15),(22,3454,1.23669),(22,3455,1.19),(22,3456,1.12),(22,3457,6.72084),(22,3458,17.2204),(22,3459,21.42),(22,3460,2.73),(22,3461,3.29007),(22,3462,5.59986),(22,3463,6.01986),(22,3464,5.88),(22,3465,6.58014),(22,3466,3.08007),(22,3467,3.29007),(22,3468,21.28),(22,3469,0.88669),(22,3470,1.02669),(22,3471,0.95669),(22,3472,1.09669),(22,3473,5.13345),(22,3474,4.48),(22,3475,1.14331),(22,3476,6.04317),(22,3477,7.02317),(22,3478,99.6362),(22,3479,113.846),(22,3480,1.86662),(22,3481,13.3004),(22,3482,15.4003),(22,3483,0.56007),(22,3484,2.58993),(22,3485,2.73),(22,3486,4.9),(22,3487,2.19338),(22,3488,3.21993),(22,3489,1.16655),(22,3490,4.31655),(22,3491,4.78345),(22,3492,1.11972),(22,3493,5.88),(22,3494,6.58014),(22,3495,2.66007),(22,3496,3.15),(22,3497,2.37993),(22,3498,0.98),(22,3499,0.84),(25,120,0.18669),(25,2483,0.37338),(25,3489,0.23331),(25,4063,0.88669),(25,4064,0.95669),(25,4065,0.86331),(25,4066,0.95669),(25,4067,0.14),(25,4068,0.91),(25,4069,1.00331),(25,4207,0.86331),(25,4208,1.02669),(25,4209,0.46662),(25,4210,0.91),(25,4211,1.09669),(25,4212,0.93331),(25,4213,1.05),(25,4214,1.02669),(25,4215,1.23669),(26,120,0.18669),(26,4363,0.88669),(26,4364,0.95669),(27,2476,0.14),(27,2495,0.56),(27,2500,0.46662),(27,2516,0.37338),(27,2555,0.74676),(27,2936,0.18669),(27,2941,0.56007),(27,2958,0.32669),(27,3444,0.37331),(27,3449,0.84),(27,3457,0.37338),(27,3492,0.37324),(27,4560,1.00331),(27,4561,1.16669),(27,4562,0.91),(27,4563,1.19),(27,4564,0.91),(27,4565,1.09669),(27,4566,0.93331),(27,4567,0.98),(27,4568,0.91),(27,4569,1.14331),(27,4570,0.93331),(27,4571,1.16669),(27,4572,0.93331),(27,4573,1.02669),(27,4574,1.00331),(27,4575,1.19),(27,4576,0.18669),(27,4577,0.88669),(27,4578,1.05),(27,4579,0.98),(27,4580,1.14331),(27,4581,0.98),(27,4582,1.19),(27,4583,1.07331),(27,4584,1.19),(27,4585,0.86331),(27,4586,1.07331),(27,4619,0.98),(27,4620,1.05),(27,4621,1.02669),(27,4622,1.19),(27,4623,0.93331),(27,4624,1.07331),(27,4625,0.95669),(27,4626,1.02669),(27,4627,1.02669),(27,4628,1.19),(27,4671,1.07331),(27,4672,1.26),(27,4673,0.98),(27,4674,1.12),(27,4675,1.00331),(27,4676,1.16669),(27,4677,0.95669),(27,4678,1.02669),(27,4679,0.98),(27,4680,1.14331),(27,4681,0.93331),(27,4682,1.00331),(27,4683,0.91),(27,4684,1.07331),(27,4685,0.86331),(27,4686,0.95669),(27,4687,0.95669),(27,4688,1.02669),(28,2476,0.14),(28,2495,0.56),(28,2500,0.46662),(28,2516,0.37338),(28,2555,0.74676),(28,2936,0.18669),(28,2941,0.56007),(28,2958,0.32669),(28,3444,0.37331),(28,3449,0.84),(28,3457,0.37338),(28,3492,0.37324),(28,4560,1.00331),(28,4561,1.16669),(28,4562,0.91),(28,4563,1.19),(28,4564,0.91),(28,4565,1.09669),(28,4566,0.93331),(28,4567,0.98),(28,4568,0.91),(28,4569,1.14331),(28,4570,0.93331),(28,4571,1.16669),(28,4572,0.93331),(28,4573,1.02669),(28,4574,1.00331),(28,4575,1.19),(28,4576,0.18669),(28,4577,0.88669),(28,4578,1.05),(28,4579,0.98),(28,4580,1.14331),(28,4581,0.98),(28,4582,1.19),(28,4583,1.07331),(28,4584,1.19),(28,4585,0.86331),(28,4586,1.07331),(28,4619,0.98),(28,4620,1.05),(28,4621,1.02669),(28,4622,1.19),(28,4623,0.93331),(28,4624,1.07331),(28,4625,0.95669),(28,4626,1.02669),(28,4627,1.02669),(28,4628,1.19),(28,4671,1.07331),(28,4672,1.26),(28,4673,0.98),(28,4674,1.12),(28,4675,1.00331),(28,4676,1.16669),(28,4677,0.95669),(28,4678,1.02669),(28,4679,0.98),(28,4680,1.14331),(28,4681,0.93331),(28,4682,1.00331),(28,4683,0.91),(28,4684,1.07331),(28,4685,0.86331),(28,4686,0.95669),(28,4687,0.95669),(28,4688,1.02669),(29,2476,0.14),(29,2495,0.56),(29,2500,0.46662),(29,2516,0.37338),(29,2555,0.74676),(29,2936,0.18669),(29,2941,0.56007),(29,2958,0.32669),(29,3444,0.37331),(29,3449,0.84),(29,3457,0.37338),(29,3492,0.37324),(29,4560,1.00331),(29,4561,1.16669),(29,4562,0.91),(29,4563,1.19),(29,4564,0.91),(29,4565,1.09669),(29,4566,0.93331),(29,4567,0.98),(29,4568,0.91),(29,4569,1.14331),(29,4570,0.93331),(29,4571,1.16669),(29,4572,0.93331),(29,4573,1.02669),(29,4574,1.00331),(29,4575,1.19),(29,4576,0.18669),(29,4577,0.88669),(29,4578,1.05),(29,4579,0.98),(29,4580,1.14331),(29,4581,0.98),(29,4582,1.19),(29,4583,1.07331),(29,4584,1.19),(29,4585,0.86331),(29,4586,1.07331),(29,4619,0.98),(29,4620,1.05),(29,4621,1.02669),(29,4622,1.19),(29,4623,0.93331),(29,4624,1.07331),(29,4625,0.95669),(29,4626,1.02669),(29,4627,1.02669),(29,4628,1.19),(29,4671,1.07331),(29,4672,1.26),(29,4673,0.98),(29,4674,1.12),(29,4675,1.00331),(29,4676,1.16669),(29,4677,0.95669),(29,4678,1.02669),(29,4679,0.98),(29,4680,1.14331),(29,4681,0.93331),(29,4682,1.00331),(29,4683,0.91),(29,4684,1.07331),(29,4685,0.86331),(29,4686,0.95669),(29,4687,0.95669),(29,4688,1.02669),(30,2476,0.14),(30,2495,0.56),(30,2500,0.46662),(30,2516,0.37338),(30,2555,0.74676),(30,2936,0.18669),(30,2941,0.56007),(30,2958,0.32669),(30,3444,0.37331),(30,3449,0.84),(30,3457,0.37338),(30,3492,0.37324),(30,4560,1.00331),(30,4561,1.16669),(30,4562,0.91),(30,4563,1.19),(30,4564,0.91),(30,4565,1.09669),(30,4566,0.93331),(30,4567,0.98),(30,4568,0.91),(30,4569,1.14331),(30,4570,0.93331),(30,4571,1.16669),(30,4572,0.93331),(30,4573,1.02669),(30,4574,1.00331),(30,4575,1.19),(30,4576,0.18669),(30,4577,0.88669),(30,4578,1.05),(30,4579,0.98),(30,4580,1.14331),(30,4581,0.98),(30,4582,1.19),(30,4583,1.07331),(30,4584,1.19),(30,4585,0.86331),(30,4586,1.07331),(30,4619,0.98),(30,4620,1.05),(30,4621,1.02669),(30,4622,1.19),(30,4623,0.93331),(30,4624,1.07331),(30,4625,0.95669),(30,4626,1.02669),(30,4627,1.02669),(30,4628,1.19),(30,4671,1.07331),(30,4672,1.26),(30,4673,0.98),(30,4674,1.12),(30,4675,1.00331),(30,4676,1.16669),(30,4677,0.95669),(30,4678,1.02669),(30,4679,0.98),(30,4680,1.14331),(30,4681,0.93331),(30,4682,1.00331),(30,4683,0.91),(30,4684,1.07331),(30,4685,0.86331),(30,4686,0.95669),(30,4687,0.95669),(30,4688,1.02669),(31,2476,0.14),(31,2495,0.56),(31,2500,0.46662),(31,2516,0.37338),(31,2555,0.74676),(31,2936,0.18669),(31,2941,0.56007),(31,2958,0.32669),(31,3444,0.37331),(31,3449,0.84),(31,3457,0.37338),(31,3492,0.37324),(31,4560,1.00331),(31,4561,1.16669),(31,4562,0.91),(31,4563,1.19),(31,4564,0.91),(31,4565,1.09669),(31,4566,0.93331),(31,4567,0.98),(31,4568,0.91),(31,4569,1.14331),(31,4570,0.93331),(31,4571,1.16669),(31,4572,0.93331),(31,4573,1.02669),(31,4574,1.00331),(31,4575,1.19),(31,4576,0.18669),(31,4577,0.88669),(31,4578,1.05),(31,4579,0.98),(31,4580,1.14331),(31,4581,0.98),(31,4582,1.19),(31,4583,1.07331),(31,4584,1.19),(31,4585,0.86331),(31,4586,1.07331),(31,4619,0.98),(31,4620,1.05),(31,4621,1.02669),(31,4622,1.19),(31,4623,0.93331),(31,4624,1.07331),(31,4625,0.95669),(31,4626,1.02669),(31,4627,1.02669),(31,4628,1.19),(31,4671,1.07331),(31,4672,1.26),(31,4673,0.98),(31,4674,1.12),(31,4675,1.00331),(31,4676,1.16669),(31,4677,0.95669),(31,4678,1.02669),(31,4679,0.98),(31,4680,1.14331),(31,4681,0.93331),(31,4682,1.00331),(31,4683,0.91),(31,4684,1.07331),(31,4685,0.86331),(31,4686,0.95669),(31,4687,0.95669),(31,4688,1.02669),(32,2476,0.14),(32,2495,0.56),(32,2500,0.46662),(32,2516,0.37338),(32,2555,0.74676),(32,2936,0.18669),(32,2941,0.56007),(32,2958,0.32669),(32,3444,0.37331),(32,3449,0.84),(32,3457,0.37338),(32,3492,0.37324),(32,4560,1.00331),(32,4561,1.16669),(32,4562,0.91),(32,4563,1.19),(32,4564,0.91),(32,4565,1.09669),(32,4566,0.93331),(32,4567,0.98),(32,4568,0.91),(32,4569,1.14331),(32,4570,0.93331),(32,4571,1.16669),(32,4572,0.93331),(32,4573,1.02669),(32,4574,1.00331),(32,4575,1.19),(32,4576,0.18669),(32,4577,0.88669),(32,4578,1.05),(32,4579,0.98),(32,4580,1.14331),(32,4581,0.98),(32,4582,1.19),(32,4583,1.07331),(32,4584,1.19),(32,4585,0.86331),(32,4586,1.07331),(32,4619,0.98),(32,4620,1.05),(32,4621,1.02669),(32,4622,1.19),(32,4623,0.93331),(32,4624,1.07331),(32,4625,0.95669),(32,4626,1.02669),(32,4627,1.02669),(32,4628,1.19),(32,4671,1.07331),(32,4672,1.26),(32,4673,0.98),(32,4674,1.12),(32,4675,1.00331),(32,4676,1.16669),(32,4677,0.95669),(32,4678,1.02669),(32,4679,0.98),(32,4680,1.14331),(32,4681,0.93331),(32,4682,1.00331),(32,4683,0.91),(32,4684,1.07331),(32,4685,0.86331),(32,4686,0.95669),(32,4687,0.95669),(32,4688,1.02669),(33,2476,0.14),(33,2495,0.56),(33,2500,0.46662),(33,2516,0.37338),(33,2555,0.74676),(33,2936,0.18669),(33,2941,0.56007),(33,2958,0.32669),(33,3444,0.37331),(33,3449,0.84),(33,3457,0.37338),(33,3492,0.37324),(33,4560,1.00331),(33,4561,1.16669),(33,4562,0.91),(33,4563,1.19),(33,4564,0.91),(33,4565,1.09669),(33,4566,0.93331),(33,4567,0.98),(33,4568,0.91),(33,4569,1.14331),(33,4570,0.93331),(33,4571,1.16669),(33,4572,0.93331),(33,4573,1.02669),(33,4574,1.00331),(33,4575,1.19),(33,4576,0.18669),(33,4577,0.88669),(33,4578,1.05),(33,4579,0.98),(33,4580,1.14331),(33,4581,0.98),(33,4582,1.19),(33,4583,1.07331),(33,4584,1.19),(33,4585,0.86331),(33,4586,1.07331),(33,4619,0.98),(33,4620,1.05),(33,4621,1.02669),(33,4622,1.19),(33,4623,0.93331),(33,4624,1.07331),(33,4625,0.95669),(33,4626,1.02669),(33,4627,1.02669),(33,4628,1.19),(33,4671,1.07331),(33,4672,1.26),(33,4673,0.98),(33,4674,1.12),(33,4675,1.00331),(33,4676,1.16669),(33,4677,0.95669),(33,4678,1.02669),(33,4679,0.98),(33,4680,1.14331),(33,4681,0.93331),(33,4682,1.00331),(33,4683,0.91),(33,4684,1.07331),(33,4685,0.86331),(33,4686,0.95669),(33,4687,0.95669),(33,4688,1.02669),(34,2476,0.14),(34,2495,0.56),(34,2500,0.46662),(34,2516,0.37338),(34,2555,0.74676),(34,2936,0.18669),(34,2941,0.56007),(34,2958,0.32669),(34,3444,0.37331),(34,3449,0.84),(34,3457,0.37338),(34,3492,0.37324),(34,4560,1.00331),(34,4561,1.16669),(34,4562,0.91),(34,4563,1.19),(34,4564,0.91),(34,4565,1.09669),(34,4566,0.93331),(34,4567,0.98),(34,4568,0.91),(34,4569,1.14331),(34,4570,0.93331),(34,4571,1.16669),(34,4572,0.93331),(34,4573,1.02669),(34,4574,1.00331),(34,4575,1.19),(34,4576,0.18669),(34,4577,0.88669),(34,4578,1.05),(34,4579,0.98),(34,4580,1.14331),(34,4581,0.98),(34,4582,1.19),(34,4583,1.07331),(34,4584,1.19),(34,4585,0.86331),(34,4586,1.07331),(34,4619,0.98),(34,4620,1.05),(34,4621,1.02669),(34,4622,1.19),(34,4623,0.93331),(34,4624,1.07331),(34,4625,0.95669),(34,4626,1.02669),(34,4627,1.02669),(34,4628,1.19),(34,4671,1.07331),(34,4672,1.26),(34,4673,0.98),(34,4674,1.12),(34,4675,1.00331),(34,4676,1.16669),(34,4677,0.95669),(34,4678,1.02669),(34,4679,0.98),(34,4680,1.14331),(34,4681,0.93331),(34,4682,1.00331),(34,4683,0.91),(34,4684,1.07331),(34,4685,0.86331),(34,4686,0.95669),(34,4687,0.95669),(34,4688,1.02669),(35,2476,0.14),(35,2495,0.56),(35,2500,0.46662),(35,2516,0.37338),(35,2555,0.74676),(35,2936,0.18669),(35,2941,0.56007),(35,2958,0.32669),(35,3444,0.37331),(35,3449,0.84),(35,3457,0.37338),(35,3492,0.37324),(35,4560,1.00331),(35,4561,1.16669),(35,4562,0.91),(35,4563,1.19),(35,4564,0.91),(35,4565,1.09669),(35,4566,0.93331),(35,4567,0.98),(35,4568,0.91),(35,4569,1.14331),(35,4570,0.93331),(35,4571,1.16669),(35,4572,0.93331),(35,4573,1.02669),(35,4574,1.00331),(35,4575,1.19),(35,4576,0.18669),(35,4577,0.88669),(35,4578,1.05),(35,4579,0.98),(35,4580,1.14331),(35,4581,0.98),(35,4582,1.19),(35,4583,1.07331),(35,4584,1.19),(35,4585,0.86331),(35,4586,1.07331),(35,4619,0.98),(35,4620,1.05),(35,4621,1.02669),(35,4622,1.19),(35,4623,0.93331),(35,4624,1.07331),(35,4625,0.95669),(35,4626,1.02669),(35,4627,1.02669),(35,4628,1.19),(35,4671,1.07331),(35,4672,1.26),(35,4673,0.98),(35,4674,1.12),(35,4675,1.00331),(35,4676,1.16669),(35,4677,0.95669),(35,4678,1.02669),(35,4679,0.98),(35,4680,1.14331),(35,4681,0.93331),(35,4682,1.00331),(35,4683,0.91),(35,4684,1.07331),(35,4685,0.86331),(35,4686,0.95669),(35,4687,0.95669),(35,4688,1.02669),(36,120,0.18669),(36,4363,0.88669),(36,4364,0.95669),(37,120,0.18669),(37,4363,0.88669),(37,4364,0.95669),(38,120,0.18669),(38,4363,0.88669),(38,4364,0.95669),(39,2483,0.18669),(39,2486,0.37331),(39,2487,1.12),(39,2488,1.21331),(39,2492,0.32669),(39,2493,1.09669),(39,2494,1.16669),(39,2530,0.56),(39,2544,0.46662),(39,2549,0.56),(39,2936,0.37338),(39,2941,0.37338),(39,3437,0.51331),(39,3457,0.37338),(39,3483,0.18669),(39,3489,0.23331),(39,4065,0.86331),(39,4878,1.02669),(39,4879,0.91),(39,4880,1.05),(39,4881,0.91),(39,4882,1.07331),(39,4883,1.68),(39,4884,1.96),(39,4885,0.91),(39,4886,1.05),(39,4887,0.91),(39,4888,1.19),(39,4889,1.91338),(39,4890,2.19338),(39,4927,1.09669),(39,4928,1.26),(39,4929,1.02669),(39,4930,1.28331),(39,4931,1.86662),(39,4932,2.1),(39,4979,1.09669),(39,4980,1.19),(39,4981,1.91338),(39,4982,2.24),(39,4983,0.86331),(39,4984,0.98),(39,4985,0.95669),(39,4986,1.02669),(40,5,1.04004),(40,2476,0.28),(40,2481,0.88669),(40,2486,0.37331),(40,2487,1.12),(40,2488,1.21331),(40,2492,0.32669),(40,2493,1.09669),(40,2494,1.16669),(40,2495,0.84),(40,2500,0.23331),(40,2516,0.18669),(40,2523,0.37338),(40,2530,0.28),(40,2535,0.95669),(40,2544,0.46662),(40,2555,0.37338),(40,2936,0.37338),(40,2939,1.09669),(40,2941,0.56007),(40,2944,0.91),(40,2958,0.32669),(40,3444,0.37331),(40,3449,0.42),(40,3457,0.56007),(40,3460,0.91),(40,3492,0.37324),(40,4576,0.37338),(40,5279,1.00331),(40,5280,0.91),(40,5281,1.14331),(40,5282,0.88669),(40,5283,1.02669),(40,5284,0.88669),(40,5285,1.12),(40,5286,0.91),(40,5287,1.09669),(40,5288,0.88669),(40,5289,1.07331),(40,5290,0.95669),(40,5291,1.02669),(40,5292,0.91),(40,5293,1.02669),(40,5294,1.00331),(40,5295,1.09669),(40,5296,0.98),(40,5297,1.19),(40,5298,1.02669),(40,5299,1.12),(40,5300,1.02669),(40,5301,1.14331),(40,5302,0.95669),(40,5303,1.14331),(40,5304,0.88669),(40,5305,1.00331),(40,5306,0.88669),(40,5307,0.98),(40,5308,1.12),(40,5309,0.88669),(40,5310,1.07331),(40,5311,0.95669),(40,5312,1.16669),(40,5313,0.88669),(40,5314,1.07331),(40,5355,1.19),(40,5356,0.91),(40,5357,0.98),(40,5358,0.98),(40,5359,0.98),(40,5360,1.05),(40,5361,0.95669),(40,5362,1.09669),(40,5363,1.02669),(40,5364,1.26),(40,5437,1.09669),(40,5438,1.23669),(40,5439,0.98),(40,5440,1.28331),(40,5441,0.86331),(40,5442,1.16669),(40,5443,0.98),(40,5444,1.02669),(40,5445,1.12),(40,5446,0.81669),(40,5447,0.98),(40,5448,0.88669),(40,5449,1.02669),(40,5450,1.05),(40,5451,1.09669),(40,5452,0.93331),(40,5453,1.05),(41,5,1.04004),(41,2476,0.28),(41,2481,0.88669),(41,2486,0.37331),(41,2487,1.12),(41,2488,1.21331),(41,2492,0.32669),(41,2493,1.09669),(41,2494,1.16669),(41,2495,0.84),(41,2500,0.23331),(41,2516,0.18669),(41,2523,0.37338),(41,2530,0.28),(41,2535,0.95669),(41,2544,0.46662),(41,2555,0.37338),(41,2936,0.37338),(41,2939,1.09669),(41,2941,0.56007),(41,2944,0.91),(41,2958,0.32669),(41,3444,0.37331),(41,3449,0.42),(41,3457,0.56007),(41,3460,0.91),(41,3492,0.37324),(41,4576,0.37338),(41,5279,1.00331),(41,5280,0.91),(41,5281,1.14331),(41,5282,0.88669),(41,5283,1.02669),(41,5284,0.88669),(41,5285,1.12),(41,5286,0.91),(41,5287,1.09669),(41,5288,0.88669),(41,5289,1.07331),(41,5290,0.95669),(41,5291,1.02669),(41,5292,0.91),(41,5293,1.02669),(41,5294,1.00331),(41,5295,1.09669),(41,5296,0.98),(41,5297,1.19),(41,5298,1.02669),(41,5299,1.12),(41,5300,1.02669),(41,5301,1.14331),(41,5302,0.95669),(41,5303,1.14331),(41,5304,0.88669),(41,5305,1.00331),(41,5306,0.88669),(41,5307,0.98),(41,5308,1.12),(41,5309,0.88669),(41,5310,1.07331),(41,5311,0.95669),(41,5312,1.16669),(41,5313,0.88669),(41,5314,1.07331),(41,5355,1.19),(41,5356,0.91),(41,5357,0.98),(41,5358,0.98),(41,5359,0.98),(41,5360,1.05),(41,5361,0.95669),(41,5362,1.09669),(41,5363,1.02669),(41,5364,1.26),(41,5437,1.09669),(41,5438,1.23669),(41,5439,0.98),(41,5440,1.28331),(41,5441,0.86331),(41,5442,1.16669),(41,5443,0.98),(41,5444,1.02669),(41,5445,1.12),(41,5446,0.81669),(41,5447,0.98),(41,5448,0.88669),(41,5449,1.02669),(41,5450,1.05),(41,5451,1.09669),(41,5452,0.93331),(41,5453,1.05),(42,5,1.04004),(42,2476,0.28),(42,2481,0.88669),(42,2486,0.37331),(42,2487,1.12),(42,2488,1.21331),(42,2492,0.32669),(42,2493,1.09669),(42,2494,1.16669),(42,2495,0.84),(42,2500,0.23331),(42,2516,0.18669),(42,2523,0.37338),(42,2530,0.28),(42,2535,0.95669),(42,2544,0.46662),(42,2555,0.37338),(42,2936,0.37338),(42,2939,1.09669),(42,2941,0.56007),(42,2944,0.91),(42,2958,0.32669),(42,3444,0.37331),(42,3449,0.42),(42,3457,0.56007),(42,3460,0.91),(42,3492,0.37324),(42,4576,0.37338),(42,5279,1.00331),(42,5280,0.91),(42,5281,1.14331),(42,5282,0.88669),(42,5283,1.02669),(42,5284,0.88669),(42,5285,1.12),(42,5286,0.91),(42,5287,1.09669),(42,5288,0.88669),(42,5289,1.07331),(42,5290,0.95669),(42,5291,1.02669),(42,5292,0.91),(42,5293,1.02669),(42,5294,1.00331),(42,5295,1.09669),(42,5296,0.98),(42,5297,1.19),(42,5298,1.02669),(42,5299,1.12),(42,5300,1.02669),(42,5301,1.14331),(42,5302,0.95669),(42,5303,1.14331),(42,5304,0.88669),(42,5305,1.00331),(42,5306,0.88669),(42,5307,0.98),(42,5308,1.12),(42,5309,0.88669),(42,5310,1.07331),(42,5311,0.95669),(42,5312,1.16669),(42,5313,0.88669),(42,5314,1.07331),(42,5355,1.19),(42,5356,0.91),(42,5357,0.98),(42,5358,0.98),(42,5359,0.98),(42,5360,1.05),(42,5361,0.95669),(42,5362,1.09669),(42,5363,1.02669),(42,5364,1.26),(42,5437,1.09669),(42,5438,1.23669),(42,5439,0.98),(42,5440,1.28331),(42,5441,0.86331),(42,5442,1.16669),(42,5443,0.98),(42,5444,1.02669),(42,5445,1.12),(42,5446,0.81669),(42,5447,0.98),(42,5448,0.88669),(42,5449,1.02669),(42,5450,1.05),(42,5451,1.09669),(42,5452,0.93331),(42,5453,1.05),(43,2552,0.28),(43,4067,0.14),(43,4209,0.69993),(43,4210,0.91),(43,4212,0.93331),(43,5621,0.95669),(43,5622,1.05),(43,5623,0.91),(43,5624,1.05),(43,5740,0.42),(43,5741,1.12),(43,5742,1.33),(43,5743,0.23331),(43,5744,0.91),(43,5745,0.98),(43,5746,1.05),(43,5747,1.02669),(43,5748,0.93331),(43,5749,1.05),(44,2486,0.74662),(44,2487,2.24),(44,2488,2.42662),(44,2492,0.65338),(44,2493,2.19338),(44,2494,2.33338),(44,2495,0.42),(44,2516,0.18669),(44,2523,0.56007),(44,2530,1.26),(44,2544,1.16655),(44,2549,0.28),(44,2936,0.56007),(44,2941,0.18669),(44,3437,2.05324),(44,3457,0.18669),(44,3492,0.09331),(44,4576,0.18669),(44,4879,1.82),(44,4881,3.64),(44,4882,4.29324),(44,4885,3.64),(44,4886,4.2),(44,4889,0.95669),(44,4890,1.09669),(44,4927,1.09669),(44,4928,1.26),(44,4929,1.02669),(44,4930,1.28331),(44,4931,0.93331),(44,4932,1.05),(44,4979,4.38676),(44,4980,4.76),(44,4981,0.95669),(44,4982,1.12),(44,5282,2.66007),(44,5908,1.02669),(44,5909,1.14331),(44,5910,1.07331),(44,5911,0.86331),(44,5912,1.09669),(44,5913,2.73),(44,5914,3.42993),(44,5915,1.07331),(44,5916,1.14331),(44,5917,2.87007),(44,5918,3.36),(44,5919,1.00331),(44,5920,1.12),(44,5921,0.95669),(44,5922,1.07331),(44,5942,0.88669),(44,5943,1.05),(44,5963,0.98),(44,5964,1.12),(45,120,0.37338),(45,2509,0.28),(45,3483,0.18669),(45,4209,0.23331),(45,6303,1.00331),(45,6304,1.23669),(45,6305,0.93331),(45,6306,1.02669),(45,6307,0.37338),(45,6308,1.05),(45,6309,1.16669),(45,6310,0.93331),(45,6311,1.00331),(45,6312,0.14),(45,6313,0.98),(45,6314,1.09669),(45,6369,0.32669),(45,6370,1.07331),(45,6371,1.23669),(45,6472,0.86331),(45,6473,1.19),(45,6474,1.05),(45,6475,1.14331),(45,6476,1.02669),(45,6477,1.14331),(46,2476,0.14),(46,2495,0.7),(46,2500,0.93324),(46,2516,0.56007),(46,2523,0.74676),(46,2530,0.28),(46,2544,0.46662),(46,2549,0.56),(46,2555,0.37338),(46,2936,0.74676),(46,2941,0.93345),(46,2950,0.93331),(46,2958,0.32669),(46,3444,1.11993),(46,3449,0.42),(46,3457,0.74676),(46,3492,0.18662),(46,4570,0.93331),(46,4576,0.74676),(46,4687,0.95669),(46,6922,0.95669),(46,6923,1.12),(46,6924,1.86662),(46,6925,1.00331),(46,6926,1.07331),(46,6927,1.00331),(46,6928,1.16669),(46,6929,1.00331),(46,6930,1.07331),(46,6931,0.88669),(46,6932,0.98),(46,6933,0.86331),(46,6934,1.09669),(46,6935,1.00331),(46,6936,1.23669),(46,6937,1.02669),(46,6938,1.12),(46,6939,1.21331),(46,6940,0.91),(46,6941,1.12),(46,6942,0.91),(46,6943,1.00331),(46,6944,1.02669),(46,6945,1.07331),(46,6946,1.82),(46,6947,1.14331),(46,6948,1.07331),(46,6949,0.86331),(46,6950,1.07331),(46,6951,0.98),(46,6952,1.09669),(46,6953,0.88669),(46,6954,1.05),(46,6955,0.88669),(46,6956,1.14331),(46,6957,0.93331),(46,6958,1.00331),(46,6959,1.02669),(46,6960,1.16669),(46,6961,0.93331),(46,6962,1.05),(46,6963,1.02669),(46,6964,1.12),(46,6965,0.37331),(46,6966,1.12),(46,6967,1.21331),(46,6968,0.88669),(46,6969,0.98),(46,6970,0.98),(46,6971,1.14331),(46,6972,0.98),(46,6973,1.14331),(46,6974,0.98),(46,6975,1.12),(46,6976,0.91),(46,6977,0.88669),(46,6978,1.05),(46,7044,0.32669),(46,7045,0.91),(46,7046,1.12),(46,7047,1.02669),(46,7048,1.12),(46,7049,0.93331),(46,7050,1.23669),(46,7051,0.95669),(46,7052,1.07331),(46,7053,1.02669),(46,7054,1.23669),(46,7055,0.93331),(46,7056,1.05),(46,7057,0.88669),(46,7058,1.09669),(46,7059,1.00331),(46,7060,0.98),(46,7061,1.07331),(46,7062,1.07331),(46,7063,1.19),(46,7064,0.98),(46,7065,1.12),(46,7158,1.02669),(46,7159,1.26),(46,7160,1.00331),(46,7161,1.07331),(46,7162,1.02669),(46,7163,1.12),(46,7164,1.07331),(46,7165,1.16669),(46,7166,0.93331),(46,7167,1.14331),(46,7168,0.93331),(46,7169,1.16669),(46,7170,0.86331),(46,7171,1.07331),(46,7172,0.88669),(46,7173,1.09669),(46,7174,0.86331),(46,7175,0.98),(46,7176,1.05),(47,2476,0.14),(47,2495,0.7),(47,2500,1.16655),(47,2516,0.93345),(47,2523,0.93345),(47,2530,0.28),(47,2544,0.46662),(47,2549,0.84),(47,2555,0.37338),(47,2936,0.74676),(47,2941,0.93345),(47,2950,0.93331),(47,2958,0.32669),(47,3444,1.11993),(47,3449,0.42),(47,3457,0.74676),(47,3492,0.18662),(47,4570,0.93331),(47,4576,0.74676),(47,4687,0.95669),(47,6922,0.95669),(47,6923,1.12),(47,6924,1.86662),(47,6925,1.00331),(47,6926,1.07331),(47,6927,1.00331),(47,6928,1.16669),(47,6929,1.00331),(47,6930,1.07331),(47,6931,0.88669),(47,6932,0.98),(47,6933,0.86331),(47,6934,1.09669),(47,6935,1.00331),(47,6936,1.23669),(47,6937,1.02669),(47,6938,1.12),(47,6939,1.21331),(47,6940,0.91),(47,6941,1.12),(47,6942,0.91),(47,6943,1.00331),(47,6944,1.02669),(47,6945,1.07331),(47,6946,1.82),(47,6947,1.14331),(47,6948,1.07331),(47,6949,0.86331),(47,6950,1.07331),(47,6951,0.98),(47,6952,1.09669),(47,6953,0.88669),(47,6954,1.05),(47,6955,0.88669),(47,6956,1.14331),(47,6957,0.93331),(47,6958,1.00331),(47,6959,1.02669),(47,6960,1.16669),(47,6961,0.93331),(47,6962,1.05),(47,6963,1.02669),(47,6964,1.12),(47,6968,0.88669),(47,6969,0.98),(47,6970,0.98),(47,6971,1.14331),(47,6972,0.98),(47,6973,1.14331),(47,6974,0.98),(47,6975,1.12),(47,6976,0.91),(47,6977,0.88669),(47,6978,1.05),(47,7047,1.02669),(47,7048,1.12),(47,7049,0.93331),(47,7050,1.23669),(47,7051,0.95669),(47,7052,1.07331),(47,7053,1.02669),(47,7054,1.23669),(47,7055,0.93331),(47,7056,1.05),(47,7057,0.88669),(47,7058,1.09669),(47,7059,1.00331),(47,7060,0.98),(47,7061,1.07331),(47,7062,1.07331),(47,7063,1.19),(47,7064,0.98),(47,7065,1.12),(47,7158,1.02669),(47,7159,1.26),(47,7160,1.00331),(47,7161,1.07331),(47,7162,1.02669),(47,7163,1.12),(47,7164,1.07331),(47,7165,1.16669),(47,7166,0.93331),(47,7167,1.14331),(47,7168,0.93331),(47,7169,1.16669),(47,7170,0.86331),(47,7171,1.07331),(47,7172,0.88669),(47,7173,1.09669),(47,7174,0.86331),(47,7175,0.98),(47,7176,1.05),(47,7279,0.98679),(47,7280,5.55),(47,7281,6.53679),(47,7282,0.98),(47,7283,1.05),(47,7284,0.93331),(47,7285,1.09669),(47,7286,1.07331),(47,7287,1.14331),(47,7288,0.95669),(47,7289,1.09669),(47,7290,1.14331),(48,2476,0.14),(48,2495,0.7),(48,2500,1.16655),(48,2516,0.93345),(48,2523,0.93345),(48,2530,0.28),(48,2544,0.46662),(48,2549,0.84),(48,2555,0.37338),(48,2936,0.74676),(48,2941,0.93345),(48,2950,0.93331),(48,2958,0.32669),(48,3444,1.11993),(48,3449,0.42),(48,3457,0.74676),(48,3492,0.18662),(48,4570,0.93331),(48,4576,0.74676),(48,4687,0.95669),(48,6922,0.95669),(48,6923,1.12),(48,6924,1.86662),(48,6925,1.00331),(48,6926,1.07331),(48,6927,1.00331),(48,6928,1.16669),(48,6929,1.00331),(48,6930,1.07331),(48,6931,0.88669),(48,6932,0.98),(48,6933,0.86331),(48,6934,1.09669),(48,6935,1.00331),(48,6936,1.23669),(48,6937,1.02669),(48,6938,1.12),(48,6939,1.21331),(48,6940,0.91),(48,6941,1.12),(48,6942,0.91),(48,6943,1.00331),(48,6944,1.02669),(48,6945,1.07331),(48,6946,1.82),(48,6947,1.14331),(48,6948,1.07331),(48,6949,0.86331),(48,6950,1.07331),(48,6951,0.98),(48,6952,1.09669),(48,6953,0.88669),(48,6954,1.05),(48,6955,0.88669),(48,6956,1.14331),(48,6957,0.93331),(48,6958,1.00331),(48,6959,1.02669),(48,6960,1.16669),(48,6961,0.93331),(48,6962,1.05),(48,6963,1.02669),(48,6964,1.12),(48,6968,0.88669),(48,6969,0.98),(48,6970,0.98),(48,6971,1.14331),(48,6972,0.98),(48,6973,1.14331),(48,6974,0.98),(48,6975,1.12),(48,6976,0.91),(48,6977,0.88669),(48,6978,1.05),(48,7047,1.02669),(48,7048,1.12),(48,7049,0.93331),(48,7050,1.23669),(48,7051,0.95669),(48,7052,1.07331),(48,7053,1.02669),(48,7054,1.23669),(48,7055,0.93331),(48,7056,1.05),(48,7057,0.88669),(48,7058,1.09669),(48,7059,1.00331),(48,7060,0.98),(48,7061,1.07331),(48,7062,1.07331),(48,7063,1.19),(48,7064,0.98),(48,7065,1.12),(48,7158,1.02669),(48,7159,1.26),(48,7160,1.00331),(48,7161,1.07331),(48,7162,1.02669),(48,7163,1.12),(48,7164,1.07331),(48,7165,1.16669),(48,7166,0.93331),(48,7167,1.14331),(48,7168,0.93331),(48,7169,1.16669),(48,7170,0.86331),(48,7171,1.07331),(48,7172,0.88669),(48,7173,1.09669),(48,7174,0.86331),(48,7175,0.98),(48,7176,1.05),(48,7282,0.98),(48,7283,1.05),(48,7284,0.93331),(48,7285,1.09669),(48,7286,1.07331),(48,7287,1.14331),(48,7288,0.95669),(48,7289,1.09669),(48,7290,1.14331),(49,2476,0.14),(49,2495,0.98),(49,2500,0.46662),(49,2516,0.37338),(49,2523,0.93345),(49,2530,0.56),(49,2544,0.93324),(49,2549,0.84),(49,2555,0.18669),(49,2936,0.37338),(49,2941,1.68021),(49,2950,1.86662),(49,3444,0.74662),(49,3449,0.42),(49,3457,0.93345),(49,3492,0.18662),(49,4570,0.93331),(49,4576,1.12014),(49,4687,1.91338),(49,6922,0.95669),(49,6923,1.12),(49,6924,3.73324),(49,6925,2.00662),(49,6926,2.14662),(49,6927,1.00331),(49,6928,1.16669),(49,6931,1.77338),(49,6932,0.98),(49,6933,0.86331),(49,6934,1.09669),(49,6939,1.21331),(49,6944,2.05338),(49,6945,2.14662),(49,6946,2.73),(49,6947,1.14331),(49,6948,2.14662),(49,6949,0.86331),(49,6950,1.07331),(49,6953,1.77338),(49,6954,2.1),(49,6955,1.77338),(49,6956,2.28662),(49,6959,2.05338),(49,6960,2.33338),(49,6961,1.86662),(49,6962,2.1),(49,6963,2.05338),(49,6964,2.24),(49,6968,1.77338),(49,6969,1.96),(49,6970,1.96),(49,6971,2.28662),(49,6972,1.96),(49,6973,2.28662),(49,6974,0.98),(49,6975,1.12),(49,6977,0.88669),(49,6978,1.05),(49,7051,1.91338),(49,7052,2.14662),(49,7055,1.86662),(49,7056,2.1),(49,7057,1.77338),(49,7058,2.19338),(49,7059,2.00662),(49,7060,1.96),(49,7061,2.14662),(49,7062,1.07331),(49,7063,1.19),(49,7160,1.00331),(49,7161,1.07331),(49,7162,1.02669),(49,7163,1.12),(49,7164,1.07331),(49,7165,1.16669),(49,7166,1.86662),(49,7167,2.28662),(49,7170,0.86331),(49,7171,1.07331),(49,7172,0.88669),(49,7173,1.09669),(49,7176,2.1),(49,7376,1.02669),(49,7419,0.93331),(49,7420,1.00331),(50,2476,0.28),(50,2495,0.7),(50,2500,0.93324),(50,2516,0.18669),(50,2523,1.30683),(50,2530,0.28),(50,2544,0.46662),(50,2549,0.84),(50,2555,0.74676),(50,2936,1.30683),(50,2941,1.12014),(50,2950,0.93331),(50,2958,0.65338),(50,3444,1.49324),(50,3449,0.84),(50,3457,1.12014),(50,3492,0.09331),(50,4067,0.14),(50,4570,1.86662),(50,4576,0.56007),(50,4687,0.95669),(50,6922,1.91338),(50,6923,2.24),(50,6924,1.86662),(50,6925,1.00331),(50,6926,1.07331),(50,6927,2.00662),(50,6928,2.33338),(50,6931,0.88669),(50,6932,0.98),(50,6933,1.72662),(50,6934,2.19338),(50,6939,2.42662),(50,6944,1.02669),(50,6945,1.07331),(50,6946,2.73),(50,6947,2.28662),(50,6948,1.07331),(50,6949,1.72662),(50,6950,2.14662),(50,6951,1.96),(50,6952,2.19338),(50,6953,0.88669),(50,6954,1.05),(50,6955,0.88669),(50,6956,1.14331),(50,6959,1.02669),(50,6960,1.16669),(50,6961,0.93331),(50,6962,1.05),(50,6963,1.02669),(50,6964,1.12),(50,6968,0.88669),(50,6969,0.98),(50,6970,0.98),(50,6971,1.14331),(50,6972,0.98),(50,6973,1.14331),(50,6974,1.96),(50,6975,2.24),(50,6976,1.82),(50,6977,1.77338),(50,6978,2.1),(50,7047,2.05338),(50,7048,2.24),(50,7049,1.86662),(50,7050,2.47338),(50,7051,0.95669),(50,7052,1.07331),(50,7053,2.05338),(50,7054,2.47338),(50,7055,0.93331),(50,7056,1.05),(50,7057,0.88669),(50,7058,1.09669),(50,7059,1.00331),(50,7060,0.98),(50,7061,1.07331),(50,7062,2.14662),(50,7063,2.38),(50,7064,1.96),(50,7065,2.24),(50,7160,2.00662),(50,7161,2.14662),(50,7162,2.05338),(50,7163,2.24),(50,7164,2.14662),(50,7165,2.33338),(50,7166,0.93331),(50,7167,1.14331),(50,7168,1.86662),(50,7169,2.33338),(50,7170,1.72662),(50,7171,2.14662),(50,7172,0.88669),(50,7173,1.09669),(50,7176,1.05),(50,7290,2.28662),(50,7475,0.81669),(50,7476,1.00331),(50,7520,0.60669),(50,7521,1.05),(50,7522,1.26),(51,2476,0.14),(51,2495,0.7),(51,2500,0.93324),(51,2516,0.56007),(51,2523,0.74676),(51,2530,0.28),(51,2544,0.46662),(51,2549,0.56),(51,2555,0.37338),(51,2936,0.74676),(51,2941,0.93345),(51,2950,0.93331),(51,2958,0.32669),(51,3444,1.11993),(51,3449,0.42),(51,3457,0.74676),(51,3492,0.18662),(51,4570,0.93331),(51,4576,0.74676),(51,4687,0.95669),(51,6922,0.95669),(51,6923,1.12),(51,6924,1.86662),(51,6925,1.00331),(51,6926,1.07331),(51,6927,1.00331),(51,6928,1.16669),(51,6929,1.00331),(51,6930,1.07331),(51,6931,0.88669),(51,6932,0.98),(51,6933,0.86331),(51,6934,1.09669),(51,6935,1.00331),(51,6936,1.23669),(51,6937,1.02669),(51,6938,1.12),(51,6939,1.21331),(51,6940,0.91),(51,6941,1.12),(51,6942,0.91),(51,6943,1.00331),(51,6944,1.02669),(51,6945,1.07331),(51,6946,1.82),(51,6947,1.14331),(51,6948,1.07331),(51,6949,0.86331),(51,6950,1.07331),(51,6951,0.98),(51,6952,1.09669),(51,6953,0.88669),(51,6954,1.05),(51,6955,0.88669),(51,6956,1.14331),(51,6957,0.93331),(51,6958,1.00331),(51,6959,1.02669),(51,6960,1.16669),(51,6961,0.93331),(51,6962,1.05),(51,6963,1.02669),(51,6964,1.12),(51,6968,0.88669),(51,6969,0.98),(51,6970,0.98),(51,6971,1.14331),(51,6972,0.98),(51,6973,1.14331),(51,6974,0.98),(51,6975,1.12),(51,6976,0.91),(51,7047,1.02669),(51,7048,1.12),(51,7049,0.93331),(51,7050,1.23669),(51,7051,0.95669),(51,7052,1.07331),(51,7053,1.02669),(51,7054,1.23669),(51,7055,0.93331),(51,7056,1.05),(51,7057,0.88669),(51,7058,1.09669),(51,7059,1.00331),(51,7060,0.98),(51,7061,1.07331),(51,7062,1.07331),(51,7063,1.19),(51,7064,0.98),(51,7065,1.12),(51,7158,1.02669),(51,7159,1.26),(51,7160,1.00331),(51,7161,1.07331),(51,7162,1.02669),(51,7163,1.12),(51,7164,1.07331),(51,7165,1.16669),(51,7166,0.93331),(51,7167,1.14331),(51,7168,0.93331),(51,7169,1.16669),(51,7170,0.86331),(51,7171,1.07331),(51,7172,0.88669),(51,7173,1.09669),(51,7174,0.86331),(51,7175,0.98),(51,7176,1.05),(51,7279,0.37338),(51,7290,1.14331),(51,7651,0.46669),(51,7652,1.07331),(51,7653,1.19),(51,7654,0.88669),(51,7655,1.12),(51,7656,0.86331),(51,7657,0.98),(51,7682,0.32669),(51,7683,0.95669),(51,7684,1.05),(51,7735,0.60669),(51,7736,1.09669),(51,7737,1.21331),(51,7738,0.09331),(51,7739,0.81669),(51,7740,0.91),(52,2476,0.14),(52,2495,1.12),(52,2500,0.46662),(52,2516,0.37338),(52,2523,0.93345),(52,2530,0.56),(52,2544,1.16655),(52,2549,0.84),(52,2555,0.37338),(52,2936,0.93345),(52,2941,1.8669),(52,2950,1.86662),(52,2958,0.32669),(52,3444,0.74662),(52,3449,0.42),(52,3457,1.12014),(52,3492,0.18662),(52,4570,0.93331),(52,4576,1.12014),(52,4687,1.91338),(52,6922,0.95669),(52,6923,1.12),(52,6924,4.66655),(52,6925,3.00993),(52,6926,2.14662),(52,6927,1.00331),(52,6928,1.16669),(52,6931,1.77338),(52,6932,0.98),(52,6933,0.86331),(52,6934,1.09669),(52,6939,1.21331),(52,6944,2.05338),(52,6945,2.14662),(52,6946,2.73),(52,6947,1.14331),(52,6948,2.14662),(52,6949,0.86331),(52,6950,1.07331),(52,6953,1.77338),(52,6954,2.1),(52,6955,1.77338),(52,6956,2.28662),(52,6959,2.05338),(52,6960,2.33338),(52,6961,1.86662),(52,6962,2.1),(52,6963,2.05338),(52,6964,2.24),(52,6968,2.66007),(52,6969,2.94),(52,6970,1.96),(52,6971,2.28662),(52,6972,1.96),(52,6973,2.28662),(52,6974,0.98),(52,6975,1.12),(52,6976,0.91),(52,6977,0.88669),(52,6978,1.05),(52,7047,1.02669),(52,7048,1.12),(52,7049,0.93331),(52,7050,1.23669),(52,7051,1.91338),(52,7052,2.14662),(52,7053,1.02669),(52,7054,1.23669),(52,7055,1.86662),(52,7056,2.1),(52,7057,2.66007),(52,7058,3.29007),(52,7059,2.00662),(52,7060,1.96),(52,7061,2.14662),(52,7062,1.07331),(52,7063,1.19),(52,7064,0.98),(52,7065,1.12),(52,7160,1.00331),(52,7161,1.07331),(52,7162,1.02669),(52,7163,1.12),(52,7164,1.07331),(52,7165,1.16669),(52,7166,1.86662),(52,7167,2.28662),(52,7168,0.93331),(52,7169,1.16669),(52,7170,0.86331),(52,7171,1.07331),(52,7172,0.88669),(52,7173,1.09669),(52,7176,2.1),(52,7290,1.14331),(52,7376,1.02669),(52,7419,0.93331),(52,7420,1.00331),(52,7793,0.09331),(52,7794,0.91),(52,7795,1.09669),(53,2476,0.42),(53,2495,0.42),(53,2500,1.39986),(53,2523,1.68021),(53,2549,0.84),(53,2555,1.12014),(53,2936,1.8669),(53,2941,0.56007),(53,2958,1.30676),(53,3444,2.23986),(53,3449,1.26),(53,3457,1.12014),(53,4570,2.79993),(53,6922,2.87007),(53,6923,3.36),(53,6927,3.00993),(53,6928,3.50007),(53,6933,2.58993),(53,6934,3.29007),(53,6939,3.63993),(53,6946,2.73),(53,6947,3.42993),(53,6949,2.58993),(53,6950,3.21993),(53,6951,2.94),(53,6952,3.29007),(53,6974,2.94),(53,6975,3.36),(53,6976,2.73),(53,6977,2.66007),(53,6978,3.15),(53,7047,3.08007),(53,7048,3.36),(53,7049,2.79993),(53,7050,3.71007),(53,7053,3.08007),(53,7054,3.71007),(53,7062,3.21993),(53,7063,3.57),(53,7064,3.92),(53,7065,4.48),(53,7160,3.00993),(53,7161,3.21993),(53,7162,3.08007),(53,7163,3.36),(53,7164,3.21993),(53,7165,3.50007),(53,7168,2.79993),(53,7169,3.50007),(53,7170,2.58993),(53,7171,3.21993),(53,7290,3.42993),(54,2495,0.42),(54,2500,1.86648),(54,2516,1.8669),(54,2523,0.37338),(54,2549,0.84),(54,3444,0.74662),(54,3492,0.18662),(54,4576,0.37338),(54,6929,3.00993),(54,6930,3.21993),(54,6935,2.00662),(54,6936,2.47338),(54,6937,3.08007),(54,6938,3.36),(54,6940,1.82),(54,6941,2.24),(54,6942,1.82),(54,6943,2.00662),(54,7158,2.05338),(54,7159,2.52),(54,7174,1.72662),(54,7175,1.96),(54,7282,2.94),(54,7283,3.15),(54,7284,2.79993),(54,7285,3.29007),(54,7286,2.14662),(54,7287,2.28662),(54,7288,2.87007),(54,7289,3.29007),(54,7991,3.08007),(54,7992,3.42993),(54,7993,0.93331),(54,7994,1.07331),(55,2495,0.42),(55,2500,2.09979),(55,2516,2.24028),(55,2523,0.56007),(55,2549,0.84),(55,3444,1.11993),(55,3492,0.27993),(55,4576,0.56007),(55,6929,3.00993),(55,6930,3.21993),(55,6935,3.00993),(55,6936,3.71007),(55,6937,3.08007),(55,6938,3.36),(55,6940,2.73),(55,6941,3.36),(55,6942,2.73),(55,6943,3.00993),(55,7158,3.08007),(55,7159,3.78),(55,7174,2.58993),(55,7175,2.94),(55,7279,0.18669),(55,7282,2.94),(55,7283,3.15),(55,7284,2.79993),(55,7285,3.29007),(55,7286,3.21993),(55,7287,3.42993),(55,7288,2.87007),(55,7289,3.29007),(55,7656,0.86331),(55,7657,0.98),(55,7682,0.32669),(55,7683,0.95669),(55,7684,1.05),(55,7735,0.60669),(55,7736,1.09669),(55,7737,1.21331),(55,7991,3.08007),(55,7992,3.42993),(55,7993,1.86662),(55,7994,2.14662),(56,2495,0.42),(56,2500,2.3331),(56,2516,2.61366),(56,2523,0.74676),(56,2549,1.12),(56,3444,1.11993),(56,3492,0.27993),(56,4576,0.56007),(56,6929,3.00993),(56,6930,3.21993),(56,6935,3.00993),(56,6936,3.71007),(56,6937,3.08007),(56,6938,3.36),(56,6940,2.73),(56,6941,3.36),(56,6942,2.73),(56,6943,3.00993),(56,7158,3.08007),(56,7159,3.78),(56,7174,2.58993),(56,7175,2.94),(56,7282,3.92),(56,7283,4.2),(56,7284,3.73324),(56,7285,4.38676),(56,7286,4.29324),(56,7287,4.57324),(56,7288,3.82676),(56,7289,4.38676),(56,7991,3.08007),(56,7992,3.42993),(56,7993,1.86662),(56,7994,2.14662),(57,2495,0.7),(57,2500,0.69993),(57,2516,0.74676),(57,2523,0.56007),(57,2530,0.28),(57,2544,0.46662),(57,2549,0.28),(57,2936,0.37338),(57,2941,0.37338),(57,3444,0.37331),(57,3492,0.09331),(57,4067,0.14),(57,4576,0.93345),(57,6924,3.73324),(57,6925,2.00662),(57,6926,2.14662),(57,6929,1.00331),(57,6930,1.07331),(57,6935,1.00331),(57,6936,1.23669),(57,6937,1.02669),(57,6938,1.12),(57,6940,0.91),(57,6941,1.12),(57,6942,0.91),(57,6943,1.00331),(57,6946,1.82),(57,6948,2.14662),(57,6953,1.77338),(57,6954,2.1),(57,6957,0.93331),(57,6958,1.00331),(57,6959,2.05338),(57,6960,2.33338),(57,6961,1.86662),(57,6968,1.77338),(57,6969,1.96),(57,7051,1.91338),(57,7052,2.14662),(57,7057,1.77338),(57,7058,2.19338),(57,7158,1.02669),(57,7159,1.26),(57,7174,0.86331),(57,7175,0.98),(57,7282,0.98),(57,7283,1.05),(57,7284,0.93331),(57,7285,1.09669),(57,7286,1.07331),(57,7287,1.14331),(57,7288,0.95669),(57,7289,1.09669),(57,7991,1.02669),(57,7992,1.14331),(57,8238,0.14),(57,8239,0.84),(57,8240,0.95669),(57,8241,1.07331),(57,8242,0.86331),(57,8243,1.09669),(58,2495,1.12),(58,2500,0.93324),(58,2523,1.12014),(58,2530,0.28),(58,2544,2.3331),(58,2549,0.56),(58,2555,0.74676),(58,2941,1.12014),(58,2950,1.86662),(58,2958,1.30676),(58,3444,1.49324),(58,3449,0.84),(58,3457,0.37338),(58,3492,0.37324),(58,4576,0.37338),(58,4625,1.91338),(58,4887,1.82),(58,5284,1.77338),(58,5292,1.82),(58,5298,2.05338),(58,5439,1.96),(58,8612,2.1),(58,8613,1.86662),(58,8614,2.38),(58,8615,1.96),(58,8616,2.19338),(58,8617,2.00662),(58,8618,1.77338),(58,8619,2.14662),(58,8620,1.77338),(58,8621,2.19338),(58,8622,0.46662),(58,8623,1.77338),(58,8624,2.24),(58,8625,2.42662),(58,8626,1.86662),(58,8627,2.14662),(58,8628,1.82),(58,8629,2.05338),(58,8630,2.00662),(58,8631,2.19338),(58,8632,1.86662),(58,8633,2.05338),(58,8634,2.05338),(58,8635,2.66),(58,8636,1.96),(58,8637,2.38),(58,8638,2.05338),(58,8639,2.42662),(58,8640,1.86662),(58,8641,2.19338),(58,8642,2.14662),(58,8643,2.05338),(58,8644,2.28662),(58,8645,1.72662),(58,8646,2.1),(58,8647,1.72662),(58,8648,1.96),(58,8689,1.82),(58,8690,2.19338),(58,8691,2.19338),(58,8692,2.28662),(58,8693,2.00662),(58,8694,2.33338),(58,8695,2.14662),(58,8696,2.42662),(58,8766,2.05338),(58,8767,2.19338),(58,8768,2.05338),(58,8769,2.52),(58,8770,2.38),(58,8771,1.91338),(58,8772,2.19338),(58,8773,1.72662),(58,8774,1.86662),(58,8775,1.91338),(58,8776,2.19338),(59,8815,1.30683),(59,8816,1.56),(69,8893,2.28683),(69,8894,1.68),(70,7738,0.49321),(71,8815,0.98679),(72,120,0.18669),(72,2483,0.37338),(72,3489,0.23331),(72,4063,0.88669),(72,4064,0.95669),(72,4065,0.86331),(72,4066,0.95669),(72,4067,0.14),(72,4068,0.91),(72,4069,1.00331),(72,4207,0.86331),(72,4208,1.02669),(72,4209,0.46662),(72,4210,0.91),(72,4211,1.09669),(72,4212,0.93331),(72,4213,1.05),(72,4214,1.02669),(72,4215,1.23669);


--
-- Table structure for table `#__finder_links_terms8`
--



CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms8`
--


INSERT INTO `#__finder_links_terms8` (`link_id`, `term_id`, `weight`) VALUES (1,4,0.6666),(2,4,0.6666),(3,4,0.6666),(4,4,0.6666),(5,4,0.6666),(6,4,0.6666),(6,10,0.17),(7,4,0.6666),(8,4,0.6666),(9,4,0.6666),(9,23,0.51331),(9,24,0.24679),(10,4,0.6666),(10,23,0.51331),(10,30,0.49321),(11,4,0.6666),(12,4,0.6666),(13,4,0.6666),(14,4,0.6666),(15,4,0.6666),(16,4,0.6666),(16,58,2.22),(16,59,5.92),(17,4,0.6666),(17,58,2.22),(17,62,5.79679),(18,4,0.6666),(18,65,2.46679),(18,66,5.67321),(19,4,0.6666),(20,4,0.6666),(20,24,0.08004),(20,98,0.32004),(20,99,1.71996),(20,100,1.92),(21,4,0.6666),(21,30,0.15996),(21,98,0.32004),(21,99,1.71996),(21,100,1.92),(22,4,0.6666),(22,10,0.07),(22,171,0.84),(22,172,0.91),(22,1073,1.39986),(22,1074,2.79993),(22,1075,3.00993),(22,1076,3.00993),(22,1077,3.36),(22,1078,3.92028),(22,1079,5.88),(22,1080,6.72),(22,1081,6.01986),(22,1082,7.14),(22,1083,0.55986),(22,1084,2.45007),(22,1085,2.94),(22,1086,2.58993),(22,1087,2.94),(22,1088,0.84),(22,1089,2.73),(22,1090,2.94),(22,1091,2.80014),(22,1092,3.00993),(22,1093,3.21993),(22,1094,3.21993),(22,1095,1.21331),(22,1096,1.14331),(22,1097,1.26),(22,1098,0.42),(22,1099,1.09669),(22,1100,1.23669),(22,1101,1.68021),(22,1102,0.91),(22,1103,0.98),(22,1104,0.93331),(22,1105,1.12),(22,1106,0.88669),(22,1107,1.02669),(22,1108,5.59986),(22,1109,6.01986),(22,1110,0.84),(22,1111,0.98),(22,1112,1.09669),(22,1113,1.77338),(22,1114,2.00662),(22,1115,0.37331),(22,1116,1.05),(22,1117,1.26),(22,1118,0.84),(22,1119,2.94),(22,1120,3.36),(22,1121,3.78),(22,1122,6.3),(22,1123,7.14),(22,1124,3.36),(22,1125,3.63993),(22,1126,2.52),(22,1127,18.4804),(22,1128,21.42),(22,1129,0.37338),(22,1130,0.91),(22,1131,1.02669),(22,1132,0.98),(22,1133,1.07331),(22,1134,0.98007),(22,1135,3.00993),(22,1136,2.28662),(22,1137,1.23669),(22,1138,0.42),(22,1139,0.98),(22,1140,1.02669),(22,1141,5.04),(22,1142,4.10676),(22,1143,1.19),(22,1144,3.42993),(22,1145,14.56),(22,1146,1.23669),(22,1147,1.23669),(22,1148,1.23669),(22,1149,1.23669),(22,1150,1.09669),(22,1151,1.09669),(22,1152,1.09669),(22,1153,1.14331),(22,1154,1.14331),(22,1155,1.14331),(22,1156,1.14331),(22,1157,1.14331),(22,1158,1.14331),(22,1159,1.14331),(22,1160,1.14331),(22,1161,1.14331),(22,1162,3.45324),(22,1163,4.48),(22,1164,0.98),(22,1165,1.02669),(22,1166,0.88669),(22,1167,1.07331),(22,1168,5.59986),(22,1169,6.3),(22,1170,3.54676),(22,1171,4.2),(22,1172,0.55986),(22,1173,2.73),(22,1174,2.94),(22,1175,2.66007),(22,1176,1.05),(22,1177,1.05),(22,1178,1.05),(22,1179,0.55986),(22,1180,0.81669),(22,1181,0.93331),(22,1182,4.43345),(22,1183,4.66655),(22,1184,6.76599),(22,1185,1.05),(22,1186,1.21331),(22,1187,25.48),(22,1188,28.7473),(22,1189,3.73296),(22,1190,5.59986),(22,1191,6.43986),(22,1192,0.98),(22,1193,1.19),(22,1194,5.59986),(22,1195,7.00014),(22,1196,2.73),(22,1197,3.15),(22,1198,0.09331),(22,1199,0.84),(22,1200,0.95669),(22,1201,0.98007),(22,1202,2.87007),(22,1203,3.00993),(22,1204,0.74662),(22,1205,1.07331),(22,1206,1.23669),(22,1207,0.93331),(22,1208,1.02669),(22,1209,0.55986),(22,1210,2.45007),(22,1211,2.79993),(22,1212,2.58993),(22,1213,2.94),(22,1214,0.14),(22,1215,0.86331),(22,1216,1.00331),(22,1217,2.24028),(22,1218,6.01986),(22,1219,7.00014),(22,1220,5.46),(22,1221,6.16014),(22,1367,0.74662),(22,1368,2.14662),(22,1369,1.19),(22,1370,1.16669),(22,1371,4.2),(22,1372,6.16014),(22,1373,7.00014),(22,1374,3.42993),(22,1375,4.05993),(22,1376,1.07331),(22,1377,1.14331),(22,1378,3.35979),(22,1379,9.45),(22,1380,11.1302),(22,1381,0.93345),(22,1382,0.91),(22,1383,1.02669),(22,1384,3.92),(22,1385,1.09669),(22,1386,3.21993),(22,1387,1.12014),(22,1388,5.46),(22,1389,5.88),(22,1390,3.73296),(22,1391,6.01986),(22,1392,6.43986),(22,1393,5.59986),(22,1394,5.71655),(22,1395,0.93331),(22,1396,1.07331),(22,1397,2.73),(22,1398,3.21993),(22,1399,1.26),(22,1400,3.15),(22,1401,3.36),(22,1402,2.52),(22,1403,6.16014),(22,1404,6.85986),(22,1405,4.90035),(22,1406,8.39979),(22,1407,9.65979),(22,1408,6.3),(22,1409,7.00014),(22,1410,0.37338),(22,1411,0.86331),(22,1412,0.98),(22,1413,0.98),(22,1414,1.19),(22,1415,0.37338),(22,1416,0.91),(22,1417,1.02669),(22,1418,0.98),(22,1419,1.07331),(22,1420,0.69993),(22,1421,2.94),(22,1422,3.42993),(22,1423,0.69993),(22,1424,2.79993),(22,1425,3.36),(22,1426,0.65338),(22,1427,2.05338),(22,1428,1.16669),(22,1429,1.16669),(22,1430,1.12),(22,1431,4.10676),(22,1432,2.28662),(22,1433,2.24),(22,1434,0.56007),(22,1435,1.72662),(22,1436,2.00662),(22,1437,0.98),(22,1438,1.14331),(22,1439,0.56),(22,1440,1.96),(22,1441,2.28662),(22,1442,0.98),(22,1443,1.96),(22,1444,2.05338),(22,1445,2.87007),(22,1446,3.42993),(22,1447,2.1),(22,1448,2.19338),(22,1449,1.12014),(22,1450,5.17986),(22,1451,5.74014),(22,1452,0.69993),(22,1453,2.66007),(22,1454,3.36),(22,1455,0.42),(22,1456,1.02669),(22,1457,1.21331),(22,1458,0.84),(22,1459,3.00993),(22,1460,3.63993),(22,1461,0.37338),(22,1462,0.95669),(22,1463,1.07331),(22,1464,0.91),(22,1465,0.98),(22,1466,4.6662),(22,1467,15.5396),(22,1468,18.0596),(22,1469,1.07331),(22,1470,1.21331),(22,1471,0.88669),(22,1472,1.02669),(22,2126,0.32669),(22,2127,1.09669),(22,2128,1.33),(22,2129,1.12014),(22,2130,5.32014),(22,2131,1.86662),(22,2132,1.86662),(22,2133,1.86662),(22,2134,0.46655),(22,2135,0.98),(22,2136,1.09669),(22,2137,2.73),(22,2138,3.29007),(22,2139,0.88669),(22,2140,1.00331),(22,2141,0.93324),(22,2142,4.01324),(22,2143,2.24),(22,2144,2.19338),(22,2145,1.12),(22,2146,4.10676),(22,2147,2.28662),(22,2148,2.24),(22,2149,1.68),(22,2150,3.42993),(22,2151,2.56662),(22,2152,1.12),(22,2153,1.35331),(22,2154,1.02641),(22,2155,0.79331),(22,2156,1.00331),(22,2157,2.79993),(22,2158,3.71007),(22,2159,0.88669),(22,2160,1.09669),(22,2161,0.84),(22,2162,1.07331),(22,2163,0.86331),(22,2164,0.91),(22,2165,1.05),(22,2166,1.91338),(22,2167,1.07331),(22,2168,1.09669),(22,2169,0.88669),(22,2170,1.00331),(22,2171,1.26),(22,2172,3.50007),(22,2173,3.71007),(22,2174,1.8669),(22,2175,9.8),(22,2176,5.48345),(22,2177,5.36655),(22,2178,0.46669),(22,2179,1.12),(22,2180,1.23669),(22,2181,3.59317),(22,2182,1.23669),(22,2183,1.35331),(22,2184,5.71655),(22,2185,2.52),(22,2186,3.71007),(22,2187,1.07331),(22,2188,1.14331),(22,2189,6.5338),(22,2190,1.00331),(22,2191,1.23669),(22,2192,1.02669),(22,2193,1.21331),(22,2194,17.64),(22,2195,20.5796),(22,2196,0.37331),(22,2197,1.00331),(22,2198,1.09669),(22,2199,8.16585),(22,2200,0.98),(22,2201,1.05),(22,2202,26.7873),(22,2203,29.4),(22,2204,5.32014),(22,2205,6.16014),(22,2206,16.5159),(22,2207,126.136),(22,2208,1.00331),(22,2209,2.79993),(22,2210,0.93331),(22,2211,1.00331),(22,2212,4.10676),(22,2213,0.93331),(22,2214,139.677),(22,2215,0.93331),(22,2216,1.07331),(22,2217,2.45007),(22,2218,2.94),(22,2219,0.98),(22,2220,1.05),(22,2221,2.94),(22,2222,3.29007),(22,2223,3.73324),(22,2224,0.98),(22,2225,0.98),(22,2226,0.98),(22,2227,0.98),(22,2228,5.17986),(22,2229,5.59986),(22,2230,1.11972),(22,2231,5.71683),(22,2232,2.58993),(22,2233,1.05),(22,2234,3.15),(22,2235,0.93331),(22,2236,1.02669),(22,2237,2.87007),(22,2238,3.15),(22,2661,12.7931),(22,2662,1.58662),(22,2663,1.96),(22,2664,105.324),(22,2665,1.07331),(22,2666,1.00331),(22,2667,1.05),(22,2668,1.12),(22,2669,1.12),(22,2670,1.00331),(22,2671,1.05),(22,2672,1.12),(22,2673,1.19),(22,2674,1.07331),(22,2675,1.14331),(22,2676,2.28662),(22,2677,1.02669),(22,2678,1.09669),(22,2679,1.09669),(22,2680,0.98),(22,2681,1.05),(22,2682,1.12),(22,2683,1.19),(22,2684,1.14331),(22,2685,1.21331),(22,2686,1.12),(22,2687,1.19),(22,2688,1.05),(22,2689,1.12),(22,2690,1.12),(22,2691,1.00331),(22,2692,1.07331),(22,2693,1.05),(22,2694,1.12),(22,2695,1.12),(22,2696,1.19),(22,2697,1.19),(22,2698,1.16669),(22,2699,1.14331),(22,2700,1.16669),(22,2701,1.16669),(22,2702,1.05),(22,2703,1.12),(22,2704,1.02669),(22,2705,1.12),(22,2706,1.05),(22,2707,1.12),(22,2708,1.05),(22,2709,1.12),(22,2710,1.12),(22,2711,1.19),(22,2712,1.26),(22,2713,1.19),(22,2714,1.02669),(22,2715,1.09669),(22,2716,1.02669),(22,2717,1.09669),(22,2718,1.07331),(22,2719,1.14331),(22,2720,1.05),(22,2721,1.12),(22,2722,2.24),(22,2723,1.05),(22,2724,1.02669),(22,2725,1.05),(22,2726,1.12),(22,2727,1.12),(22,2728,1.05),(22,2729,1.12),(22,2730,1.07331),(22,2731,1.14331),(22,2732,1.05),(22,2733,1.05),(22,2734,1.05),(22,2735,1.05),(22,2736,1.05),(22,2737,1.19),(22,2738,1.26),(22,2739,1.26),(22,2740,1.14331),(22,2741,1.02669),(22,2742,1.09669),(22,2743,2.19338),(22,2744,1.14331),(22,2745,1.21331),(22,2746,1.21331),(22,2747,1.05),(22,2748,1.12),(22,2749,1.00331),(22,2750,1.02669),(22,2751,1.02669),(22,2752,1.09669),(22,2753,1.09669),(22,2754,1.07331),(22,2755,1.09669),(22,2756,1.16669),(22,2757,1.07331),(22,2758,1.07331),(22,2759,1.09669),(22,2760,2.38),(22,2761,1.21331),(22,2762,1.02669),(22,2763,1.09669),(22,2764,1.05),(22,2765,1.05),(22,2766,1.05),(22,2767,1.05),(22,2768,1.05),(22,2769,1.16669),(22,2770,1.02669),(22,2771,1.09669),(22,2772,1.09669),(22,2773,1.12),(22,2774,1.12),(22,2775,1.12),(22,2776,1.12),(22,2777,1.12),(22,2778,1.12),(22,2779,1.07331),(22,2780,1.05),(22,2781,1.12),(22,2782,1.16669),(22,2783,5.71683),(22,2784,1.02669),(22,2785,5.88),(22,2786,0.91),(22,2787,1.07331),(22,2788,0.91),(22,2789,1.02669),(22,2790,2.52),(22,2791,2.87007),(22,2792,1.68),(22,2793,1.86662),(22,2794,8.6331),(22,2795,10.0331),(22,2796,1.54),(22,2797,1.82),(22,2798,3.36),(22,2799,1.96),(22,2800,1.91338),(22,2801,0.77),(22,2802,0.86331),(22,2803,94.92),(22,2804,102.83),(22,2805,0.93331),(22,2806,1.05),(22,2807,1.68),(22,2808,1.91338),(22,2809,0.86331),(22,2810,0.93331),(22,2811,1.49352),(22,2812,0.91),(22,2813,1.02669),(22,2814,4.9),(22,2815,2.19338),(22,2816,3.21993),(22,2817,1.86662),(22,2818,2.24),(22,2819,2.98704),(22,2820,13.813),(22,2821,0.93331),(22,2822,12.0397),(22,2823,2.87007),(22,2824,8.40042),(22,2825,19.7404),(22,2826,23.5204),(22,2827,7.56),(22,2828,17.64),(22,2829,20.5796),(22,2830,0.42),(22,2831,1.14331),(22,2832,1.30669),(22,2833,2.8),(22,2834,3.82676),(22,2835,4.29324),(22,2836,1.91338),(22,2837,2.14662),(22,2838,3.73324),(22,2839,4.2),(22,2840,0.42),(22,2841,2.87007),(22,2842,1.07331),(22,2843,2.1),(22,2844,1.54),(22,2845,9.75359),(22,2846,10.78),(22,2847,2.23986),(22,2848,0.95669),(22,2849,1.09669),(22,2850,1.05),(22,2851,1.14331),(22,2852,2.94),(22,2853,3.50007),(22,2854,1.12),(22,2855,1.19),(22,2856,0.28),(22,2857,1.05),(22,2858,1.21331),(22,2859,0.56),(22,2860,2.05338),(22,2861,1.14331),(22,2862,1.12),(22,2863,3.26634),(22,2864,1.00331),(22,2865,1.16669),(22,2866,6.16014),(22,2867,3.50007),(22,2868,3.63993),(22,2869,1.05),(22,2870,1.21331),(22,2871,5.32014),(22,2872,3.08007),(22,2873,2.79993),(22,2874,1.11993),(22,2875,3.29007),(22,2876,3.71007),(22,2877,0.65338),(22,2878,1.02669),(22,2879,1.09669),(22,2880,0.98),(22,2881,1.19),(22,2882,0.32669),(22,2883,1.07331),(22,2884,1.19),(22,2885,0.32669),(22,2886,1.05),(22,2887,1.16669),(22,2888,0.74662),(22,2889,1.07331),(22,2890,1.23669),(22,2891,1.00331),(22,2892,1.12),(22,2893,0.14),(22,2894,0.84),(22,2895,0.93331),(22,2896,0.98007),(22,2897,3.29007),(22,2898,3.99),(22,2899,0.98007),(22,2900,3.08007),(22,2901,3.29007),(22,2902,1.30676),(22,2903,4.2),(22,2904,2.33338),(22,2905,2.28662),(22,2906,1.96014),(22,2907,5.88),(22,2908,6.43986),(22,2909,1.11993),(22,2910,2.87007),(22,2911,3.15),(22,2912,0.98007),(22,2913,2.94),(22,2914,3.15),(22,2915,0.23331),(22,2916,0.93331),(22,2917,1.05),(22,2918,1.11993),(22,2919,3.08007),(22,2920,3.42993),(22,2921,1.11993),(22,2922,2.94),(22,2923,3.50007),(22,2924,3.7331),(22,2925,9.24021),(22,2926,10.08),(22,2927,1.00331),(22,2928,1.16669),(22,2929,3.49965),(22,2930,2.87007),(22,2931,3.15),(22,2932,5.59986),(22,2933,5.88),(22,2934,5.74014),(22,2935,7.00014),(23,4,0.6666),(23,3774,2.22),(24,4,0.6666),(24,2181,0.51331),(24,2206,0.37324),(24,2207,2.37993),(24,2214,2.87007),(24,3785,0.42),(24,3786,0.98),(24,3787,1.02669),(24,3788,0.42),(24,3789,1.05),(24,3790,1.12),(24,3793,0.32669),(24,3794,1.00331),(24,3795,1.12),(24,3796,1.09669),(24,3797,1.26),(24,3798,0.98),(24,3799,1.21331),(24,3819,0.42),(24,3820,1.14331),(24,3821,1.21331),(25,4,0.6666),(25,1179,0.09331),(25,1442,0.14),(25,2154,0.27993),(25,2174,0.18669),(25,2206,0.18662),(25,2207,0.79331),(25,2811,0.18669),(25,3925,0.32669),(25,3926,0.95669),(25,3927,1.07331),(25,3928,0.93338),(25,3929,1.12),(25,3930,1.4),(25,3931,0.84),(25,3932,0.98),(25,3948,0.46669),(25,3949,1.12),(25,3950,1.19),(25,3951,0.18669),(25,3952,0.91),(25,3953,1.00331),(25,3954,0.28),(25,3955,1.00331),(25,3956,1.14331),(25,3957,1.02669),(25,3958,2.16645),(25,3959,0.91),(25,3960,1.16669),(25,3961,0.88669),(25,3962,0.93331),(25,3963,0.98),(25,3964,1.12),(25,3965,1.00331),(25,3966,1.23669),(25,3967,0.18669),(25,3968,0.95669),(25,3969,1.12),(25,4000,0.09331),(25,4001,0.88669),(25,4002,1.00331),(25,4003,0.51331),(25,4004,1.07331),(25,4005,1.16669),(25,4006,1.00331),(25,4007,1.12),(25,4008,0.84),(25,4009,1.05),(25,4010,0.84),(25,4011,0.95669),(25,4012,0.93331),(25,4013,1.09669),(25,4014,0.42),(25,4015,1.02669),(25,4016,1.09669),(25,4017,0.51331),(25,4018,1.16669),(25,4019,1.28331),(25,4020,0.42),(25,4021,0.98),(25,4022,1.09669),(25,4023,1.11993),(25,4024,1.09669),(25,4025,1.16669),(25,4026,2.19338),(25,4027,1.28331),(25,4028,1.33),(25,4029,0.18669),(25,4030,0.93331),(25,4031,1.09669),(25,4032,0.18669),(25,4033,0.88669),(25,4034,1.00331),(25,4035,0.95669),(25,4036,0.88669),(25,4037,1.05),(25,4038,0.28),(25,4039,1.00331),(25,4040,1.16669),(25,4041,0.98),(25,4042,1.09669),(25,4043,0.18669),(25,4044,0.91),(25,4045,1.05),(25,4095,0.86331),(25,4096,1.12),(25,4097,0.28),(25,4098,0.98),(25,4099,1.09669),(25,4100,0.98007),(25,4101,0.98),(25,4102,1.07331),(25,4103,1.09669),(25,4104,1.21331),(25,4105,1.00331),(25,4106,1.09669),(25,4107,0.32669),(25,4108,1.05),(25,4109,1.14331),(25,4110,0.42),(25,4111,1.00331),(25,4112,1.12),(26,4,0.6666),(26,2154,0.18662),(26,2206,0.09331),(26,2230,0.09331),(26,2231,0.81669),(26,3788,0.42),(26,4010,0.84),(26,4043,0.18669),(26,4100,0.32669),(26,4270,1.26),(26,4271,1.33),(26,4272,0.37331),(26,4273,1.00331),(26,4274,1.14331),(26,4278,0.23331),(26,4279,0.88669),(26,4280,0.98),(26,4281,0.60669),(26,4282,1.19),(26,4283,1.26),(26,4294,0.42),(26,4295,0.98),(26,4296,1.09669),(26,4297,0.88669),(26,4298,0.95669),(26,4299,1.09669),(26,4300,0.32669),(26,4301,0.91),(26,4302,1.09669),(26,4303,0.98),(26,4304,1.05),(26,4305,1.05),(26,4306,0.91),(26,4307,0.98),(26,4328,0.32669),(26,4329,0.93331),(26,4330,0.98),(26,4331,0.46669),(26,4332,1.14331),(26,4333,1.00331),(26,4334,1.09669),(27,4,0.6666),(27,1101,0.18669),(27,1184,0.23331),(27,1187,0.91),(27,1188,1.02669),(27,1189,0.46662),(27,1194,0.93331),(27,1214,0.14),(27,1217,0.18669),(27,1371,0.42),(27,1378,0.37331),(27,1390,0.23331),(27,1402,0.42),(27,1455,0.42),(27,2126,0.32669),(27,2134,0.09331),(27,2154,0.65317),(27,2196,0.37331),(27,2199,0.46662),(27,2202,0.95669),(27,2203,1.05),(27,2830,0.42),(27,2847,0.74662),(27,2877,0.32669),(27,2896,0.32669),(27,2929,0.46662),(27,4425,0.93331),(27,4426,1.07331),(27,4427,1.05),(27,4428,1.21331),(27,4429,0.86331),(27,4430,1.00331),(27,4431,0.88669),(27,4432,1.00331),(27,4467,0.98),(27,4468,1.16669),(27,4469,1.00331),(27,4470,1.16669),(27,4471,1.09669),(27,4472,1.26),(27,4473,0.95669),(27,4474,1.19),(27,4475,1.09669),(27,4476,1.21331),(27,4482,0.93331),(27,4483,1.05),(27,4484,0.93331),(27,4485,1.02669),(27,4486,0.81669),(27,4487,0.98),(27,4488,0.98),(27,4489,1.02669),(27,4490,0.95669),(27,4491,1.07331),(27,4492,0.81669),(27,4493,0.93331),(27,4494,0.86331),(27,4495,1.00331),(27,4496,0.86331),(27,4497,1.12),(27,4498,0.91),(27,4499,1.14331),(27,4500,1.09669),(27,4501,1.26),(27,4502,0.98),(27,4503,1.05),(27,4596,0.37331),(27,4597,0.93331),(27,4598,1.02669),(27,4599,1.14331),(27,4600,1.33),(27,4601,1.07331),(27,4602,1.19),(27,4603,1.02669),(27,4604,1.21331),(27,4605,0.42),(27,4606,1.07331),(27,4607,1.14331),(27,4608,1.05),(27,4609,1.19),(27,4610,0.95669),(27,4611,1.05),(27,4612,0.28),(27,4613,0.91),(27,4614,1.12),(27,4615,0.95669),(27,4616,1.12),(27,4617,0.91),(27,4618,1.14331),(28,4,0.6666),(28,10,0.17),(28,1101,0.18669),(28,1184,0.23331),(28,1187,0.91),(28,1188,1.02669),(28,1189,0.46662),(28,1194,0.93331),(28,1214,0.14),(28,1217,0.18669),(28,1371,0.42),(28,1378,0.37331),(28,1390,0.23331),(28,1402,0.42),(28,1455,0.42),(28,2126,0.32669),(28,2134,0.09331),(28,2154,0.65317),(28,2196,0.37331),(28,2199,0.46662),(28,2202,0.95669),(28,2203,1.05),(28,2830,0.42),(28,2847,0.74662),(28,2877,0.32669),(28,2896,0.32669),(28,2929,0.46662),(28,4425,0.93331),(28,4426,1.07331),(28,4427,1.05),(28,4428,1.21331),(28,4429,0.86331),(28,4430,1.00331),(28,4431,0.88669),(28,4432,1.00331),(28,4467,0.98),(28,4468,1.16669),(28,4469,1.00331),(28,4470,1.16669),(28,4471,1.09669),(28,4472,1.26),(28,4473,0.95669),(28,4474,1.19),(28,4475,1.09669),(28,4476,1.21331),(28,4482,0.93331),(28,4483,1.05),(28,4484,0.93331),(28,4485,1.02669),(28,4486,0.81669),(28,4487,0.98),(28,4488,0.98),(28,4489,1.02669),(28,4490,0.95669),(28,4491,1.07331),(28,4492,0.81669),(28,4493,0.93331),(28,4494,0.86331),(28,4495,1.00331),(28,4496,0.86331),(28,4497,1.12),(28,4498,0.91),(28,4499,1.14331),(28,4500,1.09669),(28,4501,1.26),(28,4502,0.98),(28,4503,1.05),(28,4596,0.37331),(28,4597,0.93331),(28,4598,1.02669),(28,4599,1.14331),(28,4600,1.33),(28,4601,1.07331),(28,4602,1.19),(28,4603,1.02669),(28,4604,1.21331),(28,4605,0.42),(28,4606,1.07331),(28,4607,1.14331),(28,4608,1.05),(28,4609,1.19),(28,4610,0.95669),(28,4611,1.05),(28,4612,0.28),(28,4613,0.91),(28,4614,1.12),(28,4615,0.95669),(28,4616,1.12),(28,4617,0.91),(28,4618,1.14331),(29,4,0.6666),(29,1101,0.18669),(29,1184,0.23331),(29,1187,0.91),(29,1188,1.02669),(29,1189,0.46662),(29,1194,0.93331),(29,1214,0.14),(29,1217,0.18669),(29,1371,0.42),(29,1378,0.37331),(29,1390,0.23331),(29,1402,0.42),(29,1455,0.42),(29,2126,0.32669),(29,2134,0.09331),(29,2154,0.65317),(29,2196,0.37331),(29,2199,0.46662),(29,2202,0.95669),(29,2203,1.05),(29,2830,0.42),(29,2847,0.74662),(29,2877,0.32669),(29,2896,0.32669),(29,2929,0.46662),(29,4425,0.93331),(29,4426,1.07331),(29,4427,1.05),(29,4428,1.21331),(29,4429,0.86331),(29,4430,1.00331),(29,4431,0.88669),(29,4432,1.00331),(29,4467,0.98),(29,4468,1.16669),(29,4469,1.00331),(29,4470,1.16669),(29,4471,1.09669),(29,4472,1.26),(29,4473,0.95669),(29,4474,1.19),(29,4475,1.09669),(29,4476,1.21331),(29,4482,0.93331),(29,4483,1.05),(29,4484,0.93331),(29,4485,1.02669),(29,4486,0.81669),(29,4487,0.98),(29,4488,0.98),(29,4489,1.02669),(29,4490,0.95669),(29,4491,1.07331),(29,4492,0.81669),(29,4493,0.93331),(29,4494,0.86331),(29,4495,1.00331),(29,4496,0.86331),(29,4497,1.12),(29,4498,0.91),(29,4499,1.14331),(29,4500,1.09669),(29,4501,1.26),(29,4502,0.98),(29,4503,1.05),(29,4596,0.37331),(29,4597,0.93331),(29,4598,1.02669),(29,4599,1.14331),(29,4600,1.33),(29,4601,1.07331),(29,4602,1.19),(29,4603,1.02669),(29,4604,1.21331),(29,4605,0.42),(29,4606,1.07331),(29,4607,1.14331),(29,4608,1.05),(29,4609,1.19),(29,4610,0.95669),(29,4611,1.05),(29,4612,0.28),(29,4613,0.91),(29,4614,1.12),(29,4615,0.95669),(29,4616,1.12),(29,4617,0.91),(29,4618,1.14331),(30,4,0.6666),(30,1101,0.18669),(30,1184,0.23331),(30,1187,0.91),(30,1188,1.02669),(30,1189,0.46662),(30,1194,0.93331),(30,1214,0.14),(30,1217,0.18669),(30,1371,0.42),(30,1378,0.37331),(30,1390,0.23331),(30,1402,0.42),(30,1455,0.42),(30,2126,0.32669),(30,2134,0.09331),(30,2154,0.65317),(30,2196,0.37331),(30,2199,0.46662),(30,2202,0.95669),(30,2203,1.05),(30,2830,0.42),(30,2847,0.74662),(30,2877,0.32669),(30,2896,0.32669),(30,2929,0.46662),(30,4425,0.93331),(30,4426,1.07331),(30,4427,1.05),(30,4428,1.21331),(30,4429,0.86331),(30,4430,1.00331),(30,4431,0.88669),(30,4432,1.00331),(30,4467,0.98),(30,4468,1.16669),(30,4469,1.00331),(30,4470,1.16669),(30,4471,1.09669),(30,4472,1.26),(30,4473,0.95669),(30,4474,1.19),(30,4475,1.09669),(30,4476,1.21331),(30,4482,0.93331),(30,4483,1.05),(30,4484,0.93331),(30,4485,1.02669),(30,4486,0.81669),(30,4487,0.98),(30,4488,0.98),(30,4489,1.02669),(30,4490,0.95669),(30,4491,1.07331),(30,4492,0.81669),(30,4493,0.93331),(30,4494,0.86331),(30,4495,1.00331),(30,4496,0.86331),(30,4497,1.12),(30,4498,0.91),(30,4499,1.14331),(30,4500,1.09669),(30,4501,1.26),(30,4502,0.98),(30,4503,1.05),(30,4596,0.37331),(30,4597,0.93331),(30,4598,1.02669),(30,4599,1.14331),(30,4600,1.33),(30,4601,1.07331),(30,4602,1.19),(30,4603,1.02669),(30,4604,1.21331),(30,4605,0.42),(30,4606,1.07331),(30,4607,1.14331),(30,4608,1.05),(30,4609,1.19),(30,4610,0.95669),(30,4611,1.05),(30,4612,0.28),(30,4613,0.91),(30,4614,1.12),(30,4615,0.95669),(30,4616,1.12),(30,4617,0.91),(30,4618,1.14331),(31,4,0.6666),(31,1101,0.18669),(31,1184,0.23331),(31,1187,0.91),(31,1188,1.02669),(31,1189,0.46662),(31,1194,0.93331),(31,1214,0.14),(31,1217,0.18669),(31,1371,0.42),(31,1378,0.37331),(31,1390,0.23331),(31,1402,0.42),(31,1455,0.42),(31,2126,0.32669),(31,2134,0.09331),(31,2154,0.65317),(31,2196,0.37331),(31,2199,0.46662),(31,2202,0.95669),(31,2203,1.05),(31,2830,0.42),(31,2847,0.74662),(31,2877,0.32669),(31,2896,0.32669),(31,2929,0.46662),(31,4425,0.93331),(31,4426,1.07331),(31,4427,1.05),(31,4428,1.21331),(31,4429,0.86331),(31,4430,1.00331),(31,4431,0.88669),(31,4432,1.00331),(31,4467,0.98),(31,4468,1.16669),(31,4469,1.00331),(31,4470,1.16669),(31,4471,1.09669),(31,4472,1.26),(31,4473,0.95669),(31,4474,1.19),(31,4475,1.09669),(31,4476,1.21331),(31,4482,0.93331),(31,4483,1.05),(31,4484,0.93331),(31,4485,1.02669),(31,4486,0.81669),(31,4487,0.98),(31,4488,0.98),(31,4489,1.02669),(31,4490,0.95669),(31,4491,1.07331),(31,4492,0.81669),(31,4493,0.93331),(31,4494,0.86331),(31,4495,1.00331),(31,4496,0.86331),(31,4497,1.12),(31,4498,0.91),(31,4499,1.14331),(31,4500,1.09669),(31,4501,1.26),(31,4502,0.98),(31,4503,1.05),(31,4596,0.37331),(31,4597,0.93331),(31,4598,1.02669),(31,4599,1.14331),(31,4600,1.33),(31,4601,1.07331),(31,4602,1.19),(31,4603,1.02669),(31,4604,1.21331),(31,4605,0.42),(31,4606,1.07331),(31,4607,1.14331),(31,4608,1.05),(31,4609,1.19),(31,4610,0.95669),(31,4611,1.05),(31,4612,0.28),(31,4613,0.91),(31,4614,1.12),(31,4615,0.95669),(31,4616,1.12),(31,4617,0.91),(31,4618,1.14331),(31,4726,1.23321),(31,4727,4.93321),(32,4,0.6666),(32,1101,0.18669),(32,1184,0.23331),(32,1187,0.91),(32,1188,1.02669),(32,1189,0.46662),(32,1194,0.93331),(32,1214,0.14),(32,1217,0.18669),(32,1371,0.42),(32,1378,0.37331),(32,1390,0.23331),(32,1402,0.42),(32,1455,0.42),(32,2126,0.32669),(32,2134,0.09331),(32,2154,0.65317),(32,2196,0.37331),(32,2199,0.46662),(32,2202,0.95669),(32,2203,1.05),(32,2830,0.42),(32,2847,0.74662),(32,2877,0.32669),(32,2896,0.32669),(32,2929,0.46662),(32,4425,0.93331),(32,4426,1.07331),(32,4427,1.05),(32,4428,1.21331),(32,4429,0.86331),(32,4430,1.00331),(32,4431,0.88669),(32,4432,1.00331),(32,4467,0.98),(32,4468,1.16669),(32,4469,1.00331),(32,4470,1.16669),(32,4471,1.09669),(32,4472,1.26),(32,4473,0.95669),(32,4474,1.19),(32,4475,1.09669),(32,4476,1.21331),(32,4482,0.93331),(32,4483,1.05),(32,4484,0.93331),(32,4485,1.02669),(32,4486,0.81669),(32,4487,0.98),(32,4488,0.98),(32,4489,1.02669),(32,4490,0.95669),(32,4491,1.07331),(32,4492,0.81669),(32,4493,0.93331),(32,4494,0.86331),(32,4495,1.00331),(32,4496,0.86331),(32,4497,1.12),(32,4498,0.91),(32,4499,1.14331),(32,4500,1.09669),(32,4501,1.26),(32,4502,0.98),(32,4503,1.05),(32,4596,0.37331),(32,4597,0.93331),(32,4598,1.02669),(32,4599,1.14331),(32,4600,1.33),(32,4601,1.07331),(32,4602,1.19),(32,4603,1.02669),(32,4604,1.21331),(32,4605,0.42),(32,4606,1.07331),(32,4607,1.14331),(32,4608,1.05),(32,4609,1.19),(32,4610,0.95669),(32,4611,1.05),(32,4612,0.28),(32,4613,0.91),(32,4614,1.12),(32,4615,0.95669),(32,4616,1.12),(32,4617,0.91),(32,4618,1.14331),(32,4726,1.23321),(32,4729,5.05679),(33,4,0.6666),(33,1101,0.18669),(33,1184,0.23331),(33,1187,0.91),(33,1188,1.02669),(33,1189,0.46662),(33,1194,0.93331),(33,1214,0.14),(33,1217,0.18669),(33,1371,0.42),(33,1378,0.37331),(33,1390,0.23331),(33,1402,0.42),(33,1455,0.42),(33,2126,0.32669),(33,2134,0.09331),(33,2154,0.65317),(33,2196,0.37331),(33,2199,0.46662),(33,2202,0.95669),(33,2203,1.05),(33,2830,0.42),(33,2847,0.74662),(33,2877,0.32669),(33,2896,0.32669),(33,2929,0.46662),(33,4425,0.93331),(33,4426,1.07331),(33,4427,1.05),(33,4428,1.21331),(33,4429,0.86331),(33,4430,1.00331),(33,4431,0.88669),(33,4432,1.00331),(33,4467,0.98),(33,4468,1.16669),(33,4469,1.00331),(33,4470,1.16669),(33,4471,1.09669),(33,4472,1.26),(33,4473,0.95669),(33,4474,1.19),(33,4475,1.09669),(33,4476,1.21331),(33,4482,0.93331),(33,4483,1.05),(33,4484,0.93331),(33,4485,1.02669),(33,4486,0.81669),(33,4487,0.98),(33,4488,0.98),(33,4489,1.02669),(33,4490,0.95669),(33,4491,1.07331),(33,4492,0.81669),(33,4493,0.93331),(33,4494,0.86331),(33,4495,1.00331),(33,4496,0.86331),(33,4497,1.12),(33,4498,0.91),(33,4499,1.14331),(33,4500,1.09669),(33,4501,1.26),(33,4502,0.98),(33,4503,1.05),(33,4596,0.37331),(33,4597,0.93331),(33,4598,1.02669),(33,4599,1.14331),(33,4600,1.33),(33,4601,1.07331),(33,4602,1.19),(33,4603,1.02669),(33,4604,1.21331),(33,4605,0.42),(33,4606,1.07331),(33,4607,1.14331),(33,4608,1.05),(33,4609,1.19),(33,4610,0.95669),(33,4611,1.05),(33,4612,0.28),(33,4613,0.91),(33,4614,1.12),(33,4615,0.95669),(33,4616,1.12),(33,4617,0.91),(33,4618,1.14331),(33,4726,1.23321),(33,4732,4.93321),(34,4,0.6666),(34,1101,0.18669),(34,1184,0.23331),(34,1187,0.91),(34,1188,1.02669),(34,1189,0.46662),(34,1194,0.93331),(34,1214,0.14),(34,1217,0.18669),(34,1371,0.42),(34,1378,0.37331),(34,1390,0.23331),(34,1402,0.42),(34,1455,0.42),(34,2126,0.32669),(34,2134,0.09331),(34,2154,0.65317),(34,2196,0.37331),(34,2199,0.46662),(34,2202,0.95669),(34,2203,1.05),(34,2830,0.42),(34,2847,0.74662),(34,2877,0.32669),(34,2896,0.32669),(34,2929,0.46662),(34,4425,0.93331),(34,4426,1.07331),(34,4427,1.05),(34,4428,1.21331),(34,4429,0.86331),(34,4430,1.00331),(34,4431,0.88669),(34,4432,1.00331),(34,4467,0.98),(34,4468,1.16669),(34,4469,1.00331),(34,4470,1.16669),(34,4471,1.09669),(34,4472,1.26),(34,4473,0.95669),(34,4474,1.19),(34,4475,1.09669),(34,4476,1.21331),(34,4482,0.93331),(34,4483,1.05),(34,4484,0.93331),(34,4485,1.02669),(34,4486,0.81669),(34,4487,0.98),(34,4488,0.98),(34,4489,1.02669),(34,4490,0.95669),(34,4491,1.07331),(34,4492,0.81669),(34,4493,0.93331),(34,4494,0.86331),(34,4495,1.00331),(34,4496,0.86331),(34,4497,1.12),(34,4498,0.91),(34,4499,1.14331),(34,4500,1.09669),(34,4501,1.26),(34,4502,0.98),(34,4503,1.05),(34,4596,0.37331),(34,4597,0.93331),(34,4598,1.02669),(34,4599,1.14331),(34,4600,1.33),(34,4601,1.07331),(34,4602,1.19),(34,4603,1.02669),(34,4604,1.21331),(34,4605,0.42),(34,4606,1.07331),(34,4607,1.14331),(34,4608,1.05),(34,4609,1.19),(34,4610,0.95669),(34,4611,1.05),(34,4612,0.28),(34,4613,0.91),(34,4614,1.12),(34,4615,0.95669),(34,4616,1.12),(34,4617,0.91),(34,4618,1.14331),(34,4726,1.23321),(34,4734,5.18),(35,4,0.6666),(35,1101,0.18669),(35,1184,0.23331),(35,1187,0.91),(35,1188,1.02669),(35,1189,0.46662),(35,1194,0.93331),(35,1214,0.14),(35,1217,0.18669),(35,1371,0.42),(35,1378,0.37331),(35,1390,0.23331),(35,1402,0.42),(35,1455,0.42),(35,2126,0.32669),(35,2134,0.09331),(35,2154,0.65317),(35,2196,0.37331),(35,2199,0.46662),(35,2202,0.95669),(35,2203,1.05),(35,2830,0.42),(35,2847,0.74662),(35,2877,0.32669),(35,2896,0.32669),(35,2929,0.46662),(35,4425,0.93331),(35,4426,1.07331),(35,4427,1.05),(35,4428,1.21331),(35,4429,0.86331),(35,4430,1.00331),(35,4431,0.88669),(35,4432,1.00331),(35,4467,0.98),(35,4468,1.16669),(35,4469,1.00331),(35,4470,1.16669),(35,4471,1.09669),(35,4472,1.26),(35,4473,0.95669),(35,4474,1.19),(35,4475,1.09669),(35,4476,1.21331),(35,4482,0.93331),(35,4483,1.05),(35,4484,0.93331),(35,4485,1.02669),(35,4486,0.81669),(35,4487,0.98),(35,4488,0.98),(35,4489,1.02669),(35,4490,0.95669),(35,4491,1.07331),(35,4492,0.81669),(35,4493,0.93331),(35,4494,0.86331),(35,4495,1.00331),(35,4496,0.86331),(35,4497,1.12),(35,4498,0.91),(35,4499,1.14331),(35,4500,1.09669),(35,4501,1.26),(35,4502,0.98),(35,4503,1.05),(35,4596,0.37331),(35,4597,0.93331),(35,4598,1.02669),(35,4599,1.14331),(35,4600,1.33),(35,4601,1.07331),(35,4602,1.19),(35,4603,1.02669),(35,4604,1.21331),(35,4605,0.42),(35,4606,1.07331),(35,4607,1.14331),(35,4608,1.05),(35,4609,1.19),(35,4610,0.95669),(35,4611,1.05),(35,4612,0.28),(35,4613,0.91),(35,4614,1.12),(35,4615,0.95669),(35,4616,1.12),(35,4617,0.91),(35,4618,1.14331),(35,4726,1.23321),(35,4734,5.18),(35,4737,5.55),(36,4,0.6666),(36,2154,0.18662),(36,2206,0.09331),(36,2230,0.09331),(36,2231,0.81669),(36,3788,0.42),(36,4010,0.84),(36,4043,0.18669),(36,4100,0.32669),(36,4270,1.26),(36,4271,1.33),(36,4272,0.37331),(36,4273,1.00331),(36,4274,1.14331),(36,4278,0.23331),(36,4279,0.88669),(36,4280,0.98),(36,4281,0.60669),(36,4282,1.19),(36,4283,1.26),(36,4294,0.42),(36,4295,0.98),(36,4296,1.09669),(36,4297,0.88669),(36,4298,0.95669),(36,4299,1.09669),(36,4300,0.32669),(36,4301,0.91),(36,4302,1.09669),(36,4303,0.98),(36,4304,1.05),(36,4305,1.05),(36,4306,0.91),(36,4307,0.98),(36,4328,0.32669),(36,4329,0.93331),(36,4330,0.98),(36,4331,0.46669),(36,4332,1.14331),(36,4333,1.00331),(36,4334,1.09669),(37,4,0.6666),(37,2154,0.18662),(37,2206,0.09331),(37,2230,0.09331),(37,2231,0.81669),(37,3788,0.42),(37,4010,0.84),(37,4043,0.18669),(37,4100,0.32669),(37,4270,1.26),(37,4271,1.33),(37,4272,2.34652),(37,4273,6.30652),(37,4274,1.14331),(37,4278,0.23331),(37,4279,0.88669),(37,4280,0.98),(37,4281,0.60669),(37,4282,1.19),(37,4283,1.26),(37,4294,0.42),(37,4295,0.98),(37,4296,1.09669),(37,4297,0.88669),(37,4298,0.95669),(37,4299,1.09669),(37,4300,0.32669),(37,4301,0.91),(37,4302,1.09669),(37,4303,0.98),(37,4304,1.05),(37,4305,1.05),(37,4306,0.91),(37,4307,0.98),(37,4328,0.32669),(37,4329,0.93331),(37,4330,0.98),(37,4331,0.46669),(37,4332,1.14331),(37,4333,1.00331),(37,4334,1.09669),(38,4,0.6666),(38,2154,0.18662),(38,2206,0.09331),(38,2230,0.09331),(38,2231,0.81669),(38,3788,0.42),(38,4010,0.84),(38,4043,0.18669),(38,4100,0.32669),(38,4270,1.26),(38,4271,1.33),(38,4272,0.37331),(38,4273,1.00331),(38,4274,1.14331),(38,4278,0.23331),(38,4279,0.88669),(38,4280,0.98),(38,4281,0.60669),(38,4282,1.19),(38,4283,1.26),(38,4294,0.42),(38,4295,0.98),(38,4296,1.09669),(38,4297,0.88669),(38,4298,0.95669),(38,4299,1.09669),(38,4300,0.32669),(38,4301,0.91),(38,4302,1.09669),(38,4303,0.98),(38,4304,1.05),(38,4305,1.05),(38,4306,0.91),(38,4307,0.98),(38,4328,0.32669),(38,4329,0.93331),(38,4330,0.98),(38,4331,0.46669),(38,4332,1.14331),(38,4333,1.00331),(38,4334,1.09669),(39,4,0.6666),(39,1101,0.18669),(39,1126,0.14),(39,1127,1.02669),(39,1128,1.19),(39,1189,0.69993),(39,1390,0.46662),(39,1402,0.42),(39,1455,0.42),(39,2134,0.37324),(39,2154,0.18662),(39,2811,0.18669),(39,2824,0.46669),(39,2825,1.09669),(39,2826,1.30669),(39,2827,0.42),(39,2828,0.98),(39,2829,1.14331),(39,2863,1.39986),(39,2877,0.32669),(39,2929,0.23331),(39,4097,0.28),(39,4605,1.68),(39,4789,0.91),(39,4790,1.05),(39,4791,1.77338),(39,4792,2.00662),(39,4793,1.09669),(39,4794,1.23669),(39,4817,2.00662),(39,4818,2.33338),(39,4819,1.07331),(39,4820,1.19),(39,4821,1.07331),(39,4822,1.26),(39,4825,1.72662),(39,4826,1.91338),(39,4827,1.82),(39,4828,2.1),(39,4829,0.91),(39,4830,1.09669),(39,4831,0.86331),(39,4832,1.07331),(39,4902,0.88669),(39,4903,0.98),(39,4904,0.56),(39,4905,1.14331),(39,4906,1.23669),(39,4907,1.05),(39,4908,1.19),(39,4909,0.88669),(39,4910,1.16669),(39,4911,1.91338),(39,4912,2.28662),(39,4913,2.00662),(39,4914,2.14662),(39,4915,0.91),(39,4916,1.14331),(39,4917,2.28662),(39,4918,2.66),(39,4919,1.05),(39,4920,1.19),(39,4921,1.07331),(39,4922,1.19),(39,4923,1.14331),(39,4924,1.23669),(39,4925,0.91),(39,4926,1.02669),(40,4,0.6666),(40,24,0.24679),(40,1078,0.65338),(40,1101,0.37338),(40,1126,0.14),(40,1127,1.02669),(40,1128,1.19),(40,1184,1.16655),(40,1187,2.73),(40,1188,3.08007),(40,1189,0.69993),(40,1214,0.28),(40,1217,0.18669),(40,1371,0.84),(40,1378,0.74662),(40,1390,0.69993),(40,1397,0.91),(40,1402,0.84),(40,1405,0.32669),(40,1455,0.42),(40,1466,0.23331),(40,2134,0.46655),(40,2154,0.46655),(40,2155,0.79331),(40,2189,0.32669),(40,2199,0.93324),(40,2202,2.87007),(40,2203,3.15),(40,2824,0.46669),(40,2825,1.09669),(40,2826,1.30669),(40,2827,0.42),(40,2828,0.98),(40,2829,1.14331),(40,2830,1.26),(40,2847,0.74662),(40,2863,0.23331),(40,2877,0.65338),(40,2888,0.37331),(40,2896,0.32669),(40,2924,0.37331),(40,2929,0.23331),(40,4429,0.86331),(40,4596,0.37331),(40,4605,0.84),(40,4904,2.24),(40,5085,1.05),(40,5086,1.14331),(40,5087,1.00331),(40,5088,1.07331),(40,5089,0.98),(40,5090,1.16669),(40,5091,0.86331),(40,5092,0.98),(40,5093,0.88669),(40,5094,1.00331),(40,5095,1.02669),(40,5096,1.23669),(40,5097,0.95669),(40,5098,1.07331),(40,5099,0.91),(40,5100,1.02669),(40,5101,0.98),(40,5102,1.12),(40,5103,1.02669),(40,5104,1.19),(40,5105,1.05),(40,5106,0.86331),(40,5107,1.12),(40,5156,0.98),(40,5157,1.14331),(40,5158,1.00331),(40,5159,1.09669),(40,5160,1.02669),(40,5161,1.09669),(40,5162,1.05),(40,5163,1.26),(40,5164,1.12),(40,5165,1.16669),(40,5166,1.07331),(40,5167,0.91),(40,5168,1.12),(40,5169,1.00331),(40,5170,1.14331),(40,5171,1.21331),(40,5172,1.35331),(40,5173,1.09669),(40,5174,1.26),(40,5175,1.05),(40,5176,1.14331),(40,5177,0.88669),(40,5178,1.02669),(40,5184,0.91),(40,5185,1.00331),(40,5186,0.88669),(40,5187,0.95669),(40,5188,0.98),(40,5189,1.05),(40,5190,0.93331),(40,5191,1.07331),(40,5192,0.84),(40,5193,1.05),(40,5194,0.91),(40,5195,0.86331),(40,5196,0.98),(40,5197,0.88669),(40,5198,1.07331),(40,5199,0.91),(40,5200,1.00331),(40,5201,0.98),(40,5202,1.21331),(40,5203,0.98),(40,5204,1.09669),(40,5205,0.93331),(40,5206,1.12),(40,5318,2.05338),(40,5319,1.16669),(40,5320,1.16669),(40,5321,1.14331),(40,5322,1.33),(40,5323,1.14331),(40,5324,1.37669),(40,5325,0.98),(40,5326,1.09669),(40,5327,1.16669),(40,5328,1.4),(40,5329,1.14331),(40,5330,1.37669),(40,5331,1.12),(40,5332,1.21331),(40,5333,0.98),(40,5334,1.14331),(40,5335,1.05),(40,5336,1.21331),(40,5337,0.93331),(40,5338,1.09669),(40,5339,0.98),(40,5340,1.14331),(40,5341,1.12),(40,5342,1.26),(40,5343,1.09669),(40,5344,1.21331),(40,5345,1.02669),(40,5346,1.23669),(40,5347,0.98),(40,5348,1.09669),(40,5349,0.93331),(40,5350,1.00331),(40,5351,1.02669),(40,5352,1.16669),(40,5353,1.02669),(40,5354,1.12),(41,4,0.6666),(41,30,0.49321),(41,1078,0.65338),(41,1101,0.37338),(41,1126,0.14),(41,1127,1.02669),(41,1128,1.19),(41,1184,1.16655),(41,1187,2.73),(41,1188,3.08007),(41,1189,0.69993),(41,1214,0.28),(41,1217,0.18669),(41,1371,0.84),(41,1378,0.74662),(41,1390,0.69993),(41,1397,0.91),(41,1402,0.84),(41,1405,0.32669),(41,1455,0.42),(41,1466,0.23331),(41,2134,0.46655),(41,2154,0.46655),(41,2155,0.79331),(41,2189,0.32669),(41,2199,0.93324),(41,2202,2.87007),(41,2203,3.15),(41,2824,0.46669),(41,2825,1.09669),(41,2826,1.30669),(41,2827,0.42),(41,2828,0.98),(41,2829,1.14331),(41,2830,1.26),(41,2847,0.74662),(41,2863,0.23331),(41,2877,0.65338),(41,2888,0.37331),(41,2896,0.32669),(41,2924,0.37331),(41,2929,0.23331),(41,4429,0.86331),(41,4596,0.37331),(41,4605,0.84),(41,4904,2.24),(41,5085,1.05),(41,5086,1.14331),(41,5087,1.00331),(41,5088,1.07331),(41,5089,0.98),(41,5090,1.16669),(41,5091,0.86331),(41,5092,0.98),(41,5093,0.88669),(41,5094,1.00331),(41,5095,1.02669),(41,5096,1.23669),(41,5097,0.95669),(41,5098,1.07331),(41,5099,0.91),(41,5100,1.02669),(41,5101,0.98),(41,5102,1.12),(41,5103,1.02669),(41,5104,1.19),(41,5105,1.05),(41,5106,0.86331),(41,5107,1.12),(41,5156,0.98),(41,5157,1.14331),(41,5158,1.00331),(41,5159,1.09669),(41,5160,1.02669),(41,5161,1.09669),(41,5162,1.05),(41,5163,1.26),(41,5164,1.12),(41,5165,1.16669),(41,5166,1.07331),(41,5167,0.91),(41,5168,1.12),(41,5169,1.00331),(41,5170,1.14331),(41,5171,1.21331),(41,5172,1.35331),(41,5173,1.09669),(41,5174,1.26),(41,5175,1.05),(41,5176,1.14331),(41,5177,0.88669),(41,5178,1.02669),(41,5184,0.91),(41,5185,1.00331),(41,5186,0.88669),(41,5187,0.95669),(41,5188,0.98),(41,5189,1.05),(41,5190,0.93331),(41,5191,1.07331),(41,5192,0.84),(41,5193,1.05),(41,5194,0.91),(41,5195,0.86331),(41,5196,0.98),(41,5197,0.88669),(41,5198,1.07331),(41,5199,0.91),(41,5200,1.00331),(41,5201,0.98),(41,5202,1.21331),(41,5203,0.98),(41,5204,1.09669),(41,5205,0.93331),(41,5206,1.12),(41,5318,2.05338),(41,5319,1.16669),(41,5320,1.16669),(41,5321,1.14331),(41,5322,1.33),(41,5323,1.14331),(41,5324,1.37669),(41,5325,0.98),(41,5326,1.09669),(41,5327,1.16669),(41,5328,1.4),(41,5329,1.14331),(41,5330,1.37669),(41,5331,1.12),(41,5332,1.21331),(41,5333,0.98),(41,5334,1.14331),(41,5335,1.05),(41,5336,1.21331),(41,5337,0.93331),(41,5338,1.09669),(41,5339,0.98),(41,5340,1.14331),(41,5341,1.12),(41,5342,1.26),(41,5343,1.09669),(41,5344,1.21331),(41,5345,1.02669),(41,5346,1.23669),(41,5347,0.98),(41,5348,1.09669),(41,5349,0.93331),(41,5350,1.00331),(41,5351,1.02669),(41,5352,1.16669),(41,5353,1.02669),(41,5354,1.12),(42,4,0.6666),(42,1078,0.65338),(42,1101,0.37338),(42,1126,0.14),(42,1127,1.02669),(42,1128,1.19),(42,1184,1.16655),(42,1187,2.73),(42,1188,3.08007),(42,1189,0.69993),(42,1214,0.28),(42,1217,0.18669),(42,1371,0.84),(42,1378,0.74662),(42,1390,0.69993),(42,1397,0.91),(42,1402,0.84),(42,1405,0.32669),(42,1455,0.42),(42,1466,0.23331),(42,2134,0.46655),(42,2154,0.46655),(42,2155,0.79331),(42,2189,0.32669),(42,2199,0.93324),(42,2202,2.87007),(42,2203,3.15),(42,2824,0.46669),(42,2825,1.09669),(42,2826,1.30669),(42,2827,0.42),(42,2828,0.98),(42,2829,1.14331),(42,2830,1.26),(42,2847,0.74662),(42,2863,0.23331),(42,2877,0.65338),(42,2888,0.37331),(42,2896,0.32669),(42,2924,0.37331),(42,2929,0.23331),(42,4429,0.86331),(42,4596,0.37331),(42,4605,0.84),(42,4904,2.24),(42,5085,1.05),(42,5086,1.14331),(42,5087,1.00331),(42,5088,1.07331),(42,5089,0.98),(42,5090,1.16669),(42,5091,0.86331),(42,5092,0.98),(42,5093,0.88669),(42,5094,1.00331),(42,5095,1.02669),(42,5096,1.23669),(42,5097,0.95669),(42,5098,1.07331),(42,5099,0.91),(42,5100,1.02669),(42,5101,0.98),(42,5102,1.12),(42,5103,1.02669),(42,5104,1.19),(42,5105,1.05),(42,5106,0.86331),(42,5107,1.12),(42,5156,0.98),(42,5157,1.14331),(42,5158,1.00331),(42,5159,1.09669),(42,5160,1.02669),(42,5161,1.09669),(42,5162,1.05),(42,5163,1.26),(42,5164,1.12),(42,5165,1.16669),(42,5166,1.07331),(42,5167,0.91),(42,5168,1.12),(42,5169,1.00331),(42,5170,1.14331),(42,5171,1.21331),(42,5172,1.35331),(42,5173,1.09669),(42,5174,1.26),(42,5175,1.05),(42,5176,1.14331),(42,5177,0.88669),(42,5178,1.02669),(42,5184,0.91),(42,5185,1.00331),(42,5186,0.88669),(42,5187,0.95669),(42,5188,0.98),(42,5189,1.05),(42,5190,0.93331),(42,5191,1.07331),(42,5192,0.84),(42,5193,1.05),(42,5194,0.91),(42,5195,0.86331),(42,5196,0.98),(42,5197,0.88669),(42,5198,1.07331),(42,5199,0.91),(42,5200,1.00331),(42,5201,0.98),(42,5202,1.21331),(42,5203,0.98),(42,5204,1.09669),(42,5205,0.93331),(42,5206,1.12),(42,5318,2.05338),(42,5319,1.16669),(42,5320,1.16669),(42,5321,1.14331),(42,5322,1.33),(42,5323,1.14331),(42,5324,1.37669),(42,5325,0.98),(42,5326,1.09669),(42,5327,1.16669),(42,5328,1.4),(42,5329,1.14331),(42,5330,1.37669),(42,5331,1.12),(42,5332,1.21331),(42,5333,0.98),(42,5334,1.14331),(42,5335,1.05),(42,5336,1.21331),(42,5337,0.93331),(42,5338,1.09669),(42,5339,0.98),(42,5340,1.14331),(42,5341,1.12),(42,5342,1.26),(42,5343,1.09669),(42,5344,1.21331),(42,5345,1.02669),(42,5346,1.23669),(42,5347,0.98),(42,5348,1.09669),(42,5349,0.93331),(42,5350,1.00331),(42,5351,1.02669),(42,5352,1.16669),(42,5353,1.02669),(42,5354,1.12),(42,5496,0.74),(43,4,0.6666),(43,1134,0.32669),(43,1461,0.18669),(43,2154,0.18662),(43,2206,0.18662),(43,4000,0.67983),(43,4023,1.11993),(43,4026,3.29007),(43,4036,0.88669),(43,4100,0.32669),(43,4110,0.42),(43,5561,0.32669),(43,5562,0.98),(43,5563,1.07331),(43,5564,0.18669),(43,5565,0.86331),(43,5566,0.95669),(43,5567,0.95669),(43,5568,1.05),(43,5575,0.95669),(43,5576,1.02669),(43,5577,0.51331),(43,5578,1.09669),(43,5579,1.16669),(43,5588,4.98652),(43,5589,1.00331),(43,5590,4.93321),(43,5591,0.93331),(43,5592,1.00331),(43,5593,0.14),(43,5594,0.86331),(43,5595,1.05),(43,5596,0.98),(43,5597,1.09669),(43,5598,0.88669),(43,5599,0.95669),(43,5600,0.37331),(43,5601,1.00331),(43,5602,1.21331),(43,5603,0.32669),(43,5604,0.93331),(43,5605,1.02669),(43,5606,2.28662),(43,5607,1.19),(43,5608,0.81669),(43,5609,0.91),(43,5610,0.93331),(43,5611,0.18669),(43,5612,0.91),(43,5613,1.12),(43,5646,1.09669),(43,5647,1.16669),(43,5648,1.09669),(43,5649,1.26),(43,5650,0.37331),(43,5651,1.19),(43,5652,1.37669),(44,4,0.6666),(44,1078,0.98007),(44,1101,0.37338),(44,1126,0.28),(44,1127,2.05338),(44,1128,2.38),(44,1184,0.23331),(44,1189,1.39986),(44,1214,0.28),(44,1217,0.56007),(44,1371,0.42),(44,1378,0.74662),(44,1390,0.46662),(44,1402,0.42),(44,1455,1.68),(44,1466,0.23331),(44,2134,0.18662),(44,2154,0.09331),(44,2189,0.32669),(44,2196,0.37331),(44,2199,1.23321),(44,2824,0.93338),(44,2825,2.19338),(44,2826,2.61338),(44,2827,0.84),(44,2828,1.96),(44,2829,2.28662),(44,2863,0.46662),(44,2877,0.98007),(44,2888,0.37331),(44,4596,0.37331),(44,4605,1.68),(44,4789,1.82),(44,4790,2.1),(44,4793,4.38676),(44,4794,4.94676),(44,4817,2.00662),(44,4818,2.33338),(44,4827,1.82),(44,4828,2.1),(44,4904,0.56),(44,4905,1.14331),(44,4906,1.23669),(44,4911,1.91338),(44,4912,2.28662),(44,4923,1.14331),(44,4924,1.23669),(44,5811,0.93331),(44,5812,1.16669),(44,5813,1.05),(44,5814,1.19),(44,5815,1.02669),(44,5816,1.09669),(44,5817,0.98),(44,5818,1.12),(44,5819,1.82),(44,5820,2.05338),(44,5821,0.93331),(44,5822,1.00331),(44,5823,0.91),(44,5824,1.19),(44,5825,2.87007),(44,5826,3.15),(44,5849,0.98),(44,5850,1.16669),(44,5851,1.02669),(44,5852,1.19),(44,5853,1.05),(44,5854,1.26),(44,5855,1.05),(44,5856,1.19),(44,5857,1.02669),(44,5858,1.16669),(44,5859,1.05),(44,5860,1.14331),(44,5861,1.12),(44,5862,1.21331),(44,5863,1.07331),(44,5864,1.19),(44,5865,1.00331),(44,5866,1.16669),(44,5867,0.93331),(44,5868,1.05),(44,5869,1.05),(44,5870,1.16669),(44,5871,0.98),(44,5872,1.16669),(44,5930,1.02669),(44,5931,1.21331),(44,5932,1.02669),(44,5933,1.19),(44,5934,3.21993),(44,5935,3.57),(44,5936,0.98),(44,5937,1.02669),(44,5938,1.00331),(44,5939,1.19),(44,5940,1.07331),(44,5941,1.23669),(45,4,0.6666),(45,1442,0.42),(45,1449,0.37338),(45,1450,0.86331),(45,2171,0.84),(45,2206,0.37324),(45,2207,0.79331),(45,2921,0.74662),(45,4020,0.42),(45,6117,0.37331),(45,6118,1.02669),(45,6119,1.14331),(45,6120,0.37331),(45,6121,0.98),(45,6122,1.16669),(45,6123,0.84),(45,6124,1.05),(45,6125,1.19),(45,6126,1.14331),(45,6127,1.30669),(45,6128,0.51331),(45,6129,1.07331),(45,6130,1.23669),(45,6131,0.42),(45,6132,1.02669),(45,6133,1.23669),(45,6134,0.46669),(45,6135,1.12),(45,6136,1.19),(45,6137,0.42),(45,6138,1.00331),(45,6139,1.12),(45,6167,0.46669),(45,6168,1.12),(45,6169,1.21331),(45,6170,0.51331),(45,6171,1.05),(45,6172,1.14331),(45,6173,1.00331),(45,6174,1.09669),(45,6175,0.95669),(45,6176,1.16669),(45,6177,0.91),(45,6178,1.00331),(45,6179,0.84),(45,6180,1.00331),(45,6181,1.19),(45,6182,1.14331),(45,6183,1.4),(45,6184,0.91),(45,6185,1.07331),(45,6186,0.98),(45,6187,0.37331),(45,6188,0.98),(45,6189,1.12),(45,6190,0.23331),(45,6191,1.07331),(45,6192,1.26),(45,6222,1.02669),(45,6223,1.26),(45,6224,1.21331),(45,6225,1.37669),(45,6226,0.42),(45,6227,1.23669),(45,6228,1.4),(45,6229,0.46669),(45,6230,1.07331),(45,6231,1.16669),(45,6232,0.51331),(45,6233,1.07331),(45,6234,1.35331),(45,6235,0.51331),(45,6236,1.30669),(45,6237,1.4),(45,6238,1.02669),(45,6239,1.28331),(45,6240,0.42),(45,6241,1.00331),(45,6242,1.23669),(45,6243,0.91),(45,6244,0.98),(45,6245,1.05),(45,6246,0.98),(45,6247,1.05),(45,6248,0.86331),(45,6249,0.93331),(45,6344,0.32669),(45,6345,0.98),(45,6346,1.05),(45,6347,0.32669),(45,6348,1.00331),(45,6349,1.09669),(45,6350,0.46662),(45,6351,0.91),(45,6352,1.19),(45,6353,0.95669),(45,6354,1.12),(45,6355,0.56),(45,6356,1.14331),(45,6357,1.4),(45,6358,0.95669),(45,6359,1.23669),(45,6360,1.00331),(45,6361,1.23669),(45,6362,1.40007),(45,6363,1.00331),(45,6364,1.14331),(45,6365,1.09669),(45,6366,1.30669),(45,6367,1.07331),(45,6368,1.23669),(46,4,0.6666),(46,58,0.72),(46,62,1.88004),(46,1078,0.32669),(46,1101,0.74676),(46,1121,0.42),(46,1184,0.23331),(46,1189,0.46662),(46,1214,0.56),(46,1215,0.86331),(46,1217,0.37338),(46,1371,1.68),(46,1378,0.37331),(46,1402,0.42),(46,1455,0.84),(46,2126,0.98007),(46,2134,0.74648),(46,2149,0.84),(46,2154,0.46655),(46,2155,0.79331),(46,2163,0.86331),(46,2189,0.65338),(46,2196,0.37331),(46,2199,0.69993),(46,2830,0.42),(46,2847,0.74662),(46,2863,0.23331),(46,2888,0.74662),(46,2896,0.65338),(46,2915,0.46662),(46,2924,0.37331),(46,4023,0.37331),(46,4596,1.86655),(46,4605,0.42),(46,4827,0.91),(46,4904,2.8),(46,4909,0.88669),(46,5089,0.98),(46,5188,0.98),(46,6656,1.05),(46,6657,1.12),(46,6658,0.42),(46,6659,1.07331),(46,6660,1.30669),(46,6661,1.16669),(46,6662,0.93331),(46,6663,1.00331),(46,6664,1.09669),(46,6665,1.21331),(46,6666,1.07331),(46,6667,1.14331),(46,6668,1.02669),(46,6669,1.09669),(46,6670,1.05),(46,6671,1.21331),(46,6672,1.05),(46,6673,1.16669),(46,6674,0.86331),(46,6675,0.95669),(46,6676,0.88669),(46,6677,0.98),(46,6678,0.98),(46,6679,1.00331),(46,6680,1.21331),(46,6681,1.77338),(46,6682,1.00331),(46,6683,1.05),(46,6750,1.14331),(46,6751,1.26),(46,6752,1.00331),(46,6753,1.16669),(46,6754,1.02669),(46,6755,1.16669),(46,6756,1.00331),(46,6757,1.12),(46,6758,1.00331),(46,6759,1.14331),(46,6760,1.19),(46,6761,1.4),(46,6762,1.07331),(46,6763,1.12),(46,6764,1.07331),(46,6765,1.21331),(46,6775,0.98),(46,6776,1.21331),(46,6777,0.93331),(46,6778,1.12),(46,6779,1.05),(46,6780,1.19),(46,6781,0.93331),(46,6782,1.00331),(46,6783,1.21331),(46,6784,0.98),(46,6785,1.09669),(46,6786,1.02669),(46,6787,0.95669),(46,6788,1.16669),(46,6789,1.72662),(46,6790,1.00331),(46,6791,1.02669),(46,6792,0.91),(46,6793,0.98),(46,6794,0.98),(46,6795,1.14331),(46,6796,1.02669),(46,6797,1.21331),(46,6798,0.51331),(46,6799,1.14331),(46,6800,1.19),(46,6801,0.91),(46,6802,0.88669),(46,6803,1.07331),(46,6804,1.09669),(46,6805,0.91),(46,6806,1.05),(46,6807,0.98),(46,6808,1.19),(46,6809,1.00331),(46,6810,1.14331),(46,6811,0.98),(46,6812,1.12),(46,6813,1.02669),(46,6814,1.19),(46,6815,1.12),(46,6816,1.19),(46,6817,0.93331),(46,6818,1.00331),(46,6819,0.93331),(46,6820,1.16669),(46,6821,0.93331),(46,6822,1.00331),(46,6996,1.05),(46,6997,1.28331),(46,6998,1.14331),(46,6999,1.26),(46,7000,1.07331),(46,7001,1.30669),(46,7002,1.09669),(46,7003,1.23669),(46,7004,1.23669),(46,7005,1.4),(46,7006,1.05),(46,7007,1.14331),(46,7008,1.05),(46,7009,1.16669),(46,7010,2.00662),(46,7011,1.12),(46,7012,1.19),(46,7013,1.09669),(46,7014,1.21331),(46,7015,1.02669),(46,7016,1.19),(46,7017,1.07331),(46,7018,1.26),(46,7019,1.02669),(46,7020,1.16669),(46,7021,1.02669),(46,7022,1.19),(46,7023,1.4),(46,7024,1.02669),(46,7025,1.14331),(46,7026,1.12),(46,7027,1.23669),(46,7028,0.93331),(46,7029,1.02669),(46,7030,0.95669),(46,7031,1.07331),(46,7032,0.56),(46,7033,1.16669),(46,7034,1.21331),(46,7035,1.12),(46,7036,1.28331),(46,7037,0.98),(46,7038,1.12),(46,7039,0.42),(46,7040,1.00331),(46,7041,1.30669),(46,7042,1.00331),(46,7043,1.12),(47,4,0.6666),(47,58,0.72),(47,62,1.88004),(47,1078,0.32669),(47,1101,0.74676),(47,1121,0.42),(47,1184,0.46662),(47,1187,0.91),(47,1188,1.02669),(47,1189,0.46662),(47,1214,0.56),(47,1215,0.86331),(47,1217,0.37338),(47,1371,1.68),(47,1378,0.37331),(47,1402,0.42),(47,1455,0.84),(47,2126,0.98007),(47,2134,0.9331),(47,2149,0.84),(47,2154,0.37324),(47,2163,0.86331),(47,2189,0.65338),(47,2196,0.37331),(47,2199,0.93324),(47,2202,0.95669),(47,2203,1.05),(47,2830,0.42),(47,2847,1.11993),(47,2863,0.23331),(47,2888,0.74662),(47,2896,0.65338),(47,2915,0.46662),(47,2924,0.74662),(47,4596,1.86655),(47,4605,0.42),(47,4827,0.91),(47,4904,2.8),(47,4909,0.88669),(47,5089,0.98),(47,5188,0.98),(47,6656,1.05),(47,6657,1.12),(47,6661,1.16669),(47,6662,0.93331),(47,6663,1.00331),(47,6664,1.09669),(47,6665,1.21331),(47,6666,1.07331),(47,6667,1.14331),(47,6668,1.02669),(47,6669,1.09669),(47,6670,1.05),(47,6671,1.21331),(47,6672,1.05),(47,6673,1.16669),(47,6674,0.86331),(47,6675,0.95669),(47,6676,0.88669),(47,6677,0.98),(47,6678,0.98),(47,6679,1.00331),(47,6680,1.21331),(47,6681,1.77338),(47,6682,1.00331),(47,6683,1.05),(47,6750,1.14331),(47,6751,1.26),(47,6752,1.00331),(47,6753,1.16669),(47,6754,1.02669),(47,6755,1.16669),(47,6756,1.00331),(47,6757,1.12),(47,6758,1.00331),(47,6759,1.14331),(47,6760,1.19),(47,6761,1.4),(47,6762,1.07331),(47,6763,1.12),(47,6764,1.07331),(47,6765,1.21331),(47,6775,0.98),(47,6776,1.21331),(47,6777,0.93331),(47,6778,1.12),(47,6779,1.05),(47,6780,1.19),(47,6781,0.93331),(47,6782,1.00331),(47,6783,1.21331),(47,6784,0.98),(47,6785,1.09669),(47,6786,1.02669),(47,6787,0.95669),(47,6788,1.16669),(47,6789,1.72662),(47,6790,1.00331),(47,6791,1.02669),(47,6792,0.91),(47,6793,0.98),(47,6794,0.98),(47,6795,1.14331),(47,6796,1.02669),(47,6797,1.21331),(47,6802,0.88669),(47,6803,1.07331),(47,6804,1.09669),(47,6805,0.91),(47,6806,1.05),(47,6807,0.98),(47,6808,1.19),(47,6809,1.00331),(47,6810,1.14331),(47,6811,0.98),(47,6812,1.12),(47,6813,1.02669),(47,6814,1.19),(47,6817,0.93331),(47,6818,1.00331),(47,6819,0.93331),(47,6820,1.16669),(47,6821,0.93331),(47,6822,1.00331),(47,6996,1.05),(47,6997,1.28331),(47,6998,1.14331),(47,6999,1.26),(47,7000,1.07331),(47,7001,1.30669),(47,7002,1.09669),(47,7003,1.23669),(47,7004,1.23669),(47,7005,1.4),(47,7006,1.05),(47,7007,1.14331),(47,7008,1.05),(47,7009,1.16669),(47,7010,2.00662),(47,7011,1.12),(47,7012,1.19),(47,7013,1.09669),(47,7014,1.21331),(47,7015,1.02669),(47,7016,1.19),(47,7017,1.07331),(47,7018,1.26),(47,7019,1.02669),(47,7020,1.16669),(47,7021,1.02669),(47,7022,1.19),(47,7023,1.4),(47,7024,1.02669),(47,7025,1.14331),(47,7026,1.12),(47,7027,1.23669),(47,7028,0.93331),(47,7029,1.02669),(47,7030,0.95669),(47,7031,1.07331),(47,7035,1.12),(47,7036,1.28331),(47,7037,0.98),(47,7038,1.12),(47,7042,1.00331),(47,7043,1.12),(47,7260,1.02669),(47,7261,1.30669),(47,7269,0.86331),(47,7270,0.98),(47,7271,0.95669),(47,7272,1.02669),(47,7291,1.00331),(47,7292,1.12),(47,7293,0.95669),(47,7294,1.07331),(48,4,0.6666),(48,58,0.72),(48,62,1.88004),(48,1078,0.32669),(48,1101,0.74676),(48,1121,0.42),(48,1184,0.46662),(48,1187,0.91),(48,1188,1.02669),(48,1189,0.46662),(48,1214,0.56),(48,1215,0.86331),(48,1217,0.37338),(48,1371,1.68),(48,1378,0.37331),(48,1402,0.42),(48,1455,0.84),(48,2126,0.98007),(48,2134,0.9331),(48,2149,0.84),(48,2154,0.37324),(48,2163,0.86331),(48,2189,0.65338),(48,2196,0.37331),(48,2199,0.93324),(48,2202,0.95669),(48,2203,1.05),(48,2830,0.42),(48,2847,1.11993),(48,2863,0.23331),(48,2888,0.74662),(48,2896,0.65338),(48,2915,0.46662),(48,2924,0.74662),(48,4596,1.86655),(48,4605,0.42),(48,4827,0.91),(48,4904,2.8),(48,4909,0.88669),(48,5089,0.98),(48,5188,0.98),(48,6656,1.05),(48,6657,1.12),(48,6661,1.16669),(48,6662,0.93331),(48,6663,1.00331),(48,6664,1.09669),(48,6665,1.21331),(48,6666,1.07331),(48,6667,1.14331),(48,6668,1.02669),(48,6669,1.09669),(48,6670,1.05),(48,6671,1.21331),(48,6672,1.05),(48,6673,1.16669),(48,6674,0.86331),(48,6675,0.95669),(48,6676,0.88669),(48,6677,0.98),(48,6678,0.98),(48,6679,1.00331),(48,6680,1.21331),(48,6681,1.77338),(48,6682,1.00331),(48,6683,1.05),(48,6750,1.14331),(48,6751,1.26),(48,6752,1.00331),(48,6753,1.16669),(48,6754,1.02669),(48,6755,1.16669),(48,6756,1.00331),(48,6757,1.12),(48,6758,1.00331),(48,6759,1.14331),(48,6760,1.19),(48,6761,1.4),(48,6762,1.07331),(48,6763,1.12),(48,6764,1.07331),(48,6765,1.21331),(48,6775,0.98),(48,6776,1.21331),(48,6777,0.93331),(48,6778,1.12),(48,6779,1.05),(48,6780,1.19),(48,6781,0.93331),(48,6782,1.00331),(48,6783,1.21331),(48,6784,0.98),(48,6785,1.09669),(48,6786,1.02669),(48,6787,0.95669),(48,6788,1.16669),(48,6789,1.72662),(48,6790,1.00331),(48,6791,1.02669),(48,6792,0.91),(48,6793,0.98),(48,6794,0.98),(48,6795,1.14331),(48,6796,1.02669),(48,6797,1.21331),(48,6802,0.88669),(48,6803,1.07331),(48,6804,1.09669),(48,6805,0.91),(48,6806,1.05),(48,6807,0.98),(48,6808,1.19),(48,6809,1.00331),(48,6810,1.14331),(48,6811,0.98),(48,6812,1.12),(48,6813,1.02669),(48,6814,1.19),(48,6817,0.93331),(48,6818,1.00331),(48,6819,0.93331),(48,6820,1.16669),(48,6821,0.93331),(48,6822,1.00331),(48,6996,1.05),(48,6997,1.28331),(48,6998,1.14331),(48,6999,1.26),(48,7000,1.07331),(48,7001,1.30669),(48,7002,1.09669),(48,7003,1.23669),(48,7004,1.23669),(48,7005,1.4),(48,7006,1.05),(48,7007,1.14331),(48,7008,1.05),(48,7009,1.16669),(48,7010,2.00662),(48,7011,1.12),(48,7012,1.19),(48,7013,1.09669),(48,7014,1.21331),(48,7015,1.02669),(48,7016,1.19),(48,7017,1.07331),(48,7018,1.26),(48,7019,1.02669),(48,7020,1.16669),(48,7021,1.02669),(48,7022,1.19),(48,7023,1.4),(48,7024,1.02669),(48,7025,1.14331),(48,7026,1.12),(48,7027,1.23669),(48,7028,0.93331),(48,7029,1.02669),(48,7030,0.95669),(48,7031,1.07331),(48,7035,1.12),(48,7036,1.28331),(48,7037,0.98),(48,7038,1.12),(48,7042,1.00331),(48,7043,1.12),(48,7260,1.02669),(48,7261,1.30669),(48,7269,0.86331),(48,7270,0.98),(48,7271,0.95669),(48,7272,1.02669),(48,7291,1.00331),(48,7292,1.12),(48,7293,0.95669),(48,7294,1.07331),(49,4,0.6666),(49,58,0.72),(49,62,1.88004),(49,1078,0.65338),(49,1101,0.93345),(49,1184,0.46662),(49,1214,0.7),(49,1215,1.72662),(49,1217,0.18669),(49,1371,2.1),(49,1378,0.74662),(49,1455,0.84),(49,2126,1.63345),(49,2134,0.74648),(49,2149,0.84),(49,2154,0.27993),(49,2189,1.30676),(49,2199,1.16655),(49,2230,0.09331),(49,2847,1.49324),(49,2863,0.46662),(49,2888,0.74662),(49,2896,1.30676),(49,2915,0.46662),(49,2924,0.37331),(49,4010,1.68),(49,4596,1.86655),(49,4605,0.42),(49,4827,0.91),(49,4904,2.8),(49,4909,1.77338),(49,5089,1.96),(49,5188,0.98),(49,6656,2.1),(49,6657,2.24),(49,6661,2.33338),(49,6662,0.93331),(49,6663,1.00331),(49,6664,2.19338),(49,6665,2.42662),(49,6668,2.05338),(49,6669,2.19338),(49,6674,1.72662),(49,6675,1.91338),(49,6676,0.88669),(49,6677,0.98),(49,6678,1.96),(49,6681,0.88669),(49,6682,1.00331),(49,6750,1.14331),(49,6751,1.26),(49,6752,2.00662),(49,6753,2.33338),(49,6754,2.05338),(49,6755,2.33338),(49,6758,2.00662),(49,6759,2.28662),(49,6762,1.07331),(49,6763,1.12),(49,6764,1.07331),(49,6765,1.21331),(49,6775,1.96),(49,6776,2.42662),(49,6777,0.93331),(49,6778,1.12),(49,6779,2.1),(49,6780,2.38),(49,6781,0.93331),(49,6782,1.00331),(49,6783,1.21331),(49,6784,1.96),(49,6785,2.19338),(49,6786,1.02669),(49,6787,0.95669),(49,6788,1.16669),(49,6789,1.72662),(49,6791,2.05338),(49,6796,2.05338),(49,6797,2.42662),(49,6805,0.91),(49,6806,1.05),(49,6809,2.00662),(49,6810,2.28662),(49,6811,1.96),(49,6812,2.24),(49,6817,1.86662),(49,6818,2.00662),(49,6819,1.86662),(49,6820,2.33338),(49,6821,0.93331),(49,6822,1.00331),(49,6996,2.1),(49,6997,2.56662),(49,7002,2.19338),(49,7003,2.47338),(49,7004,1.23669),(49,7005,1.4),(49,7008,1.05),(49,7009,1.16669),(49,7010,2.00662),(49,7011,2.24),(49,7013,1.09669),(49,7014,1.21331),(49,7017,2.14662),(49,7018,2.52),(49,7019,2.05338),(49,7020,2.33338),(49,7021,2.05338),(49,7022,1.19),(49,7023,1.4),(49,7024,2.05338),(49,7025,2.28662),(49,7028,1.86662),(49,7029,2.05338),(49,7030,1.91338),(49,7031,2.14662),(49,7037,1.96),(49,7038,2.24),(49,7042,1.00331),(49,7043,1.12),(49,7340,0.23331),(49,7341,0.88669),(49,7342,0.98),(49,7346,0.28),(49,7347,0.91),(49,7348,1.05),(49,7349,0.32669),(49,7350,0.95669),(49,7351,1.12),(49,7363,1.54686),(49,7364,5.86652),(49,7365,7.18652),(49,7366,0.88669),(49,7367,1.07331),(49,7368,0.93331),(49,7369,1.02669),(49,7370,0.95669),(49,7371,0.95669),(49,7372,0.84),(49,7373,1.05),(49,7386,0.23331),(49,7387,0.91),(49,7388,1.05),(49,7389,0.51331),(49,7390,1.02669),(49,7391,1.23669),(50,4,0.6666),(50,58,2.22),(50,65,0.80004),(50,66,1.83996),(50,1078,0.32669),(50,1101,1.12014),(50,1184,0.23331),(50,1189,0.46662),(50,1214,0.56),(50,1215,0.86331),(50,1217,0.37338),(50,1371,2.52),(50,1378,0.37331),(50,1402,0.84),(50,1455,1.68),(50,2126,1.30676),(50,2134,1.11972),(50,2149,0.42),(50,2154,0.55986),(50,2163,1.72662),(50,2189,0.65338),(50,2196,0.74662),(50,2199,0.93324),(50,2206,0.27993),(50,2847,0.74662),(50,2863,0.23331),(50,2888,0.37331),(50,2896,0.65338),(50,2915,0.69993),(50,2924,0.74662),(50,4038,0.14),(50,4596,3.35979),(50,4605,0.84),(50,4827,1.82),(50,4904,4.48),(50,4909,0.88669),(50,5089,0.98),(50,5188,1.96),(50,6656,1.05),(50,6657,1.12),(50,6661,1.16669),(50,6662,1.86662),(50,6663,2.00662),(50,6664,1.09669),(50,6665,1.21331),(50,6668,1.02669),(50,6669,1.09669),(50,6672,2.1),(50,6673,2.33338),(50,6674,0.86331),(50,6675,0.95669),(50,6676,1.77338),(50,6677,1.96),(50,6678,0.98),(50,6681,1.77338),(50,6682,2.00662),(50,6750,2.28662),(50,6751,2.52),(50,6752,1.00331),(50,6753,1.16669),(50,6754,1.02669),(50,6755,1.16669),(50,6756,2.00662),(50,6757,2.24),(50,6758,1.00331),(50,6759,1.14331),(50,6760,2.38),(50,6761,2.8),(50,6762,2.14662),(50,6763,2.24),(50,6764,2.14662),(50,6765,2.42662),(50,6775,0.98),(50,6776,1.21331),(50,6777,1.86662),(50,6778,2.24),(50,6779,1.05),(50,6780,1.19),(50,6781,1.86662),(50,6782,2.00662),(50,6783,2.42662),(50,6784,0.98),(50,6785,1.09669),(50,6786,2.05338),(50,6787,1.91338),(50,6788,2.33338),(50,6789,2.58993),(50,6790,2.00662),(50,6791,1.02669),(50,6796,1.02669),(50,6797,1.21331),(50,6804,2.19338),(50,6805,1.82),(50,6806,2.1),(50,6807,1.96),(50,6808,2.38),(50,6809,1.00331),(50,6810,1.14331),(50,6811,0.98),(50,6812,1.12),(50,6813,2.05338),(50,6814,2.38),(50,6817,0.93331),(50,6818,1.00331),(50,6819,0.93331),(50,6820,1.16669),(50,6821,1.86662),(50,6822,2.00662),(50,6996,1.05),(50,6997,1.28331),(50,6998,2.28662),(50,6999,2.52),(50,7000,2.14662),(50,7001,2.61338),(50,7002,1.09669),(50,7003,1.23669),(50,7004,2.47338),(50,7005,2.8),(50,7006,2.1),(50,7007,2.28662),(50,7008,2.1),(50,7009,2.33338),(50,7010,3.00993),(50,7011,1.12),(50,7012,2.38),(50,7013,2.19338),(50,7014,2.42662),(50,7017,1.07331),(50,7018,1.26),(50,7019,1.02669),(50,7020,1.16669),(50,7021,1.02669),(50,7022,2.38),(50,7023,1.4),(50,7024,1.02669),(50,7025,1.14331),(50,7028,0.93331),(50,7029,1.02669),(50,7030,0.95669),(50,7031,1.07331),(50,7035,2.24),(50,7036,2.56662),(50,7037,0.98),(50,7038,1.12),(50,7042,2.00662),(50,7043,2.24),(50,7260,2.05338),(50,7261,2.61338),(50,7386,0.23331),(50,7454,0.32669),(50,7455,1.19),(50,7456,1.23669),(50,7457,5.79679),(50,7458,0.18669),(50,7459,0.93331),(50,7460,0.46669),(50,7461,1.00331),(50,7462,1.05),(50,7463,1.00331),(50,7464,1.07331),(50,7465,0.84),(50,7466,0.88669),(50,7467,0.91),(50,7468,1.00331),(50,7469,0.93331),(50,7470,1.00331),(50,7483,0.37331),(50,7484,0.95669),(50,7485,1.00331),(50,7486,0.46669),(50,7487,1.05),(50,7488,1.14331),(50,7489,0.51331),(50,7490,1.02669),(50,7491,1.26),(51,4,0.6666),(51,58,0.42),(51,65,0.80004),(51,66,1.83996),(51,1078,0.32669),(51,1101,0.74676),(51,1121,0.42),(51,1184,0.23331),(51,1189,0.46662),(51,1214,0.56),(51,1215,0.86331),(51,1217,0.37338),(51,1371,1.68),(51,1378,0.37331),(51,1402,0.42),(51,1442,0.28),(51,1455,0.84),(51,2126,0.98007),(51,2134,0.74648),(51,2149,0.84),(51,2154,0.46655),(51,2163,0.86331),(51,2189,0.65338),(51,2196,0.37331),(51,2199,0.69993),(51,2206,0.27993),(51,2217,0.81669),(51,2230,0.09331),(51,2819,0.18669),(51,2820,0.86331),(51,2823,0.95669),(51,2830,0.42),(51,2847,0.74662),(51,2863,0.23331),(51,2888,0.74662),(51,2896,0.65338),(51,2915,0.46662),(51,2924,0.37331),(51,3967,0.98679),(51,4294,0.42),(51,4596,1.86655),(51,4605,0.42),(51,4827,0.91),(51,4904,2.8),(51,4909,0.88669),(51,5089,0.98),(51,5188,0.98),(51,6656,1.05),(51,6657,1.12),(51,6658,2.22),(51,6661,1.16669),(51,6662,0.93331),(51,6663,1.00331),(51,6664,1.09669),(51,6665,1.21331),(51,6666,1.07331),(51,6667,1.14331),(51,6668,1.02669),(51,6669,1.09669),(51,6670,1.05),(51,6671,1.21331),(51,6672,1.05),(51,6673,1.16669),(51,6674,0.86331),(51,6675,0.95669),(51,6676,0.88669),(51,6677,0.98),(51,6678,0.98),(51,6679,1.00331),(51,6680,1.21331),(51,6681,1.77338),(51,6682,1.00331),(51,6683,1.05),(51,6750,1.14331),(51,6751,1.26),(51,6752,1.00331),(51,6753,1.16669),(51,6754,1.02669),(51,6755,1.16669),(51,6756,1.00331),(51,6757,1.12),(51,6758,1.00331),(51,6759,1.14331),(51,6760,1.19),(51,6761,1.4),(51,6762,1.07331),(51,6763,1.12),(51,6764,1.07331),(51,6765,1.21331),(51,6775,0.98),(51,6776,1.21331),(51,6777,0.93331),(51,6778,1.12),(51,6779,1.05),(51,6780,1.19),(51,6781,0.93331),(51,6782,1.00331),(51,6783,1.21331),(51,6784,0.98),(51,6785,1.09669),(51,6786,1.02669),(51,6787,0.95669),(51,6788,1.16669),(51,6789,1.72662),(51,6790,1.00331),(51,6791,1.02669),(51,6792,0.91),(51,6793,0.98),(51,6794,0.98),(51,6795,1.14331),(51,6796,1.02669),(51,6797,1.21331),(51,6802,0.88669),(51,6803,1.07331),(51,6804,1.09669),(51,6805,0.91),(51,6806,1.05),(51,6807,0.98),(51,6808,1.19),(51,6809,1.00331),(51,6810,1.14331),(51,6811,0.98),(51,6812,1.12),(51,6813,1.02669),(51,6814,1.19),(51,6817,0.93331),(51,6818,1.00331),(51,6819,0.93331),(51,6820,1.16669),(51,6821,0.93331),(51,6822,1.00331),(51,6996,1.05),(51,6997,1.28331),(51,6998,1.14331),(51,6999,1.26),(51,7000,1.07331),(51,7001,1.30669),(51,7002,1.09669),(51,7003,1.23669),(51,7004,1.23669),(51,7005,1.4),(51,7006,1.05),(51,7007,1.14331),(51,7008,1.05),(51,7009,1.16669),(51,7010,2.00662),(51,7011,1.12),(51,7012,1.19),(51,7013,1.09669),(51,7014,1.21331),(51,7015,1.02669),(51,7016,1.19),(51,7017,1.07331),(51,7018,1.26),(51,7019,1.02669),(51,7020,1.16669),(51,7021,1.02669),(51,7022,1.19),(51,7023,1.4),(51,7024,1.02669),(51,7025,1.14331),(51,7026,1.12),(51,7027,1.23669),(51,7028,0.93331),(51,7029,1.02669),(51,7030,0.95669),(51,7031,1.07331),(51,7035,1.12),(51,7036,1.28331),(51,7037,0.98),(51,7038,1.12),(51,7042,1.00331),(51,7043,1.12),(51,7260,1.02669),(51,7261,1.30669),(51,7584,0.46669),(51,7585,1.14331),(51,7586,1.21331),(51,7587,0.37331),(51,7588,1.05),(51,7589,1.23669),(51,7590,6.04321),(51,7603,1.12),(51,7604,1.21331),(51,7605,0.42),(51,7606,1.16669),(51,7607,1.4),(51,7608,0.18669),(51,7609,1.02669),(51,7610,1.14331),(51,7611,0.86331),(51,7612,0.95669),(51,7613,1.00331),(51,7614,1.16669),(51,7615,5.42679),(51,7616,6.66),(51,7617,0.32669),(51,7627,1.02669),(51,7628,1.09669),(51,7629,0.93331),(51,7630,1.12),(51,7631,0.42),(51,7632,1.07331),(51,7633,1.30669),(51,7634,1.05),(51,7635,1.02669),(51,7636,1.09669),(51,7637,0.84),(51,7638,1.02669),(51,7639,0.88669),(51,7640,0.95669),(51,7676,0.32669),(51,7677,1.07331),(51,7678,1.30669),(51,7679,0.37331),(51,7680,0.95669),(51,7681,1.16669),(52,4,0.6666),(52,65,0.80004),(52,66,1.83996),(52,1078,0.65338),(52,1101,1.12014),(52,1184,0.46662),(52,1189,0.23331),(52,1214,0.7),(52,1215,1.72662),(52,1217,0.18669),(52,1371,2.94),(52,1378,0.74662),(52,1402,0.42),(52,1442,0.14),(52,1455,0.84),(52,2126,1.96014),(52,2134,0.83979),(52,2149,0.84),(52,2154,0.27993),(52,2163,0.86331),(52,2189,1.63345),(52,2196,0.37331),(52,2199,1.16655),(52,2847,1.86655),(52,2863,0.46662),(52,2888,0.74662),(52,2896,1.30676),(52,2915,0.69993),(52,2924,0.37331),(52,4596,2.23986),(52,4605,0.42),(52,4827,0.91),(52,4904,4.48),(52,4909,1.77338),(52,5089,1.96),(52,5188,0.98),(52,6656,2.1),(52,6657,2.24),(52,6661,2.33338),(52,6662,0.93331),(52,6663,1.00331),(52,6664,2.19338),(52,6665,2.42662),(52,6668,2.05338),(52,6669,2.19338),(52,6672,1.05),(52,6673,1.16669),(52,6674,1.72662),(52,6675,1.91338),(52,6676,0.88669),(52,6677,0.98),(52,6678,1.96),(52,6681,0.88669),(52,6682,1.00331),(52,6750,1.14331),(52,6751,1.26),(52,6752,3.00993),(52,6753,3.50007),(52,6754,2.05338),(52,6755,2.33338),(52,6756,1.00331),(52,6757,1.12),(52,6758,2.00662),(52,6759,2.28662),(52,6760,1.19),(52,6761,1.4),(52,6762,1.07331),(52,6763,1.12),(52,6764,1.07331),(52,6765,1.21331),(52,6775,1.96),(52,6776,2.42662),(52,6777,0.93331),(52,6778,1.12),(52,6779,3.15),(52,6780,3.57),(52,6781,0.93331),(52,6782,1.00331),(52,6783,1.21331),(52,6784,1.96),(52,6785,2.19338),(52,6786,1.02669),(52,6787,0.95669),(52,6788,1.16669),(52,6789,2.58993),(52,6790,1.00331),(52,6791,2.05338),(52,6796,2.05338),(52,6797,2.42662),(52,6804,1.09669),(52,6805,0.91),(52,6806,1.05),(52,6807,0.98),(52,6808,1.19),(52,6809,3.00993),(52,6810,3.42993),(52,6811,1.96),(52,6812,2.24),(52,6813,1.02669),(52,6814,1.19),(52,6817,1.86662),(52,6818,2.00662),(52,6819,1.86662),(52,6820,2.33338),(52,6821,0.93331),(52,6822,1.00331),(52,6996,3.15),(52,6997,3.84993),(52,6998,1.14331),(52,6999,1.26),(52,7000,1.07331),(52,7001,1.30669),(52,7002,2.19338),(52,7003,2.47338),(52,7004,1.23669),(52,7005,1.4),(52,7006,1.05),(52,7007,1.14331),(52,7008,1.05),(52,7009,1.16669),(52,7010,3.00993),(52,7011,2.24),(52,7013,1.09669),(52,7014,1.21331),(52,7017,3.21993),(52,7018,3.78),(52,7019,2.05338),(52,7020,2.33338),(52,7021,2.05338),(52,7022,1.19),(52,7023,1.4),(52,7024,2.05338),(52,7025,2.28662),(52,7028,1.86662),(52,7029,2.05338),(52,7030,1.91338),(52,7031,2.14662),(52,7035,1.12),(52,7036,1.28331),(52,7037,1.96),(52,7038,2.24),(52,7042,1.00331),(52,7043,1.12),(52,7260,1.02669),(52,7261,1.30669),(52,7779,0.84),(52,7780,1.00331),(52,7803,0.37331),(52,7804,1.02669),(52,7805,1.14331),(53,4,0.6666),(53,65,0.80004),(53,66,1.83996),(53,1101,1.12014),(53,1189,0.69993),(53,1214,0.42),(53,1217,0.56007),(53,1371,2.94),(53,1402,1.26),(53,1455,2.52),(53,2126,0.98007),(53,2134,1.39965),(53,2154,1.02641),(53,2163,3.45324),(53,2196,1.11993),(53,2199,0.69993),(53,2230,0.09331),(53,2915,0.69993),(53,2924,1.11993),(53,4010,0.84),(53,4596,4.47972),(53,4605,1.26),(53,4827,2.73),(53,4904,5.04),(53,5188,2.94),(53,6662,2.79993),(53,6663,3.00993),(53,6672,3.15),(53,6673,3.50007),(53,6676,2.66007),(53,6677,2.94),(53,6681,2.66007),(53,6682,3.00993),(53,6750,3.42993),(53,6751,3.78),(53,6756,4.01324),(53,6757,4.48),(53,6760,3.57),(53,6761,4.2),(53,6762,3.21993),(53,6763,3.36),(53,6764,3.21993),(53,6765,3.63993),(53,6777,2.79993),(53,6778,3.36),(53,6781,2.79993),(53,6782,3.00993),(53,6783,3.63993),(53,6786,3.08007),(53,6787,2.87007),(53,6788,3.50007),(53,6789,2.58993),(53,6790,3.00993),(53,6804,3.29007),(53,6805,2.73),(53,6806,3.15),(53,6807,2.94),(53,6808,3.57),(53,6813,3.08007),(53,6814,3.57),(53,6821,2.79993),(53,6822,3.00993),(53,6998,3.42993),(53,6999,3.78),(53,7000,3.21993),(53,7001,3.92007),(53,7004,3.71007),(53,7005,4.2),(53,7006,3.15),(53,7007,3.42993),(53,7008,3.15),(53,7009,3.50007),(53,7010,3.00993),(53,7012,3.57),(53,7013,3.29007),(53,7014,3.63993),(53,7022,3.57),(53,7023,4.2),(53,7035,3.36),(53,7036,3.84993),(53,7042,3.00993),(53,7043,3.36),(53,7260,3.08007),(53,7261,3.92007),(53,7844,0.28),(53,7845,0.98),(53,7846,1.26),(53,7860,0.95669),(53,7861,0.88669),(53,7862,1.00331),(53,7863,0.23331),(53,7864,1.07331),(53,7865,1.19),(54,4,0.6666),(54,1121,0.84),(54,1179,0.09331),(54,1184,0.46662),(54,1187,1.82),(54,1188,2.05338),(54,1189,0.46662),(54,1214,0.28),(54,1217,0.37338),(54,1442,0.14),(54,2134,0.65317),(54,2149,1.26),(54,2154,0.37324),(54,2199,0.46662),(54,2202,1.91338),(54,2203,2.1),(54,2206,0.58652),(54,2230,0.27993),(54,2231,0.81669),(54,2830,1.26),(54,2847,1.11993),(54,2888,0.74662),(54,2924,0.74662),(54,3967,0.18669),(54,6350,0.23331),(54,6355,0.56),(54,6666,2.14662),(54,6667,2.28662),(54,6670,2.1),(54,6671,2.42662),(54,6679,2.00662),(54,6680,2.42662),(54,6681,1.77338),(54,6683,2.1),(54,6792,2.73),(54,6793,2.94),(54,6794,2.94),(54,6795,3.42993),(54,6802,1.77338),(54,6803,2.14662),(54,7015,3.08007),(54,7016,3.57),(54,7026,2.24),(54,7027,2.47338),(54,7269,1.72662),(54,7270,1.96),(54,7271,1.91338),(54,7272,2.05338),(54,7291,3.00993),(54,7292,3.36),(54,7293,1.91338),(54,7294,2.14662),(54,7803,0.37331),(54,7939,0.37331),(54,7940,1.00331),(54,7941,1.23669),(54,7942,0.46669),(54,7943,1.00331),(54,7944,1.14331),(54,7945,0.86331),(54,7946,0.98),(54,7951,0.37331),(54,7952,1.05),(54,7953,1.21331),(54,7954,1.02669),(54,7955,1.09669),(54,7956,2.46679),(54,7957,0.98),(54,7958,1.21331),(54,7959,0.23331),(54,7960,0.88669),(54,7961,0.98),(54,7967,0.98),(54,7968,1.05),(54,7969,0.88669),(54,7970,0.95669),(54,7971,4.68679),(54,7972,5.05679),(54,7973,0.86331),(54,7974,1.07331),(54,7975,0.84),(54,7976,0.95669),(54,7977,0.95669),(54,7978,1.12),(54,7979,0.93331),(54,7980,0.14),(54,7981,0.93331),(54,7982,1.05),(54,8003,1.02669),(54,8004,1.09669),(54,8005,0.18669),(54,8006,0.91),(54,8007,1.02669),(54,8008,0.88669),(54,8009,1.00331),(54,8010,0.46669),(54,8011,1.00331),(54,8012,1.21331),(54,8013,1.07331),(54,8014,1.33),(55,4,0.6666),(55,58,2.22),(55,1121,1.26),(55,1184,0.69993),(55,1187,2.73),(55,1188,3.08007),(55,1189,0.69993),(55,1214,0.42),(55,1217,0.56007),(55,1442,0.14),(55,2134,0.83979),(55,2149,1.26),(55,2154,0.86645),(55,2199,0.69993),(55,2202,2.87007),(55,2203,3.15),(55,2206,0.18662),(55,2217,0.81669),(55,2230,0.09331),(55,2819,0.18669),(55,2820,0.86331),(55,2823,0.95669),(55,2830,1.26),(55,2847,1.11993),(55,2888,1.11993),(55,2924,1.11993),(55,4294,0.42),(55,6666,3.21993),(55,6667,3.42993),(55,6670,3.15),(55,6671,3.63993),(55,6679,3.00993),(55,6680,3.63993),(55,6681,2.66007),(55,6683,3.15),(55,6792,2.73),(55,6793,2.94),(55,6794,2.94),(55,6795,3.42993),(55,6802,2.66007),(55,6803,3.21993),(55,7015,3.08007),(55,7016,3.57),(55,7026,3.36),(55,7027,3.71007),(55,7269,2.58993),(55,7270,2.94),(55,7271,2.87007),(55,7272,3.08007),(55,7291,3.00993),(55,7292,3.36),(55,7293,2.87007),(55,7294,3.21993),(55,7584,0.46669),(55,7585,1.14331),(55,7586,1.21331),(55,7587,0.37331),(55,7588,1.05),(55,7589,1.23669),(55,7611,0.86331),(55,7612,0.95669),(55,7617,0.32669),(55,7627,1.02669),(55,7628,1.09669),(55,7629,0.93331),(55,7630,1.12),(55,7634,1.05),(55,7635,1.02669),(55,7636,1.09669),(55,7639,0.88669),(55,7640,0.95669),(55,7676,0.32669),(55,8096,5.67321),(55,8097,0.95669),(55,8098,5.18),(55,8099,6.04321),(55,8101,1.00331),(55,8102,1.14331),(56,4,0.6666),(56,1121,1.26),(56,1184,0.93324),(56,1187,3.64),(56,1188,4.10676),(56,1189,0.69993),(56,1214,0.42),(56,1217,0.56007),(56,2134,1.02641),(56,2149,1.26),(56,2154,0.27993),(56,2199,0.93324),(56,2202,3.82676),(56,2203,4.2),(56,2830,1.26),(56,2847,1.49324),(56,2888,1.11993),(56,2924,1.49324),(56,6190,1.23321),(56,6666,3.21993),(56,6667,3.42993),(56,6670,3.15),(56,6671,3.63993),(56,6679,3.00993),(56,6680,3.63993),(56,6681,2.66007),(56,6683,3.15),(56,6792,2.73),(56,6793,2.94),(56,6794,2.94),(56,6795,3.42993),(56,6802,2.66007),(56,6803,3.21993),(56,7015,3.08007),(56,7016,3.57),(56,7026,3.36),(56,7027,3.71007),(56,7269,3.45324),(56,7270,3.92),(56,7271,3.82676),(56,7272,4.10676),(56,7291,4.01324),(56,7292,4.48),(56,7293,3.82676),(56,7294,4.29324),(56,8109,5.42679),(56,8110,6.29),(57,4,0.6666),(57,1078,0.65338),(57,1101,0.37338),(57,1121,0.42),(57,1179,0.27993),(57,1184,0.23331),(57,1187,0.91),(57,1188,1.02669),(57,1189,0.23331),(57,1214,0.14),(57,1217,0.18669),(57,1371,0.84),(57,1387,0.18669),(57,1388,0.91),(57,1389,0.98),(57,1449,0.18669),(57,1450,0.86331),(57,2126,1.30676),(57,2134,0.46655),(57,2149,0.42),(57,2154,0.18662),(57,2155,0.79331),(57,2189,0.65338),(57,2199,0.23331),(57,2202,0.95669),(57,2203,1.05),(57,2206,0.09331),(57,2230,0.09331),(57,2237,0.95669),(57,2830,0.42),(57,2847,1.11993),(57,2888,0.37331),(57,2896,0.65338),(57,2915,0.46662),(57,2921,0.37331),(57,2924,0.37331),(57,3931,0.84),(57,4097,0.56),(57,4596,0.74662),(57,4904,1.12),(57,5089,1.96),(57,6656,2.1),(57,6657,2.24),(57,6658,0.84),(57,6659,1.07331),(57,6661,2.33338),(57,6666,1.07331),(57,6667,1.14331),(57,6670,1.05),(57,6671,1.21331),(57,6679,1.00331),(57,6680,1.21331),(57,6681,0.88669),(57,6683,1.05),(57,6752,2.00662),(57,6753,2.33338),(57,6775,1.96),(57,6776,2.42662),(57,6779,2.1),(57,6780,2.38),(57,6789,1.72662),(57,6791,2.05338),(57,6792,0.91),(57,6793,0.98),(57,6794,0.98),(57,6795,1.14331),(57,6802,0.88669),(57,6803,1.07331),(57,6809,2.00662),(57,6810,2.28662),(57,6996,2.1),(57,6997,2.56662),(57,7010,2.00662),(57,7011,2.24),(57,7015,1.02669),(57,7016,1.19),(57,7017,2.14662),(57,7018,2.52),(57,7026,1.12),(57,7027,1.23669),(57,7028,1.86662),(57,7029,2.05338),(57,7032,3.52),(57,7037,1.96),(57,7038,2.24),(57,7269,0.86331),(57,7270,0.98),(57,7271,0.95669),(57,7272,1.02669),(57,7291,1.00331),(57,7292,1.12),(57,7293,0.95669),(57,7294,1.07331),(57,8005,0.18669),(57,8174,0.95669),(57,8175,1.16669),(57,8176,1.14331),(57,8177,0.93331),(57,8178,1.68),(57,8179,0.95669),(57,8180,1.07331),(57,8191,1.05),(57,8203,0.23331),(57,8204,0.88669),(57,8205,1.00331),(57,8206,0.09331),(57,8207,0.84),(57,8208,0.95669),(57,8209,0.98),(57,8210,0.84),(57,8211,1.02669),(57,8212,1.09669),(57,8213,1.02669),(57,8214,1.09669),(57,8215,0.46669),(57,8216,1.00331),(57,8217,1.09669),(57,8218,0.88669),(57,8219,0.98),(57,8220,1.05),(57,8247,0.65338),(57,8248,1.02669),(57,8249,1.26),(57,8250,0.91),(57,8251,1.12),(57,8252,0.86331),(57,8253,0.95669),(57,8254,0.91),(57,8255,1.00331),(57,8256,0.95669),(57,8257,1.07331),(57,8258,6.29),(57,8259,1.07331),(57,8260,1.30669),(57,8261,0.65338),(57,8262,1.96),(57,8263,1.02669),(57,8264,1.07331),(57,8265,0.98),(57,8266,1.07331),(58,4,0.6666),(58,1078,0.65338),(58,1101,1.12014),(58,1110,1.68),(58,1184,0.93324),(58,1187,3.64),(58,1188,4.10676),(58,1189,1.39986),(58,1214,0.56),(58,1217,0.37338),(58,1378,2.23986),(58,1390,0.46662),(58,1402,3.36),(58,1405,0.65338),(58,2134,0.55986),(58,2137,1.82),(58,2154,1.30634),(58,2189,1.30676),(58,2199,0.93324),(58,2202,3.82676),(58,2203,4.2),(58,2811,0.98679),(58,2830,0.84),(58,2847,0.74662),(58,2863,0.93324),(58,2877,1.30676),(58,2896,0.65338),(58,2915,0.46662),(58,2924,1.49324),(58,2929,0.46662),(58,4596,0.74662),(58,4605,0.84),(58,4825,1.72662),(58,4904,3.36),(58,6807,3.92),(58,8405,2.19338),(58,8406,2.56662),(58,8407,2.00662),(58,8408,2.24),(58,8409,1.72662),(58,8410,1.91338),(58,8411,1.82),(58,8412,2.1),(58,8413,1.91338),(58,8414,2.24),(58,8415,1.96),(58,8416,2.24),(58,8417,2.14662),(58,8418,2.33338),(58,8419,2.00662),(58,8420,2.33338),(58,8421,1.96),(58,8422,2.19338),(58,8423,1.82),(58,8424,2.05338),(58,8425,1.77338),(58,8426,2.19338),(58,8427,1.68),(58,8428,1.86662),(58,8429,1.68),(58,8430,1.96),(58,8490,0.74662),(58,8491,2.38),(58,8492,2.70662),(58,8493,0.46662),(58,8494,1.77338),(58,8495,2.1),(58,8496,4.01324),(58,8497,2.14662),(58,8498,2.14662),(58,8499,1.96),(58,8500,2.19338),(58,8501,1.91338),(58,8502,2.33338),(58,8503,2.05338),(58,8504,2.28662),(58,8505,2.05338),(58,8506,2.33338),(58,8507,2.24),(58,8508,2.42662),(58,8509,2.00662),(58,8510,2.24),(58,8511,2.05338),(58,8512,2.14662),(58,8520,1.77338),(58,8521,2.38),(58,8522,2.1),(58,8523,2.28662),(58,8524,1.86662),(58,8525,2.00662),(58,8526,1.72662),(58,8527,1.96),(58,8528,1.68),(58,8529,1.91338),(58,8530,1.91338),(58,8531,2.24),(58,8532,1.91338),(58,8533,2.52),(58,8534,2.24),(58,8535,2.33338),(58,8536,1.82),(58,8537,2.1),(58,8538,2.05338),(58,8539,2.52),(58,8656,4.93321),(58,8657,2.38),(58,8658,2.66),(58,8659,2.19338),(58,8660,2.47338),(58,8661,2.28662),(58,8662,2.70662),(58,8663,2.00662),(58,8664,2.47338),(58,8665,1.96),(58,8666,2.24),(58,8667,2.14662),(58,8668,2.52),(58,8669,1.96),(58,8670,2.28662),(58,8671,2.05338),(58,8672,2.42662),(58,8673,1.96),(58,8674,2.42662),(58,8675,1.96),(58,8676,2.1),(58,8677,1.96),(58,8678,2.19338),(58,8679,2.00662),(58,8680,2.42662),(58,8681,2.00662),(58,8682,2.24),(58,8683,2.14662),(58,8684,2.47338),(58,8685,2.00662),(58,8686,2.14662),(58,8687,2.1),(58,8688,2.33338),(59,4,1.06656),(59,1381,0.64008),(59,8803,1.56),(59,8804,1.71996),(59,8805,0.48),(59,8806,1.64004),(59,8807,1.83996),(59,8813,1.56),(59,8814,1.83996),(59,8817,0.24),(59,8818,1.59996),(59,8819,1.8),(60,4,0.6666),(61,4,0.6666),(62,4,0.6666),(62,1461,0.18669),(62,8845,0.32004),(62,8846,1.64004),(62,8847,1.8),(62,8848,3.81348),(62,8849,0.95669),(62,8850,1.28331),(63,4,0.6666),(63,8854,1.30683),(63,8855,4.37344),(63,8856,1.8),(64,4,0.6666),(65,4,0.6666),(66,4,0.6666),(66,10,0.17),(67,4,0.6666),(68,4,0.6666),(68,1367,2.61317),(68,8881,1.68),(68,8882,2.07996),(69,4,0.6666),(70,4,0.6666),(71,4,1.06656),(71,1381,0.32004),(71,8803,1.56),(71,8804,1.71996),(71,8805,0.48),(71,8806,1.64004),(71,8807,1.83996),(71,8813,1.56),(71,8814,1.83996),(71,8817,0.24),(71,8818,1.59996),(71,8819,1.8),(72,4,0.6666),(72,1179,0.09331),(72,1442,0.14),(72,2154,0.27993),(72,2174,0.18669),(72,2206,0.18662),(72,2207,0.79331),(72,2811,0.18669),(72,3925,0.32669),(72,3926,0.95669),(72,3927,1.07331),(72,3928,0.93338),(72,3929,1.12),(72,3930,1.4),(72,3931,0.84),(72,3932,0.98),(72,3948,0.46669),(72,3949,1.12),(72,3950,1.19),(72,3951,0.18669),(72,3952,0.91),(72,3953,1.00331),(72,3954,0.28),(72,3955,1.00331),(72,3956,1.14331),(72,3957,1.02669),(72,3958,2.16645),(72,3959,0.91),(72,3960,1.16669),(72,3961,0.88669),(72,3962,0.93331),(72,3963,0.98),(72,3964,1.12),(72,3965,1.00331),(72,3966,1.23669),(72,3967,0.18669),(72,3968,0.95669),(72,3969,1.12),(72,4000,0.09331),(72,4001,0.88669),(72,4002,1.00331),(72,4003,0.51331),(72,4004,1.07331),(72,4005,1.16669),(72,4006,1.00331),(72,4007,1.12),(72,4008,0.84),(72,4009,1.05),(72,4010,0.84),(72,4011,0.95669),(72,4012,0.93331),(72,4013,1.09669),(72,4014,0.42),(72,4015,1.02669),(72,4016,1.09669),(72,4017,0.51331),(72,4018,1.16669),(72,4019,1.28331),(72,4020,0.42),(72,4021,0.98),(72,4022,1.09669),(72,4023,1.11993),(72,4024,1.09669),(72,4025,1.16669),(72,4026,2.19338),(72,4027,1.28331),(72,4028,1.33),(72,4029,0.18669),(72,4030,0.93331),(72,4031,1.09669),(72,4032,0.18669),(72,4033,0.88669),(72,4034,1.00331),(72,4035,0.95669),(72,4036,0.88669),(72,4037,1.05),(72,4038,0.28),(72,4039,1.00331),(72,4040,1.16669),(72,4041,0.98),(72,4042,1.09669),(72,4043,0.18669),(72,4044,0.91),(72,4045,1.05),(72,4095,0.86331),(72,4096,1.12),(72,4097,0.28),(72,4098,0.98),(72,4099,1.09669),(72,4100,0.98007),(72,4101,0.98),(72,4102,1.07331),(72,4103,1.09669),(72,4104,1.21331),(72,4105,1.00331),(72,4106,1.09669),(72,4107,0.32669),(72,4108,1.05),(72,4109,1.14331),(72,4110,0.42),(72,4111,1.00331),(72,4112,1.12),(72,8914,4.56321);


--
-- Table structure for table `#__finder_links_terms9`
--



CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms9`
--


INSERT INTO `#__finder_links_terms9` (`link_id`, `term_id`, `weight`) VALUES (16,57,1.97321),(20,86,0.08004),(20,87,1.32),(20,88,1.56),(20,111,0.63996),(20,112,1.71996),(21,86,0.08004),(21,87,1.32),(21,88,1.56),(21,111,0.63996),(21,112,1.71996),(21,121,2.12004),(22,458,0.84),(22,459,2.94),(22,460,3.42993),(22,461,0.56),(22,462,0.88669),(22,463,1.00331),(22,464,2.87007),(22,465,1.07331),(22,466,2.1),(22,467,0.84),(22,468,2.87007),(22,469,3.15),(22,470,1.16655),(22,471,1.82),(22,472,2.19338),(22,473,2.66007),(22,474,2.79993),(22,475,2.28683),(22,476,0.98),(22,477,1.05),(22,478,5.88),(22,479,7.00014),(22,480,1.63317),(22,481,1.91338),(22,482,2.05338),(22,483,2.66007),(22,484,3.00993),(22,485,0.86331),(22,486,0.98),(22,487,1.05),(22,488,1.19),(22,489,4.6669),(22,490,4.10676),(22,491,4.66676),(22,492,1.09669),(22,493,1.23669),(22,494,3.15),(22,495,3.36),(22,496,1.05),(22,497,1.21331),(22,498,1.02662),(22,499,1.12),(22,500,1.33),(22,501,1.07331),(22,502,1.14331),(22,503,1.12),(22,504,0.98),(22,505,1.07331),(22,506,1.12),(22,507,1.28331),(22,508,0.98),(22,509,1.09669),(22,510,0.95669),(22,511,1.02669),(22,512,0.28),(22,513,1.91338),(22,514,1.07331),(22,515,1.05),(22,516,0.46662),(22,517,0.93331),(22,518,1.05),(22,519,1.00331),(22,520,1.09669),(22,521,1.68),(22,522,3.15),(22,523,3.36),(22,524,2.73),(22,525,2.94),(22,526,1.26),(22,527,3.15),(22,528,3.42993),(22,529,0.55986),(22,530,2.87007),(22,531,3.29007),(22,532,2.52),(22,533,3.08007),(22,3500,0.28),(22,3501,1.05),(22,3502,1.21331),(22,3503,0.37331),(22,3504,1.07331),(22,3505,1.21331),(22,3506,2.38),(22,3507,8.39979),(22,3508,9.65979),(22,3509,3.15),(22,3510,3.36),(22,3511,0.88669),(22,3512,1.14331),(22,3513,0.93331),(22,3514,1.02669),(22,3515,2.73),(22,3516,3.42993),(22,3517,1.39986),(22,3518,0.88669),(22,3519,1.00331),(22,3520,3.15),(22,3521,3.63993),(22,3522,0.95669),(22,3523,1.19),(22,3524,0.93331),(22,3525,1.07331),(22,3526,1.68),(22,3527,3.29007),(22,3528,3.84993),(22,3529,1.07331),(22,3530,1.21331),(22,3531,4.6669),(22,3532,10.9198),(22,3533,11.2),(22,3534,1.12),(22,3535,1.28331),(22,3536,0.46662),(22,3537,2.00662),(22,3538,1.12),(22,3539,1.09669),(22,3540,2.09979),(22,3541,3.15),(22,3542,3.57),(22,3543,5.74014),(22,3544,6.43986),(22,3545,1.30676),(22,3546,1.05),(22,3547,1.16669),(22,3548,3.42993),(22,3549,3.71007),(22,3550,1.49324),(22,3551,1.16669),(22,3552,1.37669),(22,3553,1.00331),(22,3554,1.12),(22,3555,1.02669),(22,3556,1.28331),(22,3557,1.09669),(22,3558,1.26),(25,529,0.18662),(25,3869,0.18662),(25,3870,0.86331),(25,3871,0.93331),(25,3872,1.02669),(25,3873,1.14331),(25,3874,0.28),(25,3875,0.98),(25,3876,1.19),(25,3877,0.32669),(25,3878,0.98),(25,3879,1.14331),(25,3880,0.32669),(25,3881,1.00331),(25,3882,1.07331),(25,3883,0.37331),(25,3884,0.95669),(25,3885,1.16669),(25,3886,0.95669),(25,3887,1.07331),(25,3888,0.91),(25,3889,1.14331),(25,4216,0.23331),(25,4217,0.93331),(25,4218,1.05),(25,4219,0.32669),(25,4220,0.98),(25,4221,1.05),(26,529,0.09331),(26,3869,0.09331),(26,4261,0.88669),(26,4262,0.95669),(26,4263,0.81669),(26,4264,0.93331),(27,475,0.98007),(27,3506,0.28),(27,3517,0.23331),(27,3520,1.05),(27,3526,0.42),(27,3531,1.86676),(27,3540,0.23331),(27,3550,1.11993),(27,4399,0.93331),(27,4400,1.00331),(27,4401,1.07331),(27,4402,1.28331),(27,4403,0.95669),(27,4404,1.07331),(27,4689,0.86331),(27,4690,0.98),(27,4691,0.88669),(27,4692,1.07331),(27,4693,1.21331),(27,4694,0.98),(27,4695,1.21331),(27,4696,1.05),(27,4697,1.19),(27,4698,1.02669),(27,4699,1.19),(27,4700,1.16669),(27,4701,1.23669),(27,4702,1.19),(27,4703,1.4),(27,4704,1.00331),(27,4705,1.16669),(27,4706,1.14331),(27,4707,1.35331),(27,4708,0.95669),(27,4709,1.19),(27,4710,0.95669),(27,4711,1.02669),(27,4712,0.42),(27,4713,1.12),(27,4714,1.26),(28,475,0.98007),(28,3506,0.28),(28,3517,0.23331),(28,3520,1.05),(28,3526,0.42),(28,3531,1.86676),(28,3540,0.23331),(28,3550,1.11993),(28,4399,0.93331),(28,4400,1.00331),(28,4401,1.07331),(28,4402,1.28331),(28,4403,0.95669),(28,4404,1.07331),(28,4689,0.86331),(28,4690,0.98),(28,4691,0.88669),(28,4692,1.07331),(28,4693,1.21331),(28,4694,0.98),(28,4695,1.21331),(28,4696,1.05),(28,4697,1.19),(28,4698,1.02669),(28,4699,1.19),(28,4700,1.16669),(28,4701,1.23669),(28,4702,1.19),(28,4703,1.4),(28,4704,1.00331),(28,4705,1.16669),(28,4706,1.14331),(28,4707,1.35331),(28,4708,0.95669),(28,4709,1.19),(28,4710,0.95669),(28,4711,1.02669),(28,4712,0.42),(28,4713,1.12),(28,4714,1.26),(29,475,0.98007),(29,3506,0.28),(29,3517,0.23331),(29,3520,1.05),(29,3526,0.42),(29,3531,1.86676),(29,3540,0.23331),(29,3550,1.11993),(29,4399,0.93331),(29,4400,1.00331),(29,4401,1.07331),(29,4402,1.28331),(29,4403,0.95669),(29,4404,1.07331),(29,4689,0.86331),(29,4690,0.98),(29,4691,0.88669),(29,4692,1.07331),(29,4693,1.21331),(29,4694,0.98),(29,4695,1.21331),(29,4696,1.05),(29,4697,1.19),(29,4698,1.02669),(29,4699,1.19),(29,4700,1.16669),(29,4701,1.23669),(29,4702,1.19),(29,4703,1.4),(29,4704,1.00331),(29,4705,1.16669),(29,4706,1.14331),(29,4707,1.35331),(29,4708,0.95669),(29,4709,1.19),(29,4710,0.95669),(29,4711,1.02669),(29,4712,0.42),(29,4713,1.12),(29,4714,1.26),(30,475,0.98007),(30,3506,0.28),(30,3517,0.23331),(30,3520,1.05),(30,3526,0.42),(30,3531,1.86676),(30,3540,0.23331),(30,3550,1.11993),(30,4399,0.93331),(30,4400,1.00331),(30,4401,1.07331),(30,4402,1.28331),(30,4403,0.95669),(30,4404,1.07331),(30,4689,0.86331),(30,4690,0.98),(30,4691,0.88669),(30,4692,1.07331),(30,4693,1.21331),(30,4694,0.98),(30,4695,1.21331),(30,4696,1.05),(30,4697,1.19),(30,4698,1.02669),(30,4699,1.19),(30,4700,1.16669),(30,4701,1.23669),(30,4702,1.19),(30,4703,1.4),(30,4704,1.00331),(30,4705,1.16669),(30,4706,1.14331),(30,4707,1.35331),(30,4708,0.95669),(30,4709,1.19),(30,4710,0.95669),(30,4711,1.02669),(30,4712,0.42),(30,4713,1.12),(30,4714,1.26),(31,475,0.98007),(31,3506,0.28),(31,3517,0.23331),(31,3520,1.05),(31,3526,0.42),(31,3531,1.86676),(31,3540,0.23331),(31,3550,1.11993),(31,4399,0.93331),(31,4400,1.00331),(31,4401,1.07331),(31,4402,1.28331),(31,4403,0.95669),(31,4404,1.07331),(31,4689,0.86331),(31,4690,0.98),(31,4691,0.88669),(31,4692,1.07331),(31,4693,1.21331),(31,4694,0.98),(31,4695,1.21331),(31,4696,1.05),(31,4697,1.19),(31,4698,1.02669),(31,4699,1.19),(31,4700,1.16669),(31,4701,1.23669),(31,4702,1.19),(31,4703,1.4),(31,4704,1.00331),(31,4705,1.16669),(31,4706,1.14331),(31,4707,1.35331),(31,4708,0.95669),(31,4709,1.19),(31,4710,0.95669),(31,4711,1.02669),(31,4712,0.42),(31,4713,1.12),(31,4714,1.26),(32,475,0.98007),(32,3506,0.28),(32,3517,0.23331),(32,3520,1.05),(32,3526,0.42),(32,3531,1.86676),(32,3540,0.23331),(32,3550,1.11993),(32,4399,0.93331),(32,4400,1.00331),(32,4401,1.07331),(32,4402,1.28331),(32,4403,0.95669),(32,4404,1.07331),(32,4689,0.86331),(32,4690,0.98),(32,4691,0.88669),(32,4692,1.07331),(32,4693,1.21331),(32,4694,0.98),(32,4695,1.21331),(32,4696,1.05),(32,4697,1.19),(32,4698,1.02669),(32,4699,1.19),(32,4700,1.16669),(32,4701,1.23669),(32,4702,1.19),(32,4703,1.4),(32,4704,1.00331),(32,4705,1.16669),(32,4706,1.14331),(32,4707,1.35331),(32,4708,0.95669),(32,4709,1.19),(32,4710,0.95669),(32,4711,1.02669),(32,4712,0.42),(32,4713,1.12),(32,4714,1.26),(33,475,0.98007),(33,3506,0.28),(33,3517,0.23331),(33,3520,1.05),(33,3526,0.42),(33,3531,1.86676),(33,3540,0.23331),(33,3550,1.11993),(33,4399,0.93331),(33,4400,1.00331),(33,4401,1.07331),(33,4402,1.28331),(33,4403,0.95669),(33,4404,1.07331),(33,4689,0.86331),(33,4690,0.98),(33,4691,0.88669),(33,4692,1.07331),(33,4693,1.21331),(33,4694,0.98),(33,4695,1.21331),(33,4696,1.05),(33,4697,1.19),(33,4698,1.02669),(33,4699,1.19),(33,4700,1.16669),(33,4701,1.23669),(33,4702,1.19),(33,4703,1.4),(33,4704,1.00331),(33,4705,1.16669),(33,4706,1.14331),(33,4707,1.35331),(33,4708,0.95669),(33,4709,1.19),(33,4710,0.95669),(33,4711,1.02669),(33,4712,0.42),(33,4713,1.12),(33,4714,1.26),(33,4730,0.98679),(34,475,0.98007),(34,3506,0.28),(34,3517,0.23331),(34,3520,1.05),(34,3526,0.42),(34,3531,1.86676),(34,3540,0.23331),(34,3550,1.11993),(34,4399,0.93331),(34,4400,1.00331),(34,4401,1.07331),(34,4402,1.28331),(34,4403,0.95669),(34,4404,1.07331),(34,4689,0.86331),(34,4690,0.98),(34,4691,0.88669),(34,4692,1.07331),(34,4693,1.21331),(34,4694,0.98),(34,4695,1.21331),(34,4696,1.05),(34,4697,1.19),(34,4698,1.02669),(34,4699,1.19),(34,4700,1.16669),(34,4701,1.23669),(34,4702,1.19),(34,4703,1.4),(34,4704,1.00331),(34,4705,1.16669),(34,4706,1.14331),(34,4707,1.35331),(34,4708,0.95669),(34,4709,1.19),(34,4710,0.95669),(34,4711,1.02669),(34,4712,0.42),(34,4713,1.12),(34,4714,1.26),(35,475,0.98007),(35,3506,0.28),(35,3517,0.23331),(35,3520,1.05),(35,3526,0.42),(35,3531,1.86676),(35,3540,0.23331),(35,3550,1.11993),(35,4399,0.93331),(35,4400,1.00331),(35,4401,1.07331),(35,4402,1.28331),(35,4403,0.95669),(35,4404,1.07331),(35,4689,0.86331),(35,4690,0.98),(35,4691,0.88669),(35,4692,1.07331),(35,4693,1.21331),(35,4694,0.98),(35,4695,1.21331),(35,4696,1.05),(35,4697,1.19),(35,4698,1.02669),(35,4699,1.19),(35,4700,1.16669),(35,4701,1.23669),(35,4702,1.19),(35,4703,1.4),(35,4704,1.00331),(35,4705,1.16669),(35,4706,1.14331),(35,4707,1.35331),(35,4708,0.95669),(35,4709,1.19),(35,4710,0.95669),(35,4711,1.02669),(35,4712,0.42),(35,4713,1.12),(35,4714,1.26),(36,529,0.09331),(36,3869,0.09331),(36,4261,0.88669),(36,4262,0.95669),(36,4263,0.81669),(36,4264,0.93331),(37,529,0.09331),(37,3869,0.09331),(37,4261,0.88669),(37,4262,0.95669),(37,4263,0.81669),(37,4264,0.93331),(38,529,0.09331),(38,3869,0.09331),(38,4261,0.88669),(38,4262,0.95669),(38,4263,0.81669),(38,4264,0.93331),(39,475,1.63345),(39,3500,0.28),(39,3506,0.28),(39,3526,0.42),(39,3531,1.86676),(39,4702,1.19),(39,4762,0.23331),(39,4763,1.02669),(39,4764,1.14331),(39,4765,0.42),(39,4766,0.98),(39,4767,1.14331),(39,4768,0.37331),(39,4769,1.02669),(39,4770,1.12),(39,4771,0.95669),(39,4772,1.07331),(39,4773,4.10676),(39,4774,5.04),(39,4987,2.22),(39,4988,1.02669),(39,4989,1.12),(39,4990,1.68),(39,4991,1.86662),(39,4992,1.16669),(39,4993,1.4),(39,4994,1.00331),(39,4995,1.12),(39,4996,2.00662),(39,4997,2.33338),(39,4998,1.26),(40,475,0.32669),(40,476,0.98),(40,3503,1.11993),(40,3506,0.7),(40,3526,0.42),(40,3531,0.46669),(40,3540,0.46662),(40,3545,0.65338),(40,3550,1.11993),(40,4768,0.37331),(40,5066,0.98),(40,5067,1.12),(40,5068,1.02669),(40,5454,0.95669),(40,5455,1.02669),(40,5456,1.02669),(40,5457,1.33),(40,5458,0.95669),(40,5459,1.19),(40,5460,0.91),(40,5461,1.07331),(40,5462,0.86331),(40,5463,1.00331),(40,5464,0.98),(40,5465,1.14331),(40,5466,1.00331),(40,5467,1.07331),(40,5468,0.93331),(40,5469,1.07331),(40,5470,1.02669),(40,5471,1.21331),(40,5472,1.05),(40,5473,1.21331),(40,5474,1.05),(40,5475,1.19),(40,5476,0.91),(40,5477,1.09669),(40,5478,1.07331),(40,5479,1.28331),(40,5480,0.95669),(40,5481,1.09669),(40,5482,0.32669),(40,5483,0.95669),(40,5484,1.05),(40,5485,1.05),(40,5486,1.26),(40,5487,0.98),(40,5488,1.16669),(40,5489,1.12),(40,5490,1.26),(41,475,0.32669),(41,476,0.98),(41,3503,1.11993),(41,3506,0.7),(41,3526,0.42),(41,3531,0.46669),(41,3540,0.46662),(41,3545,0.65338),(41,3550,1.11993),(41,4768,0.37331),(41,5066,0.98),(41,5067,1.12),(41,5068,1.02669),(41,5454,0.95669),(41,5455,1.02669),(41,5456,1.02669),(41,5457,1.33),(41,5458,0.95669),(41,5459,1.19),(41,5460,0.91),(41,5461,1.07331),(41,5462,0.86331),(41,5463,1.00331),(41,5464,0.98),(41,5465,1.14331),(41,5466,1.00331),(41,5467,1.07331),(41,5468,0.93331),(41,5469,1.07331),(41,5470,1.02669),(41,5471,1.21331),(41,5472,1.05),(41,5473,1.21331),(41,5474,1.05),(41,5475,1.19),(41,5476,0.91),(41,5477,1.09669),(41,5478,1.07331),(41,5479,1.28331),(41,5480,0.95669),(41,5481,1.09669),(41,5482,0.32669),(41,5483,0.95669),(41,5484,1.05),(41,5485,1.05),(41,5486,1.26),(41,5487,0.98),(41,5488,1.16669),(41,5489,1.12),(41,5490,1.26),(42,475,0.32669),(42,476,0.98),(42,3503,1.11993),(42,3506,0.7),(42,3526,0.42),(42,3531,0.46669),(42,3540,0.46662),(42,3545,0.65338),(42,3550,1.11993),(42,4768,0.37331),(42,5066,0.98),(42,5067,1.12),(42,5068,1.02669),(42,5454,0.95669),(42,5455,1.02669),(42,5456,1.02669),(42,5457,1.33),(42,5458,0.95669),(42,5459,1.19),(42,5460,0.91),(42,5461,1.07331),(42,5462,0.86331),(42,5463,1.00331),(42,5464,0.98),(42,5465,1.14331),(42,5466,1.00331),(42,5467,1.07331),(42,5468,0.93331),(42,5469,1.07331),(42,5470,1.02669),(42,5471,1.21331),(42,5472,1.05),(42,5473,1.21331),(42,5474,1.05),(42,5475,1.19),(42,5476,0.91),(42,5477,1.09669),(42,5478,1.07331),(42,5479,1.28331),(42,5480,0.95669),(42,5481,1.09669),(42,5482,0.32669),(42,5483,0.95669),(42,5484,1.05),(42,5485,1.05),(42,5486,1.26),(42,5487,0.98),(42,5488,1.16669),(42,5489,1.12),(42,5490,1.26),(43,461,0.28),(43,529,0.09331),(43,3869,0.09331),(43,3880,0.65338),(43,5533,0.84),(43,5534,0.98),(43,5535,0.95669),(43,5536,1.19),(43,5537,0.86331),(43,5538,1.00331),(43,5539,1.09669),(43,5540,1.16669),(43,5541,0.93331),(43,5542,1.05),(43,5543,0.28),(43,5544,0.84),(43,5545,0.93331),(43,5546,0.91),(43,5547,0.98),(43,5548,0.86331),(43,5549,0.93331),(44,475,0.98007),(44,3500,0.56),(44,3506,0.42),(44,3517,0.23331),(44,3526,0.84),(44,3531,1.40007),(44,3540,0.23331),(44,3545,0.32669),(44,4771,1.91338),(44,4772,2.14662),(44,4773,1.02669),(44,4774,1.26),(44,4988,2.05338),(44,4989,2.24),(44,4990,0.84),(44,4991,0.93331),(44,4992,1.16669),(44,4996,2.00662),(44,4997,2.33338),(44,5965,0.91),(44,5966,1.09669),(44,5967,1.05),(44,5968,1.16669),(44,5969,1.00331),(44,5970,1.14331),(44,5971,1.09669),(44,5972,1.28331),(44,5973,1.28331),(44,5974,1.05),(44,5975,1.21331),(44,5976,0.93331),(44,5977,1.09669),(44,5978,1.07331),(44,5979,1.21331),(45,467,0.28),(45,529,0.18662),(45,6062,0.32669),(45,6063,0.95669),(45,6064,1.05),(45,6065,0.18669),(45,6066,0.98),(45,6067,1.09669),(45,6068,1.05),(45,6069,1.14331),(45,6070,0.23331),(45,6071,0.91),(45,6072,1.14331),(45,6073,0.28),(45,6074,0.93331),(45,6075,1.19),(45,6076,0.79331),(45,6077,1.02669),(45,6078,1.07331),(45,6079,1.14331),(45,6478,0.32669),(45,6479,0.93331),(45,6480,1.12),(46,57,3.09314),(46,475,0.98007),(46,3500,0.28),(46,3503,0.37331),(46,3506,0.98),(46,3517,0.46662),(46,3531,0.93338),(46,3540,0.69993),(46,3545,0.32669),(46,3550,0.37331),(46,4712,1.26),(46,5482,0.32669),(46,5487,0.98),(46,6065,0.37338),(46,6613,0.98),(46,6614,1.19),(46,6615,1.00331),(46,6616,1.12),(46,6617,1.07331),(46,6618,1.23669),(46,6619,1.00331),(46,6620,1.12),(46,6621,0.98),(46,6622,1.07331),(46,6623,6.04321),(46,6624,1.09669),(46,6625,1.23669),(46,6626,1.09669),(46,6627,1.16669),(46,6628,1.02669),(46,6629,1.14331),(46,7177,0.56),(46,7178,2.14662),(46,7179,2.61338),(46,7180,0.91),(46,7181,1.07331),(46,7182,0.95669),(46,7183,1.26),(46,7184,0.88669),(46,7185,1.00331),(46,7186,0.88669),(46,7187,1.02669),(46,7188,0.86331),(46,7189,0.98),(46,7190,0.88669),(46,7191,1.00331),(46,7192,0.86331),(46,7193,0.93331),(46,7194,0.93331),(46,7195,1.05),(46,7196,0.93331),(46,7197,1.05),(46,7198,0.93331),(46,7199,1.21331),(46,7200,0.95669),(46,7201,1.14331),(46,7202,1.12),(46,7203,1.26),(46,7204,1.02669),(46,7205,1.12),(46,7206,0.95669),(46,7207,1.07331),(46,7208,1.00331),(46,7209,1.21331),(46,7210,0.98),(46,7211,1.02669),(46,7212,1.21331),(46,7213,1.09669),(46,7214,1.19),(46,7215,1.19),(46,7216,1.02669),(46,7217,1.09669),(46,7218,1.07331),(46,7219,1.19),(46,7220,1.12),(46,7221,1.26),(47,475,0.98007),(47,3500,0.56),(47,3503,0.37331),(47,3506,0.98),(47,3517,0.46662),(47,3531,1.86676),(47,3540,0.69993),(47,3545,0.32669),(47,3550,0.37331),(47,4698,1.02669),(47,4712,1.26),(47,4996,1.00331),(47,5482,0.32669),(47,5487,0.98),(47,6617,1.07331),(47,6618,1.23669),(47,6619,1.00331),(47,6620,1.12),(47,6621,0.98),(47,6622,1.07331),(47,7180,0.91),(47,7181,1.07331),(47,7182,0.95669),(47,7183,1.26),(47,7184,0.88669),(47,7185,1.00331),(47,7186,0.88669),(47,7187,1.02669),(47,7188,0.86331),(47,7189,0.98),(47,7190,0.88669),(47,7191,1.00331),(47,7192,0.86331),(47,7193,0.93331),(47,7194,0.93331),(47,7195,1.05),(47,7196,0.93331),(47,7197,1.05),(47,7198,0.93331),(47,7199,1.21331),(47,7200,0.95669),(47,7201,1.14331),(47,7202,1.12),(47,7203,1.26),(47,7204,1.02669),(47,7205,1.12),(47,7206,0.95669),(47,7207,1.07331),(47,7208,1.00331),(47,7209,1.21331),(47,7211,1.02669),(47,7212,1.21331),(47,7213,1.09669),(47,7214,1.19),(47,7215,1.19),(47,7216,1.02669),(47,7217,1.09669),(47,7218,1.07331),(47,7219,1.19),(47,7220,1.12),(47,7221,1.26),(47,7299,0.91),(47,7300,1.07331),(47,7301,1.21331),(47,7302,1.14331),(48,475,0.98007),(48,3500,0.56),(48,3503,0.37331),(48,3506,0.98),(48,3517,0.46662),(48,3531,1.86676),(48,3540,0.69993),(48,3545,0.32669),(48,3550,0.37331),(48,4698,1.02669),(48,4712,1.26),(48,4996,1.00331),(48,5482,0.32669),(48,5487,0.98),(48,6617,1.07331),(48,6618,1.23669),(48,6619,1.00331),(48,6620,1.12),(48,6621,0.98),(48,6622,1.07331),(48,7180,0.91),(48,7181,1.07331),(48,7182,0.95669),(48,7183,1.26),(48,7184,0.88669),(48,7185,1.00331),(48,7186,0.88669),(48,7187,1.02669),(48,7188,0.86331),(48,7189,0.98),(48,7190,0.88669),(48,7191,1.00331),(48,7192,0.86331),(48,7193,0.93331),(48,7194,0.93331),(48,7195,1.05),(48,7196,0.93331),(48,7197,1.05),(48,7198,0.93331),(48,7199,1.21331),(48,7200,0.95669),(48,7201,1.14331),(48,7202,1.12),(48,7203,1.26),(48,7204,1.02669),(48,7205,1.12),(48,7206,0.95669),(48,7207,1.07331),(48,7208,1.00331),(48,7209,1.21331),(48,7211,1.02669),(48,7212,1.21331),(48,7213,1.09669),(48,7214,1.19),(48,7215,1.19),(48,7216,1.02669),(48,7217,1.09669),(48,7218,1.07331),(48,7219,1.19),(48,7220,1.12),(48,7221,1.26),(48,7299,0.91),(48,7300,1.07331),(48,7301,1.21331),(48,7302,1.14331),(49,57,2.34652),(49,475,1.63345),(49,3500,0.56),(49,3503,0.74662),(49,3506,0.7),(49,3517,0.46662),(49,3531,1.40007),(49,3540,0.69993),(49,3545,0.65338),(49,3550,0.74662),(49,4712,0.42),(49,5487,1.96),(49,6617,2.14662),(49,6618,2.47338),(49,6619,1.00331),(49,6620,1.12),(49,6621,1.96),(49,6622,2.14662),(49,7180,1.82),(49,7181,2.14662),(49,7182,1.91338),(49,7183,2.52),(49,7184,1.77338),(49,7185,2.00662),(49,7186,0.88669),(49,7187,1.02669),(49,7188,0.86331),(49,7189,0.98),(49,7196,0.93331),(49,7197,1.05),(49,7200,1.91338),(49,7201,2.28662),(49,7202,1.12),(49,7203,1.26),(49,7204,2.05338),(49,7205,2.24),(49,7206,0.95669),(49,7207,1.07331),(49,7208,2.00662),(49,7209,2.42662),(49,7211,2.05338),(49,7212,2.42662),(49,7215,2.38),(49,7218,1.07331),(49,7219,1.19),(49,7326,0.18669),(49,7327,0.86331),(49,7328,0.98),(49,7329,0.23331),(49,7330,0.88669),(49,7331,1.12),(49,7332,0.28),(49,7333,0.93331),(49,7334,1.05),(49,7335,0.95669),(49,7336,1.05),(50,57,0.74662),(50,475,1.30676),(50,3500,0.28),(50,3503,0.37331),(50,3506,1.26),(50,3517,0.69993),(50,3531,1.40007),(50,3540,1.16655),(50,3545,0.32669),(50,3550,0.37331),(50,4712,1.68),(50,5482,0.65338),(50,5487,0.98),(50,6617,1.07331),(50,6618,1.23669),(50,6619,2.00662),(50,6620,2.24),(50,6621,0.98),(50,6622,1.07331),(50,7180,0.91),(50,7181,1.07331),(50,7182,0.95669),(50,7183,1.26),(50,7184,0.88669),(50,7185,1.00331),(50,7186,1.77338),(50,7187,2.05338),(50,7188,1.72662),(50,7189,1.96),(50,7190,1.77338),(50,7191,2.00662),(50,7196,1.86662),(50,7197,2.1),(50,7198,1.86662),(50,7199,2.42662),(50,7200,0.95669),(50,7201,1.14331),(50,7202,2.24),(50,7203,2.52),(50,7204,1.02669),(50,7205,1.12),(50,7206,1.91338),(50,7207,2.14662),(50,7208,1.00331),(50,7209,1.21331),(50,7210,1.96),(50,7211,1.02669),(50,7212,1.21331),(50,7213,2.19338),(50,7214,2.38),(50,7215,1.19),(50,7216,2.05338),(50,7217,2.19338),(50,7218,2.14662),(50,7219,2.38),(50,7446,2.05338),(50,7447,2.19338),(50,7523,1.12),(51,57,2.23986),(51,475,0.98007),(51,3500,0.28),(51,3503,0.37331),(51,3506,0.98),(51,3517,0.46662),(51,3531,0.93338),(51,3540,0.69993),(51,3545,0.32669),(51,3550,0.37331),(51,4712,1.26),(51,5482,0.32669),(51,5487,0.98),(51,6617,1.07331),(51,6618,1.23669),(51,6619,1.00331),(51,6620,1.12),(51,6621,0.98),(51,6622,1.07331),(51,7180,0.91),(51,7181,1.07331),(51,7182,0.95669),(51,7183,1.26),(51,7184,0.88669),(51,7185,1.00331),(51,7186,0.88669),(51,7187,1.02669),(51,7188,0.86331),(51,7189,0.98),(51,7190,0.88669),(51,7191,1.00331),(51,7192,0.86331),(51,7193,0.93331),(51,7194,0.93331),(51,7195,1.05),(51,7196,0.93331),(51,7197,1.05),(51,7198,0.93331),(51,7199,1.21331),(51,7200,0.95669),(51,7201,1.14331),(51,7202,1.12),(51,7203,1.26),(51,7204,1.02669),(51,7205,1.12),(51,7206,0.95669),(51,7207,1.07331),(51,7208,1.00331),(51,7209,1.21331),(51,7210,0.98),(51,7211,1.02669),(51,7212,1.21331),(51,7213,1.09669),(51,7214,1.19),(51,7215,1.19),(51,7216,1.02669),(51,7217,1.09669),(51,7218,1.07331),(51,7219,1.19),(51,7220,1.12),(51,7221,1.26),(51,7541,0.14),(51,7542,0.84),(51,7543,0.93331),(51,7544,2.14662),(51,7545,1.19),(51,7546,1.16669),(51,7547,1.12),(51,7548,1.33),(51,7549,1.07331),(51,7550,1.02669),(51,7551,1.35331),(51,7552,1.05),(51,7553,1.16669),(51,7554,0.46669),(51,7555,1.19),(51,7556,1.33),(51,7741,0.28),(51,7742,1.07331),(51,7743,1.33),(52,475,1.63345),(52,3500,0.56),(52,3503,0.74662),(52,3506,0.84),(52,3517,0.69993),(52,3531,1.40007),(52,3540,0.93324),(52,3545,0.65338),(52,3550,0.74662),(52,4712,0.84),(52,5482,0.32669),(52,5487,1.96),(52,6065,0.18669),(52,6073,0.28),(52,6074,0.93331),(52,6617,2.14662),(52,6618,2.47338),(52,6619,1.00331),(52,6620,1.12),(52,6621,1.96),(52,6622,2.14662),(52,7180,1.82),(52,7181,2.14662),(52,7182,1.91338),(52,7183,2.52),(52,7184,1.77338),(52,7185,2.00662),(52,7186,0.88669),(52,7187,1.02669),(52,7188,0.86331),(52,7189,0.98),(52,7190,0.88669),(52,7191,1.00331),(52,7196,0.93331),(52,7197,1.05),(52,7198,0.93331),(52,7199,1.21331),(52,7200,1.91338),(52,7201,2.28662),(52,7202,1.12),(52,7203,1.26),(52,7204,2.05338),(52,7205,2.24),(52,7206,0.95669),(52,7207,1.07331),(52,7208,2.00662),(52,7209,2.42662),(52,7210,0.98),(52,7211,2.05338),(52,7212,2.42662),(52,7213,1.09669),(52,7214,1.19),(52,7215,2.38),(52,7216,1.02669),(52,7217,1.09669),(52,7218,1.07331),(52,7219,1.19),(52,7776,0.98),(52,7777,1.07331),(52,7778,1.14331),(52,7824,0.23331),(52,7825,0.93331),(52,7826,1.07331),(53,57,0.37331),(53,475,0.98007),(53,3506,1.68),(53,3517,0.93324),(53,3531,1.40007),(53,3540,1.39986),(53,4712,2.52),(53,5482,1.30676),(53,6619,3.00993),(53,6620,3.36),(53,7186,2.66007),(53,7187,3.08007),(53,7188,2.58993),(53,7189,2.94),(53,7190,2.66007),(53,7191,3.00993),(53,7196,2.79993),(53,7197,3.15),(53,7198,3.73324),(53,7199,4.85324),(53,7202,3.36),(53,7203,3.78),(53,7206,2.87007),(53,7207,3.21993),(53,7210,2.94),(53,7213,4.38676),(53,7214,4.76),(53,7216,3.08007),(53,7217,3.29007),(53,7218,3.21993),(53,7219,3.57),(53,7835,0.23331),(53,7836,0.88669),(53,7837,0.98),(53,7838,1.14331),(53,7839,1.28331),(53,7886,2.14662),(54,57,2.34652),(54,529,0.09331),(54,3500,0.84),(54,3506,0.7),(54,3531,1.86676),(54,3869,0.18662),(54,3870,0.86331),(54,3871,0.93331),(54,4698,2.05338),(54,4712,0.84),(54,4996,2.00662),(54,7192,2.58993),(54,7193,2.79993),(54,7194,1.86662),(54,7195,2.1),(54,7220,2.24),(54,7221,2.52),(54,7299,2.73),(54,7300,3.21993),(54,7301,2.42662),(54,7302,2.28662),(54,7916,0.95669),(54,7917,1.02669),(54,7918,0.23331),(54,7919,0.93331),(54,7920,1.00331),(54,7921,0.18669),(54,7922,0.95669),(54,7923,1.05),(54,7924,1.23321),(54,7925,4.68679),(54,7926,6.04321),(54,7927,5.05679),(54,7928,5.79679),(54,7929,1.00331),(54,7930,1.12),(54,7931,0.88669),(54,7932,1.00331),(55,57,1.11993),(55,3500,0.84),(55,3506,0.84),(55,3531,2.80014),(55,4698,3.08007),(55,4712,1.26),(55,4996,3.00993),(55,7192,2.58993),(55,7193,2.79993),(55,7194,2.79993),(55,7195,3.15),(55,7220,3.36),(55,7221,3.78),(55,7299,2.73),(55,7300,3.21993),(55,7301,3.63993),(55,7302,3.42993),(55,7544,1.07331),(55,7546,1.16669),(55,7549,1.07331),(55,7550,1.02669),(55,7551,1.35331),(55,8095,1.16669),(56,3500,1.12),(56,3506,0.84),(56,3531,3.73352),(56,4698,4.10676),(56,4712,1.26),(56,4996,4.01324),(56,7192,2.58993),(56,7193,2.79993),(56,7194,2.79993),(56,7195,3.15),(56,7220,3.36),(56,7221,3.78),(56,7299,3.64),(56,7300,4.29324),(56,7301,4.85324),(56,7302,4.57324),(57,57,3.35979),(57,475,1.30676),(57,529,0.09331),(57,532,0.84),(57,3500,0.28),(57,3506,0.56),(57,3531,0.93338),(57,3545,0.65338),(57,3869,0.09331),(57,4698,1.02669),(57,4712,0.42),(57,4996,1.00331),(57,6617,2.14662),(57,6618,2.47338),(57,6621,1.96),(57,6622,2.14662),(57,6623,1.14331),(57,6624,4.38676),(57,7184,1.77338),(57,7185,2.00662),(57,7192,0.86331),(57,7193,0.93331),(57,7194,0.93331),(57,7195,1.05),(57,7211,2.05338),(57,7212,2.42662),(57,7220,1.12),(57,7221,1.26),(57,7299,0.91),(57,7300,1.07331),(57,7301,1.21331),(57,7302,1.14331),(57,7918,0.23331),(57,7929,1.00331),(57,8138,0.98),(57,8139,1.09669),(57,8140,1.07331),(57,8141,1.14331),(57,8142,1.12),(57,8143,1.35331),(57,8144,1.02669),(57,8145,1.09669),(57,8146,1.07331),(57,8147,1.19),(57,8148,1.16669),(57,8149,1.37669),(57,8150,1.23669),(57,8151,1.16669),(57,8152,1.07331),(57,8153,0.95669),(58,3506,1.12),(58,3517,0.46662),(58,3526,1.68),(58,3540,1.39986),(58,3550,1.49324),(58,4710,1.91338),(58,4712,0.84),(58,5474,2.1),(58,8391,1.23321),(58,8777,1.96),(58,8778,2.14662),(58,8779,2.00662),(58,8780,2.19338),(58,8781,1.86662),(58,8782,2.14662),(58,8783,2.00662),(58,8784,2.1),(58,8785,2.1),(58,8786,2.28662),(58,8787,2.14662),(58,8788,2.42662),(58,8789,2.1),(58,8790,2.24),(58,8791,2.38),(58,8792,2.24),(58,8793,2.42662),(58,8794,1.96),(58,8795,2.19338),(58,8796,2.14662),(58,8797,1.02669),(58,8798,1.16669),(58,8799,2.00662),(58,8800,2.24),(72,529,0.18662),(72,3869,0.18662),(72,3870,0.86331),(72,3871,0.93331),(72,3872,1.02669),(72,3873,1.14331),(72,3874,0.28),(72,3875,0.98),(72,3876,1.19),(72,3877,0.32669),(72,3878,0.98),(72,3879,1.14331),(72,3880,0.32669),(72,3881,1.00331),(72,3882,1.07331),(72,3883,0.37331),(72,3884,0.95669),(72,3885,1.16669),(72,3886,0.95669),(72,3887,1.07331),(72,3888,0.91),(72,3889,1.14331),(72,4216,0.23331),(72,4217,0.93331),(72,4218,1.05),(72,4219,0.32669),(72,4220,0.98),(72,4221,1.05);


--
-- Table structure for table `#__finder_links_termsa`
--



CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsa`
--


INSERT INTO `#__finder_links_termsa` (`link_id`, `term_id`, `weight`) VALUES (3,7,0.17),(22,7,0.21),(22,163,1.68),(22,164,1.82),(22,165,0.86331),(22,166,0.98),(25,7,0.17),(63,7,0.17);


--
-- Table structure for table `#__finder_links_termsb`
--



CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsb`
--


INSERT INTO `#__finder_links_termsb` (`link_id`, `term_id`, `weight`) VALUES (12,50,0.8),(12,51,1.02),(13,51,2.22),(18,64,1.23321),(20,95,0.32004),(20,96,1.56),(20,97,1.92),(21,95,0.32004),(21,96,1.56),(21,97,1.92),(22,1473,1.26),(22,1474,3.08007),(22,1475,3.29007),(22,1476,0.84),(22,1477,5.88),(22,1478,6.43986),(22,1479,0.37331),(22,1480,1.00331),(22,1481,1.16669),(22,1482,0.23331),(22,1483,0.93331),(22,1484,1.02669),(22,1485,0.32669),(22,1486,1.05),(22,1487,1.23669),(22,1488,0.32669),(22,1489,0.98),(22,1490,1.12),(22,1491,0.46669),(22,1492,1.05),(22,1493,1.19),(22,1494,0.46669),(22,1495,1.05),(22,1496,1.19),(22,1497,1.21338),(22,1498,1.09669),(22,1499,1.21331),(22,1500,1.12),(22,1501,1.19),(22,1502,0.60669),(22,1503,1.09669),(22,1504,1.21331),(22,1505,0.60669),(22,1506,1.09669),(22,1507,1.21331),(22,1508,0.60669),(22,1509,1.09669),(22,1510,1.21331),(22,1511,0.7),(22,1512,1.23669),(22,1513,1.30669),(22,1514,0.7),(22,1515,1.19),(22,1516,1.26),(22,1517,0.7),(22,1518,1.21331),(22,1519,1.28331),(22,1520,0.23331),(22,1521,0.93331),(22,1522,1.02669),(22,1523,0.32669),(22,1524,0.98),(22,1525,1.12),(22,1526,0.42),(22,1527,1.09669),(22,1528,1.14331),(22,1529,0.42),(22,1530,1.09669),(22,1531,1.14331),(22,1532,0.42),(22,1533,1.09669),(22,1534,1.14331),(22,1535,0.42),(22,1536,1.09669),(22,1537,1.14331),(22,1538,0.46669),(22,1539,1.05),(22,1540,1.26),(22,1541,0.60669),(22,1542,1.12),(22,1543,1.33),(22,1544,0.37331),(22,1545,1.00331),(22,1546,1.16669),(22,1547,0.51331),(22,1548,1.07331),(22,1549,1.23669),(22,1550,1.02662),(22,1551,2.14662),(22,1552,2.47338),(22,1553,0.28),(22,1554,0.95669),(22,1555,1.07331),(22,1556,0.42),(22,1557,1.02669),(22,1558,1.14331),(22,1559,0.42),(22,1560,1.02669),(22,1561,1.14331),(22,1562,0.18669),(22,1563,0.91),(22,1564,0.98),(22,1565,0.32669),(22,1566,0.98),(22,1567,1.05),(22,1568,0.46669),(22,1569,1.05),(22,1570,1.19),(22,1571,0.60669),(22,1572,1.12),(22,1573,1.26),(22,1574,0.51331),(22,1575,1.07331),(22,1576,1.21331),(22,1577,0.65331),(22,1578,1.14331),(22,1579,1.28331),(22,1580,0.46669),(22,1581,1.05),(22,1582,1.19),(22,1583,0.60669),(22,1584,1.12),(22,1585,1.33),(22,1586,0.42),(22,1587,1.09669),(22,1588,1.14331),(22,1589,0.42),(22,1590,1.09669),(22,1591,1.14331),(22,1592,0.32669),(22,1593,1.00331),(22,1594,1.14331),(22,1595,0.42),(22,1596,1.05),(22,1597,1.19),(22,1598,0.42),(22,1599,1.05),(22,1600,1.19),(22,1601,0.32669),(22,1602,0.98),(22,1603,1.12),(22,1604,0.46669),(22,1605,1.05),(22,1606,1.19),(22,1607,0.32669),(22,1608,1.05),(22,1609,1.26),(22,1610,0.65338),(22,1611,1.05),(22,1612,1.26),(22,1613,0.32669),(22,1614,0.93331),(22,1615,1.05),(22,1616,0.46669),(22,1617,1.05),(22,1618,1.19),(22,1619,0.23331),(22,1620,0.93331),(22,1621,1.02669),(22,1622,0.37331),(22,1623,1.00331),(22,1624,1.16669),(22,1625,0.32669),(22,1626,0.98),(22,1627,1.12),(22,1628,0.32669),(22,1629,1.00331),(22,1630,1.14331),(22,1631,0.42),(22,1632,1.05),(22,1633,1.19),(22,1634,0.42),(22,1635,1.05),(22,1636,1.19),(22,1637,0.42),(22,1638,1.05),(22,1639,1.19),(22,1640,0.42),(22,1641,1.05),(22,1642,1.19),(22,1643,0.42),(22,1644,1.05),(22,1645,1.19),(22,1646,0.42),(22,1647,1.05),(22,1648,1.19),(22,1649,0.42),(22,1650,1.05),(22,1651,1.19),(22,1652,0.46669),(22,1653,1.05),(22,1654,1.26),(22,1655,0.46669),(22,1656,1.05),(22,1657,1.26),(22,1658,0.60669),(22,1659,1.12),(22,1660,1.33),(22,1661,0.60669),(22,1662,1.12),(22,1663,1.33),(22,1664,0.56),(22,1665,1.09669),(22,1666,1.4),(22,1667,0.51331),(22,1668,1.07331),(22,1669,1.23669),(22,1670,0.56),(22,1671,1.09669),(22,1672,1.28331),(22,1673,0.56),(22,1674,1.09669),(22,1675,1.35331),(22,1676,0.32669),(22,1677,0.98),(22,1678,1.12),(22,1679,0.46669),(22,1680,1.05),(22,1681,1.19),(22,1682,0.23331),(22,1683,1.00331),(22,1684,1.19),(22,1685,0.7),(22,1686,1.35331),(22,1687,1.4),(22,1688,0.28),(22,1689,0.91),(22,1690,1.02669),(22,1691,0.28),(22,1692,0.91),(22,1693,1.02669),(22,1694,0.28),(22,1695,0.91),(22,1696,1.02669),(22,1697,0.28),(22,1698,0.95669),(22,1699,1.07331),(22,1700,0.46669),(22,1701,0.98),(22,1702,1.09669),(22,1703,0.93338),(22,1704,1.96),(22,1705,1.07331),(22,1706,1.09669),(22,1707,0.93338),(22,1708,1.05),(22,1709,1.19),(22,1710,0.98),(22,1711,1.09669),(22,1712,0.32669),(22,1713,0.98),(22,1714,1.12),(22,1715,0.46669),(22,1716,1.05),(22,1717,1.19),(22,1718,0.32669),(22,1719,0.98),(22,1720,0.46669),(22,1721,1.05),(22,1722,1.19),(22,1723,0.46669),(22,1724,1.05),(22,1725,1.19),(22,1726,0.60669),(22,1727,1.12),(22,1728,1.4),(22,1729,0.7),(22,1730,1.19),(22,1731,1.4),(22,1732,0.60669),(22,1733,1.12),(22,1734,1.33),(22,1735,0.28),(22,1736,0.95669),(22,1737,1.07331),(22,1738,0.42),(22,1739,1.02669),(22,1740,1.14331),(22,1741,0.28),(22,1742,0.95669),(22,1743,1.07331),(22,1744,0.42),(22,1745,1.02669),(22,1746,1.16669),(22,1747,0.37331),(22,1748,1.00331),(22,1749,1.16669),(22,1750,0.51331),(22,1751,1.07331),(22,1752,1.23669),(22,1753,0.32669),(22,1754,0.98),(22,1755,1.12),(22,1756,0.46669),(22,1757,1.05),(22,1758,1.19),(22,1759,0.93338),(22,1760,2.05338),(22,1761,2.47338),(22,1762,0.32669),(22,1763,0.98),(22,1764,1.12),(22,1765,0.28),(22,1766,0.95669),(22,1767,1.07331),(22,1768,0.56),(22,1769,1.09669),(22,1770,1.33),(22,1771,0.56),(22,1772,1.09669),(22,1773,1.33),(22,1774,0.56),(22,1775,1.09669),(22,1776,1.33),(22,1777,0.56),(22,1778,1.09669),(22,1779,1.33),(22,1780,0.32669),(22,1781,0.98),(22,1782,1.12),(22,1783,0.46669),(22,1784,1.05),(22,1785,1.19),(22,1786,0.46669),(22,1787,1.05),(22,1788,1.19),(22,1789,0.32669),(22,1790,0.98),(22,1791,1.12),(22,1792,0.46669),(22,1793,1.05),(22,1794,1.19),(22,1795,0.37331),(22,1796,1.00331),(22,1797,1.16669),(22,1798,0.51331),(22,1799,1.07331),(22,1800,1.23669),(22,1801,0.32669),(22,1802,0.98),(22,1803,1.09669),(22,1804,0.32669),(22,1805,0.98),(22,1806,1.09669),(22,1807,0.32669),(22,1808,0.98),(22,1809,1.09669),(22,1810,0.32669),(22,1811,0.98),(22,1812,1.09669),(22,1813,0.32669),(22,1814,0.98),(22,1815,1.09669),(22,1816,0.60669),(22,1817,1.12),(22,1818,1.4),(22,1819,0.7),(22,1820,1.19),(22,1821,1.4),(22,1822,0.7),(22,1823,1.19),(22,1824,1.4),(22,1825,0.42),(22,1826,0.98),(22,1827,1.12),(22,1828,0.42),(22,1829,0.98),(22,1830,1.12),(22,1831,0.42),(22,1832,0.98),(22,1833,1.12),(22,1834,0.42),(22,1835,0.98),(22,1836,1.12),(22,1837,0.42),(22,1838,0.98),(22,1839,1.12),(22,1840,0.42),(22,1841,0.98),(22,1842,1.12),(22,1843,0.42),(22,1844,0.98),(22,1845,1.12),(22,1846,0.51331),(22,1847,1.07331),(22,1848,1.19),(22,1849,0.28),(22,1850,0.95669),(22,1851,1.12),(22,1852,0.42),(22,1853,1.02669),(22,1854,1.14331),(22,1855,0.84),(22,1856,2.05338),(22,1857,2.28662),(22,1858,0.51331),(22,1859,1.07331),(22,1860,1.30669),(22,1861,0.65331),(22,1862,1.14331),(22,1863,1.37669),(22,1864,0.65331),(22,1865,1.14331),(22,1866,1.37669),(22,1867,0.32669),(22,1868,0.98),(22,1869,1.12),(22,1870,0.46669),(22,1871,1.05),(22,1872,1.19),(22,1873,0.23331),(22,1874,0.93331),(22,1875,1.02669),(22,1876,0.28),(22,1877,0.95669),(22,1878,1.07331),(22,1879,0.42),(22,1880,0.95669),(22,1881,1.07331),(22,1882,0.42),(22,1883,0.95669),(22,1884,1.07331),(22,1885,0.56),(22,1886,0.98),(22,1887,1.09669),(22,1888,0.95669),(22,1889,1.07331),(22,1890,0.42),(22,1891,1.02669),(22,1892,1.14331),(22,1893,0.42),(22,1894,1.02669),(22,1895,1.14331),(22,1896,0.37331),(22,1897,1.00331),(22,1898,1.16669),(22,1899,0.42),(22,1900,1.02669),(22,1901,1.21331),(22,1902,0.56),(22,1903,1.09669),(22,1904,1.28331),(22,1905,0.37331),(22,1906,1.00331),(22,1907,1.16669),(22,1908,0.32669),(22,1909,1.05),(22,1910,1.23669),(22,1911,0.37331),(22,1912,1.00331),(22,1913,1.16669),(22,1914,0.42),(22,1915,1.09669),(22,1916,1.14331),(22,1917,0.42),(22,1918,1.09669),(22,1919,1.14331),(22,1920,0.42),(22,1921,1.09669),(22,1922,1.14331),(22,1923,0.42),(22,1924,1.02669),(22,1925,1.14331),(22,1926,1.21338),(22,1927,2.19338),(22,1928,2.75338),(22,1929,0.65331),(22,1930,1.14331),(22,1931,1.37669),(22,1932,0.28),(22,1933,0.95669),(22,1934,1.07331),(22,1935,0.42),(22,1936,1.02669),(22,1937,1.14331),(22,1938,0.32669),(22,1939,0.98),(22,1940,1.09669),(22,1941,0.32669),(22,1942,0.98),(22,1943,1.09669),(22,1944,0.32669),(22,1945,0.98),(22,1946,1.09669),(22,1947,0.32669),(22,1948,0.98),(22,1949,1.09669),(22,1950,0.32669),(22,1951,0.98),(22,1952,1.09669),(22,1953,0.56),(22,1954,1.09669),(22,1955,1.28331),(22,1956,0.28),(22,1957,0.95669),(22,1958,0.42),(22,1959,1.02669),(22,1960,1.23669),(22,1961,0.42),(22,1962,1.02669),(22,1963,1.14331),(22,1964,0.46669),(22,1965,1.05),(22,1966,1.19),(22,1967,0.46669),(22,1968,1.05),(22,1969,1.23669),(22,1970,0.46669),(22,1971,1.05),(22,1972,1.23669),(22,1973,0.46669),(22,1974,1.05),(22,1975,1.23669),(22,1976,0.46669),(22,1977,1.05),(22,1978,1.23669),(22,1979,0.46669),(22,1980,1.05),(22,1981,1.23669),(22,1982,0.37331),(22,1983,1.00331),(22,1984,1.16669),(22,1985,0.32669),(22,1986,0.98),(22,1987,1.12),(22,1988,0.46669),(22,1989,1.05),(22,1990,1.19),(22,1991,0.56),(22,1992,1.09669),(22,1993,1.28331),(22,1994,0.84),(22,1995,2.73),(22,1996,3.29007),(22,1997,26.6967),(22,1998,1.68),(22,1999,2.00662),(22,2000,1.72662),(22,2001,1.16669),(22,2002,1.05),(22,2003,3.15),(22,2004,3.36),(22,2005,1.82),(22,2006,1.07331),(22,2007,1.02669),(22,2008,112.84),(22,2009,1.16669),(22,2010,4.01324),(22,2011,110.019),(22,2012,4.10676),(22,2013,2.73),(22,2014,3.08007),(22,2015,2.66007),(22,2016,3.00993),(22,2017,0.91),(22,2018,1.02669),(22,2019,0.93324),(22,2020,1.02669),(22,2021,1.21331),(22,2022,3.00993),(22,2023,2.24),(22,2024,1.09669),(25,1476,0.14),(25,3970,0.88669),(25,3971,1.00331),(25,3972,1.68),(25,3973,4.01324),(25,3974,4.57324),(25,3975,0.93331),(25,3976,1.05),(25,3977,1.02669),(25,3978,1.09669),(26,4284,0.18669),(26,4285,0.86331),(26,4286,1.12),(26,4287,0.18662),(26,4288,1.72662),(26,4289,0.91),(26,4290,1.07331),(27,4477,0.32669),(27,4478,1.07331),(27,4479,1.33),(28,4477,0.32669),(28,4478,1.07331),(28,4479,1.33),(29,4477,0.32669),(29,4478,1.07331),(29,4479,1.33),(30,4477,0.32669),(30,4478,1.07331),(30,4479,1.33),(31,4477,0.32669),(31,4478,1.07331),(31,4479,1.33),(32,4477,0.32669),(32,4478,1.07331),(32,4479,1.33),(33,4477,0.32669),(33,4478,1.07331),(33,4479,1.33),(34,4477,0.32669),(34,4478,1.07331),(34,4479,1.33),(35,4477,0.32669),(35,4478,1.07331),(35,4479,1.33),(36,4284,0.18669),(36,4285,0.86331),(36,4286,1.12),(36,4287,0.18662),(36,4288,1.72662),(36,4289,0.91),(36,4290,1.07331),(37,4284,0.18669),(37,4285,0.86331),(37,4286,1.12),(37,4287,0.18662),(37,4288,1.72662),(37,4289,0.91),(37,4290,1.07331),(38,4284,0.18669),(38,4285,0.86331),(38,4286,1.12),(38,4287,0.67983),(38,4288,6.28983),(38,4289,0.91),(38,4290,1.07331),(39,4477,0.65338),(39,4823,1.86662),(39,4824,2.1),(40,4477,0.32669),(40,5179,0.95669),(40,5180,1.07331),(41,4477,0.32669),(41,5179,0.95669),(41,5180,1.07331),(42,4477,0.32669),(42,5179,0.95669),(42,5180,1.07331),(43,5580,0.23331),(43,5581,0.88669),(43,5582,1.07331),(45,1476,0.14),(45,6193,0.46669),(45,6194,1.05),(45,6195,1.12),(45,6196,0.91),(45,6197,0.98),(45,6198,0.42),(45,6199,1.02669),(45,6200,1.26),(45,6201,0.42),(45,6202,1.19),(45,6203,1.28331),(46,4477,0.32669),(46,6766,1.07331),(46,6767,1.19),(47,4477,0.32669),(47,6766,1.07331),(47,6767,1.19),(48,4477,0.32669),(48,6766,1.07331),(48,6767,1.19),(49,1476,0.14),(49,4477,0.65338),(49,6766,2.14662),(49,6767,2.38),(49,7352,0.23331),(49,7353,0.95669),(49,7354,1.14331),(49,7355,0.18669),(49,7356,0.86331),(49,7357,0.93331),(49,7358,0.91),(49,7359,1.07331),(50,64,0.39996),(50,4477,0.32669),(50,6766,1.07331),(50,6767,1.19),(51,64,0.39996),(51,1476,0.14),(51,4477,0.32669),(51,6766,1.07331),(51,6767,1.19),(51,7618,0.86331),(51,7619,1.00331),(51,7620,0.32669),(51,7621,0.95669),(51,7622,1.09669),(52,64,0.39996),(52,4477,0.65338),(52,6766,2.14662),(52,6767,2.38),(53,64,0.39996),(53,7857,1.23321),(53,7858,4.93321),(53,7859,6.41321),(54,7962,0.18669),(54,7963,0.95669),(54,7964,1.02669),(55,7620,0.32669),(55,7621,0.95669),(55,7622,1.09669),(57,1476,0.28),(57,4477,0.65338),(57,6766,2.14662),(57,6767,2.38),(57,8192,0.81669),(57,8193,1.00331),(57,8194,1.00331),(57,8195,1.07331),(58,4477,0.65338),(58,8513,2.1),(58,8514,2.24),(59,51,2.94),(59,8808,1.11996),(59,8809,1.92),(59,8810,2.16),(59,8811,5.42679),(63,50,1.28),(63,51,1.74),(63,8857,1.59996),(63,8858,2.49339),(64,50,0.8),(64,51,1.74),(64,8808,1.11996),(64,8809,1.92),(64,8861,3),(64,8862,2.72),(65,50,0.48),(65,51,2.94),(65,8857,1.59996),(65,8864,5.92),(66,50,0.48),(66,51,2.94),(66,8857,1.59996),(66,8869,5.55),(67,51,3.66),(67,8876,5.79679),(68,51,3.66),(68,8883,5.92),(69,50,0.48),(69,51,2.94),(69,8857,1.59996),(69,8889,1.92),(69,8890,5.79679),(70,50,0.48),(70,51,0.72),(70,8857,1.59996),(70,8897,1.8),(71,51,2.94),(71,8808,1.11996),(71,8809,1.92),(71,8810,2.16),(71,8906,5.30321),(71,8907,3),(71,8908,2.72),(72,1476,0.14),(72,3970,0.88669),(72,3971,1.00331),(72,3972,1.68),(72,3973,4.01324),(72,3974,4.57324),(72,3975,0.93331),(72,3976,1.05),(72,3977,1.02669),(72,3978,1.09669);


--
-- Table structure for table `#__finder_links_termsc`
--



CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsc`
--


INSERT INTO `#__finder_links_termsc` (`link_id`, `term_id`, `weight`) VALUES (1,2,0.17),(7,14,0.17),(9,20,0.34),(10,28,0.34),(11,33,0.34),(12,49,0.34),(13,52,0.34),(14,53,0.34),(15,54,0.34),(16,56,0.34),(17,60,0.34),(18,63,0.34),(19,67,0.34),(20,74,0.72),(20,75,0.17),(20,76,0.24),(20,77,1.64004),(20,78,1.76004),(20,83,1.44),(20,84,4.43988),(21,2,0.17),(21,76,0.24),(21,77,1.64004),(21,78,1.76004),(22,2,1.05),(22,14,0.07),(22,75,1.22),(22,122,0.28),(22,123,1.86662),(22,124,2.00662),(22,125,0.28),(22,126,1.86662),(22,127,1.07331),(22,128,1.02669),(22,129,1.77338),(22,130,1.86662),(22,131,8.19),(22,132,8.61021),(22,133,0.84),(22,134,0.93331),(22,135,0.86331),(22,136,1.00331),(22,137,0.84),(22,138,0.91),(22,139,0.84),(22,140,0.91),(22,141,0.84),(22,142,0.88669),(22,143,0.84),(22,144,0.95669),(22,145,8.19),(22,146,8.61021),(22,147,0.84),(22,148,0.93331),(22,149,0.84),(22,150,0.91),(22,151,0.84),(22,152,0.91),(22,173,0.84),(22,174,0.91),(23,2,0.17),(29,14,0.17),(31,20,0.34),(32,28,0.34),(33,33,0.34),(34,49,0.34),(35,52,0.34),(35,4735,0.49321),(36,53,0.34),(37,54,0.34),(38,56,0.34),(39,60,0.34),(40,63,0.34),(41,67,0.34),(42,5493,0.34),(43,5497,0.34),(44,5772,0.34),(45,76,0.34),(45,5989,0.21),(45,5990,0.86331),(45,5991,0.98),(46,6525,0.34),(47,7239,0.34),(48,7303,0.34),(49,7311,0.34),(51,7526,0.28),(51,7527,1.00331),(51,7528,1.16669),(59,75,0.17),(60,54,0.4),(60,75,0.17),(60,8824,0.51),(61,2,0.17),(67,14,0.17),(69,20,0.34),(70,28,0.34),(71,33,0.34),(72,2,0.37);


--
-- Table structure for table `#__finder_links_termsd`
--



CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsd`
--


INSERT INTO `#__finder_links_termsd` (`link_id`, `term_id`, `weight`) VALUES (1,1,0),(2,1,0),(3,1,0),(4,1,0),(5,1,0),(6,1,0),(7,1,0),(8,1,0),(9,1,0),(10,1,0),(11,1,0),(12,1,0),(13,1,0),(14,1,0),(15,1,0),(16,1,0),(17,1,0),(18,1,0),(19,1,0),(20,1,0),(21,1,0),(22,1,0),(22,2567,0.14),(22,2568,0.88669),(22,2569,0.93331),(22,2570,0.18669),(22,2571,1.00331),(22,2572,1.07331),(22,2573,4.94543),(22,2574,0.79331),(22,2575,0.98),(22,2576,1.63338),(22,2577,1.12),(22,2578,1.00331),(22,2579,2.94),(22,2580,3.36),(22,2581,1.00331),(22,2582,1.14331),(22,2583,1.68),(22,2584,1.96),(22,2585,1.86662),(22,2586,1.96),(22,2587,2.58993),(22,2588,1.86662),(22,2589,1.05),(22,2590,0.81669),(22,2591,0.88669),(22,2592,2.79993),(22,2593,3.50007),(22,2594,2.94),(22,2595,3.21993),(22,2596,0.93331),(22,2597,1.05),(22,2598,0.84),(22,2599,0.91),(22,2600,10.6403),(22,2601,10.0331),(22,2602,1.02669),(22,2603,3.45324),(22,2604,0.93331),(22,2605,2.94),(22,2606,5.04),(22,2607,5.74014),(22,2608,0.98),(22,2609,1.12),(22,2610,5.17986),(22,2611,5.74014),(22,2612,0.86331),(22,2613,0.98),(22,2614,0.37324),(22,2615,3.54676),(22,2616,1.07331),(22,2617,1.02669),(22,2618,1.37669),(22,2619,1.07331),(22,2620,0.84),(22,2621,2.94),(22,2622,3.42993),(22,2623,0.74648),(22,2624,0.84),(22,2625,0.98),(22,2626,2.94),(22,2627,3.36),(22,2628,2.58993),(22,2629,2.79993),(22,2630,0.91),(22,2631,1.02669),(22,2632,0.98007),(22,2633,0.98),(22,2634,1.05),(22,2635,2.00662),(22,2636,1.14331),(22,2637,1.14331),(22,2638,1.96),(22,2639,6.43986),(22,2640,7.56),(22,2641,0.98),(22,2642,1.21331),(22,2643,1.16655),(22,2644,1.86662),(22,2645,2.19338),(22,2646,2.87007),(22,2647,3.08007),(22,2648,0.84),(22,2649,0.86331),(22,2650,1.05),(22,2651,0.98),(22,2652,1.19),(22,2653,0.86331),(22,2654,1.05),(22,2655,0.88669),(22,2656,1.00331),(22,2657,1.02669),(22,2658,1.14331),(22,2659,1.05),(22,2660,1.33),(23,1,0),(24,1,0),(24,2573,0.09331),(24,3811,0.95669),(24,3812,1.19),(24,3813,0.28),(24,3814,0.98),(24,3815,1.21331),(24,3816,0.09331),(24,3817,0.79331),(24,3818,0.98),(25,1,0),(25,2573,0.27993),(25,2606,0.84),(25,2643,0.23331),(25,4070,0.91),(25,4071,1.09669),(25,4072,1.02669),(25,4073,0.88669),(25,4074,1.09669),(25,4075,0.32669),(25,4076,0.93331),(25,4077,1.09669),(25,4078,0.37331),(25,4079,1.12),(25,4080,1.21331),(25,4081,0.51331),(25,4082,1.02669),(25,4083,1.16669),(25,4084,0.28),(25,4085,0.91),(25,4086,1.00331),(25,4087,0.14),(25,4088,1.02669),(25,4089,1.21331),(25,4090,1.02669),(25,4091,1.23669),(25,4092,0.14),(25,4093,0.98),(25,4094,1.19),(26,1,0),(26,2573,0.18662),(26,2574,0.79331),(26,4075,0.32669),(26,4076,0.93331),(26,4092,0.14),(26,4093,0.98),(26,4320,1.05),(26,4321,0.88669),(26,4322,1.02669),(26,4323,1.00331),(26,4324,0.23331),(26,4325,0.88669),(26,4326,1.00331),(26,4327,1.19),(27,1,0),(27,2570,0.37338),(27,4587,1.02669),(27,4588,1.16669),(27,4589,1.02669),(27,4590,1.23669),(27,4591,0.37338),(27,4592,0.95669),(27,4593,1.02669),(27,4594,1.05),(27,4595,1.16669),(28,1,0),(28,2570,0.37338),(28,4587,1.02669),(28,4588,1.16669),(28,4589,1.02669),(28,4590,1.23669),(28,4591,0.37338),(28,4592,0.95669),(28,4593,1.02669),(28,4594,1.05),(28,4595,1.16669),(29,1,0),(29,2570,0.37338),(29,4587,1.02669),(29,4588,1.16669),(29,4589,1.02669),(29,4590,1.23669),(29,4591,0.37338),(29,4592,0.95669),(29,4593,1.02669),(29,4594,1.05),(29,4595,1.16669),(30,1,0),(30,2570,0.37338),(30,4587,1.02669),(30,4588,1.16669),(30,4589,1.02669),(30,4590,1.23669),(30,4591,0.37338),(30,4592,0.95669),(30,4593,1.02669),(30,4594,1.05),(30,4595,1.16669),(31,1,0),(31,2570,0.37338),(31,4587,1.02669),(31,4588,1.16669),(31,4589,1.02669),(31,4590,1.23669),(31,4591,0.37338),(31,4592,0.95669),(31,4593,1.02669),(31,4594,1.05),(31,4595,1.16669),(32,1,0),(32,2570,0.37338),(32,4587,1.02669),(32,4588,1.16669),(32,4589,1.02669),(32,4590,1.23669),(32,4591,0.37338),(32,4592,0.95669),(32,4593,1.02669),(32,4594,1.05),(32,4595,1.16669),(33,1,0),(33,2570,0.37338),(33,4587,1.02669),(33,4588,1.16669),(33,4589,1.02669),(33,4590,1.23669),(33,4591,0.37338),(33,4592,0.95669),(33,4593,1.02669),(33,4594,1.05),(33,4595,1.16669),(34,1,0),(34,2570,0.37338),(34,4587,1.02669),(34,4588,1.16669),(34,4589,1.02669),(34,4590,1.23669),(34,4591,0.37338),(34,4592,0.95669),(34,4593,1.02669),(34,4594,1.05),(34,4595,1.16669),(35,1,0),(35,2570,0.37338),(35,4587,1.02669),(35,4588,1.16669),(35,4589,1.02669),(35,4590,1.23669),(35,4591,0.37338),(35,4592,0.95669),(35,4593,1.02669),(35,4594,1.05),(35,4595,1.16669),(36,1,0),(36,2573,0.18662),(36,2574,0.79331),(36,4075,0.32669),(36,4076,0.93331),(36,4092,0.14),(36,4093,0.98),(36,4320,1.05),(36,4321,0.88669),(36,4322,1.02669),(36,4323,1.00331),(36,4324,0.23331),(36,4325,0.88669),(36,4326,1.00331),(36,4327,1.19),(37,1,0),(37,2573,0.18662),(37,2574,0.79331),(37,4075,0.32669),(37,4076,0.93331),(37,4092,0.14),(37,4093,0.98),(37,4320,1.05),(37,4321,0.88669),(37,4322,1.02669),(37,4323,1.00331),(37,4324,0.23331),(37,4325,0.88669),(37,4326,1.00331),(37,4327,1.19),(38,1,0),(38,2573,0.18662),(38,2574,0.79331),(38,4075,0.32669),(38,4076,0.93331),(38,4092,0.14),(38,4093,0.98),(38,4320,1.05),(38,4321,0.88669),(38,4322,1.02669),(38,4323,1.00331),(38,4324,0.23331),(38,4325,0.88669),(38,4326,1.00331),(38,4327,1.19),(39,1,0),(39,2573,0.09331),(39,2638,0.84),(39,3816,0.09331),(39,4891,0.91),(39,4892,1.02669),(39,4893,0.86331),(39,4894,0.98),(39,4895,0.32669),(39,4896,1.12),(39,4897,1.19),(39,4898,0.93331),(39,4899,1.12),(39,4900,1.86662),(39,4901,2.00662),(40,1,0),(40,2638,0.56),(40,2641,0.98),(40,5315,1.02669),(40,5316,1.07331),(40,5317,1.16669),(41,1,0),(41,2638,0.56),(41,2641,0.98),(41,5315,1.02669),(41,5316,1.07331),(41,5317,1.16669),(42,1,0),(42,2638,0.56),(42,2641,0.98),(42,5315,1.02669),(42,5316,1.07331),(42,5317,1.16669),(43,1,0),(43,2573,0.37324),(43,2606,1.68),(43,2643,0.23331),(43,3816,0.18662),(43,4092,0.14),(43,4895,0.32669),(43,5625,0.95669),(43,5626,1.12),(43,5627,0.93331),(43,5628,0.98),(43,5629,0.88669),(43,5630,1.00331),(43,5631,1.68),(43,5632,0.98),(43,5633,0.93331),(43,5634,0.14),(43,5635,0.91),(43,5636,1.14331),(43,5637,1.00331),(43,5638,1.09669),(43,5639,0.93331),(43,5640,0.98),(43,5641,1.00331),(43,5642,1.09669),(43,5643,0.14),(43,5644,0.86331),(43,5645,1.00331),(44,1,0),(44,2570,1.12014),(44,2638,0.56),(44,4898,0.93331),(44,4899,1.12),(44,4900,0.93331),(44,4901,1.00331),(44,5923,0.98),(44,5924,1.05),(44,5925,1.77338),(44,5926,1.05),(44,5927,1.02669),(44,5928,2.66007),(44,5929,2.94),(45,1,0),(45,2573,1.02641),(45,2574,0.79331),(45,2623,0.09331),(45,5629,0.88669),(45,6315,0.86331),(45,6316,0.98),(45,6317,0.88669),(45,6318,0.84),(45,6319,0.98),(45,6320,1.86662),(45,6321,1.14331),(45,6322,1.16669),(45,6323,0.98),(45,6324,1.21331),(45,6325,0.88669),(45,6326,1.05),(45,6327,0.88669),(45,6328,1.07331),(45,6329,0.86331),(45,6330,0.93331),(45,6331,0.98),(45,6332,1.05),(45,6333,0.28),(45,6334,1.12),(45,6335,1.26),(45,6336,0.18669),(45,6337,0.95669),(45,6338,1.19),(45,6339,0.79331),(45,6340,1.00331),(45,6341,0.60669),(45,6342,1.07331),(45,6343,1.16669),(46,1,0),(46,2570,0.18669),(46,2573,0.18662),(46,2638,0.28),(46,4591,0.37338),(46,6333,1.48),(46,6979,0.93331),(46,6980,1.09669),(46,6981,0.79331),(46,6982,1.00331),(46,6983,1.00331),(46,6984,1.09669),(46,6985,5.55),(46,6986,6.90679),(46,6987,0.86331),(46,6988,1.09669),(46,6989,1.07331),(46,6990,1.14331),(46,6991,0.95669),(46,6992,1.23669),(46,6993,0.18669),(46,6994,0.88669),(46,6995,1.02669),(47,1,0),(47,2570,0.18669),(47,2638,0.28),(47,4591,0.37338),(47,6979,0.93331),(47,6980,1.09669),(47,6987,0.86331),(47,6988,1.09669),(47,6989,1.07331),(47,6990,1.14331),(47,6991,0.95669),(47,6992,1.23669),(48,1,0),(48,2570,0.18669),(48,2638,0.28),(48,4591,0.37338),(48,6979,0.93331),(48,6980,1.09669),(48,6987,0.86331),(48,6988,1.09669),(48,6989,1.07331),(48,6990,1.14331),(48,6991,0.95669),(48,6992,1.23669),(49,1,0),(49,2570,0.37338),(49,2573,0.27993),(49,2576,0.81669),(49,2612,0.86331),(49,2638,0.56),(49,2648,0.88),(49,6979,1.86662),(49,6980,2.19338),(49,6991,1.91338),(49,6992,2.47338),(49,7377,0.95669),(49,7378,1.09669),(49,7379,0.93331),(49,7380,0.98),(49,7381,0.14),(49,7382,0.95669),(49,7383,1.05),(49,7384,6.16),(49,7385,1.05),(50,1,0),(50,2570,0.18669),(50,2573,0.27993),(50,2574,0.79331),(50,2606,0.84),(50,2623,0.09331),(50,2638,0.28),(50,4591,0.74676),(50,6979,0.93331),(50,6980,1.09669),(50,6987,1.72662),(50,6988,2.19338),(50,6989,2.14662),(50,6990,2.28662),(50,6991,0.95669),(50,6992,1.23669),(50,7477,0.93331),(50,7478,0.86331),(50,7479,1.00331),(50,7480,1.05),(50,7481,0.98),(50,7482,1.23669),(51,1,0),(51,2570,0.18669),(51,2573,0.27993),(51,2606,0.84),(51,2623,0.09331),(51,2638,0.28),(51,3816,0.09331),(51,4591,0.37338),(51,6979,0.93331),(51,6980,1.09669),(51,6987,0.86331),(51,6988,1.09669),(51,6989,1.07331),(51,6990,1.14331),(51,6991,0.95669),(51,6992,1.23669),(51,7658,0.42),(51,7659,1.09669),(51,7660,1.28331),(51,7661,0.95669),(51,7662,1.07331),(51,7663,0.88669),(51,7664,1.09669),(51,7665,1.05),(51,7666,0.81669),(51,7667,0.88669),(51,7668,0.86331),(51,7669,1.00331),(51,7670,0.23331),(51,7671,1.14331),(51,7672,1.23669),(51,7673,0.28),(51,7674,0.95669),(51,7675,1.07331),(52,1,0),(52,2570,0.37338),(52,2573,0.09331),(52,2638,0.56),(52,4591,0.37338),(52,4895,0.32669),(52,6979,1.86662),(52,6980,2.19338),(52,6987,0.86331),(52,6988,1.09669),(52,6989,1.07331),(52,6990,1.14331),(52,6991,1.91338),(52,6992,2.47338),(52,7796,0.86331),(52,7797,1.09669),(52,7798,1.48),(52,7799,4.93321),(52,7800,5.92),(52,7801,0.95669),(52,7802,1.09669),(53,1,0),(53,4591,1.30683),(53,6987,2.58993),(53,6988,3.29007),(53,6989,4.29324),(53,6990,4.57324),(54,1,0),(54,2573,0.18662),(54,2606,1.68),(54,3816,0.49321),(54,4092,0.74),(54,7995,0.98),(54,7996,0.95669),(54,7997,5.30321),(54,7998,0.28),(54,7999,0.91),(54,8000,0.98),(54,8001,5.18),(54,8002,5.55),(55,1,0),(55,2573,0.18662),(55,2606,0.84),(55,3816,0.09331),(55,7658,0.42),(55,7659,1.09669),(55,7660,1.28331),(55,7663,0.88669),(55,7664,1.09669),(55,7665,1.05),(55,7666,0.81669),(55,7667,0.88669),(55,7670,0.23331),(55,7671,1.14331),(55,7672,1.23669),(56,1,0),(57,1,0),(57,2638,0.56),(57,2648,0.42),(57,6991,1.91338),(57,6992,2.47338),(57,7384,1.96),(57,8244,2.38),(57,8245,0.95669),(57,8246,1.05),(58,1,0),(58,2570,1.12014),(58,4591,0.37338),(58,8649,1.96),(58,8650,2.14662),(58,8651,3.45324),(58,8652,2.1),(58,8653,2.19338),(58,8654,1.86662),(58,8655,2.33338),(59,1,0),(60,1,0),(60,4087,0.24),(60,8834,0.32669),(60,8835,0.98),(61,1,0),(61,4087,0.24),(62,1,0),(62,4087,0.24),(63,1,0),(64,1,0),(65,1,0),(66,1,0),(67,1,0),(68,1,0),(69,1,0),(70,1,0),(71,1,0),(72,1,0),(72,2573,0.27993),(72,2606,0.84),(72,2643,0.23331),(72,4070,0.91),(72,4071,1.09669),(72,4072,1.02669),(72,4073,0.88669),(72,4074,1.09669),(72,4075,0.32669),(72,4076,0.93331),(72,4077,1.09669),(72,4078,0.37331),(72,4079,1.12),(72,4080,1.21331),(72,4081,0.51331),(72,4082,1.02669),(72,4083,1.16669),(72,4084,0.28),(72,4085,0.91),(72,4086,1.00331),(72,4087,0.14),(72,4088,1.02669),(72,4089,1.21331),(72,4090,1.02669),(72,4091,1.23669),(72,4092,0.14),(72,4093,0.98),(72,4094,1.19);


--
-- Table structure for table `#__finder_links_termse`
--



CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termse`
--


INSERT INTO `#__finder_links_termse` (`link_id`, `term_id`, `weight`) VALUES (2,6,0.17),(4,8,0.17),(6,12,1.97321),(6,13,2.66339),(7,17,1.23321),(20,79,0.48),(20,80,1.44),(20,81,4.68),(20,82,5.04),(20,93,0.74),(20,94,5.05679),(21,79,0.48),(21,93,0.4),(21,94,2.7334),(21,113,1.76004),(21,116,0.64008),(21,117,1.52004),(21,118,1.56),(21,119,1.71996),(22,6,0.98),(22,8,0.14),(22,12,0.63996),(22,13,1.88004),(22,17,1.16655),(22,153,1.68),(22,154,1.82),(22,155,0.84),(22,156,0.91),(22,157,0.93331),(22,158,1.19),(22,159,6.34648),(22,160,7.46648),(22,161,0.91),(22,162,1.09669),(22,167,1.68),(22,168,1.82),(22,1222,1.30676),(22,1223,0.98),(22,1224,1.05),(22,1225,2.87007),(22,1226,3.71007),(22,1227,2.42697),(22,1228,6.16014),(22,1229,7.00014),(22,1230,0.98),(22,1231,1.12),(22,1232,6.01986),(22,1233,7.14),(22,1234,3.35979),(22,1235,3.08007),(22,1236,3.36),(22,1237,3.08007),(22,1238,3.50007),(22,1239,3.21993),(22,1240,4.05993),(22,1241,16.0078),(22,1242,1.86662),(22,1243,2.24),(22,1244,8.19),(22,1245,9.87021),(22,1246,8.19),(22,1247,9.87021),(22,1248,8.19),(22,1249,7.84),(22,1250,1.00331),(22,1251,1.09669),(22,1252,1.91338),(22,1253,2.19338),(22,1254,12.6),(22,1255,1.14331),(22,1256,9.89352),(22,1257,3.36),(22,1258,2.79993),(22,1259,3.21993),(22,1260,1.82),(22,1261,1.96),(22,1262,2.52),(22,1263,6.01986),(22,1264,7.14),(22,1265,5.6007),(22,1266,0.86331),(22,1267,1.05),(22,1268,18.62),(22,1269,1.14331),(22,1270,19.7404),(22,1271,0.88669),(22,1272,1.05),(22,1273,9.45),(22,1274,11.97),(22,1275,0.93324),(22,1276,4.01324),(22,1277,2.24),(22,1278,2.19338),(22,1279,4.66725),(22,1280,5.17986),(22,1281,6.16014),(22,1282,0.98),(22,1283,1.09669),(22,1284,5.74014),(22,1285,6.58014),(22,1286,8.39979),(22,1287,9.24021),(22,1288,2.73),(22,1289,3.42993),(22,1290,0.74676),(22,1291,0.93331),(22,1292,1.09669),(22,1293,2.94),(22,1294,3.21993),(22,1295,2.61366),(22,1296,5.46),(22,1297,7.14),(22,1298,5.32014),(22,1299,6.3),(22,1300,0.95669),(22,1301,1.14331),(22,1302,1.05),(22,1303,1.23669),(22,1304,1.39986),(22,1305,6.01986),(22,1306,3.36),(22,1307,3.29007),(22,1308,1.4),(22,1309,2.52),(22,1310,3.00993),(22,1311,2.73),(22,1312,3.42993),(22,1313,1.00331),(22,1314,1.23669),(22,1315,2.58993),(22,1316,3.00993),(22,1317,3.26585),(22,1318,1.02669),(22,1319,1.07331),(22,1320,2.45007),(22,1321,2.87007),(22,1322,5.32014),(22,1323,5.88),(22,1324,5.46),(22,1325,6.43986),(22,1326,16.38),(22,1327,17.0563),(22,1328,0.93331),(22,1329,1.14331),(22,1330,0.23331),(22,1331,1.02669),(22,1332,1.23669),(22,1333,1.67958),(22,1334,5.88),(22,1335,6.58014),(22,1336,0.88669),(22,1337,1.00331),(22,1338,0.81669),(22,1339,0.95669),(22,1340,2.66007),(22,1341,3.00993),(22,1342,5.17986),(22,1343,6.58014),(22,1344,0.95669),(22,1345,1.07331),(22,1346,2.94021),(22,1347,3.15),(22,1348,3.50007),(22,1349,1.02669),(22,1350,1.16669),(22,1351,2.87007),(22,1352,3.21993),(22,1353,0.98),(22,1354,1.14331),(22,1355,1.02669),(22,1356,1.19),(22,1357,1.96014),(22,1358,5.59986),(22,1359,6.3),(22,1360,0.37331),(22,1361,0.95669),(22,1362,1.00331),(22,1363,2.05324),(22,1364,4.57324),(22,1365,2.52),(22,1366,2.47338),(22,3282,0.28014),(22,3283,2.45007),(22,3284,2.66007),(22,3285,2.52),(22,3286,2.73),(22,3287,0.93324),(22,3288,1.96),(22,3289,2.24),(22,3290,1.96),(22,3291,2.24),(22,3292,0.56),(22,3293,0.98),(22,3294,1.14331),(22,3295,1.05),(22,3296,1.16669),(22,3297,2.79972),(22,3298,9.3331),(22,3299,0.98),(22,3300,0.98),(22,3301,1.96),(22,3302,1.96),(22,3303,1.96),(22,3304,0.98),(22,3305,0.98),(22,3306,0.95669),(22,3307,1.12),(22,3308,0.84),(22,3309,2.19338),(22,3310,1.21331),(22,3311,1.19),(22,3312,1.68),(22,3313,3.00993),(22,3314,3.57),(22,3315,2.94),(22,3316,3.63993),(22,3317,0.56),(22,3318,0.91),(22,3319,1.12),(22,3320,1.02669),(22,3321,1.26),(22,3322,1.96),(22,3323,5.59986),(22,3324,6.43986),(22,3325,0.98),(22,3326,1.14331),(22,3327,4.66725),(22,3328,4.55),(22,3329,5.13345),(22,3330,0.86331),(22,3331,1.00331),(22,3332,1.72662),(22,3333,2.1),(22,3334,2.52),(22,3335,2.94),(22,3336,5.46),(22,3337,3.15),(22,3338,3.08007),(22,3339,4.43345),(22,3340,5.71655),(22,3341,2.73),(22,3342,3.29007),(22,3343,0.46662),(22,3344,1.96),(22,3345,2.05338),(22,3346,2.52),(22,3347,2.73),(22,3348,3.21993),(22,3349,2.87007),(22,3350,3.36),(22,3351,2.87007),(22,3352,3.36),(22,3353,5.32014),(22,3354,2.79993),(22,3355,3.00993),(22,3356,2.66007),(22,3357,3.15),(22,3358,0.46662),(22,3359,1.91338),(22,3360,2.24),(22,3361,0.56007),(22,3362,2.66007),(22,3363,3.00993),(22,3364,29.8704),(22,3365,137.266),(22,3366,135.59),(22,3367,4.2),(22,3368,4.9),(22,3369,0.74676),(22,3370,3.92),(22,3371,2.19338),(22,3372,2.14662),(22,3373,1.8669),(22,3374,4.55),(22,3375,4.10676),(22,3376,4.9),(22,3377,5.36655),(22,3378,2.09979),(22,3379,6.20683),(22,3380,6.53317),(22,3381,1.86662),(22,3382,2.1),(22,3383,1.39965),(22,3384,1.82),(22,3385,1.96),(22,3386,2.73),(22,3387,3.15),(22,3388,5.04),(22,3389,6.3),(22,3390,2.58993),(22,3391,2.87007),(22,3392,1.96014),(22,3393,4.9),(22,3394,5.48345),(22,3395,0.98),(22,3396,1.05),(22,3397,0.74662),(22,3398,1.00331),(22,3399,1.09669),(22,3400,1.14331),(22,3401,1.26),(22,3402,0.28),(22,3403,0.95669),(22,3404,1.14331),(22,3405,8.4),(22,3406,1.14331),(22,3407,1.23669),(22,3408,0.98),(22,3409,1.26),(22,3410,18.9),(22,3411,19.7404),(22,3412,1.12),(22,3413,0.91),(22,3414,1.02669),(22,3415,3.00993),(22,3416,3.42993),(22,3417,0.65338),(22,3418,2.1),(22,3419,1.16669),(22,3420,1.14331),(22,3421,4.43345),(22,3422,3.00993),(22,3423,1.07331),(22,3424,1.12),(22,3425,2.46679),(23,12,0.63996),(23,13,1.88004),(24,6,0.17),(24,12,0.63996),(24,13,1.88004),(24,17,0.23331),(24,1304,0.93324),(24,1305,1.00331),(24,3364,0.56007),(24,3365,2.58993),(24,3366,2.73),(24,3421,0.88669),(24,3791,2.79993),(24,3792,3.00993),(24,3830,0.23331),(24,3831,1.05),(24,3832,1.19),(24,3833,0.18669),(24,3834,0.86331),(24,3835,1.05),(24,3836,1.09669),(25,12,1.01327),(25,13,1.88004),(25,3346,1.68),(25,3364,0.37338),(25,3369,0.18669),(25,3383,0.65317),(25,3388,0.84),(25,3390,0.86331),(25,3933,0.23331),(25,3934,0.98),(25,3935,1.26),(25,3936,0.84),(25,3937,1.14331),(25,3938,1.23669),(25,3939,1.02669),(25,3940,1.19),(25,3941,0.91),(25,3942,1.00331),(25,3943,0.74662),(25,3944,1.07331),(25,3945,1.21331),(25,3946,1.12),(25,3947,1.19),(25,4154,1.09669),(25,4155,1.16669),(25,4156,0.93345),(25,4157,0.88669),(25,4158,0.95669),(25,4159,0.91),(25,4160,1.07331),(25,4161,0.93331),(25,4162,1.02669),(25,4163,0.88669),(25,4164,1.12),(25,4165,0.88669),(25,4166,1.09669),(25,4167,0.88669),(25,4168,1.00331),(25,4169,1.77338),(25,4170,2.14662),(25,4171,0.88669),(25,4172,0.95669),(25,4173,0.88669),(25,4174,1.00331),(25,4175,0.98),(25,4176,1.21331),(25,4177,1.05),(25,4178,1.12),(25,4179,0.95669),(25,4180,1.07331),(25,4181,0.88669),(25,4182,1.00331),(25,4183,0.88669),(25,4184,0.95669),(25,4185,0.95669),(25,4186,1.07331),(25,4187,0.86331),(25,4188,0.98),(25,4189,1.07331),(25,4190,1.28331),(25,4191,0.98),(25,4192,1.12),(25,4193,0.86331),(25,4194,0.95669),(25,4195,0.81669),(25,4196,1.09669),(25,4197,0.95669),(25,4198,0.95669),(25,4199,1.16669),(25,4200,0.98),(25,4201,0.84),(25,4202,0.93331),(25,4203,0.91),(25,4204,1.00331),(25,4205,0.84),(25,4206,1.02669),(26,8,0.17),(26,12,0.74662),(26,17,1.86648),(26,3346,0.14),(26,3383,0.27993),(26,3830,0.23331),(26,4156,0.18669),(26,4275,0.18669),(26,4276,0.86331),(26,4277,1.00331),(26,4344,1.09669),(26,4345,1.23669),(26,4346,0.86331),(26,4347,1.00331),(26,4348,1.02669),(26,4349,1.21331),(26,4350,0.23331),(26,4351,0.95669),(26,4352,1.05),(26,4353,0.93331),(26,4354,1.07331),(26,4355,0.86331),(26,4356,0.93331),(26,4357,0.93331),(26,4358,0.98),(26,4359,0.86331),(26,4360,0.98),(26,4361,0.88669),(26,4362,1.00331),(27,1222,0.32669),(27,1227,0.56007),(27,1262,0.42),(27,1265,0.18669),(27,1279,0.37338),(27,1317,0.46655),(27,1330,0.46662),(27,1333,0.09331),(27,1346,0.32669),(27,3312,0.28),(27,3317,0.56),(27,3322,1.12),(27,3402,0.28),(27,3412,0.28),(27,4433,1.12),(27,4434,1.21331),(27,4435,0.91),(27,4436,1.00331),(27,4437,0.93331),(27,4438,1.00331),(27,4439,0.91),(27,4440,1.07331),(27,4441,0.95669),(27,4442,1.19),(27,4443,0.91),(27,4444,1.00331),(27,4445,0.91),(27,4446,1.02669),(27,4447,0.88669),(27,4448,1.00331),(27,4449,0.88669),(27,4450,1.09669),(27,4451,0.86331),(27,4452,1.07331),(27,4453,0.88669),(27,4454,0.98),(27,4455,0.95669),(27,4456,1.14331),(27,4457,0.98),(27,4458,1.07331),(27,4459,0.93331),(27,4460,1.05),(27,4461,0.95669),(27,4462,1.12),(27,4463,0.91),(27,4464,1.02669),(27,4465,0.93331),(27,4466,1.12),(27,4650,0.91),(27,4651,1.02669),(27,4652,1.00331),(27,4653,1.16669),(27,4654,0.95669),(27,4655,1.19),(27,4656,0.88669),(27,4657,1.00331),(27,4658,0.98),(27,4659,1.09669),(27,4660,0.93331),(27,4661,1.02669),(27,4662,0.95669),(27,4663,1.23669),(27,4664,0.42),(27,4665,0.98),(27,4666,1.14331),(27,4667,1.00331),(27,4668,1.23669),(27,4669,1.07331),(27,4670,1.14331),(28,1222,0.32669),(28,1227,0.56007),(28,1262,0.42),(28,1265,0.18669),(28,1279,0.37338),(28,1317,0.46655),(28,1330,0.46662),(28,1333,0.09331),(28,1346,0.32669),(28,3312,0.28),(28,3317,0.56),(28,3322,1.12),(28,3402,0.28),(28,3412,0.28),(28,4433,1.12),(28,4434,1.21331),(28,4435,0.91),(28,4436,1.00331),(28,4437,0.93331),(28,4438,1.00331),(28,4439,0.91),(28,4440,1.07331),(28,4441,0.95669),(28,4442,1.19),(28,4443,0.91),(28,4444,1.00331),(28,4445,0.91),(28,4446,1.02669),(28,4447,0.88669),(28,4448,1.00331),(28,4449,0.88669),(28,4450,1.09669),(28,4451,0.86331),(28,4452,1.07331),(28,4453,0.88669),(28,4454,0.98),(28,4455,0.95669),(28,4456,1.14331),(28,4457,0.98),(28,4458,1.07331),(28,4459,0.93331),(28,4460,1.05),(28,4461,0.95669),(28,4462,1.12),(28,4463,0.91),(28,4464,1.02669),(28,4465,0.93331),(28,4466,1.12),(28,4650,0.91),(28,4651,1.02669),(28,4652,1.00331),(28,4653,1.16669),(28,4654,0.95669),(28,4655,1.19),(28,4656,0.88669),(28,4657,1.00331),(28,4658,0.98),(28,4659,1.09669),(28,4660,0.93331),(28,4661,1.02669),(28,4662,0.95669),(28,4663,1.23669),(28,4664,0.42),(28,4665,0.98),(28,4666,1.14331),(28,4667,1.00331),(28,4668,1.23669),(28,4669,1.07331),(28,4670,1.14331),(28,4718,0.74),(28,4719,5.05679),(29,1222,0.32669),(29,1227,0.56007),(29,1262,0.42),(29,1265,0.18669),(29,1279,0.37338),(29,1317,0.46655),(29,1330,0.46662),(29,1333,0.09331),(29,1346,0.32669),(29,3312,0.28),(29,3317,0.56),(29,3322,1.12),(29,3402,0.28),(29,3412,0.28),(29,4433,1.12),(29,4434,1.21331),(29,4435,0.91),(29,4436,1.00331),(29,4437,0.93331),(29,4438,1.00331),(29,4439,0.91),(29,4440,1.07331),(29,4441,0.95669),(29,4442,1.19),(29,4443,0.91),(29,4444,1.00331),(29,4445,0.91),(29,4446,1.02669),(29,4447,0.88669),(29,4448,1.00331),(29,4449,0.88669),(29,4450,1.09669),(29,4451,0.86331),(29,4452,1.07331),(29,4453,0.88669),(29,4454,0.98),(29,4455,0.95669),(29,4456,1.14331),(29,4457,0.98),(29,4458,1.07331),(29,4459,0.93331),(29,4460,1.05),(29,4461,0.95669),(29,4462,1.12),(29,4463,0.91),(29,4464,1.02669),(29,4465,0.93331),(29,4466,1.12),(29,4650,0.91),(29,4651,1.02669),(29,4652,1.00331),(29,4653,1.16669),(29,4654,0.95669),(29,4655,1.19),(29,4656,0.88669),(29,4657,1.00331),(29,4658,0.98),(29,4659,1.09669),(29,4660,0.93331),(29,4661,1.02669),(29,4662,0.95669),(29,4663,1.23669),(29,4664,0.42),(29,4665,0.98),(29,4666,1.14331),(29,4667,1.00331),(29,4668,1.23669),(29,4669,1.07331),(29,4670,1.14331),(30,1222,0.32669),(30,1227,0.56007),(30,1262,0.42),(30,1265,0.18669),(30,1279,0.37338),(30,1317,0.46655),(30,1330,0.46662),(30,1333,0.09331),(30,1346,0.32669),(30,3312,0.28),(30,3317,0.56),(30,3322,1.12),(30,3402,0.28),(30,3412,0.28),(30,4433,1.12),(30,4434,1.21331),(30,4435,0.91),(30,4436,1.00331),(30,4437,0.93331),(30,4438,1.00331),(30,4439,0.91),(30,4440,1.07331),(30,4441,0.95669),(30,4442,1.19),(30,4443,0.91),(30,4444,1.00331),(30,4445,0.91),(30,4446,1.02669),(30,4447,0.88669),(30,4448,1.00331),(30,4449,0.88669),(30,4450,1.09669),(30,4451,0.86331),(30,4452,1.07331),(30,4453,0.88669),(30,4454,0.98),(30,4455,0.95669),(30,4456,1.14331),(30,4457,0.98),(30,4458,1.07331),(30,4459,0.93331),(30,4460,1.05),(30,4461,0.95669),(30,4462,1.12),(30,4463,0.91),(30,4464,1.02669),(30,4465,0.93331),(30,4466,1.12),(30,4650,0.91),(30,4651,1.02669),(30,4652,1.00331),(30,4653,1.16669),(30,4654,0.95669),(30,4655,1.19),(30,4656,0.88669),(30,4657,1.00331),(30,4658,0.98),(30,4659,1.09669),(30,4660,0.93331),(30,4661,1.02669),(30,4662,0.95669),(30,4663,1.23669),(30,4664,0.42),(30,4665,0.98),(30,4666,1.14331),(30,4667,1.00331),(30,4668,1.23669),(30,4669,1.07331),(30,4670,1.14331),(30,4718,0.74),(30,4719,5.05679),(31,1222,0.32669),(31,1227,0.56007),(31,1262,0.42),(31,1265,0.18669),(31,1279,0.37338),(31,1317,0.46655),(31,1330,0.46662),(31,1333,0.09331),(31,1346,0.32669),(31,3312,0.28),(31,3317,0.56),(31,3322,1.12),(31,3402,0.28),(31,3412,0.28),(31,4433,1.12),(31,4434,1.21331),(31,4435,0.91),(31,4436,1.00331),(31,4437,0.93331),(31,4438,1.00331),(31,4439,0.91),(31,4440,1.07331),(31,4441,0.95669),(31,4442,1.19),(31,4443,0.91),(31,4444,1.00331),(31,4445,0.91),(31,4446,1.02669),(31,4447,0.88669),(31,4448,1.00331),(31,4449,0.88669),(31,4450,1.09669),(31,4451,0.86331),(31,4452,1.07331),(31,4453,0.88669),(31,4454,0.98),(31,4455,0.95669),(31,4456,1.14331),(31,4457,0.98),(31,4458,1.07331),(31,4459,0.93331),(31,4460,1.05),(31,4461,0.95669),(31,4462,1.12),(31,4463,0.91),(31,4464,1.02669),(31,4465,0.93331),(31,4466,1.12),(31,4650,0.91),(31,4651,1.02669),(31,4652,1.00331),(31,4653,1.16669),(31,4654,0.95669),(31,4655,1.19),(31,4656,0.88669),(31,4657,1.00331),(31,4658,0.98),(31,4659,1.09669),(31,4660,0.93331),(31,4661,1.02669),(31,4662,0.95669),(31,4663,1.23669),(31,4664,0.42),(31,4665,0.98),(31,4666,1.14331),(31,4667,1.00331),(31,4668,1.23669),(31,4669,1.07331),(31,4670,1.14331),(32,1222,0.32669),(32,1227,0.56007),(32,1262,0.42),(32,1265,0.18669),(32,1279,0.37338),(32,1317,0.46655),(32,1330,0.46662),(32,1333,0.09331),(32,1346,0.32669),(32,3312,0.28),(32,3317,0.56),(32,3322,1.12),(32,3402,0.28),(32,3412,0.28),(32,4433,1.12),(32,4434,1.21331),(32,4435,0.91),(32,4436,1.00331),(32,4437,0.93331),(32,4438,1.00331),(32,4439,0.91),(32,4440,1.07331),(32,4441,0.95669),(32,4442,1.19),(32,4443,0.91),(32,4444,1.00331),(32,4445,0.91),(32,4446,1.02669),(32,4447,0.88669),(32,4448,1.00331),(32,4449,0.88669),(32,4450,1.09669),(32,4451,0.86331),(32,4452,1.07331),(32,4453,0.88669),(32,4454,0.98),(32,4455,0.95669),(32,4456,1.14331),(32,4457,0.98),(32,4458,1.07331),(32,4459,0.93331),(32,4460,1.05),(32,4461,0.95669),(32,4462,1.12),(32,4463,0.91),(32,4464,1.02669),(32,4465,0.93331),(32,4466,1.12),(32,4650,0.91),(32,4651,1.02669),(32,4652,1.00331),(32,4653,1.16669),(32,4654,0.95669),(32,4655,1.19),(32,4656,0.88669),(32,4657,1.00331),(32,4658,0.98),(32,4659,1.09669),(32,4660,0.93331),(32,4661,1.02669),(32,4662,0.95669),(32,4663,1.23669),(32,4664,0.42),(32,4665,0.98),(32,4666,1.14331),(32,4667,1.00331),(32,4668,1.23669),(32,4669,1.07331),(32,4670,1.14331),(33,1222,0.32669),(33,1227,0.56007),(33,1262,0.42),(33,1265,0.18669),(33,1279,0.37338),(33,1317,0.46655),(33,1330,0.46662),(33,1333,0.09331),(33,1346,0.32669),(33,3312,0.28),(33,3317,0.56),(33,3322,1.12),(33,3402,0.28),(33,3412,0.28),(33,4433,1.12),(33,4434,1.21331),(33,4435,0.91),(33,4436,1.00331),(33,4437,0.93331),(33,4438,1.00331),(33,4439,0.91),(33,4440,1.07331),(33,4441,0.95669),(33,4442,1.19),(33,4443,0.91),(33,4444,1.00331),(33,4445,0.91),(33,4446,1.02669),(33,4447,0.88669),(33,4448,1.00331),(33,4449,0.88669),(33,4450,1.09669),(33,4451,0.86331),(33,4452,1.07331),(33,4453,0.88669),(33,4454,0.98),(33,4455,0.95669),(33,4456,1.14331),(33,4457,0.98),(33,4458,1.07331),(33,4459,0.93331),(33,4460,1.05),(33,4461,0.95669),(33,4462,1.12),(33,4463,0.91),(33,4464,1.02669),(33,4465,0.93331),(33,4466,1.12),(33,4650,0.91),(33,4651,1.02669),(33,4652,1.00331),(33,4653,1.16669),(33,4654,0.95669),(33,4655,1.19),(33,4656,0.88669),(33,4657,1.00331),(33,4658,0.98),(33,4659,1.09669),(33,4660,0.93331),(33,4661,1.02669),(33,4662,0.95669),(33,4663,1.23669),(33,4664,0.42),(33,4665,0.98),(33,4666,1.14331),(33,4667,1.00331),(33,4668,1.23669),(33,4669,1.07331),(33,4670,1.14331),(34,1222,0.32669),(34,1227,0.56007),(34,1262,0.42),(34,1265,0.18669),(34,1279,0.37338),(34,1317,0.46655),(34,1330,0.46662),(34,1333,0.09331),(34,1346,0.32669),(34,3312,0.28),(34,3317,0.56),(34,3322,1.12),(34,3402,0.28),(34,3412,0.28),(34,4433,1.12),(34,4434,1.21331),(34,4435,0.91),(34,4436,1.00331),(34,4437,0.93331),(34,4438,1.00331),(34,4439,0.91),(34,4440,1.07331),(34,4441,0.95669),(34,4442,1.19),(34,4443,0.91),(34,4444,1.00331),(34,4445,0.91),(34,4446,1.02669),(34,4447,0.88669),(34,4448,1.00331),(34,4449,0.88669),(34,4450,1.09669),(34,4451,0.86331),(34,4452,1.07331),(34,4453,0.88669),(34,4454,0.98),(34,4455,0.95669),(34,4456,1.14331),(34,4457,0.98),(34,4458,1.07331),(34,4459,0.93331),(34,4460,1.05),(34,4461,0.95669),(34,4462,1.12),(34,4463,0.91),(34,4464,1.02669),(34,4465,0.93331),(34,4466,1.12),(34,4650,0.91),(34,4651,1.02669),(34,4652,1.00331),(34,4653,1.16669),(34,4654,0.95669),(34,4655,1.19),(34,4656,0.88669),(34,4657,1.00331),(34,4658,0.98),(34,4659,1.09669),(34,4660,0.93331),(34,4661,1.02669),(34,4662,0.95669),(34,4663,1.23669),(34,4664,0.42),(34,4665,0.98),(34,4666,1.14331),(34,4667,1.00331),(34,4668,1.23669),(34,4669,1.07331),(34,4670,1.14331),(35,1222,0.32669),(35,1227,0.56007),(35,1262,0.42),(35,1265,0.18669),(35,1279,0.37338),(35,1317,0.46655),(35,1330,0.46662),(35,1333,0.09331),(35,1346,0.32669),(35,3312,0.28),(35,3317,0.56),(35,3322,1.12),(35,3402,0.28),(35,3412,0.28),(35,4433,1.12),(35,4434,1.21331),(35,4435,0.91),(35,4436,1.00331),(35,4437,0.93331),(35,4438,1.00331),(35,4439,0.91),(35,4440,1.07331),(35,4441,0.95669),(35,4442,1.19),(35,4443,0.91),(35,4444,1.00331),(35,4445,0.91),(35,4446,1.02669),(35,4447,0.88669),(35,4448,1.00331),(35,4449,0.88669),(35,4450,1.09669),(35,4451,0.86331),(35,4452,1.07331),(35,4453,0.88669),(35,4454,0.98),(35,4455,0.95669),(35,4456,1.14331),(35,4457,0.98),(35,4458,1.07331),(35,4459,0.93331),(35,4460,1.05),(35,4461,0.95669),(35,4462,1.12),(35,4463,0.91),(35,4464,1.02669),(35,4465,0.93331),(35,4466,1.12),(35,4650,0.91),(35,4651,1.02669),(35,4652,1.00331),(35,4653,1.16669),(35,4654,0.95669),(35,4655,1.19),(35,4656,0.88669),(35,4657,1.00331),(35,4658,0.98),(35,4659,1.09669),(35,4660,0.93331),(35,4661,1.02669),(35,4662,0.95669),(35,4663,1.23669),(35,4664,0.42),(35,4665,0.98),(35,4666,1.14331),(35,4667,1.00331),(35,4668,1.23669),(35,4669,1.07331),(35,4670,1.14331),(36,12,0.74662),(36,17,0.63327),(36,3346,0.14),(36,3383,0.27993),(36,3830,0.23331),(36,4156,0.18669),(36,4275,0.18669),(36,4276,0.86331),(36,4277,1.00331),(36,4344,1.09669),(36,4345,1.23669),(36,4346,0.86331),(36,4347,1.00331),(36,4348,1.02669),(36,4349,1.21331),(36,4350,0.23331),(36,4351,0.95669),(36,4352,1.05),(36,4353,0.93331),(36,4354,1.07331),(36,4355,0.86331),(36,4356,0.93331),(36,4357,0.93331),(36,4358,0.98),(36,4359,0.86331),(36,4360,0.98),(36,4361,0.88669),(36,4362,1.00331),(37,12,0.74662),(37,17,0.63327),(37,3346,0.14),(37,3383,0.27993),(37,3830,0.23331),(37,4156,0.18669),(37,4275,0.18669),(37,4276,0.86331),(37,4277,1.00331),(37,4344,1.09669),(37,4345,1.23669),(37,4346,0.86331),(37,4347,1.00331),(37,4348,1.02669),(37,4349,1.21331),(37,4350,0.23331),(37,4351,0.95669),(37,4352,1.05),(37,4353,0.93331),(37,4354,1.07331),(37,4355,0.86331),(37,4356,0.93331),(37,4357,0.93331),(37,4358,0.98),(37,4359,0.86331),(37,4360,0.98),(37,4361,0.88669),(37,4362,1.00331),(38,12,0.74662),(38,17,0.63327),(38,3346,0.14),(38,3383,0.27993),(38,3830,0.23331),(38,4156,0.18669),(38,4275,0.18669),(38,4276,0.86331),(38,4277,1.00331),(38,4344,1.09669),(38,4345,1.23669),(38,4346,0.86331),(38,4347,1.00331),(38,4348,1.02669),(38,4349,1.21331),(38,4350,0.23331),(38,4351,0.95669),(38,4352,1.05),(38,4353,0.93331),(38,4354,1.07331),(38,4355,0.86331),(38,4356,0.93331),(38,4357,0.93331),(38,4358,0.98),(38,4359,0.86331),(38,4360,0.98),(38,4361,0.88669),(38,4362,1.00331),(39,12,1.01327),(39,13,1.88004),(39,1227,0.93345),(39,1265,0.37338),(39,1295,0.18669),(39,1308,0.14),(39,1317,0.09331),(39,1326,0.91),(39,1327,1.00331),(39,1330,0.23331),(39,1333,0.27993),(39,1346,0.98007),(39,3322,1.12),(39,3364,0.37338),(39,4439,1.82),(39,4795,1.86662),(39,4796,1.02669),(39,4797,1.07331),(39,4798,0.93331),(39,4799,1.09669),(39,4800,2.14662),(39,4801,1.77338),(39,4802,1.91338),(39,4803,0.93331),(39,4804,1.00331),(39,4805,0.84),(39,4806,1.05),(39,4807,0.95669),(39,4808,1.05),(39,4809,2.52),(39,4810,0.98),(39,4811,0.95669),(39,4812,0.98),(39,4813,1.14331),(39,4814,2.05338),(39,4815,1.26),(39,4816,1.12),(39,4969,1.05),(39,4970,1.26),(39,4971,4.29324),(39,4972,2.61338),(39,4973,1.21331),(39,4974,1.23669),(39,4975,0.91),(39,4976,1.00331),(39,4977,1.00331),(39,4978,1.16669),(40,1222,0.32669),(40,1227,0.74676),(40,1262,0.42),(40,1265,0.93345),(40,1271,0.88669),(40,1279,0.74676),(40,1290,0.56007),(40,1308,0.14),(40,1317,0.27993),(40,1326,0.91),(40,1327,1.00331),(40,1333,0.27993),(40,1346,0.32669),(40,3312,0.56),(40,3317,0.56),(40,3322,0.56),(40,3402,0.56),(40,3405,0.42),(40,3412,0.28),(40,4439,0.91),(40,4664,0.84),(40,5108,1.00331),(40,5109,1.09669),(40,5110,0.93331),(40,5111,1.16669),(40,5112,0.91),(40,5113,1.14331),(40,5114,1.02669),(40,5115,1.16669),(40,5116,1.02669),(40,5117,1.02669),(40,5118,1.26),(40,5119,0.84),(40,5120,1.00331),(40,5121,0.93331),(40,5122,1.00331),(40,5123,0.88669),(40,5124,1.00331),(40,5125,1.02669),(40,5126,0.93331),(40,5127,1.02669),(40,5128,0.86331),(40,5129,1.00331),(40,5130,0.91),(40,5131,1.14331),(40,5132,1.02669),(40,5133,1.28331),(40,5134,0.91),(40,5135,1.07331),(40,5136,0.86331),(40,5137,1.09669),(40,5138,0.98),(40,5139,1.16669),(40,5140,0.98),(40,5141,1.07331),(40,5142,0.86331),(40,5143,0.98),(40,5144,1.00331),(40,5145,1.09669),(40,5146,0.98),(40,5147,1.12),(40,5148,0.84),(40,5149,0.95669),(40,5150,0.86331),(40,5151,1.09669),(40,5152,1.00331),(40,5153,1.12),(40,5154,1.05),(40,5155,1.19),(40,5413,0.98),(40,5414,1.12),(40,5415,0.93331),(40,5416,1.12),(40,5417,1.07331),(40,5418,1.21331),(40,5419,1.05),(40,5420,1.19),(40,5421,0.91),(40,5422,1.00331),(40,5423,1.00331),(40,5424,1.16669),(40,5425,1.14331),(40,5426,1.26),(40,5427,1.05),(40,5428,1.23669),(40,5429,0.98),(40,5430,1.07331),(40,5431,0.98),(40,5432,1.16669),(40,5433,1.05),(40,5434,1.14331),(40,5435,1.14331),(40,5436,1.30669),(41,1222,0.32669),(41,1227,0.74676),(41,1262,0.42),(41,1265,0.93345),(41,1271,0.88669),(41,1279,0.74676),(41,1290,0.56007),(41,1308,0.14),(41,1317,0.27993),(41,1326,0.91),(41,1327,1.00331),(41,1333,0.27993),(41,1346,0.32669),(41,3312,0.56),(41,3317,0.56),(41,3322,0.56),(41,3402,0.56),(41,3405,0.42),(41,3412,0.28),(41,4439,0.91),(41,4664,0.84),(41,5108,1.00331),(41,5109,1.09669),(41,5110,0.93331),(41,5111,1.16669),(41,5112,0.91),(41,5113,1.14331),(41,5114,1.02669),(41,5115,1.16669),(41,5116,1.02669),(41,5117,1.02669),(41,5118,1.26),(41,5119,0.84),(41,5120,1.00331),(41,5121,0.93331),(41,5122,1.00331),(41,5123,0.88669),(41,5124,1.00331),(41,5125,1.02669),(41,5126,0.93331),(41,5127,1.02669),(41,5128,0.86331),(41,5129,1.00331),(41,5130,0.91),(41,5131,1.14331),(41,5132,1.02669),(41,5133,1.28331),(41,5134,0.91),(41,5135,1.07331),(41,5136,0.86331),(41,5137,1.09669),(41,5138,0.98),(41,5139,1.16669),(41,5140,0.98),(41,5141,1.07331),(41,5142,0.86331),(41,5143,0.98),(41,5144,1.00331),(41,5145,1.09669),(41,5146,0.98),(41,5147,1.12),(41,5148,0.84),(41,5149,0.95669),(41,5150,0.86331),(41,5151,1.09669),(41,5152,1.00331),(41,5153,1.12),(41,5154,1.05),(41,5155,1.19),(41,5413,0.98),(41,5414,1.12),(41,5415,0.93331),(41,5416,1.12),(41,5417,1.07331),(41,5418,1.21331),(41,5419,1.05),(41,5420,1.19),(41,5421,0.91),(41,5422,1.00331),(41,5423,1.00331),(41,5424,1.16669),(41,5425,1.14331),(41,5426,1.26),(41,5427,1.05),(41,5428,1.23669),(41,5429,0.98),(41,5430,1.07331),(41,5431,0.98),(41,5432,1.16669),(41,5433,1.05),(41,5434,1.14331),(41,5435,1.14331),(41,5436,1.30669),(42,1222,0.32669),(42,1227,0.74676),(42,1262,0.42),(42,1265,0.93345),(42,1271,0.88669),(42,1279,0.74676),(42,1290,0.56007),(42,1308,0.14),(42,1317,0.27993),(42,1326,0.91),(42,1327,1.00331),(42,1333,0.27993),(42,1346,0.32669),(42,3312,0.56),(42,3317,0.56),(42,3322,0.56),(42,3402,0.56),(42,3405,0.42),(42,3412,0.28),(42,4439,0.91),(42,4664,0.84),(42,5108,1.00331),(42,5109,1.09669),(42,5110,0.93331),(42,5111,1.16669),(42,5112,0.91),(42,5113,1.14331),(42,5114,1.02669),(42,5115,1.16669),(42,5116,1.02669),(42,5117,1.02669),(42,5118,1.26),(42,5119,0.84),(42,5120,1.00331),(42,5121,0.93331),(42,5122,1.00331),(42,5123,0.88669),(42,5124,1.00331),(42,5125,1.02669),(42,5126,0.93331),(42,5127,1.02669),(42,5128,0.86331),(42,5129,1.00331),(42,5130,0.91),(42,5131,1.14331),(42,5132,1.02669),(42,5133,1.28331),(42,5134,0.91),(42,5135,1.07331),(42,5136,0.86331),(42,5137,1.09669),(42,5138,0.98),(42,5139,1.16669),(42,5140,0.98),(42,5141,1.07331),(42,5142,0.86331),(42,5143,0.98),(42,5144,1.00331),(42,5145,1.09669),(42,5146,0.98),(42,5147,1.12),(42,5148,0.84),(42,5149,0.95669),(42,5150,0.86331),(42,5151,1.09669),(42,5152,1.00331),(42,5153,1.12),(42,5154,1.05),(42,5155,1.19),(42,5413,0.98),(42,5414,1.12),(42,5415,0.93331),(42,5416,1.12),(42,5417,1.07331),(42,5418,1.21331),(42,5419,1.05),(42,5420,1.19),(42,5421,0.91),(42,5422,1.00331),(42,5423,1.00331),(42,5424,1.16669),(42,5425,1.14331),(42,5426,1.26),(42,5427,1.05),(42,5428,1.23669),(42,5429,0.98),(42,5430,1.07331),(42,5431,0.98),(42,5432,1.16669),(42,5433,1.05),(42,5434,1.14331),(42,5435,1.14331),(42,5436,1.30669),(43,12,1.01327),(43,13,1.88004),(43,3346,1.12),(43,3364,0.56007),(43,3383,0.65317),(43,3943,1.11993),(43,4156,0.56007),(43,4165,0.88669),(43,4187,0.86331),(43,4188,0.98),(43,4205,0.84),(43,5569,1.86662),(43,5570,1.02669),(43,5571,1.00331),(43,5572,0.98),(43,5573,1.07331),(43,5574,0.28),(43,5685,1.05),(43,5686,1.12),(43,5687,0.84),(43,5688,1.00331),(43,5689,1.14331),(43,5690,1.02669),(43,5691,1.21331),(43,5692,0.28),(43,5693,0.91),(43,5694,1.02669),(43,5695,0.88669),(43,5696,1.02669),(43,5697,1.00331),(43,5698,1.21331),(43,5699,1.12),(43,5700,0.88669),(43,5701,1.05),(43,5702,0.86331),(43,5703,0.95669),(43,5704,0.91),(43,5705,1.02669),(43,5706,0.91),(43,5707,1.00331),(43,5708,0.86331),(43,5709,0.95669),(43,5710,0.91),(43,5711,1.09669),(43,5712,0.91),(43,5713,1.05),(43,5714,0.23331),(43,5715,0.88669),(43,5716,1.07331),(43,5717,0.18669),(43,5718,1.00331),(43,5719,1.12),(43,5720,0.23331),(43,5721,0.88669),(43,5722,1.02669),(43,5723,0.98),(43,5724,1.21331),(43,5725,0.93331),(43,5726,1.05),(43,5727,0.86331),(43,5728,1.05),(43,5729,0.86331),(43,5730,0.98),(43,5731,0.86331),(43,5732,1.02669),(43,5733,0.93331),(43,5734,1.00331),(43,5735,0.98),(43,5736,2.58993),(43,5737,1.05),(43,5738,1.00331),(43,5739,0.93331),(44,12,0.63996),(44,13,1.88004),(44,1222,0.32669),(44,1227,1.30683),(44,1265,0.74676),(44,1273,1.05),(44,1290,0.74676),(44,1308,0.56),(44,1317,0.27993),(44,1326,1.82),(44,1327,2.00662),(44,1333,0.18662),(44,1346,0.65338),(44,3312,0.28),(44,3322,0.28),(44,3402,0.28),(44,4439,0.91),(44,4798,1.86662),(44,4799,2.19338),(44,4800,1.07331),(44,4805,0.84),(44,4806,1.05),(44,4809,1.68),(44,4810,0.98),(44,4811,0.95669),(44,4814,2.05338),(44,4815,1.26),(44,4971,1.07331),(44,5827,0.98),(44,5828,1.09669),(44,5829,2.94),(44,5830,3.29007),(44,5831,0.91),(44,5832,1.00331),(44,5833,0.93331),(44,5834,1.21331),(44,5835,0.95669),(44,5836,1.00331),(44,5837,1.12),(44,5838,0.98),(44,5839,1.19),(44,5840,0.84),(44,5841,0.95669),(44,5842,3.08007),(44,5843,3.57),(44,5844,2.58993),(44,5845,3.15),(44,5846,0.88669),(44,5847,1.02669),(44,5848,1.16669),(44,5958,0.91),(44,5959,1.07331),(44,5960,1.19),(44,5961,1.00331),(44,5962,1.28331),(45,3346,1.12),(45,3364,0.18669),(45,3383,0.77314),(45,4156,0.18669),(45,4183,0.88669),(45,4205,0.84),(45,5720,0.23331),(45,6140,0.28),(45,6141,0.95669),(45,6142,1.07331),(45,6143,0.51331),(45,6144,1.19),(45,6145,1.30669),(45,6146,0.42),(45,6147,1.21331),(45,6148,1.37669),(45,6149,0.18669),(45,6150,0.95669),(45,6151,1.16669),(45,6152,0.23331),(45,6153,0.98),(45,6154,1.05),(45,6155,0.46669),(45,6156,1.00331),(45,6157,1.12),(45,6158,0.46669),(45,6159,1.02669),(45,6160,1.12),(45,6161,0.60669),(45,6162,1.16669),(45,6163,1.26),(45,6164,0.42),(45,6165,1.00331),(45,6166,1.07331),(45,6412,0.37338),(45,6413,1.00331),(45,6414,1.23669),(45,6415,0.88669),(45,6416,0.95669),(45,6417,0.23331),(45,6418,0.91),(45,6419,1.00331),(45,6420,0.18669),(45,6421,0.95669),(45,6422,1.05),(45,6423,0.18669),(45,6424,0.86331),(45,6425,1.09669),(45,6426,0.37338),(45,6427,0.84),(45,6428,0.95669),(45,6429,0.91),(45,6430,1.07331),(45,6431,1.05),(45,6432,1.14331),(45,6433,1.09669),(45,6434,1.16669),(45,6435,1.02669),(45,6436,1.09669),(45,6437,1.02669),(45,6438,1.12),(45,6439,0.88669),(45,6440,1.09669),(45,6441,0.86331),(45,6442,1.02669),(45,6443,0.88669),(45,6444,1.02669),(45,6445,0.91),(45,6446,1.19),(45,6447,1.14331),(45,6448,0.88669),(45,6449,1.00331),(45,6450,0.23331),(45,6451,0.98),(45,6452,0.37331),(45,6453,0.98),(45,6454,1.23669),(45,6455,0.51331),(45,6456,1.26),(45,6457,1.4),(45,6458,0.95669),(45,6459,1.00331),(45,6460,0.23331),(45,6461,0.91),(45,6462,1.07331),(45,6463,0.42),(45,6464,0.98),(45,6465,1.12),(45,6466,4.81),(45,6467,0.86331),(45,6468,1.07331),(45,6469,0.95669),(45,6470,0.86331),(45,6471,1.12),(46,1222,0.32669),(46,1227,0.37338),(46,1262,0.42),(46,1265,0.18669),(46,1279,1.12014),(46,1290,0.37338),(46,1295,0.74676),(46,1308,0.28),(46,1317,0.55986),(46,1324,0.91),(46,1330,0.23331),(46,1333,0.46655),(46,1334,0.98),(46,3317,0.56),(46,3322,0.28),(46,3346,0.42),(46,3383,0.18662),(46,3402,1.12),(46,3405,0.42),(46,3412,1.12),(46,4664,1.26),(46,4805,0.84),(46,5714,0.46662),(46,6445,0.91),(46,6463,0.42),(46,6464,0.98),(46,6684,0.14007),(46,6685,2.79993),(46,6686,1.14331),(46,6687,1.14331),(46,6688,1.07331),(46,6689,1.02669),(46,6690,1.09669),(46,6691,0.91),(46,6692,1.02669),(46,6693,0.93331),(46,6694,1.05),(46,6695,0.98),(46,6696,1.09669),(46,6697,0.95669),(46,6698,1.14331),(46,6699,0.32669),(46,6700,1.07331),(46,6701,1.30669),(46,6702,0.91),(46,6703,0.98),(46,6704,1.02669),(46,6705,1.19),(46,6706,0.95669),(46,6707,1.07331),(46,6708,0.95669),(46,6709,1.07331),(46,6710,0.95669),(46,6711,1.09669),(46,6712,0.86331),(46,6713,1.07331),(46,6714,0.91),(46,6715,1.07331),(46,6716,0.95669),(46,6717,1.19),(46,6718,0.98),(46,6719,1.19),(46,6720,1.07331),(46,6721,1.26),(46,6722,0.86331),(46,6723,1.09669),(46,6724,1.00331),(46,6725,1.07331),(46,6726,1.00331),(46,6727,0.88669),(46,6728,0.98),(46,6729,0.98),(46,6730,1.91338),(46,6731,1.12),(46,6732,1.07331),(46,6733,0.93331),(46,6734,1.02669),(46,6735,0.88669),(46,6736,1.09669),(46,6737,0.91),(46,6738,1.09669),(46,6739,0.88669),(46,6740,1.00331),(46,6741,0.81669),(46,6742,0.98),(46,6743,1.07331),(46,6744,0.88669),(46,6745,0.95669),(46,6746,0.95669),(46,6747,1.09669),(46,6748,0.91),(46,6749,0.98),(46,7117,0.46669),(46,7118,1.02669),(46,7119,1.23669),(46,7120,0.98),(46,7121,1.28331),(46,7122,0.91),(46,7123,1.14331),(46,7124,0.91),(46,7125,1.05),(46,7126,1.07331),(46,7127,1.26),(46,7128,1.19),(46,7129,0.91),(46,7130,1.02669),(46,7131,1.96),(46,7132,2.42662),(46,7133,1.02669),(46,7134,0.98),(46,7135,1.09669),(46,7136,1.05),(46,7137,1.12),(46,7138,1.12),(46,7139,1.28331),(46,7140,1.77338),(46,7141,2.1),(46,7142,0.95669),(46,7143,1.02669),(46,7144,1.02669),(46,7145,1.16669),(46,7146,0.95669),(46,7147,1.16669),(46,7148,1.00331),(46,7149,1.09669),(46,7150,1.12),(46,7151,1.26),(46,7152,1.02669),(46,7153,1.09669),(46,7154,1.00331),(46,7155,1.07331),(46,7156,1.02669),(46,7157,1.19),(47,1222,0.32669),(47,1227,0.56007),(47,1262,0.84),(47,1265,0.37338),(47,1273,1.05),(47,1279,1.12014),(47,1290,0.37338),(47,1295,0.93345),(47,1308,0.28),(47,1317,0.65317),(47,1324,0.91),(47,1330,0.23331),(47,1333,0.46655),(47,1334,0.98),(47,3317,0.56),(47,3322,0.28),(47,3402,1.4),(47,3405,0.42),(47,3412,1.12),(47,4664,1.26),(47,4805,0.84),(47,6689,1.02669),(47,6690,1.09669),(47,6691,1.82),(47,6692,1.02669),(47,6693,0.93331),(47,6694,1.05),(47,6695,0.98),(47,6696,1.09669),(47,6697,0.95669),(47,6698,1.14331),(47,6702,0.91),(47,6703,0.98),(47,6704,1.02669),(47,6705,1.19),(47,6706,0.95669),(47,6707,1.07331),(47,6708,0.95669),(47,6709,1.07331),(47,6710,0.95669),(47,6711,1.09669),(47,6712,0.86331),(47,6713,1.07331),(47,6714,0.91),(47,6715,1.07331),(47,6716,0.95669),(47,6717,1.19),(47,6718,0.98),(47,6719,1.19),(47,6720,1.07331),(47,6721,1.26),(47,6722,0.86331),(47,6723,1.09669),(47,6724,1.00331),(47,6725,1.07331),(47,6726,1.00331),(47,6727,0.88669),(47,6728,0.98),(47,6729,0.98),(47,6730,1.91338),(47,6731,1.12),(47,6732,1.07331),(47,6733,0.93331),(47,6734,1.02669),(47,6735,0.88669),(47,6736,1.09669),(47,6737,0.91),(47,6738,1.09669),(47,6739,0.88669),(47,6740,1.00331),(47,6741,0.81669),(47,6742,0.98),(47,6743,1.07331),(47,6744,0.88669),(47,6745,0.95669),(47,6746,0.95669),(47,6747,1.09669),(47,6748,0.91),(47,6749,0.98),(47,7120,0.98),(47,7121,1.28331),(47,7122,0.91),(47,7123,1.14331),(47,7124,0.91),(47,7125,1.05),(47,7134,0.98),(47,7135,1.09669),(47,7136,1.05),(47,7137,1.12),(47,7138,1.12),(47,7139,1.28331),(47,7142,0.95669),(47,7143,1.02669),(47,7144,1.02669),(47,7145,1.16669),(47,7146,0.95669),(47,7147,1.16669),(47,7148,1.00331),(47,7149,1.09669),(47,7150,1.12),(47,7151,1.26),(47,7152,1.02669),(47,7153,1.09669),(47,7154,1.00331),(47,7155,1.07331),(47,7156,1.02669),(47,7157,1.19),(47,7262,1.07331),(47,7263,1.23669),(47,7264,1.14331),(47,7265,0.91),(47,7266,1.09669),(47,7267,0.91),(47,7268,1.00331),(47,7297,1.00331),(47,7298,1.07331),(48,1222,0.32669),(48,1227,0.56007),(48,1262,0.84),(48,1265,0.37338),(48,1273,1.05),(48,1279,1.12014),(48,1290,0.37338),(48,1295,0.93345),(48,1308,0.28),(48,1317,0.65317),(48,1324,0.91),(48,1330,0.23331),(48,1333,0.46655),(48,1334,0.98),(48,3317,0.56),(48,3322,0.28),(48,3402,1.4),(48,3405,0.42),(48,3412,1.12),(48,4664,1.26),(48,4805,0.84),(48,6689,1.02669),(48,6690,1.09669),(48,6691,1.82),(48,6692,1.02669),(48,6693,0.93331),(48,6694,1.05),(48,6695,0.98),(48,6696,1.09669),(48,6697,0.95669),(48,6698,1.14331),(48,6702,0.91),(48,6703,0.98),(48,6704,1.02669),(48,6705,1.19),(48,6706,0.95669),(48,6707,1.07331),(48,6708,0.95669),(48,6709,1.07331),(48,6710,0.95669),(48,6711,1.09669),(48,6712,0.86331),(48,6713,1.07331),(48,6714,0.91),(48,6715,1.07331),(48,6716,0.95669),(48,6717,1.19),(48,6718,0.98),(48,6719,1.19),(48,6720,1.07331),(48,6721,1.26),(48,6722,0.86331),(48,6723,1.09669),(48,6724,1.00331),(48,6725,1.07331),(48,6726,1.00331),(48,6727,0.88669),(48,6728,0.98),(48,6729,0.98),(48,6730,1.91338),(48,6731,1.12),(48,6732,1.07331),(48,6733,0.93331),(48,6734,1.02669),(48,6735,0.88669),(48,6736,1.09669),(48,6737,0.91),(48,6738,1.09669),(48,6739,0.88669),(48,6740,1.00331),(48,6741,0.81669),(48,6742,0.98),(48,6743,1.07331),(48,6744,0.88669),(48,6745,0.95669),(48,6746,0.95669),(48,6747,1.09669),(48,6748,0.91),(48,6749,0.98),(48,7120,0.98),(48,7121,1.28331),(48,7122,0.91),(48,7123,1.14331),(48,7124,0.91),(48,7125,1.05),(48,7134,0.98),(48,7135,1.09669),(48,7136,1.05),(48,7137,1.12),(48,7138,1.12),(48,7139,1.28331),(48,7142,0.95669),(48,7143,1.02669),(48,7144,1.02669),(48,7145,1.16669),(48,7146,0.95669),(48,7147,1.16669),(48,7148,1.00331),(48,7149,1.09669),(48,7150,1.12),(48,7151,1.26),(48,7152,1.02669),(48,7153,1.09669),(48,7154,1.00331),(48,7155,1.07331),(48,7156,1.02669),(48,7157,1.19),(48,7262,1.07331),(48,7263,1.23669),(48,7264,1.14331),(48,7265,0.91),(48,7266,1.09669),(48,7267,0.91),(48,7268,1.00331),(48,7297,1.00331),(48,7298,1.07331),(49,1222,0.32669),(49,1265,0.18669),(49,1279,1.30683),(49,1295,0.93345),(49,1308,0.28),(49,1317,0.55986),(49,1330,0.46662),(49,1333,0.37324),(49,1334,1.96),(49,3317,0.84),(49,3346,0.7),(49,3364,0.18669),(49,3383,0.27993),(49,3388,0.84),(49,3402,1.68),(49,3412,1.4),(49,4664,0.84),(49,5714,0.46662),(49,6689,1.02669),(49,6690,1.09669),(49,6697,0.95669),(49,6698,1.14331),(49,6702,0.91),(49,6703,0.98),(49,6704,1.02669),(49,6705,1.19),(49,6706,1.91338),(49,6707,2.14662),(49,6710,0.95669),(49,6711,1.09669),(49,6712,1.72662),(49,6713,2.14662),(49,6718,1.96),(49,6719,2.38),(49,6720,2.14662),(49,6721,2.52),(49,6722,0.86331),(49,6723,1.09669),(49,6727,1.77338),(49,6728,1.96),(49,6730,1.91338),(49,6731,1.12),(49,6733,0.93331),(49,6734,1.02669),(49,6735,0.88669),(49,6736,1.09669),(49,6737,1.82),(49,6738,2.19338),(49,6739,1.77338),(49,6740,2.00662),(49,6743,2.14662),(49,6748,1.82),(49,6749,1.96),(49,7120,0.98),(49,7121,1.28331),(49,7122,1.82),(49,7123,2.28662),(49,7136,2.1),(49,7137,2.24),(49,7142,0.95669),(49,7143,1.02669),(49,7144,1.02669),(49,7145,1.16669),(49,7146,1.91338),(49,7147,2.33338),(49,7148,2.00662),(49,7149,2.19338),(49,7152,1.02669),(49,7153,1.09669),(49,7154,2.00662),(49,7155,2.14662),(49,7156,2.05338),(49,7157,2.38),(49,7343,0.32669),(49,7344,0.95669),(49,7345,1.23669),(49,7400,0.88669),(49,7401,0.95669),(49,7402,1.77338),(49,7403,0.98),(49,7404,1.02669),(49,7405,1.05),(49,7406,1.12),(49,7407,0.98),(49,7408,1.07331),(49,7409,0.98),(49,7410,1.00331),(49,7411,1.09669),(49,7412,0.91),(49,7413,0.98),(49,7414,0.88669),(49,7415,1.02669),(49,7416,0.98),(49,7417,0.98),(49,7418,1.16669),(50,1222,0.65338),(50,1227,0.37338),(50,1262,0.84),(50,1265,0.37338),(50,1279,1.8669),(50,1290,0.37338),(50,1295,0.74676),(50,1308,0.14),(50,1317,0.83979),(50,1330,0.23331),(50,1333,0.18662),(50,1334,0.98),(50,3317,0.84),(50,3346,0.28),(50,3383,0.09331),(50,3402,1.68),(50,3405,0.84),(50,3412,1.68),(50,4664,1.26),(50,6689,2.05338),(50,6690,2.19338),(50,6693,1.86662),(50,6694,2.1),(50,6695,1.96),(50,6696,2.19338),(50,6697,1.91338),(50,6698,2.28662),(50,6702,1.82),(50,6703,1.96),(50,6704,2.05338),(50,6705,2.38),(50,6706,0.95669),(50,6707,1.07331),(50,6708,1.91338),(50,6709,2.14662),(50,6710,1.91338),(50,6711,2.19338),(50,6712,0.86331),(50,6713,1.07331),(50,6714,1.82),(50,6715,2.14662),(50,6718,0.98),(50,6719,1.19),(50,6720,1.07331),(50,6721,1.26),(50,6722,1.72662),(50,6723,2.19338),(50,6727,0.88669),(50,6728,0.98),(50,6730,3.82676),(50,6731,2.24),(50,6732,2.14662),(50,6733,1.86662),(50,6734,2.05338),(50,6735,1.77338),(50,6736,2.19338),(50,6737,0.91),(50,6738,1.09669),(50,6739,0.88669),(50,6740,1.00331),(50,6743,1.07331),(50,6748,0.91),(50,6749,0.98),(50,7120,1.96),(50,7121,2.56662),(50,7122,0.91),(50,7123,1.14331),(50,7136,1.05),(50,7137,1.12),(50,7138,2.24),(50,7139,2.56662),(50,7142,1.91338),(50,7143,2.05338),(50,7144,2.05338),(50,7145,2.33338),(50,7146,0.95669),(50,7147,1.16669),(50,7148,1.00331),(50,7149,1.09669),(50,7150,2.24),(50,7151,2.52),(50,7152,2.05338),(50,7153,2.19338),(50,7154,1.00331),(50,7155,1.07331),(50,7156,1.02669),(50,7157,1.19),(50,7434,0.34),(50,7509,0.98),(50,7510,1.05),(50,7511,0.91),(50,7512,0.98),(50,7513,0.28),(50,7514,0.91),(50,7515,1.07331),(50,7516,0.79331),(50,7517,0.93331),(50,7518,0.98),(50,7519,1.05),(51,1222,0.32669),(51,1227,0.37338),(51,1262,0.42),(51,1265,0.18669),(51,1279,1.12014),(51,1290,0.37338),(51,1295,0.74676),(51,1308,0.28),(51,1317,0.55986),(51,1324,0.91),(51,1330,0.23331),(51,1333,0.46655),(51,1334,0.98),(51,3317,0.56),(51,3322,0.28),(51,3346,0.7),(51,3361,0.18669),(51,3383,0.46655),(51,3388,0.84),(51,3402,1.12),(51,3405,0.42),(51,3412,1.12),(51,3833,0.18669),(51,4664,1.26),(51,4805,0.84),(51,5720,0.23331),(51,6689,1.02669),(51,6690,1.09669),(51,6691,0.91),(51,6692,1.02669),(51,6693,0.93331),(51,6694,1.05),(51,6695,0.98),(51,6696,1.09669),(51,6697,0.95669),(51,6698,1.14331),(51,6702,0.91),(51,6703,0.98),(51,6704,1.02669),(51,6705,1.19),(51,6706,0.95669),(51,6707,1.07331),(51,6708,0.95669),(51,6709,1.07331),(51,6710,0.95669),(51,6711,1.09669),(51,6712,0.86331),(51,6713,1.07331),(51,6714,0.91),(51,6715,1.07331),(51,6716,0.95669),(51,6717,1.19),(51,6718,0.98),(51,6719,1.19),(51,6720,1.07331),(51,6721,1.26),(51,6722,0.86331),(51,6723,1.09669),(51,6724,1.00331),(51,6725,1.07331),(51,6726,1.00331),(51,6727,0.88669),(51,6728,0.98),(51,6729,0.98),(51,6730,1.91338),(51,6731,1.12),(51,6732,1.07331),(51,6733,0.93331),(51,6734,1.02669),(51,6735,0.88669),(51,6736,1.09669),(51,6737,0.91),(51,6738,1.09669),(51,6739,0.88669),(51,6740,1.00331),(51,6741,0.81669),(51,6742,0.98),(51,6743,1.07331),(51,6744,0.88669),(51,6745,0.95669),(51,6746,0.95669),(51,6747,1.09669),(51,6748,0.91),(51,6749,0.98),(51,7120,0.98),(51,7121,1.28331),(51,7122,0.91),(51,7123,1.14331),(51,7124,0.91),(51,7125,1.05),(51,7134,0.98),(51,7135,1.09669),(51,7136,1.05),(51,7137,1.12),(51,7138,1.12),(51,7139,1.28331),(51,7142,0.95669),(51,7143,1.02669),(51,7144,1.02669),(51,7145,1.16669),(51,7146,0.95669),(51,7147,1.16669),(51,7148,1.00331),(51,7149,1.09669),(51,7150,1.12),(51,7151,1.26),(51,7152,1.02669),(51,7153,1.09669),(51,7154,1.00331),(51,7155,1.07331),(51,7156,1.02669),(51,7157,1.19),(51,7529,0.34),(51,7591,0.32669),(51,7592,0.93331),(51,7593,1.16669),(51,7594,0.42),(51,7595,1.05),(51,7596,1.12),(51,7597,0.37331),(51,7598,0.95669),(51,7599,1.23669),(51,7600,0.23331),(51,7601,0.93331),(51,7602,1.05),(51,7703,0.23331),(51,7704,0.88669),(51,7705,1.00331),(51,7706,0.98),(51,7707,1.14331),(51,7708,1.82),(51,7709,2.24),(51,7710,0.95669),(51,7711,1.16669),(51,7712,0.88669),(51,7713,0.95669),(51,7714,0.91),(51,7715,1.02669),(51,7716,0.91),(51,7717,1.00331),(51,7718,1.00331),(51,7719,1.26),(51,7720,0.93331),(51,7721,0.86331),(51,7722,0.98),(51,7723,0.98),(51,7724,1.16669),(51,7725,0.81669),(51,7726,0.88669),(51,7727,0.32669),(51,7728,1.05),(51,7729,1.12),(51,7730,0.32669),(51,7731,1.07331),(51,7732,1.14331),(51,7733,0.86331),(51,7734,1.00331),(52,1222,0.32669),(52,1227,0.18669),(52,1262,0.42),(52,1265,0.18669),(52,1279,1.49352),(52,1290,0.18669),(52,1295,0.93345),(52,1308,0.42),(52,1317,0.65317),(52,1330,0.46662),(52,1333,0.46655),(52,1334,2.94),(52,3317,0.84),(52,3346,0.14),(52,3402,1.68),(52,3405,0.42),(52,3412,1.96),(52,4156,0.18669),(52,4664,1.26),(52,6689,1.02669),(52,6690,1.09669),(52,6693,0.93331),(52,6694,1.05),(52,6695,0.98),(52,6696,1.09669),(52,6697,0.95669),(52,6698,1.14331),(52,6702,0.91),(52,6703,0.98),(52,6704,1.02669),(52,6705,1.19),(52,6706,1.91338),(52,6707,2.14662),(52,6708,0.95669),(52,6709,1.07331),(52,6710,0.95669),(52,6711,1.09669),(52,6712,1.72662),(52,6713,2.14662),(52,6714,0.91),(52,6715,1.07331),(52,6718,1.96),(52,6719,2.38),(52,6720,2.14662),(52,6721,2.52),(52,6722,0.86331),(52,6723,1.09669),(52,6727,2.66007),(52,6728,2.94),(52,6730,1.91338),(52,6731,1.12),(52,6732,1.07331),(52,6733,0.93331),(52,6734,1.02669),(52,6735,0.88669),(52,6736,1.09669),(52,6737,2.73),(52,6738,2.19338),(52,6739,1.77338),(52,6740,2.00662),(52,6743,3.21993),(52,6748,1.82),(52,6749,1.96),(52,7120,0.98),(52,7121,1.28331),(52,7122,1.82),(52,7123,2.28662),(52,7136,2.1),(52,7137,2.24),(52,7138,1.12),(52,7139,1.28331),(52,7142,0.95669),(52,7143,1.02669),(52,7144,1.02669),(52,7145,1.16669),(52,7146,1.91338),(52,7147,2.33338),(52,7148,2.00662),(52,7149,2.19338),(52,7150,1.12),(52,7151,1.26),(52,7152,1.02669),(52,7153,1.09669),(52,7154,2.00662),(52,7155,2.14662),(52,7156,2.05338),(52,7157,2.38),(52,7763,0.34),(52,7811,0.42),(52,7812,1.09669),(52,7813,1.23669),(52,7814,0.88669),(52,7815,1.00331),(52,7816,0.98),(52,7817,1.12),(52,7818,0.32669),(52,7819,0.91),(52,7820,1.02669),(52,7821,0.23331),(52,7822,0.93331),(52,7823,1.02669),(53,1222,0.98007),(53,1227,0.74676),(53,1262,1.26),(53,1265,0.56007),(53,1279,2.24028),(53,1290,0.56007),(53,1295,0.56007),(53,1317,1.11972),(53,3317,0.84),(53,3346,0.14),(53,3402,1.68),(53,3405,1.26),(53,3412,1.68),(53,4350,0.23331),(53,4664,1.26),(53,6420,0.98679),(53,6689,3.08007),(53,6690,3.29007),(53,6693,3.73324),(53,6694,4.2),(53,6695,2.94),(53,6696,3.29007),(53,6697,2.87007),(53,6698,3.42993),(53,6702,2.73),(53,6703,2.94),(53,6704,3.08007),(53,6705,3.57),(53,6708,2.87007),(53,6709,3.21993),(53,6710,2.87007),(53,6711,3.29007),(53,6714,2.73),(53,6715,3.21993),(53,6722,2.58993),(53,6723,3.29007),(53,6730,5.74014),(53,6731,3.36),(53,6732,3.21993),(53,6733,2.79993),(53,6734,3.08007),(53,6735,2.66007),(53,6736,3.29007),(53,7120,2.94),(53,7121,3.84993),(53,7138,3.36),(53,7139,3.84993),(53,7142,2.87007),(53,7143,3.08007),(53,7144,3.08007),(53,7145,3.50007),(53,7150,3.36),(53,7151,3.78),(53,7152,3.08007),(53,7153,3.29007),(53,7832,0.34),(53,7847,0.46669),(53,7848,1.07331),(53,7849,1.14331),(53,7850,2.71321),(53,7851,0.46669),(53,7852,1.05),(53,7853,1.19),(53,7854,0.37331),(53,7855,1.02669),(53,7856,1.28331),(53,7876,5.67321),(53,7877,0.88669),(53,7878,0.95669),(53,7879,1.09669),(53,7880,1.23669),(53,7881,0.23331),(53,7882,1.00331),(53,7883,1.12),(53,7884,1.86662),(53,7885,2.28662),(54,1227,0.93345),(54,1262,0.84),(54,1265,0.37338),(54,1273,2.1),(54,1290,0.56007),(54,1295,0.74676),(54,1308,0.42),(54,1317,0.46655),(54,1324,1.82),(54,1333,0.55986),(54,3322,0.84),(54,3346,0.56),(54,3364,0.18669),(54,3383,0.65317),(54,3390,0.86331),(54,3391,0.95669),(54,3402,0.56),(54,4195,0.81669),(54,4205,0.84),(54,4664,0.84),(54,4805,2.52),(54,6691,4.55),(54,6692,2.05338),(54,6716,2.87007),(54,6717,3.57),(54,6724,2.00662),(54,6725,2.14662),(54,6726,3.00993),(54,6729,1.96),(54,6741,1.63338),(54,6742,1.96),(54,6744,1.77338),(54,6745,1.91338),(54,6746,1.91338),(54,6747,2.19338),(54,7124,2.73),(54,7125,3.15),(54,7134,1.96),(54,7135,2.19338),(54,7262,2.14662),(54,7263,2.47338),(54,7264,2.28662),(54,7265,1.82),(54,7266,2.19338),(54,7267,2.73),(54,7268,3.00993),(54,7297,2.00662),(54,7298,2.14662),(54,7818,0.32669),(54,7893,0.34),(54,7947,3.42993),(54,7948,0.18669),(54,7949,0.86331),(54,7950,0.95669),(54,8030,0.88669),(54,8031,1.05),(54,8032,0.91),(54,8033,1.05),(54,8034,1.02669),(54,8035,1.09669),(54,8036,0.88669),(54,8037,0.95669),(54,8038,1.09669),(54,8039,1.19),(54,8040,0.98),(54,8041,1.12),(54,8042,0.91),(54,8043,1.07331),(54,8044,0.93331),(54,8045,0.81669),(54,8046,0.93331),(54,8047,0.86331),(54,8048,1.02669),(54,8049,0.84),(54,8050,1.00331),(54,8051,0.95669),(54,8052,0.28),(54,8053,1.02669),(54,8054,1.14331),(54,8055,0.18669),(54,8056,0.86331),(54,8057,0.95669),(54,8058,0.23331),(54,8059,0.95669),(54,8060,1.14331),(54,8061,0.28),(54,8062,1.00331),(54,8063,1.12),(55,1227,1.12014),(55,1262,1.26),(55,1265,0.56007),(55,1273,3.15),(55,1290,0.56007),(55,1295,1.12014),(55,1308,0.42),(55,1317,0.55986),(55,1324,2.73),(55,1333,0.83979),(55,3322,0.84),(55,3346,0.42),(55,3383,0.18662),(55,3402,0.84),(55,3833,0.18669),(55,4664,1.26),(55,4805,2.52),(55,5720,0.23331),(55,6691,5.46),(55,6692,3.08007),(55,6716,2.87007),(55,6717,3.57),(55,6724,3.00993),(55,6725,3.21993),(55,6726,3.00993),(55,6729,2.94),(55,6741,2.45007),(55,6742,2.94),(55,6744,2.66007),(55,6745,2.87007),(55,6746,2.87007),(55,6747,3.29007),(55,7124,2.73),(55,7125,3.15),(55,7134,1.96),(55,7135,2.19338),(55,7262,3.21993),(55,7263,3.71007),(55,7264,3.42993),(55,7265,2.73),(55,7266,3.29007),(55,7267,2.73),(55,7268,3.00993),(55,7297,3.00993),(55,7298,3.21993),(55,7591,0.32669),(55,7592,0.93331),(55,7593,1.16669),(55,7597,0.37331),(55,7598,0.95669),(55,7599,1.23669),(55,7706,0.98),(55,7707,1.14331),(55,7708,0.91),(55,7709,1.12),(55,7712,0.88669),(55,7713,0.95669),(55,7714,0.91),(55,7715,1.02669),(55,7721,0.86331),(55,7722,0.98),(55,7723,0.98),(55,7724,1.16669),(55,7727,0.32669),(55,7728,1.05),(55,7729,1.12),(55,7730,1.72679),(55,7733,0.86331),(55,7734,1.00331),(55,7947,3.42993),(55,8094,0.34),(55,8103,4.93321),(55,8104,6.16679),(56,1227,1.30683),(56,1262,1.68),(56,1265,0.74676),(56,1273,4.2),(56,1290,0.56007),(56,1295,1.30683),(56,1308,0.42),(56,1317,0.65317),(56,1324,2.73),(56,1333,0.83979),(56,3322,0.84),(56,3402,1.12),(56,4664,1.26),(56,4805,2.52),(56,6691,6.37),(56,6692,3.08007),(56,6716,2.87007),(56,6717,3.57),(56,6724,3.00993),(56,6725,3.21993),(56,6726,3.00993),(56,6729,2.94),(56,6741,2.45007),(56,6742,2.94),(56,6744,2.66007),(56,6745,2.87007),(56,6746,2.87007),(56,6747,3.29007),(56,7124,2.73),(56,7125,3.15),(56,7134,2.94),(56,7135,3.29007),(56,7262,4.29324),(56,7263,4.94676),(56,7264,4.57324),(56,7265,3.64),(56,7266,4.38676),(56,7267,3.64),(56,7268,4.01324),(56,7297,4.01324),(56,7298,4.29324),(56,7947,3.42993),(56,8105,0.34),(56,8106,1.97321),(56,8107,5.55),(56,8108,6.66),(57,1227,0.37338),(57,1262,0.42),(57,1265,0.18669),(57,1273,1.05),(57,1279,0.37338),(57,1290,0.18669),(57,1295,1.12014),(57,1308,0.42),(57,1317,0.37324),(57,1324,0.91),(57,1330,0.46662),(57,1333,0.46655),(57,1334,1.96),(57,3322,0.28),(57,3346,0.28),(57,3364,0.18669),(57,3365,0.86331),(57,3373,0.18669),(57,3383,0.46655),(57,3388,0.84),(57,3402,1.4),(57,3412,0.56),(57,4664,1.26),(57,4805,0.84),(57,6684,0.28014),(57,6685,5.59986),(57,6686,2.28662),(57,6691,1.82),(57,6692,1.02669),(57,6706,1.91338),(57,6707,2.14662),(57,6716,0.95669),(57,6717,1.19),(57,6718,1.96),(57,6719,2.38),(57,6720,2.14662),(57,6721,2.52),(57,6724,1.00331),(57,6725,1.07331),(57,6726,1.00331),(57,6727,1.77338),(57,6728,1.96),(57,6729,0.98),(57,6737,1.82),(57,6738,2.19338),(57,6739,1.77338),(57,6740,2.00662),(57,6741,0.81669),(57,6742,0.98),(57,6743,2.14662),(57,6744,0.88669),(57,6745,0.95669),(57,6746,0.95669),(57,6747,1.09669),(57,7124,0.91),(57,7125,1.05),(57,7134,0.98),(57,7135,1.09669),(57,7136,2.1),(57,7137,2.24),(57,7148,2.00662),(57,7149,2.19338),(57,7156,2.05338),(57,7157,2.38),(57,7262,1.07331),(57,7263,1.23669),(57,7264,1.14331),(57,7265,0.91),(57,7266,1.09669),(57,7267,0.91),(57,7268,1.00331),(57,7297,1.00331),(57,7298,1.07331),(57,7818,0.32669),(57,7947,1.14331),(57,8113,0.34),(57,8181,1.16669),(57,8182,1.19),(57,8183,1.07331),(57,8184,1.05),(57,8185,0.7),(57,8186,1.19),(57,8187,1.26),(57,8188,0.56),(57,8189,1.05),(57,8190,1.21331),(57,8283,0.88669),(57,8284,1.19),(57,8285,0.91),(57,8286,1.12),(57,8287,0.18669),(57,8288,0.95669),(57,8289,1.07331),(57,8290,1.00331),(57,8291,1.00331),(57,8292,1.09669),(57,8293,0.98),(57,8294,1.12),(57,8295,1.86662),(57,8296,1.00331),(57,8297,1.05),(57,8298,0.88669),(57,8299,1.86662),(57,8300,2.1),(57,8301,0.74),(57,8302,5.67321),(57,8303,6.78321),(57,8304,0.98),(57,8305,1.12),(58,12,0.63996),(58,13,1.88004),(58,1222,1.96014),(58,1227,1.12014),(58,1234,0.74662),(58,1262,0.84),(58,1265,1.12014),(58,1279,0.74676),(58,1290,0.74676),(58,1295,0.37338),(58,1308,0.84),(58,1317,1.67958),(58,1333,0.55986),(58,3312,2.8),(58,3317,0.56),(58,3322,1.12),(58,3402,0.56),(58,3405,2.52),(58,3412,1.12),(58,4664,3.36),(58,4667,2.00662),(58,4809,1.68),(58,6693,1.86662),(58,8341,0.34),(58,8431,2.00662),(58,8432,2.19338),(58,8433,2.19338),(58,8434,2.42662),(58,8435,1.91338),(58,8436,2.24),(58,8437,1.82),(58,8438,1.96),(58,8439,2.05338),(58,8440,2.19338),(58,8441,2.33338),(58,8442,1.96),(58,8443,2.38),(58,8444,1.96),(58,8445,2.24),(58,8446,3.92),(58,8447,2.1),(58,8448,2.19338),(58,8449,1.86662),(58,8450,2.24),(58,8451,1.91338),(58,8452,2.05338),(58,8453,1.86662),(58,8454,2.33338),(58,8455,1.77338),(58,8456,2.1),(58,8457,2.00662),(58,8458,1.14331),(58,8459,2.05338),(58,8460,2.47338),(58,8461,1.91338),(58,8462,2.19338),(58,8463,2.14662),(58,8464,2.42662),(58,8465,2.00662),(58,8466,2.14662),(58,8467,1.86662),(58,8468,2.33338),(58,8469,1.72662),(58,8470,1.91338),(58,8471,1.86662),(58,8472,2.19338),(58,8473,1.77338),(58,8474,1.91338),(58,8475,1.96),(58,8476,2.24),(58,8477,1.77338),(58,8478,2.05338),(58,8479,1.77338),(58,8480,1.91338),(58,8481,1.82),(58,8482,2.1),(58,8483,1.82),(58,8484,2.14662),(58,8485,1.96),(58,8486,2.14662),(58,8487,2.00662),(58,8488,1.91338),(58,8489,2.19338),(58,8731,2.24),(58,8732,2.33338),(58,8733,1.91338),(58,8734,2.00662),(58,8735,2.05338),(58,8736,2.52),(58,8737,1.96),(58,8738,2.14662),(58,8739,2.00662),(58,8740,2.56662),(58,8741,2.14662),(58,8742,2.28662),(58,8743,1.86662),(58,8744,2.47338),(58,8745,2.1),(58,8746,2.38),(58,8747,1.91338),(58,8748,2.24),(58,8749,2.1),(58,8750,2.33338),(58,8751,2.19338),(58,8752,2.66),(58,8753,2.24),(58,8754,2.38),(58,8755,2.19338),(58,8756,1.96),(58,8757,2.38),(58,8758,2.1),(58,8759,2.42662),(58,8760,2.24),(58,8761,2.38),(58,8762,1.77338),(58,8763,2.1),(58,8764,2.05338),(58,8765,2.33338),(59,3833,0.32004),(59,8821,1.52004),(61,8839,3.73352),(61,8840,1.88004),(61,8841,2.04),(62,6,0.17),(64,8,0.17),(66,8872,1.63317),(66,8873,1.68),(66,8874,1.83996),(67,3417,2.28683),(67,8879,1.64004),(67,8880,2.04),(71,3833,0.32004),(71,8821,1.52004),(72,12,1.01327),(72,13,1.88004),(72,3346,1.68),(72,3364,0.37338),(72,3369,0.18669),(72,3383,0.65317),(72,3388,0.84),(72,3390,0.86331),(72,3933,0.23331),(72,3934,0.98),(72,3935,1.26),(72,3936,0.84),(72,3937,1.14331),(72,3938,1.23669),(72,3939,1.02669),(72,3940,1.19),(72,3941,0.91),(72,3942,1.00331),(72,3943,0.74662),(72,3944,1.07331),(72,3945,1.21331),(72,3946,1.12),(72,3947,1.19),(72,4154,1.09669),(72,4155,1.16669),(72,4156,0.93345),(72,4157,0.88669),(72,4158,0.95669),(72,4159,0.91),(72,4160,1.07331),(72,4161,0.93331),(72,4162,1.02669),(72,4163,0.88669),(72,4164,1.12),(72,4165,0.88669),(72,4166,1.09669),(72,4167,0.88669),(72,4168,1.00331),(72,4169,1.77338),(72,4170,2.14662),(72,4171,0.88669),(72,4172,0.95669),(72,4173,0.88669),(72,4174,1.00331),(72,4175,0.98),(72,4176,1.21331),(72,4177,1.05),(72,4178,1.12),(72,4179,0.95669),(72,4180,1.07331),(72,4181,0.88669),(72,4182,1.00331),(72,4183,0.88669),(72,4184,0.95669),(72,4185,0.95669),(72,4186,1.07331),(72,4187,0.86331),(72,4188,0.98),(72,4189,1.07331),(72,4190,1.28331),(72,4191,0.98),(72,4192,1.12),(72,4193,0.86331),(72,4194,0.95669),(72,4195,0.81669),(72,4196,1.09669),(72,4197,0.95669),(72,4198,0.95669),(72,4199,1.16669),(72,4200,0.98),(72,4201,0.84),(72,4202,0.93331),(72,4203,0.91),(72,4204,1.00331),(72,4205,0.84),(72,4206,1.02669),(72,8912,0.34);


--
-- Table structure for table `#__finder_links_termsf`
--



CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsf`
--


INSERT INTO `#__finder_links_termsf` (`link_id`, `term_id`, `weight`) VALUES (11,44,1.72679),(11,45,5.67321),(11,46,0.18669),(11,47,0.95669),(11,48,1.09669),(22,46,0.56007),(22,3559,3.92028),(22,3560,10.5),(22,3561,5.83345),(22,3562,5.71655),(22,3563,0.98),(22,3564,1.05),(22,3565,1.05),(22,3566,1.16669),(22,3567,0.74662),(22,3568,1.07331),(22,3569,1.19),(22,3570,1.00331),(22,3571,1.07331),(22,3572,0.69993),(22,3573,2.73),(22,3574,3.08007),(22,3575,0.84),(22,3576,1.91338),(22,3577,2.14662),(22,3578,1.02669),(22,3579,1.12),(22,3580,0.56007),(22,3581,2.58993),(22,3582,2.79993),(22,3583,1.12014),(22,3584,5.32014),(22,3585,5.88),(22,3586,0.23331),(22,3587,0.93331),(22,3588,1.00331),(22,3589,1.39986),(22,3590,2.94),(22,3591,3.57),(22,3592,2.00662),(22,3593,1.12),(22,3594,1.09669),(22,3595,0.93331),(22,3596,1.05),(22,3597,2.94),(22,3598,3.21993),(22,3599,0.74676),(22,3600,0.86331),(22,3601,1.02669),(22,3602,2.87007),(22,3603,3.29007),(22,3604,0.93324),(22,3605,0.93331),(22,3606,1.05),(22,3607,3.00993),(22,3608,1.12),(22,3609,2.19338),(22,3610,0.98007),(22,3611,3.21993),(22,3612,3.84993),(24,3559,0.32669),(24,3560,1.05),(24,3837,1.19),(25,46,0.37338),(25,3586,0.23331),(25,4222,0.28),(25,4223,0.88669),(25,4224,1.14331),(25,4225,0.88669),(25,4226,1.02669),(25,4227,0.56),(25,4228,1.00331),(25,4229,1.30669),(25,4230,1.07331),(25,4231,1.23669),(25,4232,0.88669),(25,4233,1.02669),(25,4234,0.28),(25,4235,1.02669),(25,4236,1.21331),(25,4237,0.18669),(25,4238,0.86331),(25,4239,0.98),(25,4240,0.88669),(25,4241,1.14331),(25,4242,0.91),(25,4243,1.00331),(25,4244,0.18669),(25,4245,0.86331),(25,4246,1.14331),(25,4247,0.14),(25,4248,0.98),(25,4249,1.07331),(26,3586,0.23331),(26,4365,0.91),(26,4366,0.98),(36,3586,0.23331),(36,4365,0.91),(36,4366,0.98),(37,3586,0.23331),(37,4365,0.91),(37,4366,0.98),(38,3586,0.23331),(38,4365,0.91),(38,4366,0.98),(43,4222,0.28),(43,4225,0.88669),(43,4237,0.18669),(43,5750,0.14),(43,5751,0.86331),(43,5752,0.95669),(43,5753,0.18662),(43,5754,0.93331),(43,5755,1.02669),(43,5756,0.93331),(43,5757,1.05),(43,5758,1.09669),(43,5759,0.93331),(43,5760,1.19),(43,5761,0.23331),(43,5762,1.00331),(43,5763,1.09669),(43,5764,0.32669),(43,5765,1.02669),(43,5766,1.09669),(43,5767,0.23331),(43,5768,0.95669),(43,5769,1.02669),(43,5770,0.91),(43,5771,1.00331),(45,46,0.56007),(45,4222,0.42),(45,4225,0.88669),(45,5753,0.09331),(45,6481,0.28),(45,6482,1.07331),(45,6483,1.4),(45,6484,0.86331),(45,6485,0.98),(45,6486,1.02669),(45,6487,1.16669),(45,6488,1.12),(45,6489,0.91),(45,6490,1.07331),(45,6491,1.72679),(45,6492,4.93321),(45,6493,5.79679),(45,6494,0.37331),(45,6495,1.12),(45,6496,1.23669),(45,6497,0.32669),(45,6498,0.95669),(45,6499,1.05),(45,6500,0.23331),(45,6501,0.98),(45,6502,1.07331),(45,6503,0.14),(45,6504,0.93331),(45,6505,1.09669),(45,6506,0.84),(45,6507,0.98),(45,6508,0.86331),(45,6509,0.91),(45,6510,1.07331),(45,6511,1.37669),(46,46,0.18669),(46,3604,0.23331),(46,4222,0.14),(46,7222,0.98),(46,7223,1.16669),(46,7224,0.18669),(46,7225,0.88669),(46,7226,1.09669),(46,7227,0.88669),(46,7228,1.02669),(46,7229,0.28),(46,7230,0.95669),(46,7231,1.21331),(46,7232,0.93331),(46,7233,1.02669),(46,7234,0.84),(46,7235,0.98),(46,7236,1.02669),(46,7237,1.07331),(46,7238,1.19),(48,5753,0.49321),(48,7308,5.18),(48,7309,5.79679),(49,7421,0.37331),(49,7422,0.98),(49,7423,1.14331),(51,46,0.18669),(51,5753,0.09331),(51,6503,0.14),(51,7744,0.98),(51,7745,1.09669),(51,7746,0.18669),(51,7747,0.86331),(51,7748,1.00331),(51,7749,0.86331),(51,7750,0.95669),(51,7751,1.05),(51,7752,1.26),(51,7753,0.32669),(51,7754,1.05),(51,7755,1.19),(51,7756,1.97321),(51,7757,5.30321),(51,7758,6.53679),(52,7827,0.28),(52,7828,1.02669),(52,7829,1.07331),(53,7746,0.18669),(53,7887,0.91),(53,7888,1.12),(54,46,0.56007),(54,3583,0.18669),(54,3584,0.88669),(54,7229,0.56),(54,8064,0.98),(54,8065,0.32669),(54,8066,0.95669),(54,8067,1.07331),(54,8068,0.91),(54,8069,1.21331),(54,8070,0.95669),(54,8071,1.14331),(54,8072,0.91),(54,8073,1.00331),(54,8074,0.93331),(54,8075,1.02669),(54,8076,1.05),(54,8077,1.14331),(54,8078,0.23331),(54,8079,0.91),(54,8080,1.09669),(55,46,0.18669),(55,5753,0.09331),(55,6503,0.14),(55,7744,0.98),(55,7745,1.09669),(55,7746,0.18669),(55,7747,0.86331),(55,7748,1.00331),(55,7749,0.86331),(55,7750,0.95669),(55,7751,1.05),(55,7752,1.26),(55,7753,0.32669),(55,7754,1.05),(55,7755,1.19),(56,7756,1.97321),(57,46,0.18669),(57,3580,0.37338),(57,3581,1.72662),(57,3586,0.23331),(57,4247,0.14),(57,6503,0.14),(57,7234,0.42),(57,8306,0.18669),(57,8307,0.86331),(57,8308,1.05),(57,8309,1.07331),(57,8310,1.14331),(57,8311,0.91),(57,8312,1.05),(57,8313,0.91),(57,8314,1.00331),(57,8315,0.84),(57,8316,1.05),(57,8317,0.98),(57,8318,1.05),(57,8319,0.23331),(57,8320,0.88669),(57,8321,1.12),(57,8322,1.19),(57,8323,1.28331),(59,4247,0.24),(59,8822,1.92),(59,8823,2.07996),(60,44,0.56004),(60,45,1.83996),(60,4222,0.24),(60,4247,0.24),(60,8836,1.52004),(60,8837,1.59996),(60,8838,1.76004),(61,44,0.56004),(61,45,1.83996),(61,4222,0.24),(61,8836,1.52004),(62,44,0.56004),(62,45,1.83996),(62,4222,0.24),(62,8836,1.52004),(63,4222,0.24),(63,8836,1.52004),(64,4222,0.24),(64,4247,0.24),(64,8822,1.92),(64,8823,2.07996),(64,8836,1.52004),(65,4222,0.24),(65,4247,0.24),(65,8836,1.52004),(65,8867,1.59996),(65,8868,1.76004),(66,4222,0.24),(66,8836,1.52004),(67,4222,0.24),(67,8836,1.52004),(68,4222,0.24),(68,4247,0.24),(68,8836,1.52004),(68,8885,1.68),(68,8886,1.83996),(69,4222,0.24),(69,4247,0.24),(69,8836,1.52004),(69,8867,1.59996),(69,8868,1.76004),(70,4222,0.24),(70,4247,0.24),(70,8836,1.52004),(70,8867,1.59996),(70,8868,1.76004),(71,4222,0.24),(71,4247,0.24),(71,8822,1.92),(71,8823,2.07996),(71,8836,1.52004),(72,46,0.37338),(72,3586,0.23331),(72,4222,0.28),(72,4223,0.88669),(72,4224,1.14331),(72,4225,0.88669),(72,4226,1.02669),(72,4227,0.56),(72,4228,1.00331),(72,4229,1.30669),(72,4230,1.07331),(72,4231,1.23669),(72,4232,0.88669),(72,4233,1.02669),(72,4234,0.28),(72,4235,1.02669),(72,4236,1.21331),(72,4237,0.18669),(72,4238,0.86331),(72,4239,0.98),(72,4240,0.88669),(72,4241,1.14331),(72,4242,0.91),(72,4243,1.00331),(72,4244,0.18669),(72,4245,0.86331),(72,4246,1.14331),(72,4247,0.14),(72,4248,0.98),(72,4249,1.07331);


--
-- Table structure for table `#__finder_taxonomy`
--



CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_taxonomy`
--


INSERT INTO `#__finder_taxonomy` (`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES (1,0,'ROOT',0,0,0),(2,1,'Type',1,1,0),(3,2,'Category',1,1,0),(4,1,'Language',1,1,0),(5,4,'*',1,1,0),(6,2,'Contact',1,1,0),(7,1,'Category',1,1,0),(8,7,'Sample category I',1,1,0),(9,1,'Region',1,1,0),(10,9,'Australia',1,1,0),(11,1,'Country',1,1,0),(12,11,'Australia',1,1,0),(13,7,'Sample category II',1,1,0),(14,2,'Article',1,1,0),(15,1,'Author',1,1,0),(16,15,'Administrator',1,1,0),(17,7,'Template articles',1,1,0),(18,7,'Menu types',1,1,0),(19,7,'Layouts',1,1,0),(20,7,'Uncategorised',1,1,0),(21,7,'Latest',1,1,0),(22,7,'Financial Adviser',1,1,0),(23,7,' Investment Guide',1,1,0),(24,7,'Market Center',1,1,0),(25,2,'News Feed',1,1,0),(26,7,'GavickPro',1,1,0),(27,2,'Web Link',1,1,0),(28,7,'Joomla Weblink Category',1,1,0);


--
-- Table structure for table `#__finder_taxonomy_map`
--



CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_taxonomy_map`
--


INSERT INTO `#__finder_taxonomy_map` (`link_id`, `node_id`) VALUES (1,3),(1,5),(2,3),(2,5),(3,3),(3,5),(4,3),(4,5),(5,3),(5,5),(6,3),(6,5),(7,3),(7,5),(8,3),(8,5),(9,3),(9,5),(10,3),(10,5),(11,3),(11,5),(12,3),(12,5),(13,3),(13,5),(14,3),(14,5),(15,3),(15,5),(16,3),(16,5),(17,3),(17,5),(18,3),(18,5),(19,3),(19,5),(20,5),(20,6),(20,8),(20,10),(20,12),(21,5),(21,6),(21,10),(21,13),(22,5),(22,14),(22,16),(22,17),(23,5),(23,14),(23,16),(23,17),(24,5),(24,14),(24,16),(24,17),(25,5),(25,14),(25,16),(25,17),(26,5),(26,14),(26,16),(26,18),(27,5),(27,14),(27,16),(27,19),(28,5),(28,14),(28,16),(28,19),(29,5),(29,14),(29,16),(29,19),(30,5),(30,14),(30,16),(30,19),(31,5),(31,14),(31,16),(31,19),(32,5),(32,14),(32,16),(32,19),(33,5),(33,14),(33,16),(33,19),(34,5),(34,14),(34,16),(34,19),(35,5),(35,14),(35,16),(35,19),(36,5),(36,14),(36,16),(36,18),(37,5),(37,14),(37,16),(37,18),(38,5),(38,14),(38,16),(38,18),(39,5),(39,14),(39,16),(39,17),(40,5),(40,14),(40,16),(40,20),(41,5),(41,14),(41,16),(41,20),(42,5),(42,14),(42,16),(42,20),(43,5),(43,14),(43,16),(43,17),(44,5),(44,14),(44,16),(44,17),(45,5),(45,14),(45,16),(45,21),(46,5),(46,14),(46,16),(46,22),(47,5),(47,14),(47,16),(47,22),(48,5),(48,14),(48,16),(48,22),(49,5),(49,14),(49,16),(49,22),(50,5),(50,14),(50,16),(50,23),(51,5),(51,14),(51,16),(51,23),(52,5),(52,14),(52,16),(52,23),(53,5),(53,14),(53,16),(53,23),(54,5),(54,14),(54,16),(54,24),(55,5),(55,14),(55,16),(55,24),(56,5),(56,14),(56,16),(56,24),(57,5),(57,14),(57,16),(57,24),(58,5),(58,14),(58,16),(58,17),(59,5),(59,25),(59,26),(60,5),(60,27),(60,28),(61,5),(61,27),(61,28),(62,5),(62,27),(62,28),(63,5),(63,26),(63,27),(64,5),(64,26),(64,27),(65,5),(65,26),(65,27),(66,5),(66,26),(66,27),(67,5),(67,26),(67,27),(68,5),(68,26),(68,27),(69,5),(69,26),(69,27),(70,5),(70,26),(70,27),(71,5),(71,26),(71,27),(72,5),(72,14),(72,16),(72,17);


--
-- Table structure for table `#__finder_terms`
--



CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM AUTO_INCREMENT=8915 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_terms`
--


INSERT INTO `#__finder_terms` (`term_id`, `term`, `stem`, `common`, `phrase`, `weight`, `soundex`, `links`) VALUES (1,'','',0,0,0,'',73),(2,'2','2',0,0,0.1,'',6),(3,'category','category',0,0,0.5333,'C326',24),(4,'index','index',0,0,0.3333,'I532',73),(5,'uncategorised','uncategorised',0,0,0.8667,'U5232623',8),(6,'3','3',0,0,0.1,'',4),(7,'4','4',0,0,0.1,'',5),(8,'5','5',0,0,0.1,'',4),(9,'6','6',0,0,0.1,'',5),(10,'7','7',0,0,0.1,'',4),(11,'articles','articles',0,0,0.5333,'A63242',11),(12,'template','template',0,0,0.5333,'T5143',15),(13,'template articles','template articles',0,1,1.5667,'T514363242',11),(14,'8','8',0,0,0.1,'',4),(15,'menu','menu',0,0,0.2667,'M000',6),(16,'menu types','menu types',0,1,1.3333,'M312',5),(17,'types','types',0,0,0.3333,'T120',7),(18,'9','9',0,0,0.1,'',3),(19,'layouts','layouts',0,0,0.4667,'L320',10),(20,'10','10',0,0,0.2,'',3),(21,'category description','category description',0,1,1.6667,'C326326135',2),(22,'category i','category i',0,1,1.3333,'C326',2),(23,'description','description',0,0,0.7333,'D26135',2),(24,'i','i',0,0,0.0667,'I000',3),(25,'sample','sample',0,0,0.4,'S514',6),(26,'sample category','sample category',0,1,1.5,'S5142326',4),(27,'sample category i','sample category i',0,1,1.5667,'S5142326',2),(28,'11','11',0,0,0.2,'',3),(29,'category ii','category ii',0,1,1.3667,'C326',2),(30,'ii','ii',0,0,0.1333,'I000',3),(31,'sample category description','sample category description',0,1,1.9,'S5142326326135',1),(32,'sample category ii','sample category ii',0,1,1.6,'S5142326',2),(33,'12','12',0,0,0.2,'',3),(34,'category with','category with',0,1,1.4333,'C3263',1),(35,'category with joomla','category with joomla',0,1,1.6667,'C3263254',1),(36,'joomla','joomla',0,0,0.4,'J540',8),(37,'joomla links','joomla links',0,1,1.4,'J5452',1),(38,'joomla weblink','joomla weblink',0,1,1.4667,'J541452',4),(39,'joomla weblink category','joomla weblink category',0,1,1.7667,'J541452326',4),(40,'links','links',0,0,0.3333,'L520',1),(41,'simple','simple',0,0,0.4,'S514',1),(42,'simple category','simple category',0,1,1.5,'S5142326',1),(43,'simple category with','simple category with',0,1,1.6667,'S51423263',1),(44,'weblink','weblink',0,0,0.4667,'W1452',4),(45,'weblink category','weblink category',0,1,1.5333,'W1452326',4),(46,'with','with',0,0,0.2667,'W300',11),(47,'with joomla','with joomla',0,1,1.3667,'W3254',1),(48,'with joomla links','with joomla links',0,1,1.5667,'W325452',1),(49,'13','13',0,0,0.2,'',2),(50,'gavick','gavick',0,0,0.4,'G120',7),(51,'gavickpro','gavickpro',0,0,0.6,'G1216',12),(52,'14','14',0,0,0.2,'',2),(53,'15','15',0,0,0.2,'',2),(54,'16','16',0,0,0.2,'',3),(55,'latest','latest',0,0,0.4,'L323',3),(56,'17','17',0,0,0.2,'',2),(57,'business','business',0,0,0.5333,'B252',9),(58,'financial','financial',0,0,0.6,'F524',9),(59,'financial business','financial business',0,1,1.6,'F5241252',1),(60,'18','18',0,0,0.2,'',2),(61,'adviser','adviser',0,0,0.4667,'A3126',5),(62,'financial adviser','financial adviser',0,1,1.5667,'F5243126',5),(63,'19','19',0,0,0.2,'',2),(64,'guide','guide',0,0,0.3333,'G300',5),(65,'investment','investment',0,0,0.6667,'I512353',5),(66,'investment guide','investment guide',0,1,1.5333,'I51235323',5),(67,'20','20',0,0,0.2,'',2),(68,'center','center',0,0,0.4,'C536',5),(69,'market','market',0,0,0.4,'M623',5),(70,'market center','market center',0,1,1.4333,'M6232536',5),(71,'+49','+49',0,0,0.3,'',1),(72,'+49 5241','+49 5241',0,1,1.2667,'',1),(73,'+49 5241 80-0','+49 5241 80-0',0,1,1.4333,'',1),(74,'00','00',0,0,0.2,'',1),(75,'1','1',0,0,0.1,'',4),(76,'25','25',0,0,0.2,'',3),(77,'25 cromwell','25 cromwell',0,1,1.3667,'C654',2),(78,'25 cromwell st','25 cromwell st',0,1,1.4667,'C65423',2),(79,'3146','3146',0,0,0.4,'',2),(80,'5241','5241',0,0,0.4,'',1),(81,'5241 80-0','5241 80-0',0,1,1.3,'',1),(82,'5241 80-0 00','5241 80-0 00',0,1,1.4,'',1),(83,'80-0','80-0',0,0,0.4,'',1),(84,'80-0 00','80-0 00',0,1,1.2333,'',1),(85,'australia','australia',0,0,0.6,'A2364',2),(86,'b','b',0,0,0.0667,'B000',2),(87,'b s','b s',0,1,1.1,'B200',2),(88,'b s sound','b s sound',0,1,1.3,'B253',2),(89,'contact','contact',0,0,0.4667,'C5323',4),(90,'cromwell','cromwell',0,0,0.5333,'C654',2),(91,'cromwell st','cromwell st',0,1,1.3667,'C65423',2),(92,'cromwell st glen','cromwell st glen',0,1,1.5333,'C65423245',2),(93,'eli','eli',0,0,0.2,'E400',2),(94,'eli manning','eli manning',0,1,1.3667,'E452',2),(95,'glen','glen',0,0,0.2667,'G450',2),(96,'glen iris','glen iris',0,1,1.3,'G4562',2),(97,'glen iris victoria','glen iris victoria',0,1,1.6,'G45621236',2),(98,'iris','iris',0,0,0.2667,'I620',2),(99,'iris victoria','iris victoria',0,1,1.4333,'I621236',2),(100,'iris victoria 3146','iris victoria 3146',0,1,1.6,'I621236',2),(101,'manning','manning',0,0,0.4667,'M200',2),(102,'s','s',0,0,0.0667,'S000',2),(103,'s sound','s sound',0,1,1.2333,'S530',2),(104,'s sound 25','s sound 25',0,1,1.3333,'S530',2),(105,'sound','sound',0,0,0.3333,'S530',2),(106,'sound 25','sound 25',0,1,1.2667,'S530',2),(107,'sound 25 cromwell','sound 25 cromwell',0,1,1.5667,'S532654',2),(108,'st','st',0,0,0.1333,'S300',2),(109,'st glen','st glen',0,1,1.2333,'S3245',2),(110,'st glen iris','st glen iris',0,1,1.4,'S324562',2),(111,'victoria','victoria',0,0,0.5333,'V236',2),(112,'victoria 3146','victoria 3146',0,1,1.4333,'V236',2),(113,'3146 australia','3146 australia',0,1,1.4667,'A2364',1),(114,'com','com',0,0,0.2,'C500',14),(115,'joomla user','joomla user',0,1,1.3667,'J5426',1),(116,'test','test',0,0,0.2667,'T230',1),(117,'test com','test com',0,1,1.2667,'T2325',1),(118,'test test','test test',0,1,1.3,'T2323',1),(119,'test test com','test test com',0,1,1.4333,'T232325',1),(120,'user','user',0,0,0.2667,'U260',10),(121,'victoria 3146 australia','victoria 3146 australia',0,1,1.7667,'V2362364',1),(122,'01','01',0,0,0.2,'',1),(123,'01 element','01 element',0,1,1.3333,'E453',1),(124,'01 element 02','01 element 02',0,1,1.4333,'E453',1),(125,'02','02',0,0,0.2,'',1),(126,'02 element','02 element',0,1,1.3333,'E453',1),(127,'02 element abbrs','02 element abbrs',0,1,1.5333,'E453162',1),(128,'02 element div','02 element div',0,1,1.4667,'E4531',1),(129,'1 column','1 column',0,1,1.2667,'C450',1),(130,'1 column 2','1 column 2',0,1,1.3333,'C450',1),(131,'1 element','1 element',0,1,1.3,'E453',1),(132,'1 element 2','1 element 2',0,1,1.3667,'E453',1),(133,'1 icon','1 icon',0,1,1.2,'I250',1),(134,'1 icon set','1 icon set',0,1,1.3333,'I2523',1),(135,'1 lorem','1 lorem',0,1,1.2333,'L650',1),(136,'1 lorem ipsum','1 lorem ipsum',0,1,1.4333,'L65125',1),(137,'1 part','1 part',0,1,1.2,'P630',1),(138,'1 part of','1 part of',0,1,1.3,'P631',1),(139,'1 this','1 this',0,1,1.2,'T200',1),(140,'1 this is','1 this is',0,1,1.3,'T200',1),(141,'2 cell','2 cell',0,1,1.2,'C400',1),(142,'2 cell 3','2 cell 3',0,1,1.2667,'C400',1),(143,'2 cras','2 cras',0,1,1.2,'C620',1),(144,'2 cras diam','2 cras diam',0,1,1.3667,'C6235',1),(145,'2 element','2 element',0,1,1.3,'E453',1),(146,'2 element 3','2 element 3',0,1,1.3667,'E453',1),(147,'2 icon','2 icon',0,1,1.2,'I250',1),(148,'2 icon set','2 icon set',0,1,1.3333,'I2523',1),(149,'2 part','2 part',0,1,1.2,'P630',1),(150,'2 part of','2 part of',0,1,1.3,'P631',1),(151,'2 this','2 this',0,1,1.2,'T200',1),(152,'2 this is','2 this is',0,1,1.3,'T200',1),(153,'3 part','3 part',0,1,1.2,'P630',1),(154,'3 part of','3 part of',0,1,1.3,'P631',1),(155,'3 this','3 this',0,1,1.2,'T200',1),(156,'3 this is','3 this is',0,1,1.3,'T200',1),(157,'3 tooltips','3 tooltips',0,1,1.3333,'T4312',1),(158,'3 tooltips highlights','3 tooltips highlights',0,1,1.7,'T43124232',1),(159,'3 ul','3 ul',0,1,1.1333,'U400',1),(160,'3 ul class','3 ul class',0,1,1.3333,'U4242',1),(161,'3 vivamus','3 vivamus',0,1,1.3,'V520',1),(162,'3 vivamus rhoncus','3 vivamus rhoncus',0,1,1.5667,'V52652',1),(163,'4 part','4 part',0,1,1.2,'P630',1),(164,'4 part of','4 part of',0,1,1.3,'P631',1),(165,'4 proin','4 proin',0,1,1.2333,'P650',1),(166,'4 proin urna','4 proin urna',0,1,1.4,'P6565',1),(167,'5 part','5 part',0,1,1.2,'P630',1),(168,'5 part of','5 part of',0,1,1.3,'P631',1),(169,'6 part','6 part',0,1,1.2,'P630',1),(170,'6 part of','6 part of',0,1,1.3,'P631',1),(171,'7 part','7 part',0,1,1.2,'P630',1),(172,'7 part of','7 part of',0,1,1.3,'P631',1),(173,'8 part','8 part',0,1,1.2,'P630',1),(174,'8 part of','8 part of',0,1,1.3,'P631',1),(175,'a','a',0,0,0.0667,'A000',36),(176,'a calendar','a calendar',0,1,1.3333,'A24536',1),(177,'a calendar feed','a calendar feed',0,1,1.5,'A2453613',1),(178,'a classic','a classic',0,1,1.3,'A242',1),(179,'a classic this','a classic this',0,1,1.4667,'A24232',1),(180,'a condiment','a condiment',0,1,1.3667,'A25353',1),(181,'a condiment as','a condiment as',0,1,1.4667,'A253532',1),(182,'a css','a css',0,1,1.1667,'A200',1),(183,'a css tooltip','a css tooltip',0,1,1.4333,'A23431',1),(184,'a dairy','a dairy',0,1,1.2333,'A360',1),(185,'a dairy product','a dairy product',0,1,1.5,'A3616323',1),(186,'a group','a group',0,1,1.2333,'A261',1),(187,'a group calendar','a group calendar',0,1,1.5333,'A26124536',1),(188,'a headline','a headline',0,1,1.3333,'A345',1),(189,'a headline this','a headline this',0,1,1.5,'A34532',1),(190,'a highlight','a highlight',0,1,1.3667,'A2423',1),(191,'a highlight phrase','a highlight phrase',0,1,1.6,'A2423162',1),(192,'a large','a large',0,1,1.2333,'A462',2),(193,'a large headline','a large headline',0,1,1.5333,'A462345',1),(194,'a lorem','a lorem',0,1,1.2333,'A465',5),(195,'a lorem praesent','a lorem praesent',0,1,1.5333,'A46516253',1),(196,'a malesuada','a malesuada',0,1,1.3667,'A5423',1),(197,'a malesuada felis','a malesuada felis',0,1,1.5667,'A5423142',1),(198,'a mollis','a mollis',0,1,1.2667,'A542',1),(199,'a mollis nunc','a mollis nunc',0,1,1.4333,'A54252',1),(200,'a neque','a neque',0,1,1.2333,'A520',1),(201,'a neque cum','a neque cum',0,1,1.3667,'A525',1),(202,'a number','a number',0,1,1.2667,'A516',1),(203,'a number span','a number span',0,1,1.4333,'A516215',1),(204,'a sample','a sample',0,1,1.2667,'A2514',2),(205,'a sample accept','a sample accept',0,1,1.5,'A2514213',1),(206,'a sample add','a sample add',0,1,1.4,'A25143',1),(207,'a sample audio','a sample audio',0,1,1.4667,'A25143',1),(208,'a sample box','a sample box',0,1,1.4,'A251412',1),(209,'a sample brick','a sample brick',0,1,1.4667,'A2514162',1),(210,'a sample calendar','a sample calendar',0,1,1.5667,'A251424536',1),(211,'a sample camera','a sample camera',0,1,1.5,'A2514256',1),(212,'a sample cart','a sample cart',0,1,1.4333,'A2514263',1),(213,'a sample cd','a sample cd',0,1,1.3667,'A251423',1),(214,'a sample chart','a sample chart',0,1,1.4667,'A2514263',1),(215,'a sample clock','a sample clock',0,1,1.4667,'A2514242',1),(216,'a sample coffe','a sample coffe',0,1,1.4667,'A251421',1),(217,'a sample cog','a sample cog',0,1,1.4,'A25142',1),(218,'a sample coins','a sample coins',0,1,1.4667,'A2514252',1),(219,'a sample compress','a sample compress',0,1,1.5667,'A251425162',1),(220,'a sample computer','a sample computer',0,1,1.5667,'A251425136',1),(221,'a sample config','a sample config',0,1,1.5,'A25142512',1),(222,'a sample configuration','a sample configuration',0,1,1.7333,'A25142512635',1),(223,'a sample contact','a sample contact',0,1,1.5333,'A251425323',1),(224,'a sample creditcard','a sample creditcard',0,1,1.6333,'A2514263263',1),(225,'a sample cross','a sample cross',0,1,1.4667,'A2514262',1),(226,'a sample disk','a sample disk',0,1,1.4333,'A251432',1),(227,'a sample email','a sample email',0,1,1.4667,'A251454',1),(228,'a sample error','a sample error',0,1,1.4667,'A25146',2),(229,'a sample exclamation','a sample exclamation',0,1,1.6667,'A251424535',1),(230,'a sample facebook','a sample facebook',0,1,1.5667,'A25141212',1),(231,'a sample feed','a sample feed',0,1,1.4333,'A251413',1),(232,'a sample film','a sample film',0,1,1.4333,'A2514145',1),(233,'a sample folder','a sample folder',0,1,1.5,'A25141436',1),(234,'a sample group','a sample group',0,1,1.4667,'A2514261',1),(235,'a sample heart','a sample heart',0,1,1.4667,'A251463',1),(236,'a sample help','a sample help',0,1,1.4333,'A25141',1),(237,'a sample house','a sample house',0,1,1.4667,'A25142',1),(238,'a sample image','a sample image',0,1,1.4667,'A251452',1),(239,'a sample images','a sample images',0,1,1.5,'A251452',1),(240,'a sample info','a sample info',0,1,1.4333,'A251451',1),(241,'a sample information','a sample information',0,1,1.6667,'A2514516535',1),(242,'a sample legend','a sample legend',0,1,1.5,'A2514253',1),(243,'a sample like','a sample like',0,1,1.4333,'A25142',1),(244,'a sample lock','a sample lock',0,1,1.4333,'A25142',1),(245,'a sample magnifier','a sample magnifier',0,1,1.6,'A251452516',1),(246,'a sample money','a sample money',0,1,1.4667,'A25145',1),(247,'a sample movie','a sample movie',0,1,1.4667,'A251451',1),(248,'a sample new','a sample new',0,1,1.4,'A25145',1),(249,'a sample note','a sample note',0,1,1.4333,'A251453',1),(250,'a sample of','a sample of',0,1,1.3667,'A25141',1),(251,'a sample page','a sample page',0,1,1.4333,'A251412',1),(252,'a sample pin','a sample pin',0,1,1.4,'A251415',1),(253,'a sample plugin','a sample plugin',0,1,1.5,'A25141425',1),(254,'a sample printer','a sample printer',0,1,1.5333,'A251416536',1),(255,'a sample quote','a sample quote',0,1,1.4667,'A251423',1),(256,'a sample report','a sample report',0,1,1.5,'A25146163',1),(257,'a sample script','a sample script',0,1,1.5,'A25142613',1),(258,'a sample star','a sample star',0,1,1.4333,'A2514236',1),(259,'a sample telephone','a sample telephone',0,1,1.6,'A25143415',1),(260,'a sample text','a sample text',0,1,1.4333,'A2514323',1),(261,'a sample time','a sample time',0,1,1.4333,'A251435',1),(262,'a sample tips','a sample tips',0,1,1.4333,'A2514312',1),(263,'a sample twitter','a sample twitter',0,1,1.5333,'A251436',1),(264,'a sample user','a sample user',0,1,1.4333,'A251426',1),(265,'a sample video','a sample video',0,1,1.4667,'A251413',1),(266,'a sample warning','a sample warning',0,1,1.5333,'A2514652',2),(267,'a sample webcam','a sample webcam',0,1,1.5,'A2514125',1),(268,'a sample world','a sample world',0,1,1.4667,'A2514643',1),(269,'a sample youtube','a sample youtube',0,1,1.5333,'A251431',1),(270,'a separate','a separate',0,1,1.3333,'A2163',1),(271,'a separate block','a separate block',0,1,1.5333,'A2163142',1),(272,'a small','a small',0,1,1.2333,'A254',1),(273,'a small headline','a small headline',0,1,1.5333,'A254345',1),(274,'a spread','a spread',0,1,1.2667,'A2163',1),(275,'a spread and','a spread and',0,1,1.4,'A216353',1),(276,'a subheadline','a subheadline',0,1,1.4333,'A21345',1),(277,'a subheadline use','a subheadline use',0,1,1.5667,'A213452',1),(278,'abbr','abbr',0,0,0.2667,'A160',1),(279,'abbr definition','abbr definition',0,1,1.5,'A1631535',1),(280,'abbr definition lists','abbr definition lists',0,1,1.7,'A16315354232',1),(281,'abbr this','abbr this',0,1,1.3,'A1632',1),(282,'abbr this is','abbr this is',0,1,1.4,'A1632',1),(283,'abbr title','abbr title',0,1,1.3333,'A1634',1),(284,'abbr title here','abbr title here',0,1,1.5,'A16346',1),(285,'abbreviation','abbreviation',0,0,0.8,'A16135',1),(286,'abbreviation abbr','abbreviation abbr',0,1,1.5667,'A1613516',1),(287,'abbreviation abbr this','abbreviation abbr this',0,1,1.7333,'A161351632',1),(288,'abbreviation dr','abbreviation dr',0,1,1.5,'A1613536',1),(289,'abbreviation dr use','abbreviation dr use',0,1,1.6333,'A16135362',1),(290,'abbrs','abbrs',0,0,0.3333,'A162',1),(291,'abbrs and','abbrs and',0,1,1.3,'A16253',1),(292,'abbrs and acronyms','abbrs and acronyms',0,1,1.6,'A162532652',1),(293,'able','able',0,0,0.2667,'A140',6),(294,'able to','able to',0,1,1.2333,'A143',6),(295,'able to digest','able to digest',0,1,1.4667,'A14323',1),(296,'about','about',0,0,0.3333,'A130',7),(297,'about to','about to',0,1,1.2667,'A130',1),(298,'about to define','about to define',0,1,1.5,'A1315',1),(299,'ac','ac',0,0,0.1333,'A200',25),(300,'ac dui','ac dui',0,1,1.2,'A230',1),(301,'ac dui sed','ac dui sed',0,1,1.3333,'A2323',1),(302,'ac eros','ac eros',0,1,1.2333,'A262',1),(303,'ac eros tempor','ac eros tempor',0,1,1.4667,'A2623516',1),(304,'ac mollis','ac mollis',0,1,1.3,'A2542',1),(305,'ac mollis pretium','ac mollis pretium',0,1,1.5667,'A25421635',1),(306,'ac morbi','ac morbi',0,1,1.2667,'A2561',1),(307,'ac morbi quis','ac morbi quis',0,1,1.4333,'A25612',1),(308,'ac sem','ac sem',0,1,1.2,'A250',1),(309,'ac sem sed','ac sem sed',0,1,1.3333,'A2523',1),(310,'accept','accept',0,0,0.4,'A213',2),(311,'accept goes','accept goes',0,1,1.3667,'A2132',1),(312,'accept goes here','accept goes here',0,1,1.5333,'A21326',1),(313,'accept message','accept message',0,1,1.4667,'A21352',1),(314,'accept message use','accept message use',0,1,1.6,'A21352',1),(315,'accumsan','accumsan',0,0,0.5333,'A2525',12),(316,'accumsan at','accumsan at',0,1,1.3667,'A25253',1),(317,'accumsan at purus','accumsan at purus',0,1,1.5667,'A25253162',1),(318,'accumsan cursus','accumsan cursus',0,1,1.5,'A2525262',1),(319,'accumsan cursus massa','accumsan cursus massa',0,1,1.7,'A252526252',1),(320,'accumsan this','accumsan this',0,1,1.4333,'A252532',1),(321,'accumsan this is','accumsan this is',0,1,1.5333,'A252532',1),(322,'acronym','acronym',0,0,0.4667,'A265',1),(323,'acronym abbr','acronym abbr',0,1,1.4,'A26516',1),(324,'acronym abbr definition','acronym abbr definition',0,1,1.7667,'A2651631535',1),(325,'acronym nato','acronym nato',0,1,1.4,'A2653',1),(326,'acronym nato use','acronym nato use',0,1,1.5333,'A26532',1),(327,'acronym title','acronym title',0,1,1.4333,'A26534',1),(328,'acronym title here','acronym title here',0,1,1.6,'A265346',1),(329,'acronyms','acronyms',0,0,0.5333,'A2652',1),(330,'acronyms definition','acronyms definition',0,1,1.6333,'A265231535',1),(331,'acronyms definition lists','acronyms definition lists',0,1,1.8333,'A2652315354232',1),(332,'acronyms this','acronyms this',0,1,1.4333,'A265232',1),(333,'acronyms this is','acronyms this is',0,1,1.5333,'A265232',1),(334,'add','add',0,0,0.2,'A300',1),(335,'add message','add message',0,1,1.3667,'A352',1),(336,'add message goes','add message goes',0,1,1.5333,'A352',1),(337,'add message use','add message use',0,1,1.5,'A352',1),(338,'adipiscing','adipiscing',0,0,0.6667,'A31252',20),(339,'adipiscing elit','adipiscing elit',0,1,1.5,'A3125243',20),(340,'adipiscing elit integer','adipiscing elit integer',0,1,1.7667,'A31252435326',1),(341,'adipiscing elit vestibulum','adipiscing elit vestibulum',0,1,1.8667,'A3125243123145',7),(342,'adipiscing justo','adipiscing justo',0,1,1.5333,'A312523',1),(343,'adipiscing justo sit','adipiscing justo sit',0,1,1.6667,'A31252323',1),(344,'adipiscing velit','adipiscing velit',0,1,1.5333,'A31252143',1),(345,'adipiscing velit ac','adipiscing velit ac',0,1,1.6333,'A312521432',1),(346,'administrator','administrator',0,0,0.8667,'A3523636',39),(347,'aenean','aenean',0,0,0.4,'A500',4),(348,'aenean tristique','aenean tristique',0,1,1.5333,'A536232',1),(349,'aenean tristique fusce','aenean tristique fusce',0,1,1.7333,'A53623212',1),(350,'aenean venenatis','aenean venenatis',0,1,1.5333,'A51532',1),(351,'aenean venenatis aliquet','aenean venenatis aliquet',0,1,1.8,'A51532423',1),(352,'aliquam','aliquam',0,0,0.4667,'A425',26),(353,'aliquam laoreet','aliquam laoreet',0,1,1.5,'A425463',1),(354,'aliquam laoreet enim','aliquam laoreet enim',0,1,1.6667,'A4254635',1),(355,'aliquam nibh','aliquam nibh',0,1,1.4,'A4251',1),(356,'aliquam nibh mattis','aliquam nibh mattis',0,1,1.6333,'A4251532',1),(357,'aliquam rhoncus','aliquam rhoncus',0,1,1.5,'A425652',1),(358,'aliquam rhoncus enim','aliquam rhoncus enim',0,1,1.6667,'A4256525',1),(359,'aliquam ullamcorper','aliquam ullamcorper',0,1,1.6333,'A425452616',1),(360,'aliquam ullamcorper donec','aliquam ullamcorper donec',0,1,1.8333,'A425452616352',1),(361,'aliquam ut','aliquam ut',0,1,1.3333,'A4253',1),(362,'aliquam ut consequat','aliquam ut consequat',0,1,1.6667,'A42532523',1),(363,'aliquam varius','aliquam varius',0,1,1.4667,'A425162',1),(364,'aliquam varius placerat','aliquam varius placerat',0,1,1.7667,'A42516214263',1),(365,'aliquet','aliquet',0,0,0.4667,'A423',26),(366,'aliquet euismod','aliquet euismod',0,1,1.5,'A423253',1),(367,'aliquet euismod nam','aliquet euismod nam',0,1,1.6333,'A4232535',1),(368,'aliquet turpis','aliquet turpis',0,1,1.4667,'A423612',1),(369,'aliquet turpis in','aliquet turpis in',0,1,1.5667,'A4236125',1),(370,'amet','amet',0,0,0.2667,'A530',27),(371,'amet condimentum','amet condimentum',0,1,1.5333,'A53253535',1),(372,'amet condimentum urna','amet condimentum urna',0,1,1.7,'A5325353565',1),(373,'amet consectetuer','amet consectetuer',0,1,1.5667,'A5325236',1),(374,'amet consectetuer adipiscing','amet consectetuer adipiscing',0,1,1.9333,'A532523631252',1),(375,'amet consectetur','amet consectetur',0,1,1.5333,'A5325236',20),(376,'amet consectetur adipiscing','amet consectetur adipiscing',0,1,1.9,'A532523631252',20),(377,'amet est','amet est',0,1,1.2667,'A5323',1),(378,'amet est tristique','amet est tristique',0,1,1.6,'A53236232',1),(379,'an','an',0,0,0.1333,'A500',12),(380,'an abbreviation','an abbreviation',0,1,1.5,'A516135',1),(381,'an abbreviation abbr','an abbreviation abbr',0,1,1.6667,'A51613516',1),(382,'an abbreviation dr','an abbreviation dr',0,1,1.6,'A51613536',1),(383,'an acronym','an acronym',0,1,1.3333,'A5265',1),(384,'an acronym abbr','an acronym abbr',0,1,1.5,'A526516',1),(385,'an acronym nato','an acronym nato',0,1,1.5,'A52653',1),(386,'an example','an example',0,1,1.3333,'A52514',1),(387,'an example of','an example of',0,1,1.4333,'A525141',1),(388,'an opaque','an opaque',0,1,1.3,'A512',1),(389,'an opaque white','an opaque white',0,1,1.5,'A5123',1),(390,'and','and',0,0,0.2,'A530',14),(391,'and a','and a',0,1,1.1667,'A530',2),(392,'and a condiment','and a condiment',0,1,1.5,'A5325353',1),(393,'and acronyms','and acronyms',0,1,1.4,'A532652',1),(394,'and acronyms definition','and acronyms definition',0,1,1.7667,'A53265231535',1),(395,'and acronyms this','and acronyms this',0,1,1.5667,'A53265232',1),(396,'and frying','and frying',0,1,1.3333,'A531652',1),(397,'and frying butter','and frying butter',0,1,1.5667,'A531652136',1),(398,'and here','and here',0,1,1.2667,'A536',1),(399,'and here text','and here text',0,1,1.4333,'A536323',1),(400,'and milk','and milk',0,1,1.2667,'A53542',1),(401,'and milk proteins','and milk proteins',0,1,1.5667,'A5354216352',1),(402,'and produce','and produce',0,1,1.3667,'A531632',1),(403,'and produce your','and produce your',0,1,1.5333,'A5316326',1),(404,'and warning','and warning',0,1,1.3667,'A53652',1),(405,'and warning warning','and warning warning',0,1,1.6333,'A53652652',1),(406,'ante','ante',0,0,0.2667,'A530',24),(407,'ante ac','ante ac',0,1,1.2333,'A532',1),(408,'ante ac dui','ante ac dui',0,1,1.3667,'A5323',1),(409,'ante felis','ante felis',0,1,1.3333,'A53142',1),(410,'ante felis aliquam','ante felis aliquam',0,1,1.6,'A53142425',1),(411,'applications','applications',0,0,0.8,'A142352',2),(412,'applications such','applications such',0,1,1.5667,'A142352',1),(413,'applications such as','applications such as',0,1,1.6667,'A142352',1),(414,'arcu','arcu',0,0,0.2667,'A620',17),(415,'arcu sit','arcu sit',0,1,1.2667,'A623',4),(416,'arcu sit amet','arcu sit amet',0,1,1.4333,'A62353',4),(417,'are','are',0,0,0.2,'A600',7),(418,'are able','are able',0,1,1.2667,'A614',1),(419,'are able to','are able to',0,1,1.3667,'A6143',1),(420,'are samples','are samples',0,1,1.3667,'A625142',1),(421,'are samples of','are samples of',0,1,1.4667,'A6251421',1),(422,'are some','are some',0,1,1.2667,'A625',1),(423,'are some examples','are some examples',0,1,1.5667,'A62525142',1),(424,'article','article',0,0,0.4667,'A6324',39),(425,'as','as',0,0,0.1333,'A200',7),(426,'as a','as a',0,1,1.1333,'A200',5),(427,'as a spread','as a spread',0,1,1.3667,'A2163',1),(428,'as baking','as baking',0,1,1.3,'A21252',1),(429,'as baking sauce','as baking sauce',0,1,1.5,'A21252',1),(430,'as in','as in',0,1,1.1667,'A250',1),(431,'as in cooking','as in cooking',0,1,1.4333,'A25252',1),(432,'as well','as well',0,1,1.2333,'A240',2),(433,'as well as','as well as',0,1,1.3333,'A242',2),(434,'at','at',0,0,0.1333,'A300',29),(435,'at accumsan','at accumsan',0,1,1.3667,'A32525',1),(436,'at accumsan at','at accumsan at',0,1,1.4667,'A325253',1),(437,'at euismod','at euismod',0,1,1.3333,'A3253',1),(438,'at euismod rutrum','at euismod rutrum',0,1,1.5667,'A32536365',1),(439,'at purus','at purus',0,1,1.2667,'A3162',1),(440,'at purus donec','at purus donec',0,1,1.4667,'A3162352',1),(441,'auctor','auctor',0,0,0.4,'A236',15),(442,'auctor et','auctor et',0,1,1.3,'A2363',9),(443,'auctor et quisque','auctor et quisque',0,1,1.5667,'A23632',1),(444,'audio','audio',0,0,0.3333,'A300',1),(445,'audio message','audio message',0,1,1.4333,'A352',1),(446,'audio message goes','audio message goes',0,1,1.6,'A352',1),(447,'audio message use','audio message use',0,1,1.5667,'A352',1),(448,'augue','augue',0,0,0.3333,'A200',15),(449,'augue donec','augue donec',0,1,1.3667,'A2352',1),(450,'augue donec ante','augue donec ante',0,1,1.5333,'A235253',1),(451,'augue donec eget','augue donec eget',0,1,1.5333,'A23523',1),(452,'augue duis','augue duis',0,1,1.3333,'A232',1),(453,'augue duis quis','augue duis quis',0,1,1.5,'A232',1),(454,'augue id','augue id',0,1,1.2667,'A230',4),(455,'augue id fringilla','augue id fringilla',0,1,1.6,'A2316524',1),(456,'augue non','augue non',0,1,1.3,'A250',1),(457,'augue non posuere','augue non posuere',0,1,1.5667,'A25126',1),(458,'baking','baking',0,0,0.4,'B252',1),(459,'baking sauce','baking sauce',0,1,1.4,'B252',1),(460,'baking sauce making','baking sauce making',0,1,1.6333,'B2525252',1),(461,'bar','bar',0,0,0.2,'B600',2),(462,'bar goes','bar goes',0,1,1.2667,'B620',1),(463,'bar goes here','bar goes here',0,1,1.4333,'B626',1),(464,'bar message','bar message',0,1,1.3667,'B652',1),(465,'bar message goes','bar message goes',0,1,1.5333,'B652',1),(466,'bar message use','bar message use',0,1,1.5,'B652',1),(467,'before','before',0,0,0.4,'B600',2),(468,'before they','before they',0,1,1.3667,'B630',1),(469,'before they are','before they are',0,1,1.5,'B636',1),(470,'below','below',0,0,0.3333,'B400',1),(471,'below are','below are',0,1,1.3,'B460',1),(472,'below are samples','below are samples',0,1,1.5667,'B4625142',1),(473,'below is','below is',0,1,1.2667,'B420',1),(474,'below is a','below is a',0,1,1.3333,'B420',1),(475,'blandit','blandit',0,0,0.4667,'B453',24),(476,'blandit elit','blandit elit',0,1,1.4,'B45343',4),(477,'blandit elit at','blandit elit at',0,1,1.5,'B45343',1),(478,'blandit urna','blandit urna',0,1,1.4,'B45365',1),(479,'blandit urna sodales','blandit urna sodales',0,1,1.6667,'B453652342',1),(480,'block','block',0,0,0.3333,'B420',1),(481,'block below','block below',0,1,1.3667,'B4214',1),(482,'block below is','block below is',0,1,1.4667,'B42142',1),(483,'block of','block of',0,1,1.2667,'B421',1),(484,'block of text','block of text',0,1,1.4333,'B421323',1),(485,'block p','block p',0,1,1.2333,'B421',1),(486,'block p here','block p here',0,1,1.4,'B4216',1),(487,'block unordered','block unordered',0,1,1.5,'B4256363',1),(488,'block unordered lists','block unordered lists',0,1,1.7,'B42563634232',1),(489,'blockquote','blockquote',0,0,0.6667,'B423',1),(490,'blockquote div','blockquote div',0,1,1.4667,'B4231',1),(491,'blockquote div class','blockquote div class',0,1,1.6667,'B4231242',1),(492,'blockquote tables','blockquote tables',0,1,1.5667,'B423142',1),(493,'blockquote tables table','blockquote tables table',0,1,1.7667,'B423142314',1),(494,'blockquote this','blockquote this',0,1,1.5,'B4232',1),(495,'blockquote this is','blockquote this is',0,1,1.6,'B4232',1),(496,'blockquote your','blockquote your',0,1,1.5,'B4236',1),(497,'blockquote your quoted','blockquote your quoted',0,1,1.7333,'B423623',1),(498,'blockquotes','blockquotes',0,0,0.7333,'B4232',1),(499,'blockquotes tables','blockquotes tables',0,1,1.6,'B42323142',1),(500,'blockquotes tables warnings','blockquotes tables warnings',0,1,1.9,'B42323142652',1),(501,'blockquotes this','blockquotes this',0,1,1.5333,'B423232',1),(502,'blockquotes this is','blockquotes this is',0,1,1.6333,'B423232',1),(503,'blocks','blocks',0,0,0.4,'B420',1),(504,'blocks below','blocks below',0,1,1.4,'B4214',1),(505,'blocks below are','blocks below are',0,1,1.5333,'B42146',1),(506,'blocks blockquotes','blocks blockquotes',0,1,1.6,'B4214232',1),(507,'blocks blockquotes tables','blocks blockquotes tables',0,1,1.8333,'B42142323142',1),(508,'blocks other','blocks other',0,1,1.4,'B4236',1),(509,'blocks other span','blocks other span',0,1,1.5667,'B4236215',1),(510,'blocks this','blocks this',0,1,1.3667,'B4232',1),(511,'blocks this is','blocks this is',0,1,1.4667,'B4232',1),(512,'box','box',0,0,0.2,'B200',1),(513,'box message','box message',0,1,1.3667,'B252',1),(514,'box message goes','box message goes',0,1,1.5333,'B252',1),(515,'box message use','box message use',0,1,1.5,'B252',1),(516,'brick','brick',0,0,0.3333,'B620',1),(517,'brick goes','brick goes',0,1,1.3333,'B620',1),(518,'brick goes here','brick goes here',0,1,1.5,'B626',1),(519,'brick message','brick message',0,1,1.4333,'B6252',1),(520,'brick message use','brick message use',0,1,1.5667,'B6252',1),(521,'butter','butter',0,0,0.4,'B360',1),(522,'butter consists','butter consists',0,1,1.5,'B3625232',1),(523,'butter consists of','butter consists of',0,1,1.6,'B36252321',1),(524,'butter it','butter it',0,1,1.3,'B363',1),(525,'butter it is','butter it is',0,1,1.4,'B3632',1),(526,'butterfat','butterfat',0,0,0.6,'B3613',1),(527,'butterfat water','butterfat water',0,1,1.5,'B36136',1),(528,'butterfat water and','butterfat water and',0,1,1.6333,'B3613653',1),(529,'by','by',0,0,0.1333,'B000',12),(530,'by churning','by churning',0,1,1.3667,'B2652',1),(531,'by churning fresh','by churning fresh',0,1,1.5667,'B2652162',1),(532,'by the','by the',0,1,1.2,'B300',2),(533,'by the mammary','by the mammary',0,1,1.4667,'B356',1),(534,'calendar','calendar',0,0,0.5333,'C4536',1),(535,'calendar feed','calendar feed',0,1,1.4333,'C453613',1),(536,'calendar feed message','calendar feed message',0,1,1.7,'C45361352',1),(537,'calendar message','calendar message',0,1,1.5333,'C453652',1),(538,'calendar message goes','calendar message goes',0,1,1.7,'C453652',1),(539,'calendar message use','calendar message use',0,1,1.6667,'C453652',1),(540,'camera','camera',0,0,0.4,'C560',1),(541,'camera message','camera message',0,1,1.4667,'C5652',1),(542,'camera message goes','camera message goes',0,1,1.6333,'C5652',1),(543,'camera message use','camera message use',0,1,1.6,'C5652',1),(544,'can','can',0,0,0.2,'C500',13),(545,'can do','can do',0,1,1.2,'C530',1),(546,'can do so','can do so',0,1,1.3,'C532',1),(547,'can do using','can do using',0,1,1.4,'C53252',1),(548,'cart','cart',0,0,0.2667,'C630',1),(549,'cart message','cart message',0,1,1.4,'C6352',1),(550,'cart message goes','cart message goes',0,1,1.5667,'C6352',1),(551,'cart message use','cart message use',0,1,1.5333,'C6352',1),(552,'cd','cd',0,0,0.1333,'C300',1),(553,'cd message','cd message',0,1,1.3333,'C352',1),(554,'cd message goes','cd message goes',0,1,1.5,'C352',1),(555,'cd message use','cd message use',0,1,1.4667,'C352',1),(556,'cell','cell',0,0,0.2667,'C400',1),(557,'cell 1','cell 1',0,1,1.2,'C400',1),(558,'cell 1 part','cell 1 part',0,1,1.3667,'C4163',1),(559,'cell 2','cell 2',0,1,1.2,'C400',1),(560,'cell 2 part','cell 2 part',0,1,1.3667,'C4163',1),(561,'cell 3','cell 3',0,1,1.2,'C400',1),(562,'cell 3 part','cell 3 part',0,1,1.3667,'C4163',1),(563,'cell 4','cell 4',0,1,1.2,'C400',1),(564,'cell 4 part','cell 4 part',0,1,1.3667,'C4163',1),(565,'cell 5','cell 5',0,1,1.2,'C400',1),(566,'cell 5 part','cell 5 part',0,1,1.3667,'C4163',1),(567,'cell 6','cell 6',0,1,1.2,'C400',1),(568,'cell 6 part','cell 6 part',0,1,1.3667,'C4163',1),(569,'cell 7','cell 7',0,1,1.2,'C400',1),(570,'cell 7 part','cell 7 part',0,1,1.3667,'C4163',1),(571,'cell 8','cell 8',0,1,1.2,'C400',1),(572,'cell 8 part','cell 8 part',0,1,1.3667,'C4163',1),(573,'chart','chart',0,0,0.3333,'C630',1),(574,'chart bar','chart bar',0,1,1.3,'C6316',1),(575,'chart bar goes','chart bar goes',0,1,1.4667,'C63162',1),(576,'chart bar message','chart bar message',0,1,1.5667,'C631652',1),(577,'chart line','chart line',0,1,1.3333,'C6345',1),(578,'chart line message','chart line message',0,1,1.6,'C63452',1),(579,'chart pie','chart pie',0,1,1.3,'C631',1),(580,'chart pie message','chart pie message',0,1,1.5667,'C63152',1),(581,'churning','churning',0,0,0.5333,'C652',1),(582,'churning fresh','churning fresh',0,1,1.4667,'C652162',1),(583,'churning fresh or','churning fresh or',0,1,1.5667,'C6521626',1),(584,'class','class',0,0,0.3333,'C420',1),(585,'class demo-typo','class demo-typo',0,1,1.5,'C423531',1),(586,'class demo-typo ordered','class demo-typo ordered',0,1,1.7667,'C4235316363',1),(587,'class gkaccept','class gkaccept',0,1,1.4667,'C4213',1),(588,'class gkaccept your','class gkaccept your',0,1,1.6333,'C42136',1),(589,'class gkadd','class gkadd',0,1,1.3667,'C423',1),(590,'class gkadd your','class gkadd your',0,1,1.5333,'C4236',1),(591,'class gkalpha','class gkalpha',0,1,1.4333,'C4241',1),(592,'class gkalpha element','class gkalpha element',0,1,1.7,'C4241453',1),(593,'class gkaudio','class gkaudio',0,1,1.4333,'C423',1),(594,'class gkaudio your','class gkaudio your',0,1,1.6,'C4236',1),(595,'class gkaudiois2','class gkaudiois2',0,1,1.5333,'C4232',1),(596,'class gkaudiois2 your','class gkaudiois2 your',0,1,1.7,'C42326',1),(597,'class gkaudiois3','class gkaudiois3',0,1,1.5333,'C4232',1),(598,'class gkaudiois3 your','class gkaudiois3 your',0,1,1.7,'C42326',1),(599,'class gkblockquote1','class gkblockquote1',0,1,1.6333,'C421423',1),(600,'class gkblockquote1 div','class gkblockquote1 div',0,1,1.7667,'C4214231',1),(601,'class gkblockquote1 this','class gkblockquote1 this',0,1,1.8,'C4214232',1),(602,'class gkblockquote2','class gkblockquote2',0,1,1.6333,'C421423',1),(603,'class gkblockquote2 div','class gkblockquote2 div',0,1,1.7667,'C4214231',1),(604,'class gkblockquote3','class gkblockquote3',0,1,1.6333,'C421423',1),(605,'class gkblockquote3 div','class gkblockquote3 div',0,1,1.7667,'C4214231',1),(606,'class gkblockquote4','class gkblockquote4',0,1,1.6333,'C421423',1),(607,'class gkblockquote4 div','class gkblockquote4 div',0,1,1.7667,'C4214231',1),(608,'class gkblocktextcenter','class gkblocktextcenter',0,1,1.7667,'C421423232536',1),(609,'class gkblocktextcenter block','class gkblocktextcenter block',0,1,1.9667,'C421423232536142',1),(610,'class gkblocktextleft','class gkblocktextleft',0,1,1.7,'C42142323413',1),(611,'class gkblocktextleft block','class gkblocktextleft block',0,1,1.9,'C42142323413142',1),(612,'class gkblocktextright','class gkblocktextright',0,1,1.7333,'C42142323623',1),(613,'class gkblocktextright block','class gkblocktextright block',0,1,1.9333,'C42142323623142',1),(614,'class gkbox','class gkbox',0,1,1.3667,'C4212',1),(615,'class gkbox your','class gkbox your',0,1,1.5333,'C42126',1),(616,'class gkbrick','class gkbrick',0,1,1.4333,'C42162',1),(617,'class gkbrick your','class gkbrick your',0,1,1.6,'C421626',1),(618,'class gkbullet1','class gkbullet1',0,1,1.5,'C42143',1),(619,'class gkbullet1 element','class gkbullet1 element',0,1,1.7667,'C42143453',1),(620,'class gkbullet2','class gkbullet2',0,1,1.5,'C42143',1),(621,'class gkbullet2 element','class gkbullet2 element',0,1,1.7667,'C42143453',1),(622,'class gkbullet3','class gkbullet3',0,1,1.5,'C42143',1),(623,'class gkbullet3 element','class gkbullet3 element',0,1,1.7667,'C42143453',1),(624,'class gkbullet4','class gkbullet4',0,1,1.5,'C42143',1),(625,'class gkbullet4 element','class gkbullet4 element',0,1,1.7667,'C42143453',1),(626,'class gkcalendar','class gkcalendar',0,1,1.5333,'C424536',1),(627,'class gkcalendar your','class gkcalendar your',0,1,1.7,'C424536',1),(628,'class gkcalendaris2','class gkcalendaris2',0,1,1.6333,'C4245362',1),(629,'class gkcalendaris2 your','class gkcalendaris2 your',0,1,1.8,'C42453626',1),(630,'class gkcamera','class gkcamera',0,1,1.4667,'C4256',1),(631,'class gkcamera your','class gkcamera your',0,1,1.6333,'C4256',1),(632,'class gkcamerais2','class gkcamerais2',0,1,1.5667,'C42562',1),(633,'class gkcamerais2 your','class gkcamerais2 your',0,1,1.7333,'C425626',1),(634,'class gkcamerais3','class gkcamerais3',0,1,1.5667,'C42562',1),(635,'class gkcamerais3 your','class gkcamerais3 your',0,1,1.7333,'C425626',1),(636,'class gkcart','class gkcart',0,1,1.4,'C4263',1),(637,'class gkcart your','class gkcart your',0,1,1.5667,'C42636',1),(638,'class gkcartis2','class gkcartis2',0,1,1.5,'C42632',1),(639,'class gkcartis2 your','class gkcartis2 your',0,1,1.6667,'C426326',1),(640,'class gkcartis3','class gkcartis3',0,1,1.5,'C42632',1),(641,'class gkcartis3 your','class gkcartis3 your',0,1,1.6667,'C426326',1),(642,'class gkcd','class gkcd',0,1,1.3333,'C423',1),(643,'class gkcd your','class gkcd your',0,1,1.5,'C4236',1),(644,'class gkcdis2','class gkcdis2',0,1,1.4333,'C4232',1),(645,'class gkcdis2 your','class gkcdis2 your',0,1,1.6,'C42326',1),(646,'class gkchartbar','class gkchartbar',0,1,1.5333,'C426316',1),(647,'class gkchartbar your','class gkchartbar your',0,1,1.7,'C426316',1),(648,'class gkchartbaris3','class gkchartbaris3',0,1,1.6333,'C4263162',1),(649,'class gkchartbaris3 your','class gkchartbaris3 your',0,1,1.8,'C42631626',1),(650,'class gkchartline','class gkchartline',0,1,1.5667,'C426345',1),(651,'class gkchartline your','class gkchartline your',0,1,1.7333,'C4263456',1),(652,'class gkchartlineis2','class gkchartlineis2',0,1,1.6667,'C4263452',1),(653,'class gkchartlineis2 your','class gkchartlineis2 your',0,1,1.8333,'C42634526',1),(654,'class gkchartpie','class gkchartpie',0,1,1.5333,'C42631',1),(655,'class gkchartpie your','class gkchartpie your',0,1,1.7,'C426316',1),(656,'class gkchartpieis2','class gkchartpieis2',0,1,1.6333,'C426312',1),(657,'class gkchartpieis2 your','class gkchartpieis2 your',0,1,1.8,'C4263126',1),(658,'class gkcircle1','class gkcircle1',0,1,1.5,'C42624',1),(659,'class gkcircle1 element','class gkcircle1 element',0,1,1.7667,'C4262453',1),(660,'class gkcircle2','class gkcircle2',0,1,1.5,'C42624',1),(661,'class gkcircle2 element','class gkcircle2 element',0,1,1.7667,'C4262453',1),(662,'class gkclear','class gkclear',0,1,1.4333,'C4246',1),(663,'class gkclear lorem','class gkclear lorem',0,1,1.6333,'C4246465',1),(664,'class gkclear-1','class gkclear-1',0,1,1.5,'C4246',1),(665,'class gkclear-1 lorem','class gkclear-1 lorem',0,1,1.7,'C4246465',1),(666,'class gkclear-2','class gkclear-2',0,1,1.5,'C4246',1),(667,'class gkclear-2 lorem','class gkclear-2 lorem',0,1,1.7,'C4246465',1),(668,'class gkclock','class gkclock',0,1,1.4333,'C4242',1),(669,'class gkclock your','class gkclock your',0,1,1.6,'C42426',1),(670,'class gkclockis2','class gkclockis2',0,1,1.5333,'C4242',1),(671,'class gkclockis2 your','class gkclockis2 your',0,1,1.7,'C42426',1),(672,'class gkcode1','class gkcode1',0,1,1.4333,'C423',1),(673,'class gkcode1 wrapper','class gkcode1 wrapper',0,1,1.7,'C423616',1),(674,'class gkcode2','class gkcode2',0,1,1.4333,'C423',1),(675,'class gkcode2 wrapper','class gkcode2 wrapper',0,1,1.7,'C423616',1),(676,'class gkcode3','class gkcode3',0,1,1.4333,'C423',1),(677,'class gkcode3 h4','class gkcode3 h4',0,1,1.5333,'C423',1),(678,'class gkcoffeis3','class gkcoffeis3',0,1,1.5333,'C4212',1),(679,'class gkcoffeis3 your','class gkcoffeis3 your',0,1,1.7,'C42126',1),(680,'class gkcog','class gkcog',0,1,1.3667,'C420',1),(681,'class gkcog your','class gkcog your',0,1,1.5333,'C426',1),(682,'class gkcogis2','class gkcogis2',0,1,1.4667,'C420',1),(683,'class gkcogis2 your','class gkcogis2 your',0,1,1.6333,'C426',1),(684,'class gkcoins','class gkcoins',0,1,1.4333,'C4252',1),(685,'class gkcoins your','class gkcoins your',0,1,1.6,'C42526',1),(686,'class gkcolor','class gkcolor',0,1,1.4333,'C4246',1),(687,'class gkcolor lorem','class gkcolor lorem',0,1,1.6333,'C4246465',1),(688,'class gkcolor-1','class gkcolor-1',0,1,1.5,'C4246',1),(689,'class gkcolor-1 lorem','class gkcolor-1 lorem',0,1,1.7,'C4246465',1),(690,'class gkcolor-2','class gkcolor-2',0,1,1.5,'C4246',1),(691,'class gkcolor-2 lorem','class gkcolor-2 lorem',0,1,1.7,'C4246465',1),(692,'class gkcolor-3','class gkcolor-3',0,1,1.5,'C4246',1),(693,'class gkcolor-3 lorem','class gkcolor-3 lorem',0,1,1.7,'C4246465',1),(694,'class gkcolor-4','class gkcolor-4',0,1,1.5,'C4246',1),(695,'class gkcolor-4 lorem','class gkcolor-4 lorem',0,1,1.7,'C4246465',1),(696,'class gkcolor-5','class gkcolor-5',0,1,1.5,'C4246',1),(697,'class gkcolor-5 lorem','class gkcolor-5 lorem',0,1,1.7,'C4246465',1),(698,'class gkcolor-6','class gkcolor-6',0,1,1.5,'C4246',1),(699,'class gkcolor-6 lorem','class gkcolor-6 lorem',0,1,1.7,'C4246465',1),(700,'class gkcolor-7','class gkcolor-7',0,1,1.5,'C4246',1),(701,'class gkcolor-7 lorem','class gkcolor-7 lorem',0,1,1.7,'C4246465',1),(702,'class gkcompress','class gkcompress',0,1,1.5333,'C425162',1),(703,'class gkcompress your','class gkcompress your',0,1,1.7,'C4251626',1),(704,'class gkcomputer','class gkcomputer',0,1,1.5333,'C425136',1),(705,'class gkcomputer your','class gkcomputer your',0,1,1.7,'C425136',1),(706,'class gkcomputeris2','class gkcomputeris2',0,1,1.6333,'C4251362',1),(707,'class gkcomputeris2 your','class gkcomputeris2 your',0,1,1.8,'C42513626',1),(708,'class gkcomputeris3','class gkcomputeris3',0,1,1.6333,'C4251362',1),(709,'class gkcomputeris3 your','class gkcomputeris3 your',0,1,1.8,'C42513626',1),(710,'class gkconfig2is3','class gkconfig2is3',0,1,1.6,'C42512',1),(711,'class gkconfig2is3 your','class gkconfig2is3 your',0,1,1.7667,'C425126',1),(712,'class gkconfigis3','class gkconfigis3',0,1,1.5667,'C42512',1),(713,'class gkconfigis3 your','class gkconfigis3 your',0,1,1.7333,'C425126',1),(714,'class gkcontactis2','class gkcontactis2',0,1,1.6,'C4253232',1),(715,'class gkcontactis2 your','class gkcontactis2 your',0,1,1.7667,'C42532326',1),(716,'class gkcreditcard','class gkcreditcard',0,1,1.6,'C4263263',1),(717,'class gkcreditcard your','class gkcreditcard your',0,1,1.7667,'C42632636',1),(718,'class gkcross','class gkcross',0,1,1.4333,'C4262',1),(719,'class gkcross your','class gkcross your',0,1,1.6,'C42626',1),(720,'class gkcrossis3','class gkcrossis3',0,1,1.5333,'C4262',1),(721,'class gkcrossis3 your','class gkcrossis3 your',0,1,1.7,'C42626',1),(722,'class gkdec','class gkdec',0,1,1.3667,'C4232',1),(723,'class gkdec element','class gkdec element',0,1,1.6333,'C4232453',1),(724,'class gkdecimalleadingzero','class gkdecimalleadingzero',0,1,1.8667,'C4232543526',1),(725,'class gkdecimalleadingzero element','class gkdecimalleadingzero element',0,1,2,'C4232543526453',1),(726,'class gkdef1','class gkdef1',0,1,1.4,'C4231',1),(727,'class gkdef1 dt','class gkdef1 dt',0,1,1.5,'C42313',1),(728,'class gkdef2','class gkdef2',0,1,1.4,'C4231',1),(729,'class gkdef2 dt','class gkdef2 dt',0,1,1.5,'C42313',1),(730,'class gkdef3','class gkdef3',0,1,1.4,'C4231',1),(731,'class gkdef3 dt','class gkdef3 dt',0,1,1.5,'C42313',1),(732,'class gkdisk','class gkdisk',0,1,1.4,'C4232',1),(733,'class gkdisk your','class gkdisk your',0,1,1.5667,'C42326',1),(734,'class gkdropcap1','class gkdropcap1',0,1,1.5333,'C4236121',1),(735,'class gkdropcap1 t','class gkdropcap1 t',0,1,1.6,'C42361213',1),(736,'class gkdropcap2','class gkdropcap2',0,1,1.5333,'C4236121',1),(737,'class gkdropcap2 t','class gkdropcap2 t',0,1,1.6,'C42361213',1),(738,'class gkdropcap3','class gkdropcap3',0,1,1.5333,'C4236121',1),(739,'class gkdropcap3 span','class gkdropcap3 span',0,1,1.7,'C4236121215',1),(740,'class gkdropcap3 t','class gkdropcap3 t',0,1,1.6,'C42361213',1),(741,'class gkemail','class gkemail',0,1,1.4333,'C4254',1),(742,'class gkemail your','class gkemail your',0,1,1.6,'C42546',1),(743,'class gkemailis2','class gkemailis2',0,1,1.5333,'C42542',1),(744,'class gkemailis2 your','class gkemailis2 your',0,1,1.7,'C425426',1),(745,'class gkerror','class gkerror',0,1,1.4333,'C426',1),(746,'class gkerror your','class gkerror your',0,1,1.6,'C426',1),(747,'class gkerroris2','class gkerroris2',0,1,1.5333,'C4262',1),(748,'class gkerroris2 your','class gkerroris2 your',0,1,1.7,'C42626',1),(749,'class gkerroris3','class gkerroris3',0,1,1.5333,'C4262',1),(750,'class gkerroris3 your','class gkerroris3 your',0,1,1.7,'C42626',1),(751,'class gkexclamation','class gkexclamation',0,1,1.6333,'C424535',1),(752,'class gkexclamation your','class gkexclamation your',0,1,1.8,'C4245356',1),(753,'class gkexclamationis2','class gkexclamationis2',0,1,1.7333,'C4245352',1),(754,'class gkexclamationis2 your','class gkexclamationis2 your',0,1,1.9,'C42453526',1),(755,'class gkfacebookis2','class gkfacebookis2',0,1,1.6333,'C421212',1),(756,'class gkfacebookis2 your','class gkfacebookis2 your',0,1,1.8,'C4212126',1),(757,'class gkfeed','class gkfeed',0,1,1.4,'C4213',1),(758,'class gkfeed your','class gkfeed your',0,1,1.5667,'C42136',1),(759,'class gkfeedis2','class gkfeedis2',0,1,1.5,'C42132',1),(760,'class gkfeedis2 your','class gkfeedis2 your',0,1,1.6667,'C421326',1),(761,'class gkfilm','class gkfilm',0,1,1.4,'C42145',1),(762,'class gkfilm your','class gkfilm your',0,1,1.5667,'C421456',1),(763,'class gkfilmis2','class gkfilmis2',0,1,1.5,'C421452',1),(764,'class gkfilmis2 your','class gkfilmis2 your',0,1,1.6667,'C4214526',1),(765,'class gkfolder','class gkfolder',0,1,1.4667,'C421436',1),(766,'class gkfolder your','class gkfolder your',0,1,1.6333,'C421436',1),(767,'class gkfolderis2','class gkfolderis2',0,1,1.5667,'C4214362',1),(768,'class gkfolderis2 your','class gkfolderis2 your',0,1,1.7333,'C42143626',1),(769,'class gkgroup','class gkgroup',0,1,1.4333,'C4261',1),(770,'class gkgroup your','class gkgroup your',0,1,1.6,'C42616',1),(771,'class gkgroupis2','class gkgroupis2',0,1,1.5333,'C42612',1),(772,'class gkgroupis2 your','class gkgroupis2 your',0,1,1.7,'C426126',1),(773,'class gkheadling','class gkheadling',0,1,1.5333,'C423452',1),(774,'class gkheadling for','class gkheadling for',0,1,1.6667,'C42345216',1),(775,'class gkheart','class gkheart',0,1,1.4333,'C4263',1),(776,'class gkheart your','class gkheart your',0,1,1.6,'C42636',1),(777,'class gkhelp','class gkhelp',0,1,1.4,'C4241',1),(778,'class gkhelp your','class gkhelp your',0,1,1.5667,'C42416',1),(779,'class gkhighlight1','class gkhighlight1',0,1,1.6,'C42423',1),(780,'class gkhighlight1 your','class gkhighlight1 your',0,1,1.7667,'C424236',1),(781,'class gkhighlight2','class gkhighlight2',0,1,1.6,'C42423',1),(782,'class gkhighlight2 your','class gkhighlight2 your',0,1,1.7667,'C424236',1),(783,'class gkhighlight3','class gkhighlight3',0,1,1.6,'C42423',1),(784,'class gkhighlight3 your','class gkhighlight3 your',0,1,1.7667,'C424236',1),(785,'class gkhighlight4','class gkhighlight4',0,1,1.6,'C42423',1),(786,'class gkhighlight4 your','class gkhighlight4 your',0,1,1.7667,'C424236',1),(787,'class gkhouse','class gkhouse',0,1,1.4333,'C420',1),(788,'class gkhouse your','class gkhouse your',0,1,1.6,'C426',1),(789,'class gkhouseis2','class gkhouseis2',0,1,1.5333,'C420',1),(790,'class gkhouseis2 your','class gkhouseis2 your',0,1,1.7,'C426',1),(791,'class gkhouseis3','class gkhouseis3',0,1,1.5333,'C420',1),(792,'class gkhouseis3 your','class gkhouseis3 your',0,1,1.7,'C426',1),(793,'class gkimage','class gkimage',0,1,1.4333,'C4252',1),(794,'class gkimage your','class gkimage your',0,1,1.6,'C42526',1),(795,'class gkimageis2','class gkimageis2',0,1,1.5333,'C4252',1),(796,'class gkimageis2 your','class gkimageis2 your',0,1,1.7,'C42526',1),(797,'class gkimages','class gkimages',0,1,1.4667,'C4252',1),(798,'class gkimages your','class gkimages your',0,1,1.6333,'C42526',1),(799,'class gkimagesis2','class gkimagesis2',0,1,1.5667,'C4252',1),(800,'class gkimagesis2 your','class gkimagesis2 your',0,1,1.7333,'C42526',1),(801,'class gkinfo1','class gkinfo1',0,1,1.4333,'C4251',1),(802,'class gkinfo1 your','class gkinfo1 your',0,1,1.6,'C42516',1),(803,'class gkinfo2','class gkinfo2',0,1,1.4333,'C4251',1),(804,'class gkinfo2 your','class gkinfo2 your',0,1,1.6,'C42516',1),(805,'class gkinfo3','class gkinfo3',0,1,1.4333,'C4251',1),(806,'class gkinfo3 your','class gkinfo3 your',0,1,1.6,'C42516',1),(807,'class gkinfo4','class gkinfo4',0,1,1.4333,'C4251',1),(808,'class gkinfo4 your','class gkinfo4 your',0,1,1.6,'C42516',1),(809,'class gkinfo5','class gkinfo5',0,1,1.4333,'C4251',1),(810,'class gkinfo5 your','class gkinfo5 your',0,1,1.6,'C42516',1),(811,'class gkinformation','class gkinformation',0,1,1.6333,'C42516535',1),(812,'class gkinformation your','class gkinformation your',0,1,1.8,'C425165356',1),(813,'class gkinformationis3','class gkinformationis3',0,1,1.7333,'C425165352',1),(814,'class gkinformationis3 your','class gkinformationis3 your',0,1,1.9,'C4251653526',1),(815,'class gkinfromationis2','class gkinfromationis2',0,1,1.7333,'C425165352',1),(816,'class gkinfromationis2 your','class gkinfromationis2 your',0,1,1.9,'C4251653526',1),(817,'class gklegend1','class gklegend1',0,1,1.5,'C424253',1),(818,'class gklegend1 h4','class gklegend1 h4',0,1,1.6,'C424253',1),(819,'class gklegend2','class gklegend2',0,1,1.5,'C424253',1),(820,'class gklegend2 h4','class gklegend2 h4',0,1,1.6,'C424253',1),(821,'class gklegend3','class gklegend3',0,1,1.5,'C424253',1),(822,'class gklegend3 h4','class gklegend3 h4',0,1,1.6,'C424253',1),(823,'class gklegend4','class gklegend4',0,1,1.5,'C424253',1),(824,'class gklegend4 h4','class gklegend4 h4',0,1,1.6,'C424253',1),(825,'class gklegend5','class gklegend5',0,1,1.5,'C424253',1),(826,'class gklegend5 h4','class gklegend5 h4',0,1,1.6,'C424253',1),(827,'class gklegend6','class gklegend6',0,1,1.5,'C424253',1),(828,'class gklegend6 h4','class gklegend6 h4',0,1,1.6,'C424253',1),(829,'class gklegend7','class gklegend7',0,1,1.5,'C424253',1),(830,'class gklegend7 h4','class gklegend7 h4',0,1,1.6,'C424253',1),(831,'class gklikeitis2','class gklikeitis2',0,1,1.5667,'C424232',1),(832,'class gklikeitis2 your','class gklikeitis2 your',0,1,1.7333,'C4242326',1),(833,'class gklock','class gklock',0,1,1.4,'C4242',1),(834,'class gklock your','class gklock your',0,1,1.5667,'C42426',1),(835,'class gklockis2','class gklockis2',0,1,1.5,'C4242',1),(836,'class gklockis2 your','class gklockis2 your',0,1,1.6667,'C42426',1),(837,'class gklockis3','class gklockis3',0,1,1.5,'C4242',1),(838,'class gklockis3 your','class gklockis3 your',0,1,1.6667,'C42426',1),(839,'class gkmagnifier','class gkmagnifier',0,1,1.5667,'C4252516',1),(840,'class gkmagnifier your','class gkmagnifier your',0,1,1.7333,'C4252516',1),(841,'class gkmagnifieris2','class gkmagnifieris2',0,1,1.6667,'C42525162',1),(842,'class gkmagnifieris2 your','class gkmagnifieris2 your',0,1,1.8333,'C425251626',1),(843,'class gkmagnifieris3','class gkmagnifieris3',0,1,1.6667,'C42525162',1),(844,'class gkmagnifieris3 your','class gkmagnifieris3 your',0,1,1.8333,'C425251626',1),(845,'class gkmoney','class gkmoney',0,1,1.4333,'C425',1),(846,'class gkmoney your','class gkmoney your',0,1,1.6,'C4256',1),(847,'class gkmoneyis2','class gkmoneyis2',0,1,1.5333,'C4252',1),(848,'class gkmoneyis2 your','class gkmoneyis2 your',0,1,1.7,'C42526',1),(849,'class gknew','class gknew',0,1,1.3667,'C425',1),(850,'class gknew your','class gknew your',0,1,1.5333,'C4256',1),(851,'class gknote','class gknote',0,1,1.4,'C4253',1),(852,'class gknote your','class gknote your',0,1,1.5667,'C42536',1),(853,'class gknumber1','class gknumber1',0,1,1.5,'C42516',1),(854,'class gknumber1 p','class gknumber1 p',0,1,1.5667,'C425161',1),(855,'class gknumber2','class gknumber2',0,1,1.5,'C42516',1),(856,'class gknumber2 p','class gknumber2 p',0,1,1.5667,'C425161',1),(857,'class gkpage','class gkpage',0,1,1.4,'C4212',1),(858,'class gkpage white','class gkpage white',0,1,1.6,'C42123',1),(859,'class gkpage your','class gkpage your',0,1,1.5667,'C42126',1),(860,'class gkpageis2','class gkpageis2',0,1,1.5,'C4212',1),(861,'class gkpageis2 your','class gkpageis2 your',0,1,1.6667,'C42126',1),(862,'class gkpageis3','class gkpageis3',0,1,1.5,'C4212',1),(863,'class gkpageis3 your','class gkpageis3 your',0,1,1.6667,'C42126',1),(864,'class gkplugin','class gkplugin',0,1,1.4667,'C421425',1),(865,'class gkplugin your','class gkplugin your',0,1,1.6333,'C4214256',1),(866,'class gkprinter','class gkprinter',0,1,1.5,'C4216536',1),(867,'class gkprinter your','class gkprinter your',0,1,1.6667,'C4216536',1),(868,'class gkprinteris2','class gkprinteris2',0,1,1.6,'C42165362',1),(869,'class gkprinteris2 your','class gkprinteris2 your',0,1,1.7667,'C421653626',1),(870,'class gkreport','class gkreport',0,1,1.4667,'C426163',1),(871,'class gkreport your','class gkreport your',0,1,1.6333,'C4261636',1),(872,'class gkroman','class gkroman',0,1,1.4333,'C4265',1),(873,'class gkroman element','class gkroman element',0,1,1.7,'C4265453',1),(874,'class gkscript','class gkscript',0,1,1.4667,'C42613',1),(875,'class gkscript your','class gkscript your',0,1,1.6333,'C426136',1),(876,'class gksquare1','class gksquare1',0,1,1.5,'C426',1),(877,'class gksquare1 element','class gksquare1 element',0,1,1.7667,'C426453',1),(878,'class gksquare2','class gksquare2',0,1,1.5,'C426',1),(879,'class gksquare2 element','class gksquare2 element',0,1,1.7667,'C426453',1),(880,'class gksquare3','class gksquare3',0,1,1.5,'C426',1),(881,'class gksquare3 element','class gksquare3 element',0,1,1.7667,'C426453',1),(882,'class gkstaris3','class gkstaris3',0,1,1.5,'C42362',1),(883,'class gkstaris3 your','class gkstaris3 your',0,1,1.6667,'C423626',1),(884,'class gksubheadline','class gksubheadline',0,1,1.6333,'C421345',1),(885,'class gksubheadline for','class gksubheadline for',0,1,1.7667,'C42134516',1),(886,'class gktelephoneis3','class gktelephoneis3',0,1,1.6667,'C4234152',1),(887,'class gktelephoneis3 your','class gktelephoneis3 your',0,1,1.8333,'C42341526',1),(888,'class gktime','class gktime',0,1,1.4,'C4235',1),(889,'class gktime your','class gktime your',0,1,1.5667,'C42356',1),(890,'class gktimeis2','class gktimeis2',0,1,1.5,'C42352',1),(891,'class gktimeis2 your','class gktimeis2 your',0,1,1.6667,'C423526',1),(892,'class gktips1','class gktips1',0,1,1.4333,'C42312',1),(893,'class gktips1 your','class gktips1 your',0,1,1.6,'C423126',1),(894,'class gktips2','class gktips2',0,1,1.4333,'C42312',1),(895,'class gktips2 your','class gktips2 your',0,1,1.6,'C423126',1),(896,'class gktips3','class gktips3',0,1,1.4333,'C42312',1),(897,'class gktips3 your','class gktips3 your',0,1,1.6,'C423126',1),(898,'class gktips4','class gktips4',0,1,1.4333,'C42312',1),(899,'class gktips4 your','class gktips4 your',0,1,1.6,'C423126',1),(900,'class gktips5','class gktips5',0,1,1.4333,'C42312',1),(901,'class gktips5 your','class gktips5 your',0,1,1.6,'C423126',1),(902,'class gktwitteris2','class gktwitteris2',0,1,1.6,'C42362',1),(903,'class gktwitteris2 your','class gktwitteris2 your',0,1,1.7667,'C423626',1),(904,'class gkuser','class gkuser',0,1,1.4,'C426',1),(905,'class gkuser your','class gkuser your',0,1,1.5667,'C426',1),(906,'class gkuseris2','class gkuseris2',0,1,1.5,'C4262',1),(907,'class gkuseris2 your','class gkuseris2 your',0,1,1.6667,'C42626',1),(908,'class gkuseris3','class gkuseris3',0,1,1.5,'C4262',1),(909,'class gkuseris3 your','class gkuseris3 your',0,1,1.6667,'C42626',1),(910,'class gkvideois2','class gkvideois2',0,1,1.5333,'C42132',1),(911,'class gkvideois2 your','class gkvideois2 your',0,1,1.7,'C421326',1),(912,'class gkwarning1','class gkwarning1',0,1,1.5333,'C42652',1),(913,'class gkwarning1 your','class gkwarning1 your',0,1,1.7,'C426526',1),(914,'class gkwarning2','class gkwarning2',0,1,1.5333,'C42652',1),(915,'class gkwarning2 your','class gkwarning2 your',0,1,1.7,'C426526',1),(916,'class gkwarning3','class gkwarning3',0,1,1.5333,'C42652',1),(917,'class gkwarning3 your','class gkwarning3 your',0,1,1.7,'C426526',1),(918,'class gkwarning4','class gkwarning4',0,1,1.5333,'C42652',1),(919,'class gkwarning4 your','class gkwarning4 your',0,1,1.7,'C426526',1),(920,'class gkwarning5','class gkwarning5',0,1,1.5333,'C42652',1),(921,'class gkwarning5 your','class gkwarning5 your',0,1,1.7,'C426526',1),(922,'class gkwebcam','class gkwebcam',0,1,1.4667,'C42125',1),(923,'class gkwebcam your','class gkwebcam your',0,1,1.6333,'C421256',1),(924,'class gkworld','class gkworld',0,1,1.4333,'C42643',1),(925,'class gkworld your','class gkworld your',0,1,1.6,'C426436',1),(926,'class gkworldis2','class gkworldis2',0,1,1.5333,'C426432',1),(927,'class gkworldis2 your','class gkworldis2 your',0,1,1.7,'C4264326',1),(928,'class gkyoutubeis2','class gkyoutubeis2',0,1,1.6,'C42312',1),(929,'class gkyoutubeis2 your','class gkyoutubeis2 your',0,1,1.7667,'C423126',1),(930,'class odd','class odd',0,1,1.3,'C423',1),(931,'class odd cell','class odd cell',0,1,1.4667,'C42324',1),(932,'classic','classic',0,0,0.4667,'C420',1),(933,'classic this','classic this',0,1,1.4,'C4232',1),(934,'classic this is','classic this is',0,1,1.5,'C4232',1),(935,'clock','clock',0,0,0.3333,'C420',2),(936,'clock goes','clock goes',0,1,1.3333,'C420',1),(937,'clock goes here','clock goes here',0,1,1.5,'C426',1),(938,'clock message','clock message',0,1,1.4333,'C4252',1),(939,'clock message goes','clock message goes',0,1,1.6,'C4252',1),(940,'clock message use','clock message use',0,1,1.5667,'C4252',1),(941,'code','code',0,0,0.2667,'C300',4),(942,'code below','code below',0,1,1.3333,'C314',1),(943,'code below is','code below is',0,1,1.4333,'C3142',1),(944,'code div','code div',0,1,1.2667,'C310',1),(945,'code div file','code div file',0,1,1.4333,'C314',1),(946,'code unordered','code unordered',0,1,1.4667,'C356363',1),(947,'code unordered lists','code unordered lists',0,1,1.6667,'C3563634232',1),(948,'coffe','coffe',0,0,0.3333,'C100',1),(949,'coffe message','coffe message',0,1,1.4333,'C152',1),(950,'coffe message goes','coffe message goes',0,1,1.6,'C152',1),(951,'coffe message use','coffe message use',0,1,1.5667,'C152',1),(952,'cog','cog',0,0,0.2,'C000',1),(953,'cog message','cog message',0,1,1.3667,'C520',1),(954,'cog message goes','cog message goes',0,1,1.5333,'C520',1),(955,'cog message use','cog message use',0,1,1.5,'C520',1),(956,'coins','coins',0,0,0.3333,'C520',1),(957,'coins message','coins message',0,1,1.4333,'C5252',1),(958,'coins message goes','coins message goes',0,1,1.6,'C5252',1),(959,'coins message use','coins message use',0,1,1.5667,'C5252',1),(960,'column','column',0,0,0.4,'C450',5),(961,'column 1','column 1',0,1,1.2667,'C450',1),(962,'column 1 column','column 1 column',0,1,1.5,'C45245',1),(963,'column 2','column 2',0,1,1.2667,'C450',1),(964,'column 2 cell','column 2 cell',0,1,1.4333,'C4524',1),(965,'compress','compress',0,0,0.5333,'C5162',1),(966,'compress goes','compress goes',0,1,1.4333,'C5162',1),(967,'compress goes here','compress goes here',0,1,1.6,'C51626',1),(968,'compress message','compress message',0,1,1.5333,'C516252',1),(969,'compress message use','compress message use',0,1,1.6667,'C516252',1),(970,'computer','computer',0,0,0.5333,'C5136',1),(971,'computer message','computer message',0,1,1.5333,'C513652',1),(972,'computer message goes','computer message goes',0,1,1.7,'C513652',1),(973,'computer message use','computer message use',0,1,1.6667,'C513652',1),(974,'condiment','condiment',0,0,0.6,'C5353',1),(975,'condiment as','condiment as',0,1,1.4,'C53532',1),(976,'condiment as well','condiment as well',0,1,1.5667,'C535324',1),(977,'condimentum','condimentum',0,0,0.7333,'C53535',15),(978,'condimentum et','condimentum et',0,1,1.4667,'C535353',1),(979,'condimentum et eu','condimentum et eu',0,1,1.5667,'C535353',1),(980,'condimentum lectus','condimentum lectus',0,1,1.6,'C535354232',1),(981,'condimentum lectus eget','condimentum lectus eget',0,1,1.7667,'C5353542323',1),(982,'condimentum pulvinar','condimentum pulvinar',0,1,1.6667,'C5353514156',1),(983,'condimentum pulvinar justo','condimentum pulvinar justo',0,1,1.8667,'C535351415623',1),(984,'condimentum urna','condimentum urna',0,1,1.5333,'C5353565',9),(985,'condimentum urna ipsum','condimentum urna ipsum',0,1,1.7333,'C5353565125',1),(986,'config','config',0,0,0.4,'C512',1),(987,'config message','config message',0,1,1.4667,'C51252',1),(988,'config message goes','config message goes',0,1,1.6333,'C51252',1),(989,'config message use','config message use',0,1,1.6,'C51252',1),(990,'configuration','configuration',0,0,0.8667,'C512635',1),(991,'configuration message','configuration message',0,1,1.7,'C5126352',1),(992,'configuration message goes','configuration message goes',0,1,1.8667,'C5126352',1),(993,'configuration message use','configuration message use',0,1,1.8333,'C5126352',1),(994,'congue','congue',0,0,0.4,'C520',15),(995,'congue augue','congue augue',0,1,1.4,'C520',1),(996,'congue augue donec','congue augue donec',0,1,1.6,'C52352',1),(997,'congue augue duis','congue augue duis',0,1,1.5667,'C5232',1),(998,'congue interdum','congue interdum',0,1,1.5,'C5253635',1),(999,'congue interdum elit','congue interdum elit',0,1,1.6667,'C525363543',1),(1000,'consectetuer','consectetuer',0,0,0.8,'C5236',1),(1001,'consectetuer adipiscing','consectetuer adipiscing',0,1,1.7667,'C523631252',1),(1002,'consectetuer adipiscing elit','consectetuer adipiscing elit',0,1,1.9333,'C52363125243',1),(1003,'consectetur','consectetur',0,0,0.7333,'C5236',28),(1004,'consectetur a','consectetur a',0,1,1.4333,'C5236',1),(1005,'consectetur a lorem','consectetur a lorem',0,1,1.6333,'C5236465',1),(1006,'consectetur accumsan','consectetur accumsan',0,1,1.6667,'C52362525',1),(1007,'consectetur accumsan this','consectetur accumsan this',0,1,1.8333,'C5236252532',1),(1008,'consectetur adipiscing','consectetur adipiscing',0,1,1.7333,'C523631252',20),(1009,'consectetur adipiscing elit','consectetur adipiscing elit',0,1,1.9,'C52363125243',20),(1010,'consectetur at','consectetur at',0,1,1.4667,'C52363',1),(1011,'consectetur at accumsan','consectetur at accumsan',0,1,1.7667,'C523632525',1),(1012,'consequat','consequat',0,0,0.6,'C523',13),(1013,'consequat eget','consequat eget',0,1,1.4667,'C52323',1),(1014,'consequat eget lobortis','consequat eget lobortis',0,1,1.7667,'C5232341632',1),(1015,'consists','consists',0,0,0.5333,'C5232',1),(1016,'consists of','consists of',0,1,1.3667,'C52321',1),(1017,'consists of butterfat','consists of butterfat',0,1,1.7,'C523213613',1),(1018,'contact message','contact message',0,1,1.5,'C532352',1),(1019,'contact message goes','contact message goes',0,1,1.6667,'C532352',1),(1020,'contact message use','contact message use',0,1,1.6333,'C532352',1),(1021,'convallis','convallis',0,0,0.6,'C5142',17),(1022,'convallis lacinia','convallis lacinia',0,1,1.5667,'C5142425',1),(1023,'convallis lacinia in','convallis lacinia in',0,1,1.6667,'C5142425',1),(1024,'convallis libero','convallis libero',0,1,1.5333,'C5142416',1),(1025,'convallis libero mauris','convallis libero mauris',0,1,1.7667,'C5142416562',1),(1026,'convallis mattis','convallis mattis',0,1,1.5333,'C5142532',1),(1027,'convallis mattis eu','convallis mattis eu',0,1,1.6333,'C5142532',1),(1028,'convallis nec','convallis nec',0,1,1.4333,'C514252',2),(1029,'convallis nec vel','convallis nec vel',0,1,1.5667,'C51425214',1),(1030,'cooking','cooking',0,0,0.4667,'C520',1),(1031,'cooking applications','cooking applications',0,1,1.6667,'C52142352',1),(1032,'cooking applications such','cooking applications such',0,1,1.8333,'C52142352',1),(1033,'cras','cras',0,0,0.2667,'C620',23),(1034,'cras diam','cras diam',0,1,1.3,'C6235',1),(1035,'cras diam justo','cras diam justo',0,1,1.5,'C623523',1),(1036,'cras ultrices','cras ultrices',0,1,1.4333,'C624362',1),(1037,'cras ultrices sapien','cras ultrices sapien',0,1,1.6667,'C62436215',1),(1038,'cream','cream',0,0,0.3333,'C650',1),(1039,'cream or','cream or',0,1,1.2667,'C656',1),(1040,'cream or milk','cream or milk',0,1,1.4333,'C656542',1),(1041,'creative','creative',0,0,0.5333,'C631',2),(1042,'creative and','creative and',0,1,1.4,'C63153',1),(1043,'creative and produce','creative and produce',0,1,1.6667,'C631531632',1),(1044,'creditcard','creditcard',0,0,0.6667,'C63263',1),(1045,'creditcard message','creditcard message',0,1,1.6,'C6326352',1),(1046,'creditcard message use','creditcard message use',0,1,1.7333,'C6326352',1),(1047,'creditcart','creditcart',0,0,0.6667,'C63263',1),(1048,'creditcart message','creditcart message',0,1,1.6,'C6326352',1),(1049,'creditcart message goes','creditcart message goes',0,1,1.7667,'C6326352',1),(1050,'critical','critical',0,0,0.5333,'C6324',1),(1051,'critical critical','critical critical',0,1,1.5667,'C632426324',1),(1052,'critical critical this','critical critical this',0,1,1.7333,'C63242632432',1),(1053,'critical this','critical this',0,1,1.4333,'C632432',1),(1054,'cross','cross',0,0,0.3333,'C620',1),(1055,'cross message','cross message',0,1,1.4333,'C6252',1),(1056,'cross message goes','cross message goes',0,1,1.6,'C6252',1),(1057,'cross message use','cross message use',0,1,1.5667,'C6252',1),(1058,'css','css',0,0,0.2,'C000',2),(1059,'css powered','css powered',0,1,1.3667,'C163',1),(1060,'css powered tooltip','css powered tooltip',0,1,1.6333,'C163431',1),(1061,'css tooltip','css tooltip',0,1,1.3667,'C3431',1),(1062,'css tooltip feel','css tooltip feel',0,1,1.5333,'C34314',1),(1063,'cum','cum',0,0,0.2,'C500',6),(1064,'cum sociis','cum sociis',0,1,1.3333,'C520',6),(1065,'cum sociis natoque','cum sociis natoque',0,1,1.6,'C52532',6),(1066,'cursus','cursus',0,0,0.4,'C620',22),(1067,'cursus est','cursus est',0,1,1.3333,'C623',1),(1068,'cursus est vel','cursus est vel',0,1,1.4667,'C62314',1),(1069,'cursus lacinia','cursus lacinia',0,1,1.4667,'C62425',1),(1070,'cursus lacinia aenean','cursus lacinia aenean',0,1,1.7,'C62425',1),(1071,'cursus massa','cursus massa',0,1,1.4,'C6252',1),(1072,'cursus massa eu','cursus massa eu',0,1,1.5,'C6252',1),(1073,'dairy','dairy',0,0,0.3333,'D600',1),(1074,'dairy milk','dairy milk',0,1,1.3333,'D6542',1),(1075,'dairy milk is','dairy milk is',0,1,1.4333,'D6542',1),(1076,'dairy product','dairy product',0,1,1.4333,'D616323',1),(1077,'dairy product made','dairy product made',0,1,1.6,'D61632353',1),(1078,'dapibus','dapibus',0,0,0.4667,'D120',14),(1079,'dapibus nisi','dapibus nisi',0,1,1.4,'D1252',1),(1080,'dapibus nisi massa','dapibus nisi massa',0,1,1.6,'D125252',1),(1081,'dapibus risus','dapibus risus',0,1,1.4333,'D1262',1),(1082,'dapibus risus aliquam','dapibus risus aliquam',0,1,1.7,'D1262425',1),(1083,'dd','dd',0,0,0.1333,'D000',1),(1084,'dd dl','dd dl',0,1,1.1667,'D400',1),(1085,'dd dl butter','dd dl butter',0,1,1.4,'D4136',1),(1086,'dd here','dd here',0,1,1.2333,'D600',1),(1087,'dd here goes','dd here goes',0,1,1.4,'D620',1),(1088,'define','define',0,0,0.4,'D150',1),(1089,'define dt','define dt',0,1,1.3,'D153',1),(1090,'define dt dd','define dt dd',0,1,1.4,'D153',1),(1091,'definition','definition',0,0,0.6667,'D1535',1),(1092,'definition dd','definition dd',0,1,1.4333,'D15353',1),(1093,'definition dd dl','definition dd dl',0,1,1.5333,'D153534',1),(1094,'definition lists','definition lists',0,1,1.5333,'D15354232',1),(1095,'definition lists below','definition lists below',0,1,1.7333,'D1535423214',1),(1096,'definition lists dl','definition lists dl',0,1,1.6333,'D1535423234',1),(1097,'definition lists legends','definition lists legends',0,1,1.8,'D1535423242532',1),(1098,'demo-typo','demo-typo',0,0,0.6,'D531',1),(1099,'demo-typo ordered','demo-typo ordered',0,1,1.5667,'D5316363',1),(1100,'demo-typo ordered lists','demo-typo ordered lists',0,1,1.7667,'D53163634232',1),(1101,'diam','diam',0,0,0.2667,'D500',25),(1102,'diam ante','diam ante',0,1,1.3,'D530',1),(1103,'diam ante ac','diam ante ac',0,1,1.4,'D532',1),(1104,'diam justo','diam justo',0,1,1.3333,'D523',1),(1105,'diam justo sodales','diam justo sodales',0,1,1.6,'D5232342',1),(1106,'diam non','diam non',0,1,1.2667,'D500',1),(1107,'diam non dolor','diam non dolor',0,1,1.4667,'D5346',1),(1108,'diam porta','diam porta',0,1,1.3333,'D5163',1),(1109,'diam porta ut','diam porta ut',0,1,1.4333,'D5163',1),(1110,'dictum','dictum',0,0,0.4,'D235',2),(1111,'dictum other','dictum other',0,1,1.4,'D23536',1),(1112,'dictum other span','dictum other span',0,1,1.5667,'D23536215',1),(1113,'dictum p','dictum p',0,1,1.2667,'D2351',1),(1114,'dictum p here','dictum p here',0,1,1.4333,'D23516',1),(1115,'dictumst','dictumst',0,0,0.5333,'D23523',1),(1116,'dictumst mauris','dictumst mauris',0,1,1.5,'D23523562',1),(1117,'dictumst mauris volutpat','dictumst mauris volutpat',0,1,1.8,'D2352356214313',1),(1118,'digest','digest',0,0,0.4,'D230',1),(1119,'digest other','digest other',0,1,1.4,'D236',1),(1120,'digest other types','digest other types',0,1,1.6,'D236312',1),(1121,'dignissim','dignissim',0,0,0.6,'D2525',9),(1122,'dignissim augue','dignissim augue',0,1,1.5,'D25252',1),(1123,'dignissim augue donec','dignissim augue donec',0,1,1.7,'D25252352',1),(1124,'dignissim placerat','dignissim placerat',0,1,1.6,'D252514263',1),(1125,'dignissim placerat nec','dignissim placerat nec',0,1,1.7333,'D25251426352',1),(1126,'dis','dis',0,0,0.2,'D200',6),(1127,'dis parturient','dis parturient',0,1,1.4667,'D2163653',6),(1128,'dis parturient montes','dis parturient montes',0,1,1.7,'D2163653532',6),(1129,'disk','disk',0,0,0.2667,'D200',1),(1130,'disk goes','disk goes',0,1,1.3,'D200',1),(1131,'disk goes here','disk goes here',0,1,1.4667,'D260',1),(1132,'disk message','disk message',0,1,1.4,'D252',1),(1133,'disk message use','disk message use',0,1,1.5333,'D252',1),(1134,'display','display',0,0,0.4667,'D214',2),(1135,'display block','display block',0,1,1.4333,'D214142',1),(1136,'display block below','display block below',0,1,1.6333,'D21414214',1),(1137,'display block unordered','display block unordered',0,1,1.7667,'D21414256363',1),(1138,'displayed','displayed',0,0,0.6,'D2143',1),(1139,'displayed in','displayed in',0,1,1.4,'D21435',1),(1140,'displayed in a','displayed in a',0,1,1.4667,'D21435',1),(1141,'div','div',0,0,0.2,'D100',1),(1142,'div blockquote','div blockquote',0,1,1.4667,'D1423',1),(1143,'div blockquote tables','div blockquote tables',0,1,1.7,'D1423142',1),(1144,'div blockquote this','div blockquote this',0,1,1.6333,'D14232',1),(1145,'div class','div class',0,1,1.3,'D1242',1),(1146,'div class gkblockquote1','div class gkblockquote1',0,1,1.7667,'D12421423',1),(1147,'div class gkblockquote2','div class gkblockquote2',0,1,1.7667,'D12421423',1),(1148,'div class gkblockquote3','div class gkblockquote3',0,1,1.7667,'D12421423',1),(1149,'div class gkblockquote4','div class gkblockquote4',0,1,1.7667,'D12421423',1),(1150,'div class gkcode1','div class gkcode1',0,1,1.5667,'D12423',1),(1151,'div class gkcode2','div class gkcode2',0,1,1.5667,'D12423',1),(1152,'div class gkcode3','div class gkcode3',0,1,1.5667,'D12423',1),(1153,'div class gklegend1','div class gklegend1',0,1,1.6333,'D12424253',1),(1154,'div class gklegend2','div class gklegend2',0,1,1.6333,'D12424253',1),(1155,'div class gklegend3','div class gklegend3',0,1,1.6333,'D12424253',1),(1156,'div class gklegend4','div class gklegend4',0,1,1.6333,'D12424253',1),(1157,'div class gklegend5','div class gklegend5',0,1,1.6333,'D12424253',1),(1158,'div class gklegend6','div class gklegend6',0,1,1.6333,'D12424253',1),(1159,'div class gklegend7','div class gklegend7',0,1,1.6333,'D12424253',1),(1160,'div class gknumber1','div class gknumber1',0,1,1.6333,'D1242516',1),(1161,'div class gknumber2','div class gknumber2',0,1,1.6333,'D1242516',1),(1162,'div div','div div',0,1,1.2333,'D131',1),(1163,'div div blockquote','div div blockquote',0,1,1.6,'D131423',1),(1164,'div dropcaps','div dropcaps',0,1,1.4,'D1361212',1),(1165,'div dropcaps t','div dropcaps t',0,1,1.4667,'D13612123',1),(1166,'div file','div file',0,1,1.2667,'D140',1),(1167,'div file wrapper','div file wrapper',0,1,1.5333,'D14616',1),(1168,'div legend','div legend',0,1,1.3333,'D14253',1),(1169,'div legend this','div legend this',0,1,1.5,'D142532',1),(1170,'div your','div your',0,1,1.2667,'D160',1),(1171,'div your quoted','div your quoted',0,1,1.5,'D1623',1),(1172,'dl','dl',0,0,0.1333,'D400',1),(1173,'dl butter','dl butter',0,1,1.3,'D4136',1),(1174,'dl butter it','dl butter it',0,1,1.4,'D41363',1),(1175,'dl class','dl class',0,1,1.2667,'D4242',1),(1176,'dl class gkdef1','dl class gkdef1',0,1,1.5,'D424231',1),(1177,'dl class gkdef2','dl class gkdef2',0,1,1.5,'D424231',1),(1178,'dl class gkdef3','dl class gkdef3',0,1,1.5,'D424231',1),(1179,'do','do',0,0,0.1333,'D000',6),(1180,'do so','do so',0,1,1.1667,'D200',1),(1181,'do so feel','do so feel',0,1,1.3333,'D214',1),(1182,'do using','do using',0,1,1.2667,'D252',1),(1183,'do using a','do using a',0,1,1.3333,'D252',1),(1184,'dolor','dolor',0,0,0.3333,'D460',26),(1185,'dolor convallis','dolor convallis',0,1,1.5,'D4625142',1),(1186,'dolor convallis mattis','dolor convallis mattis',0,1,1.7333,'D4625142532',1),(1187,'dolor sit','dolor sit',0,1,1.3,'D4623',20),(1188,'dolor sit amet','dolor sit amet',0,1,1.4667,'D462353',20),(1189,'donec','donec',0,0,0.3333,'D520',27),(1190,'donec ante','donec ante',0,1,1.3333,'D5253',1),(1191,'donec ante felis','donec ante felis',0,1,1.5333,'D5253142',1),(1192,'donec congue','donec congue',0,1,1.4,'D5252',1),(1193,'donec congue interdum','donec congue interdum',0,1,1.7,'D525253635',1),(1194,'donec eget','donec eget',0,1,1.3333,'D523',10),(1195,'donec eget dignissim','donec eget dignissim',0,1,1.6667,'D5232525',1),(1196,'donec est','donec est',0,1,1.3,'D523',1),(1197,'donec est risus','donec est risus',0,1,1.5,'D52362',1),(1198,'dr','dr',0,0,0.1333,'D600',1),(1199,'dr use','dr use',0,1,1.2,'D620',1),(1200,'dr use abbr','dr use abbr',0,1,1.3667,'D6216',1),(1201,'dropcap','dropcap',0,0,0.4667,'D6121',1),(1202,'dropcap use','dropcap use',0,1,1.3667,'D61212',1),(1203,'dropcap use p','dropcap use p',0,1,1.4333,'D612121',1),(1204,'dropcaps','dropcaps',0,0,0.5333,'D61212',1),(1205,'dropcaps floated','dropcaps floated',0,1,1.5333,'D61212143',1),(1206,'dropcaps floated blocks','dropcaps floated blocks',0,1,1.7667,'D61212143142',1),(1207,'dropcaps t','dropcaps t',0,1,1.3333,'D612123',1),(1208,'dropcaps t his','dropcaps t his',0,1,1.4667,'D6121232',1),(1209,'dt','dt',0,0,0.1333,'D000',1),(1210,'dt dd','dt dd',0,1,1.1667,'D000',1),(1211,'dt dd here','dt dd here',0,1,1.3333,'D600',1),(1212,'dt here','dt here',0,1,1.2333,'D600',1),(1213,'dt here goes','dt here goes',0,1,1.4,'D620',1),(1214,'dui','dui',0,0,0.2,'D000',27),(1215,'dui sed','dui sed',0,1,1.2333,'D230',8),(1216,'dui sed velit','dui sed velit',0,1,1.4333,'D23143',1),(1217,'duis','duis',0,0,0.2667,'D200',27),(1218,'duis accumsan','duis accumsan',0,1,1.4333,'D2525',1),(1219,'duis accumsan cursus','duis accumsan cursus',0,1,1.6667,'D2525262',1),(1220,'duis quis','duis quis',0,1,1.3,'D200',1),(1221,'duis quis quam','duis quis quam',0,1,1.4667,'D250',1),(1222,'egestas','egestas',0,0,0.4667,'E232',23),(1223,'egestas nunc','egestas nunc',0,1,1.4,'E23252',1),(1224,'egestas nunc in','egestas nunc in',0,1,1.5,'E232525',1),(1225,'egestas vel','egestas vel',0,1,1.3667,'E23214',1),(1226,'egestas vel consectetur','egestas vel consectetur',0,1,1.7667,'E2321425236',1),(1227,'eget','eget',0,0,0.2667,'E230',27),(1228,'eget dignissim','eget dignissim',0,1,1.4667,'E232525',1),(1229,'eget dignissim augue','eget dignissim augue',0,1,1.6667,'E2325252',1),(1230,'eget laoreet','eget laoreet',0,1,1.4,'E23463',1),(1231,'eget laoreet ipsum','eget laoreet ipsum',0,1,1.6,'E23463125',1),(1232,'eget lobortis','eget lobortis',0,1,1.4333,'E2341632',1),(1233,'eget lobortis dapibus','eget lobortis dapibus',0,1,1.7,'E2341632312',1),(1234,'eleifend','eleifend',0,0,0.5333,'E4153',2),(1235,'eleifend felis','eleifend felis',0,1,1.4667,'E4153142',1),(1236,'eleifend felis sed','eleifend felis sed',0,1,1.6,'E41531423',1),(1237,'eleifend lorem','eleifend lorem',0,1,1.4667,'E4153465',1),(1238,'eleifend lorem ipsum','eleifend lorem ipsum',0,1,1.6667,'E4153465125',1),(1239,'eleifend vivamus','eleifend vivamus',0,1,1.5333,'E4153152',1),(1240,'eleifend vivamus ullamcorper','eleifend vivamus ullamcorper',0,1,1.9333,'E4153152452616',1),(1241,'element','element',0,0,0.4667,'E453',1),(1242,'element 02','element 02',0,1,1.3333,'E453',1),(1243,'element 02 element','element 02 element',0,1,1.6,'E453453',1),(1244,'element 1','element 1',0,1,1.3,'E453',1),(1245,'element 1 element','element 1 element',0,1,1.5667,'E453453',1),(1246,'element 2','element 2',0,1,1.3,'E453',1),(1247,'element 2 element','element 2 element',0,1,1.5667,'E453453',1),(1248,'element 3','element 3',0,1,1.3,'E453',1),(1249,'element 3 ul','element 3 ul',0,1,1.4,'E4534',1),(1250,'element abbrs','element abbrs',0,1,1.4333,'E453162',1),(1251,'element abbrs and','element abbrs and',0,1,1.5667,'E45316253',1),(1252,'element div','element div',0,1,1.3667,'E4531',1),(1253,'element div class','element div class',0,1,1.5667,'E4531242',1),(1254,'element element','element element',0,1,1.5,'E453453',1),(1255,'element element div','element element div',0,1,1.6333,'E4534531',1),(1256,'element element element','element element element',0,1,1.7667,'E453453453',1),(1257,'element element ol','element element ol',0,1,1.6,'E4534534',1),(1258,'element ol','element ol',0,1,1.3333,'E4534',1),(1259,'element ol class','element ol class',0,1,1.5333,'E4534242',1),(1260,'element p','element p',0,1,1.3,'E4531',1),(1261,'element p 01','element p 01',0,1,1.4,'E4531',1),(1262,'elementum','elementum',0,0,0.6,'E4535',25),(1263,'elementum non','elementum non',0,1,1.4333,'E4535',1),(1264,'elementum non blandit','elementum non blandit',0,1,1.7,'E45351453',1),(1265,'elit','elit',0,0,0.2667,'E430',28),(1266,'elit at','elit at',0,1,1.2333,'E430',1),(1267,'elit at euismod','elit at euismod',0,1,1.5,'E43253',1),(1268,'elit integer','elit integer',0,1,1.4,'E435326',1),(1269,'elit integer semper','elit integer semper',0,1,1.6333,'E4353262516',1),(1270,'elit integer urna','elit integer urna',0,1,1.5667,'E4353265',1),(1271,'elit sed','elit sed',0,1,1.2667,'E4323',4),(1272,'elit sed ornare','elit sed ornare',0,1,1.5,'E4323656',1),(1273,'elit vestibulum','elit vestibulum',0,1,1.5,'E43123145',8),(1274,'elit vestibulum condimentum','elit vestibulum condimentum',0,1,1.9,'E43123145253535',1),(1275,'email','email',0,0,0.3333,'E540',1),(1276,'email message','email message',0,1,1.4333,'E5452',1),(1277,'email message goes','email message goes',0,1,1.6,'E5452',1),(1278,'email message use','email message use',0,1,1.5667,'E5452',1),(1279,'enim','enim',0,0,0.2667,'E500',23),(1280,'enim et','enim et',0,1,1.2333,'E530',1),(1281,'enim et lectus','enim et lectus',0,1,1.4667,'E534232',1),(1282,'enim euismod','enim euismod',0,1,1.4,'E5253',1),(1283,'enim euismod quis','enim euismod quis',0,1,1.5667,'E52532',1),(1284,'enim libero','enim libero',0,1,1.3667,'E5416',1),(1285,'enim libero morbi','enim libero morbi',0,1,1.5667,'E5416561',1),(1286,'enim nulla','enim nulla',0,1,1.3333,'E540',1),(1287,'enim nulla vel','enim nulla vel',0,1,1.4667,'E5414',1),(1288,'enim urna','enim urna',0,1,1.3,'E565',1),(1289,'enim urna ultricies','enim urna ultricies',0,1,1.6333,'E5654362',1),(1290,'erat','erat',0,0,0.2667,'E630',17),(1291,'erat donec','erat donec',0,1,1.3333,'E6352',1),(1292,'erat donec congue','erat donec congue',0,1,1.5667,'E635252',1),(1293,'erat egestas','erat egestas',0,1,1.4,'E63232',1),(1294,'erat egestas vel','erat egestas vel',0,1,1.5333,'E6323214',1),(1295,'eros','eros',0,0,0.2667,'E620',15),(1296,'eros quis','eros quis',0,1,1.3,'E620',1),(1297,'eros quis ullamcorper','eros quis ullamcorper',0,1,1.7,'E62452616',1),(1298,'eros sed','eros sed',0,1,1.2667,'E623',1),(1299,'eros sed tempus','eros sed tempus',0,1,1.5,'E623512',1),(1300,'eros tempor','eros tempor',0,1,1.3667,'E623516',1),(1301,'eros tempor iaculis','eros tempor iaculis',0,1,1.6333,'E623516242',1),(1302,'eros vestibulum','eros vestibulum',0,1,1.5,'E62123145',1),(1303,'eros vestibulum euismod','eros vestibulum euismod',0,1,1.7667,'E62123145253',1),(1304,'error','error',0,0,0.3333,'E600',2),(1305,'error message','error message',0,1,1.4333,'E652',2),(1306,'error message goes','error message goes',0,1,1.6,'E652',1),(1307,'error message use','error message use',0,1,1.5667,'E652',1),(1308,'est','est',0,0,0.2,'E230',18),(1309,'est id','est id',0,1,1.2,'E230',1),(1310,'est id libero','est id libero',0,1,1.4333,'E23416',1),(1311,'est risus','est risus',0,1,1.3,'E2362',1),(1312,'est risus facilisis','est risus facilisis',0,1,1.6333,'E23621242',1),(1313,'est tristique','est tristique',0,1,1.4333,'E236232',1),(1314,'est tristique convallis','est tristique convallis',0,1,1.7667,'E2362325142',1),(1315,'est vel','est vel',0,1,1.2333,'E2314',1),(1316,'est vel velit','est vel velit',0,1,1.4333,'E2314143',1),(1317,'et','et',0,0,0.1333,'E300',28),(1318,'et consectetur','et consectetur',0,1,1.4667,'E325236',1),(1319,'et consectetur a','et consectetur a',0,1,1.5333,'E325236',1),(1320,'et eu','et eu',0,1,1.1667,'E300',1),(1321,'et eu neque','et eu neque',0,1,1.3667,'E352',1),(1322,'et lacus','et lacus',0,1,1.2667,'E342',1),(1323,'et lacus nam','et lacus nam',0,1,1.4,'E3425',1),(1324,'et lectus','et lectus',0,1,1.3,'E34232',9),(1325,'et lectus ornare','et lectus ornare',0,1,1.5333,'E34232656',1),(1326,'et magnis','et magnis',0,1,1.3,'E35252',6),(1327,'et magnis dis','et magnis dis',0,1,1.4333,'E3525232',6),(1328,'et quisque','et quisque',0,1,1.3333,'E320',1),(1329,'et quisque sagittis','et quisque sagittis',0,1,1.6333,'E3232',1),(1330,'etiam','etiam',0,0,0.3333,'E350',19),(1331,'etiam volutpat','etiam volutpat',0,1,1.4667,'E3514313',1),(1332,'etiam volutpat ultrices','etiam volutpat ultrices',0,1,1.7667,'E35143134362',1),(1333,'eu','eu',0,0,0.1333,'E000',27),(1334,'eu facilisis','eu facilisis',0,1,1.4,'E1242',9),(1335,'eu facilisis diam','eu facilisis diam',0,1,1.5667,'E124235',1),(1336,'eu felis','eu felis',0,1,1.2667,'E142',1),(1337,'eu felis erat','eu felis erat',0,1,1.4333,'E14263',1),(1338,'eu id','eu id',0,1,1.1667,'E300',1),(1339,'eu id nulla','eu id nulla',0,1,1.3667,'E354',1),(1340,'eu neque','eu neque',0,1,1.2667,'E520',1),(1341,'eu neque nunc','eu neque nunc',0,1,1.4333,'E5252',1),(1342,'eu nisi','eu nisi',0,1,1.2333,'E520',1),(1343,'eu nisi elementum','eu nisi elementum',0,1,1.5667,'E524535',1),(1344,'eu pulvinar','eu pulvinar',0,1,1.3667,'E14156',1),(1345,'eu pulvinar nibh','eu pulvinar nibh',0,1,1.5333,'E1415651',1),(1346,'euismod','euismod',0,0,0.4667,'E253',15),(1347,'euismod lacinia','euismod lacinia',0,1,1.5,'E253425',1),(1348,'euismod lacinia nisi','euismod lacinia nisi',0,1,1.6667,'E2534252',1),(1349,'euismod luctus','euismod luctus',0,1,1.4667,'E2534232',1),(1350,'euismod luctus velit','euismod luctus velit',0,1,1.6667,'E2534232143',1),(1351,'euismod nam','euismod nam',0,1,1.3667,'E2535',1),(1352,'euismod nam quis','euismod nam quis',0,1,1.5333,'E25352',1),(1353,'euismod quis','euismod quis',0,1,1.4,'E2532',1),(1354,'euismod quis nullam','euismod quis nullam',0,1,1.6333,'E2532545',1),(1355,'euismod rutrum','euismod rutrum',0,1,1.4667,'E2536365',1),(1356,'euismod rutrum tortor','euismod rutrum tortor',0,1,1.7,'E25363653636',1),(1357,'example','example',0,0,0.4667,'E2514',1),(1358,'example of','example of',0,1,1.3333,'E25141',1),(1359,'example of what','example of what',0,1,1.5,'E251413',1),(1360,'examples','examples',0,0,0.5333,'E25142',1),(1361,'examples of','examples of',0,1,1.3667,'E251421',1),(1362,'examples of a','examples of a',0,1,1.4333,'E251421',1),(1363,'exclamation','exclamation',0,0,0.7333,'E24535',1),(1364,'exclamation message','exclamation message',0,1,1.6333,'E245352',1),(1365,'exclamation message goes','exclamation message goes',0,1,1.8,'E245352',1),(1366,'exclamation message use','exclamation message use',0,1,1.7667,'E245352',1),(1367,'facebook','facebook',0,0,0.5333,'F212',2),(1368,'facebook message','facebook message',0,1,1.5333,'F21252',1),(1369,'facebook message goes','facebook message goes',0,1,1.7,'F21252',1),(1370,'facebook message use','facebook message use',0,1,1.6667,'F21252',1),(1371,'facilisis','facilisis',0,0,0.6,'F242',23),(1372,'facilisis diam','facilisis diam',0,1,1.4667,'F24235',1),(1373,'facilisis diam porta','facilisis diam porta',0,1,1.6667,'F24235163',1),(1374,'facilisis dignissim','facilisis dignissim',0,1,1.6333,'F24232525',1),(1375,'facilisis dignissim placerat','facilisis dignissim placerat',0,1,1.9333,'F2423252514263',1),(1376,'facilisis sapien','facilisis sapien',0,1,1.5333,'F24215',1),(1377,'facilisis sapien in','facilisis sapien in',0,1,1.6333,'F24215',1),(1378,'faucibus','faucibus',0,0,0.5333,'F212',22),(1379,'faucibus ligula','faucibus ligula',0,1,1.5,'F212424',1),(1380,'faucibus ligula feugiat','faucibus ligula feugiat',0,1,1.7667,'F212424123',1),(1381,'feed','feed',0,0,0.2667,'F300',3),(1382,'feed goes','feed goes',0,1,1.3,'F320',1),(1383,'feed goes here','feed goes here',0,1,1.4667,'F326',1),(1384,'feed message','feed message',0,1,1.4,'F352',1),(1385,'feed message goes','feed message goes',0,1,1.5667,'F352',1),(1386,'feed message use','feed message use',0,1,1.5333,'F352',1),(1387,'feel','feel',0,0,0.2667,'F400',2),(1388,'feel free','feel free',0,1,1.3,'F416',2),(1389,'feel free to','feel free to',0,1,1.4,'F4163',2),(1390,'felis','felis',0,0,0.3333,'F420',16),(1391,'felis aliquam','felis aliquam',0,1,1.4333,'F42425',1),(1392,'felis aliquam ut','felis aliquam ut',0,1,1.5333,'F424253',1),(1393,'felis cras','felis cras',0,1,1.3333,'F4262',1),(1394,'felis cras ultrices','felis cras ultrices',0,1,1.6333,'F42624362',1),(1395,'felis erat','felis erat',0,1,1.3333,'F4263',1),(1396,'felis erat donec','felis erat donec',0,1,1.5333,'F426352',1),(1397,'felis sed','felis sed',0,1,1.3,'F423',4),(1398,'felis sed tellus','felis sed tellus',0,1,1.5333,'F42342',1),(1399,'fermented','fermented',0,0,0.6,'F653',1),(1400,'fermented cream','fermented cream',0,1,1.5,'F653265',1),(1401,'fermented cream or','fermented cream or',0,1,1.6,'F6532656',1),(1402,'fermentum','fermentum',0,0,0.6,'F6535',23),(1403,'fermentum eros','fermentum eros',0,1,1.4667,'F653562',1),(1404,'fermentum eros quis','fermentum eros quis',0,1,1.6333,'F653562',1),(1405,'feugiat','feugiat',0,0,0.4667,'F230',5),(1406,'feugiat ac','feugiat ac',0,1,1.3333,'F232',1),(1407,'feugiat ac morbi','feugiat ac morbi',0,1,1.5333,'F232561',1),(1408,'feugiat dapibus','feugiat dapibus',0,1,1.5,'F2312',1),(1409,'feugiat dapibus nisi','feugiat dapibus nisi',0,1,1.6667,'F231252',1),(1410,'file','file',0,0,0.2667,'F400',1),(1411,'file h4','file h4',0,1,1.2333,'F400',1),(1412,'file h4 here','file h4 here',0,1,1.4,'F460',1),(1413,'file wrapper','file wrapper',0,1,1.4,'F4616',1),(1414,'file wrapper position','file wrapper position',0,1,1.7,'F46161235',1),(1415,'film','film',0,0,0.2667,'F450',1),(1416,'film goes','film goes',0,1,1.3,'F452',1),(1417,'film goes here','film goes here',0,1,1.4667,'F4526',1),(1418,'film message','film message',0,1,1.4,'F452',1),(1419,'film message use','film message use',0,1,1.5333,'F452',1),(1420,'first','first',0,0,0.3333,'F623',1),(1421,'first letter','first letter',0,1,1.4,'F623436',1),(1422,'first letter larger','first letter larger',0,1,1.6333,'F6234364626',1),(1423,'float','float',0,0,0.3333,'F430',1),(1424,'float left','float left',0,1,1.3333,'F43413',1),(1425,'float left display','float left display',0,1,1.6,'F43413214',1),(1426,'floated','floated',0,0,0.4667,'F430',1),(1427,'floated blocks','floated blocks',0,1,1.4667,'F43142',1),(1428,'floated blocks below','floated blocks below',0,1,1.6667,'F4314214',1),(1429,'floated blocks other','floated blocks other',0,1,1.6667,'F4314236',1),(1430,'folder','folder',0,0,0.4,'F436',1),(1431,'folder message','folder message',0,1,1.4667,'F43652',1),(1432,'folder message goes','folder message goes',0,1,1.6333,'F43652',1),(1433,'folder message use','folder message use',0,1,1.6,'F43652',1),(1434,'food','food',0,0,0.2667,'F300',1),(1435,'food dl','food dl',0,1,1.2333,'F340',1),(1436,'food dl class','food dl class',0,1,1.4333,'F34242',1),(1437,'food legends','food legends',0,1,1.4,'F342532',1),(1438,'food legends legend','food legends legend',0,1,1.6333,'F3425324253',1),(1439,'footer','footer',0,0,0.4,'F360',1),(1440,'footer tfoot','footer tfoot',0,1,1.4,'F36313',1),(1441,'footer tfoot column','footer tfoot column',0,1,1.6333,'F36313245',1),(1442,'for','for',0,0,0.2,'F600',9),(1443,'for headline','for headline',0,1,1.4,'F6345',1),(1444,'for headline p','for headline p',0,1,1.4667,'F63451',1),(1445,'for newborn','for newborn',0,1,1.3667,'F65165',1),(1446,'for newborn mammals','for newborn mammals',0,1,1.6333,'F6516542',1),(1447,'for subheadline','for subheadline',0,1,1.5,'F621345',1),(1448,'for subheadline p','for subheadline p',0,1,1.5667,'F6213451',1),(1449,'free','free',0,0,0.2667,'F600',3),(1450,'free to','free to',0,1,1.2333,'F630',3),(1451,'free to get','free to get',0,1,1.3667,'F6323',1),(1452,'fresh','fresh',0,0,0.3333,'F620',1),(1453,'fresh or','fresh or',0,1,1.2667,'F626',1),(1454,'fresh or fermented','fresh or fermented',0,1,1.6,'F6261653',1),(1455,'fringilla','fringilla',0,0,0.6,'F6524',23),(1456,'fringilla enim','fringilla enim',0,1,1.4667,'F65245',1),(1457,'fringilla enim euismod','fringilla enim euismod',0,1,1.7333,'F65245253',1),(1458,'frying','frying',0,0,0.4,'F652',1),(1459,'frying butter','frying butter',0,1,1.4333,'F652136',1),(1460,'frying butter consists','frying butter consists',0,1,1.7333,'F65213625232',1),(1461,'full','full',0,0,0.2667,'F400',3),(1462,'full phrase','full phrase',0,1,1.3667,'F4162',1),(1463,'full phrase here','full phrase here',0,1,1.5333,'F41626',1),(1464,'full word','full word',0,1,1.3,'F463',1),(1465,'full word or','full word or',0,1,1.4,'F4636',1),(1466,'fusce','fusce',0,0,0.3333,'F200',5),(1467,'fusce a','fusce a',0,1,1.2333,'F200',1),(1468,'fusce a neque','fusce a neque',0,1,1.4333,'F252',1),(1469,'fusce adipiscing','fusce adipiscing',0,1,1.5333,'F231252',1),(1470,'fusce adipiscing velit','fusce adipiscing velit',0,1,1.7333,'F231252143',1),(1471,'fusce eu','fusce eu',0,1,1.2667,'F200',1),(1472,'fusce eu felis','fusce eu felis',0,1,1.4667,'F2142',1),(1473,'generally','generally',0,0,0.6,'G564',1),(1474,'generally used','generally used',0,1,1.4667,'G56423',1),(1475,'generally used as','generally used as',0,1,1.5667,'G564232',1),(1476,'get','get',0,0,0.2,'G300',8),(1477,'get creative','get creative',0,1,1.4,'G32631',1),(1478,'get creative and','get creative and',0,1,1.5333,'G3263153',1),(1479,'gkaccept','gkaccept',0,0,0.5333,'G130',1),(1480,'gkaccept your','gkaccept your',0,1,1.4333,'G136',1),(1481,'gkaccept your accept','gkaccept your accept',0,1,1.6667,'G136213',1),(1482,'gkadd','gkadd',0,0,0.3333,'G300',1),(1483,'gkadd your','gkadd your',0,1,1.3333,'G360',1),(1484,'gkadd your add','gkadd your add',0,1,1.4667,'G363',1),(1485,'gkalpha','gkalpha',0,0,0.4667,'G410',1),(1486,'gkalpha element','gkalpha element',0,1,1.5,'G41453',1),(1487,'gkalpha element element','gkalpha element element',0,1,1.7667,'G41453453',1),(1488,'gkaudio','gkaudio',0,0,0.4667,'G300',1),(1489,'gkaudio your','gkaudio your',0,1,1.4,'G360',1),(1490,'gkaudio your audio','gkaudio your audio',0,1,1.6,'G363',1),(1491,'gkaudiois2','gkaudiois2',0,0,0.6667,'G320',1),(1492,'gkaudiois2 your','gkaudiois2 your',0,1,1.5,'G326',1),(1493,'gkaudiois2 your audio','gkaudiois2 your audio',0,1,1.7,'G3263',1),(1494,'gkaudiois3','gkaudiois3',0,0,0.6667,'G320',1),(1495,'gkaudiois3 your','gkaudiois3 your',0,1,1.5,'G326',1),(1496,'gkaudiois3 your audio','gkaudiois3 your audio',0,1,1.7,'G3263',1),(1497,'gkblockquote1','gkblockquote1',0,0,0.8667,'G1423',1),(1498,'gkblockquote1 div','gkblockquote1 div',0,1,1.5667,'G14231',1),(1499,'gkblockquote1 div your','gkblockquote1 div your',0,1,1.7333,'G142316',1),(1500,'gkblockquote1 this','gkblockquote1 this',0,1,1.6,'G14232',1),(1501,'gkblockquote1 this is','gkblockquote1 this is',0,1,1.7,'G14232',1),(1502,'gkblockquote2','gkblockquote2',0,0,0.8667,'G1423',1),(1503,'gkblockquote2 div','gkblockquote2 div',0,1,1.5667,'G14231',1),(1504,'gkblockquote2 div your','gkblockquote2 div your',0,1,1.7333,'G142316',1),(1505,'gkblockquote3','gkblockquote3',0,0,0.8667,'G1423',1),(1506,'gkblockquote3 div','gkblockquote3 div',0,1,1.5667,'G14231',1),(1507,'gkblockquote3 div your','gkblockquote3 div your',0,1,1.7333,'G142316',1),(1508,'gkblockquote4','gkblockquote4',0,0,0.8667,'G1423',1),(1509,'gkblockquote4 div','gkblockquote4 div',0,1,1.5667,'G14231',1),(1510,'gkblockquote4 div your','gkblockquote4 div your',0,1,1.7333,'G142316',1),(1511,'gkblocktextcenter','gkblocktextcenter',0,0,1,'G1423232536',1),(1512,'gkblocktextcenter block','gkblocktextcenter block',0,1,1.7667,'G1423232536142',1),(1513,'gkblocktextcenter block of','gkblocktextcenter block of',0,1,1.8667,'G14232325361421',1),(1514,'gkblocktextleft','gkblocktextleft',0,0,1,'G142323413',1),(1515,'gkblocktextleft block','gkblocktextleft block',0,1,1.7,'G142323413142',1),(1516,'gkblocktextleft block of','gkblocktextleft block of',0,1,1.8,'G1423234131421',1),(1517,'gkblocktextright','gkblocktextright',0,0,1,'G142323623',1),(1518,'gkblocktextright block','gkblocktextright block',0,1,1.7333,'G142323623142',1),(1519,'gkblocktextright block of','gkblocktextright block of',0,1,1.8333,'G1423236231421',1),(1520,'gkbox','gkbox',0,0,0.3333,'G120',1),(1521,'gkbox your','gkbox your',0,1,1.3333,'G126',1),(1522,'gkbox your box','gkbox your box',0,1,1.4667,'G12612',1),(1523,'gkbrick','gkbrick',0,0,0.4667,'G162',1),(1524,'gkbrick your','gkbrick your',0,1,1.4,'G1626',1),(1525,'gkbrick your brick','gkbrick your brick',0,1,1.6,'G1626162',1),(1526,'gkbullet1','gkbullet1',0,0,0.6,'G143',1),(1527,'gkbullet1 element','gkbullet1 element',0,1,1.5667,'G143453',1),(1528,'gkbullet1 element 1','gkbullet1 element 1',0,1,1.6333,'G143453',1),(1529,'gkbullet2','gkbullet2',0,0,0.6,'G143',1),(1530,'gkbullet2 element','gkbullet2 element',0,1,1.5667,'G143453',1),(1531,'gkbullet2 element 1','gkbullet2 element 1',0,1,1.6333,'G143453',1),(1532,'gkbullet3','gkbullet3',0,0,0.6,'G143',1),(1533,'gkbullet3 element','gkbullet3 element',0,1,1.5667,'G143453',1),(1534,'gkbullet3 element 1','gkbullet3 element 1',0,1,1.6333,'G143453',1),(1535,'gkbullet4','gkbullet4',0,0,0.6,'G143',1),(1536,'gkbullet4 element','gkbullet4 element',0,1,1.5667,'G143453',1),(1537,'gkbullet4 element 1','gkbullet4 element 1',0,1,1.6333,'G143453',1),(1538,'gkcalendar','gkcalendar',0,0,0.6667,'G4536',1),(1539,'gkcalendar your','gkcalendar your',0,1,1.5,'G4536',1),(1540,'gkcalendar your calendar','gkcalendar your calendar',0,1,1.8,'G453624536',1),(1541,'gkcalendaris2','gkcalendaris2',0,0,0.8667,'G45362',1),(1542,'gkcalendaris2 your','gkcalendaris2 your',0,1,1.6,'G453626',1),(1543,'gkcalendaris2 your calendar','gkcalendaris2 your calendar',0,1,1.9,'G45362624536',1),(1544,'gkcamera','gkcamera',0,0,0.5333,'G560',1),(1545,'gkcamera your','gkcamera your',0,1,1.4333,'G560',1),(1546,'gkcamera your camera','gkcamera your camera',0,1,1.6667,'G56256',1),(1547,'gkcamerais2','gkcamerais2',0,0,0.7333,'G562',1),(1548,'gkcamerais2 your','gkcamerais2 your',0,1,1.5333,'G5626',1),(1549,'gkcamerais2 your camera','gkcamerais2 your camera',0,1,1.7667,'G5626256',1),(1550,'gkcamerais3','gkcamerais3',0,0,0.7333,'G562',1),(1551,'gkcamerais3 your','gkcamerais3 your',0,1,1.5333,'G5626',1),(1552,'gkcamerais3 your camera','gkcamerais3 your camera',0,1,1.7667,'G5626256',1),(1553,'gkcart','gkcart',0,0,0.4,'G630',1),(1554,'gkcart your','gkcart your',0,1,1.3667,'G636',1),(1555,'gkcart your cart','gkcart your cart',0,1,1.5333,'G636263',1),(1556,'gkcartis2','gkcartis2',0,0,0.6,'G632',1),(1557,'gkcartis2 your','gkcartis2 your',0,1,1.4667,'G6326',1),(1558,'gkcartis2 your cart','gkcartis2 your cart',0,1,1.6333,'G6326263',1),(1559,'gkcartis3','gkcartis3',0,0,0.6,'G632',1),(1560,'gkcartis3 your','gkcartis3 your',0,1,1.4667,'G6326',1),(1561,'gkcartis3 your cart','gkcartis3 your cart',0,1,1.6333,'G6326263',1),(1562,'gkcd','gkcd',0,0,0.2667,'G300',1),(1563,'gkcd your','gkcd your',0,1,1.3,'G360',1),(1564,'gkcd your cd','gkcd your cd',0,1,1.4,'G3623',1),(1565,'gkcdis2','gkcdis2',0,0,0.4667,'G320',1),(1566,'gkcdis2 your','gkcdis2 your',0,1,1.4,'G326',1),(1567,'gkcdis2 your cd','gkcdis2 your cd',0,1,1.5,'G32623',1),(1568,'gkchartbar','gkchartbar',0,0,0.6667,'G6316',1),(1569,'gkchartbar your','gkchartbar your',0,1,1.5,'G6316',1),(1570,'gkchartbar your chart','gkchartbar your chart',0,1,1.7,'G6316263',1),(1571,'gkchartbaris3','gkchartbaris3',0,0,0.8667,'G63162',1),(1572,'gkchartbaris3 your','gkchartbaris3 your',0,1,1.6,'G631626',1),(1573,'gkchartbaris3 your chart','gkchartbaris3 your chart',0,1,1.8,'G631626263',1),(1574,'gkchartline','gkchartline',0,0,0.7333,'G6345',1),(1575,'gkchartline your','gkchartline your',0,1,1.5333,'G63456',1),(1576,'gkchartline your chart','gkchartline your chart',0,1,1.7333,'G63456263',1),(1577,'gkchartlineis2','gkchartlineis2',0,0,0.9333,'G63452',1),(1578,'gkchartlineis2 your','gkchartlineis2 your',0,1,1.6333,'G634526',1),(1579,'gkchartlineis2 your chart','gkchartlineis2 your chart',0,1,1.8333,'G634526263',1),(1580,'gkchartpie','gkchartpie',0,0,0.6667,'G631',1),(1581,'gkchartpie your','gkchartpie your',0,1,1.5,'G6316',1),(1582,'gkchartpie your chart','gkchartpie your chart',0,1,1.7,'G6316263',1),(1583,'gkchartpieis2','gkchartpieis2',0,0,0.8667,'G6312',1),(1584,'gkchartpieis2 your','gkchartpieis2 your',0,1,1.6,'G63126',1),(1585,'gkchartpieis2 your calendar','gkchartpieis2 your calendar',0,1,1.9,'G6312624536',1),(1586,'gkcircle1','gkcircle1',0,0,0.6,'G624',1),(1587,'gkcircle1 element','gkcircle1 element',0,1,1.5667,'G62453',1),(1588,'gkcircle1 element 1','gkcircle1 element 1',0,1,1.6333,'G62453',1),(1589,'gkcircle2','gkcircle2',0,0,0.6,'G624',1),(1590,'gkcircle2 element','gkcircle2 element',0,1,1.5667,'G62453',1),(1591,'gkcircle2 element 1','gkcircle2 element 1',0,1,1.6333,'G62453',1),(1592,'gkclear','gkclear',0,0,0.4667,'G460',1),(1593,'gkclear lorem','gkclear lorem',0,1,1.4333,'G46465',1),(1594,'gkclear lorem ipsum','gkclear lorem ipsum',0,1,1.6333,'G46465125',1),(1595,'gkclear-1','gkclear-1',0,0,0.6,'G460',1),(1596,'gkclear-1 lorem','gkclear-1 lorem',0,1,1.5,'G46465',1),(1597,'gkclear-1 lorem ipsum','gkclear-1 lorem ipsum',0,1,1.7,'G46465125',1),(1598,'gkclear-2','gkclear-2',0,0,0.6,'G460',1),(1599,'gkclear-2 lorem','gkclear-2 lorem',0,1,1.5,'G46465',1),(1600,'gkclear-2 lorem ipsum','gkclear-2 lorem ipsum',0,1,1.7,'G46465125',1),(1601,'gkclock','gkclock',0,0,0.4667,'G420',1),(1602,'gkclock your','gkclock your',0,1,1.4,'G426',1),(1603,'gkclock your clock','gkclock your clock',0,1,1.6,'G426242',1),(1604,'gkclockis2','gkclockis2',0,0,0.6667,'G420',1),(1605,'gkclockis2 your','gkclockis2 your',0,1,1.5,'G426',1),(1606,'gkclockis2 your clock','gkclockis2 your clock',0,1,1.7,'G426242',1),(1607,'gkcode1','gkcode1',0,0,0.4667,'G300',1),(1608,'gkcode1 wrapper','gkcode1 wrapper',0,1,1.5,'G3616',1),(1609,'gkcode1 wrapper position','gkcode1 wrapper position',0,1,1.8,'G36161235',1),(1610,'gkcode2','gkcode2',0,0,0.4667,'G300',1),(1611,'gkcode2 wrapper','gkcode2 wrapper',0,1,1.5,'G3616',1),(1612,'gkcode2 wrapper position','gkcode2 wrapper position',0,1,1.8,'G36161235',1),(1613,'gkcode3','gkcode3',0,0,0.4667,'G300',1),(1614,'gkcode3 h4','gkcode3 h4',0,1,1.3333,'G300',1),(1615,'gkcode3 h4 name','gkcode3 h4 name',0,1,1.5,'G350',1),(1616,'gkcoffeis3','gkcoffeis3',0,0,0.6667,'G120',1),(1617,'gkcoffeis3 your','gkcoffeis3 your',0,1,1.5,'G126',1),(1618,'gkcoffeis3 your coffe','gkcoffeis3 your coffe',0,1,1.7,'G12621',1),(1619,'gkcog','gkcog',0,0,0.3333,'G000',1),(1620,'gkcog your','gkcog your',0,1,1.3333,'G600',1),(1621,'gkcog your cog','gkcog your cog',0,1,1.4667,'G620',1),(1622,'gkcogis2','gkcogis2',0,0,0.5333,'G000',1),(1623,'gkcogis2 your','gkcogis2 your',0,1,1.4333,'G600',1),(1624,'gkcogis2 your config','gkcogis2 your config',0,1,1.6667,'G62512',1),(1625,'gkcoins','gkcoins',0,0,0.4667,'G520',1),(1626,'gkcoins your','gkcoins your',0,1,1.4,'G526',1),(1627,'gkcoins your coins','gkcoins your coins',0,1,1.6,'G526252',1),(1628,'gkcolor','gkcolor',0,0,0.4667,'G460',1),(1629,'gkcolor lorem','gkcolor lorem',0,1,1.4333,'G46465',1),(1630,'gkcolor lorem ipsum','gkcolor lorem ipsum',0,1,1.6333,'G46465125',1),(1631,'gkcolor-1','gkcolor-1',0,0,0.6,'G460',1),(1632,'gkcolor-1 lorem','gkcolor-1 lorem',0,1,1.5,'G46465',1),(1633,'gkcolor-1 lorem ipsum','gkcolor-1 lorem ipsum',0,1,1.7,'G46465125',1),(1634,'gkcolor-2','gkcolor-2',0,0,0.6,'G460',1),(1635,'gkcolor-2 lorem','gkcolor-2 lorem',0,1,1.5,'G46465',1),(1636,'gkcolor-2 lorem ipsum','gkcolor-2 lorem ipsum',0,1,1.7,'G46465125',1),(1637,'gkcolor-3','gkcolor-3',0,0,0.6,'G460',1),(1638,'gkcolor-3 lorem','gkcolor-3 lorem',0,1,1.5,'G46465',1),(1639,'gkcolor-3 lorem ipsum','gkcolor-3 lorem ipsum',0,1,1.7,'G46465125',1),(1640,'gkcolor-4','gkcolor-4',0,0,0.6,'G460',1),(1641,'gkcolor-4 lorem','gkcolor-4 lorem',0,1,1.5,'G46465',1),(1642,'gkcolor-4 lorem ipsum','gkcolor-4 lorem ipsum',0,1,1.7,'G46465125',1),(1643,'gkcolor-5','gkcolor-5',0,0,0.6,'G460',1),(1644,'gkcolor-5 lorem','gkcolor-5 lorem',0,1,1.5,'G46465',1),(1645,'gkcolor-5 lorem ipsum','gkcolor-5 lorem ipsum',0,1,1.7,'G46465125',1),(1646,'gkcolor-6','gkcolor-6',0,0,0.6,'G460',1),(1647,'gkcolor-6 lorem','gkcolor-6 lorem',0,1,1.5,'G46465',1),(1648,'gkcolor-6 lorem ipsum','gkcolor-6 lorem ipsum',0,1,1.7,'G46465125',1),(1649,'gkcolor-7','gkcolor-7',0,0,0.6,'G460',1),(1650,'gkcolor-7 lorem','gkcolor-7 lorem',0,1,1.5,'G46465',1),(1651,'gkcolor-7 lorem ipsum','gkcolor-7 lorem ipsum',0,1,1.7,'G46465125',1),(1652,'gkcompress','gkcompress',0,0,0.6667,'G5162',1),(1653,'gkcompress your','gkcompress your',0,1,1.5,'G51626',1),(1654,'gkcompress your compress','gkcompress your compress',0,1,1.8,'G5162625162',1),(1655,'gkcomputer','gkcomputer',0,0,0.6667,'G5136',1),(1656,'gkcomputer your','gkcomputer your',0,1,1.5,'G5136',1),(1657,'gkcomputer your computer','gkcomputer your computer',0,1,1.8,'G513625136',1),(1658,'gkcomputeris2','gkcomputeris2',0,0,0.8667,'G51362',1),(1659,'gkcomputeris2 your','gkcomputeris2 your',0,1,1.6,'G513626',1),(1660,'gkcomputeris2 your computer','gkcomputeris2 your computer',0,1,1.9,'G51362625136',1),(1661,'gkcomputeris3','gkcomputeris3',0,0,0.8667,'G51362',1),(1662,'gkcomputeris3 your','gkcomputeris3 your',0,1,1.6,'G513626',1),(1663,'gkcomputeris3 your computer','gkcomputeris3 your computer',0,1,1.9,'G51362625136',1),(1664,'gkconfig2is3','gkconfig2is3',0,0,0.8,'G512',1),(1665,'gkconfig2is3 your','gkconfig2is3 your',0,1,1.5667,'G5126',1),(1666,'gkconfig2is3 your configuration','gkconfig2is3 your configuration',0,1,2,'G51262512635',1),(1667,'gkconfigis3','gkconfigis3',0,0,0.7333,'G512',1),(1668,'gkconfigis3 your','gkconfigis3 your',0,1,1.5333,'G5126',1),(1669,'gkconfigis3 your config','gkconfigis3 your config',0,1,1.7667,'G51262512',1),(1670,'gkcontactis2','gkcontactis2',0,0,0.8,'G53232',1),(1671,'gkcontactis2 your','gkcontactis2 your',0,1,1.5667,'G532326',1),(1672,'gkcontactis2 your contact','gkcontactis2 your contact',0,1,1.8333,'G53232625323',1),(1673,'gkcreditcard','gkcreditcard',0,0,0.8,'G63263',1),(1674,'gkcreditcard your','gkcreditcard your',0,1,1.5667,'G632636',1),(1675,'gkcreditcard your creditcart','gkcreditcard your creditcart',0,1,1.9333,'G632636263263',1),(1676,'gkcross','gkcross',0,0,0.4667,'G620',1),(1677,'gkcross your','gkcross your',0,1,1.4,'G626',1),(1678,'gkcross your cross','gkcross your cross',0,1,1.6,'G626262',1),(1679,'gkcrossis3','gkcrossis3',0,0,0.6667,'G620',1),(1680,'gkcrossis3 your','gkcrossis3 your',0,1,1.5,'G626',1),(1681,'gkcrossis3 your cross','gkcrossis3 your cross',0,1,1.7,'G626262',1),(1682,'gkdec','gkdec',0,0,0.3333,'G320',1),(1683,'gkdec element','gkdec element',0,1,1.4333,'G32453',1),(1684,'gkdec element element','gkdec element element',0,1,1.7,'G32453453',1),(1685,'gkdecimalleadingzero','gkdecimalleadingzero',0,0,1,'G32543526',1),(1686,'gkdecimalleadingzero element','gkdecimalleadingzero element',0,1,1.9333,'G32543526453',1),(1687,'gkdecimalleadingzero element element','gkdecimalleadingzero element element',0,1,2,'G32543526453453',1),(1688,'gkdef1','gkdef1',0,0,0.4,'G310',1),(1689,'gkdef1 dt','gkdef1 dt',0,1,1.3,'G313',1),(1690,'gkdef1 dt here','gkdef1 dt here',0,1,1.4667,'G3136',1),(1691,'gkdef2','gkdef2',0,0,0.4,'G310',1),(1692,'gkdef2 dt','gkdef2 dt',0,1,1.3,'G313',1),(1693,'gkdef2 dt here','gkdef2 dt here',0,1,1.4667,'G3136',1),(1694,'gkdef3','gkdef3',0,0,0.4,'G310',1),(1695,'gkdef3 dt','gkdef3 dt',0,1,1.3,'G313',1),(1696,'gkdef3 dt here','gkdef3 dt here',0,1,1.4667,'G3136',1),(1697,'gkdisk','gkdisk',0,0,0.4,'G320',1),(1698,'gkdisk your','gkdisk your',0,1,1.3667,'G326',1),(1699,'gkdisk your disk','gkdisk your disk',0,1,1.5333,'G32632',1),(1700,'gkdropcap1','gkdropcap1',0,0,0.6667,'G36121',1),(1701,'gkdropcap1 t','gkdropcap1 t',0,1,1.4,'G361213',1),(1702,'gkdropcap1 t span','gkdropcap1 t span',0,1,1.5667,'G361213215',1),(1703,'gkdropcap2','gkdropcap2',0,0,0.6667,'G36121',1),(1704,'gkdropcap2 t','gkdropcap2 t',0,1,1.4,'G361213',1),(1705,'gkdropcap2 t his','gkdropcap2 t his',0,1,1.5333,'G3612132',1),(1706,'gkdropcap2 t span','gkdropcap2 t span',0,1,1.5667,'G361213215',1),(1707,'gkdropcap3','gkdropcap3',0,0,0.6667,'G36121',1),(1708,'gkdropcap3 span','gkdropcap3 span',0,1,1.5,'G36121215',1),(1709,'gkdropcap3 span class','gkdropcap3 span class',0,1,1.7,'G36121215242',1),(1710,'gkdropcap3 t','gkdropcap3 t',0,1,1.4,'G361213',1),(1711,'gkdropcap3 t span','gkdropcap3 t span',0,1,1.5667,'G361213215',1),(1712,'gkemail','gkemail',0,0,0.4667,'G540',1),(1713,'gkemail your','gkemail your',0,1,1.4,'G546',1),(1714,'gkemail your email','gkemail your email',0,1,1.6,'G54654',1),(1715,'gkemailis2','gkemailis2',0,0,0.6667,'G542',1),(1716,'gkemailis2 your','gkemailis2 your',0,1,1.5,'G5426',1),(1717,'gkemailis2 your email','gkemailis2 your email',0,1,1.7,'G542654',1),(1718,'gkerror','gkerror',0,0,0.4667,'G600',1),(1719,'gkerror your','gkerror your',0,1,1.4,'G600',1),(1720,'gkerroris2','gkerroris2',0,0,0.6667,'G620',1),(1721,'gkerroris2 your','gkerroris2 your',0,1,1.5,'G626',1),(1722,'gkerroris2 your error','gkerroris2 your error',0,1,1.7,'G626',1),(1723,'gkerroris3','gkerroris3',0,0,0.6667,'G620',1),(1724,'gkerroris3 your','gkerroris3 your',0,1,1.5,'G626',1),(1725,'gkerroris3 your error','gkerroris3 your error',0,1,1.7,'G626',1),(1726,'gkexclamation','gkexclamation',0,0,0.8667,'G4535',1),(1727,'gkexclamation your','gkexclamation your',0,1,1.6,'G45356',1),(1728,'gkexclamation your exclamation','gkexclamation your exclamation',0,1,2,'G4535624535',1),(1729,'gkexclamationis2','gkexclamationis2',0,0,1,'G45352',1),(1730,'gkexclamationis2 your','gkexclamationis2 your',0,1,1.7,'G453526',1),(1731,'gkexclamationis2 your exclamation','gkexclamationis2 your exclamation',0,1,2,'G45352624535',1),(1732,'gkfacebookis2','gkfacebookis2',0,0,0.8667,'G1212',1),(1733,'gkfacebookis2 your','gkfacebookis2 your',0,1,1.6,'G12126',1),(1734,'gkfacebookis2 your facebook','gkfacebookis2 your facebook',0,1,1.9,'G121261212',1),(1735,'gkfeed','gkfeed',0,0,0.4,'G130',1),(1736,'gkfeed your','gkfeed your',0,1,1.3667,'G136',1),(1737,'gkfeed your feed','gkfeed your feed',0,1,1.5333,'G13613',1),(1738,'gkfeedis2','gkfeedis2',0,0,0.6,'G132',1),(1739,'gkfeedis2 your','gkfeedis2 your',0,1,1.4667,'G1326',1),(1740,'gkfeedis2 your feed','gkfeedis2 your feed',0,1,1.6333,'G132613',1),(1741,'gkfilm','gkfilm',0,0,0.4,'G145',1),(1742,'gkfilm your','gkfilm your',0,1,1.3667,'G1456',1),(1743,'gkfilm your film','gkfilm your film',0,1,1.5333,'G1456145',1),(1744,'gkfilmis2','gkfilmis2',0,0,0.6,'G1452',1),(1745,'gkfilmis2 your','gkfilmis2 your',0,1,1.4667,'G14526',1),(1746,'gkfilmis2 your movie','gkfilmis2 your movie',0,1,1.6667,'G1452651',1),(1747,'gkfolder','gkfolder',0,0,0.5333,'G1436',1),(1748,'gkfolder your','gkfolder your',0,1,1.4333,'G1436',1),(1749,'gkfolder your folder','gkfolder your folder',0,1,1.6667,'G14361436',1),(1750,'gkfolderis2','gkfolderis2',0,0,0.7333,'G14362',1),(1751,'gkfolderis2 your','gkfolderis2 your',0,1,1.5333,'G143626',1),(1752,'gkfolderis2 your folder','gkfolderis2 your folder',0,1,1.7667,'G1436261436',1),(1753,'gkgroup','gkgroup',0,0,0.4667,'G610',1),(1754,'gkgroup your','gkgroup your',0,1,1.4,'G616',1),(1755,'gkgroup your group','gkgroup your group',0,1,1.6,'G616261',1),(1756,'gkgroupis2','gkgroupis2',0,0,0.6667,'G612',1),(1757,'gkgroupis2 your','gkgroupis2 your',0,1,1.5,'G6126',1),(1758,'gkgroupis2 your group','gkgroupis2 your group',0,1,1.7,'G6126261',1),(1759,'gkheadling','gkheadling',0,0,0.6667,'G3452',1),(1760,'gkheadling for','gkheadling for',0,1,1.4667,'G345216',1),(1761,'gkheadling for headline','gkheadling for headline',0,1,1.7667,'G345216345',1),(1762,'gkheart','gkheart',0,0,0.4667,'G630',1),(1763,'gkheart your','gkheart your',0,1,1.4,'G636',1),(1764,'gkheart your heart','gkheart your heart',0,1,1.6,'G6363',1),(1765,'gkhelp','gkhelp',0,0,0.4,'G410',1),(1766,'gkhelp your','gkhelp your',0,1,1.3667,'G416',1),(1767,'gkhelp your help','gkhelp your help',0,1,1.5333,'G41641',1),(1768,'gkhighlight1','gkhighlight1',0,0,0.8,'G423',1),(1769,'gkhighlight1 your','gkhighlight1 your',0,1,1.5667,'G4236',1),(1770,'gkhighlight1 your highlight','gkhighlight1 your highlight',0,1,1.9,'G42362423',1),(1771,'gkhighlight2','gkhighlight2',0,0,0.8,'G423',1),(1772,'gkhighlight2 your','gkhighlight2 your',0,1,1.5667,'G4236',1),(1773,'gkhighlight2 your highlight','gkhighlight2 your highlight',0,1,1.9,'G42362423',1),(1774,'gkhighlight3','gkhighlight3',0,0,0.8,'G423',1),(1775,'gkhighlight3 your','gkhighlight3 your',0,1,1.5667,'G4236',1),(1776,'gkhighlight3 your highlight','gkhighlight3 your highlight',0,1,1.9,'G42362423',1),(1777,'gkhighlight4','gkhighlight4',0,0,0.8,'G423',1),(1778,'gkhighlight4 your','gkhighlight4 your',0,1,1.5667,'G4236',1),(1779,'gkhighlight4 your highlight','gkhighlight4 your highlight',0,1,1.9,'G42362423',1),(1780,'gkhouse','gkhouse',0,0,0.4667,'G000',1),(1781,'gkhouse your','gkhouse your',0,1,1.4,'G600',1),(1782,'gkhouse your house','gkhouse your house',0,1,1.6,'G620',1),(1783,'gkhouseis2','gkhouseis2',0,0,0.6667,'G000',1),(1784,'gkhouseis2 your','gkhouseis2 your',0,1,1.5,'G600',1),(1785,'gkhouseis2 your house','gkhouseis2 your house',0,1,1.7,'G620',1),(1786,'gkhouseis3','gkhouseis3',0,0,0.6667,'G000',1),(1787,'gkhouseis3 your','gkhouseis3 your',0,1,1.5,'G600',1),(1788,'gkhouseis3 your house','gkhouseis3 your house',0,1,1.7,'G620',1),(1789,'gkimage','gkimage',0,0,0.4667,'G520',1),(1790,'gkimage your','gkimage your',0,1,1.4,'G526',1),(1791,'gkimage your image','gkimage your image',0,1,1.6,'G52652',1),(1792,'gkimageis2','gkimageis2',0,0,0.6667,'G520',1),(1793,'gkimageis2 your','gkimageis2 your',0,1,1.5,'G526',1),(1794,'gkimageis2 your image','gkimageis2 your image',0,1,1.7,'G52652',1),(1795,'gkimages','gkimages',0,0,0.5333,'G520',1),(1796,'gkimages your','gkimages your',0,1,1.4333,'G526',1),(1797,'gkimages your images','gkimages your images',0,1,1.6667,'G52652',1),(1798,'gkimagesis2','gkimagesis2',0,0,0.7333,'G520',1),(1799,'gkimagesis2 your','gkimagesis2 your',0,1,1.5333,'G526',1),(1800,'gkimagesis2 your images','gkimagesis2 your images',0,1,1.7667,'G52652',1),(1801,'gkinfo1','gkinfo1',0,0,0.4667,'G510',1),(1802,'gkinfo1 your','gkinfo1 your',0,1,1.4,'G516',1),(1803,'gkinfo1 your info','gkinfo1 your info',0,1,1.5667,'G51651',1),(1804,'gkinfo2','gkinfo2',0,0,0.4667,'G510',1),(1805,'gkinfo2 your','gkinfo2 your',0,1,1.4,'G516',1),(1806,'gkinfo2 your info','gkinfo2 your info',0,1,1.5667,'G51651',1),(1807,'gkinfo3','gkinfo3',0,0,0.4667,'G510',1),(1808,'gkinfo3 your','gkinfo3 your',0,1,1.4,'G516',1),(1809,'gkinfo3 your info','gkinfo3 your info',0,1,1.5667,'G51651',1),(1810,'gkinfo4','gkinfo4',0,0,0.4667,'G510',1),(1811,'gkinfo4 your','gkinfo4 your',0,1,1.4,'G516',1),(1812,'gkinfo4 your info','gkinfo4 your info',0,1,1.5667,'G51651',1),(1813,'gkinfo5','gkinfo5',0,0,0.4667,'G510',1),(1814,'gkinfo5 your','gkinfo5 your',0,1,1.4,'G516',1),(1815,'gkinfo5 your info','gkinfo5 your info',0,1,1.5667,'G51651',1),(1816,'gkinformation','gkinformation',0,0,0.8667,'G516535',1),(1817,'gkinformation your','gkinformation your',0,1,1.6,'G5165356',1),(1818,'gkinformation your information','gkinformation your information',0,1,2,'G5165356516535',1),(1819,'gkinformationis3','gkinformationis3',0,0,1,'G5165352',1),(1820,'gkinformationis3 your','gkinformationis3 your',0,1,1.7,'G51653526',1),(1821,'gkinformationis3 your inforation','gkinformationis3 your inforation',0,1,2,'G5165352651635',1),(1822,'gkinfromationis2','gkinfromationis2',0,0,1,'G5165352',1),(1823,'gkinfromationis2 your','gkinfromationis2 your',0,1,1.7,'G51653526',1),(1824,'gkinfromationis2 your information','gkinfromationis2 your information',0,1,2,'G51653526516535',1),(1825,'gklegend1','gklegend1',0,0,0.6,'G4253',1),(1826,'gklegend1 h4','gklegend1 h4',0,1,1.4,'G4253',1),(1827,'gklegend1 h4 title','gklegend1 h4 title',0,1,1.6,'G42534',1),(1828,'gklegend2','gklegend2',0,0,0.6,'G4253',1),(1829,'gklegend2 h4','gklegend2 h4',0,1,1.4,'G4253',1),(1830,'gklegend2 h4 title','gklegend2 h4 title',0,1,1.6,'G42534',1),(1831,'gklegend3','gklegend3',0,0,0.6,'G4253',1),(1832,'gklegend3 h4','gklegend3 h4',0,1,1.4,'G4253',1),(1833,'gklegend3 h4 title','gklegend3 h4 title',0,1,1.6,'G42534',1),(1834,'gklegend4','gklegend4',0,0,0.6,'G4253',1),(1835,'gklegend4 h4','gklegend4 h4',0,1,1.4,'G4253',1),(1836,'gklegend4 h4 title','gklegend4 h4 title',0,1,1.6,'G42534',1),(1837,'gklegend5','gklegend5',0,0,0.6,'G4253',1),(1838,'gklegend5 h4','gklegend5 h4',0,1,1.4,'G4253',1),(1839,'gklegend5 h4 title','gklegend5 h4 title',0,1,1.6,'G42534',1),(1840,'gklegend6','gklegend6',0,0,0.6,'G4253',1),(1841,'gklegend6 h4','gklegend6 h4',0,1,1.4,'G4253',1),(1842,'gklegend6 h4 title','gklegend6 h4 title',0,1,1.6,'G42534',1),(1843,'gklegend7','gklegend7',0,0,0.6,'G4253',1),(1844,'gklegend7 h4','gklegend7 h4',0,1,1.4,'G4253',1),(1845,'gklegend7 h4 title','gklegend7 h4 title',0,1,1.6,'G42534',1),(1846,'gklikeitis2','gklikeitis2',0,0,0.7333,'G4232',1),(1847,'gklikeitis2 your','gklikeitis2 your',0,1,1.5333,'G42326',1),(1848,'gklikeitis2 your like','gklikeitis2 your like',0,1,1.7,'G4232642',1),(1849,'gklock','gklock',0,0,0.4,'G420',1),(1850,'gklock your','gklock your',0,1,1.3667,'G426',1),(1851,'gklock your webcam','gklock your webcam',0,1,1.6,'G426125',1),(1852,'gklockis2','gklockis2',0,0,0.6,'G420',1),(1853,'gklockis2 your','gklockis2 your',0,1,1.4667,'G426',1),(1854,'gklockis2 your lock','gklockis2 your lock',0,1,1.6333,'G42642',1),(1855,'gklockis3','gklockis3',0,0,0.6,'G420',1),(1856,'gklockis3 your','gklockis3 your',0,1,1.4667,'G426',1),(1857,'gklockis3 your lock','gklockis3 your lock',0,1,1.6333,'G42642',1),(1858,'gkmagnifier','gkmagnifier',0,0,0.7333,'G52516',1),(1859,'gkmagnifier your','gkmagnifier your',0,1,1.5333,'G52516',1),(1860,'gkmagnifier your magnifier','gkmagnifier your magnifier',0,1,1.8667,'G5251652516',1),(1861,'gkmagnifieris2','gkmagnifieris2',0,0,0.9333,'G525162',1),(1862,'gkmagnifieris2 your','gkmagnifieris2 your',0,1,1.6333,'G5251626',1),(1863,'gkmagnifieris2 your magnifier','gkmagnifieris2 your magnifier',0,1,1.9667,'G525162652516',1),(1864,'gkmagnifieris3','gkmagnifieris3',0,0,0.9333,'G525162',1),(1865,'gkmagnifieris3 your','gkmagnifieris3 your',0,1,1.6333,'G5251626',1),(1866,'gkmagnifieris3 your magnifier','gkmagnifieris3 your magnifier',0,1,1.9667,'G525162652516',1),(1867,'gkmoney','gkmoney',0,0,0.4667,'G500',1),(1868,'gkmoney your','gkmoney your',0,1,1.4,'G560',1),(1869,'gkmoney your money','gkmoney your money',0,1,1.6,'G565',1),(1870,'gkmoneyis2','gkmoneyis2',0,0,0.6667,'G520',1),(1871,'gkmoneyis2 your','gkmoneyis2 your',0,1,1.5,'G526',1),(1872,'gkmoneyis2 your money','gkmoneyis2 your money',0,1,1.7,'G5265',1),(1873,'gknew','gknew',0,0,0.3333,'G500',1),(1874,'gknew your','gknew your',0,1,1.3333,'G560',1),(1875,'gknew your new','gknew your new',0,1,1.4667,'G565',1),(1876,'gknote','gknote',0,0,0.4,'G530',1),(1877,'gknote your','gknote your',0,1,1.3667,'G536',1),(1878,'gknote your note','gknote your note',0,1,1.5333,'G53653',1),(1879,'gknumber1','gknumber1',0,0,0.6,'G516',1),(1880,'gknumber1 p','gknumber1 p',0,1,1.3667,'G5161',1),(1881,'gknumber1 p span','gknumber1 p span',0,1,1.5333,'G5161215',1),(1882,'gknumber2','gknumber2',0,0,0.6,'G516',1),(1883,'gknumber2 p','gknumber2 p',0,1,1.3667,'G5161',1),(1884,'gknumber2 p span','gknumber2 p span',0,1,1.5333,'G5161215',1),(1885,'gkpage','gkpage',0,0,0.4,'G120',1),(1886,'gkpage white','gkpage white',0,1,1.4,'G123',1),(1887,'gkpage white your','gkpage white your',0,1,1.5667,'G1236',1),(1888,'gkpage your','gkpage your',0,1,1.3667,'G126',1),(1889,'gkpage your page','gkpage your page',0,1,1.5333,'G12612',1),(1890,'gkpageis2','gkpageis2',0,0,0.6,'G120',1),(1891,'gkpageis2 your','gkpageis2 your',0,1,1.4667,'G126',1),(1892,'gkpageis2 your page','gkpageis2 your page',0,1,1.6333,'G12612',1),(1893,'gkpageis3','gkpageis3',0,0,0.6,'G120',1),(1894,'gkpageis3 your','gkpageis3 your',0,1,1.4667,'G126',1),(1895,'gkpageis3 your page','gkpageis3 your page',0,1,1.6333,'G12612',1),(1896,'gkplugin','gkplugin',0,0,0.5333,'G1425',1),(1897,'gkplugin your','gkplugin your',0,1,1.4333,'G14256',1),(1898,'gkplugin your plugin','gkplugin your plugin',0,1,1.6667,'G142561425',1),(1899,'gkprinter','gkprinter',0,0,0.6,'G16536',1),(1900,'gkprinter your','gkprinter your',0,1,1.4667,'G16536',1),(1901,'gkprinter your printer','gkprinter your printer',0,1,1.7333,'G1653616536',1),(1902,'gkprinteris2','gkprinteris2',0,0,0.8,'G165362',1),(1903,'gkprinteris2 your','gkprinteris2 your',0,1,1.5667,'G1653626',1),(1904,'gkprinteris2 your printer','gkprinteris2 your printer',0,1,1.8333,'G165362616536',1),(1905,'gkreport','gkreport',0,0,0.5333,'G6163',1),(1906,'gkreport your','gkreport your',0,1,1.4333,'G61636',1),(1907,'gkreport your report','gkreport your report',0,1,1.6667,'G61636163',1),(1908,'gkroman','gkroman',0,0,0.4667,'G650',1),(1909,'gkroman element','gkroman element',0,1,1.5,'G65453',1),(1910,'gkroman element element','gkroman element element',0,1,1.7667,'G65453453',1),(1911,'gkscript','gkscript',0,0,0.5333,'G613',1),(1912,'gkscript your','gkscript your',0,1,1.4333,'G6136',1),(1913,'gkscript your script','gkscript your script',0,1,1.6667,'G61362613',1),(1914,'gksquare1','gksquare1',0,0,0.6,'G600',1),(1915,'gksquare1 element','gksquare1 element',0,1,1.5667,'G6453',1),(1916,'gksquare1 element 1','gksquare1 element 1',0,1,1.6333,'G6453',1),(1917,'gksquare2','gksquare2',0,0,0.6,'G600',1),(1918,'gksquare2 element','gksquare2 element',0,1,1.5667,'G6453',1),(1919,'gksquare2 element 1','gksquare2 element 1',0,1,1.6333,'G6453',1),(1920,'gksquare3','gksquare3',0,0,0.6,'G600',1),(1921,'gksquare3 element','gksquare3 element',0,1,1.5667,'G6453',1),(1922,'gksquare3 element 1','gksquare3 element 1',0,1,1.6333,'G6453',1),(1923,'gkstaris3','gkstaris3',0,0,0.6,'G362',1),(1924,'gkstaris3 your','gkstaris3 your',0,1,1.4667,'G3626',1),(1925,'gkstaris3 your star','gkstaris3 your star',0,1,1.6333,'G3626236',1),(1926,'gksubheadline','gksubheadline',0,0,0.8667,'G1345',1),(1927,'gksubheadline for','gksubheadline for',0,1,1.5667,'G134516',1),(1928,'gksubheadline for subheadline','gksubheadline for subheadline',0,1,1.9667,'G13451621345',1),(1929,'gktelephoneis3','gktelephoneis3',0,0,0.9333,'G34152',1),(1930,'gktelephoneis3 your','gktelephoneis3 your',0,1,1.6333,'G341526',1),(1931,'gktelephoneis3 your telephone','gktelephoneis3 your telephone',0,1,1.9667,'G3415263415',1),(1932,'gktime','gktime',0,0,0.4,'G350',1),(1933,'gktime your','gktime your',0,1,1.3667,'G356',1),(1934,'gktime your time','gktime your time',0,1,1.5333,'G35635',1),(1935,'gktimeis2','gktimeis2',0,0,0.6,'G352',1),(1936,'gktimeis2 your','gktimeis2 your',0,1,1.4667,'G3526',1),(1937,'gktimeis2 your time','gktimeis2 your time',0,1,1.6333,'G352635',1),(1938,'gktips1','gktips1',0,0,0.4667,'G312',1),(1939,'gktips1 your','gktips1 your',0,1,1.4,'G3126',1),(1940,'gktips1 your tips','gktips1 your tips',0,1,1.5667,'G3126312',1),(1941,'gktips2','gktips2',0,0,0.4667,'G312',1),(1942,'gktips2 your','gktips2 your',0,1,1.4,'G3126',1),(1943,'gktips2 your tips','gktips2 your tips',0,1,1.5667,'G3126312',1),(1944,'gktips3','gktips3',0,0,0.4667,'G312',1),(1945,'gktips3 your','gktips3 your',0,1,1.4,'G3126',1),(1946,'gktips3 your tips','gktips3 your tips',0,1,1.5667,'G3126312',1),(1947,'gktips4','gktips4',0,0,0.4667,'G312',1),(1948,'gktips4 your','gktips4 your',0,1,1.4,'G3126',1),(1949,'gktips4 your tips','gktips4 your tips',0,1,1.5667,'G3126312',1),(1950,'gktips5','gktips5',0,0,0.4667,'G312',1),(1951,'gktips5 your','gktips5 your',0,1,1.4,'G3126',1),(1952,'gktips5 your tips','gktips5 your tips',0,1,1.5667,'G3126312',1),(1953,'gktwitteris2','gktwitteris2',0,0,0.8,'G362',1),(1954,'gktwitteris2 your','gktwitteris2 your',0,1,1.5667,'G3626',1),(1955,'gktwitteris2 your twitter','gktwitteris2 your twitter',0,1,1.8333,'G362636',1),(1956,'gkuser','gkuser',0,0,0.4,'G600',1),(1957,'gkuser your','gkuser your',0,1,1.3667,'G600',1),(1958,'gkuseris2','gkuseris2',0,0,0.6,'G620',1),(1959,'gkuseris2 your','gkuseris2 your',0,1,1.4667,'G626',1),(1960,'gkuseris2 your calendar','gkuseris2 your calendar',0,1,1.7667,'G62624536',1),(1961,'gkuseris3','gkuseris3',0,0,0.6,'G620',1),(1962,'gkuseris3 your','gkuseris3 your',0,1,1.4667,'G626',1),(1963,'gkuseris3 your user','gkuseris3 your user',0,1,1.6333,'G62626',1),(1964,'gkvideois2','gkvideois2',0,0,0.6667,'G132',1),(1965,'gkvideois2 your','gkvideois2 your',0,1,1.5,'G1326',1),(1966,'gkvideois2 your video','gkvideois2 your video',0,1,1.7,'G132613',1),(1967,'gkwarning1','gkwarning1',0,0,0.6667,'G652',1),(1968,'gkwarning1 your','gkwarning1 your',0,1,1.5,'G6526',1),(1969,'gkwarning1 your warning','gkwarning1 your warning',0,1,1.7667,'G652652',1),(1970,'gkwarning2','gkwarning2',0,0,0.6667,'G652',1),(1971,'gkwarning2 your','gkwarning2 your',0,1,1.5,'G6526',1),(1972,'gkwarning2 your warning','gkwarning2 your warning',0,1,1.7667,'G652652',1),(1973,'gkwarning3','gkwarning3',0,0,0.6667,'G652',1),(1974,'gkwarning3 your','gkwarning3 your',0,1,1.5,'G6526',1),(1975,'gkwarning3 your warning','gkwarning3 your warning',0,1,1.7667,'G652652',1),(1976,'gkwarning4','gkwarning4',0,0,0.6667,'G652',1),(1977,'gkwarning4 your','gkwarning4 your',0,1,1.5,'G6526',1),(1978,'gkwarning4 your warning','gkwarning4 your warning',0,1,1.7667,'G652652',1),(1979,'gkwarning5','gkwarning5',0,0,0.6667,'G652',1),(1980,'gkwarning5 your','gkwarning5 your',0,1,1.5,'G6526',1),(1981,'gkwarning5 your warning','gkwarning5 your warning',0,1,1.7667,'G652652',1),(1982,'gkwebcam','gkwebcam',0,0,0.5333,'G125',1),(1983,'gkwebcam your','gkwebcam your',0,1,1.4333,'G1256',1),(1984,'gkwebcam your webcam','gkwebcam your webcam',0,1,1.6667,'G1256125',1),(1985,'gkworld','gkworld',0,0,0.4667,'G643',1),(1986,'gkworld your','gkworld your',0,1,1.4,'G6436',1),(1987,'gkworld your world','gkworld your world',0,1,1.6,'G643643',1),(1988,'gkworldis2','gkworldis2',0,0,0.6667,'G6432',1),(1989,'gkworldis2 your','gkworldis2 your',0,1,1.5,'G64326',1),(1990,'gkworldis2 your world','gkworldis2 your world',0,1,1.7,'G6432643',1),(1991,'gkyoutubeis2','gkyoutubeis2',0,0,0.8,'G312',1),(1992,'gkyoutubeis2 your','gkyoutubeis2 your',0,1,1.5667,'G3126',1),(1993,'gkyoutubeis2 your youtube','gkyoutubeis2 your youtube',0,1,1.8333,'G312631',1),(1994,'glands','glands',0,0,0.4,'G4532',1),(1995,'glands of','glands of',0,1,1.3,'G45321',1),(1996,'glands of mammals','glands of mammals',0,1,1.5667,'G45321542',1),(1997,'goes','goes',0,0,0.2667,'G000',1),(1998,'goes a','goes a',0,1,1.2,'G000',1),(1999,'goes a number','goes a number',0,1,1.4333,'G516',1),(2000,'goes an','goes an',0,1,1.2333,'G500',1),(2001,'goes an abbreviation','goes an abbreviation',0,1,1.6667,'G516135',1),(2002,'goes an acronym','goes an acronym',0,1,1.5,'G5265',1),(2003,'goes definition','goes definition',0,1,1.5,'G31535',1),(2004,'goes definition dd','goes definition dd',0,1,1.6,'G315353',1),(2005,'goes full','goes full',0,1,1.3,'G140',1),(2006,'goes full phrase','goes full phrase',0,1,1.5333,'G14162',1),(2007,'goes full word','goes full word',0,1,1.4667,'G1463',1),(2008,'goes here','goes here',0,1,1.3,'G600',1),(2009,'goes here blockquote','goes here blockquote',0,1,1.6667,'G61423',1),(2010,'goes here div','goes here div',0,1,1.4333,'G631',1),(2011,'goes here p','goes here p',0,1,1.3667,'G610',1),(2012,'goes here span','goes here span',0,1,1.4667,'G6215',1),(2013,'goes main','goes main',0,1,1.3,'G500',1),(2014,'goes main part','goes main part',0,1,1.4667,'G5163',1),(2015,'goes the','goes the',0,1,1.2667,'G300',1),(2016,'goes the word','goes the word',0,1,1.4333,'G363',1),(2017,'goes your','goes your',0,1,1.3,'G600',1),(2018,'goes your code','goes your code',0,1,1.4667,'G623',1),(2019,'group','group',0,0,0.3333,'G610',1),(2020,'group calendar','group calendar',0,1,1.4667,'G6124536',1),(2021,'group calendar message','group calendar message',0,1,1.7333,'G612453652',1),(2022,'group message','group message',0,1,1.4333,'G6152',1),(2023,'group message goes','group message goes',0,1,1.6,'G6152',1),(2024,'group message use','group message use',0,1,1.5667,'G6152',1),(2025,'h4','h4',0,0,0.1333,'H000',1),(2026,'h4 here','h4 here',0,1,1.2333,'H600',1),(2027,'h4 here goes','h4 here goes',0,1,1.4,'H620',1),(2028,'h4 name','h4 name',0,1,1.2333,'H500',1),(2029,'h4 name of','h4 name of',0,1,1.3333,'H510',1),(2030,'h4 p','h4 p',0,1,1.1333,'H100',1),(2031,'h4 p lorem','h4 p lorem',0,1,1.3333,'H1465',1),(2032,'h4 title','h4 title',0,1,1.2667,'H340',1),(2033,'h4 title h4','h4 title h4',0,1,1.3667,'H340',1),(2034,'habitasse','habitasse',0,0,0.6,'H132',1),(2035,'habitasse platea','habitasse platea',0,1,1.5333,'H132143',1),(2036,'habitasse platea dictumst','habitasse platea dictumst',0,1,1.8333,'H13214323523',1),(2037,'hac','hac',0,0,0.2,'H200',1),(2038,'hac habitasse','hac habitasse',0,1,1.4333,'H2132',1),(2039,'hac habitasse platea','hac habitasse platea',0,1,1.6667,'H2132143',1),(2040,'header','header',0,0,0.4,'H360',1),(2041,'header thead','header thead',0,1,1.4,'H363',1),(2042,'header thead table','header thead table',0,1,1.6,'H36314',1),(2043,'headers','headers',0,0,0.4667,'H362',1),(2044,'headers icon','headers icon',0,1,1.4,'H3625',1),(2045,'headers icon set','headers icon set',0,1,1.5333,'H362523',1),(2046,'headers this','headers this',0,1,1.4,'H36232',1),(2047,'headers this is','headers this is',0,1,1.5,'H36232',1),(2048,'heading','heading',0,0,0.4667,'H352',1),(2049,'heading 1','heading 1',0,1,1.3,'H352',1),(2050,'heading 1 lorem','heading 1 lorem',0,1,1.5,'H352465',1),(2051,'heading 2','heading 2',0,1,1.3,'H352',1),(2052,'heading 2 cras','heading 2 cras',0,1,1.4667,'H35262',1),(2053,'heading 3','heading 3',0,1,1.3,'H352',1),(2054,'heading 3 vivamus','heading 3 vivamus',0,1,1.5667,'H352152',1),(2055,'heading 4','heading 4',0,1,1.3,'H352',1),(2056,'heading 4 proin','heading 4 proin',0,1,1.5,'H352165',1),(2057,'headline','headline',0,0,0.5333,'H345',1),(2058,'headline p','headline p',0,1,1.3333,'H3451',1),(2059,'headline p p','headline p p',0,1,1.4,'H3451',1),(2060,'headline this','headline this',0,1,1.4333,'H34532',1),(2061,'headline this is','headline this is',0,1,1.5333,'H34532',1),(2062,'headline use','headline use',0,1,1.4,'H3452',1),(2063,'headline use p','headline use p',0,1,1.4667,'H34521',1),(2064,'heart','heart',0,0,0.3333,'H630',1),(2065,'heart goes','heart goes',0,1,1.3333,'H632',1),(2066,'heart goes here','heart goes here',0,1,1.5,'H6326',1),(2067,'heart message','heart message',0,1,1.4333,'H6352',1),(2068,'heart message use','heart message use',0,1,1.5667,'H6352',1),(2069,'help','help',0,0,0.2667,'H410',4),(2070,'help help','help help',0,1,1.3,'H4141',1),(2071,'help help this','help help this',0,1,1.4667,'H414132',1),(2072,'help message','help message',0,1,1.4,'H4152',1),(2073,'help message goes','help message goes',0,1,1.5667,'H4152',1),(2074,'help message use','help message use',0,1,1.5333,'H4152',1),(2075,'help this','help this',0,1,1.3,'H4132',1),(2076,'help this is','help this is',0,1,1.4,'H4132',1),(2077,'hendrerit','hendrerit',0,0,0.6,'H5363',21),(2078,'hendrerit aliquam','hendrerit aliquam',0,1,1.5667,'H5363425',1),(2079,'hendrerit aliquam rhoncus','hendrerit aliquam rhoncus',0,1,1.8333,'H5363425652',1),(2080,'hendrerit dictum','hendrerit dictum',0,1,1.5333,'H5363235',1),(2081,'hendrerit dictum other','hendrerit dictum other',0,1,1.7333,'H536323536',1),(2082,'hendrerit dictum p','hendrerit dictum p',0,1,1.6,'H53632351',1),(2083,'hendrerit massa','hendrerit massa',0,1,1.5,'H536352',1),(2084,'hendrerit massa sed','hendrerit massa sed',0,1,1.6333,'H5363523',1),(2085,'here','here',0,0,0.2667,'H600',1),(2086,'here are','here are',0,1,1.2667,'H600',1),(2087,'here are some','here are some',0,1,1.4333,'H625',1),(2088,'here blockquote','here blockquote',0,1,1.5,'H61423',1),(2089,'here div','here div',0,1,1.2667,'H631',1),(2090,'here div div','here div div',0,1,1.4,'H63131',1),(2091,'here goes','here goes',0,1,1.3,'H620',1),(2092,'here goes a','here goes a',0,1,1.3667,'H620',1),(2093,'here goes an','here goes an',0,1,1.4,'H625',1),(2094,'here goes definition','here goes definition',0,1,1.6667,'H6231535',1),(2095,'here goes full','here goes full',0,1,1.4667,'H6214',1),(2096,'here goes main','here goes main',0,1,1.4667,'H625',1),(2097,'here goes the','here goes the',0,1,1.4333,'H623',1),(2098,'here goes your','here goes your',0,1,1.4667,'H626',1),(2099,'here p','here p',0,1,1.2,'H610',1),(2100,'here p headers','here p headers',0,1,1.4667,'H61362',1),(2101,'here p icon','here p icon',0,1,1.3667,'H6125',1),(2102,'here p this','here p this',0,1,1.3667,'H6132',1),(2103,'here p tooltips','here p tooltips',0,1,1.5,'H6134312',1),(2104,'here p ythis','here p ythis',0,1,1.4,'H6132',1),(2105,'here span','here span',0,1,1.3,'H6215',1),(2106,'here span code','here span code',0,1,1.4667,'H621523',1),(2107,'here span this','here span this',0,1,1.4667,'H621532',1),(2108,'here text','here text',0,1,1.3,'H6323',1),(2109,'here text of','here text of',0,1,1.4,'H63231',1),(2110,'highlight','highlight',0,0,0.6,'H2423',1),(2111,'highlight phrase','highlight phrase',0,1,1.5333,'H2423162',1),(2112,'highlight phrase goes','highlight phrase goes',0,1,1.7,'H2423162',1),(2113,'highlight phrase use','highlight phrase use',0,1,1.6667,'H2423162',1),(2114,'highlights','highlights',0,0,0.6667,'H24232',1),(2115,'highlights code','highlights code',0,1,1.5,'H242323',1),(2116,'highlights code unordered','highlights code unordered',0,1,1.8333,'H24232356363',1),(2117,'highlights this','highlights this',0,1,1.5,'H2423232',1),(2118,'highlights this is','highlights this is',0,1,1.6,'H2423232',1),(2119,'his','his',0,0,0.2,'H200',1),(2120,'his is','his is',0,1,1.2,'H200',1),(2121,'his is a','his is a',0,1,1.2667,'H200',1),(2122,'house','house',0,0,0.3333,'H200',1),(2123,'house message','house message',0,1,1.4333,'H252',1),(2124,'house message goes','house message goes',0,1,1.6,'H252',1),(2125,'house message use','house message use',0,1,1.5667,'H252',1),(2126,'iaculis','iaculis',0,0,0.4667,'I242',19),(2127,'iaculis phasellus','iaculis phasellus',0,1,1.5667,'I2421242',1),(2128,'iaculis phasellus venenatis','iaculis phasellus venenatis',0,1,1.9,'I24212421532',1),(2129,'icon','icon',0,0,0.2667,'I250',1),(2130,'icon set','icon set',0,1,1.2667,'I2523',1),(2131,'icon set 1','icon set 1',0,1,1.3333,'I2523',1),(2132,'icon set 2','icon set 2',0,1,1.3333,'I2523',1),(2133,'icon set 3','icon set 3',0,1,1.3333,'I2523',1),(2134,'id','id',0,0,0.1333,'I300',28),(2135,'id fringilla','id fringilla',0,1,1.4,'I316524',1),(2136,'id fringilla enim','id fringilla enim',0,1,1.5667,'I3165245',1),(2137,'id libero','id libero',0,1,1.3,'I3416',2),(2138,'id libero aliquam','id libero aliquam',0,1,1.5667,'I3416425',1),(2139,'id nulla','id nulla',0,1,1.2667,'I354',1),(2140,'id nulla this','id nulla this',0,1,1.4333,'I35432',1),(2141,'image','image',0,0,0.3333,'I520',1),(2142,'image message','image message',0,1,1.4333,'I5252',1),(2143,'image message goes','image message goes',0,1,1.6,'I5252',1),(2144,'image message use','image message use',0,1,1.5667,'I5252',1),(2145,'images','images',0,0,0.4,'I520',1),(2146,'images message','images message',0,1,1.4667,'I5252',1),(2147,'images message goes','images message goes',0,1,1.6333,'I5252',1),(2148,'images message use','images message use',0,1,1.6,'I5252',1),(2149,'imperdiet','imperdiet',0,0,0.6,'I5163',12),(2150,'imperdiet hendrerit','imperdiet hendrerit',0,1,1.6333,'I51635363',1),(2151,'imperdiet hendrerit massa','imperdiet hendrerit massa',0,1,1.8333,'I5163536352',1),(2152,'imperdiet placerat','imperdiet placerat',0,1,1.6,'I516314263',1),(2153,'imperdiet placerat tristique','imperdiet placerat tristique',0,1,1.9333,'I5163142636232',1),(2154,'in','in',0,0,0.1333,'I500',36),(2155,'in a','in a',0,1,1.1333,'I500',6),(2156,'in a separate','in a separate',0,1,1.4333,'I52163',1),(2157,'in cooking','in cooking',0,1,1.3333,'I5252',1),(2158,'in cooking applications','in cooking applications',0,1,1.7667,'I5252142352',1),(2159,'in etiam','in etiam',0,1,1.2667,'I535',1),(2160,'in etiam volutpat','in etiam volutpat',0,1,1.5667,'I53514313',1),(2161,'in hac','in hac',0,1,1.2,'I520',1),(2162,'in hac habitasse','in hac habitasse',0,1,1.5333,'I52132',1),(2163,'in quam','in quam',0,1,1.2333,'I525',8),(2164,'in tempus','in tempus',0,1,1.3,'I53512',1),(2165,'in tempus lorem','in tempus lorem',0,1,1.5,'I53512465',1),(2166,'in volutpat','in volutpat',0,1,1.3667,'I514313',1),(2167,'in volutpat diam','in volutpat diam',0,1,1.5333,'I5143135',1),(2168,'in volutpat fusce','in volutpat fusce',0,1,1.5667,'I51431312',1),(2169,'in which','in which',0,1,1.2667,'I520',1),(2170,'in which part','in which part',0,1,1.4333,'I52163',1),(2171,'including','including',0,0,0.6,'I524352',2),(2172,'including monotremes','including monotremes',0,1,1.6667,'I52435253652',1),(2173,'including monotremes it','including monotremes it',0,1,1.7667,'I524352536523',1),(2174,'info','info',0,0,0.2667,'I510',4),(2175,'info message','info message',0,1,1.4,'I5152',1),(2176,'info message goes','info message goes',0,1,1.5667,'I5152',1),(2177,'info message use','info message use',0,1,1.5333,'I5152',1),(2178,'inforation','inforation',0,0,0.6667,'I51635',1),(2179,'inforation message','inforation message',0,1,1.6,'I516352',1),(2180,'inforation message goes','inforation message goes',0,1,1.7667,'I516352',1),(2181,'information','information',0,0,0.7333,'I516535',2),(2182,'information information','information information',0,1,1.7667,'I51653516535',1),(2183,'information information this','information information this',0,1,1.9333,'I5165351653532',1),(2184,'information message','information message',0,1,1.6333,'I5165352',1),(2185,'information message goes','information message goes',0,1,1.8,'I5165352',1),(2186,'information message use','information message use',0,1,1.7667,'I5165352',1),(2187,'information this','information this',0,1,1.5333,'I51653532',1),(2188,'information this is','information this is',0,1,1.6333,'I51653532',1),(2189,'integer','integer',0,0,0.4667,'I5326',14),(2190,'integer porta','integer porta',0,1,1.4333,'I5326163',1),(2191,'integer porta facilisis','integer porta facilisis',0,1,1.7667,'I53261631242',1),(2192,'integer semper','integer semper',0,1,1.4667,'I53262516',1),(2193,'integer semper egestas','integer semper egestas',0,1,1.7333,'I53262516232',1),(2194,'integer urna','integer urna',0,1,1.4,'I53265',1),(2195,'integer urna aenean','integer urna aenean',0,1,1.6333,'I53265',1),(2196,'interdum','interdum',0,0,0.5333,'I53635',18),(2197,'interdum elit','interdum elit',0,1,1.4333,'I5363543',1),(2198,'interdum elit sed','interdum elit sed',0,1,1.5667,'I536354323',1),(2199,'ipsum','ipsum',0,0,0.3333,'I125',27),(2200,'ipsum auctor','ipsum auctor',0,1,1.4,'I125236',1),(2201,'ipsum auctor et','ipsum auctor et',0,1,1.5,'I1252363',1),(2202,'ipsum dolor','ipsum dolor',0,1,1.3667,'I125346',20),(2203,'ipsum dolor sit','ipsum dolor sit',0,1,1.5,'I12534623',20),(2204,'ipsum et','ipsum et',0,1,1.2667,'I1253',1),(2205,'ipsum et lacus','ipsum et lacus',0,1,1.4667,'I125342',1),(2206,'is','is',0,0,0.1333,'I200',16),(2207,'is a','is a',0,1,1.1333,'I200',6),(2208,'is a calendar','is a calendar',0,1,1.4333,'I24536',1),(2209,'is a dairy','is a dairy',0,1,1.3333,'I236',1),(2210,'is a group','is a group',0,1,1.3333,'I261',1),(2211,'is a headline','is a headline',0,1,1.4333,'I2345',1),(2212,'is a highlight','is a highlight',0,1,1.4667,'I2423',1),(2213,'is a large','is a large',0,1,1.3333,'I2462',1),(2214,'is a sample','is a sample',0,1,1.3667,'I2514',2),(2215,'is a small','is a small',0,1,1.3333,'I254',1),(2216,'is a subheadline','is a subheadline',0,1,1.5333,'I21345',1),(2217,'is an','is an',0,1,1.1667,'I250',3),(2218,'is an opaque','is an opaque',0,1,1.4,'I2512',1),(2219,'is displayed','is displayed',0,1,1.4,'I232143',1),(2220,'is displayed in','is displayed in',0,1,1.5,'I2321435',1),(2221,'is generally','is generally',0,1,1.4,'I2564',1),(2222,'is generally used','is generally used',0,1,1.5667,'I256423',1),(2223,'is heading','is heading',0,1,1.3333,'I2352',1),(2224,'is heading 1','is heading 1',0,1,1.4,'I2352',1),(2225,'is heading 2','is heading 2',0,1,1.4,'I2352',1),(2226,'is heading 3','is heading 3',0,1,1.4,'I2352',1),(2227,'is heading 4','is heading 4',0,1,1.4,'I2352',1),(2228,'is just','is just',0,1,1.2333,'I230',1),(2229,'is just an','is just an',0,1,1.3333,'I235',1),(2230,'it','it',0,0,0.1333,'I300',11),(2231,'it is','it is',0,1,1.1667,'I320',6),(2232,'it is a','it is a',0,1,1.2333,'I320',1),(2233,'it is displayed','it is displayed',0,1,1.5,'I3232143',1),(2234,'it is generally','it is generally',0,1,1.5,'I32564',1),(2235,'it message','it message',0,1,1.3333,'I352',1),(2236,'it message use','it message use',0,1,1.4667,'I352',1),(2237,'it provides','it provides',0,1,1.3667,'I316132',2),(2238,'it provides the','it provides the',0,1,1.5,'I3161323',1),(2239,'just','just',0,0,0.2667,'J300',2),(2240,'just an','just an',0,1,1.2333,'J350',1),(2241,'just an example','just an example',0,1,1.5,'J352514',1),(2242,'justo','justo',0,0,0.3333,'J300',11),(2243,'justo sed','justo sed',0,1,1.3,'J323',1),(2244,'justo sed faucibus','justo sed faucibus',0,1,1.6,'J3231212',1),(2245,'justo sit','justo sit',0,1,1.3,'J323',2),(2246,'justo sit amet','justo sit amet',0,1,1.4667,'J32353',2),(2247,'justo sodales','justo sodales',0,1,1.4333,'J32342',1),(2248,'justo sodales quis','justo sodales quis',0,1,1.6,'J32342',1),(2249,'lacinia','lacinia',0,0,0.4667,'L250',15),(2250,'lacinia aenean','lacinia aenean',0,1,1.4667,'L250',1),(2251,'lacinia aenean venenatis','lacinia aenean venenatis',0,1,1.8,'L251532',1),(2252,'lacinia eros','lacinia eros',0,1,1.4,'L2562',1),(2253,'lacinia eros sed','lacinia eros sed',0,1,1.5333,'L25623',1),(2254,'lacinia in','lacinia in',0,1,1.3333,'L250',1),(2255,'lacinia in hac','lacinia in hac',0,1,1.4667,'L252',1),(2256,'lacinia nisi','lacinia nisi',0,1,1.4,'L252',1),(2257,'lacinia nisi nam','lacinia nisi nam',0,1,1.5333,'L2525',1),(2258,'lacus','lacus',0,0,0.3333,'L200',27),(2259,'lacus nam','lacus nam',0,1,1.3,'L250',1),(2260,'lacus nam fermentum','lacus nam fermentum',0,1,1.6333,'L2516535',1),(2261,'laoreet','laoreet',0,0,0.4667,'L630',13),(2262,'laoreet enim','laoreet enim',0,1,1.4,'L635',1),(2263,'laoreet enim et','laoreet enim et',0,1,1.5,'L6353',1),(2264,'laoreet ipsum','laoreet ipsum',0,1,1.4333,'L63125',1),(2265,'laoreet ipsum auctor','laoreet ipsum auctor',0,1,1.6667,'L63125236',1),(2266,'large','large',0,0,0.3333,'L620',3),(2267,'large headline','large headline',0,1,1.4667,'L62345',1),(2268,'large headline use','large headline use',0,1,1.6,'L623452',1),(2269,'larger','larger',0,0,0.4,'L626',1),(2270,'larger lorem','larger lorem',0,1,1.4,'L626465',1),(2271,'larger lorem ipsum','larger lorem ipsum',0,1,1.6,'L626465125',1),(2272,'lectus','lectus',0,0,0.4,'L232',26),(2273,'lectus eget','lectus eget',0,1,1.3667,'L2323',1),(2274,'lectus eget laoreet','lectus eget laoreet',0,1,1.6333,'L2323463',1),(2275,'lectus fusce','lectus fusce',0,1,1.4,'L23212',1),(2276,'lectus fusce eu','lectus fusce eu',0,1,1.5,'L23212',1),(2277,'lectus ornare','lectus ornare',0,1,1.4333,'L232656',1),(2278,'lectus ornare hendrerit','lectus ornare hendrerit',0,1,1.7667,'L2326565363',1),(2279,'left','left',0,0,0.2667,'L130',4),(2280,'left display','left display',0,1,1.4,'L13214',1),(2281,'left display block','left display block',0,1,1.6,'L13214142',1),(2282,'legend','legend',0,0,0.4,'L253',1),(2283,'legend note','legend note',0,1,1.3667,'L25353',1),(2284,'legend note use','legend note use',0,1,1.5,'L253532',1),(2285,'legend this','legend this',0,1,1.3667,'L2532',1),(2286,'legend this is','legend this is',0,1,1.4667,'L2532',1),(2287,'legends','legends',0,0,0.4667,'L2532',1),(2288,'legends dropcaps','legends dropcaps',0,1,1.5333,'L2532361212',1),(2289,'legends dropcaps floated','legends dropcaps floated',0,1,1.8,'L2532361212143',1),(2290,'legends legend','legends legend',0,1,1.4667,'L25324253',1),(2291,'legends legend this','legends legend this',0,1,1.6333,'L253242532',1),(2292,'leo','leo',0,0,0.2,'L000',28),(2293,'leo lorem','leo lorem',0,1,1.3,'L650',1),(2294,'leo lorem vitae','leo lorem vitae',0,1,1.5,'L6513',1),(2295,'letter','letter',0,0,0.4,'L360',1),(2296,'letter larger','letter larger',0,1,1.4333,'L364626',1),(2297,'letter larger lorem','letter larger lorem',0,1,1.6333,'L364626465',1),(2298,'libero','libero',0,0,0.4,'L160',27),(2299,'libero aliquam','libero aliquam',0,1,1.4667,'L16425',10),(2300,'libero aliquam ullamcorper','libero aliquam ullamcorper',0,1,1.8667,'L16425452616',1),(2301,'libero mauris','libero mauris',0,1,1.4333,'L16562',1),(2302,'libero mauris lacinia','libero mauris lacinia',0,1,1.7,'L16562425',1),(2303,'libero morbi','libero morbi',0,1,1.4,'L16561',1),(2304,'libero morbi aliquam','libero morbi aliquam',0,1,1.6667,'L16561425',1),(2305,'ligula','ligula',0,0,0.4,'L240',25),(2306,'ligula feugiat','ligula feugiat',0,1,1.4667,'L24123',1),(2307,'ligula feugiat ac','ligula feugiat ac',0,1,1.5667,'L241232',1),(2308,'like','like',0,0,0.2667,'L200',3),(2309,'like it','like it',0,1,1.2333,'L230',1),(2310,'like it message','like it message',0,1,1.5,'L2352',1),(2311,'line','line',0,0,0.2667,'L500',1),(2312,'line message','line message',0,1,1.4,'L520',1),(2313,'line message goes','line message goes',0,1,1.5667,'L520',1),(2314,'line message use','line message use',0,1,1.5333,'L520',1),(2315,'liquid','liquid',0,0,0.4,'L230',1),(2316,'liquid produced','liquid produced',0,1,1.5,'L2316323',1),(2317,'liquid produced by','liquid produced by',0,1,1.6,'L23163231',1),(2318,'list','list',0,0,0.2667,'L230',2),(2319,'list ol','list ol',0,1,1.2333,'L234',1),(2320,'list ol class','list ol class',0,1,1.4333,'L234242',1),(2321,'lists','lists',0,0,0.3333,'L232',1),(2322,'lists abbrs','lists abbrs',0,1,1.3667,'L232162',1),(2323,'lists abbrs and','lists abbrs and',0,1,1.5,'L23216253',1),(2324,'lists below','lists below',0,1,1.3667,'L23214',1),(2325,'lists below are','lists below are',0,1,1.5,'L232146',1),(2326,'lists dl','lists dl',0,1,1.2667,'L23234',1),(2327,'lists dl class','lists dl class',0,1,1.4667,'L23234242',1),(2328,'lists legends','lists legends',0,1,1.4333,'L23242532',1),(2329,'lists legends dropcaps','lists legends dropcaps',0,1,1.7333,'L23242532361212',1),(2330,'lists ordered','lists ordered',0,1,1.4333,'L2326363',1),(2331,'lists ordered lists','lists ordered lists',0,1,1.6333,'L23263634232',1),(2332,'lists types','lists types',0,1,1.3667,'L232312',1),(2333,'lists types of','lists types of',0,1,1.4667,'L2323121',1),(2334,'lists ul','lists ul',0,1,1.2667,'L2324',1),(2335,'lists ul class','lists ul class',0,1,1.4667,'L2324242',1),(2336,'lobortis','lobortis',0,0,0.5333,'L1632',21),(2337,'lobortis dapibus','lobortis dapibus',0,1,1.5333,'L1632312',1),(2338,'lobortis dapibus risus','lobortis dapibus risus',0,1,1.7333,'L163231262',1),(2339,'lobortis sed','lobortis sed',0,1,1.4,'L16323',9),(2340,'lobortis sed lobortis','lobortis sed lobortis',0,1,1.7,'L1632341632',1),(2341,'lobortis vel','lobortis vel',0,1,1.4,'L163214',2),(2342,'lobortis vel mauris','lobortis vel mauris',0,1,1.6333,'L163214562',1),(2343,'lock','lock',0,0,0.2667,'L200',1),(2344,'lock message','lock message',0,1,1.4,'L252',1),(2345,'lock message goes','lock message goes',0,1,1.5667,'L252',1),(2346,'lock message use','lock message use',0,1,1.5333,'L252',1),(2347,'lorem','lorem',0,0,0.3333,'L650',27),(2348,'lorem ipsum','lorem ipsum',0,1,1.3667,'L65125',21),(2349,'lorem ipsum dolor','lorem ipsum dolor',0,1,1.5667,'L65125346',20),(2350,'lorem mattis','lorem mattis',0,1,1.4,'L6532',1),(2351,'lorem mattis molestie','lorem mattis molestie',0,1,1.7,'L65325423',1),(2352,'lorem praesent','lorem praesent',0,1,1.4667,'L6516253',1),(2353,'lorem praesent aliquet','lorem praesent aliquet',0,1,1.7333,'L6516253423',1),(2354,'lorem vitae','lorem vitae',0,1,1.3667,'L6513',1),(2355,'lorem vitae purus','lorem vitae purus',0,1,1.5667,'L6513162',1),(2356,'luctus','luctus',0,0,0.4,'L232',25),(2357,'luctus augue','luctus augue',0,1,1.4,'L232',1),(2358,'luctus augue id','luctus augue id',0,1,1.5,'L2323',1),(2359,'luctus this','luctus this',0,1,1.3667,'L23232',1),(2360,'luctus this is','luctus this is',0,1,1.4667,'L23232',1),(2361,'luctus velit','luctus velit',0,1,1.4,'L232143',1),(2362,'luctus velit quis','luctus velit quis',0,1,1.5667,'L2321432',1),(2363,'made','made',0,0,0.2667,'M300',1),(2364,'made by','made by',0,1,1.2333,'M310',1),(2365,'made by churning','made by churning',0,1,1.5333,'M312652',1),(2366,'magna','magna',0,0,0.3333,'M250',27),(2367,'magna convallis','magna convallis',0,1,1.5,'M2525142',1),(2368,'magna convallis lacinia','magna convallis lacinia',0,1,1.7667,'M2525142425',1),(2369,'magnifier','magnifier',0,0,0.6,'M2516',1),(2370,'magnifier message','magnifier message',0,1,1.5667,'M251652',1),(2371,'magnifier message goes','magnifier message goes',0,1,1.7333,'M251652',1),(2372,'magnifier message use','magnifier message use',0,1,1.7,'M251652',1),(2373,'magnis','magnis',0,0,0.4,'M252',6),(2374,'magnis dis','magnis dis',0,1,1.3333,'M25232',6),(2375,'magnis dis parturient','magnis dis parturient',0,1,1.7,'M25232163653',6),(2376,'main','main',0,0,0.2667,'M000',1),(2377,'main part','main part',0,1,1.3,'M163',1),(2378,'main part of','main part of',0,1,1.4,'M1631',1),(2379,'make','make',0,0,0.2667,'M200',6),(2380,'make the','make the',0,1,1.2667,'M230',2),(2381,'make the first','make the first',0,1,1.4667,'M231623',1),(2382,'making','making',0,0,0.4,'M252',4),(2383,'making and','making and',0,1,1.3333,'M25253',1),(2384,'making and frying','making and frying',0,1,1.5667,'M252531652',1),(2385,'malesuada','malesuada',0,0,0.6,'M423',26),(2386,'malesuada felis','malesuada felis',0,1,1.5,'M423142',1),(2387,'malesuada felis cras','malesuada felis cras',0,1,1.6667,'M42314262',1),(2388,'malesuada neque','malesuada neque',0,1,1.5,'M42352',1),(2389,'malesuada neque icon','malesuada neque icon',0,1,1.6667,'M423525',1),(2390,'malesuada neque this','malesuada neque this',0,1,1.6667,'M4235232',1),(2391,'mammals','mammals',0,0,0.4667,'M420',1),(2392,'mammals before','mammals before',0,1,1.4667,'M4216',1),(2393,'mammals before they','mammals before they',0,1,1.6333,'M42163',1),(2394,'mammals including','mammals including',0,1,1.5667,'M42524352',1),(2395,'mammals including monotremes','mammals including monotremes',0,1,1.9333,'M4252435253652',1),(2396,'mammary','mammary',0,0,0.4667,'M600',1),(2397,'mammary glands','mammary glands',0,1,1.4667,'M624532',1),(2398,'mammary glands of','mammary glands of',0,1,1.5667,'M6245321',1),(2399,'massa','massa',0,0,0.3333,'M200',23),(2400,'massa adipiscing','massa adipiscing',0,1,1.5333,'M231252',1),(2401,'massa adipiscing justo','massa adipiscing justo',0,1,1.7333,'M2312523',1),(2402,'massa eu','massa eu',0,1,1.2667,'M200',1),(2403,'massa eu facilisis','massa eu facilisis',0,1,1.6,'M21242',1),(2404,'massa imperdiet','massa imperdiet',0,1,1.5,'M25163',1),(2405,'massa imperdiet placerat','massa imperdiet placerat',0,1,1.8,'M2516314263',1),(2406,'massa sed','massa sed',0,1,1.3,'M230',1),(2407,'massa sed eleifend','massa sed eleifend',0,1,1.6,'M234153',1),(2408,'mattis','mattis',0,0,0.4,'M320',23),(2409,'mattis eu','mattis eu',0,1,1.3,'M320',1),(2410,'mattis eu id','mattis eu id',0,1,1.4,'M323',1),(2411,'mattis feugiat','mattis feugiat',0,1,1.4667,'M32123',1),(2412,'mattis feugiat dapibus','mattis feugiat dapibus',0,1,1.7333,'M3212312',1),(2413,'mattis molestie','mattis molestie',0,1,1.5,'M325423',1),(2414,'mattis molestie suspendisse','mattis molestie suspendisse',0,1,1.9,'M32542321532',1),(2415,'mauris','mauris',0,0,0.4,'M620',23),(2416,'mauris in','mauris in',0,1,1.3,'M625',1),(2417,'mauris in volutpat','mauris in volutpat',0,1,1.6,'M62514313',1),(2418,'mauris lacinia','mauris lacinia',0,1,1.4667,'M62425',1),(2419,'mauris lacinia eros','mauris lacinia eros',0,1,1.6333,'M6242562',1),(2420,'mauris sed','mauris sed',0,1,1.3333,'M623',1),(2421,'mauris sed a','mauris sed a',0,1,1.4,'M623',1),(2422,'mauris sed vehicula','mauris sed vehicula',0,1,1.6333,'M623124',1),(2423,'mauris volutpat','mauris volutpat',0,1,1.5,'M6214313',1),(2424,'mauris volutpat consectetur','mauris volutpat consectetur',0,1,1.9,'M621431325236',1),(2425,'message','message',0,0,0.4667,'M200',2),(2426,'message goes','message goes',0,1,1.4,'M200',1),(2427,'message goes here','message goes here',0,1,1.5667,'M260',1),(2428,'message use','message use',0,1,1.3667,'M200',1),(2429,'message use p','message use p',0,1,1.4333,'M210',1),(2430,'milk','milk',0,0,0.2667,'M420',1),(2431,'milk is','milk is',0,1,1.2333,'M420',1),(2432,'milk is an','milk is an',0,1,1.3333,'M425',1),(2433,'milk it','milk it',0,1,1.2333,'M423',1),(2434,'milk it is','milk it is',0,1,1.3333,'M4232',1),(2435,'milk proteins','milk proteins',0,1,1.4333,'M4216352',1),(2436,'milk proteins dairy','milk proteins dairy',0,1,1.6333,'M421635236',1),(2437,'molestie','molestie',0,0,0.5333,'M423',20),(2438,'molestie suspendisse','molestie suspendisse',0,1,1.6667,'M42321532',1),(2439,'molestie suspendisse potenti','molestie suspendisse potenti',0,1,1.9333,'M423215321353',1),(2440,'mollis','mollis',0,0,0.4,'M420',14),(2441,'mollis augue','mollis augue',0,1,1.4,'M420',1),(2442,'mollis augue non','mollis augue non',0,1,1.5333,'M425',1),(2443,'mollis nunc','mollis nunc',0,1,1.3667,'M4252',1),(2444,'mollis nunc quisque','mollis nunc quisque',0,1,1.6333,'M4252',1),(2445,'mollis pretium','mollis pretium',0,1,1.4667,'M421635',1),(2446,'mollis pretium imperdiet','mollis pretium imperdiet',0,1,1.8,'M421635163',1),(2447,'money','money',0,0,0.3333,'M000',1),(2448,'money goes','money goes',0,1,1.3333,'M200',1),(2449,'money goes here','money goes here',0,1,1.5,'M260',1),(2450,'money message','money message',0,1,1.4333,'M200',1),(2451,'money message goes','money message goes',0,1,1.6,'M200',1),(2452,'money message use','money message use',0,1,1.5667,'M200',1),(2453,'monotremes','monotremes',0,0,0.6667,'M3652',1),(2454,'monotremes it','monotremes it',0,1,1.4333,'M36523',1),(2455,'monotremes it provides','monotremes it provides',0,1,1.7333,'M3652316132',1),(2456,'montes','montes',0,0,0.4,'M320',6),(2457,'montes nascetur','montes nascetur',0,1,1.5,'M325236',6),(2458,'montes nascetur ridiculus','montes nascetur ridiculus',0,1,1.8333,'M3252363242',6),(2459,'morbi','morbi',0,0,0.3333,'M610',15),(2460,'morbi aliquam','morbi aliquam',0,1,1.4333,'M61425',1),(2461,'morbi aliquam nibh','morbi aliquam nibh',0,1,1.6,'M614251',1),(2462,'morbi cursus','morbi cursus',0,1,1.4,'M61262',1),(2463,'morbi cursus est','morbi cursus est',0,1,1.5333,'M612623',1),(2464,'morbi quis','morbi quis',0,1,1.3333,'M612',1),(2465,'morbi quis enim','morbi quis enim',0,1,1.5,'M6125',1),(2466,'movie','movie',0,0,0.3333,'M100',1),(2467,'movie message','movie message',0,1,1.4333,'M152',1),(2468,'movie message goes','movie message goes',0,1,1.6,'M152',1),(2469,'movie message use','movie message use',0,1,1.5667,'M152',1),(2470,'mus','mus',0,0,0.2,'M200',6),(2471,'mus p','mus p',0,1,1.1667,'M210',1),(2472,'mus p div','mus p div',0,1,1.3,'M2131',1),(2473,'mus span','mus span',0,1,1.2667,'M215',1),(2474,'mus span blockquotes','mus span blockquotes',0,1,1.6667,'M21514232',1),(2475,'mus span this','mus span this',0,1,1.4333,'M21532',1),(2476,'nam','nam',0,0,0.2,'N000',21),(2477,'nam ac','nam ac',0,1,1.2,'N200',1),(2478,'nam ac sem','nam ac sem',0,1,1.3333,'N250',1),(2479,'nam fermentum','nam fermentum',0,1,1.4333,'N16535',1),(2480,'nam fermentum eros','nam fermentum eros',0,1,1.6,'N1653562',1),(2481,'nam quis','nam quis',0,1,1.2667,'N200',4),(2482,'nam quis turpis','nam quis turpis',0,1,1.5,'N23612',1),(2483,'name','name',0,0,0.2667,'N000',5),(2484,'name of','name of',0,1,1.2333,'N100',1),(2485,'name of your','name of your',0,1,1.4,'N160',1),(2486,'nascetur','nascetur',0,0,0.5333,'N236',6),(2487,'nascetur ridiculus','nascetur ridiculus',0,1,1.6,'N2363242',6),(2488,'nascetur ridiculus mus','nascetur ridiculus mus',0,1,1.7333,'N236324252',6),(2489,'nato','nato',0,0,0.2667,'N300',1),(2490,'nato use','nato use',0,1,1.2667,'N320',1),(2491,'nato use acronym','nato use acronym',0,1,1.5333,'N3265',1),(2492,'natoque','natoque',0,0,0.4667,'N320',6),(2493,'natoque penatibus','natoque penatibus',0,1,1.5667,'N3215312',6),(2494,'natoque penatibus et','natoque penatibus et',0,1,1.6667,'N32153123',6),(2495,'nec','nec',0,0,0.2,'N200',27),(2496,'nec euismod','nec euismod',0,1,1.3667,'N253',1),(2497,'nec euismod lacinia','nec euismod lacinia',0,1,1.6333,'N253425',1),(2498,'nec vel','nec vel',0,1,1.2333,'N214',1),(2499,'nec vel eros','nec vel eros',0,1,1.4,'N21462',1),(2500,'neque','neque',0,0,0.3333,'N200',26),(2501,'neque cum','neque cum',0,1,1.3,'N250',1),(2502,'neque cum sociis','neque cum sociis',0,1,1.5333,'N252',1),(2503,'neque icon','neque icon',0,1,1.3333,'N250',1),(2504,'neque icon set','neque icon set',0,1,1.4667,'N2523',1),(2505,'neque nunc','neque nunc',0,1,1.3333,'N252',1),(2506,'neque nunc enim','neque nunc enim',0,1,1.5,'N2525',1),(2507,'neque this','neque this',0,1,1.3333,'N232',1),(2508,'neque this is','neque this is',0,1,1.4333,'N232',1),(2509,'new','new',0,0,0.2,'N000',2),(2510,'new message','new message',0,1,1.3667,'N200',1),(2511,'new message goes','new message goes',0,1,1.5333,'N200',1),(2512,'new message use','new message use',0,1,1.5,'N200',1),(2513,'newborn','newborn',0,0,0.4667,'N165',1),(2514,'newborn mammals','newborn mammals',0,1,1.5,'N16542',1),(2515,'newborn mammals before','newborn mammals before',0,1,1.7333,'N1654216',1),(2516,'nibh','nibh',0,0,0.2667,'N100',25),(2517,'nibh luctus','nibh luctus',0,1,1.3667,'N14232',1),(2518,'nibh luctus this','nibh luctus this',0,1,1.5333,'N1423232',1),(2519,'nibh mattis','nibh mattis',0,1,1.3667,'N1532',1),(2520,'nibh mattis feugiat','nibh mattis feugiat',0,1,1.6333,'N1532123',1),(2521,'nibh posuere','nibh posuere',0,1,1.4,'N126',1),(2522,'nibh posuere mauris','nibh posuere mauris',0,1,1.6333,'N126562',1),(2523,'nisi','nisi',0,0,0.2667,'N200',18),(2524,'nisi elementum','nisi elementum',0,1,1.4667,'N24535',1),(2525,'nisi elementum non','nisi elementum non',0,1,1.6,'N24535',1),(2526,'nisi massa','nisi massa',0,1,1.3333,'N252',1),(2527,'nisi massa adipiscing','nisi massa adipiscing',0,1,1.7,'N25231252',1),(2528,'nisi nam','nisi nam',0,1,1.2667,'N250',1),(2529,'nisi nam ac','nisi nam ac',0,1,1.3667,'N252',1),(2530,'non','non',0,0,0.2,'N000',15),(2531,'non blandit','non blandit',0,1,1.3667,'N1453',1),(2532,'non blandit urna','non blandit urna',0,1,1.5333,'N145365',1),(2533,'non dolor','non dolor',0,1,1.3,'N346',1),(2534,'non dolor convallis','non dolor convallis',0,1,1.6333,'N34625142',1),(2535,'non posuere','non posuere',0,1,1.3667,'N126',4),(2536,'non posuere odio','non posuere odio',0,1,1.5333,'N1263',1),(2537,'note','note',0,0,0.2667,'N300',1),(2538,'note message','note message',0,1,1.4,'N352',1),(2539,'note message goes','note message goes',0,1,1.5667,'N352',1),(2540,'note message use','note message use',0,1,1.5333,'N352',1),(2541,'note use','note use',0,1,1.2667,'N320',1),(2542,'note use div','note use div',0,1,1.4,'N3231',1),(2543,'note use span','note use span',0,1,1.4333,'N3215',1),(2544,'nulla','nulla',0,0,0.3333,'N400',15),(2545,'nulla this','nulla this',0,1,1.3333,'N432',1),(2546,'nulla this is','nulla this is',0,1,1.4333,'N432',1),(2547,'nulla vel','nulla vel',0,1,1.3,'N414',1),(2548,'nulla vel congue','nulla vel congue',0,1,1.5333,'N414252',1),(2549,'nullam','nullam',0,0,0.4,'N450',16),(2550,'nullam blandit','nullam blandit',0,1,1.4667,'N451453',1),(2551,'nullam blandit elit','nullam blandit elit',0,1,1.6333,'N45145343',1),(2552,'number','number',0,0,0.4,'N160',2),(2553,'number span','number span',0,1,1.3667,'N16215',1),(2554,'number span and','number span and',0,1,1.5,'N162153',1),(2555,'nunc','nunc',0,0,0.2667,'N200',22),(2556,'nunc a','nunc a',0,1,1.2,'N200',1),(2557,'nunc a malesuada','nunc a malesuada',0,1,1.5333,'N25423',1),(2558,'nunc enim','nunc enim',0,1,1.3,'N250',1),(2559,'nunc enim urna','nunc enim urna',0,1,1.4667,'N2565',1),(2560,'nunc in','nunc in',0,1,1.2333,'N250',1),(2561,'nunc in volutpat','nunc in volutpat',0,1,1.5333,'N2514313',1),(2562,'nunc quisque','nunc quisque',0,1,1.4,'N200',1),(2563,'nunc quisque semper','nunc quisque semper',0,1,1.6333,'N2516',1),(2564,'nutrition','nutrition',0,0,0.6,'N3635',1),(2565,'nutrition for','nutrition for',0,1,1.4333,'N363516',1),(2566,'nutrition for newborn','nutrition for newborn',0,1,1.7,'N3635165165',1),(2567,'odd','odd',0,0,0.2,'O300',1),(2568,'odd cell','odd cell',0,1,1.2667,'O324',1),(2569,'odd cell 1','odd cell 1',0,1,1.3333,'O324',1),(2570,'odio','odio',0,0,0.2667,'O300',19),(2571,'odio placerat','odio placerat',0,1,1.4333,'O314263',1),(2572,'odio placerat in','odio placerat in',0,1,1.5333,'O3142635',1),(2573,'of','of',0,0,0.1333,'O100',19),(2574,'of a','of a',0,1,1.1333,'O100',7),(2575,'of a classic','of a classic',0,1,1.4,'O1242',1),(2576,'of an','of an',0,1,1.1667,'O150',2),(2577,'of an abbreviation','of an abbreviation',0,1,1.6,'O1516135',1),(2578,'of an acronym','of an acronym',0,1,1.4333,'O15265',1),(2579,'of butterfat','of butterfat',0,1,1.4,'O13613',1),(2580,'of butterfat water','of butterfat water',0,1,1.6,'O136136',1),(2581,'of definition','of definition',0,1,1.4333,'O131535',1),(2582,'of definition lists','of definition lists',0,1,1.6333,'O1315354232',1),(2583,'of div','of div',0,1,1.2,'O131',1),(2584,'of div class','of div class',0,1,1.4,'O131242',1),(2585,'of element','of element',0,1,1.3333,'O1453',1),(2586,'of element p','of element p',0,1,1.4,'O14531',1),(2587,'of food','of food',0,1,1.2333,'O130',1),(2588,'of food dl','of food dl',0,1,1.3333,'O134',1),(2589,'of food legends','of food legends',0,1,1.5,'O1342532',1),(2590,'of it','of it',0,1,1.1667,'O130',1),(2591,'of it is','of it is',0,1,1.2667,'O132',1),(2592,'of mammals','of mammals',0,1,1.3333,'O1542',1),(2593,'of mammals including','of mammals including',0,1,1.6667,'O1542524352',1),(2594,'of nutrition','of nutrition',0,1,1.4,'O153635',1),(2595,'of nutrition for','of nutrition for',0,1,1.5333,'O15363516',1),(2596,'of ordered','of ordered',0,1,1.3333,'O16363',1),(2597,'of ordered list','of ordered list',0,1,1.5,'O16363423',1),(2598,'of pre','of pre',0,1,1.2,'O160',1),(2599,'of pre or','of pre or',0,1,1.3,'O160',1),(2600,'of tbody','of tbody',0,1,1.2667,'O1313',1),(2601,'of tbody cell','of tbody cell',0,1,1.4333,'O131324',1),(2602,'of tbody table','of tbody table',0,1,1.4667,'O131314',1),(2603,'of text','of text',0,1,1.2333,'O1323',1),(2604,'of text in','of text in',0,1,1.3333,'O13235',1),(2605,'of text span','of text span',0,1,1.4,'O1323215',1),(2606,'of the','of the',0,1,1.2,'O130',9),(2607,'of the text','of the text',0,1,1.3667,'O1323',1),(2608,'of unordered','of unordered',0,1,1.4,'O156363',1),(2609,'of unordered lists','of unordered lists',0,1,1.6,'O1563634232',1),(2610,'of what','of what',0,1,1.2333,'O130',1),(2611,'of what you','of what you',0,1,1.3667,'O130',1),(2612,'of your','of your',0,1,1.2333,'O160',2),(2613,'of your file','of your file',0,1,1.4,'O1614',1),(2614,'ol','ol',0,0,0.1333,'O400',1),(2615,'ol class','ol class',0,1,1.2667,'O4242',1),(2616,'ol class gkalpha','ol class gkalpha',0,1,1.5333,'O424241',1),(2617,'ol class gkdec','ol class gkdec',0,1,1.4667,'O424232',1),(2618,'ol class gkdecimalleadingzero','ol class gkdecimalleadingzero',0,1,1.9667,'O424232543526',1),(2619,'ol class gkroman','ol class gkroman',0,1,1.5333,'O424265',1),(2620,'opaque','opaque',0,0,0.4,'O120',1),(2621,'opaque white','opaque white',0,1,1.4,'O123',1),(2622,'opaque white liquid','opaque white liquid',0,1,1.6333,'O123423',1),(2623,'or','or',0,0,0.1333,'O600',4),(2624,'or div','or div',0,1,1.2,'O631',1),(2625,'or div class','or div class',0,1,1.4,'O631242',1),(2626,'or fermented','or fermented',0,1,1.4,'O61653',1),(2627,'or fermented cream','or fermented cream',0,1,1.6,'O61653265',1),(2628,'or milk','or milk',0,1,1.2333,'O6542',1),(2629,'or milk it','or milk it',0,1,1.3333,'O65423',1),(2630,'or phrase','or phrase',0,1,1.3,'O6162',1),(2631,'or phrase here','or phrase here',0,1,1.4667,'O61626',1),(2632,'ordered','ordered',0,0,0.4667,'O6363',1),(2633,'ordered list','ordered list',0,1,1.4,'O6363423',1),(2634,'ordered list ol','ordered list ol',0,1,1.5,'O63634234',1),(2635,'ordered lists','ordered lists',0,1,1.4333,'O63634232',1),(2636,'ordered lists abbrs','ordered lists abbrs',0,1,1.6333,'O63634232162',1),(2637,'ordered lists types','ordered lists types',0,1,1.6333,'O63634232312',1),(2638,'ornare','ornare',0,0,0.4,'O656',14),(2639,'ornare hendrerit','ornare hendrerit',0,1,1.5333,'O6565363',1),(2640,'ornare hendrerit aliquam','ornare hendrerit aliquam',0,1,1.8,'O6565363425',1),(2641,'ornare magna','ornare magna',0,1,1.4,'O656525',4),(2642,'ornare magna convallis','ornare magna convallis',0,1,1.7333,'O65652525142',1),(2643,'other','other',0,0,0.3333,'O360',5),(2644,'other span','other span',0,1,1.3333,'O36215',1),(2645,'other span blocks','other span blocks',0,1,1.5667,'O36215142',1),(2646,'other types','other types',0,1,1.3667,'O36312',1),(2647,'other types of','other types of',0,1,1.4667,'O363121',1),(2648,'own','own',0,0,0.2,'O500',3),(2649,'own and','own and',0,1,1.2333,'O530',1),(2650,'own and warning','own and warning',0,1,1.5,'O53652',1),(2651,'own critical','own critical',0,1,1.4,'O526324',1),(2652,'own critical critical','own critical critical',0,1,1.7,'O52632426324',1),(2653,'own css','own css',0,1,1.2333,'O520',1),(2654,'own css powered','own css powered',0,1,1.5,'O52163',1),(2655,'own help','own help',0,1,1.2667,'O541',1),(2656,'own help help','own help help',0,1,1.4333,'O54141',1),(2657,'own highlights','own highlights',0,1,1.4667,'O524232',1),(2658,'own highlights this','own highlights this',0,1,1.6333,'O52423232',1),(2659,'own information','own information',0,1,1.5,'O516535',1),(2660,'own information information','own information information',0,1,1.9,'O51653516535',1),(2661,'p','p',0,0,0.0667,'P000',1),(2662,'p 01','p 01',0,1,1.1333,'P000',1),(2663,'p 01 element','p 01 element',0,1,1.4,'P453',1),(2664,'p class','p class',0,1,1.2333,'P242',1),(2665,'p class gkaccept','p class gkaccept',0,1,1.5333,'P24213',1),(2666,'p class gkadd','p class gkadd',0,1,1.4333,'P2423',1),(2667,'p class gkaudio','p class gkaudio',0,1,1.5,'P2423',1),(2668,'p class gkaudiois2','p class gkaudiois2',0,1,1.6,'P24232',1),(2669,'p class gkaudiois3','p class gkaudiois3',0,1,1.6,'P24232',1),(2670,'p class gkbox','p class gkbox',0,1,1.4333,'P24212',1),(2671,'p class gkbrick','p class gkbrick',0,1,1.5,'P242162',1),(2672,'p class gkcalendar','p class gkcalendar',0,1,1.6,'P2424536',1),(2673,'p class gkcalendaris2','p class gkcalendaris2',0,1,1.7,'P24245362',1),(2674,'p class gkcamera','p class gkcamera',0,1,1.5333,'P24256',1),(2675,'p class gkcamerais2','p class gkcamerais2',0,1,1.6333,'P242562',1),(2676,'p class gkcamerais3','p class gkcamerais3',0,1,1.6333,'P242562',1),(2677,'p class gkcart','p class gkcart',0,1,1.4667,'P24263',1),(2678,'p class gkcartis2','p class gkcartis2',0,1,1.5667,'P242632',1),(2679,'p class gkcartis3','p class gkcartis3',0,1,1.5667,'P242632',1),(2680,'p class gkcd','p class gkcd',0,1,1.4,'P2423',1),(2681,'p class gkcdis2','p class gkcdis2',0,1,1.5,'P24232',1),(2682,'p class gkchartbar','p class gkchartbar',0,1,1.6,'P2426316',1),(2683,'p class gkchartbaris3','p class gkchartbaris3',0,1,1.7,'P24263162',1),(2684,'p class gkchartline','p class gkchartline',0,1,1.6333,'P2426345',1),(2685,'p class gkchartlineis2','p class gkchartlineis2',0,1,1.7333,'P24263452',1),(2686,'p class gkchartpie','p class gkchartpie',0,1,1.6,'P242631',1),(2687,'p class gkchartpieis2','p class gkchartpieis2',0,1,1.7,'P2426312',1),(2688,'p class gkclock','p class gkclock',0,1,1.5,'P24242',1),(2689,'p class gkclockis2','p class gkclockis2',0,1,1.6,'P24242',1),(2690,'p class gkcoffeis3','p class gkcoffeis3',0,1,1.6,'P24212',1),(2691,'p class gkcog','p class gkcog',0,1,1.4333,'P242',1),(2692,'p class gkcogis2','p class gkcogis2',0,1,1.5333,'P242',1),(2693,'p class gkcoins','p class gkcoins',0,1,1.5,'P24252',1),(2694,'p class gkcompress','p class gkcompress',0,1,1.6,'P2425162',1),(2695,'p class gkcomputer','p class gkcomputer',0,1,1.6,'P2425136',1),(2696,'p class gkcomputeris2','p class gkcomputeris2',0,1,1.7,'P24251362',1),(2697,'p class gkcomputeris3','p class gkcomputeris3',0,1,1.7,'P24251362',1),(2698,'p class gkconfig2is3','p class gkconfig2is3',0,1,1.6667,'P242512',1),(2699,'p class gkconfigis3','p class gkconfigis3',0,1,1.6333,'P242512',1),(2700,'p class gkcontactis2','p class gkcontactis2',0,1,1.6667,'P24253232',1),(2701,'p class gkcreditcard','p class gkcreditcard',0,1,1.6667,'P24263263',1),(2702,'p class gkcross','p class gkcross',0,1,1.5,'P24262',1),(2703,'p class gkcrossis3','p class gkcrossis3',0,1,1.6,'P24262',1),(2704,'p class gkdisk','p class gkdisk',0,1,1.4667,'P24232',1),(2705,'p class gkdropcap3','p class gkdropcap3',0,1,1.6,'P24236121',1),(2706,'p class gkemail','p class gkemail',0,1,1.5,'P24254',1),(2707,'p class gkemailis2','p class gkemailis2',0,1,1.6,'P242542',1),(2708,'p class gkerror','p class gkerror',0,1,1.5,'P2426',1),(2709,'p class gkerroris2','p class gkerroris2',0,1,1.6,'P24262',1),(2710,'p class gkerroris3','p class gkerroris3',0,1,1.6,'P24262',1),(2711,'p class gkexclamation','p class gkexclamation',0,1,1.7,'P2424535',1),(2712,'p class gkexclamationis2','p class gkexclamationis2',0,1,1.8,'P24245352',1),(2713,'p class gkfacebookis2','p class gkfacebookis2',0,1,1.7,'P2421212',1),(2714,'p class gkfeed','p class gkfeed',0,1,1.4667,'P24213',1),(2715,'p class gkfeedis2','p class gkfeedis2',0,1,1.5667,'P242132',1),(2716,'p class gkfilm','p class gkfilm',0,1,1.4667,'P242145',1),(2717,'p class gkfilmis2','p class gkfilmis2',0,1,1.5667,'P2421452',1),(2718,'p class gkfolder','p class gkfolder',0,1,1.5333,'P2421436',1),(2719,'p class gkfolderis2','p class gkfolderis2',0,1,1.6333,'P24214362',1),(2720,'p class gkgroup','p class gkgroup',0,1,1.5,'P24261',1),(2721,'p class gkgroupis2','p class gkgroupis2',0,1,1.6,'P242612',1),(2722,'p class gkheadling','p class gkheadling',0,1,1.6,'P2423452',1),(2723,'p class gkheart','p class gkheart',0,1,1.5,'P24263',1),(2724,'p class gkhelp','p class gkhelp',0,1,1.4667,'P24241',1),(2725,'p class gkhouse','p class gkhouse',0,1,1.5,'P242',1),(2726,'p class gkhouseis2','p class gkhouseis2',0,1,1.6,'P242',1),(2727,'p class gkhouseis3','p class gkhouseis3',0,1,1.6,'P242',1),(2728,'p class gkimage','p class gkimage',0,1,1.5,'P24252',1),(2729,'p class gkimageis2','p class gkimageis2',0,1,1.6,'P24252',1),(2730,'p class gkimages','p class gkimages',0,1,1.5333,'P24252',1),(2731,'p class gkimagesis2','p class gkimagesis2',0,1,1.6333,'P24252',1),(2732,'p class gkinfo1','p class gkinfo1',0,1,1.5,'P24251',1),(2733,'p class gkinfo2','p class gkinfo2',0,1,1.5,'P24251',1),(2734,'p class gkinfo3','p class gkinfo3',0,1,1.5,'P24251',1),(2735,'p class gkinfo4','p class gkinfo4',0,1,1.5,'P24251',1),(2736,'p class gkinfo5','p class gkinfo5',0,1,1.5,'P24251',1),(2737,'p class gkinformation','p class gkinformation',0,1,1.7,'P242516535',1),(2738,'p class gkinformationis3','p class gkinformationis3',0,1,1.8,'P2425165352',1),(2739,'p class gkinfromationis2','p class gkinfromationis2',0,1,1.8,'P2425165352',1),(2740,'p class gklikeitis2','p class gklikeitis2',0,1,1.6333,'P2424232',1),(2741,'p class gklock','p class gklock',0,1,1.4667,'P24242',1),(2742,'p class gklockis2','p class gklockis2',0,1,1.5667,'P24242',1),(2743,'p class gklockis3','p class gklockis3',0,1,1.5667,'P24242',1),(2744,'p class gkmagnifier','p class gkmagnifier',0,1,1.6333,'P24252516',1),(2745,'p class gkmagnifieris2','p class gkmagnifieris2',0,1,1.7333,'P242525162',1),(2746,'p class gkmagnifieris3','p class gkmagnifieris3',0,1,1.7333,'P242525162',1),(2747,'p class gkmoney','p class gkmoney',0,1,1.5,'P2425',1),(2748,'p class gkmoneyis2','p class gkmoneyis2',0,1,1.6,'P24252',1),(2749,'p class gknew','p class gknew',0,1,1.4333,'P2425',1),(2750,'p class gknote','p class gknote',0,1,1.4667,'P24253',1),(2751,'p class gkpage','p class gkpage',0,1,1.4667,'P24212',1),(2752,'p class gkpageis2','p class gkpageis2',0,1,1.5667,'P24212',1),(2753,'p class gkpageis3','p class gkpageis3',0,1,1.5667,'P24212',1),(2754,'p class gkplugin','p class gkplugin',0,1,1.5333,'P2421425',1),(2755,'p class gkprinter','p class gkprinter',0,1,1.5667,'P24216536',1),(2756,'p class gkprinteris2','p class gkprinteris2',0,1,1.6667,'P242165362',1),(2757,'p class gkreport','p class gkreport',0,1,1.5333,'P2426163',1),(2758,'p class gkscript','p class gkscript',0,1,1.5333,'P242613',1),(2759,'p class gkstaris3','p class gkstaris3',0,1,1.5667,'P242362',1),(2760,'p class gksubheadline','p class gksubheadline',0,1,1.7,'P2421345',1),(2761,'p class gktelephoneis3','p class gktelephoneis3',0,1,1.7333,'P24234152',1),(2762,'p class gktime','p class gktime',0,1,1.4667,'P24235',1),(2763,'p class gktimeis2','p class gktimeis2',0,1,1.5667,'P242352',1),(2764,'p class gktips1','p class gktips1',0,1,1.5,'P242312',1),(2765,'p class gktips2','p class gktips2',0,1,1.5,'P242312',1),(2766,'p class gktips3','p class gktips3',0,1,1.5,'P242312',1),(2767,'p class gktips4','p class gktips4',0,1,1.5,'P242312',1),(2768,'p class gktips5','p class gktips5',0,1,1.5,'P242312',1),(2769,'p class gktwitteris2','p class gktwitteris2',0,1,1.6667,'P242362',1),(2770,'p class gkuser','p class gkuser',0,1,1.4667,'P2426',1),(2771,'p class gkuseris2','p class gkuseris2',0,1,1.5667,'P24262',1),(2772,'p class gkuseris3','p class gkuseris3',0,1,1.5667,'P24262',1),(2773,'p class gkvideois2','p class gkvideois2',0,1,1.6,'P242132',1),(2774,'p class gkwarning1','p class gkwarning1',0,1,1.6,'P242652',1),(2775,'p class gkwarning2','p class gkwarning2',0,1,1.6,'P242652',1),(2776,'p class gkwarning3','p class gkwarning3',0,1,1.6,'P242652',1),(2777,'p class gkwarning4','p class gkwarning4',0,1,1.6,'P242652',1),(2778,'p class gkwarning5','p class gkwarning5',0,1,1.6,'P242652',1),(2779,'p class gkwebcam','p class gkwebcam',0,1,1.5333,'P242125',1),(2780,'p class gkworld','p class gkworld',0,1,1.5,'P242643',1),(2781,'p class gkworldis2','p class gkworldis2',0,1,1.6,'P2426432',1),(2782,'p class gkyoutubeis2','p class gkyoutubeis2',0,1,1.6667,'P242312',1),(2783,'p div','p div',0,1,1.1667,'P310',1),(2784,'p div dropcaps','p div dropcaps',0,1,1.4667,'P31361212',1),(2785,'p div legend','p div legend',0,1,1.4,'P314253',1),(2786,'p floated','p floated',0,1,1.3,'P430',1),(2787,'p floated blocks','p floated blocks',0,1,1.5333,'P43142',1),(2788,'p headers','p headers',0,1,1.3,'P362',1),(2789,'p headers this','p headers this',0,1,1.4667,'P36232',1),(2790,'p here','p here',0,1,1.2,'P600',1),(2791,'p here goes','p here goes',0,1,1.3667,'P620',1),(2792,'p icon','p icon',0,1,1.2,'P250',1),(2793,'p icon set','p icon set',0,1,1.3333,'P2523',1),(2794,'p lorem','p lorem',0,1,1.2333,'P465',1),(2795,'p lorem ipsum','p lorem ipsum',0,1,1.4333,'P465125',1),(2796,'p p','p p',0,1,1.1,'P000',1),(2797,'p p class','p p class',0,1,1.3,'P242',1),(2798,'p span','p span',0,1,1.2,'P215',1),(2799,'p span class','p span class',0,1,1.4,'P215242',1),(2800,'p span here','p span here',0,1,1.3667,'P2156',1),(2801,'p t','p t',0,1,1.1,'P300',1),(2802,'p t his','p t his',0,1,1.2333,'P320',1),(2803,'p this','p this',0,1,1.2,'P320',1),(2804,'p this is','p this is',0,1,1.3,'P320',1),(2805,'p tooltips','p tooltips',0,1,1.3333,'P34312',1),(2806,'p tooltips here','p tooltips here',0,1,1.5,'P343126',1),(2807,'p urna','p urna',0,1,1.2,'P650',1),(2808,'p urna erat','p urna erat',0,1,1.3667,'P6563',1),(2809,'p ythis','p ythis',0,1,1.2333,'P320',1),(2810,'p ythis is','p ythis is',0,1,1.3333,'P320',1),(2811,'page','page',0,0,0.2667,'P200',6),(2812,'page goes','page goes',0,1,1.3,'P200',1),(2813,'page goes here','page goes here',0,1,1.4667,'P260',1),(2814,'page message','page message',0,1,1.4,'P252',1),(2815,'page message goes','page message goes',0,1,1.5667,'P252',1),(2816,'page message use','page message use',0,1,1.5333,'P252',1),(2817,'page white','page white',0,1,1.3333,'P230',1),(2818,'page white message','page white message',0,1,1.6,'P2352',1),(2819,'part','part',0,0,0.2667,'P630',3),(2820,'part of','part of',0,1,1.2333,'P631',3),(2821,'part of it','part of it',0,1,1.3333,'P6313',1),(2822,'part of tbody','part of tbody',0,1,1.4333,'P631313',1),(2823,'part of the','part of the',0,1,1.3667,'P6313',3),(2824,'parturient','parturient',0,0,0.6667,'P63653',6),(2825,'parturient montes','parturient montes',0,1,1.5667,'P63653532',6),(2826,'parturient montes nascetur','parturient montes nascetur',0,1,1.8667,'P636535325236',6),(2827,'penatibus','penatibus',0,0,0.6,'P5312',6),(2828,'penatibus et','penatibus et',0,1,1.4,'P53123',6),(2829,'penatibus et magnis','penatibus et magnis',0,1,1.6333,'P531235252',6),(2830,'phasellus','phasellus',0,0,0.6,'P242',22),(2831,'phasellus venenatis','phasellus venenatis',0,1,1.6333,'P2421532',1),(2832,'phasellus venenatis mollis','phasellus venenatis mollis',0,1,1.8667,'P2421532542',1),(2833,'phrase','phrase',0,0,0.4,'P620',1),(2834,'phrase goes','phrase goes',0,1,1.3667,'P620',1),(2835,'phrase goes here','phrase goes here',0,1,1.5333,'P626',1),(2836,'phrase here','phrase here',0,1,1.3667,'P626',1),(2837,'phrase here goes','phrase here goes',0,1,1.5333,'P6262',1),(2838,'phrase use','phrase use',0,1,1.3333,'P620',1),(2839,'phrase use span','phrase use span',0,1,1.5,'P6215',1),(2840,'pie','pie',0,0,0.2,'P000',1),(2841,'pie message','pie message',0,1,1.3667,'P520',1),(2842,'pie message goes','pie message goes',0,1,1.5333,'P520',1),(2843,'pie message use','pie message use',0,1,1.5,'P520',1),(2844,'pin','pin',0,0,0.2,'P500',1),(2845,'pin note','pin note',0,1,1.2667,'P530',1),(2846,'pin note use','pin note use',0,1,1.4,'P532',1),(2847,'placerat','placerat',0,0,0.5333,'P4263',25),(2848,'placerat in','placerat in',0,1,1.3667,'P42635',1),(2849,'placerat in etiam','placerat in etiam',0,1,1.5667,'P4263535',1),(2850,'placerat mauris','placerat mauris',0,1,1.5,'P4263562',1),(2851,'placerat mauris sed','placerat mauris sed',0,1,1.6333,'P42635623',1),(2852,'placerat nec','placerat nec',0,1,1.4,'P426352',1),(2853,'placerat nec euismod','placerat nec euismod',0,1,1.6667,'P42635253',1),(2854,'placerat tristique','placerat tristique',0,1,1.6,'P42636232',1),(2855,'placerat tristique et','placerat tristique et',0,1,1.7,'P426362323',1),(2856,'platea','platea',0,0,0.4,'P430',1),(2857,'platea dictumst','platea dictumst',0,1,1.5,'P4323523',1),(2858,'platea dictumst mauris','platea dictumst mauris',0,1,1.7333,'P4323523562',1),(2859,'plugin','plugin',0,0,0.4,'P425',1),(2860,'plugin message','plugin message',0,1,1.4667,'P4252',1),(2861,'plugin message goes','plugin message goes',0,1,1.6333,'P4252',1),(2862,'plugin message use','plugin message use',0,1,1.6,'P4252',1),(2863,'porta','porta',0,0,0.3333,'P630',14),(2864,'porta aliquam','porta aliquam',0,1,1.4333,'P63425',1),(2865,'porta aliquam varius','porta aliquam varius',0,1,1.6667,'P63425162',1),(2866,'porta eleifend','porta eleifend',0,1,1.4667,'P634153',1),(2867,'porta eleifend lorem','porta eleifend lorem',0,1,1.6667,'P634153465',1),(2868,'porta eleifend vivamus','porta eleifend vivamus',0,1,1.7333,'P634153152',1),(2869,'porta facilisis','porta facilisis',0,1,1.5,'P631242',1),(2870,'porta facilisis sapien','porta facilisis sapien',0,1,1.7333,'P63124215',1),(2871,'porta ut','porta ut',0,1,1.2667,'P630',1),(2872,'porta ut morbi','porta ut morbi',0,1,1.4667,'P63561',1),(2873,'porta ut p','porta ut p',0,1,1.3333,'P631',1),(2874,'position','position',0,0,0.5333,'P235',1),(2875,'position relative','position relative',0,1,1.5667,'P2356431',1),(2876,'position relative float','position relative float',0,1,1.7667,'P235643143',1),(2877,'posuere','posuere',0,0,0.4667,'P260',16),(2878,'posuere mauris','posuere mauris',0,1,1.4667,'P26562',1),(2879,'posuere mauris in','posuere mauris in',0,1,1.5667,'P265625',1),(2880,'posuere odio','posuere odio',0,1,1.4,'P263',1),(2881,'posuere odio placerat','posuere odio placerat',0,1,1.7,'P26314263',1),(2882,'potenti','potenti',0,0,0.4667,'P353',1),(2883,'potenti praesent','potenti praesent',0,1,1.5333,'P35316253',1),(2884,'potenti praesent quis','potenti praesent quis',0,1,1.7,'P353162532',1),(2885,'powered','powered',0,0,0.4667,'P630',1),(2886,'powered tooltip','powered tooltip',0,1,1.5,'P63431',1),(2887,'powered tooltip this','powered tooltip this',0,1,1.6667,'P6343132',1),(2888,'praesent','praesent',0,0,0.5333,'P6253',16),(2889,'praesent aliquet','praesent aliquet',0,1,1.5333,'P6253423',1),(2890,'praesent aliquet turpis','praesent aliquet turpis',0,1,1.7667,'P6253423612',1),(2891,'praesent quis','praesent quis',0,1,1.4333,'P62532',1),(2892,'praesent quis diam','praesent quis diam',0,1,1.6,'P6253235',1),(2893,'pre','pre',0,0,0.2,'P600',1),(2894,'pre or','pre or',0,1,1.2,'P600',1),(2895,'pre or div','pre or div',0,1,1.3333,'P631',1),(2896,'pretium','pretium',0,0,0.4667,'P635',22),(2897,'pretium imperdiet','pretium imperdiet',0,1,1.5667,'P635163',1),(2898,'pretium imperdiet hendrerit','pretium imperdiet hendrerit',0,1,1.9,'P6351635363',1),(2899,'primary','primary',0,0,0.4667,'P656',1),(2900,'primary source','primary source',0,1,1.4667,'P656262',1),(2901,'primary source of','primary source of',0,1,1.5667,'P6562621',1),(2902,'printer','printer',0,0,0.4667,'P6536',1),(2903,'printer message','printer message',0,1,1.5,'P653652',1),(2904,'printer message goes','printer message goes',0,1,1.6667,'P653652',1),(2905,'printer message use','printer message use',0,1,1.6333,'P653652',1),(2906,'produce','produce',0,0,0.4667,'P632',1),(2907,'produce your','produce your',0,1,1.4,'P6326',1),(2908,'produce your own','produce your own',0,1,1.5333,'P63265',1),(2909,'produced','produced',0,0,0.5333,'P6323',1),(2910,'produced by','produced by',0,1,1.3667,'P63231',1),(2911,'produced by the','produced by the',0,1,1.5,'P632313',1),(2912,'product','product',0,0,0.4667,'P6323',1),(2913,'product made','product made',0,1,1.4,'P632353',1),(2914,'product made by','product made by',0,1,1.5,'P6323531',1),(2915,'proin','proin',0,0,0.3333,'P650',11),(2916,'proin urna','proin urna',0,1,1.3333,'P6565',1),(2917,'proin urna erat','proin urna erat',0,1,1.5,'P656563',1),(2918,'proteins','proteins',0,0,0.5333,'P6352',1),(2919,'proteins dairy','proteins dairy',0,1,1.4667,'P635236',1),(2920,'proteins dairy milk','proteins dairy milk',0,1,1.6333,'P635236542',1),(2921,'provides','provides',0,0,0.5333,'P6132',3),(2922,'provides the','provides the',0,1,1.4,'P61323',1),(2923,'provides the primary','provides the primary',0,1,1.6667,'P613231656',1),(2924,'pulvinar','pulvinar',0,0,0.5333,'P4156',17),(2925,'pulvinar justo','pulvinar justo',0,1,1.4667,'P415623',1),(2926,'pulvinar justo sed','pulvinar justo sed',0,1,1.6,'P41562323',1),(2927,'pulvinar nibh','pulvinar nibh',0,1,1.4333,'P415651',1),(2928,'pulvinar nibh luctus','pulvinar nibh luctus',0,1,1.6667,'P4156514232',1),(2929,'purus','purus',0,0,0.3333,'P620',15),(2930,'purus donec','purus donec',0,1,1.3667,'P62352',1),(2931,'purus donec est','purus donec est',0,1,1.5,'P623523',1),(2932,'purus nunc','purus nunc',0,1,1.3333,'P6252',1),(2933,'purus nunc a','purus nunc a',0,1,1.4,'P6252',1),(2934,'purus porta','purus porta',0,1,1.3667,'P62163',1),(2935,'purus porta eleifend','purus porta eleifend',0,1,1.6667,'P621634153',1),(2936,'quam','quam',0,0,0.2667,'Q500',24),(2937,'quam sed','quam sed',0,1,1.2667,'Q523',1),(2938,'quam sed purus','quam sed purus',0,1,1.4667,'Q523162',1),(2939,'quam sollicitudin','quam sollicitudin',0,1,1.5667,'Q524235',4),(2940,'quam sollicitudin condimentum','quam sollicitudin condimentum',0,1,1.9667,'Q524235253535',1),(2941,'quis','quis',0,0,0.2667,'Q000',25),(2942,'quis diam','quis diam',0,1,1.3,'Q350',1),(2943,'quis diam non','quis diam non',0,1,1.4333,'Q350',1),(2944,'quis enim','quis enim',0,1,1.3,'Q500',4),(2945,'quis enim nulla','quis enim nulla',0,1,1.5,'Q540',1),(2946,'quis lobortis','quis lobortis',0,1,1.4333,'Q41632',1),(2947,'quis lobortis sed','quis lobortis sed',0,1,1.5667,'Q416323',1),(2948,'quis nullam','quis nullam',0,1,1.3667,'Q545',1),(2949,'quis nullam blandit','quis nullam blandit',0,1,1.6333,'Q5451453',1),(2950,'quis porta','quis porta',0,1,1.3333,'Q163',9),(2951,'quis porta aliquam','quis porta aliquam',0,1,1.6,'Q163425',1),(2952,'quis quam','quis quam',0,1,1.3,'Q500',1),(2953,'quis quam sed','quis quam sed',0,1,1.4333,'Q523',1),(2954,'quis turpis','quis turpis',0,1,1.3667,'Q3612',1),(2955,'quis turpis tellus','quis turpis tellus',0,1,1.6,'Q3612342',1),(2956,'quis ullamcorper','quis ullamcorper',0,1,1.5333,'Q452616',1),(2957,'quis ullamcorper convallis','quis ullamcorper convallis',0,1,1.8667,'Q45261625142',1),(2958,'quisque','quisque',0,0,0.4667,'Q000',21),(2959,'quisque sagittis','quisque sagittis',0,1,1.5333,'Q320',1),(2960,'quisque sagittis luctus','quisque sagittis luctus',0,1,1.7667,'Q324232',1),(2961,'quisque semper','quisque semper',0,1,1.4667,'Q516',1),(2962,'quisque semper condimentum','quisque semper condimentum',0,1,1.8667,'Q516253535',1),(2963,'quote','quote',0,0,0.3333,'Q300',1),(2964,'quote text','quote text',0,1,1.3333,'Q323',1),(2965,'quote text use','quote text use',0,1,1.4667,'Q3232',1),(2966,'quoted','quoted',0,0,0.4,'Q300',1),(2967,'quoted text','quoted text',0,1,1.3667,'Q323',1),(2968,'quoted text goes','quoted text goes',0,1,1.5333,'Q3232',1),(2969,'relative','relative',0,0,0.5333,'R431',1),(2970,'relative float','relative float',0,1,1.4667,'R43143',1),(2971,'relative float left','relative float left',0,1,1.6333,'R43143413',1),(2972,'report','report',0,0,0.4,'R163',1),(2973,'report message','report message',0,1,1.4667,'R16352',1),(2974,'report message goes','report message goes',0,1,1.6333,'R16352',1),(2975,'report message use','report message use',0,1,1.6,'R16352',1),(2976,'rest','rest',0,0,0.2667,'R230',1),(2977,'rest of','rest of',0,1,1.2333,'R231',1),(2978,'rest of the','rest of the',0,1,1.3667,'R2313',1),(2979,'rhoncus','rhoncus',0,0,0.4667,'R520',12),(2980,'rhoncus arcu','rhoncus arcu',0,1,1.4,'R5262',1),(2981,'rhoncus arcu sit','rhoncus arcu sit',0,1,1.5333,'R52623',1),(2982,'rhoncus enim','rhoncus enim',0,1,1.4,'R525',1),(2983,'rhoncus enim libero','rhoncus enim libero',0,1,1.6333,'R525416',1),(2984,'ridiculus','ridiculus',0,0,0.6,'R3242',6),(2985,'ridiculus mus','ridiculus mus',0,1,1.4333,'R324252',6),(2986,'ridiculus mus p','ridiculus mus p',0,1,1.5,'R3242521',1),(2987,'ridiculus mus span','ridiculus mus span',0,1,1.6,'R32425215',1),(2988,'risus','risus',0,0,0.3333,'R200',15),(2989,'risus aliquam','risus aliquam',0,1,1.4333,'R2425',1),(2990,'risus aliquam laoreet','risus aliquam laoreet',0,1,1.7,'R2425463',1),(2991,'risus facilisis','risus facilisis',0,1,1.5,'R21242',1),(2992,'risus facilisis dignissim','risus facilisis dignissim',0,1,1.8333,'R2124232525',1),(2993,'rutrum','rutrum',0,0,0.4,'R365',10),(2994,'rutrum tortor','rutrum tortor',0,1,1.4333,'R3653636',1),(2995,'rutrum tortor nibh','rutrum tortor nibh',0,1,1.6,'R365363651',1),(2996,'sagittis','sagittis',0,0,0.5333,'S320',3),(2997,'sagittis luctus','sagittis luctus',0,1,1.5,'S324232',1),(2998,'sagittis luctus augue','sagittis luctus augue',0,1,1.7,'S324232',1),(2999,'sample accept','sample accept',0,1,1.4333,'S514213',1),(3000,'sample accept message','sample accept message',0,1,1.7,'S51421352',1),(3001,'sample add','sample add',0,1,1.3333,'S5143',1),(3002,'sample add message','sample add message',0,1,1.6,'S514352',1),(3003,'sample audio','sample audio',0,1,1.4,'S5143',1),(3004,'sample audio message','sample audio message',0,1,1.6667,'S514352',1),(3005,'sample box','sample box',0,1,1.3333,'S51412',1),(3006,'sample box message','sample box message',0,1,1.6,'S5141252',1),(3007,'sample brick','sample brick',0,1,1.4,'S514162',1),(3008,'sample brick message','sample brick message',0,1,1.6667,'S51416252',1),(3009,'sample calendar','sample calendar',0,1,1.5,'S51424536',1),(3010,'sample calendar message','sample calendar message',0,1,1.7667,'S5142453652',1),(3011,'sample camera','sample camera',0,1,1.4333,'S514256',1),(3012,'sample camera message','sample camera message',0,1,1.7,'S51425652',1),(3013,'sample cart','sample cart',0,1,1.3667,'S514263',1),(3014,'sample cart message','sample cart message',0,1,1.6333,'S51426352',1),(3015,'sample cd','sample cd',0,1,1.3,'S51423',1),(3016,'sample cd message','sample cd message',0,1,1.5667,'S5142352',1),(3017,'sample chart','sample chart',0,1,1.4,'S514263',1),(3018,'sample chart bar','sample chart bar',0,1,1.5333,'S51426316',1),(3019,'sample chart line','sample chart line',0,1,1.5667,'S51426345',1),(3020,'sample chart pie','sample chart pie',0,1,1.5333,'S5142631',1),(3021,'sample clock','sample clock',0,1,1.4,'S514242',1),(3022,'sample clock message','sample clock message',0,1,1.6667,'S51424252',1),(3023,'sample coffe','sample coffe',0,1,1.4,'S51421',1),(3024,'sample coffe message','sample coffe message',0,1,1.6667,'S5142152',1),(3025,'sample cog','sample cog',0,1,1.3333,'S5142',1),(3026,'sample cog message','sample cog message',0,1,1.6,'S514252',1),(3027,'sample coins','sample coins',0,1,1.4,'S514252',1),(3028,'sample coins message','sample coins message',0,1,1.6667,'S51425252',1),(3029,'sample compress','sample compress',0,1,1.5,'S51425162',1),(3030,'sample compress message','sample compress message',0,1,1.7667,'S5142516252',1),(3031,'sample computer','sample computer',0,1,1.5,'S51425136',1),(3032,'sample computer message','sample computer message',0,1,1.7667,'S5142513652',1),(3033,'sample config','sample config',0,1,1.4333,'S5142512',1),(3034,'sample config message','sample config message',0,1,1.7,'S514251252',1),(3035,'sample configuration','sample configuration',0,1,1.6667,'S5142512635',1),(3036,'sample configuration message','sample configuration message',0,1,1.9333,'S51425126352',1),(3037,'sample contact','sample contact',0,1,1.4667,'S51425323',1),(3038,'sample contact message','sample contact message',0,1,1.7333,'S5142532352',1),(3039,'sample creditcard','sample creditcard',0,1,1.5667,'S514263263',1),(3040,'sample creditcard message','sample creditcard message',0,1,1.8333,'S51426326352',1),(3041,'sample cross','sample cross',0,1,1.4,'S514262',1),(3042,'sample cross message','sample cross message',0,1,1.6667,'S51426252',1),(3043,'sample disk','sample disk',0,1,1.3667,'S51432',1),(3044,'sample disk message','sample disk message',0,1,1.6333,'S5143252',1),(3045,'sample email','sample email',0,1,1.4,'S51454',1),(3046,'sample email message','sample email message',0,1,1.6667,'S5145452',1),(3047,'sample error','sample error',0,1,1.4,'S5146',2),(3048,'sample error message','sample error message',0,1,1.6667,'S514652',2),(3049,'sample exclamation','sample exclamation',0,1,1.6,'S51424535',1),(3050,'sample exclamation message','sample exclamation message',0,1,1.8667,'S514245352',1),(3051,'sample facebook','sample facebook',0,1,1.5,'S5141212',1),(3052,'sample facebook message','sample facebook message',0,1,1.7667,'S514121252',1),(3053,'sample feed','sample feed',0,1,1.3667,'S51413',1),(3054,'sample feed message','sample feed message',0,1,1.6333,'S5141352',1),(3055,'sample film','sample film',0,1,1.3667,'S514145',1),(3056,'sample film message','sample film message',0,1,1.6333,'S5141452',1),(3057,'sample folder','sample folder',0,1,1.4333,'S5141436',1),(3058,'sample folder message','sample folder message',0,1,1.7,'S514143652',1),(3059,'sample group','sample group',0,1,1.4,'S514261',1),(3060,'sample group message','sample group message',0,1,1.6667,'S51426152',1),(3061,'sample heart','sample heart',0,1,1.4,'S51463',1),(3062,'sample heart message','sample heart message',0,1,1.6667,'S5146352',1),(3063,'sample help','sample help',0,1,1.3667,'S5141',1),(3064,'sample help message','sample help message',0,1,1.6333,'S514152',1),(3065,'sample house','sample house',0,1,1.4,'S5142',1),(3066,'sample house message','sample house message',0,1,1.6667,'S514252',1),(3067,'sample image','sample image',0,1,1.4,'S51452',1),(3068,'sample image message','sample image message',0,1,1.6667,'S5145252',1),(3069,'sample images','sample images',0,1,1.4333,'S51452',1),(3070,'sample images message','sample images message',0,1,1.7,'S5145252',1),(3071,'sample info','sample info',0,1,1.3667,'S51451',1),(3072,'sample info message','sample info message',0,1,1.6333,'S5145152',1),(3073,'sample information','sample information',0,1,1.6,'S514516535',1),(3074,'sample information message','sample information message',0,1,1.8667,'S5145165352',1),(3075,'sample legend','sample legend',0,1,1.4333,'S514253',1),(3076,'sample legend note','sample legend note',0,1,1.6,'S51425353',1),(3077,'sample like','sample like',0,1,1.3667,'S5142',1),(3078,'sample like it','sample like it',0,1,1.4667,'S51423',1),(3079,'sample lock','sample lock',0,1,1.3667,'S5142',1),(3080,'sample lock message','sample lock message',0,1,1.6333,'S514252',1),(3081,'sample magnifier','sample magnifier',0,1,1.5333,'S51452516',1),(3082,'sample magnifier message','sample magnifier message',0,1,1.8,'S5145251652',1),(3083,'sample money','sample money',0,1,1.4,'S5145',1),(3084,'sample money message','sample money message',0,1,1.6667,'S51452',1),(3085,'sample movie','sample movie',0,1,1.4,'S51451',1),(3086,'sample movie message','sample movie message',0,1,1.6667,'S5145152',1),(3087,'sample new','sample new',0,1,1.3333,'S5145',1),(3088,'sample new message','sample new message',0,1,1.6,'S51452',1),(3089,'sample note','sample note',0,1,1.3667,'S51453',1),(3090,'sample note message','sample note message',0,1,1.6333,'S5145352',1),(3091,'sample of','sample of',0,1,1.3,'S5141',1),(3092,'sample of an','sample of an',0,1,1.4,'S51415',1),(3093,'sample of div','sample of div',0,1,1.4333,'S514131',1),(3094,'sample of pre','sample of pre',0,1,1.4333,'S51416',1),(3095,'sample page','sample page',0,1,1.3667,'S51412',1),(3096,'sample page message','sample page message',0,1,1.6333,'S5141252',1),(3097,'sample page white','sample page white',0,1,1.5667,'S514123',1),(3098,'sample pin','sample pin',0,1,1.3333,'S51415',1),(3099,'sample pin note','sample pin note',0,1,1.5,'S514153',1),(3100,'sample plugin','sample plugin',0,1,1.4333,'S5141425',1),(3101,'sample plugin message','sample plugin message',0,1,1.7,'S51414252',1),(3102,'sample printer','sample printer',0,1,1.4667,'S51416536',1),(3103,'sample printer message','sample printer message',0,1,1.7333,'S5141653652',1),(3104,'sample quote','sample quote',0,1,1.4,'S51423',1),(3105,'sample quote text','sample quote text',0,1,1.5667,'S5142323',1),(3106,'sample report','sample report',0,1,1.4333,'S5146163',1),(3107,'sample report message','sample report message',0,1,1.7,'S514616352',1),(3108,'sample script','sample script',0,1,1.4333,'S5142613',1),(3109,'sample script message','sample script message',0,1,1.7,'S514261352',1),(3110,'sample star','sample star',0,1,1.3667,'S514236',1),(3111,'sample star message','sample star message',0,1,1.6333,'S51423652',1),(3112,'sample telephone','sample telephone',0,1,1.5333,'S5143415',1),(3113,'sample telephone message','sample telephone message',0,1,1.8,'S51434152',1),(3114,'sample text','sample text',0,1,1.3667,'S514323',1),(3115,'sample text with','sample text with',0,1,1.5333,'S514323',1),(3116,'sample time','sample time',0,1,1.3667,'S51435',1),(3117,'sample time message','sample time message',0,1,1.6333,'S514352',1),(3118,'sample tips','sample tips',0,1,1.3667,'S514312',1),(3119,'sample tips message','sample tips message',0,1,1.6333,'S51431252',1),(3120,'sample twitter','sample twitter',0,1,1.4667,'S51436',1),(3121,'sample twitter message','sample twitter message',0,1,1.7333,'S5143652',1),(3122,'sample user','sample user',0,1,1.3667,'S51426',1),(3123,'sample user message','sample user message',0,1,1.6333,'S5142652',1),(3124,'sample video','sample video',0,1,1.4,'S51413',1),(3125,'sample video message','sample video message',0,1,1.6667,'S5141352',1),(3126,'sample warning','sample warning',0,1,1.4667,'S514652',2),(3127,'sample warning message','sample warning message',0,1,1.7333,'S51465252',2),(3128,'sample webcam','sample webcam',0,1,1.4333,'S514125',1),(3129,'sample webcam message','sample webcam message',0,1,1.7,'S5141252',1),(3130,'sample world','sample world',0,1,1.4,'S514643',1),(3131,'sample world message','sample world message',0,1,1.6667,'S51464352',1),(3132,'sample youtube','sample youtube',0,1,1.4667,'S51431',1),(3133,'sample youtube message','sample youtube message',0,1,1.7333,'S5143152',1),(3134,'samples','samples',0,0,0.4667,'S5142',1),(3135,'samples of','samples of',0,1,1.3333,'S51421',1),(3136,'samples of definition','samples of definition',0,1,1.7,'S5142131535',1),(3137,'samples of text','samples of text',0,1,1.5,'S51421323',1),(3138,'sapien','sapien',0,0,0.4,'S150',26),(3139,'sapien eu','sapien eu',0,1,1.3,'S150',1),(3140,'sapien eu nisi','sapien eu nisi',0,1,1.4667,'S152',1),(3141,'sapien in','sapien in',0,1,1.3,'S150',1),(3142,'sapien in tempus','sapien in tempus',0,1,1.5333,'S153512',1),(3143,'sauce','sauce',0,0,0.3333,'S000',1),(3144,'sauce making','sauce making',0,1,1.4,'S5252',1),(3145,'sauce making and','sauce making and',0,1,1.5333,'S525253',1),(3146,'script','script',0,0,0.4,'S613',1),(3147,'script goes','script goes',0,1,1.3667,'S6132',1),(3148,'script goes here','script goes here',0,1,1.5333,'S61326',1),(3149,'script message','script message',0,1,1.4667,'S61352',1),(3150,'script message use','script message use',0,1,1.6,'S61352',1),(3151,'sed','sed',0,0,0.2,'S300',28),(3152,'sed a','sed a',0,1,1.1667,'S300',1),(3153,'sed a mollis','sed a mollis',0,1,1.4,'S3542',1),(3154,'sed eleifend','sed eleifend',0,1,1.4,'S34153',1),(3155,'sed eleifend felis','sed eleifend felis',0,1,1.6,'S34153142',1),(3156,'sed faucibus','sed faucibus',0,1,1.4,'S31212',1),(3157,'sed faucibus ligula','sed faucibus ligula',0,1,1.6333,'S31212424',1),(3158,'sed lobortis','sed lobortis',0,1,1.4,'S341632',1),(3159,'sed lobortis vel','sed lobortis vel',0,1,1.5333,'S34163214',1),(3160,'sed ornare','sed ornare',0,1,1.3333,'S3656',1),(3161,'sed ornare magna','sed ornare magna',0,1,1.5333,'S3656525',1),(3162,'sed purus','sed purus',0,1,1.3,'S3162',1),(3163,'sed purus porta','sed purus porta',0,1,1.5,'S3162163',1),(3164,'sed quam','sed quam',0,1,1.2667,'S325',1),(3165,'sed quam sollicitudin','sed quam sollicitudin',0,1,1.7,'S32524235',1),(3166,'sed tellus','sed tellus',0,1,1.3333,'S342',5),(3167,'sed tellus cursus','sed tellus cursus',0,1,1.5667,'S34262',1),(3168,'sed tempus','sed tempus',0,1,1.3333,'S3512',13),(3169,'sed tempus leo','sed tempus leo',0,1,1.4667,'S35124',1),(3170,'sed vehicula','sed vehicula',0,1,1.4,'S3124',1),(3171,'sed vehicula integer','sed vehicula integer',0,1,1.6667,'S31245326',1),(3172,'sed velit','sed velit',0,1,1.3,'S3143',1),(3173,'sed velit massa','sed velit massa',0,1,1.5,'S314352',1),(3174,'sem','sem',0,0,0.2,'S500',13),(3175,'sem sed','sem sed',0,1,1.2333,'S523',1),(3176,'sem sed quam','sem sed quam',0,1,1.4,'S52325',1),(3177,'semper','semper',0,0,0.4,'S516',18),(3178,'semper condimentum','semper condimentum',0,1,1.6,'S516253535',1),(3179,'semper condimentum lectus','semper condimentum lectus',0,1,1.8333,'S5162535354232',1),(3180,'semper egestas','semper egestas',0,1,1.4667,'S516232',1),(3181,'semper egestas nunc','semper egestas nunc',0,1,1.6333,'S51623252',1),(3182,'separate','separate',0,0,0.5333,'S163',1),(3183,'separate block','separate block',0,1,1.4667,'S163142',1),(3184,'separate block p','separate block p',0,1,1.5333,'S1631421',1),(3185,'set','set',0,0,0.2,'S300',1),(3186,'set 1','set 1',0,1,1.1667,'S300',1),(3187,'set 1 icon','set 1 icon',0,1,1.3333,'S325',1),(3188,'set 1 this','set 1 this',0,1,1.3333,'S320',1),(3189,'set 2','set 2',0,1,1.1667,'S300',1),(3190,'set 2 icon','set 2 icon',0,1,1.3333,'S325',1),(3191,'set 2 this','set 2 this',0,1,1.3333,'S320',1),(3192,'set 3','set 3',0,1,1.1667,'S300',1),(3193,'set 3 this','set 3 this',0,1,1.3333,'S320',1),(3194,'set 3 tooltips','set 3 tooltips',0,1,1.4667,'S34312',1),(3195,'sit','sit',0,0,0.2,'S300',27),(3196,'sit amet','sit amet',0,1,1.2667,'S353',27),(3197,'sit amet condimentum','sit amet condimentum',0,1,1.6667,'S353253535',1),(3198,'sit amet consectetuer','sit amet consectetuer',0,1,1.7,'S35325236',1),(3199,'sit amet consectetur','sit amet consectetur',0,1,1.6667,'S35325236',20),(3200,'sit amet est','sit amet est',0,1,1.4,'S35323',1),(3201,'small','small',0,0,0.3333,'S540',3),(3202,'small headline','small headline',0,1,1.4667,'S54345',1),(3203,'small headline this','small headline this',0,1,1.6333,'S5434532',1),(3204,'so','so',0,0,0.1333,'S000',6),(3205,'so feel','so feel',0,1,1.2333,'S140',1),(3206,'so feel free','so feel free',0,1,1.4,'S1416',1),(3207,'sociis','sociis',0,0,0.4,'S000',6),(3208,'sociis natoque','sociis natoque',0,1,1.4667,'S532',6),(3209,'sociis natoque penatibus','sociis natoque penatibus',0,1,1.8,'S53215312',6),(3210,'sodales','sodales',0,0,0.4667,'S342',11),(3211,'sodales duis','sodales duis',0,1,1.4,'S34232',1),(3212,'sodales duis accumsan','sodales duis accumsan',0,1,1.7,'S34232525',1),(3213,'sodales quis','sodales quis',0,1,1.4,'S342',1),(3214,'sodales quis lobortis','sodales quis lobortis',0,1,1.7,'S34241632',1),(3215,'sollicitudin','sollicitudin',0,0,0.8,'S4235',12),(3216,'sollicitudin condimentum','sollicitudin condimentum',0,1,1.8,'S4235253535',1),(3217,'sollicitudin condimentum et','sollicitudin condimentum et',0,1,1.9,'S42352535353',1),(3218,'some','some',0,0,0.2667,'S500',2),(3219,'some examples','some examples',0,1,1.4333,'S525142',1),(3220,'some examples of','some examples of',0,1,1.5333,'S5251421',1),(3221,'source','source',0,0,0.4,'S620',2),(3222,'source of','source of',0,1,1.3,'S621',1),(3223,'source of nutrition','source of nutrition',0,1,1.6333,'S62153635',1),(3224,'span','span',0,0,0.2667,'S150',1),(3225,'span and','span and',0,1,1.2667,'S153',1),(3226,'span and here','span and here',0,1,1.4333,'S1536',1),(3227,'span blockquotes','span blockquotes',0,1,1.5333,'S1514232',1),(3228,'span blockquotes this','span blockquotes this',0,1,1.7,'S151423232',1),(3229,'span blocks','span blocks',0,1,1.3667,'S15142',1),(3230,'span blocks blockquotes','span blocks blockquotes',0,1,1.7667,'S1514214232',1),(3231,'span blocks this','span blocks this',0,1,1.5333,'S1514232',1),(3232,'span class','span class',0,1,1.3333,'S15242',1),(3233,'span class gkblocktextcenter','span class gkblocktextcenter',0,1,1.9333,'S152421423232536',1),(3234,'span class gkblocktextleft','span class gkblocktextleft',0,1,1.8667,'S15242142323413',1),(3235,'span class gkblocktextright','span class gkblocktextright',0,1,1.9,'S15242142323623',1),(3236,'span class gkclear','span class gkclear',0,1,1.6,'S1524246',1),(3237,'span class gkclear-1','span class gkclear-1',0,1,1.6667,'S1524246',1),(3238,'span class gkclear-2','span class gkclear-2',0,1,1.6667,'S1524246',1),(3239,'span class gkcolor','span class gkcolor',0,1,1.6,'S1524246',1),(3240,'span class gkcolor-1','span class gkcolor-1',0,1,1.6667,'S1524246',1),(3241,'span class gkcolor-2','span class gkcolor-2',0,1,1.6667,'S1524246',1),(3242,'span class gkcolor-3','span class gkcolor-3',0,1,1.6667,'S1524246',1),(3243,'span class gkcolor-4','span class gkcolor-4',0,1,1.6667,'S1524246',1),(3244,'span class gkcolor-5','span class gkcolor-5',0,1,1.6667,'S1524246',1),(3245,'span class gkcolor-6','span class gkcolor-6',0,1,1.6667,'S1524246',1),(3246,'span class gkcolor-7','span class gkcolor-7',0,1,1.6667,'S1524246',1),(3247,'span class gkdropcap1','span class gkdropcap1',0,1,1.7,'S1524236121',1),(3248,'span class gkdropcap2','span class gkdropcap2',0,1,1.7,'S1524236121',1),(3249,'span class gkdropcap3','span class gkdropcap3',0,1,1.7,'S1524236121',1),(3250,'span class gkhighlight1','span class gkhighlight1',0,1,1.7667,'S15242423',1),(3251,'span class gkhighlight2','span class gkhighlight2',0,1,1.7667,'S15242423',1),(3252,'span class gkhighlight3','span class gkhighlight3',0,1,1.7667,'S15242423',1),(3253,'span class gkhighlight4','span class gkhighlight4',0,1,1.7667,'S15242423',1),(3254,'span code','span code',0,1,1.3,'S1523',1),(3255,'span code below','span code below',0,1,1.5,'S152314',1),(3256,'span here','span here',0,1,1.3,'S156',1),(3257,'span here goes','span here goes',0,1,1.4667,'S1562',1),(3258,'span rest','span rest',0,1,1.3,'S15623',1),(3259,'span rest of','span rest of',0,1,1.4,'S156231',1),(3260,'span this','span this',0,1,1.3,'S1532',1),(3261,'span this is','span this is',0,1,1.4,'S1532',1),(3262,'span to','span to',0,1,1.2333,'S153',1),(3263,'span to make','span to make',0,1,1.4,'S15352',1),(3264,'spread','spread',0,0,0.4,'S163',1),(3265,'spread and','spread and',0,1,1.3333,'S16353',1),(3266,'spread and a','spread and a',0,1,1.4,'S16353',1),(3267,'star','star',0,0,0.2667,'S360',1),(3268,'star message','star message',0,1,1.4,'S3652',1),(3269,'star message goes','star message goes',0,1,1.5667,'S3652',1),(3270,'star message use','star message use',0,1,1.5333,'S3652',1),(3271,'subheadline','subheadline',0,0,0.7333,'S1345',1),(3272,'subheadline p','subheadline p',0,1,1.4333,'S13451',1),(3273,'subheadline p urna','subheadline p urna',0,1,1.6,'S1345165',1),(3274,'subheadline use','subheadline use',0,1,1.5,'S13452',1),(3275,'subheadline use p','subheadline use p',0,1,1.5667,'S134521',1),(3276,'such','such',0,0,0.2667,'S000',2),(3277,'such as','such as',0,1,1.2333,'S000',1),(3278,'such as baking','such as baking',0,1,1.4667,'S1252',1),(3279,'suspendisse','suspendisse',0,0,0.7333,'S1532',18),(3280,'suspendisse potenti','suspendisse potenti',0,1,1.6333,'S15321353',1),(3281,'suspendisse potenti praesent','suspendisse potenti praesent',0,1,1.9333,'S1532135316253',1),(3282,'t','t',0,0,0.0667,'T000',1),(3283,'t his','t his',0,1,1.1667,'T200',1),(3284,'t his is','t his is',0,1,1.2667,'T200',1),(3285,'t span','t span',0,1,1.2,'T215',1),(3286,'t span to','t span to',0,1,1.3,'T2153',1),(3287,'table','table',0,0,0.3333,'T140',1),(3288,'table footer','table footer',0,1,1.4,'T14136',1),(3289,'table footer tfoot','table footer tfoot',0,1,1.6,'T14136313',1),(3290,'table header','table header',0,1,1.4,'T1436',1),(3291,'table header thead','table header thead',0,1,1.6,'T14363',1),(3292,'tables','tables',0,0,0.4,'T142',1),(3293,'tables table','tables table',0,1,1.4,'T142314',1),(3294,'tables table header','tables table header',0,1,1.6333,'T14231436',1),(3295,'tables warnings','tables warnings',0,1,1.5,'T142652',1),(3296,'tables warnings this','tables warnings this',0,1,1.6667,'T14265232',1),(3297,'tbody','tbody',0,0,0.3333,'T130',1),(3298,'tbody cell','tbody cell',0,1,1.3333,'T1324',1),(3299,'tbody cell 2','tbody cell 2',0,1,1.4,'T1324',1),(3300,'tbody cell 3','tbody cell 3',0,1,1.4,'T1324',1),(3301,'tbody cell 4','tbody cell 4',0,1,1.4,'T1324',1),(3302,'tbody cell 5','tbody cell 5',0,1,1.4,'T1324',1),(3303,'tbody cell 6','tbody cell 6',0,1,1.4,'T1324',1),(3304,'tbody cell 7','tbody cell 7',0,1,1.4,'T1324',1),(3305,'tbody cell 8','tbody cell 8',0,1,1.4,'T1324',1),(3306,'tbody table','tbody table',0,1,1.3667,'T1314',1),(3307,'tbody table header','tbody table header',0,1,1.6,'T131436',1),(3308,'telephone','telephone',0,0,0.6,'T415',1),(3309,'telephone message','telephone message',0,1,1.5667,'T4152',1),(3310,'telephone message goes','telephone message goes',0,1,1.7333,'T4152',1),(3311,'telephone message use','telephone message use',0,1,1.7,'T4152',1),(3312,'tellus','tellus',0,0,0.4,'T420',15),(3313,'tellus cursus','tellus cursus',0,1,1.4333,'T4262',1),(3314,'tellus cursus lacinia','tellus cursus lacinia',0,1,1.7,'T4262425',1),(3315,'tellus vitae','tellus vitae',0,1,1.4,'T4213',1),(3316,'tellus vitae malesuada','tellus vitae malesuada',0,1,1.7333,'T42135423',1),(3317,'tempor','tempor',0,0,0.4,'T516',22),(3318,'tempor eu','tempor eu',0,1,1.3,'T516',1),(3319,'tempor eu pulvinar','tempor eu pulvinar',0,1,1.6,'T51614156',1),(3320,'tempor iaculis','tempor iaculis',0,1,1.4667,'T516242',1),(3321,'tempor iaculis phasellus','tempor iaculis phasellus',0,1,1.8,'T5162421242',1),(3322,'tempus','tempus',0,0,0.4,'T512',24),(3323,'tempus leo','tempus leo',0,1,1.3333,'T5124',1),(3324,'tempus leo lorem','tempus leo lorem',0,1,1.5333,'T512465',1),(3325,'tempus lorem','tempus lorem',0,1,1.4,'T512465',1),(3326,'tempus lorem mattis','tempus lorem mattis',0,1,1.6333,'T51246532',1),(3327,'text','text',0,0,0.2667,'T230',1),(3328,'text goes','text goes',0,1,1.3,'T232',1),(3329,'text goes here','text goes here',0,1,1.4667,'T2326',1),(3330,'text in','text in',0,1,1.2333,'T235',1),(3331,'text in which','text in which',0,1,1.4333,'T2352',1),(3332,'text of','text of',0,1,1.2333,'T231',1),(3333,'text of element','text of element',0,1,1.5,'T231453',1),(3334,'text p','text p',0,1,1.2,'T231',1),(3335,'text p lorem','text p lorem',0,1,1.4,'T231465',1),(3336,'text span','text span',0,1,1.3,'T23215',1),(3337,'text span class','text span class',0,1,1.5,'T23215242',1),(3338,'text span rest','text span rest',0,1,1.4667,'T23215623',1),(3339,'text use','text use',0,1,1.2667,'T232',1),(3340,'text use blockquote','text use blockquote',0,1,1.6333,'T2321423',1),(3341,'text with','text with',0,1,1.3,'T230',1),(3342,'text with dropcap','text with dropcap',0,1,1.5667,'T236121',1),(3343,'tfoot','tfoot',0,0,0.3333,'T130',1),(3344,'tfoot column','tfoot column',0,1,1.4,'T13245',1),(3345,'tfoot column 1','tfoot column 1',0,1,1.4667,'T13245',1),(3346,'the','the',0,0,0.2,'T000',19),(3347,'the first','the first',0,1,1.3,'T1623',1),(3348,'the first letter','the first letter',0,1,1.5333,'T1623436',1),(3349,'the mammary','the mammary',0,1,1.3667,'T560',1),(3350,'the mammary glands','the mammary glands',0,1,1.6,'T5624532',1),(3351,'the primary','the primary',0,1,1.3667,'T1656',1),(3352,'the primary source','the primary source',0,1,1.6,'T1656262',1),(3353,'the text','the text',0,1,1.2667,'T230',1),(3354,'the text p','the text p',0,1,1.3333,'T231',1),(3355,'the text span','the text span',0,1,1.4333,'T23215',1),(3356,'the word','the word',0,1,1.2667,'T630',1),(3357,'the word you\'re','the word you',0,1,1.5,'T636',1),(3358,'thead','thead',0,0,0.3333,'T000',1),(3359,'thead table','thead table',0,1,1.3667,'T140',1),(3360,'thead table footer','thead table footer',0,1,1.6,'T14136',1),(3361,'they','they',0,0,0.2667,'T000',2),(3362,'they are','they are',0,1,1.2667,'T600',1),(3363,'they are able','they are able',0,1,1.4333,'T614',1),(3364,'this','this',0,0,0.2667,'T200',11),(3365,'this is','this is',0,1,1.2333,'T200',3),(3366,'this is a','this is a',0,1,1.3,'T200',2),(3367,'this is heading','this is heading',0,1,1.5,'T2352',1),(3368,'this is just','this is just',0,1,1.4,'T230',1),(3369,'time','time',0,0,0.2667,'T500',4),(3370,'time message','time message',0,1,1.4,'T520',1),(3371,'time message goes','time message goes',0,1,1.5667,'T520',1),(3372,'time message use','time message use',0,1,1.5333,'T520',1),(3373,'tips','tips',0,0,0.2667,'T120',2),(3374,'tips goes','tips goes',0,1,1.3,'T120',1),(3375,'tips goes here','tips goes here',0,1,1.4667,'T126',1),(3376,'tips message','tips message',0,1,1.4,'T1252',1),(3377,'tips message use','tips message use',0,1,1.5333,'T1252',1),(3378,'title','title',0,0,0.3333,'T400',1),(3379,'title h4','title h4',0,1,1.2667,'T400',1),(3380,'title h4 p','title h4 p',0,1,1.3333,'T410',1),(3381,'title here','title here',0,1,1.3333,'T460',1),(3382,'title here goes','title here goes',0,1,1.5,'T462',1),(3383,'to','to',0,0,0.1333,'T000',17),(3384,'to define','to define',0,1,1.3,'T150',1),(3385,'to define dt','to define dt',0,1,1.4,'T153',1),(3386,'to digest','to digest',0,1,1.3,'T230',1),(3387,'to digest other','to digest other',0,1,1.5,'T236',1),(3388,'to get','to get',0,1,1.2,'T230',7),(3389,'to get creative','to get creative',0,1,1.5,'T232631',1),(3390,'to make','to make',0,1,1.2333,'T520',5),(3391,'to make the','to make the',0,1,1.3667,'T523',2),(3392,'tooltip','tooltip',0,0,0.4667,'T431',1),(3393,'tooltip feel','tooltip feel',0,1,1.4,'T4314',1),(3394,'tooltip feel free','tooltip feel free',0,1,1.5667,'T431416',1),(3395,'tooltip this','tooltip this',0,1,1.4,'T43132',1),(3396,'tooltip this is','tooltip this is',0,1,1.5,'T43132',1),(3397,'tooltips','tooltips',0,0,0.5333,'T4312',1),(3398,'tooltips here','tooltips here',0,1,1.4333,'T43126',1),(3399,'tooltips here are','tooltips here are',0,1,1.5667,'T43126',1),(3400,'tooltips highlights','tooltips highlights',0,1,1.6333,'T43124232',1),(3401,'tooltips highlights code','tooltips highlights code',0,1,1.8,'T431242323',1),(3402,'tortor','tortor',0,0,0.4,'T636',27),(3403,'tortor nibh','tortor nibh',0,1,1.3667,'T63651',1),(3404,'tortor nibh posuere','tortor nibh posuere',0,1,1.6333,'T6365126',1),(3405,'tristique','tristique',0,0,0.6,'T6232',12),(3406,'tristique convallis','tristique convallis',0,1,1.6333,'T62325142',1),(3407,'tristique convallis nec','tristique convallis nec',0,1,1.7667,'T6232514252',1),(3408,'tristique et','tristique et',0,1,1.4,'T62323',1),(3409,'tristique et consectetur','tristique et consectetur',0,1,1.8,'T6232325236',1),(3410,'tristique fusce','tristique fusce',0,1,1.5,'T623212',1),(3411,'tristique fusce a','tristique fusce a',0,1,1.5667,'T623212',1),(3412,'turpis','turpis',0,0,0.4,'T612',23),(3413,'turpis in','turpis in',0,1,1.3,'T6125',1),(3414,'turpis in quam','turpis in quam',0,1,1.4667,'T612525',1),(3415,'turpis tellus','turpis tellus',0,1,1.4333,'T612342',1),(3416,'turpis tellus vitae','turpis tellus vitae',0,1,1.6333,'T61234213',1),(3417,'twitter','twitter',0,0,0.4667,'T600',2),(3418,'twitter message','twitter message',0,1,1.5,'T652',1),(3419,'twitter message goes','twitter message goes',0,1,1.6667,'T652',1),(3420,'twitter message use','twitter message use',0,1,1.6333,'T652',1),(3421,'types of','types of',0,1,1.2667,'T121',2),(3422,'types of food','types of food',0,1,1.4333,'T1213',1),(3423,'types of ordered','types of ordered',0,1,1.5333,'T1216363',1),(3424,'types of unordered','types of unordered',0,1,1.6,'T12156363',1),(3425,'typography','typography',0,0,0.6667,'T1261',1),(3426,'ul','ul',0,0,0.1333,'U400',1),(3427,'ul class','ul class',0,1,1.2667,'U4242',1),(3428,'ul class gkbullet1','ul class gkbullet1',0,1,1.6,'U4242143',1),(3429,'ul class gkbullet2','ul class gkbullet2',0,1,1.6,'U4242143',1),(3430,'ul class gkbullet3','ul class gkbullet3',0,1,1.6,'U4242143',1),(3431,'ul class gkbullet4','ul class gkbullet4',0,1,1.6,'U4242143',1),(3432,'ul class gkcircle1','ul class gkcircle1',0,1,1.6,'U4242624',1),(3433,'ul class gkcircle2','ul class gkcircle2',0,1,1.6,'U4242624',1),(3434,'ul class gksquare1','ul class gksquare1',0,1,1.6,'U42426',1),(3435,'ul class gksquare2','ul class gksquare2',0,1,1.6,'U42426',1),(3436,'ul class gksquare3','ul class gksquare3',0,1,1.6,'U42426',1),(3437,'ullamcorper','ullamcorper',0,0,0.7333,'U452616',3),(3438,'ullamcorper convallis','ullamcorper convallis',0,1,1.7,'U45261625142',1),(3439,'ullamcorper convallis libero','ullamcorper convallis libero',0,1,1.9333,'U45261625142416',1),(3440,'ullamcorper donec','ullamcorper donec',0,1,1.5667,'U452616352',1),(3441,'ullamcorper donec eget','ullamcorper donec eget',0,1,1.7333,'U4526163523',1),(3442,'ullamcorper est','ullamcorper est',0,1,1.5,'U45261623',1),(3443,'ullamcorper est id','ullamcorper est id',0,1,1.6,'U45261623',1),(3444,'ultrices','ultrices',0,0,0.5333,'U4362',26),(3445,'ultrices lectus','ultrices lectus',0,1,1.5,'U43624232',1),(3446,'ultrices lectus fusce','ultrices lectus fusce',0,1,1.7,'U4362423212',1),(3447,'ultrices sapien','ultrices sapien',0,1,1.5,'U436215',1),(3448,'ultrices sapien eu','ultrices sapien eu',0,1,1.6,'U436215',1),(3449,'ultricies','ultricies',0,0,0.6,'U4362',22),(3450,'ultricies ac','ultricies ac',0,1,1.4,'U4362',1),(3451,'ultricies ac mollis','ultricies ac mollis',0,1,1.6333,'U4362542',1),(3452,'unordered','unordered',0,0,0.6,'U56363',1),(3453,'unordered lists','unordered lists',0,1,1.5,'U563634232',1),(3454,'unordered lists ordered','unordered lists ordered',0,1,1.7667,'U5636342326363',1),(3455,'unordered lists types','unordered lists types',0,1,1.7,'U563634232312',1),(3456,'unordered lists ul','unordered lists ul',0,1,1.6,'U5636342324',1),(3457,'urna','urna',0,0,0.2667,'U650',24),(3458,'urna aenean','urna aenean',0,1,1.3667,'U650',1),(3459,'urna aenean tristique','urna aenean tristique',0,1,1.7,'U6536232',1),(3460,'urna erat','urna erat',0,1,1.3,'U6563',4),(3461,'urna erat egestas','urna erat egestas',0,1,1.5667,'U6563232',1),(3462,'urna ipsum','urna ipsum',0,1,1.3333,'U65125',1),(3463,'urna ipsum et','urna ipsum et',0,1,1.4333,'U651253',1),(3464,'urna sodales','urna sodales',0,1,1.4,'U652342',1),(3465,'urna sodales duis','urna sodales duis',0,1,1.5667,'U65234232',1),(3466,'urna ultricies','urna ultricies',0,1,1.4667,'U654362',1),(3467,'urna ultricies ac','urna ultricies ac',0,1,1.5667,'U654362',1),(3468,'use','use',0,0,0.2,'U200',1),(3469,'use abbr','use abbr',0,1,1.2667,'U216',1),(3470,'use abbr title','use abbr title',0,1,1.4667,'U21634',1),(3471,'use acronym','use acronym',0,1,1.3667,'U265',1),(3472,'use acronym title','use acronym title',0,1,1.5667,'U26534',1),(3473,'use blockquote','use blockquote',0,1,1.4667,'U21423',1),(3474,'use blockquote div','use blockquote div',0,1,1.6,'U214231',1),(3475,'use blockquote your','use blockquote your',0,1,1.6333,'U214236',1),(3476,'use div','use div',0,1,1.2333,'U231',1),(3477,'use div class','use div class',0,1,1.4333,'U231242',1),(3478,'use p','use p',0,1,1.1667,'U210',1),(3479,'use p class','use p class',0,1,1.3667,'U21242',1),(3480,'use p span','use p span',0,1,1.3333,'U21215',1),(3481,'use span','use span',0,1,1.2667,'U215',1),(3482,'use span class','use span class',0,1,1.4667,'U215242',1),(3483,'used','used',0,0,0.2667,'U230',3),(3484,'used as','used as',0,1,1.2333,'U232',1),(3485,'used as a','used as a',0,1,1.3,'U232',1),(3486,'user message','user message',0,1,1.4,'U2652',1),(3487,'user message goes','user message goes',0,1,1.5667,'U2652',1),(3488,'user message use','user message use',0,1,1.5333,'U2652',1),(3489,'using','using',0,0,0.3333,'U252',5),(3490,'using a','using a',0,1,1.2333,'U252',1),(3491,'using a css','using a css',0,1,1.3667,'U252',1),(3492,'ut','ut',0,0,0.1333,'U300',26),(3493,'ut consequat','ut consequat',0,1,1.4,'U32523',1),(3494,'ut consequat eget','ut consequat eget',0,1,1.5667,'U3252323',1),(3495,'ut morbi','ut morbi',0,1,1.2667,'U3561',1),(3496,'ut morbi cursus','ut morbi cursus',0,1,1.5,'U3561262',1),(3497,'ut p','ut p',0,1,1.1333,'U310',1),(3498,'ut p floated','ut p floated',0,1,1.4,'U3143',1),(3499,'ut p t','ut p t',0,1,1.2,'U313',1),(3500,'varius','varius',0,0,0.4,'V620',14),(3501,'varius placerat','varius placerat',0,1,1.5,'V6214263',1),(3502,'varius placerat mauris','varius placerat mauris',0,1,1.7333,'V6214263562',1),(3503,'vehicula','vehicula',0,0,0.5333,'V240',11),(3504,'vehicula integer','vehicula integer',0,1,1.5333,'V245326',1),(3505,'vehicula integer porta','vehicula integer porta',0,1,1.7333,'V245326163',1),(3506,'vel','vel',0,0,0.2,'V400',28),(3507,'vel congue','vel congue',0,1,1.3333,'V4252',1),(3508,'vel congue augue','vel congue augue',0,1,1.5333,'V4252',1),(3509,'vel consectetur','vel consectetur',0,1,1.5,'V425236',1),(3510,'vel consectetur at','vel consectetur at',0,1,1.6,'V4252363',1),(3511,'vel eros','vel eros',0,1,1.2667,'V462',1),(3512,'vel eros vestibulum','vel eros vestibulum',0,1,1.6333,'V462123145',1),(3513,'vel mauris','vel mauris',0,1,1.3333,'V4562',1),(3514,'vel mauris sed','vel mauris sed',0,1,1.4667,'V45623',1),(3515,'vel velit','vel velit',0,1,1.3,'V4143',1),(3516,'vel velit hendrerit','vel velit hendrerit',0,1,1.6333,'V41435363',1),(3517,'velit','velit',0,0,0.3333,'V430',20),(3518,'velit ac','velit ac',0,1,1.2667,'V432',1),(3519,'velit ac eros','velit ac eros',0,1,1.4333,'V43262',1),(3520,'velit hendrerit','velit hendrerit',0,1,1.5,'V435363',10),(3521,'velit hendrerit dictum','velit hendrerit dictum',0,1,1.7333,'V435363235',1),(3522,'velit massa','velit massa',0,1,1.3667,'V4352',1),(3523,'velit massa imperdiet','velit massa imperdiet',0,1,1.7,'V43525163',1),(3524,'velit quis','velit quis',0,1,1.3333,'V432',1),(3525,'velit quis porta','velit quis porta',0,1,1.5333,'V432163',1),(3526,'venenatis','venenatis',0,0,0.6,'V532',16),(3527,'venenatis aliquet','venenatis aliquet',0,1,1.5667,'V532423',1),(3528,'venenatis aliquet euismod','venenatis aliquet euismod',0,1,1.8333,'V532423253',1),(3529,'venenatis mollis','venenatis mollis',0,1,1.5333,'V532542',1),(3530,'venenatis mollis augue','venenatis mollis augue',0,1,1.7333,'V532542',1),(3531,'vestibulum','vestibulum',0,0,0.6667,'V23145',27),(3532,'vestibulum condimentum','vestibulum condimentum',0,1,1.7333,'V23145253535',1),(3533,'vestibulum condimentum pulvinar','vestibulum condimentum pulvinar',0,1,2,'V2314525353514156',1),(3534,'vestibulum euismod','vestibulum euismod',0,1,1.6,'V23145253',1),(3535,'vestibulum euismod luctus','vestibulum euismod luctus',0,1,1.8333,'V231452534232',1),(3536,'video','video',0,0,0.3333,'V300',1),(3537,'video message','video message',0,1,1.4333,'V352',1),(3538,'video message goes','video message goes',0,1,1.6,'V352',1),(3539,'video message use','video message use',0,1,1.5667,'V352',1),(3540,'vitae','vitae',0,0,0.3333,'V300',23),(3541,'vitae malesuada','vitae malesuada',0,1,1.5,'V35423',1),(3542,'vitae malesuada neque','vitae malesuada neque',0,1,1.7,'V3542352',1),(3543,'vitae purus','vitae purus',0,1,1.3667,'V3162',1),(3544,'vitae purus nunc','vitae purus nunc',0,1,1.5333,'V316252',1),(3545,'vivamus','vivamus',0,0,0.4667,'V520',13),(3546,'vivamus rhoncus','vivamus rhoncus',0,1,1.5,'V52652',1),(3547,'vivamus rhoncus arcu','vivamus rhoncus arcu',0,1,1.6667,'V5265262',1),(3548,'vivamus ullamcorper','vivamus ullamcorper',0,1,1.6333,'V52452616',1),(3549,'vivamus ullamcorper est','vivamus ullamcorper est',0,1,1.7667,'V5245261623',1),(3550,'volutpat','volutpat',0,0,0.5333,'V4313',21),(3551,'volutpat consectetur','volutpat consectetur',0,1,1.6667,'V431325236',1),(3552,'volutpat consectetur accumsan','volutpat consectetur accumsan',0,1,1.9667,'V4313252362525',1),(3553,'volutpat diam','volutpat diam',0,1,1.4333,'V43135',1),(3554,'volutpat diam ante','volutpat diam ante',0,1,1.6,'V431353',1),(3555,'volutpat fusce','volutpat fusce',0,1,1.4667,'V431312',1),(3556,'volutpat fusce adipiscing','volutpat fusce adipiscing',0,1,1.8333,'V43131231252',1),(3557,'volutpat ultrices','volutpat ultrices',0,1,1.5667,'V43134362',1),(3558,'volutpat ultrices lectus','volutpat ultrices lectus',0,1,1.8,'V431343624232',1),(3559,'warning','warning',0,0,0.4667,'W652',2),(3560,'warning message','warning message',0,1,1.5,'W65252',2),(3561,'warning message goes','warning message goes',0,1,1.6667,'W65252',1),(3562,'warning message use','warning message use',0,1,1.6333,'W65252',1),(3563,'warning this','warning this',0,1,1.4,'W65232',1),(3564,'warning this is','warning this is',0,1,1.5,'W65232',1),(3565,'warning warning','warning warning',0,1,1.5,'W652652',1),(3566,'warning warning this','warning warning this',0,1,1.6667,'W65265232',1),(3567,'warnings','warnings',0,0,0.5333,'W652',1),(3568,'warnings headers','warnings headers',0,1,1.5333,'W652362',1),(3569,'warnings headers icon','warnings headers icon',0,1,1.7,'W6523625',1),(3570,'warnings this','warnings this',0,1,1.4333,'W65232',1),(3571,'warnings this is','warnings this is',0,1,1.5333,'W65232',1),(3572,'water','water',0,0,0.3333,'W360',1),(3573,'water and','water and',0,1,1.3,'W3653',1),(3574,'water and milk','water and milk',0,1,1.4667,'W3653542',1),(3575,'webcam','webcam',0,0,0.4,'W125',1),(3576,'webcam goes','webcam goes',0,1,1.3667,'W1252',1),(3577,'webcam goes here','webcam goes here',0,1,1.5333,'W12526',1),(3578,'webcam message','webcam message',0,1,1.4667,'W1252',1),(3579,'webcam message use','webcam message use',0,1,1.6,'W1252',1),(3580,'well','well',0,0,0.2667,'W400',2),(3581,'well as','well as',0,1,1.2333,'W420',2),(3582,'well as in','well as in',0,1,1.3333,'W425',1),(3583,'what','what',0,0,0.2667,'W300',2),(3584,'what you','what you',0,1,1.2667,'W300',2),(3585,'what you can','what you can',0,1,1.4,'W325',1),(3586,'which','which',0,0,0.3333,'W200',9),(3587,'which part','which part',0,1,1.3333,'W2163',1),(3588,'which part of','which part of',0,1,1.4333,'W21631',1),(3589,'white','white',0,0,0.3333,'W300',1),(3590,'white liquid','white liquid',0,1,1.4,'W3423',1),(3591,'white liquid produced','white liquid produced',0,1,1.7,'W342316323',1),(3592,'white message','white message',0,1,1.4333,'W352',1),(3593,'white message goes','white message goes',0,1,1.6,'W352',1),(3594,'white message use','white message use',0,1,1.5667,'W352',1),(3595,'white your','white your',0,1,1.3333,'W360',1),(3596,'white your page','white your page',0,1,1.5,'W3612',1),(3597,'with dropcap','with dropcap',0,1,1.4,'W36121',1),(3598,'with dropcap use','with dropcap use',0,1,1.5333,'W361212',1),(3599,'word','word',0,0,0.2667,'W630',1),(3600,'word or','word or',0,1,1.2333,'W636',1),(3601,'word or phrase','word or phrase',0,1,1.4667,'W636162',1),(3602,'word you\'re','word you',0,1,1.3667,'W636',1),(3603,'word you\'re about','word you about',0,1,1.5667,'W63613',1),(3604,'world','world',0,0,0.3333,'W643',2),(3605,'world goes','world goes',0,1,1.3333,'W6432',1),(3606,'world goes here','world goes here',0,1,1.5,'W64326',1),(3607,'world message','world message',0,1,1.4333,'W64352',1),(3608,'world message goes','world message goes',0,1,1.6,'W64352',1),(3609,'world message use','world message use',0,1,1.5667,'W64352',1),(3610,'wrapper','wrapper',0,0,0.4667,'W616',1),(3611,'wrapper position','wrapper position',0,1,1.5333,'W6161235',1),(3612,'wrapper position relative','wrapper position relative',0,1,1.8333,'W61612356431',1),(3613,'you','you',0,0,0.2,'Y000',9),(3614,'you can','you can',0,1,1.2333,'Y250',4),(3615,'you can do','you can do',0,1,1.3333,'Y253',1),(3616,'you\'re','you',0,0,0.4,'Y600',1),(3617,'you\'re about','you about',0,1,1.4,'Y613',1),(3618,'you\'re about to','you about to',0,1,1.5,'Y613',1),(3619,'your','your',0,0,0.2667,'Y600',8),(3620,'your accept','your accept',0,1,1.3667,'Y6213',1),(3621,'your accept goes','your accept goes',0,1,1.5333,'Y62132',1),(3622,'your add','your add',0,1,1.2667,'Y630',1),(3623,'your add message','your add message',0,1,1.5333,'Y6352',1),(3624,'your audio','your audio',0,1,1.3333,'Y630',1),(3625,'your audio message','your audio message',0,1,1.6,'Y6352',1),(3626,'your box','your box',0,1,1.2667,'Y612',1),(3627,'your box message','your box message',0,1,1.5333,'Y61252',1),(3628,'your brick','your brick',0,1,1.3333,'Y6162',1),(3629,'your brick goes','your brick goes',0,1,1.5,'Y6162',1),(3630,'your calendar','your calendar',0,1,1.4333,'Y624536',1),(3631,'your calendar message','your calendar message',0,1,1.7,'Y62453652',1),(3632,'your camera','your camera',0,1,1.3667,'Y6256',1),(3633,'your camera message','your camera message',0,1,1.6333,'Y625652',1),(3634,'your cart','your cart',0,1,1.3,'Y6263',1),(3635,'your cart message','your cart message',0,1,1.5667,'Y626352',1),(3636,'your cd','your cd',0,1,1.2333,'Y623',1),(3637,'your cd message','your cd message',0,1,1.5,'Y62352',1),(3638,'your chart','your chart',0,1,1.3333,'Y6263',1),(3639,'your chart bar','your chart bar',0,1,1.4667,'Y626316',1),(3640,'your chart line','your chart line',0,1,1.5,'Y626345',1),(3641,'your chart pie','your chart pie',0,1,1.4667,'Y62631',1),(3642,'your clock','your clock',0,1,1.3333,'Y6242',1),(3643,'your clock goes','your clock goes',0,1,1.5,'Y6242',1),(3644,'your clock message','your clock message',0,1,1.6,'Y624252',1),(3645,'your code','your code',0,1,1.3,'Y623',1),(3646,'your code div','your code div',0,1,1.4333,'Y6231',1),(3647,'your coffe','your coffe',0,1,1.3333,'Y621',1),(3648,'your coffe message','your coffe message',0,1,1.6,'Y62152',1),(3649,'your cog','your cog',0,1,1.2667,'Y620',1),(3650,'your cog message','your cog message',0,1,1.5333,'Y6252',1),(3651,'your coins','your coins',0,1,1.3333,'Y6252',1),(3652,'your coins message','your coins message',0,1,1.6,'Y625252',1),(3653,'your compress','your compress',0,1,1.4333,'Y625162',1),(3654,'your compress goes','your compress goes',0,1,1.6,'Y625162',1),(3655,'your computer','your computer',0,1,1.4333,'Y625136',1),(3656,'your computer message','your computer message',0,1,1.7,'Y62513652',1),(3657,'your config','your config',0,1,1.3667,'Y62512',1),(3658,'your config message','your config message',0,1,1.6333,'Y6251252',1),(3659,'your configuration','your configuration',0,1,1.6,'Y62512635',1),(3660,'your configuration message','your configuration message',0,1,1.8667,'Y625126352',1),(3661,'your contact','your contact',0,1,1.4,'Y625323',1),(3662,'your contact message','your contact message',0,1,1.6667,'Y62532352',1),(3663,'your creditcart','your creditcart',0,1,1.5,'Y6263263',1),(3664,'your creditcart message','your creditcart message',0,1,1.7667,'Y626326352',1),(3665,'your cross','your cross',0,1,1.3333,'Y6262',1),(3666,'your cross message','your cross message',0,1,1.6,'Y626252',1),(3667,'your disk','your disk',0,1,1.3,'Y632',1),(3668,'your disk goes','your disk goes',0,1,1.4667,'Y632',1),(3669,'your email','your email',0,1,1.3333,'Y654',1),(3670,'your email message','your email message',0,1,1.6,'Y65452',1),(3671,'your error','your error',0,1,1.3333,'Y600',1),(3672,'your error message','your error message',0,1,1.6,'Y652',1),(3673,'your exclamation','your exclamation',0,1,1.5333,'Y624535',1),(3674,'your exclamation message','your exclamation message',0,1,1.8,'Y6245352',1),(3675,'your facebook','your facebook',0,1,1.4333,'Y61212',1),(3676,'your facebook message','your facebook message',0,1,1.7,'Y6121252',1),(3677,'your feed','your feed',0,1,1.3,'Y613',1),(3678,'your feed goes','your feed goes',0,1,1.4667,'Y6132',1),(3679,'your feed message','your feed message',0,1,1.5667,'Y61352',1),(3680,'your file','your file',0,1,1.3,'Y614',1),(3681,'your file h4','your file h4',0,1,1.4,'Y614',1),(3682,'your film','your film',0,1,1.3,'Y6145',1),(3683,'your film goes','your film goes',0,1,1.4667,'Y61452',1),(3684,'your folder','your folder',0,1,1.3667,'Y61436',1),(3685,'your folder message','your folder message',0,1,1.6333,'Y6143652',1),(3686,'your group','your group',0,1,1.3333,'Y6261',1),(3687,'your group message','your group message',0,1,1.6,'Y626152',1),(3688,'your heart','your heart',0,1,1.3333,'Y630',1),(3689,'your heart goes','your heart goes',0,1,1.5,'Y632',1),(3690,'your help','your help',0,1,1.3,'Y641',1),(3691,'your help message','your help message',0,1,1.5667,'Y64152',1),(3692,'your highlight','your highlight',0,1,1.4667,'Y62423',1),(3693,'your highlight phrase','your highlight phrase',0,1,1.7,'Y62423162',1),(3694,'your house','your house',0,1,1.3333,'Y620',1),(3695,'your house message','your house message',0,1,1.6,'Y6252',1),(3696,'your image','your image',0,1,1.3333,'Y652',1),(3697,'your image message','your image message',0,1,1.6,'Y65252',1),(3698,'your images','your images',0,1,1.3667,'Y652',1),(3699,'your images message','your images message',0,1,1.6333,'Y65252',1),(3700,'your info','your info',0,1,1.3,'Y651',1),(3701,'your info message','your info message',0,1,1.5667,'Y65152',1),(3702,'your inforation','your inforation',0,1,1.5,'Y651635',1),(3703,'your inforation message','your inforation message',0,1,1.7667,'Y6516352',1),(3704,'your information','your information',0,1,1.5333,'Y6516535',1),(3705,'your information message','your information message',0,1,1.8,'Y65165352',1),(3706,'your like','your like',0,1,1.3,'Y642',1),(3707,'your like it','your like it',0,1,1.4,'Y6423',1),(3708,'your lock','your lock',0,1,1.3,'Y642',1),(3709,'your lock message','your lock message',0,1,1.5667,'Y64252',1),(3710,'your magnifier','your magnifier',0,1,1.4667,'Y652516',1),(3711,'your magnifier message','your magnifier message',0,1,1.7333,'Y65251652',1),(3712,'your money','your money',0,1,1.3333,'Y650',1),(3713,'your money goes','your money goes',0,1,1.5,'Y652',1),(3714,'your money message','your money message',0,1,1.6,'Y652',1),(3715,'your movie','your movie',0,1,1.3333,'Y651',1),(3716,'your movie message','your movie message',0,1,1.6,'Y65152',1),(3717,'your new','your new',0,1,1.2667,'Y650',1),(3718,'your new message','your new message',0,1,1.5333,'Y652',1),(3719,'your note','your note',0,1,1.3,'Y653',1),(3720,'your note message','your note message',0,1,1.5667,'Y65352',1),(3721,'your own','your own',0,1,1.2667,'Y650',3),(3722,'your own and','your own and',0,1,1.4,'Y653',1),(3723,'your own critical','your own critical',0,1,1.5667,'Y6526324',1),(3724,'your own css','your own css',0,1,1.4,'Y652',1),(3725,'your own help','your own help',0,1,1.4333,'Y6541',1),(3726,'your own highlights','your own highlights',0,1,1.6333,'Y6524232',1),(3727,'your own information','your own information',0,1,1.6667,'Y6516535',1),(3728,'your page','your page',0,1,1.3,'Y612',1),(3729,'your page goes','your page goes',0,1,1.4667,'Y612',1),(3730,'your page message','your page message',0,1,1.5667,'Y61252',1),(3731,'your page white','your page white',0,1,1.5,'Y6123',1),(3732,'your plugin','your plugin',0,1,1.3667,'Y61425',1),(3733,'your plugin message','your plugin message',0,1,1.6333,'Y614252',1),(3734,'your printer','your printer',0,1,1.4,'Y616536',1),(3735,'your printer message','your printer message',0,1,1.6667,'Y61653652',1),(3736,'your quoted','your quoted',0,1,1.3667,'Y623',1),(3737,'your quoted text','your quoted text',0,1,1.5333,'Y62323',1),(3738,'your report','your report',0,1,1.3667,'Y6163',1),(3739,'your report message','your report message',0,1,1.6333,'Y616352',1),(3740,'your script','your script',0,1,1.3667,'Y62613',1),(3741,'your script goes','your script goes',0,1,1.5333,'Y626132',1),(3742,'your star','your star',0,1,1.3,'Y6236',1),(3743,'your star message','your star message',0,1,1.5667,'Y623652',1),(3744,'your telephone','your telephone',0,1,1.4667,'Y63415',1),(3745,'your telephone message','your telephone message',0,1,1.7333,'Y634152',1),(3746,'your time','your time',0,1,1.3,'Y635',1),(3747,'your time message','your time message',0,1,1.5667,'Y6352',1),(3748,'your tips','your tips',0,1,1.3,'Y6312',1),(3749,'your tips goes','your tips goes',0,1,1.4667,'Y6312',1),(3750,'your twitter','your twitter',0,1,1.4,'Y636',1),(3751,'your twitter message','your twitter message',0,1,1.6667,'Y63652',1),(3752,'your user','your user',0,1,1.3,'Y626',1),(3753,'your user message','your user message',0,1,1.5667,'Y62652',1),(3754,'your video','your video',0,1,1.3333,'Y613',1),(3755,'your video message','your video message',0,1,1.6,'Y61352',1),(3756,'your warning','your warning',0,1,1.4,'Y652',1),(3757,'your warning message','your warning message',0,1,1.6667,'Y65252',1),(3758,'your webcam','your webcam',0,1,1.3667,'Y6125',1),(3759,'your webcam goes','your webcam goes',0,1,1.5333,'Y61252',1),(3760,'your world','your world',0,1,1.3333,'Y643',1),(3761,'your world goes','your world goes',0,1,1.5,'Y6432',1),(3762,'your world message','your world message',0,1,1.6,'Y64352',1),(3763,'your youtube','your youtube',0,1,1.4,'Y631',1),(3764,'your youtube message','your youtube message',0,1,1.6667,'Y63152',1),(3765,'youtube','youtube',0,0,0.4667,'Y310',1),(3766,'youtube message','youtube message',0,1,1.5,'Y3152',1),(3767,'youtube message goes','youtube message goes',0,1,1.6667,'Y3152',1),(3768,'youtube message use','youtube message use',0,1,1.6333,'Y3152',1),(3769,'ythis','ythis',0,0,0.3333,'Y320',1),(3770,'ythis is','ythis is',0,1,1.2667,'Y320',1),(3771,'ythis is a','ythis is a',0,1,1.3333,'Y320',1),(3772,'module','module',0,0,0.4,'M340',2),(3773,'module positions','module positions',0,1,1.5333,'M3412352',1),(3774,'positions','positions',0,0,0.6,'P2352',1),(3775,'a message','a message',0,1,1.3,'A520',1),(3776,'a message type','a message type',0,1,1.4667,'A5231',1),(3777,'a sample message','a sample message',0,1,1.5333,'A251452',1),(3778,'about joomla','about joomla',0,1,1.4,'A13254',1),(3779,'about joomla system','about joomla system',0,1,1.6333,'A13254235',1),(3780,'as follows','as follows',0,1,1.3333,'A2142',1),(3781,'as follows error','as follows error',0,1,1.5333,'A21426',1),(3782,'creatings','creatings',0,0,0.6,'C6352',1),(3783,'creatings standard','creatings standard',0,1,1.6,'C635235363',1),(3784,'creatings standard information','creatings standard information',0,1,2,'C635235363516535',1),(3785,'depending','depending',0,0,0.6,'D15352',1),(3786,'depending on','depending on',0,1,1.4,'D153525',1),(3787,'depending on a','depending on a',0,1,1.4667,'D153525',1),(3788,'different','different',0,0,0.6,'D1653',5),(3789,'different types','different types',0,1,1.5,'D165312',1),(3790,'different types of','different types of',0,1,1.6,'D1653121',1),(3791,'error this','error this',0,1,1.3333,'E632',1),(3792,'error this is','error this is',0,1,1.4333,'E632',1),(3793,'follows','follows',0,0,0.4667,'F420',1),(3794,'follows error','follows error',0,1,1.4333,'F426',1),(3795,'follows error this','follows error this',0,1,1.6,'F42632',1),(3796,'information about','information about',0,1,1.5667,'I51653513',1),(3797,'information about joomla','information about joomla',0,1,1.8,'I51653513254',1),(3798,'is presented','is presented',0,1,1.4,'I216253',1),(3799,'is presented depending','is presented depending',0,1,1.7333,'I21625315352',1),(3800,'joomla offers','joomla offers',0,1,1.4333,'J54162',1),(3801,'joomla offers three','joomla offers three',0,1,1.6333,'J5416236',1),(3802,'joomla system','joomla system',0,1,1.4333,'J54235',1),(3803,'joomla system is','joomla system is',0,1,1.5333,'J542352',1),(3804,'message error','message error',0,1,1.4333,'M260',1),(3805,'message error this','message error this',0,1,1.6,'M2632',1),(3806,'message type','message type',0,1,1.4,'M231',1),(3807,'message type as','message type as',0,1,1.5,'M2312',1),(3808,'messages','messages',0,0,0.5333,'M200',1),(3809,'messages creatings','messages creatings',0,1,1.6,'M26352',1),(3810,'messages creatings standard','messages creatings standard',0,1,1.9,'M2635235363',1),(3811,'of messages','of messages',0,1,1.3667,'O152',1),(3812,'of messages creatings','of messages creatings',0,1,1.7,'O1526352',1),(3813,'offers','offers',0,0,0.4,'O162',1),(3814,'offers three','offers three',0,1,1.4,'O16236',1),(3815,'offers three different','offers three different',0,1,1.7333,'O1623631653',1),(3816,'on','on',0,0,0.1333,'O500',6),(3817,'on a','on a',0,1,1.1333,'O500',1),(3818,'on a message','on a message',0,1,1.4,'O520',1),(3819,'presented','presented',0,0,0.6,'P6253',1),(3820,'presented depending','presented depending',0,1,1.6333,'P625315352',1),(3821,'presented depending on','presented depending on',0,1,1.7333,'P6253153525',1),(3822,'sample message','sample message',0,1,1.4667,'S51452',1),(3823,'sample message error','sample message error',0,1,1.6667,'S514526',1),(3824,'standard','standard',0,0,0.5333,'S35363',1),(3825,'standard information','standard information',0,1,1.6667,'S35363516535',1),(3826,'standard information about','standard information about',0,1,1.8667,'S3536351653513',1),(3827,'system','system',0,0,0.4,'S350',2),(3828,'system is','system is',0,1,1.3,'S352',1),(3829,'system is presented','system is presented',0,1,1.6333,'S35216253',1),(3830,'three','three',0,0,0.3333,'T600',5),(3831,'three different','three different',0,1,1.5,'T631653',1),(3832,'three different types','three different types',0,1,1.7,'T63165312',1),(3833,'type','type',0,0,0.2667,'T100',5),(3834,'type as','type as',0,1,1.2333,'T120',1),(3835,'type as follows','type as follows',0,1,1.5,'T12142',1),(3836,'types of messages','types of messages',0,1,1.5667,'T12152',1),(3837,'warning message error','warning message error',0,1,1.7,'W652526',1),(3838,'a retort','a retort',0,1,1.2667,'A6363',3),(3839,'a retort of','a retort of',0,1,1.3667,'A63631',3),(3840,'able to see','able to see',0,1,1.3667,'A1432',3),(3841,'about google','about google',0,1,1.4,'A1324',3),(3842,'about google chrome','about google chrome',0,1,1.6333,'A1324265',3),(3843,'accordance','accordance',0,0,0.6667,'A26352',3),(3844,'accordance with','accordance with',0,1,1.5,'A263523',3),(3845,'accordance with that','accordance with that',0,1,1.6667,'A263523',3),(3846,'all','all',0,0,0.2,'A400',5),(3847,'all facilities','all facilities',0,1,1.4667,'A412432',3),(3848,'all facilities offered','all facilities offered',0,1,1.7333,'A412432163',3),(3849,'all ie','all ie',0,1,1.2,'A400',3),(3850,'all ie users','all ie users',0,1,1.4,'A4262',3),(3851,'along','along',0,0,0.3333,'A452',3),(3852,'along with','along with',0,1,1.3333,'A4523',3),(3853,'along with all','along with all',0,1,1.4667,'A45234',3),(3854,'an appropriate','an appropriate',0,1,1.4667,'A516163',3),(3855,'an appropriate meta','an appropriate meta',0,1,1.6333,'A51616353',3),(3856,'an appropriate option','an appropriate option',0,1,1.7,'A516163135',3),(3857,'and at','and at',0,1,1.2,'A530',3),(3858,'and at the','and at the',0,1,1.3333,'A530',3),(3859,'applying','applying',0,0,0.5333,'A1452',3),(3860,'applying this','applying this',0,1,1.4333,'A145232',3),(3861,'applying this plug-in','applying this plug-in',0,1,1.7,'A1452321425',3),(3862,'appropriate','appropriate',0,0,0.7333,'A16163',3),(3863,'appropriate meta','appropriate meta',0,1,1.5333,'A1616353',3),(3864,'appropriate meta name','appropriate meta name',0,1,1.7,'A16163535',3),(3865,'appropriate option','appropriate option',0,1,1.6,'A16163135',3),(3866,'appropriate option in','appropriate option in',0,1,1.7,'A16163135',3),(3867,'at the','at the',0,1,1.2,'A300',3),(3868,'at the same','at the same',0,1,1.3667,'A325',3),(3869,'be','be',0,0,0.1333,'B000',10),(3870,'be able','be able',0,1,1.2333,'B400',4),(3871,'be able to','be able to',0,1,1.3333,'B430',4),(3872,'be implemented','be implemented',0,1,1.4667,'B51453',3),(3873,'be implemented into','be implemented into',0,1,1.6333,'B5145353',3),(3874,'behind','behind',0,0,0.4,'B530',3),(3875,'behind other','behind other',0,1,1.4,'B536',3),(3876,'behind other internet','behind other internet',0,1,1.7,'B53653653',3),(3877,'benefit','benefit',0,0,0.4667,'B513',3),(3878,'benefit from','benefit from',0,1,1.4,'B513165',3),(3879,'benefit from webkit','benefit from webkit',0,1,1.6333,'B513165123',3),(3880,'browser','browser',0,0,0.4667,'B626',4),(3881,'browser which','browser which',0,1,1.4333,'B6262',3),(3882,'browser which is','browser which is',0,1,1.5333,'B6262',3),(3883,'browsers','browsers',0,0,0.5333,'B6262',3),(3884,'browsers by','browsers by',0,1,1.3667,'B62621',3),(3885,'browsers by applying','browsers by applying',0,1,1.6667,'B62621452',3),(3886,'by applying','by applying',0,1,1.3667,'B452',3),(3887,'by applying this','by applying this',0,1,1.5333,'B45232',3),(3888,'by webkit','by webkit',0,1,1.3,'B230',3),(3889,'by webkit rendering','by webkit rendering',0,1,1.6333,'B23653652',3),(3890,'can benefit','can benefit',0,1,1.3667,'C51513',3),(3891,'can benefit from','can benefit from',0,1,1.5333,'C51513165',3),(3892,'capabilities','capabilities',0,0,0.8,'C1432',3),(3893,'capabilities and','capabilities and',0,1,1.5333,'C143253',3),(3894,'capabilities and at','capabilities and at',0,1,1.6333,'C143253',3),(3895,'chrome','chrome',0,0,0.4,'C650',3),(3896,'chrome chromeframe','chrome chromeframe',0,1,1.6,'C65265165',3),(3897,'chrome chromeframe the','chrome chromeframe the',0,1,1.7333,'C652651653',3),(3898,'chrome frame','chrome frame',0,1,1.4,'C65165',3),(3899,'chrome frame for','chrome frame for',0,1,1.5333,'C6516516',3),(3900,'chrome frame is','chrome frame is',0,1,1.5,'C651652',3),(3901,'chrome frame please','chrome frame please',0,1,1.6333,'C65165142',3),(3902,'chrome frame plug-in','chrome frame plug-in',0,1,1.6667,'C651651425',3),(3903,'chrome-frame-getting-started','chrome-frame-getting-started',0,0,1,'C651652352363',3),(3904,'chrome-frame-getting-started more','chrome-frame-getting-started more',0,1,2,'C65165235236356',3),(3905,'chrome-frame-getting-started more info','chrome-frame-getting-started more info',0,1,2,'C6516523523635651',3),(3906,'chromeframe','chromeframe',0,0,0.7333,'C65165',3),(3907,'chromeframe the','chromeframe the',0,1,1.5,'C651653',3),(3908,'chromeframe the official','chromeframe the official',0,1,1.8,'C651653124',3),(3909,'chromium','chromium',0,0,0.5333,'C650',3),(3910,'chromium org','chromium org',0,1,1.4,'C6562',3),(3911,'chromium org developers','chromium org developers',0,1,1.7667,'C6562314162',3),(3912,'code google','code google',0,1,1.3667,'C324',3),(3913,'code google com','code google com',0,1,1.5,'C32425',3),(3914,'com intl','com intl',0,1,1.2667,'C534',3),(3915,'com intl en-gb','com intl en-gb',0,1,1.4667,'C534521',3),(3916,'company','company',0,0,0.4667,'C515',4),(3917,'company to','company to',0,1,1.3333,'C5153',3),(3918,'company to internet','company to internet',0,1,1.6333,'C515353653',3),(3919,'containing','containing',0,0,0.6667,'C5352',3),(3920,'containing the','containing the',0,1,1.4667,'C53523',3),(3921,'containing the link','containing the link',0,1,1.6333,'C53523452',3),(3922,'contains','contains',0,0,0.5333,'C5352',3),(3923,'contains an','contains an',0,1,1.3667,'C53525',3),(3924,'contains an appropriate','contains an appropriate',0,1,1.7667,'C5352516163',3),(3925,'despite','despite',0,0,0.4667,'D213',3),(3926,'despite the','despite the',0,1,1.3667,'D213',3),(3927,'despite the fact','despite the fact',0,1,1.5333,'D213123',3),(3928,'developers','developers',0,0,0.6667,'D14162',3),(3929,'developers how-tos','developers how-tos',0,1,1.6,'D1416232',3),(3930,'developers how-tos chrome-frame-getting-started','developers how-tos chrome-frame-getting-started',0,1,2,'D1416232651652352363',3),(3931,'do not','do not',0,1,1.2,'D530',4),(3932,'do not loose','do not loose',0,1,1.4,'D5342',3),(3933,'en-gb','en-gb',0,0,0.3333,'E521',3),(3934,'en-gb chrome','en-gb chrome',0,1,1.4,'E521265',3),(3935,'en-gb chrome chromeframe','en-gb chrome chromeframe',0,1,1.8,'E521265265165',3),(3936,'engine','engine',0,0,0.4,'E525',3),(3937,'engine capabilities','engine capabilities',0,1,1.6333,'E52521432',3),(3938,'engine capabilities and','engine capabilities and',0,1,1.7667,'E5252143253',3),(3939,'engine remains','engine remains',0,1,1.4667,'E525652',3),(3940,'engine remains fallen','engine remains fallen',0,1,1.7,'E525652145',3),(3941,'engine to','engine to',0,1,1.3,'E5253',3),(3942,'engine to get','engine to get',0,1,1.4333,'E525323',3),(3943,'explorer','explorer',0,0,0.5333,'E2146',4),(3944,'explorer browser','explorer browser',0,1,1.5333,'E21461626',3),(3945,'explorer browser which','explorer browser which',0,1,1.7333,'E214616262',3),(3946,'explorer interface','explorer interface',0,1,1.6,'E214653612',3),(3947,'explorer interface to','explorer interface to',0,1,1.7,'E2146536123',3),(3948,'facilities','facilities',0,0,0.6667,'F2432',3),(3949,'facilities offered','facilities offered',0,1,1.6,'F2432163',3),(3950,'facilities offered by','facilities offered by',0,1,1.7,'F24321631',3),(3951,'fact','fact',0,0,0.2667,'F230',3),(3952,'fact that','fact that',0,1,1.3,'F230',3),(3953,'fact that its','fact that its',0,1,1.4333,'F232',3),(3954,'fallen','fallen',0,0,0.4,'F450',3),(3955,'fallen behind','fallen behind',0,1,1.4333,'F45153',3),(3956,'fallen behind other','fallen behind other',0,1,1.6333,'F451536',3),(3957,'for developers','for developers',0,1,1.4667,'F6314162',3),(3958,'frame','frame',0,0,0.3333,'F650',3),(3959,'frame for','frame for',0,1,1.3,'F6516',3),(3960,'frame for developers','frame for developers',0,1,1.6667,'F6516314162',3),(3961,'frame is','frame is',0,1,1.2667,'F652',3),(3962,'frame is a','frame is a',0,1,1.3333,'F652',3),(3963,'frame please','frame please',0,1,1.4,'F65142',3),(3964,'frame please visit','frame please visit',0,1,1.6,'F65142123',3),(3965,'frame plug-in','frame plug-in',0,1,1.4333,'F651425',3),(3966,'frame plug-in installed','frame plug-in installed',0,1,1.7667,'F6514252343',3),(3967,'from','from',0,0,0.2667,'F650',5),(3968,'from webkit','from webkit',0,1,1.3667,'F65123',3),(3969,'from webkit engine','from webkit engine',0,1,1.6,'F65123525',3),(3970,'get know','get know',0,1,1.2667,'G325',3),(3971,'get know more','get know more',0,1,1.4333,'G3256',3),(3972,'google','google',0,0,0.4,'G400',3),(3973,'google chrome','google chrome',0,1,1.4333,'G4265',3),(3974,'google chrome frame','google chrome frame',0,1,1.6333,'G4265165',3),(3975,'google com','google com',0,1,1.3333,'G425',3),(3976,'google com intl','google com intl',0,1,1.5,'G42534',3),(3977,'google company','google company',0,1,1.4667,'G42515',3),(3978,'google company to','google company to',0,1,1.5667,'G425153',3),(3979,'has','has',0,0,0.2,'H200',8),(3980,'has to','has to',0,1,1.2,'H230',7),(3981,'has to be','has to be',0,1,1.3,'H231',3),(3982,'have','have',0,0,0.2667,'H100',10),(3983,'have google','have google',0,1,1.3667,'H124',3),(3984,'have google chrome','have google chrome',0,1,1.6,'H124265',3),(3985,'head','head',0,0,0.2667,'H300',3),(3986,'head section','head section',0,1,1.4,'H3235',3),(3987,'head section of','head section of',0,1,1.5,'H32351',3),(3988,'head section so','head section so',0,1,1.5,'H32352',3),(3989,'helps','helps',0,0,0.3333,'H412',4),(3990,'helps the','helps the',0,1,1.3,'H4123',3),(3991,'helps the user','helps the user',0,1,1.4667,'H412326',3),(3992,'how-tos','how-tos',0,0,0.4667,'H320',3),(3993,'how-tos chrome-frame-getting-started','how-tos chrome-frame-getting-started',0,1,2,'H32651652352363',3),(3994,'how-tos chrome-frame-getting-started more','how-tos chrome-frame-getting-started more',0,1,2,'H3265165235236356',3),(3995,'http','http',0,0,0.2667,'H310',16),(3996,'http code','http code',0,1,1.3,'H3123',3),(3997,'http code google','http code google',0,1,1.5333,'H312324',3),(3998,'http www','http www',0,1,1.2667,'H310',11),(3999,'http www chromium','http www chromium',0,1,1.5667,'H31265',3),(4000,'ie','ie',0,0,0.1333,'I000',4),(4001,'ie users','ie users',0,1,1.2667,'I262',3),(4002,'ie users that','ie users that',0,1,1.4333,'I2623',3),(4003,'implemented','implemented',0,0,0.7333,'I51453',3),(4004,'implemented into','implemented into',0,1,1.5333,'I5145353',3),(4005,'implemented into the','implemented into the',0,1,1.6667,'I5145353',3),(4006,'in accordance','in accordance',0,1,1.4333,'I526352',3),(4007,'in accordance with','in accordance with',0,1,1.6,'I5263523',3),(4008,'in its','in its',0,1,1.2,'I532',3),(4009,'in its settings','in its settings',0,1,1.5,'I532352',3),(4010,'in the','in the',0,1,1.2,'I530',9),(4011,'in the head','in the head',0,1,1.3667,'I530',3),(4012,'info about','info about',0,1,1.3333,'I513',3),(4013,'info about google','info about google',0,1,1.5667,'I51324',3),(4014,'installed','installed',0,0,0.6,'I52343',3),(4015,'installed will','installed will',0,1,1.4667,'I523434',3),(4016,'installed will be','installed will be',0,1,1.5667,'I5234341',3),(4017,'interesting','interesting',0,0,0.7333,'I5362352',3),(4018,'interesting solution','interesting solution',0,1,1.6667,'I5362352435',3),(4019,'interesting solution work','interesting solution work',0,1,1.8333,'I536235243562',3),(4020,'interface','interface',0,0,0.6,'I53612',4),(4021,'interface to','interface to',0,1,1.4,'I536123',3),(4022,'interface to make','interface to make',0,1,1.5667,'I53612352',3),(4023,'internet','internet',0,0,0.5333,'I53653',5),(4024,'internet browsers','internet browsers',0,1,1.5667,'I5365316262',3),(4025,'internet browsers by','internet browsers by',0,1,1.6667,'I53653162621',3),(4026,'internet explorer','internet explorer',0,1,1.5667,'I536532146',4),(4027,'internet explorer browser','internet explorer browser',0,1,1.8333,'I5365321461626',3),(4028,'internet explorer interface','internet explorer interface',0,1,1.9,'I53653214653612',3),(4029,'intl','intl',0,0,0.2667,'I534',3),(4030,'intl en-gb','intl en-gb',0,1,1.3333,'I534521',3),(4031,'intl en-gb chrome','intl en-gb chrome',0,1,1.5667,'I534521265',3),(4032,'into','into',0,0,0.2667,'I530',3),(4033,'into the','into the',0,1,1.2667,'I530',3),(4034,'into the head','into the head',0,1,1.4333,'I530',3),(4035,'is a retort','is a retort',0,1,1.3667,'I26363',3),(4036,'is still','is still',0,1,1.2667,'I234',4),(4037,'is still widely','is still widely',0,1,1.5,'I23434',3),(4038,'its','its',0,0,0.2,'I320',4),(4039,'its rendering','its rendering',0,1,1.4333,'I32653652',3),(4040,'its rendering engine','its rendering engine',0,1,1.6667,'I32653652525',3),(4041,'its settings','its settings',0,1,1.4,'I32352',3),(4042,'its settings that','its settings that',0,1,1.5667,'I323523',3),(4043,'know','know',0,0,0.2667,'K500',7),(4044,'know more','know more',0,1,1.3,'K560',3),(4045,'know more about','know more about',0,1,1.5,'K5613',3),(4046,'link','link',0,0,0.2667,'L520',15),(4047,'link to','link to',0,1,1.2333,'L523',3),(4048,'link to the','link to the',0,1,1.3667,'L523',3),(4049,'loose','loose',0,0,0.3333,'L200',3),(4050,'loose the','loose the',0,1,1.3,'L230',3),(4051,'loose the opportunity','loose the opportunity',0,1,1.7,'L2316353',3),(4052,'make this','make this',0,1,1.3,'M232',4),(4053,'make this interesting','make this interesting',0,1,1.7,'M2325362352',3),(4054,'meta','meta',0,0,0.2667,'M300',3),(4055,'meta name','meta name',0,1,1.3,'M350',3),(4056,'meta name has','meta name has',0,1,1.4333,'M352',3),(4057,'meta name in','meta name in',0,1,1.4,'M350',3),(4058,'more','more',0,0,0.2667,'M600',6),(4059,'more about','more about',0,1,1.3333,'M613',3),(4060,'more about google','more about google',0,1,1.5667,'M61324',3),(4061,'more info','more info',0,1,1.3,'M651',3),(4062,'more info about','more info about',0,1,1.5,'M6513',3),(4063,'name has','name has',0,1,1.2667,'N200',3),(4064,'name has to','name has to',0,1,1.3667,'N230',3),(4065,'name in','name in',0,1,1.2333,'N000',4),(4066,'name in the','name in the',0,1,1.3667,'N300',3),(4067,'not','not',0,0,0.2,'N300',6),(4068,'not loose','not loose',0,1,1.3,'N342',3),(4069,'not loose the','not loose the',0,1,1.4333,'N3423',3),(4070,'of google','of google',0,1,1.3,'O124',3),(4071,'of google company','of google company',0,1,1.5667,'O1242515',3),(4072,'of the visited','of the visited',0,1,1.4667,'O13123',3),(4073,'of using','of using',0,1,1.2667,'O1252',3),(4074,'of using internet','of using internet',0,1,1.5667,'O125253653',3),(4075,'offered','offered',0,0,0.4667,'O163',7),(4076,'offered by','offered by',0,1,1.3333,'O1631',7),(4077,'offered by webkit','offered by webkit',0,1,1.5667,'O163123',3),(4078,'official','official',0,0,0.5333,'O124',3),(4079,'official project\'s','official project',0,1,1.6,'O12416232',3),(4080,'official project\'s web','official project web',0,1,1.7333,'O124162321',3),(4081,'opportunity','opportunity',0,0,0.7333,'O16353',3),(4082,'opportunity of','opportunity of',0,1,1.4667,'O163531',3),(4083,'opportunity of using','opportunity of using',0,1,1.6667,'O163531252',3),(4084,'option','option',0,0,0.4,'O135',3),(4085,'option in','option in',0,1,1.3,'O135',3),(4086,'option in its','option in its',0,1,1.4333,'O13532',3),(4087,'org','org',0,0,0.2,'O620',6),(4088,'org developers','org developers',0,1,1.4667,'O62314162',3),(4089,'org developers how-tos','org developers how-tos',0,1,1.7333,'O6231416232',3),(4090,'other internet','other internet',0,1,1.4667,'O3653653',3),(4091,'other internet browsers','other internet browsers',0,1,1.7667,'O365365316262',3),(4092,'our','our',0,0,0.2,'O600',9),(4093,'our template','our template',0,1,1.4,'O635143',7),(4094,'our template contains','our template contains',0,1,1.7,'O63514325352',3),(4095,'page in','page in',0,1,1.2333,'P250',3),(4096,'page in accordance','page in accordance',0,1,1.6,'P2526352',3),(4097,'please','please',0,0,0.4,'P420',5),(4098,'please visit','please visit',0,1,1.4,'P42123',3),(4099,'please visit http','please visit http',0,1,1.5667,'P421231',3),(4100,'plug-in','plug-in',0,0,0.4667,'P425',8),(4101,'plug-in http','plug-in http',0,1,1.4,'P42531',3),(4102,'plug-in http www','plug-in http www',0,1,1.5333,'P42531',3),(4103,'plug-in installed','plug-in installed',0,1,1.5667,'P4252343',3),(4104,'plug-in installed will','plug-in installed will',0,1,1.7333,'P42523434',3),(4105,'plug-in users','plug-in users',0,1,1.4333,'P425262',3),(4106,'plug-in users can','plug-in users can',0,1,1.5667,'P4252625',3),(4107,'popular','popular',0,0,0.4667,'P460',3),(4108,'popular despite','popular despite',0,1,1.5,'P463213',3),(4109,'popular despite the','popular despite the',0,1,1.6333,'P463213',3),(4110,'project\'s','project',0,0,0.6,'P6232',4),(4111,'project\'s web','project web',0,1,1.4333,'P62321',3),(4112,'project\'s web side','project web side',0,1,1.6,'P6232123',3),(4113,'remains','remains',0,0,0.4667,'R520',3),(4114,'remains fallen','remains fallen',0,1,1.4667,'R52145',3),(4115,'remains fallen behind','remains fallen behind',0,1,1.7,'R52145153',3),(4116,'rendering','rendering',0,0,0.6,'R53652',3),(4117,'rendering engine','rendering engine',0,1,1.5333,'R53652525',3),(4118,'rendering engine remains','rendering engine remains',0,1,1.8,'R53652525652',3),(4119,'rendering engine to','rendering engine to',0,1,1.6333,'R536525253',3),(4120,'retort','retort',0,0,0.4,'R363',3),(4121,'retort of','retort of',0,1,1.3,'R3631',3),(4122,'retort of google','retort of google',0,1,1.5333,'R363124',3),(4123,'same','same',0,0,0.2667,'S500',3),(4124,'same time','same time',0,1,1.3,'S535',3),(4125,'same time do','same time do',0,1,1.4,'S5353',3),(4126,'section','section',0,0,0.4667,'S350',3),(4127,'section of','section of',0,1,1.3333,'S351',3),(4128,'section of the','section of the',0,1,1.4667,'S3513',3),(4129,'section so','section so',0,1,1.3333,'S352',3),(4130,'section so that','section so that',0,1,1.5,'S3523',3),(4131,'see','see',0,0,0.2,'S000',4),(4132,'see the','see the',0,1,1.2333,'S300',3),(4133,'see the web','see the web',0,1,1.3667,'S310',3),(4134,'settings','settings',0,0,0.5333,'S352',3),(4135,'settings that','settings that',0,1,1.4333,'S3523',3),(4136,'settings that helps','settings that helps',0,1,1.6333,'S3523412',3),(4137,'side','side',0,0,0.2667,'S300',3),(4138,'side containing','side containing',0,1,1.5,'S325352',3),(4139,'side containing the','side containing the',0,1,1.6333,'S3253523',3),(4140,'site','site',0,0,0.2667,'S300',6),(4141,'site along','site along',0,1,1.3333,'S3452',3),(4142,'site along with','site along with',0,1,1.5,'S34523',3),(4143,'so that','so that',0,1,1.2333,'S300',3),(4144,'so that all','so that all',0,1,1.3667,'S340',3),(4145,'solution','solution',0,0,0.5333,'S435',3),(4146,'solution work','solution work',0,1,1.4333,'S43562',3),(4147,'solution work an','solution work an',0,1,1.5333,'S435625',3),(4148,'still','still',0,0,0.3333,'S340',4),(4149,'still widely','still widely',0,1,1.4,'S3434',3),(4150,'still widely popular','still widely popular',0,1,1.6667,'S3434146',3),(4151,'switch','switch',0,0,0.4,'S320',3),(4152,'switch the','switch the',0,1,1.3333,'S323',3),(4153,'switch the meta','switch the meta',0,1,1.5,'S32353',3),(4154,'template contains','template contains',0,1,1.5667,'T514325352',3),(4155,'template contains an','template contains an',0,1,1.6667,'T5143253525',3),(4156,'that','that',0,0,0.2667,'T000',10),(4157,'that all','that all',0,1,1.2667,'T400',3),(4158,'that all ie','that all ie',0,1,1.3667,'T400',3),(4159,'that have','that have',0,1,1.3,'T100',3),(4160,'that have google','that have google',0,1,1.5333,'T124',3),(4161,'that helps','that helps',0,1,1.3333,'T412',3),(4162,'that helps the','that helps the',0,1,1.4667,'T4123',3),(4163,'that its','that its',0,1,1.2667,'T200',3),(4164,'that its rendering','that its rendering',0,1,1.6,'T2653652',3),(4165,'that our','that our',0,1,1.2667,'T600',4),(4166,'that our template','that our template',0,1,1.5667,'T635143',3),(4167,'the fact','the fact',0,1,1.2667,'T123',3),(4168,'the fact that','the fact that',0,1,1.4333,'T123',3),(4169,'the head','the head',0,1,1.2667,'T000',3),(4170,'the head section','the head section',0,1,1.5333,'T235',3),(4171,'the link','the link',0,1,1.2667,'T452',3),(4172,'the link to','the link to',0,1,1.3667,'T4523',3),(4173,'the meta','the meta',0,1,1.2667,'T530',3),(4174,'the meta name','the meta name',0,1,1.4333,'T535',3),(4175,'the official','the official',0,1,1.4,'T124',3),(4176,'the official project\'s','the official project',0,1,1.7333,'T12416232',3),(4177,'the opportunity','the opportunity',0,1,1.5,'T16353',3),(4178,'the opportunity of','the opportunity of',0,1,1.6,'T163531',3),(4179,'the plug-in','the plug-in',0,1,1.3667,'T1425',3),(4180,'the plug-in http','the plug-in http',0,1,1.5333,'T142531',3),(4181,'the same','the same',0,1,1.2667,'T250',3),(4182,'the same time','the same time',0,1,1.4333,'T2535',3),(4183,'the user','the user',0,1,1.2667,'T260',4),(4184,'the user to','the user to',0,1,1.3667,'T263',3),(4185,'the visited','the visited',0,1,1.3667,'T123',3),(4186,'the visited page','the visited page',0,1,1.5333,'T12312',3),(4187,'the web','the web',0,1,1.2333,'T100',4),(4188,'the web site','the web site',0,1,1.4,'T123',4),(4189,'this interesting','this interesting',0,1,1.5333,'T25362352',3),(4190,'this interesting solution','this interesting solution',0,1,1.8333,'T25362352435',3),(4191,'this plug-in','this plug-in',0,1,1.4,'T21425',3),(4192,'this plug-in users','this plug-in users',0,1,1.6,'T21425262',3),(4193,'time do','time do',0,1,1.2333,'T530',3),(4194,'time do not','time do not',0,1,1.3667,'T5353',3),(4195,'to be','to be',0,1,1.1667,'T100',4),(4196,'to be implemented','to be implemented',0,1,1.5667,'T151453',3),(4197,'to get know','to get know',0,1,1.3667,'T2325',3),(4198,'to internet','to internet',0,1,1.3667,'T53653',3),(4199,'to internet explorer','to internet explorer',0,1,1.6667,'T536532146',3),(4200,'to make this','to make this',0,1,1.4,'T5232',3),(4201,'to see','to see',0,1,1.2,'T200',3),(4202,'to see the','to see the',0,1,1.3333,'T230',3),(4203,'to switch','to switch',0,1,1.3,'T232',3),(4204,'to switch the','to switch the',0,1,1.4333,'T2323',3),(4205,'to the','to the',0,1,1.2,'T000',6),(4206,'to the plug-in','to the plug-in',0,1,1.4667,'T1425',3),(4207,'user to','user to',0,1,1.2333,'U263',3),(4208,'user to switch','user to switch',0,1,1.4667,'U263232',3),(4209,'users','users',0,0,0.3333,'U262',5),(4210,'users can','users can',0,1,1.3,'U2625',4),(4211,'users can benefit','users can benefit',0,1,1.5667,'U26251513',3),(4212,'users that','users that',0,1,1.3333,'U2623',4),(4213,'users that have','users that have',0,1,1.5,'U26231',3),(4214,'using internet','using internet',0,1,1.4667,'U25253653',3),(4215,'using internet explorer','using internet explorer',0,1,1.7667,'U252536532146',3),(4216,'visit','visit',0,0,0.3333,'V230',3),(4217,'visit http','visit http',0,1,1.3333,'V231',3),(4218,'visit http code','visit http code',0,1,1.5,'V23123',3),(4219,'visited','visited',0,0,0.4667,'V230',3),(4220,'visited page','visited page',0,1,1.4,'V2312',3),(4221,'visited page in','visited page in',0,1,1.5,'V23125',3),(4222,'web','web',0,0,0.2,'W100',18),(4223,'web side','web side',0,1,1.2667,'W123',3),(4224,'web side containing','web side containing',0,1,1.6333,'W12325352',3),(4225,'web site','web site',0,1,1.2667,'W123',5),(4226,'web site along','web site along',0,1,1.4667,'W123452',3),(4227,'webkit','webkit',0,0,0.4,'W123',3),(4228,'webkit engine','webkit engine',0,1,1.4333,'W123525',3),(4229,'webkit engine capabilities','webkit engine capabilities',0,1,1.8667,'W12352521432',3),(4230,'webkit rendering','webkit rendering',0,1,1.5333,'W123653652',3),(4231,'webkit rendering engine','webkit rendering engine',0,1,1.7667,'W123653652525',3),(4232,'which is','which is',0,1,1.2667,'W200',3),(4233,'which is still','which is still',0,1,1.4667,'W234',3),(4234,'widely','widely',0,0,0.4,'W340',3),(4235,'widely popular','widely popular',0,1,1.4667,'W34146',3),(4236,'widely popular despite','widely popular despite',0,1,1.7333,'W341463213',3),(4237,'will','will',0,0,0.2667,'W400',4),(4238,'will be','will be',0,1,1.2333,'W410',3),(4239,'will be able','will be able',0,1,1.4,'W414',3),(4240,'with all','with all',0,1,1.2667,'W340',3),(4241,'with all facilities','with all facilities',0,1,1.6333,'W3412432',3),(4242,'with that','with that',0,1,1.3,'W300',3),(4243,'with that our','with that our',0,1,1.4333,'W360',3),(4244,'work','work',0,0,0.2667,'W620',3),(4245,'work an','work an',0,1,1.2333,'W625',3),(4246,'work an appropriate','work an appropriate',0,1,1.6333,'W62516163',3),(4247,'www','www',0,0,0.2,'W000',12),(4248,'www chromium','www chromium',0,1,1.4,'W265',3),(4249,'www chromium org','www chromium org',0,1,1.5333,'W26562',3),(4250,'a particular','a particular',0,1,1.4,'A163246',4),(4251,'a particular template','a particular template',0,1,1.7,'A16324635143',4),(4252,'a plug-in','a plug-in',0,1,1.3,'A1425',4),(4253,'a plug-in which','a plug-in which',0,1,1.5,'A14252',4),(4254,'a user','a user',0,1,1.2,'A260',4),(4255,'a user has','a user has',0,1,1.3333,'A262',4),(4256,'additional','additional',0,0,0.6667,'A354',5),(4257,'additional functionality','additional functionality',0,1,1.8,'A3541523543',4),(4258,'additional functionality offered','additional functionality offered',0,1,2,'A3541523543163',4),(4259,'an additional','an additional',0,1,1.4333,'A5354',4),(4260,'an additional functionality','an additional functionality',0,1,1.9,'A53541523543',4),(4261,'be found','be found',0,1,1.2667,'B530',4),(4262,'be found in','be found in',0,1,1.3667,'B535',4),(4263,'by gk','by gk',0,1,1.1667,'B200',4),(4264,'by gk menu','by gk menu',0,1,1.3333,'B250',4),(4265,'can be','can be',0,1,1.2,'C510',4),(4266,'can be found','can be found',0,1,1.4,'C5153',4),(4267,'characteristic','characteristic',0,0,0.9333,'C6236232',4),(4268,'characteristic it','characteristic it',0,1,1.5667,'C62362323',4),(4269,'characteristic it is','characteristic it is',0,1,1.6667,'C623623232',4),(4270,'different characteristic','different characteristic',0,1,1.8,'D165326236232',4),(4271,'different characteristic it','different characteristic it',0,1,1.9,'D1653262362323',4),(4272,'dropline','dropline',0,0,0.5333,'D6145',4),(4273,'dropline menu','dropline menu',0,1,1.4333,'D6145',4),(4274,'dropline menu split','dropline menu split',0,1,1.6333,'D61452143',4),(4275,'each','each',0,0,0.2667,'E200',4),(4276,'each of','each of',0,1,1.2333,'E210',4),(4277,'each of these','each of these',0,1,1.4333,'E2132',4),(4278,'found','found',0,0,0.3333,'F530',4),(4279,'found in','found in',0,1,1.2667,'F535',4),(4280,'found in the','found in the',0,1,1.4,'F5353',4),(4281,'functionality','functionality',0,0,0.8667,'F523543',4),(4282,'functionality offered','functionality offered',0,1,1.7,'F523543163',4),(4283,'functionality offered by','functionality offered by',0,1,1.8,'F5235431631',4),(4284,'gain','gain',0,0,0.2667,'G500',4),(4285,'gain an','gain an',0,1,1.2333,'G500',4),(4286,'gain an additional','gain an additional',0,1,1.6,'G5354',4),(4287,'gk','gk',0,0,0.1333,'G000',4),(4288,'gk menu','gk menu',0,1,1.2333,'G500',4),(4289,'gk menu a','gk menu a',0,1,1.3,'G500',4),(4290,'gk menu dropline','gk menu dropline',0,1,1.5333,'G536145',4),(4291,'has different','has different',0,1,1.4333,'H231653',4),(4292,'has different characteristic','has different characteristic',0,1,1.9333,'H23165326236232',4),(4293,'has to install','has to install',0,1,1.4667,'H235234',4),(4294,'important','important',0,0,0.6,'I516353',6),(4295,'important to','important to',0,1,1.4,'I516353',4),(4296,'important to know','important to know',0,1,1.5667,'I51635325',4),(4297,'in order','in order',0,1,1.2667,'I5636',4),(4298,'in order to','in order to',0,1,1.3667,'I56363',4),(4299,'in the rest-files','in the rest-files',0,1,1.5667,'I53623142',4),(4300,'install','install',0,0,0.4667,'I5234',4),(4301,'install a','install a',0,1,1.3,'I5234',4),(4302,'install a plug-in','install a plug-in',0,1,1.5667,'I52341425',4),(4303,'is important','is important',0,1,1.4,'I2516353',4),(4304,'is important to','is important to',0,1,1.5,'I2516353',4),(4305,'it is important','it is important',0,1,1.5,'I32516353',4),(4306,'know that','know that',0,1,1.3,'K530',4),(4307,'know that in','know that in',0,1,1.4,'K535',4),(4308,'menu a','menu a',0,1,1.2,'M000',4),(4309,'menu a user','menu a user',0,1,1.3667,'M260',4),(4310,'menu dropline','menu dropline',0,1,1.4333,'M36145',4),(4311,'menu dropline menu','menu dropline menu',0,1,1.6,'M36145',4),(4312,'menu each','menu each',0,1,1.3,'M200',4),(4313,'menu each of','menu each of',0,1,1.4,'M210',4),(4314,'menu split','menu split',0,1,1.3333,'M2143',4),(4315,'menu split menu','menu split menu',0,1,1.5,'M21435',4),(4316,'menu types gk','menu types gk',0,1,1.4333,'M312',4),(4317,'menus','menus',0,0,0.3333,'M200',4),(4318,'menus has','menus has',0,1,1.3,'M200',4),(4319,'menus has different','menus has different',0,1,1.6333,'M231653',4),(4320,'of a particular','of a particular',0,1,1.5,'O163246',4),(4321,'of these','of these',0,1,1.2667,'O132',4),(4322,'of these menus','of these menus',0,1,1.4667,'O13252',4),(4323,'offered by gk','offered by gk',0,1,1.4333,'O16312',4),(4324,'order','order',0,0,0.3333,'O636',4),(4325,'order to','order to',0,1,1.2667,'O6363',4),(4326,'order to gain','order to gain',0,1,1.4333,'O636325',4),(4327,'our template supports','our template supports',0,1,1.7,'O63514321632',4),(4328,'package','package',0,0,0.4667,'P200',4),(4329,'package of','package of',0,1,1.3333,'P210',4),(4330,'package of a','package of a',0,1,1.4,'P210',4),(4331,'particular','particular',0,0,0.6667,'P63246',4),(4332,'particular template','particular template',0,1,1.6333,'P6324635143',4),(4333,'plug-in which','plug-in which',0,1,1.4333,'P4252',4),(4334,'plug-in which can','plug-in which can',0,1,1.5667,'P42525',4),(4335,'rest-files','rest-files',0,0,0.6667,'R23142',4),(4336,'rest-files package','rest-files package',0,1,1.6,'R2314212',4),(4337,'rest-files package of','rest-files package of',0,1,1.7,'R23142121',4),(4338,'split','split',0,0,0.3333,'S143',4),(4339,'split menu','split menu',0,1,1.3333,'S1435',4),(4340,'split menu each','split menu each',0,1,1.5,'S14352',4),(4341,'supports','supports',0,0,0.5333,'S1632',4),(4342,'supports three','supports three',0,1,1.4667,'S163236',4),(4343,'supports three menu','supports three menu',0,1,1.6333,'S1632365',4),(4344,'template supports','template supports',0,1,1.5667,'T514321632',4),(4345,'template supports three','template supports three',0,1,1.7667,'T51432163236',4),(4346,'that in','that in',0,1,1.2333,'T500',4),(4347,'that in order','that in order',0,1,1.4333,'T5636',4),(4348,'the rest-files','the rest-files',0,1,1.4667,'T623142',4),(4349,'the rest-files package','the rest-files package',0,1,1.7333,'T62314212',4),(4350,'these','these',0,0,0.3333,'T200',5),(4351,'these menus','these menus',0,1,1.3667,'T252',4),(4352,'these menus has','these menus has',0,1,1.5,'T252',4),(4353,'three menu','three menu',0,1,1.3333,'T650',4),(4354,'three menu types','three menu types',0,1,1.5333,'T65312',4),(4355,'to gain','to gain',0,1,1.2333,'T250',4),(4356,'to gain an','to gain an',0,1,1.3333,'T250',4),(4357,'to install','to install',0,1,1.3333,'T5234',4),(4358,'to install a','to install a',0,1,1.4,'T5234',4),(4359,'to know','to know',0,1,1.2333,'T250',4),(4360,'to know that','to know that',0,1,1.4,'T253',4),(4361,'types gk','types gk',0,1,1.2667,'T120',4),(4362,'types gk menu','types gk menu',0,1,1.4333,'T125',4),(4363,'user has','user has',0,1,1.2667,'U262',4),(4364,'user has to','user has to',0,1,1.3667,'U2623',4),(4365,'which can','which can',0,1,1.3,'W250',4),(4366,'which can be','which can be',0,1,1.4,'W251',4),(4367,'a enim','a enim',0,1,1.2,'A500',9),(4368,'a enim cras','a enim cras',0,1,1.3667,'A5262',9),(4369,'a facilisis','a facilisis',0,1,1.3667,'A1242',16),(4370,'a facilisis id','a facilisis id',0,1,1.4667,'A12423',9),(4371,'a nec','a nec',0,1,1.1667,'A520',9),(4372,'a nec felis','a nec felis',0,1,1.3667,'A52142',9),(4373,'a tincidunt','a tincidunt',0,1,1.3667,'A352353',9),(4374,'a tincidunt in','a tincidunt in',0,1,1.4667,'A3523535',9),(4375,'ac euismod','ac euismod',0,1,1.3333,'A253',9),(4376,'ac euismod ut','ac euismod ut',0,1,1.4333,'A253',9),(4377,'adipiscing elit duis','adipiscing elit duis',0,1,1.6667,'A31252432',9),(4378,'adipiscing placerat','adipiscing placerat',0,1,1.6333,'A3125214263',9),(4379,'adipiscing placerat commodo','adipiscing placerat commodo',0,1,1.9,'A3125214263253',9),(4380,'aliquam blandit','aliquam blandit',0,1,1.5,'A4251453',9),(4381,'aliquam blandit in','aliquam blandit in',0,1,1.6,'A42514535',9),(4382,'aliquam nunc','aliquam nunc',0,1,1.4,'A4252',9),(4383,'aliquam nunc ut','aliquam nunc ut',0,1,1.5,'A42523',9),(4384,'aliquet ac','aliquet ac',0,1,1.3333,'A4232',9),(4385,'aliquet ac euismod','aliquet ac euismod',0,1,1.6,'A423253',9),(4386,'amet lacus','amet lacus',0,1,1.3333,'A5342',9),(4387,'amet lacus sed','amet lacus sed',0,1,1.4667,'A53423',9),(4388,'amet lacus sit','amet lacus sit',0,1,1.4667,'A53423',9),(4389,'amet nunc','amet nunc',0,1,1.3,'A5352',12),(4390,'amet nunc commodo','amet nunc commodo',0,1,1.5667,'A535253',9),(4391,'amet odio','amet odio',0,1,1.3,'A530',9),(4392,'amet odio vulputate','amet odio vulputate',0,1,1.6333,'A531413',9),(4393,'ante ipsum','ante ipsum',0,1,1.3333,'A53125',9),(4394,'ante ipsum primis','ante ipsum primis',0,1,1.5667,'A531251652',9),(4395,'ante nec','ante nec',0,1,1.2667,'A5352',9),(4396,'ante nec magna','ante nec magna',0,1,1.4667,'A5352525',9),(4397,'at sapien','at sapien',0,1,1.3,'A3215',9),(4398,'at sapien neque','at sapien neque',0,1,1.5,'A32152',9),(4399,'blandit in','blandit in',0,1,1.3333,'B4535',9),(4400,'blandit in at','blandit in at',0,1,1.4333,'B45353',9),(4401,'blandit interdum','blandit interdum',0,1,1.5333,'B45353635',9),(4402,'blandit interdum maecenas','blandit interdum maecenas',0,1,1.8333,'B45353635252',9),(4403,'blandit vel','blandit vel',0,1,1.3667,'B45314',9),(4404,'blandit vel urna','blandit vel urna',0,1,1.5333,'B4531465',9),(4405,'commodo','commodo',0,0,0.4667,'C530',18),(4406,'commodo quis','commodo quis',0,1,1.4,'C532',9),(4407,'commodo quis purus','commodo quis purus',0,1,1.6,'C532162',9),(4408,'commodo tempus','commodo tempus',0,1,1.4667,'C53512',9),(4409,'commodo tempus donec','commodo tempus donec',0,1,1.6667,'C53512352',9),(4410,'consequat etiam','consequat etiam',0,1,1.5,'C5235',9),(4411,'consequat etiam eget','consequat etiam eget',0,1,1.6667,'C523523',9),(4412,'cras quis','cras quis',0,1,1.3,'C620',9),(4413,'cras quis tellus','cras quis tellus',0,1,1.5333,'C62342',9),(4414,'cubilia','cubilia',0,0,0.4667,'C140',9),(4415,'cubilia curae','cubilia curae',0,1,1.4333,'C1426',9),(4416,'cubilia curae donec','cubilia curae donec',0,1,1.6333,'C1426352',9),(4417,'curabitur','curabitur',0,0,0.6,'C6136',22),(4418,'curabitur ut','curabitur ut',0,1,1.4,'C61363',9),(4419,'curabitur ut nisl','curabitur ut nisl',0,1,1.5667,'C61363524',9),(4420,'curae','curae',0,0,0.3333,'C600',9),(4421,'curae donec','curae donec',0,1,1.3667,'C6352',9),(4422,'curae donec malesuada','curae donec malesuada',0,1,1.7,'C63525423',9),(4423,'cursus libero','cursus libero',0,1,1.4333,'C62416',9),(4424,'cursus libero aliquam','cursus libero aliquam',0,1,1.7,'C62416425',9),(4425,'diam neque','diam neque',0,1,1.3333,'D520',9),(4426,'donec eget massa','donec eget massa',0,1,1.5333,'D52352',9),(4427,'donec malesuada','donec malesuada',0,1,1.5,'D525423',9),(4428,'donec malesuada ligula','donec malesuada ligula',0,1,1.7333,'D525423424',9),(4429,'dui nec','dui nec',0,1,1.2333,'D520',12),(4430,'dui nec velit','dui nec velit',0,1,1.4333,'D52143',9),(4431,'duis sit','duis sit',0,1,1.2667,'D230',9),(4432,'duis sit amet','duis sit amet',0,1,1.4333,'D2353',9),(4433,'egestas vestibulum','egestas vestibulum',0,1,1.6,'E232123145',9),(4434,'egestas vestibulum leo','egestas vestibulum leo',0,1,1.7333,'E2321231454',9),(4435,'eget enim','eget enim',0,1,1.3,'E235',9),(4436,'eget enim sit','eget enim sit',0,1,1.4333,'E23523',9),(4437,'eget massa','eget massa',0,1,1.3333,'E2352',9),(4438,'eget massa ut','eget massa ut',0,1,1.4333,'E23523',9),(4439,'eget urna','eget urna',0,1,1.3,'E2365',14),(4440,'eget urna luctus','eget urna luctus',0,1,1.5333,'E23654232',9),(4441,'elementum a','elementum a',0,1,1.3667,'E4535',9),(4442,'elementum a tincidunt','elementum a tincidunt',0,1,1.7,'E4535352353',9),(4443,'elit duis','elit duis',0,1,1.3,'E432',9),(4444,'elit duis sit','elit duis sit',0,1,1.4333,'E4323',9),(4445,'enim cras','enim cras',0,1,1.3,'E5262',9),(4446,'enim cras quis','enim cras quis',0,1,1.4667,'E5262',9),(4447,'enim sit','enim sit',0,1,1.2667,'E523',9),(4448,'enim sit amet','enim sit amet',0,1,1.4333,'E52353',9),(4449,'et justo','et justo',0,1,1.2667,'E323',9),(4450,'et justo placerat','et justo placerat',0,1,1.5667,'E32314263',9),(4451,'et nibh','et nibh',0,1,1.2333,'E351',9),(4452,'et nibh molestie','et nibh molestie',0,1,1.5333,'E3515423',9),(4453,'et purus','et purus',0,1,1.2667,'E3162',9),(4454,'et purus nam','et purus nam',0,1,1.4,'E31625',9),(4455,'et ultrices','et ultrices',0,1,1.3667,'E34362',9),(4456,'et ultrices posuere','et ultrices posuere',0,1,1.6333,'E34362126',9),(4457,'et ultricies','et ultricies',0,1,1.4,'E34362',9),(4458,'et ultricies nec','et ultricies nec',0,1,1.5333,'E3436252',9),(4459,'etiam eget','etiam eget',0,1,1.3333,'E3523',9),(4460,'etiam eget enim','etiam eget enim',0,1,1.5,'E35235',9),(4461,'etiam lorem','etiam lorem',0,1,1.3667,'E35465',9),(4462,'etiam lorem libero','etiam lorem libero',0,1,1.6,'E35465416',9),(4463,'eu tempor','eu tempor',0,1,1.3,'E3516',9),(4464,'eu tempor odio','eu tempor odio',0,1,1.4667,'E35163',9),(4465,'euismod ut','euismod ut',0,1,1.3333,'E253',9),(4466,'euismod ut iaculis','euismod ut iaculis',0,1,1.6,'E253242',9),(4467,'facilisis id','facilisis id',0,1,1.4,'F2423',9),(4468,'facilisis id blandit','facilisis id blandit',0,1,1.6667,'F24231453',9),(4469,'faucibus orci','faucibus orci',0,1,1.4333,'F21262',9),(4470,'faucibus orci luctus','faucibus orci luctus',0,1,1.6667,'F212624232',9),(4471,'felis suspendisse','felis suspendisse',0,1,1.5667,'F421532',9),(4472,'felis suspendisse tortor','felis suspendisse tortor',0,1,1.8,'F4215323636',9),(4473,'fermentum a','fermentum a',0,1,1.3667,'F6535',9),(4474,'fermentum a facilisis','fermentum a facilisis',0,1,1.7,'F65351242',9),(4475,'fringilla aliquam','fringilla aliquam',0,1,1.5667,'F652425',9),(4476,'fringilla aliquam nunc','fringilla aliquam nunc',0,1,1.7333,'F6524252',9),(4477,'gravida','gravida',0,0,0.4667,'G613',22),(4478,'gravida volutpat','gravida volutpat',0,1,1.5333,'G61314313',9),(4479,'gravida volutpat adipiscing','gravida volutpat adipiscing',0,1,1.9,'G613143131252',9),(4480,'hendrerit tempus','hendrerit tempus',0,1,1.5333,'H5363512',9),(4481,'hendrerit tempus nunc','hendrerit tempus nunc',0,1,1.7,'H536351252',9),(4482,'iaculis in','iaculis in',0,1,1.3333,'I2425',9),(4483,'iaculis in orci','iaculis in orci',0,1,1.5,'I242562',9),(4484,'id blandit','id blandit',0,1,1.3333,'I31453',9),(4485,'id blandit vel','id blandit vel',0,1,1.4667,'I3145314',9),(4486,'in at','in at',0,1,1.1667,'I530',9),(4487,'in at sapien','in at sapien',0,1,1.4,'I53215',9),(4488,'in elementum','in elementum',0,1,1.4,'I54535',9),(4489,'in elementum a','in elementum a',0,1,1.4667,'I54535',9),(4490,'in faucibus','in faucibus',0,1,1.3667,'I51212',9),(4491,'in faucibus orci','in faucibus orci',0,1,1.5333,'I5121262',9),(4492,'in in','in in',0,1,1.1667,'I500',9),(4493,'in in nibh','in in nibh',0,1,1.3333,'I510',9),(4494,'in nibh','in nibh',0,1,1.2333,'I510',9),(4495,'in nibh lacus','in nibh lacus',0,1,1.4333,'I5142',9),(4496,'in orci','in orci',0,1,1.2333,'I562',9),(4497,'in orci vestibulum','in orci vestibulum',0,1,1.6,'I562123145',9),(4498,'in turpis','in turpis',0,1,1.3,'I53612',9),(4499,'in turpis curabitur','in turpis curabitur',0,1,1.6333,'I536126136',9),(4500,'interdum maecenas','interdum maecenas',0,1,1.5667,'I53635252',9),(4501,'interdum maecenas lectus','interdum maecenas lectus',0,1,1.8,'I536352524232',9),(4502,'ipsum primis','ipsum primis',0,1,1.4,'I1251652',9),(4503,'ipsum primis in','ipsum primis in',0,1,1.5,'I12516525',9),(4504,'justo placerat','justo placerat',0,1,1.4667,'J314263',9),(4505,'justo placerat vitae','justo placerat vitae',0,1,1.6667,'J31426313',9),(4506,'lacus sed','lacus sed',0,1,1.3,'L230',9),(4507,'lacus sed sed','lacus sed sed',0,1,1.4333,'L2323',9),(4508,'lacus sed tempus','lacus sed tempus',0,1,1.5333,'L23512',9),(4509,'lacus sit','lacus sit',0,1,1.3,'L230',9),(4510,'lacus sit amet','lacus sit amet',0,1,1.4667,'L2353',9),(4511,'lectus nunc','lectus nunc',0,1,1.3667,'L23252',9),(4512,'lectus nunc gravida','lectus nunc gravida',0,1,1.6333,'L23252613',9),(4513,'leo ligula','leo ligula',0,1,1.3333,'L240',9),(4514,'leo ligula volutpat','leo ligula volutpat',0,1,1.6333,'L2414313',9),(4515,'libero aliquam blandit','libero aliquam blandit',0,1,1.7333,'L164251453',9),(4516,'libero et','libero et',0,1,1.3,'L163',9),(4517,'libero et justo','libero et justo',0,1,1.5,'L16323',9),(4518,'libero fermentum','libero fermentum',0,1,1.5333,'L1616535',10),(4519,'libero fermentum a','libero fermentum a',0,1,1.6,'L1616535',9),(4520,'libero venenatis','libero venenatis',0,1,1.5333,'L161532',9),(4521,'libero venenatis in','libero venenatis in',0,1,1.6333,'L1615325',9),(4522,'ligula egestas','ligula egestas',0,1,1.4667,'L24232',9),(4523,'ligula egestas vestibulum','ligula egestas vestibulum',0,1,1.8333,'L24232123145',9),(4524,'ligula eget','ligula eget',0,1,1.3667,'L2423',10),(4525,'ligula eget urna','ligula eget urna',0,1,1.5333,'L242365',9),(4526,'ligula mattis','ligula mattis',0,1,1.4333,'L24532',9),(4527,'ligula mattis pharetra','ligula mattis pharetra',0,1,1.7333,'L245321636',9),(4528,'ligula phasellus','ligula phasellus',0,1,1.5333,'L241242',9),(4529,'ligula phasellus fringilla','ligula phasellus fringilla',0,1,1.8667,'L24124216524',9),(4530,'ligula quam','ligula quam',0,1,1.3667,'L2425',9),(4531,'ligula quam aliquet','ligula quam aliquet',0,1,1.6333,'L2425423',9),(4532,'ligula volutpat','ligula volutpat',0,1,1.5,'L2414313',9),(4533,'ligula volutpat et','ligula volutpat et',0,1,1.6,'L2414313',9),(4534,'lobortis etiam','lobortis etiam',0,1,1.4667,'L163235',9),(4535,'lobortis etiam lorem','lobortis etiam lorem',0,1,1.6667,'L163235465',9),(4536,'lorem libero','lorem libero',0,1,1.4,'L65416',9),(4537,'lorem libero fermentum','lorem libero fermentum',0,1,1.7333,'L6541616535',9),(4538,'luctus et','luctus et',0,1,1.3,'L2323',9),(4539,'luctus et ultrices','luctus et ultrices',0,1,1.6,'L23234362',9),(4540,'luctus eu','luctus eu',0,1,1.3,'L232',9),(4541,'luctus eu tempor','luctus eu tempor',0,1,1.5333,'L2323516',9),(4542,'maecenas','maecenas',0,0,0.5333,'M252',27),(4543,'maecenas lectus','maecenas lectus',0,1,1.5,'M2524232',17),(4544,'maecenas lectus nunc','maecenas lectus nunc',0,1,1.6667,'M252423252',9),(4545,'magna blandit','magna blandit',0,1,1.4333,'M251453',9),(4546,'magna blandit interdum','magna blandit interdum',0,1,1.7333,'M25145353635',9),(4547,'malesuada ligula','malesuada ligula',0,1,1.5333,'M423424',9),(4548,'malesuada ligula eget','malesuada ligula eget',0,1,1.7,'M42342423',9),(4549,'malesuada ligula phasellus','malesuada ligula phasellus',0,1,1.8667,'M4234241242',9),(4550,'massa ut','massa ut',0,1,1.2667,'M230',9),(4551,'massa ut ligula','massa ut ligula',0,1,1.5,'M23424',9),(4552,'mattis pharetra','mattis pharetra',0,1,1.5,'M321636',9),(4553,'mattis pharetra a','mattis pharetra a',0,1,1.5667,'M321636',9),(4554,'mauris vestibulum','mauris vestibulum',0,1,1.5667,'M62123145',9),(4555,'mauris vestibulum vestibulum','mauris vestibulum vestibulum',0,1,1.9333,'M62123145123145',9),(4556,'molestie pretium','molestie pretium',0,1,1.5333,'M4231635',9),(4557,'molestie pretium vel','molestie pretium vel',0,1,1.6667,'M423163514',9),(4558,'morbi ligula','morbi ligula',0,1,1.4,'M61424',9),(4559,'morbi ligula quam','morbi ligula quam',0,1,1.5667,'M6142425',9),(4560,'nam porttitor','nam porttitor',0,1,1.4333,'N1636',9),(4561,'nam porttitor libero','nam porttitor libero',0,1,1.6667,'N1636416',9),(4562,'nec felis','nec felis',0,1,1.3,'N2142',9),(4563,'nec felis suspendisse','nec felis suspendisse',0,1,1.7,'N21421532',9),(4564,'nec magna','nec magna',0,1,1.3,'N2525',9),(4565,'nec magna blandit','nec magna blandit',0,1,1.5667,'N25251453',9),(4566,'nec tempus','nec tempus',0,1,1.3333,'N23512',9),(4567,'nec tempus a','nec tempus a',0,1,1.4,'N23512',9),(4568,'nec velit','nec velit',0,1,1.3,'N2143',9),(4569,'nec velit hendrerit','nec velit hendrerit',0,1,1.6333,'N21435363',9),(4570,'neque quis','neque quis',0,1,1.3333,'N200',17),(4571,'neque quis malesuada','neque quis malesuada',0,1,1.6667,'N25423',9),(4572,'nibh lacus','nibh lacus',0,1,1.3333,'N142',9),(4573,'nibh lacus sed','nibh lacus sed',0,1,1.4667,'N1423',9),(4574,'nibh molestie','nibh molestie',0,1,1.4333,'N15423',9),(4575,'nibh molestie pretium','nibh molestie pretium',0,1,1.7,'N154231635',9),(4576,'nisl','nisl',0,0,0.2667,'N240',25),(4577,'nisl sed','nisl sed',0,1,1.2667,'N2423',9),(4578,'nisl sed mauris','nisl sed mauris',0,1,1.5,'N2423562',9),(4579,'nunc commodo','nunc commodo',0,1,1.4,'N253',9),(4580,'nunc commodo tempus','nunc commodo tempus',0,1,1.6333,'N253512',9),(4581,'nunc gravida','nunc gravida',0,1,1.4,'N2613',9),(4582,'nunc gravida volutpat','nunc gravida volutpat',0,1,1.7,'N261314313',9),(4583,'nunc scelerisque','nunc scelerisque',0,1,1.5333,'N2462',9),(4584,'nunc scelerisque ante','nunc scelerisque ante',0,1,1.7,'N246253',9),(4585,'nunc ut','nunc ut',0,1,1.2333,'N230',9),(4586,'nunc ut volutpat','nunc ut volutpat',0,1,1.5333,'N2314313',9),(4587,'odio consequat','odio consequat',0,1,1.4667,'O32523',9),(4588,'odio consequat etiam','odio consequat etiam',0,1,1.6667,'O325235',9),(4589,'odio vulputate','odio vulputate',0,1,1.4667,'O31413',9),(4590,'odio vulputate lobortis','odio vulputate lobortis',0,1,1.7667,'O3141341632',9),(4591,'orci','orci',0,0,0.2667,'O620',17),(4592,'orci luctus','orci luctus',0,1,1.3667,'O624232',9),(4593,'orci luctus et','orci luctus et',0,1,1.4667,'O6242323',9),(4594,'orci vestibulum','orci vestibulum',0,1,1.5,'O62123145',9),(4595,'orci vestibulum ante','orci vestibulum ante',0,1,1.6667,'O621231453',9),(4596,'pharetra','pharetra',0,0,0.5333,'P636',23),(4597,'pharetra a','pharetra a',0,1,1.3333,'P636',9),(4598,'pharetra a nec','pharetra a nec',0,1,1.4667,'P63652',9),(4599,'phasellus fringilla','phasellus fringilla',0,1,1.6333,'P24216524',9),(4600,'phasellus fringilla aliquam','phasellus fringilla aliquam',0,1,1.9,'P2421652425',9),(4601,'placerat commodo','placerat commodo',0,1,1.5333,'P4263253',9),(4602,'placerat commodo quis','placerat commodo quis',0,1,1.7,'P42632532',9),(4603,'placerat vitae','placerat vitae',0,1,1.4667,'P426313',9),(4604,'placerat vitae sodales','placerat vitae sodales',0,1,1.7333,'P4263132342',9),(4605,'porttitor','porttitor',0,0,0.6,'P636',23),(4606,'porttitor libero','porttitor libero',0,1,1.5333,'P636416',9),(4607,'porttitor libero et','porttitor libero et',0,1,1.6333,'P6364163',9),(4608,'posuere cubilia','posuere cubilia',0,1,1.5,'P26214',9),(4609,'posuere cubilia curae','posuere cubilia curae',0,1,1.7,'P2621426',9),(4610,'pretium vel','pretium vel',0,1,1.3667,'P63514',9),(4611,'pretium vel sit','pretium vel sit',0,1,1.5,'P6351423',9),(4612,'primis','primis',0,0,0.4,'P652',9),(4613,'primis in','primis in',0,1,1.3,'P6525',9),(4614,'primis in faucibus','primis in faucibus',0,1,1.6,'P65251212',9),(4615,'purus morbi','purus morbi',0,1,1.3667,'P62561',9),(4616,'purus morbi ligula','purus morbi ligula',0,1,1.6,'P62561424',9),(4617,'purus nam','purus nam',0,1,1.3,'P625',9),(4618,'purus nam porttitor','purus nam porttitor',0,1,1.6333,'P6251636',9),(4619,'quam aliquet','quam aliquet',0,1,1.4,'Q5423',9),(4620,'quam aliquet ac','quam aliquet ac',0,1,1.5,'Q54232',9),(4621,'quis malesuada','quis malesuada',0,1,1.4667,'Q5423',9),(4622,'quis malesuada ligula','quis malesuada ligula',0,1,1.7,'Q5423424',9),(4623,'quis purus','quis purus',0,1,1.3333,'Q162',9),(4624,'quis purus morbi','quis purus morbi',0,1,1.5333,'Q162561',9),(4625,'quis tellus','quis tellus',0,1,1.3667,'Q342',10),(4626,'quis tellus et','quis tellus et',0,1,1.4667,'Q3423',9),(4627,'quisque tempor','quisque tempor',0,1,1.4667,'Q3516',9),(4628,'quisque tempor cursus','quisque tempor cursus',0,1,1.7,'Q3516262',9),(4629,'right','right',0,0,0.3333,'R230',3),(4630,'right column','right column',0,1,1.4,'R23245',1),(4631,'sapien neque','sapien neque',0,1,1.4,'S152',9),(4632,'sapien neque quis','sapien neque quis',0,1,1.5667,'S152',9),(4633,'scelerisque','scelerisque',0,0,0.7333,'S462',18),(4634,'scelerisque ante','scelerisque ante',0,1,1.5333,'S46253',9),(4635,'scelerisque ante nec','scelerisque ante nec',0,1,1.6667,'S4625352',9),(4636,'sed diam','sed diam',0,1,1.2667,'S350',18),(4637,'sed diam neque','sed diam neque',0,1,1.4667,'S352',9),(4638,'sed mauris','sed mauris',0,1,1.3333,'S3562',9),(4639,'sed mauris vestibulum','sed mauris vestibulum',0,1,1.7,'S3562123145',9),(4640,'sed sed','sed sed',0,1,1.2333,'S323',12),(4641,'sed sed diam','sed sed diam',0,1,1.4,'S3235',9),(4642,'sed tempus dui','sed tempus dui',0,1,1.4667,'S35123',9),(4643,'sit amet lacus','sit amet lacus',0,1,1.4667,'S35342',9),(4644,'sit amet nunc','sit amet nunc',0,1,1.4333,'S35352',12),(4645,'sit amet odio','sit amet odio',0,1,1.4333,'S353',9),(4646,'sodales ligula','sodales ligula',0,1,1.4667,'S342424',9),(4647,'sodales ligula egestas','sodales ligula egestas',0,1,1.7333,'S342424232',9),(4648,'suspendisse tortor','suspendisse tortor',0,1,1.6,'S15323636',9),(4649,'suspendisse tortor libero','suspendisse tortor libero',0,1,1.8333,'S15323636416',9),(4650,'tellus et','tellus et',0,1,1.3,'T423',9),(4651,'tellus et nibh','tellus et nibh',0,1,1.4667,'T42351',9),(4652,'tempor cursus','tempor cursus',0,1,1.4333,'T516262',9),(4653,'tempor cursus libero','tempor cursus libero',0,1,1.6667,'T516262416',9),(4654,'tempor odio','tempor odio',0,1,1.3667,'T5163',9),(4655,'tempor odio consequat','tempor odio consequat',0,1,1.7,'T51632523',9),(4656,'tempus a','tempus a',0,1,1.2667,'T512',9),(4657,'tempus a enim','tempus a enim',0,1,1.4333,'T5125',9),(4658,'tempus donec','tempus donec',0,1,1.4,'T512352',9),(4659,'tempus donec eget','tempus donec eget',0,1,1.5667,'T5123523',9),(4660,'tempus dui','tempus dui',0,1,1.3333,'T5123',9),(4661,'tempus dui nec','tempus dui nec',0,1,1.4667,'T512352',9),(4662,'tempus nunc','tempus nunc',0,1,1.3667,'T51252',9),(4663,'tempus nunc scelerisque','tempus nunc scelerisque',0,1,1.7667,'T51252462',9),(4664,'tincidunt','tincidunt',0,0,0.6,'T52353',25),(4665,'tincidunt in','tincidunt in',0,1,1.4,'T523535',9),(4666,'tincidunt in turpis','tincidunt in turpis',0,1,1.6333,'T5235353612',9),(4667,'tortor libero','tortor libero',0,1,1.4333,'T636416',10),(4668,'tortor libero venenatis','tortor libero venenatis',0,1,1.7667,'T6364161532',9),(4669,'turpis curabitur','turpis curabitur',0,1,1.5333,'T6126136',9),(4670,'turpis curabitur ut','turpis curabitur ut',0,1,1.6333,'T61261363',9),(4671,'ultrices posuere','ultrices posuere',0,1,1.5333,'U4362126',9),(4672,'ultrices posuere cubilia','ultrices posuere cubilia',0,1,1.8,'U4362126214',9),(4673,'ultricies et','ultricies et',0,1,1.4,'U43623',9),(4674,'ultricies et purus','ultricies et purus',0,1,1.6,'U43623162',9),(4675,'ultricies nec','ultricies nec',0,1,1.4333,'U436252',9),(4676,'ultricies nec tempus','ultricies nec tempus',0,1,1.6667,'U4362523512',9),(4677,'urna luctus','urna luctus',0,1,1.3667,'U654232',9),(4678,'urna luctus eu','urna luctus eu',0,1,1.4667,'U654232',9),(4679,'urna quisque','urna quisque',0,1,1.4,'U652',9),(4680,'urna quisque tempor','urna quisque tempor',0,1,1.6333,'U6523516',9),(4681,'ut iaculis','ut iaculis',0,1,1.3333,'U3242',9),(4682,'ut iaculis in','ut iaculis in',0,1,1.4333,'U32425',9),(4683,'ut ligula','ut ligula',0,1,1.3,'U3424',9),(4684,'ut ligula mattis','ut ligula mattis',0,1,1.5333,'U3424532',9),(4685,'ut nisl','ut nisl',0,1,1.2333,'U3524',9),(4686,'ut nisl sed','ut nisl sed',0,1,1.3667,'U352423',9),(4687,'ut volutpat','ut volutpat',0,1,1.3667,'U314313',16),(4688,'ut volutpat in','ut volutpat in',0,1,1.4667,'U3143135',9),(4689,'vel sit','vel sit',0,1,1.2333,'V423',9),(4690,'vel sit amet','vel sit amet',0,1,1.4,'V42353',9),(4691,'vel urna','vel urna',0,1,1.2667,'V465',9),(4692,'vel urna quisque','vel urna quisque',0,1,1.5333,'V4652',9),(4693,'velit hendrerit tempus','velit hendrerit tempus',0,1,1.7333,'V435363512',9),(4694,'venenatis in','venenatis in',0,1,1.4,'V5325',9),(4695,'venenatis in elementum','venenatis in elementum',0,1,1.7333,'V53254535',9),(4696,'vestibulum ante','vestibulum ante',0,1,1.5,'V231453',9),(4697,'vestibulum ante ipsum','vestibulum ante ipsum',0,1,1.7,'V231453125',9),(4698,'vestibulum leo','vestibulum leo',0,1,1.4667,'V231454',15),(4699,'vestibulum leo ligula','vestibulum leo ligula',0,1,1.7,'V23145424',9),(4700,'vestibulum ultricies','vestibulum ultricies',0,1,1.6667,'V231454362',9),(4701,'vestibulum ultricies et','vestibulum ultricies et',0,1,1.7667,'V2314543623',9),(4702,'vestibulum vestibulum','vestibulum vestibulum',0,1,1.7,'V23145123145',10),(4703,'vestibulum vestibulum ultricies','vestibulum vestibulum ultricies',0,1,2,'V231451231454362',9),(4704,'vitae sodales','vitae sodales',0,1,1.4333,'V32342',9),(4705,'vitae sodales ligula','vitae sodales ligula',0,1,1.6667,'V32342424',9),(4706,'volutpat adipiscing','volutpat adipiscing',0,1,1.6333,'V43131252',9),(4707,'volutpat adipiscing placerat','volutpat adipiscing placerat',0,1,1.9333,'V4313125214263',9),(4708,'volutpat et','volutpat et',0,1,1.3667,'V4313',9),(4709,'volutpat et ultricies','volutpat et ultricies',0,1,1.7,'V43134362',9),(4710,'volutpat in','volutpat in',0,1,1.3667,'V43135',10),(4711,'volutpat in in','volutpat in in',0,1,1.4667,'V43135',9),(4712,'vulputate','vulputate',0,0,0.6,'V413',22),(4713,'vulputate lobortis','vulputate lobortis',0,1,1.6,'V41341632',9),(4714,'vulputate lobortis etiam','vulputate lobortis etiam',0,1,1.8,'V4134163235',9),(4715,'columns','columns',0,0,0.4667,'C452',2),(4716,'right two','right two',0,1,1.3,'R230',1),(4717,'right two columns','right two columns',0,1,1.5667,'R232452',1),(4718,'two','two',0,0,0.2,'T000',2),(4719,'two columns','two columns',0,1,1.3667,'T2452',2),(4720,'left column','left column',0,1,1.3667,'L13245',1),(4721,'left two','left two',0,1,1.2667,'L130',1),(4722,'left two columns','left two columns',0,1,1.5333,'L132452',1),(4723,'content','content',0,0,0.4667,'C5353',7),(4724,'content inset','content inset',0,1,1.4333,'C5353523',5),(4725,'content inset left','content inset left',0,1,1.6,'C5353523413',1),(4726,'inset','inset',0,0,0.3333,'I523',5),(4727,'inset left','inset left',0,1,1.3333,'I523413',1),(4728,'content inset right','content inset right',0,1,1.6333,'C5353523623',1),(4729,'inset right','inset right',0,1,1.3667,'I523623',1),(4730,'both','both',0,0,0.2667,'B300',1),(4731,'content inset both','content inset both',0,1,1.6,'C535352313',1),(4732,'inset both','inset both',0,1,1.3333,'I52313',1),(4733,'content inset column','content inset column',0,1,1.6667,'C5353523245',2),(4734,'inset column','inset column',0,1,1.4,'I523245',2),(4735,'2x','2x',0,0,0.1333,'X000',1),(4736,'column 2x','column 2x',0,1,1.3,'C452',1),(4737,'inset column 2x','inset column 2x',0,1,1.5,'I5232452',1),(4738,'about using','about using',0,1,1.3667,'A13252',1),(4739,'about using space','about using space',0,1,1.5667,'A1325212',1),(4740,'ac consectetur','ac consectetur',0,1,1.4667,'A25236',1),(4741,'ac consectetur ac','ac consectetur ac',0,1,1.5667,'A252362',1),(4742,'ac vestibulum','ac vestibulum',0,1,1.4333,'A2123145',1),(4743,'ac vestibulum at','ac vestibulum at',0,1,1.5333,'A21231453',1),(4744,'aenean eu','aenean eu',0,1,1.3,'A500',2),(4745,'aenean eu leo','aenean eu leo',0,1,1.4333,'A540',2),(4746,'aenean lacinia','aenean lacinia',0,1,1.4667,'A5425',1),(4747,'aenean lacinia bibendum','aenean lacinia bibendum',0,1,1.7667,'A54251535',1),(4748,'amet fermentum','amet fermentum',0,1,1.4667,'A5316535',1),(4749,'amet fermentum nullam','amet fermentum nullam',0,1,1.7,'A531653545',1),(4750,'amet non','amet non',0,1,1.2667,'A535',2),(4751,'amet non magna','amet non magna',0,1,1.4667,'A53525',2),(4752,'at beginning','at beginning',0,1,1.4,'A31252',1),(4753,'at beginning of','at beginning of',0,1,1.5,'A312521',1),(4754,'at eget','at eget',0,1,1.2333,'A323',1),(4755,'at eget metus','at eget metus',0,1,1.4333,'A323532',1),(4756,'at eros','at eros',0,1,1.2333,'A362',1),(4757,'at eros donec','at eros donec',0,1,1.4333,'A362352',1),(4758,'at lobortis','at lobortis',0,1,1.3667,'A341632',2),(4759,'at lobortis curabitur','at lobortis curabitur',0,1,1.7,'A3416326136',1),(4760,'auctor fringilla','auctor fringilla',0,1,1.5333,'A23616524',2),(4761,'auctor fringilla aenean','auctor fringilla aenean',0,1,1.7667,'A236165245',1),(4762,'basic','basic',0,0,0.3333,'B200',1),(4763,'basic suffixes','basic suffixes',0,1,1.4667,'B212',1),(4764,'basic suffixes used','basic suffixes used',0,1,1.6333,'B2123',1),(4765,'beginning','beginning',0,0,0.6,'B252',1),(4766,'beginning of','beginning of',0,1,1.4,'B2521',1),(4767,'beginning of suffix','beginning of suffix',0,1,1.6333,'B2521212',1),(4768,'bibendum','bibendum',0,0,0.5333,'B535',4),(4769,'bibendum nulla','bibendum nulla',0,1,1.4667,'B5354',1),(4770,'bibendum nulla sed','bibendum nulla sed',0,1,1.6,'B535423',1),(4771,'blandit sit','blandit sit',0,1,1.3667,'B45323',2),(4772,'blandit sit amet','blandit sit amet',0,1,1.5333,'B4532353',2),(4773,'blandit tempus','blandit tempus',0,1,1.4667,'B453512',2),(4774,'blandit tempus porttitor','blandit tempus porttitor',0,1,1.8,'B4535121636',2),(4775,'can see','can see',0,1,1.2333,'C520',1),(4776,'can see basic','can see basic',0,1,1.4333,'C5212',1),(4777,'consectetur ac','consectetur ac',0,1,1.4667,'C52362',1),(4778,'consectetur ac vestibulum','consectetur ac vestibulum',0,1,1.8333,'C52362123145',1),(4779,'consectetur aenean','consectetur aenean',0,1,1.6,'C52365',1),(4780,'consectetur aenean eu','consectetur aenean eu',0,1,1.7,'C52365',1),(4781,'consectetur est','consectetur est',0,1,1.5,'C523623',2),(4782,'consectetur est at','consectetur est at',0,1,1.6,'C523623',2),(4783,'consectetur purus','consectetur purus',0,1,1.5667,'C5236162',1),(4784,'consectetur purus sit','consectetur purus sit',0,1,1.7,'C52361623',1),(4785,'cras mattis','cras mattis',0,1,1.3667,'C62532',1),(4786,'cras mattis consectetur','cras mattis consectetur',0,1,1.7667,'C625325236',1),(4787,'curabitur blandit','curabitur blandit',0,1,1.5667,'C61361453',2),(4788,'curabitur blandit tempus','curabitur blandit tempus',0,1,1.8,'C61361453512',2),(4789,'diam eget','diam eget',0,1,1.3,'D523',2),(4790,'diam eget risus','diam eget risus',0,1,1.5,'D52362',2),(4791,'donec id','donec id',0,1,1.2667,'D523',1),(4792,'donec id elit','donec id elit',0,1,1.4333,'D52343',1),(4793,'donec ullamcorper','donec ullamcorper',0,1,1.5667,'D52452616',2),(4794,'donec ullamcorper nulla','donec ullamcorper nulla',0,1,1.7667,'D5245261654',2),(4795,'eget metus','eget metus',0,1,1.3333,'E23532',1),(4796,'eget metus cum','eget metus cum',0,1,1.4667,'E235325',1),(4797,'eget metus donec','eget metus donec',0,1,1.5333,'E23532352',1),(4798,'eget risus','eget risus',0,1,1.3333,'E2362',2),(4799,'eget risus varius','eget risus varius',0,1,1.5667,'E2362162',2),(4800,'eget urna mollis','eget urna mollis',0,1,1.5333,'E236542',2),(4801,'elit non','elit non',0,1,1.2667,'E435',1),(4802,'elit non mi','elit non mi',0,1,1.3667,'E435',1),(4803,'eros donec','eros donec',0,1,1.3333,'E62352',1),(4804,'eros donec id','eros donec id',0,1,1.4333,'E623523',1),(4805,'est at','est at',0,1,1.2,'E230',10),(4806,'est at lobortis','est at lobortis',0,1,1.5,'E2341632',2),(4807,'etiam porta','etiam porta',0,1,1.3667,'E35163',1),(4808,'etiam porta sem','etiam porta sem',0,1,1.5,'E3516325',1),(4809,'eu leo','eu leo',0,1,1.2,'E400',3),(4810,'eu leo donec','eu leo donec',0,1,1.4,'E4352',2),(4811,'eu leo quam','eu leo quam',0,1,1.3667,'E425',2),(4812,'euismod cras','euismod cras',0,1,1.4,'E253262',1),(4813,'euismod cras mattis','euismod cras mattis',0,1,1.6333,'E253262532',1),(4814,'euismod semper','euismod semper',0,1,1.4667,'E2532516',2),(4815,'euismod semper curabitur','euismod semper curabitur',0,1,1.8,'E253251626136',2),(4816,'euismod semper sed','euismod semper sed',0,1,1.6,'E253251623',1),(4817,'felis euismod','felis euismod',0,1,1.4333,'F4253',2),(4818,'felis euismod semper','felis euismod semper',0,1,1.6667,'F42532516',2),(4819,'fermentum nullam','fermentum nullam',0,1,1.5333,'F653545',1),(4820,'fermentum nullam quis','fermentum nullam quis',0,1,1.7,'F6535452',1),(4821,'fringilla aenean','fringilla aenean',0,1,1.5333,'F65245',1),(4822,'fringilla aenean lacinia','fringilla aenean lacinia',0,1,1.8,'F65245425',1),(4823,'gravida at','gravida at',0,1,1.3333,'G613',1),(4824,'gravida at eget','gravida at eget',0,1,1.5,'G61323',1),(4825,'id elit','id elit',0,1,1.2333,'I343',2),(4826,'id elit non','id elit non',0,1,1.3667,'I3435',1),(4827,'id ligula','id ligula',0,1,1.3,'I3424',10),(4828,'id ligula porta','id ligula porta',0,1,1.5,'I3424163',2),(4829,'in module','in module',0,1,1.3,'I534',1),(4830,'in module options','in module options',0,1,1.5667,'I5341352',1),(4831,'in this','in this',0,1,1.2333,'I532',1),(4832,'in this template','in this template',0,1,1.5333,'I53235143',1),(4833,'lacinia bibendum','lacinia bibendum',0,1,1.5333,'L251535',1),(4834,'lacinia bibendum nulla','lacinia bibendum nulla',0,1,1.7333,'L2515354',1),(4835,'lacinia quam','lacinia quam',0,1,1.4,'L2525',2),(4836,'lacinia quam venenatis','lacinia quam venenatis',0,1,1.7333,'L25251532',2),(4837,'leo donec','leo donec',0,1,1.3,'L352',2),(4838,'leo donec id','leo donec id',0,1,1.4,'L3523',1),(4839,'leo quam','leo quam',0,1,1.2667,'L250',5),(4840,'leo quam pellentesque','leo quam pellentesque',0,1,1.7,'L2514532',2),(4841,'leo risus','leo risus',0,1,1.3,'L620',1),(4842,'leo risus porta','leo risus porta',0,1,1.5,'L62163',1),(4843,'ligula porta','ligula porta',0,1,1.4,'L24163',2),(4844,'ligula porta felis','ligula porta felis',0,1,1.6,'L24163142',2),(4845,'lobortis curabitur','lobortis curabitur',0,1,1.6,'L16326136',1),(4846,'lobortis curabitur blandit','lobortis curabitur blandit',0,1,1.8667,'L163261361453',1),(4847,'maecenas sed','maecenas sed',0,1,1.4,'M2523',2),(4848,'maecenas sed diam','maecenas sed diam',0,1,1.5667,'M25235',2),(4849,'magna mollis','magna mollis',0,1,1.4,'M2542',4),(4850,'magna mollis euismod','magna mollis euismod',0,1,1.6667,'M254253',1),(4851,'magna morbi','magna morbi',0,1,1.3667,'M2561',1),(4852,'magna morbi leo','magna morbi leo',0,1,1.5,'M25614',1),(4853,'malesuada magna','malesuada magna',0,1,1.5,'M423525',1),(4854,'malesuada magna mollis','malesuada magna mollis',0,1,1.7333,'M42352542',1),(4855,'mattis consectetur','mattis consectetur',0,1,1.6,'M325236',1),(4856,'mattis consectetur purus','mattis consectetur purus',0,1,1.8,'M325236162',1),(4857,'metus','metus',0,0,0.3333,'M320',13),(4858,'metus auctor','metus auctor',0,1,1.4,'M3236',2),(4859,'metus auctor fringilla','metus auctor fringilla',0,1,1.7333,'M323616524',2),(4860,'metus cum','metus cum',0,1,1.3,'M325',1),(4861,'metus cum sociis','metus cum sociis',0,1,1.5333,'M3252',1),(4862,'metus donec','metus donec',0,1,1.3667,'M32352',1),(4863,'metus donec ullamcorper','metus donec ullamcorper',0,1,1.7667,'M32352452616',1),(4864,'mi','mi',0,0,0.1333,'M000',2),(4865,'mi porta','mi porta',0,1,1.2667,'M163',1),(4866,'mi porta gravida','mi porta gravida',0,1,1.5333,'M1632613',1),(4867,'module options','module options',0,1,1.4667,'M341352',1),(4868,'module options vestibulum','module options vestibulum',0,1,1.8333,'M341352123145',1),(4869,'module variation','module variation',0,1,1.5333,'M341635',1),(4870,'mollis euismod','mollis euismod',0,1,1.4667,'M4253',1),(4871,'mollis euismod cras','mollis euismod cras',0,1,1.6333,'M4253262',1),(4872,'mollis ornare','mollis ornare',0,1,1.4333,'M42656',2),(4873,'mollis ornare vel','mollis ornare vel',0,1,1.5667,'M4265614',2),(4874,'morbi leo','morbi leo',0,1,1.3,'M614',1),(4875,'morbi leo risus','morbi leo risus',0,1,1.5,'M61462',1),(4876,'mus maecenas','mus maecenas',0,1,1.4,'M25252',2),(4877,'mus maecenas sed','mus maecenas sed',0,1,1.5333,'M252523',1),(4878,'name in module','name in module',0,1,1.4667,'N340',1),(4879,'non magna','non magna',0,1,1.3,'N250',2),(4880,'non magna morbi','non magna morbi',0,1,1.5,'N2561',1),(4881,'non metus','non metus',0,1,1.3,'N320',2),(4882,'non metus auctor','non metus auctor',0,1,1.5333,'N3236',2),(4883,'non mi','non mi',0,1,1.2,'N000',1),(4884,'non mi porta','non mi porta',0,1,1.4,'N163',1),(4885,'nulla non','nulla non',0,1,1.3,'N450',2),(4886,'nulla non metus','nulla non metus',0,1,1.5,'N4532',2),(4887,'nulla sed','nulla sed',0,1,1.3,'N423',2),(4888,'nulla sed consectetur','nulla sed consectetur',0,1,1.7,'N42325236',1),(4889,'nullam quis','nullam quis',0,1,1.3667,'N452',2),(4890,'nullam quis risus','nullam quis risus',0,1,1.5667,'N45262',2),(4891,'of suffix','of suffix',0,1,1.3,'O1212',1),(4892,'of suffix name','of suffix name',0,1,1.4667,'O12125',1),(4893,'on this','on this',0,1,1.2333,'O532',1),(4894,'on this page','on this page',0,1,1.4,'O53212',1),(4895,'options','options',0,0,0.4667,'O1352',3),(4896,'options vestibulum','options vestibulum',0,1,1.6,'O1352123145',1),(4897,'options vestibulum id','options vestibulum id',0,1,1.7,'O13521231453',1),(4898,'ornare sem','ornare sem',0,1,1.3333,'O65625',2),(4899,'ornare sem lacinia','ornare sem lacinia',0,1,1.6,'O65625425',2),(4900,'ornare vel','ornare vel',0,1,1.3333,'O65614',2),(4901,'ornare vel eu','ornare vel eu',0,1,1.4333,'O65614',2),(4902,'page you','page you',0,1,1.2667,'P200',1),(4903,'page you can','page you can',0,1,1.4,'P250',1),(4904,'pellentesque','pellentesque',0,0,0.8,'P4532',15),(4905,'pellentesque ornare','pellentesque ornare',0,1,1.6333,'P4532656',2),(4906,'pellentesque ornare sem','pellentesque ornare sem',0,1,1.7667,'P453265625',2),(4907,'please remember','please remember',0,1,1.5,'P426516',1),(4908,'please remember about','please remember about',0,1,1.7,'P42651613',1),(4909,'porta ac','porta ac',0,1,1.2667,'P632',8),(4910,'porta ac consectetur','porta ac consectetur',0,1,1.6667,'P6325236',1),(4911,'porta felis','porta felis',0,1,1.3667,'P63142',2),(4912,'porta felis euismod','porta felis euismod',0,1,1.6333,'P6314253',2),(4913,'porta gravida','porta gravida',0,1,1.4333,'P632613',1),(4914,'porta gravida at','porta gravida at',0,1,1.5333,'P632613',1),(4915,'porta sem','porta sem',0,1,1.3,'P6325',1),(4916,'porta sem malesuada','porta sem malesuada',0,1,1.6333,'P6325423',1),(4917,'porttitor curabitur','porttitor curabitur',0,1,1.6333,'P63626136',1),(4918,'porttitor curabitur blandit','porttitor curabitur blandit',0,1,1.9,'P636261361453',1),(4919,'porttitor etiam','porttitor etiam',0,1,1.5,'P63635',1),(4920,'porttitor etiam porta','porttitor etiam porta',0,1,1.7,'P63635163',1),(4921,'porttitor nullam','porttitor nullam',0,1,1.5333,'P636545',1),(4922,'porttitor nullam quis','porttitor nullam quis',0,1,1.7,'P6365452',1),(4923,'posuere consectetur','posuere consectetur',0,1,1.6333,'P2625236',2),(4924,'posuere consectetur est','posuere consectetur est',0,1,1.7667,'P262523623',2),(4925,'purus sit','purus sit',0,1,1.3,'P623',1),(4926,'purus sit amet','purus sit amet',0,1,1.4667,'P62353',1),(4927,'quam pellentesque','quam pellentesque',0,1,1.5667,'Q514532',2),(4928,'quam pellentesque ornare','quam pellentesque ornare',0,1,1.8,'Q514532656',2),(4929,'quam venenatis','quam venenatis',0,1,1.4667,'Q51532',2),(4930,'quam venenatis vestibulum','quam venenatis vestibulum',0,1,1.8333,'Q51532123145',2),(4931,'quis risus','quis risus',0,1,1.3333,'Q620',2),(4932,'quis risus eget','quis risus eget',0,1,1.5,'Q623',2),(4933,'remember','remember',0,0,0.5333,'R516',1),(4934,'remember about','remember about',0,1,1.4667,'R51613',1),(4935,'remember about using','remember about using',0,1,1.6667,'R51613252',1),(4936,'ridiculus mus maecenas','ridiculus mus maecenas',0,1,1.7333,'R3242525252',2),(4937,'risus eget','risus eget',0,1,1.3333,'R230',5),(4938,'risus eget urna','risus eget urna',0,1,1.5,'R2365',2),(4939,'risus porta','risus porta',0,1,1.3667,'R2163',1),(4940,'risus porta ac','risus porta ac',0,1,1.4667,'R21632',1),(4941,'risus varius','risus varius',0,1,1.4,'R2162',2),(4942,'risus varius blandit','risus varius blandit',0,1,1.6667,'R21621453',2),(4943,'sed consectetur','sed consectetur',0,1,1.5,'S325236',1),(4944,'sed consectetur aenean','sed consectetur aenean',0,1,1.7333,'S3252365',1),(4945,'sed diam eget','sed diam eget',0,1,1.4333,'S3523',2),(4946,'sed posuere','sed posuere',0,1,1.3667,'S3126',2),(4947,'sed posuere consectetur','sed posuere consectetur',0,1,1.7667,'S312625236',2),(4948,'see basic','see basic',0,1,1.3,'S120',1),(4949,'see basic suffixes','see basic suffixes',0,1,1.6,'S1212',1),(4950,'sem lacinia','sem lacinia',0,1,1.3667,'S5425',2),(4951,'sem lacinia quam','sem lacinia quam',0,1,1.5333,'S542525',2),(4952,'sem malesuada','sem malesuada',0,1,1.4333,'S5423',1),(4953,'sem malesuada magna','sem malesuada magna',0,1,1.6333,'S5423525',1),(4954,'semper curabitur','semper curabitur',0,1,1.5333,'S51626136',2),(4955,'semper curabitur blandit','semper curabitur blandit',0,1,1.8,'S516261361453',2),(4956,'semper sed','semper sed',0,1,1.3333,'S51623',1),(4957,'semper sed posuere','semper sed posuere',0,1,1.6,'S51623126',1),(4958,'sit amet fermentum','sit amet fermentum',0,1,1.6,'S35316535',1),(4959,'sit amet non','sit amet non',0,1,1.4,'S3535',2),(4960,'space','space',0,0,0.3333,'S120',1),(4961,'space at','space at',0,1,1.2667,'S123',1),(4962,'space at beginning','space at beginning',0,1,1.6,'S1231252',1),(4963,'suffix','suffix',0,0,0.4,'S120',1),(4964,'suffix name','suffix name',0,1,1.3667,'S125',1),(4965,'suffix name in','suffix name in',0,1,1.4667,'S125',1),(4966,'suffixes','suffixes',0,0,0.5333,'S120',1),(4967,'suffixes used','suffixes used',0,1,1.4333,'S123',1),(4968,'suffixes used in','suffixes used in',0,1,1.5333,'S1235',1),(4969,'template please','template please',0,1,1.5,'T5143142',1),(4970,'template please remember','template please remember',0,1,1.8,'T51431426516',1),(4971,'tempus porttitor','tempus porttitor',0,1,1.5333,'T5121636',2),(4972,'tempus porttitor curabitur','tempus porttitor curabitur',0,1,1.8667,'T512163626136',1),(4973,'tempus porttitor etiam','tempus porttitor etiam',0,1,1.7333,'T512163635',1),(4974,'tempus porttitor nullam','tempus porttitor nullam',0,1,1.7667,'T5121636545',1),(4975,'this page','this page',0,1,1.3,'T212',1),(4976,'this page you','this page you',0,1,1.4333,'T212',1),(4977,'this template','this template',0,1,1.4333,'T235143',1),(4978,'this template please','this template please',0,1,1.6667,'T235143142',1),(4979,'ullamcorper nulla','ullamcorper nulla',0,1,1.5667,'U45261654',2),(4980,'ullamcorper nulla non','ullamcorper nulla non',0,1,1.7,'U452616545',2),(4981,'urna mollis','urna mollis',0,1,1.3667,'U6542',2),(4982,'urna mollis ornare','urna mollis ornare',0,1,1.6,'U6542656',2),(4983,'used in','used in',0,1,1.2333,'U235',1),(4984,'used in this','used in this',0,1,1.4,'U23532',1),(4985,'using space','using space',0,1,1.3667,'U25212',1),(4986,'using space at','using space at',0,1,1.4667,'U252123',1),(4987,'variation','variation',0,0,0.6,'V635',1),(4988,'varius blandit','varius blandit',0,1,1.4667,'V621453',2),(4989,'varius blandit sit','varius blandit sit',0,1,1.6,'V62145323',2),(4990,'vel eu','vel eu',0,1,1.2,'V400',2),(4991,'vel eu leo','vel eu leo',0,1,1.3333,'V400',2),(4992,'venenatis vestibulum','venenatis vestibulum',0,1,1.6667,'V532123145',2),(4993,'venenatis vestibulum vestibulum','venenatis vestibulum vestibulum',0,1,2,'V532123145123145',1),(4994,'vestibulum at','vestibulum at',0,1,1.4333,'V231453',1),(4995,'vestibulum at eros','vestibulum at eros',0,1,1.6,'V23145362',1),(4996,'vestibulum id','vestibulum id',0,1,1.4333,'V231453',8),(4997,'vestibulum id ligula','vestibulum id ligula',0,1,1.6667,'V231453424',2),(4998,'vestibulum vestibulum id','vestibulum vestibulum id',0,1,1.8,'V231451231453',1),(4999,'you can see','you can see',0,1,1.3667,'Y252',1),(5000,'a erat','a erat',0,1,1.2,'A630',3),(5001,'a erat euismod','a erat euismod',0,1,1.4667,'A63253',3),(5002,'a lorem ipsum','a lorem ipsum',0,1,1.4333,'A465125',3),(5003,'a metus','a metus',0,1,1.2333,'A532',3),(5004,'a metus duis','a metus duis',0,1,1.4,'A53232',3),(5005,'a pharetra','a pharetra',0,1,1.3333,'A1636',4),(5006,'a pharetra leo','a pharetra leo',0,1,1.4667,'A16364',3),(5007,'a quam','a quam',0,1,1.2,'A250',3),(5008,'a quam urna','a quam urna',0,1,1.3667,'A2565',3),(5009,'a turpis','a turpis',0,1,1.2667,'A3612',3),(5010,'a turpis pellentesque','a turpis pellentesque',0,1,1.7,'A361214532',3),(5011,'adipiscing elit fusce','adipiscing elit fusce',0,1,1.7,'A312524312',3),(5012,'adipiscing elit nam','adipiscing elit nam',0,1,1.6333,'A31252435',3),(5013,'adipiscing elit sed','adipiscing elit sed',0,1,1.6333,'A312524323',3),(5014,'adipiscing facilisis','adipiscing facilisis',0,1,1.6667,'A312521242',3),(5015,'adipiscing facilisis est','adipiscing facilisis est',0,1,1.8,'A3125212423',3),(5016,'adipiscing lectus','adipiscing lectus',0,1,1.5667,'A312524232',3),(5017,'adipiscing lectus a','adipiscing lectus a',0,1,1.6333,'A312524232',3),(5018,'adipiscing nec','adipiscing nec',0,1,1.4667,'A3125252',3),(5019,'adipiscing nec nibh','adipiscing nec nibh',0,1,1.6333,'A312525251',3),(5020,'aliquam fermentum','aliquam fermentum',0,1,1.5667,'A42516535',3),(5021,'aliquam fermentum sollicitudin','aliquam fermentum sollicitudin',0,1,2,'A4251653524235',3),(5022,'aliquam tempus','aliquam tempus',0,1,1.4667,'A4253512',3),(5023,'aliquam tempus eu','aliquam tempus eu',0,1,1.5667,'A4253512',3),(5024,'aliquet vel','aliquet vel',0,1,1.3667,'A42314',3),(5025,'aliquet vel nec','aliquet vel nec',0,1,1.5,'A4231452',3),(5026,'amet bibendum','amet bibendum',0,1,1.4333,'A531535',3),(5027,'amet bibendum nam','amet bibendum nam',0,1,1.5667,'A531535',3),(5028,'amet diam','amet diam',0,1,1.3,'A535',3),(5029,'amet diam dapibus','amet diam dapibus',0,1,1.5667,'A535312',3),(5030,'amet laoreet','amet laoreet',0,1,1.4,'A53463',3),(5031,'amet laoreet et','amet laoreet et',0,1,1.5,'A53463',3),(5032,'amet luctus','amet luctus',0,1,1.3667,'A534232',3),(5033,'amet luctus donec','amet luctus donec',0,1,1.5667,'A534232352',3),(5034,'amet nunc cursus','amet nunc cursus',0,1,1.5333,'A535262',3),(5035,'amet volutpat','amet volutpat',0,1,1.4333,'A5314313',3),(5036,'amet volutpat libero','amet volutpat libero',0,1,1.6667,'A5314313416',3),(5037,'archive','archive',0,0,0.4667,'A621',3),(5038,'archive article','archive article',0,1,1.5,'A6216324',3),(5039,'archive article i','archive article i',0,1,1.5667,'A6216324',1),(5040,'arcu auctor','arcu auctor',0,1,1.3667,'A6236',3),(5041,'arcu auctor phasellus','arcu auctor phasellus',0,1,1.7,'A62361242',3),(5042,'arcu morbi','arcu morbi',0,1,1.3333,'A62561',3),(5043,'arcu morbi nec','arcu morbi nec',0,1,1.4667,'A6256152',3),(5044,'article i','article i',0,1,1.3,'A6324',1),(5045,'at consequat','at consequat',0,1,1.4,'A32523',3),(5046,'at consequat neque','at consequat neque',0,1,1.6,'A3252352',3),(5047,'at cursus','at cursus',0,1,1.3,'A3262',3),(5048,'at cursus sed','at cursus sed',0,1,1.4333,'A32623',3),(5049,'at id','at id',0,1,1.1667,'A300',3),(5050,'at id dolor','at id dolor',0,1,1.3667,'A346',3),(5051,'at mattis','at mattis',0,1,1.3,'A3532',3),(5052,'at mattis eget','at mattis eget',0,1,1.4667,'A35323',3),(5053,'at sollicitudin','at sollicitudin',0,1,1.5,'A324235',3),(5054,'at sollicitudin tellus','at sollicitudin tellus',0,1,1.7333,'A324235342',3),(5055,'at vivamus','at vivamus',0,1,1.3333,'A3152',3),(5056,'at vivamus vel','at vivamus vel',0,1,1.4667,'A315214',3),(5057,'auctor phasellus','auctor phasellus',0,1,1.5333,'A2361242',3),(5058,'auctor phasellus volutpat','auctor phasellus volutpat',0,1,1.8333,'A236124214313',3),(5059,'auctor vehicula','auctor vehicula',0,1,1.5,'A236124',3),(5060,'auctor vehicula felis','auctor vehicula felis',0,1,1.7,'A236124142',3),(5061,'augue id laoreet','augue id laoreet',0,1,1.5333,'A23463',3),(5062,'augue porttitor','augue porttitor',0,1,1.5,'A21636',3),(5063,'augue porttitor pulvinar','augue porttitor pulvinar',0,1,1.8,'A2163614156',3),(5064,'augue sit','augue sit',0,1,1.3,'A230',3),(5065,'augue sit amet','augue sit amet',0,1,1.4667,'A2353',3),(5066,'bibendum nam','bibendum nam',0,1,1.4,'B535',3),(5067,'bibendum nam vitae','bibendum nam vitae',0,1,1.6,'B53513',3),(5068,'blandit elit a','blandit elit a',0,1,1.4667,'B45343',3),(5069,'congue at','congue at',0,1,1.3,'C523',3),(5070,'congue at vivamus','congue at vivamus',0,1,1.5667,'C523152',3),(5071,'congue sed','congue sed',0,1,1.3333,'C523',3),(5072,'congue sed arcu','congue sed arcu',0,1,1.5,'C52362',3),(5073,'consequat neque','consequat neque',0,1,1.5,'C52352',3),(5074,'consequat neque viverra','consequat neque viverra',0,1,1.7667,'C5235216',3),(5075,'convallis nisl','convallis nisl',0,1,1.4667,'C5142524',3),(5076,'convallis nisl sit','convallis nisl sit',0,1,1.6,'C514252423',3),(5077,'curabitur vel','curabitur vel',0,1,1.4333,'C613614',10),(5078,'curabitur vel tortor','curabitur vel tortor',0,1,1.6667,'C6136143636',3),(5079,'cursus magna','cursus magna',0,1,1.4,'C62525',4),(5080,'cursus magna dui','cursus magna dui',0,1,1.5333,'C625253',3),(5081,'cursus sed','cursus sed',0,1,1.3333,'C623',3),(5082,'cursus sed tellus','cursus sed tellus',0,1,1.5667,'C62342',3),(5083,'cursus vehicula','cursus vehicula',0,1,1.5,'C62124',3),(5084,'cursus vehicula at','cursus vehicula at',0,1,1.6,'C621243',3),(5085,'dapibus aliquet','dapibus aliquet',0,1,1.5,'D12423',3),(5086,'dapibus aliquet vel','dapibus aliquet vel',0,1,1.6333,'D1242314',3),(5087,'dapibus massa','dapibus massa',0,1,1.4333,'D1252',3),(5088,'dapibus massa id','dapibus massa id',0,1,1.5333,'D12523',3),(5089,'diam dapibus','diam dapibus',0,1,1.4,'D5312',11),(5090,'diam dapibus aliquet','diam dapibus aliquet',0,1,1.6667,'D5312423',3),(5091,'diam eu','diam eu',0,1,1.2333,'D500',3),(5092,'diam eu urna','diam eu urna',0,1,1.4,'D565',3),(5093,'dolor in','dolor in',0,1,1.2667,'D465',3),(5094,'dolor in enim','dolor in enim',0,1,1.4333,'D465',3),(5095,'dolor maecenas','dolor maecenas',0,1,1.4667,'D465252',3),(5096,'dolor maecenas volutpat','dolor maecenas volutpat',0,1,1.7667,'D46525214313',3),(5097,'donec ipsum','donec ipsum',0,1,1.3667,'D52125',3),(5098,'donec ipsum erat','donec ipsum erat',0,1,1.5333,'D5212563',3),(5099,'donec leo','donec leo',0,1,1.3,'D524',3),(5100,'donec leo quam','donec leo quam',0,1,1.4667,'D52425',3),(5101,'donec ornare','donec ornare',0,1,1.4,'D52656',3),(5102,'donec ornare magna','donec ornare magna',0,1,1.6,'D52656525',3),(5103,'dui adipiscing','dui adipiscing',0,1,1.4667,'D1252',3),(5104,'dui adipiscing lectus','dui adipiscing lectus',0,1,1.7,'D12524232',3),(5105,'dui nec pretium','dui nec pretium',0,1,1.5,'D521635',3),(5106,'duis eu','duis eu',0,1,1.2333,'D200',3),(5107,'duis eu vestibulum','duis eu vestibulum',0,1,1.6,'D2123145',3),(5108,'egestas morbi','egestas morbi',0,1,1.4333,'E232561',3),(5109,'egestas morbi non','egestas morbi non',0,1,1.5667,'E2325615',3),(5110,'eget augue','eget augue',0,1,1.3333,'E232',3),(5111,'eget augue porttitor','eget augue porttitor',0,1,1.6667,'E2321636',3),(5112,'eget nisi','eget nisi',0,1,1.3,'E2352',3),(5113,'eget nisi curabitur','eget nisi curabitur',0,1,1.6333,'E23526136',3),(5114,'eget tincidunt','eget tincidunt',0,1,1.4667,'E2352353',3),(5115,'eget tincidunt lorem','eget tincidunt lorem',0,1,1.6667,'E2352353465',3),(5116,'eget urna erat','eget urna erat',0,1,1.4667,'E236563',3),(5117,'elementum eget','elementum eget',0,1,1.4667,'E453523',3),(5118,'elementum eget tincidunt','elementum eget tincidunt',0,1,1.8,'E45352352353',3),(5119,'elit a','elit a',0,1,1.2,'E430',3),(5120,'elit a turpis','elit a turpis',0,1,1.4333,'E43612',3),(5121,'elit fusce','elit fusce',0,1,1.3333,'E4312',3),(5122,'elit fusce ut','elit fusce ut',0,1,1.4333,'E43123',3),(5123,'elit nam','elit nam',0,1,1.2667,'E435',3),(5124,'elit nam quis','elit nam quis',0,1,1.4333,'E4352',3),(5125,'elit sed risus','elit sed risus',0,1,1.4667,'E432362',3),(5126,'elit vitae','elit vitae',0,1,1.3333,'E4313',3),(5127,'elit vitae sem','elit vitae sem',0,1,1.4667,'E431325',3),(5128,'enim in','enim in',0,1,1.2333,'E500',3),(5129,'enim in lacus','enim in lacus',0,1,1.4333,'E542',3),(5130,'enim nisi','enim nisi',0,1,1.3,'E520',3),(5131,'enim nisi venenatis','enim nisi venenatis',0,1,1.6333,'E521532',3),(5132,'enim phasellus','enim phasellus',0,1,1.4667,'E51242',3),(5133,'enim phasellus adipiscing','enim phasellus adipiscing',0,1,1.8333,'E5124231252',3),(5134,'enim quis','enim quis',0,1,1.3,'E520',3),(5135,'enim quis lectus','enim quis lectus',0,1,1.5333,'E524232',3),(5136,'erat et','erat et',0,1,1.2333,'E630',3),(5137,'erat et hendrerit','erat et hendrerit',0,1,1.5667,'E635363',3),(5138,'erat euismod','erat euismod',0,1,1.4,'E63253',3),(5139,'erat euismod egestas','erat euismod egestas',0,1,1.6667,'E63253232',3),(5140,'erat gravida','erat gravida',0,1,1.4,'E632613',3),(5141,'erat gravida sit','erat gravida sit',0,1,1.5333,'E63261323',3),(5142,'est sit','est sit',0,1,1.2333,'E2323',3),(5143,'est sit amet','est sit amet',0,1,1.4,'E232353',3),(5144,'et adipiscing','et adipiscing',0,1,1.4333,'E31252',3),(5145,'et adipiscing nec','et adipiscing nec',0,1,1.5667,'E3125252',3),(5146,'et hendrerit','et hendrerit',0,1,1.4,'E35363',3),(5147,'et hendrerit magna','et hendrerit magna',0,1,1.6,'E35363525',3),(5148,'eu nec','eu nec',0,1,1.2,'E520',3),(5149,'eu nec enim','eu nec enim',0,1,1.3667,'E525',3),(5150,'eu urna','eu urna',0,1,1.2333,'E650',3),(5151,'eu urna fermentum','eu urna fermentum',0,1,1.5667,'E6516535',3),(5152,'eu vestibulum','eu vestibulum',0,1,1.4333,'E123145',3),(5153,'eu vestibulum nisl','eu vestibulum nisl',0,1,1.6,'E12314524',3),(5154,'euismod egestas','euismod egestas',0,1,1.5,'E253232',3),(5155,'euismod egestas morbi','euismod egestas morbi',0,1,1.7,'E253232561',3),(5156,'facilisis at','facilisis at',0,1,1.4,'F2423',3),(5157,'facilisis at mattis','facilisis at mattis',0,1,1.6333,'F2423532',3),(5158,'facilisis est','facilisis est',0,1,1.4333,'F2423',3),(5159,'facilisis est sit','facilisis est sit',0,1,1.5667,'F242323',3),(5160,'faucibus nulla','faucibus nulla',0,1,1.4667,'F21254',3),(5161,'faucibus nulla ut','faucibus nulla ut',0,1,1.5667,'F212543',3),(5162,'faucibus tempor','faucibus tempor',0,1,1.5,'F2123516',3),(5163,'faucibus tempor molestie','faucibus tempor molestie',0,1,1.8,'F21235165423',3),(5164,'felis pellentesque','felis pellentesque',0,1,1.6,'F4214532',3),(5165,'felis pellentesque a','felis pellentesque a',0,1,1.6667,'F4214532',3),(5166,'felis sed mattis','felis sed mattis',0,1,1.5333,'F423532',3),(5167,'felis vel','felis vel',0,1,1.3,'F4214',3),(5168,'felis vel placerat','felis vel placerat',0,1,1.6,'F421414263',3),(5169,'fermentum sed','fermentum sed',0,1,1.4333,'F653523',3),(5170,'fermentum sed porta','fermentum sed porta',0,1,1.6333,'F653523163',3),(5171,'fermentum sollicitudin','fermentum sollicitudin',0,1,1.7333,'F653524235',3),(5172,'fermentum sollicitudin lorem','fermentum sollicitudin lorem',0,1,1.9333,'F653524235465',3),(5173,'feugiat malesuada','feugiat malesuada',0,1,1.5667,'F235423',3),(5174,'feugiat malesuada cursus','feugiat malesuada cursus',0,1,1.8,'F235423262',3),(5175,'fringilla augue','fringilla augue',0,1,1.5,'F65242',3),(5176,'fringilla augue sit','fringilla augue sit',0,1,1.6333,'F652423',3),(5177,'fusce ut','fusce ut',0,1,1.2667,'F230',3),(5178,'fusce ut metus','fusce ut metus',0,1,1.4667,'F23532',3),(5179,'gravida sit','gravida sit',0,1,1.3667,'G61323',3),(5180,'gravida sit amet','gravida sit amet',0,1,1.5333,'G6132353',3),(5181,'hendrerit magna','hendrerit magna',0,1,1.5,'H5363525',3),(5182,'hendrerit magna in','hendrerit magna in',0,1,1.6,'H5363525',3),(5183,'hendrerit nulla','hendrerit nulla',0,1,1.5,'H536354',3),(5184,'id congue','id congue',0,1,1.3,'I3252',3),(5185,'id congue sed','id congue sed',0,1,1.4333,'I32523',3),(5186,'id dolor','id dolor',0,1,1.2667,'I346',3),(5187,'id dolor in','id dolor in',0,1,1.3667,'I3465',3),(5188,'id facilisis','id facilisis',0,1,1.4,'I31242',11),(5189,'id facilisis at','id facilisis at',0,1,1.5,'I312423',3),(5190,'id laoreet','id laoreet',0,1,1.3333,'I3463',3),(5191,'id laoreet dolor','id laoreet dolor',0,1,1.5333,'I346346',3),(5192,'id leo','id leo',0,1,1.2,'I340',3),(5193,'id leo faucibus','id leo faucibus',0,1,1.5,'I341212',3),(5194,'in a quam','in a quam',0,1,1.3,'I525',3),(5195,'in enim','in enim',0,1,1.2333,'I500',3),(5196,'in enim nisi','in enim nisi',0,1,1.4,'I520',3),(5197,'in lacus','in lacus',0,1,1.2667,'I542',3),(5198,'in lacus aliquam','in lacus aliquam',0,1,1.5333,'I542425',3),(5199,'in mauris','in mauris',0,1,1.3,'I562',3),(5200,'in mauris sit','in mauris sit',0,1,1.4333,'I5623',3),(5201,'in phasellus','in phasellus',0,1,1.4,'I51242',3),(5202,'in phasellus tincidunt','in phasellus tincidunt',0,1,1.7333,'I51242352353',3),(5203,'integer eget','integer eget',0,1,1.4,'I532623',3),(5204,'integer eget urna','integer eget urna',0,1,1.5667,'I53262365',3),(5205,'ipsum erat','ipsum erat',0,1,1.3333,'I12563',3),(5206,'ipsum erat gravida','ipsum erat gravida',0,1,1.6,'I125632613',3),(5207,'lacinia id','lacinia id',0,1,1.3333,'L253',3),(5208,'lacinia id congue','lacinia id congue',0,1,1.5667,'L253252',3),(5209,'lacus aliquam','lacus aliquam',0,1,1.4333,'L2425',3),(5210,'lacus aliquam tempus','lacus aliquam tempus',0,1,1.6667,'L24253512',3),(5211,'laoreet dolor','laoreet dolor',0,1,1.4333,'L6346',3),(5212,'laoreet dolor maecenas','laoreet dolor maecenas',0,1,1.7333,'L63465252',3),(5213,'laoreet et','laoreet et',0,1,1.3333,'L630',3),(5214,'laoreet et adipiscing','laoreet et adipiscing',0,1,1.7,'L631252',3),(5215,'lectus a','lectus a',0,1,1.2667,'L232',3),(5216,'lectus a pharetra','lectus a pharetra',0,1,1.5667,'L2321636',3),(5217,'lectus donec','lectus donec',0,1,1.4,'L232352',3),(5218,'lectus donec ornare','lectus donec ornare',0,1,1.6333,'L232352656',3),(5219,'leo enim','leo enim',0,1,1.2667,'L500',3),(5220,'leo enim quis','leo enim quis',0,1,1.4333,'L520',3),(5221,'leo faucibus','leo faucibus',0,1,1.4,'L1212',3),(5222,'leo faucibus tempor','leo faucibus tempor',0,1,1.6333,'L12123516',3),(5223,'leo quam sollicitudin','leo quam sollicitudin',0,1,1.7,'L2524235',3),(5224,'libero at','libero at',0,1,1.3,'L163',3),(5225,'libero at consequat','libero at consequat',0,1,1.6333,'L1632523',3),(5226,'libero vehicula','libero vehicula',0,1,1.5,'L16124',3),(5227,'libero vehicula in','libero vehicula in',0,1,1.6,'L161245',3),(5228,'lorem auctor','lorem auctor',0,1,1.4,'L65236',3),(5229,'lorem auctor vehicula','lorem auctor vehicula',0,1,1.7,'L65236124',3),(5230,'lorem quisque','lorem quisque',0,1,1.4333,'L652',3),(5231,'lorem quisque ornare','lorem quisque ornare',0,1,1.6667,'L652656',3),(5232,'luctus donec','luctus donec',0,1,1.4,'L232352',3),(5233,'luctus donec leo','luctus donec leo',0,1,1.5333,'L2323524',3),(5234,'maecenas volutpat','maecenas volutpat',0,1,1.5667,'M25214313',3),(5235,'maecenas volutpat tristique','maecenas volutpat tristique',0,1,1.9,'M252143136232',3),(5236,'magna a','magna a',0,1,1.2333,'M250',3),(5237,'magna a erat','magna a erat',0,1,1.4,'M2563',3),(5238,'magna dui','magna dui',0,1,1.3,'M253',3),(5239,'magna dui adipiscing','magna dui adipiscing',0,1,1.6667,'M2531252',3),(5240,'magna in','magna in',0,1,1.2667,'M250',3),(5241,'magna in a','magna in a',0,1,1.3333,'M250',3),(5242,'magna mollis sed','magna mollis sed',0,1,1.5333,'M25423',3),(5243,'malesuada cursus','malesuada cursus',0,1,1.5333,'M423262',3),(5244,'malesuada cursus magna','malesuada cursus magna',0,1,1.7333,'M423262525',3),(5245,'malesuada dui','malesuada dui',0,1,1.4333,'M423',3),(5246,'malesuada dui nec','malesuada dui nec',0,1,1.5667,'M42352',3),(5247,'massa aliquam','massa aliquam',0,1,1.4333,'M2425',3),(5248,'massa aliquam fermentum','massa aliquam fermentum',0,1,1.7667,'M242516535',3),(5249,'massa id','massa id',0,1,1.2667,'M230',3),(5250,'massa id leo','massa id leo',0,1,1.4,'M234',3),(5251,'massa sapien','massa sapien',0,1,1.4,'M215',3),(5252,'massa sapien sed','massa sapien sed',0,1,1.5333,'M21523',3),(5253,'mattis diam','mattis diam',0,1,1.3667,'M3235',3),(5254,'mattis diam eu','mattis diam eu',0,1,1.4667,'M3235',3),(5255,'mattis eget','mattis eget',0,1,1.3667,'M323',3),(5256,'mattis eget nisi','mattis eget nisi',0,1,1.5333,'M32352',3),(5257,'mattis libero','mattis libero',0,1,1.4333,'M32416',3),(5258,'mattis libero at','mattis libero at',0,1,1.5333,'M324163',3),(5259,'mauris blandit','mauris blandit',0,1,1.4667,'M621453',3),(5260,'mauris blandit elit','mauris blandit elit',0,1,1.6333,'M62145343',3),(5261,'mauris sit','mauris sit',0,1,1.3333,'M623',3),(5262,'mauris sit amet','mauris sit amet',0,1,1.5,'M62353',3),(5263,'metus augue','metus augue',0,1,1.3667,'M320',3),(5264,'metus augue id','metus augue id',0,1,1.4667,'M323',3),(5265,'metus duis','metus duis',0,1,1.3333,'M3232',3),(5266,'metus duis eu','metus duis eu',0,1,1.4333,'M3232',3),(5267,'metus rhoncus','metus rhoncus',0,1,1.4333,'M32652',3),(5268,'metus rhoncus id','metus rhoncus id',0,1,1.5333,'M326523',3),(5269,'molestie purus','molestie purus',0,1,1.4667,'M423162',3),(5270,'molestie purus placerat','molestie purus placerat',0,1,1.7667,'M42316214263',3),(5271,'mollis sed','mollis sed',0,1,1.3333,'M423',3),(5272,'mollis sed ultricies','mollis sed ultricies',0,1,1.6667,'M4234362',3),(5273,'morbi nec','morbi nec',0,1,1.3,'M6152',3),(5274,'morbi nec risus','morbi nec risus',0,1,1.5,'M615262',3),(5275,'morbi non','morbi non',0,1,1.3,'M615',3),(5276,'morbi non arcu','morbi non arcu',0,1,1.4667,'M61562',3),(5277,'mus pellentesque','mus pellentesque',0,1,1.5333,'M214532',3),(5278,'mus pellentesque tempor','mus pellentesque tempor',0,1,1.7667,'M2145323516',3),(5279,'nam quis enim','nam quis enim',0,1,1.4333,'N250',3),(5280,'nam vitae','nam vitae',0,1,1.3,'N130',3),(5281,'nam vitae hendrerit','nam vitae hendrerit',0,1,1.6333,'N135363',3),(5282,'nec elit','nec elit',0,1,1.2667,'N243',4),(5283,'nec elit vitae','nec elit vitae',0,1,1.4667,'N24313',3),(5284,'nec enim','nec enim',0,1,1.2667,'N250',4),(5285,'nec enim phasellus','nec enim phasellus',0,1,1.6,'N251242',3),(5286,'nec massa','nec massa',0,1,1.3,'N252',3),(5287,'nec massa aliquam','nec massa aliquam',0,1,1.5667,'N252425',3),(5288,'nec nibh','nec nibh',0,1,1.2667,'N251',3),(5289,'nec nibh vivamus','nec nibh vivamus',0,1,1.5333,'N25152',3),(5290,'nec pretium','nec pretium',0,1,1.3667,'N21635',3),(5291,'nec pretium ut','nec pretium ut',0,1,1.4667,'N216353',3),(5292,'nec risus','nec risus',0,1,1.3,'N262',4),(5293,'nec risus eget','nec risus eget',0,1,1.4667,'N2623',3),(5294,'neque viverra','neque viverra',0,1,1.4333,'N216',3),(5295,'neque viverra sed','neque viverra sed',0,1,1.5667,'N21623',3),(5296,'nibh vivamus','nibh vivamus',0,1,1.4,'N152',3),(5297,'nibh vivamus ultrices','nibh vivamus ultrices',0,1,1.7,'N1524362',3),(5298,'nisi curabitur','nisi curabitur',0,1,1.4667,'N26136',4),(5299,'nisi curabitur vel','nisi curabitur vel',0,1,1.6,'N2613614',3),(5300,'nisi venenatis','nisi venenatis',0,1,1.4667,'N21532',3),(5301,'nisi venenatis quis','nisi venenatis quis',0,1,1.6333,'N21532',3),(5302,'nisl mauris','nisl mauris',0,1,1.3667,'N24562',3),(5303,'nisl mauris blandit','nisl mauris blandit',0,1,1.6333,'N245621453',3),(5304,'nisl sit','nisl sit',0,1,1.2667,'N2423',3),(5305,'nisl sit amet','nisl sit amet',0,1,1.4333,'N242353',3),(5306,'non arcu','non arcu',0,1,1.2667,'N620',3),(5307,'non arcu sit','non arcu sit',0,1,1.4,'N623',3),(5308,'non posuere sapien','non posuere sapien',0,1,1.6,'N126215',3),(5309,'nulla ut','nulla ut',0,1,1.2667,'N430',3),(5310,'nulla ut rhoncus','nulla ut rhoncus',0,1,1.5333,'N43652',3),(5311,'nunc cursus','nunc cursus',0,1,1.3667,'N262',3),(5312,'nunc cursus vehicula','nunc cursus vehicula',0,1,1.6667,'N262124',3),(5313,'nunc non','nunc non',0,1,1.2667,'N250',3),(5314,'nunc non posuere','nunc non posuere',0,1,1.5333,'N25126',3),(5315,'ornare magna a','ornare magna a',0,1,1.4667,'O656525',3),(5316,'ornare malesuada','ornare malesuada',0,1,1.5333,'O6565423',3),(5317,'ornare malesuada dui','ornare malesuada dui',0,1,1.6667,'O6565423',3),(5318,'pellentesque a','pellentesque a',0,1,1.4667,'P4532',3),(5319,'pellentesque a lorem','pellentesque a lorem',0,1,1.6667,'P4532465',3),(5320,'pellentesque a metus','pellentesque a metus',0,1,1.6667,'P4532532',3),(5321,'pellentesque semper','pellentesque semper',0,1,1.6333,'P4532516',3),(5322,'pellentesque semper integer','pellentesque semper integer',0,1,1.9,'P45325165326',3),(5323,'pellentesque tempor','pellentesque tempor',0,1,1.6333,'P45323516',3),(5324,'pellentesque tempor fringilla','pellentesque tempor fringilla',0,1,1.9667,'P4532351616524',3),(5325,'pharetra leo','pharetra leo',0,1,1.4,'P6364',3),(5326,'pharetra leo enim','pharetra leo enim',0,1,1.5667,'P63645',3),(5327,'phasellus adipiscing','phasellus adipiscing',0,1,1.6667,'P24231252',3),(5328,'phasellus adipiscing facilisis','phasellus adipiscing facilisis',0,1,2,'P242312521242',3),(5329,'phasellus tincidunt','phasellus tincidunt',0,1,1.6333,'P242352353',3),(5330,'phasellus tincidunt convallis','phasellus tincidunt convallis',0,1,1.9667,'P24235235325142',3),(5331,'phasellus volutpat','phasellus volutpat',0,1,1.6,'P24214313',3),(5332,'phasellus volutpat sem','phasellus volutpat sem',0,1,1.7333,'P2421431325',3),(5333,'placerat cum','placerat cum',0,1,1.4,'P426325',3),(5334,'placerat cum sociis','placerat cum sociis',0,1,1.6333,'P4263252',3),(5335,'placerat sapien','placerat sapien',0,1,1.5,'P4263215',3),(5336,'placerat sapien congue','placerat sapien congue',0,1,1.7333,'P4263215252',3),(5337,'porta arcu','porta arcu',0,1,1.3333,'P6362',3),(5338,'porta arcu auctor','porta arcu auctor',0,1,1.5667,'P636236',3),(5339,'porttitor at','porttitor at',0,1,1.4,'P6363',3),(5340,'porttitor at cursus','porttitor at cursus',0,1,1.6333,'P6363262',3),(5341,'porttitor pulvinar','porttitor pulvinar',0,1,1.6,'P63614156',3),(5342,'porttitor pulvinar lorem','porttitor pulvinar lorem',0,1,1.8,'P63614156465',3),(5343,'posuere elementum','posuere elementum',0,1,1.5667,'P264535',3),(5344,'posuere elementum eget','posuere elementum eget',0,1,1.7333,'P26453523',3),(5345,'posuere sapien','posuere sapien',0,1,1.4667,'P26215',3),(5346,'posuere sapien praesent','posuere sapien praesent',0,1,1.7667,'P2621516253',3),(5347,'praesent nec','praesent nec',0,1,1.4,'P625352',3),(5348,'praesent nec elit','praesent nec elit',0,1,1.5667,'P62535243',3),(5349,'pretium ut','pretium ut',0,1,1.3333,'P6353',3),(5350,'pretium ut in','pretium ut in',0,1,1.4333,'P63535',3),(5351,'pulvinar lorem','pulvinar lorem',0,1,1.4667,'P4156465',3),(5352,'pulvinar lorem ipsum','pulvinar lorem ipsum',0,1,1.6667,'P4156465125',3),(5353,'purus placerat','purus placerat',0,1,1.4667,'P6214263',3),(5354,'purus placerat cum','purus placerat cum',0,1,1.6,'P621426325',3),(5355,'quam sollicitudin vel','quam sollicitudin vel',0,1,1.7,'Q52423514',3),(5356,'quam urna','quam urna',0,1,1.3,'Q565',3),(5357,'quam urna at','quam urna at',0,1,1.4,'Q5653',3),(5358,'quis enim in','quis enim in',0,1,1.4,'Q500',3),(5359,'quis lacinia','quis lacinia',0,1,1.4,'Q425',3),(5360,'quis lacinia id','quis lacinia id',0,1,1.5,'Q4253',3),(5361,'quis lectus','quis lectus',0,1,1.3667,'Q4232',3),(5362,'quis lectus donec','quis lectus donec',0,1,1.5667,'Q4232352',3),(5363,'quisque ornare','quisque ornare',0,1,1.4667,'Q656',3),(5364,'quisque ornare malesuada','quisque ornare malesuada',0,1,1.8,'Q6565423',3),(5365,'rhoncus id','rhoncus id',0,1,1.3333,'R523',3),(5366,'rhoncus id facilisis','rhoncus id facilisis',0,1,1.6667,'R5231242',3),(5367,'rhoncus nunc','rhoncus nunc',0,1,1.4,'R5252',3),(5368,'rhoncus nunc non','rhoncus nunc non',0,1,1.5333,'R52525',3),(5369,'ridiculus mus pellentesque','ridiculus mus pellentesque',0,1,1.8667,'R32425214532',3),(5370,'risus eget augue','risus eget augue',0,1,1.5333,'R232',3),(5371,'risus magna','risus magna',0,1,1.3667,'R2525',3),(5372,'risus magna mollis','risus magna mollis',0,1,1.6,'R252542',3),(5373,'sapien congue','sapien congue',0,1,1.4333,'S15252',3),(5374,'sapien congue at','sapien congue at',0,1,1.5333,'S152523',3),(5375,'sapien praesent','sapien praesent',0,1,1.5,'S1516253',3),(5376,'sapien praesent nec','sapien praesent nec',0,1,1.6333,'S151625352',3),(5377,'sapien sed','sapien sed',0,1,1.3333,'S1523',3),(5378,'sapien sed tempus','sapien sed tempus',0,1,1.5667,'S1523512',3),(5379,'sed arcu','sed arcu',0,1,1.2667,'S362',3),(5380,'sed arcu morbi','sed arcu morbi',0,1,1.4667,'S362561',3),(5381,'sed dapibus','sed dapibus',0,1,1.3667,'S312',3),(5382,'sed dapibus massa','sed dapibus massa',0,1,1.5667,'S31252',3),(5383,'sed mattis','sed mattis',0,1,1.3333,'S3532',3),(5384,'sed mattis diam','sed mattis diam',0,1,1.5,'S353235',3),(5385,'sed porta','sed porta',0,1,1.3,'S3163',3),(5386,'sed porta arcu','sed porta arcu',0,1,1.4667,'S316362',3),(5387,'sed risus','sed risus',0,1,1.3,'S362',3),(5388,'sed risus magna','sed risus magna',0,1,1.5,'S362525',3),(5389,'sed sed tortor','sed sed tortor',0,1,1.4667,'S323636',3),(5390,'sed tellus sed','sed tellus sed',0,1,1.4667,'S3423',3),(5391,'sed tempus mattis','sed tempus mattis',0,1,1.5667,'S3512532',3),(5392,'sed tortor','sed tortor',0,1,1.3333,'S3636',3),(5393,'sed tortor metus','sed tortor metus',0,1,1.5333,'S3636532',3),(5394,'sed ultricies','sed ultricies',0,1,1.4333,'S34362',3),(5395,'sed ultricies ut','sed ultricies ut',0,1,1.5333,'S343623',3),(5396,'sem feugiat','sem feugiat',0,1,1.3667,'S5123',3),(5397,'sem feugiat malesuada','sem feugiat malesuada',0,1,1.7,'S51235423',3),(5398,'sem posuere','sem posuere',0,1,1.3667,'S5126',3),(5399,'sem posuere elementum','sem posuere elementum',0,1,1.7,'S51264535',3),(5400,'semper integer','semper integer',0,1,1.4667,'S5165326',3),(5401,'semper integer eget','semper integer eget',0,1,1.6333,'S516532623',3),(5402,'sit amet bibendum','sit amet bibendum',0,1,1.5667,'S3531535',3),(5403,'sit amet diam','sit amet diam',0,1,1.4333,'S3535',3),(5404,'sit amet laoreet','sit amet laoreet',0,1,1.5333,'S353463',3),(5405,'sit amet luctus','sit amet luctus',0,1,1.5,'S3534232',3),(5406,'sit amet volutpat','sit amet volutpat',0,1,1.5667,'S35314313',3),(5407,'sollicitudin lorem','sollicitudin lorem',0,1,1.6,'S4235465',3),(5408,'sollicitudin lorem auctor','sollicitudin lorem auctor',0,1,1.8333,'S4235465236',3),(5409,'sollicitudin tellus','sollicitudin tellus',0,1,1.6333,'S4235342',3),(5410,'sollicitudin tellus donec','sollicitudin tellus donec',0,1,1.8333,'S4235342352',3),(5411,'sollicitudin vel','sollicitudin vel',0,1,1.5333,'S423514',3),(5412,'sollicitudin vel porttitor','sollicitudin vel porttitor',0,1,1.8667,'S4235141636',3),(5413,'tellus donec','tellus donec',0,1,1.4,'T42352',3),(5414,'tellus donec ipsum','tellus donec ipsum',0,1,1.6,'T42352125',3),(5415,'tellus sed','tellus sed',0,1,1.3333,'T423',3),(5416,'tellus sed dapibus','tellus sed dapibus',0,1,1.6,'T42312',3),(5417,'tempor fringilla','tempor fringilla',0,1,1.5333,'T51616524',3),(5418,'tempor fringilla augue','tempor fringilla augue',0,1,1.7333,'T516165242',3),(5419,'tempor molestie','tempor molestie',0,1,1.5,'T5165423',3),(5420,'tempor molestie purus','tempor molestie purus',0,1,1.7,'T5165423162',3),(5421,'tempus eu','tempus eu',0,1,1.3,'T512',3),(5422,'tempus eu nec','tempus eu nec',0,1,1.4333,'T51252',3),(5423,'tempus mattis','tempus mattis',0,1,1.4333,'T512532',3),(5424,'tempus mattis libero','tempus mattis libero',0,1,1.6667,'T512532416',3),(5425,'tincidunt convallis','tincidunt convallis',0,1,1.6333,'T5235325142',3),(5426,'tincidunt convallis nisl','tincidunt convallis nisl',0,1,1.8,'T5235325142524',3),(5427,'tincidunt lorem','tincidunt lorem',0,1,1.5,'T52353465',3),(5428,'tincidunt lorem quisque','tincidunt lorem quisque',0,1,1.7667,'T523534652',3),(5429,'tortor felis','tortor felis',0,1,1.4,'T636142',3),(5430,'tortor felis sed','tortor felis sed',0,1,1.5333,'T6361423',3),(5431,'tortor metus','tortor metus',0,1,1.4,'T636532',3),(5432,'tortor metus rhoncus','tortor metus rhoncus',0,1,1.6667,'T636532652',3),(5433,'tristique felis','tristique felis',0,1,1.5,'T6232142',3),(5434,'tristique felis vel','tristique felis vel',0,1,1.6333,'T623214214',3),(5435,'turpis pellentesque','turpis pellentesque',0,1,1.6333,'T61214532',3),(5436,'turpis pellentesque semper','turpis pellentesque semper',0,1,1.8667,'T61214532516',3),(5437,'ultrices faucibus','ultrices faucibus',0,1,1.5667,'U43621212',3),(5438,'ultrices faucibus nulla','ultrices faucibus nulla',0,1,1.7667,'U4362121254',3),(5439,'ultricies ut','ultricies ut',0,1,1.4,'U43623',4),(5440,'ultricies ut pellentesque','ultricies ut pellentesque',0,1,1.8333,'U4362314532',3),(5441,'urna at','urna at',0,1,1.2333,'U653',3),(5442,'urna at sollicitudin','urna at sollicitudin',0,1,1.6667,'U65324235',3),(5443,'urna erat et','urna erat et',0,1,1.4,'U6563',3),(5444,'urna fermentum','urna fermentum',0,1,1.4667,'U6516535',3),(5445,'urna fermentum sed','urna fermentum sed',0,1,1.6,'U651653523',3),(5446,'ut in','ut in',0,1,1.1667,'U350',3),(5447,'ut in mauris','ut in mauris',0,1,1.4,'U3562',3),(5448,'ut metus','ut metus',0,1,1.2667,'U3532',3),(5449,'ut metus augue','ut metus augue',0,1,1.4667,'U3532',3),(5450,'ut pellentesque','ut pellentesque',0,1,1.5,'U314532',3),(5451,'ut pellentesque a','ut pellentesque a',0,1,1.5667,'U314532',3),(5452,'ut rhoncus','ut rhoncus',0,1,1.3333,'U3652',3),(5453,'ut rhoncus nunc','ut rhoncus nunc',0,1,1.5,'U365252',3),(5454,'vehicula at','vehicula at',0,1,1.3667,'V243',3),(5455,'vehicula at id','vehicula at id',0,1,1.4667,'V243',3),(5456,'vehicula felis','vehicula felis',0,1,1.4667,'V24142',3),(5457,'vehicula felis pellentesque','vehicula felis pellentesque',0,1,1.9,'V2414214532',3),(5458,'vehicula in','vehicula in',0,1,1.3667,'V245',3),(5459,'vehicula in phasellus','vehicula in phasellus',0,1,1.7,'V2451242',3),(5460,'vel massa','vel massa',0,1,1.3,'V452',3),(5461,'vel massa sapien','vel massa sapien',0,1,1.5333,'V45215',3),(5462,'vel nec','vel nec',0,1,1.2333,'V452',3),(5463,'vel nec massa','vel nec massa',0,1,1.4333,'V45252',3),(5464,'vel placerat','vel placerat',0,1,1.4,'V414263',3),(5465,'vel placerat sapien','vel placerat sapien',0,1,1.6333,'V414263215',3),(5466,'vel porttitor','vel porttitor',0,1,1.4333,'V41636',3),(5467,'vel porttitor at','vel porttitor at',0,1,1.5333,'V416363',3),(5468,'vel tortor','vel tortor',0,1,1.3333,'V43636',3),(5469,'vel tortor felis','vel tortor felis',0,1,1.5333,'V43636142',3),(5470,'venenatis quis','venenatis quis',0,1,1.4667,'V532',3),(5471,'venenatis quis lacinia','venenatis quis lacinia',0,1,1.7333,'V532425',3),(5472,'vestibulum nisl','vestibulum nisl',0,1,1.5,'V2314524',3),(5473,'vestibulum nisl mauris','vestibulum nisl mauris',0,1,1.7333,'V2314524562',3),(5474,'vitae hendrerit','vitae hendrerit',0,1,1.5,'V35363',4),(5475,'vitae hendrerit nulla','vitae hendrerit nulla',0,1,1.7,'V3536354',3),(5476,'vitae sem','vitae sem',0,1,1.3,'V325',3),(5477,'vitae sem posuere','vitae sem posuere',0,1,1.5667,'V325126',3),(5478,'vivamus ultrices','vivamus ultrices',0,1,1.5333,'V524362',3),(5479,'vivamus ultrices faucibus','vivamus ultrices faucibus',0,1,1.8333,'V5243621212',3),(5480,'vivamus vel','vivamus vel',0,1,1.3667,'V5214',3),(5481,'vivamus vel massa','vivamus vel massa',0,1,1.5667,'V521452',3),(5482,'viverra','viverra',0,0,0.4667,'V600',10),(5483,'viverra sed','viverra sed',0,1,1.3667,'V623',3),(5484,'viverra sed sed','viverra sed sed',0,1,1.5,'V62323',3),(5485,'volutpat libero','volutpat libero',0,1,1.5,'V4313416',3),(5486,'volutpat libero vehicula','volutpat libero vehicula',0,1,1.8,'V4313416124',3),(5487,'volutpat sem','volutpat sem',0,1,1.4,'V431325',10),(5488,'volutpat sem feugiat','volutpat sem feugiat',0,1,1.6667,'V431325123',3),(5489,'volutpat tristique','volutpat tristique',0,1,1.6,'V43136232',3),(5490,'volutpat tristique felis','volutpat tristique felis',0,1,1.8,'V43136232142',3),(5491,'archive article ii','archive article ii',0,1,1.6,'A6216324',1),(5492,'article ii','article ii',0,1,1.3333,'A6324',1),(5493,'21','21',0,0,0.2,'',1),(5494,'archive article iii','archive article iii',0,1,1.6333,'A6216324',1),(5495,'article iii','article iii',0,1,1.3667,'A6324',1),(5496,'iii','iii',0,0,0.2,'I000',1),(5497,'23','23',0,0,0.2,'',1),(5498,'6 css','6 css',0,1,1.1667,'C000',1),(5499,'6 css project\'s','6 css project',0,1,1.5,'C16232',1),(5500,'6 is','6 is',0,1,1.1333,'I200',1),(5501,'6 is on','6 is on',0,1,1.2333,'I250',1),(5502,'6 slightly','6 slightly',0,1,1.3333,'S4234',1),(5503,'6 slightly by','6 slightly by',0,1,1.4333,'S42341',1),(5504,'6 style','6 style',0,1,1.2333,'S340',1),(5505,'a significant','a significant',0,1,1.4333,'A251253',1),(5506,'a significant number','a significant number',0,1,1.6667,'A251253516',1),(5507,'a web','a web',0,1,1.1667,'A100',2),(5508,'a web site\'s','a web site',0,1,1.4,'A1232',1),(5509,'access','access',0,0,0.4,'A200',1),(5510,'access to','access to',0,1,1.3,'A230',1),(5511,'access to the','access to the',0,1,1.4333,'A230',1),(5512,'according','according',0,0,0.6,'A26352',1),(5513,'according to','according to',0,1,1.4,'A263523',1),(5514,'according to this','according to this',0,1,1.5667,'A2635232',1),(5515,'additionally','additionally',0,0,0.8,'A354',1),(5516,'additionally instead','additionally instead',0,1,1.6667,'A354523',1),(5517,'additionally instead of','additionally instead of',0,1,1.7667,'A3545231',1),(5518,'and functioning','and functioning',0,1,1.5,'A53152352',1),(5519,'and functioning might','and functioning might',0,1,1.7,'A53152352523',1),(5520,'appearance','appearance',0,0,0.6667,'A1652',1),(5521,'appearance and','appearance and',0,1,1.4667,'A165253',1),(5522,'appearance and functioning','appearance and functioning',0,1,1.8667,'A165253152352',1),(5523,'apply','apply',0,0,0.3333,'A140',1),(5524,'apply the','apply the',0,1,1.3,'A143',1),(5525,'apply the upper','apply the upper',0,1,1.5,'A14316',1),(5526,'are going','are going',0,1,1.3,'A6252',1),(5527,'are going to','are going to',0,1,1.4,'A62523',1),(5528,'are stuck','are stuck',0,1,1.3,'A6232',1),(5529,'are stuck to','are stuck to',0,1,1.4,'A62323',1),(5530,'available','available',0,0,0.6,'A1414',1),(5531,'available in','available in',0,1,1.4,'A14145',1),(5532,'available in templates','available in templates',0,1,1.7333,'A14145351432',1),(5533,'bar in','bar in',0,1,1.2,'B650',1),(5534,'bar in their','bar in their',0,1,1.4,'B6536',1),(5535,'bar plug-in','bar plug-in',0,1,1.3667,'B61425',1),(5536,'bar plug-in available','bar plug-in available',0,1,1.7,'B614251414',1),(5537,'be more','be more',0,1,1.2333,'B560',1),(5538,'be more rough','be more rough',0,1,1.4333,'B562',1),(5539,'browser according','browser according',0,1,1.5667,'B62626352',1),(5540,'browser according to','browser according to',0,1,1.6667,'B626263523',1),(5541,'browser to','browser to',0,1,1.3333,'B6263',1),(5542,'browser to keep','browser to keep',0,1,1.5,'B626321',1),(5543,'but','but',0,0,0.2,'B300',1),(5544,'but on','but on',0,1,1.2,'B350',1),(5545,'but on the','but on the',0,1,1.3333,'B353',1),(5546,'but there','but there',0,1,1.3,'B360',1),(5547,'but there is','but there is',0,1,1.4,'B362',1),(5548,'by dint','by dint',0,1,1.2333,'B353',1),(5549,'by dint of','by dint of',0,1,1.3333,'B3531',1),(5550,'can apply','can apply',0,1,1.3,'C514',1),(5551,'can apply the','can apply the',0,1,1.4333,'C5143',1),(5552,'can not','can not',0,1,1.2333,'C530',1),(5553,'can not display','can not display',0,1,1.5,'C53214',1),(5554,'content but','content but',0,1,1.3667,'C535313',1),(5555,'content but on','content but on',0,1,1.4667,'C5353135',1),(5556,'created','created',0,0,0.4667,'C630',1),(5557,'created one','created one',0,1,1.3667,'C635',1),(5558,'created one style','created one style',0,1,1.5667,'C635234',1),(5559,'css project\'s','css project',0,1,1.4333,'C16232',1),(5560,'css project\'s website','css project website',0,1,1.7,'C16232123',1),(5561,'decided','decided',0,0,0.4667,'D230',1),(5562,'decided that','decided that',0,1,1.4,'D230',1),(5563,'decided that our','decided that our',0,1,1.5333,'D236',1),(5564,'dint','dint',0,0,0.2667,'D530',1),(5565,'dint of','dint of',0,1,1.2333,'D531',1),(5566,'dint of the','dint of the',0,1,1.3667,'D5313',1),(5567,'display the','display the',0,1,1.3667,'D2143',1),(5568,'display the web','display the web',0,1,1.5,'D21431',1),(5569,'explorer 6','explorer 6',0,1,1.3333,'E2146',1),(5570,'explorer 6 css','explorer 6 css',0,1,1.4667,'E21462',1),(5571,'explorer 6 is','explorer 6 is',0,1,1.4333,'E21462',1),(5572,'explorer can','explorer can',0,1,1.4,'E214625',1),(5573,'explorer can not','explorer can not',0,1,1.5333,'E2146253',1),(5574,'extend','extend',0,0,0.4,'E2353',1),(5575,'full access','full access',0,1,1.3667,'F420',1),(5576,'full access to','full access to',0,1,1.4667,'F423',1),(5577,'functioning','functioning',0,0,0.7333,'F52352',1),(5578,'functioning might','functioning might',0,1,1.5667,'F52352523',1),(5579,'functioning might be','functioning might be',0,1,1.6667,'F523525231',1),(5580,'going','going',0,0,0.3333,'G520',1),(5581,'going to','going to',0,1,1.2667,'G523',1),(5582,'going to support','going to support',0,1,1.5333,'G5232163',1),(5583,'hand','hand',0,0,0.2667,'H530',1),(5584,'hand a','hand a',0,1,1.2,'H530',1),(5585,'hand a web','hand a web',0,1,1.3333,'H531',1),(5586,'have the','have the',0,1,1.2667,'H130',1),(5587,'have the full','have the full',0,1,1.4333,'H1314',1),(5588,'ie 6','ie 6',0,1,1.1333,'I000',1),(5589,'ie 6 slightly','ie 6 slightly',0,1,1.4333,'I24234',1),(5590,'ie 6 style','ie 6 style',0,1,1.3333,'I234',1),(5591,'ie browser','ie browser',0,1,1.3333,'I1626',1),(5592,'ie browser to','ie browser to',0,1,1.4333,'I16263',1),(5593,'ie6','ie6',0,0,0.2,'I000',1),(5594,'ie6 bar','ie6 bar',0,1,1.2333,'I160',1),(5595,'ie6 bar plug-in','ie6 bar plug-in',0,1,1.5,'I161425',1),(5596,'in templates','in templates',0,1,1.4,'I5351432',1),(5597,'in templates menu','in templates menu',0,1,1.5667,'I53514325',1),(5598,'in their','in their',0,1,1.2667,'I536',1),(5599,'in their ie','in their ie',0,1,1.3667,'I536',1),(5600,'informed','informed',0,0,0.5333,'I51653',1),(5601,'informed that','informed that',0,1,1.4333,'I51653',1),(5602,'informed that internet','informed that internet',0,1,1.7333,'I5165353653',1),(5603,'instead','instead',0,0,0.4667,'I523',1),(5604,'instead of','instead of',0,1,1.3333,'I5231',1),(5605,'instead of the','instead of the',0,1,1.4667,'I52313',1),(5606,'internet explorer 6','internet explorer 6',0,1,1.6333,'I536532146',1),(5607,'internet explorer can','internet explorer can',0,1,1.7,'I53653214625',1),(5608,'is on','is on',0,1,1.1667,'I250',1),(5609,'is on the','is on the',0,1,1.3,'I253',1),(5610,'is still a','is still a',0,1,1.3333,'I234',1),(5611,'keep','keep',0,0,0.2667,'K100',1),(5612,'keep them','keep them',0,1,1.3,'K135',1),(5613,'keep them informed','keep them informed',0,1,1.6,'K1351653',1),(5614,'menu options','menu options',0,1,1.4,'M1352',1),(5615,'menu options users','menu options users',0,1,1.6,'M135262',1),(5616,'might','might',0,0,0.3333,'M230',1),(5617,'might be','might be',0,1,1.2667,'M231',1),(5618,'might be more','might be more',0,1,1.4333,'M23156',1),(5619,'more rough','more rough',0,1,1.3333,'M620',1),(5620,'more rough to','more rough to',0,1,1.4333,'M623',1),(5621,'not display','not display',0,1,1.3667,'N3214',1),(5622,'not display the','not display the',0,1,1.5,'N32143',1),(5623,'number of','number of',0,1,1.3,'N161',1),(5624,'number of users','number of users',0,1,1.5,'N161262',1),(5625,'of template','of template',0,1,1.3667,'O135143',1),(5626,'of template styles','of template styles',0,1,1.6,'O1351432342',1),(5627,'of the ie6','of the ie6',0,1,1.3333,'O130',1),(5628,'of the whole','of the whole',0,1,1.4,'O134',1),(5629,'of users','of users',0,1,1.2667,'O1262',2),(5630,'of users that','of users that',0,1,1.4333,'O12623',1),(5631,'on the','on the',0,1,1.2,'O530',1),(5632,'on the other','on the other',0,1,1.4,'O536',1),(5633,'on the way','on the way',0,1,1.3333,'O530',1),(5634,'one','one',0,0,0.2,'O500',1),(5635,'one style','one style',0,1,1.3,'O5234',1),(5636,'one style universal','one style universal',0,1,1.6333,'O523451624',1),(5637,'options users','options users',0,1,1.4333,'O135262',1),(5638,'options users can','options users can',0,1,1.5667,'O1352625',1),(5639,'other hand','other hand',0,1,1.3333,'O3653',1),(5640,'other hand a','other hand a',0,1,1.4,'O3653',1),(5641,'our templates','our templates',0,1,1.4333,'O6351432',1),(5642,'our templates are','our templates are',0,1,1.5667,'O63514326',1),(5643,'out','out',0,0,0.2,'O300',1),(5644,'out but','out but',0,1,1.2333,'O313',1),(5645,'out but there','out but there',0,1,1.4333,'O3136',1),(5646,'plug-in available','plug-in available',0,1,1.5667,'P4251414',1),(5647,'plug-in available in','plug-in available in',0,1,1.6667,'P42514145',1),(5648,'project\'s website','project website',0,1,1.5667,'P6232123',1),(5649,'project\'s website thanks','project website thanks',0,1,1.8,'P623212352',1),(5650,'properly','properly',0,0,0.5333,'P6164',1),(5651,'properly additionally','properly additionally',0,1,1.7,'P6164354',1),(5652,'properly additionally instead','properly additionally instead',0,1,1.9667,'P6164354523',1),(5653,'range','range',0,0,0.3333,'R520',1),(5654,'range of','range of',0,1,1.2667,'R521',1),(5655,'range of template','range of template',0,1,1.5667,'R52135143',1),(5656,'rough','rough',0,0,0.3333,'R200',1),(5657,'rough to','rough to',0,1,1.2667,'R230',1),(5658,'rough to some','rough to some',0,1,1.4333,'R2325',1),(5659,'significant','significant',0,0,0.7333,'S51253',1),(5660,'significant number','significant number',0,1,1.6,'S51253516',1),(5661,'significant number of','significant number of',0,1,1.7,'S512535161',1),(5662,'site properly','site properly',0,1,1.4333,'S316164',1),(5663,'site properly additionally','site properly additionally',0,1,1.8667,'S316164354',1),(5664,'site\'s','site',0,0,0.4,'S320',1),(5665,'site\'s appearance','site appearance',0,1,1.5667,'S321652',1),(5666,'site\'s appearance and','site appearance and',0,1,1.7,'S32165253',1),(5667,'slightly','slightly',0,0,0.5333,'S4234',1),(5668,'slightly by','slightly by',0,1,1.3667,'S42341',1),(5669,'slightly by dint','slightly by dint',0,1,1.5333,'S42341353',1),(5670,'some extend','some extend',0,1,1.3667,'S52353',1),(5671,'still a','still a',0,1,1.2333,'S340',1),(5672,'still a significant','still a significant',0,1,1.6333,'S34251253',1),(5673,'stuck','stuck',0,0,0.3333,'S320',1),(5674,'stuck to','stuck to',0,1,1.2667,'S323',1),(5675,'stuck to this','stuck to this',0,1,1.4333,'S3232',1),(5676,'style','style',0,0,0.3333,'S340',1),(5677,'style universal','style universal',0,1,1.5,'S3451624',1),(5678,'style universal internet','style universal internet',0,1,1.8,'S345162453653',1),(5679,'styles','styles',0,0,0.4,'S342',1),(5680,'styles we','styles we',0,1,1.3,'S342',1),(5681,'styles we created','styles we created',0,1,1.5667,'S34263',1),(5682,'support','support',0,0,0.4667,'S163',5),(5683,'support ie','support ie',0,1,1.3333,'S163',1),(5684,'support ie 6','support ie 6',0,1,1.4,'S163',1),(5685,'template styles','template styles',0,1,1.5,'T51432342',1),(5686,'template styles we','template styles we',0,1,1.6,'T51432342',1),(5687,'templates','templates',0,0,0.6,'T51432',1),(5688,'templates are','templates are',0,1,1.4333,'T514326',1),(5689,'templates are going','templates are going',0,1,1.6333,'T514326252',1),(5690,'templates menu','templates menu',0,1,1.4667,'T514325',1),(5691,'templates menu options','templates menu options',0,1,1.7333,'T5143251352',1),(5692,'thanks','thanks',0,0,0.4,'T520',1),(5693,'thanks to','thanks to',0,1,1.3,'T523',1),(5694,'thanks to this','thanks to this',0,1,1.4667,'T5232',1),(5695,'that are','that are',0,1,1.2667,'T600',1),(5696,'that are stuck','that are stuck',0,1,1.4667,'T6232',1),(5697,'that internet','that internet',0,1,1.4333,'T53653',1),(5698,'that internet explorer','that internet explorer',0,1,1.7333,'T536532146',1),(5699,'that our templates','that our templates',0,1,1.6,'T6351432',1),(5700,'the full','the full',0,1,1.2667,'T140',1),(5701,'the full access','the full access',0,1,1.5,'T142',1),(5702,'the ie6','the ie6',0,1,1.2333,'T000',1),(5703,'the ie6 bar','the ie6 bar',0,1,1.3667,'T160',1),(5704,'the other','the other',0,1,1.3,'T600',1),(5705,'the other hand','the other hand',0,1,1.4667,'T653',1),(5706,'the upper','the upper',0,1,1.3,'T160',1),(5707,'the upper bar','the upper bar',0,1,1.4333,'T1616',1),(5708,'the way','the way',0,1,1.2333,'T000',1),(5709,'the way out','the way out',0,1,1.3667,'T000',1),(5710,'the web\'s','the web',0,1,1.3,'T120',1),(5711,'the web\'s content','the web content',0,1,1.5667,'T125353',1),(5712,'the whole','the whole',0,1,1.3,'T400',1),(5713,'the whole range','the whole range',0,1,1.5,'T4652',1),(5714,'their','their',0,0,0.3333,'T600',3),(5715,'their ie','their ie',0,1,1.2667,'T600',1),(5716,'their ie browser','their ie browser',0,1,1.5333,'T61626',1),(5717,'them','them',0,0,0.2667,'T500',1),(5718,'them informed','them informed',0,1,1.4333,'T51653',1),(5719,'them informed that','them informed that',0,1,1.6,'T51653',1),(5720,'there','there',0,0,0.3333,'T600',4),(5721,'there is','there is',0,1,1.2667,'T620',1),(5722,'there is still','there is still',0,1,1.4667,'T6234',1),(5723,'this browser','this browser',0,1,1.4,'T21626',1),(5724,'this browser according','this browser according',0,1,1.7333,'T2162626352',1),(5725,'this users','this users',0,1,1.3333,'T262',1),(5726,'this users will','this users will',0,1,1.5,'T2624',1),(5727,'this we','this we',0,1,1.2333,'T200',1),(5728,'this we decided','this we decided',0,1,1.5,'T2323',1),(5729,'to keep','to keep',0,1,1.2333,'T210',1),(5730,'to keep them','to keep them',0,1,1.4,'T2135',1),(5731,'to some','to some',0,1,1.2333,'T250',1),(5732,'to some extend','to some extend',0,1,1.4667,'T252353',1),(5733,'to support','to support',0,1,1.3333,'T2163',1),(5734,'to support ie','to support ie',0,1,1.4333,'T2163',1),(5735,'to the web\'s','to the web',0,1,1.4,'T120',1),(5736,'to this','to this',0,1,1.2333,'T200',1),(5737,'to this browser','to this browser',0,1,1.5,'T21626',1),(5738,'to this users','to this users',0,1,1.4333,'T262',1),(5739,'to this we','to this we',0,1,1.3333,'T200',1),(5740,'universal','universal',0,0,0.6,'U51624',1),(5741,'universal internet','universal internet',0,1,1.6,'U5162453653',1),(5742,'universal internet explorer','universal internet explorer',0,1,1.9,'U51624536532146',1),(5743,'upper','upper',0,0,0.3333,'U160',1),(5744,'upper bar','upper bar',0,1,1.3,'U1616',1),(5745,'upper bar in','upper bar in',0,1,1.4,'U16165',1),(5746,'users can apply','users can apply',0,1,1.5,'U262514',1),(5747,'users that are','users that are',0,1,1.4667,'U26236',1),(5748,'users will','users will',0,1,1.3333,'U2624',1),(5749,'users will have','users will have',0,1,1.5,'U26241',1),(5750,'way','way',0,0,0.2,'W000',1),(5751,'way out','way out',0,1,1.2333,'W300',1),(5752,'way out but','way out but',0,1,1.3667,'W313',1),(5753,'we','we',0,0,0.1333,'W000',5),(5754,'we created','we created',0,1,1.3333,'W263',1),(5755,'we created one','we created one',0,1,1.4667,'W2635',1),(5756,'we decided','we decided',0,1,1.3333,'W323',1),(5757,'we decided that','we decided that',0,1,1.5,'W323',1),(5758,'web site properly','web site properly',0,1,1.5667,'W12316164',1),(5759,'web site\'s','web site',0,1,1.3333,'W1232',1),(5760,'web site\'s appearance','web site appearance',0,1,1.7,'W12321652',1),(5761,'web\'s','web',0,0,0.3333,'W120',1),(5762,'web\'s content','web content',0,1,1.4333,'W125353',1),(5763,'web\'s content but','web content but',0,1,1.5667,'W12535313',1),(5764,'website','website',0,0,0.4667,'W123',1),(5765,'website thanks','website thanks',0,1,1.4667,'W12352',1),(5766,'website thanks to','website thanks to',0,1,1.5667,'W123523',1),(5767,'whole','whole',0,0,0.3333,'W400',1),(5768,'whole range','whole range',0,1,1.3667,'W4652',1),(5769,'whole range of','whole range of',0,1,1.4667,'W46521',1),(5770,'will have','will have',0,1,1.3,'W410',1),(5771,'will have the','will have the',0,1,1.4333,'W413',1),(5772,'24','24',0,0,0.2,'',1),(5773,'a ante','a ante',0,1,1.2,'A530',1),(5774,'a ante venenatis','a ante venenatis',0,1,1.5333,'A531532',1),(5775,'a pharetra augue','a pharetra augue',0,1,1.5333,'A16362',1),(5776,'ac cursus','ac cursus',0,1,1.3,'A262',1),(5777,'ac cursus commodo','ac cursus commodo',0,1,1.5667,'A26253',1),(5778,'ac facilisis','ac facilisis',0,1,1.4,'A21242',1),(5779,'ac facilisis in','ac facilisis in',0,1,1.5,'A212425',1),(5780,'aliquet donec','aliquet donec',0,1,1.4333,'A42352',1),(5781,'aliquet donec sed','aliquet donec sed',0,1,1.5667,'A423523',1),(5782,'amet risus','amet risus',0,1,1.3333,'A5362',1),(5783,'ante venenatis','ante venenatis',0,1,1.4667,'A531532',1),(5784,'ante venenatis dapibus','ante venenatis dapibus',0,1,1.7333,'A531532312',1),(5785,'at lobortis maecenas','at lobortis maecenas',0,1,1.6667,'A3416325252',1),(5786,'auctor fringilla cras','auctor fringilla cras',0,1,1.7,'A23616524262',1),(5787,'auctor fringilla donec','auctor fringilla donec',0,1,1.7333,'A23616524352',1),(5788,'auctor fringilla maecenas','auctor fringilla maecenas',0,1,1.8333,'A236165245252',1),(5789,'auctor fringilla nullam','auctor fringilla nullam',0,1,1.7667,'A23616524545',1),(5790,'auctor fusce','auctor fusce',0,1,1.4,'A23612',1),(5791,'auctor fusce dapibus','auctor fusce dapibus',0,1,1.6667,'A23612312',1),(5792,'augue integer','augue integer',0,1,1.4333,'A25326',1),(5793,'augue integer posuere','augue integer posuere',0,1,1.7,'A25326126',1),(5794,'augue laoreet','augue laoreet',0,1,1.4333,'A2463',1),(5795,'augue laoreet rutrum','augue laoreet rutrum',0,1,1.6667,'A24636365',1),(5796,'commodo cursus','commodo cursus',0,1,1.4667,'C53262',1),(5797,'commodo cursus magna','commodo cursus magna',0,1,1.6667,'C53262525',1),(5798,'commodo luctus','commodo luctus',0,1,1.4667,'C534232',1),(5799,'commodo luctus nisi','commodo luctus nisi',0,1,1.6333,'C53423252',1),(5800,'commodo tortor','commodo tortor',0,1,1.4667,'C53636',1),(5801,'commodo tortor mauris','commodo tortor mauris',0,1,1.7,'C53636562',1),(5802,'condimentum nibh','condimentum nibh',0,1,1.5333,'C535351',1),(5803,'condimentum nibh ut','condimentum nibh ut',0,1,1.6333,'C5353513',1),(5804,'consectetur et','consectetur et',0,1,1.4667,'C52363',1),(5805,'consectetur et nulla','consectetur et nulla',0,1,1.6667,'C5236354',1),(5806,'cras justo','cras justo',0,1,1.3333,'C623',1),(5807,'cras justo odio','cras justo odio',0,1,1.5,'C623',1),(5808,'cursus commodo','cursus commodo',0,1,1.4667,'C6253',1),(5809,'cursus commodo tortor','cursus commodo tortor',0,1,1.7,'C6253636',1),(5810,'cursus magna vel','cursus magna vel',0,1,1.5333,'C6252514',1),(5811,'dapibus ac','dapibus ac',0,1,1.3333,'D120',1),(5812,'dapibus ac facilisis','dapibus ac facilisis',0,1,1.6667,'D121242',1),(5813,'dapibus posuere','dapibus posuere',0,1,1.5,'D12126',1),(5814,'dapibus posuere velit','dapibus posuere velit',0,1,1.7,'D12126143',1),(5815,'dapibus tellus','dapibus tellus',0,1,1.4667,'D12342',1),(5816,'dapibus tellus ac','dapibus tellus ac',0,1,1.5667,'D12342',1),(5817,'dolor auctor','dolor auctor',0,1,1.4,'D46236',1),(5818,'dolor auctor fusce','dolor auctor fusce',0,1,1.6,'D4623612',1),(5819,'donec sed','donec sed',0,1,1.3,'D523',1),(5820,'donec sed odio','donec sed odio',0,1,1.4667,'D523',1),(5821,'dui aenean','dui aenean',0,1,1.3333,'D500',1),(5822,'dui aenean eu','dui aenean eu',0,1,1.4333,'D500',1),(5823,'dui donec','dui donec',0,1,1.3,'D520',1),(5824,'dui donec ullamcorper','dui donec ullamcorper',0,1,1.7,'D52452616',1),(5825,'duis mollis','duis mollis',0,1,1.3667,'D2542',1),(5826,'duis mollis est','duis mollis est',0,1,1.5,'D25423',1),(5827,'egestas eget','egestas eget',0,1,1.4,'E2323',1),(5828,'egestas eget quam','egestas eget quam',0,1,1.5667,'E232325',1),(5829,'eget lacinia','eget lacinia',0,1,1.4,'E23425',1),(5830,'eget lacinia odio','eget lacinia odio',0,1,1.5667,'E234253',1),(5831,'eget quam','eget quam',0,1,1.3,'E2325',1),(5832,'eget quam cum','eget quam cum',0,1,1.4333,'E232525',1),(5833,'elit donec','elit donec',0,1,1.3333,'E4352',1),(5834,'elit donec ullamcorper','elit donec ullamcorper',0,1,1.7333,'E4352452616',1),(5835,'elit libero','elit libero',0,1,1.3667,'E43416',1),(5836,'elit libero a','elit libero a',0,1,1.4333,'E43416',1),(5837,'elit vestibulum id','elit vestibulum id',0,1,1.6,'E431231453',1),(5838,'elit vivamus','elit vivamus',0,1,1.4,'E43152',1),(5839,'elit vivamus sagittis','elit vivamus sagittis',0,1,1.7,'E4315232',1),(5840,'erat a','erat a',0,1,1.2,'E630',1),(5841,'erat a ante','erat a ante',0,1,1.3667,'E6353',1),(5842,'erat porttitor','erat porttitor',0,1,1.4667,'E631636',1),(5843,'erat porttitor ligula','erat porttitor ligula',0,1,1.7,'E631636424',1),(5844,'est non','est non',0,1,1.2333,'E235',1),(5845,'est non commodo','est non commodo',0,1,1.5,'E235253',1),(5846,'et nulla','et nulla',0,1,1.2667,'E354',1),(5847,'et nulla vitae','et nulla vitae',0,1,1.4667,'E35413',1),(5848,'euismod semper donec','euismod semper donec',0,1,1.6667,'E2532516352',1),(5849,'facilisis in','facilisis in',0,1,1.4,'F2425',1),(5850,'facilisis in egestas','facilisis in egestas',0,1,1.6667,'F2425232',1),(5851,'faucibus dolor','faucibus dolor',0,1,1.4667,'F212346',1),(5852,'faucibus dolor auctor','faucibus dolor auctor',0,1,1.7,'F212346236',1),(5853,'faucibus mollis','faucibus mollis',0,1,1.5,'F212542',1),(5854,'faucibus mollis interdum','faucibus mollis interdum',0,1,1.8,'F21254253635',1),(5855,'fermentum massa','fermentum massa',0,1,1.5,'F65352',1),(5856,'fermentum massa justo','fermentum massa justo',0,1,1.7,'F653523',1),(5857,'fringilla cras','fringilla cras',0,1,1.4667,'F6524262',1),(5858,'fringilla cras justo','fringilla cras justo',0,1,1.6667,'F65242623',1),(5859,'fringilla donec','fringilla donec',0,1,1.5,'F6524352',1),(5860,'fringilla donec sed','fringilla donec sed',0,1,1.6333,'F65243523',1),(5861,'fringilla maecenas','fringilla maecenas',0,1,1.6,'F65245252',1),(5862,'fringilla maecenas sed','fringilla maecenas sed',0,1,1.7333,'F652452523',1),(5863,'fringilla nullam','fringilla nullam',0,1,1.5333,'F6524545',1),(5864,'fringilla nullam quis','fringilla nullam quis',0,1,1.7,'F65245452',1),(5865,'fusce dapibus','fusce dapibus',0,1,1.4333,'F2312',1),(5866,'fusce dapibus tellus','fusce dapibus tellus',0,1,1.6667,'F2312342',1),(5867,'in egestas','in egestas',0,1,1.3333,'I5232',1),(5868,'in egestas eget','in egestas eget',0,1,1.5,'I52323',1),(5869,'integer posuere','integer posuere',0,1,1.5,'I5326126',1),(5870,'integer posuere erat','integer posuere erat',0,1,1.6667,'I53261263',1),(5871,'interdum sed','interdum sed',0,1,1.4,'I5363523',1),(5872,'interdum sed posuere','interdum sed posuere',0,1,1.6667,'I5363523126',1),(5873,'justo odio','justo odio',0,1,1.3333,'J300',1),(5874,'justo odio dapibus','justo odio dapibus',0,1,1.6,'J312',1),(5875,'lacinia odio','lacinia odio',0,1,1.4,'L253',1),(5876,'lacinia odio sem','lacinia odio sem',0,1,1.5333,'L25325',1),(5877,'lacus vel','lacus vel',0,1,1.3,'L214',1),(5878,'lacus vel augue','lacus vel augue',0,1,1.5,'L2142',1),(5879,'laoreet rutrum','laoreet rutrum',0,1,1.4667,'L636365',1),(5880,'laoreet rutrum faucibus','laoreet rutrum faucibus',0,1,1.7667,'L6363651212',1),(5881,'leo donec ullamcorper','leo donec ullamcorper',0,1,1.7,'L352452616',1),(5882,'libero a','libero a',0,1,1.2667,'L160',9),(5883,'libero a pharetra','libero a pharetra',0,1,1.5667,'L161636',1),(5884,'ligula eget lacinia','ligula eget lacinia',0,1,1.6333,'L2423425',1),(5885,'lobortis maecenas','lobortis maecenas',0,1,1.5667,'L16325252',1),(5886,'lobortis maecenas sed','lobortis maecenas sed',0,1,1.7,'L163252523',1),(5887,'luctus nisi','luctus nisi',0,1,1.3667,'L23252',1),(5888,'luctus nisi erat','luctus nisi erat',0,1,1.5333,'L2325263',1),(5889,'maecenas faucibus','maecenas faucibus',0,1,1.5667,'M2521212',1),(5890,'maecenas faucibus mollis','maecenas faucibus mollis',0,1,1.8,'M2521212542',1),(5891,'magna cum','magna cum',0,1,1.3,'M2525',1),(5892,'magna cum sociis','magna cum sociis',0,1,1.5333,'M25252',1),(5893,'magna praesent','magna praesent',0,1,1.4667,'M2516253',1),(5894,'magna praesent commodo','magna praesent commodo',0,1,1.7333,'M2516253253',1),(5895,'magna vel','magna vel',0,1,1.3,'M2514',1),(5896,'magna vel scelerisque','magna vel scelerisque',0,1,1.7,'M25142462',1),(5897,'massa justo','massa justo',0,1,1.3667,'M230',1),(5898,'massa justo sit','massa justo sit',0,1,1.5,'M2323',1),(5899,'mauris condimentum','mauris condimentum',0,1,1.6,'M6253535',1),(5900,'mauris condimentum nibh','mauris condimentum nibh',0,1,1.7667,'M62535351',1),(5901,'mollis est','mollis est',0,1,1.3333,'M423',1),(5902,'mollis est non','mollis est non',0,1,1.4667,'M4235',1),(5903,'mollis interdum','mollis interdum',0,1,1.5,'M4253635',1),(5904,'mollis interdum sed','mollis interdum sed',0,1,1.6333,'M425363523',1),(5905,'mus maecenas faucibus','mus maecenas faucibus',0,1,1.7,'M252521212',1),(5906,'mus vestibulum','mus vestibulum',0,1,1.4667,'M2123145',1),(5907,'mus vestibulum id','mus vestibulum id',0,1,1.5667,'M21231453',1),(5908,'nec elit donec','nec elit donec',0,1,1.4667,'N24352',1),(5909,'nec elit vestibulum','nec elit vestibulum',0,1,1.6333,'N243123145',1),(5910,'nec elit vivamus','nec elit vivamus',0,1,1.5333,'N243152',1),(5911,'nibh ut','nibh ut',0,1,1.2333,'N130',1),(5912,'nibh ut fermentum','nibh ut fermentum',0,1,1.5667,'N1316535',1),(5913,'nisi erat','nisi erat',0,1,1.3,'N263',1),(5914,'nisi erat porttitor','nisi erat porttitor',0,1,1.6333,'N2631636',1),(5915,'nisl consectetur','nisl consectetur',0,1,1.5333,'N2425236',1),(5916,'nisl consectetur et','nisl consectetur et',0,1,1.6333,'N24252363',1),(5917,'non commodo','non commodo',0,1,1.3667,'N253',1),(5918,'non commodo luctus','non commodo luctus',0,1,1.6,'N2534232',1),(5919,'non magna cum','non magna cum',0,1,1.4333,'N2525',1),(5920,'non magna praesent','non magna praesent',0,1,1.6,'N2516253',1),(5921,'nulla vitae','nulla vitae',0,1,1.3667,'N413',1),(5922,'nulla vitae elit','nulla vitae elit',0,1,1.5333,'N41343',1),(5923,'odio dapibus','odio dapibus',0,1,1.4,'O312',1),(5924,'odio dapibus ac','odio dapibus ac',0,1,1.5,'O312',1),(5925,'odio dui','odio dui',0,1,1.2667,'O300',1),(5926,'odio dui aenean','odio dui aenean',0,1,1.5,'O350',1),(5927,'odio dui donec','odio dui donec',0,1,1.4667,'O352',1),(5928,'odio sem','odio sem',0,1,1.2667,'O325',1),(5929,'odio sem nec','odio sem nec',0,1,1.4,'O3252',1),(5930,'pharetra augue','pharetra augue',0,1,1.4667,'P6362',1),(5931,'pharetra augue integer','pharetra augue integer',0,1,1.7333,'P63625326',1),(5932,'porttitor duis','porttitor duis',0,1,1.4667,'P63632',1),(5933,'porttitor duis mollis','porttitor duis mollis',0,1,1.7,'P63632542',1),(5934,'porttitor ligula','porttitor ligula',0,1,1.5333,'P636424',1),(5935,'porttitor ligula eget','porttitor ligula eget',0,1,1.7,'P63642423',1),(5936,'posuere erat','posuere erat',0,1,1.4,'P263',1),(5937,'posuere erat a','posuere erat a',0,1,1.4667,'P263',1),(5938,'posuere velit','posuere velit',0,1,1.4333,'P26143',1),(5939,'posuere velit aliquet','posuere velit aliquet',0,1,1.7,'P26143423',1),(5940,'praesent commodo','praesent commodo',0,1,1.5333,'P6253253',1),(5941,'praesent commodo cursus','praesent commodo cursus',0,1,1.7667,'P6253253262',1),(5942,'quam cum','quam cum',0,1,1.2667,'Q525',1),(5943,'quam cum sociis','quam cum sociis',0,1,1.5,'Q5252',1),(5944,'ridiculus mus vestibulum','ridiculus mus vestibulum',0,1,1.8,'R324252123145',1),(5945,'rutrum faucibus','rutrum faucibus',0,1,1.5,'R3651212',1),(5946,'rutrum faucibus dolor','rutrum faucibus dolor',0,1,1.7,'R3651212346',1),(5947,'sagittis lacus','sagittis lacus',0,1,1.4667,'S3242',2),(5948,'sagittis lacus vel','sagittis lacus vel',0,1,1.6,'S324214',1),(5949,'scelerisque nisl','scelerisque nisl',0,1,1.5333,'S462524',1),(5950,'scelerisque nisl consectetur','scelerisque nisl consectetur',0,1,1.9333,'S46252425236',1),(5951,'sed odio','sed odio',0,1,1.2667,'S300',1),(5952,'sed odio dui','sed odio dui',0,1,1.4,'S300',1),(5953,'sem nec','sem nec',0,1,1.2333,'S520',1),(5954,'sem nec elit','sem nec elit',0,1,1.4,'S5243',1),(5955,'semper donec','semper donec',0,1,1.4,'S516352',1),(5956,'semper donec ullamcorper','semper donec ullamcorper',0,1,1.8,'S516352452616',1),(5957,'sit amet risus','sit amet risus',0,1,1.4667,'S35362',1),(5958,'tellus ac','tellus ac',0,1,1.3,'T420',1),(5959,'tellus ac cursus','tellus ac cursus',0,1,1.5333,'T4262',1),(5960,'tempus porttitor duis','tempus porttitor duis',0,1,1.7,'T512163632',1),(5961,'tortor mauris','tortor mauris',0,1,1.4333,'T636562',1),(5962,'tortor mauris condimentum','tortor mauris condimentum',0,1,1.8333,'T63656253535',1),(5963,'ut fermentum','ut fermentum',0,1,1.4,'U316535',1),(5964,'ut fermentum massa','ut fermentum massa',0,1,1.6,'U3165352',1),(5965,'vel augue','vel augue',0,1,1.3,'V420',1),(5966,'vel augue laoreet','vel augue laoreet',0,1,1.5667,'V42463',1),(5967,'vel scelerisque','vel scelerisque',0,1,1.5,'V42462',1),(5968,'vel scelerisque nisl','vel scelerisque nisl',0,1,1.6667,'V42462524',1),(5969,'velit aliquet','velit aliquet',0,1,1.4333,'V43423',1),(5970,'velit aliquet donec','velit aliquet donec',0,1,1.6333,'V4342352',1),(5971,'venenatis dapibus','venenatis dapibus',0,1,1.5667,'V532312',1),(5972,'venenatis dapibus posuere','venenatis dapibus posuere',0,1,1.8333,'V532312126',1),(5973,'venenatis vestibulum duis','venenatis vestibulum duis',0,1,1.8333,'V53212314532',1),(5974,'vestibulum duis','vestibulum duis',0,1,1.5,'V2314532',1),(5975,'vestibulum duis mollis','vestibulum duis mollis',0,1,1.7333,'V2314532542',1),(5976,'vitae elit','vitae elit',0,1,1.3333,'V343',1),(5977,'vitae elit libero','vitae elit libero',0,1,1.5667,'V343416',1),(5978,'vivamus sagittis','vivamus sagittis',0,1,1.5333,'V5232',1),(5979,'vivamus sagittis lacus','vivamus sagittis lacus',0,1,1.7333,'V523242',1),(5980,'\'more','more',0,0,0.3333,'M600',1),(5981,'\'more than','more than',0,1,1.3333,'M635',1),(5982,'\'more than a','more than a',0,1,1.4,'M635',1),(5983,'\'noob\'','noob',0,0,0.4,'N100',1),(5984,'\'noob\' joomla','noob joomla',0,1,1.4333,'N1254',1),(5985,'\'noob\' joomla can','noob joomla can',0,1,1.5667,'N125425',1),(5986,'\'the','the',0,0,0.2667,'T000',1),(5987,'\'the next','the next',0,1,1.3,'T523',1),(5988,'\'the next generation','the next generation',0,1,1.6667,'T52325635',1),(5989,'1.5','1.5',0,0,0.3,'',1),(5990,'1.5 can','1.5 can',0,1,1.2333,'C500',1),(5991,'1.5 can make','1.5 can make',0,1,1.4,'C520',1),(5992,'a catchcry','a catchcry',0,1,1.3333,'A2326',1),(5993,'a catchcry because','a catchcry because',0,1,1.6,'A232612',1),(5994,'a cms\'','a cms',0,1,1.2,'A252',1),(5995,'a cms\' is','a cms is',0,1,1.3,'A252',1),(5996,'a community','a community',0,1,1.3667,'A253',1),(5997,'a community of','a community of',0,1,1.4667,'A2531',1),(5998,'a complete','a complete',0,1,1.3333,'A25143',1),(5999,'a complete \'noob\'','a complete noob',0,1,1.5667,'A2514351',1),(6000,'a free','a free',0,1,1.2,'A160',1),(6001,'a free open','a free open',0,1,1.3667,'A1615',1),(6002,'a fully','a fully',0,1,1.2333,'A140',1),(6003,'a fully documented','a fully documented',0,1,1.6,'A143253',1),(6004,'a highly-active','a highly-active',0,1,1.5,'A24231',1),(6005,'a highly-active development','a highly-active development',0,1,1.9,'A24231314153',1),(6006,'a new','a new',0,1,1.1667,'A500',1),(6007,'a new framework','a new framework',0,1,1.5,'A516562',1),(6008,'a systems','a systems',0,1,1.3,'A2352',1),(6009,'a systems architect','a systems architect',0,1,1.6333,'A235262323',1),(6010,'a web site','a web site',0,1,1.3333,'A123',1),(6011,'administration','administration',0,0,0.9333,'A3523635',1),(6012,'administration and','administration and',0,1,1.6,'A35236353',1),(6013,'administration and the','administration and the',0,1,1.7333,'A35236353',1),(6014,'all sizes','all sizes',0,1,1.3,'A420',1),(6015,'all sizes for','all sizes for',0,1,1.4333,'A4216',1),(6016,'all the','all the',0,1,1.2333,'A430',1),(6017,'all the more','all the more',0,1,1.4,'A4356',1),(6018,'allows','allows',0,0,0.4,'A420',1),(6019,'allows the','allows the',0,1,1.3333,'A423',1),(6020,'allows the customisation','allows the customisation',0,1,1.8,'A423235235',1),(6021,'always','always',0,0,0.4,'A420',1),(6022,'always wanted','always wanted',0,1,1.4333,'A4253',1),(6023,'always wanted increased','always wanted increased',0,1,1.7667,'A425352623',1),(6024,'an easy-to-use','an easy-to-use',0,1,1.4667,'A5232',1),(6025,'an easy-to-use graphical','an easy-to-use graphical',0,1,1.8,'A52326124',1),(6026,'and a highly-active','and a highly-active',0,1,1.6333,'A5324231',1),(6027,'and content','and content',0,1,1.3667,'A5325353',1),(6028,'and content publishing','and content publishing',0,1,1.7333,'A532535314252',1),(6029,'and ecommerce','and ecommerce',0,1,1.4333,'A532562',1),(6030,'and ecommerce applications','and ecommerce applications',0,1,1.8667,'A532562142352',1),(6031,'and extranets','and extranets',0,1,1.4333,'A53236532',1),(6032,'and extranets and','and extranets and',0,1,1.5667,'A5323653253',1),(6033,'and flexibility','and flexibility',0,1,1.5,'A53142143',1),(6034,'and flexibility you','and flexibility you',0,1,1.6333,'A53142143',1),(6035,'and is','and is',0,1,1.2,'A532',1),(6036,'and is supported','and is supported',0,1,1.5333,'A532163',1),(6037,'and joomla','and joomla',0,1,1.3333,'A53254',1),(6038,'and joomla can','and joomla can',0,1,1.4667,'A5325425',1),(6039,'and publishing','and publishing',0,1,1.4667,'A5314252',1),(6040,'and publishing of','and publishing of',0,1,1.5667,'A53142521',1),(6041,'and rich','and rich',0,1,1.2667,'A5362',1),(6042,'and rich media','and rich media',0,1,1.4667,'A536253',1),(6043,'and the','and the',0,1,1.2333,'A530',1),(6044,'and the rapid','and the rapid',0,1,1.4333,'A53613',1),(6045,'api','api',0,0,0.2,'A100',1),(6046,'api has','api has',0,1,1.2333,'A120',1),(6047,'api has such','api has such',0,1,1.4,'A120',1),(6048,'applications joomla','applications joomla',0,1,1.6333,'A14235254',1),(6049,'applications joomla now','applications joomla now',0,1,1.7667,'A142352545',1),(6050,'applications joomla provides','applications joomla provides',0,1,1.9333,'A1423525416132',1),(6051,'architect','architect',0,0,0.6,'A62323',1),(6052,'architect or','architect or',0,1,1.4,'A623236',1),(6053,'architect or a','architect or a',0,1,1.4667,'A623236',1),(6054,'are a','are a',0,1,1.1667,'A600',1),(6055,'are a systems','are a systems',0,1,1.4333,'A62352',1),(6056,'are free','are free',0,1,1.2667,'A616',1),(6057,'are free to','are free to',0,1,1.3667,'A6163',1),(6058,'as a catchcry','as a catchcry',0,1,1.4333,'A2326',1),(6059,'aspect','aspect',0,0,0.4,'A2123',1),(6060,'aspect of','aspect of',0,1,1.3,'A21231',1),(6061,'aspect of a','aspect of a',0,1,1.3667,'A21231',1),(6062,'because','because',0,0,0.4667,'B200',1),(6063,'because the','because the',0,1,1.3667,'B230',1),(6064,'because the new','because the new',0,1,1.5,'B235',1),(6065,'been','been',0,0,0.2667,'B500',3),(6066,'been playing','been playing',0,1,1.4,'B51452',1),(6067,'been playing with','been playing with',0,1,1.5667,'B514523',1),(6068,'before thinking','before thinking',0,1,1.5,'B635252',1),(6069,'before thinking web','before thinking web',0,1,1.6333,'B6352521',1),(6070,'blogs','blogs',0,0,0.3333,'B420',1),(6071,'blogs and','blogs and',0,1,1.3,'B4253',1),(6072,'blogs and ecommerce','blogs and ecommerce',0,1,1.6333,'B42532562',1),(6073,'brings','brings',0,0,0.4,'B652',2),(6074,'brings the','brings the',0,1,1.3333,'B6523',2),(6075,'brings the excitement','brings the excitement',0,1,1.7,'B65232353',1),(6076,'by a','by a',0,1,1.1333,'B000',1),(6077,'by a community','by a community',0,1,1.4667,'B253',1),(6078,'by organisations','by organisations',0,1,1.5333,'B6252352',1),(6079,'by organisations of','by organisations of',0,1,1.6333,'B62523521',1),(6080,'can help','can help',0,1,1.2667,'C541',1),(6081,'can help you','can help you',0,1,1.4,'C541',1),(6082,'can make','can make',0,1,1.2667,'C520',1),(6083,'can make this','can make this',0,1,1.4333,'C5232',1),(6084,'can take','can take',0,1,1.2667,'C532',1),(6085,'can take you','can take you',0,1,1.4,'C532',1),(6086,'catchcry','catchcry',0,0,0.5333,'C326',1),(6087,'catchcry because','catchcry because',0,1,1.5333,'C32612',1),(6088,'catchcry because the','catchcry because the',0,1,1.6667,'C326123',1),(6089,'cms\'','cms',0,0,0.2667,'C520',1),(6090,'cms\' is','cms is',0,1,1.2333,'C520',1),(6091,'cms\' is something','cms is something',0,1,1.5667,'C525352',1),(6092,'cms\' to','cms to',0,1,1.2333,'C523',1),(6093,'cms\' to your','cms to your',0,1,1.4,'C5236',1),(6094,'communities','communities',0,0,0.7333,'C532',1),(6095,'communities media','communities media',0,1,1.5667,'C53253',1),(6096,'communities media portals','communities media portals',0,1,1.8333,'C5325316342',1),(6097,'community','community',0,0,0.6,'C530',1),(6098,'community of','community of',0,1,1.4,'C531',1),(6099,'community of tens','community of tens',0,1,1.5667,'C531352',1),(6100,'complete','complete',0,0,0.5333,'C5143',1),(6101,'complete \'noob\'','complete noob',0,1,1.5,'C514351',1),(6102,'complete \'noob\' joomla','complete noob joomla',0,1,1.7333,'C514351254',1),(6103,'content delivery','content delivery',0,1,1.5333,'C5353416',1),(6104,'content delivery \'more','content delivery more',0,1,1.7333,'C535341656',1),(6105,'content including','content including',0,1,1.5667,'C5353524352',1),(6106,'content including html','content including html',0,1,1.7333,'C5353524352354',1),(6107,'content publishing','content publishing',0,1,1.6,'C535314252',1),(6108,'content publishing system','content publishing system',0,1,1.8333,'C53531425235',1),(6109,'creating','creating',0,0,0.5333,'C6352',2),(6110,'creating highly','creating highly',0,1,1.5,'C63524',1),(6111,'creating highly interactive','creating highly interactive',0,1,1.9,'C63524536231',1),(6112,'creative mind','creative mind',0,1,1.4333,'C63153',1),(6113,'creative mind takes','creative mind takes',0,1,1.6333,'C631532',1),(6114,'customisation','customisation',0,0,0.8667,'C35235',1),(6115,'customisation of','customisation of',0,1,1.5333,'C352351',1),(6116,'customisation of every','customisation of every',0,1,1.7333,'C3523516',1),(6117,'delivery','delivery',0,0,0.5333,'D416',1),(6118,'delivery \'more','delivery more',0,1,1.4667,'D41656',1),(6119,'delivery \'more than','delivery more than',0,1,1.6333,'D4165635',1),(6120,'designed','designed',0,0,0.5333,'D253',1),(6121,'designed for','designed for',0,1,1.4,'D25316',1),(6122,'designed for quickly','designed for quickly',0,1,1.6667,'D2531624',1),(6123,'developer','developer',0,0,0.6,'D1416',1),(6124,'developer power','developer power',0,1,1.5,'D141616',1),(6125,'developer power while','developer power while',0,1,1.7,'D1416164',1),(6126,'developer resources','developer resources',0,1,1.6333,'D1416262',1),(6127,'developer resources joomla','developer resources joomla',0,1,1.8667,'D141626254',1),(6128,'development','development',0,0,0.7333,'D14153',1),(6129,'development team','development team',0,1,1.5333,'D141535',1),(6130,'development team brings','development team brings',0,1,1.7667,'D1415351652',1),(6131,'direction','direction',0,0,0.6,'D6235',1),(6132,'direction your','direction your',0,1,1.4667,'D62356',1),(6133,'direction your creative','direction your creative',0,1,1.7667,'D623562631',1),(6134,'documented','documented',0,0,0.6667,'D253',1),(6135,'documented library','documented library',0,1,1.6,'D253416',1),(6136,'documented library of','documented library of',0,1,1.7,'D2534161',1),(6137,'documents','documents',0,0,0.6,'D2532',1),(6138,'documents and','documents and',0,1,1.4333,'D253253',1),(6139,'documents and rich','documents and rich',0,1,1.6,'D25325362',1),(6140,'easily','easily',0,0,0.4,'E240',1),(6141,'easily than','easily than',0,1,1.3667,'E2435',1),(6142,'easily than ever','easily than ever',0,1,1.5333,'E243516',1),(6143,'easy-to-use','easy-to-use',0,0,0.7333,'E232',1),(6144,'easy-to-use graphical','easy-to-use graphical',0,1,1.7,'E2326124',1),(6145,'easy-to-use graphical user','easy-to-use graphical user',0,1,1.8667,'E232612426',1),(6146,'ecommerce','ecommerce',0,0,0.6,'E2562',1),(6147,'ecommerce applications','ecommerce applications',0,1,1.7333,'E2562142352',1),(6148,'ecommerce applications joomla','ecommerce applications joomla',0,1,1.9667,'E256214235254',1),(6149,'ever','ever',0,0,0.2667,'E160',1),(6150,'ever before','ever before',0,1,1.3667,'E1616',1),(6151,'ever before thinking','ever before thinking',0,1,1.6667,'E161635252',1),(6152,'every','every',0,0,0.3333,'E160',1),(6153,'every aspect','every aspect',0,1,1.4,'E162123',1),(6154,'every aspect of','every aspect of',0,1,1.5,'E1621231',1),(6155,'excitement','excitement',0,0,0.6667,'E2353',1),(6156,'excitement of','excitement of',0,1,1.4333,'E23531',1),(6157,'excitement of \'the','excitement of the',0,1,1.6,'E235313',1),(6158,'experience','experience',0,0,0.6667,'E21652',1),(6159,'experience all','experience all',0,1,1.4667,'E216524',1),(6160,'experience all the','experience all the',0,1,1.6,'E2165243',1),(6161,'extensibility','extensibility',0,0,0.8667,'E2352143',1),(6162,'extensibility joomla','extensibility joomla',0,1,1.6667,'E2352143254',1),(6163,'extensibility joomla 1.5','extensibility joomla 1.5',0,1,1.8,'E2352143254',1),(6164,'extranets','extranets',0,0,0.6,'E236532',1),(6165,'extranets and','extranets and',0,1,1.4333,'E23653253',1),(6166,'extranets and is','extranets and is',0,1,1.5333,'E236532532',1),(6167,'fingertips','fingertips',0,0,0.6667,'F526312',1),(6168,'fingertips whether','fingertips whether',0,1,1.6,'F52631236',1),(6169,'fingertips whether you','fingertips whether you',0,1,1.7333,'F52631236',1),(6170,'flexibility','flexibility',0,0,0.7333,'F42143',1),(6171,'flexibility you','flexibility you',0,1,1.5,'F42143',1),(6172,'flexibility you are','flexibility you are',0,1,1.6333,'F421436',1),(6173,'for intranets','for intranets',0,1,1.4333,'F6536532',1),(6174,'for intranets and','for intranets and',0,1,1.5667,'F653653253',1),(6175,'for quickly','for quickly',0,1,1.3667,'F624',1),(6176,'for quickly creating','for quickly creating',0,1,1.6667,'F62426352',1),(6177,'for those','for those',0,1,1.3,'F632',1),(6178,'for those who','for those who',0,1,1.4333,'F632',1),(6179,'framework','framework',0,0,0.6,'F6562',1),(6180,'framework and','framework and',0,1,1.4333,'F656253',1),(6181,'framework and content','framework and content',0,1,1.7,'F65625325353',1),(6182,'framework ground-up','framework ground-up',0,1,1.6333,'F65626531',1),(6183,'framework ground-up refactoring','framework ground-up refactoring',0,1,2,'F656265316123652',1),(6184,'free open','free open',0,1,1.3,'F615',1),(6185,'free open source','free open source',0,1,1.5333,'F615262',1),(6186,'free to take','free to take',0,1,1.4,'F632',1),(6187,'friendly','friendly',0,0,0.5333,'F6534',1),(6188,'friendly for','friendly for',0,1,1.4,'F653416',1),(6189,'friendly for those','friendly for those',0,1,1.6,'F65341632',1),(6190,'fully','fully',0,0,0.3333,'F400',2),(6191,'fully documented','fully documented',0,1,1.5333,'F43253',1),(6192,'fully documented library','fully documented library',0,1,1.8,'F43253416',1),(6193,'generation','generation',0,0,0.6667,'G5635',1),(6194,'generation cms\'','generation cms',0,1,1.5,'G5635252',1),(6195,'generation cms\' to','generation cms to',0,1,1.6,'G56352523',1),(6196,'get there','get there',0,1,1.3,'G360',1),(6197,'get there so','get there so',0,1,1.4,'G362',1),(6198,'graphical','graphical',0,0,0.6,'G6124',1),(6199,'graphical user','graphical user',0,1,1.4667,'G612426',1),(6200,'graphical user interface','graphical user interface',0,1,1.8,'G61242653612',1),(6201,'ground-up','ground-up',0,0,0.6,'G6531',1),(6202,'ground-up refactoring','ground-up refactoring',0,1,1.7,'G65316123652',1),(6203,'ground-up refactoring and','ground-up refactoring and',0,1,1.8333,'G6531612365253',1),(6204,'happen','happen',0,0,0.4,'H150',1),(6205,'happen a','happen a',0,1,1.2667,'H150',1),(6206,'happen a new','happen a new',0,1,1.4,'H150',1),(6207,'has such','has such',0,1,1.2667,'H200',1),(6208,'has such incredible','has such incredible',0,1,1.6333,'H2526314',1),(6209,'have been','have been',0,1,1.3,'H150',3),(6210,'have been playing','have been playing',0,1,1.5667,'H151452',1),(6211,'help you','help you',0,1,1.2667,'H410',1),(6212,'help you get','help you get',0,1,1.4,'H4123',1),(6213,'highly','highly',0,0,0.4,'H240',1),(6214,'highly interactive','highly interactive',0,1,1.6,'H24536231',1),(6215,'highly interactive multi-language','highly interactive multi-language',0,1,2,'H24536231543452',1),(6216,'highly-active','highly-active',0,0,0.8667,'H24231',1),(6217,'highly-active development','highly-active development',0,1,1.8333,'H24231314153',1),(6218,'highly-active development team','highly-active development team',0,1,2,'H242313141535',1),(6219,'html','html',0,0,0.2667,'H354',3),(6220,'html documents','html documents',0,1,1.4667,'H35432532',1),(6221,'html documents and','html documents and',0,1,1.6,'H3543253253',1),(6222,'including html','including html',0,1,1.4667,'I524352354',1),(6223,'including html documents','including html documents',0,1,1.8,'I52435235432532',1),(6224,'including presentation','including presentation',0,1,1.7333,'I524352162535',1),(6225,'including presentation layout','including presentation layout',0,1,1.9667,'I52435216253543',1),(6226,'increased','increased',0,0,0.6,'I52623',1),(6227,'increased extensibility','increased extensibility',0,1,1.7667,'I526232352143',1),(6228,'increased extensibility joomla','increased extensibility joomla',0,1,2,'I526232352143254',1),(6229,'incredible','incredible',0,0,0.6667,'I526314',1),(6230,'incredible power','incredible power',0,1,1.5333,'I52631416',1),(6231,'incredible power and','incredible power and',0,1,1.6667,'I5263141653',1),(6232,'integration','integration',0,0,0.7333,'I532635',1),(6233,'integration with','integration with',0,1,1.5333,'I5326353',1),(6234,'integration with third-party','integration with third-party',0,1,1.9333,'I532635363163',1),(6235,'interactive','interactive',0,0,0.7333,'I536231',1),(6236,'interactive multi-language','interactive multi-language',0,1,1.8667,'I536231543452',1),(6237,'interactive multi-language web','interactive multi-language web',0,1,2,'I5362315434521',1),(6238,'interface that','interface that',0,1,1.4667,'I536123',1),(6239,'interface that simplifies','interface that simplifies',0,1,1.8333,'I536123251412',1),(6240,'intranets','intranets',0,0,0.6,'I536532',1),(6241,'intranets and','intranets and',0,1,1.4333,'I53653253',1),(6242,'intranets and extranets','intranets and extranets',0,1,1.7667,'I53653253236532',1),(6243,'is a free','is a free',0,1,1.3,'I216',1),(6244,'is something','is something',0,1,1.4,'I25352',1),(6245,'is something we','is something we',0,1,1.5,'I25352',1),(6246,'is supported','is supported',0,1,1.4,'I2163',1),(6247,'is supported by','is supported by',0,1,1.5,'I21631',1),(6248,'is used','is used',0,1,1.2333,'I230',1),(6249,'is used by','is used by',0,1,1.3333,'I231',1),(6250,'joomla 1.5','joomla 1.5',0,1,1.3333,'J540',1),(6251,'joomla 1.5 can','joomla 1.5 can',0,1,1.4667,'J5425',1),(6252,'joomla allows','joomla allows',0,1,1.4333,'J542',1),(6253,'joomla allows the','joomla allows the',0,1,1.5667,'J5423',1),(6254,'joomla api','joomla api',0,1,1.3333,'J541',1),(6255,'joomla api has','joomla api has',0,1,1.4667,'J5412',1),(6256,'joomla can','joomla can',0,1,1.3333,'J5425',1),(6257,'joomla can help','joomla can help',0,1,1.5,'J542541',1),(6258,'joomla can take','joomla can take',0,1,1.5,'J542532',1),(6259,'joomla is','joomla is',0,1,1.3,'J542',1),(6260,'joomla is a','joomla is a',0,1,1.3667,'J542',1),(6261,'joomla is used','joomla is used',0,1,1.4667,'J5423',1),(6262,'joomla now','joomla now',0,1,1.3333,'J545',1),(6263,'joomla now provides','joomla now provides',0,1,1.6333,'J54516132',1),(6264,'joomla provides','joomla provides',0,1,1.5,'J5416132',1),(6265,'joomla provides an','joomla provides an',0,1,1.6,'J54161325',1),(6266,'large volumes','large volumes',0,1,1.4333,'L621452',1),(6267,'large volumes of','large volumes of',0,1,1.5333,'L6214521',1),(6268,'layout','layout',0,0,0.4,'L300',1),(6269,'layout administration','layout administration',0,1,1.7,'L3523635',1),(6270,'layout administration and','layout administration and',0,1,1.8333,'L35236353',1),(6271,'level','level',0,0,0.3333,'L140',1),(6272,'level of','level of',0,1,1.2667,'L141',1),(6273,'level of content','level of content',0,1,1.5333,'L14125353',1),(6274,'library','library',0,0,0.4667,'L160',1),(6275,'library of','library of',0,1,1.3333,'L161',1),(6276,'library of developer','library of developer',0,1,1.6667,'L16131416',1),(6277,'make this happen','make this happen',0,1,1.5333,'M23215',1),(6278,'making the','making the',0,1,1.3333,'M2523',1),(6279,'making the user','making the user',0,1,1.5,'M252326',1),(6280,'management','management',0,0,0.6667,'M253',1),(6281,'management and','management and',0,1,1.4667,'M25353',1),(6282,'management and publishing','management and publishing',0,1,1.8333,'M2535314252',1),(6283,'media','media',0,0,0.3333,'M300',1),(6284,'media joomla','media joomla',0,1,1.4,'M3254',1),(6285,'media joomla is','media joomla is',0,1,1.5,'M32542',1),(6286,'media portals','media portals',0,1,1.4333,'M316342',1),(6287,'media portals blogs','media portals blogs',0,1,1.6333,'M316342142',1),(6288,'mind','mind',0,0,0.2667,'M300',2),(6289,'mind takes','mind takes',0,1,1.3333,'M320',1),(6290,'mind takes you','mind takes you',0,1,1.4667,'M320',1),(6291,'more developer','more developer',0,1,1.4667,'M631416',1),(6292,'more developer power','more developer power',0,1,1.6667,'M63141616',1),(6293,'more easily','more easily',0,1,1.3667,'M624',1),(6294,'more easily than','more easily than',0,1,1.5333,'M62435',1),(6295,'more friendly','more friendly',0,1,1.4333,'M616534',1),(6296,'more friendly for','more friendly for',0,1,1.5667,'M61653416',1),(6297,'much','much',0,0,0.2667,'M200',1),(6298,'much more','much more',0,1,1.3,'M256',1),(6299,'much more easily','much more easily',0,1,1.5333,'M25624',1),(6300,'multi-language','multi-language',0,0,0.9333,'M43452',1),(6301,'multi-language web','multi-language web',0,1,1.6,'M434521',1),(6302,'multi-language web sites','multi-language web sites',0,1,1.8,'M434521232',1),(6303,'new framework','new framework',0,1,1.4333,'N16562',1),(6304,'new framework ground-up','new framework ground-up',0,1,1.7667,'N165626531',1),(6305,'new joomla','new joomla',0,1,1.3333,'N254',1),(6306,'new joomla api','new joomla api',0,1,1.4667,'N2541',1),(6307,'next','next',0,0,0.2667,'N230',1),(6308,'next generation','next generation',0,1,1.5,'N2325635',1),(6309,'next generation cms\'','next generation cms',0,1,1.6667,'N2325635252',1),(6310,'next level','next level',0,1,1.3333,'N23414',1),(6311,'next level of','next level of',0,1,1.4333,'N234141',1),(6312,'now','now',0,0,0.2,'N000',1),(6313,'now provides','now provides',0,1,1.4,'N16132',1),(6314,'now provides more','now provides more',0,1,1.5667,'N1613256',1),(6315,'of \'the','of the',0,1,1.2333,'O130',1),(6316,'of \'the next','of the next',0,1,1.4,'O13523',1),(6317,'of a web','of a web',0,1,1.2667,'O100',1),(6318,'of all','of all',0,1,1.2,'O140',1),(6319,'of all sizes','of all sizes',0,1,1.4,'O142',1),(6320,'of content','of content',0,1,1.3333,'O125353',1),(6321,'of content delivery','of content delivery',0,1,1.6333,'O125353416',1),(6322,'of content including','of content including',0,1,1.6667,'O125353524352',1),(6323,'of developer','of developer',0,1,1.4,'O131416',1),(6324,'of developer resources','of developer resources',0,1,1.7333,'O131416262',1),(6325,'of every','of every',0,1,1.2667,'O160',1),(6326,'of every aspect','of every aspect',0,1,1.5,'O162123',1),(6327,'of large','of large',0,1,1.2667,'O1462',1),(6328,'of large volumes','of large volumes',0,1,1.5333,'O14621452',1),(6329,'of tens','of tens',0,1,1.2333,'O1352',1),(6330,'of tens of','of tens of',0,1,1.3333,'O13521',1),(6331,'of thousands','of thousands',0,1,1.4,'O132532',1),(6332,'of thousands of','of thousands of',0,1,1.5,'O1325321',1),(6333,'online','online',0,0,0.4,'O545',2),(6334,'online communities','online communities',0,1,1.6,'O5452532',1),(6335,'online communities media','online communities media',0,1,1.8,'O545253253',1),(6336,'open','open',0,0,0.2667,'O150',1),(6337,'open source','open source',0,1,1.3667,'O15262',1),(6338,'open source framework','open source framework',0,1,1.7,'O1526216562',1),(6339,'or a','or a',0,1,1.1333,'O600',1),(6340,'or a complete','or a complete',0,1,1.4333,'O625143',1),(6341,'organisations','organisations',0,0,0.8667,'O6252352',1),(6342,'organisations of','organisations of',0,1,1.5333,'O62523521',1),(6343,'organisations of all','organisations of all',0,1,1.6667,'O625235214',1),(6344,'playing','playing',0,0,0.4667,'P452',1),(6345,'playing with','playing with',0,1,1.4,'P4523',1),(6346,'playing with as','playing with as',0,1,1.5,'P45232',1),(6347,'portals','portals',0,0,0.4667,'P6342',1),(6348,'portals blogs','portals blogs',0,1,1.4333,'P6342142',1),(6349,'portals blogs and','portals blogs and',0,1,1.5667,'P634214253',1),(6350,'power','power',0,0,0.3333,'P600',2),(6351,'power and','power and',0,1,1.3,'P653',1),(6352,'power and flexibility','power and flexibility',0,1,1.7,'P653142143',1),(6353,'power while','power while',0,1,1.3667,'P640',1),(6354,'power while making','power while making',0,1,1.6,'P645252',1),(6355,'presentation','presentation',0,0,0.8,'P62535',2),(6356,'presentation layout','presentation layout',0,1,1.6333,'P6253543',1),(6357,'presentation layout administration','presentation layout administration',0,1,2,'P6253543523635',1),(6358,'provides an','provides an',0,1,1.3667,'P61325',1),(6359,'provides an easy-to-use','provides an easy-to-use',0,1,1.7667,'P61325232',1),(6360,'provides more','provides more',0,1,1.4333,'P613256',1),(6361,'provides more developer','provides more developer',0,1,1.7667,'P61325631416',1),(6362,'publishing','publishing',0,0,0.6667,'P4252',1),(6363,'publishing of','publishing of',0,1,1.4333,'P42521',1),(6364,'publishing of large','publishing of large',0,1,1.6333,'P42521462',1),(6365,'publishing system','publishing system',0,1,1.5667,'P425235',1),(6366,'publishing system designed','publishing system designed',0,1,1.8667,'P4252353253',1),(6367,'publishing think','publishing think',0,1,1.5333,'P4252352',1),(6368,'publishing think joomla','publishing think joomla',0,1,1.7667,'P425235254',1),(6369,'quickly','quickly',0,0,0.4667,'Q400',1),(6370,'quickly creating','quickly creating',0,1,1.5333,'Q426352',1),(6371,'quickly creating highly','quickly creating highly',0,1,1.7667,'Q4263524',1),(6372,'rapid','rapid',0,0,0.3333,'R130',2),(6373,'rapid integration','rapid integration',0,1,1.5667,'R13532635',1),(6374,'rapid integration with','rapid integration with',0,1,1.7333,'R135326353',1),(6375,'refactoring','refactoring',0,0,0.7333,'R123652',1),(6376,'refactoring and','refactoring and',0,1,1.5,'R12365253',1),(6377,'refactoring and a','refactoring and a',0,1,1.5667,'R12365253',1),(6378,'resources','resources',0,0,0.6,'R262',1),(6379,'resources joomla','resources joomla',0,1,1.5333,'R26254',1),(6380,'resources joomla allows','resources joomla allows',0,1,1.7667,'R262542',1),(6381,'rich','rich',0,0,0.2667,'R200',1),(6382,'rich media','rich media',0,1,1.3333,'R253',1),(6383,'rich media joomla','rich media joomla',0,1,1.5667,'R253254',1),(6384,'simplifies','simplifies',0,0,0.6667,'S51412',1),(6385,'simplifies the','simplifies the',0,1,1.4667,'S514123',1),(6386,'simplifies the management','simplifies the management',0,1,1.8333,'S5141235253',1),(6387,'site including','site including',0,1,1.4667,'S3524352',1),(6388,'site including presentation','site including presentation',0,1,1.9,'S3524352162535',1),(6389,'sites','sites',0,0,0.3333,'S320',2),(6390,'sites online','sites online',0,1,1.4,'S32545',1),(6391,'sites online communities','sites online communities',0,1,1.8,'S325452532',1),(6392,'sizes','sizes',0,0,0.3333,'S000',1),(6393,'sizes for','sizes for',0,1,1.3,'S160',1),(6394,'sizes for intranets','sizes for intranets',0,1,1.6333,'S16536532',1),(6395,'so much','so much',0,1,1.2333,'S520',1),(6396,'so much more','so much more',0,1,1.4,'S5256',1),(6397,'something','something',0,0,0.6,'S5352',1),(6398,'something we','something we',0,1,1.4,'S5352',1),(6399,'something we have','something we have',0,1,1.5667,'S53521',1),(6400,'source framework','source framework',0,1,1.5333,'S6216562',1),(6401,'source framework and','source framework and',0,1,1.6667,'S621656253',1),(6402,'such incredible','such incredible',0,1,1.5,'S526314',1),(6403,'such incredible power','such incredible power',0,1,1.7,'S52631416',1),(6404,'supported','supported',0,0,0.6,'S163',1),(6405,'supported by','supported by',0,1,1.4,'S1631',1),(6406,'supported by a','supported by a',0,1,1.4667,'S1631',1),(6407,'system designed','system designed',0,1,1.5,'S353253',1),(6408,'system designed for','system designed for',0,1,1.6333,'S35325316',1),(6409,'systems','systems',0,0,0.4667,'S352',1),(6410,'systems architect','systems architect',0,1,1.5667,'S35262323',1),(6411,'systems architect or','systems architect or',0,1,1.6667,'S352623236',1),(6412,'take','take',0,0,0.2667,'T200',1),(6413,'take whatever','take whatever',0,1,1.4333,'T2316',1),(6414,'take whatever direction','take whatever direction',0,1,1.7667,'T231636235',1),(6415,'take you','take you',0,1,1.2667,'T200',1),(6416,'take you to','take you to',0,1,1.3667,'T230',1),(6417,'takes','takes',0,0,0.3333,'T200',1),(6418,'takes you','takes you',0,1,1.3,'T200',1),(6419,'takes you and','takes you and',0,1,1.4333,'T253',1),(6420,'team','team',0,0,0.2667,'T500',2),(6421,'team brings','team brings',0,1,1.3667,'T51652',1),(6422,'team brings the','team brings the',0,1,1.5,'T516523',1),(6423,'tens','tens',0,0,0.2667,'T520',1),(6424,'tens of','tens of',0,1,1.2333,'T521',1),(6425,'tens of thousands','tens of thousands',0,1,1.5667,'T52132532',1),(6426,'than','than',0,0,0.2667,'T500',1),(6427,'than a','than a',0,1,1.2,'T500',1),(6428,'than a cms\'','than a cms',0,1,1.3667,'T5252',1),(6429,'than ever','than ever',0,1,1.3,'T516',1),(6430,'than ever before','than ever before',0,1,1.5333,'T51616',1),(6431,'that simplifies','that simplifies',0,1,1.5,'T251412',1),(6432,'that simplifies the','that simplifies the',0,1,1.6333,'T2514123',1),(6433,'the customisation','the customisation',0,1,1.5667,'T235235',1),(6434,'the customisation of','the customisation of',0,1,1.6667,'T2352351',1),(6435,'the excitement','the excitement',0,1,1.4667,'T2353',1),(6436,'the excitement of','the excitement of',0,1,1.5667,'T23531',1),(6437,'the management','the management',0,1,1.4667,'T5253',1),(6438,'the management and','the management and',0,1,1.6,'T525353',1),(6439,'the more','the more',0,1,1.2667,'T560',1),(6440,'the more friendly','the more friendly',0,1,1.5667,'T5616534',1),(6441,'the new','the new',0,1,1.2333,'T500',1),(6442,'the new joomla','the new joomla',0,1,1.4667,'T5254',1),(6443,'the next','the next',0,1,1.2667,'T523',1),(6444,'the next level','the next level',0,1,1.4667,'T523414',1),(6445,'the rapid','the rapid',0,1,1.3,'T613',2),(6446,'the rapid integration','the rapid integration',0,1,1.7,'T613532635',1),(6447,'the user experience','the user experience',0,1,1.6333,'T2621652',1),(6448,'there so','there so',0,1,1.2667,'T620',1),(6449,'there so much','there so much',0,1,1.4333,'T6252',1),(6450,'think','think',0,0,0.3333,'T520',1),(6451,'think joomla','think joomla',0,1,1.4,'T5254',1),(6452,'thinking','thinking',0,0,0.5333,'T5252',1),(6453,'thinking web','thinking web',0,1,1.4,'T52521',1),(6454,'thinking web publishing','thinking web publishing',0,1,1.7667,'T525214252',1),(6455,'third-party','third-party',0,0,0.7333,'T63163',1),(6456,'third-party applications','third-party applications',0,1,1.8,'T63163142352',1),(6457,'third-party applications joomla','third-party applications joomla',0,1,2,'T6316314235254',1),(6458,'this happen','this happen',0,1,1.3667,'T215',1),(6459,'this happen a','this happen a',0,1,1.4333,'T215',1),(6460,'those','those',0,0,0.3333,'T200',1),(6461,'those who','those who',0,1,1.3,'T200',1),(6462,'those who always','those who always',0,1,1.5333,'T242',1),(6463,'thousands','thousands',0,0,0.6,'T2532',2),(6464,'thousands of','thousands of',0,1,1.4,'T25321',2),(6465,'thousands of users','thousands of users',0,1,1.6,'T25321262',1),(6466,'to joomla','to joomla',0,1,1.3,'T254',1),(6467,'to take','to take',0,1,1.2333,'T200',1),(6468,'to take whatever','to take whatever',0,1,1.5333,'T2316',1),(6469,'to the next','to the next',0,1,1.3667,'T523',1),(6470,'to your','to your',0,1,1.2333,'T600',1),(6471,'to your fingertips','to your fingertips',0,1,1.6,'T61526312',1),(6472,'used by','used by',0,1,1.2333,'U231',1),(6473,'used by organisations','used by organisations',0,1,1.7,'U2316252352',1),(6474,'user experience','user experience',0,1,1.5,'U2621652',1),(6475,'user experience all','user experience all',0,1,1.6333,'U26216524',1),(6476,'user interface','user interface',0,1,1.4667,'U2653612',1),(6477,'user interface that','user interface that',0,1,1.6333,'U26536123',1),(6478,'volumes','volumes',0,0,0.4667,'V452',1),(6479,'volumes of','volumes of',0,1,1.3333,'V4521',1),(6480,'volumes of content','volumes of content',0,1,1.6,'V452125353',1),(6481,'wanted','wanted',0,0,0.4,'W530',1),(6482,'wanted increased','wanted increased',0,1,1.5333,'W5352623',1),(6483,'wanted increased extensibility','wanted increased extensibility',0,1,2,'W53526232352143',1),(6484,'we have','we have',0,1,1.2333,'W100',1),(6485,'we have been','we have been',0,1,1.4,'W150',1),(6486,'web publishing','web publishing',0,1,1.4667,'W14252',1),(6487,'web publishing think','web publishing think',0,1,1.6667,'W14252352',1),(6488,'web site including','web site including',0,1,1.6,'W123524352',1),(6489,'web sites','web sites',0,1,1.3,'W1232',1),(6490,'web sites online','web sites online',0,1,1.5333,'W1232545',1),(6491,'welcome','welcome',0,0,0.4667,'W425',1),(6492,'welcome to','welcome to',0,1,1.3333,'W4253',1),(6493,'welcome to joomla','welcome to joomla',0,1,1.5667,'W4253254',1),(6494,'whatever','whatever',0,0,0.5333,'W316',1),(6495,'whatever direction','whatever direction',0,1,1.6,'W31636235',1),(6496,'whatever direction your','whatever direction your',0,1,1.7667,'W316362356',1),(6497,'whether','whether',0,0,0.4667,'W360',1),(6498,'whether you','whether you',0,1,1.3667,'W360',1),(6499,'whether you are','whether you are',0,1,1.5,'W360',1),(6500,'while','while',0,0,0.3333,'W400',1),(6501,'while making','while making',0,1,1.4,'W45252',1),(6502,'while making the','while making the',0,1,1.5333,'W452523',1),(6503,'who','who',0,0,0.2,'W000',4),(6504,'who always','who always',0,1,1.3333,'W420',1),(6505,'who always wanted','who always wanted',0,1,1.5667,'W4253',1),(6506,'with a','with a',0,1,1.2,'W300',1),(6507,'with a fully','with a fully',0,1,1.4,'W314',1),(6508,'with as','with as',0,1,1.2333,'W320',1),(6509,'with as a','with as a',0,1,1.3,'W320',1),(6510,'with third-party','with third-party',0,1,1.5333,'W363163',1),(6511,'with third-party applications','with third-party applications',0,1,1.9667,'W363163142352',1),(6512,'you and','you and',0,1,1.2333,'Y530',2),(6513,'you and joomla','you and joomla',0,1,1.4667,'Y53254',1),(6514,'you are','you are',0,1,1.2333,'Y600',2),(6515,'you are a','you are a',0,1,1.3,'Y600',1),(6516,'you are free','you are free',0,1,1.4,'Y616',1),(6517,'you get','you get',0,1,1.2333,'Y230',1),(6518,'you get there','you get there',0,1,1.4333,'Y236',1),(6519,'you to','you to',0,1,1.2,'Y300',1),(6520,'you to the','you to the',0,1,1.3333,'Y300',1),(6521,'your creative','your creative',0,1,1.4333,'Y62631',1),(6522,'your creative mind','your creative mind',0,1,1.6,'Y6263153',1),(6523,'your fingertips','your fingertips',0,1,1.5,'Y61526312',1),(6524,'your fingertips whether','your fingertips whether',0,1,1.7667,'Y6152631236',1),(6525,'26','26',0,0,0.2,'',1),(6526,'a facilisis quis','a facilisis quis',0,1,1.5333,'A1242',7),(6527,'a most','a most',0,1,1.2,'A523',1),(6528,'a most artful','a most artful',0,1,1.4333,'A5236314',1),(6529,'a porttitor','a porttitor',0,1,1.3667,'A1636',9),(6530,'a porttitor suspendisse','a porttitor suspendisse',0,1,1.7667,'A163621532',8),(6531,'a suscipit','a suscipit',0,1,1.3333,'A213',8),(6532,'a suscipit nisl','a suscipit nisl',0,1,1.5,'A213524',8),(6533,'a vulputate','a vulputate',0,1,1.3667,'A1413',8),(6534,'a vulputate tortor','a vulputate tortor',0,1,1.6,'A1413636',8),(6535,'ac arcu','ac arcu',0,1,1.2333,'A262',7),(6536,'ac arcu viverra','ac arcu viverra',0,1,1.5,'A26216',7),(6537,'ac augue','ac augue',0,1,1.2667,'A200',7),(6538,'ac augue nullam','ac augue nullam',0,1,1.5,'A2545',7),(6539,'ac lectus','ac lectus',0,1,1.3,'A24232',7),(6540,'ac lectus integer','ac lectus integer',0,1,1.5667,'A242325326',7),(6541,'ac lorem','ac lorem',0,1,1.2667,'A2465',8),(6542,'ac lorem accumsan','ac lorem accumsan',0,1,1.5667,'A24652525',8),(6543,'ac mauris','ac mauris',0,1,1.3,'A2562',7),(6544,'ac mauris ac','ac mauris ac',0,1,1.4,'A2562',7),(6545,'ac semper','ac semper',0,1,1.3,'A2516',8),(6546,'ac semper sit','ac semper sit',0,1,1.4333,'A251623',8),(6547,'ac sollicitudin','ac sollicitudin',0,1,1.5,'A24235',7),(6548,'ac sollicitudin eu','ac sollicitudin eu',0,1,1.6,'A24235',7),(6549,'ac vel','ac vel',0,1,1.2,'A214',8),(6550,'ac vel arcu','ac vel arcu',0,1,1.3667,'A21462',8),(6551,'accumsan eu','accumsan eu',0,1,1.3667,'A2525',8),(6552,'accumsan eu lobortis','accumsan eu lobortis',0,1,1.6667,'A252541632',8),(6553,'accumsan tortor','accumsan tortor',0,1,1.5,'A25253636',8),(6554,'accumsan tortor ligula','accumsan tortor ligula',0,1,1.7333,'A25253636424',8),(6555,'advancement','advancement',0,0,0.7333,'A315253',1),(6556,'advancement of','advancement of',0,1,1.4667,'A3152531',1),(6557,'advancement of technology','advancement of technology',0,1,1.8333,'A315253132542',1),(6558,'affordable','affordable',0,0,0.6667,'A16314',1),(6559,'affordable costs','affordable costs',0,1,1.5333,'A16314232',1),(6560,'aliquam et','aliquam et',0,1,1.3333,'A4253',8),(6561,'aliquam et rhoncus','aliquam et rhoncus',0,1,1.6,'A4253652',8),(6562,'aliquam eu','aliquam eu',0,1,1.3333,'A425',8),(6563,'aliquam eu lacus','aliquam eu lacus',0,1,1.5333,'A42542',8),(6564,'aliquet neque','aliquet neque',0,1,1.4333,'A42352',8),(6565,'aliquet neque a','aliquet neque a',0,1,1.5,'A42352',8),(6566,'amet in','amet in',0,1,1.2333,'A535',7),(6567,'amet in quam','amet in quam',0,1,1.4,'A53525',7),(6568,'amet tincidunt','amet tincidunt',0,1,1.4667,'A5352353',8),(6569,'amet tincidunt at','amet tincidunt at',0,1,1.5667,'A5352353',8),(6570,'and dedicated','and dedicated',0,1,1.4333,'A5323',2),(6571,'and dedicated manner','and dedicated manner',0,1,1.6667,'A532356',2),(6572,'and internet','and internet',0,1,1.4,'A5353653',1),(6573,'and internet thousands','and internet thousands',0,1,1.7333,'A53536532532',1),(6574,'ante at','ante at',0,1,1.2333,'A530',8),(6575,'ante at dui','ante at dui',0,1,1.3667,'A530',8),(6576,'ante id','ante id',0,1,1.2333,'A530',8),(6577,'ante id ligula','ante id ligula',0,1,1.4667,'A53424',8),(6578,'ante sapien','ante sapien',0,1,1.3667,'A53215',8),(6579,'ante sapien ultricies','ante sapien ultricies',0,1,1.7,'A532154362',8),(6580,'arcu cras','arcu cras',0,1,1.3,'A6262',8),(6581,'arcu cras ornare','arcu cras ornare',0,1,1.5333,'A6262656',8),(6582,'arcu et','arcu et',0,1,1.2333,'A623',9),(6583,'arcu et risus','arcu et risus',0,1,1.4333,'A62362',8),(6584,'arcu malesuada','arcu malesuada',0,1,1.4667,'A625423',8),(6585,'arcu malesuada a','arcu malesuada a',0,1,1.5333,'A625423',8),(6586,'arcu praesent','arcu praesent',0,1,1.4333,'A6216253',8),(6587,'arcu praesent malesuada','arcu praesent malesuada',0,1,1.7667,'A62162535423',8),(6588,'arcu viverra','arcu viverra',0,1,1.4,'A6216',7),(6589,'arcu viverra facilisis','arcu viverra facilisis',0,1,1.7333,'A62161242',7),(6590,'artful','artful',0,0,0.4,'A6314',2),(6591,'artful and','artful and',0,1,1.3333,'A631453',2),(6592,'artful and dedicated','artful and dedicated',0,1,1.6667,'A63145323',2),(6593,'at dui','at dui',0,1,1.2,'A300',8),(6594,'at dui vulputate','at dui vulputate',0,1,1.5333,'A31413',8),(6595,'at est','at est',0,1,1.2,'A323',8),(6596,'at est quis','at est quis',0,1,1.3667,'A3232',8),(6597,'at lectus','at lectus',0,1,1.3,'A34232',8),(6598,'at lectus luctus','at lectus luctus',0,1,1.5333,'A342324232',8),(6599,'at neque','at neque',0,1,1.2667,'A352',8),(6600,'at neque maecenas','at neque maecenas',0,1,1.5667,'A3525252',8),(6601,'at nibh','at nibh',0,1,1.2333,'A351',8),(6602,'at nibh duis','at nibh duis',0,1,1.4,'A35132',8),(6603,'auctor et turpis','auctor et turpis',0,1,1.5333,'A2363612',8),(6604,'auctor proin','auctor proin',0,1,1.4,'A236165',8),(6605,'auctor proin rutrum','auctor proin rutrum',0,1,1.6333,'A2361656365',8),(6606,'augue nullam','augue nullam',0,1,1.4,'A2545',7),(6607,'augue nullam nulla','augue nullam nulla',0,1,1.6,'A25454',7),(6608,'augue pellentesque','augue pellentesque',0,1,1.6,'A214532',10),(6609,'augue pellentesque eu','augue pellentesque eu',0,1,1.7,'A214532',8),(6610,'augue pellentesque vestibulum','augue pellentesque vestibulum',0,1,1.9667,'A214532123145',8),(6611,'augue rutrum','augue rutrum',0,1,1.4,'A26365',7),(6612,'augue rutrum nisl','augue rutrum nisl',0,1,1.5667,'A2636524',7),(6613,'been emerged','been emerged',0,1,1.4,'B5623',1),(6614,'been emerged nowadays','been emerged nowadays',0,1,1.7,'B5623532',1),(6615,'been launched','been launched',0,1,1.4333,'B54523',1),(6616,'been launched over','been launched over',0,1,1.6,'B5452316',1),(6617,'blandit accumsan','blandit accumsan',0,1,1.5333,'B4532525',8),(6618,'blandit accumsan tortor','blandit accumsan tortor',0,1,1.7667,'B45325253636',8),(6619,'blandit neque','blandit neque',0,1,1.4333,'B45352',8),(6620,'blandit neque quis','blandit neque quis',0,1,1.6,'B45352',8),(6621,'blandit nisl','blandit nisl',0,1,1.4,'B453524',8),(6622,'blandit nisl nec','blandit nisl nec',0,1,1.5333,'B45352452',8),(6623,'business conference','business conference',0,1,1.6333,'B25251652',2),(6624,'business meetings','business meetings',0,1,1.5667,'B2525352',2),(6625,'business meetings sites','business meetings sites',0,1,1.7667,'B252535232',1),(6626,'business services','business services',0,1,1.5667,'B252612',1),(6627,'business services to','business services to',0,1,1.6667,'B2526123',1),(6628,'business sites','business sites',0,1,1.4667,'B25232',1),(6629,'business sites have','business sites have',0,1,1.6333,'B252321',1),(6630,'commodo convallis','commodo convallis',0,1,1.5667,'C5325142',8),(6631,'commodo convallis eu','commodo convallis eu',0,1,1.6667,'C5325142',8),(6632,'condimentum urna et','condimentum urna et',0,1,1.6333,'C53535653',8),(6633,'conference','conference',0,0,0.6667,'C51652',2),(6634,'congue blandit','congue blandit',0,1,1.4667,'C521453',8),(6635,'congue blandit nisl','congue blandit nisl',0,1,1.6333,'C521453524',8),(6636,'consectetur gravida','consectetur gravida',0,1,1.6333,'C52362613',8),(6637,'consectetur gravida pharetra','consectetur gravida pharetra',0,1,1.9333,'C523626131636',8),(6638,'consectetur pellentesque','consectetur pellentesque',0,1,1.8,'C523614532',7),(6639,'consectetur pellentesque sed','consectetur pellentesque sed',0,1,1.9333,'C5236145323',7),(6640,'convallis ante','convallis ante',0,1,1.4667,'C514253',8),(6641,'convallis ante sapien','convallis ante sapien',0,1,1.7,'C514253215',8),(6642,'convallis eu','convallis eu',0,1,1.4,'C5142',8),(6643,'convallis eu et','convallis eu et',0,1,1.5,'C51423',8),(6644,'costs','costs',0,0,0.3333,'C320',1),(6645,'cras ornare','cras ornare',0,1,1.3667,'C62656',8),(6646,'cras ornare eros','cras ornare eros',0,1,1.5333,'C626562',8),(6647,'cras placerat','cras placerat',0,1,1.4333,'C6214263',7),(6648,'cras placerat velit','cras placerat velit',0,1,1.6333,'C6214263143',7),(6649,'curabitur vel erat','curabitur vel erat',0,1,1.6,'C61361463',7),(6650,'cursus quam','cursus quam',0,1,1.3667,'C625',7),(6651,'cursus quam tristique','cursus quam tristique',0,1,1.7,'C62536232',7),(6652,'customers','customers',0,0,0.6,'C3562',1),(6653,'customers worldwide','customers worldwide',0,1,1.6333,'C3562643',1),(6654,'customers worldwide in','customers worldwide in',0,1,1.7333,'C35626435',1),(6655,'customers worldwide within','customers worldwide within',0,1,1.8667,'C35626435',1),(6656,'dapibus pretium','dapibus pretium',0,1,1.5,'D121635',8),(6657,'dapibus pretium ac','dapibus pretium ac',0,1,1.6,'D1216352',8),(6658,'dedicated','dedicated',0,0,0.6,'D230',3),(6659,'dedicated manner','dedicated manner',0,1,1.5333,'D2356',2),(6660,'dedicated manner phasellus','dedicated manner phasellus',0,1,1.8667,'D23561242',1),(6661,'diam dapibus pretium','diam dapibus pretium',0,1,1.6667,'D53121635',8),(6662,'diam metus','diam metus',0,1,1.3333,'D532',8),(6663,'diam metus in','diam metus in',0,1,1.4333,'D5325',8),(6664,'diam pellentesque','diam pellentesque',0,1,1.5667,'D514532',7),(6665,'diam pellentesque urna','diam pellentesque urna',0,1,1.7333,'D51453265',7),(6666,'dignissim libero','dignissim libero',0,1,1.5333,'D2525416',8),(6667,'dignissim libero ac','dignissim libero ac',0,1,1.6333,'D25254162',8),(6668,'dolor vehicula','dolor vehicula',0,1,1.4667,'D46124',7),(6669,'dolor vehicula ac','dolor vehicula ac',0,1,1.5667,'D461242',7),(6670,'donec dignissim','donec dignissim',0,1,1.5,'D5232525',8),(6671,'donec dignissim libero','donec dignissim libero',0,1,1.7333,'D5232525416',8),(6672,'donec vulputate','donec vulputate',0,1,1.5,'D521413',7),(6673,'donec vulputate orci','donec vulputate orci',0,1,1.6667,'D52141362',7),(6674,'dui dui','dui dui',0,1,1.2333,'D000',7),(6675,'dui dui sed','dui dui sed',0,1,1.3667,'D230',7),(6676,'dui duis','dui duis',0,1,1.2667,'D200',8),(6677,'dui duis vel','dui duis vel',0,1,1.4,'D214',8),(6678,'dui sed diam','dui sed diam',0,1,1.4,'D235',7),(6679,'dui vulputate','dui vulputate',0,1,1.4333,'D1413',8),(6680,'dui vulputate ultrices','dui vulputate ultrices',0,1,1.7333,'D14134362',8),(6681,'duis vel','duis vel',0,1,1.2667,'D214',12),(6682,'duis vel diam','duis vel diam',0,1,1.4333,'D21435',8),(6683,'duis vel lectus','duis vel lectus',0,1,1.5,'D214232',8),(6684,'e','e',0,0,0.0667,'E000',2),(6685,'e business','e business',0,1,1.3333,'E1252',2),(6686,'e business meetings','e business meetings',0,1,1.6333,'E12525352',2),(6687,'e business services','e business services',0,1,1.6333,'E1252612',1),(6688,'e business sites','e business sites',0,1,1.5333,'E125232',1),(6689,'egestas mauris','egestas mauris',0,1,1.4667,'E232562',8),(6690,'egestas mauris id','egestas mauris id',0,1,1.5667,'E2325623',8),(6691,'eget nibh','eget nibh',0,1,1.3,'E2351',8),(6692,'eget nibh arcu','eget nibh arcu',0,1,1.4667,'E235162',8),(6693,'eget velit','eget velit',0,1,1.3333,'E23143',8),(6694,'eget velit orci','eget velit orci',0,1,1.5,'E2314362',7),(6695,'elementum id','elementum id',0,1,1.4,'E45353',7),(6696,'elementum id quam','elementum id quam',0,1,1.5667,'E4535325',7),(6697,'elit tortor','elit tortor',0,1,1.3667,'E43636',8),(6698,'elit tortor blandit','elit tortor blandit',0,1,1.6333,'E436361453',8),(6699,'emerged','emerged',0,0,0.4667,'E5623',1),(6700,'emerged nowadays','emerged nowadays',0,1,1.5333,'E5623532',1),(6701,'emerged nowadays providing','emerged nowadays providing',0,1,1.8667,'E5623532161352',1),(6702,'enim ante','enim ante',0,1,1.3,'E530',8),(6703,'enim ante id','enim ante id',0,1,1.4,'E530',8),(6704,'enim fringilla','enim fringilla',0,1,1.4667,'E516524',8),(6705,'enim fringilla libero','enim fringilla libero',0,1,1.7,'E51652416',8),(6706,'enim luctus','enim luctus',0,1,1.3667,'E54232',8),(6707,'enim luctus eros','enim luctus eros',0,1,1.5333,'E5423262',8),(6708,'enim mauris','enim mauris',0,1,1.3667,'E562',7),(6709,'enim mauris nunc','enim mauris nunc',0,1,1.5333,'E56252',7),(6710,'enim nullam','enim nullam',0,1,1.3667,'E545',8),(6711,'enim nullam vitae','enim nullam vitae',0,1,1.5667,'E54513',8),(6712,'enim ut','enim ut',0,1,1.2333,'E530',7),(6713,'enim ut volutpat','enim ut volutpat',0,1,1.5333,'E5314313',7),(6714,'erat enim','erat enim',0,1,1.3,'E635',7),(6715,'erat enim mauris','erat enim mauris',0,1,1.5333,'E63562',7),(6716,'erat sapien','erat sapien',0,1,1.3667,'E63215',8),(6717,'erat sapien malesuada','erat sapien malesuada',0,1,1.7,'E63215423',8),(6718,'eros blandit','eros blandit',0,1,1.4,'E621453',8),(6719,'eros blandit accumsan','eros blandit accumsan',0,1,1.7,'E6214532525',8),(6720,'eros consectetur','eros consectetur',0,1,1.5333,'E625236',8),(6721,'eros consectetur gravida','eros consectetur gravida',0,1,1.8,'E6252362613',8),(6722,'eros id','eros id',0,1,1.2333,'E623',8),(6723,'eros id facilisis','eros id facilisis',0,1,1.5667,'E6231242',8),(6724,'eros lobortis','eros lobortis',0,1,1.4333,'E6241632',8),(6725,'eros lobortis ac','eros lobortis ac',0,1,1.5333,'E6241632',8),(6726,'est at lectus','est at lectus',0,1,1.4333,'E234232',8),(6727,'est quis','est quis',0,1,1.2667,'E232',8),(6728,'est quis leo','est quis leo',0,1,1.4,'E2324',8),(6729,'et lectus ut','et lectus ut',0,1,1.4,'E342323',8),(6730,'et pharetra','et pharetra',0,1,1.3667,'E31636',8),(6731,'et pharetra mollis','et pharetra mollis',0,1,1.6,'E31636542',8),(6732,'et pharetra nisi','et pharetra nisi',0,1,1.5333,'E3163652',7),(6733,'et rhoncus','et rhoncus',0,1,1.3333,'E3652',8),(6734,'et rhoncus vel','et rhoncus vel',0,1,1.4667,'E365214',8),(6735,'et risus','et risus',0,1,1.2667,'E362',8),(6736,'et risus maecenas','et risus maecenas',0,1,1.5667,'E3625252',8),(6737,'et turpis','et turpis',0,1,1.3,'E3612',8),(6738,'et turpis vivamus','et turpis vivamus',0,1,1.5667,'E3612152',8),(6739,'etiam id','etiam id',0,1,1.2667,'E353',8),(6740,'etiam id quam','etiam id quam',0,1,1.4333,'E35325',8),(6741,'eu et','eu et',0,1,1.1667,'E300',8),(6742,'eu et lectus','eu et lectus',0,1,1.4,'E34232',8),(6743,'eu facilisis nec','eu facilisis nec',0,1,1.5333,'E124252',8),(6744,'eu lacus','eu lacus',0,1,1.2667,'E420',8),(6745,'eu lacus in','eu lacus in',0,1,1.3667,'E425',8),(6746,'eu lobortis','eu lobortis',0,1,1.3667,'E41632',8),(6747,'eu lobortis lacus','eu lobortis lacus',0,1,1.5667,'E4163242',8),(6748,'eu varius','eu varius',0,1,1.3,'E162',7),(6749,'eu varius ac','eu varius ac',0,1,1.4,'E162',7),(6750,'facilisis convallis','facilisis convallis',0,1,1.6333,'F2425142',8),(6751,'facilisis convallis ante','facilisis convallis ante',0,1,1.8,'F242514253',8),(6752,'facilisis nec','facilisis nec',0,1,1.4333,'F24252',8),(6753,'facilisis nec auctor','facilisis nec auctor',0,1,1.6667,'F2425236',8),(6754,'facilisis quis','facilisis quis',0,1,1.4667,'F242',7),(6755,'facilisis quis porta','facilisis quis porta',0,1,1.6667,'F242163',7),(6756,'facilisis sit','facilisis sit',0,1,1.4333,'F2423',7),(6757,'facilisis sit amet','facilisis sit amet',0,1,1.6,'F242353',7),(6758,'faucibus odio','faucibus odio',0,1,1.4333,'F2123',7),(6759,'faucibus odio augue','faucibus odio augue',0,1,1.6333,'F21232',7),(6760,'fermentum consectetur','fermentum consectetur',0,1,1.7,'F653525236',7),(6761,'fermentum consectetur pellentesque','fermentum consectetur pellentesque',0,1,2,'F65352523614532',7),(6762,'fringilla libero','fringilla libero',0,1,1.5333,'F652416',8),(6763,'fringilla libero a','fringilla libero a',0,1,1.6,'F652416',8),(6764,'fringilla mauris','fringilla mauris',0,1,1.5333,'F6524562',8),(6765,'fringilla mauris lacus','fringilla mauris lacus',0,1,1.7333,'F652456242',8),(6766,'gravida pharetra','gravida pharetra',0,1,1.5333,'G6131636',8),(6767,'gravida pharetra nisi','gravida pharetra nisi',0,1,1.7,'G613163652',8),(6768,'have been emerged','have been emerged',0,1,1.5667,'H15623',1),(6769,'have been launched','have been launched',0,1,1.6,'H154523',1),(6770,'helping','helping',0,0,0.4667,'H4152',1),(6771,'helping to','helping to',0,1,1.3333,'H41523',1),(6772,'helping to their','helping to their',0,1,1.5333,'H415236',1),(6773,'hendrerit a','hendrerit a',0,1,1.3667,'H5363',7),(6774,'hendrerit a facilisis','hendrerit a facilisis',0,1,1.7,'H53631242',7),(6775,'iaculis arcu','iaculis arcu',0,1,1.4,'I24262',8),(6776,'iaculis arcu malesuada','iaculis arcu malesuada',0,1,1.7333,'I242625423',8),(6777,'iaculis id','iaculis id',0,1,1.3333,'I2423',8),(6778,'iaculis id aliquam','iaculis id aliquam',0,1,1.6,'I2423425',8),(6779,'iaculis integer','iaculis integer',0,1,1.5,'I2425326',8),(6780,'iaculis integer massa','iaculis integer massa',0,1,1.7,'I242532652',8),(6781,'id aliquam','id aliquam',0,1,1.3333,'I3425',8),(6782,'id aliquam et','id aliquam et',0,1,1.4333,'I34253',8),(6783,'id facilisis convallis','id facilisis convallis',0,1,1.7333,'I312425142',8),(6784,'id imperdiet','id imperdiet',0,1,1.4,'I35163',7),(6785,'id imperdiet quis','id imperdiet quis',0,1,1.5667,'I351632',7),(6786,'id ligula nunc','id ligula nunc',0,1,1.4667,'I342452',8),(6787,'id pharetra','id pharetra',0,1,1.3667,'I31636',8),(6788,'id pharetra pulvinar','id pharetra pulvinar',0,1,1.6667,'I3163614156',8),(6789,'id quam','id quam',0,1,1.2333,'I325',9),(6790,'id quam proin','id quam proin',0,1,1.4333,'I325165',7),(6791,'id quam semper','id quam semper',0,1,1.4667,'I3252516',8),(6792,'id tempus','id tempus',0,1,1.3,'I3512',8),(6793,'id tempus at','id tempus at',0,1,1.4,'I35123',8),(6794,'imperdiet id','imperdiet id',0,1,1.4,'I5163',8),(6795,'imperdiet id tempus','imperdiet id tempus',0,1,1.6333,'I5163512',8),(6796,'imperdiet quis','imperdiet quis',0,1,1.4667,'I51632',7),(6797,'imperdiet quis pretium','imperdiet quis pretium',0,1,1.7333,'I516321635',7),(6798,'importantly','importantly',0,0,0.7333,'I5163534',1),(6799,'importantly several','importantly several',0,1,1.6333,'I51635342164',1),(6800,'importantly several e','importantly several e',0,1,1.7,'I51635342164',1),(6801,'in a most','in a most',0,1,1.3,'I523',1),(6802,'in neque','in neque',0,1,1.2667,'I520',8),(6803,'in neque commodo','in neque commodo',0,1,1.5333,'I5253',8),(6804,'in quam curabitur','in quam curabitur',0,1,1.5667,'I52526136',7),(6805,'in tempor','in tempor',0,1,1.3,'I53516',8),(6806,'in tempor augue','in tempor augue',0,1,1.5,'I535162',8),(6807,'in tincidunt','in tincidunt',0,1,1.4,'I5352353',8),(6808,'in tincidunt pharetra','in tincidunt pharetra',0,1,1.7,'I53523531636',7),(6809,'integer massa','integer massa',0,1,1.4333,'I532652',8),(6810,'integer massa augue','integer massa augue',0,1,1.6333,'I532652',8),(6811,'integer quis','integer quis',0,1,1.4,'I53262',7),(6812,'integer quis ipsum','integer quis ipsum',0,1,1.6,'I53262125',7),(6813,'interdum lorem','interdum lorem',0,1,1.4667,'I53635465',7),(6814,'interdum lorem lectus','interdum lorem lectus',0,1,1.7,'I536354654232',7),(6815,'internet thousands','internet thousands',0,1,1.6,'I536532532',1),(6816,'internet thousands of','internet thousands of',0,1,1.7,'I5365325321',1),(6817,'ipsum enim','ipsum enim',0,1,1.3333,'I125',7),(6818,'ipsum enim ut','ipsum enim ut',0,1,1.4333,'I1253',7),(6819,'ipsum nibh','ipsum nibh',0,1,1.3333,'I1251',7),(6820,'ipsum nibh hendrerit','ipsum nibh hendrerit',0,1,1.6667,'I12515363',7),(6821,'ipsum nisi','ipsum nisi',0,1,1.3333,'I1252',8),(6822,'ipsum nisi et','ipsum nisi et',0,1,1.4333,'I12523',8),(6823,'lacinia aliquam','lacinia aliquam',0,1,1.5,'L25425',8),(6824,'lacinia aliquam eu','lacinia aliquam eu',0,1,1.6,'L25425',8),(6825,'lacus in','lacus in',0,1,1.2667,'L250',8),(6826,'lacus in neque','lacus in neque',0,1,1.4667,'L252',8),(6827,'lacus lobortis','lacus lobortis',0,1,1.4667,'L241632',8),(6828,'lacus lobortis sed','lacus lobortis sed',0,1,1.6,'L2416323',8),(6829,'lacus ultrices','lacus ultrices',0,1,1.4667,'L24362',8),(6830,'lacus ultrices lorem','lacus ultrices lorem',0,1,1.6667,'L24362465',8),(6831,'laoreet faucibus','laoreet faucibus',0,1,1.5333,'L631212',7),(6832,'laoreet faucibus odio','laoreet faucibus odio',0,1,1.7,'L6312123',7),(6833,'launched','launched',0,0,0.5333,'L523',1),(6834,'launched over','launched over',0,1,1.4333,'L52316',1),(6835,'launched over the','launched over the',0,1,1.5667,'L523163',1),(6836,'lectus integer','lectus integer',0,1,1.4667,'L2325326',7),(6837,'lectus integer quis','lectus integer quis',0,1,1.6333,'L23253262',7),(6838,'lectus leo','lectus leo',0,1,1.3333,'L2324',7),(6839,'lectus leo cursus','lectus leo cursus',0,1,1.5667,'L2324262',7),(6840,'lectus luctus','lectus luctus',0,1,1.4333,'L2324232',8),(6841,'lectus luctus lacinia','lectus luctus lacinia',0,1,1.7,'L2324232425',8),(6842,'lectus nisl','lectus nisl',0,1,1.3667,'L232524',8),(6843,'lectus nisl nulla','lectus nisl nulla',0,1,1.5667,'L23252454',5),(6844,'lectus turpis','lectus turpis',0,1,1.4333,'L2323612',8),(6845,'lectus turpis iaculis','lectus turpis iaculis',0,1,1.7,'L232361242',8),(6846,'lectus urna','lectus urna',0,1,1.3667,'L23265',7),(6847,'lectus urna donec','lectus urna donec',0,1,1.5667,'L23265352',7),(6848,'lectus ut','lectus ut',0,1,1.3,'L2323',9),(6849,'lectus ut eget','lectus ut eget',0,1,1.4667,'L232323',8),(6850,'lectus vitae','lectus vitae',0,1,1.4,'L23213',7),(6851,'lectus vitae turpis','lectus vitae turpis',0,1,1.6333,'L23213612',5),(6852,'leo cursus','leo cursus',0,1,1.3333,'L262',7),(6853,'leo cursus quam','leo cursus quam',0,1,1.5,'L2625',7),(6854,'leo placerat','leo placerat',0,1,1.4,'L14263',8),(6855,'leo placerat iaculis','leo placerat iaculis',0,1,1.6667,'L14263242',8),(6856,'libero a vulputate','libero a vulputate',0,1,1.6,'L161413',8),(6857,'libero ac','libero ac',0,1,1.3,'L162',8),(6858,'libero ac lorem','libero ac lorem',0,1,1.5,'L162465',8),(6859,'ligula nec','ligula nec',0,1,1.3333,'L2452',8),(6860,'ligula nec fringilla','ligula nec fringilla',0,1,1.6667,'L245216524',8),(6861,'ligula non','ligula non',0,1,1.3333,'L245',8),(6862,'ligula non tortor','ligula non tortor',0,1,1.5667,'L2453636',8),(6863,'ligula nunc','ligula nunc',0,1,1.3667,'L2452',8),(6864,'ligula nunc vel','ligula nunc vel',0,1,1.5,'L245214',7),(6865,'lobortis ac','lobortis ac',0,1,1.3667,'L1632',8),(6866,'lobortis ac semper','lobortis ac semper',0,1,1.6,'L1632516',8),(6867,'lobortis lacus','lobortis lacus',0,1,1.4667,'L163242',8),(6868,'lobortis lacus lobortis','lobortis lacus lobortis',0,1,1.7667,'L16324241632',8),(6869,'lobortis sed magna','lobortis sed magna',0,1,1.6,'L16323525',8),(6870,'lorem accumsan','lorem accumsan',0,1,1.4667,'L652525',8),(6871,'lorem accumsan eu','lorem accumsan eu',0,1,1.5667,'L652525',8),(6872,'lorem lectus','lorem lectus',0,1,1.4,'L654232',7),(6873,'lorem lectus vitae','lorem lectus vitae',0,1,1.6,'L65423213',7),(6874,'lorem nam','lorem nam',0,1,1.3,'L650',8),(6875,'lorem nam egestas','lorem nam egestas',0,1,1.5667,'L65232',8),(6876,'luctus eros','luctus eros',0,1,1.3667,'L23262',8),(6877,'luctus eros blandit','luctus eros blandit',0,1,1.6333,'L232621453',8),(6878,'luctus lacinia','luctus lacinia',0,1,1.4667,'L232425',8),(6879,'luctus lacinia aliquam','luctus lacinia aliquam',0,1,1.7333,'L232425425',8),(6880,'maecenas lectus turpis','maecenas lectus turpis',0,1,1.7333,'M25242323612',8),(6881,'maecenas vel','maecenas vel',0,1,1.4,'M25214',8),(6882,'maecenas vel est','maecenas vel est',0,1,1.5333,'M2521423',8),(6883,'magna eros','magna eros',0,1,1.3333,'M2562',8),(6884,'magna eros lobortis','magna eros lobortis',0,1,1.6333,'M256241632',8),(6885,'magna iaculis','magna iaculis',0,1,1.4333,'M25242',8),(6886,'magna iaculis arcu','magna iaculis arcu',0,1,1.6,'M2524262',8),(6887,'malesuada a','malesuada a',0,1,1.3667,'M423',8),(6888,'malesuada a suscipit','malesuada a suscipit',0,1,1.6667,'M423213',8),(6889,'malesuada ante','malesuada ante',0,1,1.4667,'M42353',8),(6890,'malesuada ante at','malesuada ante at',0,1,1.5667,'M42353',8),(6891,'malesuada nec','malesuada nec',0,1,1.4333,'M42352',8),(6892,'malesuada nec imperdiet','malesuada nec imperdiet',0,1,1.7667,'M423525163',8),(6893,'manner','manner',0,0,0.4,'M600',2),(6894,'manner phasellus','manner phasellus',0,1,1.5333,'M61242',1),(6895,'manner phasellus erat','manner phasellus erat',0,1,1.7,'M6124263',1),(6896,'massa augue','massa augue',0,1,1.3667,'M200',8),(6897,'massa augue pellentesque','massa augue pellentesque',0,1,1.8,'M214532',8),(6898,'mattis enim','mattis enim',0,1,1.3667,'M325',8),(6899,'mattis enim nullam','mattis enim nullam',0,1,1.6,'M32545',8),(6900,'mauris ac','mauris ac',0,1,1.3,'M620',7),(6901,'mauris ac arcu','mauris ac arcu',0,1,1.4667,'M6262',7),(6902,'mauris id','mauris id',0,1,1.3,'M623',8),(6903,'mauris id pharetra','mauris id pharetra',0,1,1.6,'M6231636',8),(6904,'mauris lacus','mauris lacus',0,1,1.4,'M6242',8),(6905,'mauris lacus ultrices','mauris lacus ultrices',0,1,1.7,'M62424362',8),(6906,'mauris nunc','mauris nunc',0,1,1.3667,'M6252',7),(6907,'mauris nunc diam','mauris nunc diam',0,1,1.5333,'M625235',7),(6908,'meetings','meetings',0,0,0.5333,'M352',2),(6909,'meetings sites','meetings sites',0,1,1.4667,'M35232',1),(6910,'meetings sites have','meetings sites have',0,1,1.6333,'M352321',1),(6911,'metus in','metus in',0,1,1.2667,'M325',8),(6912,'metus in tempor','metus in tempor',0,1,1.5,'M3253516',8),(6913,'mollis elit','mollis elit',0,1,1.3667,'M4243',8),(6914,'mollis elit tortor','mollis elit tortor',0,1,1.6,'M4243636',8),(6915,'more importantly','more importantly',0,1,1.5333,'M65163534',1),(6916,'more importantly several','more importantly several',0,1,1.8,'M651635342164',1),(6917,'most','most',0,0,0.2667,'M230',2),(6918,'most affordable','most affordable',0,1,1.5,'M2316314',1),(6919,'most affordable costs','most affordable costs',0,1,1.7,'M2316314232',1),(6920,'most artful','most artful',0,1,1.3667,'M236314',1),(6921,'most artful and','most artful and',0,1,1.5,'M23631453',1),(6922,'nam egestas','nam egestas',0,1,1.3667,'N232',8),(6923,'nam egestas mauris','nam egestas mauris',0,1,1.6,'N232562',8),(6924,'nec auctor','nec auctor',0,1,1.3333,'N236',8),(6925,'nec auctor et','nec auctor et',0,1,1.4333,'N2363',8),(6926,'nec auctor proin','nec auctor proin',0,1,1.5333,'N236165',8),(6927,'nec fringilla','nec fringilla',0,1,1.4333,'N216524',8),(6928,'nec fringilla mauris','nec fringilla mauris',0,1,1.6667,'N216524562',8),(6929,'nec imperdiet','nec imperdiet',0,1,1.4333,'N25163',8),(6930,'nec imperdiet id','nec imperdiet id',0,1,1.5333,'N25163',8),(6931,'nec urna','nec urna',0,1,1.2667,'N265',7),(6932,'nec urna sed','nec urna sed',0,1,1.4,'N26523',7),(6933,'neque a','neque a',0,1,1.2333,'N200',8),(6934,'neque a porttitor','neque a porttitor',0,1,1.5667,'N21636',8),(6935,'neque commodo','neque commodo',0,1,1.4333,'N253',8),(6936,'neque commodo convallis','neque commodo convallis',0,1,1.7667,'N25325142',8),(6937,'neque maecenas','neque maecenas',0,1,1.4667,'N25252',8),(6938,'neque maecenas vel','neque maecenas vel',0,1,1.6,'N2525214',8),(6939,'neque quis scelerisque','neque quis scelerisque',0,1,1.7333,'N2462',8),(6940,'nibh arcu','nibh arcu',0,1,1.3,'N162',8),(6941,'nibh arcu praesent','nibh arcu praesent',0,1,1.6,'N16216253',8),(6942,'nibh duis','nibh duis',0,1,1.3,'N132',8),(6943,'nibh duis vel','nibh duis vel',0,1,1.4333,'N13214',8),(6944,'nibh hendrerit','nibh hendrerit',0,1,1.4667,'N15363',7),(6945,'nibh hendrerit a','nibh hendrerit a',0,1,1.5333,'N15363',7),(6946,'nisi enim','nisi enim',0,1,1.3,'N250',9),(6947,'nisi enim fringilla','nisi enim fringilla',0,1,1.6333,'N2516524',8),(6948,'nisi enim luctus','nisi enim luctus',0,1,1.5333,'N254232',8),(6949,'nisi et','nisi et',0,1,1.2333,'N230',8),(6950,'nisi et pharetra','nisi et pharetra',0,1,1.5333,'N231636',8),(6951,'nisi quisque','nisi quisque',0,1,1.4,'N200',6),(6952,'nisi quisque eget','nisi quisque eget',0,1,1.5667,'N230',6),(6953,'nisl nec','nisl nec',0,1,1.2667,'N2452',8),(6954,'nisl nec auctor','nisl nec auctor',0,1,1.5,'N245236',8),(6955,'nisl non','nisl non',0,1,1.2667,'N245',7),(6956,'nisl non vestibulum','nisl non vestibulum',0,1,1.6333,'N245123145',7),(6957,'nisl nulla','nisl nulla',0,1,1.3333,'N2454',5),(6958,'nisl nulla at','nisl nulla at',0,1,1.4333,'N24543',5),(6959,'nisl tincidunt','nisl tincidunt',0,1,1.4667,'N24352353',8),(6960,'nisl tincidunt etiam','nisl tincidunt etiam',0,1,1.6667,'N243523535',8),(6961,'non tortor','non tortor',0,1,1.3333,'N3636',8),(6962,'non tortor cras','non tortor cras',0,1,1.5,'N3636262',7),(6963,'non vestibulum','non vestibulum',0,1,1.4667,'N123145',7),(6964,'non vestibulum dui','non vestibulum dui',0,1,1.6,'N1231453',7),(6965,'nowadays','nowadays',0,0,0.5333,'N320',1),(6966,'nowadays providing','nowadays providing',0,1,1.6,'N32161352',1),(6967,'nowadays providing the','nowadays providing the',0,1,1.7333,'N321613523',1),(6968,'nulla at','nulla at',0,1,1.2667,'N430',8),(6969,'nulla at est','nulla at est',0,1,1.4,'N4323',8),(6970,'nulla turpis','nulla turpis',0,1,1.4,'N43612',7),(6971,'nulla turpis tempor','nulla turpis tempor',0,1,1.6333,'N436123516',7),(6972,'nullam nulla','nullam nulla',0,1,1.4,'N454',7),(6973,'nullam nulla turpis','nullam nulla turpis',0,1,1.6333,'N4543612',7),(6974,'nullam vitae','nullam vitae',0,1,1.4,'N4513',8),(6975,'nullam vitae ipsum','nullam vitae ipsum',0,1,1.6,'N4513125',8),(6976,'nunc diam','nunc diam',0,1,1.3,'N235',7),(6977,'nunc vel','nunc vel',0,1,1.2667,'N214',7),(6978,'nunc vel mattis','nunc vel mattis',0,1,1.5,'N214532',7),(6979,'odio augue','odio augue',0,1,1.3333,'O320',7),(6980,'odio augue rutrum','odio augue rutrum',0,1,1.5667,'O326365',7),(6981,'of e','of e',0,1,1.1333,'O100',1),(6982,'of e business','of e business',0,1,1.4333,'O1252',1),(6983,'of technology','of technology',0,1,1.4333,'O132542',1),(6984,'of technology and','of technology and',0,1,1.5667,'O13254253',1),(6985,'online business','online business',0,1,1.5,'O5451252',1),(6986,'online business conference','online business conference',0,1,1.8667,'O545125251652',1),(6987,'orci in','orci in',0,1,1.2333,'O625',7),(6988,'orci in tincidunt','orci in tincidunt',0,1,1.5667,'O625352353',7),(6989,'orci suspendisse','orci suspendisse',0,1,1.5333,'O621532',7),(6990,'orci suspendisse ac','orci suspendisse ac',0,1,1.6333,'O621532',7),(6991,'ornare eros','ornare eros',0,1,1.3667,'O6562',8),(6992,'ornare eros consectetur','ornare eros consectetur',0,1,1.7667,'O65625236',8),(6993,'over','over',0,0,0.2667,'O160',1),(6994,'over the','over the',0,1,1.2667,'O163',1),(6995,'over the world','over the world',0,1,1.4667,'O163643',1),(6996,'pellentesque eu','pellentesque eu',0,1,1.5,'P4532',8),(6997,'pellentesque eu facilisis','pellentesque eu facilisis',0,1,1.8333,'P45321242',8),(6998,'pellentesque lectus','pellentesque lectus',0,1,1.6333,'P45324232',7),(6999,'pellentesque lectus urna','pellentesque lectus urna',0,1,1.8,'P4532423265',7),(7000,'pellentesque sed','pellentesque sed',0,1,1.5333,'P45323',7),(7001,'pellentesque sed elementum','pellentesque sed elementum',0,1,1.8667,'P453234535',7),(7002,'pellentesque urna','pellentesque urna',0,1,1.5667,'P453265',7),(7003,'pellentesque urna dolor','pellentesque urna dolor',0,1,1.7667,'P453265346',7),(7004,'pellentesque vestibulum','pellentesque vestibulum',0,1,1.7667,'P4532123145',8),(7005,'pellentesque vestibulum aliquet','pellentesque vestibulum aliquet',0,1,2,'P4532123145423',8),(7006,'pharetra lectus','pharetra lectus',0,1,1.5,'P6364232',7),(7007,'pharetra lectus leo','pharetra lectus leo',0,1,1.6333,'P63642324',7),(7008,'pharetra mollis','pharetra mollis',0,1,1.5,'P636542',8),(7009,'pharetra mollis elit','pharetra mollis elit',0,1,1.6667,'P63654243',8),(7010,'pharetra nisi','pharetra nisi',0,1,1.4333,'P63652',9),(7011,'pharetra nisi enim','pharetra nisi enim',0,1,1.6,'P636525',8),(7012,'pharetra nisi quisque','pharetra nisi quisque',0,1,1.7,'P63652',6),(7013,'pharetra pulvinar','pharetra pulvinar',0,1,1.5667,'P63614156',8),(7014,'pharetra pulvinar nisi','pharetra pulvinar nisi',0,1,1.7333,'P6361415652',8),(7015,'phasellus erat','phasellus erat',0,1,1.4667,'P24263',8),(7016,'phasellus erat sapien','phasellus erat sapien',0,1,1.7,'P24263215',8),(7017,'placerat iaculis','placerat iaculis',0,1,1.5333,'P4263242',8),(7018,'placerat iaculis integer','placerat iaculis integer',0,1,1.8,'P42632425326',8),(7019,'placerat velit','placerat velit',0,1,1.4667,'P4263143',7),(7020,'placerat velit vitae','placerat velit vitae',0,1,1.6667,'P426314313',7),(7021,'porta ac augue','porta ac augue',0,1,1.4667,'P632',7),(7022,'porttitor suspendisse','porttitor suspendisse',0,1,1.7,'P63621532',8),(7023,'porttitor suspendisse condimentum','porttitor suspendisse condimentum',0,1,2,'P6362153253535',8),(7024,'praesent ipsum','praesent ipsum',0,1,1.4667,'P6253125',7),(7025,'praesent ipsum nibh','praesent ipsum nibh',0,1,1.6333,'P62531251',7),(7026,'praesent malesuada','praesent malesuada',0,1,1.6,'P62535423',8),(7027,'praesent malesuada ante','praesent malesuada ante',0,1,1.7667,'P6253542353',8),(7028,'pretium ac','pretium ac',0,1,1.3333,'P6352',8),(7029,'pretium ac vel','pretium ac vel',0,1,1.4667,'P635214',8),(7030,'pretium nec','pretium nec',0,1,1.3667,'P6352',7),(7031,'pretium nec urna','pretium nec urna',0,1,1.5333,'P635265',7),(7032,'professional','professional',0,0,0.8,'P61254',2),(7033,'professional quality','professional quality',0,1,1.6667,'P61254243',1),(7034,'professional quality e','professional quality e',0,1,1.7333,'P61254243',1),(7035,'proin pellentesque','proin pellentesque',0,1,1.6,'P6514532',7),(7036,'proin pellentesque lectus','proin pellentesque lectus',0,1,1.8333,'P65145324232',7),(7037,'proin rutrum','proin rutrum',0,1,1.4,'P656365',8),(7038,'proin rutrum magna','proin rutrum magna',0,1,1.6,'P65636525',8),(7039,'providing','providing',0,0,0.6,'P61352',1),(7040,'providing the','providing the',0,1,1.4333,'P613523',1),(7041,'providing the professional','providing the professional',0,1,1.8667,'P613523161254',1),(7042,'pulvinar nisi','pulvinar nisi',0,1,1.4333,'P415652',8),(7043,'pulvinar nisi enim','pulvinar nisi enim',0,1,1.6,'P4156525',8),(7044,'quality','quality',0,0,0.4667,'Q430',1),(7045,'quality e','quality e',0,1,1.3,'Q430',1),(7046,'quality e business','quality e business',0,1,1.6,'Q431252',1),(7047,'quam curabitur','quam curabitur',0,1,1.4667,'Q526136',7),(7048,'quam curabitur vel','quam curabitur vel',0,1,1.6,'Q52613614',7),(7049,'quam proin','quam proin',0,1,1.3333,'Q5165',7),(7050,'quam proin pellentesque','quam proin pellentesque',0,1,1.7667,'Q516514532',7),(7051,'quam semper','quam semper',0,1,1.3667,'Q52516',8),(7052,'quam semper diam','quam semper diam',0,1,1.5333,'Q5251635',8),(7053,'quam tristique','quam tristique',0,1,1.4667,'Q536232',7),(7054,'quam tristique interdum','quam tristique interdum',0,1,1.7667,'Q53623253635',7),(7055,'quis ipsum','quis ipsum',0,1,1.3333,'Q125',7),(7056,'quis ipsum enim','quis ipsum enim',0,1,1.5,'Q125',7),(7057,'quis leo','quis leo',0,1,1.2667,'Q400',8),(7058,'quis leo placerat','quis leo placerat',0,1,1.5667,'Q414263',8),(7059,'quis porta ac','quis porta ac',0,1,1.4333,'Q1632',7),(7060,'quis pretium','quis pretium',0,1,1.4,'Q1635',7),(7061,'quis pretium nec','quis pretium nec',0,1,1.5333,'Q16352',7),(7062,'quis scelerisque','quis scelerisque',0,1,1.5333,'Q462',8),(7063,'quis scelerisque enim','quis scelerisque enim',0,1,1.7,'Q4625',8),(7064,'quisque eget','quisque eget',0,1,1.4,'Q300',7),(7065,'quisque eget velit','quisque eget velit',0,1,1.6,'Q3143',7),(7066,'rapid advancement','rapid advancement',0,1,1.5667,'R1315253',1),(7067,'rapid advancement of','rapid advancement of',0,1,1.6667,'R13152531',1),(7068,'recently','recently',0,0,0.5333,'R2534',1),(7069,'recently helping','recently helping',0,1,1.5333,'R2534152',1),(7070,'recently helping to','recently helping to',0,1,1.6333,'R25341523',1),(7071,'rhoncus vel','rhoncus vel',0,1,1.3667,'R5214',8),(7072,'rhoncus vel dui','rhoncus vel dui',0,1,1.5,'R52143',8),(7073,'risus maecenas','risus maecenas',0,1,1.4667,'R25252',8),(7074,'risus maecenas lectus','risus maecenas lectus',0,1,1.7,'R252524232',8),(7075,'rutrum magna','rutrum magna',0,1,1.4,'R36525',8),(7076,'rutrum magna iaculis','rutrum magna iaculis',0,1,1.6667,'R36525242',8),(7077,'rutrum nisl','rutrum nisl',0,1,1.3667,'R36524',7),(7078,'rutrum nisl non','rutrum nisl non',0,1,1.5,'R365245',7),(7079,'sapien malesuada','sapien malesuada',0,1,1.5333,'S15423',8),(7080,'sapien malesuada nec','sapien malesuada nec',0,1,1.6667,'S1542352',8),(7081,'sapien ultricies','sapien ultricies',0,1,1.5333,'S154362',8),(7082,'sapien ultricies ligula','sapien ultricies ligula',0,1,1.7667,'S154362424',8),(7083,'scelerisque enim','scelerisque enim',0,1,1.5333,'S4625',8),(7084,'scelerisque enim ante','scelerisque enim ante',0,1,1.7,'S46253',8),(7085,'sed diam pellentesque','sed diam pellentesque',0,1,1.7,'S3514532',7),(7086,'sed elementum','sed elementum',0,1,1.4333,'S34535',7),(7087,'sed elementum id','sed elementum id',0,1,1.5333,'S345353',7),(7088,'sed magna','sed magna',0,1,1.3,'S3525',8),(7089,'sed magna eros','sed magna eros',0,1,1.4667,'S352562',8),(7090,'sed ultrices','sed ultrices',0,1,1.4,'S34362',8),(7091,'sed ultrices eros','sed ultrices eros',0,1,1.5667,'S3436262',8),(7092,'sem praesent','sem praesent',0,1,1.4,'S516253',7),(7093,'sem praesent ipsum','sem praesent ipsum',0,1,1.6,'S516253125',7),(7094,'semper diam','semper diam',0,1,1.3667,'S51635',8),(7095,'semper diam dapibus','semper diam dapibus',0,1,1.6333,'S51635312',8),(7096,'semper sit','semper sit',0,1,1.3333,'S51623',8),(7097,'semper sit amet','semper sit amet',0,1,1.5,'S5162353',8),(7098,'services','services',0,0,0.5333,'S612',2),(7099,'services to','services to',0,1,1.3667,'S6123',1),(7100,'services to their','services to their',0,1,1.5667,'S61236',1),(7101,'several','several',0,0,0.4667,'S164',1),(7102,'several e','several e',0,1,1.3,'S164',1),(7103,'several e business','several e business',0,1,1.6,'S1641252',1),(7104,'sit amet in','sit amet in',0,1,1.3667,'S3535',7),(7105,'sit amet tincidunt','sit amet tincidunt',0,1,1.6,'S35352353',8),(7106,'sites have','sites have',0,1,1.3333,'S321',1),(7107,'sites have been','sites have been',0,1,1.5,'S3215',1),(7108,'sollicitudin eu','sollicitudin eu',0,1,1.5,'S4235',7),(7109,'sollicitudin eu varius','sollicitudin eu varius',0,1,1.7333,'S4235162',7),(7110,'suscipit','suscipit',0,0,0.5333,'S130',9),(7111,'suscipit nisl','suscipit nisl',0,1,1.4333,'S13524',8),(7112,'suscipit nisl tincidunt','suscipit nisl tincidunt',0,1,1.7667,'S13524352353',8),(7113,'suspendisse ac','suspendisse ac',0,1,1.4667,'S1532',7),(7114,'suspendisse ac mauris','suspendisse ac mauris',0,1,1.7,'S1532562',7),(7115,'suspendisse condimentum','suspendisse condimentum',0,1,1.7667,'S153253535',8),(7116,'suspendisse condimentum urna','suspendisse condimentum urna',0,1,1.9333,'S15325353565',8),(7117,'technology','technology',0,0,0.6667,'T2542',1),(7118,'technology and','technology and',0,1,1.4667,'T254253',1),(7119,'technology and internet','technology and internet',0,1,1.7667,'T25425353653',1),(7120,'tempor augue','tempor augue',0,1,1.4,'T5162',8),(7121,'tempor augue pellentesque','tempor augue pellentesque',0,1,1.8333,'T516214532',8),(7122,'tempor id','tempor id',0,1,1.3,'T5163',7),(7123,'tempor id imperdiet','tempor id imperdiet',0,1,1.6333,'T51635163',7),(7124,'tempus at','tempus at',0,1,1.3,'T5123',8),(7125,'tempus at neque','tempus at neque',0,1,1.5,'T512352',8),(7126,'the professional','the professional',0,1,1.5333,'T161254',1),(7127,'the professional quality','the professional quality',0,1,1.8,'T161254243',1),(7128,'the rapid advancement','the rapid advancement',0,1,1.7,'T61315253',1),(7129,'the world','the world',0,1,1.3,'T643',1),(7130,'the world wide','the world wide',0,1,1.4667,'T643',1),(7131,'their valued','their valued',0,1,1.4,'T6143',1),(7132,'their valued customers','their valued customers',0,1,1.7333,'T614323562',1),(7133,'thousands of e','thousands of e',0,1,1.4667,'T25321',1),(7134,'tincidunt at','tincidunt at',0,1,1.4,'T52353',8),(7135,'tincidunt at nibh','tincidunt at nibh',0,1,1.5667,'T5235351',8),(7136,'tincidunt etiam','tincidunt etiam',0,1,1.5,'T523535',8),(7137,'tincidunt etiam id','tincidunt etiam id',0,1,1.6,'T5235353',8),(7138,'tincidunt pharetra','tincidunt pharetra',0,1,1.6,'T523531636',7),(7139,'tincidunt pharetra lectus','tincidunt pharetra lectus',0,1,1.8333,'T5235316364232',7),(7140,'to their','to their',0,1,1.2667,'T600',1),(7141,'to their valued','to their valued',0,1,1.5,'T6143',1),(7142,'tortor arcu','tortor arcu',0,1,1.3667,'T6362',8),(7143,'tortor arcu et','tortor arcu et',0,1,1.4667,'T63623',8),(7144,'tortor blandit','tortor blandit',0,1,1.4667,'T6361453',8),(7145,'tortor blandit neque','tortor blandit neque',0,1,1.6667,'T636145352',8),(7146,'tortor cras','tortor cras',0,1,1.3667,'T636262',7),(7147,'tortor cras placerat','tortor cras placerat',0,1,1.6667,'T63626214263',7),(7148,'tortor ligula','tortor ligula',0,1,1.4333,'T636424',8),(7149,'tortor ligula non','tortor ligula non',0,1,1.5667,'T6364245',8),(7150,'tristique interdum','tristique interdum',0,1,1.6,'T623253635',7),(7151,'tristique interdum lorem','tristique interdum lorem',0,1,1.8,'T623253635465',7),(7152,'turpis iaculis','turpis iaculis',0,1,1.4667,'T61242',8),(7153,'turpis iaculis id','turpis iaculis id',0,1,1.5667,'T612423',8),(7154,'turpis tempor','turpis tempor',0,1,1.4333,'T6123516',7),(7155,'turpis tempor id','turpis tempor id',0,1,1.5333,'T61235163',7),(7156,'turpis vivamus','turpis vivamus',0,1,1.4667,'T612152',8),(7157,'turpis vivamus congue','turpis vivamus congue',0,1,1.7,'T61215252',8),(7158,'ultrices donec','ultrices donec',0,1,1.4667,'U4362352',8),(7159,'ultrices donec dignissim','ultrices donec dignissim',0,1,1.8,'U436235232525',8),(7160,'ultrices eros','ultrices eros',0,1,1.4333,'U436262',8),(7161,'ultrices eros id','ultrices eros id',0,1,1.5333,'U4362623',8),(7162,'ultrices lorem','ultrices lorem',0,1,1.4667,'U4362465',8),(7163,'ultrices lorem nam','ultrices lorem nam',0,1,1.6,'U4362465',8),(7164,'ultricies ligula','ultricies ligula',0,1,1.5333,'U4362424',8),(7165,'ultricies ligula nec','ultricies ligula nec',0,1,1.6667,'U436242452',8),(7166,'urna dolor','urna dolor',0,1,1.3333,'U65346',7),(7167,'urna dolor vehicula','urna dolor vehicula',0,1,1.6333,'U65346124',7),(7168,'urna donec','urna donec',0,1,1.3333,'U65352',7),(7169,'urna donec vulputate','urna donec vulputate',0,1,1.6667,'U653521413',7),(7170,'urna et','urna et',0,1,1.2333,'U653',8),(7171,'urna et pharetra','urna et pharetra',0,1,1.5333,'U6531636',8),(7172,'urna sed','urna sed',0,1,1.2667,'U6523',7),(7173,'urna sed ultrices','urna sed ultrices',0,1,1.5667,'U65234362',7),(7174,'ut eget','ut eget',0,1,1.2333,'U323',8),(7175,'ut eget nibh','ut eget nibh',0,1,1.4,'U32351',8),(7176,'ut volutpat sem','ut volutpat sem',0,1,1.5,'U31431325',7),(7177,'valued','valued',0,0,0.4,'V430',1),(7178,'valued customers','valued customers',0,1,1.5333,'V4323562',1),(7179,'valued customers worldwide','valued customers worldwide',0,1,1.8667,'V4323562643',1),(7180,'varius ac','varius ac',0,1,1.3,'V620',7),(7181,'varius ac lectus','varius ac lectus',0,1,1.5333,'V624232',7),(7182,'vehicula ac','vehicula ac',0,1,1.3667,'V242',7),(7183,'vehicula ac sollicitudin','vehicula ac sollicitudin',0,1,1.8,'V2424235',7),(7184,'vel arcu','vel arcu',0,1,1.2667,'V462',8),(7185,'vel arcu cras','vel arcu cras',0,1,1.4333,'V46262',8),(7186,'vel diam','vel diam',0,1,1.2667,'V435',8),(7187,'vel diam metus','vel diam metus',0,1,1.4667,'V43532',8),(7188,'vel dui','vel dui',0,1,1.2333,'V430',8),(7189,'vel dui duis','vel dui duis',0,1,1.4,'V432',8),(7190,'vel erat','vel erat',0,1,1.2667,'V463',7),(7191,'vel erat enim','vel erat enim',0,1,1.4333,'V4635',7),(7192,'vel est','vel est',0,1,1.2333,'V423',8),(7193,'vel est at','vel est at',0,1,1.3333,'V423',8),(7194,'vel lectus','vel lectus',0,1,1.3333,'V4232',8),(7195,'vel lectus nisl','vel lectus nisl',0,1,1.5,'V4232524',8),(7196,'vel mattis','vel mattis',0,1,1.3333,'V4532',8),(7197,'vel mattis enim','vel mattis enim',0,1,1.5,'V45325',8),(7198,'velit orci','velit orci',0,1,1.3333,'V4362',7),(7199,'velit orci suspendisse','velit orci suspendisse',0,1,1.7333,'V43621532',7),(7200,'velit vitae','velit vitae',0,1,1.3667,'V4313',7),(7201,'velit vitae laoreet','velit vitae laoreet',0,1,1.6333,'V4313463',7),(7202,'vestibulum aliquet','vestibulum aliquet',0,1,1.6,'V23145423',8),(7203,'vestibulum aliquet neque','vestibulum aliquet neque',0,1,1.8,'V2314542352',8),(7204,'vestibulum dui','vestibulum dui',0,1,1.4667,'V231453',7),(7205,'vestibulum dui dui','vestibulum dui dui',0,1,1.6,'V231453',7),(7206,'vitae ipsum','vitae ipsum',0,1,1.3667,'V3125',8),(7207,'vitae ipsum nisi','vitae ipsum nisi',0,1,1.5333,'V31252',8),(7208,'vitae laoreet','vitae laoreet',0,1,1.4333,'V3463',7),(7209,'vitae laoreet faucibus','vitae laoreet faucibus',0,1,1.7333,'V34631212',7),(7210,'vitae turpis','vitae turpis',0,1,1.4,'V3612',5),(7211,'vivamus congue','vivamus congue',0,1,1.4667,'V5252',8),(7212,'vivamus congue blandit','vivamus congue blandit',0,1,1.7333,'V52521453',8),(7213,'viverra facilisis','viverra facilisis',0,1,1.5667,'V61242',7),(7214,'viverra facilisis sit','viverra facilisis sit',0,1,1.7,'V612423',7),(7215,'volutpat sem praesent','volutpat sem praesent',0,1,1.7,'V43132516253',7),(7216,'vulputate orci','vulputate orci',0,1,1.4667,'V41362',7),(7217,'vulputate orci in','vulputate orci in',0,1,1.5667,'V413625',7),(7218,'vulputate tortor','vulputate tortor',0,1,1.5333,'V413636',8),(7219,'vulputate tortor arcu','vulputate tortor arcu',0,1,1.7,'V4136362',8),(7220,'vulputate ultrices','vulputate ultrices',0,1,1.6,'V4134362',8),(7221,'vulputate ultrices donec','vulputate ultrices donec',0,1,1.8,'V4134362352',8),(7222,'web recently','web recently',0,1,1.4,'W162534',1),(7223,'web recently helping','web recently helping',0,1,1.6667,'W162534152',1),(7224,'wide','wide',0,0,0.2667,'W300',1),(7225,'wide web','wide web',0,1,1.2667,'W310',1),(7226,'wide web recently','wide web recently',0,1,1.5667,'W3162534',1),(7227,'with the','with the',0,1,1.2667,'W300',1),(7228,'with the rapid','with the rapid',0,1,1.4667,'W3613',1),(7229,'within','within',0,0,0.4,'W350',2),(7230,'within most','within most',0,1,1.3667,'W3523',1),(7231,'within most affordable','within most affordable',0,1,1.7333,'W352316314',1),(7232,'world wide','world wide',0,1,1.3333,'W643',1),(7233,'world wide web','world wide web',0,1,1.4667,'W6431',1),(7234,'worldwide','worldwide',0,0,0.6,'W643',2),(7235,'worldwide in','worldwide in',0,1,1.4,'W6435',1),(7236,'worldwide in a','worldwide in a',0,1,1.4667,'W6435',1),(7237,'worldwide within','worldwide within',0,1,1.5333,'W6435',1),(7238,'worldwide within most','worldwide within most',0,1,1.7,'W643523',1),(7239,'27','27',0,0,0.2,'',1),(7240,'ac nullam','ac nullam',0,1,1.3,'A2545',6),(7241,'ac nullam nibh','ac nullam nibh',0,1,1.4667,'A25451',6),(7242,'additional capital','additional capital',0,1,1.6,'A3542134',1),(7243,'aliquet molestie','aliquet molestie',0,1,1.5333,'A4235423',6),(7244,'aliquet molestie ligula','aliquet molestie ligula',0,1,1.7667,'A4235423424',6),(7245,'amet elementum','amet elementum',0,1,1.4667,'A534535',7),(7246,'amet elementum tortor','amet elementum tortor',0,1,1.7,'A5345353636',6),(7247,'amet placerat','amet placerat',0,1,1.4333,'A5314263',6),(7248,'amet placerat eget','amet placerat eget',0,1,1.6,'A531426323',6),(7249,'at vestibulum','at vestibulum',0,1,1.4333,'A3123145',6),(7250,'at vestibulum id','at vestibulum id',0,1,1.5333,'A31231453',6),(7251,'capital','capital',0,0,0.4667,'C134',3),(7252,'condimentum at','condimentum at',0,1,1.4667,'C535353',6),(7253,'condimentum at vestibulum','condimentum at vestibulum',0,1,1.8333,'C535353123145',6),(7254,'congue ac','congue ac',0,1,1.3,'C520',6),(7255,'congue ac nullam','congue ac nullam',0,1,1.5333,'C52545',6),(7256,'congue sit','congue sit',0,1,1.3333,'C523',6),(7257,'congue sit amet','congue sit amet',0,1,1.5,'C52353',6),(7258,'cras aliquet','cras aliquet',0,1,1.4,'C62423',6),(7259,'cras aliquet molestie','cras aliquet molestie',0,1,1.7,'C624235423',6),(7260,'diam fermentum','diam fermentum',0,1,1.4667,'D516535',6),(7261,'diam fermentum consectetur','diam fermentum consectetur',0,1,1.8667,'D51653525236',6),(7262,'elementum tortor','elementum tortor',0,1,1.5333,'E45353636',6),(7263,'elementum tortor congue','elementum tortor congue',0,1,1.7667,'E45353636252',6),(7264,'elit vestibulum leo','elit vestibulum leo',0,1,1.6333,'E431231454',6),(7265,'eros cras','eros cras',0,1,1.3,'E6262',6),(7266,'eros cras aliquet','eros cras aliquet',0,1,1.5667,'E6262423',6),(7267,'et congue','et congue',0,1,1.3,'E3252',6),(7268,'et congue sit','et congue sit',0,1,1.4333,'E32523',6),(7269,'id eros','id eros',0,1,1.2333,'I362',6),(7270,'id eros cras','id eros cras',0,1,1.4,'I36262',6),(7271,'id pulvinar','id pulvinar',0,1,1.3667,'I314156',6),(7272,'id pulvinar id','id pulvinar id',0,1,1.4667,'I3141563',6),(7273,'leo nisi','leo nisi',0,1,1.2667,'L520',6),(7274,'leo nisi condimentum','leo nisi condimentum',0,1,1.6667,'L5253535',6),(7275,'ligula sit','ligula sit',0,1,1.3333,'L2423',6),(7276,'ligula sit amet','ligula sit amet',0,1,1.5,'L242353',6),(7277,'molestie ligula','molestie ligula',0,1,1.5,'M423424',6),(7278,'molestie ligula sit','molestie ligula sit',0,1,1.6333,'M42342423',6),(7279,'need','need',0,0,0.2667,'N300',3),(7280,'need additional','need additional',0,1,1.5,'N354',1),(7281,'need additional capital','need additional capital',0,1,1.7667,'N3542134',1),(7282,'neque varius','neque varius',0,1,1.4,'N2162',6),(7283,'neque varius et','neque varius et',0,1,1.5,'N21623',6),(7284,'nibh neque','nibh neque',0,1,1.3333,'N152',6),(7285,'nibh neque varius','nibh neque varius',0,1,1.5667,'N152162',6),(7286,'nisi condimentum','nisi condimentum',0,1,1.5333,'N253535',6),(7287,'nisi condimentum at','nisi condimentum at',0,1,1.6333,'N2535353',6),(7288,'nullam nibh','nullam nibh',0,1,1.3667,'N451',6),(7289,'nullam nibh neque','nullam nibh neque',0,1,1.5667,'N45152',6),(7290,'nunc diam fermentum','nunc diam fermentum',0,1,1.6333,'N23516535',6),(7291,'placerat eget','placerat eget',0,1,1.4333,'P426323',6),(7292,'placerat eget nibh','placerat eget nibh',0,1,1.6,'P42632351',6),(7293,'pulvinar id','pulvinar id',0,1,1.3667,'P41563',6),(7294,'pulvinar id eros','pulvinar id eros',0,1,1.5333,'P4156362',6),(7295,'sit amet elementum','sit amet elementum',0,1,1.6,'S3534535',7),(7296,'sit amet placerat','sit amet placerat',0,1,1.5667,'S35314263',6),(7297,'tortor congue','tortor congue',0,1,1.4333,'T636252',6),(7298,'tortor congue ac','tortor congue ac',0,1,1.5333,'T636252',6),(7299,'varius et','varius et',0,1,1.3,'V623',6),(7300,'varius et congue','varius et congue',0,1,1.5333,'V623252',6),(7301,'vestibulum id pulvinar','vestibulum id pulvinar',0,1,1.7333,'V23145314156',6),(7302,'vestibulum leo nisi','vestibulum leo nisi',0,1,1.6333,'V23145452',6),(7303,'28','28',0,0,0.2,'',1),(7304,'celebrate','celebrate',0,0,0.6,'C4163',1),(7305,'celebrate your','celebrate your',0,1,1.4667,'C41636',1),(7306,'celebrate your success','celebrate your success',0,1,1.7333,'C416362',1),(7307,'success','success',0,0,0.4667,'S000',2),(7308,'we celebrate','we celebrate',0,1,1.4,'W24163',1),(7309,'we celebrate your','we celebrate your',0,1,1.5667,'W241636',1),(7310,'your success','your success',0,1,1.4,'Y620',1),(7311,'29','29',0,0,0.2,'',1),(7312,'about starting','about starting',0,1,1.4667,'A13236352',1),(7313,'about starting your','about starting your',0,1,1.6333,'A132363526',1),(7314,'actually','actually',0,0,0.5333,'A234',1),(7315,'actually doing','actually doing',0,1,1.4667,'A234352',1),(7316,'actually doing it','actually doing it',0,1,1.5667,'A2343523',1),(7317,'advice','advice',0,0,0.4,'A312',2),(7318,'an idea','an idea',0,1,1.2333,'A530',1),(7319,'an idea about','an idea about',0,1,1.4333,'A5313',1),(7320,'and bounce','and bounce',0,1,1.3333,'A53152',1),(7321,'and bounce the','and bounce the',0,1,1.4667,'A531523',1),(7322,'and family','and family',0,1,1.3333,'A53154',1),(7323,'and family to','and family to',0,1,1.4333,'A531543',1),(7324,'and to','and to',0,1,1.2,'A530',2),(7325,'and to get','and to get',0,1,1.3333,'A5323',1),(7326,'back','back',0,0,0.2667,'B200',1),(7327,'back of','back of',0,1,1.2333,'B210',1),(7328,'back of your','back of your',0,1,1.4,'B216',1),(7329,'begin','begin',0,0,0.3333,'B250',1),(7330,'begin to','begin to',0,1,1.2667,'B253',1),(7331,'begin to seriously','begin to seriously',0,1,1.6,'B2532624',1),(7332,'bounce','bounce',0,0,0.4,'B520',1),(7333,'bounce the','bounce the',0,1,1.3333,'B523',1),(7334,'bounce the idea','bounce the idea',0,1,1.5,'B523',1),(7335,'business in','business in',0,1,1.3667,'B2525',1),(7336,'business in the','business in the',0,1,1.5,'B25253',1),(7337,'consider','consider',0,0,0.5333,'C5236',1),(7338,'consider the','consider the',0,1,1.4,'C52363',1),(7339,'consider the what-ifs','consider the what-ifs',0,1,1.7,'C5236312',1),(7340,'doing','doing',0,0,0.3333,'D520',1),(7341,'doing it','doing it',0,1,1.2667,'D523',1),(7342,'doing it you','doing it you',0,1,1.4,'D523',1),(7343,'explore','explore',0,0,0.4667,'E2146',1),(7344,'explore the','explore the',0,1,1.3667,'E21463',1),(7345,'explore the possibility','explore the possibility',0,1,1.7667,'E2146312143',1),(7346,'family','family',0,0,0.4,'F540',1),(7347,'family to','family to',0,1,1.3,'F543',1),(7348,'family to gauge','family to gauge',0,1,1.5,'F5432',1),(7349,'friends','friends',0,0,0.4667,'F6532',1),(7350,'friends and','friends and',0,1,1.3667,'F653253',1),(7351,'friends and family','friends and family',0,1,1.6,'F653253154',1),(7352,'gauge','gauge',0,0,0.3333,'G000',1),(7353,'gauge their','gauge their',0,1,1.3667,'G360',1),(7354,'gauge their support','gauge their support',0,1,1.6333,'G362163',1),(7355,'germ','germ',0,0,0.2667,'G650',1),(7356,'germ of','germ of',0,1,1.2333,'G651',1),(7357,'germ of an','germ of an',0,1,1.3333,'G6515',1),(7358,'get their','get their',0,1,1.3,'G360',1),(7359,'get their advice','get their advice',0,1,1.5333,'G36312',1),(7360,'had','had',0,0,0.2,'H300',1),(7361,'had this','had this',0,1,1.2667,'H320',1),(7362,'had this germ','had this germ',0,1,1.4333,'H3265',1),(7363,'idea','idea',0,0,0.2667,'I300',1),(7364,'idea about','idea about',0,1,1.3333,'I313',1),(7365,'idea about starting','idea about starting',0,1,1.6333,'I313236352',1),(7366,'idea off','idea off',0,1,1.2667,'I310',1),(7367,'idea off friends','idea off friends',0,1,1.5333,'I316532',1),(7368,'idea phase','idea phase',0,1,1.3333,'I312',1),(7369,'idea phase you','idea phase you',0,1,1.4667,'I312',1),(7370,'in the back','in the back',0,1,1.3667,'I5312',1),(7371,'in the idea','in the idea',0,1,1.3667,'I530',1),(7372,'it you','it you',0,1,1.2,'I300',1),(7373,'it you consider','it you consider',0,1,1.5,'I325236',1),(7374,'mind you\'ve','mind you',0,1,1.3667,'M310',1),(7375,'mind you\'ve had','mind you had',0,1,1.5,'M313',1),(7376,'nec urna nulla','nec urna nulla',0,1,1.4667,'N2654',2),(7377,'of actually','of actually',0,1,1.3667,'O1234',1),(7378,'of actually doing','of actually doing',0,1,1.5667,'O1234352',1),(7379,'of an idea','of an idea',0,1,1.3333,'O153',1),(7380,'of your mind','of your mind',0,1,1.4,'O1653',1),(7381,'off','off',0,0,0.2,'O100',1),(7382,'off friends','off friends',0,1,1.3667,'O16532',1),(7383,'off friends and','off friends and',0,1,1.5,'O1653253',1),(7384,'own business','own business',0,1,1.4,'O51252',2),(7385,'own business in','own business in',0,1,1.5,'O512525',1),(7386,'phase','phase',0,0,0.3333,'P200',2),(7387,'phase you','phase you',0,1,1.3,'P200',1),(7388,'phase you begin','phase you begin',0,1,1.5,'P2125',1),(7389,'possibility','possibility',0,0,0.7333,'P2143',1),(7390,'possibility of','possibility of',0,1,1.4667,'P21431',1),(7391,'possibility of actually','possibility of actually',0,1,1.7667,'P21431234',1),(7392,'seriously','seriously',0,0,0.6,'S624',1),(7393,'seriously explore','seriously explore',0,1,1.5667,'S6242146',1),(7394,'seriously explore the','seriously explore the',0,1,1.7,'S62421463',1),(7395,'starting','starting',0,0,0.5333,'S36352',1),(7396,'starting your','starting your',0,1,1.4333,'S363526',1),(7397,'starting your own','starting your own',0,1,1.5667,'S3635265',1),(7398,'support and','support and',0,1,1.3667,'S16353',1),(7399,'support and to','support and to',0,1,1.4667,'S16353',1),(7400,'the back','the back',0,1,1.2667,'T120',1),(7401,'the back of','the back of',0,1,1.3667,'T121',1),(7402,'the idea','the idea',0,1,1.2667,'T000',1),(7403,'the idea off','the idea off',0,1,1.4,'T100',1),(7404,'the idea phase','the idea phase',0,1,1.4667,'T120',1),(7405,'the possibility','the possibility',0,1,1.5,'T12143',1),(7406,'the possibility of','the possibility of',0,1,1.6,'T121431',1),(7407,'the what-ifs','the what-ifs',0,1,1.4,'T120',1),(7408,'the what-ifs and','the what-ifs and',0,1,1.5333,'T1253',1),(7409,'their advice','their advice',0,1,1.4,'T6312',1),(7410,'their support','their support',0,1,1.4333,'T62163',1),(7411,'their support and','their support and',0,1,1.5667,'T6216353',1),(7412,'this germ','this germ',0,1,1.3,'T265',1),(7413,'this germ of','this germ of',0,1,1.4,'T2651',1),(7414,'to gauge','to gauge',0,1,1.2667,'T200',1),(7415,'to gauge their','to gauge their',0,1,1.4667,'T236',1),(7416,'to get their','to get their',0,1,1.4,'T236',1),(7417,'to seriously','to seriously',0,1,1.4,'T2624',1),(7418,'to seriously explore','to seriously explore',0,1,1.6667,'T26242146',1),(7419,'urna nulla','urna nulla',0,1,1.3333,'U654',2),(7420,'urna nulla at','urna nulla at',0,1,1.4333,'U6543',2),(7421,'what-ifs','what-ifs',0,0,0.5333,'W312',1),(7422,'what-ifs and','what-ifs and',0,1,1.4,'W31253',1),(7423,'what-ifs and bounce','what-ifs and bounce',0,1,1.6333,'W31253152',1),(7424,'you begin','you begin',0,1,1.3,'Y125',1),(7425,'you begin to','you begin to',0,1,1.4,'Y1253',1),(7426,'you consider','you consider',0,1,1.4,'Y25236',1),(7427,'you consider the','you consider the',0,1,1.5333,'Y252363',1),(7428,'you\'ve','you',0,0,0.4,'Y100',1),(7429,'you\'ve had','you had',0,1,1.3333,'Y130',1),(7430,'you\'ve had this','you had this',0,1,1.5,'Y132',1),(7431,'your mind','your mind',0,1,1.3,'Y653',1),(7432,'your mind you\'ve','your mind you',0,1,1.5333,'Y6531',1),(7433,'your own business','your own business',0,1,1.5667,'Y651252',2),(7434,'30','30',0,0,0.2,'',1),(7435,'a business','a business',0,1,1.3333,'A1252',3),(7436,'a business cycle','a business cycle',0,1,1.5333,'A12524',1),(7437,'a clock','a clock',0,1,1.2333,'A242',1),(7438,'a clock its','a clock its',0,1,1.3667,'A24232',1),(7439,'a large degress','a large degress',0,1,1.5,'A4623262',1),(7440,'a regular','a regular',0,1,1.3,'A6246',1),(7441,'a regular predictable','a regular predictable',0,1,1.7,'A62461632314',1),(7442,'a sequence','a sequence',0,1,1.3333,'A252',1),(7443,'a sequence of','a sequence of',0,1,1.4333,'A2521',1),(7444,'and to a','and to a',0,1,1.2667,'A530',1),(7445,'as a sequence','as a sequence',0,1,1.4333,'A252',1),(7446,'business cycle','business cycle',0,1,1.4667,'B2524',1),(7447,'business cycle is','business cycle is',0,1,1.5667,'B25242',1),(7448,'clock its','clock its',0,1,1.3,'C4232',1),(7449,'clock its timing','clock its timing',0,1,1.5333,'C4232352',1),(7450,'cycle','cycle',0,0,0.3333,'C400',1),(7451,'cycle is','cycle is',0,1,1.2667,'C420',1),(7452,'cycle is identified','cycle is identified',0,1,1.6333,'C4235313',1),(7453,'cycle is not','cycle is not',0,1,1.4,'C4253',1),(7454,'degress','degress',0,0,0.4667,'D262',1),(7455,'degress unpredictable','degress unpredictable',0,1,1.7,'D26251632314',1),(7456,'degress unpredictable a','degress unpredictable a',0,1,1.7667,'D26251632314',1),(7457,'financial success','financial success',0,1,1.5667,'F5242',1),(7458,'four','four',0,0,0.2667,'F600',1),(7459,'four phase','four phase',0,1,1.3333,'F612',1),(7460,'identified','identified',0,0,0.6667,'I35313',1),(7461,'identified as','identified as',0,1,1.4333,'I353132',1),(7462,'identified as a','identified as a',0,1,1.5,'I353132',1),(7463,'is identified','is identified',0,1,1.4333,'I235313',1),(7464,'is identified as','is identified as',0,1,1.5333,'I2353132',1),(7465,'is not','is not',0,1,1.2,'I253',1),(7466,'is not a','is not a',0,1,1.2667,'I253',1),(7467,'is random','is random',0,1,1.3,'I26535',1),(7468,'is random and','is random and',0,1,1.4333,'I265353',1),(7469,'its timing','its timing',0,1,1.3333,'I32352',1),(7470,'its timing is','its timing is',0,1,1.4333,'I32352',1),(7471,'large degress','large degress',0,1,1.4333,'L623262',1),(7472,'large degress unpredictable','large degress unpredictable',0,1,1.9,'L62326251632314',1),(7473,'like the','like the',0,1,1.2667,'L230',1),(7474,'like the swing','like the swing',0,1,1.4667,'L23252',1),(7475,'not a','not a',0,1,1.1667,'N300',1),(7476,'not a regular','not a regular',0,1,1.4333,'N36246',1),(7477,'of a clock','of a clock',0,1,1.3333,'O1242',1),(7478,'of four','of four',0,1,1.2333,'O160',1),(7479,'of four phase','of four phase',0,1,1.4333,'O1612',1),(7480,'of the pendulum','of the pendulum',0,1,1.5,'O1315345',1),(7481,'or repeating','or repeating',0,1,1.4,'O61352',1),(7482,'or repeating phenomenon','or repeating phenomenon',0,1,1.7667,'O6135215',1),(7483,'pendulum','pendulum',0,0,0.5333,'P5345',1),(7484,'pendulum of','pendulum of',0,1,1.3667,'P53451',1),(7485,'pendulum of a','pendulum of a',0,1,1.4333,'P53451',1),(7486,'phenomenon','phenomenon',0,0,0.6667,'P500',1),(7487,'phenomenon like','phenomenon like',0,1,1.5,'P542',1),(7488,'phenomenon like the','phenomenon like the',0,1,1.6333,'P5423',1),(7489,'predictable','predictable',0,0,0.7333,'P632314',1),(7490,'predictable or','predictable or',0,1,1.4667,'P6323146',1),(7491,'predictable or repeating','predictable or repeating',0,1,1.8,'P63231461352',1),(7492,'random','random',0,0,0.4,'R535',1),(7493,'random and','random and',0,1,1.3333,'R5353',1),(7494,'random and to','random and to',0,1,1.4333,'R5353',1),(7495,'regular','regular',0,0,0.4667,'R246',1),(7496,'regular predictable','regular predictable',0,1,1.6333,'R2461632314',1),(7497,'regular predictable or','regular predictable or',0,1,1.7333,'R24616323146',1),(7498,'repeating','repeating',0,0,0.6,'R1352',1),(7499,'repeating phenomenon','repeating phenomenon',0,1,1.6667,'R135215',1),(7500,'repeating phenomenon like','repeating phenomenon like',0,1,1.8333,'R13521542',1),(7501,'sequence','sequence',0,0,0.5333,'S520',1),(7502,'sequence of','sequence of',0,1,1.3667,'S521',1),(7503,'sequence of four','sequence of four',0,1,1.5333,'S5216',1),(7504,'support your','support your',0,1,1.4,'S1636',1),(7505,'support your financial','support your financial',0,1,1.7333,'S16361524',1),(7506,'swing','swing',0,0,0.3333,'S520',1),(7507,'swing of','swing of',0,1,1.2667,'S521',1),(7508,'swing of the','swing of the',0,1,1.4,'S5213',1),(7509,'the pendulum','the pendulum',0,1,1.4,'T15345',1),(7510,'the pendulum of','the pendulum of',0,1,1.5,'T153451',1),(7511,'the swing','the swing',0,1,1.3,'T252',1),(7512,'the swing of','the swing of',0,1,1.4,'T2521',1),(7513,'timing','timing',0,0,0.4,'T520',1),(7514,'timing is','timing is',0,1,1.3,'T520',1),(7515,'timing is random','timing is random',0,1,1.5333,'T526535',1),(7516,'to a','to a',0,1,1.1333,'T000',1),(7517,'to a large','to a large',0,1,1.3333,'T462',1),(7518,'turpis nulla','turpis nulla',0,1,1.4,'T61254',1),(7519,'turpis nulla at','turpis nulla at',0,1,1.5,'T612543',1),(7520,'unpredictable','unpredictable',0,0,0.8667,'U51632314',1),(7521,'unpredictable a','unpredictable a',0,1,1.5,'U51632314',1),(7522,'unpredictable a business','unpredictable a business',0,1,1.8,'U516323141252',1),(7523,'vitae turpis nulla','vitae turpis nulla',0,1,1.6,'V361254',1),(7524,'your financial','your financial',0,1,1.4667,'Y61524',1),(7525,'your financial success','your financial success',0,1,1.7333,'Y615242',1),(7526,'2002','2002',0,0,0.4,'',1),(7527,'2002 business','2002 business',0,1,1.4333,'B252',1),(7528,'2002 business owners','2002 business owners',0,1,1.6667,'B252562',1),(7529,'31','31',0,0,0.2,'',1),(7530,'a business owner','a business owner',0,1,1.5333,'A125256',2),(7531,'advances','advances',0,0,0.5333,'A3152',1),(7532,'advances to','advances to',0,1,1.3667,'A31523',1),(7533,'advances to businesses','advances to businesses',0,1,1.7333,'A315231252',1),(7534,'an important','an important',0,1,1.4,'A516353',2),(7535,'an important part','an important part',0,1,1.5667,'A516353163',2),(7536,'and who','and who',0,1,1.2333,'A530',2),(7537,'and who you','and who you',0,1,1.3667,'A530',2),(7538,'are many','are many',0,1,1.2667,'A650',2),(7539,'are many choices','are many choices',0,1,1.5333,'A652',2),(7540,'as a business','as a business',0,1,1.4333,'A21252',2),(7541,'bfs','bfs',0,0,0.2,'B200',1),(7542,'bfs is','bfs is',0,1,1.2,'B200',1),(7543,'bfs is the','bfs is the',0,1,1.3333,'B230',1),(7544,'business capital','business capital',0,1,1.5333,'B252134',2),(7545,'business capital they','business capital they',0,1,1.7,'B2521343',1),(7546,'business capital you','business capital you',0,1,1.6667,'B252134',2),(7547,'business financial','business financial',0,1,1.6,'B2521524',1),(7548,'business financial services','business financial services',0,1,1.9,'B25215242612',1),(7549,'business funding','business funding',0,1,1.5333,'B25215352',2),(7550,'business owner','business owner',0,1,1.4667,'B25256',2),(7551,'business owner understanding','business owner understanding',0,1,1.9333,'B25256536235352',2),(7552,'business owners','business owners',0,1,1.5,'B252562',1),(7553,'business owners have','business owners have',0,1,1.6667,'B2525621',1),(7554,'businesses','businesses',0,0,0.6667,'B252',1),(7555,'businesses nationwide','businesses nationwide',0,1,1.7,'B2525353',1),(7556,'businesses nationwide since','businesses nationwide since',0,1,1.9,'B2525353252',1),(7557,'can qualify','can qualify',0,1,1.3667,'C5241',2),(7558,'can qualify for','can qualify for',0,1,1.5,'C52416',2),(7559,'can rely','can rely',0,1,1.2667,'C564',2),(7560,'can rely on','can rely on',0,1,1.3667,'C5645',2),(7561,'capital there','capital there',0,1,1.4333,'C13436',2),(7562,'capital there are','capital there are',0,1,1.5667,'C13436',2),(7563,'capital they','capital they',0,1,1.4,'C1343',1),(7564,'capital they need','capital they need',0,1,1.5667,'C134353',1),(7565,'capital you','capital you',0,1,1.3667,'C134',2),(7566,'capital you need','capital you need',0,1,1.5333,'C13453',2),(7567,'cash','cash',0,0,0.2667,'C000',1),(7568,'cash advances','cash advances',0,1,1.4333,'C3152',1),(7569,'cash advances to','cash advances to',0,1,1.5333,'C31523',1),(7570,'cash flow','cash flow',0,1,1.3,'C140',1),(7571,'cash flow phasellus','cash flow phasellus',0,1,1.6333,'C141242',1),(7572,'challenging','challenging',0,0,0.7333,'C45252',3),(7573,'challenging in','challenging in',0,1,1.4667,'C452525',2),(7574,'challenging in today\'s','challenging in today',0,1,1.7333,'C45252532',2),(7575,'choices','choices',0,0,0.4667,'C000',2),(7576,'choices as','choices as',0,1,1.3333,'C000',2),(7577,'choices as a','choices as a',0,1,1.4,'C000',2),(7578,'come','come',0,0,0.2667,'C500',1),(7579,'come to','come to',0,1,1.2333,'C530',1),(7580,'come to us','come to us',0,1,1.3333,'C532',1),(7581,'comes','comes',0,0,0.3333,'C520',2),(7582,'comes to','comes to',0,1,1.2667,'C523',2),(7583,'comes to obtaining','comes to obtaining',0,1,1.6,'C5231352',2),(7584,'day-to-day','day-to-day',0,0,0.6667,'D000',2),(7585,'day-to-day expenses','day-to-day expenses',0,1,1.6333,'D2152',2),(7586,'day-to-day expenses is','day-to-day expenses is',0,1,1.7333,'D2152',2),(7587,'decision','decision',0,0,0.5333,'D250',2),(7588,'decision making','decision making',0,1,1.5,'D25252',2),(7589,'decision making process','decision making process',0,1,1.7667,'D25252162',2),(7590,'dedicated stractegy','dedicated stractegy',0,1,1.6333,'D23236232',1),(7591,'economy','economy',0,0,0.4667,'E250',2),(7592,'economy we','economy we',0,1,1.3333,'E250',2),(7593,'economy we recognize','economy we recognize',0,1,1.6667,'E256252',2),(7594,'equipment','equipment',0,0,0.6,'E2153',1),(7595,'equipment taxes','equipment taxes',0,1,1.5,'E21532',1),(7596,'equipment taxes or','equipment taxes or',0,1,1.6,'E215326',1),(7597,'expenses','expenses',0,0,0.5333,'E2152',2),(7598,'expenses is','expenses is',0,1,1.3667,'E2152',2),(7599,'expenses is challenging','expenses is challenging',0,1,1.7667,'E215245252',2),(7600,'extra','extra',0,0,0.3333,'E236',1),(7601,'extra cash','extra cash',0,1,1.3333,'E2362',1),(7602,'extra cash flow','extra cash flow',0,1,1.5,'E236214',1),(7603,'financial services','financial services',0,1,1.6,'F5242612',1),(7604,'financial services bfs','financial services bfs',0,1,1.7333,'F524261212',1),(7605,'financing','financing',0,0,0.6,'F5252',1),(7606,'financing renovation','financing renovation',0,1,1.6667,'F525265135',1),(7607,'financing renovation equipment','financing renovation equipment',0,1,2,'F5252651352153',1),(7608,'flow','flow',0,0,0.2667,'F400',1),(7609,'flow phasellus','flow phasellus',0,1,1.4667,'F41242',1),(7610,'flow phasellus erat','flow phasellus erat',0,1,1.6333,'F4124263',1),(7611,'for and','for and',0,1,1.2333,'F653',2),(7612,'for and who','for and who',0,1,1.3667,'F653',2),(7613,'for inventory','for inventory',0,1,1.4333,'F651536',1),(7614,'for inventory vendor','for inventory vendor',0,1,1.6667,'F6515361536',1),(7615,'from dedicated','from dedicated',0,1,1.4667,'F65323',1),(7616,'from dedicated stractegy','from dedicated stractegy',0,1,1.8,'F65323236232',1),(7617,'funding','funding',0,0,0.4667,'F5352',2),(7618,'get the','get the',0,1,1.2333,'G300',1),(7619,'get the small','get the small',0,1,1.4333,'G3254',1),(7620,'getting','getting',0,0,0.4667,'G352',2),(7621,'getting the','getting the',0,1,1.3667,'G3523',2),(7622,'getting the small','getting the small',0,1,1.5667,'G3523254',2),(7623,'have come','have come',0,1,1.3,'H125',1),(7624,'have come to','have come to',0,1,1.4,'H1253',1),(7625,'help with','help with',0,1,1.3,'H413',2),(7626,'help with day-to-day','help with day-to-day',0,1,1.6667,'H413',2),(7627,'important part','important part',0,1,1.4667,'I516353163',2),(7628,'important part of','important part of',0,1,1.5667,'I5163531631',2),(7629,'in today\'s','in today',0,1,1.3333,'I532',2),(7630,'in today\'s economy','in today economy',0,1,1.6,'I5325',2),(7631,'inventory','inventory',0,0,0.6,'I51536',1),(7632,'inventory vendor','inventory vendor',0,1,1.5333,'I515361536',1),(7633,'inventory vendor financing','inventory vendor financing',0,1,1.8667,'I51536153615252',1),(7634,'is an important','is an important',0,1,1.5,'I2516353',2),(7635,'is challenging','is challenging',0,1,1.4667,'I245252',2),(7636,'is challenging in','is challenging in',0,1,1.5667,'I2452525',2),(7637,'is the','is the',0,1,1.2,'I230',1),(7638,'is the trusted','is the trusted',0,1,1.4667,'I23623',1),(7639,'it comes','it comes',0,1,1.2667,'I3252',2),(7640,'it comes to','it comes to',0,1,1.3667,'I32523',2),(7641,'just extra','just extra',0,1,1.3333,'J3236',1),(7642,'just extra cash','just extra cash',0,1,1.5,'J32362',1),(7643,'making process','making process',0,1,1.4667,'M252162',2),(7644,'making process business','making process business',0,1,1.7667,'M2521621252',1),(7645,'many','many',0,0,0.2667,'M000',2),(7646,'many choices','many choices',0,1,1.4,'M200',2),(7647,'many choices as','many choices as',0,1,1.5,'M200',2),(7648,'merchant','merchant',0,0,0.5333,'M6253',1),(7649,'merchant cash','merchant cash',0,1,1.4333,'M62532',1),(7650,'merchant cash advances','merchant cash advances',0,1,1.7333,'M625323152',1),(7651,'nationwide','nationwide',0,0,0.6667,'N353',1),(7652,'nationwide since','nationwide since',0,1,1.5333,'N353252',1),(7653,'nationwide since 2002','nationwide since 2002',0,1,1.7,'N353252',1),(7654,'need for','need for',0,1,1.2667,'N316',1),(7655,'need for inventory','need for inventory',0,1,1.6,'N31651536',1),(7656,'need to','need to',0,1,1.2333,'N300',2),(7657,'need to help','need to help',0,1,1.4,'N341',2),(7658,'obtaining','obtaining',0,0,0.6,'O1352',2),(7659,'obtaining working','obtaining working',0,1,1.5667,'O13526252',2),(7660,'obtaining working capital','obtaining working capital',0,1,1.8333,'O13526252134',2),(7661,'of merchant','of merchant',0,1,1.3667,'O156253',1),(7662,'of merchant cash','of merchant cash',0,1,1.5333,'O1562532',1),(7663,'of small','of small',0,1,1.2667,'O1254',2),(7664,'of small business','of small business',0,1,1.5667,'O12541252',2),(7665,'of the decision','of the decision',0,1,1.5,'O1325',2),(7666,'on is','on is',0,1,1.1667,'O520',2),(7667,'on is an','on is an',0,1,1.2667,'O525',2),(7668,'or just','or just',0,1,1.2333,'O623',1),(7669,'or just extra','or just extra',0,1,1.4333,'O623236',1),(7670,'owner','owner',0,0,0.3333,'O560',2),(7671,'owner understanding','owner understanding',0,1,1.6333,'O56536235352',2),(7672,'owner understanding the','owner understanding the',0,1,1.7667,'O565362353523',2),(7673,'owners','owners',0,0,0.4,'O562',1),(7674,'owners have','owners have',0,1,1.3667,'O5621',1),(7675,'owners have come','owners have come',0,1,1.5333,'O562125',1),(7676,'process','process',0,0,0.4667,'P620',2),(7677,'process business','process business',0,1,1.5333,'P621252',1),(7678,'process business financial','process business financial',0,1,1.8667,'P6212521524',1),(7679,'provider','provider',0,0,0.5333,'P6136',1),(7680,'provider of','provider of',0,1,1.3667,'P61361',1),(7681,'provider of merchant','provider of merchant',0,1,1.6667,'P6136156253',1),(7682,'qualify','qualify',0,0,0.4667,'Q410',2),(7683,'qualify for','qualify for',0,1,1.3667,'Q416',2),(7684,'qualify for and','qualify for and',0,1,1.5,'Q41653',2),(7685,'recognize','recognize',0,0,0.6,'R252',2),(7686,'recognize when','recognize when',0,1,1.4667,'R2525',2),(7687,'recognize when it','recognize when it',0,1,1.5667,'R25253',2),(7688,'rely','rely',0,0,0.2667,'R400',2),(7689,'rely on','rely on',0,1,1.2333,'R450',2),(7690,'rely on is','rely on is',0,1,1.3333,'R452',2),(7691,'renovation','renovation',0,0,0.6667,'R5135',1),(7692,'renovation equipment','renovation equipment',0,1,1.6667,'R51352153',1),(7693,'renovation equipment taxes','renovation equipment taxes',0,1,1.8667,'R513521532',1),(7694,'services bfs','services bfs',0,1,1.4,'S61212',1),(7695,'services bfs is','services bfs is',0,1,1.5,'S61212',1),(7696,'since','since',0,0,0.3333,'S520',1),(7697,'since 2002','since 2002',0,1,1.3333,'S520',1),(7698,'since 2002 business','since 2002 business',0,1,1.6333,'S521252',1),(7699,'small business','small business',0,1,1.4667,'S541252',2),(7700,'small business capital','small business capital',0,1,1.7333,'S541252134',2),(7701,'small business funding','small business funding',0,1,1.7333,'S54125215352',2),(7702,'stractegy','stractegy',0,0,0.6,'S36232',1),(7703,'taxes','taxes',0,0,0.3333,'T200',1),(7704,'taxes or','taxes or',0,1,1.2667,'T260',1),(7705,'taxes or just','taxes or just',0,1,1.4333,'T2623',1),(7706,'the decision','the decision',0,1,1.4,'T250',2),(7707,'the decision making','the decision making',0,1,1.6333,'T25252',2),(7708,'the small','the small',0,1,1.3,'T254',2),(7709,'the small business','the small business',0,1,1.6,'T2541252',2),(7710,'the trusted','the trusted',0,1,1.3667,'T623',1),(7711,'the trusted provider','the trusted provider',0,1,1.6667,'T62316136',1),(7712,'the type','the type',0,1,1.2667,'T100',2),(7713,'the type of','the type of',0,1,1.3667,'T100',2),(7714,'there are','there are',0,1,1.3,'T600',2),(7715,'there are many','there are many',0,1,1.4667,'T650',2),(7716,'they need','they need',0,1,1.3,'T530',1),(7717,'they need for','they need for',0,1,1.4333,'T5316',1),(7718,'to businesses','to businesses',0,1,1.4333,'T1252',1),(7719,'to businesses nationwide','to businesses nationwide',0,1,1.8,'T12525353',1),(7720,'to get the','to get the',0,1,1.3333,'T230',1),(7721,'to help','to help',0,1,1.2333,'T410',2),(7722,'to help with','to help with',0,1,1.4,'T413',2),(7723,'to obtaining','to obtaining',0,1,1.4,'T1352',2),(7724,'to obtaining working','to obtaining working',0,1,1.6667,'T13526252',2),(7725,'to us','to us',0,1,1.1667,'T200',1),(7726,'to us to','to us to',0,1,1.2667,'T230',1),(7727,'today\'s','today',0,0,0.4667,'T200',2),(7728,'today\'s economy','today economy',0,1,1.5,'T250',2),(7729,'today\'s economy we','today economy we',0,1,1.6,'T250',2),(7730,'trusted','trusted',0,0,0.4667,'T623',2),(7731,'trusted provider','trusted provider',0,1,1.5333,'T62316136',1),(7732,'trusted provider of','trusted provider of',0,1,1.6333,'T623161361',1),(7733,'type of','type of',0,1,1.2333,'T100',2),(7734,'type of small','type of small',0,1,1.4333,'T1254',2),(7735,'understanding','understanding',0,0,0.8667,'U536235352',2),(7736,'understanding the','understanding the',0,1,1.5667,'U5362353523',2),(7737,'understanding the type','understanding the type',0,1,1.7333,'U53623535231',2),(7738,'us','us',0,0,0.1333,'U200',2),(7739,'us to','us to',0,1,1.1667,'U230',1),(7740,'us to get','us to get',0,1,1.3,'U2323',1),(7741,'vendor','vendor',0,0,0.4,'V536',1),(7742,'vendor financing','vendor financing',0,1,1.5333,'V53615252',1),(7743,'vendor financing renovation','vendor financing renovation',0,1,1.9,'V5361525265135',1),(7744,'we recognize','we recognize',0,1,1.4,'W6252',2),(7745,'we recognize when','we recognize when',0,1,1.5667,'W62525',2),(7746,'when','when',0,0,0.2667,'W500',3),(7747,'when it','when it',0,1,1.2333,'W530',2),(7748,'when it comes','when it comes',0,1,1.4333,'W53252',2),(7749,'who you','who you',0,1,1.2333,'W000',2),(7750,'who you can','who you can',0,1,1.3667,'W250',2),(7751,'with day-to-day','with day-to-day',0,1,1.5,'W300',2),(7752,'with day-to-day expenses','with day-to-day expenses',0,1,1.8,'W32152',2),(7753,'working','working',0,0,0.4667,'W6252',2),(7754,'working capital','working capital',0,1,1.5,'W6252134',2),(7755,'working capital there','working capital there',0,1,1.7,'W625213436',2),(7756,'workshop','workshop',0,0,0.5333,'W621',2),(7757,'workshop from','workshop from',0,1,1.4333,'W62165',1),(7758,'workshop from dedicated','workshop from dedicated',0,1,1.7667,'W62165323',1),(7759,'you can qualify','you can qualify',0,1,1.5,'Y25241',1),(7760,'you can rely','you can rely',0,1,1.4,'Y2564',2),(7761,'you need','you need',0,1,1.2667,'Y530',2),(7762,'you need to','you need to',0,1,1.3667,'Y530',2),(7763,'32','32',0,0,0.2,'',1),(7764,'a long','a long',0,1,1.2,'A452',1),(7765,'a long list','a long list',0,1,1.3667,'A452423',1),(7766,'and support','and support',0,1,1.3667,'A532163',1),(7767,'and support staff','and support staff',0,1,1.5667,'A532163231',1),(7768,'and voice','and voice',0,1,1.3,'A5312',1),(7769,'and voice mail','and voice mail',0,1,1.4667,'A531254',1),(7770,'attendant','attendant',0,0,0.6,'A35353',1),(7771,'attendant options','attendant options',0,1,1.5667,'A353531352',1),(7772,'attendant options and','attendant options and',0,1,1.7,'A35353135253',1),(7773,'auto','auto',0,0,0.2667,'A300',1),(7774,'auto attendant','auto attendant',0,1,1.4667,'A35353',1),(7775,'auto attendant options','auto attendant options',0,1,1.7333,'A353531352',1),(7776,'been looking','been looking',0,1,1.4,'B54252',1),(7777,'been looking for','been looking for',0,1,1.5333,'B5425216',1),(7778,'brings the personal','brings the personal',0,1,1.6333,'B652316254',1),(7779,'for no','for no',0,1,1.2,'F650',1),(7780,'for no wading','for no wading',0,1,1.4333,'F65352',1),(7781,'have been looking','have been looking',0,1,1.5667,'H154252',1),(7782,'list of','list of',0,1,1.2333,'L231',1),(7783,'list of auto','list of auto',0,1,1.4,'L2313',1),(7784,'long','long',0,0,0.2667,'L520',1),(7785,'long list','long list',0,1,1.3,'L52423',1),(7786,'long list of','long list of',0,1,1.4,'L524231',1),(7787,'looking','looking',0,0,0.4667,'L252',1),(7788,'looking for','looking for',0,1,1.3667,'L25216',1),(7789,'looking for no','looking for no',0,1,1.4667,'L252165',1),(7790,'mail','mail',0,0,0.2667,'M400',1),(7791,'mail nulla','mail nulla',0,1,1.3333,'M454',1),(7792,'mail nulla at','mail nulla at',0,1,1.4333,'M4543',1),(7793,'no','no',0,0,0.1333,'N000',1),(7794,'no wading','no wading',0,1,1.3,'N352',1),(7795,'no wading through','no wading through',0,1,1.5667,'N352362',1),(7796,'of auto','of auto',0,1,1.2333,'O130',1),(7797,'of auto attendant','of auto attendant',0,1,1.5667,'O135353',1),(7798,'office','office',0,0,0.4,'O120',1),(7799,'office and','office and',0,1,1.3333,'O1253',1),(7800,'office and support','office and support',0,1,1.6,'O12532163',1),(7801,'options and','options and',0,1,1.3667,'O135253',1),(7802,'options and voice','options and voice',0,1,1.5667,'O13525312',1),(7803,'personal','personal',0,0,0.5333,'P6254',2),(7804,'personal touch','personal touch',0,1,1.4667,'P625432',1),(7805,'personal touch that','personal touch that',0,1,1.6333,'P6254323',1),(7806,'staff','staff',0,0,0.3333,'S310',2),(7807,'staff brings','staff brings',0,1,1.4,'S31652',1),(7808,'staff brings the','staff brings the',0,1,1.5333,'S316523',1),(7809,'support staff','support staff',0,1,1.4333,'S163231',1),(7810,'support staff brings','support staff brings',0,1,1.6667,'S163231652',1),(7811,'technical','technical',0,0,0.6,'T2524',1),(7812,'technical support','technical support',0,1,1.5667,'T25242163',1),(7813,'technical support staff','technical support staff',0,1,1.7667,'T25242163231',1),(7814,'that you','that you',0,1,1.2667,'T000',1),(7815,'that you have','that you have',0,1,1.4333,'T100',1),(7816,'the personal','the personal',0,1,1.4,'T16254',1),(7817,'the personal touch','the personal touch',0,1,1.6,'T1625432',1),(7818,'through','through',0,0,0.4667,'T620',3),(7819,'through a','through a',0,1,1.3,'T620',1),(7820,'through a long','through a long',0,1,1.4667,'T62452',1),(7821,'touch','touch',0,0,0.3333,'T200',1),(7822,'touch that','touch that',0,1,1.3333,'T230',1),(7823,'touch that you','touch that you',0,1,1.4667,'T230',1),(7824,'voice','voice',0,0,0.3333,'V200',1),(7825,'voice mail','voice mail',0,1,1.3333,'V254',1),(7826,'voice mail nulla','voice mail nulla',0,1,1.5333,'V25454',1),(7827,'wading','wading',0,0,0.4,'W352',1),(7828,'wading through','wading through',0,1,1.4667,'W352362',1),(7829,'wading through a','wading through a',0,1,1.5333,'W352362',1),(7830,'you have','you have',0,1,1.2667,'Y100',2),(7831,'you have been','you have been',0,1,1.4333,'Y150',1),(7832,'33','33',0,0,0.2,'',1),(7833,'a great','a great',0,1,1.2333,'A263',1),(7834,'a great team','a great team',0,1,1.4,'A2635',1),(7835,'bumps','bumps',0,0,0.3333,'B512',1),(7836,'bumps in','bumps in',0,1,1.2667,'B5125',1),(7837,'bumps in the','bumps in the',0,1,1.4,'B51253',1),(7838,'business encounters','business encounters',0,1,1.6333,'B252525362',1),(7839,'business encounters bumps','business encounters bumps',0,1,1.8333,'B2525253621512',1),(7840,'challenging times','challenging times',0,1,1.5667,'C45252352',1),(7841,'challenging times quisque','challenging times quisque',0,1,1.8333,'C45252352',1),(7842,'creating a','creating a',0,1,1.3333,'C6352',1),(7843,'creating a great','creating a great',0,1,1.5333,'C635263',1),(7844,'during','during',0,0,0.4,'D652',1),(7845,'during these','during these',0,1,1.4,'D65232',1),(7846,'during these challenging','during these challenging',0,1,1.8,'D6523245252',1),(7847,'encounters','encounters',0,0,0.6667,'E525362',1),(7848,'encounters bumps','encounters bumps',0,1,1.5333,'E5253621512',1),(7849,'encounters bumps in','encounters bumps in',0,1,1.6333,'E52536215125',1),(7850,'environment','environment',0,0,0.7333,'E51653',1),(7851,'especially','especially',0,0,0.6667,'E2124',1),(7852,'especially your','especially your',0,1,1.5,'E21246',1),(7853,'especially your staff','especially your staff',0,1,1.7,'E21246231',1),(7854,'everyone','everyone',0,0,0.5333,'E165',1),(7855,'everyone knows','everyone knows',0,1,1.4667,'E165252',1),(7856,'everyone knows especially','everyone knows especially',0,1,1.8333,'E165252124',1),(7857,'great','great',0,0,0.3333,'G630',1),(7858,'great team','great team',0,1,1.3333,'G635',1),(7859,'great team environment','great team environment',0,1,1.7333,'G6351653',1),(7860,'in the road','in the road',0,1,1.3667,'I5363',1),(7861,'it seems','it seems',0,1,1.2667,'I3252',1),(7862,'it seems like','it seems like',0,1,1.4333,'I325242',1),(7863,'knows','knows',0,0,0.3333,'K520',1),(7864,'knows especially','knows especially',0,1,1.5333,'K52124',1),(7865,'knows especially your','knows especially your',0,1,1.7,'K521246',1),(7866,'like everyone','like everyone',0,1,1.4333,'L2165',1),(7867,'like everyone knows','like everyone knows',0,1,1.6333,'L2165252',1),(7868,'road','road',0,0,0.2667,'R300',1),(7869,'road it','road it',0,1,1.2333,'R300',1),(7870,'road it seems','road it seems',0,1,1.4333,'R3252',1),(7871,'seems','seems',0,0,0.3333,'S520',1),(7872,'seems like','seems like',0,1,1.3333,'S5242',1),(7873,'seems like everyone','seems like everyone',0,1,1.6333,'S5242165',1),(7874,'staff during','staff during',0,1,1.4,'S313652',1),(7875,'staff during these','staff during these',0,1,1.6,'S31365232',1),(7876,'team environment','team environment',0,1,1.5333,'T51653',1),(7877,'the road','the road',0,1,1.2667,'T630',1),(7878,'the road it','the road it',0,1,1.3667,'T630',1),(7879,'these challenging','these challenging',0,1,1.5667,'T245252',1),(7880,'these challenging times','these challenging times',0,1,1.7667,'T245252352',1),(7881,'times','times',0,0,0.3333,'T520',1),(7882,'times quisque','times quisque',0,1,1.4333,'T520',1),(7883,'times quisque eget','times quisque eget',0,1,1.6,'T523',1),(7884,'turpis sed','turpis sed',0,1,1.3333,'T6123',1),(7885,'turpis sed ultrices','turpis sed ultrices',0,1,1.6333,'T61234362',1),(7886,'vitae turpis sed','vitae turpis sed',0,1,1.5333,'V36123',1),(7887,'when your','when your',0,1,1.3,'W560',1),(7888,'when your business','when your business',0,1,1.6,'W561252',1),(7889,'your business','your business',0,1,1.4333,'Y61252',1),(7890,'your business encounters','your business encounters',0,1,1.8,'Y61252525362',1),(7891,'your staff','your staff',0,1,1.3333,'Y6231',1),(7892,'your staff during','your staff during',0,1,1.5667,'Y62313652',1),(7893,'34','34',0,0,0.2,'',1),(7894,'able to accept','able to accept',0,1,1.4667,'A143213',1),(7895,'able to give','able to give',0,1,1.4,'A14321',1),(7896,'accept within','accept within',0,1,1.4333,'A2135',1),(7897,'accept within yourself','accept within yourself',0,1,1.7333,'A21356241',1),(7898,'accepting','accepting',0,0,0.6,'A21352',1),(7899,'accepting to','accepting to',0,1,1.4,'A213523',1),(7900,'accepting to be','accepting to be',0,1,1.5,'A2135231',1),(7901,'actions','actions',0,0,0.4667,'A2352',1),(7902,'actions be','actions be',0,1,1.3333,'A23521',1),(7903,'actions be yourself','actions be yourself',0,1,1.6333,'A235216241',1),(7904,'all have','all have',0,1,1.2667,'A410',1),(7905,'all have to','all have to',0,1,1.3667,'A413',1),(7906,'and able','and able',0,1,1.2667,'A5314',1),(7907,'and able to','and able to',0,1,1.3667,'A53143',1),(7908,'and actions','and actions',0,1,1.3667,'A532352',1),(7909,'and actions be','and actions be',0,1,1.4667,'A5323521',1),(7910,'and in','and in',0,1,1.2,'A535',1),(7911,'and in accepting','and in accepting',0,1,1.5333,'A53521352',1),(7912,'and letting','and letting',0,1,1.3667,'A534352',1),(7913,'and letting truth','and letting truth',0,1,1.5667,'A534352363',1),(7914,'are ready','are ready',0,1,1.3,'A630',1),(7915,'are ready willing','are ready willing',0,1,1.5667,'A63452',1),(7916,'be yourself','be yourself',0,1,1.3667,'B6241',1),(7917,'be yourself in','be yourself in',0,1,1.4667,'B62415',1),(7918,'being','being',0,0,0.3333,'B520',2),(7919,'being true','being true',0,1,1.3333,'B5236',1),(7920,'being true to','being true to',0,1,1.4333,'B52363',1),(7921,'best','best',0,0,0.2667,'B230',1),(7922,'best within','best within',0,1,1.3667,'B235',1),(7923,'best within you','best within you',0,1,1.5,'B235',1),(7924,'built','built',0,0,0.3333,'B430',1),(7925,'built on','built on',0,1,1.2667,'B435',1),(7926,'built on friendship','built on friendship',0,1,1.6333,'B435165321',1),(7927,'business is','business is',0,1,1.3667,'B252',1),(7928,'business is built','business is built',0,1,1.5667,'B252143',1),(7929,'business plan','business plan',0,1,1.4333,'B252145',2),(7930,'business plan with','business plan with',0,1,1.6,'B2521453',1),(7931,'by being','by being',0,1,1.2667,'B520',1),(7932,'by being true','by being true',0,1,1.4333,'B5236',1),(7933,'company\'s','company',0,0,0.6,'C5152',1),(7934,'company\'s business','company business',0,1,1.6,'C51521252',1),(7935,'company\'s business plan','company business plan',0,1,1.7667,'C51521252145',1),(7936,'crowd','crowd',0,0,0.3333,'C630',1),(7937,'crowd lorem','crowd lorem',0,1,1.3667,'C63465',1),(7938,'crowd lorem ipsum','crowd lorem ipsum',0,1,1.5667,'C63465125',1),(7939,'describe','describe',0,0,0.5333,'D261',1),(7940,'describe your','describe your',0,1,1.4333,'D2616',1),(7941,'describe your company\'s','describe your company',0,1,1.7667,'D261625152',1),(7942,'difference','difference',0,0,0.6667,'D1652',1),(7943,'difference by','difference by',0,1,1.4333,'D16521',1),(7944,'difference by being','difference by being',0,1,1.6333,'D1652152',1),(7945,'do with','do with',0,1,1.2333,'D000',1),(7946,'do with what','do with what',0,1,1.4,'D000',1),(7947,'eget nibh phasellus','eget nibh phasellus',0,1,1.6333,'E2351242',4),(7948,'eyes','eyes',0,0,0.2667,'E200',1),(7949,'eyes of','eyes of',0,1,1.2333,'E210',1),(7950,'eyes of the','eyes of the',0,1,1.3667,'E213',1),(7951,'features','features',0,0,0.5333,'F362',1),(7952,'features twelve','features twelve',0,1,1.5,'F362341',1),(7953,'features twelve slides','features twelve slides',0,1,1.7333,'F3623412432',1),(7954,'for powerpoint','for powerpoint',0,1,1.4667,'F616153',1),(7955,'for powerpoint it','for powerpoint it',0,1,1.5667,'F616153',1),(7956,'friendship','friendship',0,0,0.6667,'F65321',1),(7957,'from mission','from mission',0,1,1.4,'F6525',1),(7958,'from mission statement','from mission statement',0,1,1.7333,'F65252353',1),(7959,'front','front',0,0,0.3333,'F653',1),(7960,'front of','front of',0,1,1.2667,'F6531',1),(7961,'front of the','front of the',0,1,1.4,'F65313',1),(7962,'give','give',0,0,0.2667,'G100',1),(7963,'give others','give others',0,1,1.3667,'G1362',1),(7964,'give others it','give others it',0,1,1.4667,'G13623',1),(7965,'have to','have to',0,1,1.2333,'H130',1),(7966,'have to do','have to do',0,1,1.3333,'H130',1),(7967,'in accepting','in accepting',0,1,1.4,'I521352',1),(7968,'in accepting to','in accepting to',0,1,1.5,'I5213523',1),(7969,'in front','in front',0,1,1.2667,'I51653',1),(7970,'in front of','in front of',0,1,1.3667,'I516531',1),(7971,'is built','is built',0,1,1.2667,'I2143',1),(7972,'is built on','is built on',0,1,1.3667,'I21435',1),(7973,'is your','is your',0,1,1.2333,'I260',1),(7974,'is your personal','is your personal',0,1,1.5333,'I2616254',1),(7975,'it all','it all',0,1,1.2,'I340',1),(7976,'it all have','it all have',0,1,1.3667,'I341',1),(7977,'it features','it features',0,1,1.3667,'I31362',1),(7978,'it features twelve','it features twelve',0,1,1.6,'I31362341',1),(7979,'it is your','it is your',0,1,1.3333,'I326',1),(7980,'key','key',0,0,0.2,'K000',1),(7981,'key nullam','key nullam',0,1,1.3333,'K545',1),(7982,'key nullam nibh','key nullam nibh',0,1,1.5,'K5451',1),(7983,'lectus nisl lorem','lectus nisl lorem',0,1,1.5667,'L23252465',3),(7984,'letting','letting',0,0,0.4667,'L352',1),(7985,'letting truth','letting truth',0,1,1.4333,'L352363',1),(7986,'letting truth shine','letting truth shine',0,1,1.6333,'L35236325',1),(7987,'make the difference','make the difference',0,1,1.6333,'M231652',1),(7988,'mission','mission',0,0,0.4667,'M250',1),(7989,'mission statement','mission statement',0,1,1.5667,'M252353',1),(7990,'mission statement to','mission statement to',0,1,1.6667,'M252353',1),(7991,'nibh phasellus','nibh phasellus',0,1,1.4667,'N1242',4),(7992,'nibh phasellus erat','nibh phasellus erat',0,1,1.6333,'N124263',4),(7993,'nisl lorem','nisl lorem',0,1,1.3333,'N2465',3),(7994,'nisl lorem ipsum','nisl lorem ipsum',0,1,1.5333,'N2465125',3),(7995,'of the crowd','of the crowd',0,1,1.4,'O13263',1),(7996,'of the eyes','of the eyes',0,1,1.3667,'O132',1),(7997,'on friendship','on friendship',0,1,1.4333,'O5165321',1),(7998,'others','others',0,0,0.4,'O362',1),(7999,'others it','others it',0,1,1.3,'O3623',1),(8000,'others it is','others it is',0,1,1.4,'O36232',1),(8001,'our business','our business',0,1,1.4,'O61252',1),(8002,'our business is','our business is',0,1,1.5,'O61252',1),(8003,'personal power','personal power',0,1,1.4667,'P625416',1),(8004,'personal power to','personal power to',0,1,1.5667,'P6254163',1),(8005,'plan','plan',0,0,0.2667,'P450',2),(8006,'plan with','plan with',0,1,1.3,'P453',1),(8007,'plan with this','plan with this',0,1,1.4667,'P4532',1),(8008,'power to','power to',0,1,1.2667,'P630',1),(8009,'power to make','power to make',0,1,1.4333,'P6352',1),(8010,'powerpoint','powerpoint',0,0,0.6667,'P6153',1),(8011,'powerpoint it','powerpoint it',0,1,1.4333,'P6153',1),(8012,'powerpoint it features','powerpoint it features',0,1,1.7333,'P61531362',1),(8013,'presentation for','presentation for',0,1,1.5333,'P6253516',1),(8014,'presentation for powerpoint','presentation for powerpoint',0,1,1.9,'P625351616153',1),(8015,'ranging','ranging',0,0,0.4667,'R5252',1),(8016,'ranging from','ranging from',0,1,1.4,'R5252165',1),(8017,'ranging from mission','ranging from mission',0,1,1.6667,'R525216525',1),(8018,'ready','ready',0,0,0.3333,'R300',1),(8019,'ready willing','ready willing',0,1,1.4333,'R3452',1),(8020,'ready willing and','ready willing and',0,1,1.5667,'R345253',1),(8021,'shine','shine',0,0,0.3333,'S500',1),(8022,'shine through','shine through',0,1,1.4333,'S5362',1),(8023,'shine through your','shine through your',0,1,1.6,'S53626',1),(8024,'slides','slides',0,0,0.4,'S432',1),(8025,'slides with','slides with',0,1,1.3667,'S4323',1),(8026,'slides with topics','slides with topics',0,1,1.6,'S432312',1),(8027,'statement','statement',0,0,0.6,'S353',1),(8028,'statement to','statement to',0,1,1.4,'S353',1),(8029,'statement to key','statement to key',0,1,1.5333,'S3532',1),(8030,'the best','the best',0,1,1.2667,'T123',1),(8031,'the best within','the best within',0,1,1.5,'T1235',1),(8032,'the crowd','the crowd',0,1,1.3,'T263',1),(8033,'the crowd lorem','the crowd lorem',0,1,1.5,'T263465',1),(8034,'the difference','the difference',0,1,1.4667,'T1652',1),(8035,'the difference by','the difference by',0,1,1.5667,'T16521',1),(8036,'the eyes','the eyes',0,1,1.2667,'T200',1),(8037,'the eyes of','the eyes of',0,1,1.3667,'T210',1),(8038,'this presentation','this presentation',0,1,1.5667,'T2162535',1),(8039,'this presentation for','this presentation for',0,1,1.7,'T216253516',1),(8040,'through your','through your',0,1,1.4,'T626',1),(8041,'through your words','through your words',0,1,1.6,'T62632',1),(8042,'to accept','to accept',0,1,1.3,'T213',1),(8043,'to accept within','to accept within',0,1,1.5333,'T2135',1),(8044,'to be able','to be able',0,1,1.3333,'T140',1),(8045,'to do','to do',0,1,1.1667,'T000',1),(8046,'to do with','to do with',0,1,1.3333,'T000',1),(8047,'to give','to give',0,1,1.2333,'T210',1),(8048,'to give others','to give others',0,1,1.4667,'T21362',1),(8049,'to key','to key',0,1,1.2,'T200',1),(8050,'to key nullam','to key nullam',0,1,1.4333,'T2545',1),(8051,'to the best','to the best',0,1,1.3667,'T123',1),(8052,'topics','topics',0,0,0.4,'T120',1),(8053,'topics ranging','topics ranging',0,1,1.4667,'T1265252',1),(8054,'topics ranging from','topics ranging from',0,1,1.6333,'T1265252165',1),(8055,'true','true',0,0,0.2667,'T600',1),(8056,'true to','true to',0,1,1.2333,'T630',1),(8057,'true to the','true to the',0,1,1.3667,'T630',1),(8058,'truth','truth',0,0,0.3333,'T630',1),(8059,'truth shine','truth shine',0,1,1.3667,'T6325',1),(8060,'truth shine through','truth shine through',0,1,1.6333,'T6325362',1),(8061,'twelve','twelve',0,0,0.4,'T410',1),(8062,'twelve slides','twelve slides',0,1,1.4333,'T412432',1),(8063,'twelve slides with','twelve slides with',0,1,1.6,'T4124323',1),(8064,'what you are','what you are',0,1,1.4,'W360',1),(8065,'willing','willing',0,0,0.4667,'W452',1),(8066,'willing and','willing and',0,1,1.3667,'W45253',1),(8067,'willing and able','willing and able',0,1,1.5333,'W4525314',1),(8068,'with this','with this',0,1,1.3,'W320',1),(8069,'with this presentation','with this presentation',0,1,1.7333,'W32162535',1),(8070,'with topics','with topics',0,1,1.3667,'W312',1),(8071,'with topics ranging','with topics ranging',0,1,1.6333,'W31265252',1),(8072,'with what','with what',0,1,1.3,'W300',1),(8073,'with what you','with what you',0,1,1.4333,'W300',1),(8074,'within you','within you',0,1,1.3333,'W350',1),(8075,'within you and','within you and',0,1,1.4667,'W353',1),(8076,'within yourself','within yourself',0,1,1.5,'W356241',1),(8077,'within yourself and','within yourself and',0,1,1.6333,'W35624153',1),(8078,'words','words',0,0,0.3333,'W632',1),(8079,'words and','words and',0,1,1.3,'W63253',1),(8080,'words and actions','words and actions',0,1,1.5667,'W632532352',1),(8081,'you and letting','you and letting',0,1,1.5,'Y534352',1),(8082,'you are ready','you are ready',0,1,1.4333,'Y630',1),(8083,'your company\'s','your company',0,1,1.4667,'Y625152',1),(8084,'your company\'s business','your company business',0,1,1.7667,'Y6251521252',1),(8085,'your personal','your personal',0,1,1.4333,'Y616254',1),(8086,'your personal power','your personal power',0,1,1.6333,'Y61625416',1),(8087,'your words','your words',0,1,1.3333,'Y632',1),(8088,'your words and','your words and',0,1,1.4667,'Y63253',1),(8089,'yourself','yourself',0,0,0.5333,'Y6241',1),(8090,'yourself and','yourself and',0,1,1.4,'Y624153',1),(8091,'yourself and in','yourself and in',0,1,1.5,'Y6241535',1),(8092,'yourself in','yourself in',0,1,1.3667,'Y62415',1),(8093,'yourself in front','yourself in front',0,1,1.5667,'Y624151653',1),(8094,'35','35',0,0,0.2,'',1),(8095,'business funding you','business funding you',0,1,1.6667,'B25215352',1),(8096,'financial market','financial market',0,1,1.5333,'F5245623',1),(8097,'funding you','funding you',0,1,1.3667,'F5352',1),(8098,'in financial','in financial',0,1,1.4,'I51524',1),(8099,'in financial market','in financial market',0,1,1.6333,'I515245623',1),(8100,'making process lorem','making process lorem',0,1,1.6667,'M252162465',1),(8101,'process lorem','process lorem',0,1,1.4333,'P62465',1),(8102,'process lorem ipsum','process lorem ipsum',0,1,1.6333,'P62465125',1),(8103,'trusted in','trusted in',0,1,1.3333,'T6235',1),(8104,'trusted in financial','trusted in financial',0,1,1.6667,'T62351524',1),(8105,'36','36',0,0,0.2,'',1),(8106,'equipped','equipped',0,0,0.5333,'E213',1),(8107,'equipped modern','equipped modern',0,1,1.5,'E2135365',1),(8108,'equipped modern workshop','equipped modern workshop',0,1,1.8,'E2135365621',1),(8109,'fully equipped','fully equipped',0,1,1.4667,'F4213',1),(8110,'fully equipped modern','fully equipped modern',0,1,1.7,'F42135365',1),(8111,'modern','modern',0,0,0.4,'M365',1),(8112,'modern workshop','modern workshop',0,1,1.5,'M365621',1),(8113,'37','37',0,0,0.2,'',1),(8114,'a clearly','a clearly',0,1,1.3,'A2464',1),(8115,'a clearly artful','a clearly artful',0,1,1.5333,'A24646314',1),(8116,'a perfect','a perfect',0,1,1.3,'A16123',1),(8117,'a perfect advice','a perfect advice',0,1,1.5333,'A1612312',1),(8118,'a perfect e','a perfect e',0,1,1.3667,'A16123',1),(8119,'able to promote','able to promote',0,1,1.5,'A1431653',1),(8120,'advice regarding','advice regarding',0,1,1.5333,'A312626352',1),(8121,'advice regarding your','advice regarding your',0,1,1.7,'A3126263526',1),(8122,'advisers','advisers',0,0,0.5333,'A31262',1),(8123,'and dedicated e','and dedicated e',0,1,1.5,'A5323',1),(8124,'and seminars','and seminars',0,1,1.4,'A532562',1),(8125,'and seminars in','and seminars in',0,1,1.5,'A5325625',1),(8126,'are being','are being',0,1,1.3,'A6152',1),(8127,'are being introduced','are being introduced',0,1,1.6667,'A6152536323',1),(8128,'as concepts','as concepts',0,1,1.3667,'A252132',1),(8129,'as concepts are','as concepts are',0,1,1.5,'A2521326',1),(8130,'as conferences','as conferences',0,1,1.4667,'A251652',1),(8131,'as conferences effortlessly','as conferences effortlessly',0,1,1.9,'A251652163424',1),(8132,'as this','as this',0,1,1.2333,'A232',1),(8133,'as this is','as this is',0,1,1.3333,'A232',1),(8134,'as to','as to',0,1,1.1667,'A230',1),(8135,'as to get','as to get',0,1,1.3,'A2323',1),(8136,'at www','at www',0,1,1.2,'A300',1),(8137,'at www ebusinessmeetings','at www ebusinessmeetings',0,1,1.8,'A312525352',1),(8138,'be instantly','be instantly',0,1,1.4,'B523534',1),(8139,'be instantly able','be instantly able',0,1,1.5667,'B52353414',1),(8140,'being introduced','being introduced',0,1,1.5333,'B52536323',1),(8141,'being introduced by','being introduced by',0,1,1.6333,'B525363231',1),(8142,'business companies','business companies',0,1,1.6,'B2525152',1),(8143,'business companies worldwide','business companies worldwide',0,1,1.9333,'B2525152643',1),(8144,'business ideas','business ideas',0,1,1.4667,'B25232',1),(8145,'business ideas as','business ideas as',0,1,1.5667,'B25232',1),(8146,'business meeting','business meeting',0,1,1.5333,'B2525352',1),(8147,'business meeting tips','business meeting tips',0,1,1.7,'B2525352312',1),(8148,'business meetings as','business meetings as',0,1,1.6667,'B2525352',1),(8149,'business meetings conferences','business meetings conferences',0,1,1.9667,'B252535251652',1),(8150,'business meetings nulla','business meetings nulla',0,1,1.7667,'B252535254',1),(8151,'business meetings so','business meetings so',0,1,1.6667,'B2525352',1),(8152,'business plan do','business plan do',0,1,1.5333,'B2521453',1),(8153,'by the most','by the most',0,1,1.3667,'B3523',1),(8154,'clearly','clearly',0,0,0.4667,'C464',1),(8155,'clearly artful','clearly artful',0,1,1.4667,'C4646314',1),(8156,'clearly artful and','clearly artful and',0,1,1.6,'C464631453',1),(8157,'companies','companies',0,0,0.6,'C5152',1),(8158,'companies worldwide','companies worldwide',0,1,1.6333,'C5152643',1),(8159,'companies worldwide so','companies worldwide so',0,1,1.7333,'C51526432',1),(8160,'company who','company who',0,1,1.3667,'C515',1),(8161,'company who helps','company who helps',0,1,1.5667,'C515412',1),(8162,'concepts','concepts',0,0,0.5333,'C52132',1),(8163,'concepts are','concepts are',0,1,1.4,'C521326',1),(8164,'concepts are being','concepts are being',0,1,1.6,'C521326152',1),(8165,'conferences','conferences',0,0,0.7333,'C51652',1),(8166,'conferences and','conferences and',0,1,1.5,'C5165253',1),(8167,'conferences and seminars','conferences and seminars',0,1,1.8,'C51652532562',1),(8168,'conferences effortlessly','conferences effortlessly',0,1,1.8,'C51652163424',1),(8169,'conferences effortlessly so','conferences effortlessly so',0,1,1.9,'C516521634242',1),(8170,'contact at','contact at',0,1,1.3333,'C5323',1),(8171,'contact at www','contact at www',0,1,1.4667,'C5323',1),(8172,'contact with','contact with',0,1,1.4,'C5323',1),(8173,'contact with e','contact with e',0,1,1.4667,'C5323',1),(8174,'dedicated e','dedicated e',0,1,1.3667,'D230',1),(8175,'dedicated e business','dedicated e business',0,1,1.6667,'D231252',1),(8176,'dedicated manner it','dedicated manner it',0,1,1.6333,'D23563',1),(8177,'do not get','do not get',0,1,1.3333,'D5323',1),(8178,'do you','do you',0,1,1.2,'D000',1),(8179,'do you have','do you have',0,1,1.3667,'D100',1),(8180,'do you instantly','do you instantly',0,1,1.5333,'D523534',1),(8181,'e business companies','e business companies',0,1,1.6667,'E12525152',1),(8182,'e business conference','e business conference',0,1,1.7,'E125251652',1),(8183,'e business ideas','e business ideas',0,1,1.5333,'E125232',1),(8184,'e business plan','e business plan',0,1,1.5,'E1252145',1),(8185,'ebusinessmeetings','ebusinessmeetings',0,0,1,'E12525352',1),(8186,'ebusinessmeetings net','ebusinessmeetings net',0,1,1.7,'E1252535253',1),(8187,'ebusinessmeetings net as','ebusinessmeetings net as',0,1,1.8,'E12525352532',1),(8188,'effortlessly','effortlessly',0,0,0.8,'E163424',1),(8189,'effortlessly so','effortlessly so',0,1,1.5,'E1634242',1),(8190,'effortlessly so please','effortlessly so please',0,1,1.7333,'E1634242142',1),(8191,'free to contact','free to contact',0,1,1.5,'F6325323',1),(8192,'get a','get a',0,1,1.1667,'G300',1),(8193,'get a perfect','get a perfect',0,1,1.4333,'G316123',1),(8194,'get hesitated','get hesitated',0,1,1.4333,'G323',1),(8195,'get hesitated to','get hesitated to',0,1,1.5333,'G323',1),(8196,'have a','have a',0,1,1.2,'H100',1),(8197,'have a perfect','have a perfect',0,1,1.4667,'H16123',1),(8198,'helps you','helps you',0,1,1.3,'H412',1),(8199,'helps you regarding','helps you regarding',0,1,1.6333,'H412626352',1),(8200,'hesitated','hesitated',0,0,0.6,'H230',1),(8201,'hesitated to','hesitated to',0,1,1.4,'H230',1),(8202,'hesitated to contact','hesitated to contact',0,1,1.6667,'H2325323',1),(8203,'ideas','ideas',0,0,0.3333,'I320',1),(8204,'ideas as','ideas as',0,1,1.2667,'I320',1),(8205,'ideas as well','ideas as well',0,1,1.4333,'I324',1),(8206,'if','if',0,0,0.1333,'I100',1),(8207,'if yes','if yes',0,1,1.2,'I120',1),(8208,'if yes then','if yes then',0,1,1.3667,'I1235',1),(8209,'in a clearly','in a clearly',0,1,1.4,'I52464',1),(8210,'instantly','instantly',0,0,0.6,'I523534',1),(8211,'instantly able','instantly able',0,1,1.4667,'I52353414',1),(8212,'instantly able to','instantly able to',0,1,1.5667,'I523534143',1),(8213,'instantly want','instantly want',0,1,1.4667,'I52353453',1),(8214,'instantly want to','instantly want to',0,1,1.5667,'I52353453',1),(8215,'introduced','introduced',0,0,0.6667,'I536323',1),(8216,'introduced by','introduced by',0,1,1.4333,'I5363231',1),(8217,'introduced by the','introduced by the',0,1,1.5667,'I53632313',1),(8218,'is yours','is yours',0,1,1.2667,'I262',1),(8219,'is yours own','is yours own',0,1,1.4,'I2625',1),(8220,'it provides you','it provides you',0,1,1.5,'I316132',1),(8221,'latest e','latest e',0,1,1.2667,'L323',1),(8222,'latest e business','latest e business',0,1,1.5667,'L3231252',1),(8223,'manner it','manner it',0,1,1.3,'M630',1),(8224,'manner it provides','manner it provides',0,1,1.6,'M6316132',1),(8225,'meeting','meeting',0,0,0.4667,'M352',1),(8226,'meeting tips','meeting tips',0,1,1.4,'M352312',1),(8227,'meeting tips through','meeting tips through',0,1,1.6667,'M352312362',1),(8228,'meetings as','meetings as',0,1,1.3667,'M352',1),(8229,'meetings as well','meetings as well',0,1,1.5333,'M3524',1),(8230,'meetings conferences','meetings conferences',0,1,1.6667,'M35251652',1),(8231,'meetings conferences and','meetings conferences and',0,1,1.8,'M3525165253',1),(8232,'meetings nulla','meetings nulla',0,1,1.4667,'M35254',1),(8233,'meetings nulla at','meetings nulla at',0,1,1.5667,'M352543',1),(8234,'meetings so','meetings so',0,1,1.3667,'M352',1),(8235,'meetings so as','meetings so as',0,1,1.4667,'M352',1),(8236,'most professional','most professional',0,1,1.5667,'M23161254',1),(8237,'most professional and','most professional and',0,1,1.7,'M2316125453',1),(8238,'net','net',0,0,0.2,'N300',1),(8239,'net as','net as',0,1,1.2,'N320',1),(8240,'net as this','net as this',0,1,1.3667,'N3232',1),(8241,'non tortor lorem','non tortor lorem',0,1,1.5333,'N3636465',1),(8242,'not get','not get',0,1,1.2333,'N323',1),(8243,'not get hesitated','not get hesitated',0,1,1.5667,'N32323',1),(8244,'own business meetings','own business meetings',0,1,1.7,'O512525352',1),(8245,'own company','own company',0,1,1.3667,'O52515',1),(8246,'own company who','own company who',0,1,1.5,'O52515',1),(8247,'perfect','perfect',0,0,0.4667,'P6123',1),(8248,'perfect advice','perfect advice',0,1,1.4667,'P612312',1),(8249,'perfect advice regarding','perfect advice regarding',0,1,1.8,'P612312626352',1),(8250,'perfect e','perfect e',0,1,1.3,'P6123',1),(8251,'perfect e business','perfect e business',0,1,1.6,'P61231252',1),(8252,'plan do','plan do',0,1,1.2333,'P453',1),(8253,'plan do you','plan do you',0,1,1.3667,'P453',1),(8254,'please do','please do',0,1,1.3,'P423',1),(8255,'please do not','please do not',0,1,1.4333,'P42353',1),(8256,'please feel','please feel',0,1,1.3667,'P4214',1),(8257,'please feel free','please feel free',0,1,1.5333,'P421416',1),(8258,'professional advisers','professional advisers',0,1,1.7,'P6125431262',1),(8259,'professional and','professional and',0,1,1.5333,'P6125453',1),(8260,'professional and dedicated','professional and dedicated',0,1,1.8667,'P612545323',1),(8261,'promote','promote',0,0,0.4667,'P653',1),(8262,'promote your','promote your',0,1,1.4,'P6536',1),(8263,'promote your e','promote your e',0,1,1.4667,'P6536',1),(8264,'promote your own','promote your own',0,1,1.5333,'P65365',1),(8265,'provides you','provides you',0,1,1.4,'P6132',1),(8266,'provides you the','provides you the',0,1,1.5333,'P61323',1),(8267,'regarding','regarding',0,0,0.6,'R26352',1),(8268,'regarding your','regarding your',0,1,1.4667,'R263526',1),(8269,'regarding your e','regarding your e',0,1,1.5333,'R263526',1),(8270,'regarding your own','regarding your own',0,1,1.6,'R2635265',1),(8271,'seminars','seminars',0,0,0.5333,'S562',1),(8272,'seminars in','seminars in',0,1,1.3667,'S5625',1),(8273,'seminars in a','seminars in a',0,1,1.4333,'S5625',1),(8274,'smart','smart',0,0,0.3333,'S563',1),(8275,'smart business','smart business',0,1,1.4667,'S5631252',1),(8276,'smart business meeting','smart business meeting',0,1,1.7333,'S56312525352',1),(8277,'so as','so as',0,1,1.1667,'S000',1),(8278,'so as to','so as to',0,1,1.2667,'S300',1),(8279,'so do','so do',0,1,1.1667,'S300',1),(8280,'so do you','so do you',0,1,1.3,'S300',1),(8281,'so please','so please',0,1,1.3,'S142',1),(8282,'so please do','so please do',0,1,1.4,'S1423',1),(8283,'the most','the most',0,1,1.2667,'T523',1),(8284,'the most professional','the most professional',0,1,1.7,'T523161254',1),(8285,'the smart','the smart',0,1,1.3,'T2563',1),(8286,'the smart business','the smart business',0,1,1.6,'T25631252',1),(8287,'then','then',0,0,0.2667,'T500',1),(8288,'then please','then please',0,1,1.3667,'T5142',1),(8289,'then please feel','then please feel',0,1,1.5333,'T514214',1),(8290,'this is yours','this is yours',0,1,1.4333,'T262',1),(8291,'through which','through which',0,1,1.4333,'T620',1),(8292,'through which you','through which you',0,1,1.5667,'T620',1),(8293,'tips through','tips through',0,1,1.4,'T12362',1),(8294,'tips through which','tips through which',0,1,1.6,'T12362',1),(8295,'to contact','to contact',0,1,1.3333,'T25323',1),(8296,'to contact at','to contact at',0,1,1.4333,'T25323',1),(8297,'to contact with','to contact with',0,1,1.5,'T25323',1),(8298,'to get a','to get a',0,1,1.2667,'T230',1),(8299,'to promote','to promote',0,1,1.3333,'T1653',1),(8300,'to promote your','to promote your',0,1,1.5,'T16536',1),(8301,'top','top',0,0,0.2,'T100',1),(8302,'top professional','top professional',0,1,1.5333,'T161254',1),(8303,'top professional advisers','top professional advisers',0,1,1.8333,'T16125431262',1),(8304,'tortor lorem','tortor lorem',0,1,1.4,'T636465',1),(8305,'tortor lorem ipsum','tortor lorem ipsum',0,1,1.6,'T636465125',1),(8306,'want','want',0,0,0.2667,'W530',1),(8307,'want to','want to',0,1,1.2333,'W530',1),(8308,'want to promote','want to promote',0,1,1.5,'W531653',1),(8309,'well as concepts','well as concepts',0,1,1.5333,'W4252132',1),(8310,'well as conferences','well as conferences',0,1,1.6333,'W4251652',1),(8311,'which you','which you',0,1,1.3,'W200',1),(8312,'which you would','which you would',0,1,1.5,'W243',1),(8313,'who helps','who helps',0,1,1.3,'W412',1),(8314,'who helps you','who helps you',0,1,1.4333,'W412',1),(8315,'with e','with e',0,1,1.2,'W300',1),(8316,'with e business','with e business',0,1,1.5,'W31252',1),(8317,'worldwide so','worldwide so',0,1,1.4,'W6432',1),(8318,'worldwide so do','worldwide so do',0,1,1.5,'W64323',1),(8319,'would','would',0,0,0.3333,'W430',1),(8320,'would be','would be',0,1,1.2667,'W431',1),(8321,'would be instantly','would be instantly',0,1,1.6,'W431523534',1),(8322,'www ebusinessmeetings','www ebusinessmeetings',0,1,1.7,'W12525352',1),(8323,'www ebusinessmeetings net','www ebusinessmeetings net',0,1,1.8333,'W1252535253',1),(8324,'yes','yes',0,0,0.2,'Y200',1),(8325,'yes then','yes then',0,1,1.2667,'Y235',1),(8326,'yes then please','yes then please',0,1,1.5,'Y235142',1),(8327,'you have a','you have a',0,1,1.3333,'Y100',1),(8328,'you instantly','you instantly',0,1,1.4333,'Y523534',1),(8329,'you instantly want','you instantly want',0,1,1.6,'Y52353453',1),(8330,'you regarding','you regarding',0,1,1.4333,'Y626352',1),(8331,'you regarding your','you regarding your',0,1,1.6,'Y6263526',1),(8332,'you the','you the',0,1,1.2333,'Y300',1),(8333,'you the smart','you the smart',0,1,1.4333,'Y32563',1),(8334,'you would','you would',0,1,1.3,'Y430',1),(8335,'you would be','you would be',0,1,1.4,'Y431',1),(8336,'your e','your e',0,1,1.2,'Y600',1),(8337,'your e business','your e business',0,1,1.5,'Y61252',1),(8338,'yours','yours',0,0,0.3333,'Y620',1),(8339,'yours own','yours own',0,1,1.3,'Y625',1),(8340,'yours own company','yours own company',0,1,1.5667,'Y6252515',1),(8341,'38','38',0,0,0.2,'',1),(8342,'a dictum','a dictum',0,1,1.2667,'A3235',1),(8343,'a dictum vulputate','a dictum vulputate',0,1,1.6,'A32351413',1),(8344,'a ligula','a ligula',0,1,1.2667,'A424',1),(8345,'a ligula nulla','a ligula nulla',0,1,1.4667,'A42454',1),(8346,'a lorem ligula','a lorem ligula',0,1,1.4667,'A465424',1),(8347,'a nulla','a nulla',0,1,1.2333,'A540',1),(8348,'a nulla quis','a nulla quis',0,1,1.4,'A542',1),(8349,'a porttitor eu','a porttitor eu',0,1,1.4667,'A1636',1),(8350,'ac condimentum','ac condimentum',0,1,1.4667,'A253535',1),(8351,'ac condimentum leo','ac condimentum leo',0,1,1.6,'A2535354',1),(8352,'ac faucibus','ac faucibus',0,1,1.3667,'A21212',1),(8353,'ac faucibus sed','ac faucibus sed',0,1,1.5,'A212123',1),(8354,'ac sodales','ac sodales',0,1,1.3333,'A2342',1),(8355,'ac sodales augue','ac sodales augue',0,1,1.5333,'A2342',1),(8356,'ac turpis','ac turpis',0,1,1.3,'A23612',1),(8357,'ac turpis egestas','ac turpis egestas',0,1,1.5667,'A2361232',1),(8358,'adipiscing auctor','adipiscing auctor',0,1,1.5667,'A3125236',1),(8359,'adipiscing auctor sed','adipiscing auctor sed',0,1,1.7,'A312523623',1),(8360,'adipiscing elit aliquam','adipiscing elit aliquam',0,1,1.7667,'A3125243425',1),(8361,'adipiscing elit proin','adipiscing elit proin',0,1,1.7,'A3125243165',1),(8362,'aenean et','aenean et',0,1,1.3,'A530',1),(8363,'aenean et erat','aenean et erat',0,1,1.4667,'A5363',1),(8364,'aliquam ac','aliquam ac',0,1,1.3333,'A4252',1),(8365,'aliquam ac condimentum','aliquam ac condimentum',0,1,1.7333,'A425253535',1),(8366,'aliquam erat','aliquam erat',0,1,1.4,'A42563',1),(8367,'aliquam erat volutpat','aliquam erat volutpat',0,1,1.7,'A4256314313',1),(8368,'aliquam mi','aliquam mi',0,1,1.3333,'A425',1),(8369,'aliquam mi dui','aliquam mi dui',0,1,1.4667,'A4253',1),(8370,'amet elementum et','amet elementum et',0,1,1.5667,'A5345353',1),(8371,'amet mi','amet mi',0,1,1.2333,'A535',1),(8372,'amet mi quisque','amet mi quisque',0,1,1.5,'A5352',1),(8373,'amet nisi','amet nisi',0,1,1.3,'A5352',1),(8374,'amet nisi felis','amet nisi felis',0,1,1.5,'A5352142',1),(8375,'amet sit','amet sit',0,1,1.2667,'A5323',1),(8376,'amet sit amet','amet sit amet',0,1,1.4333,'A532353',1),(8377,'ante et','ante et',0,1,1.2333,'A530',1),(8378,'ante et tellus','ante et tellus',0,1,1.4667,'A5342',1),(8379,'arcu et egestas','arcu et egestas',0,1,1.5,'A623232',1),(8380,'arcu sapien','arcu sapien',0,1,1.3667,'A6215',1),(8381,'arcu sapien pulvinar','arcu sapien pulvinar',0,1,1.6667,'A621514156',1),(8382,'auctor sed','auctor sed',0,1,1.3333,'A23623',1),(8383,'auctor sed tellus','auctor sed tellus',0,1,1.5667,'A2362342',1),(8384,'augue eget','augue eget',0,1,1.3333,'A230',1),(8385,'augue eget velit','augue eget velit',0,1,1.5333,'A23143',1),(8386,'augue lorem','augue lorem',0,1,1.3667,'A2465',1),(8387,'augue lorem ipsum','augue lorem ipsum',0,1,1.5667,'A2465125',1),(8388,'augue magna','augue magna',0,1,1.3667,'A2525',1),(8389,'augue magna id','augue magna id',0,1,1.4667,'A25253',1),(8390,'augue pellentesque habitant','augue pellentesque habitant',0,1,1.9,'A2145321353',1),(8391,'break','break',0,0,0.3333,'B620',1),(8392,'condimentum a','condimentum a',0,1,1.4333,'C53535',1),(8393,'condimentum a porttitor','condimentum a porttitor',0,1,1.7667,'C535351636',1),(8394,'condimentum eget','condimentum eget',0,1,1.5333,'C5353523',1),(8395,'condimentum eget tristique','condimentum eget tristique',0,1,1.8667,'C53535236232',1),(8396,'condimentum leo','condimentum leo',0,1,1.5,'C535354',1),(8397,'condimentum leo laoreet','condimentum leo laoreet',0,1,1.7667,'C53535463',1),(8398,'convallis nec pharetra','convallis nec pharetra',0,1,1.7333,'C5142521636',1),(8399,'curabitur pretium','curabitur pretium',0,1,1.5667,'C61361635',1),(8400,'curabitur pretium porta','curabitur pretium porta',0,1,1.7667,'C61361635163',1),(8401,'cursus venenatis','cursus venenatis',0,1,1.5333,'C621532',1),(8402,'cursus venenatis dictum','cursus venenatis dictum',0,1,1.7667,'C6215323235',1),(8403,'cursus vitae','cursus vitae',0,1,1.4,'C6213',1),(8404,'cursus vitae sollicitudin','cursus vitae sollicitudin',0,1,1.8333,'C621324235',1),(8405,'dapibus malesuada','dapibus malesuada',0,1,1.5667,'D125423',1),(8406,'dapibus malesuada integer','dapibus malesuada integer',0,1,1.8333,'D1254235326',1),(8407,'diam faucibus','diam faucibus',0,1,1.4333,'D51212',1),(8408,'diam faucibus nunc','diam faucibus nunc',0,1,1.6,'D5121252',1),(8409,'diam in','diam in',0,1,1.2333,'D500',1),(8410,'diam in leo','diam in leo',0,1,1.3667,'D540',1),(8411,'diam quis','diam quis',0,1,1.3,'D520',1),(8412,'diam quis porta','diam quis porta',0,1,1.5,'D52163',1),(8413,'dictum arcu','dictum arcu',0,1,1.3667,'D23562',1),(8414,'dictum arcu sapien','dictum arcu sapien',0,1,1.6,'D2356215',1),(8415,'dictum morbi','dictum morbi',0,1,1.4,'D23561',1),(8416,'dictum morbi massa','dictum morbi massa',0,1,1.6,'D2356152',1),(8417,'dictum vulputate','dictum vulputate',0,1,1.5333,'D2351413',1),(8418,'dictum vulputate dui','dictum vulputate dui',0,1,1.6667,'D2351413',1),(8419,'donec feugiat','donec feugiat',0,1,1.4333,'D52123',1),(8420,'donec feugiat turpis','donec feugiat turpis',0,1,1.6667,'D52123612',1),(8421,'donec libero','donec libero',0,1,1.4,'D52416',1),(8422,'donec libero urna','donec libero urna',0,1,1.5667,'D524165',1),(8423,'donec sit','donec sit',0,1,1.3,'D523',1),(8424,'donec sit amet','donec sit amet',0,1,1.4667,'D52353',1),(8425,'dui diam','dui diam',0,1,1.2667,'D500',1),(8426,'dui diam faucibus','dui diam faucibus',0,1,1.5667,'D51212',1),(8427,'dui eu','dui eu',0,1,1.2,'D000',1),(8428,'dui eu leo','dui eu leo',0,1,1.3333,'D400',1),(8429,'duis a','duis a',0,1,1.2,'D200',1),(8430,'duis a nulla','duis a nulla',0,1,1.4,'D254',1),(8431,'egestas donec','egestas donec',0,1,1.4333,'E232352',1),(8432,'egestas donec sit','egestas donec sit',0,1,1.5667,'E2323523',1),(8433,'egestas fermentum','egestas fermentum',0,1,1.5667,'E23216535',1),(8434,'egestas fermentum enim','egestas fermentum enim',0,1,1.7333,'E23216535',1),(8435,'egestas non','egestas non',0,1,1.3667,'E2325',1),(8436,'egestas non tempus','egestas non tempus',0,1,1.6,'E23253512',1),(8437,'eget diam','eget diam',0,1,1.3,'E235',1),(8438,'eget diam in','eget diam in',0,1,1.4,'E235',1),(8439,'eget tristique','eget tristique',0,1,1.4667,'E236232',1),(8440,'eget tristique ac','eget tristique ac',0,1,1.5667,'E236232',1),(8441,'eget velit convallis','eget velit convallis',0,1,1.6667,'E2314325142',1),(8442,'eleifend vel','eleifend vel',0,1,1.4,'E415314',1),(8443,'eleifend vel lobortis','eleifend vel lobortis',0,1,1.7,'E4153141632',1),(8444,'elementum et','elementum et',0,1,1.4,'E45353',1),(8445,'elementum et massa','elementum et massa',0,1,1.6,'E4535352',1),(8446,'elit aliquam','elit aliquam',0,1,1.4,'E43425',1),(8447,'elit aliquam ac','elit aliquam ac',0,1,1.5,'E434252',1),(8448,'elit aliquam erat','elit aliquam erat',0,1,1.5667,'E4342563',1),(8449,'elit proin','elit proin',0,1,1.3333,'E43165',1),(8450,'elit proin posuere','elit proin posuere',0,1,1.6,'E43165126',1),(8451,'enim aenean','enim aenean',0,1,1.3667,'E500',1),(8452,'enim aenean et','enim aenean et',0,1,1.4667,'E530',1),(8453,'enim purus','enim purus',0,1,1.3333,'E5162',1),(8454,'enim purus fermentum','enim purus fermentum',0,1,1.6667,'E516216535',1),(8455,'erat nec','erat nec',0,1,1.2667,'E6352',1),(8456,'erat nec lectus','erat nec lectus',0,1,1.5,'E63524232',1),(8457,'erat volutpat','erat volutpat',0,1,1.4333,'E6314313',1),(8458,'erat volutpat lorem','erat volutpat lorem',0,1,1.6333,'E6314313465',1),(8459,'eros tincidunt','eros tincidunt',0,1,1.4667,'E62352353',1),(8460,'eros tincidunt maecenas','eros tincidunt maecenas',0,1,1.7667,'E623523535252',1),(8461,'est quisque','est quisque',0,1,1.3667,'E232',1),(8462,'est quisque magna','est quisque magna',0,1,1.5667,'E232525',1),(8463,'est sollicitudin','est sollicitudin',0,1,1.5333,'E2324235',1),(8464,'est sollicitudin nulla','est sollicitudin nulla',0,1,1.7333,'E23242354',1),(8465,'est ultricies','est ultricies',0,1,1.4333,'E234362',1),(8466,'est ultricies ut','est ultricies ut',0,1,1.5333,'E2343623',1),(8467,'et egestas','et egestas',0,1,1.3333,'E3232',1),(8468,'et egestas fermentum','et egestas fermentum',0,1,1.6667,'E323216535',1),(8469,'et erat','et erat',0,1,1.2333,'E363',1),(8470,'et erat nec','et erat nec',0,1,1.3667,'E36352',1),(8471,'et laoreet','et laoreet',0,1,1.3333,'E3463',1),(8472,'et laoreet dictum','et laoreet dictum',0,1,1.5667,'E3463235',1),(8473,'et lorem','et lorem',0,1,1.2667,'E3465',1),(8474,'et lorem id','et lorem id',0,1,1.3667,'E34653',1),(8475,'et malesuada','et malesuada',0,1,1.4,'E35423',1),(8476,'et malesuada fames','et malesuada fames',0,1,1.6,'E35423152',1),(8477,'et massa','et massa',0,1,1.2667,'E352',1),(8478,'et massa donec','et massa donec',0,1,1.4667,'E352352',1),(8479,'et netus','et netus',0,1,1.2667,'E3532',1),(8480,'et netus et','et netus et',0,1,1.3667,'E35323',1),(8481,'et tellus','et tellus',0,1,1.3,'E342',1),(8482,'et tellus morbi','et tellus morbi',0,1,1.5,'E342561',1),(8483,'et tortor','et tortor',0,1,1.3,'E3636',1),(8484,'et tortor libero','et tortor libero',0,1,1.5333,'E3636416',1),(8485,'eu fermentum','eu fermentum',0,1,1.4,'E16535',1),(8486,'eu fermentum nec','eu fermentum nec',0,1,1.5333,'E165352',1),(8487,'eu leo nullam','eu leo nullam',0,1,1.4333,'E4545',1),(8488,'eu sagittis','eu sagittis',0,1,1.3667,'E232',1),(8489,'eu sagittis lacus','eu sagittis lacus',0,1,1.5667,'E23242',1),(8490,'facilisi','facilisi',0,0,0.5333,'F242',1),(8491,'facilisi pellentesque','facilisi pellentesque',0,1,1.7,'F24214532',1),(8492,'facilisi pellentesque tempus','facilisi pellentesque tempus',0,1,1.9333,'F242145323512',1),(8493,'fames','fames',0,0,0.3333,'F520',1),(8494,'fames ac','fames ac',0,1,1.2667,'F520',1),(8495,'fames ac turpis','fames ac turpis',0,1,1.5,'F523612',1),(8496,'faucibus nunc','faucibus nunc',0,1,1.4333,'F21252',1),(8497,'faucibus nunc ac','faucibus nunc ac',0,1,1.5333,'F21252',1),(8498,'faucibus nunc id','faucibus nunc id',0,1,1.5333,'F212523',1),(8499,'faucibus sed','faucibus sed',0,1,1.4,'F2123',1),(8500,'faucibus sed nisi','faucibus sed nisi',0,1,1.5667,'F212352',1),(8501,'felis morbi','felis morbi',0,1,1.3667,'F42561',1),(8502,'felis morbi faucibus','felis morbi faucibus',0,1,1.6667,'F42561212',1),(8503,'fermentum diam','fermentum diam',0,1,1.4667,'F653535',1),(8504,'fermentum diam quis','fermentum diam quis',0,1,1.6333,'F6535352',1),(8505,'fermentum enim','fermentum enim',0,1,1.4667,'F6535',1),(8506,'fermentum enim purus','fermentum enim purus',0,1,1.6667,'F6535162',1),(8507,'fermentum molestie','fermentum molestie',0,1,1.6,'F6535423',1),(8508,'fermentum molestie sit','fermentum molestie sit',0,1,1.7333,'F653542323',1),(8509,'fermentum nec','fermentum nec',0,1,1.4333,'F65352',1),(8510,'fermentum nec enim','fermentum nec enim',0,1,1.6,'F653525',1),(8511,'feugiat turpis','feugiat turpis',0,1,1.4667,'F23612',1),(8512,'feugiat turpis a','feugiat turpis a',0,1,1.5333,'F23612',1),(8513,'gravida laoreet','gravida laoreet',0,1,1.5,'G613463',1),(8514,'gravida laoreet in','gravida laoreet in',0,1,1.6,'G6134635',1),(8515,'habitant','habitant',0,0,0.5333,'H1353',1),(8516,'habitant morbi','habitant morbi',0,1,1.4667,'H1353561',1),(8517,'habitant morbi tristique','habitant morbi tristique',0,1,1.8,'H135356136232',1),(8518,'hendrerit vitae','hendrerit vitae',0,1,1.5,'H536313',1),(8519,'hendrerit vitae tellus','hendrerit vitae tellus',0,1,1.7333,'H53631342',1),(8520,'id augue','id augue',0,1,1.2667,'I320',1),(8521,'id augue pellentesque','id augue pellentesque',0,1,1.7,'I3214532',1),(8522,'id elit aliquam','id elit aliquam',0,1,1.5,'I343425',1),(8523,'id libero fermentum','id libero fermentum',0,1,1.6333,'I341616535',1),(8524,'in aliquam','in aliquam',0,1,1.3333,'I5425',1),(8525,'in aliquam mi','in aliquam mi',0,1,1.4333,'I5425',1),(8526,'in eget','in eget',0,1,1.2333,'I523',1),(8527,'in eget diam','in eget diam',0,1,1.4,'I5235',1),(8528,'in leo','in leo',0,1,1.2,'I540',1),(8529,'in leo nisl','in leo nisl',0,1,1.3667,'I54524',1),(8530,'in lobortis','in lobortis',0,1,1.3667,'I541632',1),(8531,'in lobortis ligula','in lobortis ligula',0,1,1.6,'I541632424',1),(8532,'in sagittis','in sagittis',0,1,1.3667,'I5232',1),(8533,'in sagittis pellentesque','in sagittis pellentesque',0,1,1.8,'I523214532',1),(8534,'in tincidunt augue','in tincidunt augue',0,1,1.6,'I53523532',1),(8535,'in tincidunt dapibus','in tincidunt dapibus',0,1,1.6667,'I535235312',1),(8536,'integer a','integer a',0,1,1.3,'I5326',1),(8537,'integer a lorem','integer a lorem',0,1,1.5,'I5326465',1),(8538,'integer cursus','integer cursus',0,1,1.4667,'I5326262',1),(8539,'integer cursus venenatis','integer cursus venenatis',0,1,1.8,'I53262621532',1),(8540,'lacinia tristique','lacinia tristique',0,1,1.5667,'L2536232',1),(8541,'lacinia tristique donec','lacinia tristique donec',0,1,1.7667,'L2536232352',1),(8542,'lacus ante','lacus ante',0,1,1.3333,'L253',1),(8543,'lacus ante et','lacus ante et',0,1,1.4333,'L253',1),(8544,'laoreet dictum','laoreet dictum',0,1,1.4667,'L63235',1),(8545,'laoreet dictum arcu','laoreet dictum arcu',0,1,1.6333,'L6323562',1),(8546,'laoreet in','laoreet in',0,1,1.3333,'L635',1),(8547,'laoreet in lobortis','laoreet in lobortis',0,1,1.6333,'L63541632',1),(8548,'laoreet sed','laoreet sed',0,1,1.3667,'L6323',1),(8549,'laoreet sed nec','laoreet sed nec',0,1,1.5,'L632352',1),(8550,'lectus adipiscing','lectus adipiscing',0,1,1.5667,'L23231252',1),(8551,'lectus adipiscing auctor','lectus adipiscing auctor',0,1,1.8,'L2323125236',1),(8552,'lectus ut odio','lectus ut odio',0,1,1.4667,'L2323',1),(8553,'leo laoreet','leo laoreet',0,1,1.3667,'L630',1),(8554,'leo laoreet sed','leo laoreet sed',0,1,1.5,'L6323',1),(8555,'leo nisl','leo nisl',0,1,1.2667,'L524',1),(8556,'leo nisl eleifend','leo nisl eleifend',0,1,1.5667,'L524153',1),(8557,'leo nullam','leo nullam',0,1,1.3333,'L545',1),(8558,'leo nullam posuere','leo nullam posuere',0,1,1.6,'L545126',1),(8559,'libero fermentum molestie','libero fermentum molestie',0,1,1.8333,'L1616535423',1),(8560,'libero urna','libero urna',0,1,1.3667,'L165',1),(8561,'libero urna cursus','libero urna cursus',0,1,1.6,'L165262',1),(8562,'libero vel','libero vel',0,1,1.3333,'L1614',1),(8563,'libero vel malesuada','libero vel malesuada',0,1,1.6667,'L16145423',1),(8564,'ligula in','ligula in',0,1,1.3,'L245',1),(8565,'ligula in sagittis','ligula in sagittis',0,1,1.6,'L245232',1),(8566,'ligula in tincidunt','ligula in tincidunt',0,1,1.6333,'L245352353',1),(8567,'ligula nulla','ligula nulla',0,1,1.4,'L2454',1),(8568,'ligula nulla placerat','ligula nulla placerat',0,1,1.7,'L245414263',1),(8569,'lobortis ligula','lobortis ligula',0,1,1.5,'L1632424',1),(8570,'lobortis ligula in','lobortis ligula in',0,1,1.6,'L16324245',1),(8571,'lobortis vel tincidunt','lobortis vel tincidunt',0,1,1.7333,'L163214352353',1),(8572,'lorem id','lorem id',0,1,1.2667,'L653',1),(8573,'lorem id libero','lorem id libero',0,1,1.5,'L653416',1),(8574,'lorem ligula','lorem ligula',0,1,1.4,'L65424',1),(8575,'lorem ligula in','lorem ligula in',0,1,1.5,'L654245',1),(8576,'maecenas et','maecenas et',0,1,1.3667,'M2523',1),(8577,'maecenas et tortor','maecenas et tortor',0,1,1.6,'M2523636',1),(8578,'magna id','magna id',0,1,1.2667,'M253',1),(8579,'magna id augue','magna id augue',0,1,1.4667,'M2532',1),(8580,'magna tellus','magna tellus',0,1,1.4,'M25342',1),(8581,'magna tellus condimentum','magna tellus condimentum',0,1,1.8,'M2534253535',1),(8582,'magna venenatis','magna venenatis',0,1,1.5,'M251532',1),(8583,'magna venenatis neque','magna venenatis neque',0,1,1.7,'M25153252',1),(8584,'malesuada est','malesuada est',0,1,1.4333,'M42323',1),(8585,'malesuada est quisque','malesuada est quisque',0,1,1.7,'M423232',1),(8586,'malesuada fames','malesuada fames',0,1,1.5,'M423152',1),(8587,'malesuada fames ac','malesuada fames ac',0,1,1.6,'M423152',1),(8588,'malesuada integer','malesuada integer',0,1,1.5667,'M4235326',1),(8589,'malesuada integer a','malesuada integer a',0,1,1.6333,'M4235326',1),(8590,'massa donec','massa donec',0,1,1.3667,'M2352',1),(8591,'massa donec feugiat','massa donec feugiat',0,1,1.6333,'M2352123',1),(8592,'massa est','massa est',0,1,1.3,'M230',1),(8593,'massa est ultricies','massa est ultricies',0,1,1.6333,'M234362',1),(8594,'mattis volutpat','mattis volutpat',0,1,1.5,'M3214313',1),(8595,'mattis volutpat in','mattis volutpat in',0,1,1.6,'M32143135',1),(8596,'mauris lectus','mauris lectus',0,1,1.4333,'M624232',1),(8597,'mauris lectus ut','mauris lectus ut',0,1,1.5333,'M6242323',1),(8598,'mi dui','mi dui',0,1,1.2,'M300',1),(8599,'mi dui eu','mi dui eu',0,1,1.3,'M300',1),(8600,'mi quisque','mi quisque',0,1,1.3333,'M200',1),(8601,'mi quisque ultrices','mi quisque ultrices',0,1,1.6333,'M24362',1),(8602,'molestie sit','molestie sit',0,1,1.4,'M42323',1),(8603,'molestie sit amet','molestie sit amet',0,1,1.5667,'M4232353',1),(8604,'morbi faucibus','morbi faucibus',0,1,1.4667,'M61212',1),(8605,'morbi faucibus nunc','morbi faucibus nunc',0,1,1.6333,'M6121252',1),(8606,'morbi massa','morbi massa',0,1,1.3667,'M6152',1),(8607,'morbi massa est','morbi massa est',0,1,1.5,'M61523',1),(8608,'morbi tristique','morbi tristique',0,1,1.5,'M6136232',1),(8609,'morbi tristique senectus','morbi tristique senectus',0,1,1.8,'M61362325232',1),(8610,'morbi vel','morbi vel',0,1,1.3,'M614',1),(8611,'morbi vel semper','morbi vel semper',0,1,1.5333,'M6142516',1),(8612,'nec enim aenean','nec enim aenean',0,1,1.5,'N250',1),(8613,'nec lectus','nec lectus',0,1,1.3333,'N24232',1),(8614,'nec lectus adipiscing','nec lectus adipiscing',0,1,1.7,'N2423231252',1),(8615,'nec pharetra','nec pharetra',0,1,1.4,'N21636',1),(8616,'nec pharetra eros','nec pharetra eros',0,1,1.5667,'N216362',1),(8617,'nec risus sed','nec risus sed',0,1,1.4333,'N2623',1),(8618,'neque et','neque et',0,1,1.2667,'N230',1),(8619,'neque et laoreet','neque et laoreet',0,1,1.5333,'N23463',1),(8620,'neque eu','neque eu',0,1,1.2667,'N200',1),(8621,'neque eu sagittis','neque eu sagittis',0,1,1.5667,'N232',1),(8622,'netus','netus',0,0,0.3333,'N320',1),(8623,'netus et','netus et',0,1,1.2667,'N323',1),(8624,'netus et malesuada','netus et malesuada',0,1,1.6,'N3235423',1),(8625,'nisi curabitur pretium','nisi curabitur pretium',0,1,1.7333,'N261361635',1),(8626,'nisi felis','nisi felis',0,1,1.3333,'N2142',1),(8627,'nisi felis morbi','nisi felis morbi',0,1,1.5333,'N2142561',1),(8628,'nisi quis','nisi quis',0,1,1.3,'N200',1),(8629,'nisi quis odio','nisi quis odio',0,1,1.4667,'N230',1),(8630,'nisl eleifend','nisl eleifend',0,1,1.4333,'N24153',1),(8631,'nisl eleifend vel','nisl eleifend vel',0,1,1.5667,'N2415314',1),(8632,'non tempus','non tempus',0,1,1.3333,'N3512',1),(8633,'non tempus est','non tempus est',0,1,1.4667,'N35123',1),(8634,'nulla facilisi','nulla facilisi',0,1,1.4667,'N41242',1),(8635,'nulla facilisi pellentesque','nulla facilisi pellentesque',0,1,1.9,'N4124214532',1),(8636,'nulla mattis','nulla mattis',0,1,1.4,'N4532',1),(8637,'nulla mattis volutpat','nulla mattis volutpat',0,1,1.7,'N453214313',1),(8638,'nulla placerat','nulla placerat',0,1,1.4667,'N414263',1),(8639,'nulla placerat gravida','nulla placerat gravida',0,1,1.7333,'N4142632613',1),(8640,'nulla quis','nulla quis',0,1,1.3333,'N420',1),(8641,'nulla quis tellus','nulla quis tellus',0,1,1.5667,'N42342',1),(8642,'nulla sed tempor','nulla sed tempor',0,1,1.5333,'N423516',1),(8643,'nullam posuere','nullam posuere',0,1,1.4667,'N45126',1),(8644,'nullam posuere arcu','nullam posuere arcu',0,1,1.6333,'N451262',1),(8645,'nunc ac','nunc ac',0,1,1.2333,'N200',1),(8646,'nunc ac sodales','nunc ac sodales',0,1,1.5,'N2342',1),(8647,'nunc id','nunc id',0,1,1.2333,'N230',1),(8648,'nunc id elit','nunc id elit',0,1,1.4,'N2343',1),(8649,'odio egestas','odio egestas',0,1,1.4,'O3232',1),(8650,'odio egestas non','odio egestas non',0,1,1.5333,'O32325',1),(8651,'odio in','odio in',0,1,1.2333,'O350',1),(8652,'odio in aliquam','odio in aliquam',0,1,1.5,'O35425',1),(8653,'odio in tincidunt','odio in tincidunt',0,1,1.5667,'O35352353',1),(8654,'orci magna','orci magna',0,1,1.3333,'O62525',1),(8655,'orci magna venenatis','orci magna venenatis',0,1,1.6667,'O625251532',1),(8656,'page break','page break',0,1,1.3333,'P2162',1),(8657,'pellentesque habitant','pellentesque habitant',0,1,1.7,'P45321353',1),(8658,'pellentesque habitant morbi','pellentesque habitant morbi',0,1,1.9,'P45321353561',1),(8659,'pellentesque orci','pellentesque orci',0,1,1.5667,'P453262',1),(8660,'pellentesque orci magna','pellentesque orci magna',0,1,1.7667,'P453262525',1),(8661,'pellentesque tempus','pellentesque tempus',0,1,1.6333,'P45323512',1),(8662,'pellentesque tempus suscipit','pellentesque tempus suscipit',0,1,1.9333,'P4532351213',1),(8663,'pharetra eros','pharetra eros',0,1,1.4333,'P6362',1),(8664,'pharetra eros tincidunt','pharetra eros tincidunt',0,1,1.7667,'P6362352353',1),(8665,'phasellus et','phasellus et',0,1,1.4,'P2423',1),(8666,'phasellus et lorem','phasellus et lorem',0,1,1.6,'P2423465',1),(8667,'placerat gravida','placerat gravida',0,1,1.5333,'P42632613',1),(8668,'placerat gravida laoreet','placerat gravida laoreet',0,1,1.8,'P42632613463',1),(8669,'porta mauris','porta mauris',0,1,1.4,'P63562',1),(8670,'porta mauris lectus','porta mauris lectus',0,1,1.6333,'P635624232',1),(8671,'porta pulvinar','porta pulvinar',0,1,1.4667,'P6314156',1),(8672,'porta pulvinar integer','porta pulvinar integer',0,1,1.7333,'P63141565326',1),(8673,'porttitor eu','porttitor eu',0,1,1.4,'P636',1),(8674,'porttitor eu fermentum','porttitor eu fermentum',0,1,1.7333,'P63616535',1),(8675,'posuere arcu','posuere arcu',0,1,1.4,'P262',1),(8676,'posuere arcu et','posuere arcu et',0,1,1.5,'P2623',1),(8677,'posuere nisi','posuere nisi',0,1,1.4,'P2652',1),(8678,'posuere nisi quis','posuere nisi quis',0,1,1.5667,'P2652',1),(8679,'pretium porta','pretium porta',0,1,1.4333,'P635163',1),(8680,'pretium porta pulvinar','pretium porta pulvinar',0,1,1.7333,'P63516314156',1),(8681,'proin posuere','proin posuere',0,1,1.4333,'P65126',1),(8682,'proin posuere nisi','proin posuere nisi',0,1,1.6,'P6512652',1),(8683,'pulvinar integer','pulvinar integer',0,1,1.5333,'P41565326',1),(8684,'pulvinar integer cursus','pulvinar integer cursus',0,1,1.7667,'P41565326262',1),(8685,'pulvinar odio','pulvinar odio',0,1,1.4333,'P41563',1),(8686,'pulvinar odio in','pulvinar odio in',0,1,1.5333,'P415635',1),(8687,'purus fermentum','purus fermentum',0,1,1.5,'P6216535',1),(8688,'purus fermentum diam','purus fermentum diam',0,1,1.6667,'P621653535',1),(8689,'quis odio','quis odio',0,1,1.3,'Q300',1),(8690,'quis odio egestas','quis odio egestas',0,1,1.5667,'Q3232',1),(8691,'quis porta mauris','quis porta mauris',0,1,1.5667,'Q163562',1),(8692,'quis tellus lacinia','quis tellus lacinia',0,1,1.6333,'Q342425',1),(8693,'quisque magna','quisque magna',0,1,1.4333,'Q525',1),(8694,'quisque magna tellus','quisque magna tellus',0,1,1.6667,'Q525342',1),(8695,'quisque ultrices','quisque ultrices',0,1,1.5333,'Q4362',1),(8696,'quisque ultrices neque','quisque ultrices neque',0,1,1.7333,'Q436252',1),(8697,'risus sed','risus sed',0,1,1.3,'R230',1),(8698,'risus sed nulla','risus sed nulla',0,1,1.5,'R2354',1),(8699,'sagittis lacus ante','sagittis lacus ante',0,1,1.6333,'S324253',1),(8700,'sagittis pellentesque','sagittis pellentesque',0,1,1.7,'S3214532',1),(8701,'sagittis pellentesque orci','sagittis pellentesque orci',0,1,1.8667,'S321453262',1),(8702,'sapien condimentum','sapien condimentum',0,1,1.6,'S15253535',1),(8703,'sapien condimentum eget','sapien condimentum eget',0,1,1.7667,'S1525353523',1),(8704,'sapien pulvinar','sapien pulvinar',0,1,1.5,'S1514156',1),(8705,'sapien pulvinar odio','sapien pulvinar odio',0,1,1.6667,'S15141563',1),(8706,'sed nec','sed nec',0,1,1.2333,'S352',1),(8707,'sed nec risus','sed nec risus',0,1,1.4333,'S35262',1),(8708,'sed nisi','sed nisi',0,1,1.2667,'S352',1),(8709,'sed nisi curabitur','sed nisi curabitur',0,1,1.6,'S3526136',1),(8710,'sed nulla','sed nulla',0,1,1.3,'S354',1),(8711,'sed nulla mattis','sed nulla mattis',0,1,1.5333,'S354532',1),(8712,'sed tellus sapien','sed tellus sapien',0,1,1.5667,'S34215',1),(8713,'sed tempor','sed tempor',0,1,1.3333,'S3516',1),(8714,'sed tempor phasellus','sed tempor phasellus',0,1,1.6667,'S35161242',1),(8715,'semper augue','semper augue',0,1,1.4,'S5162',1),(8716,'semper augue lorem','semper augue lorem',0,1,1.6,'S5162465',1),(8717,'senectus','senectus',0,0,0.5333,'S5232',1),(8718,'senectus et','senectus et',0,1,1.3667,'S52323',1),(8719,'senectus et netus','senectus et netus',0,1,1.5667,'S52323532',1),(8720,'sit amet mi','sit amet mi',0,1,1.3667,'S3535',1),(8721,'sit amet nisi','sit amet nisi',0,1,1.4333,'S35352',1),(8722,'sit amet sit','sit amet sit',0,1,1.4,'S35323',1),(8723,'sodales augue','sodales augue',0,1,1.4333,'S342',1),(8724,'sodales augue magna','sodales augue magna',0,1,1.6333,'S342525',1),(8725,'sollicitudin nulla','sollicitudin nulla',0,1,1.6,'S42354',1),(8726,'sollicitudin nulla facilisi','sollicitudin nulla facilisi',0,1,1.9,'S423541242',1),(8727,'sollicitudin sit','sollicitudin sit',0,1,1.5333,'S423523',1),(8728,'sollicitudin sit amet','sollicitudin sit amet',0,1,1.7,'S42352353',1),(8729,'suscipit nulla','suscipit nulla',0,1,1.4667,'S1354',1),(8730,'suscipit nulla sed','suscipit nulla sed',0,1,1.6,'S135423',1),(8731,'tellus condimentum','tellus condimentum',0,1,1.6,'T4253535',1),(8732,'tellus condimentum a','tellus condimentum a',0,1,1.6667,'T4253535',1),(8733,'tellus duis','tellus duis',0,1,1.3667,'T4232',1),(8734,'tellus duis a','tellus duis a',0,1,1.4333,'T4232',1),(8735,'tellus lacinia','tellus lacinia',0,1,1.4667,'T42425',1),(8736,'tellus lacinia tristique','tellus lacinia tristique',0,1,1.8,'T4242536232',1),(8737,'tellus morbi','tellus morbi',0,1,1.4,'T42561',1),(8738,'tellus morbi vel','tellus morbi vel',0,1,1.5333,'T425614',1),(8739,'tellus sapien','tellus sapien',0,1,1.4333,'T4215',1),(8740,'tellus sapien condimentum','tellus sapien condimentum',0,1,1.8333,'T4215253535',1),(8741,'tempor phasellus','tempor phasellus',0,1,1.5333,'T5161242',1),(8742,'tempor phasellus et','tempor phasellus et',0,1,1.6333,'T51612423',1),(8743,'tempus est','tempus est',0,1,1.3333,'T5123',1),(8744,'tempus est sollicitudin','tempus est sollicitudin',0,1,1.7667,'T512324235',1),(8745,'tempus suscipit','tempus suscipit',0,1,1.5,'T51213',1),(8746,'tempus suscipit nulla','tempus suscipit nulla',0,1,1.7,'T5121354',1),(8747,'tincidunt a','tincidunt a',0,1,1.3667,'T52353',1),(8748,'tincidunt a ligula','tincidunt a ligula',0,1,1.6,'T52353424',1),(8749,'tincidunt augue','tincidunt augue',0,1,1.5,'T523532',1),(8750,'tincidunt augue eget','tincidunt augue eget',0,1,1.6667,'T5235323',1),(8751,'tincidunt dapibus','tincidunt dapibus',0,1,1.5667,'T5235312',1),(8752,'tincidunt dapibus malesuada','tincidunt dapibus malesuada',0,1,1.9,'T52353125423',1),(8753,'tincidunt maecenas','tincidunt maecenas',0,1,1.6,'T523535252',1),(8754,'tincidunt maecenas et','tincidunt maecenas et',0,1,1.7,'T5235352523',1),(8755,'tortor libero vel','tortor libero vel',0,1,1.5667,'T63641614',1),(8756,'tristique ac','tristique ac',0,1,1.4,'T6232',1),(8757,'tristique ac faucibus','tristique ac faucibus',0,1,1.7,'T62321212',1),(8758,'tristique donec','tristique donec',0,1,1.5,'T6232352',1),(8759,'tristique donec libero','tristique donec libero',0,1,1.7333,'T6232352416',1),(8760,'tristique senectus','tristique senectus',0,1,1.6,'T62325232',1),(8761,'tristique senectus et','tristique senectus et',0,1,1.7,'T623252323',1),(8762,'turpis a','turpis a',0,1,1.2667,'T612',1),(8763,'turpis a dictum','turpis a dictum',0,1,1.5,'T6123235',1),(8764,'turpis egestas','turpis egestas',0,1,1.4667,'T61232',1),(8765,'turpis egestas donec','turpis egestas donec',0,1,1.6667,'T61232352',1),(8766,'ultrices neque','ultrices neque',0,1,1.4667,'U436252',1),(8767,'ultrices neque et','ultrices neque et',0,1,1.5667,'U4362523',1),(8768,'ultrices vitae','ultrices vitae',0,1,1.4667,'U436213',1),(8769,'ultrices vitae hendrerit','ultrices vitae hendrerit',0,1,1.8,'U4362135363',1),(8770,'ultricies ut ultrices','ultricies ut ultrices',0,1,1.7,'U436234362',1),(8771,'urna cursus','urna cursus',0,1,1.3667,'U65262',1),(8772,'urna cursus vitae','urna cursus vitae',0,1,1.5667,'U6526213',1),(8773,'ut odio','ut odio',0,1,1.2333,'U300',1),(8774,'ut odio in','ut odio in',0,1,1.3333,'U350',1),(8775,'ut ultrices','ut ultrices',0,1,1.3667,'U34362',1),(8776,'ut ultrices vitae','ut ultrices vitae',0,1,1.5667,'U3436213',1),(8777,'vel lobortis','vel lobortis',0,1,1.4,'V41632',1),(8778,'vel lobortis vel','vel lobortis vel',0,1,1.5333,'V4163214',1),(8779,'vel malesuada','vel malesuada',0,1,1.4333,'V45423',1),(8780,'vel malesuada est','vel malesuada est',0,1,1.5667,'V4542323',1),(8781,'vel semper','vel semper',0,1,1.3333,'V42516',1),(8782,'vel semper augue','vel semper augue',0,1,1.5333,'V425162',1),(8783,'vel tincidunt','vel tincidunt',0,1,1.4333,'V4352353',1),(8784,'vel tincidunt a','vel tincidunt a',0,1,1.5,'V4352353',1),(8785,'velit convallis','velit convallis',0,1,1.5,'V4325142',1),(8786,'velit convallis nec','velit convallis nec',0,1,1.6333,'V432514252',1),(8787,'venenatis dictum','venenatis dictum',0,1,1.5333,'V5323235',1),(8788,'venenatis dictum morbi','venenatis dictum morbi',0,1,1.7333,'V532323561',1),(8789,'venenatis neque','venenatis neque',0,1,1.5,'V53252',1),(8790,'venenatis neque eu','venenatis neque eu',0,1,1.6,'V53252',1),(8791,'vitae hendrerit vitae','vitae hendrerit vitae',0,1,1.7,'V3536313',1),(8792,'vitae sollicitudin','vitae sollicitudin',0,1,1.6,'V324235',1),(8793,'vitae sollicitudin sit','vitae sollicitudin sit',0,1,1.7333,'V32423523',1),(8794,'vitae tellus','vitae tellus',0,1,1.4,'V342',1),(8795,'vitae tellus duis','vitae tellus duis',0,1,1.5667,'V34232',1),(8796,'volutpat in eget','volutpat in eget',0,1,1.5333,'V4313523',1),(8797,'volutpat lorem','volutpat lorem',0,1,1.4667,'V4313465',1),(8798,'volutpat lorem ipsum','volutpat lorem ipsum',0,1,1.6667,'V4313465125',1),(8799,'vulputate dui','vulputate dui',0,1,1.4333,'V413',1),(8800,'vulputate dui diam','vulputate dui diam',0,1,1.6,'V4135',1),(8801,'com index','com index',0,1,1.3,'C532',2),(8802,'com index php','com index php',0,1,1.4333,'C5321',2),(8803,'feed type','feed type',0,1,1.3,'F310',2),(8804,'feed type rss','feed type rss',0,1,1.4333,'F3162',2),(8805,'format','format',0,0,0.4,'F653',2),(8806,'format feed','format feed',0,1,1.3667,'F65313',2),(8807,'format feed type','format feed type',0,1,1.5333,'F653131',2),(8808,'gavickmagazine','gavickmagazine',0,0,0.9333,'G12525',3),(8809,'gavickmagazine com','gavickmagazine com',0,1,1.6,'G1252525',3),(8810,'gavickmagazine com index','gavickmagazine com index',0,1,1.8,'G125252532',2),(8811,'gavickpro news','gavickpro news',0,1,1.4667,'G121652',1),(8812,'http www gavickmagazine','http www gavickmagazine',0,1,1.7667,'H31212525',3),(8813,'index php','index php',0,1,1.3,'I5321',2),(8814,'index php format','index php format',0,1,1.5333,'I5321653',2),(8815,'news','news',0,0,0.2667,'N200',2),(8816,'news feed','news feed',0,1,1.3,'N213',1),(8817,'php','php',0,0,0.2,'P000',2),(8818,'php format','php format',0,1,1.3333,'P653',2),(8819,'php format feed','php format feed',0,1,1.5,'P65313',2),(8820,'rss','rss',0,0,0.2,'R200',2),(8821,'type rss','type rss',0,1,1.2667,'T162',2),(8822,'www gavickmagazine','www gavickmagazine',0,1,1.6,'W212525',3),(8823,'www gavickmagazine com','www gavickmagazine com',0,1,1.7333,'W21252525',3),(8824,'1.6','1.6',0,0,0.3,'',1),(8825,'cms','cms',0,0,0.2,'C520',1),(8826,'cms offical','cms offical',0,1,1.3667,'C52124',1),(8827,'cms offical site','cms offical site',0,1,1.5333,'C5212423',1),(8828,'http www joomla','http www joomla',0,1,1.5,'H31254',1),(8829,'joomla 1.6','joomla 1.6',0,1,1.3333,'J540',1),(8830,'joomla 16','joomla 16',0,1,1.3,'J540',1),(8831,'joomla cms','joomla cms',0,1,1.3333,'J54252',1),(8832,'joomla cms offical','joomla cms offical',0,1,1.6,'J54252124',1),(8833,'joomla org','joomla org',0,1,1.3333,'J5462',3),(8834,'offical','offical',0,0,0.4667,'O124',1),(8835,'offical site','offical site',0,1,1.4,'O12423',1),(8836,'web link','web link',0,1,1.2667,'W1452',12),(8837,'www joomla','www joomla',0,1,1.3333,'W254',1),(8838,'www joomla org','www joomla org',0,1,1.4667,'W25462',1),(8839,'extensions','extensions',0,0,0.6667,'E235252',1),(8840,'extensions joomla','extensions joomla',0,1,1.5667,'E23525254',1),(8841,'extensions joomla org','extensions joomla org',0,1,1.7,'E2352525462',1),(8842,'http extensions','http extensions',0,1,1.5,'H31235252',1),(8843,'http extensions joomla','http extensions joomla',0,1,1.7333,'H3123525254',1),(8844,'joomla extensions','joomla extensions',0,1,1.5667,'J54235252',1),(8845,'docs','docs',0,0,0.2667,'D200',1),(8846,'docs joomla','docs joomla',0,1,1.3667,'D254',1),(8847,'docs joomla org','docs joomla org',0,1,1.5,'D25462',1),(8848,'documentation','documentation',0,0,0.8667,'D2535',1),(8849,'full joomla','full joomla',0,1,1.3667,'F4254',1),(8850,'full joomla documentation','full joomla documentation',0,1,1.8333,'F425432535',1),(8851,'http docs','http docs',0,1,1.3,'H3132',1),(8852,'http docs joomla','http docs joomla',0,1,1.5333,'H313254',1),(8853,'joomla documentation','joomla documentation',0,1,1.6667,'J5432535',1),(8854,'demo','demo',0,0,0.2667,'D500',1),(8855,'demo gavick','demo gavick',0,1,1.3667,'D5212',1),(8856,'demo gavick com','demo gavick com',0,1,1.5,'D52125',1),(8857,'gavick com','gavick com',0,1,1.3333,'G125',5),(8858,'gavickpro demo','gavickpro demo',0,1,1.4667,'G121635',1),(8859,'http demo','http demo',0,1,1.3,'H3135',1),(8860,'http demo gavick','http demo gavick',0,1,1.5333,'H3135212',1),(8861,'gavick magazine','gavick magazine',0,1,1.5,'G12525',1),(8862,'gavickpro magazine','gavickpro magazine',0,1,1.6,'G1216525',1),(8863,'magazine','magazine',0,0,0.5333,'M250',1),(8864,'gavickpro homepage','gavickpro homepage',0,1,1.6,'G1216512',1),(8865,'homepage','homepage',0,0,0.5333,'H512',1),(8866,'http www gavick','http www gavick',0,1,1.5,'H31212',3),(8867,'www gavick','www gavick',0,1,1.3333,'W212',3),(8868,'www gavick com','www gavick com',0,1,1.4667,'W2125',3),(8869,'gavickpro tools','gavickpro tools',0,1,1.5,'G1216342',1),(8870,'http tools','http tools',0,1,1.3333,'H31342',1),(8871,'http tools gavick','http tools gavick',0,1,1.5667,'H3134212',1),(8872,'tools','tools',0,0,0.3333,'T420',1),(8873,'tools gavick','tools gavick',0,1,1.4,'T4212',1),(8874,'tools gavick com','tools gavick com',0,1,1.5333,'T42125',1),(8875,'com gavickpro','com gavickpro',0,1,1.4333,'C521216',2),(8876,'gavickpro twitter','gavickpro twitter',0,1,1.5667,'G121636',1),(8877,'http twitter','http twitter',0,1,1.4,'H3136',1),(8878,'http twitter com','http twitter com',0,1,1.5333,'H313625',1),(8879,'twitter com','twitter com',0,1,1.3667,'T625',1),(8880,'twitter com gavickpro','twitter com gavickpro',0,1,1.7,'T62521216',1),(8881,'facebook com','facebook com',0,1,1.4,'F2125',1),(8882,'facebook com gavickpro','facebook com gavickpro',0,1,1.7333,'F212521216',1),(8883,'gavickpro facebook','gavickpro facebook',0,1,1.6,'G12161212',1),(8884,'http www facebook','http www facebook',0,1,1.5667,'H31212',1),(8885,'www facebook','www facebook',0,1,1.4,'W1212',1),(8886,'www facebook com','www facebook com',0,1,1.5333,'W12125',1),(8887,'com support','com support',0,1,1.3667,'C52163',1),(8888,'com support updates','com support updates',0,1,1.6333,'C52163132',1),(8889,'gavick com support','gavick com support',0,1,1.6,'G1252163',1),(8890,'gavickpro updates','gavickpro updates',0,1,1.5667,'G1216132',1),(8891,'support updates','support updates',0,1,1.5,'S163132',1),(8892,'support updates html','support updates html',0,1,1.6667,'S163132354',1),(8893,'updates','updates',0,0,0.4667,'U132',1),(8894,'updates html','updates html',0,1,1.4,'U132354',1),(8895,'com home','com home',0,1,1.2667,'C500',1),(8896,'com home join-us','com home join-us',0,1,1.5333,'C5252',1),(8897,'gavick com home','gavick com home',0,1,1.5,'G125',1),(8898,'home','home',0,0,0.2667,'H500',1),(8899,'home join-us','home join-us',0,1,1.4,'H5252',1),(8900,'home join-us html','home join-us html',0,1,1.5667,'H5252354',1),(8901,'join','join',0,0,0.2667,'J500',1),(8902,'join us','join us',0,1,1.2333,'J520',1),(8903,'join-us','join-us',0,0,0.4667,'J520',1),(8904,'join-us html','join-us html',0,1,1.4,'J52354',1),(8905,'a news','a news',0,1,1.2,'A520',1),(8906,'gavickpro rss','gavickpro rss',0,1,1.4333,'G12162',1),(8907,'gavickpro rss a','gavickpro rss a',0,1,1.5,'G12162',1),(8908,'gavickpro rss news','gavickpro rss news',0,1,1.6,'G1216252',1),(8909,'rss a','rss a',0,1,1.1667,'R200',1),(8910,'rss a news','rss a news',0,1,1.3333,'R252',1),(8911,'rss news','rss news',0,1,1.2667,'R252',1),(8912,'39','39',0,0,0.2,'',1),(8913,'chrome frame 2','chrome frame 2',0,1,1.4667,'C65165',1),(8914,'frame 2','frame 2',0,1,1.2333,'F650',1);


--
-- Table structure for table `#__finder_terms_common`
--



CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_terms_common`
--


INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES ('a','en'),('about','en'),('after','en'),('ago','en'),('all','en'),('am','en'),('an','en'),('and','en'),('ani','en'),('any','en'),('are','en'),('aren\'t','en'),('as','en'),('at','en'),('be','en'),('but','en'),('by','en'),('for','en'),('from','en'),('get','en'),('go','en'),('how','en'),('if','en'),('in','en'),('into','en'),('is','en'),('isn\'t','en'),('it','en'),('its','en'),('me','en'),('more','en'),('most','en'),('must','en'),('my','en'),('new','en'),('no','en'),('none','en'),('not','en'),('noth','en'),('nothing','en'),('of','en'),('off','en'),('often','en'),('old','en'),('on','en'),('onc','en'),('once','en'),('onli','en'),('only','en'),('or','en'),('other','en'),('our','en'),('ours','en'),('out','en'),('over','en'),('page','en'),('she','en'),('should','en'),('small','en'),('so','en'),('some','en'),('than','en'),('thank','en'),('that','en'),('the','en'),('their','en'),('theirs','en'),('them','en'),('then','en'),('there','en'),('these','en'),('they','en'),('this','en'),('those','en'),('thus','en'),('time','en'),('times','en'),('to','en'),('too','en'),('true','en'),('under','en'),('until','en'),('up','en'),('upon','en'),('use','en'),('user','en'),('users','en'),('veri','en'),('version','en'),('very','en'),('via','en'),('want','en'),('was','en'),('way','en'),('were','en'),('what','en'),('when','en'),('where','en'),('whi','en'),('which','en'),('who','en'),('whom','en'),('whose','en'),('why','en'),('wide','en'),('will','en'),('with','en'),('within','en'),('without','en'),('would','en'),('yes','en'),('yet','en'),('you','en'),('your','en'),('yours','en');


--
-- Table structure for table `#__finder_tokens`
--



CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_tokens`
--




--
-- Table structure for table `#__finder_tokens_aggregate`
--



CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_tokens_aggregate`
--




--
-- Table structure for table `#__finder_types`
--



CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_types`
--


INSERT INTO `#__finder_types` (`id`, `title`, `mime`) VALUES (1,'Category',''),(2,'Contact',''),(3,'Article',''),(4,'News Feed',''),(5,'Web Link','');


--
-- Table structure for table `#__k2_attachments`
--



CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_attachments`
--




--
-- Table structure for table `#__k2_categories`
--



CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`),
  KEY `language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_categories`
--


INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`) VALUES (1,'Financial Business','financial-business','<p class=\"ItemCatDesc\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus.</p>',0,0,1,1,1,'','{\"inheritFrom\":\"0\",\"num_leading_items\":\"0\",\"num_leading_columns\":\"0\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"0\",\"num_primary_columns\":\"0\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"0\",\"secondaryImgSize\":\"Small\",\"num_links\":\"0\",\"num_links_columns\":\"0\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"1\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"0\",\"catDescription\":\"1\",\"catImage\":\"0\",\"catFeedLink\":\"0\",\"feedLink\":\"0\",\"subCategories\":\"1\",\"subCatColumns\":\"3\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,'',''),(2,'Financial Adviser','financial-adviser','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus. Quisque aliquet posuere libero at molestie.</p>',1,0,1,1,1,'2.png','{\"inheritFrom\":\"3\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"2\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"feedLink\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,'',''),(3,'Investment Guide','investment-guide','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus. Quisque aliquet posuere libero at molestie</p>',1,0,1,1,2,'3.png','{\"inheritFrom\":\"0\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"2\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"2\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"0\",\"secondaryImgSize\":\"Large\",\"num_links\":\"0\",\"num_links_columns\":\"0\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"0\",\"catFeedLink\":\"1\",\"feedLink\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"0\",\"catItemDateCreated\":\"0\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"20\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"0\",\"catItemTags\":\"0\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,'',''),(4,'Market Center','market-center','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur eget nisi velit, adipiscing consectetur orci. Donec lobortis ornare felis non luctus. Quisque aliquet posuere libero at molestie.</p>',1,1,1,1,3,'4.png','{\"inheritFrom\":\"3\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"2\",\"leadingImgSize\":\"Medium\",\"num_primary_items\":\"2\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"feedLink\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemTwitterLink\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemShareLinks\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemK2Plugins\":\"1\"}',0,'','');


--
-- Table structure for table `#__k2_comments`
--



CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_comments`
--


INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`) VALUES (1,7,0,'Robert','2011-08-17 17:03:31','Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi faucibus risus id metus porttitor sit amet vulputate nibh blandit.','eeee@aaa.pl','',1),(2,8,0,'Robert','2011-08-17 17:04:26','Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue.','eeee@aaa.pl','',1),(3,8,0,'Paulo','2011-08-17 17:05:04','Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum','eeeee@aa.pl','',1),(4,6,0,'Paulo','2011-08-17 17:06:45','Aliquam auctor feugiat ante, ac lobortis metus facilisis sit amet. Proin mollis mollis ultrices. Sed elementum faucibus lacinia. Vivamus posuere.','eeeee@aa.pl','',1);


--
-- Table structure for table `#__k2_extra_fields`
--



CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields`
--


INSERT INTO `#__k2_extra_fields` (`id`, `name`, `value`, `type`, `group`, `published`, `ordering`) VALUES (1,'Theme','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,1),(2,'Version','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,2),(3,'Demo','[{\"name\":\"\",\"value\":\"http:\\/\\/\",\"target\":\"new\"}]','link',1,1,3),(4,'Developer','[{\"name\":\"\",\"value\":\"http:\\/\\/\",\"target\":\"new\"}]','link',1,1,4);


--
-- Table structure for table `#__k2_extra_fields_groups`
--



CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields_groups`
--


INSERT INTO `#__k2_extra_fields_groups` (`id`, `name`) VALUES (1,'PortFolio');


--
-- Table structure for table `#__k2_items`
--



CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `created` (`created`),
  KEY `language` (`language`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_items`
--


INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES (1,'Online Business Conference','online-business-conference',2,1,'<p>With the rapid advancement of technology and internet, thousands of e business sites have been emerged nowadays providing the professional quality e business services to their valued customers worldwide within most affordable costs.</p>\r\n','\r\n<p>More importantly, several e business meetings sites have been launched over the World Wide Web recently helping to their valued customers worldwide in a most artful and dedicated manner.<br /><br />Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam</p>',NULL,NULL,'[]','','2011-07-12 09:17:45',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:49:06',42,'2011-07-12 09:17:45','0000-00-00 00:00:00',0,1,1,0,0,'Online Business Conference','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(2,'Need Additional Capital?','need-additional-capital?',2,1,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:21:17',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:49:42',42,'2011-07-12 09:21:17','0000-00-00 00:00:00',0,1,2,1,1,'Need Additional Capital?','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(3,'We celebrate your success! ','we-celebrate-your-success',2,1,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:24:22',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:50:57',42,'2011-07-12 09:24:22','0000-00-00 00:00:00',0,1,3,0,0,'We celebrate your success! ','','','',5,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(4,'Idea about starting your own business','idea-about-starting-your-own-business',2,1,'<p>In the back of your mind, you\'ve had this germ of an idea about starting your own business. In the Idea Phase, you begin to seriously explore the possibility of actually doing it. You consider the \"what-ifs\" and bounce the idea off friends and family to gauge their support and to get their advice.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi.</p>',NULL,NULL,'[]','','2011-07-12 09:25:58',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:51:27',42,'2011-07-12 09:25:58','0000-00-00 00:00:00',0,1,4,1,2,'Idea about starting your own business','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(5,'Support your financial success ','support-your-financial-success',3,1,'<p>A business cycle is not a regular, predictable, or repeating phenomenon like the swing of the pendulum of a clock. Its timing is random and, to a large degress, unpredictable. A business cycle is identified as a sequence of four phase.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:33:33',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:47:39',42,'2011-07-12 09:33:33','0000-00-00 00:00:00',0,1,1,0,0,'Support your financial success ','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(6,'WorkShop from dedicated stractegy','workshop-from-dedicated-stractegy',3,1,'<p>Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding</p>\r\n','\r\n<p>you can qualify for and who you can rely on is an important part of the decision making process.</p>\r\n<p>Business Financial Services (BFS) is the trusted provider of merchant cash advances to businesses nationwide. Since 2002, business owners have come to us to get the small business capital they need for inventory, vendor financing, renovation, equipment, taxes or just extra cash flow.</p>\r\n<p>Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:38:15',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:46:55',42,'2011-07-12 09:38:15','0000-00-00 00:00:00',0,1,2,0,0,'WorkShop from dedicated stractegy','','','',9,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(7,'Office and Support Staff ','office-and-support-staff',3,1,'<p>Technical Support staff brings the personal touch that you have been looking for. No wading through a long list of auto attendant options and voice mail. Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis.</p>\r\n','\r\n<p>Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor. Cras placerat, velit vitae laoreet faucibus, odio augue rutrum nisl, non vestibulum dui dui sed diam. Pellentesque urna dolor, vehicula ac sollicitudin eu, varius ac lectus. Integer quis ipsum enim, ut volutpat sem. Praesent ipsum nibh, hendrerit a facilisis quis, porta ac augue. Nullam nulla turpis, tempor id imperdiet quis, pretium nec urna.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 09:55:04',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:46:12',42,'2011-07-12 09:55:04','0000-00-00 00:00:00',0,1,3,0,0,'Office and Support Staff ','','','',2,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(8,'Creating a great team environment','creating-a-great-team-environment',3,1,'<p>When your business encounters bumps in the road, it seems like everyone knows — especially your staff. During these challenging times. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam.</p>\r\n','\r\n<p>Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.<br /><br />Sed ultrices, eros id facilisis convallis, ante sapien ultricies ligula, nec fringilla mauris lacus ultrices lorem. Nam egestas, mauris id pharetra pulvinar, nisi enim fringilla libero, a vulputate tortor arcu et risus. Maecenas lectus turpis, iaculis id aliquam et, rhoncus vel dui. Duis vel diam metus, in tempor augue. Pellentesque vestibulum aliquet neque a porttitor. Suspendisse condimentum, urna et pharetra mollis, elit tortor blandit neque, quis scelerisque enim ante id ligula. Nunc vel mattis enim. Nullam vitae ipsum nisi, et pharetra nisi. Quisque eget velit orci. Suspendisse ac mauris ac arcu viverra facilisis sit amet in quam. Curabitur vel erat enim. Mauris nunc diam, fermentum consectetur pellentesque sed, elementum id quam. Proin pellentesque lectus urna. Donec vulputate, orci in tincidunt pharetra, lectus leo cursus quam, tristique interdum lorem lectus vitae turpis.</p>',NULL,NULL,'[]','','2011-07-12 10:09:11',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:45:05',42,'2011-07-12 10:09:11','0000-00-00 00:00:00',0,1,4,1,3,'Creating a great team environment','','','',10,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(9,'Our business is built on friendship.','our-business-is-built-on-friendship',4,1,'<p>Describe your company\'s <em>business</em> plan with this <em>presentation</em> for PowerPoint. It features twelve slides with topics ranging from mission statement to key.Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia.</p>\r\n','\r\n<p>It all have to do with what you are ready, willing and able to accept within yourself and in accepting to be able to give others. It is your personal power to make the difference by being true to the best within you and letting truth shine through your words and actions. Be yourself in front of the eyes of the crowd.<br /><br /></p>\r\n<div style=\"text-align: justify;\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</div>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"PostNote\"},{\"id\":\"2\",\"value\":\"Jun 2010\"},{\"id\":\"3\",\"value\":[\"Click here\",\"http:\\/\\/demo.gavick.com\\/joomla15\\/jun2010\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"GavickPro Creative Joomla! Development Studio\",\"http:\\/\\/www.gavick.com\",\"new\"]}]','PostNote Jun 2010 Click here http://demo.gavick.com/joomla15/jun2010/  GavickPro Creative Joomla! Development Studio http://www.gavick.com  ','2011-07-12 10:17:07',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:44:23',42,'2011-07-12 10:17:07','0000-00-00 00:00:00',0,1,1,0,0,'Our business is built on friendship.','','','',61,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(10,'Trusted in financial market','trusted-in-financial-market',4,1,'<p>Getting the small business capital you need to help with day-to-day expenses is challenging in today\'s economy. We recognize when it comes to obtaining working capital, there are many choices. As a business owner, understanding the type of small business funding you</p>\r\n','\r\n<p>can qualify for and who you can rely on is an important part of the decision making process. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]}]','   http://   http://  ','2011-07-12 10:19:19',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:43:43',42,'2011-07-12 10:19:19','0000-00-00 00:00:00',0,1,2,1,4,'Trusted in financial market','','','',6,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(11,'Fully equipped modern workshop','fully-equipped-modern-workshop',4,1,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh.</p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl. <br /><br />~Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"Click here\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"GavickPro Creative Joomla! Development Studio\",\"http:\\/\\/\",\"new\"]}]','  Click here http://  GavickPro Creative Joomla! Development Studio http://  ','2011-07-12 10:23:54',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:43:06',42,'2011-07-12 10:23:54','0000-00-00 00:00:00',0,1,3,0,0,'Fully equipped modern workshop','','','',9,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(12,'Top professional advisers','top-professional-advisers',4,1,'<p>Latest e business ideas as well as concepts are being introduced by the most professional and dedicated e business companies worldwide. So do you have a perfect e business plan? Do you instantly want to promote your e business conference?</p>\r\n','\r\n<p>If yes, then please feel free to contact at www.ebusinessmeetings.net as this is yours own company who helps you regarding your e business meetings, conferences and seminars in a clearly artful and dedicated manner. It provides you the smart business meeting tips through which you would be instantly able to promote your own business meetings as well as conferences effortlessly.  So please do not get hesitated to contact with E Business Meetings so as to get a perfect advice regarding your own business meetings.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac. Nullam nibh neque, varius et congue sit amet, placerat eget nibh. Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque. Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis leo placerat iaculis. Integer massa augue, pellentesque eu facilisis nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan tortor ligula non tortor.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]}]','   http://   http://  ','2011-07-12 10:29:13',42,'',0,'0000-00-00 00:00:00','2011-08-19 13:42:21',42,'2011-07-12 10:29:13','0000-00-00 00:00:00',0,1,4,0,0,'Top professional advisers','','','',14,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','',''),(13,'Copy of Top professional advisers','top-professional-advisers',4,0,'<p>Latest e business ideas as well as concepts are being introduced by the   most professional and dedicated e business companies worldwide. So do   you have a perfect e business plan?  Do you instantly want to promote  your e business conference?</p>','<p>If yes,  then please feel free to contact at www.ebusinessmeetings.net  as this is  yours own company who helps you regarding your e business  meetings,  conferences and seminars in a clearly artful and dedicated  manner. It  provides you the smart business meeting tips through which  you would be  instantly able to promote your own business meetings as  well as  conferences effortlessly.  So please do not get hesitated to  contact  with E Business Meetings so as to get a perfect advice  regarding your  own business meetings.<br /><br />Nulla at est quis leo  placerat iaculis. Integer massa augue,  pellentesque eu facilisis nec,  auctor et turpis. Vivamus congue blandit  nisl nec auctor. Proin rutrum  magna iaculis arcu malesuada a suscipit  nisl tincidunt. Etiam id quam  semper diam dapibus pretium ac vel arcu.  Cras ornare, eros consectetur  gravida pharetra, nisi enim luctus eros,  blandit accumsan tortor ligula  non tortor.<br /><br />Lorem ipsum dolor sit amet, consectetur adipiscing  elit. Vestibulum leo nisi, condimentum at vestibulum id, pulvinar id  eros. Cras aliquet molestie ligula, sit amet elementum tortor congue ac.  Nullam nibh neque, varius et congue sit amet, placerat eget nibh.  Phasellus erat sapien, malesuada nec imperdiet id, tempus at neque.  Maecenas vel est at lectus luctus lacinia. Aliquam eu lacus in neque  commodo convallis eu et lectus. Ut eget nibh arcu. Praesent malesuada  ante at dui vulputate ultrices. Donec dignissim libero ac lorem accumsan  eu lobortis lacus lobortis. Sed magna eros, lobortis ac semper sit  amet, tincidunt at nibh. Duis vel lectus nisl.<br /><br />Nulla at est quis  leo placerat iaculis. Integer massa augue, pellentesque eu facilisis  nec, auctor et turpis. Vivamus congue blandit nisl nec auctor. Proin  rutrum magna iaculis arcu malesuada a suscipit nisl tincidunt. Etiam id  quam semper diam dapibus pretium ac vel arcu. Cras ornare, eros  consectetur gravida pharetra, nisi enim luctus eros, blandit accumsan  tortor ligula non tortor.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]},{\"id\":\"4\",\"value\":[\"\",\"http:\\/\\/\",\"new\"]}]','   http://   http://  ','2011-07-20 12:05:48',42,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2011-07-12 10:29:13','0000-00-00 00:00:00',1,1,4,0,0,'Top professional advisers','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemTwitterLink\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemShareLinks\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','');


--
-- Table structure for table `#__k2_rating`
--



CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_rating`
--




--
-- Table structure for table `#__k2_tags`
--



CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=23 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags`
--


INSERT INTO `#__k2_tags` (`id`, `name`, `published`) VALUES (1,'support',1),(2,'Business',1),(3,'Conference',1),(4,'capital',1),(5,'credit',1),(6,'financial',1),(7,'idea',1),(8,'sucess',1),(9,'workshop',1),(10,'strategy',1),(11,'staff',1),(12,'office',1),(13,'team',1),(14,'environment',1),(15,'friendship',1),(16,'market',1),(17,'trust',1),(18,'professionalism',1),(19,'advisers',1),(20,'client',1),(21,'Vitory',1),(22,'Team Work',1);


--
-- Table structure for table `#__k2_tags_xref`
--



CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM AUTO_INCREMENT=199 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags_xref`
--


INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`) VALUES (180,3,1),(179,2,1),(178,1,1),(190,6,2),(189,5,2),(188,4,2),(187,2,2),(186,1,2),(198,7,4),(197,6,4),(196,2,4),(195,1,4),(166,8,5),(165,2,5),(164,1,5),(160,10,6),(159,9,6),(158,8,6),(157,2,6),(152,12,7),(151,11,7),(150,2,7),(149,1,7),(144,14,8),(143,13,8),(142,6,8),(141,2,8),(136,15,9),(135,6,9),(134,2,9),(130,17,10),(129,16,10),(128,6,10),(127,2,10),(122,18,11),(121,9,11),(120,2,11),(116,20,12),(115,19,12),(114,6,12),(113,2,12),(42,19,13),(43,20,13),(44,2,13),(45,6,13),(191,2,3),(192,8,3),(193,21,3),(194,22,3);


--
-- Table structure for table `#__k2_user_groups`
--



CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_user_groups`
--


INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`) VALUES (1,'Registered','{\"comment\":\"1\",\"frontEdit\":\"0\",\"add\":\"0\",\"editOwn\":\"0\",\"editAll\":\"0\",\"publish\":\"0\",\"inheritance\":\"0\",\"categories\":\"all\"}'),(2,'Site Owner','{\"comment\":\"1\",\"frontEdit\":\"1\",\"add\":\"1\",\"editOwn\":\"1\",\"editAll\":\"1\",\"publish\":\"1\",\"inheritance\":\"1\",\"categories\":\"all\"}');


--
-- Table structure for table `#__k2_users`
--



CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_users`
--


INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`) VALUES (1,42,'Administrator','m','<p>Hi my name is Bob Urichuck and I have been the SEO Director on Business Financial Inc. More than 5000 employees support BF Inc outsourcing <em>business</em>, delivering a seamless customer service experience to <em>our</em> client.</p>','1.png','http://www.gavick.com',2,'');


--
-- Table structure for table `#__languages`
--



CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__languages`
--


INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `ordering`) VALUES (1,'en-GB','English (UK)','English (UK)','en','en','','','','',1,0);


--
-- Table structure for table `#__menu`
--



CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned DEFAULT NULL,
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=274 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu`
--


INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES (1,'','Menu_Item_Root','root','','','','',1,0,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,267,0,'*',0),(2,'menu','com_banners','Banners','','Banners','index.php?option=com_banners','component',0,1,1,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',1,10,0,'*',1),(3,'menu','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',2,3,0,'*',1),(4,'menu','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',4,5,0,'*',1),(5,'menu','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',6,7,0,'*',1),(6,'menu','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',8,9,0,'*',1),(7,'menu','com_contact','Contacts','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',11,16,0,'*',1),(8,'menu','com_contact','Contacts','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',12,13,0,'*',1),(9,'menu','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',14,15,0,'*',1),(10,'menu','com_messages','Messaging','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',17,22,0,'*',1),(11,'menu','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',18,19,0,'*',1),(12,'menu','com_messages_read','Read Private Message','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',20,21,0,'*',1),(13,'menu','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',23,28,0,'*',1),(14,'menu','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',24,25,0,'*',1),(15,'menu','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',26,27,0,'*',1),(16,'menu','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',37,38,0,'*',1),(17,'menu','com_search','Search','','Search','index.php?option=com_search','component',0,1,1,19,0,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',29,30,0,'*',1),(18,'menu','com_weblinks','Weblinks','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',31,36,0,'*',1),(19,'menu','com_weblinks_links','Links','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',32,33,0,'*',1),(20,'menu','com_weblinks_categories','Categories','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',34,35,0,'*',1),(101,'mainmenu','Home','home','','home','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',39,40,1,'*',0),(102,'mainmenu','Template','template','','template','#','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"2\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',41,134,0,'*',0),(103,'mainmenu','Template articles','template-articles','','template/lorem-ipsum/template-articles','#','url',1,123,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',43,56,0,'*',0),(104,'mainmenu','Typography','typography','','template/lorem-ipsum/template-articles/typography','index.php?option=com_content&view=article&id=1','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" demo_typography\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" demo_typography\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',44,45,0,'*',0),(105,'mainmenu','Error page','error-page','','template/lorem-ipsum/template-articles/error-page','?option=non-existing-component','url',1,103,4,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',46,47,0,'*',0),(106,'mainmenu','Offline page','offline-page','','template/lorem-ipsum/template-articles/offline-page','?tmpl=offline','url',1,103,4,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',48,49,0,'*',0),(107,'mainmenu','Module positions','module-positions','','template/lorem-ipsum/module-positions','index.php?option=com_content&view=article&id=2','component',1,123,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',57,58,0,'*',0),(108,'mainmenu','Messages','messages','','template/lorem-ipsum/template-articles/messages','index.php?option=com_content&view=article&id=3','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',50,51,0,'*',0),(109,'mainmenu','Chrome frame','chrome-frame','','template/lorem-ipsum/template-articles/chrome-frame','index.php?option=com_content&view=article&id=4','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',52,53,0,'*',0),(110,'mainmenu','Menu types','menu-types','','menu-types','index.php?option=com_content&view=article&id=5','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',135,142,0,'*',0),(111,'mainmenu','Dropline menu','dropline-menu','','menu-types/dropline-menu','index.php?option=com_content&view=article&id=16','component',1,110,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',138,139,0,'*',0),(112,'mainmenu','Split menu','split-menu','','menu-types/split-menu','index.php?option=com_content&view=article&id=15','component',1,110,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',140,141,0,'*',0),(113,'mainmenu','Layouts','layouts','','template/lorem-ipsum-ii/layouts','#','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',63,82,0,'*',0),(114,'mainmenu','Right column','right-column','','template/lorem-ipsum-ii/layouts/right-column','index.php?option=com_content&view=article&id=6','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',64,65,0,'*',0),(115,'mainmenu','Right two columns','right-two-columns','','template/lorem-ipsum-ii/layouts/right-two-columns','index.php?option=com_content&view=article&id=7','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',66,67,0,'*',0),(116,'mainmenu','Left column','left-column','','template/lorem-ipsum-ii/layouts/left-column','index.php?option=com_content&view=article&id=8','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',68,69,0,'*',0),(117,'mainmenu','Left two columns','left-two-columns','','template/lorem-ipsum-ii/layouts/left-two-columns','index.php?option=com_content&view=article&id=9','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',70,71,0,'*',0),(118,'mainmenu','Content inset left','content-inset-left','','template/lorem-ipsum-ii/layouts/content-inset-left','index.php?option=com_content&view=article&id=10','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',72,73,0,'*',0),(119,'mainmenu','Content inset both','content-inset-both','','template/lorem-ipsum-ii/layouts/content-inset-both','index.php?option=com_content&view=article&id=12','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',74,75,0,'*',0),(120,'mainmenu','Content inset right','content-inset-right','','template/lorem-ipsum-ii/layouts/content-inset-right','index.php?option=com_content&view=article&id=11','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',76,77,0,'*',0),(121,'mainmenu','Content inset + column','content-inset-column','','template/lorem-ipsum-ii/layouts/content-inset-column','index.php?option=com_content&view=article&id=13','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',78,79,0,'*',0),(122,'mainmenu','Content inset + column (2x)','content-inset-column-2x','','template/lorem-ipsum-ii/layouts/content-inset-column-2x','index.php?option=com_content&view=article&id=14','component',1,113,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',80,81,0,'*',0),(123,'mainmenu','Lorem ipsum','lorem-ipsum','','template/lorem-ipsum','#','url',1,102,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"Group1\",\"gk_cols\":\"1\",\"gk_group\":\"1\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',42,61,0,'*',0),(124,'mainmenu','Lorem ipsum II','lorem-ipsum-ii','','template/lorem-ipsum-ii','#','url',1,102,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"Group2\",\"gk_cols\":\"1\",\"gk_group\":\"1\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',62,133,0,'*',0),(125,'mainmenu','Who\'s online','2011-01-12-23-23-21','','modules-menu/2011-01-12-23-23-21','index.php?option=com_content&view=archive','url',1,137,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"pos\",\"gk_subcontent_pos_positions\":\"menu1\"}',144,145,0,'*',0),(126,'mainmenu','GK Menu','gk-menu','','menu-types/gk-menu','index.php?option=com_content&view=article&id=17','component',1,110,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',136,137,0,'*',0),(127,'mainmenu','Module variations','module-variations','','template/lorem-ipsum/module-variations','index.php?option=com_content&view=article&id=18','component',1,123,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',59,60,0,'*',0),(128,'mainmenu','Joomla pages I','joomla-pages-i','','template/lorem-ipsum-ii/joomla-pages-i','#','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',83,100,0,'*',0),(129,'mainmenu','Contact categories','contact-categories','','template/lorem-ipsum-ii/joomla-pages-i/contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',84,85,0,'*',0),(130,'mainmenu','Contacts in Category','contacts-in-category','','template/lorem-ipsum-ii/joomla-pages-i/contacts-in-category','index.php?option=com_contact&view=category&id=10','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"0\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"1\",\"show_fax_headings\":\"1\",\"show_suburb_headings\":\"0\",\"show_state_headings\":\"0\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',86,87,0,'*',0),(131,'mainmenu','Single Contact','single-contact','','template/lorem-ipsum-ii/joomla-pages-i/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"0\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',88,89,0,'*',0),(132,'mainmenu','Weblink single category','weblink-single-category','','template/lorem-ipsum-ii/joomla-pages-i/weblink-single-category','index.php?option=com_weblinks&view=category&id=13','component',1,128,4,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',90,91,0,'*',0),(134,'mainmenu','Web Link Categories Link','web-link-categories-link','','template/lorem-ipsum-ii/joomla-pages-i/web-link-categories-link','index.php?option=com_weblinks&view=categories&id=0','component',1,128,4,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',92,93,0,'*',0),(135,'mainmenu','Joomla Pages II','joomla-pages-ii','','template/lorem-ipsum-ii/joomla-pages-ii','#','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',101,116,0,'*',0),(136,'mainmenu','News feeds categories list','news-feeds-categories-list','','template/lorem-ipsum-ii/joomla-pages-ii/news-feeds-categories-list','index.php?option=com_newsfeeds&view=categories&id=0','component',1,135,4,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',102,103,0,'*',0),(137,'mainmenu','Modules menu','modules-menu','','modules-menu','#','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',143,146,0,'*',0),(138,'mainmenu','News feeds in a category','news-feeds-in-a-category','','template/lorem-ipsum-ii/joomla-pages-ii/news-feeds-in-a-category','index.php?option=com_weblinks&view=category&id=13','component',1,135,4,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',104,105,0,'*',0),(139,'mainmenu','User login','user-login','','template/lorem-ipsum-ii/joomla-pages-ii/user-login','index.php?option=com_users&view=login','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',106,107,0,'*',0),(140,'mainmenu','User registration','user-registration','','template/lorem-ipsum-ii/joomla-pages-ii/user-registration','index.php?option=com_users&view=registration','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',108,109,0,'*',0),(141,'mainmenu','User profile','user-profile','','template/lorem-ipsum-ii/joomla-pages-ii/user-profile','index.php?option=com_users&view=profile','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',110,111,0,'*',0),(142,'mainmenu','User remind','user-remind','','template/lorem-ipsum-ii/joomla-pages-ii/user-remind','index.php?option=com_users&view=remind','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',112,113,0,'*',0),(143,'mainmenu','Password reset','password-reset','','template/lorem-ipsum-ii/joomla-pages-ii/password-reset','index.php?option=com_users&view=reset','component',1,135,4,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',114,115,0,'*',0),(144,'mainmenu','Featured contacts','featured-contacts','','template/lorem-ipsum-ii/joomla-pages-i/featured-contacts','index.php?option=com_contact&view=featured','component',1,128,4,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',94,95,0,'*',0),(145,'mainmenu','Joomla pages III','joomla-pages-iii','','template/lorem-ipsum-ii/joomla-pages-iii','','url',1,124,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',117,132,0,'*',0),(146,'mainmenu','Archieved Articles','archieved-articles','','template/lorem-ipsum-ii/joomla-pages-iii/archieved-articles','index.php?option=com_content&view=archive','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',118,119,0,'*',0),(147,'mainmenu','Single Article','single-article','','template/lorem-ipsum-ii/joomla-pages-iii/single-article','index.php?option=com_content&view=article&id=24','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',120,121,0,'*',0),(148,'mainmenu','Categories List','categories-list','','template/lorem-ipsum-ii/joomla-pages-iii/categories-list','index.php?option=com_content&view=categories&id=0','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',122,123,0,'*',0),(149,'mainmenu','Blog Layout','blog-layout','','template/lorem-ipsum-ii/joomla-pages-iii/blog-layout','index.php?option=com_content&view=category&layout=blog&id=7','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',124,125,0,'*',0),(150,'mainmenu','Category List','category-list','','template/lorem-ipsum-ii/joomla-pages-iii/category-list','index.php?option=com_content&view=category&id=7','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',126,127,0,'*',0),(151,'mainmenu','Featured Articles','featured-articles','','template/lorem-ipsum-ii/joomla-pages-iii/featured-articles','index.php?option=com_content&view=featured','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',128,129,0,'*',0),(152,'footmenu','About Joomla!','about-joomla','','about-joomla','index.php?option=com_content&view=article&id=4','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',147,148,0,'*',0),(153,'footmenu','Features','features','','features','index.php?option=com_content&view=article&id=18','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',149,150,0,'*',0),(154,'footmenu','News','news','','news','index.php?option=com_content&view=article&id=1','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',151,152,0,'*',0),(155,'footmenu','The Community','the-community','','the-community','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',153,154,0,'*',0),(156,'mobile-menu','Home','home-2','','home-2','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',155,156,0,'*',0),(157,'mobile-menu','Template articles','template-articles','','template-articles','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',157,168,0,'*',0),(158,'mobile-menu','Typography','typography','','template-articles/typography','index.php?option=com_content&view=article&id=1','component',1,157,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" demo_typography\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" demo_typography\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',158,159,0,'*',0),(159,'mobile-menu','Error page','error-page','','template-articles/error-page','?option=non-existing-component','url',1,157,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',160,161,0,'*',0),(160,'mobile-menu','Offline page','offline-page','','template-articles/offline-page','?tmpl=offline','url',1,157,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',162,163,0,'*',0),(161,'mobile-menu','Messages','messages','','template-articles/messages','index.php?option=com_content&view=article&id=3','component',1,157,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',164,165,0,'*',0),(162,'mobile-menu','Chrome frame','chrome-frame','','template-articles/chrome-frame','index.php?option=com_content&view=article&id=4','component',1,157,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',166,167,0,'*',0),(175,'mobile-menu','Joomla pages I','joomla-pages-i','','joomla-pages-i','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',169,182,0,'*',0),(176,'mobile-menu','Contact categories','contact-categories','','joomla-pages-i/contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',170,171,0,'*',0),(177,'mobile-menu','Contacts in Category','contacts-in-category','','joomla-pages-i/contacts-in-category','index.php?option=com_contact&view=category&id=10','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"0\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"1\",\"show_fax_headings\":\"1\",\"show_suburb_headings\":\"0\",\"show_state_headings\":\"0\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',172,173,0,'*',0),(178,'mobile-menu','Single Contact','single-contact','','joomla-pages-i/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"0\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',174,175,0,'*',0),(179,'mobile-menu','Weblink single category','weblink-single-category','','joomla-pages-i/weblink-single-category','index.php?option=com_weblinks&view=category&id=13','component',1,175,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',176,177,0,'*',0),(180,'mobile-menu','Web Link Categories Link','web-link-categories-link','','joomla-pages-i/web-link-categories-link','index.php?option=com_weblinks&view=categories&id=0','component',1,175,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',178,179,0,'*',0),(181,'mobile-menu','Featured contacts','featured-contacts','','joomla-pages-i/featured-contacts','index.php?option=com_contact&view=featured','component',1,175,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',180,181,0,'*',0),(182,'mobile-menu','Joomla Pages II','joomla-pages-ii','','joomla-pages-ii','index.php?Itemid=','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',183,198,0,'*',0),(183,'mobile-menu','News feeds categories list','news-feeds-categories-list','','joomla-pages-ii/news-feeds-categories-list','index.php?option=com_newsfeeds&view=categories&id=0','component',1,182,2,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',184,185,0,'*',0),(184,'mobile-menu','News feeds in a category','news-feeds-in-a-category','','joomla-pages-ii/news-feeds-in-a-category','index.php?option=com_weblinks&view=category&id=13','component',1,182,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',186,187,0,'*',0),(185,'mobile-menu','User login','user-login','','joomla-pages-ii/user-login','index.php?option=com_users&view=login','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',188,189,0,'*',0),(186,'mobile-menu','User registration','user-registration','','joomla-pages-ii/user-registration','index.php?option=com_users&view=registration','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',190,191,0,'*',0),(187,'mobile-menu','User profile','user-profile','','joomla-pages-ii/user-profile','index.php?option=com_users&view=profile','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',192,193,0,'*',0),(188,'mobile-menu','User remind','user-remind','','joomla-pages-ii/user-remind','index.php?option=com_users&view=remind','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',194,195,0,'*',0),(189,'mobile-menu','Password reset','password-reset','','joomla-pages-ii/password-reset','index.php?option=com_users&view=reset','component',1,182,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',196,197,0,'*',0),(190,'mobile-menu','Joomla pages III','joomla-pages-iii','','joomla-pages-iii','index.php?Itemid=','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',199,212,0,'*',0),(191,'mobile-menu','Archieved Articles','archieved-articles','','joomla-pages-iii/archieved-articles','index.php?option=com_content&view=archive','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',200,201,0,'*',0),(192,'mobile-menu','Single Article','single-article','','joomla-pages-iii/single-article','index.php?option=com_content&view=article&id=4','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',202,203,0,'*',0),(193,'mobile-menu','Categories List','categories-list','','joomla-pages-iii/categories-list','index.php?option=com_content&view=categories&id=0','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',204,205,0,'*',0),(194,'mobile-menu','Blog Layout','blog-layout','','joomla-pages-iii/blog-layout','index.php?option=com_content&view=category&layout=blog&id=7','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',206,207,0,'*',0),(195,'mobile-menu','Category List','category-list','','joomla-pages-iii/category-list','index.php?option=com_content&view=category&id=7','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',208,209,0,'*',0),(196,'mobile-menu','Featured Articles','featured-articles','','joomla-pages-iii/featured-articles','index.php?option=com_content&view=featured','component',1,190,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',210,211,0,'*',0),(198,'mainmenu','IE6 Style','ie-6-style','','template/lorem-ipsum/template-articles/ie-6-style','index.php?option=com_content&view=article&id=23','component',1,103,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',54,55,0,'*',0),(199,'mainemu','Your Profile','your-profile','','your-profile','index.php?option=com_users&view=profile','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',213,214,0,'*',0),(200,'mainemu','Edit Profile','edit-profile','','edit-profile','index.php?option=com_users&view=profile&layout=edit','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',215,216,0,'*',0),(201,'mainemu','Create Article','create-article','','create-article','index.php?option=com_content&view=form&layout=edit','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',217,218,0,'*',0),(202,'mainemu','Submit a Web Link','submit-a-web-link','','submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,1,1,21,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',219,220,0,'*',0),(204,'mainmenu','K2','2011-07-28-18-14-23','','2011-07-28-18-14-23','http://getk2.org/','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',221,236,0,'*',0),(205,'mainmenu','item','item','','2011-07-28-18-14-23/item','index.php?option=com_k2&view=item&layout=item&id=9','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',222,223,0,'*',0),(206,'mainmenu','Categories','categories','','2011-07-28-18-14-23/categories','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=1','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"1\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',224,231,0,'*',0),(207,'mainmenu','Financial Adviser','financial-adviser','','2011-07-28-18-14-23/categories/financial-adviser','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=2','component',1,206,3,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"2\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',225,226,0,'*',0),(208,'mainmenu','Investment Guide','investment-guide','','2011-07-28-18-14-23/categories/investment-guide','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=3','component',1,206,3,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"3\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',227,228,0,'*',0),(209,'mainmenu','Market Center','market-center','','2011-07-28-18-14-23/categories/market-center','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=4','component',1,206,3,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"4\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',229,230,0,'*',0),(210,'mainmenu','User','user','','2011-07-28-18-14-23/user','index.php?option=com_k2&view=itemlist&layout=user&id=42&task=user','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"feedLink\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',232,233,0,'*',0),(211,'mainmenu','Tag','tag','','2011-07-28-18-14-23/tag','index.php?option=com_k2&view=itemlist&layout=tag&tag=Business&task=tag','component',1,204,2,10022,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"categoriesFilter\":[\"2\",\"3\",\"4\"],\"tagOrdering\":\"\",\"feedLink\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',234,235,0,'*',0),(212,'mainmenu','News','2011-08-19-13-59-20','','2011-08-19-13-59-20','#','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',237,244,0,'*',0),(213,'mainmenu','Financial adviser','financial-adviser','','2011-08-19-13-59-20/financial-adviser','index.php?option=com_content&view=category&layout=blog&id=18','component',1,212,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"2\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',238,239,0,'*',0),(214,'mainmenu','Investment Guide','investment-guide','','2011-08-19-13-59-20/investment-guide','index.php?option=com_content&view=category&layout=blog&id=19','component',1,212,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',240,241,0,'*',0),(215,'mainmenu','Market Center','market-center','','2011-08-19-13-59-20/market-center','index.php?option=com_content&view=category&layout=blog&id=20','component',1,212,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',242,243,0,'*',0),(216,'mainmenu','Page Break','page-break','','template/lorem-ipsum-ii/joomla-pages-i/page-break','index.php?option=com_content&view=article&id=38','component',1,128,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',96,97,0,'*',0),(271,'main','K2_INFORMATION','k2information','','comk2/k2information','index.php?option=com_k2&view=info','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',264,265,0,'',1),(268,'main','K2_EXTRA_FIELDS','k2extrafields','','comk2/k2extrafields','index.php?option=com_k2&view=extrafields','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',258,259,0,'',1),(269,'main','K2_EXTRA_FIELD_GROUPS','k2extrafieldgroups','','comk2/k2extrafieldgroups','index.php?option=com_k2&view=extrafieldsgroups','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',260,261,0,'',1),(270,'main','K2_MEDIA_MANAGER','k2mediamanager','','comk2/k2mediamanager','index.php?option=com_k2&view=media','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',262,263,0,'',1),(267,'main','K2_USER_GROUPS','k2usergroups','','comk2/k2usergroups','index.php?option=com_k2&view=usergroups','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',256,257,0,'',1),(266,'main','K2_USERS','k2users','','comk2/k2users','index.php?option=com_k2&view=users','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',254,255,0,'',1),(265,'main','K2_COMMENTS','k2comments','','comk2/k2comments','index.php?option=com_k2&view=comments','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',252,253,0,'',1),(264,'main','K2_TAGS','k2tags','','comk2/k2tags','index.php?option=com_k2&view=tags','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',250,251,0,'',1),(263,'main','K2_CATEGORIES','k2categories','','comk2/k2categories','index.php?option=com_k2&view=categories','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',248,249,0,'',1),(261,'main','COM_K2','comk2','','comk2','index.php?option=com_k2','component',0,1,1,10022,0,0,'0000-00-00 00:00:00',0,1,'../media/k2/assets/images/system/k2_16x16.png',0,'',245,266,0,'',1),(262,'main','K2_ITEMS','k2items','','comk2/k2items','index.php?option=com_k2&view=items','component',0,261,2,10022,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',246,247,0,'',1),(21,'menu','com_finder','Smart Search','','Smart Search','index.php?option=com_finder','component',0,1,1,27,0,0,'0000-00-00 00:00:00',0,0,'class:finder',0,'',41,42,0,'*',1),(272,'mainmenu','Smart Search','smart-search','','template/lorem-ipsum-ii/joomla-pages-i/smart-search','index.php?option=com_finder&view=search&q=&f=','component',1,128,4,27,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_date_filters\":\"\",\"show_advanced\":\"\",\"expand_advanced\":\"\",\"show_description\":\"\",\"description_length\":255,\"show_url\":\"\",\"show_pagination_limit\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"allow_empty_query\":\"0\",\"sort_order\":\"\",\"sort_direction\":\"\",\"show_feed\":\"0\",\"show_feed_text\":\"0\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',98,99,0,'*',0),(273,'mainmenu','Article Standarized Layout','article-standarized-layout','','template/lorem-ipsum-ii/joomla-pages-iii/article-standarized-layout','index.php?option=com_content&view=article&id=4','component',1,145,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\"}',130,131,0,'*',0);


--
-- Table structure for table `#__menu_types`
--



CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu_types`
--


INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES (1,'mainmenu','Main Menu','The main menu for the site'),(2,'footmenu','Footer menu',''),(3,'mobile-menu','Mobile menu','Menu for mobile devices'),(4,'mainemu','User Menu','');


--
-- Table structure for table `#__messages`
--



CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages`
--




--
-- Table structure for table `#__messages_cfg`
--



CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages_cfg`
--




--
-- Table structure for table `#__modules`
--



CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned DEFAULT NULL,
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=121 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules`
--


INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES (1,'Main Menu','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(6,'Unread Messages','','',1,'header',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_unread',3,1,'',1,'*'),(7,'Online Users','','',2,'header',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_online',3,1,'',1,'*'),(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),(14,'User Status','','',2,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),(16,'Sign In','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,0,'{\"pretext\":\"Log in to your account or \",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*'),(17,'Breadcrumbs','','',1,'position-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,1,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(18,'Banners','','',1,'position-5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"27\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(19,'Right column (right-top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(23,'Left column (left-bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(20,'Right column (right-left)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(22,'Right column (right-bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(21,'Right column (right-right)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'right_right',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(24,'Left column (left-top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(25,'Left column (left-right)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_right',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(26,'Left column (left-left)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'left_left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(27,'Inset left (inset1)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'inset1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(28,'Mainbody top (mainbody_top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(29,'Inset right (inset2)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'inset2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(30,'Mainbody bottom (mainbody_bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(31,'Top module (top)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(32,'Bottom module (bottom)','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris aliquam tincidunt velit id varius. Sed arcu quam, tempus eu facilisis non, pulvinar at ligula. Duis sem sapien, sollicitudin eu sollicitudin sed, dignissim vitae arcu. Integer consequat dui nec nisl scelerisque hendrerit.</p>',1,'bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(33,'Pinguin video','','<p>\r\n\r\n<param name=\"movie\" value=\"http://www.youtube.com/v/eKG08z85DtY?fs=1&amp;hl=pl_PL&amp;rel=0\" />\r\n<param name=\"allowFullScreen\" value=\"true\" />\r\n<param name=\"allowscriptaccess\" value=\"always\" />\r\n\r\n</p>',1,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(34,'Statistics','','',0,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_stats',1,1,'{\"serverinfo\":\"0\",\"siteinfo\":\"0\",\"counter\":\"0\",\"increase\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(35,'Who\'s online','','',0,'menu1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_whosonline',1,1,'{\"showmode\":\"0\",\"linknames\":\"0\",\"linktowhat\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*'),(36,'\"badge-new\"','','',0,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-new\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(37,'\"badge-hot\"','','',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-hot\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(38,'\"badge-top\"','','',1,'top3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-top\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(39,'\"badge-soon\"','','',1,'top4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"4\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_featured\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" badge-soon\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(40,'Default module','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',0,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(41,'Suffix \" light1\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(42,'Suffix \" light2\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(43,'Suffix \" light3\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(44,'Suffix \" border1\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(45,'Suffix \" border2\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(46,'Suffix \" border3\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(47,'Suffix \" border4\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'top10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border4\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(48,'Suffix  \" smalltitle\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" smalltitle\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(49,'Suffix      \" bigtitle\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet. In tincidunt vestibulum laoreet.  Phasellus pellentesque venenatis iaculis. Aenean posuere massa vitae  ipsum rutrum lacinia.  In tincidunt vestibulum laoreet.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" bigtitle\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(50,'Suffix \"_menu color1\"','','<ul class=\"menu\">\r\n<li class=\"item1\"><a href=\"../oct2010/\"><span>Home</span></a></li>\r\n<li class=\"parent\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=19&amp;Itemid=27\"><span>Template</span></a> </li>\r\n<li class=\"parent item56\"><a href=\"#\"><span>Template articles</span></a></li>\r\n<li id=\"current\" class=\"active item59\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=47&amp;Itemid=59\"><span>Module variations</span></a></li>\r\n<li class=\"item117\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=65&amp;Itemid=117\"><span>GK Tab variations</span></a></li>\r\n<li class=\"item60\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=48&amp;Itemid=60\"><span>Module positions</span></a></li>\r\n</ul>',0,'left_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu color1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(51,'Suffix \"_menu\"','','<ul class=\"menu\">\r\n<li class=\"item1\"><a href=\"../oct2010/\"><span>Home</span></a></li>\r\n<li class=\"parent\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=19&amp;Itemid=27\"><span>Template</span></a> </li>\r\n<li class=\"parent item56\"><a href=\"#\"><span>Template articles</span></a></li>\r\n<li id=\"current\" class=\"active item59\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=47&amp;Itemid=59\"><span>Module variations</span></a></li>\r\n<li class=\"item117\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=65&amp;Itemid=117\"><span>GK Tab variations</span></a></li>\r\n<li class=\"item60\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=48&amp;Itemid=60\"><span>Module positions</span></a></li>\r\n</ul>',1,'left_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(52,'Suffix \"_text\"','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"5\",\"cid\":\"0\",\"catid\":[\"3\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured Links:\",\"footer_text\":\"<a href=\\\"http:\\/\\/www.joomla.org\\\">Ads by Joomla!<\\/a>\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_text\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(53,'Suffix \" clear\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu  odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique  quis sagittis lectus imperdiet.</p>',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(54,'Our offers','','<ul>\r\n<li><a href=\"#\">New products</a></li>\r\n<li><a href=\"#\">Top sellers</a></li>\r\n<li><a href=\"#\">Specials</a></li>\r\n<li><a href=\"#\">Manufacturers</a></li>\r\n<li><a href=\"#\">Suppliers</a></li>\r\n</ul>',0,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(55,'Shipping Info','','<ul>\r\n<li><a href=\"#\">Returns</a></li>\r\n<li><a href=\"#\">Delivery</a></li>\r\n<li><a href=\"#\">Customer Service</a></li>\r\n<li><a href=\"#\">Gift Cards</a></li>\r\n<li><a href=\"#\">Extended Service Plan</a></li>\r\n</ul>',0,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(56,'Account','','<ul>\r\n<li><a href=\"#\">Your Account</a></li>\r\n<li><a href=\"#\">Personal information</a></li>\r\n<li><a href=\"#\">Addresses</a></li>\r\n<li><a href=\"#\">Discount</a></li>\r\n<li><a href=\"#\">Orders history</a></li>\r\n</ul>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(57,'Support','','<ul>\r\n<li><a href=\"#\">Site Map</a></li>\r\n<li><a href=\"#\">Search Terms</a></li>\r\n<li><a href=\"#\">Advanced Search</a></li>\r\n<li><a href=\"#\">Mobile</a></li>\r\n<li><a href=\"#\">Contact Us</a></li>\r\n</ul>',0,'bottom5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(58,'Sell','','<ul>\r\n<li><a href=\"#\">Top-rated sellers</a></li>\r\n<li><a href=\"#\">Affiliates</a></li>\r\n<li><a href=\"#\">Learn to sell</a></li>\r\n<li><a href=\"#\">Bestsellers</a></li>\r\n<li><a href=\"#\">Sell is an art</a></li>\r\n</ul>',1,'bottom6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(59,'Frontpage - demo content','','<p><img src=\"images/demo/img4.jpg\" alt=\"Mailing list\" style=\"display: block;\" /></p>\r\n<p><small>The Admin Console allows you to control every aspect of Email Temlate - in multiple languages. </small></p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(60,'Frontpage - demo content','','<div>\r\n<h3>Quick &amp; Easy deployment</h3>\r\n<img src=\"images/demo/img1.png\" alt=\"Quick &amp; Easy deployment\" />Add your own text and images as you please, and arrange them until you\'re completely satisfied with your creation.</div>\r\n<div>\r\n<h3>Track and analyze your email</h3>\r\n<img src=\"images/demo/img2.png\" alt=\"Track and analyze your email\" />Add your own text and images as you please, and arrange them until you\'re completely satisfied with your creation.</div>\r\n<div>\r\n<h3>Manage lists and subscribers</h3>\r\n<img src=\"images/demo/img3.png\" alt=\"Manage lists and subscribers\" />Add your own text and images as you please, and arrange them until you\'re completely satisfied with your creation.</div>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light3 demoFront1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(61,'Frontpage - demo content','','<div>\r\n<h1>Email marketing that is Powerful, Easy and Fun!</h1>\r\nStore up to 1,000 subscribers - Send up to 6,000 emails a month.</div>\r\n<p><a class=\"buttonGreen\" href=\"#\">Sign Up Free!</a></p>',1,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" demoFront2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(62,'User Menu','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',2,1,'{\"menutype\":\"mainemu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(63,'Frontpage - demo content','','Get in touch\r\n<h1>+48 800 801 5577</h1>',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(72,'Categories','','',1,'left_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(64,'Frontpage - demo content','','<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>Our clients are blown away when we demo PenguinMail.\r\n<p><strong><em><small>Robert Gavick, Designer</small></em></strong></p>\r\n</div>\r\n</div>\r\n</blockquote>',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(65,'Search','','',0,'search',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,0,'{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(66,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"0\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(67,'Footer','','',0,'footer_nav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_footer',1,0,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(68,'Footer menu','','',1,'footer_nav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"footmenu\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(69,'Test ','','<param name=\"movie\" value=\"http://www.youtube.com/v/EnlCz1P95WM?fs=1&amp;hl=pl_PL&amp;rel=0\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowscriptaccess\" value=\"always\"></param>',1,'menu2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(70,'mod_news_pro_gk4','','',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_width\":\"100\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"7\"],\"com_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"art_padding\":\"0 20px 20px 0\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"3\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"160\",\"img_height\":\"120\",\"img_margin\":\"6px 14px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"top_interface_style\":\"arrows_with_pagination\",\"bottom_interface_style\":\"arrows_with_counter\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(71,'mod_tabs_gk4','','',1,'header',42,'2011-08-18 14:15:48','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_tabs_gk4',1,0,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\" clear tabHeader\",\"module_height\":\"377\",\"tabs_data\":\"[{\\\"name\\\":\\\"Tab 1\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]div class=\\\\\\\"tabHeaderStyle\\\\\\\"[rightbracket]\\\\n[leftbracket]h1 class=\\\\\\\"tabH1\\\\\\\"[rightbracket]Create and send [leftbracket]strong[rightbracket]newsletters[leftbracket]\\/strong[rightbracket] [leftbracket]span[rightbracket]in a second.[leftbracket]\\/span[rightbracket][leftbracket]\\/h1[rightbracket]\\\\n[leftbracket]a class=\\\\\\\"bigButton\\\\\\\" href=\\\\\\\"#\\\\\\\"[rightbracket]Try It Now[leftbracket]span[rightbracket]30-day trial, then $30[leftbracket]\\/span[rightbracket][leftbracket]\\/a[rightbracket][leftbracket]\\/div[rightbracket]\\\\n[leftbracket]img src=\\\\\\\"images\\/demo\\/header.png\\\\\\\" alt=\\\\\\\"Mail\\\\\\\" style=\\\\\\\"border: 0; float: right; margin: 0px;\\\\\\\" \\/[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Tab 2\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]img src=\\\\\\\"images\\/demo\\/img8.png\\\\\\\" alt=\\\\\\\"Newsletter\\\\\\\" \\/[rightbracket][leftbracket]br \\/[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Tab 3\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"[leftbracket]img src=\\\\\\\"images\\/demo\\/img7.png\\\\\\\" alt=\\\\\\\"demo-image\\\\\\\" \\/[rightbracket]\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"}]\",\"buttons\":\"0\",\"tabs_position\":\"bottom\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"0\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"slider\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(73,'K2 Comments','','',1,'right_bottom',42,'2011-08-17 17:09:17','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_comments',1,1,'{\"moduleclass_sfx\":\" light3\",\"module_usage\":\"0\",\"catfilter\":\"0\",\"comments_limit\":\"3\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"0\",\"itemCategory\":\"0\",\"feed\":\"0\",\"commenters_limit\":\"3\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(74,'K2 Content','','',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_content',1,1,'{\"moduleclass_sfx\":\" border\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"catfilter\":\"1\",\"category_id\":[\"2\",\"3\",\"4\"],\"getChildren\":\"0\",\"itemCount\":\"2\",\"itemsOrdering\":\"rand\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"0\",\"itemTitle\":\"1\",\"itemAuthor\":\"0\",\"itemAuthorAvatar\":\"0\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"30\",\"userDescription\":\"0\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"16\",\"itemImage\":\"1\",\"itemImgSize\":\"Medium\",\"itemVideo\":\"0\",\"itemVideoCaption\":\"0\",\"itemVideoCredits\":\"0\",\"itemAttachments\":\"0\",\"itemTags\":\"0\",\"itemCategory\":\"0\",\"itemDateCreated\":\"0\",\"itemHits\":\"0\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"0\",\"feed\":\"1\",\"itemPreText\":\"Find some of our top services and take advantage of the most professional and determine team.\",\"itemCustomLink\":\"0\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkTitle\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(75,'K2 Login','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_login',1,1,'',0,'*'),(76,'K2 Categories','','',1,'right_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"_menu\",\"module_usage\":\"4\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(77,'K2 Users','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_users',1,1,'',0,'*'),(78,'K2 QuickIcons (admin)','','',99,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_quickicons',3,1,'',1,'*'),(79,'K2 Stats (admin)','','',0,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_stats',3,1,'',1,'*'),(80,'Default module','','',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(81,'Suffix \" smaller\"','','',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" smaller\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(82,'Suffix \" color\"','','',1,'top3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(83,'Suffix \" font1\"','','',1,'top7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" font1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(84,'Suffix \" clear\" ','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent eu   odio erat, ac imperdiet justo. Nullam elementum enim et nulla tristique   quis sagittis lectus imperdiet.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Curabitur blandit  tempus porttitor. Etiam porta sem malesuada magna mollis euismod.</p>',1,'top8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(85,'Suffix \" icon-info\"','','<p>You can also use a lot of suffixes with icons. There is available 13   suffixes with prefix   \"icon-\": icon-rss, icon-mail, .icon-alert, .icon-cog, .icon-clock, .icon-calendar, .icon-chat, .icon-marker, .icon-document, .icon-mac, .icon-ipad, .icon-info, .icon-access.</p>',1,'top10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-info\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(86,'Suffix \"_menu\"','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"2\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(87,'Suffix \" font2\"','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" font2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(88,'Suffix \" icon-cog\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-cog\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(89,'Suffix \" icon-clock\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-clock\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(90,'Suffix \" icon-mail\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-mail\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(91,'Suffix \" icon-marker\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-marker\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(92,'Suffix \" icon-chat\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-chat\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(93,'Suffix \" icon-calendar\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-calendar\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(94,'Suffix \" icon-ipad\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-ipad\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(95,'Suffix \" icon-document\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-document\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(96,'Suffix \" icon-rss\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-rss\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(97,'Suffix \" icon-alert\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-alert\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(98,'Suffix \" icon-access\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-access\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(99,'Suffix \" icon-mac\"','','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh,  ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla  sed consectetur.</p>',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" icon-mac\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(100,'Suffix \" color4\"','','',1,'user7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color4\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(101,'Suffix \" color3\"','','',1,'user8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(102,'Suffix \" color2\"','','',1,'user9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(103,'Suffix \" color1\"','','',1,'user10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" color1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(104,'Tabs color','','',1,'bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_tabs_gk4',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\" color\",\"module_height\":\"144\",\"tabs_data\":\"[{\\\"name\\\":\\\"First\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Second\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. \\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Third\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Aenean lacinia bibendum nulla sed consectetur. \\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"}]\",\"buttons\":\"0\",\"tabs_position\":\"top\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"0\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"slider\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"1\"}',0,'*'),(107,'News','','',1,'header2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_1\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"309\",\"module_font_size\":\"100\",\"data_source\":\"k2_articles\",\"com_articles\":\"34,37,27,26,31\",\"k2_articles\":\"9,12,2,1,6,8\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"16\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"1\",\"news_limit_type\":\"chars\",\"news_limit\":\"23\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 20px 0 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"74\",\"img_height\":\"74\",\"img_margin\":\"0 10px 18px 0\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"5\",\"simple_crop_bottom\":\"5\",\"simple_crop_left\":\"30\",\"simple_crop_right\":\"30\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"1\"}',0,'*'),(105,'Tabs default','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_tabs_gk4',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-tab-1\",\"moduleclass_sfx\":\"\",\"module_height\":\"170\",\"tabs_data\":\"[{\\\"name\\\":\\\"First\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\\u000a\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Second\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\\u000a \\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"},{\\\"name\\\":\\\"Third\\\",\\\"type\\\":\\\"xhtml\\\",\\\"content\\\":\\\"Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications.\\\\u000a\\\",\\\"published\\\":\\\"1\\\",\\\"access\\\":\\\"public\\\"}]\",\"buttons\":\"0\",\"tabs_position\":\"top\",\"styleCSS\":\"style1\",\"activator\":\"click\",\"animation\":\"0\",\"animation_speed\":\"250\",\"animation_interval\":\"5000\",\"animation_type\":\"slider\",\"animation_function\":\"Fx.Transitions.linear\",\"url_tab_selection\":\"1\",\"cookie_tab_selection\":\"0\",\"parse_plugins\":\"1\",\"useCSS\":\"0\",\"useScript\":\"1\"}',0,'*'),(106,'Image Show','','<p><img src=\"images/image_show.png\" border=\"0\" /></p>',1,'header1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),(108,'Popular','','',1,'user1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color1\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"none\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"0\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(109,'News','','',1,'user2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color2\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro2\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"title\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"0\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(110,'Top Rated ','','',1,'user3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color3\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro3\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"title\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\"}',0,'*'),(111,'Latest','','',1,'user4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\"  nsp color4\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro4\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":[\"18\",\"19\",\"20\"],\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"ordering\",\"news_sort_order\":\"ASC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"25\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"90\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHORS %DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"6\",\"links_amount\":\"2\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"pagination\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"65\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"0\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"3px 0px 3px 0px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(112,'mod_gk_register','','',1,'register',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_gk_register',1,1,'',0,'*'),(113,'NSP - Portal mode 2','','',2,'mainbody',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,0,'{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_2\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"2\",\"3\",\"4\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHOR %COMMENTS %DATE %HITS\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"123\",\"img_height\":\"82\",\"img_margin\":\"3px 5px 3px 5px\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"15\",\"simple_crop_right\":\"15\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\"}',0,'*'),(114,'NSP - Portal mode 3','','',1,'mainbody',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,0,'{\"moduleclass_sfx\":\" clean\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"Portal_Mode_3\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"3\",\"4\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"2\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"5\",\"news_portal_mode_4_amount\":\"10\",\"news_full_pages\":\"1\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"left\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"0\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"60\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%AUTHOR %COMMENTS %DATE %HITS %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 5px\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"2\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"0 10px 0 10px\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"204\",\"img_height\":\"138\",\"img_margin\":\"7px 20px 10px 0\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"7\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"20\",\"simple_crop_right\":\"20\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"1\"}',0,'*'),(115,'K2 Tag Cloud','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\" border1\",\"module_usage\":\"7\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"130\",\"cloud_limit\":\"20\",\"cloud_category\":[\"2\",\"3\",\"4\"],\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(116,'Advertise','','',1,'right_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"5\",\"cid\":\"0\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured links:\",\"footer_text\":\"<a href=\\\"http:\\/\\/www.joomla.org\\\">Ads by Joomla!<\\/a>\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_text\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),(117,'NSP GK4 suffix \" nsp\"','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"2\",\"3\",\"4\"],\"k2_articles\":\"\",\"news_sort_value\":\"hits\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"2\",\"news_full_pages\":\"2\",\"news_column\":\"2\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_counter\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"17\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"none\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"100\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"left\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE\",\"info2_format\":\"%COMMENTS %HITS\",\"category_link\":\"0\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 12px 0 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"left\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows_with_pagination\",\"links_margin\":\"20px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"90\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"1\",\"img_keep_aspect_ratio\":\"1\",\"img_width\":\"170\",\"img_height\":\"90\",\"img_margin\":\"0 0 20px\",\"img_bg\":\"#fff\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"10\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"10\",\"simple_crop_right\":\"10\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\"}',0,'*'),(118,'Image Show GK4','','',1,'header1',42,'2011-12-13 12:16:23','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_image_show_gk4',1,0,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-is-1\",\"moduleclass_sfx\":\"\",\"module_style\":\"gk_financial_business\",\"last_modification\":\"1313761171\",\"image_show_data\":\"[{\\\"name\\\":\\\"Strong technical team with innovative solutions\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide1.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#1\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Dedicated strategy workshop\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide2.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#2\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Creating a great team environment\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide3.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#3\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Top professional advisers support our customers\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide4.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#4\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Do you have a perfect business plan?\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/slide5.png\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"#\\\",\\\"url\\\":\\\"#5\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"}]\",\"config\":\"{\\\"gk_appsite1\\\":{\\\"gk_appsite1_image_width\\\":\\\"166\\\",\\\"gk_appsite1_image_height\\\":\\\"166\\\",\\\"gk_appsite1_image_bg\\\":\\\"#000000\\\",\\\"gk_appsite1_quality\\\":\\\"95\\\",\\\"gk_appsite1_show_text_block\\\":\\\"1\\\",\\\"gk_appsite1_text_block_x\\\":\\\"0\\\",\\\"gk_appsite1_text_block_y\\\":\\\"215\\\",\\\"gk_appsite1_text_block_width\\\":\\\"1000\\\",\\\"gk_appsite1_image_y\\\":\\\"65\\\",\\\"gk_appsite1_module_height\\\":\\\"450\\\",\\\"gk_appsite1_pagination\\\":\\\"1\\\",\\\"gk_appsite1_slide_links\\\":\\\"1\\\",\\\"gk_appsite1_animation_speed\\\":\\\"500\\\",\\\"gk_appsite1_animation_interval\\\":\\\"5000\\\",\\\"gk_appsite1_autoanimation\\\":\\\"1\\\"},\\\"gk_black_and_white\\\":{\\\"gk_black_and_white_image_width\\\":\\\"978\\\",\\\"gk_black_and_white_image_height\\\":\\\"362\\\",\\\"gk_black_and_white_image_bg\\\":\\\"#000000\\\",\\\"gk_black_and_white_quality\\\":\\\"95\\\",\\\"gk_black_and_white_text_block_position_x\\\":\\\"20\\\",\\\"gk_black_and_white_text_block_position_y\\\":\\\"20\\\",\\\"gk_black_and_white_text_block_width\\\":\\\"300\\\",\\\"gk_black_and_white_show_text_block\\\":\\\"1\\\",\\\"gk_black_and_white_clean_xhtml\\\":\\\"1\\\",\\\"gk_black_and_white_wordcount\\\":\\\"10\\\",\\\"gk_black_and_white_title_char_amount\\\":\\\"30\\\",\\\"gk_black_and_white_pagination\\\":\\\"1\\\",\\\"gk_black_and_white_pagination_position_x\\\":\\\"20\\\",\\\"gk_black_and_white_pagination_position_y\\\":\\\"320\\\",\\\"gk_black_and_white_show_readmore\\\":\\\"1\\\",\\\"gk_black_and_white_stripe_width\\\":\\\"60\\\",\\\"gk_black_and_white_slide_links\\\":\\\"1\\\",\\\"gk_black_and_white_animation_speed\\\":\\\"1800\\\",\\\"gk_black_and_white_animation_interval\\\":\\\"5000\\\",\\\"gk_black_and_white_autoanimation\\\":\\\"1\\\",\\\"gk_black_and_white_animation_type\\\":\\\"opacity\\\",\\\"gk_black_and_white_show_title_block\\\":\\\"1\\\",\\\"gk_black_and_white_title_link\\\":\\\"1\\\",\\\"gk_black_and_white_interface\\\":\\\"1\\\"},\\\"gk_cherrydesign\\\":{\\\"gk_cherrydesign_image_width\\\":\\\"480\\\",\\\"gk_cherrydesign_image_height\\\":\\\"320\\\",\\\"gk_cherrydesign_image_bg\\\":\\\"#000000\\\",\\\"gk_cherrydesign_quality\\\":\\\"95\\\",\\\"gk_cherrydesign_show_text_block\\\":\\\"1\\\",\\\"gk_cherrydesign_slide_links\\\":\\\"1\\\",\\\"gk_cherrydesign_pagination\\\":\\\"1\\\",\\\"gk_cherrydesign_pagination_position\\\":\\\"left\\\",\\\"gk_cherrydesign_readmore_text\\\":\\\"Read more...\\\",\\\"gk_cherrydesign_clean_xhtml\\\":\\\"1\\\",\\\"gk_cherrydesign_wordcount\\\":\\\"30\\\",\\\"gk_cherrydesign_animation_speed\\\":\\\"500\\\",\\\"gk_cherrydesign_animation_interval\\\":\\\"5000\\\",\\\"gk_cherrydesign_autoanimation\\\":\\\"1\\\",\\\"gk_cherrydesign_animation_type\\\":\\\"opacity\\\"},\\\"gk_coffe\\\":{\\\"gk_coffe_image_width\\\":\\\"480\\\",\\\"gk_coffe_image_height\\\":\\\"320\\\",\\\"gk_coffe_image_bg\\\":\\\"#000000\\\",\\\"gk_coffe_quality\\\":\\\"95\\\",\\\"gk_coffe_show_title_block\\\":\\\"1\\\",\\\"gk_coffe_title_link\\\":\\\"1\\\",\\\"gk_coffe_interface\\\":\\\"1\\\",\\\"gk_coffe_slide_links\\\":\\\"1\\\",\\\"gk_coffe_animation_speed\\\":\\\"500\\\",\\\"gk_coffe_animation_interval\\\":\\\"5000\\\",\\\"gk_coffe_autoanimation\\\":\\\"1\\\",\\\"gk_coffe_animation_type\\\":\\\"opacity\\\"},\\\"gk_corporate2\\\":{\\\"gk_corporate2_image_width\\\":\\\"480\\\",\\\"gk_corporate2_image_height\\\":\\\"320\\\",\\\"gk_corporate2_image_bg\\\":\\\"#000000\\\",\\\"gk_corporate2_quality\\\":\\\"95\\\",\\\"gk_corporate2_show_list\\\":\\\"1\\\",\\\"gk_corporate2_list_title_small\\\":\\\"Why to choose\\\",\\\"gk_corporate2_list_title_big\\\":\\\"our company\\\",\\\"gk_corporate2_list_char_count\\\":\\\"25\\\",\\\"gk_corporate2_list_text_overflow\\\":\\\"...\\\",\\\"gk_corporate2_image_position\\\":\\\"gkRightFloat\\\",\\\"gk_corporate2_list_position\\\":\\\"gkRightFloat\\\",\\\"gk_corporate2_art_width\\\":\\\"70\\\",\\\"gk_corporate2_title\\\":\\\"1\\\",\\\"gk_corporate2_title_link\\\":\\\"1\\\",\\\"gk_corporate2_clean_xhtml\\\":\\\"1\\\",\\\"gk_corporate2_wordcount\\\":\\\"30\\\",\\\"gk_corporate2_readmore_button\\\":\\\"1\\\",\\\"gk_corporate2_readmore_text\\\":\\\"Find more\\\",\\\"gk_corporate2_interface\\\":\\\"1\\\",\\\"gk_corporate2_interface_animation\\\":\\\"0\\\",\\\"gk_corporate2_animation_speed\\\":\\\"500\\\",\\\"gk_corporate2_animation_interval\\\":\\\"5000\\\",\\\"gk_corporate2_autoanimation\\\":\\\"1\\\",\\\"gk_corporate2_animation_type\\\":\\\"opacity\\\"},\\\"gk_financial_business\\\":{\\\"gk_financial_business_image_width\\\":\\\"750\\\",\\\"gk_financial_business_image_height\\\":\\\"310\\\",\\\"gk_financial_business_image_bg\\\":\\\"#000000\\\",\\\"gk_financial_business_quality\\\":\\\"95\\\",\\\"gk_financial_business_date_format\\\":\\\"d-m-Y\\\",\\\"gk_financial_business_interface\\\":\\\"1\\\",\\\"gk_financial_business_slide_links\\\":\\\"1\\\",\\\"gk_financial_business_animation_speed\\\":\\\"500\\\",\\\"gk_financial_business_animation_interval\\\":\\\"5000\\\",\\\"gk_financial_business_autoanimation\\\":\\\"1\\\",\\\"gk_financial_business_animation_type\\\":\\\"opacity\\\"},\\\"gk_gamebox\\\":{\\\"gk_gamebox_image_width\\\":\\\"640\\\",\\\"gk_gamebox_image_height\\\":\\\"360\\\",\\\"gk_gamebox_image_bg\\\":\\\"#000000\\\",\\\"gk_gamebox_quality\\\":\\\"95\\\",\\\"gk_gamebox_show_text_block\\\":\\\"1\\\",\\\"gk_gamebox_show_info\\\":\\\"1\\\",\\\"gk_gamebox_date_format\\\":\\\"A e, B Y\\\",\\\"gk_gamebox_author_name\\\":\\\"username\\\",\\\"gk_gamebox_info_format\\\":\\\"Written: %date by %author\\\",\\\"gk_gamebox_readmore_text\\\":\\\"Read more\\\",\\\"gk_gamebox_text_position\\\":\\\"280\\\",\\\"gk_gamebox_text_height\\\":\\\"80\\\",\\\"gk_gamebox_interface\\\":\\\"1\\\",\\\"gk_gamebox_slide_links\\\":\\\"1\\\",\\\"gk_gamebox_animation_speed\\\":\\\"500\\\",\\\"gk_gamebox_animation_interval\\\":\\\"5000\\\",\\\"gk_gamebox_autoanimation\\\":\\\"1\\\",\\\"gk_gamebox_animation_type\\\":\\\"opacity\\\"},\\\"gk_memovie\\\":{\\\"gk_memovie_image_width\\\":\\\"670\\\",\\\"gk_memovie_image_height\\\":\\\"313\\\",\\\"gk_memovie_image_bg\\\":\\\"#000000\\\",\\\"gk_memovie_quality\\\":\\\"95\\\",\\\"gk_memovie_interface\\\":\\\"1\\\",\\\"gk_memovie_interface_animation\\\":\\\"0\\\",\\\"gk_memovie_interface_x\\\":\\\"30\\\",\\\"gk_memovie_interface_y\\\":\\\"30\\\",\\\"gk_memovie_slide_links\\\":\\\"1\\\",\\\"gk_memovie_animation_speed\\\":\\\"500\\\",\\\"gk_memovie_animation_interval\\\":\\\"5000\\\",\\\"gk_memovie_autoanimation\\\":\\\"1\\\",\\\"gk_memovie_animation_type\\\":\\\"opacity\\\"},\\\"gk_musicity\\\":{\\\"gk_musicity_image_width\\\":\\\"627\\\",\\\"gk_musicity_image_height\\\":\\\"345\\\",\\\"gk_musicity_image_bg\\\":\\\"#000000\\\",\\\"gk_musicity_quality\\\":\\\"95\\\",\\\"gk_musicity_show_title_block\\\":\\\"1\\\",\\\"gk_musicity_show_date_block\\\":\\\"1\\\",\\\"gk_musicity_date_format\\\":\\\"F d, Y\\\",\\\"gk_musicity_interface\\\":\\\"1\\\",\\\"gk_musicity_title_block_y\\\":\\\"23\\\",\\\"gk_musicity_date_block_y\\\":\\\"14\\\",\\\"gk_musicity_slide_links\\\":\\\"1\\\",\\\"gk_musicity_animation_speed\\\":\\\"500\\\",\\\"gk_musicity_animation_interval\\\":\\\"5000\\\",\\\"gk_musicity_autoanimation\\\":\\\"1\\\",\\\"gk_musicity_animation_type\\\":\\\"opacity\\\"},\\\"gk_partyfreak\\\":{\\\"gk_partyfreak_image_width\\\":\\\"600\\\",\\\"gk_partyfreak_image_height\\\":\\\"600\\\",\\\"gk_partyfreak_thumb_width\\\":\\\"70\\\",\\\"gk_partyfreak_thumb_height\\\":\\\"70\\\",\\\"gk_partyfreak_image_bg\\\":\\\"#ffffff\\\",\\\"gk_partyfreak_quality\\\":\\\"95\\\",\\\"gk_partyfreak_total_width\\\":\\\"980\\\",\\\"gk_partyfreak_thumbs_margin\\\":\\\"0 0 0 0\\\",\\\"gk_partyfreak_thumbs_padding\\\":\\\"0 0 0 0\\\",\\\"gk_partyfreak_thumbs_amount\\\":\\\"3\\\",\\\"gk_partyfreak_thumbs_space\\\":\\\"8\\\",\\\"gk_partyfreak_thumbs_text_word_amount\\\":\\\"14\\\",\\\"gk_partyfreak_show_title\\\":\\\"1\\\",\\\"gk_partyfreak_text_block_height\\\":\\\"80\\\",\\\"gk_partyfreak_show_text\\\":\\\"1\\\",\\\"gk_partyfreak_text_word_amount\\\":\\\"40\\\",\\\"gk_partyfreak_slide_links\\\":\\\"1\\\",\\\"gk_partyfreak_animation_speed\\\":\\\"500\\\",\\\"gk_partyfreak_animation_interval\\\":\\\"5000\\\",\\\"gk_partyfreak_autoanimation\\\":\\\"1\\\",\\\"gk_partyfreak_animation_type\\\":\\\"opacity\\\"},\\\"gk_sporter1\\\":{\\\"gk_sporter1_image_width\\\":\\\"637\\\",\\\"gk_sporter1_image_height\\\":\\\"346\\\",\\\"gk_sporter1_image_bg\\\":\\\"#000000\\\",\\\"gk_sporter1_quality\\\":\\\"95\\\",\\\"gk_sporter1_text_position\\\":\\\"246\\\",\\\"gk_sporter1_text_height\\\":\\\"90\\\",\\\"gk_sporter1_show_text_block\\\":\\\"1\\\",\\\"gk_sporter1_pagination\\\":\\\"1\\\",\\\"gk_sporter1_pagination_cols\\\":\\\"4\\\",\\\"gk_sporter1_pagination_date\\\":\\\"1\\\",\\\"gk_sporter1_pagination_date_format\\\":\\\"d m, Y\\\",\\\"gk_sporter1_pagination_limit\\\":\\\"39\\\",\\\"gk_sporter1_readmore_text\\\":\\\"Read more\\\",\\\"gk_sporter1_pagination_position\\\":\\\"left\\\",\\\"gk_sporter1_clean_xhtml\\\":\\\"1\\\",\\\"gk_sporter1_wordcount\\\":\\\"24\\\",\\\"gk_sporter1_title_char_amount\\\":\\\"27\\\",\\\"gk_sporter1_show_info\\\":\\\"1\\\",\\\"gk_sporter1_date_format\\\":\\\"F d, Y\\\",\\\"gk_sporter1_author_name\\\":\\\"name\\\",\\\"gk_sporter1_info_format\\\":\\\"Written: %date by %author\\\",\\\"gk_sporter1_slide_links\\\":\\\"1\\\",\\\"gk_sporter1_animation_speed\\\":\\\"500\\\",\\\"gk_sporter1_animation_interval\\\":\\\"5000\\\",\\\"gk_sporter1_autoanimation\\\":\\\"1\\\",\\\"gk_sporter1_animation_type\\\":\\\"opacity\\\"},\\\"gk_sporter2\\\":{\\\"gk_sporter2_image_width\\\":\\\"600\\\",\\\"gk_sporter2_image_height\\\":\\\"600\\\",\\\"gk_sporter2_thumb_width\\\":\\\"70\\\",\\\"gk_sporter2_thumb_height\\\":\\\"70\\\",\\\"gk_sporter2_image_bg\\\":\\\"#ffffff\\\",\\\"gk_sporter2_quality\\\":\\\"95\\\",\\\"gk_sporter2_image_rows\\\":\\\"3\\\",\\\"gk_sporter2_image_cols\\\":\\\"3\\\",\\\"gk_sporter2_image_margin\\\":\\\"0\\\",\\\"gk_sporter2_image_padding\\\":\\\"0\\\",\\\"gk_sporter2_image_border\\\":\\\"0\\\",\\\"gk_sporter2_slide_popups\\\":\\\"1\\\",\\\"gk_sporter2_overlay\\\":\\\"1\\\",\\\"gk_sporter2_show_text_block\\\":\\\"1\\\",\\\"gk_sporter2_text_block_height\\\":\\\"100\\\",\\\"gk_sporter2_clean_xhtml\\\":\\\"1\\\",\\\"gk_sporter2_readmore_text\\\":\\\"Read more\\\",\\\"gk_sporter2_title_char_amount\\\":\\\"30\\\",\\\"gk_sporter2_text_wordcount\\\":\\\"30\\\"}}\"}',0,'*'),(119,'Multilanguage status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_multilangstatus',3,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),(120,'K2 User','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_user',1,1,'',0,'*');


--
-- Table structure for table `#__modules_menu`
--



CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules_menu`
--


INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES (1,0),(2,0),(3,0),(4,0),(6,0),(7,0),(8,0),(9,0),(10,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(18,0),(19,114),(19,115),(19,120),(19,121),(19,122),(20,115),(20,121),(20,122),(21,114),(21,115),(21,120),(21,121),(21,122),(22,114),(22,115),(22,120),(22,121),(22,122),(23,116),(23,117),(23,122),(24,116),(24,117),(24,122),(25,117),(25,122),(26,116),(26,117),(26,122),(27,118),(27,119),(27,121),(27,122),(28,118),(28,119),(28,120),(28,122),(29,119),(29,120),(29,121),(29,122),(30,118),(30,119),(30,120),(30,122),(31,118),(31,119),(31,120),(31,121),(31,122),(32,118),(32,119),(32,120),(32,121),(32,122),(33,0),(34,0),(35,0),(36,127),(37,127),(38,127),(39,127),(40,127),(41,127),(42,127),(43,127),(44,127),(45,127),(46,127),(47,127),(48,127),(49,127),(50,127),(51,127),(52,127),(53,127),(54,0),(55,0),(56,0),(57,0),(58,0),(59,101),(60,101),(61,101),(62,0),(63,101),(64,101),(65,0),(66,0),(67,0),(68,0),(69,0),(70,0),(71,101),(72,101),(73,205),(73,206),(73,207),(73,208),(73,209),(73,210),(73,211),(74,205),(74,210),(76,101),(76,205),(76,206),(76,207),(76,208),(76,209),(76,210),(76,211),(78,0),(79,0),(80,127),(81,127),(82,127),(83,127),(84,127),(85,127),(86,127),(87,127),(88,127),(89,127),(90,127),(91,127),(92,127),(93,127),(94,127),(95,127),(96,127),(97,127),(98,127),(99,127),(100,127),(101,127),(102,127),(103,127),(104,127),(105,127),(106,101),(107,101),(108,101),(109,101),(110,101),(111,101),(112,0),(113,101),(114,101),(115,205),(115,206),(115,210),(115,211),(116,101),(117,127),(118,101),(119,0);


--
-- Table structure for table `#__newsfeeds`
--



CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__newsfeeds`
--


INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`) VALUES (14,1,'GavickPro News','gavickpro-news','http://www.gavickmagazine.com/index.php?format=feed&type=rss',NULL,1,5,3600,0,'0000-00-00 00:00:00',1,0,1,'*','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\"}','2011-01-13 15:35:16',42,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00');


--
-- Table structure for table `#__overrider`
--



CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__overrider`
--




--
-- Table structure for table `#__redirect_links`
--



CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) DEFAULT NULL,
  `new_url` varchar(255) DEFAULT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM AUTO_INCREMENT=32 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__redirect_links`
--


INSERT INTO `#__redirect_links` (`id`, `old_url`, `new_url`, `referer`, `comment`, `published`, `created_date`, `modified_date`) VALUES (1,'http://project.gavick.com/dziudek/joomla16/penguinmail/?option=non-existing-component','','http://project.gavick.com/dziudek/joomla16/penguinmail/','',0,'2011-01-11 22:42:03','0000-00-00 00:00:00'),(2,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/module-variations','','http://project.gavick.com/dziudek/joomla16/penguinmail/','',0,'2011-01-13 13:12:27','0000-00-00 00:00:00'),(3,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/single-contact','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/menu-types/dropline-menu','',0,'2011-01-13 15:16:23','0000-00-00 00:00:00'),(4,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_user&view=login','','http://project.gavick.com/dziudek/joomla16/penguinmail/','',0,'2011-01-13 16:06:50','0000-00-00 00:00:00'),(5,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_user&task=login','','','',0,'2011-01-13 16:23:44','0000-00-00 00:00:00'),(6,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_user','','','',0,'2011-01-13 16:23:47','0000-00-00 00:00:00'),(7,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=user','','','',0,'2011-01-13 16:23:53','0000-00-00 00:00:00'),(8,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/blog-layout','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-iii/categories-list','',0,'2011-01-13 19:12:35','0000-00-00 00:00:00'),(9,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-ii/index.php','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-ii/user-login','',0,'2011-01-17 22:56:37','0000-00-00 00:00:00'),(10,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-i/index.php','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php/template/lorem-ipsum-ii/joomla-pages-i/single-contact','',0,'2011-01-19 11:06:04','0000-00-00 00:00:00'),(11,'http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=non-existing-component','','http://project.gavick.com/dziudek/joomla16/penguinmail/index.php?option=com_content&view=article&id=1&Itemid=104','',0,'2011-01-20 19:09:13','0000-00-00 00:00:00'),(12,'http://project.gavick.com/konrad/J16_finance_business/?option=non-existing-component','','http://project.gavick.com/konrad/J16_finance_business/','',0,'2011-07-21 11:00:31','0000-00-00 00:00:00'),(13,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-i/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-i/single-contact','',0,'2011-07-22 10:36:02','0000-00-00 00:00:00'),(14,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/template-articles/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/template-articles/typography','',0,'2011-07-26 10:54:30','0000-00-00 00:00:00'),(15,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/layouts/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/layouts/content-inset-column-2x','',0,'2011-07-27 11:46:45','0000-00-00 00:00:00'),(16,'http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/item','',0,'2011-07-28 18:31:16','0000-00-00 00:00:00'),(17,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum/module-variations','',0,'2011-07-28 20:39:03','0000-00-00 00:00:00'),(18,'http://project.gavick.com/konrad/J16_finance_business/index.php/component/search/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/component/search/?searchword=&ordering=newest&searchphrase=all&limit=20','',0,'2011-08-15 12:53:28','0000-00-00 00:00:00'),(19,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-iii/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-iii/single-article','',0,'2011-08-17 11:02:35','0000-00-00 00:00:00'),(20,'http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-ii/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-ii/user-registration','',0,'2011-08-17 13:26:39','0000-00-00 00:00:00'),(21,'http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide/item/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide/item/6-workshop-from-dedicated-stracte','',0,'2011-08-17 17:23:27','0000-00-00 00:00:00'),(22,'http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/index.php','','http://project.gavick.com/konrad/J16_finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide','',0,'2011-08-18 09:07:39','0000-00-00 00:00:00'),(23,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-08-19-13-59-20/index.php','','http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-08-19-13-59-20/financial-adviser','',0,'2011-08-19 14:35:23','0000-00-00 00:00:00'),(24,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/template/lorem-ipsum/template-articles/index.php','','http://project.gavick.com/_updates/joomla17/finance_business/index.php/template/lorem-ipsum/template-articles/messages','',0,'2011-09-13 17:25:58','0000-00-00 00:00:00'),(25,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/component/search/index.php','','http://project.gavick.com/_updates/joomla17/finance_business/index.php/component/search/?searchword=lorem%20ipsum&searchphrase=all&Itemid=9999','',0,'2011-09-13 18:30:52','0000-00-00 00:00:00'),(26,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-iii/index.php','','http://project.gavick.com/_updates/joomla17/finance_business/index.php/template/lorem-ipsum-ii/joomla-pages-iii/single-article','',0,'2011-09-23 20:07:50','0000-00-00 00:00:00'),(27,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-07-28-18-14-23/index.php',NULL,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-07-28-18-14-23/item','',0,'2011-10-25 09:56:13','0000-00-00 00:00:00'),(28,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide/item/index.php',NULL,'http://project.gavick.com/_updates/joomla17/finance_business/index.php/2011-07-28-18-14-23/categories/investment-guide/item/6-workshop-from-dedicated-','',0,'2011-10-31 22:28:31','0000-00-00 00:00:00'),(29,'http://project.gavick.com/_updates/joomla17/finance_business/?option=non-existing-component',NULL,'http://project.gavick.com/_updates/joomla17/finance_business/','',0,'2011-11-15 21:11:51','0000-00-00 00:00:00'),(30,'http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/template/lorem-ipsum-ii/joomla-pages-i/index.php','','http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/template/lorem-ipsum-ii/joomla-pages-i/smart-search','',0,'2012-01-15 23:16:49','0000-00-00 00:00:00'),(31,'http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/2011-07-28-18-14-23/index.php','','http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/2011-07-28-18-14-23/item','',0,'2012-01-24 14:58:07','0000-00-00 00:00:00');


--
-- Table structure for table `#__schemas`
--



CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__schemas`
--





--
-- Table structure for table `#__session`
--



CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  `usertype` varchar(50) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__session`
--


INSERT INTO `#__session` (`session_id`, `client_id`, `guest`, `time`, `data`, `userid`, `username`, `usertype`) VALUES ('e418fbd4ad11b88a0f78e12e4200b5b5',0,1,'1327443075','__default|a:9:{s:15:\"session.counter\";i:3;s:19:\"session.timer.start\";i:1327442136;s:18:\"session.timer.last\";i:1327442914;s:17:\"session.timer.now\";i:1327443074;s:22:\"session.client.browser\";s:105:\"Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/535.7 (KHTML, like Gecko) Chrome/16.0.912.75 Safari/535.7\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:4:\"user\";O:5:\"JUser\":23:{s:9:\"\0*\0isRoot\";b:0;s:2:\"id\";i:0;s:4:\"name\";N;s:8:\"username\";N;s:5:\"email\";N;s:8:\"password\";N;s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";N;s:5:\"block\";N;s:9:\"sendEmail\";i:0;s:12:\"registerDate\";N;s:13:\"lastvisitDate\";N;s:10:\"activation\";N;s:6:\"params\";N;s:6:\"groups\";a:0:{}s:5:\"guest\";i:1;s:10:\"\0*\0_params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:14:\"\0*\0_authGroups\";a:1:{i:0;s:1:\"1\";}s:14:\"\0*\0_authLevels\";a:2:{i:0;i:1;i:1;i:1;}s:15:\"\0*\0_authActions\";N;s:12:\"\0*\0_errorMsg\";N;s:10:\"\0*\0_errors\";a:0:{}s:3:\"aid\";i:0;}s:16:\"com_mailto.links\";a:3:{s:40:\"6b6ce78bc4eabf7f8c607fe45c19513d4eda58d3\";O:8:\"stdClass\":2:{s:4:\"link\";s:124:\"http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/joomla-pages-iii/category-list/39-chrome-frame-2\";s:6:\"expiry\";i:1327443075;}s:40:\"566553f7ac8192b72e5b00dff97d3202dd0f0b96\";O:8:\"stdClass\":2:{s:4:\"link\";s:102:\"http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/template-articles/messages\";s:6:\"expiry\";i:1327443075;}s:40:\"a3b103c9dd884d5d9d5f408e3b3259aa63518208\";O:8:\"stdClass\":2:{s:4:\"link\";s:125:\"http://project.gavick.com/_updates/joomla25/finance_business_beta/index.php/template/lorem-ipsum/template-articles/ie-6-style\";s:6:\"expiry\";i:1327443075;}}s:13:\"session.token\";s:32:\"8aab292def238c6de1d00fdcd04397f7\";}',0,'',''),('51dbcc274fc789f90d8cb5f445361bf3',1,0,'1327443052','__default|a:8:{s:15:\"session.counter\";i:7;s:19:\"session.timer.start\";i:1327442929;s:18:\"session.timer.last\";i:1327443025;s:17:\"session.timer.now\";i:1327443052;s:22:\"session.client.browser\";s:105:\"Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/535.7 (KHTML, like Gecko) Chrome/16.0.912.75 Safari/535.7\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:11:\"application\";O:8:\"stdClass\":1:{s:4:\"lang\";s:0:\"\";}s:13:\"com_installer\";O:8:\"stdClass\":3:{s:7:\"message\";s:0:\"\";s:17:\"extension_message\";s:0:\"\";s:12:\"redirect_url\";N;}}}s:4:\"user\";O:5:\"JUser\":24:{s:9:\"\0*\0isRoot\";b:1;s:2:\"id\";s:2:\"42\";s:4:\"name\";s:13:\"Administrator\";s:8:\"username\";s:5:\"admin\";s:5:\"email\";s:18:\"dziudek@gavick.com\";s:8:\"password\";s:65:\"5917e9b35073a2e8513a96b390813e43:KmIyeTk7JDEByZE4ATBv62c87E06rZZP\";s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";s:10:\"deprecated\";s:5:\"block\";s:1:\"0\";s:9:\"sendEmail\";s:1:\"1\";s:12:\"registerDate\";s:19:\"2011-07-08 09:20:19\";s:13:\"lastvisitDate\";s:19:\"2012-01-19 23:25:14\";s:10:\"activation\";s:0:\"\";s:6:\"params\";s:92:\"{\"admin_style\":\"\",\"admin_language\":\"\",\"language\":\"\",\"editor\":\"\",\"helpsite\":\"\",\"timezone\":\"\"}\";s:6:\"groups\";a:1:{i:8;s:1:\"8\";}s:5:\"guest\";i:0;s:10:\"\0*\0_params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":6:{s:11:\"admin_style\";s:0:\"\";s:14:\"admin_language\";s:0:\"\";s:8:\"language\";s:0:\"\";s:6:\"editor\";s:0:\"\";s:8:\"helpsite\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}}s:14:\"\0*\0_authGroups\";a:2:{i:0;i:1;i:1;i:8;}s:14:\"\0*\0_authLevels\";a:4:{i:0;i:1;i:1;i:1;i:2;i:2;i:3;i:3;}s:15:\"\0*\0_authActions\";N;s:12:\"\0*\0_errorMsg\";N;s:10:\"\0*\0_errors\";a:0:{}s:3:\"aid\";i:0;s:3:\"gid\";i:1000;}s:13:\"session.token\";s:32:\"845f169bb31948d45d89099f3cf33f95\";}',42,'admin','');


--
-- Table structure for table `#__template_styles`
--



CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__template_styles`
--


INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES (2,'bluestork',1,'1','Bluestork - Default','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}'),(3,'atomic',0,'0','Atomic - Default','{}'),(4,'beez_20',0,'0','Beez2 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),(6,'beez5',0,'0','Beez5 - Default-Fruit Shop','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Matuna Market \",\"sitedescription\":\"Fruit Shop Sample Site\",\"navposition\":\"left\",\"html5\":\"0\"}'),(11,'gk_finance_business',0,'1','gk_finance_business - Default','{\"template_color\":\"1\",\"mainbody_frontpage\":\"only_mainbody\",\"mainbody_subpage\":\"only_component\",\"messages_position\":\"message-position-3\",\"default_layout\":\"default\",\"facebook_layout\":\"facebook\",\"iphone_layout\":\"iphone\",\"android_layout\":\"android\",\"handheld_layout\":\"handheld\",\"layout_override\":\"\",\"template_width\":\"1002px\",\"header_column_width\":\"25\",\"left_column_width\":\"50\",\"left2_column_width\":\"50\",\"right_column_width\":\"27\",\"right2_column_width\":\"54\",\"inset_column_width\":\"47\",\"inset2_column_width\":\"6\",\"user1_6_widest_value\":\"0\",\"user1_6_widest\":\"user1\",\"user7_12_widest_value\":\"0\",\"user7_12_widest\":\"user7\",\"top1_6_widest_value\":\"0\",\"top1_6_widest\":\"top1\",\"top7_12_widest_value\":\"0\",\"top7_12_widest\":\"top7\",\"bottom1_6_widest_value\":\"0\",\"bottom1_6_widest\":\"bottom1\",\"bottom7_12_widest_value\":\"0\",\"bottom7_12_widest\":\"bottom7\",\"font_name_group1\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group1\":\"body,\\r\\ndiv.gk-menu .level0 > li li,\\r\\n#gkWrap2 .box_text .banneritem,\\r\\n#gkWrap2 .box_text .bannerfooter,\\r\\n#gkWrap2 .box.color1 > h3, \\r\\n#gkWrap2 .box_menu.color1 > h3, \\r\\n#gkWrap2 .box_text.color1 > h3, \\r\\n#gkWrap2 .box.color2 > h3, \\r\\n#gkWrap2 .box_menu.color2 > h3, \\r\\n#gkWrap2 .box_text.color2 > h3, \\r\\n#gkWrap2 .box.color3 > h3, \\r\\n#gkWrap2 .box_menu.color3 > h3, \\r\\n#gkWrap2 .box_text.color3 > h3, \\r\\n#gkWrap2 .box.color4 > h3, \\r\\n#gkWrap2 .box_menu.color4 > h3, \\r\\n#gkWrap2 .box_text.color4 > h3,\\r\\n.nspMainPortalMode2 .nspBotInterface .nspArtHeadline .nspHeadline h4, \\r\\n.nspMainPortalMode1 .nspHeader\",\"font_name_group2\":\"squirrel;BebasNeue\",\"font_rules_group2\":\"h1,\\r\\nh2,\\r\\nh3,\\r\\nh4,\\r\\nh5,\\r\\ndiv.gk-menu > ul.level0 > li,\\r\\ndiv#gkDropMain > ul > li,\\r\\n#gkWrap2 .box_text .bannergroup_text,\\r\\n.search-results dt.result-title a,\\r\\n.nspMainPortalMode3 .nspTitleTab .nspTitle,\\r\\n.registration legend,\\r\\n.gkIsTextTitle a\",\"font_name_group3\":\"standard;Tahoma, Geneva, sans-serif\",\"font_rules_group3\":\"#gkButtons a,\\r\\n.button, button, \\r\\nbutton.button, \\r\\na.readon, \\r\\n .moduleItemReadMore, \\r\\n .latestItemReadMore a.k2ReadMore, \\r\\n .userItemReadMore a.k2ReadMore, \\r\\n .catItemReadMore a.k2ReadMore, \\r\\n .k2ReadMore,\\r\\n .subCategoryMore, \\r\\n .readmore-link, \\r\\n .comments-link,\\r\\n#gkWrap2 .box.font2 > h3, \\r\\n#gkWrap2 .box_menu.font2 > h3, \\r\\n#gkWrap2 .box_text.font2 > h3 \",\"logo_type\":\"css\",\"mobile_logo_type\":\"css\",\"logo_image\":\"images\\/logo.png\",\"mobile_logo_image\":\"images\\/powered_by.png\",\"logo_text\":\"Finance Business\",\"logo_slogan\":\"slogan\",\"print_logo\":\"\",\"print_behaviour\":\"nothing\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"copyrights\":\"Copyright by GavickPro 2011. All rights reserved.\",\"google_analytics\":\"\",\"tools\":\"all\",\"tools_for_pages\":\"\",\"mootools_for_pages\":\"108=Disabled\\r\\n\",\"suffix_override\":\"\",\"module_override\":\"\",\"socialIcons\":\"1\",\"socialIcons1\":\"1\",\"socialIcons1url\":\"http:\\/\\/twitter.com\\/gavickpro\",\"socialIcons1text\":\"Twitter\",\"socialIcons2\":\"1\",\"socialIcons2url\":\"http:\\/\\/www.demo.gavick.com\",\"socialIcons2text\":\"Vimeo\",\"socialIcons3\":\"1\",\"socialIcons3url\":\"http:\\/\\/www.facebook.com\\/gavickpro\",\"socialIcons3text\":\"Facebook\",\"typography\":\"1\",\"typo_iconset1\":\"1\",\"typo_iconset2\":\"1\",\"typo_iconset3\":\"1\",\"menu_name\":\"mainmenu\",\"menu_type\":\"gk_menu\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_height\":\"1\",\"menu_width\":\"1\",\"menu_duration\":\"250\",\"menu_override\":\"111=gk_dropline\\r\\n112=gk_split\\r\\n\",\"mobile_menu_name\":\"mobile-menu\",\"mobile_login\":\"1\",\"mobile_register\":\"1\",\"mobile_desktop\":\"1\",\"mobile_search\":\"1\",\"mobile_collapsible\":\"1\",\"fb_api_id\":\"2432432432\",\"fb_lang\":\"en_US\",\"fb_login\":\"1\",\"fb_like\":\"1\",\"fb_like_send\":\"0\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"false\",\"fb_like_width\":\"320\",\"fb_like_action\":\"like\",\"fb_like_font\":\"verdana\",\"fb_like_colorscheme\":\"light\",\"tweet_btn\":\"1\",\"tweet_btn_data_count\":\"horizontal\",\"tweet_btn_data_via\":\"http:\\/\\/twitter.com\\/gavickpro\",\"tweet_btn_data_lang\":\"en\",\"digg_btn\":\"1\",\"digg_btn_style\":\"DiggCompact\",\"delicious_btn\":\"1\",\"instapaper_btn\":\"1\",\"excluded_arts\":\"\",\"excluded_cats\":[\"2\"],\"selectivizr\":\"0\",\"reset_css\":\"meyer\",\"use_gk_cache\":\"0\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"css_custom\":\"\",\"chrome_frame_support\":\"0\",\"ie6bar\":\"1\",\"cwidth_position\":\"style\"}');


--
-- Table structure for table `#__update_categories`
--



CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Update Categories';


--
-- Dumping data for table `#__update_categories`
--




--
-- Table structure for table `#__update_sites`
--



CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Update Sites';


--
-- Dumping data for table `#__update_sites`
--


INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES (1,'Joomla Core','collection','http://update.joomla.org/core/list.xml',1,1327442967),(2,'Joomla Extension Directory','collection','http://update.joomla.org/jed/list.xml',1,1327442967);


--
-- Table structure for table `#__update_sites_extensions`
--



CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';


--
-- Dumping data for table `#__update_sites_extensions`
--


INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES (1,700),(2,700);


--
-- Table structure for table `#__updates`
--



CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Available Updates';


--
-- Dumping data for table `#__updates`
--




--
-- Table structure for table `#__user_notes`
--



CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_notes`
--




--
-- Table structure for table `#__user_profiles`
--



CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';


--
-- Dumping data for table `#__user_profiles`
--




--
-- Table structure for table `#__user_usergroup_map`
--



CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_usergroup_map`
--


INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES (1,1),(45,2);


--
-- Table structure for table `#__usergroups`
--



CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup`  USING BTREE (`lft`,`rgt`) 
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__usergroups`
--


INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES (1,0,1,20,'Public'),(2,1,6,17,'Registered'),(3,2,7,14,'Author'),(4,3,8,11,'Editor'),(5,4,9,10,'Publisher'),(6,1,2,5,'Manager'),(7,6,3,4,'Administrator'),(8,1,18,19,'Super Users');


--
-- Table structure for table `#__users`
--



CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `usertype` varchar(25) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM AUTO_INCREMENT=50 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__users`
--


INSERT INTO `#__users` (`id`, `name`, `username`, `email`, `password`, `usertype`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`) VALUES (42,'Administrator','admin','dziudek@gavick.com','5917e9b35073a2e8513a96b390813e43:KmIyeTk7JDEByZE4ATBv62c87E06rZZP','deprecated',0,1,'2011-07-08 09:20:19','2012-01-24 22:09:14','','{\"admin_style\":\"\",\"admin_language\":\"\",\"language\":\"\",\"editor\":\"\",\"helpsite\":\"\",\"timezone\":\"\"}');


--
-- Table structure for table `#__viewlevels`
--



CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__viewlevels`
--


INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES (1,'Public',0,'[1]'),(2,'Registered',1,'[6,2,8]'),(3,'Special',2,'[6,3,8]');


--
-- Table structure for table `#__weblinks`
--



CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__weblinks`
--


INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES (1,12,0,'Joomla! 1.6','joomla-16','http://www.joomla.org','<p>Joomla! CMS offical site.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:02:04',42,'','2011-01-13 15:02:15',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(2,12,0,'Joomla Extensions','joomla-extensions','http://extensions.joomla.org','<p>Joomla extensions.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:02:54',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(3,12,0,'Joomla documentation','joomla-documentation','http://docs.joomla.org','<p>Full Joomla! documentation.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:03:23',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(4,13,0,'GavickPro Demo','demo-gavick','http://demo.gavick.com','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',4,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:06:17',42,'','2011-01-13 15:12:26',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(5,13,0,'GavickPro Magazine','gavick-magazine','http://www.gavickmagazine.com','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',5,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:09:14',42,'','2011-01-13 15:13:34',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(6,13,0,'GavickPro Homepage','gavickpro-homepage','http://www.gavick.com','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',6,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:13:15',42,'','2011-01-13 15:13:24',42,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(7,13,0,'GavickPro Tools','gavickpro-tools','http://tools.gavick.com/','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',7,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:14:11',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(8,13,0,'GavickPro Twitter','gavickpro-twitter','http://twitter.com/gavickpro','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',8,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:15:04',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(9,13,0,'GavickPro Facebook','gavickpro-facebook','http://www.facebook.com/gavickpro','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',9,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:15:30',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(10,13,0,'GavickPro Updates','gavickpro-updates','http://www.gavick.com/support/updates.html','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',10,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:16:04',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(11,13,0,'Join us!','join-us','http://www.gavick.com/home/join-us.html','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',11,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:17:14',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),(12,13,0,'GavickPro RSS & News','gavickpro-rss-a-news','http://www.gavickmagazine.com/index.php?format=feed&type=rss','','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',12,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2011-01-13 15:19:20',42,'','0000-00-00 00:00:00',0,'','','',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');











-- Dump completed on 2012-01-24 23:52:00
